/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/lazy","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(ie){for(var t=[],k=0,T=ie.length;k<T;k++)t[k]=be[ie[k]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:jt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Pt}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,k,T){return t.apply(k,T)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Pt||(Pt=function(t,k){return new t(...k)});const oi=ct(Array.prototype.forEach),Ht=ct(Array.prototype.pop),$t=ct(Array.prototype.push),Dt=ct(String.prototype.toLowerCase),Tt=ct(String.prototype.toString),li=ct(String.prototype.match),dt=ct(String.prototype.replace),ai=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),pt=ui(TypeError);function ct(ie){return function(t){for(var k=arguments.length,T=new Array(k>1?k-1:0),n=1;n<k;n++)T[n-1]=arguments[n];return Nt(ie,t,T)}}function ui(ie){return function(){for(var t=arguments.length,k=new Array(t),T=0;T<t;T++)k[T]=arguments[T];return Pt(ie,k)}}function Ue(ie,t,k){var T;k=(T=k)!==null&&T!==void 0?T:Dt,jt&&jt(ie,null);let n=t.length;for(;n--;){let H=t[n];if(typeof H=="string"){const A=k(H);A!==H&&(ii(t)||(t[n]=A),H=A)}ie[H]=!0}return ie}function mt(ie){const t=ri(null);for(const[k,T]of zt(ie))t[k]=T;return t}function Et(ie,t){for(;ie!==null;){const T=si(ie,t);if(T){if(T.get)return ct(T.get);if(typeof T.value=="function")return ct(T.value)}ie=ni(ie)}function k(T){return console.warn("fallback value for",T),null}return k}const Ut=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Rt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Mt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),At=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),_t=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=ft(/^html$/i);var xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:_t,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Qt});const vi=()=>typeof window>"u"?null:window,yi=function(t,k){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let T=null;const n="data-tt-policy-suffix";k&&k.hasAttribute(n)&&(T=k.getAttribute(n));const H="dompurify"+(T?"#"+T:"");try{return t.createPolicy(H,{createHTML(A){return A},createScriptURL(A){return A}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function Kt(){let ie=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=ze=>Kt(ze);if(t.version="3.0.5",t.removed=[],!ie||!ie.document||ie.document.nodeType!==9)return t.isSupported=!1,t;const k=ie.document,T=k.currentScript;let{document:n}=ie;const{DocumentFragment:H,HTMLTemplateElement:A,Node:S,Element:m,NodeFilter:w,NamedNodeMap:D=ie.NamedNodeMap||ie.MozNamedAttrMap,HTMLFormElement:M,DOMParser:r,trustedTypes:l}=ie,e=m.prototype,s=Et(e,"cloneNode"),g=Et(e,"nextSibling"),b=Et(e,"childNodes"),h=Et(e,"parentNode");if(typeof A=="function"){const ze=n.createElement("template");ze.content&&ze.content.ownerDocument&&(n=ze.content.ownerDocument)}let $,c="";const{implementation:f,createNodeIterator:a,createDocumentFragment:C,getElementsByTagName:O}=n,{importNode:L}=k;let B={};t.isSupported=typeof zt=="function"&&typeof h=="function"&&f&&f.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:v,ERB_EXPR:P,TMPLIT_EXPR:V,DATA_ATTR:U,ARIA_ATTR:N,IS_SCRIPT_OR_DATA:I,ATTR_WHITESPACE:z}=xt;let{IS_ALLOWED_URI:X}=xt,Y=null;const fe=Ue({},[...Ut,...Rt,...Lt,...It,...Wt]);let ae=null;const ee=Ue({},[...Vt,...Mt,...qt,...At]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Ie=null,Ce=null,Be=!0,se=!0,J=!1,re=!0,oe=!1,W=!1,G=!1,ue=!1,me=!1,Se=!1,ke=!1,Pe=!0,x=!1;const d="user-content-";let y=!0,p=!1,u={},i=null;const o=Ue({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let E=null;const R=Ue({},["audio","video","img","source","image","track"]);let F=null;const j=Ue({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),q="http://www.w3.org/1998/Math/MathML",Z="http://www.w3.org/2000/svg",le="http://www.w3.org/1999/xhtml";let pe=le,De=!1,we=null;const Ee=Ue({},[q,Z,le],Tt);let ve;const Te=["application/xhtml+xml","text/html"],Le="text/html";let Me,Ze=null;const et=n.createElement("form"),xe=function(he){return he instanceof RegExp||he instanceof Function},K=function(he){if(!(Ze&&Ze===he)){if((!he||typeof he!="object")&&(he={}),he=mt(he),ve=Te.indexOf(he.PARSER_MEDIA_TYPE)===-1?ve=Le:ve=he.PARSER_MEDIA_TYPE,Me=ve==="application/xhtml+xml"?Tt:Dt,Y="ALLOWED_TAGS"in he?Ue({},he.ALLOWED_TAGS,Me):fe,ae="ALLOWED_ATTR"in he?Ue({},he.ALLOWED_ATTR,Me):ee,we="ALLOWED_NAMESPACES"in he?Ue({},he.ALLOWED_NAMESPACES,Tt):Ee,F="ADD_URI_SAFE_ATTR"in he?Ue(mt(j),he.ADD_URI_SAFE_ATTR,Me):j,E="ADD_DATA_URI_TAGS"in he?Ue(mt(R),he.ADD_DATA_URI_TAGS,Me):R,i="FORBID_CONTENTS"in he?Ue({},he.FORBID_CONTENTS,Me):o,Ie="FORBID_TAGS"in he?Ue({},he.FORBID_TAGS,Me):{},Ce="FORBID_ATTR"in he?Ue({},he.FORBID_ATTR,Me):{},u="USE_PROFILES"in he?he.USE_PROFILES:!1,Be=he.ALLOW_ARIA_ATTR!==!1,se=he.ALLOW_DATA_ATTR!==!1,J=he.ALLOW_UNKNOWN_PROTOCOLS||!1,re=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,oe=he.SAFE_FOR_TEMPLATES||!1,W=he.WHOLE_DOCUMENT||!1,me=he.RETURN_DOM||!1,Se=he.RETURN_DOM_FRAGMENT||!1,ke=he.RETURN_TRUSTED_TYPE||!1,ue=he.FORCE_BODY||!1,Pe=he.SANITIZE_DOM!==!1,x=he.SANITIZE_NAMED_PROPS||!1,y=he.KEEP_CONTENT!==!1,p=he.IN_PLACE||!1,X=he.ALLOWED_URI_REGEXP||_t,pe=he.NAMESPACE||le,ge=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&xe(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&xe(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),oe&&(se=!1),Se&&(me=!0),u&&(Y=Ue({},[...Wt]),ae=[],u.html===!0&&(Ue(Y,Ut),Ue(ae,Vt)),u.svg===!0&&(Ue(Y,Rt),Ue(ae,Mt),Ue(ae,At)),u.svgFilters===!0&&(Ue(Y,Lt),Ue(ae,Mt),Ue(ae,At)),u.mathMl===!0&&(Ue(Y,It),Ue(ae,qt),Ue(ae,At))),he.ADD_TAGS&&(Y===fe&&(Y=mt(Y)),Ue(Y,he.ADD_TAGS,Me)),he.ADD_ATTR&&(ae===ee&&(ae=mt(ae)),Ue(ae,he.ADD_ATTR,Me)),he.ADD_URI_SAFE_ATTR&&Ue(F,he.ADD_URI_SAFE_ATTR,Me),he.FORBID_CONTENTS&&(i===o&&(i=mt(i)),Ue(i,he.FORBID_CONTENTS,Me)),y&&(Y["#text"]=!0),W&&Ue(Y,["html","head","body"]),Y.table&&(Ue(Y,["tbody"]),delete Ie.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');$=he.TRUSTED_TYPES_POLICY,c=$.createHTML("")}else $===void 0&&($=yi(l,T)),$!==null&&typeof c=="string"&&(c=$.createHTML(""));ot&&ot(he),Ze=he}},ne=Ue({},["mi","mo","mn","ms","mtext"]),de=Ue({},["foreignobject","desc","title","annotation-xml"]),Ae=Ue({},["title","style","font","a","script"]),Ne=Ue({},Rt);Ue(Ne,Lt),Ue(Ne,ci);const je=Ue({},It);Ue(je,fi);const Ve=function(he){let Fe=h(he);(!Fe||!Fe.tagName)&&(Fe={namespaceURI:pe,tagName:"template"});const Re=Dt(he.tagName),We=Dt(Fe.tagName);return we[he.namespaceURI]?he.namespaceURI===Z?Fe.namespaceURI===le?Re==="svg":Fe.namespaceURI===q?Re==="svg"&&(We==="annotation-xml"||ne[We]):!!Ne[Re]:he.namespaceURI===q?Fe.namespaceURI===le?Re==="math":Fe.namespaceURI===Z?Re==="math"&&de[We]:!!je[Re]:he.namespaceURI===le?Fe.namespaceURI===Z&&!de[We]||Fe.namespaceURI===q&&!ne[We]?!1:!je[Re]&&(Ae[Re]||!Ne[Re]):!!(ve==="application/xhtml+xml"&&we[he.namespaceURI]):!1},_e=function(he){$t(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},Je=function(he,Fe){try{$t(t.removed,{attribute:Fe.getAttributeNode(he),from:Fe})}catch{$t(t.removed,{attribute:null,from:Fe})}if(Fe.removeAttribute(he),he==="is"&&!ae[he])if(me||Se)try{_e(Fe)}catch{}else try{Fe.setAttribute(he,"")}catch{}},tt=function(he){let Fe,Re;if(ue)he="<remove></remove>"+he;else{const at=li(he,/^[\r\n\t ]+/);Re=at&&at[0]}ve==="application/xhtml+xml"&&pe===le&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const We=$?$.createHTML(he):he;if(pe===le)try{Fe=new r().parseFromString(We,ve)}catch{}if(!Fe||!Fe.documentElement){Fe=f.createDocument(pe,"template",null);try{Fe.documentElement.innerHTML=De?c:We}catch{}}const it=Fe.body||Fe.documentElement;return he&&Re&&it.insertBefore(n.createTextNode(Re),it.childNodes[0]||null),pe===le?O.call(Fe,W?"html":"body")[0]:W?Fe.documentElement:it},Ye=function(he){return a.call(he.ownerDocument||he,he,w.SHOW_ELEMENT|w.SHOW_COMMENT|w.SHOW_TEXT,null,!1)},nt=function(he){return he instanceof M&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof D)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},st=function(he){return typeof S=="object"?he instanceof S:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},rt=function(he,Fe,Re){B[he]&&oi(B[he],We=>{We.call(t,Fe,Re,Ze)})},gt=function(he){let Fe;if(rt("beforeSanitizeElements",he,null),nt(he))return _e(he),!0;const Re=Me(he.nodeName);if(rt("uponSanitizeElement",he,{tagName:Re,allowedTags:Y}),he.hasChildNodes()&&!st(he.firstElementChild)&&(!st(he.content)||!st(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return _e(he),!0;if(!Y[Re]||Ie[Re]){if(!Ie[Re]&&St(Re)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Re)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Re)))return!1;if(y&&!i[Re]){const We=h(he)||he.parentNode,it=b(he)||he.childNodes;if(it&&We){const at=it.length;for(let Qe=at-1;Qe>=0;--Qe)We.insertBefore(s(it[Qe],!0),g(he))}}return _e(he),!0}return he instanceof m&&!Ve(he)||(Re==="noscript"||Re==="noembed"||Re==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(_e(he),!0):(oe&&he.nodeType===3&&(Fe=he.textContent,Fe=dt(Fe,v," "),Fe=dt(Fe,P," "),Fe=dt(Fe,V," "),he.textContent!==Fe&&($t(t.removed,{element:he.cloneNode()}),he.textContent=Fe)),rt("afterSanitizeElements",he,null),!1)},kt=function(he,Fe,Re){if(Pe&&(Fe==="id"||Fe==="name")&&(Re in n||Re in et))return!1;if(!(se&&!Ce[Fe]&&ht(U,Fe))){if(!(Be&&ht(N,Fe))){if(!ae[Fe]||Ce[Fe]){if(!(St(he)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,he)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(he))&&(ge.attributeNameCheck instanceof RegExp&&ht(ge.attributeNameCheck,Fe)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(Fe))||Fe==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Re)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Re))))return!1}else if(!F[Fe]){if(!ht(X,dt(Re,z,""))){if(!((Fe==="src"||Fe==="xlink:href"||Fe==="href")&&he!=="script"&&ai(Re,"data:")===0&&E[he])){if(!(J&&!ht(I,dt(Re,z,"")))){if(Re)return!1}}}}}}return!0},St=function(he){return he.indexOf("-")>0},wt=function(he){let Fe,Re,We,it;rt("beforeSanitizeAttributes",he,null);const{attributes:at}=he;if(!at)return;const Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ae};for(it=at.length;it--;){Fe=at[it];const{name:ut,namespaceURI:vt}=Fe;if(Re=ut==="value"?Fe.value:hi(Fe.value),We=Me(ut),Qe.attrName=We,Qe.attrValue=Re,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,rt("uponSanitizeAttribute",he,Qe),Re=Qe.attrValue,Qe.forceKeepAttr||(Je(ut,he),!Qe.keepAttr))continue;if(!re&&ht(/\/>/i,Re)){Je(ut,he);continue}oe&&(Re=dt(Re,v," "),Re=dt(Re,P," "),Re=dt(Re,V," "));const Ft=Me(he.nodeName);if(kt(Ft,We,Re)){if(x&&(We==="id"||We==="name")&&(Je(ut,he),Re=d+Re),$&&typeof l=="object"&&typeof l.getAttributeType=="function"&&!vt)switch(l.getAttributeType(Ft,We)){case"TrustedHTML":{Re=$.createHTML(Re);break}case"TrustedScriptURL":{Re=$.createScriptURL(Re);break}}try{vt?he.setAttributeNS(vt,ut,Re):he.setAttribute(ut,Re),Ht(t.removed)}catch{}}}rt("afterSanitizeAttributes",he,null)},Ot=function ze(he){let Fe;const Re=Ye(he);for(rt("beforeSanitizeShadowDOM",he,null);Fe=Re.nextNode();)rt("uponSanitizeShadowNode",Fe,null),!gt(Fe)&&(Fe.content instanceof H&&ze(Fe.content),wt(Fe));rt("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(ze){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Fe,Re,We,it;if(De=!ze,De&&(ze="<!-->"),typeof ze!="string"&&!st(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw pt("dirty is not a string, aborting")}else throw pt("toString is not a function");if(!t.isSupported)return ze;if(G||K(he),t.removed=[],typeof ze=="string"&&(p=!1),p){if(ze.nodeName){const ut=Me(ze.nodeName);if(!Y[ut]||Ie[ut])throw pt("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof S)Fe=tt("<!---->"),Re=Fe.ownerDocument.importNode(ze,!0),Re.nodeType===1&&Re.nodeName==="BODY"||Re.nodeName==="HTML"?Fe=Re:Fe.appendChild(Re);else{if(!me&&!oe&&!W&&ze.indexOf("<")===-1)return $&&ke?$.createHTML(ze):ze;if(Fe=tt(ze),!Fe)return me?null:ke?c:""}Fe&&ue&&_e(Fe.firstChild);const at=Ye(p?ze:Fe);for(;We=at.nextNode();)gt(We)||(We.content instanceof H&&Ot(We.content),wt(We));if(p)return ze;if(me){if(Se)for(it=C.call(Fe.ownerDocument);Fe.firstChild;)it.appendChild(Fe.firstChild);else it=Fe;return(ae.shadowroot||ae.shadowrootmode)&&(it=L.call(k,it,!0)),it}let Qe=W?Fe.outerHTML:Fe.innerHTML;return W&&Y["!doctype"]&&Fe.ownerDocument&&Fe.ownerDocument.doctype&&Fe.ownerDocument.doctype.name&&ht(Qt,Fe.ownerDocument.doctype.name)&&(Qe="<!DOCTYPE "+Fe.ownerDocument.doctype.name+`>
`+Qe),oe&&(Qe=dt(Qe,v," "),Qe=dt(Qe,P," "),Qe=dt(Qe,V," ")),$&&ke?$.createHTML(Qe):Qe},t.setConfig=function(ze){K(ze),G=!0},t.clearConfig=function(){Ze=null,G=!1},t.isValidAttribute=function(ze,he,Fe){Ze||K({});const Re=Me(ze),We=Me(he);return kt(Re,We,Fe)},t.addHook=function(ze,he){typeof he=="function"&&(B[ze]=B[ze]||[],$t(B[ze],he))},t.removeHook=function(ze){if(B[ze])return Ht(B[ze])},t.removeHooks=function(ze){B[ze]&&(B[ze]=[])},t.removeAllHooks=function(){B={}},t}var Di=Kt();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define(be[41],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eR=t.$dR=void 0;class k{constructor(A){this.domNode=A,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(A){const S=T(A);this.a!==S&&(this.a=S,this.domNode.style.maxWidth=this.a)}setWidth(A){const S=T(A);this.b!==S&&(this.b=S,this.domNode.style.width=this.b)}setHeight(A){const S=T(A);this.c!==S&&(this.c=S,this.domNode.style.height=this.c)}setTop(A){const S=T(A);this.d!==S&&(this.d=S,this.domNode.style.top=this.d)}setLeft(A){const S=T(A);this.e!==S&&(this.e=S,this.domNode.style.left=this.e)}setBottom(A){const S=T(A);this.f!==S&&(this.f=S,this.domNode.style.bottom=this.f)}setRight(A){const S=T(A);this.g!==S&&(this.g=S,this.domNode.style.right=this.g)}setPaddingTop(A){const S=T(A);this.h!==S&&(this.h=S,this.domNode.style.paddingTop=this.h)}setPaddingLeft(A){const S=T(A);this.i!==S&&(this.i=S,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(A){const S=T(A);this.j!==S&&(this.j=S,this.domNode.style.paddingBottom=this.j)}setPaddingRight(A){const S=T(A);this.k!==S&&(this.k=S,this.domNode.style.paddingRight=this.k)}setFontFamily(A){this.l!==A&&(this.l=A,this.domNode.style.fontFamily=this.l)}setFontWeight(A){this.m!==A&&(this.m=A,this.domNode.style.fontWeight=this.m)}setFontSize(A){const S=T(A);this.n!==S&&(this.n=S,this.domNode.style.fontSize=this.n)}setFontStyle(A){this.o!==A&&(this.o=A,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(A){this.p!==A&&(this.p=A,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(A){this.q!==A&&(this.q=A,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(A){this.r!==A&&(this.r=A,this.domNode.style.textDecoration=this.r)}setLineHeight(A){const S=T(A);this.s!==S&&(this.s=S,this.domNode.style.lineHeight=this.s)}setLetterSpacing(A){const S=T(A);this.t!==S&&(this.t=S,this.domNode.style.letterSpacing=this.t)}setClassName(A){this.u!==A&&(this.u=A,this.domNode.className=this.u)}toggleClassName(A,S){this.domNode.classList.toggle(A,S),this.u=this.domNode.className}setDisplay(A){this.v!==A&&(this.v=A,this.domNode.style.display=this.v)}setPosition(A){this.w!==A&&(this.w=A,this.domNode.style.position=this.w)}setVisibility(A){this.x!==A&&(this.x=A,this.domNode.style.visibility=this.x)}setColor(A){this.y!==A&&(this.y=A,this.domNode.style.color=this.y)}setBackgroundColor(A){this.z!==A&&(this.z=A,this.domNode.style.backgroundColor=this.z)}setLayerHinting(A){this.A!==A&&(this.A=A,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(A){this.C!==A&&(this.C=A,this.domNode.style.boxShadow=A)}setContain(A){this.B!==A&&(this.B=A,this.domNode.style.contain=this.B)}setAttribute(A,S){this.domNode.setAttribute(A,S)}removeAttribute(A){this.domNode.removeAttribute(A)}appendChild(A){this.domNode.appendChild(A.domNode)}removeChild(A){this.domNode.removeChild(A.domNode)}}t.$dR=k;function T(H){return typeof H=="number"?`${H}px`:H}function n(H){return new k(H)}t.$eR=n}),define(be[69],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wP=t.$vP=void 0;const k=new WeakMap;function T(S){if(!S.parent||S.parent===S)return null;try{const m=S.location,w=S.parent.location;if(m.origin!=="null"&&w.origin!=="null"&&m.origin!==w.origin)return null}catch{return null}return S.parent}class n{static a(m){let w=k.get(m);if(!w){w=[],k.set(m,w);let D=m,M;do M=T(D),M?w.push({window:new WeakRef(D),iframeElement:D.frameElement||null}):w.push({window:new WeakRef(D),iframeElement:null}),D=M;while(D)}return w.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(m,w){if(!w||m===w)return{top:0,left:0};let D=0,M=0;const r=this.a(m);for(const l of r){const e=l.window.deref();if(D+=e?.scrollY??0,M+=e?.scrollX??0,e===w||!l.iframeElement)break;const s=l.iframeElement.getBoundingClientRect();D+=s.top,M+=s.left}return{top:D,left:M}}}t.$vP=n;async function H(S,m){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const w=JSON.stringify({parentOrigin:S,salt:m}),M=new TextEncoder().encode(w),r=await crypto.subtle.digest("sha-256",M);return A(r)}t.$wP=H;function A(S){const w=Array.from(new Uint8Array(S)).map(D=>D.toString(16).padStart(2,"0")).join("");return BigInt(`0x${w}`).toString(32).padStart(52,"0")}}),define(be[70],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WR=t.$VR=t.$UR=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var k;(function(A){A[A.Copy=0]="Copy",A[A.Move=1]="Move"})(k||(t.ListDragOverEffectType=k={}));var T;(function(A){A.Over="drop-target",A.Before="drop-target-before",A.After="drop-target-after"})(T||(t.ListDragOverEffectPosition=T={})),t.$UR={reject(){return{accept:!1}},accept(){return{accept:!0}}};class n extends Error{constructor(S,m){super(`ListError [${S}] ${m}`)}}t.$VR=n;class H{constructor(){this.c=new WeakMap}getHeight(S){return this.c.get(S)??this.d(S)}setDynamicHeight(S,m){m>0&&this.c.set(S,m)}}t.$WR=H}),define(be[71],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KR=void 0;class k{constructor(n){this.a=n}splice(n,H,A){this.a.forEach(S=>S.splice(n,H,A))}}t.$KR=k}),define(be[42],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jR=void 0;const k=20;class T{constructor(H,A,S,m,w,D){this.a=Math.round(A),this.b=Math.round(S),this.c=Math.round(H),this.d=m,this.e=w,this.f=D,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new T(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const A=Math.round(H);return this.d!==A?(this.d=A,this.m(),!0):!1}setScrollSize(H){const A=Math.round(H);return this.e!==A?(this.e=A,this.m(),!0):!1}setScrollPosition(H){const A=Math.round(H);return this.f!==A?(this.f=A,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,A,S,m,w){const D=Math.max(0,S-H),M=Math.max(0,D-2*A),r=m>0&&m>S;if(!r)return{computedAvailableSize:Math.round(D),computedIsNeeded:r,computedSliderSize:Math.round(M),computedSliderRatio:0,computedSliderPosition:0};const l=Math.round(Math.max(k,Math.floor(S*M/m))),e=(M-l)/(m-S),s=w*e;return{computedAvailableSize:Math.round(D),computedIsNeeded:r,computedSliderSize:Math.round(l),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const H=T.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const A=H-this.c-this.i/2;return Math.round(A/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const A=H-this.c;let S=this.f;return A<this.k?S-=this.d:S+=this.d,S}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const A=this.k+H;return Math.round(A/this.j)}}t.$jR=T}),define(be[26],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NT=t.$MT=t.$LT=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var k;(function(m){m[m.Hidden=0]="Hidden",m[m.Visible=1]="Visible",m[m.Recurse=2]="Recurse"})(k||(t.TreeVisibility=k={}));var T;(function(m){m[m.Expanded=0]="Expanded",m[m.Collapsed=1]="Collapsed",m[m.PreserveOrExpanded=2]="PreserveOrExpanded",m[m.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(T||(t.ObjectTreeElementCollapseState=T={}));var n;(function(m){m[m.Unknown=0]="Unknown",m[m.Twistie=1]="Twistie",m[m.Element=2]="Element",m[m.Filter=3]="Filter"})(n||(t.TreeMouseEventTarget=n={}));var H;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(H||(t.TreeDragOverBubble=H={})),t.$LT={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(m=!1){return{accept:!0,bubble:0,autoExpand:m}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(m=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:m}}};class A extends Error{constructor(w,D){super(`TreeError [${w}] ${D}`)}}t.$MT=A;class S{constructor(w){this.a=w,this.b=new WeakMap}map(w){let D=this.b.get(w);return D||(D=this.a(w),this.b.set(w,D)),D}}t.$NT=S}),define(be[21],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_O=t.$window=t.$0O=t.$9O=void 0;function k(n,H){const A=n;typeof A.vscodeWindowId!="number"&&Object.defineProperty(A,"vscodeWindowId",{get:()=>H})}t.$9O=k,t.$0O=window,t.$window=t.$0O;function T(n){return n===t.$0O?!1:typeof n?.vscodeWindowId=="number"}t.$_O=T}),define(be[72],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function k(s,g,b){const h=T(s,g);if(h!==-1)return s[h]}t.$fb=k;function T(s,g,b=s.length-1){for(let h=b;h>=0;h--){const $=s[h];if(g($))return h}return-1}t.$gb=T;function n(s,g){const b=H(s,g);return b===-1?void 0:s[b]}t.$hb=n;function H(s,g,b=0,h=s.length){let $=b,c=h;for(;$<c;){const f=Math.floor(($+c)/2);g(s[f])?$=f+1:c=f}return $-1}t.$ib=H;function A(s,g){const b=S(s,g);return b===s.length?void 0:s[b]}t.$jb=A;function S(s,g,b=0,h=s.length){let $=b,c=h;for(;$<c;){const f=Math.floor(($+c)/2);g(s[f])?c=f:$=f+1}return $}t.$kb=S;function m(s,g,b=0,h=s.length){const $=S(s,g,b,h);return $===s.length?-1:$}t.$lb=m;class w{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(w.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!g(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const b=H(this.e,g,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}t.$mb=w;function D(s,g){if(s.length===0)return;let b=s[0];for(let h=1;h<s.length;h++){const $=s[h];g($,b)>0&&(b=$)}return b}t.$nb=D;function M(s,g){if(s.length===0)return;let b=s[0];for(let h=1;h<s.length;h++){const $=s[h];g($,b)>=0&&(b=$)}return b}t.$ob=M;function r(s,g){return D(s,(b,h)=>-g(b,h))}t.$pb=r;function l(s,g){if(s.length===0)return-1;let b=0;for(let h=1;h<s.length;h++){const $=s[h];g($,s[b])>0&&(b=h)}return b}t.$qb=l;function e(s,g){for(const b of s){const h=g(b);if(h!==void 0)return h}}t.$rb=e}),define(be[73],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function k(A,S){const m=Object.create(null);for(const w of A){const D=S(w);let M=m[D];M||(M=m[D]=[]),M.push(w)}return m}t.$K=k;function T(A,S){const m=[],w=[];for(const D of A)S.has(D)||m.push(D);for(const D of S)A.has(D)||w.push(D);return{removed:m,added:w}}t.$L=T;function n(A,S){const m=[],w=[];for(const[D,M]of A)S.has(D)||m.push(M);for(const[D,M]of S)A.has(D)||w.push(M);return{removed:m,added:w}}t.$M=n;function H(A,S){const m=new Set;for(const w of S)A.has(w)&&m.add(w);return m}t.$N=H}),define(be[74],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mt=t.$lt=t.$kt=t.$jt=void 0;function k(S,m){const w=Math.pow(10,m);return Math.round(S*w)/w}class T{constructor(m,w,D,M=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,D))|0,this.a=k(Math.max(Math.min(1,M),0),3)}static equals(m,w){return m.r===w.r&&m.g===w.g&&m.b===w.b&&m.a===w.a}}t.$jt=T;class n{constructor(m,w,D,M){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=k(Math.max(Math.min(1,w),0),3),this.l=k(Math.max(Math.min(1,D),0),3),this.a=k(Math.max(Math.min(1,M),0),3)}static equals(m,w){return m.h===w.h&&m.s===w.s&&m.l===w.l&&m.a===w.a}static fromRGBA(m){const w=m.r/255,D=m.g/255,M=m.b/255,r=m.a,l=Math.max(w,D,M),e=Math.min(w,D,M);let s=0,g=0;const b=(e+l)/2,h=l-e;if(h>0){switch(g=Math.min(b<=.5?h/(2*b):h/(2-2*b),1),l){case w:s=(D-M)/h+(D<M?6:0);break;case D:s=(M-w)/h+2;break;case M:s=(w-D)/h+4;break}s*=60,s=Math.round(s)}return new n(s,g,b,r)}static i(m,w,D){return D<0&&(D+=1),D>1&&(D-=1),D<1/6?m+(w-m)*6*D:D<1/2?w:D<2/3?m+(w-m)*(2/3-D)*6:m}static toRGBA(m){const w=m.h/360,{s:D,l:M,a:r}=m;let l,e,s;if(D===0)l=e=s=M;else{const g=M<.5?M*(1+D):M+D-M*D,b=2*M-g;l=n.i(b,g,w+1/3),e=n.i(b,g,w),s=n.i(b,g,w-1/3)}return new T(Math.round(l*255),Math.round(e*255),Math.round(s*255),r)}}t.$kt=n;class H{constructor(m,w,D,M){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=k(Math.max(Math.min(1,w),0),3),this.v=k(Math.max(Math.min(1,D),0),3),this.a=k(Math.max(Math.min(1,M),0),3)}static equals(m,w){return m.h===w.h&&m.s===w.s&&m.v===w.v&&m.a===w.a}static fromRGBA(m){const w=m.r/255,D=m.g/255,M=m.b/255,r=Math.max(w,D,M),l=Math.min(w,D,M),e=r-l,s=r===0?0:e/r;let g;return e===0?g=0:r===w?g=((D-M)/e%6+6)%6:r===D?g=(M-w)/e+2:g=(w-D)/e+4,new H(Math.round(g*60),s,r,m.a)}static toRGBA(m){const{h:w,s:D,v:M,a:r}=m,l=M*D,e=l*(1-Math.abs(w/60%2-1)),s=M-l;let[g,b,h]=[0,0,0];return w<60?(g=l,b=e):w<120?(g=e,b=l):w<180?(b=l,h=e):w<240?(b=e,h=l):w<300?(g=e,h=l):w<=360&&(g=l,h=e),g=Math.round((g+s)*255),b=Math.round((b+s)*255),h=Math.round((h+s)*255),new T(g,b,h,r)}}t.$lt=H;class A{static fromHex(m){return A.Format.CSS.parseHex(m)||A.red}static equals(m,w){return!m&&!w?!0:!m||!w?!1:m.equals(w)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof T)this.rgba=m;else if(m instanceof n)this.i=m,this.rgba=n.toRGBA(m);else if(m instanceof H)this.j=m,this.rgba=H.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&T.equals(this.rgba,m.rgba)&&n.equals(this.hsla,m.hsla)&&H.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=A.k(this.rgba.r),w=A.k(this.rgba.g),D=A.k(this.rgba.b),M=.2126*m+.7152*w+.0722*D;return k(M,4)}static k(m){const w=m/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(m){const w=this.getRelativeLuminance(),D=m.getRelativeLuminance();return w>D?(w+.05)/(D+.05):(D+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const w=this.getRelativeLuminance(),D=m.getRelativeLuminance();return w>D}isDarkerThan(m){const w=this.getRelativeLuminance(),D=m.getRelativeLuminance();return w<D}lighten(m){return new A(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new A(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:w,g:D,b:M,a:r}=this.rgba;return new A(new T(w,D,M,r*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const w=m.rgba,D=this.rgba.a,M=w.a,r=D+M*(1-D);if(r<1e-6)return A.transparent;const l=this.rgba.r*D/r+w.r*M*(1-D)/r,e=this.rgba.g*D/r+w.g*M*(1-D)/r,s=this.rgba.b*D/r+w.b*M*(1-D)/r;return new A(new T(l,e,s,r))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:w,g:D,b:M,a:r}=this.rgba;return new A(new T(m.rgba.r-r*(m.rgba.r-w),m.rgba.g-r*(m.rgba.g-D),m.rgba.b-r*(m.rgba.b-M),1))}flatten(...m){const w=m.reduceRight((D,M)=>A.o(M,D));return A.o(this,w)}static o(m,w){const D=1-m.rgba.a;return new A(new T(D*w.rgba.r+m.rgba.a*m.rgba.r,D*w.rgba.g+m.rgba.a*m.rgba.g,D*w.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(m,w,D){if(m.isLighterThan(w))return m;D=D||.5;const M=m.getRelativeLuminance(),r=w.getRelativeLuminance();return D=D*(r-M)/r,m.lighten(D)}static getDarkerColor(m,w,D){if(m.isDarkerThan(w))return m;D=D||.5;const M=m.getRelativeLuminance(),r=w.getRelativeLuminance();return D=D*(M-r)/M,m.darken(D)}static{this.white=new A(new T(255,255,255,1))}static{this.black=new A(new T(0,0,0,1))}static{this.red=new A(new T(255,0,0,1))}static{this.blue=new A(new T(0,0,255,1))}static{this.green=new A(new T(0,255,0,1))}static{this.cyan=new A(new T(0,255,255,1))}static{this.lightgrey=new A(new T(211,211,211,1))}static{this.transparent=new A(new T(0,0,0,0))}}t.$mt=A,function(S){let m;(function(w){let D;(function(M){function r(a){return a.rgba.a===1?`rgb(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b})`:S.Format.CSS.formatRGBA(a)}M.formatRGB=r;function l(a){return`rgba(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b}, ${+a.rgba.a.toFixed(2)})`}M.formatRGBA=l;function e(a){return a.hsla.a===1?`hsl(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(a)}M.formatHSL=e;function s(a){return`hsla(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%, ${a.hsla.a.toFixed(2)})`}M.formatHSLA=s;function g(a){const C=a.toString(16);return C.length!==2?"0"+C:C}function b(a){return`#${g(a.rgba.r)}${g(a.rgba.g)}${g(a.rgba.b)}`}M.formatHex=b;function h(a,C=!1){return C&&a.rgba.a===1?S.Format.CSS.formatHex(a):`#${g(a.rgba.r)}${g(a.rgba.g)}${g(a.rgba.b)}${g(Math.round(a.rgba.a*255))}`}M.formatHexA=h;function $(a){return a.isOpaque()?S.Format.CSS.formatHex(a):S.Format.CSS.formatRGBA(a)}M.format=$;function c(a){const C=a.length;if(C===0||a.charCodeAt(0)!==35)return null;if(C===7){const O=16*f(a.charCodeAt(1))+f(a.charCodeAt(2)),L=16*f(a.charCodeAt(3))+f(a.charCodeAt(4)),B=16*f(a.charCodeAt(5))+f(a.charCodeAt(6));return new S(new T(O,L,B,1))}if(C===9){const O=16*f(a.charCodeAt(1))+f(a.charCodeAt(2)),L=16*f(a.charCodeAt(3))+f(a.charCodeAt(4)),B=16*f(a.charCodeAt(5))+f(a.charCodeAt(6)),v=16*f(a.charCodeAt(7))+f(a.charCodeAt(8));return new S(new T(O,L,B,v/255))}if(C===4){const O=f(a.charCodeAt(1)),L=f(a.charCodeAt(2)),B=f(a.charCodeAt(3));return new S(new T(16*O+O,16*L+L,16*B+B))}if(C===5){const O=f(a.charCodeAt(1)),L=f(a.charCodeAt(2)),B=f(a.charCodeAt(3)),v=f(a.charCodeAt(4));return new S(new T(16*O+O,16*L+L,16*B+B,(16*v+v)/255))}return null}M.parseHex=c;function f(a){switch(a){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(D=w.CSS||(w.CSS={}))})(m=S.Format||(S.Format={}))}(A||(t.$mt=A={}))}),define(be[27],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zh=t.$yh=t.$xh=void 0;function k(A){return(S,m,w)=>{let D=null,M=null;if(typeof w.value=="function"?(D="value",M=w.value):typeof w.get=="function"&&(D="get",M=w.get),!M)throw new Error("not supported");w[D]=A(M,m)}}function T(A,S,m){let w=null,D=null;if(typeof m.value=="function"?(w="value",D=m.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(w="get",D=m.get),!D)throw new Error("not supported");const M=`$memoize$${S}`;m[w]=function(...r){return this.hasOwnProperty(M)||Object.defineProperty(this,M,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,r)}),this[M]}}t.$xh=T;function n(A,S,m){return k((w,D)=>{const M=`$debounce$${D}`,r=`$debounce$result$${D}`;return function(...l){this[r]||(this[r]=m?m():void 0),clearTimeout(this[M]),S&&(this[r]=S(this[r],...l),l=[this[r]]),this[M]=setTimeout(()=>{w.apply(this,l),this[r]=m?m():void 0},A)}})}t.$yh=n;function H(A,S,m){return k((w,D)=>{const M=`$throttle$timer$${D}`,r=`$throttle$result$${D}`,l=`$throttle$lastRun$${D}`,e=`$throttle$pending$${D}`;return function(...s){if(this[r]||(this[r]=m?m():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),S&&(this[r]=S(this[r],...s)),this[e])return;const g=this[l]+A;g<=Date.now()?(this[l]=Date.now(),w.apply(this,[this[r]]),this[r]=m?m():void 0):(this[e]=!0,this[M]=setTimeout(()=>{this[e]=!1,this[l]=Date.now(),w.apply(this,[this[r]]),this[r]=m?m():void 0},g-Date.now()))}})}t.$zh=H}),define(be[75],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xs=void 0;class k{constructor(n,H,A,S){this.originalStart=n,this.originalLength=H,this.modifiedStart=A,this.modifiedLength=S}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Xs=k}),define(be[6],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class k{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?$.isErrorNoTelemetry(a)?new $(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(C=>{C(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}t.$W=k,t.$X=new k;function T(f){t.$X.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=T;function n(f){if(!f||typeof f!="object")return!1;const a=f;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}t.$Z=n;function H(f){w(f)||t.$X.onUnexpectedError(f)}t.$1=H;function A(f){w(f)||t.$X.onUnexpectedExternalError(f)}t.$2=A;function S(f){if(f instanceof Error){const{name:a,message:C}=f,O=f.stacktrace||f.stack;return{$isError:!0,name:a,message:C,stack:O,noTelemetry:$.isErrorNoTelemetry(f)}}return f}t.$3=S;const m="Canceled";function w(f){return f instanceof D?!0:f instanceof Error&&f.name===m&&f.message===m}t.$4=w;class D extends Error{constructor(){super(m),this.name=this.message}}t.$5=D;function M(){const f=new Error(m);return f.name=f.message,f}t.$6=M;function r(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.$7=r;function l(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.$8=l;class e extends TypeError{constructor(a){super(a?`${a} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function s(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.$0=s;class g extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}t.$$=g;class b extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}t.$_=b;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=h;class $ extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof $)return a;const C=new $;return C.message=a.message,C.stack=a.stack,C}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}t.$bb=$;class c extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}t.$cb=c}),define(be[12],$e([1,0,6,72]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function n(x,d=0){return x[x.length-(1+d)]}t.$sb=n;function H(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}t.$tb=H;function A(x,d,y=(p,u)=>p===u){if(x===d)return!0;if(!x||!d||x.length!==d.length)return!1;for(let p=0,u=x.length;p<u;p++)if(!y(x[p],d[p]))return!1;return!0}t.$ub=A;function S(x,d){const y=x.length-1;d<y&&(x[d]=x[y]),x.pop()}t.$vb=S;function m(x,d,y){return w(x.length,p=>y(x[p],d))}t.$wb=m;function w(x,d){let y=0,p=x-1;for(;y<=p;){const u=(y+p)/2|0,i=d(u);if(i<0)y=u+1;else if(i>0)p=u-1;else return u}return-(y+1)}t.$xb=w;function D(x,d,y){if(x=x|0,x>=d.length)throw new TypeError("invalid index");const p=d[Math.floor(d.length*Math.random())],u=[],i=[],o=[];for(const E of d){const R=y(E,p);R<0?u.push(E):R>0?i.push(E):o.push(E)}return x<u.length?D(x,u,y):x<u.length+o.length?o[0]:D(x-(u.length+o.length),i,y)}t.$yb=D;function M(x,d){const y=[];let p;for(const u of x.slice(0).sort(d))!p||d(p[0],u)!==0?(p=[u],y.push(p)):p.push(u);return y}t.$zb=M;function*r(x,d){let y,p;for(const u of x)p!==void 0&&d(p,u)?y.push(u):(y&&(yield y),y=[u]),p=u;y&&(yield y)}t.$Ab=r;function l(x,d){for(let y=0;y<=x.length;y++)d(y===0?void 0:x[y-1],y===x.length?void 0:x[y])}t.$Bb=l;function e(x,d){for(let y=0;y<x.length;y++)d(y===0?void 0:x[y-1],x[y],y+1===x.length?void 0:x[y+1])}t.$Cb=e;function s(x,d,y){const p=[];function u(E,R,F){if(R===0&&F.length===0)return;const j=p[p.length-1];j&&j.start+j.deleteCount===E?(j.deleteCount+=R,j.toInsert.push(...F)):p.push({start:E,deleteCount:R,toInsert:F})}let i=0,o=0;for(;;){if(i===x.length){u(i,0,d.slice(o));break}if(o===d.length){u(i,x.length-i,[]);break}const E=x[i],R=d[o],F=y(E,R);F===0?(i+=1,o+=1):F<0?(u(i,1,[]),i+=1):F>0&&(u(i,0,[R]),o+=1)}return p}t.$Db=s;function g(x,d,y){const p=s(x,d,y),u=[],i=[];for(const o of p)u.push(...x.slice(o.start,o.start+o.deleteCount)),i.push(...o.toInsert);return{removed:u,added:i}}t.$Eb=g;function b(x,d,y){if(y===0)return[];const p=x.slice(0,y).sort(d);return $(x,d,p,y,x.length),p}t.top=b;function h(x,d,y,p,u){return y===0?Promise.resolve([]):new Promise((i,o)=>{(async()=>{const E=x.length,R=x.slice(0,y).sort(d);for(let F=y,j=Math.min(y+p,E);F<E;F=j,j=Math.min(j+p,E)){if(F>y&&await new Promise(q=>setTimeout(q)),u&&u.isCancellationRequested)throw new k.$5;$(x,d,R,F,j)}return R})().then(i,o)})}t.$Gb=h;function $(x,d,y,p,u){for(const i=y.length;p<u;p++){const o=x[p];if(d(o,y[i-1])<0){y.pop();const E=(0,T.$kb)(y,R=>d(o,R)<0);y.splice(E,0,o)}}}function c(x){return x.filter(d=>!!d)}t.$Hb=c;function f(x){let d=0;for(let y=0;y<x.length;y++)x[y]&&(x[d]=x[y],d+=1);x.length=d}t.$Ib=f;function a(x,d,y){x.splice(y,0,x.splice(d,1)[0])}t.$Jb=a;function C(x){return!Array.isArray(x)||x.length===0}t.$Kb=C;function O(x){return Array.isArray(x)&&x.length>0}t.$Lb=O;function L(x,d=y=>y){const y=new Set;return x.filter(p=>{const u=d(p);return y.has(u)?!1:(y.add(u),!0)})}t.$Mb=L;function B(x){const d=new Set;return y=>{const p=x(y);return d.has(p)?!1:(d.add(p),!0)}}t.$Nb=B;function v(x,d){return x.length>0?x[0]:d}t.$Ob=v;function P(x,d){return x.length>0?x[x.length-1]:d}t.$Pb=P;function V(x,d,y=(p,u)=>p===u){let p=0;for(let u=0,i=Math.min(x.length,d.length);u<i&&y(x[u],d[u]);u++)p++;return p}t.$Qb=V;function U(x){return[].concat(...x)}t.$Rb=U;function N(x,d){let y=typeof d=="number"?x:0;typeof d=="number"?y=x:(y=0,d=x);const p=[];if(y<=d)for(let u=y;u<d;u++)p.push(u);else for(let u=y;u>d;u--)p.push(u);return p}t.$Sb=N;function I(x,d,y){return x.reduce((p,u)=>(p[d(u)]=y?y(u):u,p),Object.create(null))}t.$Tb=I;function z(x,d){return x.push(d),()=>X(x,d)}t.$Ub=z;function X(x,d){const y=x.indexOf(d);if(y>-1)return x.splice(y,1),d}t.$Vb=X;function Y(x,d,y){const p=x.slice(0,d),u=x.slice(d);return p.concat(y,u)}t.$Wb=Y;function fe(x,d){let y;if(typeof d=="number"){let p=d;y=()=>{const u=Math.sin(p++)*179426549;return u-Math.floor(u)}}else y=Math.random;for(let p=x.length-1;p>0;p-=1){const u=Math.floor(y()*(p+1)),i=x[p];x[p]=x[u],x[u]=i}}t.$Xb=fe;function ae(x,d){const y=x.indexOf(d);y>-1&&(x.splice(y,1),x.unshift(d))}t.$Yb=ae;function ee(x,d){const y=x.indexOf(d);y>-1&&(x.splice(y,1),x.push(d))}t.$Zb=ee;function ge(x,d){for(const y of d)x.push(y)}t.$1b=ge;function Ie(x,d){return Array.isArray(x)?x.map(d):d(x)}t.$2b=Ie;function Ce(x){return Array.isArray(x)?x:[x]}t.$3b=Ce;function Be(x){return x[Math.floor(Math.random()*x.length)]}t.$4b=Be;function se(x,d,y){const p=re(x,d),u=x.length,i=y.length;x.length=u+i;for(let o=u-1;o>=p;o--)x[o+i]=x[o];for(let o=0;o<i;o++)x[o+p]=y[o]}t.$5b=se;function J(x,d,y,p){const u=re(x,d);let i=x.splice(u,y);return i===void 0&&(i=[]),se(x,u,p),i}t.$6b=J;function re(x,d){return d<0?Math.max(d+x.length,0):Math.min(d,x.length)}var oe;(function(x){function d(i){return i<0}x.isLessThan=d;function y(i){return i<=0}x.isLessThanOrEqual=y;function p(i){return i>0}x.isGreaterThan=p;function u(i){return i===0}x.isNeitherLessOrGreaterThan=u,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(oe||(t.CompareResult=oe={}));function W(x,d){return(y,p)=>d(x(y),x(p))}t.$7b=W;function G(...x){return(d,y)=>{for(const p of x){const u=p(d,y);if(!oe.isNeitherLessOrGreaterThan(u))return u}return oe.neitherLessOrGreaterThan}}t.$8b=G;const ue=(x,d)=>x-d;t.$9b=ue;const me=(x,d)=>(0,t.$9b)(x?1:0,d?1:0);t.$0b=me;function Se(x){return(d,y)=>-x(d,y)}t.$$b=Se;class ke{constructor(d){this.g=d,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(d){let y=this.c;for(;y<this.g.length&&d(this.g[y]);)y++;const p=y===this.c?null:this.g.slice(this.c,y);return this.c=y,p}takeFromEndWhile(d){let y=this.d;for(;y>=0&&d(this.g[y]);)y--;const p=y===this.d?null:this.g.slice(y+1,this.d+1);return this.d=y,p}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const d=this.g[this.c];return this.c++,d}removeLast(){const d=this.g[this.d];return this.d--,d}takeCount(d){const y=this.g.slice(this.c,this.c+d);return this.c+=d,y}}t.$_b=ke;class Pe{static{this.empty=new Pe(d=>{})}constructor(d){this.iterate=d}forEach(d){this.iterate(y=>(d(y),!0))}toArray(){const d=[];return this.iterate(y=>(d.push(y),!0)),d}filter(d){return new Pe(y=>this.iterate(p=>d(p)?y(p):!0))}map(d){return new Pe(y=>this.iterate(p=>y(d(p))))}some(d){let y=!1;return this.iterate(p=>(y=d(p),!y)),y}findFirst(d){let y;return this.iterate(p=>d(p)?(y=p,!1):!0),y}findLast(d){let y;return this.iterate(p=>(d(p)&&(y=p),!0)),y}findLastMaxBy(d){let y,p=!0;return this.iterate(u=>((p||oe.isGreaterThan(d(u,y)))&&(p=!1,y=u),!0)),y}}t.$ac=Pe}),define(be[76],$e([1,0,6]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9c=t.$8c=t.$7c=t.$6c=t.ok=void 0;function T(m,w){if(!m)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}t.ok=T;function n(m,w="Unreachable"){throw new Error(w)}t.$6c=n;function H(m){if(!m)throw new k.$cb("Assertion Failed")}t.$7c=H;function A(m){if(!m()){debugger;m(),(0,k.$1)(new k.$cb("Assertion Failed"))}}t.$8c=A;function S(m,w){let D=0;for(;D<m.length-1;){const M=m[D],r=m[D+1];if(!w(M,r))return!1;D++}return!0}t.$9c=S}),define(be[43],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function k(T,n){const H=this;let A=!1,S;return function(){if(A)return S;if(A=!0,n)try{S=T.apply(H,arguments)}finally{n()}else S=T.apply(H,arguments);return S}}t.$db=k}),define(be[77],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hN=t.$gN=void 0;class k{constructor(n){this.a=n,this.b=0}nextId(){return this.a+ ++this.b}}t.$gN=k,t.$hN=new k("id#")}),define(be[28],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var k;(function(T){function n(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}T.is=n;const H=Object.freeze([]);function A(){return H}T.empty=A;function*S(a){yield a}T.single=S;function m(a){return n(a)?a:S(a)}T.wrap=m;function w(a){return a||H}T.from=w;function*D(a){for(let C=a.length-1;C>=0;C--)yield a[C]}T.reverse=D;function M(a){return!a||a[Symbol.iterator]().next().done===!0}T.isEmpty=M;function r(a){return a[Symbol.iterator]().next().value}T.first=r;function l(a,C){for(const O of a)if(C(O))return!0;return!1}T.some=l;function e(a,C){for(const O of a)if(C(O))return O}T.find=e;function*s(a,C){for(const O of a)C(O)&&(yield O)}T.filter=s;function*g(a,C){let O=0;for(const L of a)yield C(L,O++)}T.map=g;function*b(...a){for(const C of a)yield*C}T.concat=b;function h(a,C,O){let L=O;for(const B of a)L=C(L,B);return L}T.reduce=h;function*$(a,C,O=a.length){for(C<0&&(C+=a.length),O<0?O+=a.length:O>a.length&&(O=a.length);C<O;C++)yield a[C]}T.slice=$;function c(a,C=Number.POSITIVE_INFINITY){const O=[];if(C===0)return[O,a];const L=a[Symbol.iterator]();for(let B=0;B<C;B++){const v=L.next();if(v.done)return[O,T.empty()];O.push(v.value)}return[O,{[Symbol.iterator](){return L}}]}T.consume=c;async function f(a){const C=[];for await(const O of a)C.push(O);return Promise.resolve(C)}T.asyncToArray=f})(k||(t.Iterable=k={}))}),define(be[44],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7q=t.KeyMod=t.KeyCodeUtils=t.$6q=t.$5q=t.$4q=t.$3q=t.$2q=t.ScanCode=t.KeyCode=void 0;var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(k||(t.KeyCode=k={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T||(t.ScanCode=T={}));class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,g){this._keyCodeToStr[s]=g,this._strToKeyCode[g.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const H=new n,A=new n,S=new n;t.$2q=new Array(230),t.$3q={};const m=[],w=Object.create(null),D=Object.create(null);t.$4q={lowerCaseToEnum:e=>D[e]||0,toEnum:e=>w[e]||0,toString:e=>m[e]||"None"},t.$5q=[],t.$6q=[];for(let e=0;e<=193;e++)t.$5q[e]=-1;for(let e=0;e<=132;e++)t.$6q[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],g=[],b=[];for(const h of s){const[$,c,f,a,C,O,L,B,v]=h;if(b[c]||(b[c]=!0,m[c]=f,w[f]=c,D[f.toLowerCase()]=c,$&&(t.$5q[c]=a,a!==0&&a!==3&&a!==5&&a!==4&&a!==6&&a!==57&&(t.$6q[a]=c))),!g[a]){if(g[a]=!0,!C)throw new Error(`String representation missing for key code ${a} around scan code ${f}`);H.define(a,C),A.define(a,B||C),S.define(a,v||B||C)}O&&(t.$2q[O]=a),L&&(t.$3q[L]=a)}t.$6q[3]=46})();var M;(function(e){function s(f){return H.keyCodeToStr(f)}e.toString=s;function g(f){return H.strToKeyCode(f)}e.fromString=g;function b(f){return A.keyCodeToStr(f)}e.toUserSettingsUS=b;function h(f){return S.keyCodeToStr(f)}e.toUserSettingsGeneral=h;function $(f){return A.strToKeyCode(f)||S.strToKeyCode(f)}e.fromUserSettings=$;function c(f){if(f>=98&&f<=113)return null;switch(f){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(f)}e.toElectronAccelerator=c})(M||(t.KeyCodeUtils=M={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r||(t.KeyMod=r={}));function l(e,s){const g=(s&65535)<<16>>>0;return(e|g)>>>0}t.$7q=l}),define(be[78],$e([1,0,6]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$br=t.$ar=t.$_q=t.$$q=t.$0q=t.$9q=t.$8q=void 0;var T;(function(M){M[M.CtrlCmd=2048]="CtrlCmd",M[M.Shift=1024]="Shift",M[M.Alt=512]="Alt",M[M.WinCtrl=256]="WinCtrl",M[M.KeyCode=255]="KeyCode"})(T||(T={}));function n(M,r){if(typeof M=="number"){if(M===0)return null;const l=(M&65535)>>>0,e=(M&4294901760)>>>16;return e!==0?new m([H(l,r),H(e,r)]):new m([H(l,r)])}else{const l=[];for(let e=0;e<M.length;e++)l.push(H(M[e],r));return new m(l)}}t.$8q=n;function H(M,r){const l=!!(M&2048),e=!!(M&256),s=r===2?e:l,g=!!(M&1024),b=!!(M&512),h=r===2?l:e,$=M&255;return new A(s,g,b,h,$)}t.$9q=H;class A{constructor(r,l,e,s,g){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=s,this.keyCode=g}equals(r){return r instanceof A&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${r}${l}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$0q=A;class S{constructor(r,l,e,s,g){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=s,this.scanCode=g}equals(r){return r instanceof S&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${r}${l}${e}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$$q=S;class m{constructor(r){if(r.length===0)throw(0,k.$7)("chords");this.chords=r}getHashCode(){let r="";for(let l=0,e=this.chords.length;l<e;l++)l!==0&&(r+=";"),r+=this.chords[l].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let l=0;l<this.chords.length;l++)if(!this.chords[l].equals(r.chords[l]))return!1;return!0}}t.$_q=m;class w{constructor(r,l,e,s,g,b){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=s,this.keyLabel=g,this.keyAriaLabel=b}}t.$ar=w;class D{}t.$br=D}),define(be[23],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class k{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=k}),define(be[45],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class k{static{this.Undefined=new k(void 0)}constructor(H){this.element=H,this.next=k.Undefined,this.prev=k.Undefined}}class T{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let H=this.a;for(;H!==k.Undefined;){const A=H.next;H.prev=k.Undefined,H.next=k.Undefined,H=A}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,A){const S=new k(H);if(this.a===k.Undefined)this.a=S,this.b=S;else if(A){const w=this.b;this.b=S,S.prev=w,w.next=S}else{const w=this.a;this.a=S,S.next=w,w.prev=S}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(S))}}shift(){if(this.a!==k.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==k.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==k.Undefined&&H.next!==k.Undefined){const A=H.prev;A.next=H.next,H.next.prev=A}else H.prev===k.Undefined&&H.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):H.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):H.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==k.Undefined;)yield H.element,H=H.next}}t.$4c=T}),define(be[32],$e([1,0]),function(ie,t){"use strict";var k,T,n;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function H($,c,f){let a=$.get(c);return a===void 0&&(a=f,$.set(c,a)),a}t.$xc=H;function A($){const c=[];return $.forEach((f,a)=>{c.push(`${a} => ${f}`)}),`Map(${$.size}) {${c.join(", ")}}`}t.$yc=A;function S($){const c=[];return $.forEach(f=>{c.push(f)}),`Set(${$.size}) {${c.join(", ")}}`}t.$zc=S;class m{constructor(c,f){this.uri=c,this.value=f}}function w($){return Array.isArray($)}class D{static{this.c=c=>c.toString()}constructor(c,f){if(this[k]="ResourceMap",c instanceof D)this.d=new Map(c.d),this.e=f??D.c;else if(w(c)){this.d=new Map,this.e=f??D.c;for(const[a,C]of c)this.set(a,C)}else this.d=new Map,this.e=c??D.c}set(c,f){return this.d.set(this.e(c),new m(c,f)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,f){typeof f<"u"&&(c=c.bind(f));for(const[a,C]of this.d)c(C.value,C.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}t.$Ac=D;class M{constructor(c,f){this[T]="ResourceSet",!c||typeof c=="function"?this.c=new D(c):(this.c=new D(f),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,f){this.c.forEach((a,C)=>c.call(f,C,C,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=M;var r;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(r||(t.Touch=r={}));class l{constructor(){this[n]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,f=0){const a=this.c.get(c);if(a)return f!==0&&this.l(a,f),a.value}set(c,f,a=0){let C=this.c.get(c);if(C)C.value=f,a!==0&&this.l(C,a);else{switch(C={key:c,value:f,next:void 0,previous:void 0},a){case 0:this.j(C);break;case 1:this.i(C);break;case 2:this.j(C);break;default:this.j(C);break}this.c.set(c,C),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const f=this.c.get(c);if(f)return this.c.delete(c),this.k(f),this.f--,f.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,f){const a=this.g;let C=this.d;for(;C;){if(f?c.bind(f)(C.value,C.key,this):c(C.value,C.key,this),this.g!==a)throw new Error("LinkedMap got modified during iteration.");C=C.next}}keys(){const c=this,f=this.g;let a=this.d;const C={[Symbol.iterator](){return C},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(a){const O={value:a.key,done:!1};return a=a.next,O}else return{value:void 0,done:!0}}};return C}values(){const c=this,f=this.g;let a=this.d;const C={[Symbol.iterator](){return C},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(a){const O={value:a.value,done:!1};return a=a.next,O}else return{value:void 0,done:!0}}};return C}entries(){const c=this,f=this.g;let a=this.d;const C={[Symbol.iterator](){return C},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(a){const O={value:[a.key,a.value],done:!1};return a=a.next,O}else return{value:void 0,done:!0}}};return C}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let f=this.d,a=this.size;for(;f&&a>c;)this.c.delete(f.key),f=f.next,a--;this.d=f,this.f=a,f&&(f.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const f=c.next,a=c.previous;if(!f||!a)throw new Error("Invalid list");f.previous=a,a.next=f}c.next=void 0,c.previous=void 0,this.g++}l(c,f){if(!this.d||!this.e)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(c===this.d)return;const a=c.next,C=c.previous;c===this.e?(C.next=void 0,this.e=C):(a.previous=C,C.next=a),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(f===2){if(c===this.e)return;const a=c.next,C=c.previous;c===this.d?(a.previous=void 0,this.d=a):(a.previous=C,C.next=a),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((f,a)=>{c.push([a,f])}),c}fromJSON(c){this.clear();for(const[f,a]of c)this.set(f,a)}}t.$Cc=l;class e extends l{constructor(c,f=1){super(),this.m=c,this.n=Math.min(Math.max(0,f),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,f=2){return super.get(c,f)}peek(c){return super.get(c,0)}set(c,f){return super.set(c,f,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class s{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let f=this.c.get(c)||0;return f===0?!1:(f--,f===0?this.c.delete(c):this.c.set(c,f),!0)}has(c){return this.c.has(c)}}t.$Ec=s;class g{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[f,a]of c)this.set(f,a)}clear(){this.c.clear(),this.d.clear()}set(c,f){this.c.set(c,f),this.d.set(f,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const f=this.c.get(c);return f===void 0?!1:(this.c.delete(c),this.d.delete(f),!0)}forEach(c,f){this.c.forEach((a,C)=>{c.call(f,a,C,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=g;class b{constructor(){this.c=new Map}add(c,f){let a=this.c.get(c);a||(a=new Set,this.c.set(c,a)),a.add(f)}delete(c,f){const a=this.c.get(c);a&&(a.delete(f),a.size===0&&this.c.delete(c))}forEach(c,f){const a=this.c.get(c);a&&a.forEach(f)}get(c){const f=this.c.get(c);return f||new Set}}t.$Gc=b;function h($,c){if($===c)return!0;if($.size!==c.size)return!1;for(const[f,a]of $)if(!c.has(f)||c.get(f)!==a)return!1;for(const[f]of c)if(!$.has(f))return!1;return!0}t.$Hc=h}),define(be[2],$e([1,0,12,73,32,43,28]),function(ie,t,k,T,n,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const S=!1;let m=null;class w{constructor(){this.b=new Map}static{this.a=0}c(z){let X=this.b.get(z);return X||(X={parent:null,source:null,isSingleton:!1,value:z,idx:w.a++},this.b.set(z,X)),X}trackDisposable(z){const X=this.c(z);X.source||(X.source=new Error().stack)}setParent(z,X){const Y=this.c(z);Y.parent=X}markAsDisposed(z){this.b.delete(z)}markAsSingleton(z){this.c(z).isSingleton=!0}f(z,X){const Y=X.get(z);if(Y)return Y;const fe=z.parent?this.f(this.c(z.parent),X):z;return X.set(z,fe),fe}getTrackedDisposables(){const z=new Map;return[...this.b.entries()].filter(([,Y])=>Y.source!==null&&!this.f(Y,z).isSingleton).flatMap(([Y])=>Y)}computeLeakingDisposables(z=10,X){let Y;if(X)Y=X;else{const Ie=new Map,Ce=[...this.b.values()].filter(se=>se.source!==null&&!this.f(se,Ie).isSingleton);if(Ce.length===0)return;const Be=new Set(Ce.map(se=>se.value));if(Y=Ce.filter(se=>!(se.parent&&Be.has(se.parent))),Y.length===0)throw new Error("There are cyclic diposable chains!")}if(!Y)return;function fe(Ie){function Ce(se,J){for(;se.length>0&&J.some(re=>typeof re=="string"?re===se[0]:se[0].match(re));)se.shift()}const Be=Ie.source.split(`
`).map(se=>se.trim().replace("at ","")).filter(se=>se!=="");return Ce(Be,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Be.reverse()}const ae=new n.$Gc;for(const Ie of Y){const Ce=fe(Ie);for(let Be=0;Be<=Ce.length;Be++)ae.add(Ce.slice(0,Be).join(`
`),Ie)}Y.sort((0,k.$7b)(Ie=>Ie.idx,k.$9b));let ee="",ge=0;for(const Ie of Y.slice(0,z)){ge++;const Ce=fe(Ie),Be=[];for(let se=0;se<Ce.length;se++){let J=Ce[se];J=`(shared with ${ae.get(Ce.slice(0,se+1).join(`
`)).size}/${Y.length} leaks) at ${J}`;const oe=ae.get(Ce.slice(0,se).join(`
`)),W=(0,T.$K)([...oe].map(G=>fe(G)[se]),G=>G);delete W[Ce[se]];for(const[G,ue]of Object.entries(W))Be.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${G}`);Be.unshift(J)}ee+=`


==================== Leaking disposable ${ge}/${Y.length}: ${Ie.value.constructor.name} ====================
${Be.join(`
`)}
============================================================

`}return Y.length>z&&(ee+=`


... and ${Y.length-z} more leaking disposables

`),{leaks:Y,details:ee}}}t.$Ic=w;function D(I){m=I}if(t.$Jc=D,S){const I="__is_disposable_tracked__";D(new class{trackDisposable(z){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{z[I]||console.log(X)},3e3)}setParent(z,X){if(z&&z!==a.None)try{z[I]=!0}catch{}}markAsDisposed(z){if(z&&z!==a.None)try{z[I]=!0}catch{}}markAsSingleton(z){}})}function M(I){return m?.trackDisposable(I),I}t.$Kc=M;function r(I){m?.markAsDisposed(I)}t.$Lc=r;function l(I,z){m?.setParent(I,z)}function e(I,z){if(m)for(const X of I)m.setParent(X,z)}function s(I){return m?.markAsSingleton(I),I}t.$Mc=s;function g(I){return typeof I.dispose=="function"&&I.dispose.length===0}t.$Nc=g;function b(I){if(A.Iterable.is(I)){const z=[];for(const X of I)if(X)try{X.dispose()}catch(Y){z.push(Y)}if(z.length===1)throw z[0];if(z.length>1)throw new AggregateError(z,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}t.$Oc=b;function h(I){for(const z of I)g(z)&&z.dispose();return[]}t.$Pc=h;function $(...I){const z=c(()=>b(I));return e(I,z),z}t.$Qc=$;function c(I){const z=M({dispose:(0,H.$db)(()=>{r(z),I()})});return z}t.$Rc=c;class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,M(this)}dispose(){this.g||(r(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(z){if(!z)return z;if(z===this)throw new Error("Cannot register a disposable on itself!");return l(z,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(z),z}delete(z){if(z){if(z===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(z),z.dispose()}}deleteAndLeak(z){z&&this.f.has(z)&&(this.f.delete(z),l(z,null))}}t.$Sc=f;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,M(this),l(this.q,this)}dispose(){r(this),this.q.dispose()}B(z){if(z===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(z)}}t.$Tc=a;class C{constructor(){this.b=!1,M(this)}get value(){return this.b?void 0:this.a}set value(z){this.b||z===this.a||(this.a?.dispose(),z&&l(z,this),this.a=z)}clear(){this.value=void 0}dispose(){this.b=!0,r(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const z=this.a;return this.a=void 0,z&&l(z,null),z}}t.$Uc=C;class O{constructor(z){this.a=new C,this.b=!1,this.a.value=z}get value(){return this.a.value}set value(z){this.b||z===this.a.value||(this.a.value=z)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=O;class L{constructor(z){this.b=z,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=L;class B{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,M(this)}set(z){let X=z;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,r(this))},this}}t.$Xc=B;class v{constructor(){this.a=new Map}acquire(z,...X){let Y=this.a.get(z);Y||(Y={counter:0,object:this.b(z,...X)},this.a.set(z,Y));const{object:fe}=Y,ae=(0,H.$db)(()=>{--Y.counter===0&&(this.c(z,Y.object),this.a.delete(z))});return Y.counter++,{object:fe,dispose:ae}}}t.$Yc=v;class P{constructor(z){this.a=z}async acquire(z,...X){const Y=this.a.acquire(z,...X);try{return{object:await Y.object,dispose:()=>Y.dispose()}}catch(fe){throw Y.dispose(),fe}}}t.$Zc=P;class V{constructor(z){this.object=z}dispose(){}}t.$1c=V;function U(I){const z=new f;try{I(z)}finally{z.dispose()}}t.$2c=U;class N{constructor(){this.a=new Map,this.b=!1,M(this)}dispose(){r(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(z){return this.a.has(z)}get size(){return this.a.size}get(z){return this.a.get(z)}set(z,X,Y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Y||this.a.get(z)?.dispose(),this.a.set(z,X)}deleteAndDispose(z){this.a.get(z)?.dispose(),this.a.delete(z)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=N}),function(ie,t){typeof define=="function"&&define.amd?define(be[79],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,t(ie.marked={}))}(this,function(ie){"use strict";function t(d,y){for(var p=0;p<y.length;p++){var u=y[p];u.enumerable=u.enumerable||!1,u.configurable=!0,"value"in u&&(u.writable=!0),Object.defineProperty(d,u.key,u)}}function k(d,y,p){return y&&t(d.prototype,y),p&&t(d,p),Object.defineProperty(d,"prototype",{writable:!1}),d}function T(d,y){if(d){if(typeof d=="string")return n(d,y);var p=Object.prototype.toString.call(d).slice(8,-1);if(p==="Object"&&d.constructor&&(p=d.constructor.name),p==="Map"||p==="Set")return Array.from(d);if(p==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(p))return n(d,y)}}function n(d,y){(y==null||y>d.length)&&(y=d.length);for(var p=0,u=new Array(y);p<y;p++)u[p]=d[p];return u}function H(d,y){var p=typeof Symbol<"u"&&d[Symbol.iterator]||d["@@iterator"];if(p)return(p=p.call(d)).next.bind(p);if(Array.isArray(d)||(p=T(d))||y&&d&&typeof d.length=="number"){p&&(d=p);var u=0;return function(){return u>=d.length?{done:!0}:{done:!1,value:d[u++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=A();function S(d){ie.defaults=d}var m=/[&<>"']/,w=/[&<>"']/g,D=/[<>"']|&(?!#?\w+;)/,M=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(y){return r[y]};function e(d,y){if(y){if(m.test(d))return d.replace(w,l)}else if(D.test(d))return d.replace(M,l);return d}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(d){return d.replace(s,function(y,p){return p=p.toLowerCase(),p==="colon"?":":p.charAt(0)==="#"?p.charAt(1)==="x"?String.fromCharCode(parseInt(p.substring(2),16)):String.fromCharCode(+p.substring(1)):""})}var b=/(^|[^\[])\^/g;function h(d,y){d=typeof d=="string"?d:d.source,y=y||"";var p={replace:function(i,o){return o=o.source||o,o=o.replace(b,"$1"),d=d.replace(i,o),p},getRegex:function(){return new RegExp(d,y)}};return p}var $=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(d,y,p){if(d){var u;try{u=decodeURIComponent(g(p)).replace($,"").toLowerCase()}catch{return null}if(u.indexOf("javascript:")===0||u.indexOf("vbscript:")===0||u.indexOf("data:")===0)return null}y&&!c.test(p)&&(p=B(y,p));try{p=encodeURI(p).replace(/%25/g,"%")}catch{return null}return p}var a={},C=/^[^:]+:\/*[^/]*$/,O=/^([^:]+:)[\s\S]*$/,L=/^([^:]+:\/*[^/]*)[\s\S]*$/;function B(d,y){a[" "+d]||(C.test(d)?a[" "+d]=d+"/":a[" "+d]=U(d,"/",!0)),d=a[" "+d];var p=d.indexOf(":")===-1;return y.substring(0,2)==="//"?p?y:d.replace(O,"$1")+y:y.charAt(0)==="/"?p?y:d.replace(L,"$1")+y:d+y}var v={exec:function(){}};function P(d){for(var y=1,p,u;y<arguments.length;y++){p=arguments[y];for(u in p)Object.prototype.hasOwnProperty.call(p,u)&&(d[u]=p[u])}return d}function V(d,y){var p=d.replace(/\|/g,function(o,E,R){for(var F=!1,j=E;--j>=0&&R[j]==="\\";)F=!F;return F?"|":" |"}),u=p.split(/ \|/),i=0;if(u[0].trim()||u.shift(),u.length>0&&!u[u.length-1].trim()&&u.pop(),u.length>y)u.splice(y);else for(;u.length<y;)u.push("");for(;i<u.length;i++)u[i]=u[i].trim().replace(/\\\|/g,"|");return u}function U(d,y,p){var u=d.length;if(u===0)return"";for(var i=0;i<u;){var o=d.charAt(u-i-1);if(o===y&&!p)i++;else if(o!==y&&p)i++;else break}return d.slice(0,u-i)}function N(d,y){if(d.indexOf(y[1])===-1)return-1;for(var p=d.length,u=0,i=0;i<p;i++)if(d[i]==="\\")i++;else if(d[i]===y[0])u++;else if(d[i]===y[1]&&(u--,u<0))return i;return-1}function I(d){d&&d.sanitize&&!d.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function z(d,y){if(y<1)return"";for(var p="";y>1;)y&1&&(p+=d),y>>=1,d+=d;return p+d}function X(d,y,p,u){var i=y.href,o=y.title?e(y.title):null,E=d[1].replace(/\\([\[\]])/g,"$1");if(d[0].charAt(0)!=="!"){u.state.inLink=!0;var R={type:"link",raw:p,href:i,title:o,text:E,tokens:u.inlineTokens(E)};return u.state.inLink=!1,R}return{type:"image",raw:p,href:i,title:o,text:e(E)}}function Y(d,y){var p=d.match(/^(\s+)(?:```)/);if(p===null)return y;var u=p[1];return y.split(`
`).map(function(i){var o=i.match(/^\s+/);if(o===null)return i;var E=o[0];return E.length>=u.length?i.slice(u.length):i}).join(`
`)}var fe=function(){function d(p){this.options=p||ie.defaults}var y=d.prototype;return y.space=function(u){var i=this.rules.block.newline.exec(u);if(i&&i[0].length>0)return{type:"space",raw:i[0]}},y.code=function(u){var i=this.rules.block.code.exec(u);if(i){var o=i[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:i[0],codeBlockStyle:"indented",text:this.options.pedantic?o:U(o,`
`)}}},y.fences=function(u){var i=this.rules.block.fences.exec(u);if(i){var o=i[0],E=Y(o,i[3]||"");return{type:"code",raw:o,lang:i[2]?i[2].trim():i[2],text:E}}},y.heading=function(u){var i=this.rules.block.heading.exec(u);if(i){var o=i[2].trim();if(/#$/.test(o)){var E=U(o,"#");(this.options.pedantic||!E||/ $/.test(E))&&(o=E.trim())}return{type:"heading",raw:i[0],depth:i[1].length,text:o,tokens:this.lexer.inline(o)}}},y.hr=function(u){var i=this.rules.block.hr.exec(u);if(i)return{type:"hr",raw:i[0]}},y.blockquote=function(u){var i=this.rules.block.blockquote.exec(u);if(i){var o=i[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:i[0],tokens:this.lexer.blockTokens(o,[]),text:o}}},y.list=function(u){var i=this.rules.block.list.exec(u);if(i){var o,E,R,F,j,q,Z,le,pe,De,we,Ee,ve=i[1].trim(),Te=ve.length>1,Le={type:"list",raw:"",ordered:Te,start:Te?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Te?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Te?ve:"[*+-]");for(var Me=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");u&&(Ee=!1,!(!(i=Me.exec(u))||this.rules.block.hr.test(u)));){if(o=i[0],u=u.substring(o.length),le=i[2].split(`
`,1)[0],pe=u.split(`
`,1)[0],this.options.pedantic?(F=2,we=le.trimLeft()):(F=i[2].search(/[^ ]/),F=F>4?1:F,we=le.slice(F),F+=i[1].length),q=!1,!le&&/^ *$/.test(pe)&&(o+=pe+`
`,u=u.substring(pe.length+1),Ee=!0),!Ee)for(var Ze=new RegExp("^ {0,"+Math.min(3,F-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,F-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),xe=new RegExp("^ {0,"+Math.min(3,F-1)+"}(?:```|~~~)"),K=new RegExp("^ {0,"+Math.min(3,F-1)+"}#");u&&(De=u.split(`
`,1)[0],le=De,this.options.pedantic&&(le=le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(xe.test(le)||K.test(le)||Ze.test(le)||et.test(u)));){if(le.search(/[^ ]/)>=F||!le.trim())we+=`
`+le.slice(F);else if(!q)we+=`
`+le;else break;!q&&!le.trim()&&(q=!0),o+=De+`
`,u=u.substring(De.length+1)}Le.loose||(Z?Le.loose=!0:/\n *\n *$/.test(o)&&(Z=!0)),this.options.gfm&&(E=/^\[[ xX]\] /.exec(we),E&&(R=E[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Le.items.push({type:"list_item",raw:o,task:!!E,checked:R,loose:!1,text:we}),Le.raw+=o}Le.items[Le.items.length-1].raw=o.trimRight(),Le.items[Le.items.length-1].text=we.trimRight(),Le.raw=Le.raw.trimRight();var ne=Le.items.length;for(j=0;j<ne;j++){this.lexer.state.top=!1,Le.items[j].tokens=this.lexer.blockTokens(Le.items[j].text,[]);var de=Le.items[j].tokens.filter(function(Ne){return Ne.type==="space"}),Ae=de.every(function(Ne){for(var je=Ne.raw.split(""),Ve=0,_e=H(je),Je;!(Je=_e()).done;){var tt=Je.value;if(tt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Le.loose&&de.length&&Ae&&(Le.loose=!0,Le.items[j].loose=!0)}return Le}},y.html=function(u){var i=this.rules.block.html.exec(u);if(i){var o={type:"html",raw:i[0],pre:!this.options.sanitizer&&(i[1]==="pre"||i[1]==="script"||i[1]==="style"),text:i[0]};if(this.options.sanitize){var E=this.options.sanitizer?this.options.sanitizer(i[0]):e(i[0]);o.type="paragraph",o.text=E,o.tokens=this.lexer.inline(E)}return o}},y.def=function(u){var i=this.rules.block.def.exec(u);if(i){i[3]&&(i[3]=i[3].substring(1,i[3].length-1));var o=i[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:o,raw:i[0],href:i[2],title:i[3]}}},y.table=function(u){var i=this.rules.block.table.exec(u);if(i){var o={type:"table",header:V(i[1]).map(function(Z){return{text:Z}}),align:i[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:i[3]&&i[3].trim()?i[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(o.header.length===o.align.length){o.raw=i[0];var E=o.align.length,R,F,j,q;for(R=0;R<E;R++)/^ *-+: *$/.test(o.align[R])?o.align[R]="right":/^ *:-+: *$/.test(o.align[R])?o.align[R]="center":/^ *:-+ *$/.test(o.align[R])?o.align[R]="left":o.align[R]=null;for(E=o.rows.length,R=0;R<E;R++)o.rows[R]=V(o.rows[R],o.header.length).map(function(Z){return{text:Z}});for(E=o.header.length,F=0;F<E;F++)o.header[F].tokens=this.lexer.inline(o.header[F].text);for(E=o.rows.length,F=0;F<E;F++)for(q=o.rows[F],j=0;j<q.length;j++)q[j].tokens=this.lexer.inline(q[j].text);return o}}},y.lheading=function(u){var i=this.rules.block.lheading.exec(u);if(i)return{type:"heading",raw:i[0],depth:i[2].charAt(0)==="="?1:2,text:i[1],tokens:this.lexer.inline(i[1])}},y.paragraph=function(u){var i=this.rules.block.paragraph.exec(u);if(i){var o=i[1].charAt(i[1].length-1)===`
`?i[1].slice(0,-1):i[1];return{type:"paragraph",raw:i[0],text:o,tokens:this.lexer.inline(o)}}},y.text=function(u){var i=this.rules.block.text.exec(u);if(i)return{type:"text",raw:i[0],text:i[0],tokens:this.lexer.inline(i[0])}},y.escape=function(u){var i=this.rules.inline.escape.exec(u);if(i)return{type:"escape",raw:i[0],text:e(i[1])}},y.tag=function(u){var i=this.rules.inline.tag.exec(u);if(i)return!this.lexer.state.inLink&&/^<a /i.test(i[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(i[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(i[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(i[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:i[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(i[0]):e(i[0]):i[0]}},y.link=function(u){var i=this.rules.inline.link.exec(u);if(i){var o=i[2].trim();if(!this.options.pedantic&&/^</.test(o)){if(!/>$/.test(o))return;var E=U(o.slice(0,-1),"\\");if((o.length-E.length)%2===0)return}else{var R=N(i[2],"()");if(R>-1){var F=i[0].indexOf("!")===0?5:4,j=F+i[1].length+R;i[2]=i[2].substring(0,R),i[0]=i[0].substring(0,j).trim(),i[3]=""}}var q=i[2],Z="";if(this.options.pedantic){var le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);le&&(q=le[1],Z=le[3])}else Z=i[3]?i[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(o)?q=q.slice(1):q=q.slice(1,-1)),X(i,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:Z&&Z.replace(this.rules.inline._escapes,"$1")},i[0],this.lexer)}},y.reflink=function(u,i){var o;if((o=this.rules.inline.reflink.exec(u))||(o=this.rules.inline.nolink.exec(u))){var E=(o[2]||o[1]).replace(/\s+/g," ");if(E=i[E.toLowerCase()],!E||!E.href){var R=o[0].charAt(0);return{type:"text",raw:R,text:R}}return X(o,E,o[0],this.lexer)}},y.emStrong=function(u,i,o){o===void 0&&(o="");var E=this.rules.inline.emStrong.lDelim.exec(u);if(E&&!(E[3]&&o.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var R=E[1]||E[2]||"";if(!R||R&&(o===""||this.rules.inline.punctuation.exec(o))){var F=E[0].length-1,j,q,Z=F,le=0,pe=E[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,i=i.slice(-1*u.length+F);(E=pe.exec(i))!=null;)if(j=E[1]||E[2]||E[3]||E[4]||E[5]||E[6],!!j){if(q=j.length,E[3]||E[4]){Z+=q;continue}else if((E[5]||E[6])&&F%3&&!((F+q)%3)){le+=q;continue}if(Z-=q,!(Z>0)){if(q=Math.min(q,q+Z+le),Math.min(F,q)%2){var De=u.slice(1,F+E.index+q);return{type:"em",raw:u.slice(0,F+E.index+q+1),text:De,tokens:this.lexer.inlineTokens(De)}}var we=u.slice(2,F+E.index+q-1);return{type:"strong",raw:u.slice(0,F+E.index+q+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},y.codespan=function(u){var i=this.rules.inline.code.exec(u);if(i){var o=i[2].replace(/\n/g," "),E=/[^ ]/.test(o),R=/^ /.test(o)&&/ $/.test(o);return E&&R&&(o=o.substring(1,o.length-1)),o=e(o,!0),{type:"codespan",raw:i[0],text:o}}},y.br=function(u){var i=this.rules.inline.br.exec(u);if(i)return{type:"br",raw:i[0]}},y.del=function(u){var i=this.rules.inline.del.exec(u);if(i)return{type:"del",raw:i[0],text:i[2],tokens:this.lexer.inlineTokens(i[2])}},y.autolink=function(u,i){var o=this.rules.inline.autolink.exec(u);if(o){var E,R;return o[2]==="@"?(E=e(this.options.mangle?i(o[1]):o[1]),R="mailto:"+E):(E=e(o[1]),R=E),{type:"link",raw:o[0],text:E,href:R,tokens:[{type:"text",raw:E,text:E}]}}},y.url=function(u,i){var o;if(o=this.rules.inline.url.exec(u)){var E,R;if(o[2]==="@")E=e(this.options.mangle?i(o[0]):o[0]),R="mailto:"+E;else{var F;do F=o[0],o[0]=this.rules.inline._backpedal.exec(o[0])[0];while(F!==o[0]);E=e(o[0]),o[1]==="www."?R="http://"+E:R=E}return{type:"link",raw:o[0],text:E,href:R,tokens:[{type:"text",raw:E,text:E}]}}},y.inlineText=function(u,i){var o=this.rules.inline.text.exec(u);if(o){var E;return this.lexer.state.inRawBlock?E=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(o[0]):e(o[0]):o[0]:E=e(this.options.smartypants?i(o[0]):o[0]),{type:"text",raw:o[0],text:E}}},d}(),ae={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ae._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ae._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ae.def=h(ae.def).replace("label",ae._label).replace("title",ae._title).getRegex(),ae.bullet=/(?:[*+-]|\d{1,9}[.)])/,ae.listItemStart=h(/^( *)(bull) */).replace("bull",ae.bullet).getRegex(),ae.list=h(ae.list).replace(/bull/g,ae.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ae.def.source+")").getRegex(),ae._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ae._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ae.html=h(ae.html,"i").replace("comment",ae._comment).replace("tag",ae._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ae.paragraph=h(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.blockquote=h(ae.blockquote).replace("paragraph",ae.paragraph).getRegex(),ae.normal=P({},ae),ae.gfm=P({},ae.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ae.gfm.table=h(ae.gfm.table).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.gfm.paragraph=h(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ae.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.pedantic=P({},ae.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ae._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:h(ae.normal._paragraph).replace("hr",ae.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ae.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=h(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=h(ae._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=h(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=h(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=h(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=h(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=h(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=h(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=h(ee.reflink).replace("label",ee._label).replace("ref",ae._label).getRegex(),ee.nolink=h(ee.nolink).replace("ref",ae._label).getRegex(),ee.reflinkSearch=h(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=P({},ee),ee.pedantic=P({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=P({},ee.normal,{escape:h(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=h(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=P({},ee.gfm,{br:h(ee.br).replace("{2,}","*").getRegex(),text:h(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(d){return d.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ie(d){var y="",p,u,i=d.length;for(p=0;p<i;p++)u=d.charCodeAt(p),Math.random()>.5&&(u="x"+u.toString(16)),y+="&#"+u+";";return y}var Ce=function(){function d(p){this.tokens=[],this.tokens.links=Object.create(null),this.options=p||ie.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var u={block:ae.normal,inline:ee.normal};this.options.pedantic?(u.block=ae.pedantic,u.inline=ee.pedantic):this.options.gfm&&(u.block=ae.gfm,this.options.breaks?u.inline=ee.breaks:u.inline=ee.gfm),this.tokenizer.rules=u}d.lex=function(u,i){var o=new d(i);return o.lex(u)},d.lexInline=function(u,i){var o=new d(i);return o.inlineTokens(u)};var y=d.prototype;return y.lex=function(u){u=u.replace(/\r\n|\r/g,`
`),this.blockTokens(u,this.tokens);for(var i;i=this.inlineQueue.shift();)this.inlineTokens(i.src,i.tokens);return this.tokens},y.blockTokens=function(u,i){var o=this;i===void 0&&(i=[]),this.options.pedantic?u=u.replace(/\t/g,"    ").replace(/^ +$/gm,""):u=u.replace(/^( *)(\t+)/gm,function(Z,le,pe){return le+"    ".repeat(pe.length)});for(var E,R,F,j;u;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Z){return(E=Z.call({lexer:o},u,i))?(u=u.substring(E.raw.length),i.push(E),!0):!1}))){if(E=this.tokenizer.space(u)){u=u.substring(E.raw.length),E.raw.length===1&&i.length>0?i[i.length-1].raw+=`
`:i.push(E);continue}if(E=this.tokenizer.code(u)){u=u.substring(E.raw.length),R=i[i.length-1],R&&(R.type==="paragraph"||R.type==="text")?(R.raw+=`
`+E.raw,R.text+=`
`+E.text,this.inlineQueue[this.inlineQueue.length-1].src=R.text):i.push(E);continue}if(E=this.tokenizer.fences(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.heading(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.hr(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.blockquote(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.list(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.html(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.def(u)){u=u.substring(E.raw.length),R=i[i.length-1],R&&(R.type==="paragraph"||R.type==="text")?(R.raw+=`
`+E.raw,R.text+=`
`+E.raw,this.inlineQueue[this.inlineQueue.length-1].src=R.text):this.tokens.links[E.tag]||(this.tokens.links[E.tag]={href:E.href,title:E.title});continue}if(E=this.tokenizer.table(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.lheading(u)){u=u.substring(E.raw.length),i.push(E);continue}if(F=u,this.options.extensions&&this.options.extensions.startBlock&&function(){var Z=1/0,le=u.slice(1),pe=void 0;o.options.extensions.startBlock.forEach(function(De){pe=De.call({lexer:this},le),typeof pe=="number"&&pe>=0&&(Z=Math.min(Z,pe))}),Z<1/0&&Z>=0&&(F=u.substring(0,Z+1))}(),this.state.top&&(E=this.tokenizer.paragraph(F))){R=i[i.length-1],j&&R.type==="paragraph"?(R.raw+=`
`+E.raw,R.text+=`
`+E.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=R.text):i.push(E),j=F.length!==u.length,u=u.substring(E.raw.length);continue}if(E=this.tokenizer.text(u)){u=u.substring(E.raw.length),R=i[i.length-1],R&&R.type==="text"?(R.raw+=`
`+E.raw,R.text+=`
`+E.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=R.text):i.push(E);continue}if(u){var q="Infinite loop on byte: "+u.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,i},y.inline=function(u,i){return i===void 0&&(i=[]),this.inlineQueue.push({src:u,tokens:i}),i},y.inlineTokens=function(u,i){var o=this;i===void 0&&(i=[]);var E,R,F,j=u,q,Z,le;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(j))!=null;)pe.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(j=j.slice(0,q.index)+"["+z("a",q[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(j))!=null;)j=j.slice(0,q.index)+"["+z("a",q[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(j))!=null;)j=j.slice(0,q.index)+"++"+j.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;u;)if(Z||(le=""),Z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(E=we.call({lexer:o},u,i))?(u=u.substring(E.raw.length),i.push(E),!0):!1}))){if(E=this.tokenizer.escape(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.tag(u)){u=u.substring(E.raw.length),R=i[i.length-1],R&&E.type==="text"&&R.type==="text"?(R.raw+=E.raw,R.text+=E.text):i.push(E);continue}if(E=this.tokenizer.link(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.reflink(u,this.tokens.links)){u=u.substring(E.raw.length),R=i[i.length-1],R&&E.type==="text"&&R.type==="text"?(R.raw+=E.raw,R.text+=E.text):i.push(E);continue}if(E=this.tokenizer.emStrong(u,j,le)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.codespan(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.br(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.del(u)){u=u.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.autolink(u,Ie)){u=u.substring(E.raw.length),i.push(E);continue}if(!this.state.inLink&&(E=this.tokenizer.url(u,Ie))){u=u.substring(E.raw.length),i.push(E);continue}if(F=u,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Ee=u.slice(1),ve=void 0;o.options.extensions.startInline.forEach(function(Te){ve=Te.call({lexer:this},Ee),typeof ve=="number"&&ve>=0&&(we=Math.min(we,ve))}),we<1/0&&we>=0&&(F=u.substring(0,we+1))}(),E=this.tokenizer.inlineText(F,ge)){u=u.substring(E.raw.length),E.raw.slice(-1)!=="_"&&(le=E.raw.slice(-1)),Z=!0,R=i[i.length-1],R&&R.type==="text"?(R.raw+=E.raw,R.text+=E.text):i.push(E);continue}if(u){var De="Infinite loop on byte: "+u.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return i},k(d,null,[{key:"rules",get:function(){return{block:ae,inline:ee}}}]),d}(),Be=function(){function d(p){this.options=p||ie.defaults}var y=d.prototype;return y.code=function(u,i,o){var E=(i||"").match(/\S*/)[0];if(this.options.highlight){var R=this.options.highlight(u,E);R!=null&&R!==u&&(o=!0,u=R)}return u=u.replace(/\n$/,"")+`
`,E?'<pre><code class="'+this.options.langPrefix+e(E,!0)+'">'+(o?u:e(u,!0))+`</code></pre>
`:"<pre><code>"+(o?u:e(u,!0))+`</code></pre>
`},y.blockquote=function(u){return`<blockquote>
`+u+`</blockquote>
`},y.html=function(u){return u},y.heading=function(u,i,o,E){if(this.options.headerIds){var R=this.options.headerPrefix+E.slug(o);return"<h"+i+' id="'+R+'">'+u+"</h"+i+`>
`}return"<h"+i+">"+u+"</h"+i+`>
`},y.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},y.list=function(u,i,o){var E=i?"ol":"ul",R=i&&o!==1?' start="'+o+'"':"";return"<"+E+R+`>
`+u+"</"+E+`>
`},y.listitem=function(u){return"<li>"+u+`</li>
`},y.checkbox=function(u){return"<input "+(u?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},y.paragraph=function(u){return"<p>"+u+`</p>
`},y.table=function(u,i){return i&&(i="<tbody>"+i+"</tbody>"),`<table>
<thead>
`+u+`</thead>
`+i+`</table>
`},y.tablerow=function(u){return`<tr>
`+u+`</tr>
`},y.tablecell=function(u,i){var o=i.header?"th":"td",E=i.align?"<"+o+' align="'+i.align+'">':"<"+o+">";return E+u+("</"+o+`>
`)},y.strong=function(u){return"<strong>"+u+"</strong>"},y.em=function(u){return"<em>"+u+"</em>"},y.codespan=function(u){return"<code>"+u+"</code>"},y.br=function(){return this.options.xhtml?"<br/>":"<br>"},y.del=function(u){return"<del>"+u+"</del>"},y.link=function(u,i,o){if(u=f(this.options.sanitize,this.options.baseUrl,u),u===null)return o;var E='<a href="'+e(u)+'"';return i&&(E+=' title="'+i+'"'),E+=">"+o+"</a>",E},y.image=function(u,i,o){if(u=f(this.options.sanitize,this.options.baseUrl,u),u===null)return o;var E='<img src="'+u+'" alt="'+o+'"';return i&&(E+=' title="'+i+'"'),E+=this.options.xhtml?"/>":">",E},y.text=function(u){return u},d}(),se=function(){function d(){}var y=d.prototype;return y.strong=function(u){return u},y.em=function(u){return u},y.codespan=function(u){return u},y.del=function(u){return u},y.html=function(u){return u},y.text=function(u){return u},y.link=function(u,i,o){return""+o},y.image=function(u,i,o){return""+o},y.br=function(){return""},d}(),J=function(){function d(){this.seen={}}var y=d.prototype;return y.serialize=function(u){return u.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},y.getNextSafeSlug=function(u,i){var o=u,E=0;if(this.seen.hasOwnProperty(o)){E=this.seen[u];do E++,o=u+"-"+E;while(this.seen.hasOwnProperty(o))}return i||(this.seen[u]=E,this.seen[o]=0),o},y.slug=function(u,i){i===void 0&&(i={});var o=this.serialize(u);return this.getNextSafeSlug(o,i.dryrun)},d}(),re=function(){function d(p){this.options=p||ie.defaults,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new se,this.slugger=new J}d.parse=function(u,i){var o=new d(i);return o.parse(u)},d.parseInline=function(u,i){var o=new d(i);return o.parseInline(u)};var y=d.prototype;return y.parse=function(u,i){i===void 0&&(i=!0);var o="",E,R,F,j,q,Z,le,pe,De,we,Ee,ve,Te,Le,Me,Ze,et,xe,K,ne=u.length;for(E=0;E<ne;E++){if(we=u[E],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(K=this.options.extensions.renderers[we.type].call({parser:this},we),K!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){o+=K||"";continue}switch(we.type){case"space":continue;case"hr":{o+=this.renderer.hr();continue}case"heading":{o+=this.renderer.heading(this.parseInline(we.tokens),we.depth,g(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{o+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(pe="",le="",j=we.header.length,R=0;R<j;R++)le+=this.renderer.tablecell(this.parseInline(we.header[R].tokens),{header:!0,align:we.align[R]});for(pe+=this.renderer.tablerow(le),De="",j=we.rows.length,R=0;R<j;R++){for(Z=we.rows[R],le="",q=Z.length,F=0;F<q;F++)le+=this.renderer.tablecell(this.parseInline(Z[F].tokens),{header:!1,align:we.align[F]});De+=this.renderer.tablerow(le)}o+=this.renderer.table(pe,De);continue}case"blockquote":{De=this.parse(we.tokens),o+=this.renderer.blockquote(De);continue}case"list":{for(Ee=we.ordered,ve=we.start,Te=we.loose,j=we.items.length,De="",R=0;R<j;R++)Me=we.items[R],Ze=Me.checked,et=Me.task,Le="",Me.task&&(xe=this.renderer.checkbox(Ze),Te?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=xe+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=xe+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:xe}):Le+=xe),Le+=this.parse(Me.tokens,Te),De+=this.renderer.listitem(Le,et,Ze);o+=this.renderer.list(De,Ee,ve);continue}case"html":{o+=this.renderer.html(we.text);continue}case"paragraph":{o+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(De=we.tokens?this.parseInline(we.tokens):we.text;E+1<ne&&u[E+1].type==="text";)we=u[++E],De+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);o+=i?this.renderer.paragraph(De):De;continue}default:{var de='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return o},y.parseInline=function(u,i){i=i||this.renderer;var o="",E,R,F,j=u.length;for(E=0;E<j;E++){if(R=u[E],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[R.type]&&(F=this.options.extensions.renderers[R.type].call({parser:this},R),F!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(R.type))){o+=F||"";continue}switch(R.type){case"escape":{o+=i.text(R.text);break}case"html":{o+=i.html(R.text);break}case"link":{o+=i.link(R.href,R.title,this.parseInline(R.tokens,i));break}case"image":{o+=i.image(R.href,R.title,R.text);break}case"strong":{o+=i.strong(this.parseInline(R.tokens,i));break}case"em":{o+=i.em(this.parseInline(R.tokens,i));break}case"codespan":{o+=i.codespan(R.text);break}case"br":{o+=i.br();break}case"del":{o+=i.del(this.parseInline(R.tokens,i));break}case"text":{o+=i.text(R.text);break}default:{var q='Token with "'+R.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return o},d}();function oe(d,y,p){if(typeof d>"u"||d===null)throw new Error("marked(): input parameter is undefined or null");if(typeof d!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(d)+", string expected");if(typeof y=="function"&&(p=y,y=null),y=P({},oe.defaults,y||{}),I(y),p){var u=y.highlight,i;try{i=Ce.lex(d,y)}catch(j){return p(j)}var o=function(q){var Z;if(!q)try{y.walkTokens&&oe.walkTokens(i,y.walkTokens),Z=re.parse(i,y)}catch(le){q=le}return y.highlight=u,q?p(q):p(null,Z)};if(!u||u.length<3||(delete y.highlight,!i.length))return o();var E=0;oe.walkTokens(i,function(j){j.type==="code"&&(E++,setTimeout(function(){u(j.text,j.lang,function(q,Z){if(q)return o(q);Z!=null&&Z!==j.text&&(j.text=Z,j.escaped=!0),E--,E===0&&o()})},0))}),E===0&&o();return}function R(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,y.silent)return"<p>An error occurred:</p><pre>"+e(j.message+"",!0)+"</pre>";throw j}try{var F=Ce.lex(d,y);if(y.walkTokens){if(y.async)return Promise.all(oe.walkTokens(F,y.walkTokens)).then(function(){return re.parse(F,y)}).catch(R);oe.walkTokens(F,y.walkTokens)}return re.parse(F,y)}catch(j){R(j)}}oe.options=oe.setOptions=function(d){return P(oe.defaults,d),S(oe.defaults),oe},oe.getDefaults=A,oe.defaults=ie.defaults,oe.use=function(){for(var d=arguments.length,y=new Array(d),p=0;p<d;p++)y[p]=arguments[p];var u=P.apply(void 0,[{}].concat(y)),i=oe.defaults.extensions||{renderers:{},childTokens:{}},o;y.forEach(function(E){if(E.extensions&&(o=!0,E.extensions.forEach(function(F){if(!F.name)throw new Error("extension name required");if(F.renderer){var j=i.renderers?i.renderers[F.name]:null;j?i.renderers[F.name]=function(){for(var q=arguments.length,Z=new Array(q),le=0;le<q;le++)Z[le]=arguments[le];var pe=F.renderer.apply(this,Z);return pe===!1&&(pe=j.apply(this,Z)),pe}:i.renderers[F.name]=F.renderer}if(F.tokenizer){if(!F.level||F.level!=="block"&&F.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");i[F.level]?i[F.level].unshift(F.tokenizer):i[F.level]=[F.tokenizer],F.start&&(F.level==="block"?i.startBlock?i.startBlock.push(F.start):i.startBlock=[F.start]:F.level==="inline"&&(i.startInline?i.startInline.push(F.start):i.startInline=[F.start]))}F.childTokens&&(i.childTokens[F.name]=F.childTokens)})),E.renderer&&function(){var F=oe.defaults.renderer||new Be,j=function(le){var pe=F[le];F[le]=function(){for(var De=arguments.length,we=new Array(De),Ee=0;Ee<De;Ee++)we[Ee]=arguments[Ee];var ve=E.renderer[le].apply(F,we);return ve===!1&&(ve=pe.apply(F,we)),ve}};for(var q in E.renderer)j(q);u.renderer=F}(),E.tokenizer&&function(){var F=oe.defaults.tokenizer||new fe,j=function(le){var pe=F[le];F[le]=function(){for(var De=arguments.length,we=new Array(De),Ee=0;Ee<De;Ee++)we[Ee]=arguments[Ee];var ve=E.tokenizer[le].apply(F,we);return ve===!1&&(ve=pe.apply(F,we)),ve}};for(var q in E.tokenizer)j(q);u.tokenizer=F}(),E.walkTokens){var R=oe.defaults.walkTokens;u.walkTokens=function(F){var j=[];return j.push(E.walkTokens.call(this,F)),R&&(j=j.concat(R.call(this,F))),j}}o&&(u.extensions=i),oe.setOptions(u)})},oe.walkTokens=function(d,y){for(var p=[],u=function(){var R=o.value;switch(p=p.concat(y.call(oe,R)),R.type){case"table":{for(var F=H(R.header),j;!(j=F()).done;){var q=j.value;p=p.concat(oe.walkTokens(q.tokens,y))}for(var Z=H(R.rows),le;!(le=Z()).done;)for(var pe=le.value,De=H(pe),we;!(we=De()).done;){var Ee=we.value;p=p.concat(oe.walkTokens(Ee.tokens,y))}break}case"list":{p=p.concat(oe.walkTokens(R.items,y));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[R.type]?oe.defaults.extensions.childTokens[R.type].forEach(function(ve){p=p.concat(oe.walkTokens(R[ve],y))}):R.tokens&&(p=p.concat(oe.walkTokens(R.tokens,y)))}},i=H(d),o;!(o=i()).done;)u();return p},oe.parseInline=function(d,y){if(typeof d>"u"||d===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof d!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(d)+", string expected");y=P({},oe.defaults,y||{}),I(y);try{var p=Ce.lexInline(d,y);return y.walkTokens&&oe.walkTokens(p,y.walkTokens),re.parseInline(p,y)}catch(u){if(u.message+=`
Please report this to https://github.com/markedjs/marked.`,y.silent)return"<p>An error occurred:</p><pre>"+e(u.message+"",!0)+"</pre>";throw u}},oe.Parser=re,oe.parser=re.parse,oe.Renderer=Be,oe.TextRenderer=se,oe.Lexer=Ce,oe.lexer=Ce.lex,oe.Tokenizer=fe,oe.Slugger=J,oe.parse=oe;var W=oe.options,G=oe.setOptions,ue=oe.use,me=oe.walkTokens,Se=oe.parseInline,ke=oe,Pe=re.parse,x=Ce.lex;ie.Lexer=Ce,ie.Parser=re,ie.Renderer=Be,ie.Slugger=J,ie.TextRenderer=se,ie.Tokenizer=fe,ie.getDefaults=A,ie.lexer=x,ie.marked=oe,ie.options=W,ie.parse=ke,ie.parseInline=Se,ie.parser=Pe,ie.setOptions=G,ie.use=ue,ie.walkTokens=me,Object.defineProperty(ie,"__esModule",{value:!0})}),define(be[80],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rj=void 0;function k(s){const g=H(s);if(g&&g.length>0)return new Uint32Array(g)}t.$Rj=k;let T=0;const n=new Uint32Array(10);function H(s){if(T=0,A(s,M,4352),T>0||(A(s,r,4449),T>0)||(A(s,l,4520),T>0)||(A(s,e,12593),T))return n.subarray(0,T);if(s>=44032&&s<=55203){const g=s-44032,b=g%588,h=Math.floor(g/588),$=Math.floor(b/28),c=b%28-1;if(h<M.length?A(h,M,0):4352+h-12593<e.length&&A(4352+h,e,12593),$<r.length?A($,r,0):4449+$-12593<e.length&&A(4449+$-12593,e,12593),c>=0&&(c<l.length?A(c,l,0):4520+c-12593<e.length&&A(4520+c-12593,e,12593)),T>0)return n.subarray(0,T)}}function A(s,g,b){s>=b&&s<b+g.length&&S(g[s-b])}function S(s){s!==0&&(n[T++]=s&255,s>>8&&(n[T++]=s>>8&255),s>>16&&(n[T++]=s>>16&255))}var m;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var w;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(w||(w={}));var D;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(D||(D={}));const M=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),r=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),l=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(be[81],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5S=void 0;class k{constructor(n,H=0,A=n.length,S=H-1){this.a=n,this.b=H,this.c=A,this.d=S}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$5S=k}),define(be[82],$e([1,0,81]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7S=t.$6S=void 0;class T{constructor(A=[],S=10){this.h(A),this.b=S,this.d()}getHistory(){return this.j}add(A){this.a.delete(A),this.a.add(A),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(A){return this.a.has(A)}clear(){this.h([]),this.d()}d(){this.f();const A=this.j;this.c=new k.$5S(A,0,A.length,A.length)}f(){const A=this.j;A.length>this.b&&this.h(A.slice(A.length-this.b))}g(){const A=this.c.current();return A?this.j.indexOf(A):-1}h(A){this.a=new Set;for(const S of A)this.a.add(S)}get j(){const A=[];return this.a.forEach(S=>A.push(S)),A}}t.$6S=T;class n{get size(){return this.f}constructor(A,S=10){if(this.g=S,A.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:A[0],previous:void 0,next:void 0},this.a=new Set([A[0]]);for(let m=1;m<A.length;m++)this.add(A[m])}add(A){const S={value:A,previous:this.c,next:void 0};for(this.c.next=S,this.c=S,this.d=this.c,this.f++,this.a.has(A)?this.h(A):this.a.add(A);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(A){if(this.c.value===A)return A;const S=this.c.value;return this.a.delete(S),this.c.value=A,this.a.has(A)?this.h(A):this.a.add(A),S}prepend(A){if(this.f===this.g||this.a.has(A))return;const S={value:A,previous:void 0,next:this.b};this.b.previous=S,this.b=S,this.f++,this.a.add(A)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(A){return this.a.has(A)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let A=this.b;for(;A;)yield A.value,A=A.next}h(A){let S=this.b;for(;S!==this.c;)S.value===A&&(S===this.b?(this.b=this.b.next,this.b.previous=void 0):(S.previous.next=S.next,S.next.previous=S.previous),this.f--),S=S.next}}t.$7S=n}),define(be[46],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$l=t.$0l=t.$9l=t.rot=t.$7l=void 0;function k(S,m,w){return Math.min(Math.max(S,m),w)}t.$7l=k;function T(S,m){return(m+S%m)%m}t.rot=T;class n{constructor(){this.a=0}getNext(){return this.a++}}t.$9l=n;class H{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$0l=H;class A{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const w=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$$l=A}),define(be[47],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var k;(function(T){function n(m,w){if(m.start>=w.end||w.start>=m.end)return{start:0,end:0};const D=Math.max(m.start,w.start),M=Math.min(m.end,w.end);return M-D<=0?{start:0,end:0}:{start:D,end:M}}T.intersect=n;function H(m){return m.end-m.start<=0}T.isEmpty=H;function A(m,w){return!H(n(m,w))}T.intersects=A;function S(m,w){const D=[],M={start:m.start,end:Math.min(w.start,m.end)},r={start:Math.max(w.end,m.start),end:m.end};return H(M)||D.push(M),H(r)||D.push(r),D}T.relativeComplement=S})(k||(t.Range=k={}))}),define(be[83],$e([1,0,47]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OR=t.$NR=t.$MR=t.$LR=void 0;function T(m,w){const D=[];for(const M of w){if(m.start>=M.range.end)continue;if(m.end<M.range.start)break;const r=k.Range.intersect(m,M.range);k.Range.isEmpty(r)||D.push({range:r,size:M.size})}return D}t.$LR=T;function n({start:m,end:w},D){return{start:m+D,end:w+D}}t.$MR=n;function H(m){const w=[];let D=null;for(const M of m){const r=M.range.start,l=M.range.end,e=M.size;if(D&&e===D.size){D.range.end=l;continue}D={range:{start:r,end:l},size:e},w.push(D)}return w}t.$NR=H;function A(...m){return H(m.reduce((w,D)=>w.concat(D),[]))}class S{get paddingTop(){return this.c}set paddingTop(w){this.b=this.b+w-this.c,this.c=w}constructor(w){this.a=[],this.b=0,this.c=0,this.c=w??0,this.b=this.c}splice(w,D,M=[]){const r=M.length-D,l=T({start:0,end:w},this.a),e=T({start:w+D,end:Number.POSITIVE_INFINITY},this.a).map(g=>({range:n(g.range,r),size:g.size})),s=M.map((g,b)=>({range:{start:w+b,end:w+b+1},size:g.size}));this.a=A(l,s,e),this.b=this.c+this.a.reduce((g,b)=>g+b.size*(b.range.end-b.range.start),0)}get count(){const w=this.a.length;return w?this.a[w-1].range.end:0}get size(){return this.b}indexAt(w){if(w<0)return-1;if(w<this.c)return 0;let D=0,M=this.c;for(const r of this.a){const l=r.range.end-r.range.start,e=M+l*r.size;if(w<e)return D+Math.floor((w-M)/r.size);D+=l,M=e}return D}indexAfter(w){return Math.min(this.indexAt(w)+1,this.count)}positionAt(w){if(w<0)return-1;let D=0,M=0;for(const r of this.a){const l=r.range.end-r.range.start,e=M+l;if(w<e)return this.c+D+(w-M)*r.size;D+=l*r.size,M=e}return-1}}t.$OR=S}),define(be[84],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rd=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(H){return new T(H)}constructor(H){this.c=k&&H===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Rd=T}),define(be[4],$e([1,0,6,43,2,45,84]),function(ie,t,k,T,n,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.Event=void 0;const S=!1,m=!1;var w;(function(U){U.None=()=>n.$Tc.None;function N(i){if(m){const{onDidAddListener:o}=i,E=e.create();let R=0;i.onDidAddListener=()=>{++R===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),E.print()),o?.()}}}function I(i,o){return Be(i,()=>{},0,void 0,!0,void 0,o)}U.defer=I;function z(i){return(o,E=null,R)=>{let F=!1,j;return j=i(q=>{if(!F)return j?j.dispose():F=!0,o.call(E,q)},null,R),F&&j.dispose(),j}}U.once=z;function X(i,o,E){return Ie((R,F=null,j)=>i(q=>R.call(F,o(q)),null,j),E)}U.map=X;function Y(i,o,E){return Ie((R,F=null,j)=>i(q=>{o(q),R.call(F,q)},null,j),E)}U.forEach=Y;function fe(i,o,E){return Ie((R,F=null,j)=>i(q=>o(q)&&R.call(F,q),null,j),E)}U.filter=fe;function ae(i){return i}U.signal=ae;function ee(...i){return(o,E=null,R)=>{const F=(0,n.$Qc)(...i.map(j=>j(q=>o.call(E,q))));return Ce(F,R)}}U.any=ee;function ge(i,o,E,R){let F=E;return X(i,j=>(F=o(F,j),F),R)}U.reduce=ge;function Ie(i,o){let E;const R={onWillAddFirstListener(){E=i(F.fire,F)},onDidRemoveLastListener(){E?.dispose()}};o||N(R);const F=new $(R);return o?.add(F),F.event}function Ce(i,o){return o instanceof Array?o.push(i):o&&o.add(i),i}function Be(i,o,E=100,R=!1,F=!1,j,q){let Z,le,pe,De=0,we;const Ee={leakWarningThreshold:j,onWillAddFirstListener(){Z=i(Te=>{De++,le=o(le,Te),R&&!pe&&(ve.fire(le),le=void 0),we=()=>{const Le=le;le=void 0,pe=void 0,(!R||De>1)&&ve.fire(Le),De=0},typeof E=="number"?(clearTimeout(pe),pe=setTimeout(we,E)):pe===void 0&&(pe=0,queueMicrotask(we))})},onWillRemoveListener(){F&&De>0&&we?.()},onDidRemoveLastListener(){we=void 0,Z.dispose()}};q||N(Ee);const ve=new $(Ee);return q?.add(ve),ve.event}U.debounce=Be;function se(i,o=0,E){return U.debounce(i,(R,F)=>R?(R.push(F),R):[F],o,void 0,!0,void 0,E)}U.accumulate=se;function J(i,o=(R,F)=>R===F,E){let R=!0,F;return fe(i,j=>{const q=R||!o(j,F);return R=!1,F=j,q},E)}U.latch=J;function re(i,o,E){return[U.filter(i,o,E),U.filter(i,R=>!o(R),E)]}U.split=re;function oe(i,o=!1,E=[],R){let F=E.slice(),j=i(le=>{F?F.push(le):Z.fire(le)});R&&R.add(j);const q=()=>{F?.forEach(le=>Z.fire(le)),F=null},Z=new $({onWillAddFirstListener(){j||(j=i(le=>Z.fire(le)),R&&R.add(j))},onDidAddFirstListener(){F&&(o?setTimeout(q):q())},onDidRemoveLastListener(){j&&j.dispose(),j=null}});return R&&R.add(Z),Z.event}U.buffer=oe;function W(i,o){return(R,F,j)=>{const q=o(new ue);return i(function(Z){const le=q.evaluate(Z);le!==G&&R.call(F,le)},void 0,j)}}U.chain=W;const G=Symbol("HaltChainable");class ue{constructor(){this.f=[]}map(o){return this.f.push(o),this}forEach(o){return this.f.push(E=>(o(E),E)),this}filter(o){return this.f.push(E=>o(E)?E:G),this}reduce(o,E){let R=E;return this.f.push(F=>(R=o(R,F),R)),this}latch(o=(E,R)=>E===R){let E=!0,R;return this.f.push(F=>{const j=E||!o(F,R);return E=!1,R=F,j?F:G}),this}evaluate(o){for(const E of this.f)if(o=E(o),o===G)break;return o}}function me(i,o,E=R=>R){const R=(...Z)=>q.fire(E(...Z)),F=()=>i.on(o,R),j=()=>i.removeListener(o,R),q=new $({onWillAddFirstListener:F,onDidRemoveLastListener:j});return q.event}U.fromNodeEventEmitter=me;function Se(i,o,E=R=>R){const R=(...Z)=>q.fire(E(...Z)),F=()=>i.addEventListener(o,R),j=()=>i.removeEventListener(o,R),q=new $({onWillAddFirstListener:F,onDidRemoveLastListener:j});return q.event}U.fromDOMEventEmitter=Se;function ke(i){return new Promise(o=>z(i)(o))}U.toPromise=ke;function Pe(i){const o=new $;return i.then(E=>{o.fire(E)},()=>{o.fire(void 0)}).finally(()=>{o.dispose()}),o.event}U.fromPromise=Pe;function x(i,o,E){return o(E),i(R=>o(R))}U.runAndSubscribe=x;function d(i,o){let E=null;function R(j){E?.dispose(),E=new n.$Sc,o(j,E)}R(void 0);const F=i(j=>R(j));return(0,n.$Rc)(()=>{F.dispose(),E?.dispose()})}U.runAndSubscribeWithStore=d;class y{constructor(o,E){this._observable=o,this.f=0,this.g=!1;const R={onWillAddFirstListener:()=>{o.addObserver(this)},onDidRemoveLastListener:()=>{o.removeObserver(this)}};E||N(R),this.emitter=new $(R),E&&E.add(this.emitter)}beginUpdate(o){this.f++}handlePossibleChange(o){}handleChange(o,E){this.g=!0}endUpdate(o){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function p(i,o){return new y(i,o).emitter.event}U.fromObservable=p;function u(i){return(o,E,R)=>{let F=0,j=!1;const q={beginUpdate(){F++},endUpdate(){F--,F===0&&(i.reportChanges(),j&&(j=!1,o.call(E)))},handlePossibleChange(){},handleChange(){j=!0}};i.addObserver(q),i.reportChanges();const Z={dispose(){i.removeObserver(q)}};return R instanceof n.$Sc?R.add(Z):Array.isArray(R)&&R.push(Z),Z}}U.fromObservableLight=u})(w||(t.Event=w={}));class D{static{this.all=new Set}static{this.f=0}constructor(N){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${N}_${D.f++}`,D.all.add(this)}start(N){this.g=new A.$Rd,this.listenerCount=N}stop(){if(this.g){const N=this.g.elapsed();this.durations.push(N),this.elapsedOverall+=N,this.invocationCount+=1,this.g=void 0}}}t.$Td=D;let M=-1;function r(U){const N=M;return M=U,{dispose(){M=N}}}t.$Ud=r;class l{constructor(N,I=Math.random().toString(18).slice(2,5)){this.threshold=N,this.name=I,this.g=0}dispose(){this.f?.clear()}check(N,I){const z=this.threshold;if(z<=0||I<z)return;this.f||(this.f=new Map);const X=this.f.get(N.value)||0;if(this.f.set(N.value,X+1),this.g-=1,this.g<=0){this.g=z*.5;let Y,fe=0;for(const[ae,ee]of this.f)(!Y||fe<ee)&&(Y=ae,fe=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${fe}):`),console.warn(Y)}return()=>{const Y=this.f.get(N.value)||0;this.f.set(N.value,Y-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(N){this.value=N}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class g{constructor(N){this.value=N,this.id=s++}}const b=2,h=(U,N)=>{if(U instanceof g)N(U);else for(let I=0;I<U.length;I++){const z=U[I];z&&N(z)}};class ${constructor(N){this.w=0,this.f=N,this.g=M>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??M):void 0,this.j=this.f?._profName?new D(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const N=this.t;queueMicrotask(()=>{h(N,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(N,I,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.$Tc.None;if(this.m)return n.$Tc.None;I&&(N=N.bind(I));const X=new g(N);let Y,fe;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=e.create(),Y=this.g.check(X.stack,this.w+1)),S&&(X.stack=fe??e.create()),this.t?this.t instanceof g?(this.u??=new f,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const ae=(0,n.$Rc)(()=>{Y?.(),this.x(X)});return z instanceof n.$Sc?z.add(ae):Array.isArray(z)&&z.push(ae),ae},this.q}x(N){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,z=I.indexOf(N);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[z]=void 0;const X=this.u.current===this;if(this.w*b<=I.length){let Y=0;for(let fe=0;fe<I.length;fe++)I[fe]?I[Y++]=I[fe]:X&&(this.u.end--,Y<this.u.i&&this.u.i--);I.length=Y}}y(N,I){if(!N)return;const z=this.f?.onListenerError||k.$1;if(!z){N.value(I);return}try{N.value(I)}catch(X){z(X)}}z(N){const I=N.current.t;for(;N.i<N.end;)this.y(I[N.i++],N.value);N.reset()}fire(N){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,N);else{const I=this.u;I.enqueue(this,N,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Vd=$;const c=()=>new f;t.$Wd=c;class f{constructor(){this.i=-1,this.end=0}enqueue(N,I,z){this.i=0,this.end=z,this.current=N,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends ${async fireAsync(N,I,z){if(this.t)for(this.h||(this.h=new H.$4c),h(this.t,X=>this.h.push([X.value,N]));this.h.size>0&&!I.isCancellationRequested;){const[X,Y]=this.h.shift(),fe=[],ae={...Y,token:I,waitUntil:ee=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");z&&(ee=z(ee,X)),fe.push(ee)}};try{X(ae)}catch(ee){(0,k.$1)(ee);continue}Object.freeze(fe),await Promise.allSettled(fe).then(ee=>{for(const ge of ee)ge.status==="rejected"&&(0,k.$1)(ge.reason)})}}}t.$Xd=a;class C extends ${get isPaused(){return this.h!==0}constructor(N){super(N),this.h=0,this.s=new H.$4c,this.A=N?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const N=Array.from(this.s);this.s.clear(),super.fire(this.A(N))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(N){this.w&&(this.h!==0?this.s.push(N):super.fire(N))}}t.$Yd=C;class O extends C{constructor(N){super(N),this.k=N.delay??100}fire(N){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(N)}}t.$Zd=O;class L extends ${constructor(N){super(N),this.h=[],this.k=N?.merge}fire(N){this.hasListeners()&&(this.h.push(N),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}t.$1d=L;class B{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(N){const I={event:N,listener:null};this.h.push(I),this.g&&this.m(I);const z=()=>{this.g&&this.o(I);const X=this.h.indexOf(I);this.h.splice(X,1)};return(0,n.$Rc)((0,T.$db)(z))}j(){this.g=!0,this.h.forEach(N=>this.m(N))}k(){this.g=!1,this.h.forEach(N=>this.o(N))}m(N){N.listener=N.event(I=>this.f.fire(I))}o(N){N.listener&&N.listener.dispose(),N.listener=null}dispose(){this.f.dispose()}}t.$2d=B;class v{constructor(N,I,z,X){this.f=new n.$Sc;const Y=this.f.add(new B),fe=this.f.add(new n.$3c);function ae(ee){fe.set(ee,Y.add(X(ee)))}for(const ee of N)ae(ee);this.f.add(I(ee=>{ae(ee)})),this.f.add(z(ee=>{fe.deleteAndDispose(ee)})),this.event=Y.event}dispose(){this.f.dispose()}}t.$3d=v;class P{constructor(){this.f=[]}wrapEvent(N){return(I,z,X)=>N(Y=>{const fe=this.f[this.f.length-1];fe?fe.push(()=>I.call(z,Y)):I.call(z,Y)},void 0,X)}bufferEvents(N){const I=[];this.f.push(I);const z=N();return this.f.pop(),I.forEach(X=>X()),z}}t.$4d=P;class V{constructor(){this.f=!1,this.g=w.None,this.h=n.$Tc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(N){this.g=N,this.f&&(this.h.dispose(),this.h=N(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$5d=V}),define(be[16],$e([1,0,21,4,2]),function(ie,t,k,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=void 0;class H{constructor(){this.a=new Map,this.b=new T.$Vd,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new T.$Vd,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new H}getZoomLevel(f){return this.a.get(this.f(f))??0}setZoomLevel(f,a){if(this.getZoomLevel(a)===f)return;const C=this.f(a);this.a.set(C,f),this.b.fire(C)}getZoomFactor(f){return this.c.get(this.f(f))??1}setZoomFactor(f,a){this.c.set(this.f(a),f)}setFullscreen(f,a){if(this.isFullscreen(a)===f)return;const C=this.f(a);this.e.set(C,f),this.d.fire(C)}isFullscreen(f){return!!this.e.get(this.f(f))}f(f){return f.vscodeWindowId}}class A extends n.$Tc{constructor(){super(),this.a=this.B(new T.$Vd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(f){this.c?.removeEventListener("change",this.b),this.c=k.$window.matchMedia(`(resolution: ${k.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),f&&this.a.fire()}}class S extends n.$Tc{get value(){return this.b}constructor(){super(),this.a=this.B(new T.$Vd),this.onDidChange=this.a.event,this.b=this.c();const f=this.B(new A);this.B(f.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const f=document.createElement("canvas").getContext("2d"),a=k.$window.devicePixelRatio||1,C=f.webkitBackingStorePixelRatio||f.mozBackingStorePixelRatio||f.msBackingStorePixelRatio||f.oBackingStorePixelRatio||f.backingStorePixelRatio||1;return a/C}}class m{constructor(){this.a=null}b(){return this.a||(this.a=(0,n.$Mc)(new S)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function w(c,f,a){typeof f=="string"&&(f=c.matchMedia(f)),f.addEventListener("change",a)}t.$bP=w,t.$cP=new m;function D(c,f){H.INSTANCE.setZoomLevel(c,f)}t.$dP=D;function M(c){return H.INSTANCE.getZoomLevel(c)}t.$eP=M,t.$fP=H.INSTANCE.onDidChangeZoomLevel;function r(c){return H.INSTANCE.getZoomFactor(c)}t.$gP=r;function l(c,f){H.INSTANCE.setZoomFactor(c,f)}t.$hP=l;function e(c,f){H.INSTANCE.setFullscreen(c,f)}t.$iP=e;function s(c){return H.INSTANCE.isFullscreen(c)}t.$jP=s,t.$kP=H.INSTANCE.onDidChangeFullscreen;const g=navigator.userAgent;t.$lP=g.indexOf("Firefox")>=0,t.$mP=g.indexOf("AppleWebKit")>=0,t.$nP=g.indexOf("Chrome")>=0,t.$oP=!t.$nP&&g.indexOf("Safari")>=0,t.$pP=!t.$nP&&!t.$oP&&t.$mP,t.$qP=g.indexOf("Electron/")>=0,t.$rP=g.indexOf("Android")>=0;let b=!1;if(typeof k.$0O.matchMedia=="function"){const c=k.$0O.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),f=k.$0O.matchMedia("(display-mode: fullscreen)");b=c.matches,w(k.$0O,c,({matches:a})=>{b&&f.matches||(b=a)})}function h(){return b}t.$sP=h;function $(){return navigator?.windowControlsOverlay?.visible}t.$tP=$}),define(be[22],$e([1,0,4]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GR=void 0;class T{get event(){return this.a.event}constructor(H,A,S){const m=w=>this.a.fire(w);this.a=new k.$Vd({onWillAddFirstListener:()=>H.addEventListener(A,m,S),onDidRemoveLastListener:()=>H.removeEventListener(A,m,S)})}dispose(){this.a.dispose()}}t.$GR=T}),define(be[29],$e([1,0,4]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6d=t.CancellationToken=void 0;const T=Object.freeze(function(S,m){const w=setTimeout(S.bind(m),0);return{dispose(){clearTimeout(w)}}});var n;(function(S){function m(w){return w===S.None||w===S.Cancelled||w instanceof H?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}S.isCancellationToken=m,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(n||(t.CancellationToken=n={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new k.$Vd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(m){this.f=void 0,this.g=void 0,this.g=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new H),this.f}cancel(){this.f?this.f instanceof H&&this.f.cancel():this.f=n.Cancelled}dispose(m=!1){m&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof H&&this.f.dispose():this.f=n.None}}t.$6d=A}),define(be[85],$e([1,0,29]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ge=t.$Fe=t.$Ee=void 0;class T{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new k.$6d,m=this.b(S.token);return this.a={promise:m,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}t.$Ee=T;class n{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const m=JSON.stringify(S);return this.b!==m&&(this.b=m,this.a=this.c(S)),this.a}}t.$Fe=n;class H{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const m=this.b(S);return this.a.set(S,m),m}}t.$Ge=H}),define(be[48],$e([1,0,4,2]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ns=t.$ms=t.$ls=t.$ks=t.ScrollbarVisibility=void 0;var n;(function(l){l[l.Auto=1]="Auto",l[l.Hidden=2]="Hidden",l[l.Visible=3]="Visible"})(n||(t.ScrollbarVisibility=n={}));class H{constructor(e,s,g,b,h,$,c){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,g=g|0,b=b|0,h=h|0,$=$|0,c=c|0),this.rawScrollLeft=b,this.rawScrollTop=c,s<0&&(s=0),b+s>g&&(b=g-s),b<0&&(b=0),h<0&&(h=0),c+h>$&&(c=$-h),c<0&&(c=0),this.width=s,this.scrollWidth=g,this.scrollLeft=b,this.height=h,this.scrollHeight=$,this.scrollTop=c}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const g=this.width!==e.width,b=this.scrollWidth!==e.scrollWidth,h=this.scrollLeft!==e.scrollLeft,$=this.height!==e.height,c=this.scrollHeight!==e.scrollHeight,f=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:g,scrollWidthChanged:b,scrollLeftChanged:h,heightChanged:$,scrollHeightChanged:c,scrollTopChanged:f}}}t.$ks=H;class A extends T.$Tc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new k.$Vd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const g=this.g.withScrollDimensions(e,s);this.n(g,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const g=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===g.scrollLeft&&this.h.to.scrollTop===g.scrollTop)return;let b;s?b=new D(this.h.from,g,this.h.startTime,this.h.duration):b=this.h.combine(this.g,g,this.c),this.h.dispose(),this.h=b}else{const g=this.g.withScrollPosition(e);this.h=D.start(this.g,g,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const g=this.g;g.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(g,s)))}}t.$ls=A;class S{constructor(e,s,g){this.scrollLeft=e,this.scrollTop=s,this.isDone=g}}t.$ms=S;function m(l,e){const s=e-l;return function(g){return l+s*r(g)}}function w(l,e,s){return function(g){return g<s?l(g/s):e((g-s)/(1-s))}}class D{constructor(e,s,g,b){this.from=e,this.to=s,this.duration=b,this.startTime=g,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,g){if(Math.abs(e-s)>2.5*g){let h,$;return e<s?(h=e+.75*g,$=s-.75*g):(h=e-.75*g,$=s+.75*g),w(m(e,h),m($,s),.33)}return m(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const g=this.c(s),b=this.d(s);return new S(g,b,!1)}return new S(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,g){return D.start(e,s,g)}static start(e,s,g){g=g+10;const b=Date.now()-10;return new D(e,s,b,g)}}t.$ns=D;function M(l){return Math.pow(l,3)}function r(l){return 1-M(1-l)}}),define(be[86],$e([1,0,6,2]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=void 0;function n(c){const f=c;return f?typeof f.read=="function":!1}t.$7d=n;function H(c){const f=c;return f?[f.on,f.pause,f.resume,f.destroy].every(a=>typeof a=="function"):!1}t.$8d=H;function A(c){const f=c;return f?H(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}t.$9d=A;function S(c,f){return new m(c,f)}t.$0d=S;class m{constructor(f,a){this.e=f,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(a=>a(f))}h(f){this.c.error.length===0?(0,k.$1)(f):this.c.error.slice(0).forEach(a=>a(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,a){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(f,a){if(this.a.destroyed)return;let C;switch(f){case"data":C=this.c.data;break;case"end":C=this.c.end;break;case"error":C=this.c.error;break}if(C){const O=C.indexOf(a);O>=0&&C.splice(O,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(C=>C())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,f){const a=[];let C;for(;(C=c.read())!==null;)a.push(C);return f(a)}t.$$d=w;function D(c,f,a){const C=[];let O;for(;(O=c.read())!==null&&C.length<a;)C.push(O);return O===null&&C.length>0?f(C):{read:()=>{if(C.length>0)return C.shift();if(typeof O<"u"){const L=O;return O=void 0,L}return c.read()}}}t.$_d=D;function M(c,f){return new Promise((a,C)=>{const O=[];r(c,{onData:L=>{f&&O.push(L)},onError:L=>{f?C(L):a(void 0)},onEnd:()=>{a(f?f(O):void 0)}})})}t.$ae=M;function r(c,f,a){c.on("error",C=>{a?.isCancellationRequested||f.onError(C)}),c.on("end",()=>{a?.isCancellationRequested||f.onEnd()}),c.on("data",C=>{a?.isCancellationRequested||f.onData(C)})}t.$be=r;function l(c,f){return new Promise((a,C)=>{const O=new T.$Sc,L=[],B=V=>{if(L.push(V),L.length>f)return O.dispose(),c.pause(),a({stream:c,buffer:L,ended:!1})},v=V=>(O.dispose(),C(V)),P=()=>(O.dispose(),a({stream:c,buffer:L,ended:!0}));O.add((0,T.$Rc)(()=>c.removeListener("error",v))),c.on("error",v),O.add((0,T.$Rc)(()=>c.removeListener("end",P))),c.on("end",P),O.add((0,T.$Rc)(()=>c.removeListener("data",B))),c.on("data",B)})}t.$ce=l;function e(c,f){const a=S(f);return a.end(c),a}t.$de=e;function s(){const c=S(()=>{throw new Error("not supported")});return c.end(),c}t.$ee=s;function g(c){let f=!1;return{read:()=>f?null:(f=!0,c)}}t.$fe=g;function b(c,f,a){const C=S(a);return r(c,{onData:O=>C.write(f.data(O)),onError:O=>C.error(f.error?f.error(O):O),onEnd:()=>C.end()}),C}t.$ge=b;function h(c,f,a){let C=!1;return{read:()=>{const O=f.read();return C?O:(C=!0,O!==null?a([c,O]):c)}}}t.$he=h;function $(c,f,a){let C=!1;const O=S(a);return r(f,{onData:L=>C?O.write(L):(C=!0,O.write(a([c,L]))),onError:L=>O.error(L),onEnd:()=>{C||(C=!0,O.write(c)),O.end()}}),O}t.$ie=$}),define(be[33],$e([1,0,23,86]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$De=t.$Ce=t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=void 0;const n=typeof Buffer<"u",H=new k.$V(()=>new Uint8Array(256));let A,S;class m{static alloc(I){return n?new m(Buffer.allocUnsafe(I)):new m(new Uint8Array(I))}static wrap(I){return n&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new m(I)}static fromString(I,z){return!(z?.dontUseNodeBuffer||!1)&&n?new m(Buffer.from(I)):(A||(A=new TextEncoder),new m(A.encode(I)))}static fromByteArray(I){const z=m.alloc(I.length);for(let X=0,Y=I.length;X<Y;X++)z.buffer[X]=I[X];return z}static concat(I,z){if(typeof z>"u"){z=0;for(let fe=0,ae=I.length;fe<ae;fe++)z+=I[fe].byteLength}const X=m.alloc(z);let Y=0;for(let fe=0,ae=I.length;fe<ae;fe++){const ee=I[fe];X.set(ee,Y),Y+=ee.byteLength}return X}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=m.alloc(this.byteLength);return I.set(this),I}toString(){return n?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(I,z){return new m(this.buffer.subarray(I,z))}set(I,z){if(I instanceof m)this.buffer.set(I.buffer,z);else if(I instanceof Uint8Array)this.buffer.set(I,z);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),z);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return r(this.buffer,I)}writeUInt32BE(I,z){l(this.buffer,I,z)}readUInt32LE(I){return e(this.buffer,I)}writeUInt32LE(I,z){s(this.buffer,I,z)}readUInt8(I){return g(this.buffer,I)}writeUInt8(I,z){b(this.buffer,I,z)}indexOf(I,z=0){return w(this.buffer,I instanceof m?I.buffer:I,z)}}t.$je=m;function w(N,I,z=0){const X=I.byteLength,Y=N.byteLength;if(X===0)return 0;if(X===1)return N.indexOf(I[0]);if(X>Y-z)return-1;const fe=H.value;fe.fill(I.length);for(let Ie=0;Ie<I.length;Ie++)fe[I[Ie]]=I.length-Ie-1;let ae=z+I.length-1,ee=ae,ge=-1;for(;ae<Y;)if(N[ae]===I[ee]){if(ee===0){ge=ae;break}ae--,ee--}else ae+=Math.max(I.length-ee,fe[N[ae]]),ee=I.length-1;return ge}t.$ke=w;function D(N,I){return N[I+0]<<0>>>0|N[I+1]<<8>>>0}t.$le=D;function M(N,I,z){N[z+0]=I&255,I=I>>>8,N[z+1]=I&255}t.$me=M;function r(N,I){return N[I]*2**24+N[I+1]*2**16+N[I+2]*2**8+N[I+3]}t.$ne=r;function l(N,I,z){N[z+3]=I,I=I>>>8,N[z+2]=I,I=I>>>8,N[z+1]=I,I=I>>>8,N[z]=I}t.$oe=l;function e(N,I){return N[I+0]<<0>>>0|N[I+1]<<8>>>0|N[I+2]<<16>>>0|N[I+3]<<24>>>0}t.$pe=e;function s(N,I,z){N[z+0]=I&255,I=I>>>8,N[z+1]=I&255,I=I>>>8,N[z+2]=I&255,I=I>>>8,N[z+3]=I&255}t.$qe=s;function g(N,I){return N[I]}t.$re=g;function b(N,I,z){N[z]=I}t.$se=b;function h(N){return T.$$d(N,I=>m.concat(I))}t.$te=h;function $(N){return T.$fe(N)}t.$ue=$;function c(N){return T.$ae(N,I=>m.concat(I))}t.$ve=c;async function f(N){return N.ended?m.concat(N.buffer):m.concat([...N.buffer,await c(N.stream)])}t.$we=f;function a(N){return T.$de(N,I=>m.concat(I))}t.$xe=a;function C(N){return T.$ge(N,{data:I=>typeof I=="string"?m.fromString(I):m.wrap(I)},I=>m.concat(I))}t.$ye=C;function O(N){return T.$0d(I=>m.concat(I),N)}t.$ze=O;function L(N,I){return T.$he(N,I,z=>m.concat(z))}t.$Ae=L;function B(N,I){return T.$ie(N,I,z=>m.concat(z))}t.$Be=B;function v(N){let I=0,z=0,X=0;const Y=new Uint8Array(Math.floor(N.length/4*3)),fe=ee=>{switch(z){case 3:Y[X++]=I|ee,z=0;break;case 2:Y[X++]=I|ee>>>2,I=ee<<6,z=3;break;case 1:Y[X++]=I|ee>>>4,I=ee<<4,z=2;break;default:I=ee<<2,z=1}};for(let ee=0;ee<N.length;ee++){const ge=N.charCodeAt(ee);if(ge>=65&&ge<=90)fe(ge-65);else if(ge>=97&&ge<=122)fe(ge-97+26);else if(ge>=48&&ge<=57)fe(ge-48+52);else if(ge===43||ge===45)fe(62);else if(ge===47||ge===95)fe(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${N[ee]}`)}}const ae=X;for(;z>0;)fe(0);return m.wrap(Y).slice(0,ae)}t.$Ce=v;const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",V="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:N},I=!0,z=!1){const X=z?V:P;let Y="";const fe=N.byteLength%3;let ae=0;for(;ae<N.byteLength-fe;ae+=3){const ee=N[ae+0],ge=N[ae+1],Ie=N[ae+2];Y+=X[ee>>>2],Y+=X[(ee<<4|ge>>>4)&63],Y+=X[(ge<<2|Ie>>>6)&63],Y+=X[Ie&63]}if(fe===1){const ee=N[ae+0];Y+=X[ee>>>2],Y+=X[ee<<4&63],I&&(Y+="==")}else if(fe===2){const ee=N[ae+0],ge=N[ae+1];Y+=X[ee>>>2],Y+=X[(ee<<4|ge>>>4)&63],Y+=X[ge<<2&63],I&&(Y+="=")}return Y}t.$De=U}),define(be[10],$e([1,0,85,23]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.GraphemeBreakType=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=void 0;function n(K){return!K||typeof K!="string"?!0:K.trim().length===0}t.$Je=n;const H=/{(\d+)}/g;function A(K,...ne){return ne.length===0?K:K.replace(H,function(de,Ae){const Ne=parseInt(Ae,10);return isNaN(Ne)||Ne<0||Ne>=ne.length?de:ne[Ne]})}t.$Ke=A;const S=/{([^}]+)}/g;function m(K,ne){return Object.keys(ne).length===0?K:K.replace(S,(de,Ae)=>ne[Ae]??de)}t.$Le=m;function w(K){return K.replace(/[<>"'&]/g,ne=>{switch(ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ne})}t.$Me=w;function D(K){return K.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}t.$Ne=D;function M(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Oe=M;function r(K,ne){let de=0;const Ae=ne.charCodeAt(0);for(let Ne=K.length-1;Ne>=0;Ne--)K.charCodeAt(Ne)===Ae&&de++;return de}t.$Pe=r;function l(K,ne,de="\u2026"){return K.length<=ne?K:`${K.substr(0,ne)}${de}`}t.$Qe=l;function e(K,ne,de="\u2026"){if(K.length<=ne)return K;const Ae=Math.ceil(ne/2)-de.length/2,Ne=Math.floor(ne/2)-de.length/2;return`${K.substr(0,Ae)}${de}${K.substr(K.length-Ne)}`}t.$Re=e;function s(K,ne=" "){const de=g(K,ne);return b(de,ne)}t.$Se=s;function g(K,ne){if(!K||!ne)return K;const de=ne.length;if(de===0||K.length===0)return K;let Ae=0;for(;K.indexOf(ne,Ae)===Ae;)Ae=Ae+de;return K.substring(Ae)}t.$Te=g;function b(K,ne){if(!K||!ne)return K;const de=ne.length,Ae=K.length;if(de===0||Ae===0)return K;let Ne=Ae,je=-1;for(;je=K.lastIndexOf(ne,Ne-1),!(je===-1||je+de!==Ne);){if(je===0)return"";Ne=je}return K.substring(0,Ne)}t.$Ue=b;function h(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Ve=h;function $(K){return K.replace(/\*/g,"")}t.$We=$;function c(K,ne,de={}){if(!K)throw new Error("Cannot create regex from empty string");ne||(K=M(K)),de.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Ae="";return de.global&&(Ae+="g"),de.matchCase||(Ae+="i"),de.multiline&&(Ae+="m"),de.unicode&&(Ae+="u"),new RegExp(K,Ae)}t.$Xe=c;function f(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}t.$Ye=f;function a(K){return K.split(/\r\n|\r|\n/)}t.$Ze=a;function C(K){for(let ne=0,de=K.length;ne<de;ne++){const Ae=K.charCodeAt(ne);if(Ae!==32&&Ae!==9)return ne}return-1}t.$1e=C;function O(K,ne=0,de=K.length){for(let Ae=ne;Ae<de;Ae++){const Ne=K.charCodeAt(Ae);if(Ne!==32&&Ne!==9)return K.substring(ne,Ae)}return K.substring(ne,de)}t.$2e=O;function L(K,ne=K.length-1){for(let de=ne;de>=0;de--){const Ae=K.charCodeAt(de);if(Ae!==32&&Ae!==9)return de}return-1}t.$3e=L;function B(K,ne,de){const Ae=[];let Ne=0;for(const je of K.matchAll(ne)){if(Ae.push(K.slice(Ne,je.index)),je.index===void 0)throw new Error("match.index should be defined");Ne=je.index+je[0].length,Ae.push(de(je[0],...je.slice(1),je.index,K,je.groups))}return Ae.push(K.slice(Ne)),Promise.all(Ae).then(je=>je.join(""))}t.$4e=B;function v(K,ne){return K<ne?-1:K>ne?1:0}t.$5e=v;function P(K,ne,de=0,Ae=K.length,Ne=0,je=ne.length){for(;de<Ae&&Ne<je;de++,Ne++){const Je=K.charCodeAt(de),tt=ne.charCodeAt(Ne);if(Je<tt)return-1;if(Je>tt)return 1}const Ve=Ae-de,_e=je-Ne;return Ve<_e?-1:Ve>_e?1:0}t.$6e=P;function V(K,ne){return U(K,ne,0,K.length,0,ne.length)}t.$7e=V;function U(K,ne,de=0,Ae=K.length,Ne=0,je=ne.length){for(;de<Ae&&Ne<je;de++,Ne++){let Je=K.charCodeAt(de),tt=ne.charCodeAt(Ne);if(Je===tt)continue;if(Je>=128||tt>=128)return P(K.toLowerCase(),ne.toLowerCase(),de,Ae,Ne,je);I(Je)&&(Je-=32),I(tt)&&(tt-=32);const Ye=Je-tt;if(Ye!==0)return Ye}const Ve=Ae-de,_e=je-Ne;return Ve<_e?-1:Ve>_e?1:0}t.$8e=U;function N(K){return K>=48&&K<=57}t.$9e=N;function I(K){return K>=97&&K<=122}t.$0e=I;function z(K){return K>=65&&K<=90}t.$$e=z;function X(K,ne){return K.length===ne.length&&U(K,ne)===0}t.$_e=X;function Y(K,ne){const de=ne.length;return ne.length>K.length?!1:U(K,ne,0,de)===0}t.$af=Y;function fe(K,ne){const de=Math.min(K.length,ne.length);let Ae;for(Ae=0;Ae<de;Ae++)if(K.charCodeAt(Ae)!==ne.charCodeAt(Ae))return Ae;return de}t.$bf=fe;function ae(K,ne){const de=Math.min(K.length,ne.length);let Ae;const Ne=K.length-1,je=ne.length-1;for(Ae=0;Ae<de;Ae++)if(K.charCodeAt(Ne-Ae)!==ne.charCodeAt(je-Ae))return Ae;return de}t.$cf=ae;function ee(K){return 55296<=K&&K<=56319}t.$df=ee;function ge(K){return 56320<=K&&K<=57343}t.$ef=ge;function Ie(K,ne){return(K-55296<<10)+(ne-56320)+65536}t.$ff=Ie;function Ce(K,ne,de){const Ae=K.charCodeAt(de);if(ee(Ae)&&de+1<ne){const Ne=K.charCodeAt(de+1);if(ge(Ne))return Ie(Ae,Ne)}return Ae}t.$gf=Ce;function Be(K,ne){const de=K.charCodeAt(ne-1);if(ge(de)&&ne>1){const Ae=K.charCodeAt(ne-2);if(ee(Ae))return Ie(Ae,de)}return de}class se{get offset(){return this.e}constructor(ne,de=0){this.c=ne,this.d=ne.length,this.e=de}setOffset(ne){this.e=ne}prevCodePoint(){const ne=Be(this.c,this.e);return this.e-=ne>=65536?2:1,ne}nextCodePoint(){const ne=Ce(this.c,this.d,this.e);return this.e+=ne>=65536?2:1,ne}eol(){return this.e>=this.d}}t.$hf=se;class J{get offset(){return this.c.offset}constructor(ne,de=0){this.c=new se(ne,de)}nextGraphemeLength(){const ne=Ee.getInstance(),de=this.c,Ae=de.offset;let Ne=ne.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const je=de.offset,Ve=ne.getGraphemeBreakType(de.nextCodePoint());if(De(Ne,Ve)){de.setOffset(je);break}Ne=Ve}return de.offset-Ae}prevGraphemeLength(){const ne=Ee.getInstance(),de=this.c,Ae=de.offset;let Ne=ne.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const je=de.offset,Ve=ne.getGraphemeBreakType(de.prevCodePoint());if(De(Ve,Ne)){de.setOffset(je);break}Ne=Ve}return Ae-de.offset}eol(){return this.c.eol()}}t.$if=J;function re(K,ne){return new J(K,ne).nextGraphemeLength()}t.$jf=re;function oe(K,ne){return new J(K,ne).prevGraphemeLength()}t.$kf=oe;function W(K,ne){ne>0&&ge(K.charCodeAt(ne))&&ne--;const de=ne+re(K,ne);return[de-oe(K,de),de]}t.$lf=W;function G(K){const ne=new J(K);let de=0;for(;!ne.eol();)de++,ne.nextGraphemeLength();return de}t.$mf=G;let ue;function me(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(K){return ue||(ue=me()),ue.test(K)}t.$nf=Se;const ke=/^[\t\n\r\x20-\x7E]*$/;function Pe(K){return ke.test(K)}t.$of=Pe,t.$pf=/[\u2028\u2029]/;function x(K){return t.$pf.test(K)}t.$qf=x;function d(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}t.$rf=d;function y(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}t.$sf=y;function p(K,ne,de=""){const Ae=K.trimStart();if(Ae.length<ne)return Ae;const Ne=/\b/g;let je=0;for(;Ne.test(Ae)&&!(Ae.length-Ne.lastIndex<ne);)je=Ne.lastIndex,Ne.lastIndex+=1;return je===0?Ae:de+Ae.substring(je).trimStart()}t.$tf=p;const u=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,i=/\x1b\].*?\x07/g;function o(K){return K&&(K=K.replace(u,"").replace(i,"")),K}t.$uf=o,t.$vf=String.fromCharCode(65279);function E(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}t.$wf=E;function R(K){return E(K)?K.substr(1):K}t.$xf=R;function F(K,ne){if(!K||!ne||K.length<ne.length)return!1;const de=ne.length,Ae=K.toLowerCase();let Ne=0,je=-1;for(;Ne<de;){const Ve=Ae.indexOf(ne[Ne],je+1);if(Ve<0)return!1;je=Ve,Ne++}return!0}t.$yf=F;function j(K,ne=!1){return K?(ne&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}t.$zf=j;function q(K){return K.charAt(0).toUpperCase()+K.slice(1)}t.$Af=q;function Z(K,ne=1){if(ne===0)return"";let de=-1;do de=K.indexOf(`
`,de+1),ne--;while(ne>0&&de>=0);return de===-1?K:(K[de-1]==="\r"&&de--,K.substr(0,de))}t.$Bf=Z;function le(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}t.$Cf=le;function pe(K){return Ee.getInstance().getGraphemeBreakType(K)}t.$Df=pe;function De(K,ne){return K===0?ne!==5&&ne!==7:K===2&&ne===3?!1:K===4||K===2||K===3||ne===4||ne===2||ne===3?!0:!(K===8&&(ne===8||ne===9||ne===11||ne===12)||(K===11||K===9)&&(ne===9||ne===10)||(K===12||K===10)&&ne===10||ne===5||ne===13||ne===7||K===1||K===13&&ne===14||K===6&&ne===6)}var we;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(we||(t.GraphemeBreakType=we={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=ve()}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const de=this.d,Ae=de.length/3;let Ne=1;for(;Ne<=Ae;)if(ne<de[3*Ne])Ne=2*Ne;else if(ne>de[3*Ne+1])Ne=2*Ne+1;else return de[3*Ne+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(K,ne){if(K===0)return 0;const de=Le(K,ne);if(de!==void 0)return de;const Ae=new se(ne,K);return Ae.prevCodePoint(),Ae.offset}t.$Ef=Te;function Le(K,ne){const de=new se(ne,K);let Ae=de.prevCodePoint();for(;Me(Ae)||Ae===65039||Ae===8419;){if(de.offset===0)return;Ae=de.prevCodePoint()}if(!y(Ae))return;let Ne=de.offset;return Ne>0&&de.prevCodePoint()===8205&&(Ne=de.offset),Ne}function Me(K){return 127995<=K&&K<=127999}var Ze;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),t.$Ff="\xA0";class et{static{this.c=new T.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new k.$Fe(ne=>{function de(Ye){const nt=new Map;for(let st=0;st<Ye.length;st+=2)nt.set(Ye[st],Ye[st+1]);return nt}function Ae(Ye,nt){const st=new Map(Ye);for(const[rt,gt]of nt)st.set(rt,gt);return st}function Ne(Ye,nt){if(!Ye)return nt;const st=new Map;for(const[rt,gt]of Ye)nt.has(rt)&&st.set(rt,gt);return st}const je=this.c.value;let Ve=ne.filter(Ye=>!Ye.startsWith("_")&&Ye in je);Ve.length===0&&(Ve=["_default"]);let _e;for(const Ye of Ve){const nt=de(je[Ye]);_e=Ne(_e,nt)}const Je=de(je._common),tt=Ae(Je,_e);return new et(tt)})}static getInstance(ne){return et.d.get(Array.from(ne))}static{this.e=new T.$V(()=>Object.keys(et.c.value).filter(ne=>!ne.startsWith("_")))}static getLocales(){return et.e.value}constructor(ne){this.f=ne}isAmbiguous(ne){return this.f.has(ne)}getPrimaryConfusable(ne){return this.f.get(ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Gf=et;class xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(xe.c())),this.d}static isInvisibleCharacter(ne){return xe.e().has(ne)}static get codePoints(){return xe.e()}}t.$Hf=xe}),define(be[34],$e([1,0,32,80,10]),function(ie,t,k,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9j=t.$8j=t.$7j=t.$6j=t.FuzzyScore=t.$5j=t.$4j=t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.or=void 0;function H(...F){return function(j,q){for(let Z=0,le=F.length;Z<le;Z++){const pe=F[Z](j,q);if(pe)return pe}return null}}t.or=H,t.$Tj=A.bind(void 0,!1),t.$Uj=A.bind(void 0,!0);function A(F,j,q){if(!q||q.length<j.length)return null;let Z;return F?Z=n.$af(q,j):Z=q.indexOf(j)===0,Z?j.length>0?[{start:0,end:j.length}]:[]:null}function S(F,j){const q=j.toLowerCase().indexOf(F.toLowerCase());return q===-1?null:[{start:q,end:q+F.length}]}t.$Vj=S;function m(F,j){return w(F.toLowerCase(),j.toLowerCase(),0,0)}t.$Wj=m;function w(F,j,q,Z){if(q===F.length)return[];if(Z===j.length)return null;if(F[q]===j[Z]){let le=null;return(le=w(F,j,q+1,Z+1))?c({start:Z,end:Z+1},le):null}return w(F,j,q,Z+1)}function D(F){return 97<=F&&F<=122}function M(F){return 65<=F&&F<=90}t.$Xj=M;function r(F){return 48<=F&&F<=57}function l(F){return F===32||F===9||F===10||F===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(F=>e.add(F.charCodeAt(0)));function s(F){return l(F)||e.has(F)}function g(F,j){return F===j||s(F)&&s(j)}const b=new Map;function h(F){if(b.has(F))return b.get(F);let j;const q=(0,T.$Rj)(F);return q&&(j=q),b.set(F,j),j}function $(F){return D(F)||M(F)||r(F)}function c(F,j){return j.length===0?j=[F]:F.end===j[0].start?j[0].start=F.start:j.unshift(F),j}function f(F,j){for(let q=j;q<F.length;q++){const Z=F.charCodeAt(q);if(M(Z)||r(Z)||q>0&&!$(F.charCodeAt(q-1)))return q}return F.length}function a(F,j,q,Z){if(q===F.length)return[];if(Z===j.length)return null;if(F[q]!==j[Z].toLowerCase())return null;{let le=null,pe=Z+1;for(le=a(F,j,q+1,Z+1);!le&&(pe=f(j,pe))<j.length;)le=a(F,j,q+1,pe),pe++;return le===null?null:c({start:Z,end:Z+1},le)}}function C(F){let j=0,q=0,Z=0,le=0,pe=0;for(let Te=0;Te<F.length;Te++)pe=F.charCodeAt(Te),M(pe)&&j++,D(pe)&&q++,$(pe)&&Z++,r(pe)&&le++;const De=j/F.length,we=q/F.length,Ee=Z/F.length,ve=le/F.length;return{upperPercent:De,lowerPercent:we,alphaPercent:Ee,numericPercent:ve}}function O(F){const{upperPercent:j,lowerPercent:q}=F;return q===0&&j>.6}function L(F){const{upperPercent:j,lowerPercent:q,alphaPercent:Z,numericPercent:le}=F;return q>.2&&j<.8&&Z>.6&&le<.2}function B(F){let j=0,q=0,Z=0,le=0;for(let pe=0;pe<F.length;pe++)Z=F.charCodeAt(pe),M(Z)&&j++,D(Z)&&q++,l(Z)&&le++;return(j===0||q===0)&&le===0?F.length<=30:j<=5}function v(F,j){if(!j||(j=j.trim(),j.length===0)||!B(F)||j.length>60)return null;const q=C(j);if(!L(q)){if(!O(q))return null;j=j.toLowerCase()}let Z=null,le=0;for(F=F.toLowerCase();le<j.length&&(Z=a(F,j,0,le))===null;)le=f(j,le+1);return Z}t.$Yj=v;function P(F,j,q=!1){if(!j||j.length===0)return null;let Z=null,le=0;for(F=F.toLowerCase(),j=j.toLowerCase();le<j.length&&(Z=V(F,j,0,le,q),Z===null);)le=U(j,le+1);return Z}t.$Zj=P;function V(F,j,q,Z,le){let pe=0;if(q===F.length)return[];if(Z===j.length)return null;if(!g(F.charCodeAt(q),j.charCodeAt(Z))){const Ee=h(F.charCodeAt(q));if(!Ee)return null;for(let ve=0;ve<Ee.length;ve++)if(!g(Ee[ve],j.charCodeAt(Z+ve)))return null;pe+=Ee.length-1}let De=null,we=Z+pe+1;if(De=V(F,j,q+1,we,le),!le)for(;!De&&(we=U(j,we))<j.length;)De=V(F,j,q+1,we,le),we++;if(!De)return null;if(F.charCodeAt(q)!==j.charCodeAt(Z)){const Ee=h(F.charCodeAt(q));if(!Ee)return De;for(let ve=0;ve<Ee.length;ve++)if(Ee[ve]!==j.charCodeAt(Z+ve))return De}return c({start:Z,end:Z+pe+1},De)}function U(F,j){for(let q=j;q<F.length;q++)if(s(F.charCodeAt(q))||q>0&&s(F.charCodeAt(q-1)))return q;return F.length}const N=H(t.$Uj,v,S),I=H(t.$Uj,v,m),z=new k.$Dc(1e4);function X(F,j,q=!1){if(typeof F!="string"||typeof j!="string")return null;let Z=z.get(F);Z||(Z=new RegExp(n.$Ve(F),"i"),z.set(F,Z));const le=Z.exec(j);return le?[{start:le.index,end:le.index+le[0].length}]:q?I(F,j):N(F,j)}t.$1j=X;function Y(F,j){const q=y(F,F.toLowerCase(),0,j,j.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?ae(q):null}t.$2j=Y;function fe(F,j,q,Z,le,pe){const De=Math.min(13,F.length);for(;q<De;q++){const we=y(F,j,q,Z,le,pe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,pe]}t.$3j=fe;function ae(F){if(typeof F>"u")return[];const j=[],q=F[1];for(let Z=F.length-1;Z>1;Z--){const le=F[Z]+q,pe=j[j.length-1];pe&&pe.end===le?pe.end=le+1:j.push({start:le,end:le+1})}return j}t.$4j=ae;const ee=128;function ge(){const F=[],j=[];for(let q=0;q<=ee;q++)j[q]=0;for(let q=0;q<=ee;q++)F.push(j.slice(0));return F}function Ie(F){const j=[];for(let q=0;q<=F;q++)j[q]=0;return j}const Ce=Ie(2*ee),Be=Ie(2*ee),se=ge(),J=ge(),re=ge(),oe=!1;function W(F,j,q,Z,le){function pe(we,Ee,ve=" "){for(;we.length<Ee;)we=ve+we;return we}let De=` |   |${Z.split("").map(we=>pe(we,3)).join("|")}
`;for(let we=0;we<=q;we++)we===0?De+=" |":De+=`${j[we-1]}|`,De+=F[we].slice(0,le+1).map(Ee=>pe(Ee.toString(),3)).join("|")+`
`;return De}function G(F,j,q,Z){F=F.substr(j),q=q.substr(Z),console.log(W(J,F,F.length,q,q.length)),console.log(W(re,F,F.length,q,q.length)),console.log(W(se,F,F.length,q,q.length))}function ue(F,j){if(j<0||j>=F.length)return!1;const q=F.codePointAt(j);switch(q){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.$sf(q)}}function me(F,j){if(j<0||j>=F.length)return!1;switch(F.charCodeAt(j)){case 32:case 9:return!0;default:return!1}}function Se(F,j,q){return j[F]!==q[F]}function ke(F,j,q,Z,le,pe,De=!1){for(;j<q&&le<pe;)F[j]===Z[le]&&(De&&(Ce[j]=le),j+=1),le+=1;return j===q}t.$5j=ke;var Pe;(function(F){F[F.Diag=1]="Diag",F[F.Left=2]="Left",F[F.LeftLeft=3]="LeftLeft"})(Pe||(Pe={}));var x;(function(F){F.Default=[-100,0];function j(q){return!q||q.length===2&&q[0]===-100&&q[1]===0}F.isDefault=j})(x||(t.FuzzyScore=x={}));class d{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(j,q){this.firstMatchCanBeWeak=j,this.boostFullMatch=q}}t.$6j=d;function y(F,j,q,Z,le,pe,De=d.default){const we=F.length>ee?ee:F.length,Ee=Z.length>ee?ee:Z.length;if(q>=we||pe>=Ee||we-q>Ee-pe||!ke(j,q,we,le,pe,Ee,!0))return;p(we,Ee,q,pe,j,le);let ve=1,Te=1,Le=q,Me=pe;const Ze=[!1];for(ve=1,Le=q;Le<we;ve++,Le++){const de=Ce[Le],Ae=Be[Le],Ne=Le+1<we?Be[Le+1]:Ee;for(Te=de-pe+1,Me=de;Me<Ne;Te++,Me++){let je=Number.MIN_SAFE_INTEGER,Ve=!1;Me<=Ae&&(je=u(F,j,Le,q,Z,le,Me,Ee,pe,se[ve-1][Te-1]===0,Ze));let _e=0;je!==Number.MAX_SAFE_INTEGER&&(Ve=!0,_e=je+J[ve-1][Te-1]);const Je=Me>de,tt=Je?J[ve][Te-1]+(se[ve][Te-1]>0?-5:0):0,Ye=Me>de+1&&se[ve][Te-1]>0,nt=Ye?J[ve][Te-2]+(se[ve][Te-2]>0?-5:0):0;if(Ye&&(!Je||nt>=tt)&&(!Ve||nt>=_e))J[ve][Te]=nt,re[ve][Te]=3,se[ve][Te]=0;else if(Je&&(!Ve||tt>=_e))J[ve][Te]=tt,re[ve][Te]=2,se[ve][Te]=0;else if(Ve)J[ve][Te]=_e,re[ve][Te]=1,se[ve][Te]=se[ve-1][Te-1]+1;else throw new Error("not possible")}}if(oe&&G(F,q,Z,pe),!Ze[0]&&!De.firstMatchCanBeWeak)return;ve--,Te--;const et=[J[ve][Te],pe];let xe=0,K=0;for(;ve>=1;){let de=Te;do{const Ae=re[ve][de];if(Ae===3)de=de-2;else if(Ae===2)de=de-1;else break}while(de>=1);xe>1&&j[q+ve-1]===le[pe+Te-1]&&!Se(de+pe-1,Z,le)&&xe+1>se[ve][de]&&(de=Te),de===Te?xe++:xe=1,K||(K=de),ve--,Te=de-1,et.push(Te)}Ee===we&&De.boostFullMatch&&(et[0]+=2);const ne=K-we;return et[0]-=ne,et}t.$7j=y;function p(F,j,q,Z,le,pe){let De=F-1,we=j-1;for(;De>=q&&we>=Z;)le[De]===pe[we]&&(Be[De]=we,De--),we--}function u(F,j,q,Z,le,pe,De,we,Ee,ve,Te){if(j[q]!==pe[De])return Number.MIN_SAFE_INTEGER;let Le=1,Me=!1;return De===q-Z?Le=F[q]===le[De]?7:5:Se(De,le,pe)&&(De===0||!Se(De-1,le,pe))?(Le=F[q]===le[De]?7:5,Me=!0):ue(pe,De)&&(De===0||!ue(pe,De-1))?Le=5:(ue(pe,De-1)||me(pe,De-1))&&(Le=5,Me=!0),Le>1&&q===Z&&(Te[0]=!0),Me||(Me=Se(De,le,pe)||ue(pe,De-1)||me(pe,De-1)),q===Z?De>Ee&&(Le-=Me?3:5):ve?Le+=Me?2:0:Le+=Me?0:1,De+1===we&&(Le-=Me?3:5),Le}function i(F,j,q,Z,le,pe,De){return E(F,j,q,Z,le,pe,!0,De)}t.$8j=i;function o(F,j,q,Z,le,pe,De){return E(F,j,q,Z,le,pe,!1,De)}t.$9j=o;function E(F,j,q,Z,le,pe,De,we){let Ee=y(F,j,q,Z,le,pe,we);if(Ee&&!De)return Ee;if(F.length>=3){const ve=Math.min(7,F.length-1);for(let Te=q+1;Te<ve;Te++){const Le=R(F,Te);if(Le){const Me=y(Le,Le.toLowerCase(),q,Z,le,pe,we);Me&&(Me[0]-=3,(!Ee||Me[0]>Ee[0])&&(Ee=Me))}}}return Ee}function R(F,j){if(j+1>=F.length)return;const q=F[j],Z=F[j+1];if(q!==Z)return F.slice(0,j)+Z+q+F.slice(j+2)}}),define(be[49],$e([1,0,10]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zi=t.$Yi=t.$Xi=t.$Wi=t.$Vi=t.$Ui=t.$Ti=void 0;function T(b){return n(b,0)}t.$Ti=T;function n(b,h){switch(typeof b){case"object":return b===null?H(349,h):Array.isArray(b)?m(b,h):w(b,h);case"string":return S(b,h);case"boolean":return A(b,h);case"number":return H(b,h);case"undefined":return H(937,h);default:return H(617,h)}}t.$Ui=n;function H(b,h){return(h<<5)-h+b|0}t.$Vi=H;function A(b,h){return H(b?433:863,h)}function S(b,h){h=H(149417,h);for(let $=0,c=b.length;$<c;$++)h=H(b.charCodeAt($),h);return h}t.$Wi=S;function m(b,h){return h=H(104579,h),b.reduce(($,c)=>n(c,$),h)}function w(b,h){return h=H(181387,h),Object.keys(b).sort().reduce(($,c)=>($=S(c,$),n(b[c],$)),h)}class D{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=n(h,this.g),this.g}}t.$Xi=D;var M;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function r(b,h,$=32){const c=$-h,f=~((1<<c)-1);return(b<<h|(f&b)>>>c)>>>0}function l(b,h=0,$=b.byteLength,c=0){for(let f=0;f<$;f++)b[h+f]=c}function e(b,h,$="0"){for(;b.length<h;)b=$+b;return b}function s(b,h=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map($=>$.toString(16).padStart(2,"0")).join(""):e((b>>>0).toString(16),h/4)}t.$Yi=s;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const $=h.length;if($===0)return;const c=this.p;let f=this.r,a=this.u,C,O;for(a!==0?(C=a,O=-1,a=0):(C=h.charCodeAt(0),O=0);;){let L=C;if(k.$df(C))if(O+1<$){const B=h.charCodeAt(O+1);k.$ef(B)?(O++,L=k.$ff(C,B)):L=65533}else{a=C;break}else k.$ef(C)&&(L=65533);if(f=this.w(c,f,L),O++,O<$)C=h.charCodeAt(O);else break}this.r=f,this.u=a}w(h,$,c){return c<128?h[$++]=c:c<2048?(h[$++]=192|(c&1984)>>>6,h[$++]=128|(c&63)>>>0):c<65536?(h[$++]=224|(c&61440)>>>12,h[$++]=128|(c&4032)>>>6,h[$++]=128|(c&63)>>>0):(h[$++]=240|(c&1835008)>>>18,h[$++]=128|(c&258048)>>>12,h[$++]=128|(c&4032)>>>6,h[$++]=128|(c&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=g.g,$=this.q;for(let P=0;P<64;P+=4)h.setUint32(P,$.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)h.setUint32(P,r(h.getUint32(P-12,!1)^h.getUint32(P-32,!1)^h.getUint32(P-56,!1)^h.getUint32(P-64,!1),1),!1);let c=this.h,f=this.l,a=this.m,C=this.n,O=this.o,L,B,v;for(let P=0;P<80;P++)P<20?(L=f&a|~f&C,B=1518500249):P<40?(L=f^a^C,B=1859775393):P<60?(L=f&a|f&C|a&C,B=2400959708):(L=f^a^C,B=3395469782),v=r(c,5)+L+O+B+h.getUint32(P*4,!1)&4294967295,O=C,C=a,a=r(f,30),f=c,c=v;this.h=this.h+c&4294967295,this.l=this.l+f&4294967295,this.m=this.m+a&4294967295,this.n=this.n+C&4294967295,this.o=this.o+O&4294967295}}t.$Zi=g}),define(be[87],$e([1,0,75,49]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1s=t.$Zs=t.$Ys=void 0;class n{constructor(r){this.a=r}getElements(){const r=this.a,l=new Int32Array(r.length);for(let e=0,s=r.length;e<s;e++)l[e]=r.charCodeAt(e);return l}}t.$Ys=n;function H(M,r,l){return new D(new n(M),new n(r)).ComputeDiff(l).changes}t.$Zs=H;class A{static Assert(r,l){if(!r)throw new Error(l)}}class S{static Copy(r,l,e,s,g){for(let b=0;b<g;b++)e[s+b]=r[l+b]}static Copy2(r,l,e,s,g){for(let b=0;b<g;b++)e[s+b]=r[l+b]}}var m;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class w{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new k.$Xs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(r,l){this.b=Math.min(this.b,r),this.c=Math.min(this.c,l),this.d++}AddModifiedElement(r,l){this.b=Math.min(this.b,r),this.c=Math.min(this.c,l),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class D{constructor(r,l,e=null){this.a=e,this.b=r,this.c=l;const[s,g,b]=D.o(r),[h,$,c]=D.o(l);this.d=b&&c,this.e=s,this.f=g,this.g=h,this.h=$,this.k=[],this.m=[]}static n(r){return r.length>0&&typeof r[0]=="string"}static o(r){const l=r.getElements();if(D.n(l)){const e=new Int32Array(l.length);for(let s=0,g=l.length;s<g;s++)e[s]=(0,T.$Wi)(l[s],0);return[l,e,!0]}return l instanceof Int32Array?[[],l,!1]:[[],new Int32Array(l),!1]}p(r,l){return this.f[r]!==this.h[l]?!1:this.d?this.e[r]===this.g[l]:!0}q(r,l){if(!this.p(r,l))return!1;const e=D.r(this.b,r),s=D.r(this.c,l);return e===s}static r(r,l){return typeof r.getStrictElement=="function"?r.getStrictElement(l):null}s(r,l){return this.f[r]!==this.f[l]?!1:this.d?this.e[r]===this.e[l]:!0}u(r,l){return this.h[r]!==this.h[l]?!1:this.d?this.g[r]===this.g[l]:!0}ComputeDiff(r){return this.v(0,this.f.length-1,0,this.h.length-1,r)}v(r,l,e,s,g){const b=[!1];let h=this.w(r,l,e,s,b);return g&&(h=this.z(h)),{quitEarly:b[0],changes:h}}w(r,l,e,s,g){for(g[0]=!1;r<=l&&e<=s&&this.p(r,e);)r++,e++;for(;l>=r&&s>=e&&this.p(l,s);)l--,s--;if(r>l||e>s){let a;return e<=s?(A.Assert(r===l+1,"originalStart should only be one more than originalEnd"),a=[new k.$Xs(r,0,e,s-e+1)]):r<=l?(A.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),a=[new k.$Xs(r,l-r+1,e,0)]):(A.Assert(r===l+1,"originalStart should only be one more than originalEnd"),A.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}const b=[0],h=[0],$=this.y(r,l,e,s,b,h,g),c=b[0],f=h[0];if($!==null)return $;if(!g[0]){const a=this.w(r,c,e,f,g);let C=[];return g[0]?C=[new k.$Xs(c+1,l-(c+1)+1,f+1,s-(f+1)+1)]:C=this.w(c+1,l,f+1,s,g),this.H(a,C)}return[new k.$Xs(r,l-r+1,e,s-e+1)]}x(r,l,e,s,g,b,h,$,c,f,a,C,O,L,B,v,P,V){let U=null,N=null,I=new w,z=l,X=e,Y=O[0]-v[0]-s,fe=-1073741824,ae=this.k.length-1;do{const ee=Y+r;ee===z||ee<X&&c[ee-1]<c[ee+1]?(a=c[ee+1],L=a-Y-s,a<fe&&I.MarkNextChange(),fe=a,I.AddModifiedElement(a+1,L),Y=ee+1-r):(a=c[ee-1]+1,L=a-Y-s,a<fe&&I.MarkNextChange(),fe=a-1,I.AddOriginalElement(a,L+1),Y=ee-1-r),ae>=0&&(c=this.k[ae],r=c[0],z=1,X=c.length-1)}while(--ae>=-1);if(U=I.getReverseChanges(),V[0]){let ee=O[0]+1,ge=v[0]+1;if(U!==null&&U.length>0){const Ie=U[U.length-1];ee=Math.max(ee,Ie.getOriginalEnd()),ge=Math.max(ge,Ie.getModifiedEnd())}N=[new k.$Xs(ee,C-ee+1,ge,B-ge+1)]}else{I=new w,z=b,X=h,Y=O[0]-v[0]-$,fe=1073741824,ae=P?this.m.length-1:this.m.length-2;do{const ee=Y+g;ee===z||ee<X&&f[ee-1]>=f[ee+1]?(a=f[ee+1]-1,L=a-Y-$,a>fe&&I.MarkNextChange(),fe=a+1,I.AddOriginalElement(a+1,L+1),Y=ee+1-g):(a=f[ee-1],L=a-Y-$,a>fe&&I.MarkNextChange(),fe=a,I.AddModifiedElement(a+1,L+1),Y=ee-1-g),ae>=0&&(f=this.m[ae],g=f[0],z=1,X=f.length-1)}while(--ae>=-1);N=I.getChanges()}return this.H(U,N)}y(r,l,e,s,g,b,h){let $=0,c=0,f=0,a=0,C=0,O=0;r--,e--,g[0]=0,b[0]=0,this.k=[],this.m=[];const L=l-r+(s-e),B=L+1,v=new Int32Array(B),P=new Int32Array(B),V=s-e,U=l-r,N=r-e,I=l-s,X=(U-V)%2===0;v[V]=r,P[U]=l,h[0]=!1;for(let Y=1;Y<=L/2+1;Y++){let fe=0,ae=0;f=this.J(V-Y,Y,V,B),a=this.J(V+Y,Y,V,B);for(let ge=f;ge<=a;ge+=2){ge===f||ge<a&&v[ge-1]<v[ge+1]?$=v[ge+1]:$=v[ge-1]+1,c=$-(ge-V)-N;const Ie=$;for(;$<l&&c<s&&this.p($+1,c+1);)$++,c++;if(v[ge]=$,$+c>fe+ae&&(fe=$,ae=c),!X&&Math.abs(ge-U)<=Y-1&&$>=P[ge])return g[0]=$,b[0]=c,Ie<=P[ge]&&1447>0&&Y<=1447+1?this.x(V,f,a,N,U,C,O,I,v,P,$,l,g,c,s,b,X,h):null}const ee=(fe-r+(ae-e)-Y)/2;if(this.a!==null&&!this.a(fe,ee))return h[0]=!0,g[0]=fe,b[0]=ae,ee>0&&1447>0&&Y<=1447+1?this.x(V,f,a,N,U,C,O,I,v,P,$,l,g,c,s,b,X,h):(r++,e++,[new k.$Xs(r,l-r+1,e,s-e+1)]);C=this.J(U-Y,Y,U,B),O=this.J(U+Y,Y,U,B);for(let ge=C;ge<=O;ge+=2){ge===C||ge<O&&P[ge-1]>=P[ge+1]?$=P[ge+1]-1:$=P[ge-1],c=$-(ge-U)-I;const Ie=$;for(;$>r&&c>e&&this.p($,c);)$--,c--;if(P[ge]=$,X&&Math.abs(ge-V)<=Y&&$<=v[ge])return g[0]=$,b[0]=c,Ie>=v[ge]&&1447>0&&Y<=1447+1?this.x(V,f,a,N,U,C,O,I,v,P,$,l,g,c,s,b,X,h):null}if(Y<=1447){let ge=new Int32Array(a-f+2);ge[0]=V-f+1,S.Copy2(v,f,ge,1,a-f+1),this.k.push(ge),ge=new Int32Array(O-C+2),ge[0]=U-C+1,S.Copy2(P,C,ge,1,O-C+1),this.m.push(ge)}}return this.x(V,f,a,N,U,C,O,I,v,P,$,l,g,c,s,b,X,h)}z(r){for(let l=0;l<r.length;l++){const e=r[l],s=l<r.length-1?r[l+1].originalStart:this.f.length,g=l<r.length-1?r[l+1].modifiedStart:this.h.length,b=e.originalLength>0,h=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<g&&(!b||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!h||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const c=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!c)break;e.originalStart++,e.modifiedStart++}const $=[null];if(l<r.length-1&&this.I(r[l],r[l+1],$)){r[l]=$[0],r.splice(l+1,1),l--;continue}}for(let l=r.length-1;l>=0;l--){const e=r[l];let s=0,g=0;if(l>0){const a=r[l-1];s=a.originalStart+a.originalLength,g=a.modifiedStart+a.modifiedLength}const b=e.originalLength>0,h=e.modifiedLength>0;let $=0,c=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let a=1;;a++){const C=e.originalStart-a,O=e.modifiedStart-a;if(C<s||O<g||b&&!this.s(C,C+e.originalLength)||h&&!this.u(O,O+e.modifiedLength))break;const B=(C===s&&O===g?5:0)+this.G(C,e.originalLength,O,e.modifiedLength);B>c&&(c=B,$=a)}e.originalStart-=$,e.modifiedStart-=$;const f=[null];if(l>0&&this.I(r[l-1],r[l],f)){r[l-1]=f[0],r.splice(l,1),l++;continue}}if(this.d)for(let l=1,e=r.length;l<e;l++){const s=r[l-1],g=r[l],b=g.originalStart-s.originalStart-s.originalLength,h=s.originalStart,$=g.originalStart+g.originalLength,c=$-h,f=s.modifiedStart,a=g.modifiedStart+g.modifiedLength,C=a-f;if(b<5&&c<20&&C<20){const O=this.A(h,c,f,C,b);if(O){const[L,B]=O;(L!==s.originalStart+s.originalLength||B!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=L-s.originalStart,s.modifiedLength=B-s.modifiedStart,g.originalStart=L+b,g.modifiedStart=B+b,g.originalLength=$-g.originalStart,g.modifiedLength=a-g.modifiedStart)}}}return r}A(r,l,e,s,g){if(l<g||s<g)return null;const b=r+l-g+1,h=e+s-g+1;let $=0,c=0,f=0;for(let a=r;a<b;a++)for(let C=e;C<h;C++){const O=this.B(a,C,g);O>0&&O>$&&($=O,c=a,f=C)}return $>0?[c,f]:null}B(r,l,e){let s=0;for(let g=0;g<e;g++){if(!this.p(r+g,l+g))return 0;s+=this.e[r+g].length}return s}C(r){return r<=0||r>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[r])}D(r,l){if(this.C(r)||this.C(r-1))return!0;if(l>0){const e=r+l;if(this.C(e-1)||this.C(e))return!0}return!1}E(r){return r<=0||r>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[r])}F(r,l){if(this.E(r)||this.E(r-1))return!0;if(l>0){const e=r+l;if(this.E(e-1)||this.E(e))return!0}return!1}G(r,l,e,s){const g=this.D(r,l)?1:0,b=this.F(e,s)?1:0;return g+b}H(r,l){const e=[];if(r.length===0||l.length===0)return l.length>0?l:r;if(this.I(r[r.length-1],l[0],e)){const s=new Array(r.length+l.length-1);return S.Copy(r,0,s,0,r.length-1),s[r.length-1]=e[0],S.Copy(l,1,s,r.length,l.length-1),s}else{const s=new Array(r.length+l.length);return S.Copy(r,0,s,0,r.length),S.Copy(l,0,s,r.length,l.length),s}}I(r,l,e){if(A.Assert(r.originalStart<=l.originalStart,"Left change is not less than or equal to right change"),A.Assert(r.modifiedStart<=l.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=l.originalStart||r.modifiedStart+r.modifiedLength>=l.modifiedStart){const s=r.originalStart;let g=r.originalLength;const b=r.modifiedStart;let h=r.modifiedLength;return r.originalStart+r.originalLength>=l.originalStart&&(g=l.originalStart+l.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=l.modifiedStart&&(h=l.modifiedStart+l.modifiedLength-r.modifiedStart),e[0]=new k.$Xs(s,g,b,h),!0}else return e[0]=null,!1}J(r,l,e,s){if(r>=0&&r<s)return r;const g=e,b=s-e-1,h=l%2===0;if(r<0){const $=g%2===0;return h===$?0:1}else{const $=b%2===0;return h===$?s-1:s-2}}}t.$1s=D}),define(be[50],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sd=void 0,t.$Sd=Symbol("MicrotaskDelay")}),define(be[88],$e([1,0,12,10]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_h=t.$$h=t.$0h=t.$9h=t.$8h=void 0;class n{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const e=l.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.$8h=n;class H{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,T.$6e)(l,this.b,0,l.length,this.c,this.d):(0,T.$8e)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$9h=H;class A{constructor(l=!0,e=!0){this.f=l,this.g=e}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let e=l.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,T.$6e)(l,this.b,0,l.length,this.d,this.e):(0,T.$8e)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$0h=A;var S;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(S||(S={}));class m{constructor(l,e){this.f=l,this.g=e,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,T.$7e)(l,this.c.scheme);if(this.d[this.e]===2)return(0,T.$7e)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,T.$5e)(l,this.c.query);if(this.d[this.e]===5)return(0,T.$5e)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$$h=m;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(D||(D={}));class M{static forUris(l=()=>!1,e=()=>!1){return new M(new m(l,e))}static forPaths(l=!1){return new M(new A(void 0,!l))}static forStrings(){return new M(new n)}static forConfigKeys(){return new M(new H)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,e){if(e){const s=e.slice(0);(0,k.$Xb)(s);for(const g of s)this.set(g,l)}else{const s=l.slice(0);(0,k.$Xb)(s);for(const g of s)this.set(g[0],g[1])}}set(l,e){const s=this.b.reset(l);let g;this.c||(this.c=new w,this.c.segment=s.value());const b=[];for(g=this.c;;){const $=s.cmp(g.segment);if($>0)g.left||(g.left=new w,g.left.segment=s.value()),b.push([-1,g]),g=g.left;else if($<0)g.right||(g.right=new w,g.right.segment=s.value()),b.push([1,g]),g=g.right;else if(s.hasNext())s.next(),g.mid||(g.mid=new w,g.mid.segment=s.value()),b.push([0,g]),g=g.mid;else break}const h=g.value;g.value=e,g.key=l;for(let $=b.length-1;$>=0;$--){const c=b[$][1];c.updateHeight();const f=c.balanceFactor();if(f<-1||f>1){const a=b[$][0],C=b[$+1][0];if(a===1&&C===1)b[$][1]=c.rotateLeft();else if(a===-1&&C===-1)b[$][1]=c.rotateRight();else if(a===1&&C===-1)c.right=b[$+1][1]=b[$+1][1].rotateRight(),b[$][1]=c.rotateLeft();else if(a===-1&&C===1)c.left=b[$+1][1]=b[$+1][1].rotateLeft(),b[$][1]=c.rotateRight();else throw new Error;if($>0)switch(b[$-1][0]){case-1:b[$-1][1].left=b[$][1];break;case 1:b[$-1][1].right=b[$][1];break;case 0:b[$-1][1].mid=b[$][1];break}else this.c=b[0][1]}}return h}get(l){return this.d(l)?.value}d(l){const e=this.b.reset(l);let s=this.c;for(;s;){const g=e.cmp(s.segment);if(g>0)s=s.left;else if(g<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(l){const e=this.d(l);return!(e?.value===void 0&&e?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,e){const s=this.b.reset(l),g=[];let b=this.c;for(;b;){const h=s.cmp(b.segment);if(h>0)g.push([-1,b]),b=b.left;else if(h<0)g.push([1,b]),b=b.right;else if(s.hasNext())s.next(),g.push([0,b]),b=b.mid;else break}if(b){if(e?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const h=this.f(b.right);if(h.key){const{key:$,value:c,segment:f}=h;this.e(h.key,!1),b.key=$,b.value=c,b.segment=f}}else{const h=b.left??b.right;if(g.length>0){const[$,c]=g[g.length-1];switch($){case-1:c.left=h;break;case 0:c.mid=h;break;case 1:c.right=h;break}}else this.c=h}for(let h=g.length-1;h>=0;h--){const $=g[h][1];$.updateHeight();const c=$.balanceFactor();if(c>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),g[h][1]=$.rotateLeft()):c<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),g[h][1]=$.rotateRight()),h>0)switch(g[h-1][0]){case-1:g[h-1][1].left=g[h][1];break;case 1:g[h-1][1].right=g[h][1];break;case 0:g[h-1][1].mid=g[h][1];break}else this.c=g[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const e=this.b.reset(l);let s=this.c,g;for(;s;){const b=e.cmp(s.segment);if(b>0)s=s.left;else if(b<0)s=s.right;else if(e.hasNext())e.next(),g=s.value||g,s=s.mid;else break}return s&&s.value||g}findSuperstr(l){return this.g(l,!1)}g(l,e){const s=this.b.reset(l);let g=this.c;for(;g;){const b=s.cmp(g.segment);if(b>0)g=g.left;else if(b<0)g=g.right;else if(s.hasNext())s.next(),g=g.mid;else return g.mid?this.h(g.mid):e?g.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[e,s]of this)l(s,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const e=[];return this.j(l,e),e[Symbol.iterator]()}j(l,e){l&&(l.left&&this.j(l.left,e),l.value&&e.push([l.key,l.value]),l.mid&&this.j(l.mid,e),l.right&&this.j(l.right,e))}_isBalanced(){const l=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:l(e.left)&&l(e.right)};return l(this.c)}}t.$_h=M}),define(be[7],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=void 0;function k(f){return typeof f=="string"}t.$If=k;function T(f){return Array.isArray(f)&&f.every(a=>k(a))}t.$Jf=T;function n(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}t.$Kf=n;function H(f){const a=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof a}t.$Lf=H;function A(f){return typeof f=="number"&&!isNaN(f)}t.$Mf=A;function S(f){return!!f&&typeof f[Symbol.iterator]=="function"}t.$Nf=S;function m(f){return f===!0||f===!1}t.$Of=m;function w(f){return typeof f>"u"}t.$Pf=w;function D(f){return!M(f)}t.$Qf=D;function M(f){return w(f)||f===null}t.$Rf=M;function r(f,a){if(!f)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}t.$Sf=r;function l(f){if(M(f))throw new Error("Assertion Failed: argument is undefined or null");return f}t.$Tf=l;function e(...f){const a=[];for(let C=0;C<f.length;C++){const O=f[C];if(M(O))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);a.push(O)}return a}t.$Uf=e;const s=Object.prototype.hasOwnProperty;function g(f){if(!n(f))return!1;for(const a in f)if(s.call(f,a))return!1;return!0}t.$Vf=g;function b(f){return typeof f=="function"}t.$Wf=b;function h(...f){return f.length>0&&f.every(b)}t.$Xf=h;function $(f,a){const C=Math.min(f.length,a.length);for(let O=0;O<C;O++)c(f[O],a[O])}t.$Yf=$;function c(f,a){if(k(a)){if(typeof f!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(b(a)){try{if(f instanceof a)return}catch{}if(!M(f)&&f.constructor===a||a.length===1&&a.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Zf=c}),define(be[17],$e([1,0,7]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_j=t.$$j=t.$0j=void 0;const T=Object.create(null);function n(S,m){if((0,k.$If)(m)){const w=T[m];if(w===void 0)throw new Error(`${S} references an unknown codicon: ${m}`);m=w}return T[S]=m,{id:S}}function H(){return T}t.$0j=H;function A(){return Object.values(t.$_j)}t.$$j=A,t.$_j={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugBreakpointPending:n("debug-breakpoint-pending",60377),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),thumbsDownFilled:n("thumbsdown-filled",60435),thumbsUpFilled:n("thumbsup-filled",60436),coffee:n("coffee",60437),snake:n("snake",60438),game:n("game",60439),vr:n("vr",60440),chip:n("chip",60441),piano:n("piano",60442),music:n("music",60443),micFilled:n("mic-filled",60444),gitFetch:n("git-fetch",60445),copilot:n("copilot",60446),lightbulbSparkle:n("lightbulb-sparkle",60447),lightbulbSparkleAutofix:n("lightbulb-sparkle-autofix",60447),robot:n("robot",60448),sparkleFilled:n("sparkle-filled",60449),diffSingle:n("diff-single",60450),diffMultiple:n("diff-multiple",60451),surroundWith:n("surround-with",60452),gitStash:n("git-stash",60454),gitStashApply:n("git-stash-apply",60455),gitStashPop:n("git-stash-pop",60456),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(be[51],$e([1,0,7]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gn=t.$Fn=t.$En=t.$Dn=t.$Cn=t.$Bn=t.$An=t.$zn=t.$yn=t.$xn=t.$wn=t.$vn=void 0;function T(b){if(!b||typeof b!="object"||b instanceof RegExp)return b;const h=Array.isArray(b)?[]:{};return Object.entries(b).forEach(([$,c])=>{h[$]=c&&typeof c=="object"?T(c):c}),h}t.$vn=T;function n(b){if(!b||typeof b!="object")return b;const h=[b];for(;h.length>0;){const $=h.shift();Object.freeze($);for(const c in $)if(H.call($,c)){const f=$[c];typeof f=="object"&&!Object.isFrozen(f)&&!(0,k.$Lf)(f)&&h.push(f)}}return b}t.$wn=n;const H=Object.prototype.hasOwnProperty;function A(b,h){return S(b,h,new Set)}t.$xn=A;function S(b,h,$){if((0,k.$Rf)(b))return b;const c=h(b);if(typeof c<"u")return c;if(Array.isArray(b)){const f=[];for(const a of b)f.push(S(a,h,$));return f}if((0,k.$Kf)(b)){if($.has(b))throw new Error("Cannot clone recursive data-structure");$.add(b);const f={};for(const a in b)H.call(b,a)&&(f[a]=S(b[a],h,$));return $.delete(b),f}return b}function m(b,h,$=!0){return(0,k.$Kf)(b)?((0,k.$Kf)(h)&&Object.keys(h).forEach(c=>{c in b?$&&((0,k.$Kf)(b[c])&&(0,k.$Kf)(h[c])?m(b[c],h[c],$):b[c]=h[c]):b[c]=h[c]}),b):h}t.$yn=m;function w(b,h){if(b===h)return!0;if(b==null||h===null||h===void 0||typeof b!=typeof h||typeof b!="object"||Array.isArray(b)!==Array.isArray(h))return!1;let $,c;if(Array.isArray(b)){if(b.length!==h.length)return!1;for($=0;$<b.length;$++)if(!w(b[$],h[$]))return!1}else{const f=[];for(c in b)f.push(c);f.sort();const a=[];for(c in h)a.push(c);if(a.sort(),!w(f,a))return!1;for($=0;$<f.length;$++)if(!w(b[f[$]],h[f[$]]))return!1}return!0}t.$zn=w;function D(b){const h=new Set;return JSON.stringify(b,($,c)=>{if((0,k.$Kf)(c)||Array.isArray(c)){if(h.has(c))return"[Circular]";h.add(c)}return c})}t.$An=D;function M(b,h){const $=Object.create(null);return!b||!h||Object.keys(h).forEach(f=>{const a=b[f],C=h[f];w(a,C)||($[f]=C)}),$}t.$Bn=M;function r(b,h){const $=h.toLowerCase(),c=Object.keys(b).find(f=>f.toLowerCase()===$);return c?b[c]:b[h]}t.$Cn=r;function l(b,h){const $=Object.create(null);for(const[c,f]of Object.entries(b))h(c,f)&&($[c]=f);return $}t.$Dn=l;function e(b){let h=[];for(;Object.prototype!==b;)h=h.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return h}t.$En=e;function s(b){const h=[];for(const $ of e(b))typeof b[$]=="function"&&h.push($);return h}t.$Fn=s;function g(b,h){const $=f=>function(){const a=Array.prototype.slice.call(arguments,0);return h(f,a)},c={};for(const f of b)c[f]=$(f);return c}t.$Gn=g}),define(be[18],$e([1,0,17]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$ak=t.ThemeColor=void 0;var T;(function(A){function S(m){return m&&typeof m=="object"&&typeof m.id=="string"}A.isThemeColor=S})(T||(t.ThemeColor=T={}));function n(A){return{id:A}}t.$ak=n;var H;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function m(h){const $=S.exec(h.id);if(!$)return m(k.$_j.error);const[,c,f]=$,a=["codicon","codicon-"+c];return f&&a.push("codicon-modifier-"+f.substring(1)),a}A.asClassNameArray=m;function w(h){return m(h).join(" ")}A.asClassName=w;function D(h){return"."+m(h).join(".")}A.asCSSSelector=D;function M(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||T.isThemeColor(h.color))}A.isThemeIcon=M;const r=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function l(h){const $=r.exec(h);if(!$)return;const[,c]=$;return{id:c}}A.fromString=l;function e(h){return{id:h}}A.fromId=e;function s(h,$){let c=h.id;const f=c.lastIndexOf("~");return f!==-1&&(c=c.substring(0,f)),$&&(c=`${c}~${$}`),{id:c}}A.modify=s;function g(h){const $=h.id.lastIndexOf("~");if($!==-1)return h.id.substring($+1)}A.getModifier=g;function b(h,$){return h.id===$.id&&h.color?.id===$.color?.id}A.isEqual=b})(H||(t.ThemeIcon=H={}))}),define(be[35],$e([1,0,34,10,18]),function(ie,t,k,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=void 0;const H="$(",A=new RegExp(`\\$\\(${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${A.source}`,"g");function m(b){return b.replace(S,(h,$)=>$?h:`\\${h}`)}t.$bk=m;const w=new RegExp(`\\\\${A.source}`,"g");function D(b){return b.replace(w,h=>`\\${h}`)}t.$ck=D;const M=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function r(b){return b.indexOf(H)===-1?b:b.replace(M,(h,$,c,f)=>c?h:$||f||"")}t.$dk=r;function l(b){return b?b.replace(/\$\((.*?)\)/g,(h,$)=>` ${$} `).trim():""}t.$ek=l;const e=new RegExp(`\\$\\(${n.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(b){e.lastIndex=0;let h="";const $=[];let c=0;for(;;){const f=e.lastIndex,a=e.exec(b),C=b.substring(f,a?.index);if(C.length>0){h+=C;for(let O=0;O<C.length;O++)$.push(c)}if(!a)break;c+=a[0].length}return{text:h,iconOffsets:$}}t.$fk=s;function g(b,h,$=!1){const{text:c,iconOffsets:f}=h;if(!f||f.length===0)return(0,k.$1j)(b,c,$);const a=(0,T.$Te)(c," "),C=c.length-a.length,O=(0,k.$1j)(b,a,$);if(O)for(const L of O){const B=f[L.start+C]+C;L.start+=B,L.end+=B}return O}t.$gk=g}),define(be[89],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uU=t.$tU=void 0,t.$tU="vscode:contextmenu",t.$uU="vscode:onCloseContextMenu"}),define(be[90],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BU=void 0;class k{constructor(n,H){this.a=n,this.onMessage=H}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$BU=k}),define(be[30],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const k=globalThis.vscode;t.$O=k.ipcRenderer,t.$P=k.ipcMessagePort,t.$Q=k.webFrame,t.$R=k.process,t.$S=k.context}),define(be[91],$e([1,0,89,30]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xU=void 0;let n=0;function H(S,m,w){const D=[],M=n++,r=`vscode:onContextMenu${M}`,l=(e,s,g)=>{D[s].click?.(g)};T.$O.once(r,l),T.$O.once(k.$uU,(e,s)=>{s===M&&(T.$O.removeListener(r,l),w?.())}),T.$O.send(k.$tU,M,S.map(e=>A(e,D)),r,m)}t.$xU=H;function A(S,m){const w={id:m.length,label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:typeof S.enabled=="boolean"?S.enabled:!0,visible:typeof S.visible=="boolean"?S.visible:!0};return m.push(S),Array.isArray(S.submenu)&&(w.submenu=S.submenu.map(D=>A(D,m))),w}}),define(be[52],$e([8]),{}),define(be[92],$e([8]),{}),define(be[93],$e([8]),{}),define(be[94],$e([8]),{}),define(be[95],$e([1,0,93,94]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([8]),{}),define(be[100],$e([8]),{}),define(be[101],$e([8]),{}),define(be[102],$e([8]),{}),define(be[103],$e([8]),{}),define(be[104],$e([8]),{}),define(be[105],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[106],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[107],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[108],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[109],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[110],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[111],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[112],$e([13,11]),function(ie,t){return ie.create("vs/base/common/actions",t)}),define(be[36],$e([1,0,4,2,112]),function(ie,t,k,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pi=t.$Oi=t.$Ni=t.$Mi=t.$Li=t.$Ki=void 0;class H extends T.$Tc{constructor(r,l="",e="",s=!0,g){super(),this.h=this.B(new k.$Vd),this.onDidChange=this.h.event,this.w=!0,this.j=r,this.m=l,this.u=e,this.w=s,this.C=g}get id(){return this.j}get label(){return this.m}set label(r){this.D(r)}D(r){this.m!==r&&(this.m=r,this.h.fire({label:r}))}get tooltip(){return this.n||""}set tooltip(r){this.F(r)}F(r){this.n!==r&&(this.n=r,this.h.fire({tooltip:r}))}get class(){return this.u}set class(r){this.G(r)}G(r){this.u!==r&&(this.u=r,this.h.fire({class:r}))}get enabled(){return this.w}set enabled(r){this.H(r)}H(r){this.w!==r&&(this.w=r,this.h.fire({enabled:r}))}get checked(){return this.z}set checked(r){this.I(r)}I(r){this.z!==r&&(this.z=r,this.h.fire({checked:r}))}async run(r,l){this.C&&await this.C(r)}}t.$Ki=H;class A extends T.$Tc{constructor(){super(...arguments),this.f=this.B(new k.$Vd),this.onWillRun=this.f.event,this.m=this.B(new k.$Vd),this.onDidRun=this.m.event}async run(r,l){if(!r.enabled)return;this.f.fire({action:r});let e;try{await this.u(r,l)}catch(s){e=s}this.m.fire({action:r,error:e})}async u(r,l){await r.run(l)}}t.$Li=A;class S{constructor(){this.id=S.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let l=[];for(const e of r)e.length&&(l.length?l=[...l,new S,...e]:l=e);return l}static{this.ID="vs.actions.separator"}async run(){}}t.$Mi=S;class m{get actions(){return this.a}constructor(r,l,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=l,this.class=s,this.a=e}async run(){}}t.$Ni=m;class w extends H{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,n.localize(0,null),void 0,!1)}}t.$Oi=w;function D(M){return{id:M.id,label:M.label,class:M.class,enabled:M.enabled??!0,checked:M.checked??!1,run:async(...r)=>M.run(...r),tooltip:M.label}}t.$Pi=D}),define(be[113],$e([13,11]),function(ie,t){return ie.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,113]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let T=!1,n=!1,H=!1,A=!1,S=!1,m=!1,w=!1,D=!1,M=!1,r=!1,l,e=t.$g,s=t.$g,g,b;const h=globalThis;let $;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?$=h.vscode.process:typeof process<"u"&&($=process);const c=typeof $?.versions?.electron=="string",f=c&&$?.type==="renderer";if(typeof $=="object"){T=$.platform==="win32",n=$.platform==="darwin",H=$.platform==="linux",A=H&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,w=c,M=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=t.$g,e=t.$g;const N=$.env.VSCODE_NLS_CONFIG;if(N)try{const I=JSON.parse(N),z=I.availableLanguages["*"];l=I.locale,s=I.osLocale,e=z||t.$g,g=I._translationsConfigFile}catch{}S=!0}else typeof navigator=="object"&&!f?(b=navigator.userAgent,T=b.indexOf("Windows")>=0,n=b.indexOf("Macintosh")>=0,D=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=b.indexOf("Linux")>=0,r=b?.indexOf("Mobi")>=0,m=!0,l=k.getConfiguredDefaultLocale(k.localize(0,null))||t.$g,e=l,s=navigator.language):console.error("Unable to resolve platform.");var a;(function(N){N[N.Web=0]="Web",N[N.Mac=1]="Mac",N[N.Linux=2]="Linux",N[N.Windows=3]="Windows"})(a||(t.Platform=a={}));function C(N){switch(N){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=C;let O=0;n?O=1:T?O=3:H&&(O=2),t.$i=T,t.$j=n,t.$k=H,t.$l=A,t.$m=S,t.$n=w,t.$o=m,t.$p=m&&typeof h.importScripts=="function",t.$q=t.$p?h.origin:void 0,t.$r=D,t.$s=r,t.$t=M,t.$u=O,t.$v=b,t.$w=e;var L;(function(N){function I(){return t.$w}N.value=I;function z(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}N.isDefaultVariant=z;function X(){return t.$w==="en"}N.isDefault=X})(L||(t.Language=L={})),t.$x=l,t.$y=s,t.$z=g,t.$A=typeof h.postMessage=="function"&&!h.importScripts,t.$B=(()=>{if(t.$A){const N=[];h.addEventListener("message",z=>{if(z.data&&z.data.vscodeScheduleAsyncWork)for(let X=0,Y=N.length;X<Y;X++){const fe=N[X];if(fe.id===z.data.vscodeScheduleAsyncWork){N.splice(X,1),fe.callback();return}}});let I=0;return z=>{const X=++I;N.push({id:X,callback:z}),h.postMessage({vscodeScheduleAsyncWork:X},"*")}}return N=>setTimeout(N)})();var B;(function(N){N[N.Windows=1]="Windows",N[N.Macintosh=2]="Macintosh",N[N.Linux=3]="Linux"})(B||(t.OperatingSystem=B={})),t.OS=n||D?2:T?1:3;let v=!0,P=!1;function V(){if(!P){P=!0;const N=new Uint8Array(2);N[0]=1,N[1]=2,v=new Uint16Array(N.buffer)[0]===(2<<8)+1}return v}t.$D=V,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function U(N){return parseFloat(N)>=20}t.$J=U}),define(be[114],$e([1,0,16,21,5]),function(ie,t,k,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uP=t.KeyboardSupport=void 0;var H;(function(A){A[A.Always=0]="Always",A[A.FullScreen=1]="FullScreen",A[A.None=2]="None"})(H||(t.KeyboardSupport=H={})),t.$uP={clipboard:{writeText:n.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:n.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>n.$m||k.$sP()?0:navigator.keyboard||k.$oP?1:2)(),touch:"ontouchstart"in T.$0O||navigator.maxTouchPoints>0,pointerEvents:T.$0O.PointerEvent&&("ontouchstart"in T.$0O||navigator.maxTouchPoints>0)}}),define(be[14],$e([1,0,16,44,78,5]),function(ie,t,k,T,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CP=t.$BP=t.$AP=void 0;function A(e){if(e.charCode){const g=String.fromCharCode(e.charCode).toUpperCase();return T.KeyCodeUtils.fromString(g)}const s=e.keyCode;if(s===3)return 7;if(k.$lP)switch(s){case 59:return 85;case 60:if(H.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(H.$j)return 57;break}else if(k.$mP){if(H.$j&&s===93)return 57;if(!H.$j&&s===92)return 57}return T.$2q[s]||0}const S=H.$j?256:2048,m=512,w=1024,D=H.$j?2048:256;function M(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$AP=M;function r(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${T.KeyCodeUtils.toString(e.keyCode)}')`}t.$BP=r;class l{constructor(s){this._standardKeyboardEventBrand=!0;const g=s;this.browserEvent=g,this.target=g.target,this.ctrlKey=g.ctrlKey,this.shiftKey=g.shiftKey,this.altKey=g.altKey,this.metaKey=g.metaKey,this.altGraphKey=g.getModifierState("AltGraph"),this.keyCode=A(g),this.code=g.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let g=0;return this.ctrlKey&&(g|=S),this.altKey&&(g|=m),this.shiftKey&&(g|=w),this.metaKey&&(g|=D),g|=s,g}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new n.$0q(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$CP=l}),define(be[19],$e([1,0,16,69,5]),function(ie,t,k,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zP=t.$yP=t.$xP=void 0;class H{constructor(w,D){this.timestamp=Date.now(),this.browserEvent=D,this.leftButton=D.button===0,this.middleButton=D.button===1,this.rightButton=D.button===2,this.buttons=D.buttons,this.target=D.target,this.detail=D.detail||1,D.type==="dblclick"&&(this.detail=2),this.ctrlKey=D.ctrlKey,this.shiftKey=D.shiftKey,this.altKey=D.altKey,this.metaKey=D.metaKey,typeof D.pageX=="number"?(this.posx=D.pageX,this.posy=D.pageY):(this.posx=D.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=D.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const M=T.$vP.getPositionOfChildWindowRelativeToAncestorWindow(w,D.view);this.posx-=M.left,this.posy-=M.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$xP=H;class A extends H{constructor(w,D){super(w,D),this.dataTransfer=D.dataTransfer}}t.$yP=A;class S{constructor(w,D=0,M=0){if(this.browserEvent=w||null,this.target=w?w.target||w.targetNode||w.srcElement:null,this.deltaY=M,this.deltaX=D,w){const r=w,l=w,e=w.view?.devicePixelRatio||1;if(typeof r.wheelDeltaY<"u")k.$nP?this.deltaY=r.wheelDeltaY/(120*e):this.deltaY=r.wheelDeltaY/120;else if(typeof l.VERTICAL_AXIS<"u"&&l.axis===l.VERTICAL_AXIS)this.deltaY=-l.detail/3;else if(w.type==="wheel"){const s=w;s.deltaMode===s.DOM_DELTA_LINE?k.$lP&&!n.$j?this.deltaY=-w.deltaY/3:this.deltaY=-w.deltaY:this.deltaY=-w.deltaY/40}if(typeof r.wheelDeltaX<"u")k.$oP&&n.$i?this.deltaX=-(r.wheelDeltaX/120):k.$nP?this.deltaX=r.wheelDeltaX/(120*e):this.deltaX=r.wheelDeltaX/120;else if(typeof l.HORIZONTAL_AXIS<"u"&&l.axis===l.HORIZONTAL_AXIS)this.deltaX=-w.detail/3;else if(w.type==="wheel"){const s=w;s.deltaMode===s.DOM_DELTA_LINE?k.$lP&&!n.$j?this.deltaX=-w.deltaX/3:this.deltaX=-w.deltaX:this.deltaX=-w.deltaX/40}this.deltaY===0&&this.deltaX===0&&w.wheelDelta&&(k.$nP?this.deltaY=w.wheelDelta/(120*e):this.deltaY=w.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$zP=S}),define(be[115],$e([1,0,5]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let T;const n=globalThis.vscode;if(typeof n<"u"&&typeof n.process<"u"){const H=n.process;T={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return k.$i?"win32":k.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=T.cwd,t.env=T.env,t.$dc=T.platform,t.$ec=T.arch}),define(be[24],$e([1,0,115]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const T=65,n=97,H=90,A=122,S=46,m=47,w=92,D=58,M=63;class r extends Error{constructor(C,O,L){let B;typeof O=="string"&&O.indexOf("not ")===0?(B="must not be",O=O.replace(/^not /,"")):B="must be";const v=C.indexOf(".")!==-1?"property":"argument";let P=`The "${C}" ${v} ${B} of type ${O}`;P+=`. Received type ${typeof L}`,super(P),this.code="ERR_INVALID_ARG_TYPE"}}function l(a,C){if(a===null||typeof a!="object")throw new r(C,"Object",a)}function e(a,C){if(typeof a!="string")throw new r(C,"string",a)}const s=k.$dc==="win32";function g(a){return a===m||a===w}function b(a){return a===m}function h(a){return a>=T&&a<=H||a>=n&&a<=A}function $(a,C,O,L){let B="",v=0,P=-1,V=0,U=0;for(let N=0;N<=a.length;++N){if(N<a.length)U=a.charCodeAt(N);else{if(L(U))break;U=m}if(L(U)){if(!(P===N-1||V===1))if(V===2){if(B.length<2||v!==2||B.charCodeAt(B.length-1)!==S||B.charCodeAt(B.length-2)!==S){if(B.length>2){const I=B.lastIndexOf(O);I===-1?(B="",v=0):(B=B.slice(0,I),v=B.length-1-B.lastIndexOf(O)),P=N,V=0;continue}else if(B.length!==0){B="",v=0,P=N,V=0;continue}}C&&(B+=B.length>0?`${O}..`:"..",v=2)}else B.length>0?B+=`${O}${a.slice(P+1,N)}`:B=a.slice(P+1,N),v=N-P-1;P=N,V=0}else U===S&&V!==-1?++V:V=-1}return B}function c(a,C){l(C,"pathObject");const O=C.dir||C.root,L=C.base||`${C.name||""}${C.ext||""}`;return O?O===C.root?`${O}${L}`:`${O}${a}${L}`:L}t.$fc={resolve(...a){let C="",O="",L=!1;for(let B=a.length-1;B>=-1;B--){let v;if(B>=0){if(v=a[B],e(v,"path"),v.length===0)continue}else C.length===0?v=k.cwd():(v=k.env[`=${C}`]||k.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==C.toLowerCase()&&v.charCodeAt(2)===w)&&(v=`${C}\\`));const P=v.length;let V=0,U="",N=!1;const I=v.charCodeAt(0);if(P===1)g(I)&&(V=1,N=!0);else if(g(I))if(N=!0,g(v.charCodeAt(1))){let z=2,X=z;for(;z<P&&!g(v.charCodeAt(z));)z++;if(z<P&&z!==X){const Y=v.slice(X,z);for(X=z;z<P&&g(v.charCodeAt(z));)z++;if(z<P&&z!==X){for(X=z;z<P&&!g(v.charCodeAt(z));)z++;(z===P||z!==X)&&(U=`\\\\${Y}\\${v.slice(X,z)}`,V=z)}}}else V=1;else h(I)&&v.charCodeAt(1)===D&&(U=v.slice(0,2),V=2,P>2&&g(v.charCodeAt(2))&&(N=!0,V=3));if(U.length>0)if(C.length>0){if(U.toLowerCase()!==C.toLowerCase())continue}else C=U;if(L){if(C.length>0)break}else if(O=`${v.slice(V)}\\${O}`,L=N,N&&C.length>0)break}return O=$(O,!L,"\\",g),L?`${C}\\${O}`:`${C}${O}`||"."},normalize(a){e(a,"path");const C=a.length;if(C===0)return".";let O=0,L,B=!1;const v=a.charCodeAt(0);if(C===1)return b(v)?"\\":a;if(g(v))if(B=!0,g(a.charCodeAt(1))){let V=2,U=V;for(;V<C&&!g(a.charCodeAt(V));)V++;if(V<C&&V!==U){const N=a.slice(U,V);for(U=V;V<C&&g(a.charCodeAt(V));)V++;if(V<C&&V!==U){for(U=V;V<C&&!g(a.charCodeAt(V));)V++;if(V===C)return`\\\\${N}\\${a.slice(U)}\\`;V!==U&&(L=`\\\\${N}\\${a.slice(U,V)}`,O=V)}}}else O=1;else h(v)&&a.charCodeAt(1)===D&&(L=a.slice(0,2),O=2,C>2&&g(a.charCodeAt(2))&&(B=!0,O=3));let P=O<C?$(a.slice(O),!B,"\\",g):"";return P.length===0&&!B&&(P="."),P.length>0&&g(a.charCodeAt(C-1))&&(P+="\\"),L===void 0?B?`\\${P}`:P:B?`${L}\\${P}`:`${L}${P}`},isAbsolute(a){e(a,"path");const C=a.length;if(C===0)return!1;const O=a.charCodeAt(0);return g(O)||C>2&&h(O)&&a.charCodeAt(1)===D&&g(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let C,O;for(let v=0;v<a.length;++v){const P=a[v];e(P,"path"),P.length>0&&(C===void 0?C=O=P:C+=`\\${P}`)}if(C===void 0)return".";let L=!0,B=0;if(typeof O=="string"&&g(O.charCodeAt(0))){++B;const v=O.length;v>1&&g(O.charCodeAt(1))&&(++B,v>2&&(g(O.charCodeAt(2))?++B:L=!1))}if(L){for(;B<C.length&&g(C.charCodeAt(B));)B++;B>=2&&(C=`\\${C.slice(B)}`)}return t.$fc.normalize(C)},relative(a,C){if(e(a,"from"),e(C,"to"),a===C)return"";const O=t.$fc.resolve(a),L=t.$fc.resolve(C);if(O===L||(a=O.toLowerCase(),C=L.toLowerCase(),a===C))return"";let B=0;for(;B<a.length&&a.charCodeAt(B)===w;)B++;let v=a.length;for(;v-1>B&&a.charCodeAt(v-1)===w;)v--;const P=v-B;let V=0;for(;V<C.length&&C.charCodeAt(V)===w;)V++;let U=C.length;for(;U-1>V&&C.charCodeAt(U-1)===w;)U--;const N=U-V,I=P<N?P:N;let z=-1,X=0;for(;X<I;X++){const fe=a.charCodeAt(B+X);if(fe!==C.charCodeAt(V+X))break;fe===w&&(z=X)}if(X!==I){if(z===-1)return L}else{if(N>I){if(C.charCodeAt(V+X)===w)return L.slice(V+X+1);if(X===2)return L.slice(V+X)}P>I&&(a.charCodeAt(B+X)===w?z=X:X===2&&(z=3)),z===-1&&(z=0)}let Y="";for(X=B+z+1;X<=v;++X)(X===v||a.charCodeAt(X)===w)&&(Y+=Y.length===0?"..":"\\..");return V+=z,Y.length>0?`${Y}${L.slice(V,U)}`:(L.charCodeAt(V)===w&&++V,L.slice(V,U))},toNamespacedPath(a){if(typeof a!="string"||a.length===0)return a;const C=t.$fc.resolve(a);if(C.length<=2)return a;if(C.charCodeAt(0)===w){if(C.charCodeAt(1)===w){const O=C.charCodeAt(2);if(O!==M&&O!==S)return`\\\\?\\UNC\\${C.slice(2)}`}}else if(h(C.charCodeAt(0))&&C.charCodeAt(1)===D&&C.charCodeAt(2)===w)return`\\\\?\\${C}`;return a},dirname(a){e(a,"path");const C=a.length;if(C===0)return".";let O=-1,L=0;const B=a.charCodeAt(0);if(C===1)return g(B)?a:".";if(g(B)){if(O=L=1,g(a.charCodeAt(1))){let V=2,U=V;for(;V<C&&!g(a.charCodeAt(V));)V++;if(V<C&&V!==U){for(U=V;V<C&&g(a.charCodeAt(V));)V++;if(V<C&&V!==U){for(U=V;V<C&&!g(a.charCodeAt(V));)V++;if(V===C)return a;V!==U&&(O=L=V+1)}}}}else h(B)&&a.charCodeAt(1)===D&&(O=C>2&&g(a.charCodeAt(2))?3:2,L=O);let v=-1,P=!0;for(let V=C-1;V>=L;--V)if(g(a.charCodeAt(V))){if(!P){v=V;break}}else P=!1;if(v===-1){if(O===-1)return".";v=O}return a.slice(0,v)},basename(a,C){C!==void 0&&e(C,"ext"),e(a,"path");let O=0,L=-1,B=!0,v;if(a.length>=2&&h(a.charCodeAt(0))&&a.charCodeAt(1)===D&&(O=2),C!==void 0&&C.length>0&&C.length<=a.length){if(C===a)return"";let P=C.length-1,V=-1;for(v=a.length-1;v>=O;--v){const U=a.charCodeAt(v);if(g(U)){if(!B){O=v+1;break}}else V===-1&&(B=!1,V=v+1),P>=0&&(U===C.charCodeAt(P)?--P===-1&&(L=v):(P=-1,L=V))}return O===L?L=V:L===-1&&(L=a.length),a.slice(O,L)}for(v=a.length-1;v>=O;--v)if(g(a.charCodeAt(v))){if(!B){O=v+1;break}}else L===-1&&(B=!1,L=v+1);return L===-1?"":a.slice(O,L)},extname(a){e(a,"path");let C=0,O=-1,L=0,B=-1,v=!0,P=0;a.length>=2&&a.charCodeAt(1)===D&&h(a.charCodeAt(0))&&(C=L=2);for(let V=a.length-1;V>=C;--V){const U=a.charCodeAt(V);if(g(U)){if(!v){L=V+1;break}continue}B===-1&&(v=!1,B=V+1),U===S?O===-1?O=V:P!==1&&(P=1):O!==-1&&(P=-1)}return O===-1||B===-1||P===0||P===1&&O===B-1&&O===L+1?"":a.slice(O,B)},format:c.bind(null,"\\"),parse(a){e(a,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return C;const O=a.length;let L=0,B=a.charCodeAt(0);if(O===1)return g(B)?(C.root=C.dir=a,C):(C.base=C.name=a,C);if(g(B)){if(L=1,g(a.charCodeAt(1))){let z=2,X=z;for(;z<O&&!g(a.charCodeAt(z));)z++;if(z<O&&z!==X){for(X=z;z<O&&g(a.charCodeAt(z));)z++;if(z<O&&z!==X){for(X=z;z<O&&!g(a.charCodeAt(z));)z++;z===O?L=z:z!==X&&(L=z+1)}}}}else if(h(B)&&a.charCodeAt(1)===D){if(O<=2)return C.root=C.dir=a,C;if(L=2,g(a.charCodeAt(2))){if(O===3)return C.root=C.dir=a,C;L=3}}L>0&&(C.root=a.slice(0,L));let v=-1,P=L,V=-1,U=!0,N=a.length-1,I=0;for(;N>=L;--N){if(B=a.charCodeAt(N),g(B)){if(!U){P=N+1;break}continue}V===-1&&(U=!1,V=N+1),B===S?v===-1?v=N:I!==1&&(I=1):v!==-1&&(I=-1)}return V!==-1&&(v===-1||I===0||I===1&&v===V-1&&v===P+1?C.base=C.name=a.slice(P,V):(C.name=a.slice(P,v),C.base=a.slice(P,V),C.ext=a.slice(v,V))),P>0&&P!==L?C.dir=a.slice(0,P-1):C.dir=C.root,C},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(s){const a=/\\/g;return()=>{const C=k.cwd().replace(a,"/");return C.slice(C.indexOf("/"))}}return()=>k.cwd()})();t.$gc={resolve(...a){let C="",O=!1;for(let L=a.length-1;L>=-1&&!O;L--){const B=L>=0?a[L]:f();e(B,"path"),B.length!==0&&(C=`${B}/${C}`,O=B.charCodeAt(0)===m)}return C=$(C,!O,"/",b),O?`/${C}`:C.length>0?C:"."},normalize(a){if(e(a,"path"),a.length===0)return".";const C=a.charCodeAt(0)===m,O=a.charCodeAt(a.length-1)===m;return a=$(a,!C,"/",b),a.length===0?C?"/":O?"./":".":(O&&(a+="/"),C?`/${a}`:a)},isAbsolute(a){return e(a,"path"),a.length>0&&a.charCodeAt(0)===m},join(...a){if(a.length===0)return".";let C;for(let O=0;O<a.length;++O){const L=a[O];e(L,"path"),L.length>0&&(C===void 0?C=L:C+=`/${L}`)}return C===void 0?".":t.$gc.normalize(C)},relative(a,C){if(e(a,"from"),e(C,"to"),a===C||(a=t.$gc.resolve(a),C=t.$gc.resolve(C),a===C))return"";const O=1,L=a.length,B=L-O,v=1,P=C.length-v,V=B<P?B:P;let U=-1,N=0;for(;N<V;N++){const z=a.charCodeAt(O+N);if(z!==C.charCodeAt(v+N))break;z===m&&(U=N)}if(N===V)if(P>V){if(C.charCodeAt(v+N)===m)return C.slice(v+N+1);if(N===0)return C.slice(v+N)}else B>V&&(a.charCodeAt(O+N)===m?U=N:N===0&&(U=0));let I="";for(N=O+U+1;N<=L;++N)(N===L||a.charCodeAt(N)===m)&&(I+=I.length===0?"..":"/..");return`${I}${C.slice(v+U)}`},toNamespacedPath(a){return a},dirname(a){if(e(a,"path"),a.length===0)return".";const C=a.charCodeAt(0)===m;let O=-1,L=!0;for(let B=a.length-1;B>=1;--B)if(a.charCodeAt(B)===m){if(!L){O=B;break}}else L=!1;return O===-1?C?"/":".":C&&O===1?"//":a.slice(0,O)},basename(a,C){C!==void 0&&e(C,"ext"),e(a,"path");let O=0,L=-1,B=!0,v;if(C!==void 0&&C.length>0&&C.length<=a.length){if(C===a)return"";let P=C.length-1,V=-1;for(v=a.length-1;v>=0;--v){const U=a.charCodeAt(v);if(U===m){if(!B){O=v+1;break}}else V===-1&&(B=!1,V=v+1),P>=0&&(U===C.charCodeAt(P)?--P===-1&&(L=v):(P=-1,L=V))}return O===L?L=V:L===-1&&(L=a.length),a.slice(O,L)}for(v=a.length-1;v>=0;--v)if(a.charCodeAt(v)===m){if(!B){O=v+1;break}}else L===-1&&(B=!1,L=v+1);return L===-1?"":a.slice(O,L)},extname(a){e(a,"path");let C=-1,O=0,L=-1,B=!0,v=0;for(let P=a.length-1;P>=0;--P){const V=a.charCodeAt(P);if(V===m){if(!B){O=P+1;break}continue}L===-1&&(B=!1,L=P+1),V===S?C===-1?C=P:v!==1&&(v=1):C!==-1&&(v=-1)}return C===-1||L===-1||v===0||v===1&&C===L-1&&C===O+1?"":a.slice(C,L)},format:c.bind(null,"/"),parse(a){e(a,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return C;const O=a.charCodeAt(0)===m;let L;O?(C.root="/",L=1):L=0;let B=-1,v=0,P=-1,V=!0,U=a.length-1,N=0;for(;U>=L;--U){const I=a.charCodeAt(U);if(I===m){if(!V){v=U+1;break}continue}P===-1&&(V=!1,P=U+1),I===S?B===-1?B=U:N!==1&&(N=1):B!==-1&&(N=-1)}if(P!==-1){const I=v===0&&O?1:v;B===-1||N===0||N===1&&B===P-1&&B===v+1?C.base=C.name=a.slice(I,P):(C.name=a.slice(I,B),C.base=a.slice(I,P),C.ext=a.slice(B,P))}return v>0?C.dir=a.slice(0,v-1):O&&(C.dir="/"),C},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=s?t.$fc.normalize:t.$gc.normalize,t.$ic=s?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=s?t.$fc.join:t.$gc.join,t.$kc=s?t.$fc.resolve:t.$gc.resolve,t.$lc=s?t.$fc.relative:t.$gc.relative,t.$mc=s?t.$fc.dirname:t.$gc.dirname,t.$nc=s?t.$fc.basename:t.$gc.basename,t.$oc=s?t.$fc.extname:t.$gc.extname,t.$pc=s?t.$fc.format:t.$gc.format,t.$qc=s?t.$fc.parse:t.$gc.parse,t.$rc=s?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=s?t.$fc.sep:t.$gc.sep,t.$tc=s?t.$fc.delimiter:t.$gc.delimiter}),define(be[116],$e([1,0,24,5,10,7]),function(ie,t,k,T,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=void 0;function A(v){return v===47||v===92}t.$1f=A;function S(v){return v.replace(/[\\/]/g,k.$gc.sep)}t.$2f=S;function m(v){return v.indexOf("/")===-1&&(v=S(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}t.$3f=m;function w(v,P=k.$gc.sep){if(!v)return"";const V=v.length,U=v.charCodeAt(0);if(A(U)){if(A(v.charCodeAt(1))&&!A(v.charCodeAt(2))){let I=3;const z=I;for(;I<V&&!A(v.charCodeAt(I));I++);if(z!==I&&!A(v.charCodeAt(I+1))){for(I+=1;I<V;I++)if(A(v.charCodeAt(I)))return v.slice(0,I+1).replace(/[\\/]/g,P)}}return P}else if(b(U)&&v.charCodeAt(1)===58)return A(v.charCodeAt(2))?v.slice(0,2)+P:v.slice(0,2);let N=v.indexOf("://");if(N!==-1){for(N+=3;N<V;N++)if(A(v.charCodeAt(N)))return v.slice(0,N+1)}return""}t.$4f=w;function D(v){if(!T.$i||!v||v.length<5)return!1;let P=v.charCodeAt(0);if(P!==92||(P=v.charCodeAt(1),P!==92))return!1;let V=2;const U=V;for(;V<v.length&&(P=v.charCodeAt(V),P!==92);V++);return!(U===V||(P=v.charCodeAt(V+1),isNaN(P)||P===92))}t.$5f=D;const M=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(v,P=T.$i){const V=P?M:r;return!(!v||v.length===0||/^\s+$/.test(v)||(V.lastIndex=0,V.test(v))||P&&l.test(v)||v==="."||v===".."||P&&v[v.length-1]==="."||P&&v.length!==v.trim().length||v.length>255)}t.$6f=e;function s(v,P,V){const U=v===P;return!V||U?U:!v||!P?!1:(0,n.$_e)(v,P)}t.$7f=s;function g(v,P,V,U=k.sep){if(v===P)return!0;if(!v||!P||P.length>v.length)return!1;if(V){if(!(0,n.$af)(v,P))return!1;if(P.length===v.length)return!0;let I=P.length;return P.charAt(P.length-1)===U&&I--,v.charAt(I)===U}return P.charAt(P.length-1)!==U&&(P+=U),v.indexOf(P)===0}t.$8f=g;function b(v){return v>=65&&v<=90||v>=97&&v<=122}t.$9f=b;function h(v,P){return T.$i&&v.endsWith(":")&&(v+=k.sep),(0,k.$ic)(v)||(v=(0,k.$jc)(P,v)),v=(0,k.$hc)(v),T.$i?(v=(0,n.$Ue)(v,k.sep),v.endsWith(":")&&(v+=k.sep)):(v=(0,n.$Ue)(v,k.sep),v||(v=k.sep)),v}t.$0f=h;function $(v){const P=(0,k.$hc)(v);return T.$i?v.length>3?!1:c(P)&&(v.length===2||P.charCodeAt(2)===92):P===k.$gc.sep}t.$$f=$;function c(v,P=T.$i){return P?b(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}t.$_f=c;function f(v,P=T.$i){return c(v,P)?v[0]:void 0}t.$ag=f;function a(v,P,V){return P.length>v.length?-1:v===P?0:(V&&(v=v.toLowerCase(),P=P.toLowerCase()),v.indexOf(P))}t.$bg=a;function C(v){const P=v.split(":");let V,U,N;for(const I of P){const z=Number(I);(0,H.$Mf)(z)?U===void 0?U=z:N===void 0&&(N=z):V=V?[V,I].join(":"):I}if(!V)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:V,line:U!==void 0?U:void 0,column:N!==void 0?N:U!==void 0?1:void 0}}t.$cg=C;const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function B(v,P,V=8){let U="";for(let I=0;I<V;I++){let z;I===0&&T.$i&&!P&&(V===3||V===4)?z=L:z=O,U+=z.charAt(Math.floor(Math.random()*z.length))}let N;return P?N=`${P}-${U}`:N=U,v?(0,k.$jc)(v,N):N}t.$dg=B}),define(be[117],$e([1,0,24]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$js=t.$is=t.$hs=t.$gs=t.$fs=void 0,t.$fs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},n={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(D){const M=(0,k.$oc)(D),r=T[M.toLowerCase()];return r!==void 0?r:A(D)}t.$gs=H;function A(D){const M=(0,k.$oc)(D);return n[M.toLowerCase()]}t.$hs=A;function S(D){for(const M in n)if(n[M]===D)return M}t.$is=S;const m=/^(.+)\/(.+?)(;.+)?$/;function w(D,M){const r=m.exec(D);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:M?void 0:D}t.$js=w}),define(be[15],$e([1,0,24,5]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const n=/^\w[\w\d+.-]*$/,H=/^\//,A=/^\/\//;function S(L,B){if(!L.scheme&&B)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!n.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!H.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(L,B){return!L&&!B?"file":L}function w(L,B){switch(L){case"https":case"http":case"file":B?B[0]!==M&&(B=M+B):B=M;break}return B}const D="",M="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(B){return B instanceof l?!0:B?typeof B.authority=="string"&&typeof B.fragment=="string"&&typeof B.path=="string"&&typeof B.query=="string"&&typeof B.scheme=="string"&&typeof B.fsPath=="string"&&typeof B.with=="function"&&typeof B.toString=="function":!1}constructor(B,v,P,V,U,N=!1){typeof B=="object"?(this.scheme=B.scheme||D,this.authority=B.authority||D,this.path=B.path||D,this.query=B.query||D,this.fragment=B.fragment||D):(this.scheme=m(B,N),this.authority=v||D,this.path=w(this.scheme,P||D),this.query=V||D,this.fragment=U||D,S(this,N))}get fsPath(){return c(this,!1)}with(B){if(!B)return this;let{scheme:v,authority:P,path:V,query:U,fragment:N}=B;return v===void 0?v=this.scheme:v===null&&(v=D),P===void 0?P=this.authority:P===null&&(P=D),V===void 0?V=this.path:V===null&&(V=D),U===void 0?U=this.query:U===null&&(U=D),N===void 0?N=this.fragment:N===null&&(N=D),v===this.scheme&&P===this.authority&&V===this.path&&U===this.query&&N===this.fragment?this:new g(v,P,V,U,N)}static parse(B,v=!1){const P=r.exec(B);return P?new g(P[2]||D,O(P[4]||D),O(P[5]||D),O(P[7]||D),O(P[9]||D),v):new g(D,D,D,D,D)}static file(B){let v=D;if(T.$i&&(B=B.replace(/\\/g,M)),B[0]===M&&B[1]===M){const P=B.indexOf(M,2);P===-1?(v=B.substring(2),B=M):(v=B.substring(2,P),B=B.substring(P)||M)}return new g("file",v,B,D,D)}static from(B,v){return new g(B.scheme,B.authority,B.path,B.query,B.fragment,v)}static joinPath(B,...v){if(!B.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let P;return T.$i&&B.scheme==="file"?P=l.file(k.$fc.join(c(B,!0),...v)).path:P=k.$gc.join(B.path,...v),B.with({path:P})}toString(B=!1){return f(this,B)}toJSON(){return this}static revive(B){if(B){if(B instanceof l)return B;{const v=new g(B);return v._formatted=B.external??null,v._fsPath=B._sep===s?B.fsPath??null:null,v}}else return B}}t.URI=l;function e(L){return!L||typeof L!="object"?!1:typeof L.scheme=="string"&&(typeof L.authority=="string"||typeof L.authority>"u")&&(typeof L.path=="string"||typeof L.path>"u")&&(typeof L.query=="string"||typeof L.query>"u")&&(typeof L.fragment=="string"||typeof L.fragment>"u")}t.$vc=e;const s=T.$i?1:void 0;class g extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(B=!1){return B?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const B={$mid:1};return this._fsPath&&(B.fsPath=this._fsPath,B._sep=s),this._formatted&&(B.external=this._formatted),this.path&&(B.path=this.path),this.scheme&&(B.scheme=this.scheme),this.authority&&(B.authority=this.authority),this.query&&(B.query=this.query),this.fragment&&(B.fragment=this.fragment),B}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(L,B,v){let P,V=-1;for(let U=0;U<L.length;U++){const N=L.charCodeAt(U);if(N>=97&&N<=122||N>=65&&N<=90||N>=48&&N<=57||N===45||N===46||N===95||N===126||B&&N===47||v&&N===91||v&&N===93||v&&N===58)V!==-1&&(P+=encodeURIComponent(L.substring(V,U)),V=-1),P!==void 0&&(P+=L.charAt(U));else{P===void 0&&(P=L.substr(0,U));const I=b[N];I!==void 0?(V!==-1&&(P+=encodeURIComponent(L.substring(V,U)),V=-1),P+=I):V===-1&&(V=U)}}return V!==-1&&(P+=encodeURIComponent(L.substring(V))),P!==void 0?P:L}function $(L){let B;for(let v=0;v<L.length;v++){const P=L.charCodeAt(v);P===35||P===63?(B===void 0&&(B=L.substr(0,v)),B+=b[P]):B!==void 0&&(B+=L[v])}return B!==void 0?B:L}function c(L,B){let v;return L.authority&&L.path.length>1&&L.scheme==="file"?v=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?B?v=L.path.substr(1):v=L.path[1].toLowerCase()+L.path.substr(2):v=L.path,T.$i&&(v=v.replace(/\//g,"\\")),v}t.$wc=c;function f(L,B){const v=B?$:h;let P="",{scheme:V,authority:U,path:N,query:I,fragment:z}=L;if(V&&(P+=V,P+=":"),(U||V==="file")&&(P+=M,P+=M),U){let X=U.indexOf("@");if(X!==-1){const Y=U.substr(0,X);U=U.substr(X+1),X=Y.lastIndexOf(":"),X===-1?P+=v(Y,!1,!1):(P+=v(Y.substr(0,X),!1,!1),P+=":",P+=v(Y.substr(X+1),!1,!0)),P+="@"}U=U.toLowerCase(),X=U.lastIndexOf(":"),X===-1?P+=v(U,!1,!0):(P+=v(U.substr(0,X),!1,!0),P+=U.substr(X))}if(N){if(N.length>=3&&N.charCodeAt(0)===47&&N.charCodeAt(2)===58){const X=N.charCodeAt(1);X>=65&&X<=90&&(N=`/${String.fromCharCode(X+32)}:${N.substr(3)}`)}else if(N.length>=2&&N.charCodeAt(1)===58){const X=N.charCodeAt(0);X>=65&&X<=90&&(N=`${String.fromCharCode(X+32)}:${N.substr(2)}`)}P+=v(N,!0,!1)}return I&&(P+="?",P+=v(I,!1,!1)),z&&(P+="#",P+=B?z:h(z,!1,!1)),P}function a(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+a(L.substr(3)):L}}const C=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function O(L){return L.match(C)?L.replace(C,B=>a(B)):L}}),define(be[53],$e([1,0,33,15]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ch=t.$Bh=t.$Ah=void 0;function n(m){return JSON.stringify(m,A)}t.$Ah=n;function H(m){let w=JSON.parse(m);return w=S(w),w}t.$Bh=H;function A(m,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function S(m,w=0){if(!m||w>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return T.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof k.$je||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let D=0;D<m.length;++D)m[D]=S(m[D],w+1);else for(const D in m)Object.hasOwnProperty.call(m,D)&&(m[D]=S(m[D],w+1))}return m}t.$Ch=S}),define(be[31],$e([1,0,6,5,10,15]),function(ie,t,k,T,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=t.$gg=t.$fg=t.$eg=t.Schemas=void 0;var A;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(A||(t.Schemas=A={}));function S(r,l){return H.URI.isUri(r)?(0,n.$_e)(r.scheme,l):(0,n.$af)(r,l+":")}t.$eg=S;function m(r,...l){return l.some(e=>S(r,e))}t.$fg=m,t.$gg="vscode-tkn",t.$hg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l){this.f=`${l}/${A.vscodeRemoteResource}`}set(l,e,s){this.a[l]=e,this.b[l]=s}setConnectionToken(l,e){this.c[l]=e}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch($){return k.$1($),l}const e=l.authority;let s=this.a[e];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const g=this.b[e],b=this.c[e];let h=`path=${encodeURIComponent(l.path)}`;return typeof b=="string"&&(h+=`&${t.$hg}=${encodeURIComponent(b)}`),H.URI.from({scheme:T.$o?this.d:A.vscodeRemoteResource,authority:`${s}:${g}`,path:this.f,query:h})}}t.$ig=new w,t.$jg="vs/../../extensions",t.$kg="vs/../../node_modules",t.$lg="vs/../../node_modules.asar",t.$mg="vs/../../node_modules.asar.unpacked",t.$ng="vscode-app";class D{static{this.a=t.$ng}asBrowserUri(l){const e=this.b(l,ie);return this.uriToBrowserUri(e)}uriToBrowserUri(l){return l.scheme===A.vscodeRemote?t.$ig.rewrite(l):l.scheme===A.file&&(T.$m||T.$q===`${A.vscodeFileResource}://${D.a}`)?l.with({scheme:A.vscodeFileResource,authority:l.authority||D.a,query:null,fragment:null}):l}asFileUri(l){const e=this.b(l,ie);return this.uriToFileUri(e)}uriToFileUri(l){return l.scheme===A.vscodeFileResource?l.with({scheme:A.file,authority:l.authority!==D.a?l.authority:null,query:null,fragment:null}):l}b(l,e){return H.URI.isUri(l)?l:H.URI.parse(e.toUrl(l))}}t.$og=new D;var M;(function(r){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(l.get("3"));const e="vscode-coi";function s(b){let h;typeof b=="string"?h=new URL(b).searchParams:b instanceof URL?h=b.searchParams:H.URI.isUri(b)&&(h=new URL(b.toString(!0)).searchParams);const $=h?.get(e);if($)return l.get($)}r.getHeadersFromQuery=s;function g(b,h,$){if(!globalThis.crossOriginIsolated)return;const c=h&&$?"3":$?"2":"1";b instanceof URLSearchParams?b.set(e,c):b[e]=c}r.addSearchParam=g})(M||(t.COI=M={}))}),define(be[37],$e([1,0,116,31,24,5,10,15]),function(ie,t,k,T,n,H,A,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rg=t.DataUri=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=void 0;function m(l){return(0,S.$wc)(l,!0)}t.$vg=m;class w{constructor(e){this.a=e}compare(e,s,g=!1){return e===s?0:(0,A.$5e)(this.getComparisonKey(e,g),this.getComparisonKey(s,g))}isEqual(e,s,g=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,g)===this.getComparisonKey(s,g)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,g=!1){if(e.scheme===s.scheme){if(e.scheme===T.Schemas.file)return k.$8f(m(e),m(s),this.a(e))&&e.query===s.query&&(g||e.fragment===s.fragment);if((0,t.$Mg)(e.authority,s.authority))return k.$8f(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(g||e.fragment===s.fragment)}return!1}joinPath(e,...s){return S.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.$Eg)(e)||e.authority}basename(e){return n.$gc.basename(e.path)}extname(e){return n.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===T.Schemas.file?s=S.URI.file(n.$mc(m(e))).path:(s=n.$gc.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===T.Schemas.file?s=S.URI.file(n.$hc(m(e))).path:s=n.$gc.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.$Mg)(e.authority,s.authority))return;if(e.scheme===T.Schemas.file){const h=n.$lc(m(e),m(s));return H.$i?k.$2f(h):h}let g=e.path||"/";const b=s.path||"/";if(this.a(e)){let h=0;for(const $=Math.min(g.length,b.length);h<$&&!(g.charCodeAt(h)!==b.charCodeAt(h)&&g.charAt(h).toLowerCase()!==b.charAt(h).toLowerCase());h++);g=b.substr(0,h)+g.substr(h)}return n.$gc.relative(g,b)}resolvePath(e,s){if(e.scheme===T.Schemas.file){const g=S.URI.file(n.$kc(m(e),s));return e.with({authority:g.authority,path:g.path})}return s=k.$3f(s),e.with({path:n.$gc.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,A.$_e)(e,s)}hasTrailingPathSeparator(e,s=n.sep){if(e.scheme===T.Schemas.file){const g=m(e);return g.length>k.$4f(g).length&&g[g.length-1]===s}else{const g=e.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=n.sep){return(0,t.$Ng)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=n.sep){let g=!1;if(e.scheme===T.Schemas.file){const b=m(e);g=b!==void 0&&b.length===k.$4f(b).length&&b[b.length-1]===s}else{s="/";const b=e.path;g=b.length===1&&b.charCodeAt(b.length-1)===47}return!g&&!(0,t.$Ng)(e,s)?e.with({path:e.path+"/"}):e}}t.$wg=w,t.$xg=new w(()=>!1),t.$yg=new w(l=>l.scheme===T.Schemas.file?!H.$k:!0),t.$zg=new w(l=>!0),t.$Ag=t.$xg.isEqual.bind(t.$xg),t.$Bg=t.$xg.isEqualOrParent.bind(t.$xg),t.$Cg=t.$xg.getComparisonKey.bind(t.$xg),t.$Dg=t.$xg.basenameOrAuthority.bind(t.$xg),t.$Eg=t.$xg.basename.bind(t.$xg),t.$Fg=t.$xg.extname.bind(t.$xg),t.$Gg=t.$xg.dirname.bind(t.$xg),t.$Hg=t.$xg.joinPath.bind(t.$xg),t.$Ig=t.$xg.normalizePath.bind(t.$xg),t.$Jg=t.$xg.relativePath.bind(t.$xg),t.$Kg=t.$xg.resolvePath.bind(t.$xg),t.$Lg=t.$xg.isAbsolutePath.bind(t.$xg),t.$Mg=t.$xg.isEqualAuthority.bind(t.$xg),t.$Ng=t.$xg.hasTrailingPathSeparator.bind(t.$xg),t.$Og=t.$xg.removeTrailingPathSeparator.bind(t.$xg),t.$Pg=t.$xg.addTrailingPathSeparator.bind(t.$xg);function D(l,e){const s=[];for(let g=0;g<l.length;g++){const b=e(l[g]);l.some((h,$)=>$===g?!1:(0,t.$Bg)(b,e(h)))||s.push(l[g])}return s}t.$Qg=D;var M;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function e(s){const g=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach($=>{const[c,f]=$.split(":");c&&f&&g.set(c,f)});const h=s.path.substring(0,s.path.indexOf(";"));return h&&g.set(l.META_DATA_MIME,h),g}l.parseMetaData=e})(M||(t.DataUri=M={}));function r(l,e,s){if(e){let g=l.path;return g&&g[0]!==n.$gc.sep&&(g=n.$gc.sep+g),l.with({scheme:s,authority:e,path:g})}return l.with({scheme:s})}t.$Rg=r}),define(be[9],$e([1,0,29,6,4,2,37,5,50,23]),function(ie,t,k,T,n,H,A,S,m,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wh=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.Promises=t.$qh=t.$ph=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=void 0;function D(y){return!!y&&typeof y.then=="function"}t.$Sg=D;function M(y){const p=new k.$6d,u=y(p.token),i=new Promise((o,E)=>{const R=p.token.onCancellationRequested(()=>{R.dispose(),E(new T.$5)});Promise.resolve(u).then(F=>{R.dispose(),p.dispose(),o(F)},F=>{R.dispose(),p.dispose(),E(F)})});return new class{cancel(){p.cancel(),p.dispose()}then(o,E){return i.then(o,E)}catch(o){return this.then(void 0,o)}finally(o){return i.finally(o)}}}t.$Tg=M;function r(y,p,u){return new Promise((i,o)=>{const E=p.onCancellationRequested(()=>{E.dispose(),i(u)});y.then(i,o).finally(()=>E.dispose())})}t.$Ug=r;function l(y,p){return new Promise((u,i)=>{const o=p.onCancellationRequested(()=>{o.dispose(),i(new T.$5)});y.then(u,i).finally(()=>o.dispose())})}t.$Vg=l;async function e(y){let p=-1;const u=y.map((i,o)=>i.then(E=>(p=o,E)));try{return await Promise.race(u)}finally{y.forEach((i,o)=>{o!==p&&i.cancel()})}}t.$Wg=e;function s(y,p,u){let i;const o=setTimeout(()=>{i?.(void 0),u?.()},p);return Promise.race([y.finally(()=>clearTimeout(o)),new Promise(E=>i=E)])}t.$Xg=s;function g(y){return new Promise((p,u)=>{const i=y();D(i)?i.then(p,u):p(i)})}t.$Yg=g;class b{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const u=()=>{if(this.b=null,this.f)return;const i=this.queue(this.d);return this.d=null,i};this.b=new Promise(i=>{this.a.then(u,u).then(i)})}return new Promise((u,i)=>{this.b.then(u,i)})}return this.a=p(),new Promise((u,i)=>{this.a.then(o=>{this.a=null,u(o)},o=>{this.a=null,i(o)})})}dispose(){this.f=!0}}t.$Zg=b;class h{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$1g=h;class ${constructor(){this.a=new Map}queue(p,u){const o=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(u).finally(()=>{this.a.get(p)===o&&this.a.delete(p)});return this.a.set(p,o),o}}t.$2g=$;const c=(y,p)=>{let u=!0;const i=setTimeout(()=>{u=!1,p()},y);return{isTriggered:()=>u,dispose:()=>{clearTimeout(i),u=!1}}},f=y=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,y())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class a{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,u=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((o,E)=>{this.d=o,this.f=E}).then(()=>{if(this.b=null,this.d=null,this.g){const o=this.g;return this.g=null,o()}}));const i=()=>{this.a=null,this.d?.(null)};return this.a=u===m.$Sd?f(i):c(u,i),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$3g=a;class C{constructor(p){this.a=new a(p),this.b=new b}trigger(p,u){return this.a.trigger(()=>this.b.queue(p),u)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$4g=C;class O{constructor(){this.a=!1,this.b=new Promise((p,u)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$5g=O;class L extends O{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$6g=L;function B(y,p){return p?new Promise((u,i)=>{const o=setTimeout(()=>{E.dispose(),u()},y),E=p.onCancellationRequested(()=>{clearTimeout(o),E.dispose(),i(new T.$5)})}):M(u=>B(y,u))}t.$7g=B;function v(y,p=0,u){const i=setTimeout(()=>{y(),u&&o.dispose()},p),o=(0,H.$Rc)(()=>{clearTimeout(i),u?.deleteAndLeak(o)});return u?.add(o),o}t.$8g=v;function P(y){const p=[];let u=0;const i=y.length;function o(){return u<i?y[u++]():null}function E(R){R!=null&&p.push(R);const F=o();return F?F.then(E):Promise.resolve(p)}return Promise.resolve(null).then(E)}t.$9g=P;function V(y,p=i=>!!i,u=null){let i=0;const o=y.length,E=()=>{if(i>=o)return Promise.resolve(u);const R=y[i++];return Promise.resolve(R()).then(j=>p(j)?Promise.resolve(j):E())};return E()}t.$0g=V;function U(y,p=i=>!!i,u=null){if(y.length===0)return Promise.resolve(u);let i=y.length;const o=()=>{i=-1;for(const E of y)E.cancel?.()};return new Promise((E,R)=>{for(const F of y)F.then(j=>{--i>=0&&p(j)?(o(),E(j)):i===0&&E(u)}).catch(j=>{--i>=0&&(o(),R(j))})})}t.$$g=U;class N{constructor(p){this.a=0,this.b=!1,this.f=p,this.g=[],this.d=0,this.h=new n.$Vd}whenIdle(){return this.size>0?n.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(p){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((u,i)=>{this.g.push({factory:p,c:u,e:i}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const p=this.g.shift();this.d++;const u=p.factory();u.then(p.c,p.e),u.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$_g=N;class I extends N{constructor(){super(1)}}t.$ah=I;class z{constructor(){this.a=new J,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$bh=z;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new W;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueSize(p,u=A.$xg){const i=u.getComparisonKey(p);return this.a.get(i)?.size??0}queueFor(p,u,i=A.$xg){const o=i.getComparisonKey(p);let E=this.a.get(o);if(!E){E=new I;const R=this.f++,F=n.Event.once(E.onDrained)(()=>{E?.dispose(),this.a.delete(o),this.h(),this.d?.deleteAndDispose(R),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new H.$3c),this.d.set(R,F),this.a.set(o,E)}return E.queue(u)}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$ch=X;class Y{constructor(p,u){this.a=-1,typeof p=="function"&&typeof u=="number"&&this.setIfNotSet(p,u)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,u){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},u)}setIfNotSet(p,u){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},u))}}t.$dh=Y;class fe{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(p,u,i=globalThis){this.cancel();const o=i.setInterval(()=>{p()},u);this.d=(0,H.$Rc)(()=>{i.clearInterval(o),this.d=void 0})}dispose(){this.cancel()}}t.$eh=fe;class ae{constructor(p,u){this.b=-1,this.a=p,this.d=u,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$fh=ae;class ee{constructor(p,u){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.a=p,this.b=u,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$gh=ee;class ge extends ae{constructor(p,u){super(p,u),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$hh=ge;class Ie extends H.$Tc{constructor(p,u){super(),this.g=p,this.h=u,this.a=[],this.b=this.B(new H.$Uc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const u of p)this.a.push(u);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ae(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$ih=Ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$kh=(y,p)=>{(0,S.$B)(()=>{if(u)return;const i=Date.now()+15;p(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,i-Date.now())}}))});let u=!1;return{dispose(){u||(u=!0)}}}:t.$kh=(y,p,u)=>{const i=y.requestIdleCallback(p,typeof u=="number"?{timeout:u}:void 0);let o=!1;return{dispose(){o||(o=!0,y.cancelIdleCallback(i))}}},t.$jh=y=>(0,t.$kh)(globalThis,y)}();class Ce{constructor(p,u){this.g=!1,this.d=()=>{try{this.j=u()}catch(i){this.l=i}finally{this.g=!0}},this.f=(0,t.$kh)(p,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$lh=Ce;class Be extends Ce{constructor(p){super(globalThis,p)}}t.$mh=Be;async function se(y,p,u){let i;for(let o=0;o<u;o++)try{return await y()}catch(E){i=E,await B(p)}throw i}t.$nh=se;class J{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,u,i){return this.a={taskId:p,cancel:()=>i?.(),promise:u},u.then(()=>this.d(p),()=>this.d(p)),u}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let u,i;const o=new Promise((E,R)=>{u=E,i=R});this.b={run:p,promise:o,promiseResolve:u,promiseReject:i}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$oh=J;class re{constructor(p,u=()=>Date.now()){this.d=p,this.f=u,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$ph=re;var oe;(function(y){y[y.Resolved=0]="Resolved",y[y.Rejected=1]="Rejected"})(oe||(oe={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,u)=>{this.a=p,this.b=u})}complete(p){return new Promise(u=>{this.a(p),this.d={outcome:0,value:p},u()})}error(p){return new Promise(u=>{this.b(p),this.d={outcome:1,value:p},u()})}cancel(){return this.error(new T.$5)}}t.$qh=W;var G;(function(y){async function p(i){let o;const E=await Promise.all(i.map(R=>R.then(F=>F,F=>{o||(o=F)})));if(typeof o<"u")throw o;return E}y.settled=p;function u(i){return new Promise(async(o,E)=>{try{await i(o,E)}catch(R){E(R)}})}y.withAsyncBody=u})(G||(t.Promises=G={}));class ue{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(p){this.a=void 0,this.b=void 0,this.d=!1,this.promise=p.then(u=>(this.a=u,this.d=!0,u),u=>{throw this.b=u,this.d=!0,u})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$rh=ue;class me{constructor(p){this.b=p,this.a=new w.$V(()=>new ue(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$sh=me;var Se;(function(y){y[y.Initial=0]="Initial",y[y.DoneOK=1]="DoneOK",y[y.DoneError=2]="DoneError"})(Se||(Se={}));class ke{static fromArray(p){return new ke(u=>{u.emitMany(p)})}static fromPromise(p){return new ke(async u=>{u.emitMany(await p)})}static fromPromises(p){return new ke(async u=>{await Promise.all(p.map(async i=>u.emitOne(await i)))})}static merge(p){return new ke(async u=>{await Promise.all(p.map(async i=>{for await(const o of i)u.emitOne(o)}))})}static{this.EMPTY=ke.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new n.$Vd,queueMicrotask(async()=>{const u={emitOne:i=>this.g(i),emitMany:i=>this.h(i),reject:i=>this.k(i)};try{await Promise.resolve(p(u)),this.j()}catch(i){this.k(i)}finally{u.emitOne=void 0,u.emitMany=void 0,u.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(p,u){return new ke(async i=>{for await(const o of p)i.emitOne(u(o))})}map(p){return ke.map(this,p)}static filter(p,u){return new ke(async i=>{for await(const o of p)u(o)&&i.emitOne(o)})}filter(p){return ke.filter(this,p)}static coalesce(p){return ke.filter(p,u=>!!u)}coalesce(){return ke.coalesce(this)}static async toPromise(p){const u=[];for await(const i of p)u.push(i);return u}toPromise(){return ke.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$th=ke;class Pe extends ke{constructor(p,u){super(u),this.l=p}cancel(){this.l.cancel()}}t.$uh=Pe;function x(y){const p=new k.$6d,u=y(p.token);return new Pe(p,async i=>{const o=p.token.onCancellationRequested(()=>{o.dispose(),p.dispose(),i.reject(new T.$5)});try{for await(const E of u){if(p.token.isCancellationRequested)return;i.emitOne(E)}o.dispose(),p.dispose()}catch(E){o.dispose(),p.dispose(),i.reject(E)}})}t.$vh=x;class d{constructor(){this.a=new W,this.b=new ke(i=>{if(p){i.reject(p);return}return u&&i.emitMany(u),this.d=o=>i.reject(o),this.f=o=>i.emitOne(o),this.a.p});let p,u;this.f=i=>{u||(u=[]),u.push(i)},this.d=i=>{p||(p=i)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(p){this.d(p),this.a.complete()}emitOne(p){this.f(p)}}t.$wh=d}),define(be[3],$e([1,0,16,114,14,19,9,6,4,118,2,31,5,15,49,21]),function(ie,t,k,T,n,H,A,S,m,w,D,M,r,l,e,s){"use strict";var g;Object.defineProperty(t,"__esModule",{value:!0}),t.$$Q=t.$0Q=t.h=t.$8Q=t.$7Q=t.$6Q=t.$5Q=t.$4Q=t.$3Q=t.$2Q=t.$1Q=t.DetectedFullscreenMode=t.$ZQ=t.$YQ=t.$XQ=t.$WQ=t.$VQ=t.$UQ=t.$TQ=t.$SQ=t.$RQ=t.$QQ=t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.$LQ=t.$KQ=t.$JQ=t.$=t.Namespace=t.$HQ=t.$GQ=t.$FQ=t.$EQ=t.$DQ=t.$CQ=t.$BQ=t.$AQ=t.$zQ=t.$yQ=t.$xQ=t.$wQ=t.$vQ=t.$uQ=t.$tQ=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$oQ=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,g=function(){const _=new Map;(0,s.$9O)(s.$0O,1),_.set(s.$0O.vscodeWindowId,{window:s.$0O,disposables:new D.$Sc});const Q=new m.$Vd,te=new m.$Vd,ce=new m.$Vd;return{onDidRegisterWindow:Q.event,onWillUnregisterWindow:ce.event,onDidUnregisterWindow:te.event,registerWindow(ye){if(_.has(ye.vscodeWindowId))return D.$Tc.None;const Oe=new D.$Sc,He={window:ye,disposables:Oe.add(new D.$Sc)};return _.set(ye.vscodeWindowId,He),Oe.add((0,D.$Rc)(()=>{_.delete(ye.vscodeWindowId),te.fire(ye)})),Oe.add($(ye,t.$yQ.BEFORE_UNLOAD,()=>{ce.fire(ye)})),Q.fire(He),Oe},getWindows(){return _.values()},getWindowsCount(){return _.size},getWindowId(ye){return ye.vscodeWindowId},hasWindow(ye){return _.has(ye)},getWindowById(ye){return _.get(ye)},getWindow(ye){const Oe=ye;if(Oe?.ownerDocument?.defaultView)return Oe.ownerDocument.defaultView.window;const He=ye;return He?.view?He.view.window:s.$0O},getDocument(ye){const Oe=ye;return(0,t.getWindow)(Oe).document}}}(),t.registerWindow=g.registerWindow,t.getWindow=g.getWindow,t.getDocument=g.getDocument,t.getWindows=g.getWindows,t.getWindowsCount=g.getWindowsCount,t.getWindowId=g.getWindowId,t.getWindowById=g.getWindowById,t.hasWindow=g.hasWindow,t.onDidRegisterWindow=g.onDidRegisterWindow,t.onWillUnregisterWindow=g.onWillUnregisterWindow,t.onDidUnregisterWindow=g.onDidUnregisterWindow;function b(_){for(;_.firstChild;)_.firstChild.remove()}t.$EP=b;class h{constructor(Q,te,ce,ye){this.f=Q,this.g=te,this.d=ce,this.j=ye||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function $(_,Q,te,ce){return new h(_,Q,te,ce)}t.$FP=$;function c(_,Q){return function(te){return Q(new H.$xP(_,te))}}function f(_){return function(Q){return _(new n.$CP(Q))}}const a=function(Q,te,ce,ye){let Oe=ce;return te==="click"||te==="mousedown"?Oe=c((0,t.getWindow)(Q),ce):(te==="keydown"||te==="keypress"||te==="keyup")&&(Oe=f(ce)),$(Q,te,Oe,ye)};t.$GP=a;const C=function(Q,te,ce){const ye=c((0,t.getWindow)(Q),te);return L(Q,ye,ce)};t.$HP=C;const O=function(Q,te,ce){const ye=c((0,t.getWindow)(Q),te);return v(Q,ye,ce)};t.$IP=O;function L(_,Q,te){return $(_,r.$r&&T.$uP.pointerEvents?t.$yQ.POINTER_DOWN:t.$yQ.MOUSE_DOWN,Q,te)}t.$JP=L;function B(_,Q,te){return $(_,r.$r&&T.$uP.pointerEvents?t.$yQ.POINTER_MOVE:t.$yQ.MOUSE_MOVE,Q,te)}t.$KP=B;function v(_,Q,te){return $(_,r.$r&&T.$uP.pointerEvents?t.$yQ.POINTER_UP:t.$yQ.MOUSE_UP,Q,te)}t.$LP=v;function P(_,Q,te){return(0,A.$kh)(_,Q,te)}t.$MP=P;class V extends A.$lh{constructor(Q,te){super(Q,te)}}t.$NP=V;function U(_,Q,te,ce){let ye=0;const Oe=_.setInterval(()=>{ye++,(typeof ce=="number"&&ye>=ce||Q()===!0)&&He.dispose()},te),He=(0,D.$Rc)(()=>{_.clearInterval(Oe)});return He}t.$QP=U;class N extends A.$eh{constructor(Q){super(),this.f=Q&&(0,t.getWindow)(Q)}cancelAndSet(Q,te,ce){return super.cancelAndSet(Q,te,ce??this.f)}}t.$RP=N;class I{constructor(Q,te=0){this.d=Q,this.priority=te,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Q){(0,S.$1)(Q)}}static sort(Q,te){return te.priority-Q.priority}}(function(){const _=new Map,Q=new Map,te=new Map,ce=new Map,ye=Oe=>{te.set(Oe,!1);const He=_.get(Oe)??[];for(Q.set(Oe,He),_.set(Oe,[]),ce.set(Oe,!0);He.length>0;)He.sort(I.sort),He.shift().execute();ce.set(Oe,!1)};t.$PP=(Oe,He,Ke=0)=>{const Ge=(0,t.getWindowId)(Oe),qe=new I(He,Ke);let lt=_.get(Ge);return lt||(lt=[],_.set(Ge,lt)),lt.push(qe),te.get(Ge)||(te.set(Ge,!0),Oe.requestAnimationFrame(()=>ye(Ge))),qe},t.$OP=(Oe,He,Ke)=>{const Ge=(0,t.getWindowId)(Oe);if(ce.get(Ge)){const qe=new I(He,Ke);let lt=Q.get(Ge);return lt||(lt=[],Q.set(Ge,lt)),lt.push(qe),qe}else return(0,t.$PP)(Oe,He,Ke)}})();function z(_,Q){return(0,t.$PP)(_,Q,1e4)}t.$SP=z;function X(_,Q){return(0,t.$PP)(_,Q,-1e4)}t.$TP=X;const Y=8,fe=function(_,Q){return Q};class ae extends D.$Tc{constructor(Q,te,ce,ye=fe,Oe=Y){super();let He=null,Ke=0;const Ge=this.B(new A.$dh),qe=()=>{Ke=new Date().getTime(),ce(He),He=null};this.B($(Q,te,lt=>{He=ye(He,lt);const Ct=new Date().getTime()-Ke;Ct>=Oe?(Ge.cancel(),qe()):Ge.setIfNotSet(qe,Oe-Ct)}))}}function ee(_,Q,te,ce,ye){return new ae(_,Q,te,ce,ye)}t.$UP=ee;function ge(_){return(0,t.getWindow)(_).getComputedStyle(_,null)}t.$VP=ge;function Ie(_,Q){const te=(0,t.getWindow)(_),ce=te.document;if(_!==ce.body)return new Be(_.clientWidth,_.clientHeight);if(r.$r&&te?.visualViewport)return new Be(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Be(te.innerWidth,te.innerHeight);if(ce.body&&ce.body.clientWidth&&ce.body.clientHeight)return new Be(ce.body.clientWidth,ce.body.clientHeight);if(ce.documentElement&&ce.documentElement.clientWidth&&ce.documentElement.clientHeight)return new Be(ce.documentElement.clientWidth,ce.documentElement.clientHeight);if(Q)return Ie(Q);throw new Error("Unable to figure out browser width and height")}t.$WP=Ie;class Ce{static d(Q,te){return parseFloat(te)||0}static f(Q,te,ce){const ye=ge(Q),Oe=ye?ye.getPropertyValue(te):"0";return Ce.d(Q,Oe)}static getBorderLeftWidth(Q){return Ce.f(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return Ce.f(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return Ce.f(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return Ce.f(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return Ce.f(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return Ce.f(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return Ce.f(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return Ce.f(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return Ce.f(Q,"margin-left","marginLeft")}static getMarginTop(Q){return Ce.f(Q,"margin-top","marginTop")}static getMarginRight(Q){return Ce.f(Q,"margin-right","marginRight")}static getMarginBottom(Q){return Ce.f(Q,"margin-bottom","marginBottom")}}class Be{static{this.None=new Be(0,0)}constructor(Q,te){this.width=Q,this.height=te}with(Q=this.width,te=this.height){return Q!==this.width||te!==this.height?new Be(Q,te):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof Be?Q:new Be(Q.width,Q.height)}static equals(Q,te){return Q===te?!0:!Q||!te?!1:Q.width===te.width&&Q.height===te.height}}t.$XP=Be;function se(_){let Q=_.offsetParent,te=_.offsetTop,ce=_.offsetLeft;for(;(_=_.parentNode)!==null&&_!==_.ownerDocument.body&&_!==_.ownerDocument.documentElement;){te-=_.scrollTop;const ye=R(_)?null:ge(_);ye&&(ce-=ye.direction!=="rtl"?_.scrollLeft:-_.scrollLeft),_===Q&&(ce+=Ce.getBorderLeftWidth(_),te+=Ce.getBorderTopWidth(_),te+=_.offsetTop,ce+=_.offsetLeft,Q=_.offsetParent)}return{left:ce,top:te}}t.$YP=se;function J(_,Q,te){typeof Q=="number"&&(_.style.width=`${Q}px`),typeof te=="number"&&(_.style.height=`${te}px`)}t.$ZP=J;function re(_,Q,te,ce,ye,Oe="absolute"){typeof Q=="number"&&(_.style.top=`${Q}px`),typeof te=="number"&&(_.style.right=`${te}px`),typeof ce=="number"&&(_.style.bottom=`${ce}px`),typeof ye=="number"&&(_.style.left=`${ye}px`),_.style.position=Oe}t.$1P=re;function oe(_){const Q=_.getBoundingClientRect(),te=(0,t.getWindow)(_);return{left:Q.left+te.scrollX,top:Q.top+te.scrollY,width:Q.width,height:Q.height}}t.$2P=oe;function W(_){let Q=_,te=1;do{const ce=ge(Q).zoom;ce!=null&&ce!=="1"&&(te*=ce),Q=Q.parentElement}while(Q!==null&&Q!==Q.ownerDocument.documentElement);return te}t.$3P=W;function G(_){const Q=Ce.getMarginLeft(_)+Ce.getMarginRight(_);return _.offsetWidth+Q}t.$4P=G;function ue(_){const Q=Ce.getBorderLeftWidth(_)+Ce.getBorderRightWidth(_),te=Ce.getPaddingLeft(_)+Ce.getPaddingRight(_);return _.offsetWidth-Q-te}t.$5P=ue;function me(_){const Q=Ce.getMarginLeft(_)+Ce.getMarginRight(_);return _.scrollWidth+Q}t.$6P=me;function Se(_){const Q=Ce.getBorderTopWidth(_)+Ce.getBorderBottomWidth(_),te=Ce.getPaddingTop(_)+Ce.getPaddingBottom(_);return _.offsetHeight-Q-te}t.$7P=Se;function ke(_){const Q=Ce.getMarginTop(_)+Ce.getMarginBottom(_);return _.offsetHeight+Q}t.$8P=ke;function Pe(_,Q){if(_===null)return 0;const te=se(_),ce=se(Q);return te.left-ce.left}function x(_,Q){const te=Q.map(ye=>Math.max(me(ye),G(ye))+Pe(ye,_)||0);return Math.max(...te)}t.$9P=x;function d(_,Q){return!!Q?.contains(_)}t.$0P=d;const y="parentFlowToElementId";function p(_,Q){_.dataset[y]=Q.id}t.$$P=p;function u(_){const Q=_.dataset[y];return typeof Q=="string"?_.ownerDocument.getElementById(Q):null}function i(_,Q){let te=_;for(;te;){if(te===Q)return!0;if(te instanceof HTMLElement){const ce=u(te);if(ce){te=ce;continue}}te=te.parentNode}return!1}t.$_P=i;function o(_,Q,te){for(;_&&_.nodeType===_.ELEMENT_NODE;){if(_.classList.contains(Q))return _;if(te){if(typeof te=="string"){if(_.classList.contains(te))return null}else if(_===te)return null}_=_.parentNode}return null}t.$aQ=o;function E(_,Q,te){return!!o(_,Q,te)}t.$bQ=E;function R(_){return _&&!!_.host&&!!_.mode}t.$cQ=R;function F(_){return!!j(_)}t.$dQ=F;function j(_){for(;_.parentNode;){if(_===_.ownerDocument?.body)return null;_=_.parentNode}return R(_)?_:null}t.$eQ=j;function q(){let _=De().activeElement;for(;_?.shadowRoot;)_=_.shadowRoot.activeElement;return _}t.$fQ=q;function Z(_){return q()===_}t.$gQ=Z;function le(_){return d(q(),_)}t.$hQ=le;function pe(_){return _.ownerDocument===De()}t.$iQ=pe;function De(){return(0,t.getWindowsCount)()<=1?s.$0O.document:Array.from((0,t.getWindows)()).map(({window:Q})=>Q.document).find(Q=>Q.hasFocus())??s.$0O.document}t.$jQ=De;function we(){return De().defaultView?.window??s.$0O}t.$kQ=we;function Ee(_){const Q=(0,t.getWindow)(_);Q.document.hasFocus()||Q.focus()}t.$lQ=Ee;const ve=new Map;function Te(_){return ve.has(_)}t.$mQ=Te;function Le(_=s.$0O.document.head,Q,te){const ce=document.createElement("style");if(ce.type="text/css",ce.media="screen",Q?.(ce),_.appendChild(ce),te&&te.add((0,D.$Rc)(()=>_.removeChild(ce))),_===s.$0O.document.head){const ye=new Set;ve.set(ce,ye);for(const{window:Oe,disposables:He}of(0,t.getWindows)()){if(Oe===s.$0O)continue;const Ke=He.add(Ze(ce,ye,Oe));te?.add(Ke)}}return ce}t.$nQ=Le;function Me(_){const Q=new D.$Sc;for(const[te,ce]of ve)Q.add(Ze(te,ce,_));return Q}t.$oQ=Me;function Ze(_,Q,te){const ce=new D.$Sc,ye=_.cloneNode(!0);te.document.head.appendChild(ye),ce.add((0,D.$Rc)(()=>te.document.head.removeChild(ye)));for(const Oe of Ae(_))ye.sheet?.insertRule(Oe.cssText,ye.sheet?.cssRules.length);return ce.add(t.$pQ.observe(_,ce,{childList:!0})(()=>{ye.textContent=_.textContent})),Q.add(ye),ce.add((0,D.$Rc)(()=>Q.delete(ye))),ce}t.$pQ=new class{constructor(){this.mutationObservers=new Map}observe(_,Q,te){let ce=this.mutationObservers.get(_);ce||(ce=new Map,this.mutationObservers.set(_,ce));const ye=(0,e.$Ti)(te);let Oe=ce.get(ye);if(Oe)Oe.users+=1;else{const He=new m.$Vd,Ke=new MutationObserver(qe=>He.fire(qe));Ke.observe(_,te);const Ge=Oe={users:1,observer:Ke,onDidMutate:He.event};Q.add((0,D.$Rc)(()=>{Ge.users-=1,Ge.users===0&&(He.dispose(),Ke.disconnect(),ce?.delete(ye),ce?.size===0&&this.mutationObservers.delete(_))})),ce.set(ye,Oe)}return Oe.onDidMutate}};function et(_=s.$0O.document.head){return K("meta",_)}t.$qQ=et;function xe(_=s.$0O.document.head){return K("link",_)}t.$rQ=xe;function K(_,Q=s.$0O.document.head){const te=document.createElement(_);return Q.appendChild(te),te}let ne=null;function de(){return ne||(ne=Le()),ne}function Ae(_){return _?.sheet?.rules?_.sheet.rules:_?.sheet?.cssRules?_.sheet.cssRules:[]}function Ne(_,Q,te=de()){if(!(!te||!Q)){te.sheet?.insertRule(`${_} {${Q}}`,0);for(const ce of ve.get(te)??[])Ne(_,Q,ce)}}t.$sQ=Ne;function je(_,Q=de()){if(!Q)return;const te=Ae(Q),ce=[];for(let ye=0;ye<te.length;ye++){const Oe=te[ye];Ve(Oe)&&Oe.selectorText.indexOf(_)!==-1&&ce.push(ye)}for(let ye=ce.length-1;ye>=0;ye--)Q.sheet?.deleteRule(ce[ye]);for(const ye of ve.get(Q)??[])je(_,ye)}t.$tQ=je;function Ve(_){return typeof _.selectorText=="string"}function _e(_){return _ instanceof MouseEvent||_ instanceof(0,t.getWindow)(_).MouseEvent}t.$uQ=_e;function Je(_){return _ instanceof KeyboardEvent||_ instanceof(0,t.getWindow)(_).KeyboardEvent}t.$vQ=Je;function tt(_){return _ instanceof PointerEvent||_ instanceof(0,t.getWindow)(_).PointerEvent}t.$wQ=tt;function Ye(_){return _ instanceof DragEvent||_ instanceof(0,t.getWindow)(_).DragEvent}t.$xQ=Ye,t.$yQ={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:k.$mP?"webkitAnimationStart":"animationstart",ANIMATION_END:k.$mP?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:k.$mP?"webkitAnimationIteration":"animationiteration"};function nt(_){const Q=_;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.$zQ=nt,t.$AQ={stop:(_,Q)=>(_.preventDefault(),Q&&_.stopPropagation(),_)};function st(_){const Q=[];for(let te=0;_&&_.nodeType===_.ELEMENT_NODE;te++)Q[te]=_.scrollTop,_=_.parentNode;return Q}t.$BQ=st;function rt(_,Q){for(let te=0;_&&_.nodeType===_.ELEMENT_NODE;te++)_.scrollTop!==Q[te]&&(_.scrollTop=Q[te]),_=_.parentNode}t.$CQ=rt;class gt extends D.$Tc{static m(Q){if(Q instanceof HTMLElement){const te=j(Q),ce=te?te.activeElement:Q.ownerDocument.activeElement;return d(ce,Q)}else{const te=Q;return d(te.document.activeElement,te.document)}}constructor(Q){super(),this.f=this.B(new m.$Vd),this.onDidFocus=this.f.event,this.g=this.B(new m.$Vd),this.onDidBlur=this.g.event;let te=gt.m(Q),ce=!1;const ye=()=>{ce=!1,te||(te=!0,this.f.fire())},Oe=()=>{te&&(ce=!0,(Q instanceof HTMLElement?(0,t.getWindow)(Q):Q).setTimeout(()=>{ce&&(ce=!1,te=!1,this.g.fire())},0))};this.j=()=>{gt.m(Q)!==te&&(te?Oe():ye())},this.B($(Q,t.$yQ.FOCUS,ye,!0)),this.B($(Q,t.$yQ.BLUR,Oe,!0)),Q instanceof HTMLElement&&(this.B($(Q,t.$yQ.FOCUS_IN,()=>this.j())),this.B($(Q,t.$yQ.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function kt(_){return new gt(_)}t.$DQ=kt;function St(_,Q){return _.after(Q),Q}t.$EQ=St;function wt(_,...Q){if(_.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}t.$FQ=wt;function Ot(_,Q){return _.insertBefore(Q,_.firstChild),Q}t.$GQ=Ot;function ze(_,...Q){_.innerText="",wt(_,...Q)}t.$HQ=ze;const he=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Fe;(function(_){_.HTML="http://www.w3.org/1999/xhtml",_.SVG="http://www.w3.org/2000/svg"})(Fe||(t.Namespace=Fe={}));function Re(_,Q,te,...ce){const ye=he.exec(Q);if(!ye)throw new Error("Bad use of emmet");const Oe=ye[1]||"div";let He;return _!==Fe.HTML?He=document.createElementNS(_,Oe):He=document.createElement(Oe),ye[3]&&(He.id=ye[3]),ye[4]&&(He.className=ye[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([Ke,Ge])=>{typeof Ge>"u"||(/^on\w+$/.test(Ke)?He[Ke]=Ge:Ke==="selected"?Ge&&He.setAttribute(Ke,"true"):He.setAttribute(Ke,Ge))}),He.append(...ce),He}function We(_,Q,...te){return Re(Fe.HTML,_,Q,...te)}t.$=We,We.SVG=function(_,Q,...te){return Re(Fe.SVG,_,Q,...te)};function it(_,Q){const te=[];return _.forEach((ce,ye)=>{ye>0&&(Q instanceof Node?te.push(Q.cloneNode()):te.push(document.createTextNode(Q))),te.push(ce)}),te}t.$JQ=it;function at(_,...Q){_?Qe(...Q):ut(...Q)}t.$KQ=at;function Qe(..._){for(const Q of _)Q.style.display="",Q.removeAttribute("aria-hidden")}t.$LQ=Qe;function ut(..._){for(const Q of _)Q.style.display="none",Q.setAttribute("aria-hidden","true")}t.$MQ=ut;function vt(_,Q){for(;_&&_.nodeType===_.ELEMENT_NODE;){if(_ instanceof HTMLElement&&_.hasAttribute(Q))return _;_=_.parentNode}return null}function Ft(_){!_||!_.hasAttribute("tabIndex")||(_.ownerDocument.activeElement===_&&vt(_.parentElement,"tabIndex")?.focus(),_.removeAttribute("tabindex"))}t.$NQ=Ft;function Gt(_){return Q=>{Q.preventDefault(),Q.stopPropagation(),_(Q)}}t.$OQ=Gt;function Ai(_){return new Promise(Q=>{if(_.document.readyState==="complete"||_.document&&_.document.body!==null)Q(void 0);else{const ce=()=>{_.window.removeEventListener("DOMContentLoaded",ce,!1),Q()};_.window.addEventListener("DOMContentLoaded",ce,!1)}})}t.$PQ=Ai;function ki(_,Q){const te=_.devicePixelRatio*Q;return Math.max(1,Math.floor(te))/_.devicePixelRatio}t.$QQ=ki;function Si(_){s.$0O.open(_,"_blank","noopener")}t.$RQ=Si;const Xt=780,Yt=640;function Fi(_){const Q=Math.floor(s.$0O.screenLeft+s.$0O.innerWidth/2-Xt/2),te=Math.floor(s.$0O.screenTop+s.$0O.innerHeight/2-Yt/2);s.$0O.open(_,"_blank",`width=${Xt},height=${Yt},top=${te},left=${Q}`)}t.$SQ=Fi;function Ci(_,Q=!0){const te=s.$0O.open();return te?(Q&&(te.opener=null),te.location.href=_,!0):!1}t.$TQ=Ci;function Ni(_,Q){const te=()=>{Q(),ce=(0,t.$PP)(_,te)};let ce=(0,t.$PP)(_,te);return(0,D.$Rc)(()=>ce.dispose())}t.$UQ=Ni,M.$ig.setPreferredWebSchema(/^https:/.test(s.$0O.location.href)?"https":"http");function Pi(_){return _?`url('${M.$og.uriToBrowserUri(_).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$VQ=Pi;function Ti(_){return`'${_.replace(/'/g,"%27")}'`}t.$WQ=Ti;function Zt(_,Q){if(_!==void 0){const te=_.match(/^\s*var\((.+)\)$/);if(te){const ce=te[1].split(",",2);return ce.length===2&&(Q=Zt(ce[1].trim(),Q)),`var(${ce[0]}, ${Q})`}return _}return Q}t.$XQ=Zt;function Ri(_,Q){let te;if(l.URI.isUri(_))te=_.toString(!0);else{const Oe=new Blob([_]);te=URL.createObjectURL(Oe),setTimeout(()=>URL.revokeObjectURL(te))}const ce=we(),ye=document.createElement("a");ce.document.body.appendChild(ye),ye.download=Q,ye.href=te,ye.click(),setTimeout(()=>ce.document.body.removeChild(ye))}t.$YQ=Ri;function Li(){return new Promise(_=>{const Q=we(),te=document.createElement("input");Q.document.body.appendChild(te),te.type="file",te.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(te,"input"))(()=>{_(te.files??void 0)}),te.click(),setTimeout(()=>Q.document.body.removeChild(te))})}t.$ZQ=Li;var yt;(function(_){_[_.DOCUMENT=1]="DOCUMENT",_[_.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function Ii(_){return _.document.fullscreenElement||_.document.webkitFullscreenElement||_.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:_.innerHeight===_.screen.height?{mode:yt.BROWSER,guess:!1}:(r.$j||r.$k)&&_.outerHeight===_.screen.height&&_.outerWidth===_.screen.width?{mode:yt.BROWSER,guess:!0}:null}t.$1Q=Ii;function Jt(_,Q=!1){const te=document.createElement("a");return w.addHook("afterSanitizeAttributes",ce=>{for(const ye of["href","src"])if(ce.hasAttribute(ye)){const Oe=ce.getAttribute(ye);if(ye==="href"&&Oe.startsWith("#"))continue;if(te.href=Oe,!_.includes(te.protocol.replace(/:$/,""))){if(Q&&ye==="src"&&te.href.startsWith("data:"))continue;ce.removeAttribute(ye)}}}),(0,D.$Rc)(()=>{w.removeHook("afterSanitizeAttributes")})}t.$2Q=Jt;const Mi=[M.Schemas.http,M.Schemas.https,M.Schemas.command];t.$3Q=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Oi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(_,Q){const te=Jt(Mi);try{const ce=w.sanitize(Q,Oi);_.innerHTML=ce}finally{te.dispose()}}t.$4Q=Bi;function zi(_){const Q=new Uint16Array(_.length);for(let ye=0;ye<Q.length;ye++)Q[ye]=_.charCodeAt(ye);let te="";const ce=new Uint8Array(Q.buffer);for(let ye=0;ye<ce.length;ye++)te+=String.fromCharCode(ce[ye]);return te}function ji(_){return btoa(zi(_))}t.$5Q=ji;class bt extends m.$Vd{constructor(){super(),this.o=new D.$Sc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(m.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Q,disposables:te})=>this.B(Q,te),{window:s.$0O,disposables:this.o}))}B(Q,te){te.add($(Q,"keydown",ce=>{if(ce.defaultPrevented)return;const ye=new n.$CP(ce);if(!(ye.keyCode===6&&ce.repeat)){if(ce.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(ce.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(ce.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(ce.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ye.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=ce.altKey,this.s.ctrlKey=ce.ctrlKey,this.s.metaKey=ce.metaKey,this.s.shiftKey=ce.shiftKey,this.s.lastKeyPressed&&(this.s.event=ce,this.fire(this.s))}},!0)),te.add($(Q,"keyup",ce=>{ce.defaultPrevented||(!ce.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!ce.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!ce.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!ce.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=ce.altKey,this.s.ctrlKey=ce.ctrlKey,this.s.metaKey=ce.metaKey,this.s.shiftKey=ce.shiftKey,this.s.lastKeyReleased&&(this.s.event=ce,this.fire(this.s)))},!0)),te.add($(Q.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),te.add($(Q.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),te.add($(Q.document.body,"mousemove",ce=>{ce.buttons&&(this.s.lastKeyPressed=void 0)},!0)),te.add($(Q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return bt.A||(bt.A=new bt),bt.A}dispose(){super.dispose(),this.o.dispose()}}t.$6Q=bt;function Hi(_){const Q=document.cookie.match("(^|[^;]+)\\s*"+_+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}t.$7Q=Hi;class Ui extends D.$Tc{constructor(Q,te){super(),this.j=Q,this.m=te,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B($(this.j,t.$yQ.DRAG_START,Q=>{this.m.onDragStart?.(Q)})),this.m.onDrag&&this.B($(this.j,t.$yQ.DRAG,Q=>{this.m.onDrag?.(Q)})),this.B($(this.j,t.$yQ.DRAG_ENTER,Q=>{this.f++,this.g=Q.timeStamp,this.m.onDragEnter?.(Q)})),this.B($(this.j,t.$yQ.DRAG_OVER,Q=>{Q.preventDefault(),this.m.onDragOver?.(Q,Q.timeStamp-this.g)})),this.B($(this.j,t.$yQ.DRAG_LEAVE,Q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(Q))})),this.B($(this.j,t.$yQ.DRAG_END,Q=>{this.f=0,this.g=0,this.m.onDragEnd?.(Q)})),this.B($(this.j,t.$yQ.DROP,Q=>{this.f=0,this.g=0,this.m.onDrop?.(Q)}))}}t.$8Q=Ui;const Wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Vi(_,...Q){let te,ce;Array.isArray(Q[0])?(te={},ce=Q[0]):(te=Q[0]||{},ce=Q[1]);const ye=Wi.exec(_);if(!ye||!ye.groups)throw new Error("Bad use of h");const Oe=ye.groups.tag||"div",He=document.createElement(Oe);ye.groups.id&&(He.id=ye.groups.id);const Ke=[];if(ye.groups.class)for(const qe of ye.groups.class.split("."))qe!==""&&Ke.push(qe);if(te.className!==void 0)for(const qe of te.className.split("."))qe!==""&&Ke.push(qe);Ke.length>0&&(He.className=Ke.join(" "));const Ge={};if(ye.groups.name&&(Ge[ye.groups.name]=He),ce)for(const qe of ce)qe instanceof HTMLElement?He.appendChild(qe):typeof qe=="string"?He.append(qe):"root"in qe&&(Object.assign(Ge,qe),He.appendChild(qe.root));for(const[qe,lt]of Object.entries(te))if(qe!=="className")if(qe==="style")for(const[Ct,Bt]of Object.entries(lt))He.style.setProperty(ei(Ct),typeof Bt=="number"?Bt+"px":""+Bt);else qe==="tabIndex"?He.tabIndex=lt:He.setAttribute(ei(qe),lt.toString());return Ge.root=He,Ge}t.h=Vi;function ei(_){return _.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(_,Q){for(const{name:te,value:ce}of _.attributes)Q.setAttribute(te,ce)}t.$0Q=ti;function qi(_,Q,te){const ce=_.getAttribute(te);ce?Q.setAttribute(te,ce):Q.removeAttribute(te)}function _i(_,Q,te){ti(_,Q);const ce=new D.$Sc;return ce.add(t.$pQ.observe(_,ce,{attributes:!0,attributeFilter:te})(ye=>{for(const Oe of ye)Oe.type==="attributes"&&Oe.attributeName&&qi(_,Q,Oe.attributeName)})),ce}t.$$Q=_i}),define(be[54],$e([1,0,3,2,117]),function(ie,t,k,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bR=t.$aR=t.$_Q=void 0;class H extends T.$Tc{constructor(m,w){super(),this.B((0,k.$FP)(m,"dragover",D=>{D.preventDefault(),this.a||(this.a=setTimeout(()=>{w(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(D=>{this.B((0,k.$FP)(m,D,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$_Q=H,t.$aR={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:n.$fs.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function A(S,m,w,D,M){const r=document.createElement("div");if(r.className=w,r.textContent=m,M&&(r.style.color=M),D&&(r.style.background=D),S.dataTransfer){const l=(0,k.getWindow)(S).document;l.body.appendChild(r),S.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>l.body.removeChild(r),0)}}t.$bR=A}),define(be[55],$e([1,0,3]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FR=t.$ER=t.$DR=void 0;function T(r,l={}){const e=H(l);return e.textContent=r,e}t.$DR=T;function n(r,l={}){const e=H(l);return m(e,w(r,!!l.renderCodeSegments),l.actionHandler,l.renderCodeSegments),e}t.$ER=n;function H(r){const l=r.inline?"span":"div",e=document.createElement(l);return r.className&&(e.className=r.className),e}t.$FR=H;class A{constructor(l){this.b=l,this.c=0}eos(){return this.c>=this.b.length}next(){const l=this.peek();return this.advance(),l}peek(){return this.b[this.c]}advance(){this.c++}}var S;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(S||(S={}));function m(r,l,e,s){let g;if(l.type===2)g=document.createTextNode(l.content||"");else if(l.type===3)g=document.createElement("b");else if(l.type===4)g=document.createElement("i");else if(l.type===7&&s)g=document.createElement("code");else if(l.type===5&&e){const b=document.createElement("a");e.disposables.add(k.$GP(b,"click",h=>{e.callback(String(l.index),h)})),g=b}else l.type===8?g=document.createElement("br"):l.type===1&&(g=r);g&&r!==g&&r.appendChild(g),g&&Array.isArray(l.children)&&l.children.forEach(b=>{m(g,b,e,s)})}function w(r,l){const e={type:1,children:[]};let s=0,g=e;const b=[],h=new A(r);for(;!h.eos();){let $=h.next();const c=$==="\\"&&M(h.peek(),l)!==0;if(c&&($=h.next()),!c&&D($,l)&&$===h.peek()){h.advance(),g.type===2&&(g=b.pop());const f=M($,l);if(g.type===f||g.type===5&&f===6)g=b.pop();else{const a={type:f,children:[]};f===5&&(a.index=s,s++),g.children.push(a),b.push(g),g=a}}else if($===`
`)g.type===2&&(g=b.pop()),g.children.push({type:8});else if(g.type!==2){const f={type:2,content:$};g.children.push(f),b.push(g),g=f}else g.content+=$}return g.type===2&&(g=b.pop()),b.length,e}function D(r,l){return M(r,l)!==0}function M(r,l){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return l?7:0;default:return 0}}}),define(be[56],$e([1,0,3,2]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fR=void 0;class n{constructor(){this.a=new T.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(A,S){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const m=this.c;this.c=null,A&&m&&m(S)}isMonitoring(){return!!this.b}startMonitoring(A,S,m,w,D){this.isMonitoring()&&this.stopMonitoring(!1),this.b=w,this.c=D;let M=A;try{A.setPointerCapture(S),this.a.add((0,T.$Rc)(()=>{try{A.releasePointerCapture(S)}catch{}}))}catch{M=k.getWindow(A)}this.a.add(k.$FP(M,k.$yQ.POINTER_MOVE,r=>{if(r.buttons!==m){this.stopMonitoring(!0);return}r.preventDefault(),this.b(r)})),this.a.add(k.$FP(M,k.$yQ.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.$fR=n});var Xe=this&&this.__decorate||function(ie,t,k,T){var n=arguments.length,H=n<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,k):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(ie,t,k,T);else for(var S=ie.length-1;S>=0;S--)(A=ie[S])&&(H=(n<3?A(H):n>3?A(t,k,H):A(t,k))||H);return n>3&&H&&Object.defineProperty(t,k,H),H};define(be[25],$e([1,0,3,21,12,27,4,2,45]),function(ie,t,k,T,n,H,A,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cR=t.EventType=void 0;var w;(function(M){M.Tap="-monaco-gesturetap",M.Change="-monaco-gesturechange",M.Start="-monaco-gesturestart",M.End="-monaco-gesturesend",M.Contextmenu="-monaco-gesturecontextmenu"})(w||(t.EventType=w={}));class D extends S.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new m.$4c,this.h=new m.$4c,this.m={},this.j=null,this.n=0,this.B(A.Event.runAndSubscribe(k.onDidRegisterWindow,({window:r,disposables:l})=>{l.add(k.$FP(r.document,"touchstart",e=>this.s(e),{passive:!1})),l.add(k.$FP(r.document,"touchend",e=>this.u(r,e))),l.add(k.$FP(r.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:T.$0O,disposables:this.q}))}static addTarget(r){if(!D.isTouchDevice())return S.$Tc.None;D.b||(D.b=(0,S.$Mc)(new D));const l=D.b.g.push(r);return(0,S.$Rc)(l)}static ignoreTarget(r){if(!D.isTouchDevice())return S.$Tc.None;D.b||(D.b=(0,S.$Mc)(new D));const l=D.b.h.push(r);return(0,S.$Rc)(l)}static isTouchDevice(){return"ontouchstart"in T.$0O||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(r){const l=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,s=r.targetTouches.length;e<s;e++){const g=r.targetTouches.item(e);this.m[g.identifier]={id:g.identifier,initialTarget:g.target,initialTimeStamp:l,initialPageX:g.pageX,initialPageY:g.pageY,rollingTimestamps:[l],rollingPageX:[g.pageX],rollingPageY:[g.pageY]};const b=this.w(w.Start,g.target);b.pageX=g.pageX,b.pageY=g.pageY,this.z(b)}this.f&&(r.preventDefault(),r.stopPropagation(),this.f=!1)}u(r,l){const e=Date.now(),s=Object.keys(this.m).length;for(let g=0,b=l.changedTouches.length;g<b;g++){const h=l.changedTouches.item(g);if(!this.m.hasOwnProperty(String(h.identifier))){console.warn("move of an UNKNOWN touch",h);continue}const $=this.m[h.identifier],c=Date.now()-$.initialTimeStamp;if(c<D.c&&Math.abs($.initialPageX-n.$sb($.rollingPageX))<30&&Math.abs($.initialPageY-n.$sb($.rollingPageY))<30){const f=this.w(w.Tap,$.initialTarget);f.pageX=n.$sb($.rollingPageX),f.pageY=n.$sb($.rollingPageY),this.z(f)}else if(c>=D.c&&Math.abs($.initialPageX-n.$sb($.rollingPageX))<30&&Math.abs($.initialPageY-n.$sb($.rollingPageY))<30){const f=this.w(w.Contextmenu,$.initialTarget);f.pageX=n.$sb($.rollingPageX),f.pageY=n.$sb($.rollingPageY),this.z(f)}else if(s===1){const f=n.$sb($.rollingPageX),a=n.$sb($.rollingPageY),C=n.$sb($.rollingTimestamps)-$.rollingTimestamps[0],O=f-$.rollingPageX[0],L=a-$.rollingPageY[0],B=[...this.g].filter(v=>$.initialTarget instanceof Node&&v.contains($.initialTarget));this.C(r,B,e,Math.abs(O)/C,O>0?1:-1,f,Math.abs(L)/C,L>0?1:-1,a)}this.z(this.w(w.End,$.initialTarget)),delete this.m[h.identifier]}this.f&&(l.preventDefault(),l.stopPropagation(),this.f=!1)}w(r,l){const e=document.createEvent("CustomEvent");return e.initEvent(r,!1,!0),e.initialTarget=l,e.tapCount=0,e}z(r){if(r.type===w.Tap){const l=new Date().getTime();let e=0;l-this.n>D.r?e=1:e=2,this.n=l,r.tapCount=e}else(r.type===w.Change||r.type===w.Contextmenu)&&(this.n=0);if(r.initialTarget instanceof Node){for(const l of this.h)if(l.contains(r.initialTarget))return;for(const l of this.g)l.contains(r.initialTarget)&&(l.dispatchEvent(r),this.f=!0)}}C(r,l,e,s,g,b,h,$,c){this.j=k.$PP(r,()=>{const f=Date.now(),a=f-e;let C=0,O=0,L=!0;s+=D.a*a,h+=D.a*a,s>0&&(L=!1,C=g*s*a),h>0&&(L=!1,O=$*h*a);const B=this.w(w.Change);B.translationX=C,B.translationY=O,l.forEach(v=>v.dispatchEvent(B)),L||this.C(r,l,f,s,g,b+C,h,$,c+O)})}D(r){const l=Date.now();for(let e=0,s=r.changedTouches.length;e<s;e++){const g=r.changedTouches.item(e);if(!this.m.hasOwnProperty(String(g.identifier))){console.warn("end of an UNKNOWN touch",g);continue}const b=this.m[g.identifier],h=this.w(w.Change,b.initialTarget);h.translationX=g.pageX-n.$sb(b.rollingPageX),h.translationY=g.pageY-n.$sb(b.rollingPageY),h.pageX=g.pageX,h.pageY=g.pageY,this.z(h),b.rollingPageX.length>3&&(b.rollingPageX.shift(),b.rollingPageY.shift(),b.rollingTimestamps.shift()),b.rollingPageX.push(g.pageX),b.rollingPageY.push(g.pageY),b.rollingTimestamps.push(l)}this.f&&(r.preventDefault(),r.stopPropagation(),this.f=!1)}}t.$cR=D,Xe([H.$xh],D,"isTouchDevice",null)}),define(be[57],$e([1,0,3,92]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JR=t.$IR=t.$HR=void 0;const T=2e4;let n,H,A,S,m;function w(l){n=document.createElement("div"),n.className="monaco-aria-container";const e=()=>{const g=document.createElement("div");return g.className="monaco-alert",g.setAttribute("role","alert"),g.setAttribute("aria-atomic","true"),n.appendChild(g),g};H=e(),A=e();const s=()=>{const g=document.createElement("div");return g.className="monaco-status",g.setAttribute("aria-live","polite"),g.setAttribute("aria-atomic","true"),n.appendChild(g),g};S=s(),m=s(),l.appendChild(n)}t.$HR=w;function D(l){n&&(H.textContent!==l?(k.$EP(A),r(H,l)):(k.$EP(H),r(A,l)))}t.$IR=D;function M(l){n&&(S.textContent!==l?(k.$EP(m),r(S,l)):(k.$EP(S),r(m,l)))}t.$JR=M;function r(l,e){k.$EP(l),e.length>T&&(e=e.substr(0,T)),l.textContent=e,l.style.visibility="hidden",l.style.visibility="visible"}}),define(be[119],$e([1,0,3,18]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bS=t.$aS=void 0;const n=new RegExp(`(\\\\)?\\$\\((${T.ThemeIcon.iconNameExpression}(?:${T.ThemeIcon.iconModifierExpression})?)\\)`,"g");function H(S){const m=new Array;let w,D=0,M=0;for(;(w=n.exec(S))!==null;){M=w.index||0,D<M&&m.push(S.substring(D,M)),D=(w.index||0)+w[0].length;const[,r,l]=w;m.push(r?`$(${l})`:A({id:l}))}return D<S.length&&m.push(S.substring(D)),m}t.$aS=H;function A(S){const m=k.$("span");return m.classList.add(...T.ThemeIcon.asClassNameArray(S)),m}t.$bS=A}),define(be[120],$e([1,0,3]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PR=void 0;function T(H){try{H.parentElement?.removeChild(H)}catch{}}class n{constructor(A){this.d=A,this.a=new Map,this.b=new Set,this.c=!1}alloc(A){let S=this.h(A).pop(),m=!1;if(S)m=this.b.has(S.domNode),m&&this.b.delete(S.domNode);else{const w=(0,k.$)(".monaco-list-row"),M=this.i(A).renderTemplate(w);S={domNode:w,templateId:A,templateData:M}}return{row:S,isReusingConnectedDomNode:m}}release(A){A&&this.f(A)}transact(A){if(this.c)throw new Error("Already in transaction");this.c=!0;try{A()}finally{for(const S of this.b)this.g(S);this.b.clear(),this.c=!1}}f(A){const{domNode:S,templateId:m}=A;S&&(this.c?this.b.add(S):this.g(S)),this.h(m).push(A)}g(A){A.classList.remove("scrolling"),T(A)}h(A){let S=this.a.get(A);return S||(S=[],this.a.set(A,S)),S}dispose(){this.a.forEach((A,S)=>{for(const m of A)this.i(S).disposeTemplate(m.templateData),m.templateData=null}),this.a.clear(),this.b.clear()}i(A){const S=this.d.get(A);if(!S)throw new Error(`No renderer found for ${A}`);return S}}t.$PR=n}),define(be[121],$e([1,0,9,2]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kR=void 0;class n extends T.$Tc{constructor(A,S,m){super(),this.a=A,this.b=S,this.c=m,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new k.$dh)}setVisibility(A){this.a!==A&&(this.a=A,this.s())}setShouldBeVisible(A){this.g=A,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const A=this.r();this.h!==A&&(this.h=A,this.ensureVisibility())}setIsNeeded(A){this.j!==A&&(this.j=A,this.ensureVisibility())}setDomNode(A){this.f=A,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(A){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(A?" fade":"")))}}t.$kR=n}),define(be[122],$e([1,0,3,25,12,4,2,5]),function(ie,t,k,T,n,H,A,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iS=void 0;class m extends A.$Tc{constructor(D,M,r,l){super(),this.f=0,this.b=l||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.$Vd),this.h=r,this.j(),this.setOptions(D,M)}j(){this.B(T.$cR.addTarget(this.a)),[T.EventType.Tap].forEach(D=>{this.B(k.$FP(this.a,D,M=>{this.a.focus()}))}),this.B(k.$GP(this.a,"click",D=>{k.$AQ.stop(D,!0)})),this.B(k.$GP(this.a,"change",D=>{this.a.title=D.target.value,this.g.fire({index:D.target.selectedIndex,selected:D.target.value})})),this.B(k.$GP(this.a,"keydown",D=>{let M=!1;S.$j?(D.keyCode===18||D.keyCode===16||D.keyCode===10)&&(M=!0):(D.keyCode===18&&D.altKey||D.keyCode===10||D.keyCode===3)&&(M=!0),M&&D.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(D,M){(!this.c||!n.$ub(this.c,D))&&(this.c=D,this.a.options.length=0,this.c.forEach((r,l)=>{this.a.add(this.m(r.text,l,r.isDisabled))})),M!==void 0&&this.select(M)}select(D){this.c.length===0?this.f=0:D>=0&&D<this.c.length?this.f=D:D>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(D){this.b.ariaLabel=D,this.a.setAttribute("aria-label",D)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(D){this.a.tabIndex=D?0:-1}render(D){D.classList.add("select-container"),D.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(D){this.h=D,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(D,M,r){const l=document.createElement("option");return l.value=D,l.text=D,l.disabled=!!r,l}}t.$iS=m}),define(be[58],$e([1,0,26,12,9,50,87,4,28]),function(ie,t,k,T,n,H,A,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QT=t.$PT=t.$OT=void 0;function w(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.$OT=w;function D(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.$PT=D;function M(l){return typeof l.collapsible=="boolean"}class r{constructor(e,s,g,b={}){this.o=e,this.p=s,this.rootRef=[],this.d=new S.$4d,this.f=new S.$Vd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new S.$Vd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new S.$Vd,this.onDidSplice=this.l.event,this.m=new n.$3g(H.$Sd),this.h=typeof b.collapseByDefault>"u"?!1:b.collapseByDefault,this.j=b.filter,this.k=typeof b.autoExpandSingleChildren>"u"?!1:b.autoExpandSingleChildren,this.c={parent:void 0,element:g,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,s,g=m.Iterable.empty(),b={}){if(e.length===0)throw new k.$MT(this.o,"Invalid tree location");b.diffIdentityProvider?this.q(b.diffIdentityProvider,e,s,g,b):this.s(e,s,g,b)}q(e,s,g,b=m.Iterable.empty(),h,$=h.diffDepth??0){const{parentNode:c}=this.G(s);if(!c.lastDiffIds)return this.s(s,g,b,h);const f=[...b],a=s[s.length-1],C=new A.$1s({getElements:()=>c.lastDiffIds},{getElements:()=>[...c.children.slice(0,a),...f,...c.children.slice(a+g)].map(P=>e.getId(P.element).toString())}).ComputeDiff(!1);if(C.quitEarly)return c.lastDiffIds=void 0,this.s(s,g,f,h);const O=s.slice(0,-1),L=(P,V,U)=>{if($>0)for(let N=0;N<U;N++)P--,V--,this.q(e,[...O,P,0],Number.MAX_SAFE_INTEGER,f[V].children,h,$-1)};let B=Math.min(c.children.length,a+g),v=f.length;for(const P of C.changes.sort((V,U)=>U.originalStart-V.originalStart))L(B,v,B-(P.originalStart+P.originalLength)),B=P.originalStart,v=P.modifiedStart-a,this.s([...O,B],P.originalLength,m.Iterable.slice(f,v,v+P.modifiedLength),h);L(B,v,B)}s(e,s,g=m.Iterable.empty(),{onDidCreateNode:b,onDidDeleteNode:h,diffIdentityProvider:$}){const{parentNode:c,listIndex:f,revealed:a,visible:C}=this.G(e),O=[],L=m.Iterable.map(g,X=>this.w(X,c,c.visible?1:0,a,O,b)),B=e[e.length-1];let v=0;for(let X=B;X>=0&&X<c.children.length;X--){const Y=c.children[X];if(Y.visible){v=Y.visibleChildIndex;break}}const P=[];let V=0,U=0;for(const X of L)P.push(X),U+=X.renderNodeCount,X.visible&&(X.visibleChildIndex=v+V++);const N=(0,T.$6b)(c.children,B,s,P);$?c.lastDiffIds?(0,T.$6b)(c.lastDiffIds,B,s,P.map(X=>$.getId(X.element).toString())):c.lastDiffIds=c.children.map(X=>$.getId(X.element).toString()):c.lastDiffIds=void 0;let I=0;for(const X of N)X.visible&&I++;if(I!==0)for(let X=B+P.length;X<c.children.length;X++){const Y=c.children[X];Y.visible&&(Y.visibleChildIndex-=I)}if(c.visibleChildrenCount+=V-I,a&&C){const X=N.reduce((Y,fe)=>Y+(fe.visible?fe.renderNodeCount:0),0);this.B(c,U-X),this.p.splice(f,X,O)}if(N.length>0&&h){const X=Y=>{h(Y),Y.children.forEach(X)};N.forEach(X)}this.l.fire({insertedNodes:P,deletedNodes:N});let z=c;for(;z;){if(z.visibility===2){this.m.trigger(()=>this.refilter());break}z=z.parent}}rerender(e){if(e.length===0)throw new k.$MT(this.o,"Invalid tree location");const{node:s,listIndex:g,revealed:b}=this.F(e);s.visible&&b&&this.p.splice(g,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new k.$MT(this.o,"Invalid tree location");const{listIndex:g}=this.F(e);this.p.updateElementHeight(g,s)}has(e){return this.D(e)}getListIndex(e){const{listIndex:s,visible:g,revealed:b}=this.F(e);return g&&b?s:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,s){const g=this.E(e);typeof s>"u"&&(s=!g.collapsible);const b={collapsible:s};return this.d.bufferEvents(()=>this.t(e,b))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,s,g){const b=this.E(e);typeof s>"u"&&(s=!b.collapsed);const h={collapsed:s,recursive:g||!1};return this.d.bufferEvents(()=>this.t(e,h))}t(e,s){const{node:g,listIndex:b,revealed:h}=this.F(e),$=this.u(g,b,h,s);if(g!==this.c&&this.k&&$&&!M(s)&&g.collapsible&&!g.collapsed&&!s.recursive){let c=-1;for(let f=0;f<g.children.length;f++)if(g.children[f].visible)if(c>-1){c=-1;break}else c=f;c>-1&&this.t([...e,c],s)}return $}u(e,s,g,b){const h=this.v(e,b,!1);if(!g||!e.visible||!h)return h;const $=e.renderNodeCount,c=this.x(e),f=$-(s===-1?0:1);return this.p.splice(s+1,f,c.slice(1)),h}v(e,s,g){let b;if(e===this.c?b=!1:(M(s)?(b=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(b=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):b=!1,b&&this.f.fire({node:e,deep:g})),!M(s)&&s.recursive)for(const h of e.children)b=this.v(h,s,!0)||b;return b}expandTo(e){this.d.bufferEvents(()=>{let s=this.E(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,e,s),this.m.cancel()}w(e,s,g,b,h,$){const c={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},f=this.C(c,g);c.visibility=f,b&&h.push(c);const a=e.children||m.Iterable.empty(),C=b&&f!==0&&!c.collapsed;let O=0,L=1;for(const B of a){const v=this.w(B,c,f,C,h,$);c.children.push(v),L+=v.renderNodeCount,v.visible&&(v.visibleChildIndex=O++)}return c.collapsible=c.collapsible||c.children.length>0,c.visibleChildrenCount=O,c.visible=f===2?O>0:f===1,c.visible?c.collapsed||(c.renderNodeCount=L):(c.renderNodeCount=0,b&&h.pop()),$?.(c),c}x(e){const s=e.renderNodeCount,g=[];return this.y(e,g),this.B(e.parent,g.length-s),g}y(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const g of e.children)e.renderNodeCount+=this.y(g,s);return this.g.fire(e),e.renderNodeCount}z(e){const s=e.renderNodeCount,g=[];return this.A(e,e.visible?1:0,g),this.B(e.parent,g.length-s),g}A(e,s,g,b=!0){let h;if(e!==this.c){if(h=this.C(e,s),h===0)return e.visible=!1,e.renderNodeCount=0,!1;b&&g.push(e)}const $=g.length;e.renderNodeCount=e===this.c?0:1;let c=!1;if(!e.collapsed||h!==0){let f=0;for(const a of e.children)c=this.A(a,h,g,b&&!e.collapsed)||c,a.visible&&(a.visibleChildIndex=f++);e.visibleChildrenCount=f}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=h===2?c:h===1,e.visibility=h),e.visible?e.collapsed||(e.renderNodeCount+=g.length-$):(e.renderNodeCount=0,b&&g.pop()),this.g.fire(e),e.visible}B(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}C(e,s){const g=this.j?this.j.filter(e.element,s):1;return typeof g=="boolean"?(e.filterData=void 0,g?1:0):w(g)?(e.filterData=g.data,D(g.visibility)):(e.filterData=void 0,D(g))}D(e,s=this.c){if(!e||e.length===0)return!0;const[g,...b]=e;return g<0||g>s.children.length?!1:this.D(b,s.children[g])}E(e,s=this.c){if(!e||e.length===0)return s;const[g,...b]=e;if(g<0||g>s.children.length)throw new k.$MT(this.o,"Invalid tree location");return this.E(b,s.children[g])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:g,revealed:b,visible:h}=this.G(e),$=e[e.length-1];if($<0||$>s.children.length)throw new k.$MT(this.o,"Invalid tree location");const c=s.children[$];return{node:c,listIndex:g,revealed:b,visible:h&&c.visible}}G(e,s=this.c,g=0,b=!0,h=!0){const[$,...c]=e;if($<0||$>s.children.length)throw new k.$MT(this.o,"Invalid tree location");for(let f=0;f<$;f++)g+=s.children[f].renderNodeCount;return b=b&&!s.collapsed,h=h&&s.visible,c.length===0?{parentNode:s,listIndex:g,revealed:b,visible:h}:this.G(c,s.children[$],g+1,b,h)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const s=[];let g=e;for(;g.parent;)s.push(g.parent.children.indexOf(g)),g=g.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,T.$tb)(e)[0]}getFirstElementChild(e){const s=this.E(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.E(e);if(s.children.length!==0)return this.H(s)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$QT=r}),define(be[123],$e([1,0,58,26,28]),function(ie,t,k,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XT=void 0;class H{get size(){return this.d.size}constructor(S,m,w={}){this.k=S,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new k.$QT(S,m,null,w),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,w.sorter&&(this.j={compare(D,M){return w.sorter.compare(D.element,M.element)}}),this.h=w.identityProvider}setChildren(S,m=n.Iterable.empty(),w={}){const D=this.o(S);this.l(D,this.m(m),w)}l(S,m=n.Iterable.empty(),w){const D=new Set,M=new Set,r=e=>{if(e.element===null)return;const s=e;if(D.add(s.element),this.d.set(s.element,s),this.h){const g=this.h.getId(s.element).toString();M.add(g),this.f.set(g,s)}w.onDidCreateNode?.(s)},l=e=>{if(e.element===null)return;const s=e;if(D.has(s.element)||this.d.delete(s.element),this.h){const g=this.h.getId(s.element).toString();M.has(g)||this.f.delete(g)}w.onDidDeleteNode?.(s)};this.c.splice([...S,0],Number.MAX_VALUE,m,{...w,onDidCreateNode:r,onDidDeleteNode:l})}m(S=n.Iterable.empty()){return this.j&&(S=[...S].sort(this.j.compare.bind(this.j))),n.Iterable.map(S,m=>{let w=this.d.get(m.element);if(!w&&this.h){const r=this.h.getId(m.element).toString();w=this.f.get(r)}if(!w){let r;return typeof m.collapsed>"u"?r=void 0:m.collapsed===T.ObjectTreeElementCollapseState.Collapsed||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:m.collapsed===T.ObjectTreeElementCollapseState.Expanded||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=!!m.collapsed,{...m,children:this.m(m.children),collapsed:r}}const D=typeof m.collapsible=="boolean"?m.collapsible:w.collapsible;let M;return typeof m.collapsed>"u"||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?M=w.collapsed:m.collapsed===T.ObjectTreeElementCollapseState.Collapsed?M=!0:m.collapsed===T.ObjectTreeElementCollapseState.Expanded?M=!1:M=!!m.collapsed,{...m,collapsible:D,collapsed:M,children:this.m(m.children)}})}rerender(S){const m=this.o(S);this.c.rerender(m)}updateElementHeight(S,m){const w=this.o(S);this.c.updateElementHeight(w,m)}resort(S=null,m=!0){if(!this.j)return;const w=this.o(S),D=this.c.getNode(w);this.l(w,this.n(D,m),{})}n(S,m,w=!0){let D=[...S.children];return(m||w)&&(D=D.sort(this.j.compare.bind(this.j))),n.Iterable.map(D,M=>({element:M.element,collapsible:M.collapsible,collapsed:M.collapsed,children:this.n(M,m,!1)}))}getFirstElementChild(S=null){const m=this.o(S);return this.c.getFirstElementChild(m)}getLastElementAncestor(S=null){const m=this.o(S);return this.c.getLastElementAncestor(m)}has(S){return this.d.has(S)}getListIndex(S){const m=this.o(S);return this.c.getListIndex(m)}getListRenderCount(S){const m=this.o(S);return this.c.getListRenderCount(m)}isCollapsible(S){const m=this.o(S);return this.c.isCollapsible(m)}setCollapsible(S,m){const w=this.o(S);return this.c.setCollapsible(w,m)}isCollapsed(S){const m=this.o(S);return this.c.isCollapsed(m)}setCollapsed(S,m,w){const D=this.o(S);return this.c.setCollapsed(D,m,w)}expandTo(S){const m=this.o(S);this.c.expandTo(m)}refilter(){this.c.refilter()}getNode(S=null){if(S===null)return this.c.getNode(this.c.rootRef);const m=this.d.get(S);if(!m)throw new T.$MT(this.k,`Tree element not found: ${S}`);return m}getNodeLocation(S){return S.element}getParentNodeLocation(S){if(S===null)throw new T.$MT(this.k,"Invalid getParentNodeLocation call");const m=this.d.get(S);if(!m)throw new T.$MT(this.k,`Tree element not found: ${S}`);const w=this.c.getNodeLocation(m),D=this.c.getParentNodeLocation(w);return this.c.getNode(D).element}o(S){if(S===null)return[];const m=this.d.get(S);if(!m)throw new T.$MT(this.k,`Tree element not found: ${S}`);return this.c.getNodeLocation(m)}}t.$XT=H}),define(be[20],$e([1,0,3,14,19,25,2]),function(ie,t,k,T,n,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gR=void 0;class S extends A.$Tc{f(w,D){this.B(k.$FP(w,k.$yQ.CLICK,M=>D(new n.$xP(k.getWindow(w),M))))}j(w,D){this.B(k.$FP(w,k.$yQ.MOUSE_DOWN,M=>D(new n.$xP(k.getWindow(w),M))))}m(w,D){this.B(k.$FP(w,k.$yQ.MOUSE_OVER,M=>D(new n.$xP(k.getWindow(w),M))))}u(w,D){this.B(k.$FP(w,k.$yQ.MOUSE_LEAVE,M=>D(new n.$xP(k.getWindow(w),M))))}z(w,D){this.B(k.$FP(w,k.$yQ.KEY_DOWN,M=>D(new T.$CP(M))))}C(w,D){this.B(k.$FP(w,k.$yQ.KEY_UP,M=>D(new T.$CP(M))))}D(w,D){this.B(k.$FP(w,k.$yQ.INPUT,D))}F(w,D){this.B(k.$FP(w,k.$yQ.BLUR,D))}G(w,D){this.B(k.$FP(w,k.$yQ.FOCUS,D))}H(w,D){this.B(k.$FP(w,k.$yQ.CHANGE,D))}I(w){return H.$cR.ignoreTarget(w)}}t.$gR=S}),define(be[38],$e([1,0,56,20,9,18,3]),function(ie,t,k,T,n,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iR=t.$hR=void 0,t.$hR=11;class S extends T.$gR{constructor(w){super(),this.a=w.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=w.bgWidth+"px",this.bgDomNode.style.height=w.bgHeight+"px",typeof w.top<"u"&&(this.bgDomNode.style.top="0px"),typeof w.left<"u"&&(this.bgDomNode.style.left="0px"),typeof w.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof w.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=w.className,this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(w.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$hR+"px",this.domNode.style.height=t.$hR+"px",typeof w.top<"u"&&(this.domNode.style.top=w.top+"px"),typeof w.left<"u"&&(this.domNode.style.left=w.left+"px"),typeof w.bottom<"u"&&(this.domNode.style.bottom=w.bottom+"px"),typeof w.right<"u"&&(this.domNode.style.right=w.right+"px"),this.g=this.B(new k.$fR),this.B(A.$GP(this.bgDomNode,A.$yQ.POINTER_DOWN,D=>this.h(D))),this.B(A.$GP(this.domNode,A.$yQ.POINTER_DOWN,D=>this.h(D))),this.b=this.B(new A.$RP),this.c=this.B(new n.$dh)}h(w){if(!w.target||!(w.target instanceof Element))return;const D=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,A.getWindow(w))};this.a(),this.b.cancel(),this.c.cancelAndSet(D,200),this.g.startMonitoring(w.target,w.pointerId,w.buttons,M=>{},()=>{this.b.cancel(),this.c.cancel()}),w.preventDefault()}}t.$iR=S}),define(be[59],$e([1,0,3,41,56,38,121,20,5]),function(ie,t,k,T,n,H,A,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lR=void 0;const w=140;class D extends S.$gR{constructor(r){super(),this.g=r.lazyRender,this.a=r.host,this.b=r.scrollable,this.c=r.scrollByPage,this.h=r.scrollbarState,this.n=this.B(new A.$kR(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new n.$fR),this.s=!0,this.domNode=(0,T.$eR)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(k.$FP(this.domNode.domNode,k.$yQ.POINTER_DOWN,l=>this.M(l)))}t(r){const l=this.B(new H.$iR(r));this.domNode.domNode.appendChild(l.bgDomNode),this.domNode.domNode.appendChild(l.domNode)}w(r,l,e,s){this.slider=(0,T.$eR)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(l),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(k.$FP(this.slider.domNode,k.$yQ.POINTER_DOWN,g=>{g.button===0&&(g.preventDefault(),this.O(g))})),this.f(this.slider.domNode,g=>{g.leftButton&&g.stopPropagation()})}y(r){return this.h.setVisibleSize(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(r){return this.h.setScrollSize(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(r){return this.h.setScrollPosition(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(r){r.target===this.domNode.domNode&&this.N(r)}delegatePointerDown(r){const l=this.domNode.domNode.getClientRects()[0].top,e=l+this.h.getSliderPosition(),s=l+this.h.getSliderPosition()+this.h.getSliderSize(),g=this.U(r);e<=g&&g<=s?r.button===0&&(r.preventDefault(),this.O(r)):this.N(r)}N(r){let l,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")l=r.offsetX,e=r.offsetY;else{const g=k.$2P(this.domNode.domNode);l=r.pageX-g.left,e=r.pageY-g.top}const s=this.S(l,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),r.button===0&&(r.preventDefault(),this.O(r))}O(r){if(!r.target||!(r.target instanceof Element))return;const l=this.U(r),e=this.W(r),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(r.target,r.pointerId,r.buttons,g=>{const b=this.W(g),h=Math.abs(b-e);if(m.$i&&h>w){this.P(s.getScrollPosition());return}const c=this.U(g)-l;this.P(s.getDesiredScrollPositionFromDelta(c))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(r){const l={};this.writeScrollPosition(l,r),this.b.setScrollPositionNow(l)}updateScrollbarSize(r){this.X(r),this.h.setScrollbarSize(r),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$lR=D}),define(be[124],$e([1,0,19,59,38,42,17]),function(ie,t,k,T,n,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mR=void 0;class S extends T.$lR{constructor(w,D,M){const r=w.getScrollDimensions(),l=w.getCurrentScrollPosition();if(super({lazyRender:D.lazyRender,host:M,scrollbarState:new H.$jR(D.horizontalHasArrows?D.arrowSize:0,D.horizontal===2?0:D.horizontalScrollbarSize,D.vertical===2?0:D.verticalScrollbarSize,r.width,r.scrollWidth,l.scrollLeft),visibility:D.horizontal,extraScrollbarClassName:"horizontal",scrollable:w,scrollByPage:D.scrollByPage}),D.horizontalHasArrows){const e=(D.arrowSize-n.$hR)/2,s=(D.horizontalScrollbarSize-n.$hR)/2;this.t({className:"scra",icon:A.$_j.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:D.arrowSize,bgHeight:D.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new k.$zP(null,1,0))}),this.t({className:"scra",icon:A.$_j.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:D.arrowSize,bgHeight:D.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new k.$zP(null,-1,0))})}this.w(Math.floor((D.horizontalScrollbarSize-D.horizontalSliderSize)/2),0,void 0,D.horizontalSliderSize)}R(w,D){this.slider.setWidth(w),this.slider.setLeft(D)}Q(w,D){this.domNode.setWidth(w),this.domNode.setHeight(D),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(w){return this.s=this.J(w.scrollWidth)||this.s,this.s=this.L(w.scrollLeft)||this.s,this.s=this.y(w.width)||this.s,this.s}S(w,D){return w}U(w){return w.pageX}W(w){return w.pageY}X(w){this.slider.setHeight(w)}writeScrollPosition(w,D){w.scrollLeft=D}updateOptions(w){this.updateScrollbarSize(w.horizontal===2?0:w.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(w.vertical===2?0:w.verticalScrollbarSize),this.n.setVisibility(w.horizontal),this.c=w.scrollByPage}}t.$mR=S}),define(be[125],$e([1,0,19,59,38,42,17]),function(ie,t,k,T,n,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nR=void 0;class S extends T.$lR{constructor(w,D,M){const r=w.getScrollDimensions(),l=w.getCurrentScrollPosition();if(super({lazyRender:D.lazyRender,host:M,scrollbarState:new H.$jR(D.verticalHasArrows?D.arrowSize:0,D.vertical===2?0:D.verticalScrollbarSize,0,r.height,r.scrollHeight,l.scrollTop),visibility:D.vertical,extraScrollbarClassName:"vertical",scrollable:w,scrollByPage:D.scrollByPage}),D.verticalHasArrows){const e=(D.arrowSize-n.$hR)/2,s=(D.verticalScrollbarSize-n.$hR)/2;this.t({className:"scra",icon:A.$_j.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:D.verticalScrollbarSize,bgHeight:D.arrowSize,onActivate:()=>this.a.onMouseWheel(new k.$zP(null,0,1))}),this.t({className:"scra",icon:A.$_j.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:D.verticalScrollbarSize,bgHeight:D.arrowSize,onActivate:()=>this.a.onMouseWheel(new k.$zP(null,0,-1))})}this.w(0,Math.floor((D.verticalScrollbarSize-D.verticalSliderSize)/2),D.verticalSliderSize,void 0)}R(w,D){this.slider.setHeight(w),this.slider.setTop(D)}Q(w,D){this.domNode.setWidth(D),this.domNode.setHeight(w),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(w){return this.s=this.J(w.scrollHeight)||this.s,this.s=this.L(w.scrollTop)||this.s,this.s=this.y(w.height)||this.s,this.s}S(w,D){return D}U(w){return w.pageY}W(w){return w.pageX}X(w){this.slider.setWidth(w)}writeScrollPosition(w,D){w.scrollTop=D}updateOptions(w){this.updateScrollbarSize(w.vertical===2?0:w.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(w.vertical),this.c=w.scrollByPage}}t.$nR=S}),define(be[60],$e([1,0,16,3,41,19,124,125,20,9,4,2,5,48,99]),function(ie,t,k,T,n,H,A,S,m,w,D,M,r,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sR=t.$rR=t.$qR=t.$pR=t.$oR=void 0;const e=500,s=50,g=!0;class b{constructor(L,B,v){this.timestamp=L,this.deltaX=B,this.deltaY=v,this.score=0}}class h{static{this.INSTANCE=new h}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let L=1,B=0,v=1,P=this.d;do{const V=P===this.c?L:Math.pow(2,-v);if(L-=V,B+=this.b[P].score*V,P===this.c)break;P=(this.a+P-1)%this.a,v++}while(!0);return B<=.5}acceptStandardWheelEvent(L){const B=T.getWindow(L.browserEvent),v=B.devicePixelRatio/(0,k.$gP)(B);r.$i||r.$k?this.accept(Date.now(),L.deltaX/v,L.deltaY/v):this.accept(Date.now(),L.deltaX,L.deltaY)}accept(L,B,v){const P=new b(L,B,v);P.score=this.f(P),this.c===-1&&this.d===-1?(this.b[0]=P,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=P)}f(L){if(Math.abs(L.deltaX)>0&&Math.abs(L.deltaY)>0)return 1;let B=.5;const v=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(L.deltaX)||!this.g(L.deltaY))&&(B+=.25),Math.min(Math.max(B,0),1)}g(L){return Math.abs(Math.round(L)-L)<.01}}t.$oR=h;class $ extends m.$gR{get options(){return this.a}constructor(L,B,v){super(),this.O=this.B(new D.$Vd),this.onScroll=this.O.event,this.P=this.B(new D.$Vd),this.onWillScroll=this.P.event,L.style.overflow="hidden",this.a=C(B),this.b=v,this.B(this.b.onScroll(V=>{this.P.fire(V),this.S(V),this.O.fire(V)}));const P={onMouseWheel:V=>this.R(V),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new S.$nR(this.b,this.a,P)),this.g=this.B(new A.$mR(this.b,this.a,P)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(L),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,n.$eR)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,n.$eR)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,n.$eR)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,V=>this.Z(V)),this.u(this.t,V=>this.Y(V)),this.L=this.B(new w.$dh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,M.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(L){this.c.delegatePointerDown(L)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(L){this.b.setScrollDimensions(L,!1)}updateClassName(L){this.a.className=L,r.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(L){typeof L.handleMouseWheel<"u"&&(this.a.handleMouseWheel=L.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof L.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=L.mouseWheelScrollSensitivity),typeof L.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=L.fastScrollSensitivity),typeof L.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=L.scrollPredominantAxis),typeof L.horizontal<"u"&&(this.a.horizontal=L.horizontal),typeof L.vertical<"u"&&(this.a.vertical=L.vertical),typeof L.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=L.horizontalScrollbarSize),typeof L.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=L.verticalScrollbarSize),typeof L.scrollByPage<"u"&&(this.a.scrollByPage=L.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(L){this.N=L}delegateScrollFromMouseWheelEvent(L){this.R(new H.$zP(L))}Q(L){if(this.w.length>0!==L&&(this.w=(0,M.$Oc)(this.w),L)){const v=P=>{this.R(new H.$zP(P))};this.w.push(T.$FP(this.t,T.$yQ.MOUSE_WHEEL,v,{passive:!1}))}}R(L){if(L.browserEvent?.defaultPrevented)return;const B=h.INSTANCE;g&&B.acceptStandardWheelEvent(L);let v=!1;if(L.deltaY||L.deltaX){let V=L.deltaY*this.a.mouseWheelScrollSensitivity,U=L.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&U+V===0?U=V=0:Math.abs(V)>=Math.abs(U)?U=0:V=0),this.a.flipAxes&&([V,U]=[U,V]);const N=!r.$j&&L.browserEvent&&L.browserEvent.shiftKey;(this.a.scrollYToX||N)&&!U&&(U=V,V=0),L.browserEvent&&L.browserEvent.altKey&&(U=U*this.a.fastScrollSensitivity,V=V*this.a.fastScrollSensitivity);const I=this.b.getFutureScrollPosition();let z={};if(V){const X=s*V,Y=I.scrollTop-(X<0?Math.floor(X):Math.ceil(X));this.c.writeScrollPosition(z,Y)}if(U){const X=s*U,Y=I.scrollLeft-(X<0?Math.floor(X):Math.ceil(X));this.g.writeScrollPosition(z,Y)}z=this.b.validateScrollPosition(z),(I.scrollLeft!==z.scrollLeft||I.scrollTop!==z.scrollTop)&&(g&&this.a.mouseWheelSmoothScroll&&B.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(z):this.b.setScrollPositionNow(z),v=!0)}let P=v;!P&&this.a.alwaysConsumeMouseWheel&&(P=!0),!P&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(P=!0),P&&(L.preventDefault(),L.stopPropagation())}S(L){this.M=this.g.onDidScroll(L)||this.M,this.M=this.c.onDidScroll(L)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const L=this.b.getCurrentScrollPosition(),B=L.scrollTop>0,v=L.scrollLeft>0,P=v?" left":"",V=B?" top":"",U=v||B?" top-left-corner":"";this.n.setClassName(`shadow${P}`),this.r.setClassName(`shadow${V}`),this.s.setClassName(`shadow${U}${V}${P}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(L){this.J=!1,this.ab()}Z(L){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$pR=$;class c extends ${constructor(L,B){B=B||{},B.mouseWheelSmoothScroll=!1;const v=new l.$ls({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:P=>T.$PP(T.getWindow(L),P)});super(L,B,v),this.B(v)}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$qR=c;class f extends ${constructor(L,B,v){super(L,B,v)}setScrollPosition(L){L.reuseAnimation?this.b.setScrollPositionSmooth(L,L.reuseAnimation):this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$rR=f;class a extends ${constructor(L,B){B=B||{},B.mouseWheelSmoothScroll=!1;const v=new l.$ls({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:P=>T.$PP(T.getWindow(L),P)});super(L,B,v),this.B(v),this.cb=L,this.B(this.onScroll(P=>{P.scrollTopChanged&&(this.cb.scrollTop=P.scrollTop),P.scrollLeftChanged&&(this.cb.scrollLeft=P.scrollLeft)})),this.scanDomNode()}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$sR=a;function C(O){const L={lazyRender:typeof O.lazyRender<"u"?O.lazyRender:!1,className:typeof O.className<"u"?O.className:"",useShadows:typeof O.useShadows<"u"?O.useShadows:!0,handleMouseWheel:typeof O.handleMouseWheel<"u"?O.handleMouseWheel:!0,flipAxes:typeof O.flipAxes<"u"?O.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof O.consumeMouseWheelIfScrollbarIsNeeded<"u"?O.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof O.alwaysConsumeMouseWheel<"u"?O.alwaysConsumeMouseWheel:!1,scrollYToX:typeof O.scrollYToX<"u"?O.scrollYToX:!1,mouseWheelScrollSensitivity:typeof O.mouseWheelScrollSensitivity<"u"?O.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof O.fastScrollSensitivity<"u"?O.fastScrollSensitivity:5,scrollPredominantAxis:typeof O.scrollPredominantAxis<"u"?O.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof O.mouseWheelSmoothScroll<"u"?O.mouseWheelSmoothScroll:!0,arrowSize:typeof O.arrowSize<"u"?O.arrowSize:11,listenOnDomNode:typeof O.listenOnDomNode<"u"?O.listenOnDomNode:null,horizontal:typeof O.horizontal<"u"?O.horizontal:1,horizontalScrollbarSize:typeof O.horizontalScrollbarSize<"u"?O.horizontalScrollbarSize:10,horizontalSliderSize:typeof O.horizontalSliderSize<"u"?O.horizontalSliderSize:0,horizontalHasArrows:typeof O.horizontalHasArrows<"u"?O.horizontalHasArrows:!1,vertical:typeof O.vertical<"u"?O.vertical:1,verticalScrollbarSize:typeof O.verticalScrollbarSize<"u"?O.verticalScrollbarSize:10,verticalHasArrows:typeof O.verticalHasArrows<"u"?O.verticalHasArrows:!1,verticalSliderSize:typeof O.verticalSliderSize<"u"?O.verticalSliderSize:0,scrollByPage:typeof O.scrollByPage<"u"?O.scrollByPage:!1};return L.horizontalSliderSize=typeof O.horizontalSliderSize<"u"?O.horizontalSliderSize:L.horizontalScrollbarSize,L.verticalSliderSize=typeof O.verticalSliderSize<"u"?O.verticalSliderSize:L.verticalScrollbarSize,r.$j&&(L.className+=" mac"),L}}),define(be[61],$e([1,0,54,3,22,25,60,12,9,27,4,2,47,48,83,120,6]),function(ie,t,k,T,n,H,A,S,m,w,D,M,r,l,e,s,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TR=t.$SR=t.$RR=t.$QR=t.ListViewTargetSector=void 0;const b={CurrentDragAndDropData:void 0};var h;(function(B){B[B.TOP=0]="TOP",B[B.CENTER_TOP=1]="CENTER_TOP",B[B.CENTER_BOTTOM=2]="CENTER_BOTTOM",B[B.BOTTOM=3]="BOTTOM"})(h||(t.ListViewTargetSector=h={}));const $={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(B){return[B]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class c{get context(){return this.d}set context(v){this.d=v}constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.$QR=c;class f{constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.$RR=f;class a{constructor(){this.types=[],this.files=[]}update(v){if(v.types&&this.types.splice(0,this.types.length,...v.types),v.files){this.files.splice(0,this.files.length);for(let P=0;P<v.files.length;P++){const V=v.files.item(P);V&&(V.size||V.type)&&this.files.push(V)}}}getData(){return{types:this.types,files:this.files}}}t.$SR=a;function C(B,v){return Array.isArray(B)&&Array.isArray(v)?(0,S.$ub)(B,v):B===v}class O{constructor(v){v?.getSetSize?this.getSetSize=v.getSetSize.bind(v):this.getSetSize=(P,V,U)=>U,v?.getPosInSet?this.getPosInSet=v.getPosInSet.bind(v):this.getPosInSet=(P,V)=>V+1,v?.getRole?this.getRole=v.getRole.bind(v):this.getRole=P=>"listitem",v?.isChecked?this.isChecked=v.isChecked.bind(v):this.isChecked=P=>{}}}class L{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(v){if(v!==this.P){if(v&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=v,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const P of this.d)this.Z(P);this.W(),this.q.setScrollDimensions({width:(0,T.$5P)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(v,P,V,U=$){if(this.R=P,this.domId=`list_id_${++L.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new m.$3g(50),this.v=!1,this.x=M.$Tc.None,this.y=0,this.G=!1,this.K=M.$Tc.None,this.L=M.$Tc.None,this.M=new M.$Sc,this.N=new D.$Vd,this.O=new D.$Vd,this.onDidChangeContentHeight=D.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=D.Event.latch(this.O.event,void 0,this.M),this.P=!1,U.horizontalScrolling&&U.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$OR(U.paddingTop??0);for(const I of V)this.j.set(I.templateId,I);this.h=this.M.add(new s.$PR(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof U.mouseSupport=="boolean"?U.mouseSupport:!0),this.P=U.horizontalScrolling??$.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof U.paddingBottom>"u"?0:U.paddingBottom,this.D=new O(U.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(U.transformOptimization??$.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(H.$cR.addTarget(this.o)),this.p=this.M.add(new l.$ls({forceIntegerValues:!0,smoothScrollDuration:U.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:I=>(0,T.$PP)((0,T.getWindow)(this.domNode),I)})),this.q=this.M.add(new A.$rR(this.o,{alwaysConsumeMouseWheel:U.alwaysConsumeMouseWheel??$.alwaysConsumeMouseWheel,horizontal:1,vertical:U.verticalScrollMode??$.verticalScrollMode,useShadows:U.useShadows??$.useShadows,mouseWheelScrollSensitivity:U.mouseWheelScrollSensitivity,fastScrollSensitivity:U.fastScrollSensitivity,scrollByPage:U.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),v.appendChild(this.domNode),this.q.onScroll(this.hb,this,this.M),this.M.add((0,T.$FP)(this.o,H.EventType.Change,I=>this.ib(I))),this.M.add((0,T.$FP)(this.q.getDomNode(),"scroll",I=>I.target.scrollTop=0)),this.M.add((0,T.$FP)(this.domNode,"dragover",I=>this.kb(this.gb(I)))),this.M.add((0,T.$FP)(this.domNode,"drop",I=>this.mb(this.gb(I)))),this.M.add((0,T.$FP)(this.domNode,"dragleave",I=>this.lb(this.gb(I)))),this.M.add((0,T.$FP)(this.domNode,"dragend",I=>this.nb(I))),this.z=U.setRowLineHeight??$.setRowLineHeight,this.A=U.setRowHeight??$.setRowHeight,this.B=U.supportDynamicHeights??$.supportDynamicHeights,this.F=U.dnd??this.M.add($.dnd),this.layout(U.initialSize?.height,U.initialSize?.width)}updateOptions(v){v.paddingBottom!==void 0&&(this.C=v.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),v.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(v.smoothScrolling?125:0),v.horizontalScrolling!==void 0&&(this.Q=v.horizontalScrolling);let P;if(v.scrollByPage!==void 0&&(P={...P??{},scrollByPage:v.scrollByPage}),v.mouseWheelScrollSensitivity!==void 0&&(P={...P??{},mouseWheelScrollSensitivity:v.mouseWheelScrollSensitivity}),v.fastScrollSensitivity!==void 0&&(P={...P??{},fastScrollSensitivity:v.fastScrollSensitivity}),P&&this.q.updateOptions(P),v.paddingTop!==void 0&&v.paddingTop!==this.g.paddingTop){const V=this.ub(this.k,this.m),U=v.paddingTop-this.g.paddingTop;this.g.paddingTop=v.paddingTop,this.X(V,Math.max(0,this.k+U),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.U(),this.B&&this.vb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(v){this.q.delegateScrollFromMouseWheelEvent(v)}delegateVerticalScrollbarPointerDown(v){this.q.delegateVerticalScrollbarPointerDown(v)}updateElementHeight(v,P,V){if(v<0||v>=this.d.length)return;const U=this.d[v].size;if(typeof P>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[v].lastDynamicHeightWidth=void 0,P=U+this.wb(v)}if(U===P)return;const N=this.ub(this.k,this.m);let I=0;v<N.start||V!==null&&V>v&&V<N.end?I=P-U:I=0,this.g.splice(v,1,[{size:P}]),this.d[v].size=P,this.X(N,Math.max(0,this.k+I),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.U(),this.B&&this.vb(this.k,this.m)}splice(v,P,V=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.S(v,P,V)}finally{this.v=!1,this.N.fire(this.contentHeight)}}S(v,P,V=[]){const U=this.ub(this.k,this.m),N={start:v,end:v+P},I=r.Range.intersect(U,N),z=new Map;for(let G=I.end-1;G>=I.start;G--){const ue=this.d[G];if(ue.dragStartDisposable.dispose(),ue.checkedDisposable.dispose(),ue.row){let me=z.get(ue.templateId);me||(me=[],z.set(ue.templateId,me));const Se=this.j.get(ue.templateId);Se&&Se.disposeElement&&Se.disposeElement(ue.element,G,ue.row.templateData,ue.size),me.push(ue.row)}ue.row=null}const X={start:v+P,end:this.d.length},Y=r.Range.intersect(X,U),fe=r.Range.relativeComplement(X,U),ae=V.map(G=>({id:String(this.f++),element:G,templateId:this.R.getTemplateId(G),size:this.R.getHeight(G),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(G),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:M.$Tc.None,checkedDisposable:M.$Tc.None}));let ee;v===0&&P>=this.d.length?(this.g=new e.$OR(this.g.paddingTop),this.g.splice(0,0,ae),ee=this.d,this.d=ae):(this.g.splice(v,P,ae),ee=this.d.splice(v,P,...ae));const ge=V.length-P,Ie=this.ub(this.k,this.m),Ce=(0,e.$MR)(Y,ge),Be=r.Range.intersect(Ie,Ce);for(let G=Be.start;G<Be.end;G++)this.ab(this.d[G],G);const se=r.Range.relativeComplement(Ce,Ie);for(const G of se)for(let ue=G.start;ue<G.end;ue++)this.bb(ue);const J=fe.map(G=>(0,e.$MR)(G,ge)),oe=[{start:v,end:v+V.length},...J].map(G=>r.Range.intersect(Ie,G)),W=this.xb(oe);for(const G of oe)for(let ue=G.start;ue<G.end;ue++){const me=this.d[ue],ke=z.get(me.templateId)?.pop();this.Y(ue,W,ke)}for(const G of z.values())for(const ue of G)this.h.release(ue);return this.U(),this.B&&this.vb(this.scrollTop,this.renderHeight),ee.map(G=>G.element)}U(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,T.$PP)((0,T.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.W(),this.t=null}))}V(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.W())}W(){if(!this.Q)return;let v=0;for(const P of this.d)typeof P.width<"u"&&(v=Math.max(v,P.width));this.E=v,this.q.setScrollDimensions({scrollWidth:v===0?0:v+10}),this.O.fire(this.E)}updateWidth(v){if(!this.Q||typeof this.E>"u")return;const P=this.d[v];this.Z(P),typeof P.width<"u"&&P.width>this.E&&(this.E=P.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const v of this.d)v.lastDynamicHeightWidth=void 0;this.vb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.ub(this.k,this.m).start}get firstMostlyVisibleIndex(){const v=this.firstVisibleIndex,P=this.g.positionAt(v),V=this.g.positionAt(v+1);return V!==-1&&(V-P)/2+P<this.scrollTop?v+1:v}get lastVisibleIndex(){return this.ub(this.k,this.m).end-1}element(v){return this.d[v].element}indexOf(v){return this.d.findIndex(P=>P.element===v)}domElement(v){const P=this.d[v].row;return P&&P.domNode}elementHeight(v){return this.d[v].size}elementTop(v){return this.g.positionAt(v)}indexAt(v){return this.g.indexAt(v)}indexAfter(v){return this.g.indexAfter(v)}layout(v,P){const V={height:typeof v=="number"?v:(0,T.$7P)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,V.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(V),typeof P<"u"&&(this.n=P,this.B&&this.vb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof P=="number"?P:(0,T.$5P)(this.domNode)})}X(v,P,V,U,N,I=!1){const z=this.ub(P,V),X=r.Range.relativeComplement(z,v),Y=r.Range.relativeComplement(v,z),fe=this.xb(X);if(I){const ae=r.Range.intersect(v,z);for(let ee=ae.start;ee<ae.end;ee++)this.ab(this.d[ee],ee)}this.h.transact(()=>{for(const ae of Y)for(let ee=ae.start;ee<ae.end;ee++)this.bb(ee);for(const ae of X)for(let ee=ae.start;ee<ae.end;ee++)this.Y(ee,fe)}),U!==void 0&&(this.o.style.left=`-${U}px`),this.o.style.top=`-${P}px`,this.Q&&N!==void 0&&(this.o.style.width=`${Math.max(N,this.n)}px`),this.k=P,this.m=V}Y(v,P,V){const U=this.d[v];let N=!1;if(!U.row)if(V)U.row=V;else{const fe=this.h.alloc(U.templateId);U.row=fe.row,N=fe.isReusingConnectedDomNode}const I=this.D.getRole(U.element)||"listitem";U.row.domNode.setAttribute("role",I);const z=this.D.isChecked(U.element);if(typeof z=="boolean")U.row.domNode.setAttribute("aria-checked",String(!!z));else if(z){const fe=ae=>U.row.domNode.setAttribute("aria-checked",String(!!ae));fe(z.value),U.checkedDisposable=z.onDidChange(fe)}(N||!U.row.domNode.parentElement)&&(P?this.o.insertBefore(U.row.domNode,P):this.o.appendChild(U.row.domNode)),this.ab(U,v);const X=this.j.get(U.templateId);if(!X)throw new Error(`No renderer found for template id ${U.templateId}`);X?.renderElement(U.element,v,U.row.templateData,U.size);const Y=this.F.getDragURI(U.element);U.dragStartDisposable.dispose(),U.row.domNode.draggable=!!Y,Y&&(U.dragStartDisposable=(0,T.$FP)(U.row.domNode,"dragstart",fe=>this.jb(U.element,Y,fe))),this.Q&&(this.Z(U),this.V())}Z(v){if(!v.row||!v.row.domNode)return;v.row.domNode.style.width="fit-content",v.width=(0,T.$5P)(v.row.domNode);const P=(0,T.getWindow)(v.row.domNode).getComputedStyle(v.row.domNode);P.paddingLeft&&(v.width+=parseFloat(P.paddingLeft)),P.paddingRight&&(v.width+=parseFloat(P.paddingRight)),v.row.domNode.style.width=""}ab(v,P){v.row.domNode.style.top=`${this.elementTop(P)}px`,this.A&&(v.row.domNode.style.height=`${v.size}px`),this.z&&(v.row.domNode.style.lineHeight=`${v.size}px`),v.row.domNode.setAttribute("data-index",`${P}`),v.row.domNode.setAttribute("data-last-element",P===this.length-1?"true":"false"),v.row.domNode.setAttribute("data-parity",P%2===0?"even":"odd"),v.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(v.element,P,this.length))),v.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(v.element,P))),v.row.domNode.setAttribute("id",this.getElementDomId(P)),v.row.domNode.classList.toggle("drop-target",v.dropTarget)}bb(v){const P=this.d[v];if(P.dragStartDisposable.dispose(),P.checkedDisposable.dispose(),P.row){const V=this.j.get(P.templateId);V&&V.disposeElement&&V.disposeElement(P.element,v,P.row.templateData,P.size),this.h.release(P.row),P.row=null}this.Q&&this.V()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(v,P){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:v,reuseAnimation:P})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:v})}get scrollTop(){return this.getScrollTop()}set scrollTop(v){this.setScrollTop(v)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return D.Event.map(this.M.add(new n.$GR(this.domNode,"click")).event,v=>this.db(v),this.M)}get onMouseDblClick(){return D.Event.map(this.M.add(new n.$GR(this.domNode,"dblclick")).event,v=>this.db(v),this.M)}get onMouseMiddleClick(){return D.Event.filter(D.Event.map(this.M.add(new n.$GR(this.domNode,"auxclick")).event,v=>this.db(v),this.M),v=>v.browserEvent.button===1,this.M)}get onMouseUp(){return D.Event.map(this.M.add(new n.$GR(this.domNode,"mouseup")).event,v=>this.db(v),this.M)}get onMouseDown(){return D.Event.map(this.M.add(new n.$GR(this.domNode,"mousedown")).event,v=>this.db(v),this.M)}get onMouseOver(){return D.Event.map(this.M.add(new n.$GR(this.domNode,"mouseover")).event,v=>this.db(v),this.M)}get onMouseMove(){return D.Event.map(this.M.add(new n.$GR(this.domNode,"mousemove")).event,v=>this.db(v),this.M)}get onMouseOut(){return D.Event.map(this.M.add(new n.$GR(this.domNode,"mouseout")).event,v=>this.db(v),this.M)}get onContextMenu(){return D.Event.any(D.Event.map(this.M.add(new n.$GR(this.domNode,"contextmenu")).event,v=>this.db(v),this.M),D.Event.map(this.M.add(new n.$GR(this.domNode,H.EventType.Contextmenu)).event,v=>this.fb(v),this.M))}get onTouchStart(){return D.Event.map(this.M.add(new n.$GR(this.domNode,"touchstart")).event,v=>this.eb(v),this.M)}get onTap(){return D.Event.map(this.M.add(new n.$GR(this.o,H.EventType.Tap)).event,v=>this.fb(v),this.M)}db(v){const P=this.tb(v.target||null),V=typeof P>"u"?void 0:this.d[P],U=V&&V.element;return{browserEvent:v,index:P,element:U}}eb(v){const P=this.tb(v.target||null),V=typeof P>"u"?void 0:this.d[P],U=V&&V.element;return{browserEvent:v,index:P,element:U}}fb(v){const P=this.tb(v.initialTarget||null),V=typeof P>"u"?void 0:this.d[P],U=V&&V.element;return{browserEvent:v,index:P,element:U}}gb(v){const P=this.tb(v.target||null),V=typeof P>"u"?void 0:this.d[P],U=V&&V.element,N=this.sb(v,P);return{browserEvent:v,index:P,element:U,sector:N}}hb(v){try{const P=this.ub(this.k,this.m);this.X(P,v.scrollTop,v.height,v.scrollLeft,v.scrollWidth),this.B&&this.vb(v.scrollTop,v.height,v.inSmoothScrolling)}catch(P){throw console.error("Got bad scroll event:",v),P}}ib(v){v.preventDefault(),v.stopPropagation(),this.scrollTop-=v.translationY}jb(v,P,V){if(!V.dataTransfer)return;const U=this.F.getDragElements(v);if(V.dataTransfer.effectAllowed="copyMove",V.dataTransfer.setData(k.$aR.TEXT,P),V.dataTransfer.setDragImage){let N;this.F.getDragLabel&&(N=this.F.getDragLabel(U,V)),typeof N>"u"&&(N=String(U.length));const I=(0,T.$)(".monaco-drag-image");I.textContent=N;const X=(Y=>{for(;Y&&!Y.classList.contains("monaco-workbench");)Y=Y.parentElement;return Y||this.domNode.ownerDocument})(this.domNode);X.appendChild(I),V.dataTransfer.setDragImage(I,-10,-10),setTimeout(()=>X.removeChild(I),0)}this.domNode.classList.add("dragging"),this.H=new c(U),b.CurrentDragAndDropData=new f(U),this.F.onDragStart?.(this.H,V)}kb(v){if(v.browserEvent.preventDefault(),this.L.dispose(),b.CurrentDragAndDropData&&b.CurrentDragAndDropData.getData()==="vscode-ui"||(this.pb(v.browserEvent),!v.browserEvent.dataTransfer))return!1;if(!this.H)if(b.CurrentDragAndDropData)this.H=b.CurrentDragAndDropData;else{if(!v.browserEvent.dataTransfer.types)return!1;this.H=new a}const P=this.F.onDragOver(this.H,v.element,v.index,v.sector,v.browserEvent);if(this.G=typeof P=="boolean"?P:P.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;v.browserEvent.dataTransfer.dropEffect=typeof P!="boolean"&&P.effect?.type===0?"copy":"move";let V;typeof P!="boolean"&&P.feedback?V=P.feedback:typeof v.index>"u"?V=[-1]:V=[v.index],V=(0,S.$Mb)(V).filter(N=>N>=-1&&N<this.length).sort((N,I)=>N-I),V=V[0]===-1?[-1]:V;const U=typeof P!="boolean"&&P.effect&&P.effect.position?P.effect.position:"drop-target";if(C(this.I,V)&&this.J===U)return!0;if(this.I=V,this.J=U,this.K.dispose(),V[0]===-1)this.domNode.classList.add(U),this.o.classList.add(U),this.K=(0,M.$Rc)(()=>{this.domNode.classList.remove(U),this.o.classList.remove(U)});else{if(V.length>1&&U!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");for(const N of V){const I=this.d[N];I.dropTarget=!0,I.row?.domNode.classList.add(U)}this.K=(0,M.$Rc)(()=>{for(const N of V){const I=this.d[N];I.dropTarget=!1,I.row?.domNode.classList.remove(U)}})}return!0}lb(v){this.L.dispose(),this.L=(0,m.$8g)(()=>this.ob(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,v.element,v.index,v.browserEvent)}mb(v){if(!this.G)return;const P=this.H;this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.H=void 0,b.CurrentDragAndDropData=void 0,!(!P||!v.browserEvent.dataTransfer)&&(v.browserEvent.preventDefault(),P.update(v.browserEvent.dataTransfer),this.F.drop(P,v.element,v.index,v.sector,v.browserEvent))}nb(v){this.G=!1,this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.H=void 0,b.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(v)}ob(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=M.$Tc.None}pb(v){if(!this.w){const P=(0,T.$YP)(this.domNode).top;this.w=(0,T.$UQ)((0,T.getWindow)(this.domNode),this.qb.bind(this,P))}this.x.dispose(),this.x=(0,m.$8g)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=v.pageY}qb(v){if(this.y===void 0)return;const P=this.y-v,V=this.renderHeight-35;P<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(P-35))):P>V&&(this.scrollTop+=Math.min(14,Math.floor(.3*(P-V))))}rb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}sb(v,P){if(P===void 0)return;const V=v.offsetY/this.d[P].size;return Math.floor(V/.25)}tb(v){const P=this.q.getDomNode();let V=v;for(;V instanceof HTMLElement&&V!==this.o&&P.contains(V);){const U=V.getAttribute("data-index");if(U){const N=Number(U);if(!isNaN(N))return N}V=V.parentElement}}ub(v,P){return{start:this.g.indexAt(v),end:this.g.indexAfter(v+P-1)}}vb(v,P,V){const U=this.ub(v,P);let N,I;v===this.elementTop(U.start)?(N=U.start,I=0):U.end-U.start>1&&(N=U.start+1,I=this.elementTop(N)-v);let z=0;for(;;){const X=this.ub(v,P);let Y=!1;for(let fe=X.start;fe<X.end;fe++){const ae=this.wb(fe);ae!==0&&this.g.splice(fe,1,[this.d[fe]]),z+=ae,Y=Y||ae!==0}if(!Y){z!==0&&this.U();const fe=r.Range.relativeComplement(U,X);for(const ee of fe)for(let ge=ee.start;ge<ee.end;ge++)this.d[ge].row&&this.bb(ge);const ae=r.Range.relativeComplement(X,U);for(const ee of ae)for(let ge=ee.start;ge<ee.end;ge++){const Ie=ge+1,Ce=Ie<this.d.length?this.d[Ie].row:null,Be=Ce?Ce.domNode:null;this.Y(ge,Be)}for(let ee=X.start;ee<X.end;ee++)this.d[ee].row&&this.ab(this.d[ee],ee);if(typeof N=="number"){const ee=this.p.getFutureScrollPosition().scrollTop-v,ge=this.elementTop(N)-I+ee;this.setScrollTop(ge,V)}this.N.fire(this.contentHeight);return}}}wb(v){const P=this.d[v];if(this.R.getDynamicHeight){const I=this.R.getDynamicHeight(P.element);if(I!==null){const z=P.size;return P.size=I,P.lastDynamicHeightWidth=this.n,I-z}}if(!P.hasDynamicHeight||P.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(P.element))return 0;const V=P.size;if(P.row)return P.row.domNode.style.height="",P.size=P.row.domNode.offsetHeight,P.lastDynamicHeightWidth=this.n,P.size-V;const{row:U}=this.h.alloc(P.templateId);U.domNode.style.height="",this.o.appendChild(U.domNode);const N=this.j.get(P.templateId);if(!N)throw new g.$cb("Missing renderer for templateId: "+P.templateId);return N.renderElement(P.element,v,U.templateData,void 0),P.size=U.domNode.offsetHeight,N.disposeElement?.(P.element,v,U.templateData,void 0),this.R.setDynamicHeight?.(P.element,P.size),P.lastDynamicHeightWidth=this.n,this.o.removeChild(U.domNode),this.h.release(U),P.size-V}xb(v){const P=v[v.length-1];if(!P)return null;const V=this.d[P.end];return!V||!V.row?null:V.row.domNode}getElementDomId(v){return`${this.domId}_${v}`}dispose(){for(const v of this.d)if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const P=this.j.get(v.row.templateId);P&&(P.disposeElement?.(v.element,-1,v.row.templateData,void 0),P.disposeTemplate(v.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$TR=L,Xe([w.$xh],L.prototype,"onMouseClick",null),Xe([w.$xh],L.prototype,"onMouseDblClick",null),Xe([w.$xh],L.prototype,"onMouseMiddleClick",null),Xe([w.$xh],L.prototype,"onMouseUp",null),Xe([w.$xh],L.prototype,"onMouseDown",null),Xe([w.$xh],L.prototype,"onMouseOver",null),Xe([w.$xh],L.prototype,"onMouseMove",null),Xe([w.$xh],L.prototype,"onMouseOut",null),Xe([w.$xh],L.prototype,"onContextMenu",null),Xe([w.$xh],L.prototype,"onTouchStart",null),Xe([w.$xh],L.prototype,"onTap",null)}),define(be[39],$e([1,0,3,22,14,25,57,71,12,9,74,27,4,34,2,46,5,7,70,61,19,98]),function(ie,t,k,T,n,H,A,S,m,w,D,M,r,l,e,s,g,b,h,$,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_R=t.$$R=t.$0R=t.$9R=t.$8R=t.$7R=t.$6R=t.TypeNavigationMode=t.$5R=t.$4R=t.$3R=t.$2R=t.$1R=t.$ZR=t.$YR=t.$XR=void 0;class f{constructor(d){this.d=d,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(d){return d}renderElement(d,y,p){const u=this.c.findIndex(i=>i.templateData===p);if(u>=0){const i=this.c[u];this.d.unrender(p),i.index=y}else{const i={index:y,templateData:p};this.c.push(i)}this.d.renderIndex(y,p)}splice(d,y,p){const u=[];for(const i of this.c)i.index<d?u.push(i):i.index>=d+y&&u.push({index:i.index+p-y,templateData:i.templateData});this.c=u}renderIndexes(d){for(const{index:y,templateData:p}of this.c)d.indexOf(y)>-1&&this.d.renderIndex(y,p)}disposeTemplate(d){const y=this.c.findIndex(p=>p.templateData===d);y<0||this.c.splice(y,1)}}class a{get name(){return this.g}get renderer(){return new f(this)}constructor(d){this.g=d,this.c=[],this.d=[],this.f=new r.$Vd,this.onChange=this.f.event}splice(d,y,p){const u=p.length-y,i=d+y,o=[];let E=0;for(;E<this.d.length&&this.d[E]<d;)o.push(this.d[E++]);for(let R=0;R<p.length;R++)p[R]&&o.push(R+d);for(;E<this.d.length&&this.d[E]>=i;)o.push(this.d[E++]+u);this.renderer.splice(d,y,p.length),this.h(o,o)}renderIndex(d,y){y.classList.toggle(this.g,this.contains(d))}unrender(d){d.classList.remove(this.g)}set(d,y){return this.h(d,[...d].sort(ue),y)}h(d,y,p){const u=this.c,i=this.d;this.c=d,this.d=y;const o=W(i,d);return this.renderer.renderIndexes(o),this.f.fire({indexes:d,browserEvent:p}),u}get(){return this.c}contains(d){return(0,m.$wb)(this.d,d,ue)>=0}dispose(){(0,e.$Oc)(this.f)}}Xe([M.$xh],a.prototype,"renderer",null);class C extends a{constructor(d){super("selected"),this.k=d}renderIndex(d,y){super.renderIndex(d,y),this.k&&(this.contains(d)?y.setAttribute("aria-selected","true"):y.setAttribute("aria-selected","false"))}}class O{constructor(d,y,p){this.c=d,this.d=y,this.f=p}splice(d,y,p){if(!this.f)return this.c.splice(d,y,new Array(p.length).fill(!1));const u=this.c.get().map(E=>this.f.getId(this.d.element(E)).toString());if(u.length===0)return this.c.splice(d,y,new Array(p.length).fill(!1));const i=new Set(u),o=p.map(E=>i.has(this.f.getId(E).toString()));this.c.splice(d,y,o)}}function L(x){return x.tagName==="INPUT"||x.tagName==="TEXTAREA"}t.$XR=L;function B(x,d){return x.classList.contains(d)?!0:x.classList.contains("monaco-list")||!x.parentElement?!1:B(x.parentElement,d)}function v(x){return B(x,"monaco-editor")}t.$YR=v;function P(x){return B(x,"monaco-custom-toggle")}t.$ZR=P;function V(x){return B(x,"action-item")}t.$1R=V;function U(x){return B(x,"monaco-tl-twistie")}t.$2R=U;function N(x){return B(x,"monaco-tree-sticky-row")}t.$3R=N;function I(x){return x.classList.contains("monaco-tree-sticky-container")}t.$4R=I;function z(x){return x.tagName==="A"&&x.classList.contains("monaco-button")||x.tagName==="DIV"&&x.classList.contains("monaco-button-dropdown")?!0:x.classList.contains("monaco-list")||!x.parentElement?!1:z(x.parentElement)}t.$5R=z;class X{get g(){return r.Event.chain(this.c.add(new T.$GR(this.k.domNode,"keydown")).event,d=>d.filter(y=>!L(y.target)).map(y=>new n.$CP(y)))}constructor(d,y,p){this.h=d,this.k=y,this.c=new e.$Sc,this.d=new e.$Sc,this.f=p.multipleSelectionSupport,this.c.add(this.g(u=>{switch(u.keyCode){case 3:return this.l(u);case 16:return this.o(u);case 18:return this.p(u);case 11:return this.q(u);case 12:return this.s(u);case 9:return this.u(u);case 31:this.f&&(g.$j?u.metaKey:u.ctrlKey)&&this.t(u)}}))}updateOptions(d){d.multipleSelectionSupport!==void 0&&(this.f=d.multipleSelectionSupport)}l(d){d.preventDefault(),d.stopPropagation(),this.h.setSelection(this.h.getFocus(),d.browserEvent)}o(d){d.preventDefault(),d.stopPropagation(),this.h.focusPrevious(1,!1,d.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}p(d){d.preventDefault(),d.stopPropagation(),this.h.focusNext(1,!1,d.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}q(d){d.preventDefault(),d.stopPropagation(),this.h.focusPreviousPage(d.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}s(d){d.preventDefault(),d.stopPropagation(),this.h.focusNextPage(d.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}t(d){d.preventDefault(),d.stopPropagation(),this.h.setSelection((0,m.$Sb)(this.h.length),d.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(d){this.h.getSelection().length&&(d.preventDefault(),d.stopPropagation(),this.h.setSelection([],d.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Xe([M.$xh],X.prototype,"g",null);var Y;(function(x){x[x.Automatic=0]="Automatic",x[x.Trigger=1]="Trigger"})(Y||(t.TypeNavigationMode=Y={}));var fe;(function(x){x[x.Idle=0]="Idle",x[x.Typing=1]="Typing"})(fe||(fe={})),t.$6R=new class{mightProducePrintableCharacter(x){return x.ctrlKey||x.metaKey||x.altKey?!1:x.keyCode>=31&&x.keyCode<=56||x.keyCode>=21&&x.keyCode<=30||x.keyCode>=98&&x.keyCode<=107||x.keyCode>=85&&x.keyCode<=95}};class ae{constructor(d,y,p,u,i){this.o=d,this.p=y,this.q=p,this.s=u,this.t=i,this.c=!1,this.d=fe.Idle,this.f=Y.Automatic,this.g=!1,this.h=-1,this.k=new e.$Sc,this.l=new e.$Sc,this.updateOptions(d.options)}updateOptions(d){d.typeNavigationEnabled??!0?this.u():this.v(),this.f=d.typeNavigationMode??Y.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let d=!1;const y=r.Event.chain(this.k.add(new T.$GR(this.p.domNode,"keydown")).event,i=>i.filter(o=>!L(o.target)).filter(()=>this.f===Y.Automatic||this.g).map(o=>new n.$CP(o)).filter(o=>d||this.s(o)).filter(o=>this.t.mightProducePrintableCharacter(o)).forEach(o=>k.$AQ.stop(o,!0)).map(o=>o.browserEvent.key)),p=r.Event.debounce(y,()=>null,800,void 0,void 0,void 0,this.k);r.Event.reduce(r.Event.any(y,p),(i,o)=>o===null?null:(i||"")+o,void 0,this.k)(this.x,this,this.k),p(this.w,this,this.k),y(()=>d=!0,void 0,this.k),p(()=>d=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const d=this.o.getFocus();if(d.length>0&&d[0]===this.h){const y=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(d[0]));y&&(0,A.$IR)(y)}this.h=-1}x(d){if(!d){this.d=fe.Idle,this.g=!1;return}const y=this.o.getFocus(),p=y.length>0?y[0]:0,u=this.d===fe.Idle?1:0;this.d=fe.Typing;for(let i=0;i<this.o.length;i++){const o=(p+i+u)%this.o.length,E=this.q.getKeyboardNavigationLabel(this.p.element(o)),R=E&&E.toString();if(this.o.options.typeNavigationEnabled){if(typeof R<"u"){if((0,l.$Uj)(d,R)){this.h=p,this.o.setFocus([o]),this.o.reveal(o);return}const F=(0,l.$2j)(d,R);if(F&&F[0].end-F[0].start>1&&F.length===1){this.h=p,this.o.setFocus([o]),this.o.reveal(o);return}}}else if(typeof R>"u"||(0,l.$Uj)(d,R)){this.h=p,this.o.setFocus([o]),this.o.reveal(o);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ee{constructor(d,y){this.d=d,this.f=y,this.c=new e.$Sc;const p=r.Event.chain(this.c.add(new T.$GR(y.domNode,"keydown")).event,i=>i.filter(o=>!L(o.target)).map(o=>new n.$CP(o)));r.Event.chain(p,i=>i.filter(o=>o.keyCode===2&&!o.ctrlKey&&!o.metaKey&&!o.shiftKey&&!o.altKey))(this.g,this,this.c)}g(d){if(d.target!==this.f.domNode)return;const y=this.d.getFocus();if(y.length===0)return;const p=this.f.domElement(y[0]);if(!p)return;const u=p.querySelector("[tabIndex]");if(!u||!(u instanceof HTMLElement)||u.tabIndex===-1)return;const i=(0,k.getWindow)(u).getComputedStyle(u);i.visibility==="hidden"||i.display==="none"||(d.preventDefault(),d.stopPropagation(),u.focus())}dispose(){this.c.dispose()}}function ge(x){return g.$j?x.browserEvent.metaKey:x.browserEvent.ctrlKey}t.$7R=ge;function Ie(x){return x.browserEvent.shiftKey}t.$8R=Ie;function Ce(x){return(0,k.$uQ)(x)&&x.button===2}const Be={isSelectionSingleChangeEvent:ge,isSelectionRangeChangeEvent:Ie};class se{constructor(d){this.k=d,this.f=new e.$Sc,this.g=new r.$Vd,this.onPointer=this.g.event,d.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Be),this.d=typeof d.options.mouseSupport>"u"||!!d.options.mouseSupport,this.d&&(d.onMouseDown(this.s,this,this.f),d.onContextMenu(this.t,this,this.f),d.onMouseDblClick(this.v,this,this.f),d.onTouchStart(this.s,this,this.f),this.f.add(H.$cR.addTarget(d.getHTMLElement()))),r.Event.any(d.onMouseClick,d.onMouseMiddleClick,d.onTap)(this.u,this,this.f)}updateOptions(d){d.multipleSelectionSupport!==void 0&&(this.c=void 0,d.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Be))}o(d){return this.c?this.c.isSelectionSingleChangeEvent(d):!1}p(d){return this.c?this.c.isSelectionRangeChangeEvent(d):!1}q(d){return this.o(d)||this.p(d)}s(d){v(d.browserEvent.target)||(0,k.$fQ)()!==d.browserEvent.target&&this.k.domFocus()}t(d){if(L(d.browserEvent.target)||v(d.browserEvent.target))return;const y=typeof d.index>"u"?[]:[d.index];this.k.setFocus(y,d.browserEvent)}u(d){if(!this.d||L(d.browserEvent.target)||v(d.browserEvent.target)||d.browserEvent.isHandledByList)return;d.browserEvent.isHandledByList=!0;const y=d.index;if(typeof y>"u"){this.k.setFocus([],d.browserEvent),this.k.setSelection([],d.browserEvent),this.k.setAnchor(void 0);return}if(this.q(d))return this.w(d);this.k.setFocus([y],d.browserEvent),this.k.setAnchor(y),Ce(d.browserEvent)||this.k.setSelection([y],d.browserEvent),this.g.fire(d)}v(d){if(L(d.browserEvent.target)||v(d.browserEvent.target)||this.q(d)||d.browserEvent.isHandledByList)return;d.browserEvent.isHandledByList=!0;const y=this.k.getFocus();this.k.setSelection(y,d.browserEvent)}w(d){const y=d.index;let p=this.k.getAnchor();if(this.p(d)){typeof p>"u"&&(p=this.k.getFocus()[0]??y,this.k.setAnchor(p));const u=Math.min(p,y),i=Math.max(p,y),o=(0,m.$Sb)(u,i+1),E=this.k.getSelection(),R=oe(W(E,[p]),p);if(R.length===0)return;const F=W(o,G(E,R));this.k.setSelection(F,d.browserEvent),this.k.setFocus([y],d.browserEvent)}else if(this.o(d)){const u=this.k.getSelection(),i=u.filter(o=>o!==y);this.k.setFocus([y]),this.k.setAnchor(y),u.length===i.length?this.k.setSelection([...i,y],d.browserEvent):this.k.setSelection(i,d.browserEvent)}}dispose(){this.f.dispose()}}t.$9R=se;class J{constructor(d,y){this.c=d,this.d=y}style(d){const y=this.d&&`.${this.d}`,p=[];d.listBackground&&p.push(`.monaco-list${y} .monaco-list-rows { background: ${d.listBackground}; }`),d.listFocusBackground&&(p.push(`.monaco-list${y}:focus .monaco-list-row.focused { background-color: ${d.listFocusBackground}; }`),p.push(`.monaco-list${y}:focus .monaco-list-row.focused:hover { background-color: ${d.listFocusBackground}; }`)),d.listFocusForeground&&p.push(`.monaco-list${y}:focus .monaco-list-row.focused { color: ${d.listFocusForeground}; }`),d.listActiveSelectionBackground&&(p.push(`.monaco-list${y}:focus .monaco-list-row.selected { background-color: ${d.listActiveSelectionBackground}; }`),p.push(`.monaco-list${y}:focus .monaco-list-row.selected:hover { background-color: ${d.listActiveSelectionBackground}; }`)),d.listActiveSelectionForeground&&p.push(`.monaco-list${y}:focus .monaco-list-row.selected { color: ${d.listActiveSelectionForeground}; }`),d.listActiveSelectionIconForeground&&p.push(`.monaco-list${y}:focus .monaco-list-row.selected .codicon { color: ${d.listActiveSelectionIconForeground}; }`),d.listFocusAndSelectionBackground&&p.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { background-color: ${d.listFocusAndSelectionBackground}; }
			`),d.listFocusAndSelectionForeground&&p.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { color: ${d.listFocusAndSelectionForeground}; }
			`),d.listInactiveFocusForeground&&(p.push(`.monaco-list${y} .monaco-list-row.focused { color:  ${d.listInactiveFocusForeground}; }`),p.push(`.monaco-list${y} .monaco-list-row.focused:hover { color:  ${d.listInactiveFocusForeground}; }`)),d.listInactiveSelectionIconForeground&&p.push(`.monaco-list${y} .monaco-list-row.focused .codicon { color:  ${d.listInactiveSelectionIconForeground}; }`),d.listInactiveFocusBackground&&(p.push(`.monaco-list${y} .monaco-list-row.focused { background-color:  ${d.listInactiveFocusBackground}; }`),p.push(`.monaco-list${y} .monaco-list-row.focused:hover { background-color:  ${d.listInactiveFocusBackground}; }`)),d.listInactiveSelectionBackground&&(p.push(`.monaco-list${y} .monaco-list-row.selected { background-color:  ${d.listInactiveSelectionBackground}; }`),p.push(`.monaco-list${y} .monaco-list-row.selected:hover { background-color:  ${d.listInactiveSelectionBackground}; }`)),d.listInactiveSelectionForeground&&p.push(`.monaco-list${y} .monaco-list-row.selected { color: ${d.listInactiveSelectionForeground}; }`),d.listHoverBackground&&p.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${d.listHoverBackground}; }`),d.listHoverForeground&&p.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${d.listHoverForeground}; }`);const u=(0,k.$XQ)(d.listFocusAndSelectionOutline,(0,k.$XQ)(d.listSelectionOutline,d.listFocusOutline??""));u&&p.push(`.monaco-list${y}:focus .monaco-list-row.focused.selected { outline: 1px solid ${u}; outline-offset: -1px;}`),d.listFocusOutline&&p.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.focused { outline: 1px solid ${d.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${y}.last-focused .monaco-list-row.focused { outline: 1px solid ${d.listFocusOutline}; outline-offset: -1px; }
			`);const i=(0,k.$XQ)(d.listSelectionOutline,d.listInactiveFocusOutline??"");i&&p.push(`.monaco-list${y} .monaco-list-row.focused.selected { outline: 1px dotted ${i}; outline-offset: -1px; }`),d.listSelectionOutline&&p.push(`.monaco-list${y} .monaco-list-row.selected { outline: 1px dotted ${d.listSelectionOutline}; outline-offset: -1px; }`),d.listInactiveFocusOutline&&p.push(`.monaco-list${y} .monaco-list-row.focused { outline: 1px dotted ${d.listInactiveFocusOutline}; outline-offset: -1px; }`),d.listHoverOutline&&p.push(`.monaco-list${y} .monaco-list-row:hover { outline: 1px dashed ${d.listHoverOutline}; outline-offset: -1px; }`),d.listDropOverBackground&&p.push(`
				.monaco-list${y}.drop-target,
				.monaco-list${y} .monaco-list-rows.drop-target,
				.monaco-list${y} .monaco-list-row.drop-target { background-color: ${d.listDropOverBackground} !important; color: inherit !important; }
			`),d.listDropBetweenBackground&&(p.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${y} .monaco-list-row.drop-target-after + .monaco-list-row::before,
			.monaco-list${y} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${d.listDropBetweenBackground};
			}`),p.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${y} .monaco-list-row:last-child.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${d.listDropBetweenBackground};
			}`)),d.tableColumnsBorder&&p.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${d.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),d.tableOddRowsBackgroundColor&&p.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${d.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=p.join(`
`)}}t.$0R=J,t.$$R={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:D.$mt.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:D.$mt.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:D.$mt.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const re={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function oe(x,d){const y=x.indexOf(d);if(y===-1)return[];const p=[];let u=y-1;for(;u>=0&&x[u]===d-(y-u);)p.push(x[u--]);for(p.reverse(),u=y;u<x.length&&x[u]===d+(u-y);)p.push(x[u++]);return p}function W(x,d){const y=[];let p=0,u=0;for(;p<x.length||u<d.length;)if(p>=x.length)y.push(d[u++]);else if(u>=d.length)y.push(x[p++]);else if(x[p]===d[u]){y.push(x[p]),p++,u++;continue}else x[p]<d[u]?y.push(x[p++]):y.push(d[u++]);return y}function G(x,d){const y=[];let p=0,u=0;for(;p<x.length||u<d.length;)if(p>=x.length)y.push(d[u++]);else if(u>=d.length)y.push(x[p++]);else if(x[p]===d[u]){p++,u++;continue}else x[p]<d[u]?y.push(x[p++]):u++;return y}const ue=(x,d)=>x-d;class me{constructor(d,y){this.c=d,this.d=y}get templateId(){return this.c}renderTemplate(d){return this.d.map(y=>y.renderTemplate(d))}renderElement(d,y,p,u){let i=0;for(const o of this.d)o.renderElement(d,y,p[i++],u)}disposeElement(d,y,p,u){let i=0;for(const o of this.d)o.disposeElement?.(d,y,p[i],u),i+=1}disposeTemplate(d){let y=0;for(const p of this.d)p.disposeTemplate(d[y++])}}class Se{constructor(d){this.c=d,this.templateId="a18n"}renderTemplate(d){return d}renderElement(d,y,p){const u=this.c.getAriaLabel(d);u?p.setAttribute("aria-label",u):p.removeAttribute("aria-label");const i=this.c.getAriaLevel&&this.c.getAriaLevel(d);typeof i=="number"?p.setAttribute("aria-level",`${i}`):p.removeAttribute("aria-level")}disposeTemplate(d){}}class ke{constructor(d,y){this.c=d,this.d=y}getDragElements(d){const y=this.c.getSelectedElements();return y.indexOf(d)>-1?y:[d]}getDragURI(d){return this.d.getDragURI(d)}getDragLabel(d,y){if(this.d.getDragLabel)return this.d.getDragLabel(d,y)}onDragStart(d,y){this.d.onDragStart?.(d,y)}onDragOver(d,y,p,u,i){return this.d.onDragOver(d,y,p,u,i)}onDragLeave(d,y,p,u){this.d.onDragLeave?.(d,y,p,u)}onDragEnd(d){this.d.onDragEnd?.(d)}drop(d,y,p,u,i){this.d.drop(d,y,p,u,i)}dispose(){this.d.dispose()}}class Pe{get onDidChangeFocus(){return r.Event.map(this.g.wrapEvent(this.c.onChange),d=>this.G(d),this.y)}get onDidChangeSelection(){return r.Event.map(this.g.wrapEvent(this.d.onChange),d=>this.G(d),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let d=!1;const y=r.Event.chain(this.y.add(new T.$GR(this.k.domNode,"keydown")).event,i=>i.map(o=>new n.$CP(o)).filter(o=>d=o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>k.$AQ.stop(o,!0)).filter(()=>!1)),p=r.Event.chain(this.y.add(new T.$GR(this.k.domNode,"keyup")).event,i=>i.forEach(()=>d=!1).map(o=>new n.$CP(o)).filter(o=>o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>k.$AQ.stop(o,!0)).map(({browserEvent:o})=>{const E=this.getFocus(),R=E.length?E[0]:void 0,F=typeof R<"u"?this.k.element(R):void 0,j=typeof R<"u"?this.k.domElement(R):this.k.domNode;return{index:R,element:F,anchor:j,browserEvent:o}})),u=r.Event.chain(this.k.onContextMenu,i=>i.filter(o=>!d).map(({element:o,index:E,browserEvent:R})=>({element:o,index:E,anchor:new c.$xP((0,k.getWindow)(this.k.domNode),R),browserEvent:R})));return r.Event.any(y,p,u)}get onKeyDown(){return this.y.add(new T.$GR(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new T.$GR(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new T.$GR(this.k.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.y.add(new T.$GR(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.y.add(new T.$GR(this.k.domNode,"blur",!0)).event)}constructor(d,y,p,u,i=re){this.A=d,this.B=i,this.c=new a("focused"),this.f=new a("anchor"),this.g=new r.$4d,this.x="",this.y=new e.$Sc,this.z=new r.$Vd,this.onDidDispose=this.z.event;const o=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new C(o!=="listbox");const E=[this.c.renderer,this.d.renderer];this.u=i.accessibilityProvider,this.u&&(E.push(new Se(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),u=u.map(F=>new me(F.templateId,[...E,F]));const R={...i,dnd:i.dnd&&new ke(this,i.dnd)};if(this.k=this.C(y,p,u,R),this.k.domNode.setAttribute("role",o),i.styleController)this.q=i.styleController(this.k.domId);else{const F=(0,k.$nQ)(this.k.domNode);this.q=new J(F,this.k.domId)}if(this.o=new S.$KR([new O(this.c,this.k,i.identityProvider),new O(this.d,this.k,i.identityProvider),new O(this.f,this.k,i.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ee(this,this.k)),(typeof i.keyboardSupport!="boolean"||i.keyboardSupport)&&(this.v=new X(this,this.k,i),this.y.add(this.v)),i.keyboardNavigationLabelProvider){const F=i.keyboardNavigationDelegate||t.$6R;this.t=new ae(this,this.k,i.keyboardNavigationLabelProvider,i.keyboardNavigationEventFilter??(()=>!0),F),this.y.add(this.t)}this.w=this.D(i),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(d,y,p,u){return new $.$TR(d,y,p,u)}D(d){return new se(this)}updateOptions(d={}){this.B={...this.B,...d},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(d),this.v?.updateOptions(d),this.k.updateOptions(d)}get options(){return this.B}splice(d,y,p=[]){if(d<0||d>this.k.length)throw new h.$VR(this.A,`Invalid start index: ${d}`);if(y<0)throw new h.$VR(this.A,`Invalid delete count: ${y}`);y===0&&p.length===0||this.g.bufferEvents(()=>this.o.splice(d,y,p))}updateWidth(d){this.k.updateWidth(d)}updateElementHeight(d,y){this.k.updateElementHeight(d,y,null)}rerender(){this.k.rerender()}element(d){return this.k.element(d)}indexOf(d){return this.k.indexOf(d)}indexAt(d){return this.k.indexAt(d)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(d){this.k.setScrollTop(d)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(d){this.k.setScrollLeft(d)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(d){this.x=d,this.k.domNode.setAttribute("aria-label",d)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(d,y){this.k.layout(d,y)}triggerTypeNavigation(){this.t?.trigger()}setSelection(d,y){for(const p of d)if(p<0||p>=this.length)throw new h.$VR(this.A,`Invalid index ${p}`);this.d.set(d,y)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(d=>this.k.element(d))}setAnchor(d){if(typeof d>"u"){this.f.set([]);return}if(d<0||d>=this.length)throw new h.$VR(this.A,`Invalid index ${d}`);this.f.set([d])}getAnchor(){return(0,m.$Ob)(this.f.get(),void 0)}getAnchorElement(){const d=this.getAnchor();return typeof d>"u"?void 0:this.element(d)}setFocus(d,y){for(const p of d)if(p<0||p>=this.length)throw new h.$VR(this.A,`Invalid index ${p}`);this.c.set(d,y)}focusNext(d=1,y=!1,p,u){if(this.length===0)return;const i=this.c.get(),o=this.E(i.length>0?i[0]+d:0,y,u);o>-1&&this.setFocus([o],p)}focusPrevious(d=1,y=!1,p,u){if(this.length===0)return;const i=this.c.get(),o=this.F(i.length>0?i[0]-d:0,y,u);o>-1&&this.setFocus([o],p)}async focusNextPage(d,y){let p=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);p=p===0?0:p-1;const u=this.getFocus()[0];if(u!==p&&(u===void 0||p>u)){const i=this.F(p,!1,y);i>-1&&u!==i?this.setFocus([i],d):this.setFocus([p],d)}else{const i=this.k.getScrollTop();let o=i+this.k.renderHeight;p>u&&(o-=this.k.elementHeight(p)),this.k.setScrollTop(o),this.k.getScrollTop()!==i&&(this.setFocus([]),await(0,w.$7g)(0),await this.focusNextPage(d,y))}}async focusPreviousPage(d,y,p=()=>0){let u;const i=p(),o=this.k.getScrollTop()+i;o===0?u=this.k.indexAt(o):u=this.k.indexAfter(o-1);const E=this.getFocus()[0];if(E!==u&&(E===void 0||E>=u)){const R=this.E(u,!1,y);R>-1&&E!==R?this.setFocus([R],d):this.setFocus([u],d)}else{const R=o;this.k.setScrollTop(o-this.k.renderHeight-i),this.k.getScrollTop()+p()!==R&&(this.setFocus([]),await(0,w.$7g)(0),await this.focusPreviousPage(d,y,p))}}focusLast(d,y){if(this.length===0)return;const p=this.F(this.length-1,!1,y);p>-1&&this.setFocus([p],d)}focusFirst(d,y){this.focusNth(0,d,y)}focusNth(d,y,p){if(this.length===0)return;const u=this.E(d,!1,p);u>-1&&this.setFocus([u],y)}E(d,y=!1,p){for(let u=0;u<this.length;u++){if(d>=this.length&&!y)return-1;if(d=d%this.length,!p||p(this.element(d)))return d;d++}return-1}F(d,y=!1,p){for(let u=0;u<this.length;u++){if(d<0&&!y)return-1;if(d=(this.length+d%this.length)%this.length,!p||p(this.element(d)))return d;d--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(d=>this.k.element(d))}reveal(d,y,p=0){if(d<0||d>=this.length)throw new h.$VR(this.A,`Invalid index ${d}`);const u=this.k.getScrollTop(),i=this.k.elementTop(d),o=this.k.elementHeight(d);if((0,b.$Mf)(y)){const E=o-this.k.renderHeight+p;this.k.setScrollTop(E*(0,s.$7l)(y,0,1)+i-p)}else{const E=i+o,R=u+this.k.renderHeight;i<u+p&&E>=R||(i<u+p||E>=R&&o>=this.k.renderHeight?this.k.setScrollTop(i-p):E>=R&&this.k.setScrollTop(E-this.k.renderHeight))}}getRelativeTop(d,y=0){if(d<0||d>=this.length)throw new h.$VR(this.A,`Invalid index ${d}`);const p=this.k.getScrollTop(),u=this.k.elementTop(d),i=this.k.elementHeight(d);if(u<p+y||u+i>p+this.k.renderHeight)return null;const o=i-this.k.renderHeight+y;return Math.abs((p+y-u)/o)}isDOMFocused(){return(0,k.$gQ)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(d){return this.k.getElementDomId(d)}getElementTop(d){return this.k.elementTop(d)}style(d){this.q.style(d)}G({indexes:d,browserEvent:y}){return{indexes:d,elements:d.map(p=>this.k.element(p)),browserEvent:y}}H(){const d=this.c.get();this.k.domNode.classList.toggle("element-focused",d.length>0),this.I()}I(){const d=this.c.get();if(d.length>0){let y;this.u?.getActiveDescendantId&&(y=this.u.getActiveDescendantId(this.k.element(d[0]))),this.k.domNode.setAttribute("aria-activedescendant",y||this.k.getElementDomId(d[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const d=this.d.get();this.k.domNode.classList.toggle("selection-none",d.length===0),this.k.domNode.classList.toggle("selection-single",d.length===1),this.k.domNode.classList.toggle("selection-multiple",d.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$_R=Pe,Xe([M.$xh],Pe.prototype,"onDidChangeFocus",null),Xe([M.$xh],Pe.prototype,"onDidChangeSelection",null),Xe([M.$xh],Pe.prototype,"onContextMenu",null),Xe([M.$xh],Pe.prototype,"onKeyDown",null),Xe([M.$xh],Pe.prototype,"onKeyUp",null),Xe([M.$xh],Pe.prototype,"onKeyPress",null),Xe([M.$xh],Pe.prototype,"onDidFocus",null),Xe([M.$xh],Pe.prototype,"onDidBlur",null)}),define(be[62],$e([1,0,6,35,37,10,15]),function(ie,t,k,T,n,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pk=t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.MarkdownStringTextNewlineStyle=void 0;var S;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(S||(t.MarkdownStringTextNewlineStyle=S={}));class m{constructor(h="",$=!1){if(this.value=h,typeof this.value!="string")throw(0,k.$7)("value");typeof $=="boolean"?(this.isTrusted=$,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=$.isTrusted??void 0,this.supportThemeIcons=$.supportThemeIcons??!1,this.supportHtml=$.supportHtml??!1)}appendText(h,$=0){return this.value+=r(this.supportThemeIcons?(0,T.$bk)(h):h).replace(/([ \t]+)/g,(c,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,$===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,$){return this.value+=`
${l($,h)}
`,this}appendLink(h,$,c){return this.value+="[",this.value+=this.c($,"]"),this.value+="](",this.value+=this.c(String(h),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(h,$){const c=new RegExp((0,H.$Oe)($),"g");return h.replace(c,(f,a)=>h.charAt(a-1)!=="\\"?`\\${f}`:f)}}t.$hk=m;function w(b){return D(b)?!b.value:Array.isArray(b)?b.every(w):!0}t.$ik=w;function D(b){return b instanceof m?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||typeof b.isTrusted=="object"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}t.$jk=D;function M(b,h){return b===h?!0:!b||!h?!1:b.value===h.value&&b.isTrusted===h.isTrusted&&b.supportThemeIcons===h.supportThemeIcons&&b.supportHtml===h.supportHtml&&(b.baseUri===h.baseUri||!!b.baseUri&&!!h.baseUri&&(0,n.$Ag)(A.URI.from(b.baseUri),A.URI.from(h.baseUri)))}t.$kk=M;function r(b){return b.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$lk=r;function l(b,h){const $=b.match(/^`+/gm)?.reduce((f,a)=>f.length>a.length?f:a).length??0,c=$>=3?$+1:3;return[`${"`".repeat(c)}${h}`,b,`${"`".repeat(c)}`].join(`
`)}t.$mk=l;function e(b){return b.replace(/"/g,"&quot;")}t.$nk=e;function s(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$ok=s;function g(b){const h=[],$=b.split("|").map(f=>f.trim());b=$[0];const c=$[1];if(c){const f=/height=(\d+)/.exec(c),a=/width=(\d+)/.exec(c),C=f?f[1]:"",O=a?a[1]:"",L=isFinite(parseInt(O)),B=isFinite(parseInt(C));L&&h.push(`width="${O}"`),B&&h.push(`height="${C}"`)}return{href:b,dimensions:h}}t.$pk=g}),define(be[126],$e([1,0,3,118,22,55,14,19,119,6,4,62,35,77,23,2,79,53,31,51,37,10,15]),function(ie,t,k,T,n,H,A,S,m,w,D,M,r,l,e,s,g,b,h,$,c,f,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gS=t.$fS=t.$eS=t.$dS=t.$cS=void 0;const C=Object.freeze({image:(W,G,ue)=>{let me=[],Se=[];return W&&({href:W,dimensions:me}=(0,M.$pk)(W),Se.push(`src="${(0,M.$nk)(W)}"`)),ue&&Se.push(`alt="${(0,M.$nk)(ue)}"`),G&&Se.push(`title="${(0,M.$nk)(G)}"`),me.length&&(Se=Se.concat(me)),"<img "+Se.join(" ")+">"},paragraph:W=>`<p>${W}</p>`,link:(W,G,ue)=>typeof W!="string"?"":(W===ue&&(ue=(0,M.$ok)(ue)),G=typeof G=="string"?(0,M.$nk)((0,M.$ok)(G)):"",W=(0,M.$ok)(W),W=W.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${W}" title="${G||W}" draggable="false">${ue}</a>`)});function O(W,G={},ue={}){const me=new s.$Sc;let Se=!1;const ke=(0,H.$FR)(G),Pe=function(R){let F;try{F=(0,b.$Bh)(decodeURIComponent(R))}catch{}return F?(F=(0,$.$xn)(F,j=>{if(W.uris&&W.uris[j])return a.URI.revive(W.uris[j])}),encodeURIComponent(JSON.stringify(F))):R},x=function(R,F){const j=W.uris&&W.uris[R];let q=a.URI.revive(j);return F?R.startsWith(h.Schemas.data+":")?R:(q||(q=a.URI.parse(R)),h.$og.uriToBrowserUri(q).toString(!0)):!q||a.URI.parse(R).toString()===q.toString()?R:(q.query&&(q=q.with({query:Pe(q.query)})),q.toString())},d=new g.marked.Renderer;d.image=C.image,d.link=C.link,d.paragraph=C.paragraph;const y=[],p=[];if(G.codeBlockRendererSync?d.code=(R,F)=>{const j=l.$hN.nextId(),q=G.codeBlockRendererSync(L(F),R);return p.push([j,q]),`<div class="code" data-code="${j}">${(0,f.$Ne)(R)}</div>`}:G.codeBlockRenderer&&(d.code=(R,F)=>{const j=l.$hN.nextId(),q=G.codeBlockRenderer(L(F),R);return y.push(q.then(Z=>[j,Z])),`<div class="code" data-code="${j}">${(0,f.$Ne)(R)}</div>`}),G.actionHandler){const R=function(q){let Z=q.target;if(!(Z.tagName!=="A"&&(Z=Z.parentElement,!Z||Z.tagName!=="A")))try{let le=Z.dataset.href;le&&(W.baseUri&&(le=B(a.URI.from(W.baseUri),le)),G.actionHandler.callback(le,q))}catch(le){(0,w.$1)(le)}finally{q.preventDefault()}},F=G.actionHandler.disposables.add(new n.$GR(ke,"click")),j=G.actionHandler.disposables.add(new n.$GR(ke,"auxclick"));G.actionHandler.disposables.add(D.Event.any(F.event,j.event)(q=>{const Z=new S.$xP(k.getWindow(ke),q);!Z.leftButton&&!Z.middleButton||R(Z)})),G.actionHandler.disposables.add(k.$FP(ke,"keydown",q=>{const Z=new A.$CP(q);!Z.equals(10)&&!Z.equals(3)||R(Z)}))}W.supportHtml||(ue.sanitizer=R=>(W.isTrusted?R.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?R:"",ue.sanitize=!0,ue.silent=!0),ue.renderer=d;let u=W.value??"";u.length>1e5&&(u=`${u.substr(0,1e5)}\u2026`),W.supportThemeIcons&&(u=(0,r.$ck)(u));let i;if(G.fillInIncompleteTokens){const R={...g.marked.defaults,...ue},F=g.marked.lexer(u,R),j=Y(F);i=g.marked.parser(j,R)}else i=g.marked.parse(u,ue);W.supportThemeIcons&&(i=(0,m.$aS)(i).map(F=>typeof F=="string"?F:F.outerHTML).join(""));const E=new DOMParser().parseFromString(v(W,i),"text/html");if(E.body.querySelectorAll("img").forEach(R=>{const F=R.getAttribute("src");if(F){let j=F;try{W.baseUri&&(j=B(a.URI.from(W.baseUri),j))}catch{}R.src=x(j,!0)}}),E.body.querySelectorAll("a").forEach(R=>{const F=R.getAttribute("href");if(R.setAttribute("href",""),!F||/^data:|javascript:/i.test(F)||/^command:/i.test(F)&&!W.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(F))R.replaceWith(...R.childNodes);else{let j=x(F,!1);W.baseUri&&(j=B(a.URI.from(W.baseUri),F)),R.dataset.href=j}}),ke.innerHTML=v(W,E.body.innerHTML),y.length>0)Promise.all(y).then(R=>{if(Se)return;const F=new Map(R),j=ke.querySelectorAll("div[data-code]");for(const q of j){const Z=F.get(q.dataset.code??"");Z&&k.$HQ(q,Z)}G.asyncRenderCallback?.()});else if(p.length>0){const R=new Map(p),F=ke.querySelectorAll("div[data-code]");for(const j of F){const q=R.get(j.dataset.code??"");q&&k.$HQ(j,q)}}if(G.asyncRenderCallback)for(const R of ke.getElementsByTagName("img")){const F=me.add(k.$FP(R,"load",()=>{F.dispose(),G.asyncRenderCallback()}))}return{element:ke,dispose:()=>{Se=!0,me.dispose()}}}t.$cS=O;function L(W){if(!W)return"";const G=W.split(/[\s+|:|,|\{|\?]/,1);return G.length?G[0]:W}function B(W,G){return/^\w[\w\d+.-]*:/.test(G)?G:W.path.endsWith("/")?(0,c.$Kg)(W,G).toString():(0,c.$Kg)((0,c.$Gg)(W),G).toString()}function v(W,G){const{config:ue,allowedSchemes:me}=P(W);T.addHook("uponSanitizeAttribute",(ke,Pe)=>{if(Pe.attrName==="style"||Pe.attrName==="class"){if(ke.tagName==="SPAN"){if(Pe.attrName==="style"){Pe.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Pe.attrValue);return}else if(Pe.attrName==="class"){Pe.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Pe.attrValue);return}}Pe.keepAttr=!1;return}else if(ke.tagName==="INPUT"&&ke.attributes.getNamedItem("type")?.value==="checkbox"){if(Pe.attrName==="type"&&Pe.attrValue==="checkbox"||Pe.attrName==="disabled"||Pe.attrName==="checked"){Pe.keepAttr=!0;return}Pe.keepAttr=!1}}),T.addHook("uponSanitizeElement",(ke,Pe)=>{Pe.tagName==="input"&&(ke.attributes.getNamedItem("type")?.value==="checkbox"?ke.setAttribute("disabled",""):ke.parentElement?.removeChild(ke))});const Se=k.$2Q(me);try{return T.sanitize(G,{...ue,RETURN_TRUSTED_TYPE:!0})}finally{T.removeHook("uponSanitizeAttribute"),Se.dispose()}}t.$dS=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function P(W){const G=[h.Schemas.http,h.Schemas.https,h.Schemas.mailto,h.Schemas.data,h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemote,h.Schemas.vscodeRemoteResource];return W.isTrusted&&G.push(h.Schemas.command),{config:{ALLOWED_TAGS:[...k.$3Q],ALLOWED_ATTR:t.$dS,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:G}}function V(W){return typeof W=="string"?W:U(W)}t.$eS=V;function U(W){let G=W.value??"";G.length>1e5&&(G=`${G.substr(0,1e5)}\u2026`);const ue=g.marked.parse(G,{renderer:I.value}).replace(/&(#\d+|[a-zA-Z]+);/g,me=>N.get(me)??me);return v({isTrusted:!1},ue).toString()}t.$fS=U;const N=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),I=new e.$V(()=>{const W=new g.marked.Renderer;return W.code=G=>G,W.blockquote=G=>G,W.html=G=>"",W.heading=(G,ue,me)=>G+`
`,W.hr=()=>"",W.list=(G,ue)=>G,W.listitem=G=>G+`
`,W.paragraph=G=>G+`
`,W.table=(G,ue)=>G+ue+`
`,W.tablerow=G=>G,W.tablecell=(G,ue)=>G+" ",W.strong=G=>G,W.em=G=>G,W.codespan=G=>G,W.br=()=>`
`,W.del=G=>G,W.image=(G,ue,me)=>"",W.text=G=>G,W.link=(G,ue,me)=>me,W});function z(W){let G="";return W.forEach(ue=>{G+=ue.raw}),G}function X(W){for(let G=0;G<W.tokens.length;G++){const ue=W.tokens[G];if(ue.type==="text"){const me=ue.raw.split(`
`),Se=me[me.length-1];if(Se.includes("`"))return ae(W);if(Se.includes("**"))return se(W);if(Se.match(/\*\w/))return ee(W);if(Se.match(/(^|\s)__\w/))return J(W);if(Se.match(/(^|\s)_\w/))return ge(W);if(Se.match(/(^|\s)\[.*\]\(\w*/)){const ke=W.tokens.slice(G+1);return ke[0]?.type==="link"&&ke[1]?.type==="text"&&ke[1].raw.match(/^ *"[^"]*$/)?Ce(W):Ie(W)}else if(Se.match(/(^|\s)\[\w/))return Be(W)}}}function Y(W){let G,ue;for(G=0;G<W.length;G++){const me=W[G];if(me.type==="paragraph"&&me.raw.match(/(\n|^)```/)){ue=fe(W.slice(G));break}if(me.type==="paragraph"&&me.raw.match(/(\n|^)\|/)){ue=oe(W.slice(G));break}if(G===W.length-1&&me.type==="paragraph"){const Se=X(me);if(Se){ue=[Se];break}}}if(ue){const me=[...W.slice(0,G),...ue];return me.links=W.links,me}return W}t.$gS=Y;function fe(W){const G=z(W);return g.marked.lexer(G+"\n```")}function ae(W){return re(W,"`")}function ee(W){return re(W,"*")}function ge(W){return re(W,"_")}function Ie(W){return re(W,")")}function Ce(W){return re(W,'")')}function Be(W){return re(W,"](about:blank)")}function se(W){return re(W,"**")}function J(W){return re(W,"__")}function re(W,G){const ue=z(Array.isArray(W)?W:[W]);return g.marked.lexer(ue+G)[0]}function oe(W){const G=z(W),ue=G.split(`
`);let me,Se=!1;for(let ke=0;ke<ue.length;ke++){const Pe=ue[ke].trim();if(typeof me>"u"&&Pe.match(/^\s*\|/)){const x=Pe.match(/(\|[^\|]+)(?=\||$)/g);x&&(me=x.length)}else if(typeof me=="number")if(Pe.match(/^\s*\|/)){if(ke!==ue.length-1)return;Se=!0}else return}if(typeof me=="number"&&me>0){const ke=Se?ue.slice(0,-1).join(`
`):G,Pe=!!ke.match(/\|\s*$/),x=ke+(Pe?"":"|")+`
|${" --- |".repeat(me)}`;return g.marked.lexer(x)}}}),define(be[127],$e([1,0,3,9,29,62,35,2,7,108]),function(ie,t,k,T,n,H,A,S,m,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xR=t.$wR=void 0;function D(l,e){(0,m.$If)(e)?l.title=(0,A.$dk)(e):e?.markdownNotSupportedFallback?l.title=e.markdownNotSupportedFallback:l.removeAttribute("title")}t.$wR=D;class M{constructor(e,s,g){this.c=e,this.d=s,this.f=g}async update(e,s,g){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let b;if(e===void 0||(0,m.$If)(e)||e instanceof HTMLElement)b=e;else if(!(0,m.$Wf)(e.markdown))b=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,w.localize)(0,null),s),this.b=new n.$6d;const h=this.b.token;if(b=await e.markdown(h),b===void 0&&(b=e.markdownNotSupportedFallback),this.isDisposed||h.isCancellationRequested)return}this.g(b,s,g)}g(e,s,g){const b=this.a;if(this.h(e)){const h={content:e,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!b},position:{hoverPosition:2},...g};this.a=this.c.showHover(h,s)}b?.dispose()}h(e){return e?(0,H.$jk)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function r(l,e,s,g){let b,h;const $=(U,N)=>{const I=h!==void 0;U&&(h?.dispose(),h=void 0),N&&(b?.dispose(),b=void 0),I&&l.onDidHideHover?.()},c=(U,N,I)=>new T.$dh(async()=>{(!h||h.isDisposed)&&(h=new M(l,I||e,U>0),await h.update(s,N,g))},U);let f=!1;const a=k.$FP(e,k.$yQ.MOUSE_DOWN,()=>{f=!0,$(!0,!0)},!0),C=k.$FP(e,k.$yQ.MOUSE_UP,()=>{f=!1},!0),O=k.$FP(e,k.$yQ.MOUSE_LEAVE,U=>{f=!1,$(!1,U.fromElement===e)},!0),L=()=>{if(b)return;const U=new S.$Sc,N={targetElements:[e],dispose:()=>{}};if(l.placement===void 0||l.placement==="mouse"){const I=z=>{N.x=z.x+10,z.target instanceof HTMLElement&&z.target.classList.contains("action-label")&&$(!0,!0)};U.add(k.$FP(e,k.$yQ.MOUSE_MOVE,I,!0))}U.add(c(l.delay,!1,N)),b=U},B=k.$FP(e,k.$yQ.MOUSE_OVER,L,!0),v=()=>{if(f||b)return;const U={targetElements:[e],dispose:()=>{}},N=new S.$Sc,I=()=>$(!0,!0);N.add(k.$FP(e,k.$yQ.BLUR,I,!0)),N.add(c(l.delay,!1,U)),b=N},P=k.$FP(e,k.$yQ.FOCUS,v,!0);return{show:U=>{$(!1,!0),c(0,U)},hide:()=>{$(!0,!0)},update:async(U,N)=>{s=U,await h?.update(s,void 0,N)},dispose:()=>{B.dispose(),O.dispose(),a.dispose(),C.dispose(),P.dispose(),$(!0,!0)}}}t.$xR=r}),define(be[128],$e([1,0,3,22,14,126,39,12,4,44,2,5,110,101]),function(ie,t,k,T,n,H,A,S,m,w,D,M,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hS=void 0;const l=k.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(h){const $=Object.create(null);return $.root=h,$.text=k.$FQ(h,l(".option-text")),$.detail=k.$FQ(h,l(".option-detail")),$.decoratorRight=k.$FQ(h,l(".option-decorator-right")),$}renderElement(h,$,c){const f=c,a=h.text,C=h.detail,O=h.decoratorRight,L=h.isDisabled;f.text.textContent=a,f.detail.textContent=C||"",f.decoratorRight.innerText=O||"",L?f.root.classList.add("option-disabled"):f.root.classList.remove("option-disabled")}disposeTemplate(h){}}class g extends D.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(h,$,c,f,a){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=f,this.g=a||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=g.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new m.$Vd,this.B(this.r),this.O(),this.N(c),this.n=$||0,h&&this.setOptions(h,$),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(h){this.u=h,this.w=k.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=k.$FQ(this.w,l(".select-box-details-pane"));const $=k.$FQ(this.w,l(".select-box-dropdown-container-width-control")),c=k.$FQ($,l(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",k.$FQ(c,this.D),this.G=0,this.y=k.$nQ(this.w),this.w.setAttribute("draggable","true"),this.B(k.$FP(this.w,k.$yQ.DRAG_START,f=>{k.$AQ.stop(f,!0)}))}O(){this.B(k.$GP(this.h,"change",$=>{this.n=$.target.selectedIndex,this.r.fire({index:$.target.selectedIndex,selected:$.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(k.$FP(this.h,k.$yQ.CLICK,$=>{k.$AQ.stop($),this.f?this.X(!0):this.W()})),this.B(k.$FP(this.h,k.$yQ.MOUSE_DOWN,$=>{k.$AQ.stop($)}));let h;this.B(k.$FP(this.h,"touchstart",$=>{h=this.f})),this.B(k.$FP(this.h,"touchend",$=>{k.$AQ.stop($),h?this.X(!0):this.W()})),this.B(k.$FP(this.h,k.$yQ.KEY_DOWN,$=>{const c=new n.$CP($);let f=!1;M.$j?(c.keyCode===18||c.keyCode===16||c.keyCode===10||c.keyCode===3)&&(f=!0):(c.keyCode===18&&c.altKey||c.keyCode===16&&c.altKey||c.keyCode===10||c.keyCode===3)&&(f=!0),f&&(this.W(),k.$AQ.stop($,!0))}))}get onDidSelect(){return this.r.event}setOptions(h,$){S.$ub(this.m,h)||(this.m=h,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((c,f)=>{this.h.add(this.U(c.text,f,c.isDisabled)),typeof c.description=="string"&&(this.H=!0)})),$!==void 0&&(this.select($),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(h){h>=0&&h<this.m.length?this.n=h:h>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(h){this.g.ariaLabel=h,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(h){this.h.tabIndex=h?0:-1}render(h){this.j=h,h.classList.add("select-container"),h.appendChild(this.h),this.R()}Q(){const h=[];this.s.listFocusBackground&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(h.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),h.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),h.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(h.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),h.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),h.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),h.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=h.join(`
`)}R(){const h=this.s.selectBackground??"",$=this.s.selectForeground??"",c=this.s.selectBorder??"";this.h.style.backgroundColor=h,this.h.style.color=$,this.h.style.borderColor=c}S(){const h=this.s.selectBackground??"",$=k.$XQ(this.s.selectListBackground,h);this.C.style.backgroundColor=$,this.I.style.backgroundColor=$;const c=this.s.focusBorder??"";this.w.style.outlineColor=c,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(h,$,c){const f=document.createElement("option");return f.value=h,f.text=h,f.disabled=!!c,f}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:h=>this.Y(h,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:h=>this.Y(h),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(h){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),h&&this.h.focus(),this.u.hideContextView())}Y(h,$){return h.appendChild(this.w),this.ab($),{dispose:()=>{try{h.removeChild(this.w)}catch{}}}}Z(){let h=0;return this.m.forEach(($,c)=>{this.hb(c),this.I.offsetHeight>h&&(h=this.I.offsetHeight)}),h}ab(h){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const $=k.getWindow(this.h),c=k.$2P(this.h),f=k.getWindow(this.h).getComputedStyle(this.h),a=parseFloat(f.getPropertyValue("--dropdown-padding-top"))+parseFloat(f.getPropertyValue("--dropdown-padding-bottom")),C=$.innerHeight-c.top-c.height-(this.g.minBottomMargin||0),O=c.top-g.b,L=this.h.offsetWidth,B=this.bb(this.D),v=Math.max(B,Math.round(L)).toString()+"px";this.w.style.width=v,this.z.getHTMLElement().style.height="",this.z.layout();let P=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const V=this.H?this.L:0,U=P+a+V,N=Math.floor((C-a-V)/this.getHeight()),I=Math.floor((O-a-V)/this.getHeight());if(h)return c.top+c.height>$.innerHeight-22||c.top<g.b||N<1&&I<1?!1:(N<g.c&&I>N&&this.m.length>N?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(c.top+c.height>$.innerHeight-22||c.top<g.b||this.G===0&&N<1||this.G===1&&I<1)return this.X(!0),!1;if(this.G===0){if(this.f&&N+I<1)return this.X(!0),!1;U>C&&(P=N*this.getHeight())}else U>O&&(P=I*this.getHeight());return this.z.layout(P),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=P+a+"px",this.w.style.height=""):this.w.style.height=P+a+"px",this.hb(this.n),this.w.style.width=v,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(h){let $=0;if(h){let c=0,f=0;this.m.forEach((a,C)=>{const O=a.detail?a.detail.length:0,L=a.decoratorRight?a.decoratorRight.length:0,B=a.text.length+O+L;B>f&&(c=C,f=B)}),h.textContent=this.m[c].text+(this.m[c].decoratorRight?this.m[c].decoratorRight+" ":""),$=k.$4P(h)}return $}cb(h){if(this.z)return;this.C=k.$FQ(h,l(".select-box-dropdown-list-container")),this.t=new s,this.z=new A.$_R("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:f=>{let a=f.text;return f.detail&&(a+=`. ${f.detail}`),f.decoratorRight&&(a+=`. ${f.decoratorRight}`),f.description&&(a+=`. ${f.description}`),a},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>M.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const $=this.B(new T.$GR(this.C,"keydown")),c=m.Event.chain($.event,f=>f.filter(()=>this.z.length>0).map(a=>new n.$CP(a)));this.B(m.Event.chain(c,f=>f.filter(a=>a.keyCode===3))(this.jb,this)),this.B(m.Event.chain(c,f=>f.filter(a=>a.keyCode===2))(this.jb,this)),this.B(m.Event.chain(c,f=>f.filter(a=>a.keyCode===9))(this.ib,this)),this.B(m.Event.chain(c,f=>f.filter(a=>a.keyCode===16))(this.lb,this)),this.B(m.Event.chain(c,f=>f.filter(a=>a.keyCode===18))(this.kb,this)),this.B(m.Event.chain(c,f=>f.filter(a=>a.keyCode===12))(this.nb,this)),this.B(m.Event.chain(c,f=>f.filter(a=>a.keyCode===11))(this.mb,this)),this.B(m.Event.chain(c,f=>f.filter(a=>a.keyCode===14))(this.ob,this)),this.B(m.Event.chain(c,f=>f.filter(a=>a.keyCode===13))(this.pb,this)),this.B(m.Event.chain(c,f=>f.filter(a=>a.keyCode>=21&&a.keyCode<=56||a.keyCode>=85&&a.keyCode<=113))(this.qb,this)),this.B(k.$FP(this.z.getHTMLElement(),k.$yQ.POINTER_UP,f=>this.db(f))),this.B(this.z.onMouseOver(f=>typeof f.index<"u"&&this.z.setFocus([f.index]))),this.B(this.z.onDidChangeFocus(f=>this.gb(f))),this.B(k.$FP(this.w,k.$yQ.FOCUS_OUT,f=>{!this.f||k.$0P(f.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(h){if(!this.z.length)return;k.$AQ.stop(h);const $=h.target;if(!$||$.classList.contains("slider"))return;const c=$.closest(".monaco-list-row");if(!c)return;const f=Number(c.getAttribute("data-index")),a=c.classList.contains("option-disabled");f>=0&&f<this.m.length&&!a&&(this.n=f,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(h,$){const c=a=>{for(let C=0;C<a.childNodes.length;C++){const O=a.childNodes.item(C);(O.tagName&&O.tagName.toLowerCase())==="img"?a.removeChild(O):c(O)}},f=(0,H.$cS)({value:h,supportThemeIcons:!0},{actionHandler:$});return f.element.classList.add("select-box-description-markdown"),c(f.element),f.element}gb(h){!this.f||!this.H||this.hb(h.indexes[0])}hb(h){this.I.innerText="";const $=this.m[h],c=$?.description??"",f=$?.descriptionIsMarkdown??!1;if(c){if(f){const a=$.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(c,a))}else this.I.innerText=c;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(h){k.$AQ.stop(h),this.select(this.F),this.X(!0)}jb(h){k.$AQ.stop(h),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(h){if(this.n<this.m.length-1){k.$AQ.stop(h,!0);const $=this.m[this.n+1].isDisabled;if($&&this.m.length>this.n+2)this.n+=2;else{if($)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(h){this.n>0&&(k.$AQ.stop(h,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(h){k.$AQ.stop(h),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(h){k.$AQ.stop(h),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(h){k.$AQ.stop(h),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(h){k.$AQ.stop(h),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(h){const $=w.KeyCodeUtils.toString(h.keyCode);let c=-1;for(let f=0;f<this.m.length-1;f++)if(c=(f+this.n+1)%this.m.length,this.m[c].text.charAt(0).toUpperCase()===$&&!this.m[c].isDisabled){this.select(c),this.z.setFocus([c]),this.z.reveal(this.z.getFocus()[0]),k.$AQ.stop(h);break}}dispose(){this.X(!1),super.dispose()}}t.$hS=g}),define(be[129],$e([1,0,39,128,122,20,5,100]),function(ie,t,k,T,n,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kS=t.$jS=void 0,t.$jS={...k.$$R,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class S extends H.$gR{constructor(w,D,M,r,l){super(),A.$j&&!l?.useCustomDrawn?this.a=new n.$iS(w,D,r,l):this.a=new T.$hS(w,D,M,r,l),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(w,D){this.a.setOptions(w,D)}select(w){this.a.select(w)}setAriaLabel(w){this.a.setAriaLabel(w)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(w){this.a.setFocusable(w)}render(w){this.a.render(w)}}t.$kS=S}),define(be[63],$e([1,0,16,54,3,25,127,129,36,2,5,7,105,52]),function(ie,t,k,T,n,H,A,S,m,w,D,M,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sS=t.$rS=t.$qS=void 0;class l extends w.$Tc{get action(){return this._action}constructor(b,h,$={}){super(),this.m=$,this._context=b||this,this._action=h,h instanceof m.$Ki&&this.B(h.onDidChange(c=>{this.element&&this.t(c)}))}t(b){b.enabled!==void 0&&this.u(),b.checked!==void 0&&this.H(),b.class!==void 0&&this.G(),b.label!==void 0&&(this.w(),this.D()),b.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new m.$Li)),this.j}set actionRunner(b){this.j=b}isEnabled(){return this._action.enabled}setActionContext(b){this._context=b}render(b){const h=this.element=b;this.B(H.$cR.addTarget(b));const $=this.m&&this.m.draggable;$&&(b.draggable=!0,k.$lP&&this.B((0,n.$FP)(b,n.$yQ.DRAG_START,c=>c.dataTransfer?.setData(T.$aR.TEXT,this._action.label)))),this.B((0,n.$FP)(h,H.EventType.Tap,c=>this.onClick(c,!0))),this.B((0,n.$FP)(h,n.$yQ.MOUSE_DOWN,c=>{$||n.$AQ.stop(c,!0),this._action.enabled&&c.button===0&&h.classList.add("active")})),D.$j&&this.B((0,n.$FP)(h,n.$yQ.CONTEXT_MENU,c=>{c.button===0&&c.ctrlKey===!0&&this.onClick(c)})),this.B((0,n.$FP)(h,n.$yQ.CLICK,c=>{n.$AQ.stop(c,!0),this.m&&this.m.isMenu||this.onClick(c)})),this.B((0,n.$FP)(h,n.$yQ.DBLCLICK,c=>{n.$AQ.stop(c,!0)})),[n.$yQ.MOUSE_UP,n.$yQ.MOUSE_OUT].forEach(c=>{this.B((0,n.$FP)(h,c,f=>{n.$AQ.stop(f),h.classList.remove("active")}))})}onClick(b,h=!1){n.$AQ.stop(b,!0);const $=M.$Rf(this._context)?this.m?.useEventAsContext?b:{preserveFocus:h}:this._context;this.actionRunner.run(this._action,$)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(b){this.element&&(this.element.tabIndex=b?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const b=this.C()??"";this.F(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(b):(this.f=(0,A.$xR)(this.m.hoverDelegate,this.element,b),this.q.add(this.f))):this.element.title=b}F(){if(this.element){const b=this.C()??"";this.element.setAttribute("aria-label",b)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$qS=l;class e extends l{constructor(b,h,$){super(b,h,$),this.m=$,this.m.icon=$.icon!==void 0?$.icon:!1,this.m.label=$.label!==void 0?$.label:!0,this.L=""}render(b){super.render(b),M.$Sf(this.element);const h=document.createElement("a");if(h.classList.add("action-label"),h.setAttribute("role",this.M()),this.I=h,this.element.appendChild(h),this.m.label&&this.m.keybinding){const $=document.createElement("span");$.classList.add("keybinding"),$.textContent=this.m.keybinding,this.element.appendChild($)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===m.$Mi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(b){this.I&&(this.I.tabIndex=b?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let b=null;return this.action.tooltip?b=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(b=this.action.label,this.m.keybinding&&(b=r.localize(0,null,b,this.m.keybinding))),b??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const b=this.C()??"";this.I.setAttribute("aria-label",b)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$rS=e;class s extends l{constructor(b,h,$,c,f,a,C){super(b,h),this.b=new S.$kS($,c,f,a,C),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(b,h){this.b.setOptions(b,h)}select(b){this.b.select(b)}g(){this.B(this.b.onDidSelect(b=>this.n(b.selected,b.index)))}n(b,h){this.actionRunner.run(this._action,this.r(b,h))}r(b,h){return b}setFocusable(b){this.b.setFocusable(b)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(b){this.b.render(b)}}t.$sS=s}),define(be[64],$e([1,0,3,14,63,36,4,2,7,52]),function(ie,t,k,T,n,H,A,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zR=t.$yR=t.ActionsOrientation=void 0;var w;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class D extends S.$Tc{constructor(l,e={}){super(),this.g=this.B(new S.$Sc),this.r=this.B(new S.$3c),this.w=!1,this.y=!0,this.C=this.B(new A.$Vd),this.onDidBlur=this.C.event,this.D=this.B(new A.$Vd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new A.$Vd),this.onDidRun=this.G.event,this.H=this.B(new A.$Vd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new H.$Li,this.g.add(this.f)),this.g.add(this.f.onDidRun(b=>this.G.fire(b))),this.g.add(this.f.onWillRun(b=>this.H.fire(b))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,g;switch(this.m){case 0:s=[15],g=[17];break;case 1:s=[16],g=[18],this.domNode.className+=" vertical";break}this.B(k.$FP(this.domNode,k.$yQ.KEY_DOWN,b=>{const h=new T.$CP(b);let $=!0;const c=typeof this.t=="number"?this.viewItems[this.t]:void 0;s&&(h.equals(s[0])||h.equals(s[1]))?$=this.P():g&&(h.equals(g[0])||h.equals(g[1]))?$=this.O():h.equals(9)&&this.F?this.D.fire():h.equals(14)?$=this.M():h.equals(13)?$=this.N():h.equals(2)&&c instanceof n.$qS&&c.trapsArrowNavigation?$=this.O():this.J(h)?this.n.keyDown?this.R(h):this.w=!0:$=!1,$&&(h.preventDefault(),h.stopPropagation())})),this.B(k.$FP(this.domNode,k.$yQ.KEY_UP,b=>{const h=new T.$CP(b);this.J(h)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(h)),h.preventDefault(),h.stopPropagation()):(h.equals(2)||h.equals(1026)||h.equals(16)||h.equals(18)||h.equals(15)||h.equals(17))&&this.L()})),this.u=this.B(k.$DQ(this.domNode)),this.B(this.u.onDidBlur(()=>{(k.$fQ()===this.domNode||!k.$0P(k.$fQ(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),l.appendChild(this.domNode)}I(){this.length()>=1?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(l){l?this.z.setAttribute("aria-label",l):this.z.removeAttribute("aria-label")}setFocusable(l){if(this.y=l,this.y){const e=this.viewItems.find(s=>s instanceof n.$qS&&s.isEnabled());e instanceof n.$qS&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof n.$qS&&e.setFocusable(!1)})}J(l){let e=!1;return this.n.keys.forEach(s=>{e=e||l.equals(s)}),e}L(){for(let l=0;l<this.z.children.length;l++){const e=this.z.children[l];if(k.$0P(k.$fQ(),e)){this.t=l,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(l){this.j=l,this.viewItems.forEach(e=>e.setActionContext(l))}get actionRunner(){return this.f}set actionRunner(l){this.f=l,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=l)}getContainer(){return this.domNode}hasAction(l){return this.viewItems.findIndex(e=>e.action.id===l.id)!==-1}getAction(l){if(typeof l=="number")return this.viewItems[l]?.action;if(l instanceof HTMLElement){for(;l.parentElement!==this.z;){if(!l.parentElement)return;l=l.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===l)return this.viewItems[e].action}}push(l,e={}){const s=Array.isArray(l)?l:[l];let g=m.$Mf(e.index)?e.index:null;s.forEach(b=>{const h=document.createElement("li");h.className="action-item",h.setAttribute("role","presentation");let $;const c={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&($=this.b.actionViewItemProvider(b,c)),$||($=new n.$rS(this.context,b,c)),this.b.allowContextMenu||this.r.set($,k.$FP(h,k.$yQ.CONTEXT_MENU,f=>{k.$AQ.stop(f,!0)})),$.actionRunner=this.f,$.setActionContext(this.context),$.render(h),this.y&&$ instanceof n.$qS&&this.viewItems.length===0&&$.setFocusable(!0),g===null||g<0||g>=this.z.children.length?(this.z.appendChild(h),this.viewItems.push($)):(this.z.insertBefore(h,this.z.children[g]),this.viewItems.splice(g,0,$),g++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(l){if(l>=0&&l<this.z.children.length){const e=this.z.children.item(l);if(e)return e.clientWidth}return 0}getHeight(l){if(l>=0&&l<this.z.children.length){const e=this.z.children.item(l);if(e)return e.clientHeight}return 0}pull(l){l>=0&&l<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[l]),this.r.deleteAndDispose(this.viewItems[l]),(0,S.$Oc)(this.viewItems.splice(l,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,S.$Oc)(this.viewItems),this.r.clearAndDisposeAll(),k.$EP(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(l){let e=!1,s;if(l===void 0?e=!0:typeof l=="number"?s=l:typeof l=="boolean"&&(e=l),e&&typeof this.t>"u"){const g=this.viewItems.findIndex(b=>b.isEnabled());this.t=g===-1?void 0:g,this.Q(void 0,void 0,!0)}else s!==void 0&&(this.t=s),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(l){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(!l&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.$Mi.ID));return this.Q(),!0}P(l){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(this.t=this.t-1,this.t<0){if(!l&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.$Mi.ID));return this.Q(!0),!0}Q(l,e,s=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const g=this.t!==void 0?this.viewItems[this.t]:void 0;if(g){let b=!0;m.$Wf(g.focus)||(b=!1),this.b.focusOnlyEnabledItems&&m.$Wf(g.isEnabled)&&!g.isEnabled()&&(b=!1),g.action.id===H.$Mi.ID&&(b=!1),b?(s||this.s!==this.t)&&(g.focus(l),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0),b&&g.showHover?.()}}R(l){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof n.$qS){const s=e._context===null||e._context===void 0?l:e._context;this.run(e._action,s)}}async run(l,e){await this.f.run(l,e)}dispose(){this.j=void 0,this.viewItems=(0,S.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$yR=D;function M(r){if(!r.length)return r;let l=-1;for(let s=0;s<r.length;s++)if(r[s].id!==H.$Mi.ID){l=s;break}if(l===-1)return[];r=r.slice(l);for(let s=r.length-1;s>=0&&r[s].id===H.$Mi.ID;s--)r.splice(s,1);let e=!1;for(let s=r.length-1;s>=0;s--){const g=r[s].id===H.$Mi.ID;g&&!e?r.splice(s,1):g?g&&(e=!1):e=!0}return r}t.$zR=M}),define(be[65],$e([1,0,3,22,55,64,57,60,20,4,82,51,109,97]),function(ie,t,k,T,n,H,A,S,m,w,D,M,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0S=t.$9S=t.$8S=t.MessageType=void 0;const l=k.$;var e;(function(b){b[b.INFO=1]="INFO",b[b.WARNING=2]="WARNING",b[b.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$8S={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class s extends m.$gR{constructor(h,$,c){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new w.$Vd),this.onDidChange=this.O.event,this.P=this.B(new w.$Vd),this.onDidHeightChange=this.P.event,this.a=$,this.g=c,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=k.$FQ(h,l(".monaco-inputbox.idle"));const f=this.g.flexibleHeight?"textarea":"input",a=k.$FQ(this.element,l(".ibwrapper"));if(this.b=k.$FQ(a,l(f+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=k.$FQ(a,l("div.mirror")),this.y.innerText="\xA0",this.N=new S.$qR(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),k.$FQ(h,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(L=>this.b.scrollTop=L.scrollTop));const C=this.B(new T.$GR(h.ownerDocument,"selectionchange")),O=w.Event.filter(C.event,()=>h.ownerDocument.getSelection()?.anchorNode===a);this.B(O(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new H.$yR(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(h){this.n=h,this.b.setAttribute("placeholder",h)}setTooltip(h){this.r=h,this.b.title=h}setAriaLabel(h){this.s=h,h?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(h){this.b.value!==h&&(this.b.value=h,this.Y())}get step(){return this.b.step}set step(h){this.b.step=h}get height(){return typeof this.J=="number"?this.J:k.$8P(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return k.$gQ(this.b)}select(h=null){this.b.select(),h&&(this.b.setSelectionRange(h.start,h.end),h.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(h){h?this.enable():this.disable()}get width(){return k.$4P(this.b)}set width(h){if(this.g.flexibleHeight&&this.g.flexibleWidth){let $=0;if(this.y){const c=parseFloat(this.y.style.paddingLeft||"")||0,f=parseFloat(this.y.style.paddingRight||"")||0;$=c+f}this.b.style.width=h-$+"px"}else this.b.style.width=h+"px";this.y&&(this.y.style.width=h+"px")}set paddingRight(h){this.b.style.width=`calc(100% - ${h}px)`,this.y&&(this.y.style.paddingRight=h+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const h=this.L,$=this.J,c=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:h,height:$}),this.N.setScrollPosition({scrollTop:c})}showMessage(h,$){if(this.w==="open"&&(0,M.$zn)(this.h,h))return;this.h=h,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(h.type));const c=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${k.$XQ(c.border,"transparent")}`,this.h.content&&(this.hasFocus()||$)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let h=null;return this.t&&(h=this.t(this.value),h?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(h)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),h?.type}stylesForType(h){const $=this.g.inputBoxStyles;switch(h){case 1:return{border:$.inputValidationInfoBorder,background:$.inputValidationInfoBackground,foreground:$.inputValidationInfoForeground};case 2:return{border:$.inputValidationWarningBorder,background:$.inputValidationWarningBackground,foreground:$.inputValidationWarningForeground};default:return{border:$.inputValidationErrorBorder,background:$.inputValidationErrorBackground,foreground:$.inputValidationErrorForeground}}}U(h){switch(h){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let h;const $=()=>h.style.width=k.$4P(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:f=>{if(!this.h)return null;h=k.$FQ(f,l(".monaco-inputbox-container")),$();const a={inline:!0,className:"monaco-inputbox-message"},C=this.h.formatContent?(0,n.$ER)(this.h.content,a):(0,n.$DR)(this.h.content,a);C.classList.add(this.U(this.h.type));const O=this.stylesForType(this.h.type);return C.style.backgroundColor=O.background??"",C.style.color=O.foreground??"",C.style.border=O.border?`1px solid ${O.border}`:"",k.$FQ(h,C),null},onHide:()=>{this.w="closed"},layout:$});let c;this.h.type===3?c=r.localize(0,null,this.h.content):this.h.type===2?c=r.localize(1,null,this.h.content):c=r.localize(2,null,this.h.content),A.$IR(c),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const h=this.value,c=h.charCodeAt(h.length-1)===10?" ":"";(h+c).replace(/\u000c/g,"")?this.y.textContent=h+c:this.y.innerText="\xA0",this.layout()}ab(){const h=this.g.inputBoxStyles,$=h.inputBackground??"",c=h.inputForeground??"",f=h.inputBorder??"";this.element.style.backgroundColor=$,this.element.style.color=c,this.b.style.backgroundColor="inherit",this.b.style.color=c,this.element.style.border=`1px solid ${k.$XQ(f,"transparent")}`}layout(){if(!this.y)return;const h=this.L;this.L=k.$8P(this.y),h!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(h){const $=this.inputElement,c=$.selectionStart,f=$.selectionEnd,a=$.value;c!==null&&f!==null&&(this.value=a.substr(0,c)+h+a.substr(f),$.setSelectionRange(c+1,c+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$9S=s;class g extends s{constructor(h,$,c){const f=r.localize(3,null,"\u21C5"),a=r.localize(4,null,"\u21C5");super(h,$,c),this.db=this.B(new w.$Vd),this.onDidFocus=this.db.event,this.eb=this.B(new w.$Vd),this.onDidBlur=this.eb.event,this.bb=new D.$6S(c.history,100);const C=()=>{if(c.showHistoryHint&&c.showHistoryHint()&&!this.n.endsWith(f)&&!this.n.endsWith(a)&&this.bb.getHistory().length){const O=this.n.endsWith(")")?f:a,L=this.n+O;c.showPlaceholderOnFocus&&!k.$gQ(this.b)?this.n=L:this.setPlaceHolder(L)}};this.cb=new MutationObserver((O,L)=>{O.forEach(B=>{B.target.textContent||C()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>C()),this.F(this.b,()=>{const O=L=>{if(this.n.endsWith(L)){const B=this.n.slice(0,this.n.length-L.length);return c.showPlaceholderOnFocus?this.n=B:this.setPlaceHolder(B),!0}else return!1};O(a)||O(f)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(h){this.value&&(h||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(h){const $=this.getHistory();this.clearHistory(),h.forEach(c=>{this.bb.add(c)}),$.forEach(c=>{this.bb.add(c)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let h=this.jb();h&&(h=h===this.value?this.jb():h),this.value=h??"",A.$JR(this.value?this.value:r.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let h=this.ib();h&&(h=h===this.value?this.ib():h),h&&(this.value=h,A.$JR(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(h){super.setPlaceHolder(h),this.setTooltip(h)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let h=this.bb.current();return h||(h=this.bb.last(),this.bb.next()),h}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$0S=g}),define(be[66],$e([1,0,63,20,17,18,4,3,102]),function(ie,t,k,T,n,H,A,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pS=t.$oS=t.$nS=t.$mS=t.$lS=void 0,t.$lS={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class m extends k.$qS{constructor(l,e,s){super(l,e,s),this.a=this.B(new w({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:s.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:s.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:s.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(l){this.element=l,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(l){this.a.domNode.tabIndex=l?0:-1}}t.$mS=m;class w extends T.$gR{constructor(l){super(),this.a=this.B(new A.$Vd),this.onChange=this.a.event,this.b=this.B(new A.$Vd),this.onKeyDown=this.b.event,this.c=l,this.s=this.c.isChecked;const e=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,e.push(...H.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&e.push(...this.c.actionClassName.split(" ")),this.s&&e.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...e),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,s=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),s.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,s=>{if(s.keyCode===10||s.keyCode===3){this.checked=!this.s,this.a.fire(!0),s.preventDefault(),s.stopPropagation();return}this.b.fire(s)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(l){this.s=l,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(l){this.g&&this.domNode.classList.remove(...H.ThemeIcon.asClassNameArray(this.g)),this.g=l,this.g&&this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(l){this.domNode.title=l,this.domNode.setAttribute("aria-label",l)}}t.$nS=w;class D extends T.$gR{constructor(l,e,s){super(),this.g=l,this.h=e,this.a=this.B(new A.$Vd),this.onChange=this.a.event,this.b=new w({title:this.g,isChecked:this.h,icon:n.$_j.check,actionClassName:"monaco-checkbox",...t.$lS}),this.domNode=this.b.domNode,this.c=s,this.n(),this.B(this.b.onChange(g=>{this.n(),this.a.fire(g)}))}get checked(){return this.b.checked}set checked(l){this.b.checked=l,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,S.$gQ)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$oS=D;class M extends k.$qS{constructor(l,e,s){super(l,e,s),this.a=this.B(new D(this._action.label,!!this._action.checked,s.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(l){if(this.element=l,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const e=this.element.appendChild((0,S.$)("span.checkbox-label",void 0,this._action.label));this.B((0,S.$FP)(e,S.$yQ.CLICK,s=>{this.a.checked=!this.a.checked,s.stopPropagation(),s.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(l){this.a.domNode.tabIndex=l?0:-1}}t.$pS=M}),define(be[130],$e([1,0,66,17,107]),function(ie,t,k,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kT=t.$jT=t.$iT=void 0;const H=n.localize(0,null),A=n.localize(1,null),S=n.localize(2,null);class m extends k.$nS{constructor(r){super({icon:T.$_j.caseSensitive,title:H+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$iT=m;class w extends k.$nS{constructor(r){super({icon:T.$_j.wholeWord,title:A+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$jT=w;class D extends k.$nS{constructor(r){super({icon:T.$_j.regex,title:S+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$kT=D}),define(be[131],$e([1,0,3,130,65,20,4,106,2,96]),function(ie,t,k,T,n,H,A,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lT=void 0;const w=S.localize(0,null);class D extends H.$gR{static{this.OPTION_CHANGE="optionChange"}constructor(r,l,e){super(),this.n=!0,this.s=!1,this.w=this.B(new m.$Uc),this.N=[],this.O=this.B(new A.$Vd),this.onDidOptionChange=this.O.event,this.P=this.B(new A.$Vd),this.onKeyDown=this.P.event,this.Q=this.B(new A.$Vd),this.onMouseDown=this.Q.event,this.R=this.B(new A.$Vd),this.onInput=this.R.event,this.S=this.B(new A.$Vd),this.onKeyUp=this.S.event,this.U=this.B(new A.$Vd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new A.$Vd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||w,this.h=!!e.showCommonFindToggles;const s=e.appendCaseSensitiveLabel||"",g=e.appendWholeWordsLabel||"",b=e.appendRegexLabel||"",h=e.history||[],$=!!e.flexibleHeight,c=!!e.flexibleWidth,f=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new n.$0S(this.domNode,l,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:h,showHistoryHint:e.showHistoryHint,flexibleHeight:$,flexibleWidth:c,flexibleMaxHeight:f,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new T.$kT({appendTitle:b,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(C=>{this.O.fire(C),!C&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(C=>{this.W.fire(C)})),this.L=this.B(new T.$jT({appendTitle:g,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(C=>{this.O.fire(C),!C&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new T.$iT({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(C=>{this.O.fire(C),!C&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(C=>{this.U.fire(C)}));const a=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,C=>{if(C.equals(15)||C.equals(17)||C.equals(9)){const O=a.indexOf(this.domNode.ownerDocument.activeElement);if(O>=0){let L=-1;C.equals(17)?L=(O+1)%a.length:C.equals(15)&&(O===0?L=a.length-1:L=O-1),C.equals(9)?(a[O].blur(),this.inputBox.focus()):L>=0&&a[L].focus(),k.$AQ.stop(C,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),r?.appendChild(this.domNode),this.B(k.$FP(this.inputBox.inputElement,"compositionstart",a=>{this.s=!0})),this.B(k.$FP(this.inputBox.inputElement,"compositionend",a=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,a=>this.P.fire(a)),this.C(this.inputBox.inputElement,a=>this.S.fire(a)),this.D(this.inputBox.inputElement,a=>this.R.fire()),this.j(this.inputBox.inputElement,a=>this.Q.fire(a))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.X(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const r of this.N)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const r of this.N)r.disable()}setFocusInputOnOptionClick(r){this.n=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const l of this.N)l.domNode.remove();this.N=[],this.w.value=new m.$Sc;for(const l of r??[])this.w.value.add(l),this.y.appendChild(l.domNode),this.w.value.add(l.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(l);this.N.length>0&&(this.y.style.display=""),this.X()}X(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((l,e)=>l+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(r){this.M&&(this.M.checked=r)}getWholeWords(){return this.L?.checked??!1}setWholeWords(r){this.L&&(this.L.checked=r)}getRegex(){return this.J?.checked??!1}setRegex(r){this.J&&(this.J.checked=r,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$lT=D}),define(be[132],$e([1,0,3,22,14,64,131,65,61,39,66,58,26,36,12,9,17,18,32,4,34,2,46,7,111,103]),function(ie,t,k,T,n,H,A,S,m,w,D,M,r,l,e,s,g,b,h,$,c,f,a,C,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WT=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$VT=t.$UT=t.$TT=t.RenderIndentGuides=t.$ST=t.$RT=void 0;class L extends m.$QR{set context(i){this.c.context=i}get context(){return this.c.context}constructor(i){super(i.elements.map(o=>o.element)),this.c=i}}function B(u){return u instanceof m.$QR?new L(u):u}class v{constructor(i,o){this.d=i,this.f=o,this.b=f.$Tc.None,this.c=new f.$Sc}getDragURI(i){return this.f.getDragURI(i.element)}getDragLabel(i,o){if(this.f.getDragLabel)return this.f.getDragLabel(i.map(E=>E.element),o)}onDragStart(i,o){this.f.onDragStart?.(B(i),o)}onDragOver(i,o,E,R,F,j=!0){const q=this.f.onDragOver(B(i),o&&o.element,E,R,F),Z=this.a!==o;if(Z&&(this.b.dispose(),this.a=o),typeof o>"u")return q;if(Z&&typeof q!="boolean"&&q.autoExpand&&(this.b=(0,s.$8g)(()=>{const Ee=this.d(),ve=Ee.getNodeLocation(o);Ee.isCollapsed(ve)&&Ee.setCollapsed(ve,!1),this.a=void 0},500,this.c)),typeof q=="boolean"||!q.accept||typeof q.bubble>"u"||q.feedback){if(!j){const Ee=typeof q=="boolean"?q:q.accept,ve=typeof q=="boolean"?void 0:q.effect;return{accept:Ee,effect:ve,feedback:[E]}}return q}if(q.bubble===1){const Ee=this.d(),ve=Ee.getNodeLocation(o),Te=Ee.getParentNodeLocation(ve),Le=Ee.getNode(Te),Me=Te&&Ee.getListIndex(Te);return this.onDragOver(i,Le,Me,R,F,!1)}const le=this.d(),pe=le.getNodeLocation(o),De=le.getListIndex(pe),we=le.getListRenderCount(pe);return{...q,feedback:(0,e.$Sb)(De,De+we)}}drop(i,o,E,R,F){this.b.dispose(),this.a=void 0,this.f.drop(B(i),o&&o.element,E,R,F)}onDragEnd(i){this.f.onDragEnd?.(i)}dispose(){this.c.dispose(),this.f.dispose()}}function P(u,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(o){return i.identityProvider.getId(o.element)}},dnd:i.dnd&&new v(u,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(o){return i.multipleSelectionController.isSelectionSingleChangeEvent({...o,element:o.element})},isSelectionRangeChangeEvent(o){return i.multipleSelectionController.isSelectionRangeChangeEvent({...o,element:o.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(o){const E=u(),R=E.getNodeLocation(o),F=E.getParentNodeLocation(R);return E.getNode(F).visibleChildrenCount},getPosInSet(o){return o.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?o=>i.accessibilityProvider.isChecked(o.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?o=>i.accessibilityProvider.getRole(o.element):()=>"treeitem",getAriaLabel(o){return i.accessibilityProvider.getAriaLabel(o.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?o=>i.accessibilityProvider.getAriaLevel(o.element):o=>o.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(o=>i.accessibilityProvider.getActiveDescendantId(o.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(o){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(o.element)}}}}class V{constructor(i){this.a=i}getHeight(i){return this.a.getHeight(i.element)}getTemplateId(i){return this.a.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(i.element)}setDynamicHeight(i,o){this.a.setDynamicHeight?.(i.element,o)}}t.$RT=V;class U{static lift(i){return i instanceof U?i:new U(i)}static empty(i=0){return new U({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const o of i.expanded)this.expanded[o]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$ST=U;var N;(function(u){u.None="none",u.OnHover="onHover",u.Always="always"})(N||(t.RenderIndentGuides=N={}));class I{get elements(){return this.b}constructor(i,o=[]){this.b=o,this.a=new f.$Sc,this.onDidChange=$.Event.forEach(i,E=>this.b=E,this.a)}dispose(){this.a.dispose()}}class z{static{this.a=8}constructor(i,o,E,R,F,j={}){this.o=i,this.p=o,this.q=R,this.s=F,this.b=new Map,this.c=new Map,this.d=z.a,this.f=!1,this.g=!1,this.j=new Set,this.k=f.$Tc.None,this.m=new f.$Sc,this.templateId=i.templateId,this.updateOptions(j),$.Event.map(E,q=>q.node)(this.u,this,this.m),i.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(i={}){if(typeof i.indent<"u"){const o=(0,a.$7l)(i.indent,0,40);if(o!==this.d){this.d=o;for(const[E,R]of this.c)this.v(E,R)}}if(typeof i.renderIndentGuides<"u"){const o=i.renderIndentGuides!==N.None;if(o!==this.g){this.g=o;for(const[E,R]of this.c)this.w(E,R);if(this.k.dispose(),o){const E=new f.$Sc;this.q.onDidChange(this.x,this,E),this.k=E,this.x(this.q.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.f=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const o=(0,k.$FQ)(i,(0,k.$)(".monaco-tl-row")),E=(0,k.$FQ)(o,(0,k.$)(".monaco-tl-indent")),R=(0,k.$FQ)(o,(0,k.$)(".monaco-tl-twistie")),F=(0,k.$FQ)(o,(0,k.$)(".monaco-tl-contents")),j=this.o.renderTemplate(F);return{container:i,indent:E,twistie:R,indentGuidesDisposable:f.$Tc.None,templateData:j}}renderElement(i,o,E,R){this.c.set(i,E),this.b.set(i.element,i),this.v(i,E),this.o.renderElement(i,o,E.templateData,R)}disposeElement(i,o,E,R){E.indentGuidesDisposable.dispose(),this.o.disposeElement?.(i,o,E.templateData,R),typeof R=="number"&&(this.c.delete(i),this.b.delete(i.element))}disposeTemplate(i){this.o.disposeTemplate(i.templateData)}t(i){const o=this.b.get(i);o&&this.u(o)}u(i){const o=this.c.get(i);o&&(this.x(this.q.elements),this.v(i,o))}v(i,o){const E=z.a+(i.depth-1)*this.d;o.twistie.style.paddingLeft=`${E}px`,o.indent.style.width=`${E+this.d-16}px`,i.collapsible?o.container.setAttribute("aria-expanded",String(!i.collapsed)):o.container.removeAttribute("aria-expanded"),o.twistie.classList.remove(...b.ThemeIcon.asClassNameArray(g.$_j.treeItemExpanded));let R=!1;this.o.renderTwistie&&(R=this.o.renderTwistie(i.element,o.twistie)),i.collapsible&&(!this.f||i.visibleChildrenCount>0)?(R||o.twistie.classList.add(...b.ThemeIcon.asClassNameArray(g.$_j.treeItemExpanded)),o.twistie.classList.add("collapsible"),o.twistie.classList.toggle("collapsed",i.collapsed)):o.twistie.classList.remove("collapsible","collapsed"),this.w(i,o)}w(i,o){if((0,k.$EP)(o.indent),o.indentGuidesDisposable.dispose(),!this.g)return;const E=new f.$Sc,R=this.p();for(;;){const F=R.getNodeLocation(i),j=R.getParentNodeLocation(F);if(!j)break;const q=R.getNode(j),Z=(0,k.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(q)&&Z.classList.add("active"),o.indent.childElementCount===0?o.indent.appendChild(Z):o.indent.insertBefore(Z,o.indent.firstElementChild),this.s.add(q,Z),E.add((0,f.$Rc)(()=>this.s.delete(q,Z))),i=q}o.indentGuidesDisposable=E}x(i){if(!this.g)return;const o=new Set,E=this.p();i.forEach(R=>{const F=E.getNodeLocation(R);try{const j=E.getParentNodeLocation(F);R.collapsible&&R.children.length>0&&!R.collapsed?o.add(R):j&&o.add(E.getNode(j))}catch{}}),this.j.forEach(R=>{o.has(R)||this.s.forEach(R,F=>F.classList.remove("active"))}),o.forEach(R=>{this.j.has(R)||this.s.forEach(R,F=>F.classList.add("active"))}),this.j=o}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,f.$Oc)(this.m)}}t.$TT=z;class X{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(i){this.c=i,this.d=i.toLowerCase()}constructor(i,o,E){this.g=i,this.j=o,this.k=E,this.a=0,this.b=0,this.c="",this.d="",this.f=new f.$Sc,i.onWillRefilter(this.m,this,this.f)}filter(i,o){let E=1;if(this.k){const j=this.k.filter(i,o);if(typeof j=="boolean"?E=j?1:0:(0,M.$OT)(j)?E=(0,M.$PT)(j.visibility):E=j,E===0)return!1}if(this.a++,!this.c)return this.b++,{data:c.FuzzyScore.Default,visibility:E};const R=this.j.getKeyboardNavigationLabel(i),F=Array.isArray(R)?R:[R];for(const j of F){const q=j&&j.toString();if(typeof q>"u")return{data:c.FuzzyScore.Default,visibility:E};let Z;if(this.g.findMatchType===ge.Contiguous){const le=q.toLowerCase().indexOf(this.d);if(le>-1){Z=[Number.MAX_SAFE_INTEGER,0];for(let pe=this.d.length;pe>0;pe--)Z.push(le+pe-1)}}else Z=(0,c.$7j)(this.c,this.d,0,q,q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return this.b++,F.length===1?{data:Z,visibility:E}:{data:{label:q,score:Z},visibility:E}}return this.g.findMode===ee.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(i):2:{data:c.FuzzyScore.Default,visibility:E}}m(){this.a=0,this.b=0}dispose(){(0,f.$Oc)(this.f)}}class Y extends D.$nS{constructor(i){super({icon:g.$_j.listFilter,title:(0,O.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$UT=Y;class fe extends D.$nS{constructor(i){super({icon:g.$_j.searchFuzzy,title:(0,O.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$VT=fe;const ae={inputBoxStyles:S.$8S,toggleStyles:D.$lS,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ee;(function(u){u[u.Highlight=0]="Highlight",u[u.Filter=1]="Filter"})(ee||(t.TreeFindMode=ee={}));var ge;(function(u){u[u.Fuzzy=0]="Fuzzy",u[u.Contiguous=1]="Contiguous"})(ge||(t.TreeFindMatchType=ge={}));class Ie extends f.$Tc{set mode(i){this.b.checked=i===ee.Filter,this.f.inputBox.setPlaceHolder(i===ee.Filter?(0,O.localize)(2,null):(0,O.localize)(3,null))}set matchType(i){this.c.checked=i===ge.Fuzzy}get value(){return this.f.inputBox.value}set value(i){this.f.inputBox.value=i}constructor(i,o,E,R,F,j){super(),this.t=o,this.a=(0,k.h)(".monaco-tree-type-filter",[(0,k.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,k.h)(".monaco-tree-type-filter-input@findInput"),(0,k.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new $.$Vd,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.a.root),this.B((0,f.$Rc)(()=>i.removeChild(this.a.root)));const q=j?.styles??ae;q.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=q.listFilterWidgetBackground),q.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${q.listFilterWidgetShadow}`),this.b=this.B(new Y({...q.toggleStyles,isChecked:R===ee.Filter})),this.c=this.B(new fe({...q.toggleStyles,isChecked:F===ge.Fuzzy})),this.onDidChangeMode=$.Event.map(this.b.onChange,()=>this.b.checked?ee.Filter:ee.Highlight,this.q),this.onDidChangeMatchType=$.Event.map(this.c.onChange,()=>this.c.checked?ge.Fuzzy:ge.Contiguous,this.q),this.f=this.B(new A.$lT(this.a.findInput,E,{label:(0,O.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:q.inputBoxStyles,toggleStyles:q.toggleStyles,history:j?.history})),this.g=this.B(new H.$yR(this.a.actionbar)),this.mode=R;const Z=this.B(new T.$GR(this.f.inputBox.inputElement,"keydown")),le=$.Event.chain(Z.event,Ee=>Ee.map(ve=>new n.$CP(ve)));this.B(le(Ee=>{if(Ee.equals(3)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ee.equals(18)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ee.equals(16)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const pe=this.B(new l.$Ki("close",(0,O.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(pe,{icon:!0,label:!1});const De=this.B(new T.$GR(this.a.grab,"mousedown"));this.B(De.event(Ee=>{const ve=new f.$Sc,Te=ve.add(new T.$GR((0,k.getWindow)(Ee),"mousemove")),Le=ve.add(new T.$GR((0,k.getWindow)(Ee),"mouseup")),Me=this.m,Ze=Ee.pageX,et=this.s,xe=Ee.pageY;this.a.grab.classList.add("grabbing");const K=this.a.root.style.transition;this.a.root.style.transition="unset";const ne=de=>{const Ae=de.pageX-Ze;this.m=Me-Ae;const Ne=de.pageY-xe;this.s=et+Ne,this.layout()};ve.add(Te.event(ne)),ve.add(Le.event(de=>{ne(de),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=K,ve.dispose()}))}));const we=$.Event.chain(this.B(new T.$GR(this.a.grab,"keydown")).event,Ee=>Ee.map(ve=>new n.$CP(ve)));this.B(we(Ee=>{let ve,Te;if(Ee.keyCode===15?ve=Number.POSITIVE_INFINITY:Ee.keyCode===17?ve=0:Ee.keyCode===10&&(ve=this.m===0?Number.POSITIVE_INFINITY:0),Ee.keyCode===16?Te=0:Ee.keyCode===18&&(Te=Number.POSITIVE_INFINITY),ve!==void 0&&(Ee.preventDefault(),Ee.stopPropagation(),this.m=ve,this.layout()),Te!==void 0){Ee.preventDefault(),Ee.stopPropagation(),this.s=Te;const Le=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Le},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(i=this.j){this.j=i,this.m=(0,a.$7l)(this.m,0,Math.max(0,i-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,a.$7l)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(i){this.f.showMessage(i)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$7g)(300),super.dispose()}}class Ce{get pattern(){return this.b}get mode(){return this.d}set mode(i){i!==this.d&&(this.d=i,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(i))}get matchType(){return this.f}set matchType(i){i!==this.f&&(this.f=i,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(i))}constructor(i,o,E,R,F,j={}){this.t=i,this.u=E,this.v=R,this.w=F,this.x=j,this.b="",this.c="",this.j=0,this.k=new $.$Vd,this.onDidChangeMode=this.k.event,this.m=new $.$Vd,this.onDidChangeMatchType=this.m.event,this.o=new $.$Vd,this.onDidChangePattern=this.o.event,this.p=new $.$Vd,this.onDidChangeOpenState=this.p.event,this.q=new f.$Sc,this.s=new f.$Sc,this.d=i.options.defaultFindMode??ee.Highlight,this.f=i.options.defaultFindMatchType??ge.Fuzzy,o.onDidSplice(this.z,this,this.s)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Ie(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(i=>this.mode=i,void 0,this.q),this.g.onDidChangeMatchType(i=>this.matchType=i,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(i){this.b=i,this.o.fire(i),this.v.pattern=i,this.t.refilter(),i&&this.t.focusNext(0,!0,void 0,E=>!c.FuzzyScore.isDefault(E.filterData));const o=this.t.getFocus();if(o.length>0){const E=o[0];this.t.getRelativeTop(E)===null&&this.t.reveal(E,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const i=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&i?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,O.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(i){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!c.FuzzyScore.isDefault(i.filterData)}layout(i){this.j=i,this.g?.layout(i)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Be(u,i){return u.position===i.position&&se(u,i)}function se(u,i){return u.node.element===i.node.element&&u.startIndex===i.startIndex&&u.height===i.height&&u.endIndex===i.endIndex}class J{constructor(i=[]){this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,e.$ub)(this.stickyNodes,i.stickyNodes,Be)}lastNodePartiallyVisible(){if(this.count===0)return!1;const i=this.stickyNodes[this.count-1];if(this.count===1)return i.position!==0;const o=this.stickyNodes[this.count-2];return o.position+o.height!==i.position}animationStateChanged(i){if(!(0,e.$ub)(this.stickyNodes,i.stickyNodes,se)||this.count===0)return!1;const o=this.stickyNodes[this.count-1],E=i.stickyNodes[i.count-1];return o.position!==E.position}}class re{constrainStickyScrollNodes(i,o,E){for(let R=0;R<i.length;R++){const F=i[R];if(F.position+F.height>E||R>=o)return i.slice(0,R)}return i}}class oe extends f.$Tc{constructor(i,o,E,R,F,j={}){super(),this.g=i,this.j=o,this.m=E,this.s=F,this.c=.4;const q=this.validateStickySettings(j);this.b=q.stickyScrollMaxItemCount,this.a=j.stickyScrollDelegate??new re,this.f=this.B(new W(E.getScrollableElement(),E,i,R,F,j.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(E.onDidScroll(()=>this.u())),this.B(E.onDidChangeContentHeight(()=>this.u())),this.B(i.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(i){return this.f.getNode(i)}t(i){let o;if(i===0?o=this.m.firstVisibleIndex:o=this.m.indexAt(i+this.m.scrollTop),!(o<0||o>=this.m.length))return this.m.element(o)}u(){const i=this.t(0);if(!i||this.g.scrollTop===0){this.f.setState(void 0);return}const o=this.w(i);this.f.setState(o)}w(i){const o=[];let E=i,R=0,F=this.z(E,void 0,R);for(;F&&(o.push(F),R+=F.height,!(o.length<=this.b&&(E=this.y(F),!E)));)F=this.z(E,F.node,R);const j=this.H(o);return j.length?new J(j):void 0}y(i){return this.t(i.position+i.height)}z(i,o,E){const R=this.F(i,o);if(R&&!(R===i&&(!this.J(i)||this.C(i,E))))return this.D(R,E)}C(i,o){const E=this.L(i),R=this.m.getElementTop(E),F=o;return this.m.scrollTop===R-F}D(i,o){const E=this.s.getHeight(i),{startIndex:R,endIndex:F}=this.M(i),j=this.G(F,o,E);return{node:i,position:j,height:E,startIndex:R,endIndex:F}}F(i,o=void 0){let E=i,R=this.I(E);for(;R;){if(R===o)return E;E=R,R=this.I(E)}if(o===void 0)return E}G(i,o,E){let R=this.m.getRelativeTop(i);if(R===null&&this.m.firstVisibleIndex===i&&i+1<this.m.length){const le=this.s.getHeight(this.m.element(i)),pe=this.m.getRelativeTop(i+1);R=pe?pe-le/this.m.renderHeight:null}if(R===null)return o;const F=this.m.element(i),j=this.s.getHeight(F),Z=R*this.m.renderHeight+j;return o+E>Z&&o<=Z?Z-E:o}H(i){if(i.length===0)return[];const o=this.m.renderHeight*this.c,E=i[i.length-1];if(i.length<=this.b&&E.position+E.height<=o)return i;const R=this.a.constrainStickyScrollNodes(i,this.b,o);if(!R.length)return[];const F=R[R.length-1];if(R.length>this.b||F.position+F.height>o)throw new Error("stickyScrollDelegate violates constraints");return R}I(i){const o=this.j.getNodeLocation(i),E=this.j.getParentNodeLocation(o);return E?this.j.getNode(E):void 0}J(i){const o=this.j.getNodeLocation(i);return this.j.getListRenderCount(o)>1}L(i){const o=this.j.getNodeLocation(i);return this.j.getListIndex(o)}M(i){const o=this.j.getNodeLocation(i),E=this.j.getListIndex(o);if(E<0)throw new Error("Node not found in tree");const R=this.j.getListRenderCount(o),F=E+R-1;return{startIndex:E,endIndex:F}}nodePositionTopBelowWidget(i){const o=[];let E=this.I(i);for(;E;)o.push(E),E=this.I(E);let R=0;for(let F=0;F<o.length&&F<this.b;F++)R+=this.s.getHeight(o[F]);return R}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(i={}){if(!i.stickyScrollMaxItemCount)return;const o=this.validateStickySettings(i);this.b!==o.stickyScrollMaxItemCount&&(this.b=o.stickyScrollMaxItemCount,this.u())}validateStickySettings(i){let o=7;return typeof i.stickyScrollMaxItemCount=="number"&&(o=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:o}}}class W{constructor(i,o,E,R,F,j){this.g=o,this.j=E,this.k=R,this.m=F,this.o=j,this.c=[],this.d=new f.$Sc,this.a=(0,k.$)(".monaco-tree-sticky-container.empty"),i.appendChild(this.a);const q=(0,k.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(q),this.f=new G(this.a,o),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const i=this.b.stickyNodes[this.b.count-1];return i.position+i.height}get count(){return this.b?.count??0}getNode(i){return this.b?.stickyNodes.find(o=>o.node===i)}setState(i){const o=!!this.b&&this.b.count>0,E=!!i&&i.count>0;if(!o&&!E||o&&E&&this.b.equal(i))return;if(o!==E&&this.s(E),!E){this.b=void 0,this.c=[],this.d.clear();return}const R=i.stickyNodes[i.count-1];if(this.b&&i.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${R.position}px`;else{this.d.clear();const F=Array(i.count);for(let j=i.count-1;j>=0;j--){const q=i.stickyNodes[j],{element:Z,disposable:le}=this.p(q,j,i.count);F[j]=Z,this.a.appendChild(Z),this.d.add(le)}this.f.updateElements(F,i),this.c=F}this.b=i,this.a.style.height=`${R.position+R.height}px`}p(i,o,E){const R=i.startIndex,F=document.createElement("div");F.style.top=`${i.position}px`,F.style.height=`${i.height}px`,F.style.lineHeight=`${i.height}px`,F.classList.add("monaco-tree-sticky-row"),F.classList.add("monaco-list-row"),F.setAttribute("data-index",`${R}`),F.setAttribute("data-parity",R%2===0?"even":"odd"),F.setAttribute("id",this.g.getElementID(R)),this.q(F,i.node.element,o,E);const j=this.m.getTemplateId(i.node),q=this.k.find(De=>De.templateId===j);if(!q)throw new Error(`No renderer found for template id ${j}`);let Z=i.node;Z===this.j.getNode(this.j.getNodeLocation(i.node))&&(Z=new Proxy(i.node,{}));const le=q.renderTemplate(F);q.renderElement(Z,i.startIndex,le,i.height);const pe=(0,f.$Rc)(()=>{q.disposeElement(Z,i.startIndex,le,i.height),q.disposeTemplate(le),F.remove()});return{element:F,disposable:pe}}q(i,o,E,R){if(!this.o)return;this.o.getSetSize&&i.setAttribute("aria-setsize",String(this.o.getSetSize(o,E,R))),this.o.getPosInSet&&i.setAttribute("aria-posinset",String(this.o.getPosInSet(o,E))),this.o.getRole&&i.setAttribute("role",this.o.getRole(o)??"treeitem");const F=this.o.getAriaLabel(o);F&&i.setAttribute("aria-label",F);const j=this.o.getAriaLevel&&this.o.getAriaLevel(o);typeof j=="number"&&i.setAttribute("aria-level",`${j}`),i.setAttribute("aria-selected",String(!1))}s(i){this.a.classList.toggle("empty",!i),i||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class G extends f.$Tc{get m(){return this.j}set m(i){this.j=i,this.f.fire(i)}constructor(i,o){super(),this.s=i,this.t=o,this.a=-1,this.b=[],this.f=new $.$Vd,this.onDidChangeHasFocus=this.f.event,this.g=new $.$Vd,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(E=>this.w(E))),this.B(this.t.onMouseDown(E=>this.y(E))),this.B(this.t.onContextMenu(E=>this.u(E)))}u(i){const o=i.browserEvent.target;if(!(0,w.$4R)(o)&&!(0,w.$3R)(o)){this.focusedLast()&&this.t.domFocus();return}if(!(0,k.$vQ)(i.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const j=this.c.stickyNodes.findIndex(q=>q.node.element===i.element?.element);if(j===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(j);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const R=this.c.stickyNodes[this.a].node.element,F=this.b[this.a];this.g.fire({element:R,anchor:F,browserEvent:i.browserEvent,isStickyScroll:!0})}w(i){if(this.m&&this.c){if(i.key==="ArrowUp")this.z(Math.max(0,this.a-1)),i.preventDefault(),i.stopPropagation();else if(i.key==="ArrowDown"||i.key==="ArrowRight"){if(this.a>=this.c.count-1){const o=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([o]),this.C(o,this.c)}else this.z(this.a+1);i.preventDefault(),i.stopPropagation()}}}y(i){const o=i.browserEvent.target;!(0,w.$4R)(o)&&!(0,w.$3R)(o)||(i.browserEvent.preventDefault(),i.browserEvent.stopPropagation())}updateElements(i,o){if(o&&o.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(o&&o.count!==i.length)throw new Error("Sticky scroll focus received illigel state");const E=this.a;if(this.D(),this.b=i,this.c=o,o){const R=(0,a.$7l)(E,0,o.count-1);this.F(R)}else this.m&&this.t.domFocus();this.s.tabIndex=o?0:-1}z(i){const o=this.c;if(!o)throw new Error("Cannot set focus when state is undefined");if(this.F(i),!(i<o.count-1)&&o.lastNodePartiallyVisible()){const E=o.stickyNodes[i];this.C(E.endIndex+1,o)}}C(i,o){const E=o.stickyNodes[o.count-1],R=o.count>1?o.stickyNodes[o.count-2]:void 0,F=this.t.getElementTop(i),j=R?R.position+R.height+E.height:E.height;this.t.scrollTop=F-j}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(i){if(0>i)throw new Error("addFocus() can not remove focus");if(!this.c&&i>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&i>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const o=this.a;o>=0&&this.G(this.b[o],!1),i>=0&&this.G(this.b[i],!0),this.a=i}G(i,o){i.classList.toggle("focused",o)}H(i){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",i)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function ue(u){let i=r.TreeMouseEventTarget.Unknown;return(0,k.$bQ)(u.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=r.TreeMouseEventTarget.Twistie:(0,k.$bQ)(u.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=r.TreeMouseEventTarget.Element:(0,k.$bQ)(u.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=r.TreeMouseEventTarget.Filter),{browserEvent:u.browserEvent,element:u.element?u.element.element:null,target:i}}function me(u){const i=(0,w.$4R)(u.browserEvent.target);return{element:u.element?u.element.element:null,browserEvent:u.browserEvent,anchor:u.anchor,isStickyScroll:i}}function Se(u,i){i(u),u.children.forEach(o=>Se(o,i))}class ke{get f(){return this.d||(this.d=this.m()),this.d}constructor(i,o){this.g=i,this.j=o,this.a=[],this.c=new $.$Vd,this.onDidChange=this.c.event}set(i,o){!o?.__forceEvent&&(0,e.$ub)(this.a,i)||this.k(i,!1,o)}k(i,o,E){if(this.a=[...i],this.b=void 0,this.d=void 0,!o){const R=this;this.c.fire({get elements(){return R.get()},browserEvent:E})}}get(){return this.b||(this.b=this.a.map(i=>i.element)),[...this.b]}getNodes(){return this.a}has(i){return this.f.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:o}){if(!this.j){const Z=this.m(),le=pe=>Z.delete(pe);o.forEach(pe=>Se(pe,le)),this.set([...Z.values()]);return}const E=new Set,R=Z=>E.add(this.j.getId(Z.element).toString());o.forEach(Z=>Se(Z,R));const F=new Map,j=Z=>F.set(this.j.getId(Z.element).toString(),Z);i.forEach(Z=>Se(Z,j));const q=[];for(const Z of this.a){const le=this.j.getId(Z.element).toString();if(!E.has(le))q.push(Z);else{const De=F.get(le);De&&De.visible&&q.push(De)}}if(this.a.length>0&&q.length===0){const Z=this.g();Z&&q.push(Z)}this.k(q,!0)}m(){const i=new Set;for(const o of this.a)i.add(o);return i}}class Pe extends w.$9R{constructor(i,o,E){super(i),this.x=o,this.y=E}u(i){if((0,w.$5R)(i.browserEvent.target)||(0,w.$XR)(i.browserEvent.target)||(0,w.$YR)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const o=i.element;if(!o)return super.u(i);if(this.p(i)||this.o(i))return super.u(i);const E=i.browserEvent.target,R=E.classList.contains("monaco-tl-twistie")||E.classList.contains("monaco-icon-label")&&E.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,F=(0,w.$3R)(i.browserEvent.target);let j=!1;if(F?j=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?j=this.x.expandOnlyOnTwistieClick(o.element):j=!!this.x.expandOnlyOnTwistieClick,F)this.A(i,o);else{if(j&&!R&&i.browserEvent.detail!==2)return super.u(i);if(!this.x.expandOnDoubleClick&&i.browserEvent.detail===2)return super.u(i)}if(o.collapsible&&(!F||R)){const q=this.x.getNodeLocation(o),Z=i.browserEvent.altKey;if(this.x.setFocus([q]),this.x.toggleCollapsed(q,Z),j&&R){i.browserEvent.isHandledByList=!0;return}}F||super.u(i)}A(i,o){if((0,w.$ZR)(i.browserEvent.target)||(0,w.$1R)(i.browserEvent.target))return;const E=this.y();if(!E)throw new Error("Sticky scroll controller not found");const R=this.k.indexOf(o),F=this.k.getElementTop(R),j=E.nodePositionTopBelowWidget(o);this.x.scrollTop=F-j,this.k.domFocus(),this.k.setFocus([R]),this.k.setSelection([R])}v(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||i.browserEvent.isHandledByList||super.v(i)}s(i){const o=i.browserEvent.target;if(!(0,w.$4R)(o)&&!(0,w.$3R)(o)){super.s(i);return}}t(i){const o=i.browserEvent.target;if(!(0,w.$4R)(o)&&!(0,w.$3R)(o)){super.t(i);return}}}class x extends w.$_R{constructor(i,o,E,R,F,j,q,Z){super(i,o,E,R,Z),this.p=F,this.s=j,this.K=q}D(i){return new Pe(this,i.tree,i.stickyScrollProvider)}splice(i,o,E=[]){if(super.splice(i,o,E),E.length===0)return;const R=[],F=[];let j;E.forEach((q,Z)=>{this.p.has(q)&&R.push(i+Z),this.s.has(q)&&F.push(i+Z),this.K.has(q)&&(j=i+Z)}),R.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...R])),F.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...F])),typeof j=="number"&&super.setAnchor(j)}setFocus(i,o,E=!1){super.setFocus(i,o),E||this.p.set(i.map(R=>this.element(R)),o)}setSelection(i,o,E=!1){super.setSelection(i,o),E||this.s.set(i.map(R=>this.element(R)),o)}setAnchor(i,o=!1){super.setAnchor(i),o||(typeof i>"u"?this.K.set([]):this.K.set([this.element(i)]))}}var d;(function(u){u[u.Tree=0]="Tree",u[u.StickyScroll=1]="StickyScroll"})(d||(t.AbstractTreePart=d={}));class y{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return $.Event.map(this.j.onMouseClick,ue)}get onMouseDblClick(){return $.Event.filter($.Event.map(this.j.onMouseDblClick,ue),i=>i.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return $.Event.any($.Event.filter($.Event.map(this.j.onContextMenu,me),i=>!i.isStickyScroll),this.B?.onContextMenu??$.Event.None)}get onTap(){return $.Event.map(this.j.onTap,ue)}get onPointer(){return $.Event.map(this.j.onPointer,ue)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return $.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ee.Highlight}set findMode(i){this.z&&(this.z.mode=i)}get findMatchType(){return this.z?.matchType??ge.Fuzzy}set findMatchType(i){this.z&&(this.z.matchType=i)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:$.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(i,o,E,R,F={}){this.G=i,this.H=F,this.y=new $.$4d,this.onDidChangeFindOpenState=$.Event.None,this.onDidChangeStickyScrollFocused=$.Event.None,this.D=new f.$Sc,this.E=new $.$Vd,this.onWillRefilter=this.E.event,this.F=new $.$Vd,this.onDidUpdateOptions=this.F.event,this.p=new V(E);const j=new $.$5d,q=new $.$5d,Z=this.D.add(new I(q.event)),le=new h.$Gc;this.k=R.map(ve=>new z(ve,()=>this.o,j.event,Z,le,F));for(const ve of this.k)this.D.add(ve);let pe;F.keyboardNavigationLabelProvider&&(pe=new X(this,F.keyboardNavigationLabelProvider,F.filter),F={...F,filter:pe},this.D.add(pe)),this.q=new ke(()=>this.j.getFocusedElements()[0],F.identityProvider),this.w=new ke(()=>this.j.getSelectedElements()[0],F.identityProvider),this.x=new ke(()=>this.j.getAnchorElement(),F.identityProvider),this.j=new x(i,o,this.p,this.k,this.q,this.w,this.x,{...P(()=>this.o,F),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(i,this.j,F),j.input=this.o.onDidChangeCollapseState;const De=$.Event.forEach(this.o.onDidSplice,ve=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(ve),this.w.onDidModelSplice(ve)})},this.D);De(()=>null,null,this.D);const we=this.D.add(new $.$Vd),Ee=this.D.add(new s.$3g(0));if(this.D.add($.Event.any(De,this.q.onDidChange,this.w.onDidChange)(()=>{Ee.trigger(()=>{const ve=new Set;for(const Te of this.q.getNodes())ve.add(Te);for(const Te of this.w.getNodes())ve.add(Te);we.fire([...ve.values()])})})),q.input=we.event,F.keyboardSupport!==!1){const ve=$.Event.chain(this.j.onKeyDown,Te=>Te.filter(Le=>!(0,w.$XR)(Le.target)).map(Le=>new n.$CP(Le)));$.Event.chain(ve,Te=>Te.filter(Le=>Le.keyCode===15))(this.J,this,this.D),$.Event.chain(ve,Te=>Te.filter(Le=>Le.keyCode===17))(this.K,this,this.D),$.Event.chain(ve,Te=>Te.filter(Le=>Le.keyCode===10))(this.L,this,this.D)}if((F.findWidgetEnabled??!0)&&F.keyboardNavigationLabelProvider&&F.contextViewProvider){const ve=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Ce(this,this.o,this.j,pe,F.contextViewProvider,ve),this.A=Te=>this.z.shouldAllowFocus(Te),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=$.Event.None,this.onDidChangeFindMatchType=$.Event.None;F.enableStickyScroll&&(this.B=new oe(this,this.o,this.j,this.k,this.p,F),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,k.$nQ)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===N.Always)}updateOptions(i={}){this.H={...this.H,...i};for(const o of this.k)o.updateOptions(i);this.j.updateOptions(this.H),this.z?.updateOptions(i),this.I(i),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===N.Always)}get options(){return this.H}I(i){!this.B&&this.H.enableStickyScroll?(this.B=new oe(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=$.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(i)}updateWidth(i){const o=this.o.getListIndex(i);o!==-1&&this.j.updateWidth(o)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(i){this.j.scrollTop=i}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(i){this.j.scrollLeft=i}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let i=this.j.firstVisibleIndex;return this.B&&(i+=this.B.count),i<0||i>=this.j.length?void 0:this.j.element(i).element}get lastVisibleElement(){const i=this.j.lastVisibleIndex;return this.j.element(i).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(i){this.j.ariaLabel=i}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,k.$gQ)(this.getHTMLElement())}layout(i,o){this.j.layout(i,o),(0,C.$Mf)(o)&&this.z?.layout(o)}style(i){const o=`.${this.j.domId}`,E=[];i.treeIndentGuidesStroke&&(E.push(`.monaco-list${o}:hover .monaco-tl-indent > .indent-guide, .monaco-list${o}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),E.push(`.monaco-list${o} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(E.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),E.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),i.listFocusForeground&&(E.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${i.listFocusForeground}; }`),E.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const R=(0,k.$XQ)(i.listFocusAndSelectionOutline,(0,k.$XQ)(i.listSelectionOutline,i.listFocusOutline??""));R&&(E.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${R}; outline-offset: -1px;}`),E.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),i.listFocusOutline&&(E.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${i.listFocusOutline}; outline-offset: -1px; }`),E.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),E.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),E.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=E.join(`
`),this.j.style(i)}getParentElement(i){const o=this.o.getParentNodeLocation(i);return this.o.getNode(o).element}getFirstElementChild(i){return this.o.getFirstElementChild(i)}getNode(i){return this.o.getNode(i)}getNodeLocation(i){return this.o.getNodeLocation(i)}collapse(i,o=!1){return this.o.setCollapsed(i,!0,o)}expand(i,o=!1){return this.o.setCollapsed(i,!1,o)}toggleCollapsed(i,o=!1){return this.o.setCollapsed(i,void 0,o)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(i){return this.o.isCollapsible(i)}setCollapsible(i,o){return this.o.setCollapsible(i,o)}isCollapsed(i){return this.o.isCollapsed(i)}expandTo(i){this.o.expandTo(i)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(i){if(typeof i>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const o=this.o.getNode(i);this.x.set([o]);const E=this.o.getListIndex(i);E>-1&&this.j.setAnchor(E,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(i,o){this.y.bufferEvents(()=>{const E=i.map(F=>this.o.getNode(F));this.w.set(E,o);const R=i.map(F=>this.o.getListIndex(F)).filter(F=>F>-1);this.j.setSelection(R,o,!0)})}getSelection(){return this.w.get()}setFocus(i,o){this.y.bufferEvents(()=>{const E=i.map(F=>this.o.getNode(F));this.q.set(E,o);const R=i.map(F=>this.o.getListIndex(F)).filter(F=>F>-1);this.j.setFocus(R,o,!0)})}focusNext(i=1,o=!1,E,R=(0,k.$vQ)(E)&&E.altKey?void 0:this.A){this.j.focusNext(i,o,E,R)}focusPrevious(i=1,o=!1,E,R=(0,k.$vQ)(E)&&E.altKey?void 0:this.A){this.j.focusPrevious(i,o,E,R)}focusNextPage(i,o=(0,k.$vQ)(i)&&i.altKey?void 0:this.A){return this.j.focusNextPage(i,o)}focusPreviousPage(i,o=(0,k.$vQ)(i)&&i.altKey?void 0:this.A){return this.j.focusPreviousPage(i,o,()=>this.B?.height??0)}focusLast(i,o=(0,k.$vQ)(i)&&i.altKey?void 0:this.A){this.j.focusLast(i,o)}focusFirst(i,o=(0,k.$vQ)(i)&&i.altKey?void 0:this.A){this.j.focusFirst(i,o)}getFocus(){return this.q.get()}getStickyScrollFocus(){const i=this.B?.getFocus();return i!==void 0?[i]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(i,o){this.o.expandTo(i);const E=this.o.getListIndex(i);if(E!==-1)if(!this.B)this.j.reveal(E,o);else{const R=this.B.nodePositionTopBelowWidget(this.getNode(i));this.j.reveal(E,o,R)}}getRelativeTop(i){const o=this.o.getListIndex(i);if(o===-1)return null;const E=this.B?.getNode(this.getNode(i));return this.j.getRelativeTop(o,E?.position??this.B?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new r.$MT(this.G,"Can't get tree view state without an identity provider");const o=j=>i.getId(j).toString(),E=U.empty(this.scrollTop);for(const j of this.getFocus())E.focus.add(o(j));for(const j of this.getSelection())E.selection.add(o(j));const R=this.o.getNode(),F=[R];for(;F.length>0;){const j=F.shift();j!==R&&j.collapsible&&(E.expanded[o(j.element)]=j.collapsed?0:1),F.push(...j.children)}return E}J(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const E=o[0],R=this.o.getNodeLocation(E);if(!this.o.setCollapsed(R,!0)){const j=this.o.getParentNodeLocation(R);if(!j)return;const q=this.o.getListIndex(j);this.j.reveal(q),this.j.setFocus([q])}}K(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const E=o[0],R=this.o.getNodeLocation(E);if(!this.o.setCollapsed(R,!1)){if(!E.children.some(Z=>Z.visible))return;const[j]=this.j.getFocus(),q=j+1;this.j.reveal(q),this.j.setFocus([q])}}L(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const E=o[0],R=this.o.getNodeLocation(E),F=i.browserEvent.altKey;this.o.setCollapsed(R,void 0,F)}navigate(i){return new p(this.j,this.o,i)}dispose(){(0,f.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$WT=y;class p{constructor(i,o,E){this.b=i,this.c=o,E?this.a=this.c.getListIndex(E):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[133],$e([1,0,132,123,26,28]),function(ie,t,k,T,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8T=void 0;class A extends k.$WT{constructor(m,w,D,M,r,l={}){super(m,w,D,M,l),this.f=m,this.g=r,this.d=new Map,this.c=l.identityProvider}getInput(){return this.b}setInput(m,w){if(w&&!this.c)throw new n.$MT(this.f,"Can't restore tree view state without an identity provider");if(this.b=m,!m){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!w){this.m(m);return}const D=[],M=[],r=e=>{const s=this.c.getId(e).toString();return!w.expanded[s]},l=e=>{const s=this.c.getId(e.element).toString();w.focus.has(s)&&D.push(e.element),w.selection.has(s)&&M.push(e.element)};this.m(m,r,l),this.setFocus(D),this.setSelection(M),w&&typeof w.scrollTop=="number"&&(this.scrollTop=w.scrollTop)}updateChildren(m=this.b){if(typeof this.b>"u")throw new n.$MT(this.f,"Tree input not set");let w;this.c&&(w=D=>{const M=this.c.getId(D).toString(),r=this.d.get(M);if(r)return r.collapsed}),this.m(m,w)}resort(m=this.b,w=!0){this.o.resort(m===this.b?null:m,w)}refresh(m){if(m===void 0){this.j.rerender();return}this.o.rerender(m)}m(m,w,D){let M;if(this.c){const r=new Set,l=D;D=e=>{const s=this.c.getId(e.element).toString();r.add(s),this.d.set(s,e),l?.(e)},M=e=>{const s=this.c.getId(e.element).toString();r.has(s)||this.d.delete(s)}}this.o.setChildren(m===this.b?null:m,this.s(m,w).elements,{onDidCreateNode:D,onDidDeleteNode:M})}s(m,w){const D=[...this.g.getChildren(m)];return{elements:H.Iterable.map(D,r=>{const{elements:l,size:e}=this.s(r,w),s=this.g.hasChildren?this.g.hasChildren(r):void 0,g=e===0?void 0:w&&w(r);return{element:r,children:l,collapsible:s,collapsed:g}}),size:D.length}}M(m,w,D){return new T.$XT(m,w,D)}}t.$8T=A}),define(be[67],$e([1,0,12,9,33,29,27,6,4,2,53,10,7]),function(ie,t,k,T,n,H,A,S,m,w,D,M,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oh=t.ProxyChannel=t.$Nh=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.RequestInitiator=t.$Hh=t.$Gh=t.$Fh=t.$Eh=t.$Dh=void 0;var l;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(l||(l={}));function e(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(s||(s={}));function g(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(b||(b={}));function h(se){let J=0;for(let re=0;;re+=7){const oe=se.read(1);if(J|=(oe.buffer[0]&127)<<re,!(oe.buffer[0]&128))return J}}const $=O(0);function c(se,J){if(J===0){se.write($);return}let re=0;for(let W=J;W!==0;W=W>>>7)re++;const oe=n.$je.alloc(re);for(let W=0;J!==0;W++)oe.buffer[W]=J&127,J=J>>>7,J>0&&(oe.buffer[W]|=128);se.write(oe)}class f{constructor(J){this.b=J,this.a=0}read(J){const re=this.b.slice(this.a,this.a+J);return this.a+=re.byteLength,re}}t.$Dh=f;class a{constructor(){this.a=[]}get buffer(){return n.$je.concat(this.a)}write(J){this.a.push(J)}}t.$Eh=a;var C;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object",se[se.Int=6]="Int"})(C||(C={}));function O(se){const J=n.$je.alloc(1);return J.writeUInt8(se,0),J}const L={Undefined:O(C.Undefined),String:O(C.String),Buffer:O(C.Buffer),VSBuffer:O(C.VSBuffer),Array:O(C.Array),Object:O(C.Object),Uint:O(C.Int)},B=typeof Buffer<"u";function v(se,J){if(typeof J>"u")se.write(L.Undefined);else if(typeof J=="string"){const re=n.$je.fromString(J);se.write(L.String),c(se,re.byteLength),se.write(re)}else if(B&&Buffer.isBuffer(J)){const re=n.$je.wrap(J);se.write(L.Buffer),c(se,re.byteLength),se.write(re)}else if(J instanceof n.$je)se.write(L.VSBuffer),c(se,J.byteLength),se.write(J);else if(Array.isArray(J)){se.write(L.Array),c(se,J.length);for(const re of J)v(se,re)}else if(typeof J=="number"&&(J|0)===J)se.write(L.Uint),c(se,J);else{const re=n.$je.fromString(JSON.stringify(J));se.write(L.Object),c(se,re.byteLength),se.write(re)}}t.$Fh=v;function P(se){switch(se.read(1).readUInt8(0)){case C.Undefined:return;case C.String:return se.read(h(se)).toString();case C.Buffer:return se.read(h(se)).buffer;case C.VSBuffer:return se.read(h(se));case C.Array:{const re=h(se),oe=[];for(let W=0;W<re;W++)oe.push(P(se));return oe}case C.Object:return JSON.parse(se.read(h(se)).toString());case C.Int:return h(se)}}t.$Gh=P;class V{constructor(J,re,oe=null,W=1e3){this.h=J,this.j=re,this.k=oe,this.l=W,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(J,re){this.b.set(J,re),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const re=this.o([J.type]);this.k?.logOutgoing(re,0,1,g(J.type));return}case 201:case 202:case 204:case 203:{const re=this.o([J.type,J.id],J.data);this.k?.logOutgoing(re,J.id,1,g(J.type),J.data);return}}}o(J,re=void 0){const oe=new a;return v(oe,J),v(oe,re),this.p(oe.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const re=new f(J),oe=P(re),W=P(re),G=oe[0];switch(G){case 100:return this.k?.logIncoming(J.byteLength,oe[1],1,`${e(G)}: ${oe[2]}.${oe[3]}`,W),this.s({type:G,id:oe[1],channelName:oe[2],name:oe[3],arg:W});case 102:return this.k?.logIncoming(J.byteLength,oe[1],1,`${e(G)}: ${oe[2]}.${oe[3]}`,W),this.t({type:G,id:oe[1],channelName:oe[2],name:oe[3],arg:W});case 101:return this.k?.logIncoming(J.byteLength,oe[1],1,`${e(G)}`),this.u({type:G,id:oe[1]});case 103:return this.k?.logIncoming(J.byteLength,oe[1],1,`${e(G)}`),this.u({type:G,id:oe[1]})}}s(J){const re=this.b.get(J.channelName);if(!re){this.v(J);return}const oe=new H.$6d;let W;try{W=re.call(this.j,J.name,J.arg,oe.token)}catch(me){W=Promise.reject(me)}const G=J.id;W.then(me=>{this.m({id:G,data:me,type:201})},me=>{me instanceof Error?this.m({id:G,data:{message:me.message,name:me.name,stack:me.stack?me.stack.split?me.stack.split(`
`):me.stack:void 0},type:202}):this.m({id:G,data:me,type:203})}).finally(()=>{ue.dispose(),this.d.delete(J.id)});const ue=(0,w.$Rc)(()=>oe.cancel());this.d.set(J.id,ue)}t(J){const re=this.b.get(J.channelName);if(!re){this.v(J);return}const oe=J.id,G=re.listen(this.j,J.name,J.arg)(ue=>this.m({id:oe,data:ue,type:204}));this.d.set(J.id,G)}u(J){const re=this.d.get(J.id);re&&(re.dispose(),this.d.delete(J.id))}v(J){let re=this.g.get(J.channelName);re||(re=[],this.g.set(J.channelName,re));const oe=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);re.push({request:J,timeoutTimer:oe})}w(J){const re=this.g.get(J);if(re){for(const oe of re)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}t.$Hh=V;var U;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(U||(t.RequestInitiator=U={}));class N{constructor(J,re=null){this.l=J,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$Vd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=re}getChannel(J){const re=this;return{call(oe,W,G){return re.a?Promise.reject(new S.$5):re.m(J,oe,W,G)},listen(oe,W){return re.a?m.Event.None:re.o(J,oe,W)}}}m(J,re,oe,W=H.CancellationToken.None){const G=this.g++,me={id:G,type:100,channelName:J,name:re,arg:oe};if(W.isCancellationRequested)return Promise.reject(new S.$5);let Se;return new Promise((Pe,x)=>{if(W.isCancellationRequested)return x(new S.$5);const d=()=>{const i=o=>{switch(o.type){case 201:this.f.delete(G),Pe(o.data);break;case 202:{this.f.delete(G);const E=new Error(o.data.message);E.stack=Array.isArray(o.data.stack)?o.data.stack.join(`
`):o.data.stack,E.name=o.data.name,x(E);break}case 203:this.f.delete(G),x(o.data);break}};this.f.set(G,i),this.p(me)};let y=null;this.b===b.Idle?d():(y=(0,T.$Tg)(i=>this.u()),y.then(()=>{y=null,d()}));const p=()=>{y?(y.cancel(),y=null):this.p({id:G,type:101}),x(new S.$5)},u=W.onCancellationRequested(p);Se=(0,w.$Qc)((0,w.$Rc)(p),u),this.d.add(Se)}).finally(()=>{Se.dispose(),this.d.delete(Se)})}o(J,re,oe){const W=this.g++,ue={id:W,type:102,channelName:J,name:re,arg:oe};let me=null;const Se=new m.$Vd({onWillAddFirstListener:()=>{me=(0,T.$Tg)(Pe=>this.u()),me.then(()=>{me=null,this.d.add(Se),this.p(ue)})},onDidRemoveLastListener:()=>{me?(me.cancel(),me=null):(this.d.delete(Se),this.p({id:W,type:103}))}}),ke=Pe=>Se.fire(Pe.data);return this.f.set(W,ke),Se.event}p(J){switch(J.type){case 100:case 102:{const re=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(re,J.id,0,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const re=this.q([J.type,J.id]);this.j?.logOutgoing(re,J.id,0,e(J.type));return}}}q(J,re=void 0){const oe=new a;return v(oe,J),v(oe,re),this.r(oe.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const re=new f(J),oe=P(re),W=P(re),G=oe[0];switch(G){case 200:return this.j?.logIncoming(J.byteLength,0,0,g(G)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,oe[1],0,g(G),W),this.t({type:oe[0],id:oe[1],data:W})}}t(J){if(J.type===200){this.b=b.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}t.$Ih=N,Xe([A.$xh],N.prototype,"onDidInitializePromise",null);class I{get connections(){const J=[];return this.f.forEach(re=>J.push(re)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new m.$Vd,this.onDidAddConnection=this.g.event,this.h=new m.$Vd,this.onDidRemoveConnection=this.h.event,this.j=new w.$Sc,this.j.add(J(({protocol:re,onDidClientDisconnect:oe})=>{const W=m.Event.once(re.onMessage);this.j.add(W(G=>{const ue=new f(G),me=P(ue),Se=new V(re,me),ke=new N(re);this.a.forEach((x,d)=>Se.registerChannel(d,x));const Pe={channelServer:Se,channelClient:ke,ctx:me};this.f.add(Pe),this.g.fire(Pe),this.j.add(oe(()=>{Se.dispose(),ke.dispose(),this.f.delete(Pe),this.h.fire(Pe)}))}))}))}getChannel(J,re){const oe=this;return{call(W,G,ue){let me;if((0,r.$Wf)(re)){const ke=(0,k.$4b)(oe.connections.filter(re));me=ke?Promise.resolve(ke):m.Event.toPromise(m.Event.filter(oe.onDidAddConnection,re))}else me=re.routeCall(oe,W,G);const Se=me.then(ke=>ke.channelClient.getChannel(J));return X(Se).call(W,G,ue)},listen(W,G){if((0,r.$Wf)(re))return oe.k(J,re,W,G);const ue=re.routeEvent(oe,W,G).then(me=>me.channelClient.getChannel(J));return X(ue).listen(W,G)}}}k(J,re,oe,W){const G=this;let ue;const me=new m.$Vd({onWillAddFirstListener:()=>{ue=new w.$Sc;const Se=new m.$2d,ke=new Map,Pe=d=>{const p=d.channelClient.getChannel(J).listen(oe,W),u=Se.add(p);ke.set(d,u)},x=d=>{const y=ke.get(d);y&&(y.dispose(),ke.delete(d))};G.connections.filter(re).forEach(Pe),m.Event.filter(G.onDidAddConnection,re)(Pe,void 0,ue),G.onDidRemoveConnection(x,void 0,ue),Se.event(me.fire,me,ue),ue.add(Se)},onDidRemoveLastListener:()=>{ue?.dispose(),ue=void 0}});return me.event}registerChannel(J,re){this.a.set(J,re);for(const oe of this.f)oe.channelServer.registerChannel(J,re)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Jh=I;class z{constructor(J,re,oe=null){const W=new a;v(W,re),J.send(W.buffer),this.a=new N(J,oe),this.d=new V(J,re,oe)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,re){this.d.registerChannel(J,re)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Kh=z;function X(se){return{call(J,re,oe){return se.then(W=>W.call(J,re,oe))},listen(J,re){const oe=new m.$5d;return se.then(W=>oe.input=W.listen(J,re)),oe.event}}}t.$Lh=X;function Y(se){let J=!1;return{call(re,oe,W){return J?se.call(re,oe,W):(0,T.$7g)(0).then(()=>J=!0).then(()=>se.call(re,oe,W))},listen(re,oe){if(J)return se.listen(re,oe);const W=new m.$5d;return(0,T.$7g)(0).then(()=>J=!0).then(()=>W.input=se.listen(re,oe)),W.event}}}t.$Mh=Y;class fe{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const re of J.connections)if(await Promise.resolve(this.a(re.ctx)))return Promise.resolve(re);return await m.Event.toPromise(J.onDidAddConnection),await this.b(J)}}t.$Nh=fe;var ae;(function(se){function J(G,ue,me){const Se=G,ke=me&&me.disableMarshalling,Pe=new Map;for(const x in Se)oe(x)&&Pe.set(x,m.Event.buffer(Se[x],!0,void 0,ue));return new class{listen(x,d,y){const p=Pe.get(d);if(p)return p;if(W(d)){const u=Se[d];if(typeof u=="function")return u.call(Se,y)}throw new S.$bb(`Event not found: ${d}`)}call(x,d,y){const p=Se[d];if(typeof p=="function"){if(!ke&&Array.isArray(y))for(let i=0;i<y.length;i++)y[i]=(0,D.$Ch)(y[i]);let u=p.apply(Se,y);return u instanceof Promise||(u=Promise.resolve(u)),u}throw new S.$bb(`Method not found: ${d}`)}}}se.fromService=J;function re(G,ue){const me=ue&&ue.disableMarshalling;return new Proxy({},{get(Se,ke){if(typeof ke=="string")return ue?.properties?.has(ke)?ue.properties.get(ke):W(ke)?function(Pe){return G.listen(ke,Pe)}:oe(ke)?G.listen(ke):async function(...Pe){let x;ue&&!(0,r.$Rf)(ue.context)?x=[ue.context,...Pe]:x=Pe;const d=await G.call(ke,x);return me?d:(0,D.$Ch)(d)};throw new S.$bb(`Property not found: ${String(ke)}`)}})}se.toService=re;function oe(G){return G[0]==="o"&&G[1]==="n"&&M.$$e(G.charCodeAt(2))}function W(G){return/^onDynamic/.test(G)&&M.$$e(G.charCodeAt(9))}})(ae||(t.ProxyChannel=ae={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const J=se.toString();if(J!=="[object Object]")return J}return se}function Ie(se){return Array.isArray(se)?se.map(ge):ge(se)}function Ce(se,J,re,oe,W,G,ue){ue=Ie(ue);const me=ee[W],Se=me[oe%me.length];let ke=[`%c[${se}]%c[${String(J).padStart(7," ")}]%c[len: ${String(re).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${Se}`];/\($/.test(G)?(ke=ke.concat(ue),ke.push(")")):ke.push(ue),console.log.apply(console,ke)}class Be{constructor(J,re){this.d=J,this.f=re,this.a=0,this.b=0}logOutgoing(J,re,oe,W,G){this.b+=J,Ce(this.d,this.b,J,re,oe,W,G)}logIncoming(J,re,oe,W,G){this.a+=J,Ce(this.f,this.a,J,re,oe,W,G)}}t.$Oh=Be}),define(be[134],$e([1,0,33,4,67,90,30]),function(ie,t,k,T,n,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FU=void 0;class S extends n.$Kh{static f(){const w=T.Event.fromNodeEventEmitter(A.$O,"vscode:message",(D,M)=>k.$je.wrap(M));return A.$O.send("vscode:hello"),new H.$BU(A.$O,w)}constructor(w){const D=S.f();super(D,w),this.b=D}dispose(){this.b.disconnect(),super.dispose()}}t.$FU=S}),define(be[135],$e([13,11]),function(ie,t){return ie.create("vs/platform/files/common/files",t)}),define(be[136],$e([13,11]),function(ie,t){return ie.create("vs/platform/theme/common/iconRegistry",t)}),define(be[40],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7h=t.$6h=t.$5h=t._util=void 0;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function S(m){return m[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=S})(k||(t._util=k={})),t.$5h=n("instantiationService");function T(A,S,m){S[k.DI_TARGET]===S?S[k.DI_DEPENDENCIES].push({id:A,index:m}):(S[k.DI_DEPENDENCIES]=[{id:A,index:m}],S[k.DI_TARGET]=S)}function n(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const S=function(m,w,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(S,m,D)};return S.toString=()=>A,k.serviceIds.set(A,S),S}t.$6h=n;function H(A){return A}t.$7h=H}),define(be[137],$e([1,0,40]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Km=t.$Jm=t.$Im=t.ID=void 0,t.ID="diagnosticsService",t.$Im=(0,k.$6h)(t.ID);function T(H){return!!H.hostName&&!!H.errorMessage}t.$Jm=T;class n{async getPerformanceInfo(A,S){return{}}async getSystemInfo(A,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,S){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}t.$Km=n}),define(be[138],$e([1,0,88,24,10,7,15,135,40,5,31,23]),function(ie,t,k,T,n,H,A,S,m,w,D,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zk=t.$Yk=t.$Xk=t.$Wk=t.$Vk=t.FileKind=t.$Uk=t.$Tk=t.$Sk=t.$Rk=t.$Qk=t.$Pk=t.$Ok=t.FileOperationResult=t.$Nk=t.$Mk=t.$Lk=t.$Kk=t.$Jk=t.FileChangeType=t.$Ik=t.FileOperation=t.$Hk=t.$Gk=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.FileSystemProviderErrorCode=t.$Bk=t.$Ak=t.$zk=t.$yk=t.$xk=t.$wk=t.$vk=t.$uk=t.$tk=t.FileSystemProviderCapabilities=t.$sk=t.FilePermission=t.FileType=t.$rk=t.$qk=void 0,t.$qk=(0,m.$6h)("fileService");function r(W){return W.create===!0}t.$rk=r;var l;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(l||(t.FileType=l={}));var e;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function s(W){const G=W;return!!G&&typeof G.onDidChange=="function"}t.$sk=s;var g;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(g||(t.FileSystemProviderCapabilities=g={}));function b(W){return!!(W.capabilities&2)}t.$tk=b;function h(W){return!!(W.capabilities&8)}t.$uk=h;function $(W){return!!(W.capabilities&131072)}t.$vk=$;function c(W){return!!(W.capabilities&4)}t.$wk=c;function f(W){return!!(W.capabilities&16)}t.$xk=f;function a(W){return b(W)?!!(W.capabilities&16384):!1}t.$yk=a;function C(W){return b(W)?!!(W.capabilities&32768):!1}t.$zk=C;function O(W){return!!(W.capabilities&65536)}t.$Ak=O;function L(W){return!!(W.capabilities&2048)}t.$Bk=L;var B;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(B||(t.FileSystemProviderErrorCode=B={}));class v extends Error{static create(G,ue){const me=new v(G.toString(),ue);return U(me,ue),me}constructor(G,ue){super(G),this.code=ue}}t.$Ck=v;function P(W,G){return v.create(W,G)}t.$Dk=P;function V(W){return W||P((0,S.localize)(0,null),B.Unknown)}t.$Ek=V;function U(W,G){return W.name=G?`${G} (FileSystemError)`:"FileSystemError",W}t.$Fk=U;function N(W){if(!W)return B.Unknown;if(W instanceof v)return W.code;const G=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!G)return B.Unknown;switch(G[1]){case B.FileExists:return B.FileExists;case B.FileIsADirectory:return B.FileIsADirectory;case B.FileNotADirectory:return B.FileNotADirectory;case B.FileNotFound:return B.FileNotFound;case B.FileTooLarge:return B.FileTooLarge;case B.FileWriteLocked:return B.FileWriteLocked;case B.NoPermissions:return B.NoPermissions;case B.Unavailable:return B.Unavailable}return B.Unknown}t.$Gk=N;function I(W){if(W instanceof ee)return W.fileOperationResult;switch(N(W)){case B.FileNotFound:return 1;case B.FileIsADirectory:return 0;case B.FileNotADirectory:return 9;case B.FileWriteLocked:return 5;case B.NoPermissions:return 6;case B.FileExists:return 4;case B.FileTooLarge:return 7;default:return 10}}t.$Hk=I;var z;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(z||(t.FileOperation=z={}));class X{constructor(G,ue,me){this.resource=G,this.operation=ue,this.target=me}isOperation(G){return this.operation===G}}t.$Ik=X;var Y;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(Y||(t.FileChangeType=Y={}));class fe{static{this.a=null}constructor(G,ue){this.c=ue,this.b=void 0,this.d=new M.$V(()=>{const me=k.$_h.forUris(()=>this.c);return me.fill(this.rawAdded.map(Se=>[Se,!0])),me}),this.f=new M.$V(()=>{const me=k.$_h.forUris(()=>this.c);return me.fill(this.rawUpdated.map(Se=>[Se,!0])),me}),this.g=new M.$V(()=>{const me=k.$_h.forUris(()=>this.c);return me.fill(this.rawDeleted.map(Se=>[Se,!0])),me}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const me of G){switch(me.type){case 1:this.rawAdded.push(me.resource);break;case 0:this.rawUpdated.push(me.resource);break;case 2:this.rawDeleted.push(me.resource);break}this.b!==fe.a&&(typeof me.cId=="number"?this.b===void 0?this.b=me.cId:this.b!==me.cId&&(this.b=fe.a):this.b!==void 0&&(this.b=fe.a))}}contains(G,...ue){return this.h(G,{includeChildren:!1},...ue)}affects(G,...ue){return this.h(G,{includeChildren:!0},...ue)}h(G,ue,...me){if(!G)return!1;const Se=me.length>0;return!!((!Se||me.includes(1))&&(this.d.value.get(G)||ue.includeChildren&&this.d.value.findSuperstr(G))||(!Se||me.includes(0))&&(this.f.value.get(G)||ue.includeChildren&&this.f.value.findSuperstr(G))||(!Se||me.includes(2))&&(this.g.value.findSubstr(G)||ue.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}t.$Jk=fe;function ae(W,G,ue){return!W||!G||W===G||G.length>W.length?!1:(G.charAt(G.length-1)!==T.sep&&(G+=T.sep),ue?(0,n.$af)(W,G):W.indexOf(G)===0)}t.$Kk=ae;class ee extends Error{constructor(G,ue,me){super(G),this.fileOperationResult=ue,this.options=me}}t.$Lk=ee;class ge extends ee{constructor(G,ue,me,Se){super(G,ue,Se),this.fileOperationResult=ue,this.size=me}}t.$Mk=ge;class Ie extends ee{constructor(G,ue,me){super(G,2,me),this.stat=ue}}t.$Nk=Ie;var Ce;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ce||(t.FileOperationResult=Ce={})),t.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Qk="files.associations",t.$Rk="files.exclude",t.$Sk="files.readonlyInclude",t.$Tk="files.readonlyExclude",t.$Uk="files.readonlyFromPermissions";var Be;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(Be||(t.FileKind=Be={})),t.$Vk="";function se(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}t.$Wk=se;async function J(W,G){if(!G.hasProvider(A.URI.from({scheme:W.scheme})))return new Promise(ue=>{const me=G.onDidChangeFileSystemProviderRegistrations(Se=>{Se.scheme===W.scheme&&Se.added&&(me.dispose(),ue())})})}t.$Xk=J;class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(G){return(0,H.$Mf)(G)||(G=0),G<re.KB?(0,S.localize)(1,null,G.toFixed(0)):G<re.MB?(0,S.localize)(2,null,(G/re.KB).toFixed(2)):G<re.GB?(0,S.localize)(3,null,(G/re.MB).toFixed(2)):G<re.TB?(0,S.localize)(4,null,(G/re.GB).toFixed(2)):(0,S.localize)(5,null,(G/re.TB).toFixed(2))}}t.$Yk=re;function oe(W){const G=typeof W=="string"||W?.scheme===D.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===D.Schemas.file?1024*re.MB:G?10*re.MB:w.$o?50*re.MB:1024*re.MB}t.$Zk=oe}),define(be[139],$e([1,0,40]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$t_b=t.$s_b=void 0,t.$s_b=(0,k.$6h)("mainProcessService");class T{constructor(H,A){this.a=H,this.b=A}getChannel(H){return this.a.getChannel(H,this.b)}registerChannel(H,A){this.a.registerChannel(H,A)}}t.$t_b=T}),define(be[140],$e([1,0,2,134]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$u_b=void 0;class n extends k.$Tc{constructor(A){super(),this.a=this.B(new T.$FU(`window:${A}`))}getChannel(A){return this.a.getChannel(A)}registerChannel(A,S){this.a.registerChannel(A,S)}}t.$u_b=n});var Ei=this&&this.__param||function(ie,t){return function(k,T){t(k,T,ie)}};define(be[141],$e([1,0,67,139]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$y_b=void 0;let n=class{constructor(A,S){return this.windowId=A,k.ProxyChannel.toService(S.getChannel("nativeHost"),{context:A,properties:(()=>{const m=new Map;return m.set("windowId",A),m})()})}};t.$y_b=n,t.$y_b=n=Xe([Ei(1,T.$s_b)],n)}),define(be[68],$e([1,0,76,7]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hn=void 0;class n{constructor(){this.a=new Map}add(A,S){k.ok(T.$If(A)),k.ok(T.$Kf(S)),k.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,S)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}t.$Hn=new n}),define(be[142],$e([1,0,4,68]),function(ie,t,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$In=void 0,t.$In={JSONContribution:"base.contributions.json"};function n(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class H{constructor(){this.b=new k.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,w){this.a[n(m)]=w,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const A=new H;T.$Hn.add(t.$In.JSONContribution,A)}),define(be[143],$e([1,0,9,17,18,4,7,15,136,142,68]),function(ie,t,k,T,n,H,A,S,m,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ew=t.$Dw=t.$Cw=t.$Bw=t.$Aw=t.$zw=t.$yw=t.$xw=t.IconFontDefinition=t.IconContribution=t.$ww=void 0,t.$ww={IconContribution:"base.contributions.icons"};var M;(function(c){function f(a,C){let O=a.defaults;for(;n.ThemeIcon.isThemeIcon(O);){const L=e.getIcon(O.id);if(!L)return;O=L.defaults}return O}c.getDefinition=f})(M||(t.IconContribution=M={}));var r;(function(c){function f(C){return{weight:C.weight,style:C.style,src:C.src.map(O=>({format:O.format,location:O.location.toString()}))}}c.toJSONObject=f;function a(C){const O=L=>(0,A.$If)(L)?L:void 0;if(C&&Array.isArray(C.src)&&C.src.every(L=>(0,A.$If)(L.format)&&(0,A.$If)(L.location)))return{weight:O(C.weight),style:O(C.style),src:C.src.map(L=>({format:L.format,location:S.URI.parse(L.location)}))}}c.fromJSONObject=a})(r||(t.IconFontDefinition=r={}));class l{constructor(){this.a=new H.$Vd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,m.localize)(0,null)},fontCharacter:{type:"string",description:(0,m.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${n.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(f,a,C,O){const L=this.b[f];if(L){if(C&&!L.description){L.description=C,this.d.properties[f].markdownDescription=`${C} $(${f})`;const P=this.e.enum.indexOf(f);P!==-1&&(this.e.enumDescriptions[P]=C),this.a.fire()}return L}const B={id:f,description:C,defaults:a,deprecationMessage:O};this.b[f]=B;const v={$ref:"#/definitions/icons"};return O&&(v.deprecationMessage=O),C&&(v.markdownDescription=`${C}: $(${f})`),this.d.properties[f]=v,this.e.enum.push(f),this.e.enumDescriptions.push(C||""),this.a.fire(),{id:f}}deregisterIcon(f){delete this.b[f],delete this.d.properties[f];const a=this.e.enum.indexOf(f);a!==-1&&(this.e.enum.splice(a,1),this.e.enumDescriptions.splice(a,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(f=>this.b[f])}getIcon(f){return this.b[f]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(f,a){const C=this.f[f];return C||(this.f[f]=a,this.a.fire(),a)}deregisterIconFont(f){delete this.f[f]}getIconFont(f){return this.f[f]}toString(){const f=(L,B)=>L.id.localeCompare(B.id),a=L=>{for(;n.ThemeIcon.isThemeIcon(L.defaults);)L=this.b[L.defaults.id];return`codicon codicon-${L?L.id:""}`},C=[];C.push("| preview     | identifier                        | default codicon ID                | description"),C.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const O=Object.keys(this.b).map(L=>this.b[L]);for(const L of O.filter(B=>!!B.description).sort(f))C.push(`|<i class="${a(L)}"></i>|${L.id}|${n.ThemeIcon.isThemeIcon(L.defaults)?L.defaults.id:L.id}|${L.description||""}|`);C.push("| preview     | identifier                        "),C.push("| ----------- | --------------------------------- |");for(const L of O.filter(B=>!n.ThemeIcon.isThemeIcon(B.defaults)).sort(f))C.push(`|<i class="${a(L)}"></i>|${L.id}|`);return C.join(`
`)}}const e=new l;D.$Hn.add(t.$ww.IconContribution,e);function s(c,f,a,C){return e.registerIcon(c,f,a,C)}t.$xw=s;function g(){return e}t.$yw=g;function b(){const c=(0,T.$0j)();for(const f in c){const a="\\"+c[f].toString(16);e.registerIcon(f,{fontCharacter:a})}}b(),t.$zw="vscode://schemas/icons";const h=D.$Hn.as(w.$In.JSONContribution);h.registerSchema(t.$zw,e.getIconSchema());const $=new k.$fh(()=>h.notifySchemaChanged(t.$zw),200);e.onDidChange(()=>{$.isScheduled()||$.schedule()}),t.$Aw=s("widget-close",T.$_j.close,(0,m.localize)(2,null)),t.$Bw=s("goto-previous-location",T.$_j.arrowUp,(0,m.localize)(3,null)),t.$Cw=s("goto-next-location",T.$_j.arrowDown,(0,m.localize)(4,null)),t.$Dw=n.ThemeIcon.modify(T.$_j.sync,"spin"),t.$Ew=n.ThemeIcon.modify(T.$_j.loading,"spin")}),define(be[144],$e([1,0,3,4,2,18,143]),function(ie,t,k,T,n,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YEb=t.$XEb=void 0;function S(w){const D=new n.$Sc,M=D.add(new T.$Vd),r=(0,A.$yw)();return D.add(r.onDidChange(()=>M.fire())),w&&D.add(w.onDidProductIconThemeChange(()=>M.fire())),{dispose:()=>D.dispose(),onDidChange:M.event,getCSS(){const l=w?w.getProductIconTheme():new m,e={},s=b=>{const h=l.getIcon(b);if(!h)return;const $=h.font;return $?(e[$.id]=$.definition,`.codicon-${b.id}:before { content: '${h.fontCharacter}'; font-family: ${(0,k.$WQ)($.id)}; }`):`.codicon-${b.id}:before { content: '${h.fontCharacter}'; }`},g=[];for(const b of r.getIcons()){const h=s(b);h&&g.push(h)}for(const b in e){const h=e[b],$=h.weight?`font-weight: ${h.weight};`:"",c=h.style?`font-style: ${h.style};`:"",f=h.src.map(a=>`${(0,k.$VQ)(a.location)} format('${a.format}')`).join(", ");g.push(`@font-face { src: ${f}; font-family: ${(0,k.$WQ)(b)};${$}${c} font-display: block; }`)}return g.join(`
`)}}}t.$XEb=S;class m{getIcon(D){const M=(0,A.$yw)();let r=D.defaults;for(;H.ThemeIcon.isThemeIcon(r);){const l=M.getIcon(r.id);if(!l)return;r=l.defaults}return r}}t.$YEb=m}),define(be[145],$e([1,0,5]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WC=t.$VC=t.$UC=t.$TC=t.$SC=t.$RC=t.$QC=t.$PC=t.$OC=t.$NC=void 0,t.$NC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function T(r){return typeof r.parentId=="number"}t.$OC=T;function n(r){return!!r.workspaceUri}t.$PC=n;function H(r){return!!r.folderUri}t.$QC=H;function A(r){return!!r.fileUri}t.$RC=A;function S(r){const l=m(r),e=r.getValue("window.menuBarVisibility");return e==="default"||l==="native"&&e==="compact"||k.$j&&k.$m?"classic":e}t.$SC=S;function m(r){if(k.$o)return"custom";const l=r.getValue("window");if(l){if(k.$j&&l.nativeTabs===!0||k.$j&&l.nativeFullScreen===!1)return"native";const g=l.titleBarStyle;if(g==="native"||g==="custom")return g}return k.$k?"native":"custom"}t.$TC=m;function w(r){return!(!k.$i||k.$o||m(r)==="native")}t.$UC=w;function D(r){const l=r.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}t.$VC=D;function M(r=0){return Math.pow(1.2,r)}t.$WC=M}),define(be[146],$e([1,0,16,3,21,30,145]),function(ie,t,k,T,n,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$E_b=t.$D_b=t.$C_b=t.$B_b=t.$A_b=t.ApplyZoomTarget=void 0;var S;(function(r){r[r.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",r[r.ALL_WINDOWS=2]="ALL_WINDOWS"})(S||(t.ApplyZoomTarget=S={})),t.$A_b=8,t.$B_b=-8;function m(r,l){r=Math.min(Math.max(r,t.$B_b),t.$A_b);const e=[];l===S.ACTIVE_WINDOW?e.push((0,T.$kQ)()):l===S.ALL_WINDOWS?e.push(...Array.from((0,T.getWindows)()).map(({window:s})=>s)):e.push(l);for(const s of e)w(s)?.webFrame?.setZoomLevel(r),(0,k.$hP)((0,A.$WC)(r),s),(0,k.$dP)(r,s)}t.$C_b=m;function w(r){if(r===n.$0O)return{ipcRenderer:H.$O,webFrame:H.$Q};{const l=r;if(l?.vscode?.ipcRenderer&&l?.vscode?.webFrame)return l.vscode}}function D(r){m((0,k.$eP)(typeof r=="number"?(0,T.$kQ)():r)+1,r)}t.$D_b=D;function M(r){m((0,k.$eP)(typeof r=="number"?(0,T.$kQ)():r)-1,r)}t.$E_b=M}),define(be[147],$e([1,0,11,3,133,9,91,30,137,138,140,141,144,146,14,21,104,95]),function(ie,t,k,T,n,H,A,S,m,w,D,M,r,l,e,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const g=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,b=/\s--inspect-port=(?<port>\d+)/;class h{getHeight(N){return 22}getTemplateId(N){return B(N)?"process":O(N)?"machine":(0,m.$Jm)(N)?"error":L(N)?"header":""}}class ${hasChildren(N){return(0,m.$Jm)(N)?!1:B(N)?!!N.children?.length:!0}getChildren(N){return B(N)?N.children?N.children:[]:(0,m.$Jm)(N)?[]:L(N)?N.processRoots.length>1?N.processRoots:[N.processRoots[0].rootProcess]:O(N)?[N.rootProcess]:[N.processes]}}class c{constructor(){this.templateId="header"}renderTemplate(N){const I=(0,T.$FQ)(N,(0,T.$)(".row")),z=(0,T.$FQ)(I,(0,T.$)(".nameLabel")),X=(0,T.$FQ)(I,(0,T.$)(".cpu")),Y=(0,T.$FQ)(I,(0,T.$)(".memory")),fe=(0,T.$FQ)(I,(0,T.$)(".pid"));return{name:z,CPU:X,memory:Y,PID:fe}}renderElement(N,I,z,X){z.name.textContent=(0,k.localize)(0,null),z.CPU.textContent=(0,k.localize)(1,null),z.PID.textContent=(0,k.localize)(2,null),z.memory.textContent=(0,k.localize)(3,null)}disposeTemplate(N){}}class f{constructor(){this.templateId="machine"}renderTemplate(N){const I=Object.create(null),z=(0,T.$FQ)(N,(0,T.$)(".row"));return I.name=(0,T.$FQ)(z,(0,T.$)(".nameLabel")),I}renderElement(N,I,z,X){z.name.textContent=N.element.name}disposeTemplate(N){}}class a{constructor(){this.templateId="error"}renderTemplate(N){const I=Object.create(null),z=(0,T.$FQ)(N,(0,T.$)(".row"));return I.name=(0,T.$FQ)(z,(0,T.$)(".nameLabel")),I}renderElement(N,I,z,X){z.name.textContent=N.element.errorMessage}disposeTemplate(N){}}class C{constructor(N,I,z){this.a=N,this.b=I,this.c=z,this.templateId="process"}renderTemplate(N){const I=(0,T.$FQ)(N,(0,T.$)(".row")),z=(0,T.$FQ)(I,(0,T.$)(".nameLabel")),X=(0,T.$FQ)(I,(0,T.$)(".cpu")),Y=(0,T.$FQ)(I,(0,T.$)(".memory")),fe=(0,T.$FQ)(I,(0,T.$)(".pid"));return{name:z,CPU:X,PID:fe,memory:Y}}renderElement(N,I,z,X){const{element:Y}=N,fe=Y.pid.toFixed(0);let ae=Y.name;this.c.has(Y.pid)&&(ae=this.c.get(Y.pid)),z.name.textContent=ae,z.name.title=Y.cmd,z.CPU.textContent=Y.load.toFixed(0),z.PID.textContent=fe,z.PID.parentElement.id=`pid-${fe}`;const ee=this.a==="win32"?Y.mem:this.b*(Y.mem/100);z.memory.textContent=(ee/w.$Yk.MB).toFixed(0)}disposeTemplate(N){}}function O(U){return!!U.name&&!!U.rootProcess}function L(U){return!!U.processRoots}function B(U){return!!U.pid}class v{constructor(N,I){this.f=I,this.b=new Map;const z=new D.$u_b(N);this.c=new M.$y_b(N,z),this.k(I.styles),this.g(I),S.$O.on("vscode:pidToNameResponse",(X,Y)=>{this.b.clear();for(const[fe,ae]of Y)this.b.set(fe,ae)}),S.$O.on("vscode:listProcessesResponse",async(X,Y)=>{Y.forEach((fe,ae)=>{B(fe.rootProcess)&&(fe.rootProcess.name=ae===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Y}}),this.d.layout(s.$0O.innerHeight,s.$0O.innerWidth)):await this.h(Y),this.m(0)}),this.a=Date.now(),S.$O.send("vscode:pidToNameRequest"),S.$O.send("vscode:listProcesses")}g(N){s.$0O.document.onkeydown=I=>{const z=N.platform==="darwin"?I.metaKey:I.ctrlKey;z&&I.keyCode===87&&(I.stopPropagation(),I.preventDefault(),S.$O.send("vscode:closeProcessExplorer")),z&&I.keyCode===187&&(0,l.$D_b)(s.$0O),z&&I.keyCode===189&&(0,l.$E_b)(s.$0O)}}async h(N){const I=s.$0O.document.getElementById("process-list");if(!I)return;const{totalmem:z}=await this.c.getOSStatistics(),X=[new C(this.f.platform,z,this.b),new c,new f,new a];this.d=new n.$8T("processExplorer",I,new h,X,new $,{identityProvider:{getId:Y=>B(Y)?Y.pid.toString():(0,m.$Jm)(Y)?Y.hostName:L(Y)?"processes":O(Y)?Y.name:"header"}}),this.d.setInput({processes:{processRoots:N}}),this.d.layout(s.$0O.innerHeight,s.$0O.innerWidth),this.d.onKeyDown(Y=>{const fe=new e.$CP(Y);if(fe.keyCode===35&&fe.altKey){const ae=this.n();Promise.all(ae.map(ee=>this.c.killProcess(ee,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Y=>{B(Y.element)&&this.l(Y.element,!0)}),I.style.height=`${s.$0O.innerHeight}px`,s.$0O.addEventListener("resize",()=>{I.style.height=`${s.$0O.innerHeight}px`,this.d?.layout(s.$0O.innerHeight,s.$0O.innerWidth)})}i(N){const I=g.exec(N);return I&&I.groups.port!=="0"||N.indexOf("node ")>=0||N.indexOf("node.exe")>=0}j(N){const I={type:"node",request:"attach",name:`process ${N.pid}`};let z=g.exec(N.cmd);z?I.port=Number(z.groups.port):I.processId=String(N.pid),z=b.exec(N.cmd),z&&(I.port=Number(z.groups.port)),S.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[I]})}k(N){const I=(0,T.$nQ)(),z=[];N.listFocusBackground&&(z.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${N.listFocusBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${N.listFocusBackground}; }`)),N.listFocusForeground&&z.push(`.monaco-list:focus .monaco-list-row.focused { color: ${N.listFocusForeground}; }`),N.listActiveSelectionBackground&&(z.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${N.listActiveSelectionBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${N.listActiveSelectionBackground}; }`)),N.listActiveSelectionForeground&&z.push(`.monaco-list:focus .monaco-list-row.selected { color: ${N.listActiveSelectionForeground}; }`),N.listHoverBackground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${N.listHoverBackground}; }`),N.listHoverForeground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${N.listHoverForeground}; }`),N.listFocusOutline&&z.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${N.listFocusOutline}; outline-offset: -1px; }`),N.listHoverOutline&&z.push(`.monaco-list-row:hover { outline: 1px dashed ${N.listHoverOutline}; outline-offset: -1px; }`),N.scrollbarShadowColor&&z.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${N.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),N.scrollbarSliderBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${N.scrollbarSliderBackgroundColor};
				}
			`),N.scrollbarSliderHoverBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${N.scrollbarSliderHoverBackgroundColor};
				}
			`),N.scrollbarSliderActiveBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${N.scrollbarSliderActiveBackgroundColor};
				}
			`),I.textContent=z.join(`
`),N.color&&(s.$0O.document.body.style.color=N.color)}l(N,I){const z=[],X=Number(N.pid);I&&(z.push({accelerator:"Alt+E",label:(0,k.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),z.push({label:(0,k.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),z.push({type:"separator"})),z.push({label:(0,k.localize)(6,null),click:()=>{const Y=this.n();Y?.includes(X)||(Y.length=0,Y.push(X));const fe=Y?.map(ae=>s.$0O.document.getElementById(`pid-${ae}`)).filter(ae=>!!ae);if(fe){const ae=fe.map(ee=>ee.innerText).filter(ee=>!!ee);this.c.writeClipboardText(ae.join(`
`))}}}),z.push({label:(0,k.localize)(7,null),click:()=>{const Y=s.$0O.document.getElementById("process-list");Y&&this.c.writeClipboardText(Y.innerText)}}),N&&I&&this.i(N.cmd)&&(z.push({type:"separator"}),z.push({label:(0,k.localize)(8,null),click:()=>{this.j(N)}})),(0,A.$xU)(z)}m(N){setTimeout(()=>{const I=Date.now(),z=N+I-this.a;this.a=I,z>1e3?(S.$O.send("vscode:pidToNameRequest"),S.$O.send("vscode:listProcesses")):this.m(z)},200)}n(){return this.d?.getSelection()?.map(N=>{if(!(!N||!("pid"in N)))return N.pid}).filter(N=>!!N)}}function P(){const U=(0,T.$nQ)();U.id="codiconStyles";const N=(0,r.$XEb)(void 0);function I(){U.textContent=N.getCSS()}const z=new H.$fh(I,0);N.onDidChange(()=>z.schedule()),z.schedule()}function V(U){const N=U.data.platform==="win32"?"windows":U.data.platform==="linux"?"linux":"mac";s.$0O.document.body.classList.add(N),P(),(0,l.$C_b)(U.data.zoomLevel,s.$0O),new v(U.windowId,U.data)}t.startup=V})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0b571a26e213bf1ec6266e37152ced80c006bd1e/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
