/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(me){for(var e=[],D=0,T=me.length;D<T;D++)e[D]=ke[me[D]];return e};define(ke[157],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const g=new Map,I=new Map,R=new Map,b=new Map;function $(p,S){p.has(S.detail)||p.set(S.detail,-S.timestamp)}function y(p,S){const d=p.get(S.detail);d&&(d>=0||p.set(S.detail,d+S.timestamp))}let L=[];typeof me=="function"&&typeof me.getStats=="function"&&(L=me.getStats().slice(0).sort((p,S)=>p.timestamp-S.timestamp));for(const p of L)switch(p.type){case 10:$(g,p);break;case 11:case 12:y(g,p);break;case 21:$(I,p);break;case 22:y(I,p);break;case 33:$(R,p);break;case 34:y(R,p);break;case 31:$(b,p);break;case 32:y(b,p);break}let C=0;R.forEach(p=>C+=p);function m(p){const S=[];return p.forEach((d,f)=>S.push([f,d])),S}return{amdLoad:m(g),amdInvoke:m(I),nodeRequire:m(R),nodeEval:m(b),nodeRequireTotal:C}}static toMarkdownTable(g,I){let R="";const b=[];return g.forEach(($,y)=>{b[y]=$.length}),I.forEach($=>{$.forEach((y,L)=>{typeof y>"u"&&(y=$[L]="-");const C=y.toString().length;b[L]=Math.max(C,b[L])})}),g.forEach(($,y)=>{R+=`| ${$+" ".repeat(b[y]-$.toString().length)} `}),R+=`|
`,g.forEach(($,y)=>{R+=`| ${"-".repeat(b[y])} `}),R+=`|
`,I.forEach($=>{$.forEach((y,L)=>{typeof y<"u"&&(R+=`| ${y+" ".repeat(b[L]-y.toString().length)} `)}),R+=`|
`}),R}}e.$U=D}),define(ke[158],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(d,f,o){const i=T(d,f);if(i!==-1)return d[i]}e.$fb=D;function T(d,f,o=d.length-1){for(let i=o;i>=0;i--){const s=d[i];if(f(s))return i}return-1}e.$gb=T;function g(d,f){const o=I(d,f);return o===-1?void 0:d[o]}e.$hb=g;function I(d,f,o=0,i=d.length){let s=o,n=i;for(;s<n;){const c=Math.floor((s+n)/2);f(d[c])?s=c+1:n=c}return s-1}e.$ib=I;function R(d,f){const o=b(d,f);return o===d.length?void 0:d[o]}e.$jb=R;function b(d,f,o=0,i=d.length){let s=o,n=i;for(;s<n;){const c=Math.floor((s+n)/2);f(d[c])?n=c:s=c+1}return s}e.$kb=b;function $(d,f,o=0,i=d.length){const s=b(d,f,o,i);return s===d.length?-1:s}e.$lb=$;class y{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!f(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const o=I(this.e,f,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=y;function L(d,f){if(d.length===0)return;let o=d[0];for(let i=1;i<d.length;i++){const s=d[i];f(s,o)>0&&(o=s)}return o}e.$nb=L;function C(d,f){if(d.length===0)return;let o=d[0];for(let i=1;i<d.length;i++){const s=d[i];f(s,o)>=0&&(o=s)}return o}e.$ob=C;function m(d,f){return L(d,(o,i)=>-f(o,i))}e.$pb=m;function p(d,f){if(d.length===0)return-1;let o=0;for(let i=1;i<d.length;i++){const s=d[i];f(s,d[o])>0&&(o=i)}return o}e.$qb=p;function S(d,f){for(const o of d){const i=f(o);if(i!==void 0)return i}}e.$rb=S}),define(ke[73],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(R,b){const $=Object.create(null);for(const y of R){const L=b(y);let C=$[L];C||(C=$[L]=[]),C.push(y)}return $}e.$K=D;function T(R,b){const $=[],y=[];for(const L of R)b.has(L)||$.push(L);for(const L of b)R.has(L)||y.push(L);return{removed:$,added:y}}e.$L=T;function g(R,b){const $=[],y=[];for(const[L,C]of R)b.has(L)||$.push(C);for(const[L,C]of b)R.has(L)||y.push(C);return{removed:$,added:y}}e.$M=g;function I(R,b){const $=new Set;for(const y of b)R.has(y)&&$.add(y);return $}e.$N=I}),define(ke[52],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function D(R){return(b,$,y)=>{let L=null,C=null;if(typeof y.value=="function"?(L="value",C=y.value):typeof y.get=="function"&&(L="get",C=y.get),!C)throw new Error("not supported");y[L]=R(C,$)}}function T(R,b,$){let y=null,L=null;if(typeof $.value=="function"?(y="value",L=$.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",L=$.get),!L)throw new Error("not supported");const C=`$memoize$${b}`;$[y]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,m)}),this[C]}}e.$xh=T;function g(R,b,$){return D((y,L)=>{const C=`$debounce$${L}`,m=`$debounce$result$${L}`;return function(...p){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),b&&(this[m]=b(this[m],...p),p=[this[m]]),this[C]=setTimeout(()=>{y.apply(this,p),this[m]=$?$():void 0},R)}})}e.$yh=g;function I(R,b,$){return D((y,L)=>{const C=`$throttle$timer$${L}`,m=`$throttle$result$${L}`,p=`$throttle$lastRun$${L}`,S=`$throttle$pending$${L}`;return function(...d){if(this[m]||(this[m]=$?$():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...d)),this[S])return;const f=this[p]+R;f<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[p]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0},f-Date.now()))}})}e.$zh=I}),define(ke[14],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?s.isErrorNoTelemetry(t)?new s(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(a=>{a(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function T(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=T;function g(c){if(!c||typeof c!="object")return!1;const t=c;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=g;function I(c){y(c)||e.$X.onUnexpectedError(c)}e.$1=I;function R(c){y(c)||e.$X.onUnexpectedExternalError(c)}e.$2=R;function b(c){if(c instanceof Error){const{name:t,message:a}=c,r=c.stacktrace||c.stack;return{$isError:!0,name:t,message:a,stack:r,noTelemetry:s.isErrorNoTelemetry(c)}}return c}e.$3=b;const $="Canceled";function y(c){return c instanceof L?!0:c instanceof Error&&c.name===$&&c.message===$}e.$4=y;class L extends Error{constructor(){super($),this.name=this.message}}e.$5=L;function C(){const c=new Error($);return c.name=c.message,c}e.$6=C;function m(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=m;function p(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=p;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function d(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=d;class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class s extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof s)return t;const a=new s;return a.message=t.message,a.stack=t.stack,a}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=s;class n extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.$cb=n}),define(ke[19],Se([1,0,14,158]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function g(de,ge=0){return de[de.length-(1+ge)]}e.$sb=g;function I(de){if(de.length===0)throw new Error("Invalid tail call");return[de.slice(0,de.length-1),de[de.length-1]]}e.$tb=I;function R(de,ge,_=(te,K)=>te===K){if(de===ge)return!0;if(!de||!ge||de.length!==ge.length)return!1;for(let te=0,K=de.length;te<K;te++)if(!_(de[te],ge[te]))return!1;return!0}e.$ub=R;function b(de,ge){const _=de.length-1;ge<_&&(de[ge]=de[_]),de.pop()}e.$vb=b;function $(de,ge,_){return y(de.length,te=>_(de[te],ge))}e.$wb=$;function y(de,ge){let _=0,te=de-1;for(;_<=te;){const K=(_+te)/2|0,ie=ge(K);if(ie<0)_=K+1;else if(ie>0)te=K-1;else return K}return-(_+1)}e.$xb=y;function L(de,ge,_){if(de=de|0,de>=ge.length)throw new TypeError("invalid index");const te=ge[Math.floor(ge.length*Math.random())],K=[],ie=[],fe=[];for(const pe of ge){const Pe=_(pe,te);Pe<0?K.push(pe):Pe>0?ie.push(pe):fe.push(pe)}return de<K.length?L(de,K,_):de<K.length+fe.length?fe[0]:L(de-(K.length+fe.length),ie,_)}e.$yb=L;function C(de,ge){const _=[];let te;for(const K of de.slice(0).sort(ge))!te||ge(te[0],K)!==0?(te=[K],_.push(te)):te.push(K);return _}e.$zb=C;function*m(de,ge){let _,te;for(const K of de)te!==void 0&&ge(te,K)?_.push(K):(_&&(yield _),_=[K]),te=K;_&&(yield _)}e.$Ab=m;function p(de,ge){for(let _=0;_<=de.length;_++)ge(_===0?void 0:de[_-1],_===de.length?void 0:de[_])}e.$Bb=p;function S(de,ge){for(let _=0;_<de.length;_++)ge(_===0?void 0:de[_-1],de[_],_+1===de.length?void 0:de[_+1])}e.$Cb=S;function d(de,ge,_){const te=[];function K(pe,Pe,we){if(Pe===0&&we.length===0)return;const Ce=te[te.length-1];Ce&&Ce.start+Ce.deleteCount===pe?(Ce.deleteCount+=Pe,Ce.toInsert.push(...we)):te.push({start:pe,deleteCount:Pe,toInsert:we})}let ie=0,fe=0;for(;;){if(ie===de.length){K(ie,0,ge.slice(fe));break}if(fe===ge.length){K(ie,de.length-ie,[]);break}const pe=de[ie],Pe=ge[fe],we=_(pe,Pe);we===0?(ie+=1,fe+=1):we<0?(K(ie,1,[]),ie+=1):we>0&&(K(ie,0,[Pe]),fe+=1)}return te}e.$Db=d;function f(de,ge,_){const te=d(de,ge,_),K=[],ie=[];for(const fe of te)K.push(...de.slice(fe.start,fe.start+fe.deleteCount)),ie.push(...fe.toInsert);return{removed:K,added:ie}}e.$Eb=f;function o(de,ge,_){if(_===0)return[];const te=de.slice(0,_).sort(ge);return s(de,ge,te,_,de.length),te}e.top=o;function i(de,ge,_,te,K){return _===0?Promise.resolve([]):new Promise((ie,fe)=>{(async()=>{const pe=de.length,Pe=de.slice(0,_).sort(ge);for(let we=_,Ce=Math.min(_+te,pe);we<pe;we=Ce,Ce=Math.min(Ce+te,pe)){if(we>_&&await new Promise(B=>setTimeout(B)),K&&K.isCancellationRequested)throw new D.$5;s(de,ge,Pe,we,Ce)}return Pe})().then(ie,fe)})}e.$Gb=i;function s(de,ge,_,te,K){for(const ie=_.length;te<K;te++){const fe=de[te];if(ge(fe,_[ie-1])<0){_.pop();const pe=(0,T.$kb)(_,Pe=>ge(fe,Pe)<0);_.splice(pe,0,fe)}}}function n(de){return de.filter(ge=>!!ge)}e.$Hb=n;function c(de){let ge=0;for(let _=0;_<de.length;_++)de[_]&&(de[ge]=de[_],ge+=1);de.length=ge}e.$Ib=c;function t(de,ge,_){de.splice(_,0,de.splice(ge,1)[0])}e.$Jb=t;function a(de){return!Array.isArray(de)||de.length===0}e.$Kb=a;function r(de){return Array.isArray(de)&&de.length>0}e.$Lb=r;function h(de,ge=_=>_){const _=new Set;return de.filter(te=>{const K=ge(te);return _.has(K)?!1:(_.add(K),!0)})}e.$Mb=h;function u(de){const ge=new Set;return _=>{const te=de(_);return ge.has(te)?!1:(ge.add(te),!0)}}e.$Nb=u;function l(de,ge){return de.length>0?de[0]:ge}e.$Ob=l;function k(de,ge){return de.length>0?de[de.length-1]:ge}e.$Pb=k;function A(de,ge,_=(te,K)=>te===K){let te=0;for(let K=0,ie=Math.min(de.length,ge.length);K<ie&&_(de[K],ge[K]);K++)te++;return te}e.$Qb=A;function v(de){return[].concat(...de)}e.$Rb=v;function w(de,ge){let _=typeof ge=="number"?de:0;typeof ge=="number"?_=de:(_=0,ge=de);const te=[];if(_<=ge)for(let K=_;K<ge;K++)te.push(K);else for(let K=_;K>ge;K--)te.push(K);return te}e.$Sb=w;function E(de,ge,_){return de.reduce((te,K)=>(te[ge(K)]=_?_(K):K,te),Object.create(null))}e.$Tb=E;function P(de,ge){return de.push(ge),()=>N(de,ge)}e.$Ub=P;function N(de,ge){const _=de.indexOf(ge);if(_>-1)return de.splice(_,1),ge}e.$Vb=N;function z(de,ge,_){const te=de.slice(0,ge),K=de.slice(ge);return te.concat(_,K)}e.$Wb=z;function F(de,ge){let _;if(typeof ge=="number"){let te=ge;_=()=>{const K=Math.sin(te++)*179426549;return K-Math.floor(K)}}else _=Math.random;for(let te=de.length-1;te>0;te-=1){const K=Math.floor(_()*(te+1)),ie=de[te];de[te]=de[K],de[K]=ie}}e.$Xb=F;function j(de,ge){const _=de.indexOf(ge);_>-1&&(de.splice(_,1),de.unshift(ge))}e.$Yb=j;function M(de,ge){const _=de.indexOf(ge);_>-1&&(de.splice(_,1),de.push(ge))}e.$Zb=M;function O(de,ge){for(const _ of ge)de.push(_)}e.$1b=O;function U(de,ge){return Array.isArray(de)?de.map(ge):ge(de)}e.$2b=U;function Q(de){return Array.isArray(de)?de:[de]}e.$3b=Q;function ue(de){return de[Math.floor(Math.random()*de.length)]}e.$4b=ue;function Z(de,ge,_){const te=X(de,ge),K=de.length,ie=_.length;de.length=K+ie;for(let fe=K-1;fe>=te;fe--)de[fe+ie]=de[fe];for(let fe=0;fe<ie;fe++)de[fe+te]=_[fe]}e.$5b=Z;function J(de,ge,_,te){const K=X(de,ge);let ie=de.splice(K,_);return ie===void 0&&(ie=[]),Z(de,K,te),ie}e.$6b=J;function X(de,ge){return ge<0?Math.max(ge+de.length,0):Math.min(ge,de.length)}var le;(function(de){function ge(ie){return ie<0}de.isLessThan=ge;function _(ie){return ie<=0}de.isLessThanOrEqual=_;function te(ie){return ie>0}de.isGreaterThan=te;function K(ie){return ie===0}de.isNeitherLessOrGreaterThan=K,de.greaterThan=1,de.lessThan=-1,de.neitherLessOrGreaterThan=0})(le||(e.CompareResult=le={}));function x(de,ge){return(_,te)=>ge(de(_),de(te))}e.$7b=x;function be(...de){return(ge,_)=>{for(const te of de){const K=te(ge,_);if(!le.isNeitherLessOrGreaterThan(K))return K}return le.neitherLessOrGreaterThan}}e.$8b=be;const ce=(de,ge)=>de-ge;e.$9b=ce;const G=(de,ge)=>(0,e.$9b)(de?1:0,ge?1:0);e.$0b=G;function W(de){return(ge,_)=>-de(ge,_)}e.$$b=W;class ne{constructor(ge){this.g=ge,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ge){let _=this.c;for(;_<this.g.length&&ge(this.g[_]);)_++;const te=_===this.c?null:this.g.slice(this.c,_);return this.c=_,te}takeFromEndWhile(ge){let _=this.d;for(;_>=0&&ge(this.g[_]);)_--;const te=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ge=this.g[this.c];return this.c++,ge}removeLast(){const ge=this.g[this.d];return this.d--,ge}takeCount(ge){const _=this.g.slice(this.c,this.c+ge);return this.c+=ge,_}}e.$_b=ne;class ye{static{this.empty=new ye(ge=>{})}constructor(ge){this.iterate=ge}forEach(ge){this.iterate(_=>(ge(_),!0))}toArray(){const ge=[];return this.iterate(_=>(ge.push(_),!0)),ge}filter(ge){return new ye(_=>this.iterate(te=>ge(te)?_(te):!0))}map(ge){return new ye(_=>this.iterate(te=>_(ge(te))))}some(ge){let _=!1;return this.iterate(te=>(_=ge(te),!_)),_}findFirst(ge){let _;return this.iterate(te=>ge(te)?(_=te,!1):!0),_}findLast(ge){let _;return this.iterate(te=>(ge(te)&&(_=te),!0)),_}findLastMaxBy(ge){let _,te=!0;return this.iterate(K=>((te||le.isGreaterThan(ge(K,_)))&&(te=!1,_=K),!0)),_}}e.$ac=ye}),define(ke[60],Se([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function T($,y){if(!$)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=T;function g($,y="Unreachable"){throw new Error(y)}e.$6c=g;function I($){if(!$)throw new D.$cb("Assertion Failed")}e.$7c=I;function R($){if(!$()){debugger;$(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$8c=R;function b($,y){let L=0;for(;L<$.length-1;){const C=$[L],m=$[L+1];if(!y(C,m))return!1;L++}return!0}e.$9c=b}),define(ke[74],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(T,g){const I=this;let R=!1,b;return function(){if(R)return b;if(R=!0,g)try{b=T.apply(I,arguments)}finally{g()}else b=T.apply(I,arguments);return b}}e.$db=D}),define(ke[121],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$gN=D,e.$hN=new D("id#")}),define(ke[53],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function g(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}T.is=g;const I=Object.freeze([]);function R(){return I}T.empty=R;function*b(t){yield t}T.single=b;function $(t){return g(t)?t:b(t)}T.wrap=$;function y(t){return t||I}T.from=y;function*L(t){for(let a=t.length-1;a>=0;a--)yield t[a]}T.reverse=L;function C(t){return!t||t[Symbol.iterator]().next().done===!0}T.isEmpty=C;function m(t){return t[Symbol.iterator]().next().value}T.first=m;function p(t,a){for(const r of t)if(a(r))return!0;return!1}T.some=p;function S(t,a){for(const r of t)if(a(r))return r}T.find=S;function*d(t,a){for(const r of t)a(r)&&(yield r)}T.filter=d;function*f(t,a){let r=0;for(const h of t)yield a(h,r++)}T.map=f;function*o(...t){for(const a of t)yield*a}T.concat=o;function i(t,a,r){let h=r;for(const u of t)h=a(h,u);return h}T.reduce=i;function*s(t,a,r=t.length){for(a<0&&(a+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);a<r;a++)yield t[a]}T.slice=s;function n(t,a=Number.POSITIVE_INFINITY){const r=[];if(a===0)return[r,t];const h=t[Symbol.iterator]();for(let u=0;u<a;u++){const l=h.next();if(l.done)return[r,T.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return h}}]}T.consume=n;async function c(t){const a=[];for await(const r of t)a.push(r);return Promise.resolve(a)}T.asyncToArray=c})(D||(e.Iterable=D={}))}),define(ke[159],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function R(t,a=!1){let r=0;const h=t.length;let u="",l=0,k=16,A=0;function v(j){let M=0,O=0;for(;M<j;){const U=t.charCodeAt(r);if(U>=48&&U<=57)O=O*16+U-48;else if(U>=65&&U<=70)O=O*16+U-65+10;else if(U>=97&&U<=102)O=O*16+U-97+10;else break;r++,M++}return M<j&&(O=-1),O}function w(j){r=j,u="",l=0,k=16,A=0}function E(){const j=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&y(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&y(t.charCodeAt(r)))for(r++;r<t.length&&y(t.charCodeAt(r));)r++;else return A=3,t.substring(j,r);let M=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&y(t.charCodeAt(r))){for(r++;r<t.length&&y(t.charCodeAt(r));)r++;M=r}else A=3;return t.substring(j,M)}function P(){let j="",M=r;for(;;){if(r>=h){j+=t.substring(M,r),A=2;break}const O=t.charCodeAt(r);if(O===34){j+=t.substring(M,r),r++;break}if(O===92){if(j+=t.substring(M,r),r++,r>=h){A=2;break}switch(t.charCodeAt(r++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const Q=v(4);Q>=0?j+=String.fromCharCode(Q):A=4;break}default:A=5}M=r;continue}if(O>=0&&O<=31)if($(O)){j+=t.substring(M,r),A=2;break}else A=6;r++}return j}function N(){if(u="",A=0,l=r,r>=h)return l=h,k=17;let j=t.charCodeAt(r);if(b(j)){do r++,u+=String.fromCharCode(j),j=t.charCodeAt(r);while(b(j));return k=15}if($(j))return r++,u+=String.fromCharCode(j),j===13&&t.charCodeAt(r)===10&&(r++,u+=`
`),k=14;switch(j){case 123:return r++,k=1;case 125:return r++,k=2;case 91:return r++,k=3;case 93:return r++,k=4;case 58:return r++,k=6;case 44:return r++,k=5;case 34:return r++,u=P(),k=10;case 47:{const M=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<h&&!$(t.charCodeAt(r));)r++;return u=t.substring(M,r),k=12}if(t.charCodeAt(r+1)===42){r+=2;const O=h-1;let U=!1;for(;r<O;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,A=1),u=t.substring(M,r),k=13}return u+=String.fromCharCode(j),r++,k=16}case 45:if(u+=String.fromCharCode(j),r++,r===h||!y(t.charCodeAt(r)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=E(),k=11;default:for(;r<h&&z(j);)r++,j=t.charCodeAt(r);if(l!==r){switch(u=t.substring(l,r),u){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return u+=String.fromCharCode(j),r++,k=16}}function z(j){if(b(j)||$(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let j;do j=N();while(j>=12&&j<=15);return j}return{setPosition:w,getPosition:()=>r,scan:a?F:N,getToken:()=>k,getTokenValue:()=>u,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>A}}e.$an=R;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function C(t,a){const r=[],h=new Object;let u;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function A(v,w,E,P){l.value=v,l.offset=w,l.length=E,l.type=P,l.colonOffset=void 0,u=l}try{s(t,{onObjectBegin:(v,w)=>{if(a<=v)throw h;u=void 0,k=a>v,r.push("")},onObjectProperty:(v,w,E)=>{if(a<w||(A(v,w,E,"property"),r[r.length-1]=v,a<=w+E))throw h},onObjectEnd:(v,w)=>{if(a<=v)throw h;u=void 0,r.pop()},onArrayBegin:(v,w)=>{if(a<=v)throw h;u=void 0,r.push(0)},onArrayEnd:(v,w)=>{if(a<=v)throw h;u=void 0,r.pop()},onLiteralValue:(v,w,E)=>{if(a<w||(A(v,w,E,c(v)),a<=w+E))throw h},onSeparator:(v,w,E)=>{if(a<=w)throw h;if(v===":"&&u&&u.type==="property")u.colonOffset=w,k=!1,u=void 0;else if(v===","){const P=r[r.length-1];typeof P=="number"?r[r.length-1]=P+1:(k=!0,r[r.length-1]=""),u=void 0}}})}catch(v){if(v!==h)throw v}return{path:r,previousNode:u,isAtPropertyKey:k,matches:v=>{let w=0;for(let E=0;w<v.length&&E<r.length;E++)if(v[w]===r[E]||v[w]==="*")w++;else if(v[w]!=="**")return!1;return w===v.length}}}e.$bn=C;function m(t,a=[],r=I.DEFAULT){let h=null,u=[];const l=[];function k(v){Array.isArray(u)?u.push(v):h!==null&&(u[h]=v)}return s(t,{onObjectBegin:()=>{const v={};k(v),l.push(u),u=v,h=null},onObjectProperty:v=>{h=v},onObjectEnd:()=>{u=l.pop()},onArrayBegin:()=>{const v=[];k(v),l.push(u),u=v,h=null},onArrayEnd:()=>{u=l.pop()},onLiteralValue:k,onError:(v,w,E)=>{a.push({error:v,offset:w,length:E})}},r),u[0]}e.$cn=m;function p(t,a=[],r=I.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(v){h.type==="property"&&(h.length=v-h.offset,h=h.parent)}function l(v){return h.children.push(v),v}s(t,{onObjectBegin:v=>{h=l({type:"object",offset:v,length:-1,parent:h,children:[]})},onObjectProperty:(v,w,E)=>{h=l({type:"property",offset:w,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:v,offset:w,length:E,parent:h})},onObjectEnd:(v,w)=>{h.length=v+w-h.offset,h=h.parent,u(v+w)},onArrayBegin:(v,w)=>{h=l({type:"array",offset:v,length:-1,parent:h,children:[]})},onArrayEnd:(v,w)=>{h.length=v+w-h.offset,h=h.parent,u(v+w)},onLiteralValue:(v,w,E)=>{l({type:c(v),offset:w,length:E,parent:h,value:v}),u(w+E)},onSeparator:(v,w,E)=>{h.type==="property"&&(v===":"?h.colonOffset=w:v===","&&u(w))},onError:(v,w,E)=>{a.push({error:v,offset:w,length:E})}},r);const A=h.children[0];return A&&delete A.parent,A}e.$dn=p;function S(t,a){if(!t)return;let r=t;for(const h of a)if(typeof h=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===h){r=l.children[1],u=!0;break}if(!u)return}else{const u=h;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}e.$en=S;function d(t){if(!t.parent||!t.parent.children)return[];const a=d(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;a.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&a.push(r)}return a}e.$fn=d;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const a=Object.create(null);for(const r of t.children){const h=r.children[1];h&&(a[r.children[0].value]=f(h))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$gn=f;function o(t,a,r=!1){return a>=t.offset&&a<t.offset+t.length||r&&a===t.offset+t.length}e.$hn=o;function i(t,a,r=!1){if(o(t,a,r)){const h=t.children;if(Array.isArray(h))for(let u=0;u<h.length&&h[u].offset<=a;u++){const l=i(h[u],a,r);if(l)return l}return t}}e.$in=i;function s(t,a,r=I.DEFAULT){const h=R(t,!1);function u(x){return x?()=>x(h.getTokenOffset(),h.getTokenLength()):()=>!0}function l(x){return x?be=>x(be,h.getTokenOffset(),h.getTokenLength()):()=>!0}const k=u(a.onObjectBegin),A=l(a.onObjectProperty),v=u(a.onObjectEnd),w=u(a.onArrayBegin),E=u(a.onArrayEnd),P=l(a.onLiteralValue),N=l(a.onSeparator),z=u(a.onComment),F=l(a.onError),j=r&&r.disallowComments,M=r&&r.allowTrailingComma;function O(){for(;;){const x=h.scan();switch(h.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:j||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(x){case 12:case 13:j?U(10):z();break;case 16:U(1);break;case 15:case 14:break;default:return x}}}function U(x,be=[],ce=[]){if(F(x),be.length+ce.length>0){let G=h.getToken();for(;G!==17;){if(be.indexOf(G)!==-1){O();break}else if(ce.indexOf(G)!==-1)break;G=O()}}}function Q(x){const be=h.getTokenValue();return x?P(be):A(be),O(),!0}function ue(){switch(h.getToken()){case 11:{let x=0;try{x=JSON.parse(h.getTokenValue()),typeof x!="number"&&(U(2),x=0)}catch{U(2)}P(x);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return O(),!0}function Z(){return h.getToken()!==10?(U(3,[],[2,5]),!1):(Q(!1),h.getToken()===6?(N(":"),O(),le()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function J(){k(),O();let x=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(x||U(4,[],[]),N(","),O(),h.getToken()===2&&M)break}else x&&U(6,[],[]);Z()||U(4,[],[2,5]),x=!0}return v(),h.getToken()!==2?U(7,[2],[]):O(),!0}function X(){w(),O();let x=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(x||U(4,[],[]),N(","),O(),h.getToken()===4&&M)break}else x&&U(6,[],[]);le()||U(4,[],[4,5]),x=!0}return E(),h.getToken()!==4?U(8,[4],[]):O(),!0}function le(){switch(h.getToken()){case 3:return X();case 1:return J();case 10:return Q(!0);default:return ue()}}return O(),h.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):le()?(h.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.$jn=s;function n(t,a){const r=R(t),h=[];let u,l=0,k;do switch(k=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:l!==k&&h.push(t.substring(l,k)),a!==void 0&&h.push(r.getTokenValue().replace(/[^\r\n]/g,a)),l=r.getPosition();break}while(u!==17);return h.join("")}e.$kn=n;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=c}),define(ke[43],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(ke[75],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(I){this.element=I,this.next=D.Undefined,this.prev=D.Undefined}}class T{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let I=this.a;for(;I!==D.Undefined;){const R=I.next;I.prev=D.Undefined,I.next=D.Undefined,I=R}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,R){const b=new D(I);if(this.a===D.Undefined)this.a=b,this.b=b;else if(R){const y=this.b;this.b=b,b.prev=y,y.next=b}else{const y=this.a;this.a=b,b.next=y,y.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==D.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==D.Undefined&&I.next!==D.Undefined){const R=I.prev;R.next=I.next,I.next.prev=R}else I.prev===D.Undefined&&I.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):I.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):I.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==D.Undefined;)yield I.element,I=I.next}}e.$4c=T}),define(ke[28],Se([1,0]),function(me,e){"use strict";var D,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function I(s,n,c){let t=s.get(n);return t===void 0&&(t=c,s.set(n,t)),t}e.$xc=I;function R(s){const n=[];return s.forEach((c,t)=>{n.push(`${t} => ${c}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.$yc=R;function b(s){const n=[];return s.forEach(c=>{n.push(c)}),`Set(${s.size}) {${n.join(", ")}}`}e.$zc=b;class ${constructor(n,c){this.uri=n,this.value=c}}function y(s){return Array.isArray(s)}class L{static{this.c=n=>n.toString()}constructor(n,c){if(this[D]="ResourceMap",n instanceof L)this.d=new Map(n.d),this.e=c??L.c;else if(y(n)){this.d=new Map,this.e=c??L.c;for(const[t,a]of n)this.set(t,a)}else this.d=new Map,this.e=n??L.c}set(n,c){return this.d.set(this.e(n),new $(n,c)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,c){typeof c<"u"&&(n=n.bind(c));for(const[t,a]of this.d)n(a.value,a.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=L;class C{constructor(n,c){this[T]="ResourceSet",!n||typeof n=="function"?this.c=new L(n):(this.c=new L(c),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,c){this.c.forEach((t,a)=>n.call(c,a,a,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var m;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class p{constructor(){this[g]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,c=0){const t=this.c.get(n);if(t)return c!==0&&this.l(t,c),t.value}set(n,c,t=0){let a=this.c.get(n);if(a)a.value=c,t!==0&&this.l(a,t);else{switch(a={key:n,value:c,next:void 0,previous:void 0},t){case 0:this.j(a);break;case 1:this.i(a);break;case 2:this.j(a);break;default:this.j(a);break}this.c.set(n,a),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const c=this.c.get(n);if(c)return this.c.delete(n),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.k(n),this.f--,n.value}forEach(n,c){const t=this.g;let a=this.d;for(;a;){if(c?n.bind(c)(a.value,a.key,this):n(a.value,a.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,c=this.g;let t=this.d;const a={[Symbol.iterator](){return a},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return a}values(){const n=this,c=this.g;let t=this.d;const a={[Symbol.iterator](){return a},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return a}entries(){const n=this,c=this.g;let t=this.d;const a={[Symbol.iterator](){return a},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return a}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let c=this.d,t=this.size;for(;c&&t>n;)this.c.delete(c.key),c=c.next,t--;this.d=c,this.f=t,c&&(c.previous=void 0),this.g++}i(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}j(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}k(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const c=n.next,t=n.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}n.next=void 0,n.previous=void 0,this.g++}l(n,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(n===this.d)return;const t=n.next,a=n.previous;n===this.e?(a.next=void 0,this.e=a):(t.previous=a,a.next=t),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(c===2){if(n===this.e)return;const t=n.next,a=n.previous;n===this.d?(t.previous=void 0,this.d=t):(t.previous=a,a.next=t),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((c,t)=>{n.push([t,c])}),n}fromJSON(n){this.clear();for(const[c,t]of n)this.set(c,t)}}e.$Cc=p;class S extends p{constructor(n,c=1){super(),this.m=n,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(n){this.m=n,this.o()}get ratio(){return this.n}set ratio(n){this.n=Math.min(Math.max(0,n),1),this.o()}get(n,c=2){return super.get(n,c)}peek(n){return super.get(n,0)}set(n,c){return super.set(n,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=S;class d{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let c=this.c.get(n)||0;return c===0?!1:(c--,c===0?this.c.delete(n):this.c.set(n,c),!0)}has(n){return this.c.has(n)}}e.$Ec=d;class f{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[c,t]of n)this.set(c,t)}clear(){this.c.clear(),this.d.clear()}set(n,c){this.c.set(n,c),this.d.set(c,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const c=this.c.get(n);return c===void 0?!1:(this.c.delete(n),this.d.delete(c),!0)}forEach(n,c){this.c.forEach((t,a)=>{n.call(c,t,a,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=f;class o{constructor(){this.c=new Map}add(n,c){let t=this.c.get(n);t||(t=new Set,this.c.set(n,t)),t.add(c)}delete(n,c){const t=this.c.get(n);t&&(t.delete(c),t.size===0&&this.c.delete(n))}forEach(n,c){const t=this.c.get(n);t&&t.forEach(c)}get(n){const c=this.c.get(n);return c||new Set}}e.$Gc=o;function i(s,n){if(s===n)return!0;if(s.size!==n.size)return!1;for(const[c,t]of s)if(!n.has(c)||n.get(c)!==t)return!1;for(const[c]of n)if(!s.has(c))return!1;return!0}e.$Hc=i}),define(ke[3],Se([1,0,19,73,28,74,53]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const b=!1;let $=null;class y{constructor(){this.b=new Map}static{this.a=0}c(P){let N=this.b.get(P);return N||(N={parent:null,source:null,isSingleton:!1,value:P,idx:y.a++},this.b.set(P,N)),N}trackDisposable(P){const N=this.c(P);N.source||(N.source=new Error().stack)}setParent(P,N){const z=this.c(P);z.parent=N}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,N){const z=N.get(P);if(z)return z;const F=P.parent?this.f(this.c(P.parent),N):P;return N.set(P,F),F}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,P).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(P=10,N){let z;if(N)z=N;else{const U=new Map,Q=[...this.b.values()].filter(Z=>Z.source!==null&&!this.f(Z,U).isSingleton);if(Q.length===0)return;const ue=new Set(Q.map(Z=>Z.value));if(z=Q.filter(Z=>!(Z.parent&&ue.has(Z.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function F(U){function Q(Z,J){for(;Z.length>0&&J.some(X=>typeof X=="string"?X===Z[0]:Z[0].match(X));)Z.shift()}const ue=U.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return Q(ue,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ue.reverse()}const j=new g.$Gc;for(const U of z){const Q=F(U);for(let ue=0;ue<=Q.length;ue++)j.add(Q.slice(0,ue).join(`
`),U)}z.sort((0,D.$7b)(U=>U.idx,D.$9b));let M="",O=0;for(const U of z.slice(0,P)){O++;const Q=F(U),ue=[];for(let Z=0;Z<Q.length;Z++){let J=Q[Z];J=`(shared with ${j.get(Q.slice(0,Z+1).join(`
`)).size}/${z.length} leaks) at ${J}`;const le=j.get(Q.slice(0,Z).join(`
`)),x=(0,T.$K)([...le].map(be=>F(be)[Z]),be=>be);delete x[Q[Z]];for(const[be,ce]of Object.entries(x))ue.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${be}`);ue.unshift(J)}M+=`


==================== Leaking disposable ${O}/${z.length}: ${U.value.constructor.name} ====================
${ue.join(`
`)}
============================================================

`}return z.length>P&&(M+=`


... and ${z.length-P} more leaking disposables

`),{leaks:z,details:M}}}e.$Ic=y;function L(E){$=E}if(e.$Jc=L,b){const E="__is_disposable_tracked__";L(new class{trackDisposable(P){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[E]||console.log(N)},3e3)}setParent(P,N){if(P&&P!==t.None)try{P[E]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[E]=!0}catch{}}markAsSingleton(P){}})}function C(E){return $?.trackDisposable(E),E}e.$Kc=C;function m(E){$?.markAsDisposed(E)}e.$Lc=m;function p(E,P){$?.setParent(E,P)}function S(E,P){if($)for(const N of E)$.setParent(N,P)}function d(E){return $?.markAsSingleton(E),E}e.$Mc=d;function f(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Nc=f;function o(E){if(R.Iterable.is(E)){const P=[];for(const N of E)if(N)try{N.dispose()}catch(z){P.push(z)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Oc=o;function i(E){for(const P of E)f(P)&&P.dispose();return[]}e.$Pc=i;function s(...E){const P=n(()=>o(E));return S(E,P),P}e.$Qc=s;function n(E){const P=C({dispose:(0,I.$db)(()=>{m(P),E()})});return P}e.$Rc=n;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return p(P,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),p(P,null))}}e.$Sc=c;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,C(this),p(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=t;class a{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&p(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&p(P,null),P}}e.$Uc=a;class r{constructor(P){this.a=new a,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=r;class h{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=h;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let N=P;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,m(this))},this}}e.$Xc=u;class l{constructor(){this.a=new Map}acquire(P,...N){let z=this.a.get(P);z||(z={counter:0,object:this.b(P,...N)},this.a.set(P,z));const{object:F}=z,j=(0,I.$db)(()=>{--z.counter===0&&(this.c(P,z.object),this.a.delete(P))});return z.counter++,{object:F,dispose:j}}}e.$Yc=l;class k{constructor(P){this.a=P}async acquire(P,...N){const z=this.a.acquire(P,...N);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(F){throw z.dispose(),F}}}e.$Zc=k;class A{constructor(P){this.object=P}dispose(){}}e.$1c=A;function v(E){const P=new c;try{E(P)}finally{P.dispose()}}e.$2c=v;class w{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,N,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(P)?.dispose(),this.a.set(P,N)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=w}),function(me,e){typeof define=="function"&&define.amd?define(ke[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ge,_){for(var te=0;te<_.length;te++){var K=_[te];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ge,K.key,K)}}function D(ge,_,te){return _&&e(ge.prototype,_),te&&e(ge,te),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function T(ge,_){if(ge){if(typeof ge=="string")return g(ge,_);var te=Object.prototype.toString.call(ge).slice(8,-1);if(te==="Object"&&ge.constructor&&(te=ge.constructor.name),te==="Map"||te==="Set")return Array.from(ge);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return g(ge,_)}}function g(ge,_){(_==null||_>ge.length)&&(_=ge.length);for(var te=0,K=new Array(_);te<_;te++)K[te]=ge[te];return K}function I(ge,_){var te=typeof Symbol<"u"&&ge[Symbol.iterator]||ge["@@iterator"];if(te)return(te=te.call(ge)).next.bind(te);if(Array.isArray(ge)||(te=T(ge))||_&&ge&&typeof ge.length=="number"){te&&(ge=te);var K=0;return function(){return K>=ge.length?{done:!0}:{done:!1,value:ge[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function b(ge){me.defaults=ge}var $=/[&<>"']/,y=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(_){return m[_]};function S(ge,_){if(_){if($.test(ge))return ge.replace(y,p)}else if(L.test(ge))return ge.replace(C,p);return ge}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ge){return ge.replace(d,function(_,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(ge,_){ge=typeof ge=="string"?ge:ge.source,_=_||"";var te={replace:function(ie,fe){return fe=fe.source||fe,fe=fe.replace(o,"$1"),ge=ge.replace(ie,fe),te},getRegex:function(){return new RegExp(ge,_)}};return te}var s=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ge,_,te){if(ge){var K;try{K=decodeURIComponent(f(te)).replace(s,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}_&&!n.test(te)&&(te=u(_,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var t={},a=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(ge,_){t[" "+ge]||(a.test(ge)?t[" "+ge]=ge+"/":t[" "+ge]=v(ge,"/",!0)),ge=t[" "+ge];var te=ge.indexOf(":")===-1;return _.substring(0,2)==="//"?te?_:ge.replace(r,"$1")+_:_.charAt(0)==="/"?te?_:ge.replace(h,"$1")+_:ge+_}var l={exec:function(){}};function k(ge){for(var _=1,te,K;_<arguments.length;_++){te=arguments[_];for(K in te)Object.prototype.hasOwnProperty.call(te,K)&&(ge[K]=te[K])}return ge}function A(ge,_){var te=ge.replace(/\|/g,function(fe,pe,Pe){for(var we=!1,Ce=pe;--Ce>=0&&Pe[Ce]==="\\";)we=!we;return we?"|":" |"}),K=te.split(/ \|/),ie=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>_)K.splice(_);else for(;K.length<_;)K.push("");for(;ie<K.length;ie++)K[ie]=K[ie].trim().replace(/\\\|/g,"|");return K}function v(ge,_,te){var K=ge.length;if(K===0)return"";for(var ie=0;ie<K;){var fe=ge.charAt(K-ie-1);if(fe===_&&!te)ie++;else if(fe!==_&&te)ie++;else break}return ge.slice(0,K-ie)}function w(ge,_){if(ge.indexOf(_[1])===-1)return-1;for(var te=ge.length,K=0,ie=0;ie<te;ie++)if(ge[ie]==="\\")ie++;else if(ge[ie]===_[0])K++;else if(ge[ie]===_[1]&&(K--,K<0))return ie;return-1}function E(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ge,_){if(_<1)return"";for(var te="";_>1;)_&1&&(te+=ge),_>>=1,ge+=ge;return te+ge}function N(ge,_,te,K){var ie=_.href,fe=_.title?S(_.title):null,pe=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){K.state.inLink=!0;var Pe={type:"link",raw:te,href:ie,title:fe,text:pe,tokens:K.inlineTokens(pe)};return K.state.inLink=!1,Pe}return{type:"image",raw:te,href:ie,title:fe,text:S(pe)}}function z(ge,_){var te=ge.match(/^(\s+)(?:```)/);if(te===null)return _;var K=te[1];return _.split(`
`).map(function(ie){var fe=ie.match(/^\s+/);if(fe===null)return ie;var pe=fe[0];return pe.length>=K.length?ie.slice(K.length):ie}).join(`
`)}var F=function(){function ge(te){this.options=te||me.defaults}var _=ge.prototype;return _.space=function(K){var ie=this.rules.block.newline.exec(K);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},_.code=function(K){var ie=this.rules.block.code.exec(K);if(ie){var fe=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:v(fe,`
`)}}},_.fences=function(K){var ie=this.rules.block.fences.exec(K);if(ie){var fe=ie[0],pe=z(fe,ie[3]||"");return{type:"code",raw:fe,lang:ie[2]?ie[2].trim():ie[2],text:pe}}},_.heading=function(K){var ie=this.rules.block.heading.exec(K);if(ie){var fe=ie[2].trim();if(/#$/.test(fe)){var pe=v(fe,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(fe=pe.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:fe,tokens:this.lexer.inline(fe)}}},_.hr=function(K){var ie=this.rules.block.hr.exec(K);if(ie)return{type:"hr",raw:ie[0]}},_.blockquote=function(K){var ie=this.rules.block.blockquote.exec(K);if(ie){var fe=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},_.list=function(K){var ie=this.rules.block.list.exec(K);if(ie){var fe,pe,Pe,we,Ce,B,Y,ee,q,oe,he,Le,je=ie[1].trim(),He=je.length>1,Qe={type:"list",raw:"",ordered:He,start:He?+je.slice(0,-1):"",loose:!1,items:[]};je=He?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=He?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(Le=!1,!(!(ie=_e.exec(K))||this.rules.block.hr.test(K)));){if(fe=ie[0],K=K.substring(fe.length),ee=ie[2].split(`
`,1)[0],q=K.split(`
`,1)[0],this.options.pedantic?(we=2,he=ee.trimLeft()):(we=ie[2].search(/[^ ]/),we=we>4?1:we,he=ee.slice(we),we+=ie[1].length),B=!1,!ee&&/^ *$/.test(q)&&(fe+=q+`
`,K=K.substring(q.length+1),Le=!0),!Le)for(var at=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,we-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:```|~~~)"),Ae=new RegExp("^ {0,"+Math.min(3,we-1)+"}#");K&&(oe=K.split(`
`,1)[0],ee=oe,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(ee)||Ae.test(ee)||at.test(ee)||st.test(K)));){if(ee.search(/[^ ]/)>=we||!ee.trim())he+=`
`+ee.slice(we);else if(!B)he+=`
`+ee;else break;!B&&!ee.trim()&&(B=!0),fe+=oe+`
`,K=K.substring(oe.length+1)}Qe.loose||(Y?Qe.loose=!0:/\n *\n *$/.test(fe)&&(Y=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(he),pe&&(Pe=pe[0]!=="[ ] ",he=he.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:fe,task:!!pe,checked:Pe,loose:!1,text:he}),Qe.raw+=fe}Qe.items[Qe.items.length-1].raw=fe.trimRight(),Qe.items[Qe.items.length-1].text=he.trimRight(),Qe.raw=Qe.raw.trimRight();var ze=Qe.items.length;for(Ce=0;Ce<ze;Ce++){this.lexer.state.top=!1,Qe.items[Ce].tokens=this.lexer.blockTokens(Qe.items[Ce].text,[]);var Re=Qe.items[Ce].tokens.filter(function(re){return re.type==="space"}),Ye=Re.every(function(re){for(var se=re.raw.split(""),Ie=0,qe=I(se),Xe;!(Xe=qe()).done;){var it=Xe.value;if(it===`
`&&(Ie+=1),Ie>1)return!0}return!1});!Qe.loose&&Re.length&&Ye&&(Qe.loose=!0,Qe.items[Ce].loose=!0)}return Qe}},_.html=function(K){var ie=this.rules.block.html.exec(K);if(ie){var fe={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]);fe.type="paragraph",fe.text=pe,fe.tokens=this.lexer.inline(pe)}return fe}},_.def=function(K){var ie=this.rules.block.def.exec(K);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var fe=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:ie[0],href:ie[2],title:ie[3]}}},_.table=function(K){var ie=this.rules.block.table.exec(K);if(ie){var fe={type:"table",header:A(ie[1]).map(function(Y){return{text:Y}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=ie[0];var pe=fe.align.length,Pe,we,Ce,B;for(Pe=0;Pe<pe;Pe++)/^ *-+: *$/.test(fe.align[Pe])?fe.align[Pe]="right":/^ *:-+: *$/.test(fe.align[Pe])?fe.align[Pe]="center":/^ *:-+ *$/.test(fe.align[Pe])?fe.align[Pe]="left":fe.align[Pe]=null;for(pe=fe.rows.length,Pe=0;Pe<pe;Pe++)fe.rows[Pe]=A(fe.rows[Pe],fe.header.length).map(function(Y){return{text:Y}});for(pe=fe.header.length,we=0;we<pe;we++)fe.header[we].tokens=this.lexer.inline(fe.header[we].text);for(pe=fe.rows.length,we=0;we<pe;we++)for(B=fe.rows[we],Ce=0;Ce<B.length;Ce++)B[Ce].tokens=this.lexer.inline(B[Ce].text);return fe}}},_.lheading=function(K){var ie=this.rules.block.lheading.exec(K);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},_.paragraph=function(K){var ie=this.rules.block.paragraph.exec(K);if(ie){var fe=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:fe,tokens:this.lexer.inline(fe)}}},_.text=function(K){var ie=this.rules.block.text.exec(K);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},_.escape=function(K){var ie=this.rules.inline.escape.exec(K);if(ie)return{type:"escape",raw:ie[0],text:S(ie[1])}},_.tag=function(K){var ie=this.rules.inline.tag.exec(K);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]):ie[0]}},_.link=function(K){var ie=this.rules.inline.link.exec(K);if(ie){var fe=ie[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var pe=v(fe.slice(0,-1),"\\");if((fe.length-pe.length)%2===0)return}else{var Pe=w(ie[2],"()");if(Pe>-1){var we=ie[0].indexOf("!")===0?5:4,Ce=we+ie[1].length+Pe;ie[2]=ie[2].substring(0,Pe),ie[0]=ie[0].substring(0,Ce).trim(),ie[3]=""}}var B=ie[2],Y="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);ee&&(B=ee[1],Y=ee[3])}else Y=ie[3]?ie[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(fe)?B=B.slice(1):B=B.slice(1,-1)),N(ie,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:Y&&Y.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},_.reflink=function(K,ie){var fe;if((fe=this.rules.inline.reflink.exec(K))||(fe=this.rules.inline.nolink.exec(K))){var pe=(fe[2]||fe[1]).replace(/\s+/g," ");if(pe=ie[pe.toLowerCase()],!pe||!pe.href){var Pe=fe[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return N(fe,pe,fe[0],this.lexer)}},_.emStrong=function(K,ie,fe){fe===void 0&&(fe="");var pe=this.rules.inline.emStrong.lDelim.exec(K);if(pe&&!(pe[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=pe[1]||pe[2]||"";if(!Pe||Pe&&(fe===""||this.rules.inline.punctuation.exec(fe))){var we=pe[0].length-1,Ce,B,Y=we,ee=0,q=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,ie=ie.slice(-1*K.length+we);(pe=q.exec(ie))!=null;)if(Ce=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Ce){if(B=Ce.length,pe[3]||pe[4]){Y+=B;continue}else if((pe[5]||pe[6])&&we%3&&!((we+B)%3)){ee+=B;continue}if(Y-=B,!(Y>0)){if(B=Math.min(B,B+Y+ee),Math.min(we,B)%2){var oe=K.slice(1,we+pe.index+B);return{type:"em",raw:K.slice(0,we+pe.index+B+1),text:oe,tokens:this.lexer.inlineTokens(oe)}}var he=K.slice(2,we+pe.index+B-1);return{type:"strong",raw:K.slice(0,we+pe.index+B+1),text:he,tokens:this.lexer.inlineTokens(he)}}}}}},_.codespan=function(K){var ie=this.rules.inline.code.exec(K);if(ie){var fe=ie[2].replace(/\n/g," "),pe=/[^ ]/.test(fe),Pe=/^ /.test(fe)&&/ $/.test(fe);return pe&&Pe&&(fe=fe.substring(1,fe.length-1)),fe=S(fe,!0),{type:"codespan",raw:ie[0],text:fe}}},_.br=function(K){var ie=this.rules.inline.br.exec(K);if(ie)return{type:"br",raw:ie[0]}},_.del=function(K){var ie=this.rules.inline.del.exec(K);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},_.autolink=function(K,ie){var fe=this.rules.inline.autolink.exec(K);if(fe){var pe,Pe;return fe[2]==="@"?(pe=S(this.options.mangle?ie(fe[1]):fe[1]),Pe="mailto:"+pe):(pe=S(fe[1]),Pe=pe),{type:"link",raw:fe[0],text:pe,href:Pe,tokens:[{type:"text",raw:pe,text:pe}]}}},_.url=function(K,ie){var fe;if(fe=this.rules.inline.url.exec(K)){var pe,Pe;if(fe[2]==="@")pe=S(this.options.mangle?ie(fe[0]):fe[0]),Pe="mailto:"+pe;else{var we;do we=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(we!==fe[0]);pe=S(fe[0]),fe[1]==="www."?Pe="http://"+pe:Pe=pe}return{type:"link",raw:fe[0],text:pe,href:Pe,tokens:[{type:"text",raw:pe,text:pe}]}}},_.inlineText=function(K,ie){var fe=this.rules.inline.text.exec(K);if(fe){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]):fe[0]:pe=S(this.options.smartypants?ie(fe[0]):fe[0]),{type:"text",raw:fe[0],text:pe}}},ge}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=i(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=i(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=i(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=i(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=i(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=k({},j),j.gfm=k({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=i(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=k({},j.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:i(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=i(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=i(j._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=i(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=i(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=i(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=i(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=i(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=i(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=i(M.reflink).replace("label",M._label).replace("ref",j._label).getRegex(),M.nolink=i(M.nolink).replace("ref",j._label).getRegex(),M.reflinkSearch=i(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=k({},M),M.pedantic=k({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=k({},M.normal,{escape:i(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=i(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=k({},M.gfm,{br:i(M.br).replace("{2,}","*").getRegex(),text:i(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(ge){var _="",te,K,ie=ge.length;for(te=0;te<ie;te++)K=ge.charCodeAt(te),Math.random()>.5&&(K="x"+K.toString(16)),_+="&#"+K+";";return _}var Q=function(){function ge(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||me.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:j.normal,inline:M.normal};this.options.pedantic?(K.block=j.pedantic,K.inline=M.pedantic):this.options.gfm&&(K.block=j.gfm,this.options.breaks?K.inline=M.breaks:K.inline=M.gfm),this.tokenizer.rules=K}ge.lex=function(K,ie){var fe=new ge(ie);return fe.lex(K)},ge.lexInline=function(K,ie){var fe=new ge(ie);return fe.inlineTokens(K)};var _=ge.prototype;return _.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},_.blockTokens=function(K,ie){var fe=this;ie===void 0&&(ie=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(Y,ee,q){return ee+"    ".repeat(q.length)});for(var pe,Pe,we,Ce;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Y){return(pe=Y.call({lexer:fe},K,ie))?(K=K.substring(pe.raw.length),ie.push(pe),!0):!1}))){if(pe=this.tokenizer.space(K)){K=K.substring(pe.raw.length),pe.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(pe);continue}if(pe=this.tokenizer.code(K)){K=K.substring(pe.raw.length),Pe=ie[ie.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(pe);continue}if(pe=this.tokenizer.fences(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.heading(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.hr(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.blockquote(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.list(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.html(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.def(K)){K=K.substring(pe.raw.length),Pe=ie[ie.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.lheading(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(we=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var Y=1/0,ee=K.slice(1),q=void 0;fe.options.extensions.startBlock.forEach(function(oe){q=oe.call({lexer:this},ee),typeof q=="number"&&q>=0&&(Y=Math.min(Y,q))}),Y<1/0&&Y>=0&&(we=K.substring(0,Y+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(we))){Pe=ie[ie.length-1],Ce&&Pe.type==="paragraph"?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(pe),Ce=we.length!==K.length,K=K.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(K)){K=K.substring(pe.raw.length),Pe=ie[ie.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(pe);continue}if(K){var B="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,ie},_.inline=function(K,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:K,tokens:ie}),ie},_.inlineTokens=function(K,ie){var fe=this;ie===void 0&&(ie=[]);var pe,Pe,we,Ce=K,B,Y,ee;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)q.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,B.index)+"["+P("a",B[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,B.index)+"["+P("a",B[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,B.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(Y||(ee=""),Y=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(he){return(pe=he.call({lexer:fe},K,ie))?(K=K.substring(pe.raw.length),ie.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.tag(K)){K=K.substring(pe.raw.length),Pe=ie[ie.length-1],Pe&&pe.type==="text"&&Pe.type==="text"?(Pe.raw+=pe.raw,Pe.text+=pe.text):ie.push(pe);continue}if(pe=this.tokenizer.link(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(pe.raw.length),Pe=ie[ie.length-1],Pe&&pe.type==="text"&&Pe.type==="text"?(Pe.raw+=pe.raw,Pe.text+=pe.text):ie.push(pe);continue}if(pe=this.tokenizer.emStrong(K,Ce,ee)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.codespan(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.br(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.del(K)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.autolink(K,U)){K=K.substring(pe.raw.length),ie.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(K,U))){K=K.substring(pe.raw.length),ie.push(pe);continue}if(we=K,this.options.extensions&&this.options.extensions.startInline&&function(){var he=1/0,Le=K.slice(1),je=void 0;fe.options.extensions.startInline.forEach(function(He){je=He.call({lexer:this},Le),typeof je=="number"&&je>=0&&(he=Math.min(he,je))}),he<1/0&&he>=0&&(we=K.substring(0,he+1))}(),pe=this.tokenizer.inlineText(we,O)){K=K.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(ee=pe.raw.slice(-1)),Y=!0,Pe=ie[ie.length-1],Pe&&Pe.type==="text"?(Pe.raw+=pe.raw,Pe.text+=pe.text):ie.push(pe);continue}if(K){var oe="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(oe);break}else throw new Error(oe)}}return ie},D(ge,null,[{key:"rules",get:function(){return{block:j,inline:M}}}]),ge}(),ue=function(){function ge(te){this.options=te||me.defaults}var _=ge.prototype;return _.code=function(K,ie,fe){var pe=(ie||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(K,pe);Pe!=null&&Pe!==K&&(fe=!0,K=Pe)}return K=K.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+S(pe,!0)+'">'+(fe?K:S(K,!0))+`</code></pre>
`:"<pre><code>"+(fe?K:S(K,!0))+`</code></pre>
`},_.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},_.html=function(K){return K},_.heading=function(K,ie,fe,pe){if(this.options.headerIds){var Pe=this.options.headerPrefix+pe.slug(fe);return"<h"+ie+' id="'+Pe+'">'+K+"</h"+ie+`>
`}return"<h"+ie+">"+K+"</h"+ie+`>
`},_.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_.list=function(K,ie,fe){var pe=ie?"ol":"ul",Pe=ie&&fe!==1?' start="'+fe+'"':"";return"<"+pe+Pe+`>
`+K+"</"+pe+`>
`},_.listitem=function(K){return"<li>"+K+`</li>
`},_.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_.paragraph=function(K){return"<p>"+K+`</p>
`},_.table=function(K,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ie+`</table>
`},_.tablerow=function(K){return`<tr>
`+K+`</tr>
`},_.tablecell=function(K,ie){var fe=ie.header?"th":"td",pe=ie.align?"<"+fe+' align="'+ie.align+'">':"<"+fe+">";return pe+K+("</"+fe+`>
`)},_.strong=function(K){return"<strong>"+K+"</strong>"},_.em=function(K){return"<em>"+K+"</em>"},_.codespan=function(K){return"<code>"+K+"</code>"},_.br=function(){return this.options.xhtml?"<br/>":"<br>"},_.del=function(K){return"<del>"+K+"</del>"},_.link=function(K,ie,fe){if(K=c(this.options.sanitize,this.options.baseUrl,K),K===null)return fe;var pe='<a href="'+S(K)+'"';return ie&&(pe+=' title="'+ie+'"'),pe+=">"+fe+"</a>",pe},_.image=function(K,ie,fe){if(K=c(this.options.sanitize,this.options.baseUrl,K),K===null)return fe;var pe='<img src="'+K+'" alt="'+fe+'"';return ie&&(pe+=' title="'+ie+'"'),pe+=this.options.xhtml?"/>":">",pe},_.text=function(K){return K},ge}(),Z=function(){function ge(){}var _=ge.prototype;return _.strong=function(K){return K},_.em=function(K){return K},_.codespan=function(K){return K},_.del=function(K){return K},_.html=function(K){return K},_.text=function(K){return K},_.link=function(K,ie,fe){return""+fe},_.image=function(K,ie,fe){return""+fe},_.br=function(){return""},ge}(),J=function(){function ge(){this.seen={}}var _=ge.prototype;return _.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_.getNextSafeSlug=function(K,ie){var fe=K,pe=0;if(this.seen.hasOwnProperty(fe)){pe=this.seen[K];do pe++,fe=K+"-"+pe;while(this.seen.hasOwnProperty(fe))}return ie||(this.seen[K]=pe,this.seen[fe]=0),fe},_.slug=function(K,ie){ie===void 0&&(ie={});var fe=this.serialize(K);return this.getNextSafeSlug(fe,ie.dryrun)},ge}(),X=function(){function ge(te){this.options=te||me.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new J}ge.parse=function(K,ie){var fe=new ge(ie);return fe.parse(K)},ge.parseInline=function(K,ie){var fe=new ge(ie);return fe.parseInline(K)};var _=ge.prototype;return _.parse=function(K,ie){ie===void 0&&(ie=!0);var fe="",pe,Pe,we,Ce,B,Y,ee,q,oe,he,Le,je,He,Qe,_e,at,st,rt,Ae,ze=K.length;for(pe=0;pe<ze;pe++){if(he=K[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(Ae=this.options.extensions.renderers[he.type].call({parser:this},he),Ae!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(he.type))){fe+=Ae||"";continue}switch(he.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(he.tokens),he.depth,f(this.parseInline(he.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(he.text,he.lang,he.escaped);continue}case"table":{for(q="",ee="",Ce=he.header.length,Pe=0;Pe<Ce;Pe++)ee+=this.renderer.tablecell(this.parseInline(he.header[Pe].tokens),{header:!0,align:he.align[Pe]});for(q+=this.renderer.tablerow(ee),oe="",Ce=he.rows.length,Pe=0;Pe<Ce;Pe++){for(Y=he.rows[Pe],ee="",B=Y.length,we=0;we<B;we++)ee+=this.renderer.tablecell(this.parseInline(Y[we].tokens),{header:!1,align:he.align[we]});oe+=this.renderer.tablerow(ee)}fe+=this.renderer.table(q,oe);continue}case"blockquote":{oe=this.parse(he.tokens),fe+=this.renderer.blockquote(oe);continue}case"list":{for(Le=he.ordered,je=he.start,He=he.loose,Ce=he.items.length,oe="",Pe=0;Pe<Ce;Pe++)_e=he.items[Pe],at=_e.checked,st=_e.task,Qe="",_e.task&&(rt=this.renderer.checkbox(at),He?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=rt+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=rt+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:rt}):Qe+=rt),Qe+=this.parse(_e.tokens,He),oe+=this.renderer.listitem(Qe,st,at);fe+=this.renderer.list(oe,Le,je);continue}case"html":{fe+=this.renderer.html(he.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(he.tokens));continue}case"text":{for(oe=he.tokens?this.parseInline(he.tokens):he.text;pe+1<ze&&K[pe+1].type==="text";)he=K[++pe],oe+=`
`+(he.tokens?this.parseInline(he.tokens):he.text);fe+=ie?this.renderer.paragraph(oe):oe;continue}default:{var Re='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return fe},_.parseInline=function(K,ie){ie=ie||this.renderer;var fe="",pe,Pe,we,Ce=K.length;for(pe=0;pe<Ce;pe++){if(Pe=K[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(we=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),we!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){fe+=we||"";continue}switch(Pe.type){case"escape":{fe+=ie.text(Pe.text);break}case"html":{fe+=ie.html(Pe.text);break}case"link":{fe+=ie.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,ie));break}case"image":{fe+=ie.image(Pe.href,Pe.title,Pe.text);break}case"strong":{fe+=ie.strong(this.parseInline(Pe.tokens,ie));break}case"em":{fe+=ie.em(this.parseInline(Pe.tokens,ie));break}case"codespan":{fe+=ie.codespan(Pe.text);break}case"br":{fe+=ie.br();break}case"del":{fe+=ie.del(this.parseInline(Pe.tokens,ie));break}case"text":{fe+=ie.text(Pe.text);break}default:{var B='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return fe},ge}();function le(ge,_,te){if(typeof ge>"u"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof _=="function"&&(te=_,_=null),_=k({},le.defaults,_||{}),E(_),te){var K=_.highlight,ie;try{ie=Q.lex(ge,_)}catch(Ce){return te(Ce)}var fe=function(B){var Y;if(!B)try{_.walkTokens&&le.walkTokens(ie,_.walkTokens),Y=X.parse(ie,_)}catch(ee){B=ee}return _.highlight=K,B?te(B):te(null,Y)};if(!K||K.length<3||(delete _.highlight,!ie.length))return fe();var pe=0;le.walkTokens(ie,function(Ce){Ce.type==="code"&&(pe++,setTimeout(function(){K(Ce.text,Ce.lang,function(B,Y){if(B)return fe(B);Y!=null&&Y!==Ce.text&&(Ce.text=Y,Ce.escaped=!0),pe--,pe===0&&fe()})},0))}),pe===0&&fe();return}function Pe(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+S(Ce.message+"",!0)+"</pre>";throw Ce}try{var we=Q.lex(ge,_);if(_.walkTokens){if(_.async)return Promise.all(le.walkTokens(we,_.walkTokens)).then(function(){return X.parse(we,_)}).catch(Pe);le.walkTokens(we,_.walkTokens)}return X.parse(we,_)}catch(Ce){Pe(Ce)}}le.options=le.setOptions=function(ge){return k(le.defaults,ge),b(le.defaults),le},le.getDefaults=R,le.defaults=me.defaults,le.use=function(){for(var ge=arguments.length,_=new Array(ge),te=0;te<ge;te++)_[te]=arguments[te];var K=k.apply(void 0,[{}].concat(_)),ie=le.defaults.extensions||{renderers:{},childTokens:{}},fe;_.forEach(function(pe){if(pe.extensions&&(fe=!0,pe.extensions.forEach(function(we){if(!we.name)throw new Error("extension name required");if(we.renderer){var Ce=ie.renderers?ie.renderers[we.name]:null;Ce?ie.renderers[we.name]=function(){for(var B=arguments.length,Y=new Array(B),ee=0;ee<B;ee++)Y[ee]=arguments[ee];var q=we.renderer.apply(this,Y);return q===!1&&(q=Ce.apply(this,Y)),q}:ie.renderers[we.name]=we.renderer}if(we.tokenizer){if(!we.level||we.level!=="block"&&we.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[we.level]?ie[we.level].unshift(we.tokenizer):ie[we.level]=[we.tokenizer],we.start&&(we.level==="block"?ie.startBlock?ie.startBlock.push(we.start):ie.startBlock=[we.start]:we.level==="inline"&&(ie.startInline?ie.startInline.push(we.start):ie.startInline=[we.start]))}we.childTokens&&(ie.childTokens[we.name]=we.childTokens)})),pe.renderer&&function(){var we=le.defaults.renderer||new ue,Ce=function(ee){var q=we[ee];we[ee]=function(){for(var oe=arguments.length,he=new Array(oe),Le=0;Le<oe;Le++)he[Le]=arguments[Le];var je=pe.renderer[ee].apply(we,he);return je===!1&&(je=q.apply(we,he)),je}};for(var B in pe.renderer)Ce(B);K.renderer=we}(),pe.tokenizer&&function(){var we=le.defaults.tokenizer||new F,Ce=function(ee){var q=we[ee];we[ee]=function(){for(var oe=arguments.length,he=new Array(oe),Le=0;Le<oe;Le++)he[Le]=arguments[Le];var je=pe.tokenizer[ee].apply(we,he);return je===!1&&(je=q.apply(we,he)),je}};for(var B in pe.tokenizer)Ce(B);K.tokenizer=we}(),pe.walkTokens){var Pe=le.defaults.walkTokens;K.walkTokens=function(we){var Ce=[];return Ce.push(pe.walkTokens.call(this,we)),Pe&&(Ce=Ce.concat(Pe.call(this,we))),Ce}}fe&&(K.extensions=ie),le.setOptions(K)})},le.walkTokens=function(ge,_){for(var te=[],K=function(){var Pe=fe.value;switch(te=te.concat(_.call(le,Pe)),Pe.type){case"table":{for(var we=I(Pe.header),Ce;!(Ce=we()).done;){var B=Ce.value;te=te.concat(le.walkTokens(B.tokens,_))}for(var Y=I(Pe.rows),ee;!(ee=Y()).done;)for(var q=ee.value,oe=I(q),he;!(he=oe()).done;){var Le=he.value;te=te.concat(le.walkTokens(Le.tokens,_))}break}case"list":{te=te.concat(le.walkTokens(Pe.items,_));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[Pe.type]?le.defaults.extensions.childTokens[Pe.type].forEach(function(je){te=te.concat(le.walkTokens(Pe[je],_))}):Pe.tokens&&(te=te.concat(le.walkTokens(Pe.tokens,_)))}},ie=I(ge),fe;!(fe=ie()).done;)K();return te},le.parseInline=function(ge,_){if(typeof ge>"u"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");_=k({},le.defaults,_||{}),E(_);try{var te=Q.lexInline(ge,_);return _.walkTokens&&le.walkTokens(te,_.walkTokens),X.parseInline(te,_)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+S(K.message+"",!0)+"</pre>";throw K}},le.Parser=X,le.parser=X.parse,le.Renderer=ue,le.TextRenderer=Z,le.Lexer=Q,le.lexer=Q.lex,le.Tokenizer=F,le.Slugger=J,le.parse=le;var x=le.options,be=le.setOptions,ce=le.use,G=le.walkTokens,W=le.parseInline,ne=le,ye=X.parse,de=Q.lex;me.Lexer=Q,me.Parser=X,me.Renderer=ue,me.Slugger=J,me.TextRenderer=Z,me.Tokenizer=F,me.getDefaults=R,me.lexer=de,me.marked=le,me.options=x,me.parse=ne,me.parseInline=W,me.parser=ye,me.setOptions=be,me.use=ce,me.walkTokens=G,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[161],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=void 0;function D(d){const f=I(d);if(f&&f.length>0)return new Uint32Array(f)}e.$Rj=D;let T=0;const g=new Uint32Array(10);function I(d){if(T=0,R(d,C,4352),T>0||(R(d,m,4449),T>0)||(R(d,p,4520),T>0)||(R(d,S,12593),T))return g.subarray(0,T);if(d>=44032&&d<=55203){const f=d-44032,o=f%588,i=Math.floor(f/588),s=Math.floor(o/28),n=o%28-1;if(i<C.length?R(i,C,0):4352+i-12593<S.length&&R(4352+i,S,12593),s<m.length?R(s,m,0):4449+s-12593<S.length&&R(4449+s-12593,S,12593),n>=0&&(n<p.length?R(n,p,0):4520+n-12593<S.length&&R(4520+n-12593,S,12593)),T>0)return g.subarray(0,T)}}function R(d,f,o){d>=o&&d<o+f.length&&b(f[d-o])}function b(d){d!==0&&(g[T++]=d&255,d>>8&&(g[T++]=d>>8&255),d>>16&&(g[T++]=d>>16&255))}var $;(function(d){d[d.InitialConsonant=4352]="InitialConsonant",d[d.Vowel=4449]="Vowel",d[d.FinalConsonant=4520]="FinalConsonant",d[d.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var y;(function(d){d[d.NUL=0]="NUL",d[d.A=65]="A",d[d.B=66]="B",d[d.C=67]="C",d[d.D=68]="D",d[d.E=69]="E",d[d.F=70]="F",d[d.G=71]="G",d[d.H=72]="H",d[d.I=73]="I",d[d.J=74]="J",d[d.K=75]="K",d[d.L=76]="L",d[d.M=77]="M",d[d.N=78]="N",d[d.O=79]="O",d[d.P=80]="P",d[d.Q=81]="Q",d[d.R=82]="R",d[d.S=83]="S",d[d.T=84]="T",d[d.U=85]="U",d[d.V=86]="V",d[d.W=87]="W",d[d.X=88]="X",d[d.Y=89]="Y",d[d.Z=90]="Z",d[d.a=97]="a",d[d.b=98]="b",d[d.c=99]="c",d[d.d=100]="d",d[d.e=101]="e",d[d.f=102]="f",d[d.g=103]="g",d[d.h=104]="h",d[d.i=105]="i",d[d.j=106]="j",d[d.k=107]="k",d[d.l=108]="l",d[d.m=109]="m",d[d.n=110]="n",d[d.o=111]="o",d[d.p=112]="p",d[d.q=113]="q",d[d.r=114]="r",d[d.s=115]="s",d[d.t=116]="t",d[d.u=117]="u",d[d.v=118]="v",d[d.w=119]="w",d[d.x=120]="x",d[d.y=121]="y",d[d.z=122]="z"})(y||(y={}));var L;(function(d){d[d.fa=24934]="fa",d[d.fg=26470]="fg",d[d.fq=29030]="fq",d[d.fr=29286]="fr",d[d.ft=29798]="ft",d[d.fv=30310]="fv",d[d.fx=30822]="fx",d[d.hk=27496]="hk",d[d.hl=27752]="hl",d[d.ho=28520]="ho",d[d.ml=27757]="ml",d[d.nj=27246]="nj",d[d.nl=27758]="nl",d[d.np=28782]="np",d[d.qt=29809]="qt",d[d.rt=29810]="rt",d[d.sg=26483]="sg",d[d.sw=30579]="sw"})(L||(L={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Se([1,0,28]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$Gl=void 0;const T=new D.$Dc(1e4);function g(y){return $(y,"NFC",T)}e.$Gl=g;const I=new D.$Dc(1e4);function R(y){return $(y,"NFD",I)}e.$Hl=R;const b=/[^\u0000-\u0080]/;function $(y,L,C){if(!y)return y;const m=C.get(y);if(m)return m;let p;return b.test(y)?p=y.normalize(L):p=y,C.set(y,p),p}e.$Il=function(){const y=/[\u0300-\u036f]/g;return function(L){return R(L).replace(y,"")}}()}),define(ke[122],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.rot=e.$7l=void 0;function D(b,$,y){return Math.min(Math.max(b,$),y)}e.$7l=D;function T(b,$){return($+b%$)%$}e.rot=T;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$9l=g;class I{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$0l=I;class R{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$$l=R}),function(){function me(g){const I=[];typeof g=="number"&&I.push("code/timeOrigin",g);function R($){I.push($,Date.now())}function b(){const $=[];for(let y=0;y<I.length;y+=2)$.push({name:I[y],startTime:I[y+1]});return $}return{mark:R,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const R of performance.getEntriesByType("mark"))I.push({name:R.name,startTime:Math.round(g+R.startTime)});return I}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:me)[T]=D[T]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function D(T){if(e[T])return e[T].exports;var g=e[T]={i:T,l:!1,exports:{}};return me[T].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=me,D.c=e,D.d=function(T,g,I){D.o(T,g)||Object.defineProperty(T,g,{enumerable:!0,get:I})},D.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,g){if(1&g&&(T=D(T)),8&g||4&g&&typeof T=="object"&&T&&T.__esModule)return T;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:T}),2&g&&typeof T!="string")for(var R in T)D.d(I,R,function(b){return T[b]}.bind(null,R));return I},D.n=function(T){var g=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(g,"a",g),g},D.o=function(T,g){return Object.prototype.hasOwnProperty.call(T,g)},D.p="",D(D.s=0)}([function(me,e,D){(function(T){var g;e=me.exports=ce,g=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],y=0,L=y++;$[L]="0|[1-9]\\d*";var C=y++;$[C]="[0-9]+";var m=y++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=y++;$[p]="("+$[L]+")\\.("+$[L]+")\\.("+$[L]+")";var S=y++;$[S]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var d=y++;$[d]="(?:"+$[L]+"|"+$[m]+")";var f=y++;$[f]="(?:"+$[C]+"|"+$[m]+")";var o=y++;$[o]="(?:-("+$[d]+"(?:\\."+$[d]+")*))";var i=y++;$[i]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var s=y++;$[s]="[0-9A-Za-z-]+";var n=y++;$[n]="(?:\\+("+$[s]+"(?:\\."+$[s]+")*))";var c=y++,t="v?"+$[p]+$[o]+"?"+$[n]+"?";$[c]="^"+t+"$";var a="[v=\\s]*"+$[S]+$[i]+"?"+$[n]+"?",r=y++;$[r]="^"+a+"$";var h=y++;$[h]="((?:<|>)?=?)";var u=y++;$[u]=$[C]+"|x|X|\\*";var l=y++;$[l]=$[L]+"|x|X|\\*";var k=y++;$[k]="[v=\\s]*("+$[l]+")(?:\\.("+$[l]+")(?:\\.("+$[l]+")(?:"+$[o]+")?"+$[n]+"?)?)?";var A=y++;$[A]="[v=\\s]*("+$[u]+")(?:\\.("+$[u]+")(?:\\.("+$[u]+")(?:"+$[i]+")?"+$[n]+"?)?)?";var v=y++;$[v]="^"+$[h]+"\\s*"+$[k]+"$";var w=y++;$[w]="^"+$[h]+"\\s*"+$[A]+"$";var E=y++;$[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=y++;$[P]="(?:~>?)";var N=y++;$[N]="(\\s*)"+$[P]+"\\s+",b[N]=new RegExp($[N],"g");var z=y++;$[z]="^"+$[P]+$[k]+"$";var F=y++;$[F]="^"+$[P]+$[A]+"$";var j=y++;$[j]="(?:\\^)";var M=y++;$[M]="(\\s*)"+$[j]+"\\s+",b[M]=new RegExp($[M],"g");var O=y++;$[O]="^"+$[j]+$[k]+"$";var U=y++;$[U]="^"+$[j]+$[A]+"$";var Q=y++;$[Q]="^"+$[h]+"\\s*("+a+")$|^$";var ue=y++;$[ue]="^"+$[h]+"\\s*("+t+")$|^$";var Z=y++;$[Z]="(\\s*)"+$[h]+"\\s*("+a+"|"+$[k]+")",b[Z]=new RegExp($[Z],"g");var J=y++;$[J]="^\\s*("+$[k]+")\\s+-\\s+("+$[k]+")\\s*$";var X=y++;$[X]="^\\s*("+$[A]+")\\s+-\\s+("+$[A]+")\\s*$";var le=y++;$[le]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)g(x,$[x]),b[x]||(b[x]=new RegExp($[x]));function be(q,oe){if(q instanceof ce)return q;if(typeof q!="string"||q.length>I||!(oe?b[r]:b[c]).test(q))return null;try{return new ce(q,oe)}catch{return null}}function ce(q,oe){if(q instanceof ce){if(q.loose===oe)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof ce))return new ce(q,oe);g("SemVer",q,oe),this.loose=oe;var he=q.trim().match(oe?b[r]:b[c]);if(!he)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var je=+Le;if(je>=0&&je<R)return je}return Le}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=be,e.valid=function(q,oe){var he=be(q,oe);return he?he.version:null},e.clean=function(q,oe){var he=be(q.trim().replace(/^[=v]+/,""),oe);return he?he.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(q){return g("SemVer.compare",this.version,this.loose,q),q instanceof ce||(q=new ce(q,this.loose)),this.compareMain(q)||this.comparePre(q)},ce.prototype.compareMain=function(q){return q instanceof ce||(q=new ce(q,this.loose)),W(this.major,q.major)||W(this.minor,q.minor)||W(this.patch,q.patch)},ce.prototype.comparePre=function(q){if(q instanceof ce||(q=new ce(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var oe=0;do{var he=this.prerelease[oe],Le=q.prerelease[oe];if(g("prerelease compare",oe,he,Le),he===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(he===void 0)return-1;if(he!==Le)return W(he,Le)}while(++oe)},ce.prototype.inc=function(q,oe){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,oe,he,Le){typeof he=="string"&&(Le=he,he=void 0);try{return new ce(q,he).inc(oe,Le).version}catch{return null}},e.diff=function(q,oe){if(ge(q,oe))return null;var he=be(q),Le=be(oe);if(he.prerelease.length||Le.prerelease.length){for(var je in he)if((je==="major"||je==="minor"||je==="patch")&&he[je]!==Le[je])return"pre"+je;return"prerelease"}for(var je in he)if((je==="major"||je==="minor"||je==="patch")&&he[je]!==Le[je])return je},e.compareIdentifiers=W;var G=/^[0-9]+$/;function W(q,oe){var he=G.test(q),Le=G.test(oe);return he&&Le&&(q=+q,oe=+oe),he&&!Le?-1:Le&&!he?1:q<oe?-1:q>oe?1:0}function ne(q,oe,he){return new ce(q,he).compare(new ce(oe,he))}function ye(q,oe,he){return ne(q,oe,he)>0}function de(q,oe,he){return ne(q,oe,he)<0}function ge(q,oe,he){return ne(q,oe,he)===0}function _(q,oe,he){return ne(q,oe,he)!==0}function te(q,oe,he){return ne(q,oe,he)>=0}function K(q,oe,he){return ne(q,oe,he)<=0}function ie(q,oe,he,Le){var je;switch(oe){case"===":typeof q=="object"&&(q=q.version),typeof he=="object"&&(he=he.version),je=q===he;break;case"!==":typeof q=="object"&&(q=q.version),typeof he=="object"&&(he=he.version),je=q!==he;break;case"":case"=":case"==":je=ge(q,he,Le);break;case"!=":je=_(q,he,Le);break;case">":je=ye(q,he,Le);break;case">=":je=te(q,he,Le);break;case"<":je=de(q,he,Le);break;case"<=":je=K(q,he,Le);break;default:throw new TypeError("Invalid operator: "+oe)}return je}function fe(q,oe){if(q instanceof fe){if(q.loose===oe)return q;q=q.value}if(!(this instanceof fe))return new fe(q,oe);g("comparator",q,oe),this.loose=oe,this.parse(q),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(q,oe){return W(oe,q)},e.major=function(q,oe){return new ce(q,oe).major},e.minor=function(q,oe){return new ce(q,oe).minor},e.patch=function(q,oe){return new ce(q,oe).patch},e.compare=ne,e.compareLoose=function(q,oe){return ne(q,oe,!0)},e.rcompare=function(q,oe,he){return ne(oe,q,he)},e.sort=function(q,oe){return q.sort(function(he,Le){return e.compare(he,Le,oe)})},e.rsort=function(q,oe){return q.sort(function(he,Le){return e.rcompare(he,Le,oe)})},e.gt=ye,e.lt=de,e.eq=ge,e.neq=_,e.gte=te,e.lte=K,e.cmp=ie,e.Comparator=fe;var pe={};function Pe(q,oe){if(q instanceof Pe)return q.loose===oe?q:new Pe(q.raw,oe);if(q instanceof fe)return new Pe(q.value,oe);if(!(this instanceof Pe))return new Pe(q,oe);if(this.loose=oe,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function we(q){return!q||q.toLowerCase()==="x"||q==="*"}function Ce(q,oe,he,Le,je,He,Qe,_e,at,st,rt,Ae,ze){return((oe=we(he)?"":we(Le)?">="+he+".0.0":we(je)?">="+he+"."+Le+".0":">="+oe)+" "+(_e=we(at)?"":we(st)?"<"+(+at+1)+".0.0":we(rt)?"<"+at+"."+(+st+1)+".0":Ae?"<="+at+"."+st+"."+rt+"-"+Ae:"<="+_e)).trim()}function B(q,oe){for(var he=0;he<q.length;he++)if(!q[he].test(oe))return!1;if(oe.prerelease.length){for(he=0;he<q.length;he++)if(g(q[he].semver),q[he].semver!==pe&&q[he].semver.prerelease.length>0){var Le=q[he].semver;if(Le.major===oe.major&&Le.minor===oe.minor&&Le.patch===oe.patch)return!0}return!1}return!0}function Y(q,oe,he){try{oe=new Pe(oe,he)}catch{return!1}return oe.test(q)}function ee(q,oe,he,Le){var je,He,Qe,_e,at;switch(q=new ce(q,Le),oe=new Pe(oe,Le),he){case">":je=ye,He=K,Qe=de,_e=">",at=">=";break;case"<":je=de,He=te,Qe=ye,_e="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Y(q,oe,Le))return!1;for(var st=0;st<oe.set.length;++st){var rt=oe.set[st],Ae=null,ze=null;if(rt.forEach(function(Re){Re.semver===pe&&(Re=new fe(">=0.0.0")),Ae=Ae||Re,ze=ze||Re,je(Re.semver,Ae.semver,Le)?Ae=Re:Qe(Re.semver,ze.semver,Le)&&(ze=Re)}),Ae.operator===_e||Ae.operator===at||(!ze.operator||ze.operator===_e)&&He(q,ze.semver)||ze.operator===at&&Qe(q,ze.semver))return!1}return!0}fe.prototype.parse=function(q){var oe=this.loose?b[Q]:b[ue],he=q.match(oe);if(!he)throw new TypeError("Invalid comparator: "+q);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new ce(he[2],this.loose):this.semver=pe},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(q){return g("Comparator.test",q,this.loose),this.semver===pe||(typeof q=="string"&&(q=new ce(q,this.loose)),ie(q,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(q,oe){if(!(q instanceof fe))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Pe(q.value,oe),Y(this.value,he,oe);if(q.operator==="")return he=new Pe(this.value,oe),Y(q.semver,he,oe);var Le=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),He=this.semver.version===q.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),_e=ie(this.semver,"<",q.semver,oe)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),at=ie(this.semver,">",q.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Le||je||He&&Qe||_e||at},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(q){var oe=this.loose;q=q.trim(),g("range",q,oe);var he=oe?b[X]:b[J];q=q.replace(he,Ce),g("hyphen replace",q),q=q.replace(b[Z],"$1$2$3"),g("comparator trim",q,b[Z]),q=(q=(q=q.replace(b[N],"$1~")).replace(b[M],"$1^")).split(/\s+/).join(" ");var Le=oe?b[Q]:b[ue],je=q.split(" ").map(function(He){return function(Qe,_e){return g("comp",Qe),Qe=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Ae,ze){g("caret",Ae,ze);var Re=ze?b[U]:b[O];return Ae.replace(Re,function(Ye,re,se,Ie,qe){var Xe;return g("caret",Ae,Ye,re,se,Ie,qe),we(re)?Xe="":we(se)?Xe=">="+re+".0.0 <"+(+re+1)+".0.0":we(Ie)?Xe=re==="0"?">="+re+"."+se+".0 <"+re+"."+(+se+1)+".0":">="+re+"."+se+".0 <"+(+re+1)+".0.0":qe?(g("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Xe=re==="0"?se==="0"?">="+re+"."+se+"."+Ie+qe+" <"+re+"."+se+"."+(+Ie+1):">="+re+"."+se+"."+Ie+qe+" <"+re+"."+(+se+1)+".0":">="+re+"."+se+"."+Ie+qe+" <"+(+re+1)+".0.0"):(g("no pr"),Xe=re==="0"?se==="0"?">="+re+"."+se+"."+Ie+" <"+re+"."+se+"."+(+Ie+1):">="+re+"."+se+"."+Ie+" <"+re+"."+(+se+1)+".0":">="+re+"."+se+"."+Ie+" <"+(+re+1)+".0.0"),g("caret return",Xe),Xe})}(rt,st)}).join(" ")}(Qe,_e),g("caret",Qe),Qe=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Ae,ze){var Re=ze?b[F]:b[z];return Ae.replace(Re,function(Ye,re,se,Ie,qe){var Xe;return g("tilde",Ae,Ye,re,se,Ie,qe),we(re)?Xe="":we(se)?Xe=">="+re+".0.0 <"+(+re+1)+".0.0":we(Ie)?Xe=">="+re+"."+se+".0 <"+re+"."+(+se+1)+".0":qe?(g("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Xe=">="+re+"."+se+"."+Ie+qe+" <"+re+"."+(+se+1)+".0"):Xe=">="+re+"."+se+"."+Ie+" <"+re+"."+(+se+1)+".0",g("tilde return",Xe),Xe})}(rt,st)}).join(" ")}(Qe,_e),g("tildes",Qe),Qe=function(at,st){return g("replaceXRanges",at,st),at.split(/\s+/).map(function(rt){return function(Ae,ze){Ae=Ae.trim();var Re=ze?b[w]:b[v];return Ae.replace(Re,function(Ye,re,se,Ie,qe,Xe){g("xRange",Ae,Ye,re,se,Ie,qe,Xe);var it=we(se),nt=it||we(Ie),Oe=nt||we(qe);return re==="="&&Oe&&(re=""),it?Ye=re===">"||re==="<"?"<0.0.0":"*":re&&Oe?(nt&&(Ie=0),Oe&&(qe=0),re===">"?(re=">=",nt?(se=+se+1,Ie=0,qe=0):Oe&&(Ie=+Ie+1,qe=0)):re==="<="&&(re="<",nt?se=+se+1:Ie=+Ie+1),Ye=re+se+"."+Ie+"."+qe):nt?Ye=">="+se+".0.0 <"+(+se+1)+".0.0":Oe&&(Ye=">="+se+"."+Ie+".0 <"+se+"."+(+Ie+1)+".0"),g("xRange return",Ye),Ye})}(rt,st)}).join(" ")}(Qe,_e),g("xrange",Qe),Qe=function(at,st){return g("replaceStars",at,st),at.trim().replace(b[le],"")}(Qe,_e),g("stars",Qe),Qe}(He,oe)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(He){return!!He.match(Le)})),je=je.map(function(He){return new fe(He,oe)})},Pe.prototype.intersects=function(q,oe){if(!(q instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Le){return q.set.some(function(je){return je.every(function(He){return Le.intersects(He,oe)})})})})},e.toComparators=function(q,oe){return new Pe(q,oe).set.map(function(he){return he.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new ce(q,this.loose));for(var oe=0;oe<this.set.length;oe++)if(B(this.set[oe],q))return!0;return!1},e.satisfies=Y,e.maxSatisfying=function(q,oe,he){var Le=null,je=null;try{var He=new Pe(oe,he)}catch{return null}return q.forEach(function(Qe){He.test(Qe)&&(Le&&je.compare(Qe)!==-1||(je=new ce(Le=Qe,he)))}),Le},e.minSatisfying=function(q,oe,he){var Le=null,je=null;try{var He=new Pe(oe,he)}catch{return null}return q.forEach(function(Qe){He.test(Qe)&&(Le&&je.compare(Qe)!==1||(je=new ce(Le=Qe,he)))}),Le},e.validRange=function(q,oe){try{return new Pe(q,oe).range||"*"}catch{return null}},e.ltr=function(q,oe,he){return ee(q,oe,"<",he)},e.gtr=function(q,oe,he){return ee(q,oe,">",he)},e.outside=ee,e.prerelease=function(q,oe){var he=be(q,oe);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(q,oe,he){return q=new Pe(q,he),oe=new Pe(oe,he),q.intersects(oe)},e.coerce=function(q){if(q instanceof ce)return q;if(typeof q!="string")return null;var oe=q.match(b[E]);return oe==null?null:be((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,D(1))},function(me,e){var D,T,g=me.exports={};function I(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function b(f){if(D===setTimeout)return setTimeout(f,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var $,y=[],L=!1,C=-1;function m(){L&&$&&(L=!1,$.length?y=$.concat(y):C=-1,y.length&&p())}function p(){if(!L){var f=b(m);L=!0;for(var o=y.length;o;){for($=y,y=[];++C<o;)$&&$[C].run();C=-1,o=y.length}$=null,L=!1,function(i){if(T===clearTimeout)return clearTimeout(i);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(i);try{T(i)}catch{try{return T.call(null,i)}catch{return T.call(this,i)}}}(f)}}function S(f,o){this.fun=f,this.array=o}function d(){}g.nextTick=function(f){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];y.push(new S(f,o)),y.length!==1||L||b(p)},S.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=d,g.addListener=d,g.once=d,g.off=d,g.removeListener=d,g.removeAllListeners=d,g.emit=d,g.prependListener=d,g.prependOnceListener=d,g.listeners=function(f){return[]},g.binding=function(f){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(f){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(I){return new T(I)}constructor(I){this.c=D&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Rd=T}),define(ke[4],Se([1,0,14,74,3,75,38]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.Event=void 0;const b=!1,$=!1;var y;(function(v){v.None=()=>g.$Tc.None;function w(ie){if($){const{onDidAddListener:fe}=ie,pe=S.create();let Pe=0;ie.onDidAddListener=()=>{++Pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),pe.print()),fe?.()}}}function E(ie,fe){return ue(ie,()=>{},0,void 0,!0,void 0,fe)}v.defer=E;function P(ie){return(fe,pe=null,Pe)=>{let we=!1,Ce;return Ce=ie(B=>{if(!we)return Ce?Ce.dispose():we=!0,fe.call(pe,B)},null,Pe),we&&Ce.dispose(),Ce}}v.once=P;function N(ie,fe,pe){return U((Pe,we=null,Ce)=>ie(B=>Pe.call(we,fe(B)),null,Ce),pe)}v.map=N;function z(ie,fe,pe){return U((Pe,we=null,Ce)=>ie(B=>{fe(B),Pe.call(we,B)},null,Ce),pe)}v.forEach=z;function F(ie,fe,pe){return U((Pe,we=null,Ce)=>ie(B=>fe(B)&&Pe.call(we,B),null,Ce),pe)}v.filter=F;function j(ie){return ie}v.signal=j;function M(...ie){return(fe,pe=null,Pe)=>{const we=(0,g.$Qc)(...ie.map(Ce=>Ce(B=>fe.call(pe,B))));return Q(we,Pe)}}v.any=M;function O(ie,fe,pe,Pe){let we=pe;return N(ie,Ce=>(we=fe(we,Ce),we),Pe)}v.reduce=O;function U(ie,fe){let pe;const Pe={onWillAddFirstListener(){pe=ie(we.fire,we)},onDidRemoveLastListener(){pe?.dispose()}};fe||w(Pe);const we=new s(Pe);return fe?.add(we),we.event}function Q(ie,fe){return fe instanceof Array?fe.push(ie):fe&&fe.add(ie),ie}function ue(ie,fe,pe=100,Pe=!1,we=!1,Ce,B){let Y,ee,q,oe=0,he;const Le={leakWarningThreshold:Ce,onWillAddFirstListener(){Y=ie(He=>{oe++,ee=fe(ee,He),Pe&&!q&&(je.fire(ee),ee=void 0),he=()=>{const Qe=ee;ee=void 0,q=void 0,(!Pe||oe>1)&&je.fire(Qe),oe=0},typeof pe=="number"?(clearTimeout(q),q=setTimeout(he,pe)):q===void 0&&(q=0,queueMicrotask(he))})},onWillRemoveListener(){we&&oe>0&&he?.()},onDidRemoveLastListener(){he=void 0,Y.dispose()}};B||w(Le);const je=new s(Le);return B?.add(je),je.event}v.debounce=ue;function Z(ie,fe=0,pe){return v.debounce(ie,(Pe,we)=>Pe?(Pe.push(we),Pe):[we],fe,void 0,!0,void 0,pe)}v.accumulate=Z;function J(ie,fe=(Pe,we)=>Pe===we,pe){let Pe=!0,we;return F(ie,Ce=>{const B=Pe||!fe(Ce,we);return Pe=!1,we=Ce,B},pe)}v.latch=J;function X(ie,fe,pe){return[v.filter(ie,fe,pe),v.filter(ie,Pe=>!fe(Pe),pe)]}v.split=X;function le(ie,fe=!1,pe=[],Pe){let we=pe.slice(),Ce=ie(ee=>{we?we.push(ee):Y.fire(ee)});Pe&&Pe.add(Ce);const B=()=>{we?.forEach(ee=>Y.fire(ee)),we=null},Y=new s({onWillAddFirstListener(){Ce||(Ce=ie(ee=>Y.fire(ee)),Pe&&Pe.add(Ce))},onDidAddFirstListener(){we&&(fe?setTimeout(B):B())},onDidRemoveLastListener(){Ce&&Ce.dispose(),Ce=null}});return Pe&&Pe.add(Y),Y.event}v.buffer=le;function x(ie,fe){return(Pe,we,Ce)=>{const B=fe(new ce);return ie(function(Y){const ee=B.evaluate(Y);ee!==be&&Pe.call(we,ee)},void 0,Ce)}}v.chain=x;const be=Symbol("HaltChainable");class ce{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(pe=>(fe(pe),pe)),this}filter(fe){return this.f.push(pe=>fe(pe)?pe:be),this}reduce(fe,pe){let Pe=pe;return this.f.push(we=>(Pe=fe(Pe,we),Pe)),this}latch(fe=(pe,Pe)=>pe===Pe){let pe=!0,Pe;return this.f.push(we=>{const Ce=pe||!fe(we,Pe);return pe=!1,Pe=we,Ce?we:be}),this}evaluate(fe){for(const pe of this.f)if(fe=pe(fe),fe===be)break;return fe}}function G(ie,fe,pe=Pe=>Pe){const Pe=(...Y)=>B.fire(pe(...Y)),we=()=>ie.on(fe,Pe),Ce=()=>ie.removeListener(fe,Pe),B=new s({onWillAddFirstListener:we,onDidRemoveLastListener:Ce});return B.event}v.fromNodeEventEmitter=G;function W(ie,fe,pe=Pe=>Pe){const Pe=(...Y)=>B.fire(pe(...Y)),we=()=>ie.addEventListener(fe,Pe),Ce=()=>ie.removeEventListener(fe,Pe),B=new s({onWillAddFirstListener:we,onDidRemoveLastListener:Ce});return B.event}v.fromDOMEventEmitter=W;function ne(ie){return new Promise(fe=>P(ie)(fe))}v.toPromise=ne;function ye(ie){const fe=new s;return ie.then(pe=>{fe.fire(pe)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}v.fromPromise=ye;function de(ie,fe,pe){return fe(pe),ie(Pe=>fe(Pe))}v.runAndSubscribe=de;function ge(ie,fe){let pe=null;function Pe(Ce){pe?.dispose(),pe=new g.$Sc,fe(Ce,pe)}Pe(void 0);const we=ie(Ce=>Pe(Ce));return(0,g.$Rc)(()=>{we.dispose(),pe?.dispose()})}v.runAndSubscribeWithStore=ge;class _{constructor(fe,pe){this._observable=fe,this.f=0,this.g=!1;const Pe={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};pe||w(Pe),this.emitter=new s(Pe),pe&&pe.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,pe){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(ie,fe){return new _(ie,fe).emitter.event}v.fromObservable=te;function K(ie){return(fe,pe,Pe)=>{let we=0,Ce=!1;const B={beginUpdate(){we++},endUpdate(){we--,we===0&&(ie.reportChanges(),Ce&&(Ce=!1,fe.call(pe)))},handlePossibleChange(){},handleChange(){Ce=!0}};ie.addObserver(B),ie.reportChanges();const Y={dispose(){ie.removeObserver(B)}};return Pe instanceof g.$Sc?Pe.add(Y):Array.isArray(Pe)&&Pe.push(Y),Y}}v.fromObservableLight=K})(y||(e.Event=y={}));class L{static{this.all=new Set}static{this.f=0}constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${L.f++}`,L.all.add(this)}start(w){this.g=new R.$Rd,this.listenerCount=w}stop(){if(this.g){const w=this.g.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this.g=void 0}}}e.$Td=L;let C=-1;function m(v){const w=C;return C=v,{dispose(){C=w}}}e.$Ud=m;class p{constructor(w,E=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=E,this.g=0}dispose(){this.f?.clear()}check(w,E){const P=this.threshold;if(P<=0||E<P)return;this.f||(this.f=new Map);const N=this.f.get(w.value)||0;if(this.f.set(w.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let z,F=0;for(const[j,M]of this.f)(!z||F<M)&&(z=j,F=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${F}):`),console.warn(z)}return()=>{const z=this.f.get(w.value)||0;this.f.set(w.value,z-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let d=0;class f{constructor(w){this.value=w,this.id=d++}}const o=2,i=(v,w)=>{if(v instanceof f)w(v);else for(let E=0;E<v.length;E++){const P=v[E];P&&w(P)}};class s{constructor(w){this.w=0,this.f=w,this.g=C>0||this.f?.leakWarningThreshold?new p(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new L(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const w=this.t;queueMicrotask(()=>{i(w,E=>E.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(w,E,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Tc.None;if(this.m)return g.$Tc.None;E&&(w=w.bind(E));const N=new f(w);let z,F;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=S.create(),z=this.g.check(N.stack,this.w+1)),b&&(N.stack=F??S.create()),this.t?this.t instanceof f?(this.u??=new c,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,g.$Rc)(()=>{z?.(),this.x(N)});return P instanceof g.$Sc?P.add(j):Array.isArray(P)&&P.push(j),j},this.q}x(w){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const E=this.t,P=E.indexOf(w);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,E[P]=void 0;const N=this.u.current===this;if(this.w*o<=E.length){let z=0;for(let F=0;F<E.length;F++)E[F]?E[z++]=E[F]:N&&(this.u.end--,z<this.u.i&&this.u.i--);E.length=z}}y(w,E){if(!w)return;const P=this.f?.onListenerError||D.$1;if(!P){w.value(E);return}try{w.value(E)}catch(N){P(N)}}z(w){const E=w.current.t;for(;w.i<w.end;)this.y(E[w.i++],w.value);w.reset()}fire(w){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,w);else{const E=this.u;E.enqueue(this,w,this.t.length),this.z(E)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Vd=s;const n=()=>new c;e.$Wd=n;class c{constructor(){this.i=-1,this.end=0}enqueue(w,E,P){this.i=0,this.end=P,this.current=w,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends s{async fireAsync(w,E,P){if(this.t)for(this.h||(this.h=new I.$4c),i(this.t,N=>this.h.push([N.value,w]));this.h.size>0&&!E.isCancellationRequested;){const[N,z]=this.h.shift(),F=[],j={...z,token:E,waitUntil:M=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");P&&(M=P(M,N)),F.push(M)}};try{N(j)}catch(M){(0,D.$1)(M);continue}Object.freeze(F),await Promise.allSettled(F).then(M=>{for(const O of M)O.status==="rejected"&&(0,D.$1)(O.reason)})}}}e.$Xd=t;class a extends s{get isPaused(){return this.h!==0}constructor(w){super(w),this.h=0,this.s=new I.$4c,this.A=w?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const w=Array.from(this.s);this.s.clear(),super.fire(this.A(w))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(w){this.w&&(this.h!==0?this.s.push(w):super.fire(w))}}e.$Yd=a;class r extends a{constructor(w){super(w),this.k=w.delay??100}fire(w){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(w)}}e.$Zd=r;class h extends s{constructor(w){super(w),this.h=[],this.k=w?.merge}fire(w){this.hasListeners()&&(this.h.push(w),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(E=>super.fire(E)),this.h=[]}))}}e.$1d=h;class u{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(w){const E={event:w,listener:null};this.h.push(E),this.g&&this.m(E);const P=()=>{this.g&&this.o(E);const N=this.h.indexOf(E);this.h.splice(N,1)};return(0,g.$Rc)((0,T.$db)(P))}j(){this.g=!0,this.h.forEach(w=>this.m(w))}k(){this.g=!1,this.h.forEach(w=>this.o(w))}m(w){w.listener=w.event(E=>this.f.fire(E))}o(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.f.dispose()}}e.$2d=u;class l{constructor(w,E,P,N){this.f=new g.$Sc;const z=this.f.add(new u),F=this.f.add(new g.$3c);function j(M){F.set(M,z.add(N(M)))}for(const M of w)j(M);this.f.add(E(M=>{j(M)})),this.f.add(P(M=>{F.deleteAndDispose(M)})),this.event=z.event}dispose(){this.f.dispose()}}e.$3d=l;class k{constructor(){this.f=[]}wrapEvent(w){return(E,P,N)=>w(z=>{const F=this.f[this.f.length-1];F?F.push(()=>E.call(P,z)):E.call(P,z)},void 0,N)}bufferEvents(w){const E=[];this.f.push(E);const P=w();return this.f.pop(),E.forEach(N=>N()),P}}e.$4d=k;class A{constructor(){this.f=!1,this.g=y.None,this.h=g.$Tc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(w){this.g=w,this.f&&(this.h.dispose(),this.h=w(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$5d=A}),define(ke[21],Se([1,0,4]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.CancellationToken=void 0;const T=Object.freeze(function(b,$){const y=setTimeout(b.bind($),0);return{dispose(){clearTimeout(y)}}});var g;(function(b){function $(y){return y===b.None||y===b.Cancelled||y instanceof I?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(g||(e.CancellationToken=g={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new D.$Vd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=g.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=g.None}}e.$6d=R}),define(ke[162],Se([1,0,21]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=e.$Fe=e.$Ee=void 0;class T{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.$6d,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Ee=T;class g{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Fe=g;class I{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$Ge=I}),define(ke[99],Se([1,0,14,3]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function g(n){const c=n;return c?typeof c.read=="function":!1}e.$7d=g;function I(n){const c=n;return c?[c.on,c.pause,c.resume,c.destroy].every(t=>typeof t=="function"):!1}e.$8d=I;function R(n){const c=n;return c?I(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$9d=R;function b(n,c){return new $(n,c)}e.$0d=b;class ${constructor(c,t){this.e=c,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(t=>t(c))}h(c){this.c.error.length===0?(0,D.$1)(c):this.c.error.slice(0).forEach(t=>t(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,t){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(c,t){if(this.a.destroyed)return;let a;switch(c){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const r=a.indexOf(t);r>=0&&a.splice(r,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(n,c){const t=[];let a;for(;(a=n.read())!==null;)t.push(a);return c(t)}e.$$d=y;function L(n,c,t){const a=[];let r;for(;(r=n.read())!==null&&a.length<t;)a.push(r);return r===null&&a.length>0?c(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r<"u"){const h=r;return r=void 0,h}return n.read()}}}e.$_d=L;function C(n,c){return new Promise((t,a)=>{const r=[];m(n,{onData:h=>{c&&r.push(h)},onError:h=>{c?a(h):t(void 0)},onEnd:()=>{t(c?c(r):void 0)}})})}e.$ae=C;function m(n,c,t){n.on("error",a=>{t?.isCancellationRequested||c.onError(a)}),n.on("end",()=>{t?.isCancellationRequested||c.onEnd()}),n.on("data",a=>{t?.isCancellationRequested||c.onData(a)})}e.$be=m;function p(n,c){return new Promise((t,a)=>{const r=new T.$Sc,h=[],u=A=>{if(h.push(A),h.length>c)return r.dispose(),n.pause(),t({stream:n,buffer:h,ended:!1})},l=A=>(r.dispose(),a(A)),k=()=>(r.dispose(),t({stream:n,buffer:h,ended:!0}));r.add((0,T.$Rc)(()=>n.removeListener("error",l))),n.on("error",l),r.add((0,T.$Rc)(()=>n.removeListener("end",k))),n.on("end",k),r.add((0,T.$Rc)(()=>n.removeListener("data",u))),n.on("data",u)})}e.$ce=p;function S(n,c){const t=b(c);return t.end(n),t}e.$de=S;function d(){const n=b(()=>{throw new Error("not supported")});return n.end(),n}e.$ee=d;function f(n){let c=!1;return{read:()=>c?null:(c=!0,n)}}e.$fe=f;function o(n,c,t){const a=b(t);return m(n,{onData:r=>a.write(c.data(r)),onError:r=>a.error(c.error?c.error(r):r),onEnd:()=>a.end()}),a}e.$ge=o;function i(n,c,t){let a=!1;return{read:()=>{const r=c.read();return a?r:(a=!0,r!==null?t([n,r]):n)}}}e.$he=i;function s(n,c,t){let a=!1;const r=b(t);return m(c,{onData:h=>a?r.write(h):(a=!0,r.write(t([n,h]))),onError:h=>r.error(h),onEnd:()=>{a||(a=!0,r.write(n)),r.end()}}),r}e.$ie=s}),define(ke[22],Se([1,0,43,99]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const g=typeof Buffer<"u",I=new D.$V(()=>new Uint8Array(256));let R,b;class ${static alloc(E){return g?new $(Buffer.allocUnsafe(E)):new $(new Uint8Array(E))}static wrap(E){return g&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new $(E)}static fromString(E,P){return!(P?.dontUseNodeBuffer||!1)&&g?new $(Buffer.from(E)):(R||(R=new TextEncoder),new $(R.encode(E)))}static fromByteArray(E){const P=$.alloc(E.length);for(let N=0,z=E.length;N<z;N++)P.buffer[N]=E[N];return P}static concat(E,P){if(typeof P>"u"){P=0;for(let F=0,j=E.length;F<j;F++)P+=E[F].byteLength}const N=$.alloc(P);let z=0;for(let F=0,j=E.length;F<j;F++){const M=E[F];N.set(M,z),z+=M.byteLength}return N}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=$.alloc(this.byteLength);return E.set(this),E}toString(){return g?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(E,P){return new $(this.buffer.subarray(E,P))}set(E,P){if(E instanceof $)this.buffer.set(E.buffer,P);else if(E instanceof Uint8Array)this.buffer.set(E,P);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),P);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,P){p(this.buffer,E,P)}readUInt32LE(E){return S(this.buffer,E)}writeUInt32LE(E,P){d(this.buffer,E,P)}readUInt8(E){return f(this.buffer,E)}writeUInt8(E,P){o(this.buffer,E,P)}indexOf(E,P=0){return y(this.buffer,E instanceof $?E.buffer:E,P)}}e.$je=$;function y(w,E,P=0){const N=E.byteLength,z=w.byteLength;if(N===0)return 0;if(N===1)return w.indexOf(E[0]);if(N>z-P)return-1;const F=I.value;F.fill(E.length);for(let U=0;U<E.length;U++)F[E[U]]=E.length-U-1;let j=P+E.length-1,M=j,O=-1;for(;j<z;)if(w[j]===E[M]){if(M===0){O=j;break}j--,M--}else j+=Math.max(E.length-M,F[w[j]]),M=E.length-1;return O}e.$ke=y;function L(w,E){return w[E+0]<<0>>>0|w[E+1]<<8>>>0}e.$le=L;function C(w,E,P){w[P+0]=E&255,E=E>>>8,w[P+1]=E&255}e.$me=C;function m(w,E){return w[E]*2**24+w[E+1]*2**16+w[E+2]*2**8+w[E+3]}e.$ne=m;function p(w,E,P){w[P+3]=E,E=E>>>8,w[P+2]=E,E=E>>>8,w[P+1]=E,E=E>>>8,w[P]=E}e.$oe=p;function S(w,E){return w[E+0]<<0>>>0|w[E+1]<<8>>>0|w[E+2]<<16>>>0|w[E+3]<<24>>>0}e.$pe=S;function d(w,E,P){w[P+0]=E&255,E=E>>>8,w[P+1]=E&255,E=E>>>8,w[P+2]=E&255,E=E>>>8,w[P+3]=E&255}e.$qe=d;function f(w,E){return w[E]}e.$re=f;function o(w,E,P){w[P]=E}e.$se=o;function i(w){return T.$$d(w,E=>$.concat(E))}e.$te=i;function s(w){return T.$fe(w)}e.$ue=s;function n(w){return T.$ae(w,E=>$.concat(E))}e.$ve=n;async function c(w){return w.ended?$.concat(w.buffer):$.concat([...w.buffer,await n(w.stream)])}e.$we=c;function t(w){return T.$de(w,E=>$.concat(E))}e.$xe=t;function a(w){return T.$ge(w,{data:E=>typeof E=="string"?$.fromString(E):$.wrap(E)},E=>$.concat(E))}e.$ye=a;function r(w){return T.$0d(E=>$.concat(E),w)}e.$ze=r;function h(w,E){return T.$he(w,E,P=>$.concat(P))}e.$Ae=h;function u(w,E){return T.$ie(w,E,P=>$.concat(P))}e.$Be=u;function l(w){let E=0,P=0,N=0;const z=new Uint8Array(Math.floor(w.length/4*3)),F=M=>{switch(P){case 3:z[N++]=E|M,P=0;break;case 2:z[N++]=E|M>>>2,E=M<<6,P=3;break;case 1:z[N++]=E|M>>>4,E=M<<4,P=2;break;default:E=M<<2,P=1}};for(let M=0;M<w.length;M++){const O=w.charCodeAt(M);if(O>=65&&O<=90)F(O-65);else if(O>=97&&O<=122)F(O-97+26);else if(O>=48&&O<=57)F(O-48+52);else if(O===43||O===45)F(62);else if(O===47||O===95)F(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${w[M]}`)}}const j=N;for(;P>0;)F(0);return $.wrap(z).slice(0,j)}e.$Ce=l;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:w},E=!0,P=!1){const N=P?A:k;let z="";const F=w.byteLength%3;let j=0;for(;j<w.byteLength-F;j+=3){const M=w[j+0],O=w[j+1],U=w[j+2];z+=N[M>>>2],z+=N[(M<<4|O>>>4)&63],z+=N[(O<<2|U>>>6)&63],z+=N[U&63]}if(F===1){const M=w[j+0];z+=N[M>>>2],z+=N[M<<4&63],E&&(z+="==")}else if(F===2){const M=w[j+0],O=w[j+1];z+=N[M>>>2],z+=N[(M<<4|O>>>4)&63],z+=N[O<<2&63],E&&(z+="=")}return z}e.$De=v}),define(ke[12],Se([1,0,162,43]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.GraphemeBreakType=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=void 0;function g(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Je=g;const I=/{(\d+)}/g;function R(Ae,...ze){return ze.length===0?Ae:Ae.replace(I,function(Re,Ye){const re=parseInt(Ye,10);return isNaN(re)||re<0||re>=ze.length?Re:ze[re]})}e.$Ke=R;const b=/{([^}]+)}/g;function $(Ae,ze){return Object.keys(ze).length===0?Ae:Ae.replace(b,(Re,Ye)=>ze[Ye]??Re)}e.$Le=$;function y(Ae){return Ae.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}e.$Me=y;function L(Ae){return Ae.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}e.$Ne=L;function C(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Oe=C;function m(Ae,ze){let Re=0;const Ye=ze.charCodeAt(0);for(let re=Ae.length-1;re>=0;re--)Ae.charCodeAt(re)===Ye&&Re++;return Re}e.$Pe=m;function p(Ae,ze,Re="\u2026"){return Ae.length<=ze?Ae:`${Ae.substr(0,ze)}${Re}`}e.$Qe=p;function S(Ae,ze,Re="\u2026"){if(Ae.length<=ze)return Ae;const Ye=Math.ceil(ze/2)-Re.length/2,re=Math.floor(ze/2)-Re.length/2;return`${Ae.substr(0,Ye)}${Re}${Ae.substr(Ae.length-re)}`}e.$Re=S;function d(Ae,ze=" "){const Re=f(Ae,ze);return o(Re,ze)}e.$Se=d;function f(Ae,ze){if(!Ae||!ze)return Ae;const Re=ze.length;if(Re===0||Ae.length===0)return Ae;let Ye=0;for(;Ae.indexOf(ze,Ye)===Ye;)Ye=Ye+Re;return Ae.substring(Ye)}e.$Te=f;function o(Ae,ze){if(!Ae||!ze)return Ae;const Re=ze.length,Ye=Ae.length;if(Re===0||Ye===0)return Ae;let re=Ye,se=-1;for(;se=Ae.lastIndexOf(ze,re-1),!(se===-1||se+Re!==re);){if(se===0)return"";re=se}return Ae.substring(0,re)}e.$Ue=o;function i(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ve=i;function s(Ae){return Ae.replace(/\*/g,"")}e.$We=s;function n(Ae,ze,Re={}){if(!Ae)throw new Error("Cannot create regex from empty string");ze||(Ae=C(Ae)),Re.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Ye="";return Re.global&&(Ye+="g"),Re.matchCase||(Ye+="i"),Re.multiline&&(Ye+="m"),Re.unicode&&(Ye+="u"),new RegExp(Ae,Ye)}e.$Xe=n;function c(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Ye=c;function t(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Ze=t;function a(Ae){for(let ze=0,Re=Ae.length;ze<Re;ze++){const Ye=Ae.charCodeAt(ze);if(Ye!==32&&Ye!==9)return ze}return-1}e.$1e=a;function r(Ae,ze=0,Re=Ae.length){for(let Ye=ze;Ye<Re;Ye++){const re=Ae.charCodeAt(Ye);if(re!==32&&re!==9)return Ae.substring(ze,Ye)}return Ae.substring(ze,Re)}e.$2e=r;function h(Ae,ze=Ae.length-1){for(let Re=ze;Re>=0;Re--){const Ye=Ae.charCodeAt(Re);if(Ye!==32&&Ye!==9)return Re}return-1}e.$3e=h;function u(Ae,ze,Re){const Ye=[];let re=0;for(const se of Ae.matchAll(ze)){if(Ye.push(Ae.slice(re,se.index)),se.index===void 0)throw new Error("match.index should be defined");re=se.index+se[0].length,Ye.push(Re(se[0],...se.slice(1),se.index,Ae,se.groups))}return Ye.push(Ae.slice(re)),Promise.all(Ye).then(se=>se.join(""))}e.$4e=u;function l(Ae,ze){return Ae<ze?-1:Ae>ze?1:0}e.$5e=l;function k(Ae,ze,Re=0,Ye=Ae.length,re=0,se=ze.length){for(;Re<Ye&&re<se;Re++,re++){const Xe=Ae.charCodeAt(Re),it=ze.charCodeAt(re);if(Xe<it)return-1;if(Xe>it)return 1}const Ie=Ye-Re,qe=se-re;return Ie<qe?-1:Ie>qe?1:0}e.$6e=k;function A(Ae,ze){return v(Ae,ze,0,Ae.length,0,ze.length)}e.$7e=A;function v(Ae,ze,Re=0,Ye=Ae.length,re=0,se=ze.length){for(;Re<Ye&&re<se;Re++,re++){let Xe=Ae.charCodeAt(Re),it=ze.charCodeAt(re);if(Xe===it)continue;if(Xe>=128||it>=128)return k(Ae.toLowerCase(),ze.toLowerCase(),Re,Ye,re,se);E(Xe)&&(Xe-=32),E(it)&&(it-=32);const nt=Xe-it;if(nt!==0)return nt}const Ie=Ye-Re,qe=se-re;return Ie<qe?-1:Ie>qe?1:0}e.$8e=v;function w(Ae){return Ae>=48&&Ae<=57}e.$9e=w;function E(Ae){return Ae>=97&&Ae<=122}e.$0e=E;function P(Ae){return Ae>=65&&Ae<=90}e.$$e=P;function N(Ae,ze){return Ae.length===ze.length&&v(Ae,ze)===0}e.$_e=N;function z(Ae,ze){const Re=ze.length;return ze.length>Ae.length?!1:v(Ae,ze,0,Re)===0}e.$af=z;function F(Ae,ze){const Re=Math.min(Ae.length,ze.length);let Ye;for(Ye=0;Ye<Re;Ye++)if(Ae.charCodeAt(Ye)!==ze.charCodeAt(Ye))return Ye;return Re}e.$bf=F;function j(Ae,ze){const Re=Math.min(Ae.length,ze.length);let Ye;const re=Ae.length-1,se=ze.length-1;for(Ye=0;Ye<Re;Ye++)if(Ae.charCodeAt(re-Ye)!==ze.charCodeAt(se-Ye))return Ye;return Re}e.$cf=j;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$df=M;function O(Ae){return 56320<=Ae&&Ae<=57343}e.$ef=O;function U(Ae,ze){return(Ae-55296<<10)+(ze-56320)+65536}e.$ff=U;function Q(Ae,ze,Re){const Ye=Ae.charCodeAt(Re);if(M(Ye)&&Re+1<ze){const re=Ae.charCodeAt(Re+1);if(O(re))return U(Ye,re)}return Ye}e.$gf=Q;function ue(Ae,ze){const Re=Ae.charCodeAt(ze-1);if(O(Re)&&ze>1){const Ye=Ae.charCodeAt(ze-2);if(M(Ye))return U(Ye,Re)}return Re}class Z{get offset(){return this.e}constructor(ze,Re=0){this.c=ze,this.d=ze.length,this.e=Re}setOffset(ze){this.e=ze}prevCodePoint(){const ze=ue(this.c,this.e);return this.e-=ze>=65536?2:1,ze}nextCodePoint(){const ze=Q(this.c,this.d,this.e);return this.e+=ze>=65536?2:1,ze}eol(){return this.e>=this.d}}e.$hf=Z;class J{get offset(){return this.c.offset}constructor(ze,Re=0){this.c=new Z(ze,Re)}nextGraphemeLength(){const ze=Le.getInstance(),Re=this.c,Ye=Re.offset;let re=ze.getGraphemeBreakType(Re.nextCodePoint());for(;!Re.eol();){const se=Re.offset,Ie=ze.getGraphemeBreakType(Re.nextCodePoint());if(oe(re,Ie)){Re.setOffset(se);break}re=Ie}return Re.offset-Ye}prevGraphemeLength(){const ze=Le.getInstance(),Re=this.c,Ye=Re.offset;let re=ze.getGraphemeBreakType(Re.prevCodePoint());for(;Re.offset>0;){const se=Re.offset,Ie=ze.getGraphemeBreakType(Re.prevCodePoint());if(oe(Ie,re)){Re.setOffset(se);break}re=Ie}return Ye-Re.offset}eol(){return this.c.eol()}}e.$if=J;function X(Ae,ze){return new J(Ae,ze).nextGraphemeLength()}e.$jf=X;function le(Ae,ze){return new J(Ae,ze).prevGraphemeLength()}e.$kf=le;function x(Ae,ze){ze>0&&O(Ae.charCodeAt(ze))&&ze--;const Re=ze+X(Ae,ze);return[Re-le(Ae,Re),Re]}e.$lf=x;function be(Ae){const ze=new J(Ae);let Re=0;for(;!ze.eol();)Re++,ze.nextGraphemeLength();return Re}e.$mf=be;let ce;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(Ae){return ce||(ce=G()),ce.test(Ae)}e.$nf=W;const ne=/^[\t\n\r\x20-\x7E]*$/;function ye(Ae){return ne.test(Ae)}e.$of=ye,e.$pf=/[\u2028\u2029]/;function de(Ae){return e.$pf.test(Ae)}e.$qf=de;function ge(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$rf=ge;function _(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$sf=_;function te(Ae,ze,Re=""){const Ye=Ae.trimStart();if(Ye.length<ze)return Ye;const re=/\b/g;let se=0;for(;re.test(Ye)&&!(Ye.length-re.lastIndex<ze);)se=re.lastIndex,re.lastIndex+=1;return se===0?Ye:Re+Ye.substring(se).trimStart()}e.$tf=te;const K=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function fe(Ae){return Ae&&(Ae=Ae.replace(K,"").replace(ie,"")),Ae}e.$uf=fe,e.$vf=String.fromCharCode(65279);function pe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$wf=pe;function Pe(Ae){return pe(Ae)?Ae.substr(1):Ae}e.$xf=Pe;function we(Ae,ze){if(!Ae||!ze||Ae.length<ze.length)return!1;const Re=ze.length,Ye=Ae.toLowerCase();let re=0,se=-1;for(;re<Re;){const Ie=Ye.indexOf(ze[re],se+1);if(Ie<0)return!1;se=Ie,re++}return!0}e.$yf=we;function Ce(Ae,ze=!1){return Ae?(ze&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$zf=Ce;function B(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$Af=B;function Y(Ae,ze=1){if(ze===0)return"";let Re=-1;do Re=Ae.indexOf(`
`,Re+1),ze--;while(ze>0&&Re>=0);return Re===-1?Ae:(Ae[Re-1]==="\r"&&Re--,Ae.substr(0,Re))}e.$Bf=Y;function ee(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$Cf=ee;function q(Ae){return Le.getInstance().getGraphemeBreakType(Ae)}e.$Df=q;function oe(Ae,ze){return Ae===0?ze!==5&&ze!==7:Ae===2&&ze===3?!1:Ae===4||Ae===2||Ae===3||ze===4||ze===2||ze===3?!0:!(Ae===8&&(ze===8||ze===9||ze===11||ze===12)||(Ae===11||Ae===9)&&(ze===9||ze===10)||(Ae===12||Ae===10)&&ze===10||ze===5||ze===13||ze===7||Ae===1||Ae===13&&ze===14||Ae===6&&ze===6)}var he;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class Le{static{this.c=null}static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=je()}getGraphemeBreakType(ze){if(ze<32)return ze===10?3:ze===13?2:4;if(ze<127)return 0;const Re=this.d,Ye=Re.length/3;let re=1;for(;re<=Ye;)if(ze<Re[3*re])re=2*re;else if(ze>Re[3*re+1])re=2*re+1;else return Re[3*re+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Ae,ze){if(Ae===0)return 0;const Re=Qe(Ae,ze);if(Re!==void 0)return Re;const Ye=new Z(ze,Ae);return Ye.prevCodePoint(),Ye.offset}e.$Ef=He;function Qe(Ae,ze){const Re=new Z(ze,Ae);let Ye=Re.prevCodePoint();for(;_e(Ye)||Ye===65039||Ye===8419;){if(Re.offset===0)return;Ye=Re.prevCodePoint()}if(!_(Ye))return;let re=Re.offset;return re>0&&Re.prevCodePoint()===8205&&(re=Re.offset),re}function _e(Ae){return 127995<=Ae&&Ae<=127999}var at;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.$Ff="\xA0";class st{static{this.c=new T.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Fe(ze=>{function Re(nt){const Oe=new Map;for(let yt=0;yt<nt.length;yt+=2)Oe.set(nt[yt],nt[yt+1]);return Oe}function Ye(nt,Oe){const yt=new Map(nt);for(const[Dt,Nt]of Oe)yt.set(Dt,Nt);return yt}function re(nt,Oe){if(!nt)return Oe;const yt=new Map;for(const[Dt,Nt]of nt)Oe.has(Dt)&&yt.set(Dt,Nt);return yt}const se=this.c.value;let Ie=ze.filter(nt=>!nt.startsWith("_")&&nt in se);Ie.length===0&&(Ie=["_default"]);let qe;for(const nt of Ie){const Oe=Re(se[nt]);qe=re(qe,Oe)}const Xe=Re(se._common),it=Ye(Xe,qe);return new st(it)})}static getInstance(ze){return st.d.get(Array.from(ze))}static{this.e=new T.$V(()=>Object.keys(st.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return st.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Gf=st;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(ze){return rt.e().has(ze)}static get codePoints(){return rt.e()}}e.$Hf=rt}),define(ke[123],Se([1,0,28,161,12]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=e.$6j=e.FuzzyScore=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.or=void 0;function I(...we){return function(Ce,B){for(let Y=0,ee=we.length;Y<ee;Y++){const q=we[Y](Ce,B);if(q)return q}return null}}e.or=I,e.$Tj=R.bind(void 0,!1),e.$Uj=R.bind(void 0,!0);function R(we,Ce,B){if(!B||B.length<Ce.length)return null;let Y;return we?Y=g.$af(B,Ce):Y=B.indexOf(Ce)===0,Y?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function b(we,Ce){const B=Ce.toLowerCase().indexOf(we.toLowerCase());return B===-1?null:[{start:B,end:B+we.length}]}e.$Vj=b;function $(we,Ce){return y(we.toLowerCase(),Ce.toLowerCase(),0,0)}e.$Wj=$;function y(we,Ce,B,Y){if(B===we.length)return[];if(Y===Ce.length)return null;if(we[B]===Ce[Y]){let ee=null;return(ee=y(we,Ce,B+1,Y+1))?n({start:Y,end:Y+1},ee):null}return y(we,Ce,B,Y+1)}function L(we){return 97<=we&&we<=122}function C(we){return 65<=we&&we<=90}e.$Xj=C;function m(we){return 48<=we&&we<=57}function p(we){return we===32||we===9||we===10||we===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(we=>S.add(we.charCodeAt(0)));function d(we){return p(we)||S.has(we)}function f(we,Ce){return we===Ce||d(we)&&d(Ce)}const o=new Map;function i(we){if(o.has(we))return o.get(we);let Ce;const B=(0,T.$Rj)(we);return B&&(Ce=B),o.set(we,Ce),Ce}function s(we){return L(we)||C(we)||m(we)}function n(we,Ce){return Ce.length===0?Ce=[we]:we.end===Ce[0].start?Ce[0].start=we.start:Ce.unshift(we),Ce}function c(we,Ce){for(let B=Ce;B<we.length;B++){const Y=we.charCodeAt(B);if(C(Y)||m(Y)||B>0&&!s(we.charCodeAt(B-1)))return B}return we.length}function t(we,Ce,B,Y){if(B===we.length)return[];if(Y===Ce.length)return null;if(we[B]!==Ce[Y].toLowerCase())return null;{let ee=null,q=Y+1;for(ee=t(we,Ce,B+1,Y+1);!ee&&(q=c(Ce,q))<Ce.length;)ee=t(we,Ce,B+1,q),q++;return ee===null?null:n({start:Y,end:Y+1},ee)}}function a(we){let Ce=0,B=0,Y=0,ee=0,q=0;for(let He=0;He<we.length;He++)q=we.charCodeAt(He),C(q)&&Ce++,L(q)&&B++,s(q)&&Y++,m(q)&&ee++;const oe=Ce/we.length,he=B/we.length,Le=Y/we.length,je=ee/we.length;return{upperPercent:oe,lowerPercent:he,alphaPercent:Le,numericPercent:je}}function r(we){const{upperPercent:Ce,lowerPercent:B}=we;return B===0&&Ce>.6}function h(we){const{upperPercent:Ce,lowerPercent:B,alphaPercent:Y,numericPercent:ee}=we;return B>.2&&Ce<.8&&Y>.6&&ee<.2}function u(we){let Ce=0,B=0,Y=0,ee=0;for(let q=0;q<we.length;q++)Y=we.charCodeAt(q),C(Y)&&Ce++,L(Y)&&B++,p(Y)&&ee++;return(Ce===0||B===0)&&ee===0?we.length<=30:Ce<=5}function l(we,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!u(we)||Ce.length>60)return null;const B=a(Ce);if(!h(B)){if(!r(B))return null;Ce=Ce.toLowerCase()}let Y=null,ee=0;for(we=we.toLowerCase();ee<Ce.length&&(Y=t(we,Ce,0,ee))===null;)ee=c(Ce,ee+1);return Y}e.$Yj=l;function k(we,Ce,B=!1){if(!Ce||Ce.length===0)return null;let Y=null,ee=0;for(we=we.toLowerCase(),Ce=Ce.toLowerCase();ee<Ce.length&&(Y=A(we,Ce,0,ee,B),Y===null);)ee=v(Ce,ee+1);return Y}e.$Zj=k;function A(we,Ce,B,Y,ee){let q=0;if(B===we.length)return[];if(Y===Ce.length)return null;if(!f(we.charCodeAt(B),Ce.charCodeAt(Y))){const Le=i(we.charCodeAt(B));if(!Le)return null;for(let je=0;je<Le.length;je++)if(!f(Le[je],Ce.charCodeAt(Y+je)))return null;q+=Le.length-1}let oe=null,he=Y+q+1;if(oe=A(we,Ce,B+1,he,ee),!ee)for(;!oe&&(he=v(Ce,he))<Ce.length;)oe=A(we,Ce,B+1,he,ee),he++;if(!oe)return null;if(we.charCodeAt(B)!==Ce.charCodeAt(Y)){const Le=i(we.charCodeAt(B));if(!Le)return oe;for(let je=0;je<Le.length;je++)if(Le[je]!==Ce.charCodeAt(Y+je))return oe}return n({start:Y,end:Y+q+1},oe)}function v(we,Ce){for(let B=Ce;B<we.length;B++)if(d(we.charCodeAt(B))||B>0&&d(we.charCodeAt(B-1)))return B;return we.length}const w=I(e.$Uj,l,b),E=I(e.$Uj,l,$),P=new D.$Dc(1e4);function N(we,Ce,B=!1){if(typeof we!="string"||typeof Ce!="string")return null;let Y=P.get(we);Y||(Y=new RegExp(g.$Ve(we),"i"),P.set(we,Y));const ee=Y.exec(Ce);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:B?E(we,Ce):w(we,Ce)}e.$1j=N;function z(we,Ce){const B=_(we,we.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?j(B):null}e.$2j=z;function F(we,Ce,B,Y,ee,q){const oe=Math.min(13,we.length);for(;B<oe;B++){const he=_(we,Ce,B,Y,ee,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(he)return he}return[0,q]}e.$3j=F;function j(we){if(typeof we>"u")return[];const Ce=[],B=we[1];for(let Y=we.length-1;Y>1;Y--){const ee=we[Y]+B,q=Ce[Ce.length-1];q&&q.end===ee?q.end=ee+1:Ce.push({start:ee,end:ee+1})}return Ce}e.$4j=j;const M=128;function O(){const we=[],Ce=[];for(let B=0;B<=M;B++)Ce[B]=0;for(let B=0;B<=M;B++)we.push(Ce.slice(0));return we}function U(we){const Ce=[];for(let B=0;B<=we;B++)Ce[B]=0;return Ce}const Q=U(2*M),ue=U(2*M),Z=O(),J=O(),X=O(),le=!1;function x(we,Ce,B,Y,ee){function q(he,Le,je=" "){for(;he.length<Le;)he=je+he;return he}let oe=` |   |${Y.split("").map(he=>q(he,3)).join("|")}
`;for(let he=0;he<=B;he++)he===0?oe+=" |":oe+=`${Ce[he-1]}|`,oe+=we[he].slice(0,ee+1).map(Le=>q(Le.toString(),3)).join("|")+`
`;return oe}function be(we,Ce,B,Y){we=we.substr(Ce),B=B.substr(Y),console.log(x(J,we,we.length,B,B.length)),console.log(x(X,we,we.length,B,B.length)),console.log(x(Z,we,we.length,B,B.length))}function ce(we,Ce){if(Ce<0||Ce>=we.length)return!1;const B=we.codePointAt(Ce);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!g.$sf(B)}}function G(we,Ce){if(Ce<0||Ce>=we.length)return!1;switch(we.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function W(we,Ce,B){return Ce[we]!==B[we]}function ne(we,Ce,B,Y,ee,q,oe=!1){for(;Ce<B&&ee<q;)we[Ce]===Y[ee]&&(oe&&(Q[Ce]=ee),Ce+=1),ee+=1;return Ce===B}e.$5j=ne;var ye;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var de;(function(we){we.Default=[-100,0];function Ce(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}we.isDefault=Ce})(de||(e.FuzzyScore=de={}));class ge{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,B){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=B}}e.$6j=ge;function _(we,Ce,B,Y,ee,q,oe=ge.default){const he=we.length>M?M:we.length,Le=Y.length>M?M:Y.length;if(B>=he||q>=Le||he-B>Le-q||!ne(Ce,B,he,ee,q,Le,!0))return;te(he,Le,B,q,Ce,ee);let je=1,He=1,Qe=B,_e=q;const at=[!1];for(je=1,Qe=B;Qe<he;je++,Qe++){const Re=Q[Qe],Ye=ue[Qe],re=Qe+1<he?ue[Qe+1]:Le;for(He=Re-q+1,_e=Re;_e<re;He++,_e++){let se=Number.MIN_SAFE_INTEGER,Ie=!1;_e<=Ye&&(se=K(we,Ce,Qe,B,Y,ee,_e,Le,q,Z[je-1][He-1]===0,at));let qe=0;se!==Number.MAX_SAFE_INTEGER&&(Ie=!0,qe=se+J[je-1][He-1]);const Xe=_e>Re,it=Xe?J[je][He-1]+(Z[je][He-1]>0?-5:0):0,nt=_e>Re+1&&Z[je][He-1]>0,Oe=nt?J[je][He-2]+(Z[je][He-2]>0?-5:0):0;if(nt&&(!Xe||Oe>=it)&&(!Ie||Oe>=qe))J[je][He]=Oe,X[je][He]=3,Z[je][He]=0;else if(Xe&&(!Ie||it>=qe))J[je][He]=it,X[je][He]=2,Z[je][He]=0;else if(Ie)J[je][He]=qe,X[je][He]=1,Z[je][He]=Z[je-1][He-1]+1;else throw new Error("not possible")}}if(le&&be(we,B,Y,q),!at[0]&&!oe.firstMatchCanBeWeak)return;je--,He--;const st=[J[je][He],q];let rt=0,Ae=0;for(;je>=1;){let Re=He;do{const Ye=X[je][Re];if(Ye===3)Re=Re-2;else if(Ye===2)Re=Re-1;else break}while(Re>=1);rt>1&&Ce[B+je-1]===ee[q+He-1]&&!W(Re+q-1,Y,ee)&&rt+1>Z[je][Re]&&(Re=He),Re===He?rt++:rt=1,Ae||(Ae=Re),je--,He=Re-1,st.push(He)}Le===he&&oe.boostFullMatch&&(st[0]+=2);const ze=Ae-he;return st[0]-=ze,st}e.$7j=_;function te(we,Ce,B,Y,ee,q){let oe=we-1,he=Ce-1;for(;oe>=B&&he>=Y;)ee[oe]===q[he]&&(ue[oe]=he,oe--),he--}function K(we,Ce,B,Y,ee,q,oe,he,Le,je,He){if(Ce[B]!==q[oe])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return oe===B-Y?Qe=we[B]===ee[oe]?7:5:W(oe,ee,q)&&(oe===0||!W(oe-1,ee,q))?(Qe=we[B]===ee[oe]?7:5,_e=!0):ce(q,oe)&&(oe===0||!ce(q,oe-1))?Qe=5:(ce(q,oe-1)||G(q,oe-1))&&(Qe=5,_e=!0),Qe>1&&B===Y&&(He[0]=!0),_e||(_e=W(oe,ee,q)||ce(q,oe-1)||G(q,oe-1)),B===Y?oe>Le&&(Qe-=_e?3:5):je?Qe+=_e?2:0:Qe+=_e?0:1,oe+1===he&&(Qe-=_e?3:5),Qe}function ie(we,Ce,B,Y,ee,q,oe){return pe(we,Ce,B,Y,ee,q,!0,oe)}e.$8j=ie;function fe(we,Ce,B,Y,ee,q,oe){return pe(we,Ce,B,Y,ee,q,!1,oe)}e.$9j=fe;function pe(we,Ce,B,Y,ee,q,oe,he){let Le=_(we,Ce,B,Y,ee,q,he);if(Le&&!oe)return Le;if(we.length>=3){const je=Math.min(7,we.length-1);for(let He=B+1;He<je;He++){const Qe=Pe(we,He);if(Qe){const _e=_(Qe,Qe.toLowerCase(),B,Y,ee,q,he);_e&&(_e[0]-=3,(!Le||_e[0]>Le[0])&&(Le=_e))}}}return Le}function Pe(we,Ce){if(Ce+1>=we.length)return;const B=we[Ce],Y=we[Ce+1];if(B!==Y)return we.slice(0,Ce)+Y+B+we.slice(Ce+2)}}),define(ke[54],Se([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=void 0;function T(o){return g(o,0)}e.$Ti=T;function g(o,i){switch(typeof o){case"object":return o===null?I(349,i):Array.isArray(o)?$(o,i):y(o,i);case"string":return b(o,i);case"boolean":return R(o,i);case"number":return I(o,i);case"undefined":return I(937,i);default:return I(617,i)}}e.$Ui=g;function I(o,i){return(i<<5)-i+o|0}e.$Vi=I;function R(o,i){return I(o?433:863,i)}function b(o,i){i=I(149417,i);for(let s=0,n=o.length;s<n;s++)i=I(o.charCodeAt(s),i);return i}e.$Wi=b;function $(o,i){return i=I(104579,i),o.reduce((s,n)=>g(n,s),i)}function y(o,i){return i=I(181387,i),Object.keys(o).sort().reduce((s,n)=>(s=b(n,s),g(o[n],s)),i)}class L{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=g(i,this.g),this.g}}e.$Xi=L;var C;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(o,i,s=32){const n=s-i,c=~((1<<n)-1);return(o<<i|(c&o)>>>n)>>>0}function p(o,i=0,s=o.byteLength,n=0){for(let c=0;c<s;c++)o[i+c]=n}function S(o,i,s="0"){for(;o.length<i;)o=s+o;return o}function d(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(s=>s.toString(16).padStart(2,"0")).join(""):S((o>>>0).toString(16),i/4)}e.$Yi=d;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const s=i.length;if(s===0)return;const n=this.p;let c=this.r,t=this.u,a,r;for(t!==0?(a=t,r=-1,t=0):(a=i.charCodeAt(0),r=0);;){let h=a;if(D.$df(a))if(r+1<s){const u=i.charCodeAt(r+1);D.$ef(u)?(r++,h=D.$ff(a,u)):h=65533}else{t=a;break}else D.$ef(a)&&(h=65533);if(c=this.w(n,c,h),r++,r<s)a=i.charCodeAt(r);else break}this.r=c,this.u=t}w(i,s,n){return n<128?i[s++]=n:n<2048?(i[s++]=192|(n&1984)>>>6,i[s++]=128|(n&63)>>>0):n<65536?(i[s++]=224|(n&61440)>>>12,i[s++]=128|(n&4032)>>>6,i[s++]=128|(n&63)>>>0):(i[s++]=240|(n&1835008)>>>18,i[s++]=128|(n&258048)>>>12,i[s++]=128|(n&4032)>>>6,i[s++]=128|(n&63)>>>0),s>=64&&(this.y(),s-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),s}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=f.g,s=this.q;for(let k=0;k<64;k+=4)i.setUint32(k,s.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)i.setUint32(k,m(i.getUint32(k-12,!1)^i.getUint32(k-32,!1)^i.getUint32(k-56,!1)^i.getUint32(k-64,!1),1),!1);let n=this.h,c=this.l,t=this.m,a=this.n,r=this.o,h,u,l;for(let k=0;k<80;k++)k<20?(h=c&t|~c&a,u=1518500249):k<40?(h=c^t^a,u=1859775393):k<60?(h=c&t|c&a|t&a,u=2400959708):(h=c^t^a,u=3395469782),l=m(n,5)+h+r+u+i.getUint32(k*4,!1)&4294967295,r=a,a=t,t=m(c,30),c=n,n=l;this.h=this.h+n&4294967295,this.l=this.l+c&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+r&4294967295}}e.$Zi=f}),define(ke[39],Se([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(T||(T={})),function(g){const I="error",R="warning",b="warn",$="info",y="ignore";function L(m){return m?D.$_e(I,m)?g.Error:D.$_e(R,m)||D.$_e(b,m)?g.Warning:D.$_e($,m)?g.Info:g.Ignore:g.Ignore}g.fromValue=L;function C(m){switch(m){case g.Error:return I;case g.Warning:return R;case g.Info:return $;default:return y}}g.toString=C}(T||(T={})),e.default=T}),define(ke[163],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,12]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class g{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const S=p.charCodeAt(0),d=this.b.charCodeAt(this.c);return S-d}value(){return this.b[this.c]}}e.$8h=g;class I{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.$6e)(p,this.b,0,p.length,this.c,this.d):(0,T.$8e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$9h=I;class R{constructor(p=!0,S=!0){this.f=p,this.g=S}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let S=p.length-1;S>=0;S--,this.c--){const d=this.b.charCodeAt(S);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.$6e)(p,this.b,0,p.length,this.d,this.e):(0,T.$8e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$0h=R;var b;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(p,S){this.f=p,this.g=S,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.$7e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.$7e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.$5e)(p,this.c.query);if(this.d[this.e]===5)return(0,T.$5e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$$h=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(L||(L={}));class C{static forUris(p=()=>!1,S=()=>!1){return new C(new $(p,S))}static forPaths(p=!1){return new C(new R(void 0,!p))}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new I)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,S){if(S){const d=S.slice(0);(0,D.$Xb)(d);for(const f of d)this.set(f,p)}else{const d=p.slice(0);(0,D.$Xb)(d);for(const f of d)this.set(f[0],f[1])}}set(p,S){const d=this.b.reset(p);let f;this.c||(this.c=new y,this.c.segment=d.value());const o=[];for(f=this.c;;){const s=d.cmp(f.segment);if(s>0)f.left||(f.left=new y,f.left.segment=d.value()),o.push([-1,f]),f=f.left;else if(s<0)f.right||(f.right=new y,f.right.segment=d.value()),o.push([1,f]),f=f.right;else if(d.hasNext())d.next(),f.mid||(f.mid=new y,f.mid.segment=d.value()),o.push([0,f]),f=f.mid;else break}const i=f.value;f.value=S,f.key=p;for(let s=o.length-1;s>=0;s--){const n=o[s][1];n.updateHeight();const c=n.balanceFactor();if(c<-1||c>1){const t=o[s][0],a=o[s+1][0];if(t===1&&a===1)o[s][1]=n.rotateLeft();else if(t===-1&&a===-1)o[s][1]=n.rotateRight();else if(t===1&&a===-1)n.right=o[s+1][1]=o[s+1][1].rotateRight(),o[s][1]=n.rotateLeft();else if(t===-1&&a===1)n.left=o[s+1][1]=o[s+1][1].rotateLeft(),o[s][1]=n.rotateRight();else throw new Error;if(s>0)switch(o[s-1][0]){case-1:o[s-1][1].left=o[s][1];break;case 1:o[s-1][1].right=o[s][1];break;case 0:o[s-1][1].mid=o[s][1];break}else this.c=o[0][1]}}return i}get(p){return this.d(p)?.value}d(p){const S=this.b.reset(p);let d=this.c;for(;d;){const f=S.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(S.hasNext())S.next(),d=d.mid;else break}return d}has(p){const S=this.d(p);return!(S?.value===void 0&&S?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,S){const d=this.b.reset(p),f=[];let o=this.c;for(;o;){const i=d.cmp(o.segment);if(i>0)f.push([-1,o]),o=o.left;else if(i<0)f.push([1,o]),o=o.right;else if(d.hasNext())d.next(),f.push([0,o]),o=o.mid;else break}if(o){if(S?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:s,value:n,segment:c}=i;this.e(i.key,!1),o.key=s,o.value=n,o.segment=c}}else{const i=o.left??o.right;if(f.length>0){const[s,n]=f[f.length-1];switch(s){case-1:n.left=i;break;case 0:n.mid=i;break;case 1:n.right=i;break}}else this.c=i}for(let i=f.length-1;i>=0;i--){const s=f[i][1];s.updateHeight();const n=s.balanceFactor();if(n>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),f[i][1]=s.rotateLeft()):n<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),f[i][1]=s.rotateRight()),i>0)switch(f[i-1][0]){case-1:f[i-1][1].left=f[i][1];break;case 1:f[i-1][1].right=f[i][1];break;case 0:f[i-1][1].mid=f[i][1];break}else this.c=f[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const S=this.b.reset(p);let d=this.c,f;for(;d;){const o=S.cmp(d.segment);if(o>0)d=d.left;else if(o<0)d=d.right;else if(S.hasNext())S.next(),f=d.value||f,d=d.mid;else break}return d&&d.value||f}findSuperstr(p){return this.g(p,!1)}g(p,S){const d=this.b.reset(p);let f=this.c;for(;f;){const o=d.cmp(f.segment);if(o>0)f=f.left;else if(o<0)f=f.right;else if(d.hasNext())d.next(),f=f.mid;else return f.mid?this.h(f.mid):S?f.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[S,d]of this)p(d,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const S=[];return this.j(p,S),S[Symbol.iterator]()}j(p,S){p&&(p.left&&this.j(p.left,S),p.value&&S.push([p.key,p.value]),p.mid&&this.j(p.mid,S),p.right&&this.j(p.right,S))}_isBalanced(){const p=S=>{if(!S)return!0;const d=S.balanceFactor();return d<-1||d>1?!1:p(S.left)&&p(S.right)};return p(this.c)}}e.$_h=C}),define(ke[18],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=void 0;function D(c){return typeof c=="string"}e.$If=D;function T(c){return Array.isArray(c)&&c.every(t=>D(t))}e.$Jf=T;function g(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Kf=g;function I(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.$Lf=I;function R(c){return typeof c=="number"&&!isNaN(c)}e.$Mf=R;function b(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Nf=b;function $(c){return c===!0||c===!1}e.$Of=$;function y(c){return typeof c>"u"}e.$Pf=y;function L(c){return!C(c)}e.$Qf=L;function C(c){return y(c)||c===null}e.$Rf=C;function m(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Sf=m;function p(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Tf=p;function S(...c){const t=[];for(let a=0;a<c.length;a++){const r=c[a];if(C(r))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);t.push(r)}return t}e.$Uf=S;const d=Object.prototype.hasOwnProperty;function f(c){if(!g(c))return!1;for(const t in c)if(d.call(c,t))return!1;return!0}e.$Vf=f;function o(c){return typeof c=="function"}e.$Wf=o;function i(...c){return c.length>0&&c.every(o)}e.$Xf=i;function s(c,t){const a=Math.min(c.length,t.length);for(let r=0;r<a;r++)n(c[r],t[r])}e.$Yf=s;function n(c,t){if(D(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(c instanceof t)return}catch{}if(!C(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Zf=n}),define(ke[78],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=e.$0j=void 0;const T=Object.create(null);function g(b,$){if((0,D.$If)($)){const y=T[$];if(y===void 0)throw new Error(`${b} references an unknown codicon: ${$}`);$=y}return T[b]=$,{id:b}}function I(){return T}e.$0j=I;function R(){return Object.values(e.$_j)}e.$$j=R,e.$_j={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugBreakpointPending:g("debug-breakpoint-pending",60377),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),thumbsDownFilled:g("thumbsdown-filled",60435),thumbsUpFilled:g("thumbsup-filled",60436),coffee:g("coffee",60437),snake:g("snake",60438),game:g("game",60439),vr:g("vr",60440),chip:g("chip",60441),piano:g("piano",60442),music:g("music",60443),micFilled:g("mic-filled",60444),gitFetch:g("git-fetch",60445),copilot:g("copilot",60446),lightbulbSparkle:g("lightbulb-sparkle",60447),lightbulbSparkleAutofix:g("lightbulb-sparkle-autofix",60447),robot:g("robot",60448),sparkleFilled:g("sparkle-filled",60449),diffSingle:g("diff-single",60450),diffMultiple:g("diff-multiple",60451),surroundWith:g("surround-with",60452),gitStash:g("git-stash",60454),gitStashApply:g("git-stash-apply",60455),gitStashPop:g("git-stash-pop",60456),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=void 0;function T(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([s,n])=>{i[s]=n&&typeof n=="object"?T(n):n}),i}e.$vn=T;function g(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const s=i.shift();Object.freeze(s);for(const n in s)if(I.call(s,n)){const c=s[n];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.$Lf)(c)&&i.push(c)}}return o}e.$wn=g;const I=Object.prototype.hasOwnProperty;function R(o,i){return b(o,i,new Set)}e.$xn=R;function b(o,i,s){if((0,D.$Rf)(o))return o;const n=i(o);if(typeof n<"u")return n;if(Array.isArray(o)){const c=[];for(const t of o)c.push(b(t,i,s));return c}if((0,D.$Kf)(o)){if(s.has(o))throw new Error("Cannot clone recursive data-structure");s.add(o);const c={};for(const t in o)I.call(o,t)&&(c[t]=b(o[t],i,s));return s.delete(o),c}return o}function $(o,i,s=!0){return(0,D.$Kf)(o)?((0,D.$Kf)(i)&&Object.keys(i).forEach(n=>{n in o?s&&((0,D.$Kf)(o[n])&&(0,D.$Kf)(i[n])?$(o[n],i[n],s):o[n]=i[n]):o[n]=i[n]}),o):i}e.$yn=$;function y(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let s,n;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(s=0;s<o.length;s++)if(!y(o[s],i[s]))return!1}else{const c=[];for(n in o)c.push(n);c.sort();const t=[];for(n in i)t.push(n);if(t.sort(),!y(c,t))return!1;for(s=0;s<c.length;s++)if(!y(o[c[s]],i[c[s]]))return!1}return!0}e.$zn=y;function L(o){const i=new Set;return JSON.stringify(o,(s,n)=>{if((0,D.$Kf)(n)||Array.isArray(n)){if(i.has(n))return"[Circular]";i.add(n)}return n})}e.$An=L;function C(o,i){const s=Object.create(null);return!o||!i||Object.keys(i).forEach(c=>{const t=o[c],a=i[c];y(t,a)||(s[c]=a)}),s}e.$Bn=C;function m(o,i){const s=i.toLowerCase(),n=Object.keys(o).find(c=>c.toLowerCase()===s);return n?o[n]:o[i]}e.$Cn=m;function p(o,i){const s=Object.create(null);for(const[n,c]of Object.entries(o))i(n,c)&&(s[n]=c);return s}e.$Dn=p;function S(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$En=S;function d(o){const i=[];for(const s of S(o))typeof o[s]=="function"&&i.push(s);return i}e.$Fn=d;function f(o,i){const s=c=>function(){const t=Array.prototype.slice.call(arguments,0);return i(c,t)},n={};for(const c of o)n[c]=s(c);return n}e.$Gn=f}),define(ke[61],Se([1,0,78]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ak=e.ThemeColor=void 0;var T;(function(R){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=b})(T||(e.ThemeColor=T={}));function g(R){return{id:R}}e.$ak=g;var I;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(i){const s=b.exec(i.id);if(!s)return $(D.$_j.error);const[,n,c]=s,t=["codicon","codicon-"+n];return c&&t.push("codicon-modifier-"+c.substring(1)),t}R.asClassNameArray=$;function y(i){return $(i).join(" ")}R.asClassName=y;function L(i){return"."+$(i).join(".")}R.asCSSSelector=L;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||T.isThemeColor(i.color))}R.isThemeIcon=C;const m=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function p(i){const s=m.exec(i);if(!s)return;const[,n]=s;return{id:n}}R.fromString=p;function S(i){return{id:i}}R.fromId=S;function d(i,s){let n=i.id;const c=n.lastIndexOf("~");return c!==-1&&(n=n.substring(0,c)),s&&(n=`${n}~${s}`),{id:n}}R.modify=d;function f(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}R.getModifier=f;function o(i,s){return i.id===s.id&&i.color?.id===s.color?.id}R.isEqual=o})(I||(e.ThemeIcon=I={}))}),define(ke[164],Se([1,0,123,12,61]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=void 0;const I="$(",R=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${R.source}`,"g");function $(o){return o.replace(b,(i,s)=>s?i:`\\${i}`)}e.$bk=$;const y=new RegExp(`\\\\${R.source}`,"g");function L(o){return o.replace(y,i=>`\\${i}`)}e.$ck=L;const C=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function m(o){return o.indexOf(I)===-1?o:o.replace(C,(i,s,n,c)=>n?i:s||c||"")}e.$dk=m;function p(o){return o?o.replace(/\$\((.*?)\)/g,(i,s)=>` ${s} `).trim():""}e.$ek=p;const S=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(o){S.lastIndex=0;let i="";const s=[];let n=0;for(;;){const c=S.lastIndex,t=S.exec(o),a=o.substring(c,t?.index);if(a.length>0){i+=a;for(let r=0;r<a.length;r++)s.push(n)}if(!t)break;n+=t[0].length}return{text:i,iconOffsets:s}}e.$fk=d;function f(o,i,s=!1){const{text:n,iconOffsets:c}=i;if(!c||c.length===0)return(0,D.$1j)(o,n,s);const t=(0,T.$Te)(n," "),a=n.length-t.length,r=(0,D.$1j)(o,t,s);if(r)for(const h of r){const u=c[h.start+a]+a;h.start+=u,h.end+=u}return r}e.$gk=f}),define(ke[124],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ie=e.$He=e.Constants=void 0;var D;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function T(I){return I<0?0:I>255?255:I|0}e.$He=T;function g(I){return I<0?0:I>4294967295?4294967295:I|0}e.$Ie=g}),define(ke[30],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(g){return D.test(g)}e.$pg=T,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const I=new Uint8Array(16),R=[];for(let b=0;b<256;b++)R.push(b.toString(16).padStart(2,"0"));return function(){g(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let $=0,y="";return y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y}}()}),define(ke[165],Se([1,0,19,53,30]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.$pt=e.$ot=e.$nt=void 0;function I(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$nt=I;function R(C,m,p){const S={id:(0,g.$qg)(),name:C,uri:m,data:p};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$ot=R;class b{constructor(){this.a=new Map}get size(){let m=0;for(const p of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const p=[...this.a.keys()];return T.Iterable.some(this,([S,d])=>d.asFile())&&p.push("files"),L($(m),p)}get(m){return this.a.get(this.b(m))?.[0]}append(m,p){const S=this.a.get(m);S?S.push(p):this.a.set(this.b(m),[p])}replace(m,p){this.a.set(this.b(m),[p])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,p]of this.a)for(const S of p)yield[m,S]}b(m){return $(m)}}e.$pt=b;function $(C){return C.toLowerCase()}function y(C,m){return L($(C),m.map($))}e.$qt=y;function L(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const p=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[S,d,f]=p;return f==="*"?m.some(o=>o.startsWith(d+"/")):!1}e.$rt=Object.freeze({create:C=>(0,D.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$rt.split(C).filter(m=>!m.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=e.$tg=e.$sg=void 0;function T(b,$,y,L=1){let C=!1;return new Promise(m=>{const p=setTimeout(()=>{if(!C)return C=!0,m(0)},y);g(b,$,L,S=>{if(!C)return C=!0,clearTimeout(p),m(S)})})}e.$sg=T;function g(b,$,y,L){if($===0)return L(0);const C=new D.Socket;C.once("connect",()=>(R(C),g(b+y,$-1,y,L))),C.once("data",()=>{}),C.once("error",m=>(R(C),m.code!=="ECONNREFUSED"?g(b+y,$-1,y,L):L(b))),C.connect(b,"127.0.0.1")}e.$tg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(b,$,y,L="127.0.0.1"){let C=!1,m,p=1;const S=D.createServer({pauseOnConnect:!0});function d(f,o){C||(C=!0,S.removeAllListeners(),S.close(),m&&clearTimeout(m),o(f))}return new Promise(f=>{m=setTimeout(()=>{d(0,f)},y),S.on("listening",()=>{d(b,f)}),S.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&p<$?(b++,p++,S.listen(b,L)):d(0,f)}),S.on("close",()=>{d(0,f)}),S.listen(b,L)})}e.$ug=I;function R(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(ke[125],Se([1,0,124]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;class T{constructor(b){const $=(0,D.$He)(b);this.c=$,this.a=T.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const y=(0,D.$He)($);b>=0&&b<256?this.a[b]=y:this.b.set(b,y)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ft=T;var g;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(g||(g={}));class I{constructor(){this.a=new T(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$gt=I}),define(ke[167],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.StringEOL=void 0;var D;(function(g){g[g.Unknown=0]="Unknown",g[g.Invalid=3]="Invalid",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function T(g){let I=0,R=0,b=0,$=0;for(let y=0,L=g.length;y<L;y++){const C=g.charCodeAt(y);C===13?(I===0&&(R=y),I++,y+1<L&&g.charCodeAt(y+1)===10?($|=2,y++):$|=3,b=y+1):C===10&&($|=1,I===0&&(R=y),I++,b=y+1)}return I===0&&(R=g.length),[I,R,g.length-b,$]}e.$ut=T}),define(ke[48],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class D{constructor(g,I){this.lineNumber=g,this.column=I}with(g=this.lineNumber,I=this.column){return g===this.lineNumber&&I===this.column?this:new D(g,I)}delta(g=0,I=0){return this.with(this.lineNumber+g,this.column+I)}equals(g){return D.equals(this,g)}static equals(g,I){return!g&&!I?!0:!!g&&!!I&&g.lineNumber===I.lineNumber&&g.column===I.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<I.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<=I.column}static compare(g,I){const R=g.lineNumber|0,b=I.lineNumber|0;if(R===b){const $=g.column|0,y=I.column|0;return $-y}return R-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Ts=D}),define(ke[29],Se([1,0,48]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class T{constructor(I,R,b,$){I>b||I===b&&R>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=I,this.endColumn=R):(this.startLineNumber=I,this.startColumn=R,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return T.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return T.containsPosition(this,I)}static containsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<I.startColumn||R.lineNumber===I.endLineNumber&&R.column>I.endColumn)}static strictContainsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<=I.startColumn||R.lineNumber===I.endLineNumber&&R.column>=I.endColumn)}containsRange(I){return T.containsRange(this,I)}static containsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>I.endColumn)}strictContainsRange(I){return T.strictContainsRange(this,I)}static strictContainsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<=I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>=I.endColumn)}plusRange(I){return T.plusRange(this,I)}static plusRange(I,R){let b,$,y,L;return R.startLineNumber<I.startLineNumber?(b=R.startLineNumber,$=R.startColumn):R.startLineNumber===I.startLineNumber?(b=R.startLineNumber,$=Math.min(R.startColumn,I.startColumn)):(b=I.startLineNumber,$=I.startColumn),R.endLineNumber>I.endLineNumber?(y=R.endLineNumber,L=R.endColumn):R.endLineNumber===I.endLineNumber?(y=R.endLineNumber,L=Math.max(R.endColumn,I.endColumn)):(y=I.endLineNumber,L=I.endColumn),new T(b,$,y,L)}intersectRanges(I){return T.intersectRanges(this,I)}static intersectRanges(I,R){let b=I.startLineNumber,$=I.startColumn,y=I.endLineNumber,L=I.endColumn;const C=R.startLineNumber,m=R.startColumn,p=R.endLineNumber,S=R.endColumn;return b<C?(b=C,$=m):b===C&&($=Math.max($,m)),y>p?(y=p,L=S):y===p&&(L=Math.min(L,S)),b>y||b===y&&$>L?null:new T(b,$,y,L)}equalsRange(I){return T.equalsRange(this,I)}static equalsRange(I,R){return!I&&!R?!0:!!I&&!!R&&I.startLineNumber===R.startLineNumber&&I.startColumn===R.startColumn&&I.endLineNumber===R.endLineNumber&&I.endColumn===R.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(I){return new D.$Ts(I.endLineNumber,I.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(I){return new D.$Ts(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,R){return new T(this.startLineNumber,this.startColumn,I,R)}setStartPosition(I,R){return new T(I,R,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(I){return new T(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(I){return new T(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new T(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,R=I){return new T(I.lineNumber,I.column,R.lineNumber,R.column)}static lift(I){return I?new T(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<I.startColumn)}static areIntersecting(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<=R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,R){if(I&&R){const y=I.startLineNumber|0,L=R.startLineNumber|0;if(y===L){const C=I.startColumn|0,m=R.startColumn|0;if(C===m){const p=I.endLineNumber|0,S=R.endLineNumber|0;if(p===S){const d=I.endColumn|0,f=R.endColumn|0;return d-f}return p-S}return C-m}return y-L}return(I?1:0)-(R?1:0)}static compareRangesUsingEnds(I,R){return I.endLineNumber===R.endLineNumber?I.endColumn===R.endColumn?I.startLineNumber===R.startLineNumber?I.startColumn-R.startColumn:I.startLineNumber-R.startLineNumber:I.endColumn-R.endColumn:I.endLineNumber-R.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Us=T}),define(ke[168],Se([1,0,29]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class T{static insert(I,R){return{range:new D.$Us(I.lineNumber,I.column,I.lineNumber,I.column),text:R,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,R){return{range:I,text:R}}static replaceMove(I,R){return{range:I,text:R,forceMoveMarkers:!0}}}e.$Vs=T}),define(ke[169],Se([1,0,48,29]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.SelectionDirection=void 0;var g;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class I extends T.$Us{constructor(b,$,y,L){super(b,$,y,L),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=y,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return I.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,b,$):new I(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Ts(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Ts(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new I(b,$,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new I(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new I(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new I(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new I(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let y=0,L=b.length;y<L;y++)if(!this.selectionsEqual(b[y],$[y]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,y,L,C){return C===0?new I(b,$,y,L):new I(y,L,b,$)}}e.$Ws=I}),define(ke[170],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0,e.$ss={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.$ht=e.WordCharacterClass=void 0;var T;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class g extends D.$ft{constructor(b){super(0);for(let $=0,y=b.length;$<y;$++)this.set(b.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$ht=g;function I(R){const b={};return $=>(b.hasOwnProperty($)||(b[$]=R($)),b[$])}e.$it=I(R=>new g(R))}),define(ke[126],Se([1,0,53,3,75]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=e.$ws=e.$vs=e.$us=e.$ts=void 0,e.$ts="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function I(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const p of e.$ts)C.indexOf(p)>=0||(m+="\\"+p);return m+="\\s]+)",new RegExp(m,"g")}e.$us=I();function R(C){let m=e.$us;if(C&&C instanceof RegExp)if(C.global)m=C;else{let p="g";C.ignoreCase&&(p+="i"),C.multiline&&(p+="m"),C.unicode&&(p+="u"),m=new RegExp(C.source,p)}return m.lastIndex=0,m}e.$vs=R;const b=new g.$4c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=b.unshift(C);return(0,T.$Rc)(m)}e.$ws=$;function y(C,m,p,S,d){if(m=R(m),d||(d=D.Iterable.first(b)),p.length>d.maxLen){let n=C-d.maxLen/2;return n<0?n=0:S+=n,p=p.substring(n,C+d.maxLen/2),y(C,m,p,S,d)}const f=Date.now(),o=C-1-S;let i=-1,s=null;for(let n=1;!(Date.now()-f>=d.timeBudget);n++){const c=o-d.windowSize*n;m.lastIndex=Math.max(0,c);const t=L(m,p,o,i);if(!t&&s||(s=t,c<=0))break;i=c}if(s){const n={word:s[0],startColumn:S+1+s.index,endColumn:S+1+s.index+s[0].length};return m.lastIndex=0,n}return null}e.$xs=y;function L(C,m,p,S){let d;for(;d=C.exec(m);){const f=d.index||0;if(f<=p&&C.lastIndex>=p)return d;if(S>0&&f>S)return null}return null}}),define(ke[172],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=e.$Rt=e.IndentAction=void 0;var D;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class T{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,y=b.notIn.length;$<y;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const y=b.findTokenIndexAtOffset($-2),L=b.getStandardTokenType(y);return this.isOK(L)}g(b,$){for(let y=b;y<=$;y++){const L=String.fromCharCode(y);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Rt=T;class g{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)I(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),I(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),I(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),I(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&I(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$St=g;function I(R,b,$){R.has(b)?R.get(b).push($):R.set(b,[$])}}),define(ke[173],Se([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AZ=e.$zZ=e.$yZ=e.State=void 0;var T;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class g{constructor(S,d,f){const o=new Uint8Array(S*d);for(let i=0,s=S*d;i<s;i++)o[i]=f;this.a=o,this.rows=S,this.cols=d}get(S,d){return this.a[S*this.cols+d]}set(S,d,f){this.a[S*this.cols+d]=f}}class I{constructor(S){let d=0,f=0;for(let i=0,s=S.length;i<s;i++){const[n,c,t]=S[i];c>d&&(d=c),n>f&&(f=n),t>f&&(f=t)}d++,f++;const o=new g(f,d,0);for(let i=0,s=S.length;i<s;i++){const[n,c,t]=S[i];o.set(n,c,t)}this.a=o,this.b=d}nextState(S,d){return d<0||d>=this.b?0:this.a.get(S,d)}}e.$yZ=I;let R=null;function b(){return R===null&&(R=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var $;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})($||($={}));let y=null;function L(){if(y===null){y=new D.$ft(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<p.length;d++)y.set(p.charCodeAt(d),1);const S=".,;:";for(let d=0;d<S.length;d++)y.set(S.charCodeAt(d),2)}return y}class C{static a(S,d,f,o,i){let s=i-1;do{const n=d.charCodeAt(s);if(S.get(n)!==2)break;s--}while(s>o);if(o>0){const n=d.charCodeAt(o-1),c=d.charCodeAt(s);(n===40&&c===41||n===91&&c===93||n===123&&c===125)&&s--}return{range:{startLineNumber:f,startColumn:o+1,endLineNumber:f,endColumn:s+2},url:d.substring(o,s+1)}}static computeLinks(S,d=b()){const f=L(),o=[];for(let i=1,s=S.getLineCount();i<=s;i++){const n=S.getLineContent(i),c=n.length;let t=0,a=0,r=0,h=1,u=!1,l=!1,k=!1,A=!1;for(;t<c;){let v=!1;const w=n.charCodeAt(t);if(h===13){let E;switch(w){case 40:u=!0,E=0;break;case 41:E=u?0:1;break;case 91:k=!0,l=!0,E=0;break;case 93:k=!1,E=l?0:1;break;case 123:A=!0,E=0;break;case 125:E=A?0:1;break;case 39:case 34:case 96:r===w?E=1:r===39||r===34||r===96?E=0:E=1;break;case 42:E=r===42?1:0;break;case 124:E=r===124?1:0;break;case 32:E=k?0:1;break;default:E=f.get(w)}E===1&&(o.push(C.a(f,n,i,a,t)),v=!0)}else if(h===12){let E;w===91?(l=!0,E=0):E=f.get(w),E===1?v=!0:h=13}else h=d.nextState(h,w),h===0&&(v=!0);v&&(h=1,u=!1,l=!1,A=!1,a=t+1,r=w),t++}h===13&&o.push(C.a(f,n,i,a,c))}return o}}e.$zZ=C;function m(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:C.computeLinks(p)}e.$AZ=m}),define(ke[79],Se([1,0,24]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fv=e.$ev=e.$dv=e.$cv=e.ModelConstants=e.PositionAffinity=e.$bv=e.TrackedRangeStickiness=e.$av=e.$_u=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var g;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(g||(e.GlyphMarginLane=g={}));var I;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(I||(e.MinimapPosition=I={}));var R;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var b;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var $;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var y;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class L{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,D.$zn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.$_u=L;class C{constructor(c,t){this._findMatchBrand=void 0,this.range=c,this.matches=t}}e.$av=C;var m;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function p(n){return n&&typeof n.read=="function"}e.$bv=p;var S;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var d;(function(n){n[n.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(d||(e.ModelConstants=d={}));class f{constructor(c,t,a,r,h,u){this.identifier=c,this.range=t,this.text=a,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=h,this._isTracked=u}}e.$cv=f;class o{constructor(c,t,a){this.regex=c,this.wordSeparators=t,this.simpleSearch=a}}e.$dv=o;class i{constructor(c,t,a){this.reverseEdits=c,this.changes=t,this.trimAutoWhitespaceLineNumbers=a}}e.$ev=i;function s(n){return!n.isTooLargeForSyncing()&&!n.isForSimpleWidget}e.$fv=s}),define(ke[174],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.NodeColor=e.$SB=void 0;class D{constructor(f,o){this.piece=f,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$TB)return g(this.right);let f=this;for(;f.parent!==e.$TB&&f.parent.left!==f;)f=f.parent;return f.parent===e.$TB?e.$TB:f.parent}prev(){if(this.left!==e.$TB)return I(this.left);let f=this;for(;f.parent!==e.$TB&&f.parent.right!==f;)f=f.parent;return f.parent===e.$TB?e.$TB:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$SB=D;var T;(function(d){d[d.Black=0]="Black",d[d.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$TB=new D(null,0),e.$TB.parent=e.$TB,e.$TB.left=e.$TB,e.$TB.right=e.$TB,e.$TB.color=0;function g(d){for(;d.left!==e.$TB;)d=d.left;return d}e.$UB=g;function I(d){for(;d.right!==e.$TB;)d=d.right;return d}e.$VB=I;function R(d){return d===e.$TB?0:d.size_left+d.piece.length+R(d.right)}function b(d){return d===e.$TB?0:d.lf_left+d.piece.lineFeedCnt+b(d.right)}function $(){e.$TB.parent=e.$TB}function y(d,f){const o=f.right;o.size_left+=f.size_left+(f.piece?f.piece.length:0),o.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=o.left,o.left!==e.$TB&&(o.left.parent=f),o.parent=f.parent,f.parent===e.$TB?d.root=o:f.parent.left===f?f.parent.left=o:f.parent.right=o,o.left=f,f.parent=o}e.$WB=y;function L(d,f){const o=f.left;f.left=o.right,o.right!==e.$TB&&(o.right.parent=f),o.parent=f.parent,f.size_left-=o.size_left+(o.piece?o.piece.length:0),f.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),f.parent===e.$TB?d.root=o:f===f.parent.right?f.parent.right=o:f.parent.left=o,o.right=f,f.parent=o}e.$XB=L;function C(d,f){let o,i;if(f.left===e.$TB?(i=f,o=i.right):f.right===e.$TB?(i=f,o=i.left):(i=g(f.right),o=i.right),i===d.root){d.root=o,o.color=0,f.detach(),$(),d.root.parent=e.$TB;return}const s=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===f?(o.parent=i.parent,S(d,o)):(i.parent===f?o.parent=i:o.parent=i.parent,S(d,o),i.left=f.left,i.right=f.right,i.parent=f.parent,i.color=f.color,f===d.root?d.root=i:f===f.parent.left?f.parent.left=i:f.parent.right=i,i.left!==e.$TB&&(i.left.parent=i),i.right!==e.$TB&&(i.right.parent=i),i.size_left=f.size_left,i.lf_left=f.lf_left,S(d,i)),f.detach(),o.parent.left===o){const c=R(o),t=b(o);if(c!==o.parent.size_left||t!==o.parent.lf_left){const a=c-o.parent.size_left,r=t-o.parent.lf_left;o.parent.size_left=c,o.parent.lf_left=t,p(d,o.parent,a,r)}}if(S(d,o.parent),s){$();return}let n;for(;o!==d.root&&o.color===0;)o===o.parent.left?(n=o.parent.right,n.color===1&&(n.color=0,o.parent.color=1,y(d,o.parent),n=o.parent.right),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.right.color===0&&(n.left.color=0,n.color=1,L(d,n),n=o.parent.right),n.color=o.parent.color,o.parent.color=0,n.right.color=0,y(d,o.parent),o=d.root)):(n=o.parent.left,n.color===1&&(n.color=0,o.parent.color=1,L(d,o.parent),n=o.parent.left),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.left.color===0&&(n.right.color=0,n.color=1,y(d,n),n=o.parent.left),n.color=o.parent.color,o.parent.color=0,n.left.color=0,L(d,o.parent),o=d.root));o.color=0,$()}e.$YB=C;function m(d,f){for(S(d,f);f!==d.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const o=f.parent.parent.right;o.color===1?(f.parent.color=0,o.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,y(d,f)),f.parent.color=0,f.parent.parent.color=1,L(d,f.parent.parent))}else{const o=f.parent.parent.left;o.color===1?(f.parent.color=0,o.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,L(d,f)),f.parent.color=0,f.parent.parent.color=1,y(d,f.parent.parent))}d.root.color=0}e.$ZB=m;function p(d,f,o,i){for(;f!==d.root&&f!==e.$TB;)f.parent.left===f&&(f.parent.size_left+=o,f.parent.lf_left+=i),f=f.parent}e.$1B=p;function S(d,f){let o=0,i=0;if(f!==d.root){for(;f!==d.root&&f===f.parent.right;)f=f.parent;if(f!==d.root)for(f=f.parent,o=R(f.left)-f.size_left,i=b(f.left)-f.lf_left,f.size_left+=o,f.lf_left+=i;f!==d.root&&(o!==0||i!==0);)f.parent.left===f&&(f.parent.size_left+=o,f.parent.lf_left+=i),f=f.parent}}e.$2B=S}),define(ke[175],Se([1,0,19,124]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=void 0;class g{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,y){$=(0,T.$Ie)($);const L=this.a,C=this.b,m=y.length;return m===0?!1:(this.a=new Uint32Array(L.length+m),this.a.set(L.subarray(0,$),0),this.a.set(L.subarray($),$+m),this.a.set(y,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,y){return $=(0,T.$Ie)($),y=(0,T.$Ie)(y),this.a[$]===y?!1:(this.a[$]=y,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,y){$=(0,T.$Ie)($),y=(0,T.$Ie)(y);const L=this.a,C=this.b;if($>=L.length)return!1;const m=L.length-$;return y>=m&&(y=m),y===0?!1:(this.a=new Uint32Array(L.length-y),this.a.set(L.subarray(0,$),0),this.a.set(L.subarray($+y),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,T.$Ie)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),$>=this.a.length&&($=this.a.length-1);for(let L=y;L<=$;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let y=0,L=this.a.length-1,C=0,m=0,p=0;for(;y<=L;)if(C=y+(L-y)/2|0,m=this.b[C],p=m-this.a[C],$<p)L=C-1;else if($>=m)y=C+1;else break;return new R(C,$-p)}}e.$iv=g;class I{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const y=this.e[$],L=y>0?this.d[y-1]:0;return new R(y,$-L)}removeValues($,y){this.a.splice($,y),this.f($)}insertValues($,y){this.a=(0,D.$Wb)(this.a,$,y),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,y=this.a.length;$<y;$++){const L=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+L;for(let m=0;m<L;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,y){this.a[$]!==y&&(this.a[$]=y,this.f($))}}e.$jv=I;class R{constructor($,y){this.index=$,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=y}}e.$kv=R}),define(ke[176],Se([1,0,12,48,175]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=void 0;class I{constructor(b,$,y,L){this.d=b,this.f=$,this.g=y,this.h=L,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const y of $)this.o(y.range),this.p(new T.$Ts(y.range.startLineNumber,y.range.startColumn),y.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,y=new Uint32Array($);for(let L=0;L<$;L++)y[L]=this.f[L].length+b;this.j=new g.$iv(y)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const y=(0,D.$Ze)($);if(y.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]+this.f[b.lineNumber-1].substring(b.column-1));return}y[y.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]);const L=new Uint32Array(y.length-1);for(let C=1;C<y.length;C++)this.f.splice(b.lineNumber+C-1,0,y[C]),L[C-1]=y[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,L)}}e.$lv=I}),define(ke[100],Se([1,0,12,171,48,29,79]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8B=e.$7B=e.$6B=e.$5B=e.$4B=e.$3B=void 0;const b=999;class ${constructor(i,s,n,c){this.searchString=i,this.isRegex=s,this.matchCase=n,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let s=null;try{s=D.$Xe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!s)return null;let n=!this.isRegex&&!i;return n&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(n=this.matchCase),new R.$dv(s,this.wordSeparators?(0,T.$it)(this.wordSeparators):null,n?this.searchString:null)}}e.$3B=$;function y(o){if(!o||o.length===0)return!1;for(let i=0,s=o.length;i<s;i++){const n=o.charCodeAt(i);if(n===10)return!0;if(n===92){if(i++,i>=s)break;const c=o.charCodeAt(i);if(c===110||c===114||c===87)return!0}}return!1}e.$4B=y;function L(o,i,s){if(!s)return new R.$av(o,null);const n=[];for(let c=0,t=i.length;c<t;c++)n[c]=i[c];return new R.$av(o,n)}e.$5B=L;class C{constructor(i){const s=[];let n=0;for(let c=0,t=i.length;c<t;c++)i.charCodeAt(c)===10&&(s[n++]=c);this.a=s}findLineFeedCountBeforeOffset(i){const s=this.a;let n=0,c=s.length-1;if(c===-1||i<=s[0])return 0;for(;n<c;){const t=n+((c-n)/2>>0);s[t]>=i?c=t-1:s[t+1]>=i?(n=t,c=t):n=t+1}return n+1}}class m{static findMatches(i,s,n,c,t){const a=s.parseSearchRequest();return a?a.regex.multiline?this.b(i,n,new f(a.wordSeparators,a.regex),c,t):this.c(i,n,a,c,t):[]}static a(i,s,n,c,t,a){let r,h=0;c?(h=c.findLineFeedCountBeforeOffset(t),r=s+t+h):r=s+t;let u;if(c){const v=c.findLineFeedCountBeforeOffset(t+a.length)-h;u=r+a.length+v}else u=r+a.length;const l=i.getPositionAt(r),k=i.getPositionAt(u);return new I.$Us(l.lineNumber,l.column,k.lineNumber,k.column)}static b(i,s,n,c,t){const a=i.getOffsetAt(s.getStartPosition()),r=i.getValueInRange(s,1),h=i.getEOL()===`\r
`?new C(r):null,u=[];let l=0,k;for(n.reset(0);k=n.next(r);)if(u[l++]=L(this.a(i,a,r,h,k.index,k[0]),k,c),l>=t)return u;return u}static c(i,s,n,c,t){const a=[];let r=0;if(s.startLineNumber===s.endLineNumber){const u=i.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return r=this.d(n,u,s.startLineNumber,s.startColumn-1,r,a,c,t),a}const h=i.getLineContent(s.startLineNumber).substring(s.startColumn-1);r=this.d(n,h,s.startLineNumber,s.startColumn-1,r,a,c,t);for(let u=s.startLineNumber+1;u<s.endLineNumber&&r<t;u++)r=this.d(n,i.getLineContent(u),u,0,r,a,c,t);if(r<t){const u=i.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);r=this.d(n,u,s.endLineNumber,0,r,a,c,t)}return a}static d(i,s,n,c,t,a,r,h){const u=i.wordSeparators;if(!r&&i.simpleSearch){const A=i.simpleSearch,v=A.length,w=s.length;let E=-v;for(;(E=s.indexOf(A,E+v))!==-1;)if((!u||d(u,s,w,E,v))&&(a[t++]=new R.$av(new I.$Us(n,E+1+c,n,E+1+v+c),null),t>=h))return t;return t}const l=new f(i.wordSeparators,i.regex);let k;l.reset(0);do if(k=l.next(s),k&&(a[t++]=L(new I.$Us(n,k.index+1+c,n,k.index+1+k[0].length+c),k,r),t>=h))return t;while(k);return t}static findNextMatch(i,s,n,c){const t=s.parseSearchRequest();if(!t)return null;const a=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,n,a,c):this.f(i,n,a,c)}static e(i,s,n,c){const t=new g.$Ts(s.lineNumber,1),a=i.getOffsetAt(t),r=i.getLineCount(),h=i.getValueInRange(new I.$Us(t.lineNumber,t.column,r,i.getLineMaxColumn(r)),1),u=i.getEOL()===`\r
`?new C(h):null;n.reset(s.column-1);const l=n.next(h);return l?L(this.a(i,a,h,u,l.index,l[0]),l,c):s.lineNumber!==1||s.column!==1?this.e(i,new g.$Ts(1,1),n,c):null}static f(i,s,n,c){const t=i.getLineCount(),a=s.lineNumber,r=i.getLineContent(a),h=this.g(n,r,a,s.column,c);if(h)return h;for(let u=1;u<=t;u++){const l=(a+u-1)%t,k=i.getLineContent(l+1),A=this.g(n,k,l+1,1,c);if(A)return A}return null}static g(i,s,n,c,t){i.reset(c-1);const a=i.next(s);return a?L(new I.$Us(n,a.index+1,n,a.index+1+a[0].length),a,t):null}static findPreviousMatch(i,s,n,c){const t=s.parseSearchRequest();if(!t)return null;const a=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,n,a,c):this.j(i,n,a,c)}static h(i,s,n,c){const t=this.b(i,new I.$Us(1,1,s.lineNumber,s.column),n,c,10*b);if(t.length>0)return t[t.length-1];const a=i.getLineCount();return s.lineNumber!==a||s.column!==i.getLineMaxColumn(a)?this.h(i,new g.$Ts(a,i.getLineMaxColumn(a)),n,c):null}static j(i,s,n,c){const t=i.getLineCount(),a=s.lineNumber,r=i.getLineContent(a).substring(0,s.column-1),h=this.k(n,r,a,c);if(h)return h;for(let u=1;u<=t;u++){const l=(t+a-u-1)%t,k=i.getLineContent(l+1),A=this.k(n,k,l+1,c);if(A)return A}return null}static k(i,s,n,c){let t=null,a;for(i.reset(0);a=i.next(s);)t=L(new I.$Us(n,a.index+1,n,a.index+1+a[0].length),a,c);return t}}e.$6B=m;function p(o,i,s,n,c){if(n===0)return!0;const t=i.charCodeAt(n-1);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const a=i.charCodeAt(n);if(o.get(a)!==0)return!0}return!1}function S(o,i,s,n,c){if(n+c===s)return!0;const t=i.charCodeAt(n+c);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const a=i.charCodeAt(n+c-1);if(o.get(a)!==0)return!0}return!1}function d(o,i,s,n,c){return p(o,i,s,n,c)&&S(o,i,s,n,c)}e.$7B=d;class f{constructor(i,s){this._wordSeparators=i,this.a=s,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const s=i.length;let n;do{if(this.b+this.c===s||(n=this.a.exec(i),!n))return null;const c=n.index,t=n[0].length;if(c===this.b&&t===this.c){if(t===0){D.$gf(i,s,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=t,!this._wordSeparators||d(this._wordSeparators,i,s,c,t))return n}while(n);return null}}e.$8B=f}),define(ke[127],Se([1,0,48,29,79,174,100]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=void 0;const b=65535;function $(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class y{constructor(i,s,n,c,t){this.lineStarts=i,this.cr=s,this.lf=n,this.crlf=c,this.isBasicASCII=t}}function L(o,i=!0){const s=[0];let n=1;for(let c=0,t=o.length;c<t;c++){const a=o.charCodeAt(c);a===13?c+1<t&&o.charCodeAt(c+1)===10?(s[n++]=c+2,c++):s[n++]=c+1:a===10&&(s[n++]=c+1)}return i?$(s):s}e.$9B=L;function C(o,i){o.length=0,o[0]=0;let s=1,n=0,c=0,t=0,a=!0;for(let h=0,u=i.length;h<u;h++){const l=i.charCodeAt(h);l===13?h+1<u&&i.charCodeAt(h+1)===10?(t++,o[s++]=h+2,h++):(n++,o[s++]=h+1):l===10?(c++,o[s++]=h+1):a&&l!==9&&(l<32||l>126)&&(a=!1)}const r=new y($(o),n,c,t,a);return o.length=0,r}e.$0B=C;class m{constructor(i,s,n,c,t){this.bufferIndex=i,this.start=s,this.end=n,this.lineFeedCnt=c,this.length=t}}e.$$B=m;class p{constructor(i,s){this.buffer=i,this.lineStarts=s}}e.$_B=p;class S{constructor(i,s){this.a=[],this.c=i,this.d=s,this.b=0,i.root!==I.$TB&&i.iterate(i.root,n=>(n!==I.$TB&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class d{constructor(i){this.a=i,this.b=[]}get(i){for(let s=this.b.length-1;s>=0;s--){const n=this.b[s];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let s=this.b.length-1;s>=0;s--){const n=this.b[s];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let s=!1;const n=this.b;for(let c=0;c<n.length;c++){const t=n[c];if(t.node.parent===null||t.nodeStartOffset>=i){n[c]=null,s=!0;continue}}if(s){const c=[];for(const t of n)t!==null&&c.push(t);this.b=c}}}class f{constructor(i,s,n){this.create(i,s,n)}create(i,s,n){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=I.$TB,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=n;let c=null;for(let t=0,a=i.length;t<a;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=L(i[t].buffer));const r=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),c=this.S(c,r)}this.h=new d(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const s=b,n=s-Math.floor(s/3),c=n*2;let t="",a=0;const r=[];if(this.iterate(this.root,h=>{const u=this.R(h),l=u.length;if(a<=n||a+l<c)return t+=u,a+=l,!0;const k=t.replace(/\r\n|\r|\n/g,i);return r.push(new p(k,L(k))),t=u,a=l,!0}),a>0){const h=t.replace(/\r\n|\r|\n/g,i);r.push(new p(h,L(h)))}this.create(r,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let s=0;return this.iterate(this.root,c=>{if(c===I.$TB)return!0;const t=this.R(c),a=t.length,r=i.G(s),h=i.G(s+a),u=i.getValueInRange2(r,h);return s+=a,t===u})}getOffsetAt(i,s){let n=0,c=this.root;for(;c!==I.$TB;)if(c.left!==I.$TB&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){n+=c.size_left;const t=this.B(c,i-c.lf_left-2);return n+=t+s-1}else i-=c.lf_left+c.piece.lineFeedCnt,n+=c.size_left+c.piece.length,c=c.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let s=this.root,n=0;const c=i;for(;s!==I.$TB;)if(s.size_left!==0&&s.size_left>=i)s=s.left;else if(s.size_left+s.piece.length>=i){const t=this.A(s,i-s.size_left);if(n+=s.lf_left+t.index,t.index===0){const a=this.getOffsetAt(n+1,1),r=c-a;return new D.$Ts(n+1,r+1)}return new D.$Ts(n+1,t.remainder+1)}else if(i-=s.size_left+s.piece.length,n+=s.lf_left+s.piece.lineFeedCnt,s.right===I.$TB){const t=this.getOffsetAt(n+1,1),a=c-i-t;return new D.$Ts(n+1,a+1)}else s=s.right;return new D.$Ts(1,1)}getValueInRange(i,s){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(n,c);return s?s!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,s):t}getValueInRange2(i,s){if(i.node===s.node){const r=i.node,h=this.a[r.piece.bufferIndex].buffer,u=this.u(r.piece.bufferIndex,r.piece.start);return h.substring(u+i.remainder,u+s.remainder)}let n=i.node;const c=this.a[n.piece.bufferIndex].buffer,t=this.u(n.piece.bufferIndex,n.piece.start);let a=c.substring(t+i.remainder,t+n.piece.length);for(n=n.next();n!==I.$TB;){const r=this.a[n.piece.bufferIndex].buffer,h=this.u(n.piece.bufferIndex,n.piece.start);if(n===s.node){a+=r.substring(h,h+s.remainder);break}else a+=r.substr(h,n.piece.length);n=n.next()}return a}getLinesContent(){const i=[];let s=0,n="",c=!1;return this.iterate(this.root,t=>{if(t===I.$TB)return!0;const a=t.piece;let r=a.length;if(r===0)return!0;const h=this.a[a.bufferIndex].buffer,u=this.a[a.bufferIndex].lineStarts,l=a.start.line,k=a.end.line;let A=u[l]+a.start.column;if(c&&(h.charCodeAt(A)===10&&(A++,r--),i[s++]=n,n="",c=!1,r===0))return!0;if(l===k)return!this.f&&h.charCodeAt(A+r-1)===13?(c=!0,n+=h.substr(A,r-1)):n+=h.substr(A,r),!0;n+=this.f?h.substring(A,Math.max(A,u[l+1]-this.e)):h.substring(A,u[l+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=n;for(let v=l+1;v<k;v++)n=this.f?h.substring(u[v],u[v+1]-this.e):h.substring(u[v],u[v+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=n;return!this.f&&h.charCodeAt(u[k]+a.end.column-1)===13?(c=!0,a.end.column===0?s--:n=h.substr(u[k],a.end.column-1)):n=h.substr(u[k],a.end.column),!0}),c&&(i[s++]=n,n=""),i[s++]=n,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const s=i.node.next();if(!s)return 0;const n=this.a[s.piece.bufferIndex],c=this.u(s.piece.bufferIndex,s.piece.start);return n.buffer.charCodeAt(c)}else{const s=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return s.buffer.charCodeAt(c)}}getLineCharCode(i,s){const n=this.H(i,s+1);return this.l(n)}getLineLength(i){if(i===this.getLineCount()){const s=this.getOffsetAt(i,1);return this.getLength()-s}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const s=this.G(i);return this.l(s)}findMatchesInNode(i,s,n,c,t,a,r,h,u,l,k){const A=this.a[i.piece.bufferIndex],v=this.u(i.piece.bufferIndex,i.piece.start),w=this.u(i.piece.bufferIndex,t),E=this.u(i.piece.bufferIndex,a);let P;const N={line:0,column:0};let z,F;s._wordSeparators?(z=A.buffer.substring(w,E),F=j=>j+w,s.reset(0)):(z=A.buffer,F=j=>j,s.reset(w));do if(P=s.next(z),P){if(F(P.index)>=E)return l;this.s(i,F(P.index)-v,N);const j=this.t(i.piece.bufferIndex,t,N),M=N.line===t.line?N.column-t.column+c:N.column+1,O=M+P[0].length;if(k[l++]=(0,R.$5B)(new T.$Us(n+j,M,n+j,O),P,h),F(P.index)+P[0].length>=E||l>=u)return l}while(P);return l}findMatchesLineByLine(i,s,n,c){const t=[];let a=0;const r=new R.$8B(s.wordSeparators,s.regex);let h=this.H(i.startLineNumber,i.startColumn);if(h===null)return[];const u=this.H(i.endLineNumber,i.endColumn);if(u===null)return[];let l=this.s(h.node,h.remainder);const k=this.s(u.node,u.remainder);if(h.node===u.node)return this.findMatchesInNode(h.node,r,i.startLineNumber,i.startColumn,l,k,s,n,c,a,t),t;let A=i.startLineNumber,v=h.node;for(;v!==u.node;){const E=this.t(v.piece.bufferIndex,l,v.piece.end);if(E>=1){const N=this.a[v.piece.bufferIndex].lineStarts,z=this.u(v.piece.bufferIndex,v.piece.start),F=N[l.line+E],j=A===i.startLineNumber?i.startColumn:1;if(a=this.findMatchesInNode(v,r,A,j,l,this.s(v,F-z),s,n,c,a,t),a>=c)return t;A+=E}const P=A===i.startLineNumber?i.startColumn-1:0;if(A===i.endLineNumber){const N=this.getLineContent(A).substring(P,i.endColumn-1);return a=this.n(s,r,N,i.endLineNumber,P,a,t,n,c),t}if(a=this.n(s,r,this.getLineContent(A).substr(P),A,P,a,t,n,c),a>=c)return t;A++,h=this.H(A,1),v=h.node,l=this.s(h.node,h.remainder)}if(A===i.endLineNumber){const E=A===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(A).substring(E,i.endColumn-1);return a=this.n(s,r,P,i.endLineNumber,E,a,t,n,c),t}const w=A===i.startLineNumber?i.startColumn:1;return a=this.findMatchesInNode(u.node,r,A,w,l,k,s,n,c,a,t),t}n(i,s,n,c,t,a,r,h,u){const l=i.wordSeparators;if(!h&&i.simpleSearch){const A=i.simpleSearch,v=A.length,w=n.length;let E=-v;for(;(E=n.indexOf(A,E+v))!==-1;)if((!l||(0,R.$7B)(l,n,w,E,v))&&(r[a++]=new g.$av(new T.$Us(c,E+1+t,c,E+1+v+t),null),a>=u))return a;return a}let k;s.reset(0);do if(k=s.next(n),k&&(r[a++]=(0,R.$5B)(new T.$Us(c,k.index+1+t,c,k.index+1+k[0].length+t),k,h),a>=u))return a;while(k);return a}insert(i,s,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==I.$TB){const{node:c,remainder:t,nodeStartOffset:a}=this.G(i),r=c.piece,h=r.bufferIndex,u=this.s(c,t);if(c.piece.bufferIndex===0&&r.end.line===this.g.line&&r.end.column===this.g.column&&a+r.length===i&&s.length<b){this.F(c,s),this.y();return}if(a===i)this.o(s,c),this.h.validate(i);else if(a+c.piece.length>i){const l=[];let k=new m(r.bufferIndex,u,r.end,this.t(r.bufferIndex,u,r.end),this.u(h,r.end)-this.u(h,u));if(this.K()&&this.M(s)&&this.I(c,t)===10){const E={line:k.start.line+1,column:0};k=new m(k.bufferIndex,E,k.end,this.t(k.bufferIndex,E,k.end),k.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(c,t-1)===13){const E=this.s(c,t-1);this.C(c,E),s="\r"+s,c.piece.length===0&&l.push(c)}else this.C(c,u);else this.C(c,u);const A=this.w(s);k.length>0&&this.S(c,k);let v=c;for(let w=0;w<A.length;w++)v=this.S(v,A[w]);this.v(l)}else this.q(s,c)}else{const c=this.w(s);let t=this.T(null,c[0]);for(let a=1;a<c.length;a++)t=this.S(t,c[a])}this.y()}delete(i,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===I.$TB)return;const n=this.G(i),c=this.G(i+s),t=n.node,a=c.node;if(t===a){const A=this.s(t,n.remainder),v=this.s(t,c.remainder);if(n.nodeStartOffset===i){if(s===t.piece.length){const w=t.next();(0,I.$YB)(this,t),this.N(w),this.y();return}this.D(t,v),this.h.validate(i),this.N(t),this.y();return}if(n.nodeStartOffset+t.piece.length===i+s){this.C(t,A),this.O(t),this.y();return}this.E(t,A,v),this.y();return}const r=[],h=this.s(t,n.remainder);this.C(t,h),this.h.validate(i),t.piece.length===0&&r.push(t);const u=this.s(a,c.remainder);this.D(a,u),a.piece.length===0&&r.push(a);const l=t.next();for(let A=l;A!==I.$TB&&A!==a;A=A.next())r.push(A);const k=t.piece.length===0?t.prev():t;this.v(r),this.O(k),this.y()}o(i,s){const n=[];if(this.K()&&this.M(i)&&this.L(s)){const a=s.piece,r={line:a.start.line+1,column:0},h=new m(a.bufferIndex,r,a.end,this.t(a.bufferIndex,r,a.end),a.length-1);s.piece=h,i+=`
`,(0,I.$1B)(this,s,-1,-1),s.piece.length===0&&n.push(s)}const c=this.w(i);let t=this.T(s,c[c.length-1]);for(let a=c.length-2;a>=0;a--)t=this.T(t,c[a]);this.N(t),this.v(n)}q(i,s){this.Q(i,s)&&(i+=`
`);const n=this.w(i),c=this.S(s,n[0]);let t=c;for(let a=1;a<n.length;a++)t=this.S(t,n[a]);this.N(c)}s(i,s,n){const c=i.piece,t=i.piece.bufferIndex,a=this.a[t].lineStarts,h=a[c.start.line]+c.start.column+s;let u=c.start.line,l=c.end.line,k=0,A=0,v=0;for(;u<=l&&(k=u+(l-u)/2|0,v=a[k],k!==l);)if(A=a[k+1],h<v)l=k-1;else if(h>=A)u=k+1;else break;return n?(n.line=k,n.column=h-v,null):{line:k,column:h-v}}t(i,s,n){if(n.column===0)return n.line-s.line;const c=this.a[i].lineStarts;if(n.line===c.length-1)return n.line-s.line;const t=c[n.line+1],a=c[n.line]+n.column;if(t>a+1)return n.line-s.line;const r=a-1;return this.a[i].buffer.charCodeAt(r)===13?n.line-s.line+1:n.line-s.line}u(i,s){return this.a[i].lineStarts[s.line]+s.column}v(i){for(let s=0;s<i.length;s++)(0,I.$YB)(this,i[s])}w(i){if(i.length>b){const l=[];for(;i.length>b;){const A=i.charCodeAt(b-1);let v;A===13||A>=55296&&A<=56319?(v=i.substring(0,b-1),i=i.substring(b-1)):(v=i.substring(0,b),i=i.substring(b));const w=L(v);l.push(new m(this.a.length,{line:0,column:0},{line:w.length-1,column:v.length-w[w.length-1]},w.length-1,v.length)),this.a.push(new p(v,w))}const k=L(i);return l.push(new m(this.a.length,{line:0,column:0},{line:k.length-1,column:i.length-k[k.length-1]},k.length-1,i.length)),this.a.push(new p(i,k)),l}let s=this.a[0].buffer.length;const n=L(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let l=0;l<n.length;l++)n[l]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+i,s+=1}else{if(s!==0)for(let l=0;l<n.length;l++)n[l]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,a=this.a[0].lineStarts.length-1,r=t-this.a[0].lineStarts[a],h={line:a,column:r},u=new m(0,c,h,this.t(0,c,h),t-s);return this.g=h,[u]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,s=0){let n=this.root,c="";const t=this.h.get2(i);if(t){n=t.node;const a=this.B(n,i-t.nodeStartLineNumber-1),r=this.a[n.piece.bufferIndex].buffer,h=this.u(n.piece.bufferIndex,n.piece.start);if(t.nodeStartLineNumber+n.piece.lineFeedCnt===i)c=r.substring(h+a,h+n.piece.length);else{const u=this.B(n,i-t.nodeStartLineNumber);return r.substring(h+a,h+u-s)}}else{let a=0;const r=i;for(;n!==I.$TB;)if(n.left!==I.$TB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const h=this.B(n,i-n.lf_left-2),u=this.B(n,i-n.lf_left-1),l=this.a[n.piece.bufferIndex].buffer,k=this.u(n.piece.bufferIndex,n.piece.start);return a+=n.size_left,this.h.set({node:n,nodeStartOffset:a,nodeStartLineNumber:r-(i-1-n.lf_left)}),l.substring(k+h,k+u-s)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const h=this.B(n,i-n.lf_left-2),u=this.a[n.piece.bufferIndex].buffer,l=this.u(n.piece.bufferIndex,n.piece.start);c=u.substring(l+h,l+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==I.$TB;){const a=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const r=this.B(n,0),h=this.u(n.piece.bufferIndex,n.piece.start);return c+=a.substring(h,h+r-s),c}else{const r=this.u(n.piece.bufferIndex,n.piece.start);c+=a.substr(r,n.piece.length)}n=n.next()}return c}y(){let i=this.root,s=1,n=0;for(;i!==I.$TB;)s+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this.b=s,this.c=n,this.h.validate(this.c)}A(i,s){const n=i.piece,c=this.s(i,s),t=c.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===s){const a=this.t(i.piece.bufferIndex,n.start,c);if(a!==t)return{index:a,remainder:0}}return{index:t,remainder:c.column}}B(i,s){if(s<0)return 0;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,t=n.start.line+s+1;return t>n.end.line?c[n.end.line]+n.end.column-c[n.start.line]-n.start.column:c[t]-c[n.start.line]-n.start.column}C(i,s){const n=i.piece,c=n.lineFeedCnt,t=this.u(n.bufferIndex,n.end),a=s,r=this.u(n.bufferIndex,a),h=this.t(n.bufferIndex,n.start,a),u=h-c,l=r-t,k=n.length+l;i.piece=new m(n.bufferIndex,n.start,a,h,k),(0,I.$1B)(this,i,l,u)}D(i,s){const n=i.piece,c=n.lineFeedCnt,t=this.u(n.bufferIndex,n.start),a=s,r=this.t(n.bufferIndex,a,n.end),h=this.u(n.bufferIndex,a),u=r-c,l=t-h,k=n.length+l;i.piece=new m(n.bufferIndex,a,n.end,r,k),(0,I.$1B)(this,i,l,u)}E(i,s,n){const c=i.piece,t=c.start,a=c.end,r=c.length,h=c.lineFeedCnt,u=s,l=this.t(c.bufferIndex,c.start,u),k=this.u(c.bufferIndex,s)-this.u(c.bufferIndex,t);i.piece=new m(c.bufferIndex,c.start,u,l,k),(0,I.$1B)(this,i,k-r,l-h);const A=new m(c.bufferIndex,n,a,this.t(c.bufferIndex,n,a),this.u(c.bufferIndex,a)-this.u(c.bufferIndex,n)),v=this.S(i,A);this.N(v)}F(i,s){this.Q(s,i)&&(s+=`
`);const n=this.K()&&this.L(s)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=s;const t=L(s,!1);for(let v=0;v<t.length;v++)t[v]+=c;if(n){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const a=this.a[0].lineStarts.length-1,r=this.a[0].buffer.length-this.a[0].lineStarts[a],h={line:a,column:r},u=i.piece.length+s.length,l=i.piece.lineFeedCnt,k=this.t(0,i.piece.start,h),A=k-l;i.piece=new m(i.piece.bufferIndex,i.piece.start,h,k,u),this.g=h,(0,I.$1B)(this,i,s.length,A)}G(i){let s=this.root;const n=this.h.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let c=0;for(;s!==I.$TB;)if(s.size_left>i)s=s.left;else if(s.size_left+s.piece.length>=i){c+=s.size_left;const t={node:s,remainder:i-s.size_left,nodeStartOffset:c};return this.h.set(t),t}else i-=s.size_left+s.piece.length,c+=s.size_left+s.piece.length,s=s.right;return null}H(i,s){let n=this.root,c=0;for(;n!==I.$TB;)if(n.left!==I.$TB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const t=this.B(n,i-n.lf_left-2),a=this.B(n,i-n.lf_left-1);return c+=n.size_left,{node:n,remainder:Math.min(t+s-1,a),nodeStartOffset:c}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const t=this.B(n,i-n.lf_left-2);if(t+s-1<=n.piece.length)return{node:n,remainder:t+s-1,nodeStartOffset:c};s-=n.piece.length-t;break}else i-=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==I.$TB;){if(n.piece.lineFeedCnt>0){const t=this.B(n,0),a=this.J(n);return{node:n,remainder:Math.min(s-1,t),nodeStartOffset:a}}else if(n.piece.length>=s-1){const t=this.J(n);return{node:n,remainder:s-1,nodeStartOffset:t}}else s-=n.piece.length;n=n.next()}return null}I(i,s){if(i.piece.lineFeedCnt<1)return-1;const n=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+s;return n.buffer.charCodeAt(c)}J(i){if(!i)return 0;let s=i.size_left;for(;i!==this.root;)i.parent.right===i&&(s+=i.parent.size_left+i.parent.piece.length),i=i.parent;return s}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===I.$TB||i.piece.lineFeedCnt===0)return!1;const s=i.piece,n=this.a[s.bufferIndex].lineStarts,c=s.start.line,t=n[c]+s.start.column;return c===n.length-1||n[c+1]>t+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===I.$TB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const s=i.prev();this.M(s)&&this.P(s,i)}}O(i){if(this.K()&&this.M(i)){const s=i.next();this.L(s)&&this.P(i,s)}}P(i,s){const n=[],c=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const a=i.piece.length-1,r=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,r,a),(0,I.$1B)(this,i,-1,-1),i.piece.length===0&&n.push(i);const h={line:s.piece.start.line+1,column:0},u=s.piece.length-1,l=this.t(s.piece.bufferIndex,h,s.piece.end);s.piece=new m(s.piece.bufferIndex,h,s.piece.end,l,u),(0,I.$1B)(this,s,-1,-1),s.piece.length===0&&n.push(s);const k=this.w(`\r
`);this.S(i,k[0]);for(let A=0;A<n.length;A++)(0,I.$YB)(this,n[A])}Q(i,s){if(this.K()&&this.M(i)){const n=s.next();if(this.L(n)){if(i+=`
`,n.piece.length===1)(0,I.$YB)(this,n);else{const c=n.piece,t={line:c.start.line+1,column:0},a=c.length-1,r=this.t(c.bufferIndex,t,c.end);n.piece=new m(c.bufferIndex,t,c.end,r,a),(0,I.$1B)(this,n,-1,-1)}return!0}}return!1}iterate(i,s){if(i===I.$TB)return s(I.$TB);const n=this.iterate(i.left,s);return n&&s(i)&&this.iterate(i.right,s)}R(i){if(i===I.$TB)return"";const s=this.a[i.piece.bufferIndex],n=i.piece,c=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return s.buffer.substring(c,t)}getPieceContent(i){const s=this.a[i.bufferIndex],n=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return s.buffer.substring(n,c)}S(i,s){const n=new I.$SB(s,1);if(n.left=I.$TB,n.right=I.$TB,n.parent=I.$TB,n.size_left=0,n.lf_left=0,this.root===I.$TB)this.root=n,n.color=0;else if(i.right===I.$TB)i.right=n,n.parent=i;else{const t=(0,I.$UB)(i.right);t.left=n,n.parent=t}return(0,I.$ZB)(this,n),n}T(i,s){const n=new I.$SB(s,1);if(n.left=I.$TB,n.right=I.$TB,n.parent=I.$TB,n.size_left=0,n.lf_left=0,this.root===I.$TB)this.root=n,n.color=0;else if(i.left===I.$TB)i.left=n,n.parent=i;else{const c=(0,I.$VB)(i.left);c.right=n,n.parent=c}return(0,I.$ZB)(this,n),n}U(i){let s="";return this.iterate(i,n=>(s+=this.R(n),!0)),s}}e.$aC=f}),define(ke[177],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8=e.$n8=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const R=this.a.get(I);return this.a.delete(I),R}}addDragOperationTransfer(I,R){this.a.set(I,R)}}e.$n8=D;class T{constructor(I){this.identifier=I}}e.$o8=T}),define(ke[178],Se([1,0,4,3]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Vd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,T.$Rc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const y=new I(this,b,$);return this.b.set(b,y),(0,T.$Rc)(()=>{const L=this.b.get(b);!L||L!==y||(this.b.delete(b),L.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const y=this.b.get(b);return!y||y.isResolved?null:(await y.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const y=this.b.get(b);return!!(!y||y.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$tt=g;class I extends T.$Tc{get isResolved(){return this.c}constructor(b,$,y){super(),this.f=b,this.g=$,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[179],Se([8,9]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class I extends T.$Tc{constructor(m,p="",S="",d=!0,f){super(),this.h=this.B(new D.$Vd),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=p,this.u=S,this.w=d,this.C=f}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,p){this.C&&await this.C(m)}}e.$Ki=I;class R extends T.$Tc{constructor(){super(...arguments),this.f=this.B(new D.$Vd),this.onWillRun=this.f.event,this.m=this.B(new D.$Vd),this.onDidRun=this.m.event}async run(m,p){if(!m.enabled)return;this.f.fire({action:m});let S;try{await this.u(m,p)}catch(d){S=d}this.m.fire({action:m,error:S})}async u(m,p){await m.run(p)}}e.$Li=R;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let p=[];for(const S of m)S.length&&(p.length?p=[...p,new b,...S]:p=S);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Mi=b;class ${get actions(){return this.a}constructor(m,p,S,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=p,this.class=d,this.a=S}async run(){}}e.$Ni=$;class y extends I{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,g.localize(0,null),void 0,!1)}}e.$Oi=y;function L(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...m)=>C.run(...m),tooltip:C.label}}e.$Pi=L}),define(ke[181],Se([8,9]),function(me,e){return me.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const T=60,g=T*60,I=g*24,R=I*7,b=I*30,$=I*365;function y(C,m,p,S){typeof C!="number"&&(C=C.getTime());const d=Math.round((new Date().getTime()-C)/1e3);if(d<-30)return(0,D.localize)(0,null,y(new Date().getTime()+d*1e3,!1));if(!S&&d<30)return(0,D.localize)(1,null);let f;return d<T?(f=d,m?f===1?p?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):p?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?p?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):p?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):d<g?(f=Math.floor(d/T),m?f===1?p?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):p?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?p?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):p?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):d<I?(f=Math.floor(d/g),m?f===1?p?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):p?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?p?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):p?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):d<R?(f=Math.floor(d/I),m?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):d<b?(f=Math.floor(d/R),m?f===1?p?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):p?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?p?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):p?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):d<$?(f=Math.floor(d/b),m?f===1?p?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):p?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?p?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):p?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(d/$),m?f===1?p?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):p?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?p?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):p?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}e.$vm=y;function L(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=L}),define(ke[183],Se([8,9]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ke[44],Se([1,0,19,18,183]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function I(C,m){return m&&(C.stack||C.stacktrace)?g.localize(0,null,b(C),R(C.stack)||R(C.stacktrace)):b(C)}function R(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function $(C=null,m=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const p=D.$Hb(C),S=$(p[0],m);return p.length>1?g.localize(4,null,S,p.length):S}if(T.$If(C))return C;if(C.detail){const p=C.detail;if(p.error)return I(p.error,m);if(p.exception)return I(p.exception,m)}return C.stack?I(C,m):C.message?C.message:g.localize(5,null)}e.$Qi=$;function y(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}e.$Ri=y;function L(C,m){let p;return typeof C=="string"?p=new Error(C):p=C,p.actions=m,p}e.$Si=L}),define(ke[184],Se([8,9]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ke[10],Se([1,0,184]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let T=!1,g=!1,I=!1,R=!1,b=!1,$=!1,y=!1,L=!1,C=!1,m=!1,p,S=e.$g,d=e.$g,f,o;const i=globalThis;let s;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?s=i.vscode.process:typeof process<"u"&&(s=process);const n=typeof s?.versions?.electron=="string",c=n&&s?.type==="renderer";if(typeof s=="object"){T=s.platform==="win32",g=s.platform==="darwin",I=s.platform==="linux",R=I&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,y=n,C=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.$g,S=e.$g;const w=s.env.VSCODE_NLS_CONFIG;if(w)try{const E=JSON.parse(w),P=E.availableLanguages["*"];p=E.locale,d=E.osLocale,S=P||e.$g,f=E._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!c?(o=navigator.userAgent,T=o.indexOf("Windows")>=0,g=o.indexOf("Macintosh")>=0,L=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=o.indexOf("Linux")>=0,m=o?.indexOf("Mobi")>=0,$=!0,p=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=p,d=navigator.language):console.error("Unable to resolve platform.");var t;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(t||(e.Platform=t={}));function a(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=a;let r=0;g?r=1:T?r=3:I&&(r=2),e.$i=T,e.$j=g,e.$k=I,e.$l=R,e.$m=b,e.$n=y,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=L,e.$s=m,e.$t=C,e.$u=r,e.$v=o,e.$w=S;var h;(function(w){function E(){return e.$w}w.value=E;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}w.isDefaultVariant=P;function N(){return e.$w==="en"}w.isDefault=N})(h||(e.Language=h={})),e.$x=p,e.$y=d,e.$z=f,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const w=[];i.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let N=0,z=w.length;N<z;N++){const F=w[N];if(F.id===P.data.vscodeScheduleAsyncWork){w.splice(N,1),F.callback();return}}});let E=0;return P=>{const N=++E;w.push({id:N,callback:P}),i.postMessage({vscodeScheduleAsyncWork:N},"*")}}return w=>setTimeout(w)})();var u;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=g||L?2:T?1:3;let l=!0,k=!1;function A(){if(!k){k=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,l=new Uint16Array(w.buffer)[0]===(2<<8)+1}return l}e.$D=A,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function v(w){return parseFloat(w)>=20}e.$J=v}),define(ke[49],Se([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let T;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.process<"u"){const I=g.process;T={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$dc=T.platform,e.$ec=T.arch}),define(ke[17],Se([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const T=65,g=97,I=90,R=122,b=46,$=47,y=92,L=58,C=63;class m extends Error{constructor(a,r,h){let u;typeof r=="string"&&r.indexOf("not ")===0?(u="must not be",r=r.replace(/^not /,"")):u="must be";const l=a.indexOf(".")!==-1?"property":"argument";let k=`The "${a}" ${l} ${u} of type ${r}`;k+=`. Received type ${typeof h}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function p(t,a){if(t===null||typeof t!="object")throw new m(a,"Object",t)}function S(t,a){if(typeof t!="string")throw new m(a,"string",t)}const d=D.$dc==="win32";function f(t){return t===$||t===y}function o(t){return t===$}function i(t){return t>=T&&t<=I||t>=g&&t<=R}function s(t,a,r,h){let u="",l=0,k=-1,A=0,v=0;for(let w=0;w<=t.length;++w){if(w<t.length)v=t.charCodeAt(w);else{if(h(v))break;v=$}if(h(v)){if(!(k===w-1||A===1))if(A===2){if(u.length<2||l!==2||u.charCodeAt(u.length-1)!==b||u.charCodeAt(u.length-2)!==b){if(u.length>2){const E=u.lastIndexOf(r);E===-1?(u="",l=0):(u=u.slice(0,E),l=u.length-1-u.lastIndexOf(r)),k=w,A=0;continue}else if(u.length!==0){u="",l=0,k=w,A=0;continue}}a&&(u+=u.length>0?`${r}..`:"..",l=2)}else u.length>0?u+=`${r}${t.slice(k+1,w)}`:u=t.slice(k+1,w),l=w-k-1;k=w,A=0}else v===b&&A!==-1?++A:A=-1}return u}function n(t,a){p(a,"pathObject");const r=a.dir||a.root,h=a.base||`${a.name||""}${a.ext||""}`;return r?r===a.root?`${r}${h}`:`${r}${t}${h}`:h}e.$fc={resolve(...t){let a="",r="",h=!1;for(let u=t.length-1;u>=-1;u--){let l;if(u>=0){if(l=t[u],S(l,"path"),l.length===0)continue}else a.length===0?l=D.cwd():(l=D.env[`=${a}`]||D.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==a.toLowerCase()&&l.charCodeAt(2)===y)&&(l=`${a}\\`));const k=l.length;let A=0,v="",w=!1;const E=l.charCodeAt(0);if(k===1)f(E)&&(A=1,w=!0);else if(f(E))if(w=!0,f(l.charCodeAt(1))){let P=2,N=P;for(;P<k&&!f(l.charCodeAt(P));)P++;if(P<k&&P!==N){const z=l.slice(N,P);for(N=P;P<k&&f(l.charCodeAt(P));)P++;if(P<k&&P!==N){for(N=P;P<k&&!f(l.charCodeAt(P));)P++;(P===k||P!==N)&&(v=`\\\\${z}\\${l.slice(N,P)}`,A=P)}}}else A=1;else i(E)&&l.charCodeAt(1)===L&&(v=l.slice(0,2),A=2,k>2&&f(l.charCodeAt(2))&&(w=!0,A=3));if(v.length>0)if(a.length>0){if(v.toLowerCase()!==a.toLowerCase())continue}else a=v;if(h){if(a.length>0)break}else if(r=`${l.slice(A)}\\${r}`,h=w,w&&a.length>0)break}return r=s(r,!h,"\\",f),h?`${a}\\${r}`:`${a}${r}`||"."},normalize(t){S(t,"path");const a=t.length;if(a===0)return".";let r=0,h,u=!1;const l=t.charCodeAt(0);if(a===1)return o(l)?"\\":t;if(f(l))if(u=!0,f(t.charCodeAt(1))){let A=2,v=A;for(;A<a&&!f(t.charCodeAt(A));)A++;if(A<a&&A!==v){const w=t.slice(v,A);for(v=A;A<a&&f(t.charCodeAt(A));)A++;if(A<a&&A!==v){for(v=A;A<a&&!f(t.charCodeAt(A));)A++;if(A===a)return`\\\\${w}\\${t.slice(v)}\\`;A!==v&&(h=`\\\\${w}\\${t.slice(v,A)}`,r=A)}}}else r=1;else i(l)&&t.charCodeAt(1)===L&&(h=t.slice(0,2),r=2,a>2&&f(t.charCodeAt(2))&&(u=!0,r=3));let k=r<a?s(t.slice(r),!u,"\\",f):"";return k.length===0&&!u&&(k="."),k.length>0&&f(t.charCodeAt(a-1))&&(k+="\\"),h===void 0?u?`\\${k}`:k:u?`${h}\\${k}`:`${h}${k}`},isAbsolute(t){S(t,"path");const a=t.length;if(a===0)return!1;const r=t.charCodeAt(0);return f(r)||a>2&&i(r)&&t.charCodeAt(1)===L&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,r;for(let l=0;l<t.length;++l){const k=t[l];S(k,"path"),k.length>0&&(a===void 0?a=r=k:a+=`\\${k}`)}if(a===void 0)return".";let h=!0,u=0;if(typeof r=="string"&&f(r.charCodeAt(0))){++u;const l=r.length;l>1&&f(r.charCodeAt(1))&&(++u,l>2&&(f(r.charCodeAt(2))?++u:h=!1))}if(h){for(;u<a.length&&f(a.charCodeAt(u));)u++;u>=2&&(a=`\\${a.slice(u)}`)}return e.$fc.normalize(a)},relative(t,a){if(S(t,"from"),S(a,"to"),t===a)return"";const r=e.$fc.resolve(t),h=e.$fc.resolve(a);if(r===h||(t=r.toLowerCase(),a=h.toLowerCase(),t===a))return"";let u=0;for(;u<t.length&&t.charCodeAt(u)===y;)u++;let l=t.length;for(;l-1>u&&t.charCodeAt(l-1)===y;)l--;const k=l-u;let A=0;for(;A<a.length&&a.charCodeAt(A)===y;)A++;let v=a.length;for(;v-1>A&&a.charCodeAt(v-1)===y;)v--;const w=v-A,E=k<w?k:w;let P=-1,N=0;for(;N<E;N++){const F=t.charCodeAt(u+N);if(F!==a.charCodeAt(A+N))break;F===y&&(P=N)}if(N!==E){if(P===-1)return h}else{if(w>E){if(a.charCodeAt(A+N)===y)return h.slice(A+N+1);if(N===2)return h.slice(A+N)}k>E&&(t.charCodeAt(u+N)===y?P=N:N===2&&(P=3)),P===-1&&(P=0)}let z="";for(N=u+P+1;N<=l;++N)(N===l||t.charCodeAt(N)===y)&&(z+=z.length===0?"..":"\\..");return A+=P,z.length>0?`${z}${h.slice(A,v)}`:(h.charCodeAt(A)===y&&++A,h.slice(A,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.$fc.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===y){if(a.charCodeAt(1)===y){const r=a.charCodeAt(2);if(r!==C&&r!==b)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(i(a.charCodeAt(0))&&a.charCodeAt(1)===L&&a.charCodeAt(2)===y)return`\\\\?\\${a}`;return t},dirname(t){S(t,"path");const a=t.length;if(a===0)return".";let r=-1,h=0;const u=t.charCodeAt(0);if(a===1)return f(u)?t:".";if(f(u)){if(r=h=1,f(t.charCodeAt(1))){let A=2,v=A;for(;A<a&&!f(t.charCodeAt(A));)A++;if(A<a&&A!==v){for(v=A;A<a&&f(t.charCodeAt(A));)A++;if(A<a&&A!==v){for(v=A;A<a&&!f(t.charCodeAt(A));)A++;if(A===a)return t;A!==v&&(r=h=A+1)}}}}else i(u)&&t.charCodeAt(1)===L&&(r=a>2&&f(t.charCodeAt(2))?3:2,h=r);let l=-1,k=!0;for(let A=a-1;A>=h;--A)if(f(t.charCodeAt(A))){if(!k){l=A;break}}else k=!1;if(l===-1){if(r===-1)return".";l=r}return t.slice(0,l)},basename(t,a){a!==void 0&&S(a,"ext"),S(t,"path");let r=0,h=-1,u=!0,l;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(r=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let k=a.length-1,A=-1;for(l=t.length-1;l>=r;--l){const v=t.charCodeAt(l);if(f(v)){if(!u){r=l+1;break}}else A===-1&&(u=!1,A=l+1),k>=0&&(v===a.charCodeAt(k)?--k===-1&&(h=l):(k=-1,h=A))}return r===h?h=A:h===-1&&(h=t.length),t.slice(r,h)}for(l=t.length-1;l>=r;--l)if(f(t.charCodeAt(l))){if(!u){r=l+1;break}}else h===-1&&(u=!1,h=l+1);return h===-1?"":t.slice(r,h)},extname(t){S(t,"path");let a=0,r=-1,h=0,u=-1,l=!0,k=0;t.length>=2&&t.charCodeAt(1)===L&&i(t.charCodeAt(0))&&(a=h=2);for(let A=t.length-1;A>=a;--A){const v=t.charCodeAt(A);if(f(v)){if(!l){h=A+1;break}continue}u===-1&&(l=!1,u=A+1),v===b?r===-1?r=A:k!==1&&(k=1):r!==-1&&(k=-1)}return r===-1||u===-1||k===0||k===1&&r===u-1&&r===h+1?"":t.slice(r,u)},format:n.bind(null,"\\"),parse(t){S(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const r=t.length;let h=0,u=t.charCodeAt(0);if(r===1)return f(u)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(f(u)){if(h=1,f(t.charCodeAt(1))){let P=2,N=P;for(;P<r&&!f(t.charCodeAt(P));)P++;if(P<r&&P!==N){for(N=P;P<r&&f(t.charCodeAt(P));)P++;if(P<r&&P!==N){for(N=P;P<r&&!f(t.charCodeAt(P));)P++;P===r?h=P:P!==N&&(h=P+1)}}}}else if(i(u)&&t.charCodeAt(1)===L){if(r<=2)return a.root=a.dir=t,a;if(h=2,f(t.charCodeAt(2))){if(r===3)return a.root=a.dir=t,a;h=3}}h>0&&(a.root=t.slice(0,h));let l=-1,k=h,A=-1,v=!0,w=t.length-1,E=0;for(;w>=h;--w){if(u=t.charCodeAt(w),f(u)){if(!v){k=w+1;break}continue}A===-1&&(v=!1,A=w+1),u===b?l===-1?l=w:E!==1&&(E=1):l!==-1&&(E=-1)}return A!==-1&&(l===-1||E===0||E===1&&l===A-1&&l===k+1?a.base=a.name=t.slice(k,A):(a.name=t.slice(k,l),a.base=t.slice(k,A),a.ext=t.slice(l,A))),k>0&&k!==h?a.dir=t.slice(0,k-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(d){const t=/\\/g;return()=>{const a=D.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let a="",r=!1;for(let h=t.length-1;h>=-1&&!r;h--){const u=h>=0?t[h]:c();S(u,"path"),u.length!==0&&(a=`${u}/${a}`,r=u.charCodeAt(0)===$)}return a=s(a,!r,"/",o),r?`/${a}`:a.length>0?a:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===$,r=t.charCodeAt(t.length-1)===$;return t=s(t,!a,"/",o),t.length===0?a?"/":r?"./":".":(r&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let a;for(let r=0;r<t.length;++r){const h=t[r];S(h,"path"),h.length>0&&(a===void 0?a=h:a+=`/${h}`)}return a===void 0?".":e.$gc.normalize(a)},relative(t,a){if(S(t,"from"),S(a,"to"),t===a||(t=e.$gc.resolve(t),a=e.$gc.resolve(a),t===a))return"";const r=1,h=t.length,u=h-r,l=1,k=a.length-l,A=u<k?u:k;let v=-1,w=0;for(;w<A;w++){const P=t.charCodeAt(r+w);if(P!==a.charCodeAt(l+w))break;P===$&&(v=w)}if(w===A)if(k>A){if(a.charCodeAt(l+w)===$)return a.slice(l+w+1);if(w===0)return a.slice(l+w)}else u>A&&(t.charCodeAt(r+w)===$?v=w:w===0&&(v=0));let E="";for(w=r+v+1;w<=h;++w)(w===h||t.charCodeAt(w)===$)&&(E+=E.length===0?"..":"/..");return`${E}${a.slice(l+v)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===$;let r=-1,h=!0;for(let u=t.length-1;u>=1;--u)if(t.charCodeAt(u)===$){if(!h){r=u;break}}else h=!1;return r===-1?a?"/":".":a&&r===1?"//":t.slice(0,r)},basename(t,a){a!==void 0&&S(a,"ext"),S(t,"path");let r=0,h=-1,u=!0,l;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let k=a.length-1,A=-1;for(l=t.length-1;l>=0;--l){const v=t.charCodeAt(l);if(v===$){if(!u){r=l+1;break}}else A===-1&&(u=!1,A=l+1),k>=0&&(v===a.charCodeAt(k)?--k===-1&&(h=l):(k=-1,h=A))}return r===h?h=A:h===-1&&(h=t.length),t.slice(r,h)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===$){if(!u){r=l+1;break}}else h===-1&&(u=!1,h=l+1);return h===-1?"":t.slice(r,h)},extname(t){S(t,"path");let a=-1,r=0,h=-1,u=!0,l=0;for(let k=t.length-1;k>=0;--k){const A=t.charCodeAt(k);if(A===$){if(!u){r=k+1;break}continue}h===-1&&(u=!1,h=k+1),A===b?a===-1?a=k:l!==1&&(l=1):a!==-1&&(l=-1)}return a===-1||h===-1||l===0||l===1&&a===h-1&&a===r+1?"":t.slice(a,h)},format:n.bind(null,"/"),parse(t){S(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const r=t.charCodeAt(0)===$;let h;r?(a.root="/",h=1):h=0;let u=-1,l=0,k=-1,A=!0,v=t.length-1,w=0;for(;v>=h;--v){const E=t.charCodeAt(v);if(E===$){if(!A){l=v+1;break}continue}k===-1&&(A=!1,k=v+1),E===b?u===-1?u=v:w!==1&&(w=1):u!==-1&&(w=-1)}if(k!==-1){const E=l===0&&r?1:l;u===-1||w===0||w===1&&u===k-1&&u===l+1?a.base=a.name=t.slice(E,k):(a.name=t.slice(E,u),a.base=t.slice(E,k),a.ext=t.slice(u,k))}return l>0?a.dir=t.slice(0,l-1):r&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=d?e.$fc.normalize:e.$gc.normalize,e.$ic=d?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=d?e.$fc.join:e.$gc.join,e.$kc=d?e.$fc.resolve:e.$gc.resolve,e.$lc=d?e.$fc.relative:e.$gc.relative,e.$mc=d?e.$fc.dirname:e.$gc.dirname,e.$nc=d?e.$fc.basename:e.$gc.basename,e.$oc=d?e.$fc.extname:e.$gc.extname,e.$pc=d?e.$fc.format:e.$gc.format,e.$qc=d?e.$fc.parse:e.$gc.parse,e.$rc=d?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=d?e.$fc.sep:e.$gc.sep,e.$tc=d?e.$fc.delimiter:e.$gc.delimiter}),define(ke[128],Se([1,0,43,17]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;const g=new D.$V(()=>{const A=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:A,collatorIsNumeric:A.resolvedOptions().numeric}}),I=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(A,v,w=!1){const E=A||"",P=v||"",N=g.value.collator.compare(E,P);return g.value.collatorIsNumeric&&N===0&&E!==P?E<P?-1:1:N}e.$Iq=b;function $(A,v){const w=I.value.collator;return A=A||"",v=v||"",n(w,A,v)}e.$Jq=$;function y(A,v){const w=I.value.collator;return A=A||"",v=v||"",r(A,v)||n(w,A,v)}e.$Kq=y;function L(A,v){const w=I.value.collator;return A=A||"",v=v||"",a(A,v)||n(w,A,v)}e.$Lq=L;function C(A,v){return A=A||"",v=v||"",A===v?0:A<v?-1:1}e.$Mq=C;function m(A,v){const[w,E]=i(A),[P,N]=i(v);let z=g.value.collator.compare(E,N);if(z===0){if(g.value.collatorIsNumeric&&E!==N)return E<N?-1:1;if(z=g.value.collator.compare(w,P),g.value.collatorIsNumeric&&z===0&&w!==P)return w<P?-1:1}return z}e.$Nq=m;function p(A,v){A=A||"",v=v||"";const w=s(A),E=s(v),P=I.value.collator,N=R.value.collator;return n(N,w,E)||n(P,A,v)}e.$Oq=p;function S(A,v){A=A||"",v=v||"";const w=s(A),E=s(v),P=I.value.collator,N=R.value.collator;return n(N,w,E)||r(A,v)||n(P,A,v)}e.$Pq=S;function d(A,v){A=A||"",v=v||"";const w=s(A),E=s(v),P=I.value.collator,N=R.value.collator;return n(N,w,E)||a(A,v)||n(P,A,v)}e.$Qq=d;function f(A,v){A=A||"",v=v||"";const w=s(A).toLowerCase(),E=s(v).toLowerCase();return w!==E?w<E?-1:1:A!==v?A<v?-1:1:0}e.$Rq=f;const o=/^(.*?)(\.([^.]*))?$/;function i(A,v=!1){const w=A?o.exec(A):[];let E=[w&&w[1]||"",w&&w[3]||""];return v&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function s(A){const v=A?o.exec(A):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function n(A,v,w){const E=A.compare(v,w);return E!==0?E:v.length!==w.length?v.length<w.length?-1:1:0}function c(A){const v=A.charAt(0);return v.toLocaleUpperCase()!==v}function t(A){const v=A.charAt(0);return v.toLocaleLowerCase()!==v}function a(A,v){return c(A)&&t(v)?-1:t(A)&&c(v)?1:0}function r(A,v){return t(A)&&c(v)?-1:c(A)&&t(v)?1:0}function h(A,v,w=!1){return w||(A=A&&A.toLowerCase(),v=v&&v.toLowerCase()),A===v?0:A<v?-1:1}function u(A,v,w=!1){const E=A.split(T.sep),P=v.split(T.sep),N=E.length-1,z=P.length-1;let F,j;for(let M=0;;M++){if(F=N===M,j=z===M,F&&j)return b(E[M],P[M],w);if(F)return-1;if(j)return 1;const O=h(E[M],P[M],w);if(O!==0)return O}}e.$Sq=u;function l(A,v,w){const E=A.toLowerCase(),P=v.toLowerCase(),N=k(A,v,w);if(N)return N;const z=E.endsWith(w),F=P.endsWith(w);if(z!==F)return z?-1:1;const j=b(E,P);return j!==0?j:E.localeCompare(P)}e.$Tq=l;function k(A,v,w){const E=A.toLowerCase(),P=v.toLowerCase(),N=E.startsWith(w),z=P.startsWith(w);if(N!==z)return N?-1:1;if(N&&z){if(E.length<P.length)return-1;if(E.length>P.length)return 1}return 0}e.$Uq=k}),define(ke[33],Se([1,0,17,10,12,18]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function R(l){return l===47||l===92}e.$1f=R;function b(l){return l.replace(/[\\/]/g,D.$gc.sep)}e.$2f=b;function $(l){return l.indexOf("/")===-1&&(l=b(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$3f=$;function y(l,k=D.$gc.sep){if(!l)return"";const A=l.length,v=l.charCodeAt(0);if(R(v)){if(R(l.charCodeAt(1))&&!R(l.charCodeAt(2))){let E=3;const P=E;for(;E<A&&!R(l.charCodeAt(E));E++);if(P!==E&&!R(l.charCodeAt(E+1))){for(E+=1;E<A;E++)if(R(l.charCodeAt(E)))return l.slice(0,E+1).replace(/[\\/]/g,k)}}return k}else if(o(v)&&l.charCodeAt(1)===58)return R(l.charCodeAt(2))?l.slice(0,2)+k:l.slice(0,2);let w=l.indexOf("://");if(w!==-1){for(w+=3;w<A;w++)if(R(l.charCodeAt(w)))return l.slice(0,w+1)}return""}e.$4f=y;function L(l){if(!T.$i||!l||l.length<5)return!1;let k=l.charCodeAt(0);if(k!==92||(k=l.charCodeAt(1),k!==92))return!1;let A=2;const v=A;for(;A<l.length&&(k=l.charCodeAt(A),k!==92);A++);return!(v===A||(k=l.charCodeAt(A+1),isNaN(k)||k===92))}e.$5f=L;const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(l,k=T.$i){const A=k?C:m;return!(!l||l.length===0||/^\s+$/.test(l)||(A.lastIndex=0,A.test(l))||k&&p.test(l)||l==="."||l===".."||k&&l[l.length-1]==="."||k&&l.length!==l.trim().length||l.length>255)}e.$6f=S;function d(l,k,A){const v=l===k;return!A||v?v:!l||!k?!1:(0,g.$_e)(l,k)}e.$7f=d;function f(l,k,A,v=D.sep){if(l===k)return!0;if(!l||!k||k.length>l.length)return!1;if(A){if(!(0,g.$af)(l,k))return!1;if(k.length===l.length)return!0;let E=k.length;return k.charAt(k.length-1)===v&&E--,l.charAt(E)===v}return k.charAt(k.length-1)!==v&&(k+=v),l.indexOf(k)===0}e.$8f=f;function o(l){return l>=65&&l<=90||l>=97&&l<=122}e.$9f=o;function i(l,k){return T.$i&&l.endsWith(":")&&(l+=D.sep),(0,D.$ic)(l)||(l=(0,D.$jc)(k,l)),l=(0,D.$hc)(l),T.$i?(l=(0,g.$Ue)(l,D.sep),l.endsWith(":")&&(l+=D.sep)):(l=(0,g.$Ue)(l,D.sep),l||(l=D.sep)),l}e.$0f=i;function s(l){const k=(0,D.$hc)(l);return T.$i?l.length>3?!1:n(k)&&(l.length===2||k.charCodeAt(2)===92):k===D.$gc.sep}e.$$f=s;function n(l,k=T.$i){return k?o(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$_f=n;function c(l,k=T.$i){return n(l,k)?l[0]:void 0}e.$ag=c;function t(l,k,A){return k.length>l.length?-1:l===k?0:(A&&(l=l.toLowerCase(),k=k.toLowerCase()),l.indexOf(k))}e.$bg=t;function a(l){const k=l.split(":");let A,v,w;for(const E of k){const P=Number(E);(0,I.$Mf)(P)?v===void 0?v=P:w===void 0&&(w=P):A=A?[A,E].join(":"):E}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:v!==void 0?v:void 0,column:w!==void 0?w:v!==void 0?1:void 0}}e.$cg=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(l,k,A=8){let v="";for(let E=0;E<A;E++){let P;E===0&&T.$i&&!k&&(A===3||A===4)?P=h:P=r,v+=P.charAt(Math.floor(Math.random()*P.length))}let w;return k?w=`${k}-${v}`:w=v,l?(0,D.$jc)(l,w):w}e.$dg=u}),define(ke[129],Se([1,0,128,123,54,17,10,12]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=void 0;const $=0,y=[$,[]];function L(U,Q,ue,Z){if(!U||!Q)return y;const J=U.length,X=Q.length;if(J<X)return y;const le=U.toLowerCase();return C(Q,ue,X,U,le,J,Z)}e.$Vq=L;function C(U,Q,ue,Z,J,X,le){const x=[],be=[];for(let ne=0;ne<ue;ne++){const ye=ne*X,de=ye-X,ge=ne>0,_=U[ne],te=Q[ne];for(let K=0;K<X;K++){const ie=K>0,fe=ye+K,pe=fe-1,Pe=de+K-1,we=ie?x[pe]:0,Ce=ge&&ie?x[Pe]:0,B=ge&&ie?be[Pe]:0;let Y;!Ce&&ge?Y=0:Y=m(_,te,Z,J,K,B),Y&&Ce+Y>=we&&(le||ge||J.startsWith(Q,K))?(be[fe]=B+1,x[fe]=Ce+Y):(be[fe]=$,x[fe]=we)}}const ce=[];let G=ue-1,W=X-1;for(;G>=0&&W>=0;){const ne=G*X+W;be[ne]===$||(ce.push(W),G--),W--}return[x[ue*X-1],ce.reverse()]}function m(U,Q,ue,Z,J,X){let le=0;if(!p(Q,Z[J]))return le;if(le+=1,X>0&&(le+=X*5),U===ue[J]&&(le+=1),J===0)le+=8;else{const x=S(ue.charCodeAt(J-1));x?le+=x:(0,T.$Xj)(ue.charCodeAt(J))&&X===0&&(le+=2)}return le}function p(U,Q){return U===Q?!0:U==="/"||U==="\\"?Q==="/"||Q==="\\":!1}function S(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function f(U,Q,ue=0,Z=0){const J=Q;return J.values&&J.values.length>1?o(U,J.values,ue,Z):i(U,Q,ue,Z)}e.$Wq=f;function o(U,Q,ue,Z){let J=0;const X=[];for(const le of Q){const[x,be]=i(U,le,ue,Z);if(typeof x!="number")return d;J+=x,X.push(...be)}return[J,A(X)]}function i(U,Q,ue,Z){const J=(0,T.$7j)(Q.original,Q.originalLowercase,ue,U,U.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,T.$4j)(J)]:d}const s=Object.freeze({score:0}),n=1<<18,c=1<<17,t=1<<16;function a(U,Q,ue,Z){const J=Z.values?Z.values:[Z];return(0,g.$Ti)({[Z.normalized]:{values:J.map(le=>({value:le.normalized,expectContiguousMatch:le.expectContiguousMatch})),label:U,description:Q,allowNonContiguousMatches:ue}})}function r(U,Q,ue,Z,J){if(!U||!Q.normalized)return s;const X=Z.getItemLabel(U);if(!X)return s;const le=Z.getItemDescription(U),x=a(X,le,ue,Q),be=J[x];if(be)return be;const ce=h(X,le,Z.getItemPath(U),Q,ue);return J[x]=ce,ce}e.$Xq=r;function h(U,Q,ue,Z,J){const X=!ue||!Z.containsPathSeparator;return ue&&(R.$k?Z.pathNormalized===ue:(0,b.$_e)(Z.pathNormalized,ue))?{score:n,labelMatch:[{start:0,end:U.length}],descriptionMatch:Q?[{start:0,end:Q.length}]:void 0}:Z.values&&Z.values.length>1?u(U,Q,ue,Z.values,X,J):l(U,Q,ue,Z,X,J)}function u(U,Q,ue,Z,J,X){let le=0;const x=[],be=[];for(const ce of Z){const{score:G,labelMatch:W,descriptionMatch:ne}=l(U,Q,ue,ce,J,X);if(G===$)return s;le+=G,W&&x.push(...W),ne&&be.push(...ne)}return{score:le,labelMatch:A(x),descriptionMatch:A(be)}}function l(U,Q,ue,Z,J,X){if(J||!Q){const[le,x]=L(U,Z.normalized,Z.normalizedLowercase,X&&!Z.expectContiguousMatch);if(le){const be=(0,T.$Uj)(Z.normalized,U);let ce;if(be){ce=c;const G=Math.round(Z.normalized.length/U.length*100);ce+=G}else ce=t;return{score:ce+le,labelMatch:be||k(x)}}}if(Q){let le=Q;ue&&(le=`${Q}${I.sep}`);const x=le.length,be=`${le}${U}`,[ce,G]=L(be,Z.normalized,Z.normalizedLowercase,X&&!Z.expectContiguousMatch);if(ce){const W=k(G),ne=[],ye=[];return W.forEach(de=>{de.start<x&&de.end>x?(ne.push({start:0,end:de.end-x}),ye.push({start:de.start,end:x})):de.start>=x?ne.push({start:de.start-x,end:de.end-x}):ye.push(de)}),{score:ce,labelMatch:ne,descriptionMatch:ye}}}return s}function k(U){const Q=[];if(!U)return Q;let ue;for(const Z of U)ue&&ue.end===Z?ue.end+=1:(ue={start:Z,end:Z+1},Q.push(ue));return Q}function A(U){const Q=U.sort((J,X)=>J.start-X.start),ue=[];let Z;for(const J of Q)!Z||!v(Z,J)?(Z=J,ue.push(J)):(Z.start=Math.min(Z.start,J.start),Z.end=Math.max(Z.end,J.end));return ue}function v(U,Q){return!(U.end<Q.start||Q.end<U.start)}function w(U,Q,ue,Z,J,X){const le=r(U,ue,Z,J,X),x=r(Q,ue,Z,J,X),be=le.score,ce=x.score;if((be===n||ce===n)&&be!==ce)return be===n?-1:1;if(be>t||ce>t){if(be!==ce)return be>ce?-1:1;if(be<c&&ce<c){const _=P(le.labelMatch,x.labelMatch);if(_!==0)return _}const de=J.getItemLabel(U)||"",ge=J.getItemLabel(Q)||"";if(de.length!==ge.length)return de.length-ge.length}if(be!==ce)return be>ce?-1:1;const G=Array.isArray(le.labelMatch)&&le.labelMatch.length>0,W=Array.isArray(x.labelMatch)&&x.labelMatch.length>0;if(G&&!W)return-1;if(W&&!G)return 1;const ne=E(U,le,J),ye=E(Q,x,J);return ne&&ye&&ne!==ye?ye>ne?-1:1:N(U,Q,ue,J)}e.$Yq=w;function E(U,Q,ue){let Z=-1,J=-1;if(Q.descriptionMatch&&Q.descriptionMatch.length?Z=Q.descriptionMatch[0].start:Q.labelMatch&&Q.labelMatch.length&&(Z=Q.labelMatch[0].start),Q.labelMatch&&Q.labelMatch.length){if(J=Q.labelMatch[Q.labelMatch.length-1].end,Q.descriptionMatch&&Q.descriptionMatch.length){const X=ue.getItemDescription(U);X&&(J+=X.length)}}else Q.descriptionMatch&&Q.descriptionMatch.length&&(J=Q.descriptionMatch[Q.descriptionMatch.length-1].end);return J-Z}function P(U,Q){if(!U&&!Q||(!U||!U.length)&&(!Q||!Q.length))return 0;if(!Q||!Q.length)return-1;if(!U||!U.length)return 1;const ue=U[0].start,J=U[U.length-1].end-ue,X=Q[0].start,x=Q[Q.length-1].end-X;return J===x?0:x<J?1:-1}function N(U,Q,ue,Z){const J=Z.getItemLabel(U)||"",X=Z.getItemLabel(Q)||"",le=Z.getItemDescription(U),x=Z.getItemDescription(Q),be=J.length+(le?le.length:0),ce=X.length+(x?x.length:0);if(be!==ce)return be-ce;const G=Z.getItemPath(U),W=Z.getItemPath(Q);return G&&W&&G.length!==W.length?G.length-W.length:J!==X?(0,D.$Tq)(J,X,ue.normalized):le&&x&&le!==x?(0,D.$Tq)(le,x,ue.normalized):G&&W&&G!==W?(0,D.$Tq)(G,W,ue.normalized):0}function z(U){return U.startsWith('"')&&U.endsWith('"')}const F=" ";function j(U){typeof U!="string"&&(U="");const Q=U.toLowerCase(),{pathNormalized:ue,normalized:Z,normalizedLowercase:J}=M(U),X=ue.indexOf(I.sep)>=0,le=z(U);let x;const be=U.split(F);if(be.length>1)for(const ce of be){const G=z(ce),{pathNormalized:W,normalized:ne,normalizedLowercase:ye}=M(ce);ne&&(x||(x=[]),x.push({original:ce,originalLowercase:ce.toLowerCase(),pathNormalized:W,normalized:ne,normalizedLowercase:ye,expectContiguousMatch:G}))}return{original:U,originalLowercase:Q,pathNormalized:ue,normalized:Z,normalizedLowercase:J,values:x,containsPathSeparator:X,expectContiguousMatch:le}}e.$Zq=j;function M(U){let Q;R.$i?Q=U.replace(/\//g,I.sep):Q=U.replace(/\\/g,I.sep);const ue=(0,b.$We)(Q).replace(/\s|"/g,"");return{pathNormalized:Q,normalized:ue,normalizedLowercase:ue.toLowerCase()}}function O(U){return Array.isArray(U)?j(U.map(Q=>Q.original).join(F)):j(U.original)}e.$1q=O}),define(ke[101],Se([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0,e.$fs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(L){const C=(0,D.$oc)(L),m=T[C.toLowerCase()];return m!==void 0?m:R(L)}e.$gs=I;function R(L){const C=(0,D.$oc)(L);return g[C.toLowerCase()]}e.$hs=R;function b(L){for(const C in g)if(g[C]===L)return C}e.$is=b;const $=/^(.+)\/(.+?)(;.+)?$/;function y(L,C){const m=$.exec(L);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:L}e.$js=y}),define(ke[102],Se([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0;var T;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(T||(e.Source=T={}));var g;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function I(b,...$){const y=$.reduce((m,p)=>(m[p]=!0,m),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!y[m]).forEach(m=>{for(let p=0;p<L.length;p++)if(m.search(L[p])!==-1){delete b[m];break}})}e.$Rl=I;function R(b){b&&(delete b.DEBUG,D.$j&&delete b.DYLD_LIBRARY_PATH,D.$k&&delete b.LD_PRELOAD)}e.$Sl=R}),define(ke[2],Se([1,0,17,10]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,I=/^\//,R=/^\/\//;function b(h,u){if(!h.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!g.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!I.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(h,u){return!h&&!u?"file":h}function y(h,u){switch(h){case"https":case"http":case"file":u?u[0]!==C&&(u=C+u):u=C;break}return u}const L="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(u){return u instanceof p?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,l,k,A,v,w=!1){typeof u=="object"?(this.scheme=u.scheme||L,this.authority=u.authority||L,this.path=u.path||L,this.query=u.query||L,this.fragment=u.fragment||L):(this.scheme=$(u,w),this.authority=l||L,this.path=y(this.scheme,k||L),this.query=A||L,this.fragment=v||L,b(this,w))}get fsPath(){return n(this,!1)}with(u){if(!u)return this;let{scheme:l,authority:k,path:A,query:v,fragment:w}=u;return l===void 0?l=this.scheme:l===null&&(l=L),k===void 0?k=this.authority:k===null&&(k=L),A===void 0?A=this.path:A===null&&(A=L),v===void 0?v=this.query:v===null&&(v=L),w===void 0?w=this.fragment:w===null&&(w=L),l===this.scheme&&k===this.authority&&A===this.path&&v===this.query&&w===this.fragment?this:new f(l,k,A,v,w)}static parse(u,l=!1){const k=m.exec(u);return k?new f(k[2]||L,r(k[4]||L),r(k[5]||L),r(k[7]||L),r(k[9]||L),l):new f(L,L,L,L,L)}static file(u){let l=L;if(T.$i&&(u=u.replace(/\\/g,C)),u[0]===C&&u[1]===C){const k=u.indexOf(C,2);k===-1?(l=u.substring(2),u=C):(l=u.substring(2,k),u=u.substring(k)||C)}return new f("file",l,u,L,L)}static from(u,l){return new f(u.scheme,u.authority,u.path,u.query,u.fragment,l)}static joinPath(u,...l){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return T.$i&&u.scheme==="file"?k=p.file(D.$fc.join(n(u,!0),...l)).path:k=D.$gc.join(u.path,...l),u.with({path:k})}toString(u=!1){return c(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof p)return u;{const l=new f(u);return l._formatted=u.external??null,l._fsPath=u._sep===d?u.fsPath??null:null,l}}else return u}}e.URI=p;function S(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}e.$vc=S;const d=T.$i?1:void 0;class f extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(u=!1){return u?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=d),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(h,u,l){let k,A=-1;for(let v=0;v<h.length;v++){const w=h.charCodeAt(v);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||u&&w===47||l&&w===91||l&&w===93||l&&w===58)A!==-1&&(k+=encodeURIComponent(h.substring(A,v)),A=-1),k!==void 0&&(k+=h.charAt(v));else{k===void 0&&(k=h.substr(0,v));const E=o[w];E!==void 0?(A!==-1&&(k+=encodeURIComponent(h.substring(A,v)),A=-1),k+=E):A===-1&&(A=v)}}return A!==-1&&(k+=encodeURIComponent(h.substring(A))),k!==void 0?k:h}function s(h){let u;for(let l=0;l<h.length;l++){const k=h.charCodeAt(l);k===35||k===63?(u===void 0&&(u=h.substr(0,l)),u+=o[k]):u!==void 0&&(u+=h[l])}return u!==void 0?u:h}function n(h,u){let l;return h.authority&&h.path.length>1&&h.scheme==="file"?l=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?u?l=h.path.substr(1):l=h.path[1].toLowerCase()+h.path.substr(2):l=h.path,T.$i&&(l=l.replace(/\//g,"\\")),l}e.$wc=n;function c(h,u){const l=u?s:i;let k="",{scheme:A,authority:v,path:w,query:E,fragment:P}=h;if(A&&(k+=A,k+=":"),(v||A==="file")&&(k+=C,k+=C),v){let N=v.indexOf("@");if(N!==-1){const z=v.substr(0,N);v=v.substr(N+1),N=z.lastIndexOf(":"),N===-1?k+=l(z,!1,!1):(k+=l(z.substr(0,N),!1,!1),k+=":",k+=l(z.substr(N+1),!1,!0)),k+="@"}v=v.toLowerCase(),N=v.lastIndexOf(":"),N===-1?k+=l(v,!1,!0):(k+=l(v.substr(0,N),!1,!0),k+=v.substr(N))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const N=w.charCodeAt(1);N>=65&&N<=90&&(w=`/${String.fromCharCode(N+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const N=w.charCodeAt(0);N>=65&&N<=90&&(w=`${String.fromCharCode(N+32)}:${w.substr(2)}`)}k+=l(w,!0,!1)}return E&&(k+="?",k+=l(E,!1,!1)),P&&(k+="#",k+=u?P:i(P,!1,!1)),k}function t(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+t(h.substr(3)):h}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(h){return h.match(a)?h.replace(a,u=>t(u)):h}}),define(ke[185],Se([1,0,2]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$oq=e.$nq=e.$mq=void 0;function T(y){const L=y;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.$mq=T;function g(y){const L=[];let C;try{const m=JSON.parse(y.arguments),p=m[m.length-1];p&&p.__$stack&&(m.pop(),C=p.__$stack),L.push(...m)}catch{L.push("Unable to log remote console arguments",y.arguments)}return{args:L,stack:C}}e.$nq=g;function I(y){if(typeof y!="string")return I(g(y).stack);const L=y;if(L){const C=R(L),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$oq=I;function R(y){if(!y)return y;const L=y.indexOf(`
`);return L===-1?y:y.substring(0,L)}function b(y,L){const{args:C,stack:m}=g(y),p=typeof C[0]=="string"&&C.length===1;let S=R(m);S&&(S=`(${S.trim()})`);let d=[];if(typeof C[0]=="string"?S&&p?d=[`%c[${L}] %c${C[0]} %c${S}`,$("blue"),$(""),$("grey")]:d=[`%c[${L}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:d=[`%c[${L}]%`,$("blue"),...C],S&&!p&&d.push(S),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,d)}e.log=b;function $(y){return`color: ${y}`}}),define(ke[55],Se([1,0,22,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function g($){return JSON.stringify($,R)}e.$Ah=g;function I($){let y=JSON.parse($);return y=b(y),y}e.$Bh=I;function R($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function b($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return T.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$je||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let L=0;L<$.length;++L)$[L]=b($[L],y+1);else for(const L in $)Object.hasOwnProperty.call($,L)&&($[L]=b($[L],y+1))}return $}e.$Ch=b}),define(ke[16],Se([1,0,14,10,12,2]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var R;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function b(m,p){return I.URI.isUri(m)?(0,g.$_e)(m.scheme,p):(0,g.$af)(m,p+":")}e.$eg=b;function $(m,...p){return p.some(S=>b(m,S))}e.$fg=$,e.$gg="vscode-tkn",e.$hg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${R.vscodeRemoteResource}`}set(p,S,d){this.a[p]=S,this.b[p]=d}setConnectionToken(p,S){this.c[p]=S}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(s){return D.$1(s),p}const S=p.authority;let d=this.a[S];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const f=this.b[S],o=this.c[S];let i=`path=${encodeURIComponent(p.path)}`;return typeof o=="string"&&(i+=`&${e.$hg}=${encodeURIComponent(o)}`),I.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${d}:${f}`,path:this.f,query:i})}}e.$ig=new y,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class L{static{this.a=e.$ng}asBrowserUri(p){const S=this.b(p,me);return this.uriToBrowserUri(S)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.$ig.rewrite(p):p.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${L.a}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||L.a,query:null,fragment:null}):p}asFileUri(p){const S=this.b(p,me);return this.uriToFileUri(S)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==L.a?p.authority:null,query:null,fragment:null}):p}b(p,S){return I.URI.isUri(p)?p:I.URI.parse(S.toUrl(p))}}e.$og=new L;var C;(function(m){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(p.get("3"));const S="vscode-coi";function d(o){let i;typeof o=="string"?i=new URL(o).searchParams:o instanceof URL?i=o.searchParams:I.URI.isUri(o)&&(i=new URL(o.toString(!0)).searchParams);const s=i?.get(S);if(s)return p.get(s)}m.getHeadersFromQuery=d;function f(o,i,s){if(!globalThis.crossOriginIsolated)return;const n=i&&s?"3":s?"2":"1";o instanceof URLSearchParams?o.set(S,n):o[S]=n}m.addSearchParam=f})(C||(e.COI=C={}))}),define(ke[186],Se([1,0,157,16,10,2]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=void 0;class R{constructor(m,p,S){this.id=m,this.dependencies=p,this.callback=S}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,p,S)=>{typeof m!="string"&&(S=p,p=m,m=null),(typeof p!="object"||!Array.isArray(p))&&(S=p,p=null),this.c.push(new R(m,p,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const p=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!p)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}h(m){return new Promise((p,S)=>{const d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript");const f=()=>{d.removeEventListener("load",o),d.removeEventListener("error",i)},o=s=>{f(),p(this.c.pop())},i=s=>{f(),S(s)};d.addEventListener("load",o),d.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),d.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(d)})}i(m){return new Promise((p,S)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),p(this.c.pop())}catch(d){S(d)}})}async j(m){try{const p=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,d=globalThis._VSCODE_NODE_MODULES.module,f=I.URI.parse(m).fsPath,o=p.readFileSync(f).toString(),i=d.wrap(o.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(p){throw p}}}const $=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function L(C,m,p){if(D.$T){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[C]&&(C=y[C]);const S=`${C}/${m}`;if($.has(S))return $.get(S);let d;if(/^\w[\w\d+.-]*:\/\//.test(S))d=S;else{const s=`${p&&!g.$o?T.$lg:T.$kg}/${S}`;d=T.$og.asBrowserUri(s).toString(!0)}const f=b.INSTANCE.load(d);return $.set(S,f),f}else return await new Promise((S,d)=>{me([C],S,d)})}e.$fD=L}),define(ke[23],Se([1,0,33,16,17,10,12,2]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function $(p){return(0,b.$wc)(p,!0)}e.$vg=$;class y{constructor(S){this.a=S}compare(S,d,f=!1){return S===d?0:(0,R.$5e)(this.getComparisonKey(S,f),this.getComparisonKey(d,f))}isEqual(S,d,f=!1){return S===d?!0:!S||!d?!1:this.getComparisonKey(S,f)===this.getComparisonKey(d,f)}getComparisonKey(S,d=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,d,f=!1){if(S.scheme===d.scheme){if(S.scheme===T.Schemas.file)return D.$8f($(S),$(d),this.a(S))&&S.query===d.query&&(f||S.fragment===d.fragment);if((0,e.$Mg)(S.authority,d.authority))return D.$8f(S.path,d.path,this.a(S),"/")&&S.query===d.query&&(f||S.fragment===d.fragment)}return!1}joinPath(S,...d){return b.URI.joinPath(S,...d)}basenameOrAuthority(S){return(0,e.$Eg)(S)||S.authority}basename(S){return g.$gc.basename(S.path)}extname(S){return g.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let d;return S.scheme===T.Schemas.file?d=b.URI.file(g.$mc($(S))).path:(d=g.$gc.dirname(S.path),S.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),d="/")),S.with({path:d})}normalizePath(S){if(!S.path.length)return S;let d;return S.scheme===T.Schemas.file?d=b.URI.file(g.$hc($(S))).path:d=g.$gc.normalize(S.path),S.with({path:d})}relativePath(S,d){if(S.scheme!==d.scheme||!(0,e.$Mg)(S.authority,d.authority))return;if(S.scheme===T.Schemas.file){const i=g.$lc($(S),$(d));return I.$i?D.$2f(i):i}let f=S.path||"/";const o=d.path||"/";if(this.a(S)){let i=0;for(const s=Math.min(f.length,o.length);i<s&&!(f.charCodeAt(i)!==o.charCodeAt(i)&&f.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);f=o.substr(0,i)+f.substr(i)}return g.$gc.relative(f,o)}resolvePath(S,d){if(S.scheme===T.Schemas.file){const f=b.URI.file(g.$kc($(S),d));return S.with({authority:f.authority,path:f.path})}return d=D.$3f(d),S.with({path:g.$gc.resolve(S.path,d)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,d){return S===d||S!==void 0&&d!==void 0&&(0,R.$_e)(S,d)}hasTrailingPathSeparator(S,d=g.sep){if(S.scheme===T.Schemas.file){const f=$(S);return f.length>D.$4f(f).length&&f[f.length-1]===d}else{const f=S.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,d=g.sep){return(0,e.$Ng)(S,d)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,d=g.sep){let f=!1;if(S.scheme===T.Schemas.file){const o=$(S);f=o!==void 0&&o.length===D.$4f(o).length&&o[o.length-1]===d}else{d="/";const o=S.path;f=o.length===1&&o.charCodeAt(o.length-1)===47}return!f&&!(0,e.$Ng)(S,d)?S.with({path:S.path+"/"}):S}}e.$wg=y,e.$xg=new y(()=>!1),e.$yg=new y(p=>p.scheme===T.Schemas.file?!I.$k:!0),e.$zg=new y(p=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function L(p,S){const d=[];for(let f=0;f<p.length;f++){const o=S(p[f]);p.some((i,s)=>s===f?!1:(0,e.$Bg)(o,S(i)))||d.push(p[f])}return d}e.$Qg=L;var C;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function S(d){const f=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(s=>{const[n,c]=s.split(":");n&&c&&f.set(n,c)});const i=d.path.substring(0,d.path.indexOf(";"));return i&&f.set(p.META_DATA_MIME,i),f}p.parseMetaData=S})(C||(e.DataUri=C={}));function m(p,S,d){if(S){let f=p.path;return f&&f[0]!==g.$gc.sep&&(f=g.$gc.sep+f),p.with({scheme:d,authority:S,path:f})}return p.with({scheme:d})}e.$Rg=m}),define(ke[11],Se([1,0,21,14,4,3,23,10,163,43]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function L(_){return!!_&&typeof _.then=="function"}e.$Sg=L;function C(_){const te=new D.$6d,K=_(te.token),ie=new Promise((fe,pe)=>{const Pe=te.token.onCancellationRequested(()=>{Pe.dispose(),pe(new T.$5)});Promise.resolve(K).then(we=>{Pe.dispose(),te.dispose(),fe(we)},we=>{Pe.dispose(),te.dispose(),pe(we)})});return new class{cancel(){te.cancel(),te.dispose()}then(fe,pe){return ie.then(fe,pe)}catch(fe){return this.then(void 0,fe)}finally(fe){return ie.finally(fe)}}}e.$Tg=C;function m(_,te,K){return new Promise((ie,fe)=>{const pe=te.onCancellationRequested(()=>{pe.dispose(),ie(K)});_.then(ie,fe).finally(()=>pe.dispose())})}e.$Ug=m;function p(_,te){return new Promise((K,ie)=>{const fe=te.onCancellationRequested(()=>{fe.dispose(),ie(new T.$5)});_.then(K,ie).finally(()=>fe.dispose())})}e.$Vg=p;async function S(_){let te=-1;const K=_.map((ie,fe)=>ie.then(pe=>(te=fe,pe)));try{return await Promise.race(K)}finally{_.forEach((ie,fe)=>{fe!==te&&ie.cancel()})}}e.$Wg=S;function d(_,te,K){let ie;const fe=setTimeout(()=>{ie?.(void 0),K?.()},te);return Promise.race([_.finally(()=>clearTimeout(fe)),new Promise(pe=>ie=pe)])}e.$Xg=d;function f(_){return new Promise((te,K)=>{const ie=_();L(ie)?ie.then(te,K):te(ie)})}e.$Yg=f;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const K=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(K,K).then(ie)})}return new Promise((K,ie)=>{this.b.then(K,ie)})}return this.a=te(),new Promise((K,ie)=>{this.a.then(fe=>{this.a=null,K(fe)},fe=>{this.a=null,ie(fe)})})}dispose(){this.f=!0}}e.$Zg=o;class i{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$1g=i;class s{constructor(){this.a=new Map}queue(te,K){const fe=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.a.get(te)===fe&&this.a.delete(te)});return this.a.set(te,fe),fe}}e.$2g=s;const n=(_,te)=>{let K=!0;const ie=setTimeout(()=>{K=!1,te()},_);return{isTriggered:()=>K,dispose:()=>{clearTimeout(ie),K=!1}}},c=_=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,_())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class t{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,K=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise((fe,pe)=>{this.d=fe,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=K===$.$Sd?c(ie):n(K,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=t;class a{constructor(te){this.a=new t(te),this.b=new o}trigger(te,K){return this.a.trigger(()=>this.b.queue(te),K)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=a;class r{constructor(){this.a=!1,this.b=new Promise((te,K)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=r;class h extends r{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$6g=h;function u(_,te){return te?new Promise((K,ie)=>{const fe=setTimeout(()=>{pe.dispose(),K()},_),pe=te.onCancellationRequested(()=>{clearTimeout(fe),pe.dispose(),ie(new T.$5)})}):C(K=>u(_,K))}e.$7g=u;function l(_,te=0,K){const ie=setTimeout(()=>{_(),K&&fe.dispose()},te),fe=(0,I.$Rc)(()=>{clearTimeout(ie),K?.deleteAndLeak(fe)});return K?.add(fe),fe}e.$8g=l;function k(_){const te=[];let K=0;const ie=_.length;function fe(){return K<ie?_[K++]():null}function pe(Pe){Pe!=null&&te.push(Pe);const we=fe();return we?we.then(pe):Promise.resolve(te)}return Promise.resolve(null).then(pe)}e.$9g=k;function A(_,te=ie=>!!ie,K=null){let ie=0;const fe=_.length,pe=()=>{if(ie>=fe)return Promise.resolve(K);const Pe=_[ie++];return Promise.resolve(Pe()).then(Ce=>te(Ce)?Promise.resolve(Ce):pe())};return pe()}e.$0g=A;function v(_,te=ie=>!!ie,K=null){if(_.length===0)return Promise.resolve(K);let ie=_.length;const fe=()=>{ie=-1;for(const pe of _)pe.cancel?.()};return new Promise((pe,Pe)=>{for(const we of _)we.then(Ce=>{--ie>=0&&te(Ce)?(fe(),pe(Ce)):ie===0&&pe(K)}).catch(Ce=>{--ie>=0&&(fe(),Pe(Ce))})})}e.$$g=v;class w{constructor(te){this.a=0,this.b=!1,this.f=te,this.g=[],this.d=0,this.h=new g.$Vd}whenIdle(){return this.size>0?g.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(te){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((K,ie)=>{this.g.push({factory:te,c:K,e:ie}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const te=this.g.shift();this.d++;const K=te.factory();K.then(te.c,te.e),K.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=w;class E extends w{constructor(){super(1)}}e.$ah=E;class P{constructor(){this.a=new J,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$bh=P;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new x;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueSize(te,K=R.$xg){const ie=K.getComparisonKey(te);return this.a.get(ie)?.size??0}queueFor(te,K,ie=R.$xg){const fe=ie.getComparisonKey(te);let pe=this.a.get(fe);if(!pe){pe=new E;const Pe=this.f++,we=g.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(Pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$3c),this.d.set(Pe,we),this.a.set(fe,pe)}return pe.queue(K)}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=N;class z{constructor(te,K){this.a=-1,typeof te=="function"&&typeof K=="number"&&this.setIfNotSet(te,K)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,K){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},K)}setIfNotSet(te,K){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},K))}}e.$dh=z;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,K,ie=globalThis){this.cancel();const fe=ie.setInterval(()=>{te()},K);this.d=(0,I.$Rc)(()=>{ie.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$eh=F;class j{constructor(te,K){this.b=-1,this.a=te,this.d=K,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=j;class M{constructor(te,K){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.a=te,this.b=K,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=M;class O extends j{constructor(te,K){super(te,K),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$hh=O;class U extends I.$Tc{constructor(te,K){super(),this.g=te,this.h=K,this.a=[],this.b=this.B(new I.$Uc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const K of te)this.a.push(K);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=U,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(_,te)=>{(0,b.$B)(()=>{if(K)return;const ie=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e.$kh=(_,te,K)=>{const ie=_.requestIdleCallback(te,typeof K=="number"?{timeout:K}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,_.cancelIdleCallback(ie))}}},e.$jh=_=>(0,e.$kh)(globalThis,_)}();class Q{constructor(te,K){this.g=!1,this.d=()=>{try{this.j=K()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$kh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=Q;class ue extends Q{constructor(te){super(globalThis,te)}}e.$mh=ue;async function Z(_,te,K){let ie;for(let fe=0;fe<K;fe++)try{return await _()}catch(pe){ie=pe,await u(te)}throw ie}e.$nh=Z;class J{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,K,ie){return this.a={taskId:te,cancel:()=>ie?.(),promise:K},K.then(()=>this.d(te),()=>this.d(te)),K}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let K,ie;const fe=new Promise((pe,Pe)=>{K=pe,ie=Pe});this.b={run:te,promise:fe,promiseResolve:K,promiseReject:ie}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=J;class X{constructor(te,K=()=>Date.now()){this.d=te,this.f=K,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$ph=X;var le;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(le||(le={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,K)=>{this.a=te,this.b=K})}complete(te){return new Promise(K=>{this.a(te),this.d={outcome:0,value:te},K()})}error(te){return new Promise(K=>{this.b(te),this.d={outcome:1,value:te},K()})}cancel(){return this.error(new T.$5)}}e.$qh=x;var be;(function(_){async function te(ie){let fe;const pe=await Promise.all(ie.map(Pe=>Pe.then(we=>we,we=>{fe||(fe=we)})));if(typeof fe<"u")throw fe;return pe}_.settled=te;function K(ie){return new Promise(async(fe,pe)=>{try{await ie(fe,pe)}catch(Pe){pe(Pe)}})}_.withAsyncBody=K})(be||(e.Promises=be={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(K=>(this.a=K,this.d=!0,K),K=>{throw this.b=K,this.d=!0,K})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=ce;class G{constructor(te){this.b=te,this.a=new y.$V(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=G;var W;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(W||(W={}));class ne{static fromArray(te){return new ne(K=>{K.emitMany(te)})}static fromPromise(te){return new ne(async K=>{K.emitMany(await te)})}static fromPromises(te){return new ne(async K=>{await Promise.all(te.map(async ie=>K.emitOne(await ie)))})}static merge(te){return new ne(async K=>{await Promise.all(te.map(async ie=>{for await(const fe of ie)K.emitOne(fe)}))})}static{this.EMPTY=ne.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new g.$Vd,queueMicrotask(async()=>{const K={emitOne:ie=>this.g(ie),emitMany:ie=>this.h(ie),reject:ie=>this.k(ie)};try{await Promise.resolve(te(K)),this.j()}catch(ie){this.k(ie)}finally{K.emitOne=void 0,K.emitMany=void 0,K.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(te,K){return new ne(async ie=>{for await(const fe of te)ie.emitOne(K(fe))})}map(te){return ne.map(this,te)}static filter(te,K){return new ne(async ie=>{for await(const fe of te)K(fe)&&ie.emitOne(fe)})}filter(te){return ne.filter(this,te)}static coalesce(te){return ne.filter(te,K=>!!K)}coalesce(){return ne.coalesce(this)}static async toPromise(te){const K=[];for await(const ie of te)K.push(ie);return K}toPromise(){return ne.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$th=ne;class ye extends ne{constructor(te,K){super(K),this.l=te}cancel(){this.l.cancel()}}e.$uh=ye;function de(_){const te=new D.$6d,K=_(te.token);return new ye(te,async ie=>{const fe=te.token.onCancellationRequested(()=>{fe.dispose(),te.dispose(),ie.reject(new T.$5)});try{for await(const pe of K){if(te.token.isCancellationRequested)return;ie.emitOne(pe)}fe.dispose(),te.dispose()}catch(pe){fe.dispose(),te.dispose(),ie.reject(pe)}})}e.$vh=de;class ge{constructor(){this.a=new x,this.b=new ne(ie=>{if(te){ie.reject(te);return}return K&&ie.emitMany(K),this.d=fe=>ie.reject(fe),this.f=fe=>ie.emitOne(fe),this.a.p});let te,K;this.f=ie=>{K||(K=[]),K.push(ie)},this.d=ie=>{te||(te=ie)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$wh=ge}),define(ke[34],Se([1,0,19,11,33,28,17,10,12]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=void 0;function y(){return Object.create(null)}e.$Hj=y,e.$Ij="**",e.$Jj="/";const L="[/\\\\]",C="[^/\\\\]",m=/\//g;function p(ue,Z){switch(ue){case 0:return"";case 1:return`${C}*?`;default:return`(?:${L}|${C}+${L}${Z?`|${L}${C}+`:""})*?`}}function S(ue,Z){if(!ue)return[];const J=[];let X=!1,le=!1,x="";for(const be of ue){switch(be){case Z:if(!X&&!le){J.push(x),x="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":le=!0;break;case"]":le=!1;break}x+=be}return x&&J.push(x),J}e.$Kj=S;function d(ue){if(!ue)return"";let Z="";const J=S(ue,e.$Jj);if(J.every(X=>X===e.$Ij))Z=".*";else{let X=!1;J.forEach((le,x)=>{if(le===e.$Ij){if(X)return;Z+=p(2,x===J.length-1)}else{let be=!1,ce="",G=!1,W="";for(const ne of le){if(ne!=="}"&&be){ce+=ne;continue}if(G&&(ne!=="]"||!W)){let ye;ne==="-"?ye=ne:(ne==="^"||ne==="!")&&!W?ye="^":ne===e.$Jj?ye="":ye=(0,$.$Oe)(ne),W+=ye;continue}switch(ne){case"{":be=!0;continue;case"[":G=!0;continue;case"}":{const de=`(?:${S(ce,",").map(ge=>d(ge)).join("|")})`;Z+=de,be=!1,ce="";break}case"]":{Z+="["+W+"]",G=!1,W="";break}case"?":Z+=C;continue;case"*":Z+=p(1);continue;default:Z+=(0,$.$Oe)(ne)}}x<J.length-1&&(J[x+1]!==e.$Ij||x+2<J.length)&&(Z+=L)}X=le===e.$Ij})}return Z}const f=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.$Dc(1e4),a=function(){return!1},r=function(){return null};function h(ue,Z){if(!ue)return r;let J;typeof ue!="string"?J=ue.pattern:J=ue,J=J.trim();const X=`${J}_${!!Z.trimForExclusions}`;let le=t.get(X);if(le)return u(le,ue);let x;return f.test(J)?le=k(J.substr(4),J):(x=o.exec(l(J,Z)))?le=A(x[1],J):(Z.trimForExclusions?s:i).test(J)?le=v(J,Z):(x=n.exec(l(J,Z)))?le=w(x[1].substr(1),J,!0):(x=c.exec(l(J,Z)))?le=w(x[1],J,!1):le=E(J),t.set(X,le),u(le,ue)}function u(ue,Z){if(typeof Z=="string")return ue;const J=function(X,le){return(0,g.$8f)(X,Z.base,!b.$k)?ue((0,$.$Te)(X.substr(Z.base.length),R.sep),le):null};return J.allBasenames=ue.allBasenames,J.allPaths=ue.allPaths,J.basenames=ue.basenames,J.patterns=ue.patterns,J}function l(ue,Z){return Z.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function k(ue,Z){return function(J,X){return typeof J=="string"&&J.endsWith(ue)?Z:null}}function A(ue,Z){const J=`/${ue}`,X=`\\${ue}`,le=function(be,ce){return typeof be!="string"?null:ce?ce===ue?Z:null:be===ue||be.endsWith(J)||be.endsWith(X)?Z:null},x=[ue];return le.basenames=x,le.patterns=[Z],le.allBasenames=x,le}function v(ue,Z){const J=U(ue.slice(1,-1).split(",").map(ce=>h(ce,Z)).filter(ce=>ce!==r),ue),X=J.length;if(!X)return r;if(X===1)return J[0];const le=function(ce,G){for(let W=0,ne=J.length;W<ne;W++)if(J[W](ce,G))return ue;return null},x=J.find(ce=>!!ce.allBasenames);x&&(le.allBasenames=x.allBasenames);const be=J.reduce((ce,G)=>G.allPaths?ce.concat(G.allPaths):ce,[]);return be.length&&(le.allPaths=be),le}function w(ue,Z,J){const X=R.sep===R.$gc.sep,le=X?ue:ue.replace(m,R.sep),x=R.sep+le,be=R.$gc.sep+ue;let ce;return J?ce=function(G,W){return typeof G=="string"&&(G===le||G.endsWith(x)||!X&&(G===ue||G.endsWith(be)))?Z:null}:ce=function(G,W){return typeof G=="string"&&(G===le||!X&&G===ue)?Z:null},ce.allPaths=[(J?"*/":"./")+ue],ce}function E(ue){try{const Z=new RegExp(`^${d(ue)}$`);return function(J){return Z.lastIndex=0,typeof J=="string"&&Z.test(J)?ue:null}}catch{return r}}function P(ue,Z,J){return!ue||typeof Z!="string"?!1:N(ue)(Z,void 0,J)}e.$Lj=P;function N(ue,Z={}){if(!ue)return a;if(typeof ue=="string"||z(ue)){const J=h(ue,Z);if(J===r)return a;const X=function(le,x){return!!J(le,x)};return J.allBasenames&&(X.allBasenames=J.allBasenames),J.allPaths&&(X.allPaths=J.allPaths),X}return M(ue,Z)}e.$Mj=N;function z(ue){const Z=ue;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.$Nj=z;function F(ue){return ue.allBasenames||[]}e.$Oj=F;function j(ue){return ue.allPaths||[]}e.$Pj=j;function M(ue,Z){const J=U(Object.getOwnPropertyNames(ue).map(ce=>O(ce,ue[ce],Z)).filter(ce=>ce!==r)),X=J.length;if(!X)return r;if(!J.some(ce=>!!ce.requiresSiblings)){if(X===1)return J[0];const ce=function(ne,ye){let de;for(let ge=0,_=J.length;ge<_;ge++){const te=J[ge](ne,ye);if(typeof te=="string")return te;(0,T.$Sg)(te)&&(de||(de=[]),de.push(te))}return de?(async()=>{for(const ge of de){const _=await ge;if(typeof _=="string")return _}return null})():null},G=J.find(ne=>!!ne.allBasenames);G&&(ce.allBasenames=G.allBasenames);const W=J.reduce((ne,ye)=>ye.allPaths?ne.concat(ye.allPaths):ne,[]);return W.length&&(ce.allPaths=W),ce}const le=function(ce,G,W){let ne,ye;for(let de=0,ge=J.length;de<ge;de++){const _=J[de];_.requiresSiblings&&W&&(G||(G=(0,R.$nc)(ce)),ne||(ne=G.substr(0,G.length-(0,R.$oc)(ce).length)));const te=_(ce,G,ne,W);if(typeof te=="string")return te;(0,T.$Sg)(te)&&(ye||(ye=[]),ye.push(te))}return ye?(async()=>{for(const de of ye){const ge=await de;if(typeof ge=="string")return ge}return null})():null},x=J.find(ce=>!!ce.allBasenames);x&&(le.allBasenames=x.allBasenames);const be=J.reduce((ce,G)=>G.allPaths?ce.concat(G.allPaths):ce,[]);return be.length&&(le.allPaths=be),le}function O(ue,Z,J){if(Z===!1)return r;const X=h(ue,J);if(X===r)return r;if(typeof Z=="boolean")return X;if(Z){const le=Z.when;if(typeof le=="string"){const x=(be,ce,G,W)=>{if(!W||!X(be,ce))return null;const ne=le.replace("$(basename)",()=>G),ye=W(ne);return(0,T.$Sg)(ye)?ye.then(de=>de?ue:null):ye?ue:null};return x.requiresSiblings=!0,x}}return X}function U(ue,Z){const J=ue.filter(ce=>!!ce.basenames);if(J.length<2)return ue;const X=J.reduce((ce,G)=>{const W=G.basenames;return W?ce.concat(W):ce},[]);let le;if(Z){le=[];for(let ce=0,G=X.length;ce<G;ce++)le.push(Z)}else le=J.reduce((ce,G)=>{const W=G.patterns;return W?ce.concat(W):ce},[]);const x=function(ce,G){if(typeof ce!="string")return null;if(!G){let ne;for(ne=ce.length;ne>0;ne--){const ye=ce.charCodeAt(ne-1);if(ye===47||ye===92)break}G=ce.substr(ne)}const W=X.indexOf(G);return W!==-1?le[W]:null};x.basenames=X,x.patterns=le,x.allBasenames=X;const be=ue.filter(ce=>!ce.basenames);return be.push(x),be}function Q(ue,Z){return(0,D.$ub)(ue,Z,(J,X)=>typeof J=="string"&&typeof X=="string"?J===X:typeof J!="string"&&typeof X!="string"?J.base===X.base&&J.pattern===X.pattern:!1)}e.$Qj=Q}),define(ke[80],Se([1,0,14,164,23,12,2]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(i="",s=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$7)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(i,s=0){return this.value+=m(this.supportThemeIcons?(0,T.$bk)(i):i).replace(/([ \t]+)/g,(n,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,s){return this.value+=`
${p(s,i)}
`,this}appendLink(i,s,n){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(i),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(i,s){const n=new RegExp((0,I.$Oe)(s),"g");return i.replace(n,(c,t)=>i.charAt(t-1)!=="\\"?`\\${c}`:c)}}e.$hk=$;function y(o){return L(o)?!o.value:Array.isArray(o)?o.every(y):!0}e.$ik=y;function L(o){return o instanceof $?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$jk=L;function C(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,g.$Ag)(R.URI.from(o.baseUri),R.URI.from(i.baseUri)))}e.$kk=C;function m(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$lk=m;function p(o,i){const s=o.match(/^`+/gm)?.reduce((c,t)=>c.length>t.length?c:t).length??0,n=s>=3?s+1:3;return[`${"`".repeat(n)}${i}`,o,`${"`".repeat(n)}`].join(`
`)}e.$mk=p;function S(o){return o.replace(/"/g,"&quot;")}e.$nk=S;function d(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ok=d;function f(o){const i=[],s=o.split("|").map(c=>c.trim());o=s[0];const n=s[1];if(n){const c=/height=(\d+)/.exec(n),t=/width=(\d+)/.exec(n),a=c?c[1]:"",r=t?t[1]:"",h=isFinite(parseInt(r)),u=isFinite(parseInt(a));h&&i.push(`width="${r}"`),u&&i.push(`height="${a}"`)}return{href:o,dimensions:i}}e.$pk=f}),define(ke[103],Se([1,0,19,33,17,10,23,12]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=void 0;function $(h,u){const{os:l,tildify:k,relative:A}=u;if(A){const E=y(h,A,l);if(typeof E=="string")return E}let v=h.fsPath;if(l===1&&!I.$i?v=v.replace(/\//g,"\\"):l!==1&&I.$i&&(v=v.replace(/\\/g,"/")),l!==1&&k?.userHome){const E=k.userHome.fsPath;let P;h.scheme!==k.userHome.scheme&&h.path[0]===g.$gc.sep&&h.path[1]!==g.$gc.sep?P=k.userHome.with({path:h.path}).fsPath:P=v,v=m(P,E,l)}return(l===1?g.$fc:g.$gc).normalize(L(v,l===1))}e.$Vv=$;function y(h,u,l){const k=l===1?g.$fc:g.$gc,A=l===3?R.$xg:R.$zg,v=u.getWorkspace(),w=(0,D.$Ob)(v.folders);if(!w)return;h.scheme!==w.uri.scheme&&h.path[0]===g.$gc.sep&&h.path[1]!==g.$gc.sep&&(h=w.uri.with({path:h.path}));const E=u.getWorkspaceFolder(h);if(!E)return;let P;if(A.isEqual(E.uri,h)?P="":P=A.relativePath(E.uri,h)??"",P&&(P=k.normalize(P)),v.folders.length>1&&!u.noPrefix){const N=E.name?E.name:A.basenameOrAuthority(E.uri);P=P?`${N} \u2022 ${P}`:N}return P}function L(h,u=I.$i){return(0,T.$_f)(h,u)?h.charAt(0).toUpperCase()+h.slice(1):h}e.$Wv=L;let C=Object.create(null);function m(h,u,l=I.OS){if(l===1||!h||!u)return h;let k=C.original===u?C.normalized:void 0;k||(k=u,I.$i&&(k=(0,T.$2f)(k)),k=`${(0,b.$Ue)(k,g.$gc.sep)}${g.$gc.sep}`,C={original:u,normalized:k});let A=h;return I.$i&&(A=(0,T.$2f)(A)),(l===3?A.startsWith(k):(0,b.$af)(A,k))?`~/${A.substr(k.length)}`:h}e.$Xv=m;function p(h,u){return h.replace(/^~($|\/|\\)/,`${u}$1`)}e.$Yv=p;const S="\u2026",d="\\\\",f="~";function o(h,u=g.sep){const l=new Array(h.length);let k=!1;for(let A=0;A<h.length;A++){const v=h[A];if(v===""){l[A]=`.${u}`;continue}if(!v){l[A]=v;continue}k=!0;let w="",E=v;E.indexOf(d)===0?(w=E.substr(0,E.indexOf(d)+d.length),E=E.substr(E.indexOf(d)+d.length)):E.indexOf(u)===0?(w=E.substr(0,E.indexOf(u)+u.length),E=E.substr(E.indexOf(u)+u.length)):E.indexOf(f)===0&&(w=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length));const P=E.split(u);for(let N=1;k&&N<=P.length;N++)for(let z=P.length-N;k&&z>=0;z--){k=!1;let F=P.slice(z,z+N).join(u);for(let j=0;!k&&j<h.length;j++)if(j!==A&&h[j]&&h[j].indexOf(F)>-1){const M=z+N===P.length,O=z>0&&h[j].indexOf(u)>-1?u+F:F,U=h[j].endsWith(O);k=!M||U}if(!k){let j="";(P[0].endsWith(":")||w!=="")&&(z===1&&(z=0,N++,F=P[0]+u+F),z>0&&(j=P[0]+u),j=w+j),z>0&&(j=j+S+u),j=j+F,z+N<P.length&&(j=j+u+S),l[A]=j}}k&&(l[A]=v)}return l}e.$Zv=o;var i;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function s(h,u=Object.create(null)){const l=[];let k=!1,A="";for(const v of h)if(v==="$"||k&&v==="{")A&&l.push({value:A,type:i.TEXT}),A="",k=!0;else if(v==="}"&&k){const w=u[A];if(typeof w=="string")w.length&&l.push({value:w,type:i.VARIABLE});else if(w){const E=l[l.length-1];(!E||E.type!==i.SEPARATOR)&&l.push({value:w.label,type:i.SEPARATOR})}A="",k=!1}else A+=v;return A&&!k&&l.push({value:A,type:i.TEXT}),l.filter((v,w)=>{if(v.type===i.SEPARATOR){const E=l[w-1],P=l[w+1];return[E,P].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map(v=>v.value).join("")}e.$1v=s;function n(h,u){return I.$j||u?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$j?"&":"&&"):h.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$2v=n;function c(h,u){return I.$j||u?h.replace(/\(&&\w\)|&&/g,""):I.$i?h.replace(/&&|&/g,l=>l==="&"?"&&":"&"):h.replace(/&&/g,"_")}e.$3v=c;function t(h){return h.replace(/&/g,"&&")}e.$4v=t;function a(h){if(h.endsWith("]")){const u=h.lastIndexOf(" [",h.length-2);if(u!==-1){const l=r(h.substring(0,u)),k=h.substring(u);return{name:l.name+k,parentPath:l.parentPath}}}return r(h)}e.$5v=a;function r(h){const u=h.indexOf("/")!==-1?g.$gc:g.$fc,l=u.basename(h),k=u.dirname(h);return l.length?{name:l,parentPath:k}:{name:k,parentPath:""}}}),define(ke[130],Se([1,0,22,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function g(C){return C.toJSON()}class I{constructor(m){this.a=m}transformIncoming(m){const p=this.a.transformIncoming(m);return p===m?m:g(T.URI.from(p))}transformOutgoing(m){const p=this.a.transformOutgoing(m);return p===m?m:g(T.URI.from(p))}transformOutgoingURI(m){const p=this.a.transformOutgoing(m);return p===m?m:T.URI.from(p)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$4m=I,e.$5m=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,m,p){if(!C||p>200)return null;if(typeof C=="object"){if(C instanceof T.URI)return m.transformOutgoing(C);for(const S in C)if(Object.hasOwnProperty.call(C,S)){const d=R(C[S],m,p+1);d!==null&&(C[S]=d)}}return null}function b(C,m){const p=R(C,m,0);return p===null?C:p}e.$6m=b;function $(C,m,p,S){if(!C||S>200)return null;if(typeof C=="object"){if(C.$mid===1)return p?T.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof D.$je)return null;for(const d in C)if(Object.hasOwnProperty.call(C,d)){const f=$(C[d],m,p,S+1);f!==null&&(C[d]=f)}}return null}function y(C,m){const p=$(C,m,!1,0);return p===null?C:p}e.$7m=y;function L(C,m){const p=$(C,m,!0,0);return p===null?C:p}e.$8m=L}),define(ke[31],Se([1,0,56,63,385,11,33,76,17,10,23,2]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function p(O,U=m.UNLINK,Q){if((0,R.$$f)(O))throw new Error("rimraf - will refuse to recursively delete root");return U===m.UNLINK?d(O):S(O,Q)}async function S(O,U=(0,R.$dg)((0,T.tmpdir)())){try{try{await D.promises.rename(O,U)}catch(Q){return Q.code==="ENOENT"?void 0:d(O)}d(U).catch(Q=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function d(O){return(0,g.promisify)(D.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function f(O){if((0,R.$$f)(O))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function o(O,U){return n(await(U?i(O):(0,g.promisify)(D.readdir)(O)))}async function i(O){try{return await(0,g.promisify)(D.readdir)(O,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const U=[],Q=await o(O);for(const ue of Q){let Z=!1,J=!1,X=!1;try{const le=await e.Promises.lstat((0,$.$jc)(O,ue));Z=le.isFile(),J=le.isDirectory(),X=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}U.push({name:ue,isFile:()=>Z,isDirectory:()=>J,isSymbolicLink:()=>X})}return U}function s(O){return n(D.readdirSync(O))}e.readdirSync=s;function n(O){return O.map(U=>typeof U=="string"?y.$j?(0,b.$Gl)(U):U:(U.name=y.$j?(0,b.$Gl)(U.name):U.name,U))}async function c(O){const U=await o(O),Q=[];for(const ue of U)await a.existsDirectory((0,$.$jc)(O,ue))&&Q.push(ue);return Q}function t(O,U=1e3){return new Promise(Q=>{let ue=!1;const Z=setInterval(()=>{ue||(ue=!0,D.access(O,J=>{ue=!1,J&&(clearInterval(Z),Q(void 0))}))},U)})}e.whenDeleted=t;var a;(function(O){async function U(Z){let J;try{if(J=await e.Promises.lstat(Z),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(y.$i&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw le}throw X}}O.stat=U;async function Q(Z){try{const{stat:J,symbolicLink:X}=await O.stat(Z);return J.isFile()&&X?.dangling!==!0}catch{}return!1}O.existsFile=Q;async function ue(Z){try{const{stat:J,symbolicLink:X}=await O.stat(Z);return J.isDirectory()&&X?.dangling!==!0}catch{}return!1}O.existsDirectory=ue})(a||(e.SymlinkSupport=a={}));const r=new I.$ch;function h(O,U,Q){return r.queueFor(C.URI.file(O),()=>{const ue=v(Q);return new Promise((Z,J)=>k(O,U,ue,X=>X?J(X):Z()))},L.$yg)}let u=!0;function l(O){u=O}e.configureFlushOnWrite=l;function k(O,U,Q,ue){if(!u)return D.writeFile(O,U,{mode:Q.mode,flag:Q.flag},ue);D.open(O,Q.flag,Q.mode,(Z,J)=>{if(Z)return ue(Z);D.writeFile(J,U,X=>{if(X)return D.close(J,()=>ue(X));D.fdatasync(J,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),l(!1)),D.close(J,x=>ue(x))))})})}function A(O,U,Q){const ue=v(Q);if(!u)return D.writeFileSync(O,U,{mode:ue.mode,flag:ue.flag});const Z=D.openSync(O,ue.flag,ue.mode);try{D.writeFileSync(Z,U);try{D.fdatasyncSync(Z)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),l(!1)}}finally{D.closeSync(Z)}}e.writeFileSync=A;function v(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function w(O,U,Q=6e4){if(O!==U)try{y.$i&&typeof Q=="number"?await E(O,U,Date.now(),Q):await(0,g.promisify)(D.rename)(O,U)}catch(ue){if(O.toLowerCase()!==U.toLowerCase()&&ue.code==="EXDEV"||O.endsWith("."))await P(O,U,{preserveSymlinks:!1}),await p(O,m.MOVE);else throw ue}}async function E(O,U,Q,ue,Z=0){try{return await(0,g.promisify)(D.rename)(O,U)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-Q>=ue)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${J}`),J;if(Z===0){let X=!1;try{const{stat:le}=await a.stat(U);le.isFile()||(X=!0)}catch{}if(X)throw J}return await(0,I.$7g)(Math.min(100,Z*10)),E(O,U,Q,ue,Z+1)}}async function P(O,U,Q){return z(O,U,{root:{source:O,target:U},options:Q,handledSourcePaths:new Set})}const N=511;async function z(O,U,Q){if(Q.handledSourcePaths.has(O))return;Q.handledSourcePaths.add(O);const{stat:ue,symbolicLink:Z}=await a.stat(O);if(Z){if(Q.options.preserveSymlinks)try{return await M(O,U,Q)}catch{}if(Z.dangling)return}return ue.isDirectory()?F(O,U,ue.mode&N,Q):j(O,U,ue.mode&N)}async function F(O,U,Q,ue){await e.Promises.mkdir(U,{recursive:!0,mode:Q});const Z=await o(O);for(const J of Z)await z((0,$.$jc)(O,J),(0,$.$jc)(U,J),ue)}async function j(O,U,Q){await e.Promises.copyFile(O,U),await e.Promises.chmod(U,Q)}async function M(O,U,Q){let ue=await e.Promises.readlink(O);(0,R.$8f)(ue,Q.root.source,!y.$k)&&(ue=(0,$.$jc)(Q.root.target,ue.substr(Q.root.source.length+1))),await e.Promises.symlink(ue,U)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(O,U,Q,ue,Z)=>new Promise((J,X)=>{D.read(O,U,Q,ue,Z,(le,x,be)=>le?X(le):J({bytesRead:x,buffer:be}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(O,U,Q,ue,Z)=>new Promise((J,X)=>{D.write(O,U,Q,ue,Z,(le,x,be)=>le?X(le):J({bytesWritten:x,buffer:be}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return c}get writeFile(){return h}get rm(){return p}get rename(){return w}get copy(){return P}}}),define(ke[104],Se([1,0,56,17,10,12,31]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=void 0;function b(m){if(g.$k)return m;const p=(0,T.$mc)(m);if(m===p)return m;const S=((0,T.$nc)(m)||m).toLowerCase();try{const f=(0,R.readdirSync)(p).filter(o=>o.toLowerCase()===S);if(f.length===1){const o=b(p);if(o)return(0,T.$jc)(o,f[0])}else if(f.length>1){const o=f.indexOf(S);if(o>=0){const i=b(p);if(i)return(0,T.$jc)(i,f[o])}}}catch{}return null}e.$tq=b;async function $(m){if(g.$k)return m;const p=(0,T.$mc)(m);if(m===p)return m;const S=((0,T.$nc)(m)||m).toLowerCase();try{const f=(await R.Promises.readdir(p)).filter(o=>o.toLowerCase()===S);if(f.length===1){const o=await $(p);if(o)return(0,T.$jc)(o,f[0])}else if(f.length>1){const o=f.indexOf(S);if(o>=0){const i=await $(p);if(i)return(0,T.$jc)(i,f[o])}}}catch{}return null}e.$uq=$;async function y(m){try{return await R.Promises.realpath(m)}catch{const S=C(m);return await R.Promises.access(S,D.constants.R_OK),S}}e.$vq=y;function L(m){try{return D.realpathSync(m)}catch{const S=C(m);return D.accessSync(S,D.constants.R_OK),S}}e.$wq=L;function C(m){return(0,I.$Ue)((0,T.$hc)(m),T.sep)}}),define(ke[105],Se([1,0,17,10,49,102,18,31]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function $(C=g.env){return C.comspec||"cmd.exe"}e.$Tl=$;function y(C){let m=[],p=!1;const S=function(d){if(p){m.push(d);return}(!C.send(d,o=>{if(o&&console.error(o),p=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(s=>S(s))}})||T.$i)&&(p=!0)};return{send:S}}e.$Ul=y;var L;(function(C){async function m(p,S,d){if(D.$ic(p))return p;if(S===void 0&&(S=g.cwd()),D.$mc(p)!=="."||(d===void 0&&R.$If(g.env.PATH)&&(d=g.env.PATH.split(D.$tc)),d===void 0||d.length===0))return D.$jc(S,p);async function o(i){if(await b.Promises.exists(i)){let s;try{s=await b.Promises.stat(i)}catch(n){n.message.startsWith("EACCES")&&(s=await b.Promises.lstat(i))}return s?!s.isDirectory():!1}return!1}for(const i of d){let s;if(D.$ic(i)?s=D.$jc(i,p):s=D.$jc(S,i,p),await o(s))return s;let n=s+".com";if(await o(n)||(n=s+".exe",await o(n)))return n}return D.$jc(S,p)}C.findExecutable=m})(L||(e.win32=L={}))});var Ge=this&&this.__decorate||function(me,e,D,T){var g=arguments.length,I=g<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(me,e,D,T);else for(var b=me.length-1;b>=0;b--)(R=me[b])&&(I=(g<3?R(I):g>3?R(e,D,I):R(e,D))||I);return g>3&&I&&Object.defineProperty(e,D,I),I};define(ke[81],Se([1,0,19,11,22,21,52,14,4,3,55,12,18]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.ProxyChannel=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.RequestInitiator=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;var p;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(p||(p={}));function S(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(d||(d={}));function f(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(o||(o={}));function i(Z){let J=0;for(let X=0;;X+=7){const le=Z.read(1);if(J|=(le.buffer[0]&127)<<X,!(le.buffer[0]&128))return J}}const s=r(0);function n(Z,J){if(J===0){Z.write(s);return}let X=0;for(let x=J;x!==0;x=x>>>7)X++;const le=g.$je.alloc(X);for(let x=0;J!==0;x++)le.buffer[x]=J&127,J=J>>>7,J>0&&(le.buffer[x]|=128);Z.write(le)}class c{constructor(J){this.b=J,this.a=0}read(J){const X=this.b.slice(this.a,this.a+J);return this.a+=X.byteLength,X}}e.$Dh=c;class t{constructor(){this.a=[]}get buffer(){return g.$je.concat(this.a)}write(J){this.a.push(J)}}e.$Eh=t;var a;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(a||(a={}));function r(Z){const J=g.$je.alloc(1);return J.writeUInt8(Z,0),J}const h={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object),Uint:r(a.Int)},u=typeof Buffer<"u";function l(Z,J){if(typeof J>"u")Z.write(h.Undefined);else if(typeof J=="string"){const X=g.$je.fromString(J);Z.write(h.String),n(Z,X.byteLength),Z.write(X)}else if(u&&Buffer.isBuffer(J)){const X=g.$je.wrap(J);Z.write(h.Buffer),n(Z,X.byteLength),Z.write(X)}else if(J instanceof g.$je)Z.write(h.VSBuffer),n(Z,J.byteLength),Z.write(J);else if(Array.isArray(J)){Z.write(h.Array),n(Z,J.length);for(const X of J)l(Z,X)}else if(typeof J=="number"&&(J|0)===J)Z.write(h.Uint),n(Z,J);else{const X=g.$je.fromString(JSON.stringify(J));Z.write(h.Object),n(Z,X.byteLength),Z.write(X)}}e.$Fh=l;function k(Z){switch(Z.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return Z.read(i(Z)).toString();case a.Buffer:return Z.read(i(Z)).buffer;case a.VSBuffer:return Z.read(i(Z));case a.Array:{const X=i(Z),le=[];for(let x=0;x<X;x++)le.push(k(Z));return le}case a.Object:return JSON.parse(Z.read(i(Z)).toString());case a.Int:return i(Z)}}e.$Gh=k;class A{constructor(J,X,le=null,x=1e3){this.h=J,this.j=X,this.k=le,this.l=x,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(be=>this.q(be)),this.m({type:200})}registerChannel(J,X){this.b.set(J,X),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const X=this.o([J.type]);this.k?.logOutgoing(X,0,1,f(J.type));return}case 201:case 202:case 204:case 203:{const X=this.o([J.type,J.id],J.data);this.k?.logOutgoing(X,J.id,1,f(J.type),J.data);return}}}o(J,X=void 0){const le=new t;return l(le,J),l(le,X),this.p(le.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const X=new c(J),le=k(X),x=k(X),be=le[0];switch(be){case 100:return this.k?.logIncoming(J.byteLength,le[1],1,`${S(be)}: ${le[2]}.${le[3]}`,x),this.s({type:be,id:le[1],channelName:le[2],name:le[3],arg:x});case 102:return this.k?.logIncoming(J.byteLength,le[1],1,`${S(be)}: ${le[2]}.${le[3]}`,x),this.t({type:be,id:le[1],channelName:le[2],name:le[3],arg:x});case 101:return this.k?.logIncoming(J.byteLength,le[1],1,`${S(be)}`),this.u({type:be,id:le[1]});case 103:return this.k?.logIncoming(J.byteLength,le[1],1,`${S(be)}`),this.u({type:be,id:le[1]})}}s(J){const X=this.b.get(J.channelName);if(!X){this.v(J);return}const le=new I.$6d;let x;try{x=X.call(this.j,J.name,J.arg,le.token)}catch(G){x=Promise.reject(G)}const be=J.id;x.then(G=>{this.m({id:be,data:G,type:201})},G=>{G instanceof Error?this.m({id:be,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:be,data:G,type:203})}).finally(()=>{ce.dispose(),this.d.delete(J.id)});const ce=(0,y.$Rc)(()=>le.cancel());this.d.set(J.id,ce)}t(J){const X=this.b.get(J.channelName);if(!X){this.v(J);return}const le=J.id,be=X.listen(this.j,J.name,J.arg)(ce=>this.m({id:le,data:ce,type:204}));this.d.set(J.id,be)}u(J){const X=this.d.get(J.id);X&&(X.dispose(),this.d.delete(J.id))}v(J){let X=this.g.get(J.channelName);X||(X=[],this.g.set(J.channelName,X));const le=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:J,timeoutTimer:le})}w(J){const X=this.g.get(J);if(X){for(const le of X)switch(clearTimeout(le.timeoutTimer),le.request.type){case 100:this.s(le.request);break;case 102:this.t(le.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=A;var v;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class w{constructor(J,X=null){this.l=J,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Vd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=X}getChannel(J){const X=this;return{call(le,x,be){return X.a?Promise.reject(new b.$5):X.m(J,le,x,be)},listen(le,x){return X.a?$.Event.None:X.o(J,le,x)}}}m(J,X,le,x=I.CancellationToken.None){const be=this.g++,G={id:be,type:100,channelName:J,name:X,arg:le};if(x.isCancellationRequested)return Promise.reject(new b.$5);let W;return new Promise((ye,de)=>{if(x.isCancellationRequested)return de(new b.$5);const ge=()=>{const ie=fe=>{switch(fe.type){case 201:this.f.delete(be),ye(fe.data);break;case 202:{this.f.delete(be);const pe=new Error(fe.data.message);pe.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,pe.name=fe.data.name,de(pe);break}case 203:this.f.delete(be),de(fe.data);break}};this.f.set(be,ie),this.p(G)};let _=null;this.b===o.Idle?ge():(_=(0,T.$Tg)(ie=>this.u()),_.then(()=>{_=null,ge()}));const te=()=>{_?(_.cancel(),_=null):this.p({id:be,type:101}),de(new b.$5)},K=x.onCancellationRequested(te);W=(0,y.$Qc)((0,y.$Rc)(te),K),this.d.add(W)}).finally(()=>{W.dispose(),this.d.delete(W)})}o(J,X,le){const x=this.g++,ce={id:x,type:102,channelName:J,name:X,arg:le};let G=null;const W=new $.$Vd({onWillAddFirstListener:()=>{G=(0,T.$Tg)(ye=>this.u()),G.then(()=>{G=null,this.d.add(W),this.p(ce)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(W),this.p({id:x,type:103}))}}),ne=ye=>W.fire(ye.data);return this.f.set(x,ne),W.event}p(J){switch(J.type){case 100:case 102:{const X=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(X,J.id,0,`${S(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const X=this.q([J.type,J.id]);this.j?.logOutgoing(X,J.id,0,S(J.type));return}}}q(J,X=void 0){const le=new t;return l(le,J),l(le,X),this.r(le.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const X=new c(J),le=k(X),x=k(X),be=le[0];switch(be){case 200:return this.j?.logIncoming(J.byteLength,0,0,f(be)),this.t({type:le[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,le[1],0,f(be),x),this.t({type:le[0],id:le[1],data:x})}}t(J){if(J.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=w,Ge([R.$xh],w.prototype,"onDidInitializePromise",null);class E{get connections(){const J=[];return this.f.forEach(X=>J.push(X)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new $.$Vd,this.onDidAddConnection=this.g.event,this.h=new $.$Vd,this.onDidRemoveConnection=this.h.event,this.j=new y.$Sc,this.j.add(J(({protocol:X,onDidClientDisconnect:le})=>{const x=$.Event.once(X.onMessage);this.j.add(x(be=>{const ce=new c(be),G=k(ce),W=new A(X,G),ne=new w(X);this.a.forEach((de,ge)=>W.registerChannel(ge,de));const ye={channelServer:W,channelClient:ne,ctx:G};this.f.add(ye),this.g.fire(ye),this.j.add(le(()=>{W.dispose(),ne.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(J,X){const le=this;return{call(x,be,ce){let G;if((0,m.$Wf)(X)){const ne=(0,D.$4b)(le.connections.filter(X));G=ne?Promise.resolve(ne):$.Event.toPromise($.Event.filter(le.onDidAddConnection,X))}else G=X.routeCall(le,x,be);const W=G.then(ne=>ne.channelClient.getChannel(J));return N(W).call(x,be,ce)},listen(x,be){if((0,m.$Wf)(X))return le.k(J,X,x,be);const ce=X.routeEvent(le,x,be).then(G=>G.channelClient.getChannel(J));return N(ce).listen(x,be)}}}k(J,X,le,x){const be=this;let ce;const G=new $.$Vd({onWillAddFirstListener:()=>{ce=new y.$Sc;const W=new $.$2d,ne=new Map,ye=ge=>{const te=ge.channelClient.getChannel(J).listen(le,x),K=W.add(te);ne.set(ge,K)},de=ge=>{const _=ne.get(ge);_&&(_.dispose(),ne.delete(ge))};be.connections.filter(X).forEach(ye),$.Event.filter(be.onDidAddConnection,X)(ye,void 0,ce),be.onDidRemoveConnection(de,void 0,ce),W.event(G.fire,G,ce),ce.add(W)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return G.event}registerChannel(J,X){this.a.set(J,X);for(const le of this.f)le.channelServer.registerChannel(J,X)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Jh=E;class P{constructor(J,X,le=null){const x=new t;l(x,X),J.send(x.buffer),this.a=new w(J,le),this.d=new A(J,X,le)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,X){this.d.registerChannel(J,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Kh=P;function N(Z){return{call(J,X,le){return Z.then(x=>x.call(J,X,le))},listen(J,X){const le=new $.$5d;return Z.then(x=>le.input=x.listen(J,X)),le.event}}}e.$Lh=N;function z(Z){let J=!1;return{call(X,le,x){return J?Z.call(X,le,x):(0,T.$7g)(0).then(()=>J=!0).then(()=>Z.call(X,le,x))},listen(X,le){if(J)return Z.listen(X,le);const x=new $.$5d;return(0,T.$7g)(0).then(()=>J=!0).then(()=>x.input=Z.listen(X,le)),x.event}}}e.$Mh=z;class F{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const X of J.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await $.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$Nh=F;var j;(function(Z){function J(be,ce,G){const W=be,ne=G&&G.disableMarshalling,ye=new Map;for(const de in W)le(de)&&ye.set(de,$.Event.buffer(W[de],!0,void 0,ce));return new class{listen(de,ge,_){const te=ye.get(ge);if(te)return te;if(x(ge)){const K=W[ge];if(typeof K=="function")return K.call(W,_)}throw new b.$bb(`Event not found: ${ge}`)}call(de,ge,_){const te=W[ge];if(typeof te=="function"){if(!ne&&Array.isArray(_))for(let ie=0;ie<_.length;ie++)_[ie]=(0,L.$Ch)(_[ie]);let K=te.apply(W,_);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new b.$bb(`Method not found: ${ge}`)}}}Z.fromService=J;function X(be,ce){const G=ce&&ce.disableMarshalling;return new Proxy({},{get(W,ne){if(typeof ne=="string")return ce?.properties?.has(ne)?ce.properties.get(ne):x(ne)?function(ye){return be.listen(ne,ye)}:le(ne)?be.listen(ne):async function(...ye){let de;ce&&!(0,m.$Rf)(ce.context)?de=[ce.context,...ye]:de=ye;const ge=await be.call(ne,de);return G?ge:(0,L.$Ch)(ge)};throw new b.$bb(`Property not found: ${String(ne)}`)}})}Z.toService=X;function le(be){return be[0]==="o"&&be[1]==="n"&&C.$$e(be.charCodeAt(2))}function x(be){return/^onDynamic/.test(be)&&C.$$e(be.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const J=Z.toString();if(J!=="[object Object]")return J}return Z}function U(Z){return Array.isArray(Z)?Z.map(O):O(Z)}function Q(Z,J,X,le,x,be,ce){ce=U(ce);const G=M[x],W=G[le%G.length];let ne=[`%c[${Z}]%c[${String(J).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${be}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(be)?(ne=ne.concat(ce),ne.push(")")):ne.push(ce),console.log.apply(console,ne)}class ue{constructor(J,X){this.d=J,this.f=X,this.a=0,this.b=0}logOutgoing(J,X,le,x,be){this.b+=J,Q(this.d,this.b,J,X,le,x,be)}logIncoming(J,X,le,x,be){this.a+=J,Q(this.f,this.a,J,X,le,x,be)}}e.$Oh=ue}),define(ke[82],Se([1,0,22,4,3,81]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.ProtocolConstants=e.$Ph=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(h){h.Created="created",h.Read="read",h.Write="write",h.Open="open",h.Error="error",h.Close="close",h.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",h.NodeEndReceived="nodeEndReceived",h.NodeEndSent="nodeEndSent",h.NodeDrainBegin="nodeDrainBegin",h.NodeDrainEnd="nodeDrainEnd",h.zlibInflateError="zlibInflateError",h.zlibInflateData="zlibInflateData",h.zlibInflateInitialWrite="zlibInflateInitialWrite",h.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",h.zlibInflateWrite="zlibInflateWrite",h.zlibInflateFlushFired="zlibInflateFlushFired",h.zlibDeflateError="zlibDeflateError",h.zlibDeflateData="zlibDeflateData",h.zlibDeflateWrite="zlibDeflateWrite",h.zlibDeflateFlushFired="zlibDeflateFlushFired",h.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",h.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",h.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",h.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",h.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",h.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",h.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",h.ProtocolHeaderRead="protocolHeaderRead",h.ProtocolMessageRead="protocolMessageRead",h.ProtocolHeaderWrite="protocolHeaderWrite",h.ProtocolMessageWrite="protocolMessageWrite",h.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var b;(function(h){h.enableDiagnostics=!1,h.records=[];const u=new WeakMap;let l=0;function k(v,w){if(!u.has(v)){const E=String(++l);u.set(v,E)}return u.get(v)}function A(v,w,E,P){if(!h.enableDiagnostics)return;const N=k(v,w);if(P instanceof D.$je||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const z=D.$je.alloc(P.byteLength);z.set(P),h.records.push({timestamp:Date.now(),id:N,label:w,type:E,buff:z})}else h.records.push({timestamp:Date.now(),id:N,label:w,type:E,data:P})}h.traceSocketEvent=A})(b||(e.SocketDiagnostics=b={}));var $;(function(h){h[h.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",h[h.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let y=null;function L(){return y||(y=D.$je.alloc(0)),y}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(u){this.a.push(u),this.b+=u.byteLength}read(u){return this.c(u,!0)}peek(u){return this.c(u,!1)}c(u,l){if(u===0)return L();if(u>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===u){const w=this.a[0];return l&&(this.a.shift(),this.b-=u),w}if(this.a[0].byteLength>u){const w=this.a[0].slice(0,u);return l&&(this.a[0]=this.a[0].slice(u),this.b-=u),w}const k=D.$je.alloc(u);let A=0,v=0;for(;u>0;){const w=this.a[v];if(w.byteLength>u){const E=w.slice(0,u);k.set(E,A),A+=u,l&&(this.a[v]=w.slice(u),this.b-=u),u-=u}else k.set(w,A),A+=w.byteLength,l?(this.a.shift(),this.b-=w.byteLength):v++,u-=w.byteLength}return k}}e.$Ph=C;var m;(function(h){h[h.None=0]="None",h[h.Regular=1]="Regular",h[h.Control=2]="Control",h[h.Ack=3]="Ack",h[h.Disconnect=5]="Disconnect",h[h.ReplayRequest=6]="ReplayRequest",h[h.Pause=7]="Pause",h[h.Resume=8]="Resume",h[h.KeepAlive=9]="KeepAlive"})(m||(m={}));function p(h){switch(h){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(h){h[h.HeaderLength=13]="HeaderLength",h[h.AcknowledgeTime=2e3]="AcknowledgeTime",h[h.TimeoutTime=2e4]="TimeoutTime",h[h.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",h[h.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",h[h.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class d{constructor(u,l,k,A){this.type=u,this.id=l,this.ack=k,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends g.$Tc{constructor(u){super(),this.f=this.B(new T.$Vd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=u,this.b=!1,this.c=new C,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(u);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,A=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new d(k,A,v,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(u){this.k=null,this.a=!1,this.b=!1,this.c=u,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(u){if(this.a)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=D.$je.alloc(13);l.writeUInt8(u.type,0),l.writeUInt32BE(u.id,1),l.writeUInt32BE(u.ack,5),l.writeUInt32BE(u.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",u.data),this.j(l,u.data)}g(u,l){const k=this.f===0;return this.d.push(u,l),this.f+=u.byteLength+l.byteLength,k}h(){const u=D.$je.concat(this.d,this.f);return this.d.length=0,this.f=0,u}j(u,l){this.g(u,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const u=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:u.byteLength}),this.c.write(u)}}class i extends g.$Tc{constructor(u){super(),this.f=new T.$Vd,this.onMessage=this.f.event,this.g=new T.$Vd,this.onDidDispose=this.g.event,this.a=u,this.b=this.B(new o(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(u){this.b.write(new d(1,0,0,u))}}e.$Qh=i;class s extends I.$Kh{static fromSocket(u,l){return new s(new i(u),l)}get onDidDispose(){return this.b.onDidDispose}constructor(u,l,k=null){super(u,l,k),this.b=u}dispose(){super.dispose();const u=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),u.end()}}e.$Rh=s;class n{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Vd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(u){this.b?this.d.length>0?this.d.push(u):this.a.fire(u):this.d.push(u)}flushBuffer(){this.d=[]}}e.$Sh=n;class c{constructor(u){this.data=u,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let u=0,l=this.a;for(;l;)l=l.next,u++;return u}peek(){return this.a?this.a.data:null}toArray(){const u=[];let l=0,k=this.a;for(;k;)u[l++]=k.data,k=k.next;return u}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(u){const l=new c(u);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const u=Date.now();for(let l=0;l<a.a;l++)this.c[l]=u-1e3*l;setInterval(()=>{for(let l=a.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const u=Date.now(),l=(1+a.a)*1e3;let k=0;for(let A=0;A<a.a;A++)u-this.c[A]<=l&&k++;return 1-k/a.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(u){this.u=new n,this.onControlMessage=this.u.event,this.v=new n,this.onMessage=this.v.event,this.w=new n,this.onDidDispose=this.w.event,this.x=new n,this.onSocketClose=this.x.event,this.y=new n,this.onSocketTimeout=this.y.event,this.s=u.loadEstimator??a.getInstance(),this.t=u.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Sc,this.o=u.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),u.initialChunk&&this.q.acceptChunk(u.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const u=new d(5,0,0,L());this.p.write(u),this.p.flush()}sendPause(){const u=new d(7,0,0,L());this.p.write(u)}sendResume(){const u=new d(8,0,0,L());this.p.write(u)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(u,l){this.a=!0,this.r.dispose(),this.r=new g.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=u,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const u=new d(3,0,this.h,L());this.p.write(u);const l=this.b.toArray();for(let k=0,A=l.length;k<A;k++)this.p.write(l[k]);this.B()}acceptDisconnect(){this.w.fire()}z(u){if(u.ack>this.d){this.d=u.ack;do{const l=this.b.peek();if(l&&l.id<=u.ack)this.b.pop();else break}while(!0)}switch(u.type){case 0:break;case 1:{if(u.id>this.g)if(u.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new d(6,0,0,L())))}else this.g=u.id,this.j=Date.now(),this.A(),this.v.fire(u.data);break}case 2:{this.u.fire(u.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let k=0,A=l.length;k<A;k++)this.p.write(l[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(u){const l=++this.c;this.h=this.g;const k=new d(1,l,this.h,u);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(u){const l=new d(2,0,0,u);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const u=Date.now()-this.j;if(u>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-u+5)}B(){if(this.c<=this.d||this.f||this.a)return;const u=this.b.peek(),l=Date.now()-u.writtenTime,k=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(l>=2e4&&k>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:k});return}const v=Math.max(2e4-l,2e4-k,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const u=new d(3,0,this.h,L());this.p.write(u)}D(){this.h=this.g;const u=new d(9,0,this.h,L());this.p.write(u)}}e.$Th=r}),define(ke[187],Se([1,0,50,11,22,21,185,14,4,3,24,105,102,81]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class S extends p.$Hh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>g.$je.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$qq=S;class d{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Vd,this.onDidProcessExit=this.h.event;const s=i&&i.timeout?i.timeout:6e4;this.b=new T.$3g(s),this.d=null,this.f=null}getChannel(o){const i=this;return{call(s,n,c){return i.k(o,s,n,c)},listen(s,n){return i.l(o,s,n)}}}k(o,i,s,n=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const c=this.n(o),t=(0,T.$Tg)(h=>c.call(i,s,h)),a=n.onCancellationRequested(()=>t.cancel()),r=(0,y.$Rc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{a.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,s){if(!this.b)return $.Event.None;this.b.cancel();let n;const c=new $.$Vd({onWillAddFirstListener:()=>{n=this.n(o).listen(i,s)(c.fire,c),this.c.add(n)},onDidRemoveLastListener:()=>{this.c.delete(n),n.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,L.$vn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,m.$Sl)(i.env),this.d=(0,D.fork)(this.i,o,i);const s=new $.$Vd;$.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,R.$mq)(u)){(0,R.log)(u,`IPC Library: ${this.j.serverName}`);return}s.fire(g.$je.wrap(Buffer.from(u,"base64")))});const c=this.j.useQueue?(0,C.$Ul)(this.d):this.d,t=u=>this.d&&this.d.connected&&c.send(u.buffer.toString("base64")),a=s.event,r={send:t,onMessage:a};this.f=new p.$Ih(r);const h=()=>this.o();process.once("exit",h),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,l)=>{process.removeListener("exit",h),this.c.forEach(k=>(0,y.$Oc)(k)),this.c.clear(),u!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:l})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$rq=d}),define(ke[188],Se([1,0,11,4,3,55,18]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.StorageState=e.$pp=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(m){const p=m;return p?.changed instanceof Map||p?.deleted instanceof Set}e.$pp=$;var y;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(y||(e.StorageState=y={}));class L extends g.$Tc{static{this.a=100}constructor(p,S=Object.create(null)){super(),this.r=p,this.s=S,this.b=this.B(new T.$Yd),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$4g(L.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((S,d)=>this.w(d,S)),p.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(p,S){if(this.c===y.Closed)return;let d=!1;(0,R.$Rf)(S)?d=this.f.delete(p):this.f.get(p)!==S&&(this.f.set(p,S),d=!0),d&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,S){const d=this.f.get(p);return(0,R.$Rf)(d)?S:d}getBoolean(p,S){const d=this.get(p);return(0,R.$Rf)(d)?S:d==="true"}getNumber(p,S){const d=this.get(p);return(0,R.$Rf)(d)?S:parseInt(d,10)}getObject(p,S){const d=this.get(p);return(0,R.$Rf)(d)?S:(0,I.$Bh)(d)}async set(p,S,d=!1){if(this.c===y.Closed)return;if((0,R.$Rf)(S))return this.delete(p,d);const f=(0,R.$Kf)(S)||Array.isArray(S)?(0,I.$Ah)(S):String(S);if(this.f.get(p)!==f)return this.f.set(p,f),this.j.set(p,f),this.h.delete(p),this.b.fire({key:p,external:d}),this.D()}async delete(p,S=!1){if(!(this.c===y.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:S}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(this.z)return this.D(p)}async D(p){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$qp=L;class C{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((S,d)=>this.a.set(d,S)),p.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$rp=C}),define(ke[189],Se([1,0,12,10,22]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=void 0;let I;function R(){return I||(I=new TextDecoder("UTF-16LE")),I}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let y;function L(){return y||(y=T.$D()?R():$()),y}e.$at=L;function C(S,d,f){const o=new Uint16Array(S.buffer,d,f);return f>0&&(o[0]===65279||o[0]===65534)?m(S,d,f):R().decode(o)}e.$bt=C;function m(S,d,f){const o=[];let i=0;for(let s=0;s<f;s++){const n=g.$le(S,d);d+=2,o[i++]=String.fromCharCode(n)}return o.join("")}class p{constructor(d){this.a=d|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const d=new Uint16Array(this.b.buffer,0,this.d);return L().decode(d)}f(){const d=this.e();this.d=0,this.c===null?this.c=[d]:this.c[this.c.length]=d}appendCharCode(d){const f=this.a-this.d;f<=1&&(f===0||D.$df(d))&&this.f(),this.b[this.d++]=d}appendASCIICharCode(d){this.d===this.a&&this.f(),this.b[this.d++]=d}appendString(d){const f=d.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=d;return}for(let o=0;o<f;o++)this.b[this.d++]=d.charCodeAt(o)}}e.$ct=p}),define(ke[190],Se([1,0,22,189]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=void 0;function g($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class I{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,L,C,m){this.oldPosition=y,this.oldText=L,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${g(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${g(this.oldText)}")`:`(replace@${this.oldPosition} "${g(this.oldText)}" with "${g(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,L,C){const m=L.length;D.$oe(y,m,C),C+=4;for(let p=0;p<m;p++)D.$me(y,L.charCodeAt(p),C),C+=2;return C}static d(y,L){const C=D.$ne(y,L);return L+=4,(0,T.$bt)(y,L,C)}writeSize(){return 4+4+I.a(this.oldText)+I.a(this.newText)}write(y,L){return D.$oe(y,this.oldPosition,L),L+=4,D.$oe(y,this.newPosition,L),L+=4,L=I.c(y,this.oldText,L),L=I.c(y,this.newText,L),L}static read(y,L,C){const m=D.$ne(y,L);L+=4;const p=D.$ne(y,L);L+=4;const S=I.d(y,L);L+=I.a(S);const d=I.d(y,L);return L+=I.a(d),C.push(new I(m,S,p,d)),L}}e.$dt=I;function R($,y){return $===null||$.length===0?y:new b($,y).compress()}e.$et=R;class b{constructor(y,L){this.a=y,this.c=L,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,L=0,C=this.n(y),m=this.l(L);for(;y<this.f||L<this.h;){if(C===null){this.k(m),m=this.l(++L);continue}if(m===null){this.m(C),C=this.n(++y);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++L);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++y);continue}if(m.oldPosition<C.newPosition){const[o,i]=b.r(m,C.newPosition-m.oldPosition);this.k(o),m=i;continue}if(C.newPosition<m.oldPosition){const[o,i]=b.q(C,m.oldPosition-C.newPosition);this.m(o),C=i;continue}let d,f;if(m.oldEnd===C.newEnd)d=C,f=m,C=this.n(++y),m=this.l(++L);else if(m.oldEnd<C.newEnd){const[o,i]=b.q(C,m.oldLength);d=o,f=m,C=i,m=this.l(++L)}else{const[o,i]=b.r(m,C.newLength);d=C,f=o,C=this.n(++y),m=i}this.d[this.e++]=new I(d.oldPosition,d.oldText,f.newPosition,f.newText),this.g+=d.newLength-d.oldLength,this.j+=f.newLength-f.oldLength}const p=b.s(this.d);return b.t(p)}k(y){this.d[this.e++]=b.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=b.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,L){return new I(L.oldPosition-y,L.oldText,L.newPosition,L.newText)}static p(y,L){return new I(L.oldPosition,L.oldText,L.newPosition+y,L.newText)}static q(y,L){const C=y.newText.substr(0,L),m=y.newText.substr(L);return[new I(y.oldPosition,y.oldText,y.newPosition,C),new I(y.oldEnd,"",y.newPosition+L,m)]}static r(y,L){const C=y.oldText.substr(0,L),m=y.oldText.substr(L);return[new I(y.oldPosition,C,y.newPosition,y.newText),new I(y.oldPosition+L,m,y.newEnd,"")]}static s(y){if(y.length===0)return y;const L=[];let C=0,m=y[0];for(let p=1;p<y.length;p++){const S=y[p];m.oldEnd===S.oldPosition?m=new I(m.oldPosition,m.oldText+S.oldText,m.newPosition,m.newText+S.newText):(L[C++]=m,m=S)}return L[C++]=m,L}static t(y){if(y.length===0)return y;const L=[];let C=0;for(let m=0;m<y.length;m++){const p=y[m];p.oldText!==p.newText&&(L[C++]=p)}return L}}}),define(ke[191],Se([1,0,34,17]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0;function g(I,R,b,$,y,L){if(Array.isArray(I)){let C=0;for(const m of I){const p=g(m,R,b,$,y,L);if(p===10)return p;p>C&&(C=p)}return C}else{if(typeof I=="string")return $?I==="*"?5:I===b?10:0:0;if(I){const{language:C,pattern:m,scheme:p,hasAccessToAllModels:S,notebookType:d}=I;if(!$&&!S)return 0;d&&y&&(R=y);let f=0;if(p)if(p===R.scheme)f=10;else if(p==="*")f=5;else return 0;if(C)if(C===b)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(d)if(d===L)f=10;else if(d==="*"&&L!==void 0)f=Math.max(f,5);else return 0;if(m){let o;if(typeof m=="string"?o=m:o={...m,base:(0,T.$hc)(m.base)},o===R.fsPath||(0,D.$Lj)(o,R.fsPath))f=10;else return 0}return f}else return 0}}e.$Bt=g}),define(ke[192],Se([1,0,4,12,29,79,127,167,190,3]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=void 0;class L extends y.$Tc{constructor(m,p,S,d,f,o,i){super(),this.m=this.B(new D.$Vd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!o,this.g=d,this.h=f,this.c=new R.$aC(m,S,i)}equals(m){return!(m instanceof L)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,p){return this.c.getOffsetAt(m,p)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,p){const S=m+p,d=this.getPositionAt(m),f=this.getPositionAt(S);return new g.$Us(d.lineNumber,d.column,f.lineNumber,f.column)}getValueInRange(m,p=0){if(m.isEmpty())return"";const S=this.n(p);return this.c.getValueInRange(m,S)}getValueLengthInRange(m,p=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const S=this.getOffsetAt(m.startLineNumber,m.startColumn),d=this.getOffsetAt(m.endLineNumber,m.endColumn);let f=0;const o=this.n(p),i=this.getEOL();if(o.length!==i.length){const s=o.length-i.length,n=m.endLineNumber-m.startLineNumber;f=s*n}return d-S+f}getCharacterCountInRange(m,p=0){if(this.j){let S=0;const d=m.startLineNumber,f=m.endLineNumber;for(let o=d;o<=f;o++){const i=this.getLineContent(o),s=o===d?m.startColumn-1:0,n=o===f?m.endColumn-1:i.length;for(let c=s;c<n;c++)T.$df(i.charCodeAt(c))?(S=S+1,c=c+1):S=S+1}return S+=this.n(p).length*(f-d),S}return this.getValueLengthInRange(m,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,p){return this.c.getLineCharCode(m,p)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const p=T.$1e(this.getLineContent(m));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(m){const p=T.$3e(this.getLineContent(m));return p===-1?0:p+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,p,S){let d=this.g,f=this.h,o=this.j,i=!0,s=[];for(let u=0;u<m.length;u++){const l=m[u];i&&l._isTracked&&(i=!1);const k=l.range;if(l.text){let P=!0;o||(P=!T.$of(l.text),o=P),!d&&P&&(d=T.$nf(l.text)),!f&&P&&(f=T.$qf(l.text))}let A="",v=0,w=0,E=0;if(l.text){let P;[v,w,E,P]=(0,b.$ut)(l.text);const N=this.getEOL();P===0||P===(N===`\r
`?2:1)?A=l.text:A=l.text.replace(/\r\n|\r|\n/g,N)}s[u]={sortIndex:u,identifier:l.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:A,eolCount:v,firstLineLength:w,lastLineLength:E,forceMoveMarkers:!!l.forceMoveMarkers,isAutoWhitespaceEdit:l.isAutoWhitespaceEdit||!1}}s.sort(L.u);let n=!1;for(let u=0,l=s.length-1;u<l;u++){const k=s[u].range.getEndPosition(),A=s[u+1].range.getStartPosition();if(A.isBeforeOrEqual(k)){if(A.isBefore(k))throw new Error("Overlapping ranges are not allowed!");n=!0}}i&&(s=this.s(s));const c=S||p?L._getInverseEditRanges(s):[],t=[];if(p)for(let u=0;u<s.length;u++){const l=s[u],k=c[u];if(l.isAutoWhitespaceEdit&&l.range.isEmpty())for(let A=k.startLineNumber;A<=k.endLineNumber;A++){let v="";A===k.startLineNumber&&(v=this.getLineContent(l.range.startLineNumber),T.$1e(v)!==-1)||t.push({lineNumber:A,oldContent:v})}}let a=null;if(S){let u=0;a=[];for(let l=0;l<s.length;l++){const k=s[l],A=c[l],v=this.getValueInRange(k.range),w=k.rangeOffset+u;u+=k.text.length-v.length,a[l]={sortIndex:k.sortIndex,identifier:k.identifier,range:A,text:v,textChange:new $.$dt(k.rangeOffset,v,w,k.text)}}n||a.sort((l,k)=>l.sortIndex-k.sortIndex)}this.g=d,this.h=f,this.j=o;const r=this.t(s);let h=null;if(p&&t.length>0){t.sort((u,l)=>l.lineNumber-u.lineNumber),h=[];for(let u=0,l=t.length;u<l;u++){const k=t[u].lineNumber;if(u>0&&t[u-1].lineNumber===k)continue;const A=t[u].oldContent,v=this.getLineContent(k);v.length===0||v===A||T.$1e(v)!==-1||h.push(k)}}return this.m.fire(),new I.$ev(a,r,h)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let p=!1;const S=m[0].range,d=m[m.length-1].range,f=new g.$Us(S.startLineNumber,S.startColumn,d.endLineNumber,d.endColumn);let o=S.startLineNumber,i=S.startColumn;const s=[];for(let r=0,h=m.length;r<h;r++){const u=m[r],l=u.range;p=p||u.forceMoveMarkers,s.push(this.getValueInRange(new g.$Us(o,i,l.startLineNumber,l.startColumn))),u.text.length>0&&s.push(u.text),o=l.endLineNumber,i=l.endColumn}const n=s.join(""),[c,t,a]=(0,b.$ut)(n);return{sortIndex:0,identifier:m[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:n,eolCount:c,firstLineLength:t,lastLineLength:a,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(m){m.sort(L.w);const p=[];for(let S=0;S<m.length;S++){const d=m[S],f=d.range.startLineNumber,o=d.range.startColumn,i=d.range.endLineNumber,s=d.range.endColumn;if(f===i&&o===s&&d.text.length===0)continue;d.text?(this.c.delete(d.rangeOffset,d.rangeLength),this.c.insert(d.rangeOffset,d.text,!0)):this.c.delete(d.rangeOffset,d.rangeLength);const n=new g.$Us(f,o,i,s);p.push({range:n,rangeLength:d.rangeLength,text:d.text,rangeOffset:d.rangeOffset,forceMoveMarkers:d.forceMoveMarkers})}return p}findMatchesLineByLine(m,p,S,d){return this.c.findMatchesLineByLine(m,p,S,d)}getPieceTree(){return this.c}static _getInverseEditRange(m,p){const S=m.startLineNumber,d=m.startColumn,[f,o,i]=(0,b.$ut)(p);let s;if(p.length>0){const n=f+1;n===1?s=new g.$Us(S,d,S,d+o):s=new g.$Us(S,d,S+n-1,i+1)}else s=new g.$Us(S,d,S,d);return s}static _getInverseEditRanges(m){const p=[];let S=0,d=0,f=null;for(let o=0,i=m.length;o<i;o++){const s=m[o];let n,c;f?f.range.endLineNumber===s.range.startLineNumber?(n=S,c=d+(s.range.startColumn-f.range.endColumn)):(n=S+(s.range.startLineNumber-f.range.endLineNumber),c=s.range.startColumn):(n=s.range.startLineNumber,c=s.range.startColumn);let t;if(s.text.length>0){const a=s.eolCount+1;a===1?t=new g.$Us(n,c,n,c+s.firstLineLength):t=new g.$Us(n,c,n+a-1,s.lastLineLength+1)}else t=new g.$Us(n,c,n,c);S=t.endLineNumber,d=t.endColumn,p.push(t),f=s}return p}static u(m,p){const S=g.$Us.compareRangesUsingEnds(m.range,p.range);return S===0?m.sortIndex-p.sortIndex:S}static w(m,p){const S=g.$Us.compareRangesUsingEnds(m.range,p.range);return S===0?p.sortIndex-m.sortIndex:-S}}e.$bC=L}),define(ke[193],Se([1,0,12,127,192]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class I{constructor($,y,L,C,m,p,S,d,f){this.a=$,this.b=y,this.c=L,this.d=C,this.e=m,this.f=p,this.g=S,this.h=d,this.j=f}k($){const y=this.c+this.d+this.e,L=this.c+this.e;return y===0?$===1?`
`:`\r
`:L>y/2?`\r
`:`
`}create($){const y=this.k($),L=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let m=0,p=L.length;m<p;m++){const S=L[m].buffer.replace(/\r\n|\r|\n/g,y),d=(0,T.$9B)(S);L[m]=new T.$_B(S,d)}const C=new g.$bC(L,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$wf($)&&(this.b=D.$vf,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,T.$0B)(this.e,$);this.a.push(new T.$_B($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$nf($)),this.k||(this.k=D.$qf($)))}finish($=!0){return this.o(),new I(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,T.$9B)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$cC=R}),define(ke[131],Se([1,0,22,10]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$=e.$w$=void 0;var g;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(g||(g={}));function I(C){for(let m=0,p=C.length;m<p;m+=4){const S=C[m+0],d=C[m+1],f=C[m+2],o=C[m+3];C[m+0]=o,C[m+1]=f,C[m+2]=d,C[m+3]=S}}function R(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return T.$D()||I(m),D.$je.wrap(m)}function b(C){const m=C.buffer;if(T.$D()||I(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const p=new Uint8Array(m.byteLength);return p.set(m),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function $(C){const m=new Uint32Array(y(C));let p=0;if(m[p++]=C.id,C.type==="full")m[p++]=1,m[p++]=C.data.length,m.set(C.data,p),p+=C.data.length;else{m[p++]=2,m[p++]=C.deltas.length;for(const S of C.deltas)m[p++]=S.start,m[p++]=S.deleteCount,S.data?(m[p++]=S.data.length,m.set(S.data,p),p+=S.data.length):m[p++]=0}return R(m)}e.$w$=$;function y(C){let m=0;if(m+=1+1,C.type==="full")m+=1+C.data.length;else{m+=1,m+=(1+1+1)*C.deltas.length;for(const p of C.deltas)p.data&&(m+=p.data.length)}return m}function L(C){const m=b(C);let p=0;const S=m[p++];if(m[p++]===1){const i=m[p++],s=m.subarray(p,p+i);return p+=i,{id:S,type:"full",data:s}}const f=m[p++],o=[];for(let i=0;i<f;i++){const s=m[p++],n=m[p++],c=m[p++];let t;c>0&&(t=m.subarray(p,p+c),p+=c),o[i]={start:s,deleteCount:n,data:t}}return{id:S,type:"delta",deltas:o}}e.$x$=L}),define(ke[194],Se([8,9]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ke[132],Se([1,0,19,24,10,170,126,194]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(se){this.c=se}hasChanged(se){return this.c[se]}}e.ConfigurationChangedEvent=y;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class C{constructor(se,Ie,qe,Xe){this.id=se,this.name=Ie,this.defaultValue=qe,this.schema=Xe}applyUpdate(se,Ie){return p(se,Ie)}compute(se,Ie,qe){return qe}}class m{constructor(se,Ie){this.newValue=se,this.didChange=Ie}}e.ApplyUpdateResult=m;function p(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new m(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const qe=Array.isArray(re)&&Array.isArray(se)&&D.$ub(re,se);return new m(se,!qe)}let Ie=!1;for(const qe in se)if(se.hasOwnProperty(qe)){const Xe=p(re[qe],se[qe]);Xe.didChange&&(re[qe]=Xe.newValue,Ie=!0)}return new m(re,Ie)}class S{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ie){return p(se,Ie)}validate(se){return this.defaultValue}}class d{constructor(se,Ie,qe,Xe){this.id=se,this.name=Ie,this.defaultValue=qe,this.schema=Xe}applyUpdate(se,Ie){return p(se,Ie)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ie,qe){return qe}}function f(re,se){return typeof re>"u"?se:re==="false"?!1:!!re}e.boolean=f;class o extends d{constructor(se,Ie,qe,Xe=void 0){typeof Xe<"u"&&(Xe.type="boolean",Xe.default=qe),super(se,Ie,qe,Xe)}validate(se){return f(se,this.defaultValue)}}function i(re,se,Ie,qe){if(typeof re>"u")return se;let Xe=parseInt(re,10);return isNaN(Xe)?se:(Xe=Math.max(Ie,Xe),Xe=Math.min(qe,Xe),Xe|0)}e.clampedInt=i;class s extends d{static clampedInt(se,Ie,qe,Xe){return i(se,Ie,qe,Xe)}constructor(se,Ie,qe,Xe,it,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=qe,nt.minimum=Xe,nt.maximum=it),super(se,Ie,qe,nt),this.minimum=Xe,this.maximum=it}validate(se){return s.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function n(re,se,Ie,qe){if(typeof re>"u")return se;const Xe=c.float(re,se);return c.clamp(Xe,Ie,qe)}e.clampedFloat=n;class c extends d{static clamp(se,Ie,qe){return se<Ie?Ie:se>qe?qe:se}static float(se,Ie){if(typeof se=="number")return se;if(typeof se>"u")return Ie;const qe=parseFloat(se);return isNaN(qe)?Ie:qe}constructor(se,Ie,qe,Xe,it){typeof it<"u"&&(it.type="number",it.default=qe),super(se,Ie,qe,it),this.validationFn=Xe}validate(se){return this.validationFn(c.float(se,this.defaultValue))}}class t extends d{static string(se,Ie){return typeof se!="string"?Ie:se}constructor(se,Ie,qe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.default=qe),super(se,Ie,qe,Xe)}validate(se){return t.string(se,this.defaultValue)}}function a(re,se,Ie,qe){return typeof re!="string"?se:qe&&re in qe?qe[re]:Ie.indexOf(re)===-1?se:re}e.stringSet=a;class r extends d{constructor(se,Ie,qe,Xe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Xe,it.default=qe),super(se,Ie,qe,it),this.c=Xe}validate(se){return a(se,this.defaultValue,this.c)}}class h extends C{constructor(se,Ie,qe,Xe,it,nt,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.enum=it,Oe.default=Xe),super(se,Ie,qe,Oe),this.c=it,this.d=nt}validate(se){return typeof se!="string"?this.defaultValue:this.c.indexOf(se)===-1?this.defaultValue:this.d(se)}}function u(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ie,qe){return qe===0?se.accessibilitySupport:qe}}class k extends C{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:b.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{insertSpace:f(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var A;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(A||(e.TextEditorCursorBlinkingStyle=A={}));function v(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function E(re){switch(re){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function P(re){switch(re){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class N extends S{constructor(){super(140)}compute(se,Ie,qe){const Xe=["monaco-editor"];return Ie.get(39)&&Xe.push(Ie.get(39)),se.extraEditorClassName&&Xe.push(se.extraEditorClassName),Ie.get(73)==="default"?Xe.push("mouse-default"):Ie.get(73)==="copy"&&Xe.push("mouse-copy"),Ie.get(110)&&Xe.push("showUnused"),Ie.get(138)&&Xe.push("showDeprecated"),Xe.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(se,Ie,qe){return qe&&se.emptySelectionClipboard}}class F extends C{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:b.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:b.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{cursorMoveOnType:f(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":a(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":a(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Ie.loop,this.defaultValue.loop)}}}class j extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"||se.length===0?j.OFF:se==="true"?j.ON:se:se?j.ON:j.OFF}}e.EditorFontLigatures=j;class M extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?M.OFF:se==="true"?M.TRANSLATE:se:se?M.TRANSLATE:M.OFF}compute(se,Ie,qe){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class O extends S{constructor(){super(50)}compute(se,Ie,qe){return se.fontInfo}}class U extends d{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(se){const Ie=c.float(se,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Ie,6,100)}compute(se,Ie,qe){return se.fontInfo.fontSize}}class Q extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Q.d,maximum:Q.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(s.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,Q.d,Q.e))}}class ue extends C{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:qe,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:qe,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:qe,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:qe,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:qe,description:b.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{multiple:a(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??a(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??a(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??a(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??a(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??a(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends C{constructor(){const se={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:se.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:se.above,description:b.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:f(Ie.enabled,this.defaultValue.enabled),delay:s.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:f(Ie.sticky,this.defaultValue.sticky),hidingDelay:s.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Ie.above,this.defaultValue.above)}}}var J;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class X extends S{constructor(){super(143)}compute(se,Ie,qe){return X.computeLayout(Ie,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const Ie=se.height/se.lineHeight,qe=Math.floor(se.paddingTop/se.lineHeight);let Xe=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(Xe=Math.max(Xe,Ie-1));const it=(qe+se.viewLineCount+Xe)/(se.pixelRatio*se.height),nt=Math.floor(se.viewLineCount/it);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Xe,desiredRatio:it,minimapLineCount:nt}}static c(se,Ie){const qe=se.outerWidth,Xe=se.outerHeight,it=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Xe};const nt=Ie.stableMinimapLayoutInput,Oe=nt&&se.outerHeight===nt.outerHeight&&se.lineHeight===nt.lineHeight&&se.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&se.pixelRatio===nt.pixelRatio&&se.scrollBeyondLastLine===nt.scrollBeyondLastLine&&se.paddingTop===nt.paddingTop&&se.paddingBottom===nt.paddingBottom&&se.minimap.enabled===nt.minimap.enabled&&se.minimap.side===nt.minimap.side&&se.minimap.size===nt.minimap.size&&se.minimap.showSlider===nt.minimap.showSlider&&se.minimap.renderCharacters===nt.minimap.renderCharacters&&se.minimap.maxColumn===nt.minimap.maxColumn&&se.minimap.scale===nt.minimap.scale&&se.verticalScrollbarWidth===nt.verticalScrollbarWidth&&se.isViewportWrapping===nt.isViewportWrapping,yt=se.lineHeight,Dt=se.typicalHalfwidthCharacterWidth,Nt=se.scrollBeyondLastLine,Ft=se.minimap.renderCharacters;let Et=it>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const Ht=se.minimap.maxColumn,Ot=se.minimap.size,Xt=se.minimap.side,Vt=se.verticalScrollbarWidth,Ut=se.viewLineCount,et=se.remainingWidth,Gt=se.isViewportWrapping,Jt=Ft?2:3;let ht=Math.floor(it*Xe);const $t=ht/it;let Bt=!1,Qt=!1,kt=Jt*Et,ft=Et/it,It=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Tt,extraLinesBeyondLastLine:Rt,desiredRatio:Wt,minimapLineCount:Me}=X.computeContainedMinimapLineCount({viewLineCount:Ut,scrollBeyondLastLine:Nt,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:Xe,lineHeight:yt,pixelRatio:it});if(Ut/Me>1)Bt=!0,Qt=!0,Et=1,kt=1,ft=Et/it;else{let De=!1,ae=Et+1;if(Ot==="fit"){const Ne=Math.ceil((Tt+Ut+Rt)*kt);Gt&&Oe&&et<=Ie.stableFitRemainingWidth?(De=!0,ae=Ie.stableFitMaxMinimapScale):De=Ne>ht}if(Ot==="fill"||De){Bt=!0;const Ne=Et;kt=Math.min(yt*it,Math.max(1,Math.floor(1/Wt))),Gt&&Oe&&et<=Ie.stableFitRemainingWidth&&(ae=Ie.stableFitMaxMinimapScale),Et=Math.min(ae,Math.max(1,Math.floor(kt/Jt))),Et>Ne&&(It=Math.min(2,Et/Ne)),ft=Et/it/It,ht=Math.ceil(Math.max(gt,Tt+Ut+Rt)*kt),Gt?(Ie.stableMinimapLayoutInput=se,Ie.stableFitRemainingWidth=et,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const _t=Math.floor(Ht*ft),At=Math.min(_t,Math.max(0,Math.floor((et-Vt-2)*ft/(Dt+ft)))+e.MINIMAP_GUTTER_WIDTH);let Je=Math.floor(it*At);const Mt=Je/it;Je=Math.floor(Je*It);const jt=Ft?1:2,Yt=Xt==="left"?0:qe-At-Vt;return{renderMinimap:jt,minimapLeft:Yt,minimapWidth:At,minimapHeightIsEditorHeight:Bt,minimapIsSampling:Qt,minimapScale:Et,minimapLineHeight:kt,minimapCanvasInnerWidth:Je,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:$t}}static computeLayout(se,Ie){const qe=Ie.outerWidth|0,Xe=Ie.outerHeight|0,it=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,Oe=Ie.typicalHalfwidthCharacterWidth,yt=Ie.maxDigitWidth,Dt=Ie.pixelRatio,Nt=Ie.viewLineCount,Ft=se.get(135),Et=Ft==="inherit"?se.get(134):Ft,Ht=Et==="inherit"?se.get(130):Et,Ot=se.get(133),Xt=Ie.isDominatedByLongLines,Vt=se.get(57),Ut=se.get(67).renderType!==0,et=se.get(68),Gt=se.get(104),Jt=se.get(83),ht=se.get(72),$t=se.get(102),Bt=$t.verticalScrollbarSize,Qt=$t.verticalHasArrows,kt=$t.arrowSize,ft=$t.horizontalScrollbarSize,It=se.get(43),_t=se.get(109)!=="never";let At=se.get(65);It&&_t&&(At+=16);let Je=0;if(Ut){const xe=Math.max(nt,et);Je=Math.round(xe*yt)}let Mt=0;Vt&&(Mt=it*Ie.glyphMarginDecorationLaneCount);let jt=0,Yt=jt+Mt,gt=Yt+Je,Tt=gt+At;const Rt=qe-Mt-Je-At;let Wt=!1,Me=!1,Fe=-1;Et==="inherit"&&Xt?(Wt=!0,Me=!0):Ht==="on"||Ht==="bounded"?Me=!0:Ht==="wordWrapColumn"&&(Fe=Ot);const De=X.c({outerWidth:qe,outerHeight:Xe,lineHeight:it,typicalHalfwidthCharacterWidth:Oe,pixelRatio:Dt,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:ht,verticalScrollbarWidth:Bt,viewLineCount:Nt,remainingWidth:Rt,isViewportWrapping:Me},Ie.memory||new L);De.renderMinimap!==0&&De.minimapLeft===0&&(jt+=De.minimapWidth,Yt+=De.minimapWidth,gt+=De.minimapWidth,Tt+=De.minimapWidth);const ae=Rt-De.minimapWidth,Ne=Math.max(1,Math.floor((ae-Bt-2)/Oe)),Ue=Qt?kt:0;return Me&&(Fe=Math.max(1,Ne),Ht==="bounded"&&(Fe=Math.min(Fe,Ot))),{width:qe,height:Xe,glyphMarginLeft:jt,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Yt,lineNumbersWidth:Je,decorationsLeft:gt,decorationsWidth:At,contentLeft:Tt,contentWidth:ae,minimap:De,viewportColumn:Ne,isWordWrapMinified:Wt,isViewportWrapping:Me,wrappingColumn:Fe,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:ft,overviewRuler:{top:Ue,width:Bt,height:Xe-2*Ue,right:0}}}}e.EditorLayoutInfoComputer=X;class le extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(se){return a(se,"simple",["simple","advanced"])}compute(se,Ie,qe){return Ie.get(2)===2?"advanced":qe}}var x;(function(re){re.Off="off",re.OnCode="onCode",re.On="on"})(x||(e.ShowLightbulbIconMode=x={}));class be extends C{constructor(){const se={enabled:x.On};super(64,"lightbulb",se,{"editor.lightbulb.enabled":{type:"string",enum:[x.Off,x.OnCode,x.On],default:se.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:a(se.enabled,this.defaultValue.enabled,[x.Off,x.OnCode,x.On])}}}class ce extends C{constructor(){const se={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:b.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:b.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:f(Ie.enabled,this.defaultValue.enabled),maxLineCount:s.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class G extends C{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:b.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:a(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:s.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:f(Ie.padding,this.defaultValue.padding)}}}class W extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):s.clampedInt(se,this.defaultValue,0,1e3)}compute(se,Ie,qe){return qe<0?s.clampedInt(-qe*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class ne extends c{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>c.clamp(se,0,150),{markdownDescription:b.localize(66,null)})}compute(se,Ie,qe){return se.fontInfo.lineHeight}}class ye extends C{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:se.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:b.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:f(Ie.enabled,this.defaultValue.enabled),autohide:f(Ie.autohide,this.defaultValue.autohide),size:a(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(Ie.side,this.defaultValue.side,["right","left"]),showSlider:a(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(Ie.scale,1,1,3),maxColumn:s.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(re){return re==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class ge extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(79,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{top:s.clampedInt(Ie.top,0,0,1e3),bottom:s.clampedInt(Ie.bottom,0,0,1e3)}}}class _ extends C{constructor(){const se={enabled:!0,cycle:!0};super(85,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:b.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:b.localize(81,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:f(Ie.enabled,this.defaultValue.enabled),cycle:f(Ie.cycle,this.defaultValue.cycle)}}}class te extends S{constructor(){super(141)}compute(se,Ie,qe){return se.pixelRatio}}class K extends C{constructor(){const se={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(82,null),b.localize(83,null),b.localize(84,null)]}];super(88,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:se.strings,description:b.localize(85,null)},comments:{anyOf:Ie,default:se.comments,description:b.localize(86,null)},other:{anyOf:Ie,default:se.other,description:b.localize(87,null)}},default:se,markdownDescription:b.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Dt=se?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ie,comments:qe,strings:Xe}=se,it=["on","inline","off"];let nt,Oe,yt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=a(Ie,this.defaultValue.other,it),typeof qe=="boolean"?Oe=qe?"on":"off":Oe=a(qe,this.defaultValue.comments,it),typeof Xe=="boolean"?yt=Xe?"on":"off":yt=a(Xe,this.defaultValue.strings,it),{other:nt,comments:Oe,strings:yt}}}var ie;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class fe extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(89,null),b.localize(90,null),b.localize(91,null),b.localize(92,null)],default:"on",description:b.localize(93,null)})}validate(se){let Ie=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ie=4,qe=se):se==="interval"?Ie=3:se==="relative"?Ie=2:se==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:qe}}}function pe(re){const se=re.get(97);return se==="editable"?re.get(90):se!=="on"}e.filterValidationDecorations=pe;class Pe extends C{constructor(){const se=[],Ie={type:"number",description:b.localize(94,null)};super(101,"rulers",se,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(95,null),format:"color-hex"}}}]},default:se,description:b.localize(96,null)})}validate(se){if(Array.isArray(se)){const Ie=[];for(const qe of se)if(typeof qe=="number")Ie.push({column:s.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Xe=qe;Ie.push({column:s.clampedInt(Xe.column,0,0,1e4),color:Xe.color})}return Ie.sort((qe,Xe)=>qe.column-Xe.column),Ie}return this.defaultValue}}class we extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function Ce(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends C{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(97,null),b.localize(98,null),b.localize(99,null)],default:"auto",description:b.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(101,null),b.localize(102,null),b.localize(103,null)],default:"auto",description:b.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:b.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:b.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:b.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:se.ignoreHorizontalScrollbarInContentHeight,description:b.localize(108,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se,qe=s.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Xe=s.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(Ie.vertical,this.defaultValue.vertical),horizontal:Ce(Ie.horizontal,this.defaultValue.horizontal),useShadows:f(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:s.clampedInt(Ie.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Xe,verticalSliderSize:s.clampedInt(Ie.verticalSliderSize,Xe,0,1e3),scrollByPage:f(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Y extends C{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:b.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:b.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:b.localize(115,null)}})}applyUpdate(se,Ie){let qe=!1;Ie.allowedCharacters&&se&&(T.$zn(se.allowedCharacters,Ie.allowedCharacters)||(se={...se,allowedCharacters:Ie.allowedCharacters},qe=!0)),Ie.allowedLocales&&se&&(T.$zn(se.allowedLocales,Ie.allowedLocales)||(se={...se,allowedLocales:Ie.allowedLocales},qe=!0));const Xe=super.applyUpdate(se,Ie);return qe?new m(Xe.newValue,!0):Xe}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{nonBasicASCII:he(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(se.allowedLocales,this.defaultValue.allowedLocales)}}c(se,Ie){if(typeof se!="object"||!se)return Ie;const qe={};for(const[Xe,it]of Object.entries(se))it===!0&&(qe[Xe]=!0);return qe}}class ee extends C{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:b.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(117,null),b.localize(118,null),b.localize(119,null)],description:b.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:b.localize(121,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:f(Ie.enabled,this.defaultValue.enabled),mode:a(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class q extends C{constructor(){const se={enabled:I.$ss.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.$ss.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:b.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:b.localize(123,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:f(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class oe extends C{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(124,null),b.localize(125,null),b.localize(126,null)],default:se.bracketPairs,description:b.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(128,null),b.localize(129,null),b.localize(130,null)],default:se.bracketPairsHorizontal,description:b.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:b.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:b.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(134,null),b.localize(135,null),b.localize(136,null)],default:se.highlightActiveIndentation,description:b.localize(137,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{bracketPairs:he(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(re,se,Ie){const qe=Ie.indexOf(re);return qe===-1?se:Ie[qe]}class Le extends C{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(138,null),b.localize(139,null)],default:se.insertMode,description:b.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:b.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:b.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:b.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(144,null),b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:se.selectionMode,markdownDescription:b.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:b.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:b.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:b.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:b.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:b.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{insertMode:a(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:f(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:f(Ie.preview,this.defaultValue.preview),previewMode:a(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Ie.showMethods,this.defaultValue.showMethods),showFunctions:f(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Ie.showFields,this.defaultValue.showFields),showVariables:f(Ie.showVariables,this.defaultValue.showVariables),showClasses:f(Ie.showClasses,this.defaultValue.showClasses),showStructs:f(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:f(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Ie.showModules,this.defaultValue.showModules),showProperties:f(Ie.showProperties,this.defaultValue.showProperties),showEvents:f(Ie.showEvents,this.defaultValue.showEvents),showOperators:f(Ie.showOperators,this.defaultValue.showOperators),showUnits:f(Ie.showUnits,this.defaultValue.showUnits),showValues:f(Ie.showValues,this.defaultValue.showValues),showConstants:f(Ie.showConstants,this.defaultValue.showConstants),showEnums:f(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Ie.showKeywords,this.defaultValue.showKeywords),showWords:f(Ie.showWords,this.defaultValue.showWords),showColors:f(Ie.showColors,this.defaultValue.showColors),showFiles:f(Ie.showFiles,this.defaultValue.showFiles),showReferences:f(Ie.showReferences,this.defaultValue.showReferences),showFolders:f(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:f(Ie.showUsers,this.defaultValue.showUsers),showIssues:f(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(187,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(se.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Qe extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(188,null),b.localize(189,null),b.localize(190,null),b.localize(191,null)],description:b.localize(192,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,Ie,qe){return Ie.get(2)===2?0:qe}}class _e extends S{constructor(){super(144)}compute(se,Ie,qe){const Xe=Ie.get(143);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Xe.isWordWrapMinified,isViewportWrapping:Xe.isViewportWrapping,wrappingColumn:Xe.wrappingColumn}}}class at extends C{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:b.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(195,null),b.localize(196,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showDropSelector:a(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends C{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:b.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(199,null),b.localize(200,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showPasteSelector:a(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?Ae:g.$k?ze:rt,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(re){return e.editorOptionsRegistry[re.id]=re,re}var Ye;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.ariaRequired=5]="ariaRequired",re[re.autoClosingBrackets=6]="autoClosingBrackets",re[re.autoClosingComments=7]="autoClosingComments",re[re.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",re[re.autoClosingDelete=9]="autoClosingDelete",re[re.autoClosingOvertype=10]="autoClosingOvertype",re[re.autoClosingQuotes=11]="autoClosingQuotes",re[re.autoIndent=12]="autoIndent",re[re.automaticLayout=13]="automaticLayout",re[re.autoSurround=14]="autoSurround",re[re.bracketPairColorization=15]="bracketPairColorization",re[re.guides=16]="guides",re[re.codeLens=17]="codeLens",re[re.codeLensFontFamily=18]="codeLensFontFamily",re[re.codeLensFontSize=19]="codeLensFontSize",re[re.colorDecorators=20]="colorDecorators",re[re.colorDecoratorsLimit=21]="colorDecoratorsLimit",re[re.columnSelection=22]="columnSelection",re[re.comments=23]="comments",re[re.contextmenu=24]="contextmenu",re[re.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",re[re.cursorBlinking=26]="cursorBlinking",re[re.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",re[re.cursorStyle=28]="cursorStyle",re[re.cursorSurroundingLines=29]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",re[re.cursorWidth=31]="cursorWidth",re[re.disableLayerHinting=32]="disableLayerHinting",re[re.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",re[re.domReadOnly=34]="domReadOnly",re[re.dragAndDrop=35]="dragAndDrop",re[re.dropIntoEditor=36]="dropIntoEditor",re[re.emptySelectionClipboard=37]="emptySelectionClipboard",re[re.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",re[re.extraEditorClassName=39]="extraEditorClassName",re[re.fastScrollSensitivity=40]="fastScrollSensitivity",re[re.find=41]="find",re[re.fixedOverflowWidgets=42]="fixedOverflowWidgets",re[re.folding=43]="folding",re[re.foldingStrategy=44]="foldingStrategy",re[re.foldingHighlight=45]="foldingHighlight",re[re.foldingImportsByDefault=46]="foldingImportsByDefault",re[re.foldingMaximumRegions=47]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=49]="fontFamily",re[re.fontInfo=50]="fontInfo",re[re.fontLigatures=51]="fontLigatures",re[re.fontSize=52]="fontSize",re[re.fontWeight=53]="fontWeight",re[re.fontVariations=54]="fontVariations",re[re.formatOnPaste=55]="formatOnPaste",re[re.formatOnType=56]="formatOnType",re[re.glyphMargin=57]="glyphMargin",re[re.gotoLocation=58]="gotoLocation",re[re.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",re[re.hover=60]="hover",re[re.inDiffEditor=61]="inDiffEditor",re[re.inlineSuggest=62]="inlineSuggest",re[re.letterSpacing=63]="letterSpacing",re[re.lightbulb=64]="lightbulb",re[re.lineDecorationsWidth=65]="lineDecorationsWidth",re[re.lineHeight=66]="lineHeight",re[re.lineNumbers=67]="lineNumbers",re[re.lineNumbersMinChars=68]="lineNumbersMinChars",re[re.linkedEditing=69]="linkedEditing",re[re.links=70]="links",re[re.matchBrackets=71]="matchBrackets",re[re.minimap=72]="minimap",re[re.mouseStyle=73]="mouseStyle",re[re.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=75]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",re[re.multiCursorModifier=77]="multiCursorModifier",re[re.multiCursorPaste=78]="multiCursorPaste",re[re.multiCursorLimit=79]="multiCursorLimit",re[re.occurrencesHighlight=80]="occurrencesHighlight",re[re.overviewRulerBorder=81]="overviewRulerBorder",re[re.overviewRulerLanes=82]="overviewRulerLanes",re[re.padding=83]="padding",re[re.pasteAs=84]="pasteAs",re[re.parameterHints=85]="parameterHints",re[re.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",re[re.quickSuggestions=88]="quickSuggestions",re[re.quickSuggestionsDelay=89]="quickSuggestionsDelay",re[re.readOnly=90]="readOnly",re[re.readOnlyMessage=91]="readOnlyMessage",re[re.renameOnType=92]="renameOnType",re[re.renderControlCharacters=93]="renderControlCharacters",re[re.renderFinalNewline=94]="renderFinalNewline",re[re.renderLineHighlight=95]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=97]="renderValidationDecorations",re[re.renderWhitespace=98]="renderWhitespace",re[re.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",re[re.roundedSelection=100]="roundedSelection",re[re.rulers=101]="rulers",re[re.scrollbar=102]="scrollbar",re[re.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=104]="scrollBeyondLastLine",re[re.scrollPredominantAxis=105]="scrollPredominantAxis",re[re.selectionClipboard=106]="selectionClipboard",re[re.selectionHighlight=107]="selectionHighlight",re[re.selectOnLineNumbers=108]="selectOnLineNumbers",re[re.showFoldingControls=109]="showFoldingControls",re[re.showUnused=110]="showUnused",re[re.snippetSuggestions=111]="snippetSuggestions",re[re.smartSelect=112]="smartSelect",re[re.smoothScrolling=113]="smoothScrolling",re[re.stickyScroll=114]="stickyScroll",re[re.stickyTabStops=115]="stickyTabStops",re[re.stopRenderingLineAfter=116]="stopRenderingLineAfter",re[re.suggest=117]="suggest",re[re.suggestFontSize=118]="suggestFontSize",re[re.suggestLineHeight=119]="suggestLineHeight",re[re.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",re[re.suggestSelection=121]="suggestSelection",re[re.tabCompletion=122]="tabCompletion",re[re.tabIndex=123]="tabIndex",re[re.unicodeHighlighting=124]="unicodeHighlighting",re[re.unusualLineTerminators=125]="unusualLineTerminators",re[re.useShadowDOM=126]="useShadowDOM",re[re.useTabStops=127]="useTabStops",re[re.wordBreak=128]="wordBreak",re[re.wordSeparators=129]="wordSeparators",re[re.wordWrap=130]="wordWrap",re[re.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=133]="wordWrapColumn",re[re.wordWrapOverride1=134]="wordWrapOverride1",re[re.wordWrapOverride2=135]="wordWrapOverride2",re[re.wrappingIndent=136]="wrappingIndent",re[re.wrappingStrategy=137]="wrappingStrategy",re[re.showDeprecated=138]="showDeprecated",re[re.inlayHints=139]="inlayHints",re[re.editorClassName=140]="editorClassName",re[re.pixelRatio=141]="pixelRatio",re[re.tabFocusMode=142]="tabFocusMode",re[re.layoutInfo=143]="layoutInfo",re[re.wrappingInfo=144]="wrappingInfo",re[re.defaultColorDecorators=145]="defaultColorDecorators",re[re.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",re[re.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ye||(e.EditorOption=Ye={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(201,null)})),acceptSuggestionOnEnter:Re(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(202,null),""],markdownDescription:b.localize(203,null)})),accessibilitySupport:Re(new l),accessibilityPageSize:Re(new s(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(204,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",b.localize(205,null))),ariaRequired:Re(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:Re(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(207,null),b.localize(208,null),""],description:b.localize(209,null)})),autoClosingComments:Re(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(210,null),b.localize(211,null),""],description:b.localize(212,null)})),autoClosingDelete:Re(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(213,null),""],description:b.localize(214,null)})),autoClosingOvertype:Re(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(215,null),""],description:b.localize(216,null)})),autoClosingQuotes:Re(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(217,null),b.localize(218,null),""],description:b.localize(219,null)})),autoIndent:Re(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[b.localize(220,null),b.localize(221,null),b.localize(222,null),b.localize(223,null),b.localize(224,null)],description:b.localize(225,null)})),automaticLayout:Re(new o(13,"automaticLayout",!1)),autoSurround:Re(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(226,null),b.localize(227,null),b.localize(228,null),""],description:b.localize(229,null)})),bracketPairColorization:Re(new q),bracketPairGuides:Re(new oe),stickyTabStops:Re(new o(115,"stickyTabStops",!1,{description:b.localize(230,null)})),codeLens:Re(new o(17,"codeLens",!0,{description:b.localize(231,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:b.localize(232,null)})),codeLensFontSize:Re(new s(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(233,null)})),colorDecorators:Re(new o(20,"colorDecorators",!0,{description:b.localize(234,null)})),colorDecoratorActivatedOn:Re(new r(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),colorDecoratorsLimit:Re(new s(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(239,null)})),columnSelection:Re(new o(22,"columnSelection",!1,{description:b.localize(240,null)})),comments:Re(new k),contextmenu:Re(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(241,null)})),cursorBlinking:Re(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:b.localize(242,null)})),cursorSmoothCaretAnimation:Re(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(243,null),b.localize(244,null),b.localize(245,null)],description:b.localize(246,null)})),cursorStyle:Re(new h(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(247,null)})),cursorSurroundingLines:Re(new s(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(248,null)})),cursorSurroundingLinesStyle:Re(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(249,null),b.localize(250,null)],markdownDescription:b.localize(251,null)})),cursorWidth:Re(new s(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(252,null)})),disableLayerHinting:Re(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new o(34,"domReadOnly",!1)),dragAndDrop:Re(new o(35,"dragAndDrop",!0,{description:b.localize(253,null)})),emptySelectionClipboard:Re(new z),dropIntoEditor:Re(new at),stickyScroll:Re(new ce),experimentalWhitespaceRendering:Re(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(254,null),b.localize(255,null),b.localize(256,null)],description:b.localize(257,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new c(40,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:b.localize(258,null)})),find:Re(new F),fixedOverflowWidgets:Re(new o(42,"fixedOverflowWidgets",!1)),folding:Re(new o(43,"folding",!0,{description:b.localize(259,null)})),foldingStrategy:Re(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(260,null),b.localize(261,null)],description:b.localize(262,null)})),foldingHighlight:Re(new o(45,"foldingHighlight",!0,{description:b.localize(263,null)})),foldingImportsByDefault:Re(new o(46,"foldingImportsByDefault",!1,{description:b.localize(264,null)})),foldingMaximumRegions:Re(new s(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(265,null)})),unfoldOnClickAfterEndOfLine:Re(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(266,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(267,null)})),fontInfo:Re(new O),fontLigatures2:Re(new j),fontSize:Re(new U),fontWeight:Re(new Q),fontVariations:Re(new M),formatOnPaste:Re(new o(55,"formatOnPaste",!1,{description:b.localize(268,null)})),formatOnType:Re(new o(56,"formatOnType",!1,{description:b.localize(269,null)})),glyphMargin:Re(new o(57,"glyphMargin",!0,{description:b.localize(270,null)})),gotoLocation:Re(new ue),hideCursorInOverviewRuler:Re(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(271,null)})),hover:Re(new Z),inDiffEditor:Re(new o(61,"inDiffEditor",!1)),letterSpacing:Re(new c(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>c.clamp(re,-5,20),{description:b.localize(272,null)})),lightbulb:Re(new be),lineDecorationsWidth:Re(new W),lineHeight:Re(new ne),lineNumbers:Re(new fe),lineNumbersMinChars:Re(new s(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new o(69,"linkedEditing",!1,{description:b.localize(273,null)})),links:Re(new o(70,"links",!0,{description:b.localize(274,null)})),matchBrackets:Re(new r(71,"matchBrackets","always",["always","near","never"],{description:b.localize(275,null)})),minimap:Re(new ye),mouseStyle:Re(new r(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new c(74,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:b.localize(276,null)})),mouseWheelZoom:Re(new o(75,"mouseWheelZoom",!1,{markdownDescription:g.$j?b.localize(277,null):b.localize(278,null)})),multiCursorMergeOverlapping:Re(new o(76,"multiCursorMergeOverlapping",!0,{description:b.localize(279,null)})),multiCursorModifier:Re(new h(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[b.localize(280,null),b.localize(281,null)],markdownDescription:b.localize(282,null)})),multiCursorPaste:Re(new r(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(283,null),b.localize(284,null)],markdownDescription:b.localize(285,null)})),multiCursorLimit:Re(new s(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(286,null)})),occurrencesHighlight:Re(new r(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(287,null),b.localize(288,null),b.localize(289,null)],markdownDescription:b.localize(290,null)})),overviewRulerBorder:Re(new o(81,"overviewRulerBorder",!0,{description:b.localize(291,null)})),overviewRulerLanes:Re(new s(82,"overviewRulerLanes",3,0,3)),padding:Re(new ge),pasteAs:Re(new st),parameterHints:Re(new _),peekWidgetDefaultFocus:Re(new r(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(292,null),b.localize(293,null)],description:b.localize(294,null)})),definitionLinkOpensInPeek:Re(new o(87,"definitionLinkOpensInPeek",!1,{description:b.localize(295,null)})),quickSuggestions:Re(new K),quickSuggestionsDelay:Re(new s(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(296,null)})),readOnly:Re(new o(90,"readOnly",!1)),readOnlyMessage:Re(new we),renameOnType:Re(new o(92,"renameOnType",!1,{description:b.localize(297,null),markdownDeprecationMessage:b.localize(298,null)})),renderControlCharacters:Re(new o(93,"renderControlCharacters",!0,{description:b.localize(299,null),restricted:!0})),renderFinalNewline:Re(new r(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(300,null)})),renderLineHighlight:Re(new r(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(301,null)],description:b.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Re(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(303,null)})),renderValidationDecorations:Re(new r(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new r(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(304,null),b.localize(305,null),b.localize(306,null),""],description:b.localize(307,null)})),revealHorizontalRightPadding:Re(new s(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new o(100,"roundedSelection",!0,{description:b.localize(308,null)})),rulers:Re(new Pe),scrollbar:Re(new B),scrollBeyondLastColumn:Re(new s(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(309,null)})),scrollBeyondLastLine:Re(new o(104,"scrollBeyondLastLine",!0,{description:b.localize(310,null)})),scrollPredominantAxis:Re(new o(105,"scrollPredominantAxis",!0,{description:b.localize(311,null)})),selectionClipboard:Re(new o(106,"selectionClipboard",!0,{description:b.localize(312,null),included:g.$k})),selectionHighlight:Re(new o(107,"selectionHighlight",!0,{description:b.localize(313,null)})),selectOnLineNumbers:Re(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Re(new r(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(314,null),b.localize(315,null),b.localize(316,null)],description:b.localize(317,null)})),showUnused:Re(new o(110,"showUnused",!0,{description:b.localize(318,null)})),showDeprecated:Re(new o(138,"showDeprecated",!0,{description:b.localize(319,null)})),inlayHints:Re(new G),snippetSuggestions:Re(new r(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(320,null),b.localize(321,null),b.localize(322,null),b.localize(323,null)],description:b.localize(324,null)})),smartSelect:Re(new je),smoothScrolling:Re(new o(113,"smoothScrolling",!1,{description:b.localize(325,null)})),stopRenderingLineAfter:Re(new s(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Le),inlineSuggest:Re(new ee),inlineCompletionsAccessibilityVerbose:Re(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(326,null)})),suggestFontSize:Re(new s(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new s(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new o(120,"suggestOnTriggerCharacters",!0,{description:b.localize(329,null)})),suggestSelection:Re(new r(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(330,null),b.localize(331,null),b.localize(332,null)],description:b.localize(333,null)})),tabCompletion:Re(new r(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),tabIndex:Re(new s(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new Y),unusualLineTerminators:Re(new r(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),useShadowDOM:Re(new o(126,"useShadowDOM",!0)),useTabStops:Re(new o(127,"useTabStops",!0,{description:b.localize(342,null)})),wordBreak:Re(new r(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null)],description:b.localize(345,null)})),wordSeparators:Re(new t(129,"wordSeparators",R.$ts,{description:b.localize(346,null)})),wordWrap:Re(new r(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null),b.localize(350,null)],description:b.localize(351,null)})),wordWrapBreakAfterCharacters:Re(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new s(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(352,null)})),wordWrapOverride1:Re(new r(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new r(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new N),defaultColorDecorators:Re(new o(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(353,null)})),pixelRatio:Re(new te),tabFocusMode:Re(new o(142,"tabFocusMode",!1,{markdownDescription:b.localize(354,null)})),layoutInfo:Re(new X),wrappingInfo:Re(new _e),wrappingIndent:Re(new Qe),wrappingStrategy:Re(new le)}}),define(ke[195],Se([8,9]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,168,29,178,195]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Mt=e.$Lt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Kt=e.$Jt=e.SymbolKinds=e.SymbolTag=e.$It=e.$Ht=e.SymbolKind=e.$Gt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Ft=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Et=e.$Dt=e.$Ct=void 0;class ${constructor(j,M,O){this.offset=j,this.type=M,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ct=$;class y{constructor(j,M){this.tokens=j,this.endState=M,this._tokenizationResultBrand=void 0}}e.$Dt=y;class L{constructor(j,M){this.tokens=j,this.endState=M,this._encodedTokenizationResultBrand=void 0}}e.$Et=L;var C;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(F){const j=new Map;j.set(0,D.$_j.symbolMethod),j.set(1,D.$_j.symbolFunction),j.set(2,D.$_j.symbolConstructor),j.set(3,D.$_j.symbolField),j.set(4,D.$_j.symbolVariable),j.set(5,D.$_j.symbolClass),j.set(6,D.$_j.symbolStruct),j.set(7,D.$_j.symbolInterface),j.set(8,D.$_j.symbolModule),j.set(9,D.$_j.symbolProperty),j.set(10,D.$_j.symbolEvent),j.set(11,D.$_j.symbolOperator),j.set(12,D.$_j.symbolUnit),j.set(13,D.$_j.symbolValue),j.set(15,D.$_j.symbolEnum),j.set(14,D.$_j.symbolConstant),j.set(15,D.$_j.symbolEnum),j.set(16,D.$_j.symbolEnumMember),j.set(17,D.$_j.symbolKeyword),j.set(27,D.$_j.symbolSnippet),j.set(18,D.$_j.symbolText),j.set(19,D.$_j.symbolColor),j.set(20,D.$_j.symbolFile),j.set(21,D.$_j.symbolReference),j.set(22,D.$_j.symbolCustomColor),j.set(23,D.$_j.symbolFolder),j.set(24,D.$_j.symbolTypeParameter),j.set(25,D.$_j.account),j.set(26,D.$_j.issues);function M(Q){let ue=j.get(Q);return ue||(console.info("No codicon found for CompletionItemKind "+Q),ue=D.$_j.symbolProperty),ue}F.toIcon=M;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function U(Q,ue){let Z=O.get(Q);return typeof Z>"u"&&!ue&&(Z=9),Z}F.fromString=U})(m||(e.CompletionItemKinds=m={}));var p;(function(F){F[F.Deprecated=1]="Deprecated"})(p||(e.CompletionItemTag=p={}));var S;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var d;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(e.CompletionTriggerKind=d={}));var f;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class o{constructor(j,M,O,U){this.range=j,this.text=M,this.completionKind=O,this.isSnippetText=U}equals(j){return I.$Us.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$Ft=o;var i;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var s;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var n;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function c(F){return F&&T.URI.isUri(F.uri)&&I.$Us.isIRange(F.range)&&(I.$Us.isIRange(F.originSelectionRange)||I.$Us.isIRange(F.targetSelectionRange))}e.$Gt=c;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Ht={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function a(F,j){return(0,b.localize)(26,null,F,e.$Ht[j])}e.$It=a;var r;(function(F){F[F.Deprecated=1]="Deprecated"})(r||(e.SymbolTag=r={}));var h;(function(F){const j=new Map;j.set(0,D.$_j.symbolFile),j.set(1,D.$_j.symbolModule),j.set(2,D.$_j.symbolNamespace),j.set(3,D.$_j.symbolPackage),j.set(4,D.$_j.symbolClass),j.set(5,D.$_j.symbolMethod),j.set(6,D.$_j.symbolProperty),j.set(7,D.$_j.symbolField),j.set(8,D.$_j.symbolConstructor),j.set(9,D.$_j.symbolEnum),j.set(10,D.$_j.symbolInterface),j.set(11,D.$_j.symbolFunction),j.set(12,D.$_j.symbolVariable),j.set(13,D.$_j.symbolConstant),j.set(14,D.$_j.symbolString),j.set(15,D.$_j.symbolNumber),j.set(16,D.$_j.symbolBoolean),j.set(17,D.$_j.symbolArray),j.set(18,D.$_j.symbolObject),j.set(19,D.$_j.symbolKey),j.set(20,D.$_j.symbolNull),j.set(21,D.$_j.symbolEnumMember),j.set(22,D.$_j.symbolStruct),j.set(23,D.$_j.symbolEvent),j.set(24,D.$_j.symbolOperator),j.set(25,D.$_j.symbolTypeParameter);function M(O){let U=j.get(O);return U||(console.info("No codicon found for SymbolKind "+O),U=D.$_j.symbolProperty),U}F.toIcon=M})(h||(e.SymbolKinds=h={}));class u{static asEditOperation(j){return g.$Vs.replace(I.$Us.lift(j.range),j.text)}}e.$Jt=u;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(j){switch(j){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(j)}constructor(j){this.value=j}}e.$Kt=l;var k;(function(F){function j(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}F.is=j})(k||(e.Command=k={}));var A;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(A||(e.CommentThreadCollapsibleState=A={}));var v;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(v||(e.CommentThreadState=v={}));var w;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(w||(e.CommentMode=w={}));var E;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(E||(e.CommentState=E={}));var P;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class N{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Lt=N,e.$Mt=new R.$tt;var z;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(ke[196],Se([8,9]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([8,9]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([8,9]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([8,9]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([8,9]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ke[204],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ke[205],Se([8,9]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([8,9]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([8,9]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([8,9]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([8,9]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[217],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[218],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[219],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[220],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[221],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[222],Se([8,9]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[223],Se([8,9]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ke[224],Se([8,9]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ke[225],Se([8,9]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ke[226],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[227],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[228],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[229],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[230],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[231],Se([8,9]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[232],Se([8,9]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[233],Se([8,9]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[234],Se([8,9]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[235],Se([8,9]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[236],Se([1,0,14,198]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var g;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(g||(e.TokenType=g={}));function I(...y){switch(y.length){case 1:return(0,T.localize)(0,null,y[0]);case 2:return(0,T.localize)(1,null,y[0],y[1]);case 3:return(0,T.localize)(2,null,y[0],y[1],y[2]);default:return}}const R=(0,T.localize)(3,null),b=(0,T.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(I("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(I("&&"));break;case 124:this.h(124)?this.k(16):this.l(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const C=this.d,m=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:L}),this.f.push(p)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,C=!1,m=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(b);return}const S=this.c.charCodeAt(L);if(C)C=!1;else if(S===47&&!m){L++;break}else S===91?m=!0:S===92?C=!0:S===93&&(m=!1);L++}for(;L<this.c.length&&$.a.has(this.c.charCodeAt(L));)L++;this.e=L;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=$}),define(ke[237],Se([1,0,23,39,201,386]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(o){return o=o.trim(),o==="*"||R.test(o)}e.$ap=$;function y(o){if(!$(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$bp=y;function L(o){if(!o)return null;const i=o.majorBase,s=o.majorMustEqual,n=o.minorBase;let c=o.minorMustEqual;const t=o.patchBase;let a=o.patchMustEqual;o.hasCaret&&(i===0||(c=!1),a=!1);let r=0;if(o.preRelease){const h=b.exec(o.preRelease);if(h){const[,u,l,k]=h;r=Date.UTC(Number(u),Number(l)-1,Number(k))}}return{majorBase:i,majorMustEqual:s,minorBase:n,minorMustEqual:c,patchBase:t,patchMustEqual:a,isMinimum:o.hasGreaterEquals,notBefore:r}}e.$cp=L;function C(o,i,s){let n;typeof o=="string"?n=L(y(o)):n=o;let c;i instanceof Date?c=i.getTime():typeof i=="string"&&(c=new Date(i).getTime());let t;if(typeof s=="string"?t=L(y(s)):t=s,!n||!t)return!1;const a=n.majorBase,r=n.minorBase,h=n.patchBase;let u=t.majorBase,l=t.minorBase,k=t.patchBase;const A=t.notBefore;let v=t.majorMustEqual,w=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?a>u?!0:a<u?!1:r>l?!0:r<l||c&&c<A?!1:h>=k:(a===1&&u===0&&(!v||!w||!E)&&(u=1,l=0,k=0,v=!0,w=!1,E=!1),a<u?!1:a>u?!v:r<l?!1:r>l?!w:h<k?!1:h>k?!E:!(c&&c<A))}e.$dp=C;function m(o,i,s,n,c){const t=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return t.push([T.default.Error,g.localize(0,null)]),t;if(typeof n.name!="string")return t.push([T.default.Error,g.localize(1,null,"name")]),t;if(typeof n.version!="string")return t.push([T.default.Error,g.localize(2,null,"version")]),t;if(!n.engines)return t.push([T.default.Error,g.localize(3,null,"engines")]),t;if(typeof n.engines.vscode!="string")return t.push([T.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof n.extensionDependencies<"u"&&!f(n.extensionDependencies))return t.push([T.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof n.activationEvents<"u"){if(!f(n.activationEvents))return t.push([T.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof n.main>"u"&&typeof n.browser>"u")return t.push([T.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&t.push([T.default.Warning,g.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return t.push([T.default.Error,g.localize(9,null,"main")]),t;{const h=(0,D.$Hg)(s,n.main);(0,D.$Bg)(h,s)||t.push([T.default.Warning,g.localize(10,null,h.path,s.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return t.push([T.default.Error,g.localize(11,null,"browser")]),t;{const h=(0,D.$Hg)(s,n.browser);(0,D.$Bg)(h,s)||t.push([T.default.Warning,g.localize(12,null,h.path,s.path)])}}if(!I.valid(n.version))return t.push([T.default.Error,g.localize(13,null)]),t;const a=[];if(!p(o,i,n,c,a))for(const h of a)t.push([T.default.Error,h]);return t}e.$ep=m;function p(o,i,s,n,c){return n||typeof s.main>"u"&&typeof s.browser>"u"?!0:d(o,i,s.engines.vscode,c)}e.$fp=p;function S(o,i,s){return o==="*"||d(i,s,o)}e.$gp=S;function d(o,i,s,n=[]){const c=L(y(s));if(!c)return n.push(g.localize(14,null,s)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return n.push(g.localize(15,null,s)),!1}else if(!c.majorMustEqual)return n.push(g.localize(16,null,s)),!1;return C(o,i,c)?!0:(n.push(g.localize(17,null,o,s)),!1)}function f(o){if(!Array.isArray(o))return!1;for(let i=0,s=o.length;i<s;i++)if(typeof o[i]!="string")return!1;return!0}}),define(ke[106],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class D{constructor(g,I=[],R=!1){this.ctor=g,this.staticArguments=I,this.supportsDelayedInstantiation=R}}e.$3h=D}),define(ke[84],Se([1,0,106]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const T=[];var g;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function I(b,$,y){$ instanceof D.$3h||($=new D.$3h($,[],!!y)),T.push([b,$])}e.$Yr=I;function R(){return T}e.$Zr=R}),define(ke[238],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class D{constructor(I,R){this.key=I,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=D;class T{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const R of this.a.values())R.outgoing.size===0&&I.push(R);return I}insertEdge(I,R){const b=this.lookupOrInsertNode(I),$=this.lookupOrInsertNode(R);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(I){const R=this.b(I);this.a.delete(R);for(const b of this.a.values())b.outgoing.delete(R),b.incoming.delete(R)}lookupOrInsertNode(I){const R=this.b(I);let b=this.a.get(R);return b||(b=new D(R,I),this.a.set(R,b)),b}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[R,b]of this.a)I.push(`${R}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,R]of this.a){const b=new Set([I]),$=this.c(R,b);if($)return $}}c(I,R){for(const[b,$]of I.outgoing){if(R.has(b))return[...R,b].join(" -> ");R.add(b);const y=this.c($,R);if(y)return y;R.delete(b)}}}e.$Dq=T}),define(ke[5],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e._util=void 0;var D;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function b($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=b})(D||(e._util=D={})),e.$5h=g("instantiationService");function T(R,b,$){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:R,index:$}):(b[D.DI_DEPENDENCIES]=[{id:R,index:$}],b[D.DI_TARGET]=b)}function g(R){if(D.serviceIds.has(R))return D.serviceIds.get(R);const b=function($,y,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(b,$,L)};return b.toString=()=>R,D.serviceIds.set(R,b),b}e.$6h=g;function I(R){return R}e.$7h=I}),define(ke[51],Se([1,0,18,2,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,g.$6h)("configurationService");function I(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof T.URI)}e.$Ai=I;function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof T.URI)}e.$Bi=R;var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=$;function y(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$Di=y;function L(o,i){const s=Object.create(null);for(const n in o)C(s,n,o[n],i);return s}e.$Ei=L;function C(o,i,s,n){const c=i.split("."),t=c.pop();let a=o;for(let r=0;r<c.length;r++){const h=c[r];let u=a[h];switch(typeof u){case"undefined":u=a[h]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${c.slice(0,r+1).join(".")} is ${JSON.stringify(u)}`);return}a=u}if(typeof a=="object"&&a!==null)try{a[t]=s}catch{n(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(a)}`)}else n(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(a)}`)}e.$Fi=C;function m(o,i){const s=i.split(".");p(o,s)}e.$Gi=m;function p(o,i){const s=i.shift();if(i.length===0){delete o[s];return}if(Object.keys(o).indexOf(s)!==-1){const n=o[s];typeof n=="object"&&!Array.isArray(n)&&(p(n,i),Object.keys(n).length===0&&delete o[s])}}function S(o,i,s){function n(a,r){let h=a;for(const u of r){if(typeof h!="object"||h===null)return;h=h[u]}return h}const c=i.split("."),t=n(o,c);return typeof t>"u"?s:t}e.$Hi=S;function d(o,i,s){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in o?D.$Kf(o[n])&&D.$Kf(i[n])?d(o[n],i[n],s):s&&(o[n]=i[n]):o[n]=i[n])})}e.$Ii=d;function f(o){return o.replace(/[\[\]]/g,"")}e.$Ji=f}),define(ke[45],Se([1,0,10,12,236,5,197,14]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function y(G,W){if($.get(G)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(G,W)}e.$2i=y;const L=Object.prototype.hasOwnProperty;var C;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(0,null),S=(0,R.localize)(1,null),d=(0,R.localize)(2,null),f=(0,R.localize)(3,null),o=(0,R.localize)(4,null),i=(0,R.localize)(5,null),s=(0,R.localize)(6,null),n=(0,R.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=m){this.k=W,this.d=new g.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const ye=this.D(),de=ye.type===17?i:void 0;throw this.h.push({message:o,offset:ye.offset,lexeme:g.$1i.getLexeme(ye),additionalInfo:de}),c.c}return ne}catch(ne){if(ne!==c.c)throw ne;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const ne=this.o();W.push(ne)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const ne=this.s();W.push(ne)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,f),ne?.negate()}case 17:return this.z(),P.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,f),ne}case 17:{const ne=W.lexeme;if(this.z(),this.y(9)){const de=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),de.type!==10)throw this.B("REGEX",de);const ge=de.lexeme,_=ge.lastIndexOf("/"),te=_===ge.length-1?void 0:this.w(ge.substring(_+1));let K;try{K=new RegExp(ge.substring(1,_),te)}catch{throw this.B("REGEX",de)}return O.create(ne,K)}switch(de.type){case 10:case 19:{const ge=[de.lexeme];this.z();let _=this.D(),te=0;for(let Pe=0;Pe<de.lexeme.length;Pe++)de.lexeme.charCodeAt(Pe)===40?te++:de.lexeme.charCodeAt(Pe)===41&&te--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Pe=0;Pe<_.lexeme.length;Pe++)_.lexeme.charCodeAt(Pe)===40?te++:de.lexeme.charCodeAt(Pe)===41&&te--}if(te<0)break;ge.push(g.$1i.getLexeme(_)),this.z(),_=this.D()}const K=ge.join(""),ie=K.lastIndexOf("/"),fe=ie===K.length-1?void 0:this.w(K.substring(ie+1));let pe;try{pe=new RegExp(K.substring(1,ie),fe)}catch{throw this.B("REGEX",de)}return t.regex(ne,pe)}case 18:{const ge=de.lexeme;this.z();let _=null;if(!(0,T.$Je)(ge)){const te=ge.indexOf("/"),K=ge.lastIndexOf("/");if(te!==K&&te>=0){const ie=ge.slice(te+1,K),fe=ge[K+1]==="i"?"i":"";try{_=new RegExp(ie,fe)}catch{throw this.B("REGEX",de)}}}if(_===null)throw this.B("REGEX",de);return O.create(ne,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,d);const de=this.u();return t.notIn(ne,de)}switch(this.D().type){case 3:{this.z();const de=this.u();if(this.x().type===18)return t.equals(ne,de);switch(de){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,de)}}case 4:{this.z();const de=this.u();if(this.x().type===18)return t.notEquals(ne,de);switch(de){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,de)}}case 5:return this.z(),j.create(ne,this.u());case 6:return this.z(),M.create(ne,this.u());case 7:return this.z(),z.create(ne,this.u());case 8:return this.z(),F.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:s,offset:W.offset,lexeme:"",additionalInfo:n}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ne){if(this.C(W))return this.z();throw this.B(ne,this.D())}B(W,ne,ye){const de=(0,R.localize)(8,null,W,g.$1i.getLexeme(ne)),ge=ne.offset,_=g.$1i.getLexeme(ne);return this.h.push({message:de,offset:ge,lexeme:_,additionalInfo:ye}),c.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=c;class t{static false(){return u.INSTANCE}static true(){return l.INSTANCE}static has(W){return k.create(W)}static equals(W,ne){return A.create(W,ne)}static notEquals(W,ne){return E.create(W,ne)}static regex(W,ne){return O.create(W,ne)}static in(W,ne){return v.create(W,ne)}static notIn(W,ne){return w.create(W,ne)}static not(W){return P.create(W)}static and(...W){return ue.create(W,null,!0)}static or(...W){return Z.create(W,null,!0)}static greater(W,ne){return z.create(W,ne)}static greaterEquals(W,ne){return F.create(W,ne)}static smaller(W,ne){return j.create(W,ne)}static smallerEquals(W,ne){return M.create(W,ne)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$4i=t;function a(G){const W=new c({regexParsingWithErrorRecovery:!1});return G.map(ne=>(W.parse(ne),W.lexingErrors.length>0?W.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,R.localize)(9,null,ye.additionalInfo):(0,R.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$5i=a;function r(G,W){const ne=G?G.substituteConstants():void 0,ye=W?W.substituteConstants():void 0;return!ne&&!ye?!0:!ne||!ye?!1:ne.equals(ye)}e.$6i=r;function h(G,W){return G.cmp(W)}class u{static{this.INSTANCE=new u}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return l.INSTANCE}}e.$7i=u;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return u.INSTANCE}}e.$8i=l;class k{static create(W,ne=null){const ye=$.get(W);return typeof ye=="boolean"?ye?l.INSTANCE:u.INSTANCE:new k(W,ne)}constructor(W,ne){this.key=W,this.c=ne,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:X(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=$.get(this.key);return typeof W=="boolean"?W?l.INSTANCE:u.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$9i=k;class A{static create(W,ne,ye=null){if(typeof ne=="boolean")return ne?k.create(W,ye):P.create(W,ye);const de=$.get(W);return typeof de=="boolean"?ne===(de?"true":"false")?l.INSTANCE:u.INSTANCE:new A(W,ne,ye)}constructor(W,ne,ye){this.c=W,this.d=ne,this.f=ye,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:le(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const ne=W?"true":"false";return this.d===ne?l.INSTANCE:u.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$0i=A;class v{static create(W,ne){return new v(W,ne)}constructor(W,ne){this.d=W,this.f=ne,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:le(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ne=W.getValue(this.f),ye=W.getValue(this.d);return Array.isArray(ne)?ne.includes(ye):typeof ye=="string"&&typeof ne=="object"&&ne!==null?L.call(ne,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$$i=v;class w{static create(W,ne){return new w(W,ne)}constructor(W,ne){this.d=W,this.f=ne,this.type=11,this.c=v.create(W,ne)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=w;class E{static create(W,ne,ye=null){if(typeof ne=="boolean")return ne?P.create(W,ye):k.create(W,ye);const de=$.get(W);return typeof de=="boolean"?ne===(de?"true":"false")?u.INSTANCE:l.INSTANCE:new E(W,ne,ye)}constructor(W,ne,ye){this.c=W,this.d=ne,this.f=ye,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:le(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const ne=W?"true":"false";return this.d===ne?u.INSTANCE:l.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$aj=E;class P{static create(W,ne=null){const ye=$.get(W);return typeof ye=="boolean"?ye?u.INSTANCE:l.INSTANCE:new P(W,ne)}constructor(W,ne){this.c=W,this.d=ne,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:X(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=$.get(this.c);return typeof W=="boolean"?W?u.INSTANCE:l.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$bj=P;function N(G,W){if(typeof G=="string"){const ne=parseFloat(G);isNaN(ne)||(G=ne)}return typeof G=="string"||typeof G=="number"?W(G):u.INSTANCE}class z{static create(W,ne,ye=null){return N(ne,de=>new z(W,de,ye))}constructor(W,ne,ye){this.c=W,this.d=ne,this.f=ye,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:le(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$cj=z;class F{static create(W,ne,ye=null){return N(ne,de=>new F(W,de,ye))}constructor(W,ne,ye){this.c=W,this.d=ne,this.f=ye,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:le(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$dj=F;class j{static create(W,ne,ye=null){return N(ne,de=>new j(W,de,ye))}constructor(W,ne,ye){this.c=W,this.d=ne,this.f=ye,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:le(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$ej=j;class M{static create(W,ne,ye=null){return N(ne,de=>new M(W,de,ye))}constructor(W,ne,ye){this.c=W,this.d=ne,this.f=ye,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:le(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$fj=M;class O{static create(W,ne){return new O(W,ne)}constructor(W,ne){this.d=W,this.f=ne,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ne=this.f?this.f.source:"",ye=W.f?W.f.source:"";return ne<ye?-1:ne>ye?1:0}equals(W){if(W.type===this.type){const ne=this.f?this.f.source:"",ye=W.f?W.f.source:"";return this.d===W.d&&ne===ye}return!1}substituteConstants(){return this}evaluate(W){const ne=W.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$gj=O;class U{static create(W){return new U(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new U(this.c.map(W))}negate(){return this.c}}e.$hj=U;function Q(G){let W=null;for(let ne=0,ye=G.length;ne<ye;ne++){const de=G[ne].substituteConstants();if(G[ne]!==de&&W===null){W=[];for(let ge=0;ge<ne;ge++)W[ge]=G[ge]}W!==null&&(W[ne]=de)}return W===null?G:W}class ue{static create(W,ne,ye){return ue.d(W,ne,ye)}constructor(W,ne){this.expr=W,this.c=ne,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const de=h(this.expr[ne],W.expr[ne]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(W.expr[ne]))return!1;return!0}return!1}substituteConstants(){const W=Q(this.expr);return W===this.expr?this:ue.create(W,this.c,!1)}evaluate(W){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].evaluate(W))return!1;return!0}static d(W,ne,ye){const de=[];let ge=!1;for(const _ of W)if(_){if(_.type===1){ge=!0;continue}if(_.type===0)return u.INSTANCE;if(_.type===6){de.push(..._.expr);continue}de.push(_)}if(de.length===0&&ge)return l.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort(h);for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];for(;de.length>1;){const _=de[de.length-1];if(_.type!==9)break;de.pop();const te=de.pop(),K=de.length===0,ie=Z.create(_.expr.map(fe=>ue.create([fe,te],null,ye)),null,K);ie&&(de.push(ie),de.sort(h))}if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let te=_+1;te<de.length;te++)if(de[_].negate().equals(de[te]))return u.INSTANCE;if(de.length===1)return de[0]}return new ue(de,ne)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ne of this.expr)W.push(...ne.keys());return W}map(W){return new ue(this.expr.map(ne=>ne.map(W)),null)}negate(){if(!this.c){const W=[];for(const ne of this.expr)W.push(ne.negate());this.c=Z.create(W,this,!0)}return this.c}}e.$ij=ue;class Z{static create(W,ne,ye){return Z.d(W,ne,ye)}constructor(W,ne){this.expr=W,this.c=ne,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const de=h(this.expr[ne],W.expr[ne]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(W.expr[ne]))return!1;return!0}return!1}substituteConstants(){const W=Q(this.expr);return W===this.expr?this:Z.create(W,this.c,!1)}evaluate(W){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(this.expr[ne].evaluate(W))return!0;return!1}static d(W,ne,ye){let de=[],ge=!1;if(W){for(let _=0,te=W.length;_<te;_++){const K=W[_];if(K){if(K.type===0){ge=!0;continue}if(K.type===1)return l.INSTANCE;if(K.type===9){de=de.concat(K.expr);continue}de.push(K)}}if(de.length===0&&ge)return u.INSTANCE;de.sort(h)}if(de.length!==0){if(de.length===1)return de[0];for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let te=_+1;te<de.length;te++)if(de[_].negate().equals(de[te]))return l.INSTANCE;if(de.length===1)return de[0]}return new Z(de,ne)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ne of this.expr)W.push(...ne.keys());return W}map(W){return new Z(this.expr.map(ne=>ne.map(W)),null)}negate(){if(!this.c){const W=[];for(const ne of this.expr)W.push(ne.negate());for(;W.length>1;){const ne=W.shift(),ye=W.shift(),de=[];for(const ge of ce(ne))for(const _ of ce(ye))de.push(ue.create([ge,_],null,!1));W.unshift(Z.create(de,null,!1))}this.c=Z.create(W,this,!0)}return this.c}}e.$jj=Z;class J extends k{static{this.d=[]}static all(){return J.d.values()}constructor(W,ne,ye){super(W,null),this.f=ne,typeof ye=="object"?J.d.push({...ye,key:W}):ye!==!0&&J.d.push({key:W,description:ye,type:ne!=null?typeof ne:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return A.create(this.key,W)}notEqualsTo(W){return E.create(this.key,W)}}e.$kj=J,e.$lj=(0,I.$6h)("contextKeyService");function X(G,W){return G<W?-1:G>W?1:0}function le(G,W,ne,ye){return G<ne?-1:G>ne?1:W<ye?-1:W>ye?1:0}function x(G,W){if(G.type===0||W.type===1)return!0;if(G.type===9)return W.type===9?be(G.expr,W.expr):!1;if(W.type===9){for(const ne of W.expr)if(x(G,ne))return!0;return!1}if(G.type===6){if(W.type===6)return be(W.expr,G.expr);for(const ne of G.expr)if(x(ne,W))return!0;return!1}return G.equals(W)}e.$mj=x;function be(G,W){let ne=0,ye=0;for(;ne<G.length&&ye<W.length;){const de=G[ne].cmp(W[ye]);if(de<0)return!1;de===0&&ne++,ye++}return ne===G.length}function ce(G){return G.type===9?G.expr:[G]}}),define(ke[239],Se([1,0,23,39,199,5,103,10,24]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0v=e.$9v=e.ConfirmResult=e.$8v=e.$7v=e.$6v=void 0,e.$6v=(0,I.$6h)("dialogService");var y;(function(d){d[d.Confirmation=1]="Confirmation",d[d.Prompt=2]="Prompt",d[d.Input=3]="Input"})(y||(y={}));class L{a(f){return this.d(f,y.Confirmation)}b(f){return this.d(f,y.Prompt)}c(f){return this.d(f,y.Input)}d(f,o){const i=[];switch(o){case y.Confirmation:{const s=f;s.primaryButton?i.push(s.primaryButton):i.push((0,g.localize)(0,null)),s.cancelButton?i.push(s.cancelButton):i.push((0,g.localize)(1,null));break}case y.Prompt:{const s=f;Array.isArray(s.buttons)&&s.buttons.length>0&&i.push(...s.buttons.map(n=>n.label)),s.cancelButton&&(s.cancelButton===!0?i.push((0,g.localize)(2,null)):typeof s.cancelButton=="string"?i.push(s.cancelButton):s.cancelButton.label?i.push(s.cancelButton.label):i.push((0,g.localize)(3,null))),i.length===0&&i.push((0,g.localize)(4,null));break}case y.Input:{const s=f;s.primaryButton?i.push(s.primaryButton):i.push((0,g.localize)(5,null)),s.cancelButton?i.push(s.cancelButton):i.push((0,g.localize)(6,null));break}}return i}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===T.default.Info?"info":f===T.default.Error?"error":f===T.default.Warning?"warning":"none"}f(f,o,i){const s=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&s.push(f.cancelButton);let n=s[o]?.run({checkboxChecked:i});return n instanceof Promise||(n=Promise.resolve(n)),{result:n,checkboxChecked:i}}}e.$7v=L,e.$8v=(0,I.$6h)("fileDialogService");var C;(function(d){d[d.SAVE=0]="SAVE",d[d.DONT_SAVE=1]="DONT_SAVE",d[d.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function p(d){const f=[];return f.push(...d.slice(0,m).map(o=>typeof o=="string"?o:(0,D.$Eg)(o))),d.length>m&&(d.length-m===1?f.push((0,g.localize)(7,null)):f.push((0,g.localize)(8,null,d.length-m))),f.push(""),f.join(`
`)}e.$9v=p;function S(d,f){const o=(0,$.$vn)(d);let i=(o.buttons??[]).map(t=>(0,R.$3v)(t)),s=(d.buttons||[]).map((t,a)=>a),n=0,c=o.cancelId??i.length-1;if(i.length>1){const t=typeof c=="number"?i[c]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&c!==1){i.splice(c,1),i.splice(1,0,t);const a=s[c];s.splice(c,1),s.splice(1,0,a),c=1}b.$k&&i.length>1&&(i=i.reverse(),s=s.reverse(),n=i.length-1,typeof t=="string"&&(c=n-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&c!==i.length-1){i.splice(c,1),i.push(t);const a=s[c];s.splice(c,1),s.push(a),c=i.length-1}}return o.buttons=i,o.defaultId=n,o.cancelId=c,o.noLink=!0,o.title=o.title||f.nameLong,{options:o,buttonIndeces:s}}e.$0v=S}),define(ke[133],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,D.$6h)("environmentService"),e.$bi=(0,D.$7h)(e.$ai)}),define(ke[134],Se([1,0,200,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ExtensionGalleryErrorCode=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function g(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=g;function I(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=I;function R(s,n){switch(s){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=R;function b(s,n){return n==="web"&&!s.includes("web")}e.$vo=b;function $(s,n,c){return b(n,c)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===c}e.$wo=$;function y(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$xo=y;var L;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var C;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(s){s.Install="install",s.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var p;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$yo=(0,T.$6h)("extensionGalleryService");var S;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.DownloadSignature="DownloadSignature",s.UpdateMetadata="UpdateMetadata",s.Extract="Extract",s.Scanning="Scanning",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.NotAllowed="NotAllowed",s.Gallery="Gallery",s.Unknown="Unknown",s.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var d;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(d||(e.ExtensionSignaturetErrorCode=d={}));class f extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$zo=f;var o;(function(s){s.Timeout="Timeout",s.Cancelled="Cancelled",s.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class i extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$Ao=i,e.$Bo=(0,T.$6h)("extensionManagementService"),e.$Co="extensionsIdentifiers/disabled",e.$Do="extensionsIdentifiers/enabled",e.$Eo=(0,T.$6h)("IGlobalExtensionEnablementService"),e.$Fo=(0,T.$6h)("IExtensionTipsService"),e.$Go=(0,D.localize)(0,null),e.$Ho={value:e.$Go,original:"Extensions"},e.$Io=(0,D.localize2)(1,"Preferences")}),define(ke[240],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d3b=e.$c3b=void 0,e.$c3b=(0,D.$6h)("externalTerminal"),e.$d3b="Terminal.app"}),define(ke[241],Se([1,0,50,52,16,17,10,102,31,105,202,240]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$b=e.$b$b=e.$a$b=void 0;const m=L.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends p{static{this.b="cmd.exe"}openTerminal(c,t){return this.spawnTerminal(D,c,y.$Tl(),t)}spawnTerminal(c,t,a,r){const h=t.windowsExec||S.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=I.$nc(h,".exe").toLowerCase();if(u==="cmder")return c.spawn(h,r?[r]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return h.indexOf(" ")>=0&&l.push('""'),l.push(h),u==="wt"&&l.push("-d ."),new Promise((k,A)=>{const v=o(process),w=c.spawn(a,l,{cwd:r,env:v,detached:!0});w.on("error",A),w.on("exit",()=>k())})}async runInTerminal(c,t,a,r,h){const u="windowsExec"in h&&h.windowsExec?h.windowsExec:S.getDefaultTerminalWindows(),l=await S.f();return new Promise((k,A)=>{const v=`"${t} - ${m}"`,w=`""${a.join('" "')}" & pause"`,E=Object.assign({},o(process),r);Object.keys(E).filter(j=>E[j]===null).forEach(j=>delete E[j]);const P={cwd:t,env:E,windowsVerbatimArguments:!0};let N,z;I.$nc(u,".exe")==="wt"?(N=u,z=["-d",".",S.b,"/c",w]):l?(N=l,z=["-d",t,u,"/c",w]):(N=S.b,z=["/c","start",v,"/wait",u,"/c",w]),D.spawn(N,z,P).on("error",j=>{A(i(j))}),k(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return S.d}static async f(){try{const c=await y.win32.findExecutable("wt");return await $.Promises.exists(c)?c:void 0}catch{return}}}e.$a$b=S,Ge([T.$xh],S,"f",null);class d extends p{static{this.b="/usr/bin/osascript"}openTerminal(c,t){return this.spawnTerminal(D,c,t)}runInTerminal(c,t,a,r,h){const u=h.osxExec||C.$d3b;return new Promise((l,k)=>{if(u===C.$d3b||u==="iTerm.app"){const A=u===C.$d3b?"TerminalHelper":"iTermHelper",w=[g.$og.asFileUri(`vs/workbench/contrib/externalTerminal/node/${A}.scpt`).fsPath,"-t",c||m,"-w",t];for(const N of a)w.push("-a"),w.push(N);if(r){const N=Object.assign({},o(process),r);for(const z in N){const F=N[z];F===null?(w.push("-u"),w.push(z)):(w.push("-e"),w.push(`${z}=${F}`))}}let E="";const P=D.spawn(d.b,w);P.on("error",N=>{k(i(N))}),P.stderr.on("data",N=>{E+=N.toString()}),P.on("exit",N=>{if(N===0)l(void 0);else if(E){const z=E.split(`
`,1);k(new Error(z[0]))}else k(new Error(L.localize(1,null,A,N)))})}else k(new Error(L.localize(2,null,u)))})}spawnTerminal(c,t,a){const r=t.osxExec||C.$d3b;return new Promise((h,u)=>{const l=["-a",r];a&&l.push(a);const k=o(process),A=c.spawn("/usr/bin/open",l,{cwd:a,env:k});A.on("error",u),A.on("exit",()=>h())})}}e.$b$b=d;class f extends p{static{this.b=L.localize(3,null)}openTerminal(c,t){return this.spawnTerminal(D,c,t)}runInTerminal(c,t,a,r,h){const u=h.linuxExec?Promise.resolve(h.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((l,k)=>{const A=[];u.then(v=>{v.indexOf("gnome-terminal")>=0?A.push("-x"):A.push("-e"),A.push("bash"),A.push("-c");const w=`${s(a)}; echo; read -p "${f.b}" -n1;`;A.push(`''${w}''`);const E=Object.assign({},o(process),r);Object.keys(E).filter(F=>E[F]===null).forEach(F=>delete E[F]);const P={cwd:t,env:E};let N="";const z=D.spawn(v,A,P);z.on("error",F=>{k(i(F))}),z.stderr.on("data",F=>{N+=F.toString()}),z.on("exit",F=>{if(F===0)l(void 0);else if(N){const j=N.split(`
`,1);k(new Error(j[0]))}else k(new Error(L.localize(4,null,v,F)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!R.$k)f.d=Promise.resolve("xterm");else{const c=await $.Promises.exists("/etc/debian_version");f.d=new Promise(t=>{c?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return f.d}spawnTerminal(c,t,a){const r=t.linuxExec?Promise.resolve(t.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((h,u)=>{r.then(l=>{const k=o(process),A=c.spawn(l,[],{cwd:a,env:k});A.on("error",u),A.on("exit",()=>h())})})}}e.$c$b=f;function o(n){const c={...n.env};return(0,b.$Rl)(c),c}function i(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(L.localize(5,null,n.path)):n}function s(n){let c="";for(const t of n)t.indexOf(" ")>=0?c+='"'+t+'"':c+=t,c+=" ";return c}}),define(ke[32],Se([1,0,77,17,12,18,2,203,5,10,16,43]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.FileKind=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileOperationResult=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileChangeType=e.$Ik=e.FileOperation=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderErrorCode=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileSystemProviderCapabilities=e.$sk=e.FilePermission=e.FileType=e.$rk=e.$qk=void 0,e.$qk=(0,$.$6h)("fileService");function m(x){return x.create===!0}e.$rk=m;var p;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var S;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function d(x){const be=x;return!!be&&typeof be.onDidChange=="function"}e.$sk=d;var f;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function o(x){return!!(x.capabilities&2)}e.$tk=o;function i(x){return!!(x.capabilities&8)}e.$uk=i;function s(x){return!!(x.capabilities&131072)}e.$vk=s;function n(x){return!!(x.capabilities&4)}e.$wk=n;function c(x){return!!(x.capabilities&16)}e.$xk=c;function t(x){return o(x)?!!(x.capabilities&16384):!1}e.$yk=t;function a(x){return o(x)?!!(x.capabilities&32768):!1}e.$zk=a;function r(x){return!!(x.capabilities&65536)}e.$Ak=r;function h(x){return!!(x.capabilities&2048)}e.$Bk=h;var u;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class l extends Error{static create(be,ce){const G=new l(be.toString(),ce);return v(G,ce),G}constructor(be,ce){super(be),this.code=ce}}e.$Ck=l;function k(x,be){return l.create(x,be)}e.$Dk=k;function A(x){return x||k((0,b.localize)(0,null),u.Unknown)}e.$Ek=A;function v(x,be){return x.name=be?`${be} (FileSystemError)`:"FileSystemError",x}e.$Fk=v;function w(x){if(!x)return u.Unknown;if(x instanceof l)return x.code;const be=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!be)return u.Unknown;switch(be[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.$Gk=w;function E(x){if(x instanceof M)return x.fileOperationResult;switch(w(x)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}e.$Hk=E;var P;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class N{constructor(be,ce,G){this.resource=be,this.operation=ce,this.target=G}isOperation(be){return this.operation===be}}e.$Ik=N;var z;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class F{static{this.a=null}constructor(be,ce){this.c=ce,this.b=void 0,this.d=new C.$V(()=>{const G=D.$_h.forUris(()=>this.c);return G.fill(this.rawAdded.map(W=>[W,!0])),G}),this.f=new C.$V(()=>{const G=D.$_h.forUris(()=>this.c);return G.fill(this.rawUpdated.map(W=>[W,!0])),G}),this.g=new C.$V(()=>{const G=D.$_h.forUris(()=>this.c);return G.fill(this.rawDeleted.map(W=>[W,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of be){switch(G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}this.b!==F.a&&(typeof G.cId=="number"?this.b===void 0?this.b=G.cId:this.b!==G.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(be,...ce){return this.h(be,{includeChildren:!1},...ce)}affects(be,...ce){return this.h(be,{includeChildren:!0},...ce)}h(be,ce,...G){if(!be)return!1;const W=G.length>0;return!!((!W||G.includes(1))&&(this.d.value.get(be)||ce.includeChildren&&this.d.value.findSuperstr(be))||(!W||G.includes(0))&&(this.f.value.get(be)||ce.includeChildren&&this.f.value.findSuperstr(be))||(!W||G.includes(2))&&(this.g.value.findSubstr(be)||ce.includeChildren&&this.g.value.findSuperstr(be)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(be){return this.b===be}hasCorrelation(){return typeof this.b=="number"}}e.$Jk=F;function j(x,be,ce){return!x||!be||x===be||be.length>x.length?!1:(be.charAt(be.length-1)!==T.sep&&(be+=T.sep),ce?(0,g.$af)(x,be):x.indexOf(be)===0)}e.$Kk=j;class M extends Error{constructor(be,ce,G){super(be),this.fileOperationResult=ce,this.options=G}}e.$Lk=M;class O extends M{constructor(be,ce,G,W){super(be,ce,W),this.fileOperationResult=ce,this.size=G}}e.$Mk=O;class U extends M{constructor(be,ce,G){super(be,2,G),this.stat=ce}}e.$Nk=U;var Q;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Qk="files.associations",e.$Rk="files.exclude",e.$Sk="files.readonlyInclude",e.$Tk="files.readonlyExclude",e.$Uk="files.readonlyFromPermissions";var ue;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$Vk="";function Z(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.$Wk=Z;async function J(x,be){if(!be.hasProvider(R.URI.from({scheme:x.scheme})))return new Promise(ce=>{const G=be.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===x.scheme&&W.added&&(G.dispose(),ce())})})}e.$Xk=J;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(be){return(0,I.$Mf)(be)||(be=0),be<X.KB?(0,b.localize)(1,null,be.toFixed(0)):be<X.MB?(0,b.localize)(2,null,(be/X.KB).toFixed(2)):be<X.GB?(0,b.localize)(3,null,(be/X.MB).toFixed(2)):be<X.TB?(0,b.localize)(4,null,(be/X.GB).toFixed(2)):(0,b.localize)(5,null,(be/X.TB).toFixed(2))}}e.$Yk=X;function le(x){const be=typeof x=="string"||x?.scheme===L.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===L.Schemas.file?1024*X.MB:be?10*X.MB:y.$o?50*X.MB:1024*X.MB}e.$Zk=le}),define(ke[242],Se([1,0,22,14,204,32]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;async function R(L,C,m,p,S,d){let f;try{await b(L,C,m,p,S,d)}catch(o){f=o}finally{f&&S.errorTransformer&&(f=S.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}e.$bq=R;async function b(L,C,m,p,S,d){$(d);const f=await L.open(C,{create:!1});try{$(d);let o=0,i=0,s=S&&typeof S.length=="number"?S.length:void 0,n=D.$je.alloc(Math.min(S.bufferSize,typeof s=="number"?s:S.bufferSize)),c=S&&typeof S.position=="number"?S.position:0,t=0;do i=await L.read(f,c,n.buffer,t,n.byteLength-t),c+=i,t+=i,o+=i,typeof s=="number"&&(s-=i),t===n.byteLength&&(await m.write(p(n)),n=D.$je.alloc(Math.min(S.bufferSize,typeof s=="number"?s:S.bufferSize)),t=0);while(i>0&&(typeof s!="number"||s>0)&&$(d)&&y(o,S));if(t>0){let a=t;typeof s=="number"&&(a=Math.min(t,s)),m.write(p(n.slice(0,a)))}}catch(o){throw(0,I.$Ek)(o)}finally{await L.close(f)}}function $(L){if(L.isCancellationRequested)throw(0,T.$6)();return!0}function y(L,C){if(typeof C?.limits?.size=="number"&&L>C.limits.size)throw(0,I.$Dk)((0,g.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[85],Se([1,0,34,3,17,10,2,32]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=void 0;function $(o){return o.recursive===!0}e.$dq=$;class y extends T.$Tc{static{this.a=5}constructor(i,s,n,c){super(),this.h=i,this.j=s,this.m=n,this.n=c,this.c=this.B(new T.$Uc),this.f=void 0,this.g=0}s(){const i=new T.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(s=>this.h(s))),i.add(this.b.onDidLogMessage(s=>this.j(s))),i.add(this.b.onDidError(s=>this.t(s)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$eq=y;class L extends y{constructor(i,s,n){super(i,s,n,{type:"node.js",restartOnError:!1})}}e.$fq=L;class C extends y{constructor(i,s,n){super(i,s,n,{type:"universal",restartOnError:!0})}}e.$gq=C;function m(o){return o.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$hq=m;function p(o){const i=new f;for(const s of o)i.processEvent(s);return i.coalesce()}e.$iq=p;function S(o,i){return typeof i=="string"&&!i.startsWith(D.$Ij)&&!(0,g.$ic)(i)?{base:o,pattern:i}:i}e.$jq=S;function d(o,i){const s=[];for(const n of i)s.push((0,D.$Mj)(S(o,n)));return s}e.$kq=d;class f{constructor(){this.a=new Set,this.b=new Map}c(i){return I.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const s=this.b.get(this.c(i));let n=!1;if(s){const c=s.type,t=i.type;s.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?n=!0:c===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(s)):c===2&&t===1?s.type=0:c===1&&t===0||(s.type=t)}else n=!0;n&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],s=[];return Array.from(this.a).filter(n=>n.type!==2?(i.push(n),!1):!0).sort((n,c)=>n.resource.fsPath.length-c.resource.fsPath.length).filter(n=>s.some(c=>(0,b.$Kk)(n.resource.fsPath,c,!I.$k))?!1:(s.push(n.resource.fsPath),!0)).concat(i)}}}),define(ke[243],Se([1,0,56,11,21,33,3,76,17,10,23,2,104,31,85]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0;class d extends R.$Tc{static{this.a=100}static{this.b=75}constructor(i,s,n,c){super(),this.m=i,this.n=s,this.r=n,this.s=c,this.c=this.B(new T.$ih({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new T.$hh(t=>this.z(t),d.b)),this.g=(0,S.$kq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$kq)(this.m.path,this.m.includes):void 0,this.j=new g.$6d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const s=await p.Promises.stat(i);this.B(await this.w(i,s.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let s=i.path;try{s=await p.Promises.realpath(i.path),i.path===s&&(s=await(0,m.$uq)(i.path)??i.path),i.path!==s&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${s})`)}catch{}return s}async w(i,s){if(y.$j&&(0,I.$8f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Tc.None;const n=new g.$6d(this.j.token),c=new R.$Sc;try{const t=C.URI.file(this.m.path),a=(0,$.$nc)(i),r=(0,D.watch)(i);c.add((0,R.$Rc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${i}'`);const h=new Set;if(s)try{for(const l of await p.Promises.readdir(i))h.add(l)}catch(l){this.D(l)}const u=new Map;c.add((0,R.$Rc)(()=>{for(const[,l]of u)l.dispose();u.clear()})),r.on("error",(l,k)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${l}, ${k})`),this.dispose()}),r.on("change",(l,k)=>{if(n.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${k}`);let A="";if(k&&(A=k.toString(),y.$j&&(A=(0,b.$Gl)(A))),!(!A||l!=="change"&&l!=="rename"))if(s)if(l==="rename"){u.get(A)?.dispose();const v=setTimeout(async()=>{if(u.delete(A),A===a&&!await p.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const w=await this.C((0,$.$jc)(i,A));if(n.token.isCancellationRequested)return;let E;w?h.has(A)?E=0:(E=1,h.add(A)):(h.delete(A),E=2),this.y({resource:(0,L.$Hg)(t,A),type:E,cId:this.m.correlationId})},d.a);u.set(A,(0,R.$Rc)(()=>clearTimeout(v)))}else{let v;h.has(A)?v=0:(v=1,h.add(A)),this.y({resource:(0,L.$Hg)(t,A),type:v,cId:this.m.correlationId})}else if(l==="rename"||A!==a){const v=setTimeout(async()=>{const w=await p.Promises.exists(i);n.token.isCancellationRequested||(w?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),c.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},d.a);c.clear(),c.add((0,R.$Rc)(()=>clearTimeout(v)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await p.Promises.exists(i)&&!n.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Rc)(()=>{n.dispose(!0),c.dispose()})}y(i,s=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!s&&this.g.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!s&&this.h&&this.h.length>0&&!this.h.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const s=(0,S.$iq)(i);if(s.length>0){if(this.s)for(const c of s)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$k)return p.Promises.exists(i);try{const s=(0,$.$nc)(i);return(await p.Promises.readdir((0,$.$mc)(i))).some(c=>c===s)}catch(s){return this.G(s),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$xq=d;async function f(o,i,s,n,c=512){const t=await p.Promises.open(o,"r"),a=Buffer.allocUnsafe(c),r=new g.$6d(n);let h,u=!1;const l={path:o,excludes:[],recursive:!1},k=new d(l,A=>{(async()=>{for(const{type:v}of A)if(v===0){if(u)return;u=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:w}=await p.Promises.read(t,a,0,c,null);if(!w||r.token.isCancellationRequested)break;i(a.slice(0,w))}}catch(w){h=new Error(w),r.dispose(!0)}finally{u=!1}}})()});return await k.ready,s(),new Promise((A,v)=>{r.token.onCancellationRequested(async()=>{k.dispose();try{await p.Promises.close(t)}catch(w){h=new Error(w)}h?v(h):A()})})}e.$yq=f}),define(ke[244],Se([1,0,4,34,3,10,243]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class b extends g.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Vd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Vd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const L=this.j(y),C=L.filter(p=>{const S=this.c.get(p.path);return S?!(0,T.$Qj)(S.request.excludes,p.excludes)||!(0,T.$Qj)(S.request.includes,p.includes):!0}),m=Array.from(this.c.values()).filter(({request:p})=>!L.find(S=>S.path===p.path&&(0,T.$Qj)(S.excludes,p.excludes)&&(0,T.$Qj)(S.includes,p.includes))).map(({request:p})=>p.path);C.length&&this.m(`Request to start watching: ${C.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"}, correlationId: ${typeof p.correlationId=="number"?p.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const p of m)this.h(p);for(const p of C)this.g(p)}g(y){const L=new R.$xq(y,m=>this.a.fire(m),m=>this.b.fire(m),this.f),C={request:y,instance:L};this.c.set(y.path,C)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const L=this.c.get(y);L&&(this.c.delete(y),L.instance.dispose())}j(y){const L=new Map;for(const C of y){const m=I.$k?C.path:C.path.toLowerCase();let p=L.get(C.correlationId);p||(p=new Map,L.set(C.correlationId,p)),p.set(m,C)}return Array.from(L.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,L]of this.c)L.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,L){return L?`[File Watcher (node.js)] ${y} (path: ${L.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$zq=b}),define(ke[245],Se([1,0,85,244]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class g extends D.$fq{constructor(R,b,$){super(R,b,$),this.s()}r(R){return R.add(new T.$zq)}}e.$Aq=g}),define(ke[246],Se([1,0,16,81,187,85]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;class R extends I.$gq{constructor($,y,L){super($,y,L),this.s()}r($){const y=$.add(new g.$rq(D.$og.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(y.onDidProcessExit(({code:L,signal:C})=>this.t(`terminated by itself with code ${L}, signal: ${C}`))),T.ProxyChannel.toService((0,T.$Mh)(y.getChannel("watcher")))}}e.$sq=R}),define(ke[107],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class D{constructor(...g){this.a=new Map;for(const[I,R]of g)this.set(I,R)}set(g,I){const R=this.a.get(g);return this.a.set(g,I),R}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$4h=D}),define(ke[247],Se([1,0,11,14,3,106,238,5,107,75]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const L=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new $.$4h,o=!1,i,s=L){this.f=f,this.g=o,this.h=i,this.i=s,this.o=new Set,this.f.set(b.$5h,this),this._globalGraph=s?i?._globalGraph??new R.$Dq(n=>n):void 0}createChild(f){return new m(f,this.g,this,this.i)}invokeFunction(f,...o){const i=S.traceInvocation(this.i,f);let s=!1;try{return f({get:c=>{if(s)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(c,i);if(!t)throw new Error(`[invokeFunction] unknown service '${c}'`);return t}},...o)}finally{s=!0,i.stop()}}createInstance(f,...o){let i,s;return f instanceof I.$3h?(i=S.traceCreation(this.i,f.ctor),s=this.j(f.ctor,f.staticArguments.concat(o),i)):(i=S.traceCreation(this.i,f),s=this.j(f,o,i)),i.stop(),s}j(f,o=[],i){const s=b._util.getServiceDependencies(f).sort((t,a)=>t.index-a.index),n=[];for(const t of s){const a=this.m(t.id,i);a||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),n.push(a)}const c=s.length>0?s[0].index:o.length;if(o.length!==c){console.trace(`[createInstance] First service dependency of ${f.name} at position ${c+1} conflicts with ${o.length} static arguments`);const t=c-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,c)}return Reflect.construct(f,o.concat(n))}k(f,o){if(this.f.get(f)instanceof I.$3h)this.f.set(f,o);else if(this.h)this.h.k(f,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const o=this.f.get(f);return!o&&this.h?this.h.l(f):o}m(f,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const i=this.l(f);return i instanceof I.$3h?this.q(f,i,o.branch(f,!0)):(o.branch(f,!1),i)}q(f,o,i){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,o,i)}finally{this.o.delete(f)}}r(f,o,i){const s=new R.$Dq(t=>t.id.toString());let n=0;const c=[{id:f,desc:o,_trace:i}];for(;c.length;){const t=c.pop();if(s.lookupOrInsertNode(t),n++>1e3)throw new C(s);for(const a of b._util.getServiceDependencies(t.desc.ctor)){const r=this.l(a.id);if(r||this.u(`[createInstance] ${f} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),r instanceof I.$3h){const h={id:a.id,desc:r,_trace:t._trace.branch(a.id,!0)};s.insertEdge(t,h),c.push(h)}}}for(;;){const t=s.roots();if(t.length===0){if(!s.isEmpty())throw new C(s);break}for(const{data:a}of t){if(this.l(a.id)instanceof I.$3h){const h=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,h)}s.removeNode(a)}}return this.l(f)}s(f,o,i=[],s,n){if(this.f.get(f)instanceof I.$3h)return this.t(f,o,i,s,n);if(this.h)return this.h.s(f,o,i,s,n);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(f,o,i=[],s,n){if(s){const c=new m(void 0,this.g,this,this.i);c.c=String(f);const t=new Map,a=new D.$mh(()=>{const r=c.j(o,i,n);for(const[h,u]of t){const l=r[h];if(typeof l=="function")for(const k of u)k.disposable=l.apply(r,k.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,h){if(!a.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let k=t.get(h);return k||(k=new y.$4c,t.set(h,k)),(v,w,E)=>{if(a.isInitialized)return a.value[h](v,w,E);{const P={listener:[v,w,E],disposable:void 0},N=k.push(P);return(0,g.$Rc)(()=>{N(),P.disposable?.dispose()})}}}if(h in r)return r[h];const u=a.value;let l=u[h];return typeof l!="function"||(l=l.bind(u),r[h]=l),l},set(r,h,u){return a.value[h]=u,!0},getPrototypeOf(r){return o.prototype}})}else return this.j(o,i,n)}u(f,o){if(o&&console.warn(f),this.g)throw new Error(f)}}e.$Eq=m;var p;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(p||(p={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,o){return f?new S(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(f,o){return f?new S(1,o.name):S.c}static{this.f=0}constructor(f,o){this.type=f,this.name=o,this.g=Date.now(),this.h=[]}branch(f,o){const i=new S(3,f.toString());return this.h.push([f,o,i]),i}stop(){const f=Date.now()-this.g;S.f+=f;let o=!1;function i(n,c){const t=[],a=new Array(n+1).join("	");for(const[r,h,u]of c.h)if(h&&u){o=!0,t.push(`${a}CREATES -> ${r}`);const l=i(n+1,u);l&&t.push(l)}else t.push(`${a}uses -> ${r}`);return t.join(`
`)}const s=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(f>2||o)&&S.all.add(s.join(`
`))}}e.$Fq=S}),define(ke[13],Se([1,0,44,4,54,3,28,10,23,18,2,45,5]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,m.$6h)("logService"),e.$oj=(0,m.$6h)("loggerService");function p(){return new Date().toISOString()}function S(v){return(0,y.$Mf)(v)}e.$pj=S;var d;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$qj=d.Info;function f(v,w,E){switch(w){case d.Trace:v.trace(E);break;case d.Debug:v.debug(E);break;case d.Info:v.info(E);break;case d.Warning:v.warn(E);break;case d.Error:v.error(E);break;case d.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=f;function o(v,w=!1){let E="";for(let P=0;P<v.length;P++){let N=v[P];if(N instanceof Error&&(N=(0,D.$Qi)(N,w)),typeof N=="object")try{N=JSON.stringify(N)}catch{}E+=(P>0?" ":"")+N}return E}class i extends I.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new T.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==d.Off&&this.b<=w}}e.$sj=i;class s extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...E){this.f(d.Trace)&&this.g(d.Trace,o([w,...E],!0))}debug(w,...E){this.f(d.Debug)&&this.g(d.Debug,o([w,...E]))}info(w,...E){this.f(d.Info)&&this.g(d.Info,o([w,...E]))}warn(w,...E){this.f(d.Warning)&&this.g(d.Warning,o([w,...E]))}error(w,...E){if(this.f(d.Error))if(w instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=w.stack,this.g(d.Error,o(P))}else this.g(d.Error,o([w,...E]))}flush(){}}e.$tj=s;class n extends i{constructor(w=e.$qj){super(),this.setLevel(w),this.g=!b.$i}trace(w,...E){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,w,...E):console.log(`[main ${p()}]`,w,...E))}debug(w,...E){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,w,...E):console.log(`[main ${p()}]`,w,...E))}info(w,...E){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,w,...E):console.log(`[main ${p()}]`,w,...E))}warn(w,...E){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,w,...E):console.warn(`[main ${p()}]`,w,...E))}error(w,...E){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,w,...E):console.error(`[main ${p()}]`,w,...E))}flush(){}}e.$uj=n;class c extends i{constructor(w=e.$qj,E=!0){super(),this.g=E,this.setLevel(w)}trace(w,...E){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...E):console.log(w,...E))}debug(w,...E){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...E):console.log(w,...E))}info(w,...E){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...E):console.log(w,...E))}warn(w,...E){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...E):console.log(w,...E))}error(w,...E){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...E):console.error(w,...E))}flush(){}}e.$vj=c;class t extends i{constructor(w,E=e.$qj){super(),this.g=w,this.setLevel(E)}trace(w,...E){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(w),...E])}debug(w,...E){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(w),...E])}info(w,...E){this.f(d.Info)&&this.g.log(d.Info,[this.h(w),...E])}warn(w,...E){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(w),...E])}error(w,...E){this.f(d.Error)&&this.g.log(d.Error,[this.h(w),...E])}h(w){return typeof w=="string"?w:(0,D.$Qi)(w,this.f(d.Trace))}flush(){}}e.$wj=t;class a extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const E of this.g)E.setLevel(w);super.setLevel(w)}trace(w,...E){for(const P of this.g)P.trace(w,...E)}debug(w,...E){for(const P of this.g)P.debug(w,...E)}info(w,...E){for(const P of this.g)P.info(w,...E)}warn(w,...E){for(const P of this.g)P.warn(w,...E)}error(w,...E){for(const P of this.g)P.error(w,...E)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$xj=a;class r extends I.$Tc{constructor(w,E,P){if(super(),this.h=w,this.j=E,this.b=new R.$Ac,this.c=this.B(new T.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Vd),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(w){return(0,y.$If)(w)?[...this.b.values()].find(E=>E.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,E){const P=this.n(w),N=(0,y.$If)(w)?w:E?.id??(0,g.$Ti)(P.toString()).toString(16);let z=this.b.get(P)?.logger;const F=E?.logLevel==="always"?d.Trace:E?.logLevel;z||(z=this.s(P,F??this.getLogLevel(P)??this.h,{...E,id:N}));const j={logger:z,info:{resource:P,id:N,logLevel:F,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(j.info),this.b.set(P,j),z}n(w){return(0,y.$If)(w)?(0,$.$Hg)(this.j,`${w}.log`):w}setLogLevel(w,E){if(L.URI.isUri(w)){const P=w,N=E,z=this.b.get(P);z&&N!==z.info.logLevel&&(z.info.logLevel=N===this.h?void 0:N,z.logger?.setLevel(N),this.b.set(z.info.resource,z),this.f.fire([P,N]))}else{this.h=w;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,E){const P=this.m(w);P&&E!==!P.info.hidden&&(P.info.hidden=!E,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,E]))}getLogLevel(w){let E;return w&&(E=this.b.get(w)?.info.logLevel),E??this.h}registerLogger(w){const E=this.b.get(w.resource);E?E.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const E=this.b.get(w);E&&(E.logger&&E.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=r;class h{constructor(){this.onDidChangeLogLevel=new T.$Vd().event}setLevel(w){}getLevel(){return d.Info}trace(w,...E){}debug(w,...E){}info(w,...E){}warn(w,...E){}error(w,...E){}critical(w,...E){}dispose(){}flush(){}}e.$zj=h;class u extends h{}e.$Aj=u;function l(v){if(v.verbose)return d.Trace;if(typeof v.logLevel=="string"){const w=A(v.logLevel.toLowerCase());if(w!==void 0)return w}return e.$qj}e.$Bj=l;function k(v){switch(v){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.$Cj=k;function A(v){switch(v){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$Dj=A,e.$Ej=new C.$kj("logLevel",k(d.Info))}),define(ke[248],Se([1,0,19,11,14,4,3,17,85,13]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class L extends R.$Tc{constructor(m,p){super(),this.a=m,this.b=p,this.c=this.B(new I.$Vd),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$Vd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$4g(0)),this.w=[],this.y=this.B(new T.$4g(0))}watch(m,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(m,p):this.z(m,p)}n(m,p){const S={path:this.H(m),excludes:p.excludes,includes:p.includes,recursive:p.recursive,correlationId:p.correlationId},d=(0,D.$Ub)(this.j,S);return this.r(),(0,R.$Rc)(()=>{d(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,g.$1)(m))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,$.$hq)(p)),p=>this.G(p),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const p of this.j)(0,$.$dq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const p of this.j)(0,$.$dq)(p)&&m.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,p){const S={path:this.H(m),excludes:p.excludes,includes:p.includes,recursive:!1,correlationId:p.correlationId},d=(0,D.$Ub)(this.w,S);return this.C(),(0,R.$Rc)(()=>{d(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,g.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$hq)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$hc)(m.fsPath)}}e.$lq=L}),define(ke[249],Se([1,0,56,387,11,28,22,4,33,3,17,10,23,99,31,205,32,242,248,44,246,245]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0,(()=>{try{(0,T.gracefulify)(D)}catch(a){console.error(`Error enabling graceful-fs: ${(0,s.$Qi)(a)}`)}})();class t extends i.$lq{static{this.I=!1}constructor(r,h){super(r,h),this.onDidChangeCapabilities=b.Event.None,this.N=new I.$Ac(u=>m.$yg.getComparisonKey(u)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:h,symbolicLink:u}=await S.SymlinkSupport.stat(this.H(r));return{type:this.M(h,u),ctime:h.birthtime.getTime(),mtime:h.mtime.getTime(),size:h.size,permissions:h.mode&128?void 0:f.FilePermission.Locked}}catch(h){throw this.fb(h)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const h=await S.Promises.readdir(this.H(r),{withFileTypes:!0}),u=[];return await Promise.all(h.map(async l=>{try{let k;l.isSymbolicLink()?k=(await this.stat((0,m.$Hg)(r,l.name))).type:k=this.M(l),u.push([l.name,k])}catch(k){this.a.trace(k)}})),u}catch(h){throw this.fb(h)}}M(r,h){let u;return h?.dangling?u=f.FileType.Unknown:r.isFile()?u=f.FileType.File:r.isDirectory()?u=f.FileType.Directory:u=f.FileType.Unknown,h&&(u|=f.FileType.SymbolicLink),u}async O(r){const h=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${h})`);let u;for(;u=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${h})`),await u.wait();const l=new g.$5g;return this.N.set(r,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${h})`),(0,y.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${h})`),this.N.get(r)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${h})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${h})`),l.open()})}async readFile(r,h){let u;try{h?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),u=await this.O(r));const l=this.H(r);return await S.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{u?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,h,u){const l=(0,p.$0d)(k=>R.$je.concat(k.map(A=>R.$je.wrap(A))).buffer);return(0,o.$bq)(this,r,l,k=>k.buffer,{...h,bufferSize:256*1024},u),l}async writeFile(r,h,u){return u?.atomic!==!1&&u?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,m.$Hg)((0,m.$Gg)(r),`${(0,m.$Eg)(r)}${u.atomic.postfix}`),h,u):this.S(r,h,u)}async Q(r){try{const h=this.H(r),{symbolicLink:u}=await S.SymlinkSupport.stat(h);if(u)return!1}catch{}return!0}async R(r,h,u,l){const k=new y.$Sc;try{k.add(await this.O(r)),k.add(await this.O(h)),await this.S(h,u,l,!0);try{await this.rename(h,r,{overwrite:!0})}catch(A){try{await this.delete(h,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{k.dispose()}}async S(r,h,u,l){let k;try{const A=this.H(r);if(!u.create||!u.overwrite){if(await S.Promises.exists(A)){if(!u.overwrite)throw(0,f.$Dk)((0,d.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,f.$Dk)((0,d.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(r,{create:!0,unlock:u.unlock},l),await this.write(k,0,h,0,h.byteLength)}catch(A){throw await this.gb(r,A)}finally{typeof k=="number"&&await this.close(k)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,h,u){const l=this.H(r);let k;(0,f.$rk)(h)&&!u&&(k=await this.O(r));let A;try{if((0,f.$rk)(h)&&h.unlock)try{const{stat:w}=await S.SymlinkSupport.stat(l);w.mode&128||await S.Promises.chmod(l,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let v;if((0,f.$rk)(h)){if(C.$i)try{await S.Promises.truncate(l,0),v="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}v||(v="w")}else v="r";A=await S.Promises.open(l,v)}catch(v){throw k?.dispose(),(0,f.$rk)(h)?await this.gb(r,v):this.fb(v)}if(this.U.set(A,0),(0,f.$rk)(h)&&this.X.set(A,r),k){const v=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${l})`),this.W.set(A,k),v&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${l})`),v.dispose())}return A}async close(r){const h=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await S.Promises.fdatasync(r)}catch(u){t.configureFlushOnWrite(!1),this.a.error(u)}return await S.Promises.close(r)}catch(u){throw this.fb(u)}finally{h&&(this.W.get(r)===h&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),h.dispose())}}async read(r,h,u,l,k){const A=this.Z(r,h);let v=null;try{v=(await S.Promises.read(r,u,l,k,A)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(r,A,v)}return v}Z(r,h){return h===this.U.get(r)?null:h}$(r,h,u){const l=this.U.get(r);typeof l=="number"&&(typeof h=="number"||(typeof u=="number"?this.U.set(r,l+u):this.U.delete(r)))}async write(r,h,u,l,k){return(0,g.$nh)(()=>this.ab(r,h,u,l,k),100,3)}async ab(r,h,u,l,k){const A=this.Z(r,h);let v=null;try{v=(await S.Promises.write(r,u,l,k,A)).bytesWritten}catch(w){throw await this.gb(this.X.get(r),w)}finally{this.$(r,A,v)}return v}async mkdir(r){try{await S.Promises.mkdir(this.H(r))}catch(h){throw this.fb(h)}}async delete(r,h){try{const u=this.H(r);if(h.recursive){let l;h?.atomic!==!1&&h.atomic.postfix&&(l=(0,L.$jc)((0,L.$mc)(u),`${(0,L.$nc)(u)}${h.atomic.postfix}`)),await S.Promises.rm(u,S.RimRafMode.MOVE,l)}else try{await S.Promises.unlink(u)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let k=!1;try{const{stat:A,symbolicLink:v}=await S.SymlinkSupport.stat(u);k=A.isDirectory()&&!v}catch{}if(k)await S.Promises.rmdir(u);else throw l}else throw l}}catch(u){throw this.fb(u)}}async rename(r,h,u){const l=this.H(r),k=this.H(h);if(l!==k)try{await this.bb(r,h,"move",u.overwrite),await S.Promises.rename(l,k)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,d.localize)(2,null,(0,L.$nc)(l),(0,L.$nc)((0,L.$mc)(k)),A.toString()))),this.fb(A)}}async copy(r,h,u){const l=this.H(r),k=this.H(h);if(l!==k)try{await this.bb(r,h,"copy",u.overwrite),await S.Promises.copy(l,k,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,d.localize)(3,null,(0,L.$nc)(l),(0,L.$nc)((0,L.$mc)(k)),A.toString()))),this.fb(A)}}async bb(r,h,u,l){const k=this.H(r),A=this.H(h);let v=!1;if(!!(this.capabilities&1024)||(v=(0,$.$7f)(k,A,!0)),v){if(u==="copy")throw(0,f.$Dk)((0,d.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const E=await this.L(r);if(!E)throw(0,f.$Dk)((0,d.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(h);if(P){if(!l)throw(0,f.$Dk)((0,d.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);E.type&f.FileType.File&&P.type&f.FileType.File||await this.delete(h,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,h){return this.cb(r,h,!1)}async cb(r,h,u){const l=this.H(r),k=this.H(h),A=!!(this.capabilities&1024);if((0,$.$7f)(l,k,!A))return;const v=new y.$Sc;try{v.add(await this.O(r)),v.add(await this.O(h)),u&&await S.Promises.mkdir((0,L.$mc)(k),{recursive:!0}),await S.Promises.copyFile(l,k)}catch(w){if(w.code==="ENOENT"&&!u)return this.cb(r,h,!0);throw this.fb(w)}finally{v.dispose()}}t(r,h,u){return new n.$sq(l=>r(l),l=>h(l),u)}F(r,h,u){return new c.$Aq(l=>r(l),l=>h(l),u)}fb(r){if(r instanceof f.$Ck)return r;let h=r,u;switch(r.code){case"ENOENT":u=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":h=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=f.FileSystemProviderErrorCode.Unknown;break;default:u=f.FileSystemProviderErrorCode.Unknown}return(0,f.$Dk)(h,u)}async gb(r,h){let u=this.fb(h);if(r&&u.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await S.SymlinkSupport.stat(this.H(r));l.mode&128||(u=(0,f.$Dk)(h,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return u}}e.$Bq=t}),define(ke[250],Se([1,0,3,13]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=void 0;class g extends D.$Tc{constructor(R,b=[]){super(),this.a=new T.$xj([R,...b]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...b){this.a.trace(R,...b)}debug(R,...b){this.a.debug(R,...b)}info(R,...b){this.a.info(R,...b)}warn(R,...b){this.a.warn(R,...b)}error(R,...b){this.a.error(R,...b)}flush(){this.a.flush()}}e.$yO=g}),define(ke[251],Se([1,0,32,13]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nO=void 0;var g;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(g||(g={}));async function I(y,L,C,m,p){try{const S=await new Promise((f,o)=>{me(["@vscode/spdlog"],f,o)});S.setFlushOn(g.Trace);const d=await S.createAsyncRotatingLogger(y,L,C,m);return p?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(S){console.error(S)}return null}function R(y,L,C){switch(L){case T.LogLevel.Trace:y.trace(C);break;case T.LogLevel.Debug:y.debug(C);break;case T.LogLevel.Info:y.info(C);break;case T.LogLevel.Warning:y.warn(C);break;case T.LogLevel.Error:y.error(C);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function b(y,L){switch(L){case T.LogLevel.Trace:y.setLevel(g.Trace);break;case T.LogLevel.Debug:y.setLevel(g.Debug);break;case T.LogLevel.Info:y.setLevel(g.Info);break;case T.LogLevel.Warning:y.setLevel(g.Warning);break;case T.LogLevel.Error:y.setLevel(g.Error);break;case T.LogLevel.Off:y.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class $ extends T.$tj{constructor(L,C,m,p,S){super(),this.m=[],this.setLevel(S),this.n=this.s(L,C,m,p),this.B(this.onDidChangeLogLevel(d=>{this.r&&b(this.r,d)}))}async s(L,C,m,p){const S=m?6:1,d=30/S*D.$Yk.MB,f=await I(L,C,d,S,p);if(f){this.r=f,b(this.r,this.getLevel());for(const{level:o,message:i}of this.m)R(this.r,o,i);this.m=[]}}g(L,C){this.r?R(this.r,L,C):this.getLevel()<=L&&this.m.push({level:L,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$nO=$}),define(ke[135],Se([1,0,39,206,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function y(S,d){return d-S}$.compare=y;const L=Object.create(null);L[$.Error]=(0,T.localize)(0,null),L[$.Warning]=(0,T.localize)(1,null),L[$.Info]=(0,T.localize)(2,null);function C(S){return L[S]||""}$.toString=C;function m(S){switch(S){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=m;function p(S){switch(S){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=p}(R||(e.MarkerSeverity=R={}));var b;(function($){const y="";function L(m){return C(m,!0)}$.makeKey=L;function C(m,p){const S=[y];return m.source?S.push(m.source.replace("\xA6","\\\xA6")):S.push(y),m.code?typeof m.code=="string"?S.push(m.code.replace("\xA6","\\\xA6")):S.push(m.code.value.replace("\xA6","\\\xA6")):S.push(y),m.severity!==void 0&&m.severity!==null?S.push(R.toString(m.severity)):S.push(y),m.message&&p?S.push(m.message.replace("\xA6","\\\xA6")):S.push(y),m.startLineNumber!==void 0&&m.startLineNumber!==null?S.push(m.startLineNumber.toString()):S.push(y),m.startColumn!==void 0&&m.startColumn!==null?S.push(m.startColumn.toString()):S.push(y),m.endLineNumber!==void 0&&m.endLineNumber!==null?S.push(m.endLineNumber.toString()):S.push(y),m.endColumn!==void 0&&m.endColumn!==null?S.push(m.endColumn.toString()):S.push(y),S.push(y),S.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$At=(0,g.$6h)("markerService")}),define(ke[252],Se([1,0,4,39,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.NotificationsFilter=e.$qv=e.NeverShowAgainScope=e.NotificationPriority=e.$pv=e.Severity=void 0,e.Severity=T.default,e.$pv=(0,g.$6h)("notificationService");var I;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(I||(e.NotificationPriority=I={}));var R;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function b(C){if(C){const m=C;return typeof m.id=="string"&&typeof m.label=="string"}return!1}e.$qv=b;var $;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class y{constructor(){this.progress=new L,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(m){}updateMessage(m){}updateActions(m){}close(){}}e.$rv=y;class L{infinite(){}done(){}total(m){}worked(m){}}e.$sv=L}),define(ke[253],Se([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.context<"u"){const I=g.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(T=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:I.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ke[136],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,D.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(me,e){return function(D,T){e(D,T,me)}};define(ke[86],Se([1,0,11,21,3,5]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.ProgressLocation=e.$tv=void 0,e.$tv=(0,I.$6h)("progressService");var R;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$uv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$vv=b;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const p=this.d;this.d=()=>{p?.(),m()}}):Promise.resolve()}}e.$wv=$;let y=class extends g.$Tc{constructor(m,p){super(),this.a=new D.$qh,p.withProgress(m,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,g.$Rc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$xv=y,e.$xv=y=Ge([Ve(1,e.$tv)],y);class L extends g.$Tc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new g.$Sc)}start(m){this.stop();const p=++this.a,S=new T.$6d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,g.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Rc)(()=>S.cancel())),this.b.add((0,g.$Rc)(()=>this.c?this.c.done():void 0)),{id:p,token:S.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$yv=L,e.$zv=(0,I.$6h)("editorProgressService")}),define(ke[37],Se([1,0,60,18]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class g{constructor(){this.a=new Map}add(R,b){D.ok(T.$If(R)),D.ok(T.$Kf(b)),D.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,b)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Hn=new g}),define(ke[108],Se([1,0,4,37]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function g(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class I{constructor(){this.b=new D.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[g($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const R=new I;T.$Hn.add(e.$In.JSONContribution,R)}),define(ke[87],Se([1,0,19,4,18,196,51,108,37]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var y;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$Mn={Configuration:"base.contributions.configuration"};var L;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const C=$.$Hn.as(b.$In.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.$Vd,this.onDidSchemaChange=this.i.event,this.j=new T.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const r=new Set;this.n(t,a,r),C.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const a=new Set;this.o(t,a),C.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const r=new Set;this.o(a,r),this.n(t,!1,r),C.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const r=[];for(const{overrides:h,source:u}of t)for(const l in h)if(a.add(l),e.$Wn.test(l)){const k=this.a.get(l),A=k?.valuesSources??new Map;if(u)for(const P of Object.keys(h[l]))A.set(P,u);const v={...k?.value||{},...h[l]};this.a.set(l,{source:u,value:v,valuesSources:A});const w=(0,R.$Ji)(l),E={type:"object",default:v,description:I.localize(1,null,w),$ref:e.$Tn,defaultDefaultValue:v,source:g.$If(u)?void 0:u,defaultValueSource:u};r.push(...d(l)),this.d[l]=E,this.b.properties[l]=E}else{this.a.set(l,{value:h[l],source:u});const k=this.d[l];k&&(this.w(l,k),this.r(l,k))}this.m(r)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:r,source:h}of t)for(const u in r){const l=this.a.get(u),k=g.$If(h)?h:h?.id,A=g.$If(l?.source)?l?.source:l?.source?.id;if(k===A)if(a.add(u),this.a.delete(u),e.$Wn.test(u))delete this.d[u],delete this.b.properties[u];else{const v=this.d[u];v&&(this.w(u,v),this.r(u,v))}}this.u()}deltaConfiguration(t){let a=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,r){t.forEach(h=>{this.p(h,a,h.extensionInfo,h.restrictedProperties,void 0,r),this.c.push(h),this.q(h)})}o(t,a){const r=h=>{if(h.properties)for(const u in h.properties){a.add(u);const l=this.d[u];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[u],this.s(u,h.properties[u])}h.allOf?.forEach(u=>r(u))};for(const h of t){r(h);const u=this.c.indexOf(h);u!==-1&&this.c.splice(u,1)}}p(t,a=!0,r,h,u=3,l){u=g.$Rf(t.scope)?u:t.scope;const k=t.properties;if(k)for(const v in k){const w=k[v];if(a&&s(v,w)){delete k[v];continue}if(w.source=r,w.defaultDefaultValue=k[v].default,this.w(v,w),e.$Wn.test(v)?w.scope=void 0:(w.scope=g.$Rf(w.scope)?u:w.scope,w.restricted=g.$Rf(w.restricted)?!!h?.includes(v):w.restricted),k[v].hasOwnProperty("included")&&!k[v].included){this.f[v]=k[v],delete k[v];continue}else this.d[v]=k[v],k[v].policy?.name&&this.e.set(k[v].policy.name,v);!k[v].deprecationMessage&&k[v].markdownDeprecationMessage&&(k[v].deprecationMessage=k[v].markdownDeprecationMessage),l.add(v)}const A=t.allOf;if(A)for(const v of A)this.p(v,a,r,h,u,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=r=>{const h=r.properties;if(h)for(const l in h)this.r(l,h[l]);r.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$Nn.properties[t]=a,a.scope){case 1:e.$On.properties[t]=a;break;case 2:e.$Pn.properties[t]=a;break;case 6:e.$Qn.properties[t]=a;break;case 3:e.$Rn.properties[t]=a;break;case 4:e.$Sn.properties[t]=a;break;case 5:e.$Sn.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$Nn.properties[t],a.scope){case 1:delete e.$On.properties[t];break;case 2:delete e.$Pn.properties[t];break;case 6:delete e.$Qn.properties[t];break;case 3:delete e.$Rn.properties[t];break;case 4:case 5:delete e.$Sn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,r={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$Tn};this.w(a,r),e.$Nn.properties[a]=r,e.$On.properties[a]=r,e.$Pn.properties[a]=r,e.$Qn.properties[a]=r,e.$Rn.properties[a]=r,e.$Sn.properties[a]=r}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=t,e.$On.patternProperties[e.$Vn]=t,e.$Pn.patternProperties[e.$Vn]=t,e.$Qn.patternProperties[e.$Vn]=t,e.$Rn.patternProperties[e.$Vn]=t,e.$Sn.patternProperties[e.$Vn]=t,this.i.fire()}w(t,a){const r=this.a.get(t);let h=r?.value,u=r?.source;g.$Pf(h)&&(h=a.defaultDefaultValue,u=void 0),g.$Pf(h)&&(h=o(a.type)),a.default=h,a.defaultValueSource=u}}const p="\\[([^\\]]+)\\]",S=new RegExp(p,"g");e.$Vn=`^(${p})+$`,e.$Wn=new RegExp(e.$Vn);function d(c){const t=[];if(e.$Wn.test(c)){let a=S.exec(c);for(;a?.length;){const r=a[1].trim();r&&t.push(r),a=S.exec(c)}}return(0,D.$Mb)(t)}e.$Xn=d;function f(c){return c.reduce((t,a)=>`${t}[${a}]`,"")}e.$Yn=f;function o(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=o;const i=new m;$.$Hn.add(e.$Mn.Configuration,i);function s(c,t){return c.trim()?e.$Wn.test(c)?I.localize(7,null,c):i.getConfigurationProperties()[c]!==void 0?I.localize(8,null,c):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,c,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.$1n=s;function n(){const c=[],t=i.getConfigurationProperties();for(const a of Object.keys(t))c.push([a,t[a].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$2n=n}),define(ke[254],Se([1,0,19,4,159,3,28,24,18,2,51,87,37]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function p(a){return Object.isFrozen(a)?a:b.$wn(a)}class S{constructor(r={},h=[],u=[],l){this.b=r,this.c=h,this.d=u,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(h=>{if(h instanceof S)return h;const u=new d("");return u.parseRaw(h),u.configurationModel});this.f=r.reduce((h,u)=>u===h?u:h.merge(u),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,L.$Hi)(this.contents,r):this.contents}inspect(r,h){const u=this.rawConfiguration.getValue(r),l=h?this.rawConfiguration.getOverrideValue(r,h):void 0,k=h?this.rawConfiguration.override(h).getValue(r):u;return{value:u,override:l,merged:k}}getOverrideValue(r,h){const u=this.i(h);return u?r?(0,L.$Hi)(u,r):u:void 0}getKeysForOverrideIdentifier(r){const h=[];for(const u of this.overrides)u.identifiers.includes(r)&&h.push(...u.keys);return D.$Mb(h)}getAllOverrideIdentifiers(){const r=[];for(const h of this.overrides)r.push(...h.identifiers);return D.$Mb(r)}override(r){let h=this.a.get(r);return h||(h=this.g(r),this.a.set(r,h)),h}merge(...r){const h=b.$vn(this.contents),u=b.$vn(this.overrides),l=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const A of r)if(k.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(h,A.contents);for(const v of A.overrides){const[w]=u.filter(E=>D.$ub(E.identifiers,v.identifiers));w?(this.h(w.contents,v.contents),w.keys.push(...v.keys),w.keys=D.$Mb(w.keys)):u.push(b.$vn(v))}for(const v of A.keys)l.indexOf(v)===-1&&l.push(v)}return new S(h,l,u,k.every(A=>A instanceof S)?void 0:k)}g(r){const h=this.i(r);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const u={};for(const l of D.$Mb([...Object.keys(this.contents),...Object.keys(h)])){let k=this.contents[l];const A=h[l];A&&(typeof k=="object"&&typeof A=="object"?(k=b.$vn(k),this.h(k,A)):k=A),u[l]=k}return new S(u,this.keys,this.overrides)}h(r,h){for(const u of Object.keys(h)){if(u in r&&$.$Kf(r[u])&&$.$Kf(h[u])){this.h(r[u],h[u]);continue}r[u]=b.$vn(h[u])}}i(r){let h=null,u=null;const l=k=>{k&&(u?this.h(u,k):u=b.$vn(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===r?h=k.contents:k.identifiers.includes(r)&&l(k.contents);return l(h),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,h){this.j(r,h,!0)}setValue(r,h){this.j(r,h,!1)}removeValue(r){const h=this.keys.indexOf(r);h!==-1&&(this.keys.splice(h,1),(0,L.$Gi)(this.contents,r),C.$Wn.test(r)&&this.overrides.splice(this.overrides.findIndex(u=>D.$ub(u.identifiers,(0,C.$Xn)(r))),1))}j(r,h,u){(0,L.$Fi)(this.contents,r,h,l=>console.error(l)),u=u||this.keys.indexOf(r)===-1,u&&this.keys.push(r),C.$Wn.test(r)&&this.overrides.push({identifiers:(0,C.$Xn)(r),keys:Object.keys(this.contents[r]),contents:(0,L.$Ei)(this.contents[r],l=>console.error(l))})}}e.$3n=S;class d{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,h){if(!$.$Rf(r)){const u=this.g(r);this.parseRaw(u,h)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,h){this.a=r;const{contents:u,keys:l,overrides:k,restricted:A,hasExcludedProperties:v}=this.h(r,h);this.b=new S(u,l,k,v?[r]:void 0),this.c=A||[]}g(r){let h={},u=null,l=[];const k=[],A=[];function v(E){Array.isArray(l)?l.push(E):u!==null&&(l[u]=E)}const w={onObjectBegin:()=>{const E={};v(E),k.push(l),l=E,u=null},onObjectProperty:E=>{u=E},onObjectEnd:()=>{l=k.pop()},onArrayBegin:()=>{const E=[];v(E),k.push(l),l=E,u=null},onArrayEnd:()=>{l=k.pop()},onLiteralValue:v,onError:(E,P,N)=>{A.push({error:E,offset:P,length:N})}};if(r)try{g.$jn(r,w),h=l[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return h}h(r,h){const u=m.$Hn.as(C.$Mn.Configuration).getConfigurationProperties(),l=this.i(r,u,!0,h);r=l.raw;const k=(0,L.$Ei)(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),A=Object.keys(r),v=this.j(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:k,keys:A,overrides:v,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(r,h,u,l){let k=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:k};const A={},v=[];for(const w in r)if(C.$Wn.test(w)&&u){const E=this.i(r[w],h,!1,l);A[w]=E.raw,k=k||E.hasExcludedProperties,v.push(...E.restricted)}else{const E=h[w],P=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&v.push(w),!l.exclude?.includes(w)&&(l.include?.includes(w)||(P===void 0||l.scopes===void 0||l.scopes.includes(P))&&!(l.skipRestricted&&E?.restricted))?A[w]=r[w]:k=!0}return{raw:A,restricted:v,hasExcludedProperties:k}}j(r,h){const u=[];for(const l of Object.keys(r))if(C.$Wn.test(l)){const k={};for(const A in r[l])k[A]=r[l][A];u.push({identifiers:(0,C.$Xn)(l),keys:Object.keys(k),contents:(0,L.$Ei)(k,h)})}return u}}e.$4n=d;class f extends I.$Tc{constructor(r,h,u,l){super(),this.c=r,this.f=h,this.g=l,this.b=this.B(new T.$Vd),this.onDidChange=this.b.event,this.a=new d(this.c.toString()),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&u.isEqual(k.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=f;class o{constructor(r,h,u,l,k,A,v,w,E,P,N,z,F){this.a=r,this.b=h,this.c=u,this.overrideIdentifiers=l,this.d=k,this.f=A,this.g=v,this.h=w,this.i=E,this.j=P,this.k=N,this.l=z,this.m=F}get value(){return p(this.c)}n(r,h,u){const l=r.inspect(h,u);return{get value(){return p(l.value)},get override(){return p(l.override)},get merged(){return p(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(r,h,u,l,k=new S,A=new S,v=new R.$Ac,w=new S,E=new R.$Ac){this.c=r,this.d=h,this.f=u,this.g=l,this.h=k,this.i=A,this.j=v,this.l=w,this.m=E,this.a=null,this.b=new R.$Ac,this.n=null}getValue(r,h,u){return this.p(r,h,u).getValue(r)}updateValue(r,h,u={}){let l;u.resource?(l=this.m.get(u.resource),l||(l=new S,this.m.set(u.resource,l))):l=this.l,h===void 0?l.removeValue(r):l.setValue(r,h),u.resource||(this.a=null)}inspect(r,h,u){const l=this.p(r,h,u),k=this.t(h.resource,u),A=h.resource?this.m.get(h.resource)||this.l:this.l,v=new Set;for(const w of l.overrides)for(const E of w.identifiers)l.getOverrideValue(r,E)!==void 0&&v.add(E);return new o(r,h,l.getValue(r),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.i:void 0,k||void 0,A)}keys(r){const h=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,h){this.j.set(r,h),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,h){const u=[];if(!h){const{added:l,updated:k,removed:A}=c(this.c,r);h=[...l,...k,...A]}for(const l of h)for(const k of(0,C.$Xn)(l)){const A=this.c.getKeysForOverrideIdentifier(k),v=r.getKeysForOverrideIdentifier(k),w=[...v.filter(E=>A.indexOf(E)===-1),...A.filter(E=>v.indexOf(E)===-1),...A.filter(E=>!b.$zn(this.c.override(k).getValue(E),r.override(k).getValue(E)))];u.push([k,w])}return this.updateDefaultConfiguration(r),{keys:h,overrides:u}}compareAndUpdatePolicyConfiguration(r){const{added:h,updated:u,removed:l}=c(this.d,r),k=[...h,...u,...l];return k.length&&this.updatePolicyConfiguration(r),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:h,updated:u,removed:l,overrides:k}=c(this.applicationConfiguration,r),A=[...h,...u,...l];return A.length&&this.updateApplicationConfiguration(r),{keys:A,overrides:k}}compareAndUpdateLocalUserConfiguration(r){const{added:h,updated:u,removed:l,overrides:k}=c(this.localUserConfiguration,r),A=[...h,...u,...l];return A.length&&this.updateLocalUserConfiguration(r),{keys:A,overrides:k}}compareAndUpdateRemoteUserConfiguration(r){const{added:h,updated:u,removed:l,overrides:k}=c(this.remoteUserConfiguration,r),A=[...h,...u,...l];return A.length&&this.updateRemoteUserConfiguration(r),{keys:A,overrides:k}}compareAndUpdateWorkspaceConfiguration(r){const{added:h,updated:u,removed:l,overrides:k}=c(this.workspaceConfiguration,r),A=[...h,...u,...l];return A.length&&this.updateWorkspaceConfiguration(r),{keys:A,overrides:k}}compareAndUpdateFolderConfiguration(r,h){const u=this.folderConfigurations.get(r),{added:l,updated:k,removed:A,overrides:v}=c(u,h),w=[...l,...k,...A];return(w.length||!u)&&this.updateFolderConfiguration(r,h),{keys:w,overrides:v}}compareAndDeleteFolderConfiguration(r){const h=this.folderConfigurations.get(r);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:u,updated:l,removed:k,overrides:A}=c(h,void 0);return{keys:[...u,...l,...k],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,h,u){let l=this.q(h,u);return h.overrideIdentifier&&(l=l.override(h.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(l=l.merge(this.d)),l}q({resource:r},h){let u=this.r();if(h&&r){const l=h.getFolder(r);l&&(u=this.s(l.uri)||u);const k=this.m.get(r);k&&(u=u.merge(k))}return u}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let h=this.b.get(r);if(!h){const u=this.r(),l=this.j.get(r);l?(h=u.merge(l),this.b.set(r,h)):h=u}return h}t(r,h){if(h&&r){const u=h.getFolder(r);if(u)return this.j.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,h)=>{const{contents:u,overrides:l,keys:k}=this.j.get(h);return r.push([h,{contents:u,overrides:l,keys:k}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(h=>r.add(h)),this.userConfiguration.keys.forEach(h=>r.add(h)),this.i.keys.forEach(h=>r.add(h)),this.j.forEach(h=>h.keys.forEach(u=>r.add(u))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(h=>r.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>r.add(h)),this.i.getAllOverrideIdentifiers().forEach(h=>r.add(h)),this.j.forEach(h=>h.getAllOverrideIdentifiers().forEach(u=>r.add(u))),[...r.values()]}v(r){const h=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(u=>h.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(u=>h.add(u)),this.i.getKeysForOverrideIdentifier(r).forEach(u=>h.add(u)),this.j.forEach(u=>u.getKeysForOverrideIdentifier(r).forEach(l=>h.add(l))),[...h.values()]}static parse(r){const h=this.w(r.defaults),u=this.w(r.policy),l=this.w(r.application),k=this.w(r.user),A=this.w(r.workspace),v=r.folders.reduce((w,E)=>(w.set(y.URI.revive(E[0]),this.w(E[1])),w),new R.$Ac);return new i(h,u,l,k,new S,A,v,new S,new R.$Ac)}static w(r){return new S(r.contents,r.keys,r.overrides)}}e.$6n=i;function s(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const r=new Set,h=new Map;for(const l of a)l.keys.forEach(k=>r.add(k)),l.overrides.forEach(([k,A])=>{const v=(0,R.$xc)(h,k,new Set);A.forEach(w=>v.add(w))});const u=[];return h.forEach((l,k)=>u.push([k,[...l.values()]])),{keys:[...r.values()],overrides:u}}e.$7n=s;class n{constructor(r,h,u,l){this.change=r,this.f=h,this.g=u,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of r.keys)this.affectedKeys.add(k);for(const[,k]of r.overrides)for(const A of k)this.affectedKeys.add(A);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(r,h){const u=this.a+r,l=this.d.indexOf(u);if(l<0)return!1;const k=l+u.length;if(k>=this.d.length)return!1;const A=this.d.charCodeAt(k);if(A!==this.b&&A!==this.c)return!1;if(h){const v=this.previousConfiguration?this.previousConfiguration.getValue(r,h,this.f?.workspace):void 0,w=this.g.getValue(r,h,this.h);return!b.$zn(v,w)}return!0}}e.$8n=n;function c(a,r){const{added:h,removed:u,updated:l}=t(r?.rawConfiguration,a?.rawConfiguration),k=[],A=a?.getAllOverrideIdentifiers()||[],v=r?.getAllOverrideIdentifiers()||[];if(r){const w=v.filter(E=>!A.includes(E));for(const E of w)k.push([E,r.getKeysForOverrideIdentifier(E)])}if(a){const w=A.filter(E=>!v.includes(E));for(const E of w)k.push([E,a.getKeysForOverrideIdentifier(E)])}if(r&&a){for(const w of A)if(v.includes(w)){const E=t({contents:a.getOverrideValue(void 0,w)||{},keys:a.getKeysForOverrideIdentifier(w)},{contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)});k.push([w,[...E.added,...E.removed,...E.updated]])}}return{added:h,removed:u,updated:l,overrides:k}}function t(a,r){const h=a?r?a.keys.filter(k=>r.keys.indexOf(k)===-1):[...a.keys]:[],u=r?a?r.keys.filter(k=>a.keys.indexOf(k)===-1):[...r.keys]:[],l=[];if(a&&r){for(const k of r.keys)if(a.keys.indexOf(k)!==-1){const A=(0,L.$Hi)(r.contents,k),v=(0,L.$Hi)(a.contents,k);b.$zn(A,v)||l.push(k)}}return{added:h,removed:u,updated:l}}}),define(ke[255],Se([1,0,22,4,3,82]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yrb=e.$xrb=e.$wrb=e.$vrb=void 0;const R=(y,L,C)=>{const m=new Uint8Array(16);for(let d=0;d<16;d++)m[d]=Math.round(Math.random()*256);const p=(0,D.$De)(D.$je.wrap(m));return[`GET ws://localhost${y}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`].join(`\r
`)+`\r
\r
`};e.$vrb=R,e.$wrb=D.$je.fromString(`\r
\r
`);async function b(y,L,C,m,p){y.write(D.$je.fromString((0,e.$vrb)(L,C,m)));const S=new g.$Sc;try{return await new Promise((d,f)=>{let o;S.add(y.onData(i=>{o?o=D.$je.concat([o,i],o.byteLength+i.byteLength):o=i;const s=o.indexOf(e.$wrb);if(s===-1)return;d(y),y.pauseData();const n=o.slice(s+e.$wrb.byteLength);n.byteLength&&p.onData.fire(n)})),S.add(y.onClose(i=>f(i??new Error("socket closed")))),S.add(y.onEnd(()=>f(new Error("socket ended"))))})}catch(d){throw y.dispose(),d}finally{S.dispose()}}e.$xrb=b;class $ extends g.$Tc{constructor(L,C){super(),this.g=L,this.a=this.B(new T.$Yd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new T.$Vd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(L,C){I.SocketDiagnostics.traceSocketEvent(this,this.g,L,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$yrb=$}),define(ke[64],Se([1,0,14,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.RemoteAuthorityResolverErrorCode=e.$0k=e.$9k=e.RemoteConnectionType=e.$8k=void 0,e.$8k=(0,T.$6h)("remoteAuthorityResolverService");var g;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class I{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$9k=I;class R{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$0k=R;var b;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends D.$bb{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=b.Unknown,p){super(C),this._message=C,this._code=m,this._detail=p,this.isHandled=m===b.NotAvailable&&p===!0,Object.setPrototypeOf(this,$.prototype)}}e.$$k=$;function y(L){const C=L.indexOf("+");return C===-1?L:L.substring(0,C)}e.$_k=y}),define(ke[65],Se([1,0,16]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function T(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$al=T;function g(y){if(!y)return;const L=y.indexOf("+");return L<0?y:y.substr(0,L)}e.$bl=g;function I(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$cl=I;function R(y){const{host:L,port:C}=$(y);if(typeof C>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:L,port:C}}e.$dl=R;function b(y,L){let{host:C,port:m}=$(y);return typeof m>"u"&&(m=L),{host:C,port:m}}e.$el=b;function $(y){const L=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const C=y.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(ke[26],Se([1,0,12,5,65]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function I(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$jm=I,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R||(e.ExtensionType=R={}));var b;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,o){if(typeof f>"u"||f===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof f=="string"||typeof o=="string"){const i=typeof f=="string"?f:f.value,s=typeof o=="string"?o:o.value;return D.$_e(i,s)}return f._lower===o._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$lm=$;class y{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const o of f)this.add(o)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$mm=y;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,o){this.c.set($.toKey(f),o)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=L;function C(d){return m(d)}e.$om=C;function m(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.$pm=m;function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.$qm=p;function S(d,f){if(f){const o=`onResolveRemoteAuthority:${(0,g.$bl)(f)}`;return!!d.activationEvents?.includes(o)}return!1}e.$rm=S,e.$sm=(0,T.$6h)("IBuiltinExtensionsScannerService")}),define(ke[137],Se([1,0,14,26]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lF=e.$kF=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(R,b){this.a.set(R,b)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const b=Object.create(null);for(const $ of R){const y=this.readActivationEvents($);y.length>0&&(b[T.$lm.toKey($.identifier)]=y)}return b}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const b=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${T.$lm.toKey(R.identifier)}`);if(!R.contributes)return b;for(const $ in R.contributes){const y=this.a.get($);if(!y)continue;const L=R.contributes[$],C=Array.isArray(L)?L:[L];try{y(C,b)}catch(m){(0,D.$1)(m)}}return b}}e.$kF=g,e.$lF=new g}),define(ke[256],Se([1,0,11,22,21,14,4,3,57,38,30,82,64,65]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.PersistentConnectionEventType=e.$ll=e.$kl=e.$jl=e.ConnectionType=void 0;const S=30*1e3;var d;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function f(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(G){const W=new g.$6d;return setTimeout(()=>W.cancel(),G),W.token}function i(G,W){if(G.isCancellationRequested||W.isCancellationRequested)return g.CancellationToken.Cancelled;const ne=new g.$6d;return G.onCancellationRequested(()=>ne.cancel()),W.onCancellationRequested(()=>ne.cancel()),ne.token}class s{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new b.$Sc,this.promise=new Promise((ne,ye)=>{this.f=ne,this.g=ye}),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function n(G,W){const ne=new s(W);return ne.registerDisposable(G.onControlMessage(ye=>{const de=JSON.parse(ye.toString()),ge=J(de);ge?ne.reject(ge):ne.resolve(de)})),ne.promise}function c(G,W,ne,ye,de,ge,_,te){const K=new s(te),ie=y.$Rd.create(!1);return G.info(`Creating a socket (${_})...`),$.mark(`code/willCreateSocket/${ge}`),W.connect(ne,ye,de,_).then(fe=>{K.didTimeout?($.mark(`code/didCreateSocketError/${ge}`),G.info(`Creating a socket (${_}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):($.mark(`code/didCreateSocketOK/${ge}`),G.info(`Creating a socket (${_}) was successful after ${ie.elapsed()} ms.`),K.resolve(fe))},fe=>{$.mark(`code/didCreateSocketError/${ge}`),G.info(`Creating a socket (${_}) returned an error after ${ie.elapsed()} ms.`),G.error(fe),K.reject(fe)}),K.promise}function t(G,W){const ne=new s(W);return G.then(ye=>{ne.didTimeout||ne.resolve(ye)},ye=>{ne.didTimeout||ne.reject(ye)}),ne.promise}async function a(G,W,ne,ye){const de=be(G,W);G.logService.trace(`${de} 1/6. invoking socketFactory.connect().`);let ge;try{ge=await c(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,p.$cl)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,f(W),`renderer-${f(W)}-${G.reconnectionToken}`,ye)}catch(fe){throw G.logService.error(`${de} socketFactory.connect() failed or timed out. Error:`),G.logService.error(fe),fe}G.logService.trace(`${de} 2/6. socketFactory.connect() was successful.`);let _,te;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(ge,null),_=G.reconnectionProtocol,te=!1):(_=new C.$Th({socket:ge}),te=!0),G.logService.trace(`${de} 3/6. sending AuthRequest control message.`);const K=await t(G.signService.createNewMessage((0,L.$qg)()),ye),ie={type:"auth",auth:G.connectionToken||"00000000000000000000",data:K.data};_.sendControl(T.$je.fromString(JSON.stringify(ie)));try{const fe=await n(_,i(ye,o(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(G.logService.trace(`${de} 4/6. received SignRequest control message.`),!await t(G.signService.validate(K,fe.signedData),ye)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const Pe=await t(G.signService.sign(fe.data),ye),we={type:"connectionType",commit:G.commit,signedData:Pe,desiredConnectionType:W};return ne&&(we.args=ne),G.logService.trace(`${de} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(T.$je.fromString(JSON.stringify(we))),{protocol:_,ownsProtocol:te}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(G.logService.error(`${de} the handshake timed out. Error:`),G.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${de} received error control message when negotiating connection. Error:`),G.logService.error(fe)),te&&Z(_),fe}}async function r(G,W,ne,ye){const de=Date.now(),ge=be(G,W),{protocol:_,ownsProtocol:te}=await a(G,W,ne,ye),K=new s(ye);return K.registerDisposable(_.onControlMessage(ie=>{const fe=JSON.parse(ie.toString()),pe=J(fe);pe?(G.logService.error(`${ge} received error control message when negotiating connection. Error:`),G.logService.error(pe),te&&Z(_),K.reject(pe)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${ge} 6/6. handshake finished, connection is up and running after ${ce(de)}!`),K.resolve({protocol:_,firstMessage:fe}))})),K.promise}async function h(G,W){const{protocol:ne}=await r(G,1,void 0,W);return{protocol:ne}}async function u(G,W,ne){const{protocol:ye,firstMessage:de}=await r(G,2,W,ne),ge=de&&de.debugPort;return{protocol:ye,debugPort:ge}}async function l(G,W,ne){const ye=Date.now(),de=be(G,3),{protocol:ge}=await a(G,3,W,ne);return G.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${ce(ye)}!`),ge}async function k(G,W,ne){const{connectTo:ye,connectionToken:de}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:ye,connectionToken:de,reconnectionToken:W,reconnectionProtocol:ne,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function A(G,W,ne){return w(G,async ye=>{const{protocol:de}=await h(ye,g.CancellationToken.None);return new Q(G,W,ne,ye.reconnectionToken,de)})}e.$jl=A;async function v(G,W){return w(G,async ne=>{const{protocol:ye,debugPort:de}=await u(ne,W,g.CancellationToken.None);return new ue(G,W,ne.reconnectionToken,ye,de)})}e.$kl=v;async function w(G,W){for(let ye=1;;ye++)try{const de=(0,L.$qg)(),ge=await k(G,de,null);return await W(ge)}catch(de){if(ye<5)G.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(de);else throw G.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(de),U.triggerPermanentFailure(0,0,m.$$k.isHandled(de)),de}}async function E(G,W,ne){const ye=await k(G,(0,L.$qg)(),null);return await l(ye,{host:W,port:ne},g.CancellationToken.None)}e.$ll=E;function P(G){return(0,D.$Tg)(W=>new Promise((ne,ye)=>{const de=setTimeout(ne,G*1e3);W.onCancellationRequested(()=>{clearTimeout(de),ne()})}))}var N;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class z{constructor(W,ne){this.reconnectionToken=W,this.millisSinceLastIncomingData=ne,this.type=0}}e.$ml=z;class F{constructor(W,ne,ye,de){this.reconnectionToken=W,this.millisSinceLastIncomingData=ne,this.durationSeconds=ye,this.c=de,this.type=1}skipWait(){this.c.cancel()}}e.$nl=F;class j{constructor(W,ne,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=2}}e.$ol=j;class M{constructor(W,ne,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=4}}e.$pl=M;class O{constructor(W,ne,ye,de){this.reconnectionToken=W,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.handled=de,this.type=3}}e.$ql=O;class U extends b.$Tc{static triggerPermanentFailure(W,ne,ye){this._permanentFailure=!0,this.f=W,this.g=ne,this.h=ye,this.j.forEach(de=>de.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(W=>W.y())}static debugPauseSocketWriting(){this.j.forEach(W=>W.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(W,ne,ye,de,ge){super(),this.t=W,this.u=ne,this.reconnectionToken=ye,this.protocol=de,this.w=ge,this.m=this.B(new R.$Vd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(de.onSocketClose(_=>{const te=x(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${te} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${te} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${te} received socket close event.`),this.y()})),this.B(de.onSocketTimeout(_=>{const te=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,b.$Rc)(()=>{const _=U.j.indexOf(this);_>=0&&U.j.splice(_,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const W=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const de=ye<ne.length?ne[ye]:ne[ne.length-1];try{if(de>0){const _=P(de);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de,_)),this.u.logService.info(`${W} waiting for ${de} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${W} resolving connection...`);const ge=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${W} connecting to ${ge.connectTo}...`),await this.G(ge,o(S)),this.u.logService.info(`${W} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(ge){if(ge.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(m.$$k.isTemporarilyNotAvailable(ge)){this.u.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((ge.code==="ETIMEDOUT"||ge.code==="ENETUNREACH"||ge.code==="ECONNREFUSED"||ge.code==="ECONNRESET")&&ge.syscall==="connect"){this.u.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((0,I.$4)(ge)){this.u.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if(ge instanceof m.$$k){this.u.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,m.$$k.isHandled(ge));break}this.u.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(W,ne,ye){this.w?U.triggerPermanentFailure(W,ne,ye):this.D(W,ne,ye)}D(W,ne,ye){this.m.fire(new O(this.reconnectionToken,W,ne,ye)),Z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$rl=U;class Q extends U{constructor(W,ne,ye,de,ge){super(1,W,de,ge,!0),this.client=this.B(new C.$Rh(ge,{remoteAuthority:ne,clientId:ye},W.ipcLogger))}async G(W,ne){await h(W,ne)}}e.$sl=Q;class ue extends U{constructor(W,ne,ye,de,ge){super(2,W,ye,de,!1),this.H=ne,this.debugPort=ge}async G(W,ne){await u(W,this.H,ne)}}e.$tl=ue;function Z(G){try{G.acceptDisconnect();const W=G.getSocket();G.dispose(),W.dispose()}catch(W){(0,I.$1)(W)}}function J(G){if(G&&G.type==="error"){const W=new Error(`Connection error: ${G.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function X(G,W){for(;G.length<W;)G+=" ";return G}function le(G,W){return`[remote-connection][${X(f(G),13)}][${W.substr(0,5)}\u2026]`}function x(G,W,ne){return`${le(G,W)}[${ne?"reconnect":"initial"}]`}function be(G,W){return`${x(W,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function ce(G){return`${Date.now()-G} ms`}}),define(ke[257],Se([1,0,3,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=void 0,e.$fl=(0,T.$6h)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(R,b){return this.a[R]??=[],this.a[R].push(b),(0,D.$Rc)(()=>{const $=this.a[R]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[R]?.splice($,1)})}b(R){return(this.a[R.type]||[]).find($=>$.supports(R))}connect(R,b,$,y){const L=this.b(R);if(!L)throw new Error(`No socket factory found for ${R}`);return L.connect(R,b,$,y)}}e.$gl=g}),define(ke[258],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const I=await this.c();if(I){const R=String(D.a++);return this.b.set(R,I),{id:R,data:I.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,I){if(!g.id)return!0;const R=this.b.get(g.id);if(!R)return!1;this.b.delete(g.id);try{return R.validate(I)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$t7b=D}),define(ke[109],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=void 0,e.$hl="signService",e.$il=(0,D.$6h)(e.$hl)}),define(ke[138],Se([1,0,258]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o_b=void 0;class T extends D.$t7b{c(){return this.h().then(I=>new I.validator)}d(I){return this.h().then(R=>new R.signer().sign(I))}h(){return new Promise((I,R)=>me(["vsda"],I,R))}}e.$o_b=T}),define(ke[259],Se([1,0,10,49,30]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=void 0;function I($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,y,L,C,m,p,S,d,f){const o=Object.create(null);o["common.machineId"]=p,o["common.sqmId"]=S,o.sessionID=(0,g.$qg)()+Date.now(),o.commitHash=C,o.version=m,o["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,D.$h)(D.$u),o["common.nodePlatform"]=T.$dc,o["common.nodeArch"]=L,o["common.product"]=f||"desktop",d&&(o["common.msftInternal"]=d);let i=0;const s=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(o["common.snap"]="true");const n=I(y);return n&&(o["common.platformDetail"]=n),o}e.$Jo=R;function b($){const y=T.env.USERDNSDOMAIN;if(!y)return!1;const L=y.toLowerCase();return $.some(C=>L===C)}e.$Ko=b}),define(ke[260],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,D.$6h)("telemetryService"),e.$vl=(0,D.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var T;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var g;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(ke[88],Se([1,0,24,18,65,259,260]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;class b{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$Lo=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Mo=$,e.$No=new $;class y{async publicLog(a,r,h){}async publicLogError(a,r,h){}}e.$Oo=y,e.$Po="telemetry",e.$Qo="extensionTelemetryLog",e.$Ro={log:()=>null,flush:()=>Promise.resolve(null)};function L(t,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!t.enableTelemetry)}e.$So=L;function C(t,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$To=C;function m(t){const a=t.getValue(R.$Cl),r=t.getValue(R.$Dl);if(t.getValue(R.$El)===!1||r===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=m;function p(t){const a={},r={},h={};f(t,h);for(let u in h){u=u.length>150?u.substr(u.length-149):u;const l=h[u];typeof l=="number"?r[u]=l:typeof l=="boolean"?r[u]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${l.length}`),a[u]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(a[u]=l)}return{properties:a,measurements:r}}e.$Vo=p;const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(t){if(!t)return"none";const a=(0,g.$bl)(t);return S.has(a)?a:"other"}e.$Wo=d;function f(t,a,r=0,h){if(t)for(const u of Object.getOwnPropertyNames(t)){const l=t[u],k=h?h+u:u;Array.isArray(l)?a[k]=(0,D.$An)(l):l instanceof Date?a[k]=l.toISOString():(0,T.$Kf)(l)?r<2?f(l,a,r+1,k+"."):a[k]=(0,D.$An)(l):a[k]=l}}function o(t,a){const r=t.msftInternalDomains||[],h=a.getValue("telemetry.internalTesting");return(0,I.$Ko)(r)||h}e.$Xo=o;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Yo=i;function s(t,a){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const h=[];for(const A of a)for(;;){const v=A.exec(t);if(!v)break;h.push([v.index,A.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(r="";;){const A=l.exec(t);if(!A)break;const v=h.some(([w,E])=>A.index<E&&w<l.lastIndex);!u.test(A[0])&&!v&&(r+=t.substring(k,A.index)+"<REDACTED: user-file-path>",k=l.lastIndex)}return k<t.length&&(r+=t.substr(k)),r}function n(t){if(!t)return t;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of a)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function c(t,a){return(0,D.$xn)(t,r=>{if(r instanceof b||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let h=r.replaceAll("%20"," ");h=s(h,a);for(const u of a)h=h.replace(u,"");return h=n(h),h}})}e.$Zo=c}),define(ke[261],Se([1,0,12,134,26,10,2,14,49,88]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function L(r,h){return r.uuid&&h.uuid?r.uuid===h.uuid:r.id===h.id?!0:(0,D.$7e)(r.id,h.id)===0}e.$1o=L;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(h){const u=h.manifest?h.manifest.version:h.version,l=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new m(h.identifier,u,l)}static parse(h){const u=C.exec(h);return u&&u[1]&&u[2]?new m({id:u[1]},u[2],u[4]||void 0):null}constructor(h,u,l="undefined"){this.version=u,this.targetPlatform=l,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof m?L(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.$2o=m;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(r){const h=p.exec(r);return h&&h[1]?[f(h[1]),h[2]]:[f(r),void 0]}e.$3o=S;function d(r,h){return`${r}.${h}`}e.$4o=d;function f(r){return r.toLowerCase()}e.$5o=f;function o(r,h){return f(d(r??g.$hm,h))}e.$6o=o;function i(r,h){const u=[],l=k=>{for(const A of u)if(A.some(v=>L(h(v),h(k))))return A;return null};for(const k of r){const A=l(k);A?A.push(k):u.push([k])}return u}e.$7o=i;function s(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$8o=s;function n(r){return{id:new y.$Lo(r.identifier.id),name:new y.$Lo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$9o=n,e.$0o=new g.$lm("pprice.better-merge");function c(r,h){const u=[],l=h.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const k=l.shift();if(k&&u.every(A=>!L(A.identifier,{id:k}))){const A=r.filter(v=>L(v.identifier,{id:k}));A.length===1&&(u.push(A[0]),l.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.$$o=c;async function t(r,h){if(!I.$k)return!1;let u;try{u=(await r.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await r.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){h.debug("Error while getting the os-release file.",(0,b.$0)(k))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(r,h){const u=await t(r,h),l=(0,T.$uo)(u?"alpine":I.$u,$.$ec);return h.debug("ComputeTargetPlatform:",l),l}e.$_o=a}),define(ke[262],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0;function D($){return[...$.entries()]}e.$Mr=D;function T($){return $?[...$.entries()]:[]}e.$Nr=T;function g($){return new Map($)}e.$Or=g;function I($){return new Map($??[])}e.$Pr=I;function R($){return Array.from($.entries()).map(y=>[y[0],D(y[1].map),T(y[1].descriptionMap)])}e.$Qr=R;function b($){return new Map($.map(y=>[y[0],{map:g(y[1]),descriptionMap:I(y[2])}]))}e.$Rr=b}),define(ke[263],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,I,R=5){const b=I($=>{const y=typeof $=="string"?$:$.data;let L=this.a.get(g);if(L){L.data.push(y);return}const C=setTimeout(()=>this.flushBuffer(g),R);L={data:[y],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(g),b.dispose()}},this.a.set(g,L)});return b}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const I=this.a.get(g);I&&(this.a.delete(g),this.b(g,I.data.join("")))}}e.$Prb=D}),define(ke[264],Se([1,0,11,78,61,4,18,2,207,108,37]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.IconFontDefinition=e.IconContribution=e.$ww=void 0,e.$ww={IconContribution:"base.contributions.icons"};var C;(function(n){function c(t,a){let r=t.defaults;for(;g.ThemeIcon.isThemeIcon(r);){const h=S.getIcon(r.id);if(!h)return;r=h.defaults}return r}n.getDefinition=c})(C||(e.IconContribution=C={}));var m;(function(n){function c(a){return{weight:a.weight,style:a.style,src:a.src.map(r=>({format:r.format,location:r.location.toString()}))}}n.toJSONObject=c;function t(a){const r=h=>(0,R.$If)(h)?h:void 0;if(a&&Array.isArray(a.src)&&a.src.every(h=>(0,R.$If)(h.format)&&(0,R.$If)(h.location)))return{weight:r(a.weight),style:r(a.style),src:a.src.map(h=>({format:h.format,location:b.URI.parse(h.location)}))}}n.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class p{constructor(){this.a=new I.$Vd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,t,a,r){const h=this.b[c];if(h){if(a&&!h.description){h.description=a,this.d.properties[c].markdownDescription=`${a} $(${c})`;const k=this.e.enum.indexOf(c);k!==-1&&(this.e.enumDescriptions[k]=a),this.a.fire()}return h}const u={id:c,description:a,defaults:t,deprecationMessage:r};this.b[c]=u;const l={$ref:"#/definitions/icons"};return r&&(l.deprecationMessage=r),a&&(l.markdownDescription=`${a}: $(${c})`),this.d.properties[c]=l,this.e.enum.push(c),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const t=this.e.enum.indexOf(c);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,t){const a=this.f[c];return a||(this.f[c]=t,this.a.fire(),t)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=(h,u)=>h.id.localeCompare(u.id),t=h=>{for(;g.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(h=>this.b[h]);for(const h of r.filter(u=>!!u.description).sort(c))a.push(`|<i class="${t(h)}"></i>|${h.id}|${g.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const h of r.filter(u=>!g.ThemeIcon.isThemeIcon(u.defaults)).sort(c))a.push(`|<i class="${t(h)}"></i>|${h.id}|`);return a.join(`
`)}}const S=new p;L.$Hn.add(e.$ww.IconContribution,S);function d(n,c,t,a){return S.registerIcon(n,c,t,a)}e.$xw=d;function f(){return S}e.$yw=f;function o(){const n=(0,T.$0j)();for(const c in n){const t="\\"+n[c].toString(16);S.registerIcon(c,{fontCharacter:t})}}o(),e.$zw="vscode://schemas/icons";const i=L.$Hn.as(y.$In.JSONContribution);i.registerSchema(e.$zw,S.getIconSchema());const s=new D.$fh(()=>i.notifySchemaChanged(e.$zw),200);S.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$Aw=d("widget-close",T.$_j.close,(0,$.localize)(2,null)),e.$Bw=d("goto-previous-location",T.$_j.arrowUp,(0,$.localize)(3,null)),e.$Cw=d("goto-next-location",T.$_j.arrowDown,(0,$.localize)(4,null)),e.$Dw=g.ThemeIcon.modify(T.$_j.sync,"spin"),e.$Ew=g.ThemeIcon.modify(T.$_j.loading,"spin")}),define(ke[89],Se([1,0,4,51,5,13]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProvidedOnAutoForward=e.$Cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bv=e.$Av=void 0,e.$Av=(0,g.$6h)("tunnelService"),e.$Bv=(0,g.$6h)("sharedTunnelsService");var R;(function(f){f.Http="http",f.Https="https"})(R||(e.TunnelProtocol=R={}));var b;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(b||(e.TunnelPrivacyId=b={}));function $(f){return!!f.forwardPort}e.$Cv=$;var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function L(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(o)return{address:o[1],port:+o[2]}}e.$Dv=L,e.$Ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(f){return e.$Ev.indexOf(f)>=0}e.$Fv=C,e.$Gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$Gv.indexOf(f)>=0}e.$Hv=m;function p(f,o,i,s){if(i===1)return!1;if(i===2&&m(o)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(n?.length===4&&parseInt(n[1])>=18)return!1}return f<1024}e.$Iv=p;class S{constructor(o,i,s){this.remoteAddress=o,this.localAddress=i,this.b=s,this.a=new D.$Vd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jv=S;let d=class{constructor(o,i){this.k=o,this.l=i,this.a=new D.$Vd,this.onTunnelOpened=this.a.event,this.b=new D.$Vd,this.onTunnelClosed=this.b.event,this.c=new D.$Vd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const o=this.l.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.i=o.privacyOptions,this.h=o.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const o=[],i=Array.from(this.e.values());for(const s of i){const n=Array.from(s.values());for(const c of n){const t=await c.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(s=>typeof s!="string"?s?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,s,n,c){this.q(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:s,privacy:n,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){(m(o)||C(o))&&(o=e.$Ev[0]);const s=this.s(o,i);if(s)return++s.refcount,s.value}openTunnel(o,i,s,n,c,t=!1,a,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${s} on local port ${c}.`);const h=this.f??o;if(!h)return;if(i||(i="localhost"),n||(n=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.t(h,i,s,n,c,t,a,r);return u?u.then(l=>{if(l){if(typeof l=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,s),l}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.o(l);return(l.tunnelRemoteHost!==i||l.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&l.privacy!==a&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}o(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const s=i.get(o.tunnelRemotePort);s&&(s.refcount--,await this.p(o.tunnelRemoteHost,o.tunnelRemotePort,s))}}}}async p(o,i,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const n=s.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),n}}async closeTunnel(o,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const s=this.e.get(o);if(s&&s.has(i)){const n=s.get(i);n.refcount=0,await this.p(o,i,n)}}q(o,i,s){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:s})}async r(o,i){const s=this.e.get(o);if(s){const n=s.get(i),c=n?await n.value:void 0;(!c||typeof c=="string")&&s.delete(i),s.size===0&&this.e.delete(o)}}s(o,i){const s=[o];C(o)?(s.push(...e.$Ev),s.push(...e.$Gv)):m(o)&&s.push(...e.$Gv);const n=s.map(c=>this.e.get(c));for(const c of n){const t=c?.get(i);if(t)return t}}canTunnel(o){return!!L(o)}u(o,i,s,n,c,t,a){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${s} on local port ${n}.`);const r=s;this.j.add(r);const h=n===void 0?s:n,u={elevationRequired:c?this.isPortPrivileged(h):!1},l={remoteAddress:{host:i,port:s},localAddressPort:n,privacy:t,public:t?t!==b.Private:void 0,protocol:a},k=o.forwardPort(l,u);return k?(this.q(i,s,k),k.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),k}};e.$Kv=d,e.$Kv=d=Ge([Ve(0,I.$nj),Ve(1,T.$zi)],d)}),define(ke[265],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=void 0,e.$1k=(0,D.$6h)("IUriIdentityService")}),define(ke[266],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Lv=void 0,e.$Lv=(0,D.$6h)("editSessionIdentityService");var T;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(ke[267],Se([1,0,16]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=void 0;function T($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$GK=T;function g($){if($.folders.length)return $.folders.every(y=>T(y.uri))?$.folders[0].uri:void 0;if($.configuration&&T($.configuration))return $.configuration}e.$HK=g;function I($){return g($)?.scheme}e.$IK=I;function R($){return g($)?.authority}e.$JK=R;function b($){return g($)!==void 0}e.$KK=b}),define(ke[40],Se([1,0,209,17,77,23,2,5,16]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,b.$6h)("contextService");function y(h){const u=h;return typeof u?.id=="string"&&R.URI.isUri(u.uri)}e.$di=y;function L(h){return typeof h?.id=="string"&&!y(h)&&!m(h)}e.$ei=L,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function C(h,u){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,T.$nc)(h)}:u?e.$fi:e.$gi;const l=h;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$hi=C;function m(h){const u=h;return typeof u?.id=="string"&&R.URI.isUri(u.configPath)}e.$ii=m;function p(h){const u=h;if(u?.uri)return{id:u.id,uri:R.URI.revive(u.uri)};const l=h;if(l?.configPath)return{id:l.id,configPath:R.URI.revive(l.configPath)};if(h?.id)return{id:h.id}}e.$ji=p;var S;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function d(h){const u=h;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.$ki=d;function f(h){const u=h;return!!(u&&typeof u=="object"&&R.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.$li=f;class o{constructor(u,l,k,A,v){this.h=u,this.j=k,this.k=A,this.l=v,this.c=g.$_h.forUris(this.l,()=>!0),this.folders=l}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=g.$_h.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=o;class i{constructor(u,l){this.raw=l,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,I.$Hg)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=i;function s(h){return new i({uri:h,index:0,name:(0,I.$Dg)(h)},{uri:h.toString()})}e.$oi=s,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,D.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function n(h,u){return I.$yg.isEqualOrParent(h,u.untitledWorkspacesHome)}e.$ti=n;function c(h){let u;return R.URI.isUri(h)?u=h:u=h.configuration,u?.scheme===$.Schemas.tmp}e.$ui=c,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(h){return h.id===e.$vi}e.$wi=t;function a(h,u){return!n(h,u)&&!c(h)}e.$xi=a;function r(h){return(typeof h=="string"?(0,T.$oc)(h):(0,I.$Fg)(h))===e.$qi}e.$yi=r}),define(ke[268],Se([1,0,54,4,3,23,2,208,133,32,5,13,40,28,265,11,30,12,18]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.ProfileResourceType=void 0;var s;(function(h){h.Settings="settings",h.Keybindings="keybindings",h.Snippets="snippets",h.Tasks="tasks",h.Extensions="extensions",h.GlobalState="globalState"})(s||(e.ProfileResourceType=s={}));function n(h){const u=h;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&R.URI.isUri(u.location)&&R.URI.isUri(u.globalStorageHome)&&R.URI.isUri(u.settingsResource)&&R.URI.isUri(u.keybindingsResource)&&R.URI.isUri(u.tasksResource)&&R.URI.isUri(u.snippetsHome)&&R.URI.isUri(u.extensionsResource))}e.$2k=n,e.$3k=(0,L.$6h)("IUserDataProfilesService");function c(h,u){return{id:h.id,isDefault:h.isDefault,name:h.name,shortName:h.shortName,icon:h.icon,location:R.URI.revive(h.location).with({scheme:u}),globalStorageHome:R.URI.revive(h.globalStorageHome).with({scheme:u}),settingsResource:R.URI.revive(h.settingsResource).with({scheme:u}),keybindingsResource:R.URI.revive(h.keybindingsResource).with({scheme:u}),tasksResource:R.URI.revive(h.tasksResource).with({scheme:u}),snippetsHome:R.URI.revive(h.snippetsHome).with({scheme:u}),extensionsResource:R.URI.revive(h.extensionsResource).with({scheme:u}),cacheHome:R.URI.revive(h.cacheHome).with({scheme:u}),useDefaultFlags:h.useDefaultFlags,isTransient:h.isTransient}}e.$4k=c;function t(h,u,l,k,A,v){return{id:h,name:u,location:l,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:v&&A?.useDefaultFlags?.globalState?v.globalStorageHome:(0,I.$Hg)(l,"globalStorage"),settingsResource:v&&A?.useDefaultFlags?.settings?v.settingsResource:(0,I.$Hg)(l,"settings.json"),keybindingsResource:v&&A?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,I.$Hg)(l,"keybindings.json"),tasksResource:v&&A?.useDefaultFlags?.tasks?v.tasksResource:(0,I.$Hg)(l,"tasks.json"),snippetsHome:v&&A?.useDefaultFlags?.snippets?v.snippetsHome:(0,I.$Hg)(l,"snippets"),extensionsResource:v&&A?.useDefaultFlags?.extensions?v.extensionsResource:(0,I.$Hg)(l,"extensions.json"),cacheHome:(0,I.$Hg)(k,h),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$5k=t;let a=class extends g.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,l,k,A){super(),this.t=u,this.u=l,this.w=k,this.y=A,this.f=!0,this.h=this.B(new T.$Vd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Vd),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Vd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Vd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new p.$Ac,emptyWindows:new Map},this.profilesHome=(0,I.$Hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$Hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),l=[u];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,i.$If)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}l.push(t((0,I.$Eg)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},u))}}catch(v){this.y.error(v)}const k=new p.$Ac,A=new Map;if(l.length)try{const v=this.Q();if(v.workspaces)for(const[w,E]of Object.entries(v.workspaces)){const P=R.URI.parse(w),N=l.find(z=>z.id===E);N&&k.set(P,N)}if(v.emptyWindows)for(const[w,E]of Object.entries(v.emptyWindows)){const P=l.find(N=>N.id===E);P&&A.set(w,P)}}catch(v){this.y.error(v)}this.z={profiles:l,workspaces:k,emptyWindows:A}}return this.z}D(){const u=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const l="Temp",k=new RegExp(`${(0,o.$Oe)(l)}\\s(\\d+)`);let A=0;for(const w of this.profiles){const E=k.exec(w.name),P=E?parseInt(E[1]):0;A=P>A?P:A}const v=`${l} ${A+1}`;return this.createProfile((0,D.$Ti)((0,f.$qg)()).toString(16),v,{transient:!0},u)}async createNamedProfile(u,l,k){return this.createProfile((0,D.$Ti)((0,f.$qg)()).toString(16),u,l,k)}async createProfile(u,l,k,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(u,l,k);return A&&await this.setProfileForWorkspace(A,v),v}async F(u,l,k){if(!(0,i.$If)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(l);return A||(A=(async()=>{try{const v=this.profiles.find(P=>P.name===l||P.id===u);if(v)return v;const w=t(u,l,(0,I.$Hg)(this.profilesHome,u),this.g,k,this.defaultProfile);await this.u.createFolder(w.location);const E=[];return this.j.fire({profile:w,join(P){E.push(P)}}),await d.Promises.settled(E),this.I([w],[],[]),w}finally{this.r.delete(l)}})(),this.r.set(l,A)),A}async updateProfile(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(A=>A.id===u.id);if(!k)throw new Error(`Profile '${u.name}' does not exist`);return k=t(k.id,l.name??k.name,k.location,this.g,{shortName:l.shortName??k.shortName,icon:l.icon===null?void 0:l.icon??k.icon,transient:l.transient??k.isTransient,useDefaultFlags:l.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(A=>A.id===u.id);if(!l)throw new Error(`Profile '${u.name}' does not exist`);const k=[];this.m.fire({profile:l,join(A){k.push(A)}});try{await Promise.allSettled(k)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(A){(0,y.$Hk)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(A=>A.id===l.id);if(!k)throw new Error(`Profile '${l.name}' does not exist`);this.L(u,k)}unsetWorkspace(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(l=>l.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(u.map(l=>this.removeProfile(l)))}getProfileForWorkspace(u){const l=this.G(u);return R.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(u){return(0,m.$di)(u)?u.uri:(0,m.$ii)(u)?u.configPath:u.id}H(u){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,u.location)))}I(u,l,k){const A=[...this.profiles,...u],v=[];this.s.profiles=[];for(let w of A)w.isDefault||l.some(E=>w.id===E.id)||(w=k.find(E=>w.id===E.id)??w,w.isTransient?this.s.profiles.push(w):v.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(v),this.z=void 0,this.J(u,l,k)}J(u,l,k){this.h.fire({added:u,removed:l,updated:k,all:this.profiles})}L(u,l,k){k=l?.isTransient?!0:k,k||this.L(u,void 0,!0);const A=this.G(u),v=k?this.s:this.C;R.URI.isUri(A)?(v.workspaces.delete(A),l&&v.workspaces.set(A,l)):(v.emptyWindows.delete(A),l&&v.emptyWindows.set(A,l)),k||this.M()}M(){const u={};for(const[k,A]of this.C.workspaces.entries())u[k.toString()]=A.id;const l={};for(const[k,A]of this.C.emptyWindows.entries())l[k.toString()]=A.id;this.R({workspaces:u,emptyWindows:l}),this.z=void 0}N(u){const l={},k=this.D();if(u.workspaces)for(const[v,w]of Object.entries(u.workspaces)){const E=R.URI.parse(w);l[v]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}const A={};if(u.emptyWindows)for(const[v,w]of Object.entries(u.emptyWindows)){const E=R.URI.parse(w);A[v]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}return{workspaces:l,emptyWindows:A}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$6k=a,e.$6k=a=Ge([Ve(0,$.$ai),Ve(1,y.$qk),Ve(2,S.$1k),Ve(3,C.$nj)],a);class r extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$7k=r}),define(ke[269],Se([1,0,11,4,3,57,18,188,5,268]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$up=e.$tp=e.$sp=void 0,e.$sp="__$__isNewStorageMarker",e.$tp="__$__targetStorageMarker",e.$up=(0,$.$6h)("storageService");var L;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function p(i){const s=i.get(e.$tp);if(s)try{return JSON.parse(s)}catch{}return Object.create(null)}e.$vp=p;class S extends g.$Tc{static{this.a=60*1e3}constructor(s={flushInterval:S.a}){super(),this.m=s,this.b=this.B(new T.$Yd),this.c=this.B(new T.$Yd),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Vd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$fh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(s,n,c){return T.Event.filter(this.b.event,t=>t.scope===s&&(n===void 0||t.key===n),c)}n(){this.j.value=(0,D.$jh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(s,n){const{key:c,external:t}=n;if(c===e.$tp){switch(s){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:s})}else this.b.fire({scope:s,key:c,target:this.J(s)[c],external:t})}w(s){this.f.fire({reason:s})}get(s,n,c){return this.P(n)?.get(s,c)}getBoolean(s,n,c){return this.P(n)?.getBoolean(s,c)}getNumber(s,n,c){return this.P(n)?.getNumber(s,c)}getObject(s,n,c){return this.P(n)?.getObject(s,c)}storeAll(s,n){this.y(()=>{for(const c of s)this.store(c.key,c.value,c.scope,c.target,n)})}store(s,n,c,t,a=!1){if((0,R.$Rf)(n)){this.remove(s,c,a);return}this.y(()=>{this.z(s,c,t),this.P(c)?.set(s,n,a)})}remove(s,n,c=!1){this.y(()=>{this.z(s,n,void 0),this.P(n)?.delete(s,c)})}y(s){this.b.pause(),this.c.pause();try{s()}finally{this.b.resume(),this.c.resume()}}keys(s,n){const c=[],t=this.J(s);for(const a of Object.keys(t))t[a]===n&&c.push(a);return c}z(s,n,c,t=!1){const a=this.J(n);typeof c=="number"?a[s]!==c&&(a[s]=c,this.P(n)?.set(e.$tp,JSON.stringify(a),t)):typeof a[s]=="number"&&(delete a[s],this.P(n)?.set(e.$tp,JSON.stringify(a),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(s){switch(s){case-1:return this.I;case 0:return this.G;default:return this.D}}L(s){const n=this.P(s);return n?p(n):Object.create(null)}isNew(s){return this.getBoolean(e.$sp,s)===!0}async flush(s=L.NONE){this.f.fire({reason:s});const n=this.P(-1),c=this.P(0),t=this.P(1);switch(s){case L.NONE:await D.Promises.settled([n?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await D.Promises.settled([n?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const s=this.P(-1)?.items??new Map,n=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return o(s,n,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(s){return await this.flush(),this.P(s)?.optimize()}async switch(s,n){return this.w(L.NONE),(0,y.$2k)(s)?this.R(s,n):this.S(s,n)}M(s,n){return!(s.id===n.id||d(n)&&d(s))}N(s,n,c){this.y(()=>{const t=new Set;for(const[a,r]of s)t.add(a),n.get(a)!==r&&this.u(c,{key:a,external:!0});for(const[a]of n.items)t.has(a)||this.u(c,{key:a,external:!0})})}}e.$wp=S;function d(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$xp=d;class f extends S{constructor(){super(),this.U=this.B(new b.$qp(new b.$rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$qp(new b.$rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$qp(new b.$rp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(s=>this.u(1,s))),this.B(this.W.onDidChangeStorage(s=>this.u(0,s))),this.B(this.U.onDidChangeStorage(s=>this.u(-1,s)))}P(s){switch(s){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(s){switch(s){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(s){return!1}}e.$yp=f;async function o(i,s,n,c,t,a){const r=P=>{try{return JSON.parse(P)}catch{return P}},h=new Map,u=new Map;i.forEach((P,N)=>{h.set(N,P),u.set(N,r(P))});const l=new Map,k=new Map;s.forEach((P,N)=>{l.set(N,P),k.set(N,r(P))});const A=new Map,v=new Map;n.forEach((P,N)=>{A.set(N,P),v.set(N,r(P))}),console.group(c!==t?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const w=[];if(h.forEach((P,N)=>{w.push({key:N,value:P})}),console.table(w),console.groupEnd(),console.log(u),c!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];l.forEach((N,z)=>{P.push({key:z,value:N})}),console.table(P),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${a})`);const E=[];A.forEach((P,N)=>{E.push({key:N,value:P})}),console.table(E),console.groupEnd(),console.log(v)}e.$zp=o}),define(ke[110],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const I=this.c++;return this.b.set(I,g),this.e(),I}get(g,I){return this.b.has(g)?this.b.get(g)[I]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$kgc=D}),define(ke[58],Se([1,0,16,23,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=void 0;class I{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new T.$wg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$ngc=I,e.$ogc=(0,g.$6h)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0,e.$rN=(0,D.$6h)("IExtHostInitDataService")}),define(ke[270],Se([1,0,214,13,250,27]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0;let R=class extends g.$yO{constructor($,y,L){const C=L.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=L.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(C,{name:m}))}};e.$uic=R,e.$uic=R=Ge([Ve(1,T.$oj),Ve(2,I.$rN)],R)}),define(ke[271],Se([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=void 0;class T{constructor(R,b,$){this.h=new Map,this.a=R,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$fh(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of y.values())L.complete()}catch(L){for(const C of y.values())C.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,b){let $=this.f[R];return typeof $>"u"&&($=b),$}update(R,b){this.f[R]=b;const $=this.h.get(R);if($!==void 0)return $.p;const y=new D.$qh;return this.h.set(R,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$9gc=T;class g extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,b){super(R.identifier.value,!0,b),this.j=R}}e.$0gc=g}),define(ke[272],Se([1,0,4,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;class g{constructor(R){this.c=R,this.a=new D.$Vd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Vd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,b,$,y){const C=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged(b.value,$,y);this.b.fire(C)}$acceptDirtyStateChanged(R,b){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty(b)}$acceptModelSaved(R){const b=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire(b.apiNotebook)}}e.$Whc=g}),define(ke[20],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=void 0,e.$bN=(0,D.$6h)("IExtHostRpcService");class T{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$cN=T}),define(ke[273],Se([1,0,26,4]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class g{#e;constructor(R,b){this.b=new T.$Vd,this.onDidChange=this.b.event,this.a=D.$lm.toKey(R.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(R){return this.#e.get(this.a,R)}store(R,b){return this.#e.store(this.a,R,b)}delete(R){return this.#e.delete(this.a,R)}}e.$ehc=g}),define(ke[66],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=e.$Ggc=void 0,e.$Ggc=(0,D.$6h)("IURITransformerService");class T{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Hgc=T}),define(ke[274],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilb=e.$hlb=void 0;class T{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function g(b,$){if($.serializeBuffersForPostMessage){const y=new T,C=JSON.stringify(b,(p,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S)};if(ArrayBuffer.isView(S)){const d=I(S);if(d)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S.buffer),view:{type:d,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),m=y.buffers.map(p=>{const S=new Uint8Array(p);return D.$je.wrap(S)});return{message:C,buffers:m}}else return{message:JSON.stringify(b),buffers:[]}}e.$hlb=g;function I(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(b,$){const y=$.map(m=>{const p=new ArrayBuffer(m.byteLength);return new Uint8Array(p).set(m.buffer),p}),L=$.length?(m,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const S=p,{index:d}=S,f=y[d];if(S.view)switch(S.view.type){case 1:return new Int8Array(f,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return p}:void 0;return{message:JSON.parse(b,L),arrayBuffers:y}}e.$ilb=R}),define(ke[275],Se([1,0,276,388,389,62,2,13,390]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;const y=!1;function L(s,n,c,t,a,r){const h=r.environment.useHostProxy,u=typeof h=="boolean"?h:!r.remote.isRemote,l={resolveProxy:v=>s.resolveProxy(v),lookupProxyAuthorization:f.bind(void 0,t,a,n,{},r.remote.isRemote),getProxyURL:()=>n.getConfiguration("http").get("proxy"),getProxySupport:()=>n.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(n),addCertificatesV2:()=>p(n),log:t,getLogLevel:()=>{const v=t.getLevel();switch(v){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return w(v)}function w(E){return t.error("Unknown log level",E),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:u,loadAdditionalCertificates:async()=>{const v=[];if(r.remote.isRemote&&v.push((0,$.loadSystemCertificates)({log:t})),u){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const w=s.loadCertificates();w.then(E=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),v.push(w)}return(await Promise.all(v)).flat()},env:process.env},k=(0,$.createProxyResolver)(l),A=C(l,k);return d(c,A)}e.$3ic=L;function C(s,n){return{http:Object.assign(D,(0,$.createHttpPatch)(s,D,n)),https:Object.assign(T,(0,$.createHttpPatch)(s,T,n)),net:Object.assign(I,(0,$.createNetPatch)(s,I)),tls:Object.assign(g,(0,$.createTlsPatch)(s,g))}}function m(s){const n=s.getConfiguration("http");return!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}function p(s){const n=s.getConfiguration("http");return!!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}const S=new Map;function d(s,n){return s.getExtensionPathIndex().then(c=>{const t=globalThis._VSCODE_NODE_MODULES.module,a=t._load;t._load=function(h,u,l){if(h==="net")return n.net;if(h==="tls")return n.tls;if(h!=="http"&&h!=="https")return a.apply(this,arguments);const k=c.findSubstr(R.URI.file(u.filename));let A=S.get(k);if(A||S.set(k,A={}),!A[h]){const v=n[h];A[h]={...v}}return A[h]}})}async function f(s,n,c,t,a,r,h,u){const l=t[r];h&&(t[r]=h),s.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${h}`,`proxyAuthenticateCache:${l}`);const k=h||l,A=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(i(n,A,a),A.some(v=>/^(Negotiate|Kerberos)( |$)/i.test(v))&&!u.kerberosRequested)try{u.kerberosRequested=!0;const v=await new Promise((z,F)=>{me(["kerberos"],z,F)}),w=new URL(r),E=c.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${w.hostname}`:`HTTP@${w.hostname}`);return s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${E}`),"Negotiate "+await(await v.initializeClient(E)).step("")}catch(v){s.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",v)}}let o=!1;function i(s,n,c){o||!n.length||(o=!0,s.$publicLog2("proxyAuthenticationRequest",{authenticationType:n.map(t=>t.split(" ")[0]).join(","),extensionHostType:c?"remote":"local"}))}}),define(ke[277],Se([1,0,130]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;function T(I){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:I,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function g(I){return new D.$4m(T(I))}e.$3r=g}),define(ke[139],Se([1,0,224,18,2,3,5,37,32,16,44,180,39]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=e.$4E=e.$3E=e.EditorsOrder=e.$2E=e.CloseDirection=e.$1E=e.$ZE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.EditorInputCapabilities=e.$QE=e.SaveReason=e.Verbosity=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=void 0,e.$DE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$EE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$FE="workbench.editor.sidebysideEditor",e.$GE="workbench.editors.textDiffEditor",e.$HE="workbench.editors.binaryResourceDiffEditor";var p;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var S;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function d(ce){const G=ce;return!!G&&typeof G.getSelection=="function"&&!!G.onDidChangeSelection}e.$IE=d;function f(ce,G,W){for(const ne of W.visibleEditorPanes)if(ne.group.id===G&&ce.matches(ne.input))return ne.getViewState()}e.$JE=f;function o(ce){if(k(ce))return!1;const G=ce;return g.URI.isUri(G?.resource)}e.$KE=o;function i(ce){if(k(ce))return!1;const G=ce;return G?.original!==void 0&&G.modified!==void 0}e.$LE=i;function s(ce){if(k(ce))return!1;const G=ce;return!G||G.resources&&!Array.isArray(G.resources)?!1:!!G.resources||!!G.multiDiffSource}e.$ME=s;function n(ce){if(k(ce)||i(ce))return!1;const G=ce;return G?.primary!==void 0&&G.secondary!==void 0}e.$NE=n;function c(ce){if(k(ce))return!1;const G=ce;return G?G.resource===void 0||G.resource.scheme===y.Schemas.untitled||G.forceUntitled===!0:!1}e.$OE=c;function t(ce){if(k(ce))return!1;const G=ce;return g.URI.isUri(G?.base?.resource)&&g.URI.isUri(G?.input1?.resource)&&g.URI.isUri(G?.input2?.resource)&&g.URI.isUri(G?.result?.resource)}e.$PE=t;var a;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var r;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class h{constructor(){this.a=new Map}registerSource(G,W){let ne=this.a.get(G);return ne||(ne={source:G,label:W},this.a.set(G,ne)),ne.source}getSourceLabel(G){return this.a.get(G)?.label??G}}e.$QE=new h;var u;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad",ce[ce.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(u||(e.EditorInputCapabilities=u={}));class l extends I.$Tc{}e.$RE=l;function k(ce){return ce instanceof l}e.$SE=k;function A(ce){const G=ce;return g.URI.isUri(G?.preferredResource)}function v(ce){const G=ce;return k(G?.primary)&&k(G?.secondary)}e.$TE=v;function w(ce){const G=ce;return k(G?.modified)&&k(G?.original)}e.$UE=w;function E(ce,G,W,ne,ye){return be(ne,[(0,C.$Pi)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const de={...W,limits:{size:Number.MAX_VALUE}};ce.openEditor(G,de)}}),(0,C.$Pi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.$VE=E;function P(ce){return k(ce?.editor)}e.$WE=P;function N(ce){const G=ce;return P(ce)&&G?.group!==void 0}e.$XE=N;function z(ce){const G=ce;return typeof G?.groupId=="number"&&k(G.editor)}e.$YE=z;var F;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(F||(e.EditorCloseContext=F={}));var j;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LABEL=2]="GROUP_LABEL",ce[ce.GROUP_LOCKED=3]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=4]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=5]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=6]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=8]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=10]="EDITOR_PIN",ce[ce.EDITOR_STICKY=11]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=12]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var M;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(M||(e.SideBySideEditor=M={}));class O{getOriginalUri(G,W){if(!G)return;if(t(G))return e.$1E.getOriginalUri(G.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:de}=this.a(G);if(ye&&de){if(W?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(de,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===M.ANY)return this.getOriginalUri(ye,{filterByScheme:W.filterByScheme})??this.getOriginalUri(de,{filterByScheme:W.filterByScheme});G=W.supportSideBySide===M.PRIMARY?ye:de}}if(i(G)||s(G)||n(G)||t(G))return;const ne=A(G)?G.preferredResource:G.resource;return!ne||!W||!W.filterByScheme?ne:this.b(ne,W.filterByScheme)}a(G){return v(G)||n(G)?{primary:G.primary,secondary:G.secondary}:w(G)||i(G)?{primary:G.modified,secondary:G.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(G,W){if(!G)return;if(t(G))return e.$1E.getCanonicalUri(G.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:de}=this.a(G);if(ye&&de){if(W?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(de,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===M.ANY)return this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(de,{filterByScheme:W.filterByScheme});G=W.supportSideBySide===M.PRIMARY?ye:de}}if(i(G)||s(G)||n(G)||t(G))return;const ne=G.resource;return!ne||!W||!W.filterByScheme?ne:this.b(ne,W.filterByScheme)}b(G,W){if(Array.isArray(W)){if(W.some(ne=>G.scheme===ne))return G}else if(W===G.scheme)return G}}var U;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(U||(e.EditorCloseMethod=U={}));function Q(ce,G,W,ne){if(!ce.isSticky(G))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return W===U.MOUSE||W===U.KEYBOARD;case"mouse":return W===U.MOUSE;case"keyboard":return W===U.KEYBOARD}return!1}e.$ZE=Q,e.$1E=new O;var ue;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(ue||(e.CloseDirection=ue={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(G){const W=this.a=G.get(R.$5h);for(const[ne,ye]of this.c)this.e(ne,ye,W);this.c.clear()}e(G,W,ne){const ye=ne.createInstance(W);this.d.set(G,ye)}registerFileEditorFactory(G){if(this.b)throw new Error("Can only register one file editor factory.");this.b=G}getFileEditorFactory(){return(0,T.$Tf)(this.b)}registerEditorSerializer(G,W){if(this.c.has(G)||this.d.has(G))throw new Error(`A editor serializer with type ID '${G}' was already registered.`);return this.a?this.e(G,W,this.a):this.c.set(G,W),(0,I.$Rc)(()=>{this.c.delete(G),this.d.delete(G)})}getEditorSerializer(G){return this.d.get(typeof G=="string"?G:G.typeId)}}b.$Hn.add(e.$DE.EditorFactory,new Z);async function J(ce,G,W){return!ce||!ce.length?[]:await Promise.all(ce.map(async ne=>{const ye=g.URI.revive(ne.fileUri);if(!ye){W.info("Cannot resolve the path because it is not valid.",ne);return}if(!await G.canHandleResource(ye)){W.info("Cannot resolve the path because it cannot be handled",ne);return}let ge=ne.exists,_=ne.type;if(typeof ge!="boolean"||typeof _!="number")try{_=(await G.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ge=!0}catch(K){W.error(K),ge=!1}if(!ge&&ne.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",ne);return}if(_===$.FileType.Directory){W.info("Cannot resolve the path because it is a directory",ne);return}const te={...ne.options,pinned:!0};return ge?{resource:ye,options:te}:{resource:ye,options:te,forceUntitled:!0}}))}e.$2E=J;var X;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function le(ce){const G=ce;if(!G)return!1;const W=G;if(W.modified)return le(W.modified);const ne=G;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$3E=le;function x(ce){return(0,L.$Ri)(ce)}e.$4E=x;function be(ce,G,W){const ne=(0,L.$Si)(ce,G);return ne.forceMessage=W?.forceMessage,ne.forceSeverity=W?.forceSeverity,ne.allowDialog=W?.allowDialog,ne}e.$5E=be}),define(ke[278],Se([1,0,4,225,5,3,28,37,19,24,78,264]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$$E=e.ViewContentGroups=e.$0E=e.$9E=e.ViewContainerLocation=e.Extensions=e.$8E=e.$7E=e.$6E=void 0,e.$6E="views",e.$7E=(0,T.localize)(0,null),e.$8E=(0,C.$xw)("default-view-icon",L.$_j.window,(0,T.localize)(1,null));var m;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var p;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel",a[a.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$9E=[0,1,2];function S(a){switch(a){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$0E=S;class d extends I.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Vd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Vd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(r,h,u){const l=this.get(r.id);if(l)return l;const k=r;return k.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,R.$xc)(this.g,h,[]).push(k),u?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:h}),k}deregisterViewContainer(r){for(const h of this.g.keys()){const u=this.g.get(h),l=u?.indexOf(r);if(l!==-1){u?.splice(l,1),u.length===0&&this.g.delete(h),this.f.fire({viewContainer:r,viewContainerLocation:h});return}}}get(r){return this.all.filter(h=>h.id===r)[0]}getViewContainers(r){return[...this.g.get(r)||[]]}getViewContainerLocation(r){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(u=>u?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.h.find(h=>this.getViewContainerLocation(h)===r)}}b.$Hn.add(m.ViewContainersRegistry,new d);var f;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(f||(e.ViewContentGroups=f={}));function o(a,r){const h=a.group??f.More,u=r.group??f.More;return h!==u?h.localeCompare(u):(a.order??5)-(r.order??5)}class i extends I.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Vd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Vd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Vd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Vd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(r,h){this.registerViews2([{views:r,viewContainer:h}])}registerViews2(r){r.forEach(({views:h,viewContainer:u})=>this.r(h,u)),this.c.fire(r)}deregisterViews(r,h){const u=this.s(r,h);u.length&&this.f.fire({views:u,viewContainer:h})}moveViews(r,h){for(const u of this.m.keys())if(u!==h){const l=this.s(r,u);l.length&&(this.r(l,h),this.g.fire({views:l,from:u,to:h}))}}getViews(r){return this.m.get(r)||[]}getView(r){for(const h of this.j){const u=(this.m.get(h)||[]).filter(l=>l.id===r)[0];if(u)return u}return null}getViewContainer(r){for(const h of this.j)if((this.m.get(h)||[]).filter(l=>l.id===r)[0])return h;return null}registerViewWelcomeContent(r,h){return this.n.add(r,h),this.h.fire(r),(0,I.$Rc)(()=>{this.n.delete(r,h),this.h.fire(r)})}registerViewWelcomeContent2(r,h){const u=new Map;for(const[l,k]of h)this.n.add(r,k),u.set(l,(0,I.$Rc)(()=>{this.n.delete(r,k),this.h.fire(r)}));return this.h.fire(r),u}getViewWelcomeContent(r){const h=[];return this.n.forEach(r,u=>h.push(u)),h.sort(o)}r(r,h){let u=this.m.get(h);u||(u=[],this.m.set(h,u),this.j.push(h));for(const l of r){if(this.getView(l.id)!==null)throw new Error((0,T.localize)(2,null,l.id));u.push(l)}}s(r,h){const u=this.m.get(h);if(!u)return[];const l=[],k=[];for(const A of u)r.includes(A)?l.push(A):k.push(A);return l.length&&(k.length?this.m.set(h,k):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),l}}b.$Hn.add(m.ViewsRegistry,new i),e.$$E=(0,g.$6h)("viewDescriptorService");var s;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(s||(e.ViewVisibilityState=s={}));var n;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class c{constructor(r,h){this.c=!1,this.d=!1,(0,y.$yn)(this,r),this.d=!!h,this.resolve=async u=>{if(h&&!this.c){const l=await h(u);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$_E=c;class t extends Error{constructor(r){super((0,T.localize)(3,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.$aF=t}),define(ke[279],Se([1,0,2,29,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$iF=e.$hF=void 0;function I(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(T.$Us.isIRange)}e.$hF=I;function R(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(I)}e.$iF=R;var b;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.ChatAgentCopyKind=$={})),e.$jF=(0,g.$6h)("IChatService")}),define(ke[140],Se([1,0,4,11,226]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlb=void 0;class I{constructor(){this.f=new Map,this.k=[],this.m=new D.$Vd,this.n=new D.$Vd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,$,y,L){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof L=="number"){const m=setTimeout(()=>{clearTimeout(m);const p=this.f.get(C.seq);if(p){this.f.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,g.localize)(0,null,L,b)};p(S)}},L)}return y&&this.f.set(C.seq,y),C.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,$){return b.type!=="event"||$.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,T.$7g)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}s(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,y)=>b.set(y,$)),await(0,T.$7g)(500),b.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Nlb=I}),define(ke[280],Se([1,0,227,45,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$NH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$MH=e.MemoryRangeType=e.$LH=e.State=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG="workbench.view.debug",e.$JG="workbench.debug.variablesView",e.$KG="workbench.debug.watchExpressionsView",e.$LG="workbench.debug.callStackView",e.$MG="workbench.debug.loadedScriptsView",e.$NG="workbench.debug.breakPointsView",e.$OG="workbench.debug.disassemblyView",e.$PG="workbench.panel.repl",e.$QG="workbench.panel.repl.view",e.$RG=new T.$kj("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$SG=new T.$kj("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$TG=new T.$kj("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$UG="debugUx",e.$VG=new T.$kj(e.$UG,"default",{type:"string",description:D.localize(3,null)}),e.$WG=new T.$kj("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$XG=new T.$kj("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$YG=new T.$kj("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$ZG=new T.$kj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$1G=new T.$kj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$2G=new T.$kj("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$3G=new T.$kj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$4G=new T.$kj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$5G=new T.$kj("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$6G=new T.$kj("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$7G=new T.$kj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$8G=new T.$kj("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$9G=new T.$kj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$0G=new T.$kj("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$$G=new T.$kj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$_G=new T.$kj("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$aH=new T.$kj("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$bH=new T.$kj("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$cH=new T.$kj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$dH=new T.$kj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$eH=new T.$kj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$fH=new T.$kj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$gH=new T.$kj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$hH=new T.$kj("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$iH=new T.$kj("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$jH=new T.$kj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$kH=new T.$kj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$lH=new T.$kj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$mH=new T.$kj("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$nH=new T.$kj("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$oH=new T.$kj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$pH=new T.$kj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$qH=new T.$kj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$rH=new T.$kj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$sH=new T.$kj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$tH=new T.$kj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$uH=new T.$kj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$vH=new T.$kj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$wH=new T.$kj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$xH=new T.$kj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$yH=new T.$kj("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$zH=new T.$kj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$AH=new T.$kj("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$BH=new T.$kj("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$CH=new T.$kj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$DH=new T.$kj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$EH=new T.$kj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$FH=new T.$kj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const I=m=>D.localize(52,null,m);e.$GH=I,e.$HH="editor.contrib.debug",e.$IH="editor.contrib.breakpoint",e.$JH="debug",e.$KH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var R;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(R||(e.State=R={}));function b(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$LH=b;var $;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})($||(e.MemoryRangeType=$={})),e.$MH="vscode-debug-memory";var y;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var L;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerString=L={})),e.$NH=(0,g.$6h)("debugService");var C;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE",m[m.TRIGGER_POINT=3]="TRIGGER_POINT"})(C||(e.BreakpointWidgetContext=C={}))}),define(ke[281],Se([1,0,12,2,17,24,16,29,21,19]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=void 0;const L=/{([^}]+)}/g;function C(A,v,w){return A.replace(L,function(E,P){return v&&P.length>0&&P[0]!=="_"?E:w&&w.hasOwnProperty(P)?w[P]:E})}e.$0F=C;function m(A){const v={};for(const w of Object.keys(A))w.startsWith("!")||(v[w]=A[w]);return v}e.$$F=m;function p(A){return A.configuration.request==="attach"&&!S(A)&&(!A.parentSession||p(A.parentSession))}e.$_F=p;function S(A){let v=A.configuration.type;if(v)return v==="vslsShare"&&(v=A.configuration.adapterProxy.configuration.type),(0,D.$_e)(v,"extensionhost")||(0,D.$_e)(v,"pwa-extensionhost")?A:A.parentSession?S(A.parentSession):void 0}e.$aG=S;function d(A){return A.type&&(A.label||A.program||A.runtime)}e.$bG=d;function f(A,v,w){let E,P=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=N.exec(A);){const F=z.index+1,j=F+z[0].length;if(F<=v&&j>=w){E=z[0],P=F;break}}if(E){const F=/\w+/g;let j=null;for(;(j=F.exec(E))&&!(j.index+1+P+j[0].length>=w););j&&(E=E.substring(0,F.lastIndex))}return E?{start:P,end:P+E.length-1}:{start:0,end:0}}e.$cG=f;async function o(A,v,w,E){if(A.evaluatableExpressionProvider.has(v)){const P=A.evaluatableExpressionProvider.ordered(v),N=(0,y.$Hb)(await Promise.all(P.map(async z=>{try{return await z.provideEvaluatableExpression(v,w,E??$.CancellationToken.None)}catch{return}})));if(N.length>0){let z=N[0].expression;const F=N[0].range;return z||(z=v.getLineContent(w.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:z}}}else{const P=v.getLineContent(w.lineNumber),{start:N,end:z}=f(P,w.column,w.column),F=P.substring(N-1,z);return{matchingExpression:F,range:new b.$Us(w.lineNumber,N,w.lineNumber,N+F.length)}}return null}e.$dG=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(A){return!!(A&&A.match(i))}e.$eG=s;function n(A){if(typeof A.path=="string"&&!(typeof A.sourceReference=="number"&&A.sourceReference>0)){if(s(A.path))return T.URI.parse(A.path);if((0,g.$ic)(A.path))return T.URI.file(A.path)}return A.path}function c(A){if(typeof A.path=="object"){const v=T.URI.revive(A.path);if(v)return v.scheme===R.Schemas.file?v.fsPath:v.toString()}return A.path}function t(A,v){const w=v?n:c,E=(0,I.$vn)(A);return r(E,(P,N)=>{P&&N&&(N.path=w(N))}),E}e.$fG=t;function a(A,v){const w=v?n:c,E=(0,I.$vn)(A);return r(E,(P,N)=>{!P&&N&&(N.path=w(N))}),E}e.$gG=a;function r(A,v){switch(A.type){case"event":{const w=A;switch(w.event){case"output":v(!1,w.body.source);break;case"loadedSource":v(!1,w.body.source);break;case"breakpoint":v(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=A;switch(w.command){case"setBreakpoints":v(!0,w.arguments.source);break;case"breakpointLocations":v(!0,w.arguments.source);break;case"source":v(!0,w.arguments.source);break;case"gotoTargets":v(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(E=>v(!1,E));break;default:break}break}case"response":{const w=A;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(E=>v(!1,E.source));break;case"loadedSources":w.body.sources.forEach(E=>v(!1,E));break;case"scopes":w.body.scopes.forEach(E=>v(!1,E.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(E=>v(!1,E.source));break;case"setBreakpoints":w.body.breakpoints.forEach(E=>v(!1,E.source));break;case"disassemble":w.body?.instructions.forEach(P=>v(!1,P.location));break;default:break}break}}}function h(A){return A.filter(v=>!v.presentation?.hidden).sort((v,w)=>v.presentation?w.presentation?v.presentation.group?w.presentation.group?v.presentation.group!==w.presentation.group?v.presentation.group.localeCompare(w.presentation.group):u(v.presentation.order,w.presentation.order):-1:w.presentation.group?1:u(v.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$hG=h;function u(A,v){return typeof A!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:A-v}async function l(A,v){const w=A.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(w!=="none"&&(await v.saveAll(),w==="allEditorsInActiveGroup")){const E=v.activeEditorPane;E&&E.input.resource?.scheme===R.Schemas.untitled&&await v.save({editor:E.input,groupId:E.group.id})}await A.reloadConfiguration()}e.$iG=l;const k=(A,v)=>!A||!v?A===v:A.name===v.name&&A.path===v.path&&A.sourceReference===v.sourceReference;e.$jG=k}),define(ke[282],Se([1,0,50,62,24,17,10,12,31,228,140]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=e.$Dic=e.$Cic=e.$Bic=e.$Aic=void 0;class C extends L.$Nlb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",s=>this.w(s))}sendMessage(o){if(this.p){const i=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(s){this.m.fire(new Error((s.message||s)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const n=this.r.toString("utf8",0,i).split(C.b);for(const c of n){const t=c.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$Aic=C;class m extends C{startSession(){return new Promise((o,i)=>{let s=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),s=!0}),this.x.on("close",()=>{s?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",n=>{s?this.m.fire(n):i(n)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Bic=m;class p extends m{constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Cic=p;class S extends m{constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.path,o)}}e.$Dic=S;class d extends C{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,s=this.y.options||{};try{if(o)if(I.$ic(o)){if(!await $.Promises.exists(o))throw new Error(y.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let n=process.env;if(s.env&&Object.keys(s.env).length>0&&(n=g.$yn(g.$vn(process.env),s.env)),o==="node")if(Array.isArray(i)&&i.length>0){const c=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:n,execArgv:c?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(t.cwd=s.cwd);const a=D.fork(i[0],i.slice(1),t);if(!a.pid)throw new Error(y.localize(2,null,i[0]));this.x=a}else throw new Error(y.localize(3,null));else{const c={env:n};s.cwd&&(c.cwd=s.cwd),this.x=D.spawn(o,i,c)}this.x.on("error",c=>{this.m.fire(c)}),this.x.on("exit",(c,t)=>{this.n.fire(c)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",c=>{this.m.fire(c)}),this.x.stdin.on("error",c=>{this.m.fire(c)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(n){this.m.fire(n)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((o,i)=>{const s=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(n,c,t){if(n)return i(n)});s.on("exit",o),s.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const s=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?s.runtime=I.$jc(i,o.runtime):s.runtime=o.runtime),o.runtimeArgs&&(s.runtimeArgs=o.runtimeArgs),o.program&&(I.$ic(o.program)?s.program=o.program:s.program=I.$jc(i,o.program)),o.args&&(s.args=o.args);const n=o;return n.win&&(s.win=d.A(n.win,i)),n.winx86&&(s.winx86=d.A(n.winx86,i)),n.windows&&(s.windows=d.A(n.windows,i)),n.osx&&(s.osx=d.A(n.osx,i)),n.linux&&(s.linux=d.A(n.linux,i)),s}static platformAdapterExecutable(o,i){let s=Object.create(null);i=i.toLowerCase();for(const h of o)if(h.contributes){const u=h.contributes.debuggers;u&&u.length>0&&u.filter(l=>typeof l.type=="string"&&b.$_e(l.type,i)).forEach(l=>{const k=d.A(l,h.extensionLocation.fsPath);s=g.$yn(s,k,h.isBuiltin)})}let n;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?n=s.winx86||s.win||s.windows:R.$i?n=s.win||s.windows:R.$j?n=s.osx:R.$k&&(n=s.linux),n=n||s;const c=n.program||s.program,t=n.args||s.args,a=n.runtime||s.runtime,r=n.runtimeArgs||s.runtimeArgs;if(a)return{type:"executable",command:a,args:(r||[]).concat(typeof c=="string"?[c]:[]).concat(t||[])};if(c)return{type:"executable",command:c,args:t||[]}}}e.$Eic=d}),define(ke[283],Se([1,0,50,33,10]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0;function I(y,L){return new Promise((C,m)=>{let p="";const S=D.spawn(y,L);S.pid&&S.stdout.on("data",d=>{p+=d.toString()}),S.on("error",d=>{m(d)}),S.on("close",d=>{C(p)})})}async function R(y){if(y)if(g.$i){const L=await new Promise((C,m)=>{me(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{L.getProcessTree(y,m=>{C(!!m&&m.children.length>0)})})}else return I("/usr/bin/pgrep",["-lP",String(y)]).then(L=>{const C=L.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.$Fic=R;var b;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(b||(b={}));function $(y,L,C,m,p){y=y.trim().toLowerCase();let S;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?S=1:y.indexOf("cmd.exe")>=0?S=0:y.indexOf("bash")>=0?S=2:g.$i?S=0:S=2;let d,f=" ";switch(S){case 1:if(d=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),m){const o=(0,T.$ag)(m);o&&(f+=`${o}:; `),f+=`cd ${d(m)}; `}if(p)for(const o in p){const i=p[o];i===null?f+=`Remove-Item env:${o}; `:f+=`\${env:${o}}='${i}'; `}if(L.length>0){const o=L.shift(),i=C?o:d(o);f+=i[0]==="'"?`& ${i} `:`${i} `;for(const s of L)f+=s==="<"||s===">"||C?s:d(s),f+=" "}break;case 0:if(d=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),m){const o=(0,T.$ag)(m);o&&(f+=`${o}: && `),f+=`cd ${d(m)} && `}if(p){f+='cmd /C "';for(const o in p){let i=p[o];i===null?f+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,s=>`^${s}`),f+=`set "${o}=${i}" && `)}}for(const o of L)f+=o==="<"||o===">"||C?o:d(o),f+=" ";p&&(f+='"');break;case 2:{d=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(f+=`cd ${d(m)} ; `),p){f+="/usr/bin/env";for(const i in p){const s=p[i];s===null?f+=` -u ${o(i)}`:f+=` ${o(`${i}=${s}`)}`}f+=" "}for(const i of L)f+=i==="<"||i===">"||C?i:d(i),f+=" ";break}}return f}e.$Gic=$}),define(ke[284],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.CellExecutionUpdateType=void 0;var T;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$fJ=(0,D.$6h)("INotebookExecutionService")}),define(ke[285],Se([1,0,3,29,193,100]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WQb=void 0;class R extends D.$Tc{constructor($,y,L){super(),this._source=$,this.b=y,this.c=L,this.a=void 0}f($){const y=$.getLineCount();return new T.$Us(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new g.$cC;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:L,disposable:C}=y.create(1);this.b=L,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new g.$cC;y.acceptChunk($);const L=y.finish(!0),{textBuffer:C,disposable:m}=L.create(1);return this.B(m),C})),this.a}findInInputs($){const L=new I.$3B($,!1,!1,null).parseSearchRequest();if(!L)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,L,!0,5e3)}findInOutputs($){const L=new I.$3B($,!1,!1,null).parseSearchRequest();return L?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),L,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$WQb=R}),define(ke[67],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(I){I.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var T;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class g{static fromExtHostTestItem(R,b,$=R.parent){if(R._isRoot)return new g([b]);const y=[R.id];for(let L=$;L&&L.id!==b;L=L.parent)y.push(L.id);return y.push(b),new g(y.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const b=R.indexOf("\0");return b===-1?R:R.slice(0,b)}static fromString(R){return new g(R.split("\0"))}static join(R,b){return new g([...R.path,b])}static joinToString(R,b){return R.toString()+"\0"+b}static parentId(R){const b=R.lastIndexOf("\0");return b===-1?void 0:R.slice(0,b)}static localId(R){const b=R.lastIndexOf("\0");return b===-1?R:R.slice(b+1)}static isChild(R,b){return b.startsWith(R)&&b[R.length]==="\0"}static compare(R,b){return R===b?0:g.isChild(R,b)?2:g.isChild(b,R)?3:1}constructor(R,b=R.length){if(this.path=R,this.d=b,R.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new g(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new g(this.path,R)}compare(R){if(typeof R=="string")return g.compare(this.toString(),R);for(let b=0;b<R.d&&b<this.d;b++)if(R.path[b]!==this.path[b])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$2J=g}),define(ke[90],Se([1,0,2,48,29,67]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$9J=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$8J=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$7J=e.$6J=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$5J=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$4J=e.$3J=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var b;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$3J=[2,4,8,16,32,64];const y=M=>"runId"in M;e.$4J=y;var L;(function(M){M.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),M.deserialize=(O,U)=>({range:g.$Us.lift(U.range),uri:O.asCanonicalUri(D.URI.revive(U.uri))})})(L||(e.IRichLocation=L={}));var C;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(M){M.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&L.serialize(O.location)}),M.deserialize=(O,U)=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&L.deserialize(O,U.location)})})(m||(e.ITestErrorMessage=m={}));const p=(M,O)=>`${O?"s":"e"}${M}`;e.$5J=p;var S;(function(M){M.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&L.serialize(O.location)}),M.deserialize=(O,U)=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&L.deserialize(O,U.location)})})(S||(e.ITestOutputMessage=S={}));var d;(function(M){M.serialize=O=>O.type===0?m.serialize(O):S.serialize(O),M.deserialize=(O,U)=>U.type===0?m.deserialize(O,U):S.deserialize(O,U)})(d||(e.ITestMessage=d={}));var f;(function(M){M.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),M.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(d.serialize)}),M.deserialize=(O,U)=>({state:U.state,duration:U.duration,messages:U.messages.map(Q=>d.deserialize(O,Q))})})(f||(e.ITestTaskState=f={}));const o="\0",i=(M,O)=>M+o+O;e.$6J=i;const s=M=>{const O=M.indexOf(o);return{ctrlId:M.slice(0,O),tagId:M.slice(O+1)}};e.$7J=s;var n;(function(M){M.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),M.deserialize=(O,U)=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?O.asCanonicalUri(D.URI.revive(U.uri)):void 0,range:U.range?g.$Us.lift(U.range):null,description:U.description,error:U.error,sortText:U.sortText})})(n||(e.ITestItem=n={}));var c;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var t;(function(M){M.serialize=O=>({expand:O.expand,item:n.serialize(O.item)}),M.deserialize=(O,U)=>({controllerId:I.$2J.root(U.item.extId),expand:U.expand,item:n.deserialize(O,U.item)})})(t||(e.InternalTestItem=t={}));var a;(function(M){M.serialize=O=>{let U;return O.item&&(U={},O.item.label!==void 0&&(U.label=O.item.label),O.item.tags!==void 0&&(U.tags=O.item.tags),O.item.busy!==void 0&&(U.busy=O.item.busy),O.item.uri!==void 0&&(U.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(U.range=O.item.range?.toJSON()),O.item.description!==void 0&&(U.description=O.item.description),O.item.error!==void 0&&(U.error=O.item.error),O.item.sortText!==void 0&&(U.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:U}},M.deserialize=O=>{let U;return O.item&&(U={},O.item.label!==void 0&&(U.label=O.item.label),O.item.tags!==void 0&&(U.tags=O.item.tags),O.item.busy!==void 0&&(U.busy=O.item.busy),O.item.range!==void 0&&(U.range=O.item.range?g.$Us.lift(O.item.range):null),O.item.description!==void 0&&(U.description=O.item.description),O.item.error!==void 0&&(U.error=O.item.error),O.item.sortText!==void 0&&(U.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:U}}})(a||(e.ITestItemUpdate=a={}));const r=(M,O)=>{O.expand!==void 0&&(M.expand=O.expand),O.item!==void 0&&(M.item=M.item?Object.assign(M.item,O.item):O.item)};e.$8J=r;var h;(function(M){M.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(f.serializeWithoutMessages)}),M.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(f.serialize)}),M.deserialize=(O,U)=>({...t.deserialize(O,U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(Q=>f.deserialize(O,Q)),retired:!0})})(h||(e.TestResultItem=h={}));var u;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(O,U)=>{O.covered+=U.covered,O.total+=U.total}})(u||(e.ICoveredCount=u={}));var l;(function(M){M.serialize=O=>({statement:O.statement,branch:O.branch,function:O.function,details:O.details?.map(w.serialize),uri:O.uri.toJSON()}),M.deserialize=(O,U)=>({statement:U.statement,branch:U.branch,function:U.function,details:U.details?.map(w.deserialize),uri:O.asCanonicalUri(D.URI.revive(U.uri))})})(l||(e.IFileCoverage=l={}));function k(M){return{...M,location:M.location?.toJSON()}}function A(M){return M.location=M.location?T.$Ts.isIPosition(M.location)?T.$Ts.lift(M.location):g.$Us.lift(M.location):void 0,M}e.$9J=3;var v;(function(M){M[M.Function=0]="Function",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(v||(e.DetailType=v={}));var w;(function(M){M.serialize=O=>O.type===0?P.serialize(O):N.serialize(O),M.deserialize=O=>O.type===0?P.deserialize(O):N.deserialize(O)})(w||(e.CoverageDetails=w={}));var E;(function(M){M.serialize=k,M.deserialize=A})(E||(e.IBranchCoverage=E={}));var P;(function(M){M.serialize=k,M.deserialize=A})(P||(e.IFunctionCoverage=P={}));var N;(function(M){M.serialize=O=>({...k(O),branches:O.branches?.map(E.serialize)}),M.deserialize=O=>({...A(O),branches:O.branches?.map(E.deserialize)})})(N||(e.IStatementCoverage=N={}));var z;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var F;(function(M){M.deserialize=(O,U)=>U.op===0?{op:U.op,item:t.deserialize(O,U.item)}:U.op===1?{op:U.op,item:a.deserialize(U.item)}:U.op===2?{op:U.op,uri:O.asCanonicalUri(D.URI.revive(U.uri)),docv:U.docv}:U,M.serialize=O=>O.op===0?{op:O.op,item:t.serialize(O.item)}:O.op===1?{op:O.op,item:a.serialize(O.item)}:O})(F||(e.TestsDiffOp=F={}));class j{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const U=this.v();for(const Q of O)switch(Q.op){case 0:this.l(t.deserialize(this.k,Q.item),U);break;case 1:this.o(a.deserialize(Q.item),U);break;case 3:this.p(Q.itemId,U);break;case 5:this.q(Q.itemId);break;case 4:this.updatePendingRoots(Q.amount);break;case 6:this.c.set(Q.tag.id,Q.tag);break;case 7:this.c.delete(Q.id);break}U.complete?.()}l(O,U){const Q=I.$2J.parentId(O.item.extId)?.toString();let ue;if(!Q)ue=this.w(O),this.g.add(ue),this.f.set(O.item.extId,ue);else if(this.f.has(Q)){const Z=this.f.get(Q);Z.children.add(O.item.extId),ue=this.w(O,Z),this.f.set(O.item.extId,ue)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return U.add?.(ue),O.expand===2&&this.h++,ue}o(O,U){const Q=this.f.get(O.extId);if(Q)return O.expand!==void 0&&(Q.expand===2&&this.h--,O.expand===2&&this.h++),(0,e.$8J)(Q,O),U.update?.(Q),Q}p(O,U){const Q=this.f.get(O);if(!Q)return;const ue=I.$2J.parentId(Q.item.extId)?.toString();ue?this.f.get(ue).children.delete(Q.item.extId):this.g.delete(Q);const Z=[[O]];for(;Z.length;)for(const J of Z.pop()){const X=this.f.get(J);X&&(Z.push(X.children),this.f.delete(J),U.remove?.(X,X!==Q),X.expand===2&&this.h--)}}q(O){}updatePendingRoots(O){this.j+=O}v(){return{}}}e.$0J=j}),define(ke[111],Se([1,0,11,4,3,60,90,67]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(i,s)=>i===s,C=Object.entries({range:(i,s)=>i===s?!0:!i||!s?!1:i.equalsRange(s),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,s)=>!(i.length!==s.length||i.some(n=>!s.includes(n)))}),m=(i,s)=>{let n;for(const[c,t]of C)t(i[c],s[c])||(n?n[c]=s[c]:n={[c]:s[c]});return n};class p extends g.$Tc{get root(){return this.s.root}constructor(s){super(),this.s=s,this.f=this.B(new D.$fh(()=>this.flushDiff(),200)),this.g=this.B(new T.$Vd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(s){this.h=s;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const s=this.m;return this.m=[],s}pushDiff(s){switch(s.op){case 2:{for(const n of this.m)if(n.op===2&&n.uri===s.uri){n.docv=s.docv;return}break}case 1:{const n=this.m[this.m.length-1];if(n){if(n.op===1&&n.item.extId===s.item.extId){(0,R.$8J)(n.item,s.item);return}if(n.op===0&&n.item.item.extId===s.item.extId){(0,R.$8J)(n.item,s.item);return}}break}}this.m.push(s),this.f.isScheduled()||this.f.schedule()}expand(s,n){const c=this.tree.get(s);if(c){if((c.expandLevels===void 0||n>c.expandLevels)&&(c.expandLevels=n),c.expand===1){const t=this.M(c);return t.isOpen()?this.L(c,n-1):t.wait().then(()=>this.L(c,n-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.L(c,n-1)):this.L(c,n-1)}}dispose(){for(const s of this.tree.values())this.s.getApiFor(s.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(s,n){switch(n.op){case 3:this.O(b.$2J.joinToString(s.fullId,n.id));break;case 0:this.z(n.item,s);break;case 5:for(const c of n.ops)this.w(s,c);break;case 1:this.C(n.new,n.old,s.fullId.toString());break;case 2:this.J(s);break;case 4:this.pushDiff({op:1,item:{extId:s.fullId.toString(),item:n.update}});break;case 6:this.y(s.actual.uri);break;default:(0,I.$6c)(n)}}y(s){s&&this.pushDiff({op:2,uri:s,docv:this.s.getDocumentVersion(s)})}z(s,n){const c=b.$2J.fromExtHostTestItem(s,this.root.id,n?.actual),t=this.s.getApiFor(s);t.parent&&t.parent!==n?.actual&&this.s.getChildren(t.parent).delete(s.id);let a=this.tree.get(c.toString());if(!a){a={fullId:c,actual:s,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:0},s.tags.forEach(this.D,this),this.tree.set(a.fullId.toString(),a),this.G(s,n),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:a.expand,item:this.s.toITestItem(s)}}),this.I(s,a,n);return}if(a.actual===s){this.H(s,a,n);return}if(a.actual.uri?.toString()!==s.uri?.toString())return this.O(c.toString()),this.z(s,n);const r=this.s.getChildren(a.actual),h=a.actual,u=m(this.s.toITestItem(h),this.s.toITestItem(s));this.s.getApiFor(h).listener=void 0,a.actual=s,a.expand=0,u&&(u.hasOwnProperty("tags")&&(this.C(s.tags,h.tags,c.toString()),delete u.tags),this.w(a,{op:4,update:u})),this.I(s,a,n);for(const[l,k]of r)this.s.getChildren(s).get(k.id)||this.O(b.$2J.joinToString(c,k.id));this.y(a.actual.uri)}C(s,n,c){const t=new Set(n.map(a=>a.id));for(const a of s)t.delete(a.id)||this.D(a);this.pushDiff({op:1,item:{extId:c,item:{tags:s.map(a=>(0,R.$6J)(this.s.controllerId,a.id))}}}),t.forEach(this.F,this)}D(s){const n=this.j.get(s.id);n?n.refCount++:(this.j.set(s.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$6J)(this.s.controllerId,s.id)}}))}F(s){const n=this.j.get(s);n&&!--n.refCount&&(this.j.delete(s),this.pushDiff({op:7,id:(0,R.$6J)(this.s.controllerId,s)}))}G(s,n){this.s.getApiFor(s).parent=n&&n.actual!==this.root?n.actual:void 0}H(s,n,c){this.G(s,c);const t=this.s.getApiFor(s);t.parent=c?.actual,t.listener=a=>this.w(n,a),this.J(n)}I(s,n,c){this.H(s,n,c);for(const[t,a]of this.s.getChildren(s))this.z(a,n)}J(s){let n;this.h?s.resolveBarrier?n=s.resolveBarrier.isOpen()?3:2:n=s.actual.canResolveChildren?1:0:n=0,n!==s.expand&&(s.expand=n,this.pushDiff({op:1,item:{extId:s.fullId.toString(),expand:n}}),n===1&&s.expandLevels!==void 0&&this.M(s))}L(s,n){if(n<0)return;const c=[];for(const[t,a]of this.s.getChildren(s.actual)){const r=this.expand(b.$2J.joinToString(s.fullId,a.id),n);(0,D.$Sg)(r)&&c.push(r)}if(c.length)return Promise.all(c).then(()=>{})}M(s){if(s.resolveBarrier)return s.resolveBarrier;if(!this.h){const a=new D.$5g;return a.open(),a}s.expand=2,this.N(s);const n=s.resolveBarrier=new D.$5g,c=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,a)};let t;try{t=this.h(s.actual===this.root?void 0:s.actual)}catch(a){c(a)}return(0,D.$Sg)(t)?t.catch(c).then(()=>{n.open(),this.J(s)}):(n.open(),this.J(s)),s.resolveBarrier}N(s){this.pushDiff({op:1,item:{extId:s.fullId.toString(),expand:s.expand}})}O(s){const n=this.tree.get(s);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:s});const c=[n];for(;c.length;){const t=c.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const a of t.actual.tags)this.F(a.id);this.tree.delete(t.fullId.toString());for(const[a,r]of this.s.getChildren(t.actual))c.push(this.tree.get(b.$2J.joinToString(t.fullId,r.id)))}}}flushDiff(){const s=this.collectDiff();s.length&&this.g.fire(s)}}e.$4M=p;class S extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.$5M=S;class d extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$6M=d;class f extends Error{constructor(s,n,c){super(`TestItem with ID "${s}" is from controller "${n}" and cannot be added as a child of an item from controller "${c}".`)}}e.$7M=f;const o=(i,s,n)=>{let c=new Map;return{get size(){return c.size},forEach(t,a){for(const r of c.values())t.call(a,r,this)},[Symbol.iterator](){return c.entries()},replace(t){const a=new Map,r=new Set(c.keys()),h={op:5,ops:[]};for(const u of t){if(!(u instanceof n))throw new d(u.id);const l=s(u).controllerId;if(l!==i.controllerId)throw new f(u.id,l,i.controllerId);if(a.has(u.id))throw new S(u.id);a.set(u.id,u),r.delete(u.id),h.ops.push({op:0,item:u})}for(const u of r.keys())h.ops.push({op:3,id:u});i.listener?.(h),c=a},add(t){if(!(t instanceof n))throw new d(t.id);c.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){c.delete(t)&&i.listener?.({op:3,id:t})},get(t){return c.get(t)},toJSON(){return Array.from(c.values())}}};e.$8M=o}),define(ke[141],Se([1,0,111]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0;const T=new WeakMap,g=(R,b)=>{const $={controllerId:b};return T.set(R,$),$};e.$9M=g;const I=R=>{const b=T.get(R);if(!b)throw new D.$6M(R?.id||"<unknown>");return b};e.$0M=I}),define(ke[112],Se([1,0,16,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Evb=e.$Dvb=e.$Cvb=e.$Bvb=e.$Avb=void 0,e.$Avb="vscode-cdn.net",e.$Bvb=`vscode-resource.${e.$Avb}`,e.$Cvb=`'self' https://*.${e.$Avb}`;function g(b,$){return b.scheme===D.Schemas.http||b.scheme===D.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===D.Schemas.file&&(b=T.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:b.path})),T.URI.from({scheme:D.Schemas.https,authority:`${b.scheme}+${I(b.authority)}.${e.$Bvb}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$Dvb=g;function I(b){return b.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function R(b){return b.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}e.$Evb=R}),define(ke[286],Se([1,0,4,3,112]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class I{constructor(b,$,y){this.d=b,this.e=$,this.f=y,this.a=0,this.b=new T.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const L=$.getVisibleTextEditors();for(const C of this.c.values())L.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,y,L,C){let m;for(const s of this.e.getVisibleTextEditors(!0))if(s.value===b){m=s;break}if(!m)throw new Error("not a visible editor");const p=this,S=this.a++,d=new D.$Vd,f=new D.$Vd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(s){return(0,g.$Dvb)(s,p.f)}get cspSource(){return g.$Cvb}set options(s){this.b=s,p.d.$setOptions(S,s)}get options(){return this.b}set html(s){this.a=s,p.d.$setHtml(S,s)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(s){return p.d.$postMessage(S,s)}},i=new class{constructor(){this.editor=b,this.line=$,this.height=y,this.webview=o,this.onDidDispose=f.event}dispose(){p.c.has(S)&&(p.c.delete(S),p.d.$disposeEditorInset(S),f.fire(),f.dispose(),d.dispose())}};return this.d.$createEditorInset(S,m.id,m.value.document.uri,$+1,y,L||{},C.identifier,C.extensionLocation),this.c.set(S,{editor:b,inset:i,onDidReceiveMessage:d}),i}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$Egc=I}),define(ke[287],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=e.VariableKind=e.$ZN=void 0,e.$ZN=(0,D.$6h)("configurationResolverService");var T;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator",I.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class g extends Error{constructor(R,b){super(b),this.variable=R}}e.$1N=g}),define(ke[288],Se([1,0,17,49,18,24,10,103,231,287,12]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,S,d,f){this.h=new Map,this.a=p,this.b=S,this.g=d,f&&(this.c=f.then(o=>this.i(o)))}i(p){if(R.$i){const S=Object.create(null);return Object.keys(p).forEach(d=>{S[d.toLowerCase()]=p[d]}),S}return p}resolveWithEnvironment(p,S,d){return this.l({env:this.i(p),userHome:void 0},S?S.uri:void 0,d)}async resolveAsync(p,S){const d={env:await this.c,userHome:await this.g};return this.l(d,p?p.uri:void 0,S)}async j(p,S,d,f){const o=I.$vn(S);R.$i&&o.windows?Object.keys(o.windows).forEach(s=>o[s]=o.windows[s]):R.$j&&o.osx?Object.keys(o.osx).forEach(s=>o[s]=o.osx[s]):R.$k&&o.linux&&Object.keys(o.linux).forEach(s=>o[s]=o.linux[s]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,p?p.uri:void 0,o,d,f)}async resolveAnyAsync(p,S,d){return this.j(p,S,d)}async resolveAnyMap(p,S,d){const f=new Map;return{newConfig:await this.j(p,S,d,f),resolvedVariables:f}}resolveWithInteractionReplace(p,S,d,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,S,d,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,S){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,S)}async l(p,S,d,f,o){if(g.$If(d))return this.m(p,S,d,f,o);if(Array.isArray(d))return Promise.all(d.map(i=>this.l(p,S,i,f,o)));if(g.$Kf(d)){const i=Object.create(null),s=await Promise.all(Object.keys(d).map(async n=>[await this.m(p,S,n,f,o),await this.l(p,S,d[n],f,o)]));for(const[n,c]of s)i[n]=c;return i}return d}m(p,S,d,f,o){return(0,L.$4e)(d,C.VARIABLE_REGEXP,async(i,s)=>{if(s.includes(C.VARIABLE_LHS))return i;let n=await this.o(p,i,s,S,f);return o?.set(s,n),n!==i&&g.$If(n)&&n.match(C.VARIABLE_REGEXP)&&(n=await this.m(p,S,n,f,o)),n})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,S,d,f,o){let i;const s=d.split(":");s.length>1&&(d=s[0],i=s[1]);const n=a=>{const r=this.a.getFilePath();if(r)return(0,b.$Wv)(r);throw new y.$1N(a,(0,$.localize)(0,null,S))},c=a=>{const r=n(a);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return(0,b.$Wv)(h)}throw new y.$1N(a,(0,$.localize)(1,null,S,D.$nc(r)))},t=a=>{if(i){const r=this.a.getFolderUri(i);if(r)return r;throw new y.$1N(a,(0,$.localize)(2,null,S,i))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new y.$1N(a,(0,$.localize)(3,null,S)):new y.$1N(a,(0,$.localize)(4,null,S))};switch(d){case"env":if(i){if(p.env){const a=p.env[R.$i?i.toLowerCase():i];if(g.$If(a))return a}return""}throw new y.$1N(y.VariableKind.Env,(0,$.localize)(5,null,S));case"config":if(i){const a=this.a.getConfigurationValue(f,i);if(g.$Rf(a))throw new y.$1N(y.VariableKind.Config,(0,$.localize)(6,null,S,i));if(g.$Kf(a))throw new y.$1N(y.VariableKind.Config,(0,$.localize)(7,null,S,i));return a}throw new y.$1N(y.VariableKind.Config,(0,$.localize)(8,null,S));case"command":return this.p(y.VariableKind.Command,S,i,o,"command");case"input":return this.p(y.VariableKind.Input,S,i,o,"input");case"extensionInstallFolder":if(i){const a=await this.a.getExtension(i);if(!a)throw new y.$1N(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,S,i));return this.n(a.extensionLocation)}throw new y.$1N(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,S));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,b.$Wv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return f||i?(0,b.$Wv)(this.n(t(y.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Wv)(D.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new y.$1N(y.VariableKind.UserHome,(0,$.localize)(11,null,S))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new y.$1N(y.VariableKind.LineNumber,(0,$.localize)(12,null,S))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new y.$1N(y.VariableKind.SelectedText,(0,$.localize)(13,null,S))}case"file":return n(y.VariableKind.File);case"fileWorkspaceFolder":return c(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(c(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||i?D.$lc(this.n(t(y.VariableKind.RelativeFile)),n(y.VariableKind.RelativeFile)):n(y.VariableKind.RelativeFile);case"relativeFileDirname":{const a=D.$mc(n(y.VariableKind.RelativeFileDirname));if(f||i){const r=D.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),a);return r.length===0?".":r}return a}case"fileDirname":return D.$mc(n(y.VariableKind.FileDirname));case"fileExtname":return D.$oc(n(y.VariableKind.FileExtname));case"fileBasename":return D.$nc(n(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=D.$nc(n(y.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-D.$oc(a).length)}case"fileDirnameBasename":return D.$nc(D.$mc(n(y.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||S}case"execInstallFolder":{const a=this.a.getAppRoot();return a||S}case"pathSeparator":case"/":return D.sep;default:try{const a=i?`${d}:${i}`:d;return this.p(y.VariableKind.Unknown,S,a,o,void 0)}catch{return S}}}}p(p,S,d,f,o){if(d&&f){const i=o===void 0?f[d]:f[o+":"+d];if(typeof i=="string")return i;throw new y.$1N(p,(0,$.localize)(14,null,S))}return S}}e.$cO=C}),define(ke[142],Se([1,0,5,139]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.OpenEditorContext=e.GroupsOrder=e.$0C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9C=void 0,e.$9C=(0,D.$6h)("editorGroupsService");var g;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var I;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var R;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var b;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(S){const d=S;return(0,T.$SE)(d?.editor)&&(0,T.$SE)(d?.replacement)}e.$0C=y;var L;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(S){const d=S;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.$$C=m;function p(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_C=p}),define(ke[289],Se([1,0,5,142]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=void 0,e.$aD=(0,D.$6h)("editorService"),e.$bD=-1,e.$cD=-2,e.$dD=-3;function g(I){const R=I;return typeof I=="number"||(0,T.$$C)(R)}e.$eD=g}),define(ke[143],Se([1,0,5,133]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=void 0,e.$uK=(0,D.$7h)(T.$ai)}),define(ke[144],Se([1,0,26,4,17,3]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8b=e.$v8b=e.$u8b=e.$t8b=e.$s8b=void 0;class R{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.$s8b=R;class b{static isHostExtension(o,i,s){if(i.getExtensionDescription(o))return!1;const n=s.getExtensionDescription(o);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(o,i){this.j=o,this.c=new T.$Vd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new D.$nm,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const i=this.j.readActivationEvents(o);for(const s of i)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,i){this.e=d(this.e,i),this.e=this.e.concat(o);const s=b.l(this.e);return this.e=d(this.e,s.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,s)}static l(o){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,r){this.addNode(a),this.addNode(r),this.c.has(a)?this.c.get(a).push(r):this.c.set(a,[r])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,r){const h=i.getArcs(a);for(let u=0;u<h.length;u++)if(!r.has(h[u]))return!1;return!0}getNodes(){return this.e}},s=new D.$nm;for(const a of o)if(s.set(a.identifier,a),a.extensionDependencies)for(const r of a.extensionDependencies)i.addArc(D.$lm.toKey(a.identifier),D.$lm.toKey(r));const n=new Set;i.getNodes().filter(a=>i.getArcs(a).length===0).forEach(a=>n.add(a));const c=i.getNodes().filter(a=>!n.has(a));let t;do{t=!1;for(let a=0;a<c.length;a++){const r=c[a];i.hasOnlyGoodArcs(r,n)&&(c.splice(a,1),a--,n.add(r),t=!0)}}while(t);return c.map(a=>s.get(a))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this.h.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this.f.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this.g)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$t8b=b;class ${constructor(o,i){this.versionId=o,this.extensions=i}}e.$u8b=$;class y{constructor(o){this.d=new m,this.c=new b(o,[])}async acquireLock(o){const i=await this.d.acquire(o);return new L(this,i)}deltaExtensions(o,i,s){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this.c.getExtensionDescriptionByIdOrUUID(o,i)}}e.$v8b=y;class L extends I.$Tc{constructor(o,i){super(),this.f=o,this.c=!1,this.B(i)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$w8b=L;class C{constructor(o){this.name=o,this.promise=new Promise((i,s)=>{this.c=i})}resolve(o){this.c(o)}}class m{constructor(){this.c=[],this.d=!1}async acquire(o){const i=new C(o);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};o.resolve((0,I.$Rc)(n))}}var p;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(p||(p={}));function S(f,o){const i=f.isBuiltin?0:f.isUnderDevelopment?2:1,s=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==s)return i-s;const n=g.$gc.basename(f.extensionLocation.path),c=g.$gc.basename(o.extensionLocation.path);return n<c?-1:n>c?1:0}function d(f,o){const i=new D.$mm(o);return f.filter(s=>!i.has(s.identifier))}}),define(ke[290],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.ExtHostConnectionType=void 0;var D;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[T.ENV_KEY]=this.pipeName}}e.$Pm=T;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[g.ENV_KEY]="1"}}e.$Qm=g;class I{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[I.ENV_KEY]="1"}}e.$Rm=I;function R(L){delete L[T.ENV_KEY],delete L[g.ENV_KEY],delete L[I.ENV_KEY]}function b(L,C){R(C),L.serialize(C)}e.$Sm=b;function $(L){if(L[T.ENV_KEY])return y(L,new T(L[T.ENV_KEY]));if(L[g.ENV_KEY])return y(L,new g);if(L[I.ENV_KEY])return y(L,new I);throw new Error("No connection information defined in environment!")}e.$Tm=$;function y(L,C){return R(L),C}}),define(ke[113],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$um=e.$tm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(T||(e.UIKind=T={}));var g;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var I;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function R(y){const L=D.$je.alloc(1);switch(y){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.$tm=R;function b(y,L){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.$um=b;var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[91],Se([1,0,5,4,13,27,113,65,88,24,2,3,217]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.$tN=e.$sN=void 0;let p=class extends C.$Tc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new T.$Vd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Vd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=L.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$Qo,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(s=>{(0,g.$pj)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,s){const n=this.getTelemetryDetails(),c=new S(i,s,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(o,i,s){this.f=o,this.g=i,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=d(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$bl)((0,$.$Wo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((s,n)=>{const c=s.filter(t=>!t.isDisposed);c.length===0?this.r.delete(n):this.r.set(n,c)}),this.r.forEach(s=>{for(const n of s)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const n=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!n)return this.r.delete(o.value),!1;let c=!1;for(const t of n)t.ignoreUnhandledExtHostErrors||(t.logError(i),c=!0);return c}};e.$sN=p,e.$sN=p=Ge([Ve(0,I.$rN),Ve(1,g.$oj)],p);class S{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,s,n,c,t,a){this.g=s,this.h=n,this.i=c,this.j=t,this.a=new T.$Vd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,$.$Zo)(i,[]),this.c&&(i=(0,y.$yn)(i,this.c)),this.b||(i=(0,y.$yn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const s={name:o.name,message:o.message,stack:o.stack,cause:o.cause},n=(0,$.$Zo)(s,[]),c=new Error(n.message,{cause:n.cause});c.stack=n.stack,c.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$tN=S;function d(f){const o=Date.now()-new Date(f).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$uN=d,e.$vN=(0,D.$6h)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,261,137,26,5]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LF=e.$KF=e.$JF=e.ActivationKind=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=e.ExtensionHostStartup=e.$DF=e.$CF=e.$BF=e.$AF=void 0,e.$AF=Object.freeze({identifier:new R.$lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$BF="extensions.webWorker",e.$CF=(0,b.$6h)("extensionService");class ${constructor(c){this.dependency=c}}e.$DF=$;var y;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class L{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(c,t,a){this.c=c,this.d=t.slice(0),this.e=a.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$lF.createActivationEventsMap(this.d)}}set(c,t,a){if(this.c>c)throw new Error(`ExtensionHostExtensions: invalid versionId ${c} (current: ${this.c})`);const r=[],h=[],u=[],l=[],k=C(this.d),A=C(t),v=(z,F)=>z.extensionLocation.toString()===F.extensionLocation.toString()||z.isBuiltin===F.isBuiltin||z.isUserBuiltin===F.isUserBuiltin||z.isUnderDevelopment===F.isUnderDevelopment;for(const z of this.d){const F=A.get(z.identifier);if(!F){r.push(z.identifier),k.delete(z.identifier);continue}if(!v(z,F)){r.push(z.identifier),k.delete(z.identifier);continue}}for(const z of t){const F=k.get(z.identifier);if(!F){h.push(z);continue}if(!v(F,z)){r.push(F.identifier),k.delete(F.identifier);continue}}const w=new R.$mm(this.e),E=new R.$mm(a);for(const z of this.e)E.has(z)||u.push(z);for(const z of a)w.has(z)||l.push(z);const P=I.$lF.createActivationEventsMap(h),N={versionId:c,toRemove:r,toAdd:h,addActivationEvents:P,myToRemove:u,myToAdd:l};return this.delta(N),N}delta(c){if(this.c>=c.versionId)return null;const{toRemove:t,toAdd:a,myToRemove:r,myToAdd:h}=c,u=new R.$mm(t),l=new R.$mm(r);for(let k=0;k<this.d.length;k++)u.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)l.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of a)this.d.push(k);for(const k of h)this.e.push(k);return this.f=null,c}containsExtension(c){for(const t of this.e)if(R.$lm.equals(t,c))return!0;return!1}containsActivationEvent(c){return this.f||(this.f=this.g()),this.f.has(c)}g(){const c=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const a=I.$lF.readActivationEvents(t);for(const r of a)c.add(r)}return c}}e.$EF=L;function C(n){const c=new R.$nm;for(const t of n)c.set(t.identifier,t);return c}function m(n,c){return n.enabledApiProposals?n.enabledApiProposals.includes(c):!1}e.$FF=m;function p(n,c){if(!m(n,c))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.$GF=p;class S{constructor(c,t,a,r){this.codeLoadingTime=c,this.activateCallTime=t,this.activateResolvedTime=a,this.activationReason=r}}e.$HF=S;class d{constructor(c,t){this.description=c,this.value=t}}e.$IF=d;var f;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function o(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,g.$6o)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.$JF=o;function i(n,c){return{identifier:new R.$lm((0,g.$4o)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!c,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.$KF=i;class s{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activateById(c,t){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(c,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$LF=s}),define(ke[291],Se([1,0,14,144,26,25,13,11]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=e.$5gc=e.$4gc=e.$3gc=e.$2gc=e.$1gc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(o,i,s,n){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=s,this.activateResolvedTime=n}}e.$1gc=$;class y{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$2gc=y;class L{constructor(o,i,s,n,c,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=s,this.module=n,this.exports=c,this.subscriptions=t}}e.$3gc=L;class C extends L{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$4gc=C;class m extends L{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$5gc=m;class p extends L{constructor(o){super(!0,o,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(o,i,s,n){this.g=n,this.a=o,this.b=i,this.c=s,this.d=new g.$nm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,s]of this.d)o.push(s.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const s=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(s.map(n=>({id:n.identifier,reason:{startup:i,extensionId:n.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const s=this.a.getExtensionDescription(o);if(!s)throw new Error(`Extension '${o}' is not known`);return this.h([{id:s.identifier,reason:i}])}async h(o){const i=o.filter(s=>!this.isActivated(s.id)).map(s=>this.j(s));await Promise.all(i.map(s=>s.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const c=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new p(c));return this.c.onExtensionActivationError(o.id,c,new I.$DF(o.id.value)),t}const s=[],n=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const c of n){if(this.m(c))continue;const t=this.d.get(c);if(t){s.push(t);continue}if(this.l(c)){s.push(this.j({id:this.b.getExtensionDescription(c).identifier,reason:o.reason}));continue}const a=this.a.getExtensionDescription(c);if(a){if(!a.main&&!a.browser)continue;s.push(this.j({id:a.identifier,reason:o.reason}));continue}const r=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${c}'`),u=this.k(o,i.displayName,[],new p(h));return this.c.onExtensionActivationError(i.identifier,h,new I.$DF(c)),u}return this.k(o,i.displayName,s,null)}k(o,i,s,n){const c=new d(o.id,i,o.reason,s,n,this.c,this.g);return this.d.set(o.id,c),c}l(o){return T.$t8b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$6gc=S,e.$6gc=S=Ge([Ve(3,R.$nj)],S);let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,s,n,c,t,a){this.c=o,this.d=i,this.f=s,this.g=n,this.h=c,this.j=t,this.k=a,this.a=new b.$5g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const s=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);s.detail=i.value.activationFailedError,this.h=new p(s),this.j.onExtensionActivationError(this.c,s,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new p(i),this.b&&D.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};d=Ge([Ve(6,R.$nj)],d)}),define(ke[292],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[293],Se([1,0,233,14,39,134,108,37,26,292,136,137]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=void 0;const m=b.$Hn.as(R.$In.JSONContribution);class p{constructor(c,t,a){this.a=c,this.b=t,this.c=a}d(c,t){this.a({type:c,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(c){this.d(g.default.Error,c)}warn(c){this.d(g.default.Warning,c)}info(c){this.d(g.default.Info,c)}}e.$uF=p;class S{static a(c){const t=new $.$mm;for(let a=0,r=c.length;a<r;a++)t.add(c[a].description.identifier);return t}static compute(c,t){if(!c||!c.length)return new S(t,[]);if(!t||!t.length)return new S([],c);const a=this.a(c),r=this.a(t),h=t.filter(l=>!a.has(l.description.identifier)),u=c.filter(l=>!r.has(l.description.identifier));return new S(h,u)}constructor(c,t){this.added=c,this.removed=t}}e.$vF=S;class d{constructor(c,t){this.name=c,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(c){if(this.a!==null)throw new Error("Handler already set!");this.a=c,this.d()}acceptUsers(c){this.c=S.compute(this.b,c),this.b=c,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(c){(0,T.$1)(c)}}}e.$wF=d;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$xF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$km},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$mo}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$mo}},extensionKind:{description:D.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(c){if(this.a.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const t=new d(c.extensionPoint,c.defaultExtensionKind);return this.a.set(c.extensionPoint,t),c.activationEventsGenerator&&C.$lF.register(c.extensionPoint,c.activationEventsGenerator),e.$xF.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,m.registerSchema(o,e.$xF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$yF=i;const s={ExtensionsRegistry:"ExtensionsRegistry"};b.$Hn.add(s.ExtensionsRegistry,new i),e.$zF=b.$Hn.as(s.ExtensionsRegistry),m.registerSchema(o,e.$xF),m.registerSchema(L.$Gj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(ke[294],Se([1,0,229,18,24,293,45,4]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(m){function p(S,d,f){if(!S)return;const o=T.$If(S.type)?S.type:void 0;if(!o||o.length===0){f.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const s of S.required)T.$If(s)&&i.push(s);return{extensionId:d.value,taskType:o,required:i,properties:S.properties?g.$vn(S.properties):{},when:S.when?R.$4i.deserialize(S.when):void 0}}m.from=p})(y||(y={}));const L=I.$zF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,p)=>{for(const S of m)S.type&&p.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$Vd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,S)=>{L.setHandler((d,f)=>{this.c=void 0;try{for(const o of f.removed){const i=o.value;for(const s of i)this.a&&s.type&&this.a[s.type]&&delete this.a[s.type]}for(const o of f.added){const i=o.value;for(const s of i){const n=y.from(s,o.description.identifier,o.collector);n&&(this.a[n.taskType]=n)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const S of this.all()){const d={type:"object",additionalProperties:!1};S.required.length>0&&(d.required=S.required.slice(0)),S.properties!==void 0?d.properties=g.$vn(S.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[S.taskType]},p.push(d)}this.c={oneOf:p}}return this.c}}e.$xG=new C}),define(ke[295],Se([1,0,230,18,23,24,45,294]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$HG=e.JsonSchemaVersion=e.ExecutionEngine=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$BG=e.ShellQuoting=e.$AG=e.$zG=e.$yG=void 0,e.$yG="settings",e.$zG=new R.$kj("taskRunning",!1,D.localize(0,null)),e.$AG={value:D.localize(1,null),original:"Tasks"};var $;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$BG="$customized",function(M){function O(U){if(!U)return M.Strong;switch(U.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=O}($||(e.ShellQuoting=$={}));var y;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var L;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(L||(e.RevealKind=L={})),function(M){function O(U){switch(U.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=O}(L||(e.RevealKind=L={}));var C;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(M){function O(U){switch(U.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=O}(C||(e.RevealProblemKind=C={}));var m;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(m||(e.PanelKind=m={})),function(M){function O(U){switch(U.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=O}(m||(e.PanelKind=m={}));var p;(function(M){M.defaults={echo:!0,reveal:L.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var S;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(M){function O(Q){switch(Q.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=O;function U(Q){switch(Q){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=U}(S||(e.RuntimeType=S={}));var d;(function(M){function O(U){return T.$If(U)?U:U.value}M.value=O})(d||(e.CommandString=d={}));var f;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function O(Q){return Q===M.Clean._id||Q===M.Build._id||Q===M.Rebuild._id||Q===M.Test._id}M.is=O;function U(Q){if(Q!==void 0)return T.$If(Q)?O(Q)?{_id:Q,isDefault:!1}:void 0:Q}M.from=U})(f||(e.TaskGroup=f={}));var o;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function O(U){switch(U){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var s;(function(M){M.parallel="parallel",M.sequence="sequence"})(s||(e.DependsOrder=s={}));var n;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var c;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class t{constructor(O,U,Q,ue,Z,J){this._label="",this._id=O,U&&(this._label=U),Q&&(this.type=Q),this.runOptions=ue,this.configurationProperties=Z,this._source=J}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,U=!1){if(O===void 0)return!1;if(T.$If(O))return O===this._label||O===this.configurationProperties.identifier||U&&O===this._id;const Q=this.getDefinition(!0);return Q!==void 0&&Q._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$CG=t;class a extends t{constructor(O,U,Q,ue,Z,J,X,le){super(O,Q,void 0,X,le,U),this.command={},this._source=U,this.hasDefinedMatchers=J,Z&&(this.command=Z)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case S.Shell:U="shell";break;case S.Process:U="process";break;case S.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(O){return O instanceof a}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let U=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(U+=this._source.kind);const Q={type:e.$BG,folder:O,id:U};return JSON.stringify(Q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new a(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$DG=a;class r extends t{constructor(O,U,Q,ue,Z,J,X){super(O,Q,ue,J,X,U),this._source=U,this.configures=Z}static is(O){return O instanceof r}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let U=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(U+=this._source.kind);const Q={type:e.$BG,folder:O,id:U};return JSON.stringify(Q)}}e.$EG=r;class h extends t{constructor(O,U,Q,ue,Z,J,X,le,x){super(O,Q,ue,le,x,U),this.defines=Z,this.hasDefinedMatchers=X,this.command=J,this.icon=x.icon,this.hide=x.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof h}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new h(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$FG=h;class u extends t{constructor(O,U,Q,ue,Z,J){super(O,Q,ue,Z,J,U),this._source=U}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new u(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$GG=u;var l;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(M){M._default=M.Terminal}(l||(e.ExecutionEngine=l={}));var k;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class A{constructor(O){this.c=new Map;for(let U=0;U<O.length;U++)this.c.set(O[U].uri.toString(),U)}compare(O,U){const Q=O.getWorkspaceFolder(),ue=U.getWorkspaceFolder();if(Q&&ue){let Z=this.c.get(Q.uri.toString());Z=Z===void 0?0:Z+1;let J=this.c.get(ue.uri.toString());return J=J===void 0?0:J+1,Z===J?O._label.localeCompare(U._label):Z-J}else return!Q&&ue?-1:Q&&!ue?1:0}}e.$HG=A;var v;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(v||(e.TaskEventKind=v={}));var w;(function(M){M.SingleRun="singleRun",M.Background="background"})(w||(e.TaskRunType=w={}));var E;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var P;(function(M){function O(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function U(le,x,be){return{...O(le),kind:"start",terminalId:x,resolvedVariables:be}}M.start=U;function Q(le,x,be){return{...O(le),kind:"processStarted",terminalId:x,processId:be}}M.processStarted=Q;function ue(le,x,be){return{...O(le),kind:"processEnded",terminalId:x,exitCode:be}}M.processEnded=ue;function Z(le,x,be){return{...O(le),kind:"terminated",exitReason:be,terminalId:x}}M.terminated=Z;function J(le,x,be){return{...O(x),kind:le,terminalId:be}}M.general=J;function X(){return{kind:"changed"}}M.changed=X})(P||(e.TaskEvent=P={}));var N;(function(M){function O(Q){const ue=Object.keys(Q).sort();let Z="";for(const J of ue){let X=Q[J];X instanceof Object?X=O(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),Z+=J+","+X+","}return Z}function U(Q){const Z={_key:O(Q),type:Q.taskType};return Object.assign(Z,Q),Z}M.create=U})(N||(e.KeyedTaskIdentifier=N={}));var z;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var F;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var j;(function(M){function O(U,Q){const ue=b.$xG.get(U.type);if(ue===void 0){const le=I.$vn(U);return delete le._key,N.create(le)}const Z=Object.create(null);Z.type=ue.taskType;const J=new Set;ue.required.forEach(le=>J.add(le));const X=ue.properties;for(const le of Object.keys(X)){const x=U[le];if(x!=null)Z[le]=x;else if(J.has(le)){const be=X[le];if(be.default!==void 0)Z[le]=I.$vn(be.default);else switch(be.type){case"boolean":Z[le]=!1;break;case"number":case"integer":Z[le]=0;break;case"string":Z[le]="";break;default:Q.error(D.localize(2,null,JSON.stringify(U,void 0,0),le));return}}}return N.create(Z)}M.createTaskIdentifier=O})(j||(e.TaskDefinition=j={}))}),define(ke[296],Se([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y8b=e.$x8b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,b)=>{this.b=R,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,D.$1)(R))}then(R,b){return this.j().then(R,b)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$x8b=T;class g extends T{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$y8b=g}),define(ke[68],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$Qv=D;const T=[];function g(b){const $=new D(b);return T[$.nid]=$,$}e.$Rv=g;function I(b){return T[b].sid}e.$Sv=I;class R{constructor($){this.value=$}}e.$Tv=R}),define(ke[6],Se([1,0,68]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$K=e.$0K=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$9K=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var g;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput",d[d.ChatEditorInput=10]="ChatEditorInput"})(g||(e.TabInputKind=g={}));var I;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var R;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var b;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var L;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class C{static{this.a=0}static mixin(f){return f._id=C.a++,f}}e.$9K=C;var m;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var p;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var S;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$0K={MainThreadAuthentication:(0,D.$Rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Rv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Rv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Rv)("MainThreadClipboard"),MainThreadCommands:(0,D.$Rv)("MainThreadCommands"),MainThreadComments:(0,D.$Rv)("MainThreadComments"),MainThreadConfiguration:(0,D.$Rv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Rv)("MainThreadConsole"),MainThreadDebugService:(0,D.$Rv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Rv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Rv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Rv)("MainThreadLanguages"),MainThreadLogger:(0,D.$Rv)("MainThreadLogger"),MainThreadMessageService:(0,D.$Rv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Rv)("MainThreadOutputService"),MainThreadProgress:(0,D.$Rv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Rv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Rv)("MainThreadSecretState"),MainThreadStorage:(0,D.$Rv)("MainThreadStorage"),MainThreadSpeech:(0,D.$Rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Rv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Rv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Rv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Rv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Rv)("MainThreadSCM"),MainThreadSearch:(0,D.$Rv)("MainThreadSearch"),MainThreadShare:(0,D.$Rv)("MainThreadShare"),MainThreadTask:(0,D.$Rv)("MainThreadTask"),MainThreadWindow:(0,D.$Rv)("MainThreadWindow"),MainThreadLabelService:(0,D.$Rv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Rv)("MainThreadInteractive"),MainThreadChat:(0,D.$Rv)("MainThreadChat"),MainThreadInlineChat:(0,D.$Rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Rv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Rv)("MainThreadTimeline"),MainThreadTesting:(0,D.$Rv)("MainThreadTesting"),MainThreadLocalization:(0,D.$Rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Rv)("MainThreadIssueReporter")},e.$$K={ExtHostCommands:(0,D.$Rv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Rv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Rv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Rv)("ExtHostStatusBar"),ExtHostShare:(0,D.$Rv)("ExtHostShare"),ExtHostExtensionService:(0,D.$Rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Rv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Rv)("ExtHostSCM"),ExtHostSearch:(0,D.$Rv)("ExtHostSearch"),ExtHostTask:(0,D.$Rv)("ExtHostTask"),ExtHostWorkspace:(0,D.$Rv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Rv)("ExtHostWindow"),ExtHostWebviews:(0,D.$Rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Rv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Rv)("ExtHostProgress"),ExtHostComments:(0,D.$Rv)("ExtHostComments"),ExtHostSecretState:(0,D.$Rv)("ExtHostSecretState"),ExtHostStorage:(0,D.$Rv)("ExtHostStorage"),ExtHostUrls:(0,D.$Rv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Rv)("ExtHostOutputService"),ExtHostLabelService:(0,D.$Rv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Rv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Rv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Rv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Rv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Rv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Rv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Rv)("ExtHostTimeline"),ExtHostTesting:(0,D.$Rv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Rv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Rv)("ExtHostIssueReporter")}}),define(ke[92],Se([1,0,5,13,6,20]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=e.$rgc=void 0,e.$rgc=(0,D.$6h)("IExtHostApiDeprecationService");let R=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(g.$0K.MainThreadTelemetry)}report($,y,L){const C=this.d($,y);this.a.has(C)||(this.a.add(C),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$sgc=R,e.$sgc=R=Ge([Ve(0,I.$bN),Ve(1,T.$nj)],R),e.$tgc=Object.freeze(new class{report(b,$,y){}})}),define(ke[297],Se([1,0,6]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;class T{constructor(I){const R=I.getProxy(D.$0K.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(b){return R.$writeText(b)}})}}e.$Cgc=T}),define(ke[298],Se([1,0,24,6,27,20]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;let R=class{constructor(L,C){this.a=L.getProxy(T.$0K.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(L,C){const m=this,p=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){m.e(L,C,p,arguments)}})}e(L,C,m,p){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(p,this.b)}),this.c&&this.f(L,m,p)}};e.$tic=R,e.$tic=R=Ge([Ve(0,I.$bN),Ve(1,g.$rN)],R);const b=1e5;function $(y,L){const C=[];if(y.length)for(let m=0;m<y.length;m++){let p=y[m];if(typeof p>"u")p="undefined";else if(p instanceof Error){const S=p;S.stack?p=S.stack:p=S.toString()}C.push(p)}if(L){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,D.$An)(C);return m.length>b?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ke[299],Se([1,0,2,6,25]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class I{constructor(b){this.a=b.getProxy(T.$0K.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,g.$GF)(b,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(L=>D.URI.revive(L)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?D.URI.revive($):void 0)}}e.$xhc=I}),define(ke[300],Se([1,0,3,6]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;class g{constructor(R){this.b=0,this.a=R.getProxy(T.$0K.MainThreadLabelService)}$registerResourceLabelFormatter(R){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,R),(0,D.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Shc=g}),define(ke[114],Se([1,0,10,12,2,5,13,6,27,20]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=e.$fhc=void 0;let L=class{constructor(m,p,S){this.f=S,this.d=new Map,this.a=p.getProxy(b.$0K.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===D.$g}getMessage(m,p){const{message:S,args:d,comment:f}=p;if(this.c)return(0,T.$Le)(S,d??{});let o=S;f&&f.length>0&&(o+=`/${Array.isArray(f)?f.join(""):f}`);const i=this.d.get(m)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,T.$Le)(i??S,d??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let p;const S=await this.g(m);if(!S){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(S),f=JSON.parse(d);p=m.isBuiltin?f.contents?.bundle:f}catch(d){this.f.error(`Failed to load translations for ${m.identifier.value} from ${S}: ${d.message}`);return}p&&this.d.set(m.identifier.value,{contents:p,uri:S})}async g(m){if(m.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return g.URI.revive(p)}return m.l10n?g.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$fhc=L,e.$fhc=L=Ge([Ve(0,$.$rN),Ve(1,y.$bN),Ve(2,R.$nj)],L),e.$ghc=(0,I.$6h)("IExtHostLocalizationService")}),define(ke[145],Se([1,0,13,6,27,20,2,55]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=void 0;let $=class extends D.$yj{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(p=>(0,b.$Ch)(p))),this.r=C.getProxy(T.$0K.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(R.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,p){return new y(this.r,C,m,p)}};e.$sic=$,e.$sic=$=Ge([Ve(0,I.$bN),Ve(1,g.$rN)],$);class y extends D.$tj{constructor(C,m,p,S){super(S?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(m,S).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const p=[[C,m]];this.m?this.u(p):this.n.push(...p)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[115],Se([1,0,6,5,3,20,22]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=e.$hhc=void 0,e.$hhc=(0,T.$6h)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$0K.MainThreadManagedSockets)}setFactory(C,m){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,p=await this.c.makeConnection(),S=new g.$Sc;return this.d.set(m,new y(m,p,S)),S.add((0,g.$Rc)(()=>this.d.delete(m))),S.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),S.dispose()})),S.add(p.onDidClose(d=>{this.a.$onDidManagedSocketClose(m,d?.stack??d?.message),S.dispose()})),S.add(p.onDidReceiveMessage(d=>this.a.$onDidManagedSocketHaveData(m,R.$je.wrap(d)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$ihc=b,e.$ihc=b=Ge([Ve(0,I.$bN)],b);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class y extends g.$Tc{constructor(C,m,p){super(),this.socketId=C,this.actual=m,this.B(p)}}}),define(ke[301],Se([1,0,6,13,25]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;function I(b){return b&&b.title}let R=class{constructor($,y){this.b=y,this.a=$.getProxy(D.$0K.MainThreadMessageService)}showMessage($,y,L,C,m){const p={source:{identifier:$.identifier,label:$.displayName||$.name}};let S;typeof C=="string"||I(C)?S=[C,...m]:(p.modal=C?.modal,p.useCustom=C?.useCustom,p.detail=C?.detail,S=m),p.useCustom&&(0,g.$GF)($,"resolvers");const d=[];let f=!1;for(let o=0;o<S.length;o++){const i=S[o];if(typeof i=="string")d.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:s,isCloseAffordance:n}=i;d.push({title:s,isCloseAffordance:!!n,handle:o}),n&&(f?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):f=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(y,L,p,d).then(o=>{if(typeof o=="number")return S[o]})}};e.$Uhc=R,e.$Uhc=R=Ge([Ve(1,T.$nj)],R)}),define(ke[302],Se([1,0,3,18,2,25,6]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class b{constructor(y){this.b=new Map,this.a=y.getProxy(R.$0K.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,L,C){if((0,I.$GF)(y,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,C),this.a.$registerProfileContentHandler(L,C.name,C.description,y.identifier.value),(0,D.$Rc)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(y,L,C,m){const p=this.b.get(y);if(!p)throw new Error(`Unknown handler with id: ${y}`);return p.saveProfile(L,C,m)}async $readProfile(y,L,C){const m=this.b.get(y);if(!m)throw new Error(`Unknown handler with id: ${y}`);return m.readProfile((0,T.$If)(L)?L:g.URI.revive(L),C)}}e.$4hc=b}),define(ke[116],Se([1,0,6,4,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=void 0;class I{constructor(b){this.b=new T.$Vd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(D.$0K.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,y){return this.a.$setPassword(b,$,y)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$chc=I,e.$dhc=(0,g.$6h)("IExtHostSecretState")}),define(ke[303],Se([1,0,21,3,6]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;class I{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(g.$0K.MainThreadSpeech)}async $createSpeechToTextSession(b,$){const y=this.c.get(b);if(!y)return;const L=new T.$Sc,C=new D.$6d;this.d.set($,C);const m=L.add(y.provideSpeechToTextSession(C.token));L.add(m.onDidChange(p=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,p)})),L.add(C.token.onCancellationRequested(()=>L.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,y){const L=I.a++;return this.c.set(L,y),this.b.$registerProvider(L,$,{extension:b,displayName:b.value}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(L),this.c.delete(L)})}}e.$$hc=I}),define(ke[117],Se([1,0,6,4,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=e.$7gc=void 0;class I{constructor(b,$){this.c=$,this.b=new T.$Vd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(D.$0K.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,y){const L=await this.a.$initializeExtensionStorage(b,$);let C;return L&&(C=this.d(b,$,L)),C||y}setValue(b,$,y){return this.a.$setValue(b,$,y)}$acceptValue(b,$,y){const L=this.d(b,$,y);L&&this.b.fire({shared:b,key:$,value:L})}d(b,$,y){try{return JSON.parse(y)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${L}`)}}}e.$7gc=I,e.$8gc=(0,g.$6h)("IExtHostStorage")}),define(ke[304],Se([1,0,3,16,2,6]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(I.$0K.MainThreadUriOpeners)}registerExternalUriOpener($,y,L,C){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const m=C.schemes.find(p=>!R.a.has(p));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(y,L),this.b.$registerUriOpener(y,C.schemes,$,C.label),(0,D.$Rc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,L){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=g.URI.revive(y);return C.canOpenExternalUri(m,L)}async $openUri($,y,L){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(g.URI.revive(y.resolvedUri),{sourceUri:g.URI.revive(y.sourceUri)},L)}}e.$mic=R}),define(ke[305],Se([1,0,6,2,3,14,26]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;class b{static{this.a=0}constructor(y){this.c=new R.$mm,this.d=new Map,this.b=y.getProxy(D.$0K.MainThreadUrls)}registerUriHandler(y,L){const C=y.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=b.a++;return this.c.add(C),this.d.set(m,L),this.b.$registerUriHandler(m,C,y.displayName||y.name),(0,g.$Rc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(y,L){const C=this.d.get(y);if(!C)return Promise.resolve(void 0);try{C.handleUri(T.URI.revive(L))}catch(m){(0,I.$1)(m)}return Promise.resolve(void 0)}async createAppUri(y){return T.URI.revive(await this.b.$createAppUri(y))}}e.$nic=b}),define(ke[93],Se([1,0,4,3,16,24,2,237,274,112,6]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=void 0;class C{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;constructor(n,c,t,a,r,h,u){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Vd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Vd,this._onDidDispose=this.#h.event,this.#e=n,this.#t=c,this.#s=t,this.#o=a,this.#n=r,this.#r=h,this.#l=m(h),this.#d=p(h),this.#i=u}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#u=!0,(0,y.$Dvb)(n,this.#o)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===g.Schemas.https||n.scheme===g.Schemas.http){let c=n.toString();return c.endsWith("/")||(c+="/"),c+" "+y.$Cvb}return y.$Cvb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#s}set options(n){this.a(),I.$zn(this.#s,n)||this.#t.$setOptions(this.#e,f(this.#r,this.#n,n)),this.#s=n}async postMessage(n){if(this.#c)return!1;const c=(0,$.$hlb)(n,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,c.message,...c.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const c=this.#r.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,r,h,u,l,k)=>{const A=R.URI.from({scheme:u||"file",path:decodeURIComponent(l)}),v=(0,y.$Dvb)(A,{isRemote:c,authority:t}).toString();return`${r}${v}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,r,h,u,l,k)=>{const A=R.URI.from({scheme:u||"file",path:decodeURIComponent(l)}),v=(0,y.$Dvb)(A,{isRemote:c,authority:t}).toString();return`${r}${v}${k}`})}}e.$Rgc=C;function m(s){try{const n=(0,b.$cp)((0,b.$bp)(s.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}e.$Sgc=m;function p(s){try{const n=(0,b.$cp)((0,b.$bp)(s.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class S extends T.$Tc{constructor(n,c,t,a,r){super(),this.c=c,this.f=t,this.g=a,this.h=r,this.b=new Map,this.a=n.getProxy(L.$0K.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,c,t){const a=this.j(n);if(a){const{message:r}=(0,$.$ilb)(c,t.value);a._onMessageEmitter.fire(r)}}$onMissingCsp(n,c){this.g.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,c,t){const a=new C(n,this.a,o(c),this.c,this.f,t,this.h);this.b.set(n,a);const r=a._onDidDispose(()=>{r.dispose(),this.deleteWebview(n)});return a}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$Tgc=S;function d(s){return{id:s.identifier,location:s.extensionLocation}}e.$Ugc=d;function f(s,n,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||i(s,n)}}e.$Vgc=f;function o(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(n=>R.URI.from(n))}}function i(s,n){return[...(n?.getWorkspaceFolders()||[]).map(c=>c.uri),s.extensionLocation]}}),define(ke[146],Se([1,0,4,6,2,16,12,5,20,25]),function(me,e,D,T,g,I,R,b,$,y){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=e.$pic=void 0;let C=class{static{L=this}static{this.a={focused:!0,active:!0}}getState(p){const S=this.d;return{get focused(){return S.focused},get active(){return(0,y.$GF)(p,"windowActivity"),S.active}}}constructor(p){this.c=new D.$Vd,this.onDidChangeWindowState=this.c.event,this.d=L.a,this.b=p.getProxy(T.$0K.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:d})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,S){S!==this.d[p]&&(this.d={...this.d,[p]:S},this.c.fire(this.d))}openUri(p,S){let d;if(typeof p=="string"){d=p;try{p=g.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,R.$Je)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,d,S)}async asExternalUri(p,S){if((0,R.$Je)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(p,S);return g.URI.from(d)}};e.$pic=C,e.$pic=C=L=Ge([Ve(0,$.$bN)],C),e.$qic=(0,b.$6h)("IExtHostWindow")}),define(ke[306],Se([1,0,298,27,20]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;const I=1024*1024;let R=class extends D.$tic{constructor($,y){super($,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,y,L){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),y.apply(console,L),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,y){const L=process[$],C=L.write;let m="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(p,S,d)=>{if(!this.g){m+=p.toString(S);const f=m.length>I?m.length:m.lastIndexOf(`
`);f!==-1&&(console[y](m.slice(0,f)),m=m.slice(f+1))}C.call(L,p,S,d)}})}};e.$5ic=R,e.$5ic=R=Ge([Ve(0,g.$bN),Ve(1,T.$rN)],R)}),define(ke[307],Se([1,0,145,16,251,30]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=void 0;class R extends D.$sic{s($,y,L){return $.scheme===T.Schemas.file?new g.$nO(L?.name||(0,I.$qg)(),$.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,y):super.s($,y,L)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$ejc=R}),define(ke[308],Se([1,0,11,22,21,14,4,3,130,296,68]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$B8b=e.ResponsiveState=e.RequestInitiator=e.$A8b=e.$z8b=void 0;function m(E,P){try{return JSON.stringify(E,P)}catch{return"null"}}const p="$$ref$$",S={[p]:-1};class d{constructor(P,N){this.jsonString=P,this.referencedBuffers=N}}function f(E,P=null,N=!1){const z=[];return{jsonString:(N?m:JSON.stringify)(E,(j,M)=>{if(typeof M>"u")return S;if(typeof M=="object"){if(M instanceof T.$je){const O=z.push(M)-1;return{[p]:O}}if(P)return P(j,M)}return M}),referencedBuffers:z}}e.$z8b=f;function o(E,P,N){return JSON.parse(E,(z,F)=>{if(F){const j=F[p];if(typeof j=="number")return P[j];if(N&&F.$mid===1)return N.transformIncoming(F)}return F})}e.$A8b=o;function i(E,P){return JSON.stringify(E,P)}function s(E){return E?(P,N)=>N&&N.$mid===1?E.transformOutgoing(N):N:null}var n;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var c;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const t=()=>{},a=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class h extends b.$Tc{static{C=a}static{this.a=3*1e3}constructor(P,N=null,z=null){super(),this[C]=!0,this.b=this.B(new R.$Vd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=N,this.g=z,this.h=s(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,j=L.$Qv.count;F<j;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$fh(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const N=this.w[P];delete this.w[P],N.resolveErr(I.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+h.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+h.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,$.$7m)(P,this.g):P}getProxy(P){const{nid:N,sid:z}=P;return this.s[N]||(this.s[N]=this.J(N,z)),this.s[N]}J(P,N){const z={get:(F,j)=>(typeof j=="string"&&!F[j]&&j.charCodeAt(0)===36&&(F[j]=(...M)=>this.U(P,j,M)),j===r?N:F[j])};return new Proxy(Object.create(null),z)}set(P,N){return this.m[P.nid]=N,N}assertRegistered(P){for(let N=0,z=P.length;N<z;N++){const F=P[N];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(P){if(this.j)return;const N=P.byteLength,z=l.read(P,0),F=z.readUInt8(),j=z.readUInt32();switch(F){case 1:case 2:{let{rpcId:M,method:O,args:U}=A.deserializeRequestJSONArgs(z);this.g&&(U=(0,$.$7m)(U,this.g)),this.M(N,j,M,O,U,F===2);break}case 3:case 4:{let{rpcId:M,method:O,args:U}=A.deserializeRequestMixedArgs(z);this.g&&(U=(0,$.$7m)(U,this.g)),this.M(N,j,M,O,U,F===4);break}case 5:{this.f?.logIncoming(N,j,0,"ack"),this.G(j);break}case 6:{this.N(N,j);break}case 7:{this.O(N,j,void 0);break}case 9:{let M=A.deserializeReplyOKJSON(z);this.g&&(M=(0,$.$7m)(M,this.g)),this.O(N,j,M);break}case 10:{const M=A.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(N,j,M);break}case 8:{const M=A.deserializeReplyOKVSBuffer(z);this.O(N,j,M);break}case 11:{let M=A.deserializeReplyErrError(z);this.g&&(M=(0,$.$7m)(M,this.g)),this.P(N,j,M);break}case 12:{this.P(N,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,N,z,F,j,M){this.f?.logIncoming(P,N,1,`receiveRequest ${(0,L.$Sv)(z)}.${F}(`,j);const O=String(N);let U,Q;if(M){const Z=new g.$6d;j.push(Z.token),U=this.Q(z,F,j),Q=()=>Z.cancel()}else U=this.Q(z,F,j),Q=t;this.u[O]=Q;const ue=A.serializeAcknowledged(N);this.f?.logOutgoing(ue.byteLength,N,1,"ack"),this.c.send(ue),U.then(Z=>{delete this.u[O];const J=A.serializeReplyOK(N,Z,this.h);this.f?.logOutgoing(J.byteLength,N,1,"reply:",Z),this.c.send(J)},Z=>{delete this.u[O];const J=A.serializeReplyErr(N,Z);this.f?.logOutgoing(J.byteLength,N,1,"replyErr:",Z),this.c.send(J)})}N(P,N){this.f?.logIncoming(P,N,1,"receiveCancel");const z=String(N);this.u[z]?.()}O(P,N,z){this.f?.logIncoming(P,N,0,"receiveReply:",z);const F=String(N);if(!this.w.hasOwnProperty(F))return;const j=this.w[F];delete this.w[F],j.resolveOk(z)}P(P,N,z){this.f?.logIncoming(P,N,0,"receiveReplyErr:",z);const F=String(N);if(!this.w.hasOwnProperty(F))return;const j=this.w[F];delete this.w[F];let M;z&&(z.$isError?(M=new Error,M.name=z.name,M.message=z.message,M.stack=z.stack):M=z),j.resolveErr(M)}Q(P,N,z){try{return Promise.resolve(this.S(P,N,z))}catch(F){return Promise.reject(F)}}S(P,N,z){const F=this.m[P];if(!F)throw new Error("Unknown actor "+(0,L.$Sv)(P));const j=F[N];if(typeof j!="function")throw new Error("Unknown method "+N+" on actor "+(0,L.$Sv)(P));return j.apply(F,z)}U(P,N,z){if(this.j)return new y.$y8b;let F=null;if(z.length>0&&g.CancellationToken.isCancellationToken(z[z.length-1])&&(F=z.pop()),F&&F.isCancellationRequested)return Promise.reject(I.$6());const j=A.serializeRequestArguments(z,this.h),M=++this.t,O=String(M),U=new y.$x8b,Q=new b.$Sc;F&&Q.add(F.onCancellationRequested(()=>{const Z=A.serializeCancel(M);this.f?.logOutgoing(Z.byteLength,M,0,"cancel"),this.c.send(A.serializeCancel(M))})),this.w[O]=new u(U,Q),this.F(M);const ue=A.serializeRequest(M,P,N,j,!!F);return this.f?.logOutgoing(ue.byteLength,M,0,`request: ${(0,L.$Sv)(P)}.${N}(`,z),this.c.send(ue),U}}e.$B8b=h;class u{constructor(P,N){this.a=P,this.b=N}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class l{static alloc(P,N,z){const F=new l(T.$je.alloc(z+1+4),0);return F.writeUInt8(P),F.writeUInt32(N),F}static read(P,N){return new l(P,N)}get buffer(){return this.a}constructor(P,N){this.a=P,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+P).toString();return this.b+=P,z}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+P).toString();return this.b+=P,z}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P);return this.b+=P,N}static sizeMixedArray(P){let N=0;N+=1;for(let z=0,F=P.length;z<F;z++){const j=P[z];switch(N+=1,j.type){case 1:N+=this.sizeLongString(j.value);break;case 2:N+=this.sizeVSBuffer(j.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(j.value);for(let M=0;M<j.buffers.length;++M)N+=this.sizeVSBuffer(j.buffers[M]);break;case 4:break}}return N}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let N=0,z=P.length;N<z;N++){const F=P[N];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let j=0;j<F.buffers.length;++j)this.writeBuffer(F.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const N=new Array(P);for(let z=0;z<P;z++)switch(this.readUInt8()){case 1:N[z]=this.readLongString();break;case 2:N[z]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),M=this.readLongString(),O=[];for(let U=0;U<j;++U)O.push(this.readVSBuffer());N[z]=new L.$Tv(o(M,O,null));break}case 4:N[z]=void 0;break}return N}}var k;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(k||(k={}));class A{static a(P){for(let N=0,z=P.length;N<z;N++)if(P[N]instanceof T.$je||P[N]instanceof L.$Tv||typeof P[N]>"u")return!0;return!1}static serializeRequestArguments(P,N){if(this.a(P)){const z=[];for(let F=0,j=P.length;F<j;F++){const M=P[F];if(M instanceof T.$je)z[F]={type:2,value:M};else if(typeof M>"u")z[F]={type:4};else if(M instanceof L.$Tv){const{jsonString:O,referencedBuffers:U}=f(M.value,N);z[F]={type:3,value:T.$je.fromString(O),buffers:U}}else z[F]={type:1,value:T.$je.fromString(i(M,N))}}return{type:1,args:z}}return{type:0,args:i(P,N)}}static serializeRequest(P,N,z,F,j){switch(F.type){case 0:return this.b(P,N,z,F.args,j);case 1:return this.c(P,N,z,F.args,j)}}static b(P,N,z,F,j){const M=T.$je.fromString(z),O=T.$je.fromString(F);let U=0;U+=l.sizeUInt8(),U+=l.sizeShortString(M),U+=l.sizeLongString(O);const Q=l.alloc(j?2:1,P,U);return Q.writeUInt8(N),Q.writeShortString(M),Q.writeLongString(O),Q.buffer}static deserializeRequestJSONArgs(P){const N=P.readUInt8(),z=P.readShortString(),F=P.readLongString();return{rpcId:N,method:z,args:JSON.parse(F)}}static c(P,N,z,F,j){const M=T.$je.fromString(z);let O=0;O+=l.sizeUInt8(),O+=l.sizeShortString(M),O+=l.sizeMixedArray(F);const U=l.alloc(j?4:3,P,O);return U.writeUInt8(N),U.writeShortString(M),U.writeMixedArray(F),U.buffer}static deserializeRequestMixedArgs(P){const N=P.readUInt8(),z=P.readShortString(),F=P.readMixedArray(),j=new Array(F.length);for(let M=0,O=F.length;M<O;M++){const U=F[M];typeof U=="string"?j[M]=JSON.parse(U):j[M]=U}return{rpcId:N,method:z,args:j}}static serializeAcknowledged(P){return l.alloc(5,P,0).buffer}static serializeCancel(P){return l.alloc(6,P,0).buffer}static serializeReplyOK(P,N,z){if(typeof N>"u")return this.d(P);if(N instanceof T.$je)return this.e(P,N);if(N instanceof L.$Tv){const{jsonString:F,referencedBuffers:j}=f(N.value,z,!0);return this.g(P,F,j)}else return this.f(P,m(N,z))}static d(P){return l.alloc(7,P,0).buffer}static e(P,N){let z=0;z+=l.sizeVSBuffer(N);const F=l.alloc(8,P,z);return F.writeVSBuffer(N),F.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,N){const z=T.$je.fromString(N);let F=0;F+=l.sizeLongString(z);const j=l.alloc(9,P,F);return j.writeLongString(z),j.buffer}static g(P,N,z){const F=T.$je.fromString(N);let j=0;j+=l.sizeUInt32,j+=l.sizeLongString(F);for(const O of z)j+=l.sizeVSBuffer(O);const M=l.alloc(10,P,j);M.writeUInt32(z.length),M.writeLongString(F);for(const O of z)M.writeBuffer(O);return M.buffer}static deserializeReplyOKJSON(P){const N=P.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(P,N){const z=P.readUInt32(),F=P.readLongString(),j=[];for(let M=0;M<z;++M)j.push(P.readVSBuffer());return new L.$Tv(o(F,j,N))}static serializeReplyErr(P,N){const z=N?m(I.$3(N),null):void 0;if(typeof z!="string")return this.h(P);const F=T.$je.fromString(z);let j=0;j+=l.sizeLongString(F);const M=l.alloc(11,P,j);return M.writeLongString(F),M.buffer}static deserializeReplyErrError(P){const N=P.readLongString();return JSON.parse(N)}static h(P){return l.alloc(12,P,0).buffer}}var v;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var w;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(w||(w={}))}),define(ke[309],Se([1,0,22,28,16,84,5]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XI=e.$WI=e.$VI=e.$UI=void 0,e.$UI=(0,R.$6h)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${b.join("")}]+`),y=7;function L(p){if(p.scheme!==g.Schemas.vscodeNotebookCell)return;const S=p.fragment.indexOf("s");if(S<0)return;const d=parseInt(p.fragment.substring(0,S).replace($,""),y),f=(0,D.$Ce)(p.fragment.substring(S+1)).toString();if(!isNaN(d))return{handle:d,notebook:p.with({scheme:f,fragment:null})}}e.$VI=L;function C(p,S){const d=S.toString(y),o=`${d.length<b.length?b[d.length-1]:"z"}${d}s${(0,D.$De)(D.$je.fromString(p.scheme),!0,!0)}`;return p.with({scheme:g.Schemas.vscodeNotebookCell,fragment:o})}e.$WI=C;class m{constructor(){this.a=new T.$Ac}getNotebook(S){if(S.scheme===g.Schemas.vscodeNotebookCell){const d=L(S);if(d){const f=this.a.get(d.notebook);if(f)return f}}return this.a.get(S)}addNotebookDocument(S){this.a.set(S.uri,S)}removeNotebookDocument(S){this.a.delete(S.uri)}}e.$XI=m,(0,I.$Yr)(e.$UI,m,1)}),define(ke[118],Se([1,0,22,34,53,101,16,17,10,45,309]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.CellStatusbarAlignment=e.$_I=e.$$I=e.$0I=e.NotebookEditorPriority=e.$9I=e.$8I=e.$7I=e.$6I=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$5I=e.$4I=e.$3I=e.$2I=e.CellKind=e.$1I=e.$ZI=e.$YI=void 0,e.$YI="workbench.editor.notebook",e.$ZI="workbench.editor.notebookTextDiffEditor",e.$1I="workbench.editor.interactive";var C;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(C||(e.CellKind=C={})),e.$2I=["application/json","application/javascript","text/html","image/svg+xml",I.$fs.latex,I.$fs.markdown,"image/png","image/jpeg",I.$fs.text],e.$3I=[I.$fs.latex,I.$fs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$fs.text],e.$4I=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$5I="_notAvailable";var m;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(m||(e.NotebookRunState=m={}));var p;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var S;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var d;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(d||(e.NotebookRendererMatch=d={}));var f;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var o;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var s;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(s||(e.CellEditType=s={}));var n;(function(U){U.scheme=R.Schemas.vscodeNotebookCell;function Q(x,be){return(0,L.$WI)(x,be)}U.generate=Q;function ue(x){return(0,L.$VI)(x)}U.parse=ue;function Z(x,be){return x.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${be??""},${x.scheme!==R.Schemas.file?x.scheme:""}`})}U.generateCellOutputUri=Z;function J(x){if(x.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const be=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!be)return;const ce=be[1]&&be[1]!==""?be[1]:void 0,G=be[2];return{outputId:ce,notebook:x.with({scheme:G||R.Schemas.file,fragment:null})}}U.parseCellOutputUri=J;function X(x,be,ce){return U.generate(x,be).with({scheme:ce})}U.generateCellPropertyUri=X;function le(x,be){if(x.scheme===be)return U.parse(x.with({scheme:U.scheme}))}U.parseCellPropertyUri=le})(n||(e.CellUri=n={}));const c=U=>$.$i?U.replace(/\//g,"\\"):U;class t{constructor(Q=[],ue=e.$2I){this.e=ue,this.d=[...new Set(Q)].map(Z=>({pattern:Z,matches:T.$Mj(c(Z))}))}sort(Q){const ue=new Map(g.Iterable.map(Q,J=>[J,c(J)]));let Z=[];for(const{matches:J}of this.d)for(const[X,le]of ue)if(J(le)){Z.push(X),ue.delete(X);break}return ue.size&&(Z=Z.concat([...ue.keys()].sort((J,X)=>this.e.indexOf(J)-this.e.indexOf(X)))),Z}prioritize(Q,ue){const Z=this.f(Q);if(Z===-1){this.d.unshift({pattern:Q,matches:T.$Mj(c(Q))});return}const J=new Set(ue.map(le=>this.f(le,Z)));J.delete(-1);const X=Array.from(J).sort();this.d.splice(Z+1,0,...X.map(le=>this.d[le]));for(let le=X.length-1;le>=0;le--)this.d.splice(X[le],1)}toArray(){return this.d.map(Q=>Q.pattern)}f(Q,ue=this.d.length){const Z=c(Q);for(let J=0;J<ue;J++)if(this.d[J].matches(Z))return J;return-1}}e.$6I=t;function a(U,Q,ue,Z=(J,X)=>J===X){const J=[];function X(be,ce,G){if(ce===0&&G.length===0)return;const W=J[J.length-1];W&&W.start+W.deleteCount===be?(W.deleteCount+=ce,W.toInsert.push(...G)):J.push({start:be,deleteCount:ce,toInsert:G})}let le=0,x=0;for(;;){if(le===U.length){X(le,0,Q.slice(x));break}if(x===Q.length){X(le,U.length-le,[]);break}const be=U[le],ce=Q[x];if(Z(be,ce)){le+=1,x+=1;continue}ue(ce)?(X(le,1,[]),le+=1):(X(le,0,[ce]),x+=1)}return J}e.$7I=a,e.$8I=new y.$kj("notebookEditorCursorAtBoundary","none"),e.$9I=new y.$kj("notebookEditorCursorAtLineBoundary","none");var r;(function(U){U.default="default",U.option="option"})(r||(e.NotebookEditorPriority=r={}));function h(U){const Q=U;return!!((typeof Q.include=="string"||T.$Nj(Q.include))&&(typeof Q.exclude=="string"||T.$Nj(Q.exclude)))}e.$0I=h;function u(U,Q,ue){if(Array.isArray(U.viewType)&&U.viewType.indexOf(Q)>=0||U.viewType===Q)return!0;if(U.filenamePattern){const Z=h(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,J=h(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(T.$Lj(Z,(0,b.$nc)(ue.fsPath).toLowerCase()))return!(J&&T.$Lj(J,(0,b.$nc)(ue.fsPath).toLowerCase()))}return!1}e.$$I=u,e.$_I={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var l;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class k{static{this.d="notebook/"}static create(Q){return`${k.d}${Q}`}static parse(Q){if(Q.startsWith(k.d))return Q.substring(k.d.length)}}e.$aJ=k;function A(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.$bJ=A;const v=new TextDecoder;function w(U){const Q=[];let ue=!1;for(const le of U)(Q.length===0||ue)&&(Q.push(le),ue=!0);let Z=N(Q);const J=D.$je.concat(Q.map(le=>D.$je.wrap(le))),X=O(J);return Z=Z||X.byteLength!==J.byteLength,{data:X,didCompression:Z}}e.$cJ=w,e.$dJ=`${String.fromCharCode(27)}[A`;const E=e.$dJ.split("").map(U=>U.charCodeAt(0)),P=10;function N(U){let Q=!1;return U.forEach((ue,Z)=>{if(Z===0||ue.length<e.$dJ.length)return;const J=U[Z-1],X=ue.subarray(0,e.$dJ.length);if(X[0]===E[0]&&X[1]===E[1]&&X[2]===E[2]){const le=J.lastIndexOf(P);if(le===-1)return;Q=!0,U[Z-1]=J.subarray(0,le),U[Z]=ue.subarray(e.$dJ.length)}}),Q}function z(U){let Q=U;do U=Q,Q=U.replace(/[^\n]\x08/gm,"");while(Q.length<U.length);return U}function F(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const Q=U.match(/^(.*)\r+/m)[1];let ue=U.match(/\r+(.*)$/m)[1];ue=ue+Q.slice(ue.length,Q.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return U}const j="\b".charCodeAt(0),M="\r".charCodeAt(0);function O(U){return!U.buffer.includes(j)&&!U.buffer.includes(M)?U:D.$je.fromString(F(z(v.decode(U.buffer))))}}),define(ke[7],Se([1,0,19,14,80,28,101,12,18,2,30,26,32,64,118]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S){"use strict";var d,f,o,i,s,n,c,t,a,r,h,u,l,k,A,v,w;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$3M=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$2M=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.TestRunProfileKind=e.TestResultState=e.$HM=e.$GM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$FM=e.NotebookVariablesRequestKind=e.$EM=e.$DM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$CM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.ColorThemeKind=e.$wM=e.$vM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$uM=e.DebugConsoleMode=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$oM=e.$nM=e.FileChangeType=e.$mM=e.$lM=e.$kM=e.$jM=e.InlineCompletionTriggerKind=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.ConfigurationTarget=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$YL=e.ViewBadge=e.ProgressLocation=e.$XL=e.$WL=e.TaskScope=e.ShellQuoting=e.$VL=e.$UL=e.$TL=e.TaskPanelKind=e.TaskRevealKind=e.$SL=e.TerminalLocation=e.$RL=e.$QL=e.$PL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$OL=e.$NL=e.$ML=e.$LL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$KL=e.StatusBarAlignment=e.ViewColumn=e.$JL=e.$IL=e.$HL=e.$GL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$FL=e.$EL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.LanguageStatusSeverity=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.CodeActionTriggerKind=e.$sL=e.$rL=e.SymbolTag=e.SymbolKind=e.$qL=e.$pL=e.DocumentHighlightKind=e.$oL=e.$nL=e.$mL=e.$lL=e.DiagnosticSeverity=e.DiagnosticTag=e.$kL=e.$jL=e.FileEditType=e.$iL=e.$hL=e.$gL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function E(H){return Object.assign(H,{apply:function(...ve){if(ve.length===0)return Reflect.construct(H,[]);{const Te=ve.length===1?[]:ve[1];return Reflect.construct(H,Te,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(H,[]);{const[Te,...Ze]=ve;return Reflect.construct(H,Ze,Te.constructor)}}})}var P;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var N;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let z=d=class{static from(...V){let ve=V;return new d(function(){if(ve){for(const Te of ve)Te&&typeof Te.dispose=="function"&&Te.dispose();ve=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$_K=z,e.$_K=z=d=Ge([E],z);let F=f=class{static Min(...V){if(V.length===0)throw new TypeError;let ve=V[0];for(let Te=1;Te<V.length;Te++){const Ze=V[Te];Ze.isBefore(ve)&&(ve=Ze)}return ve}static Max(...V){if(V.length===0)throw new TypeError;let ve=V[0];for(let Te=1;Te<V.length;Te++){const Ze=V[Te];Ze.isAfter(ve)&&(ve=Ze)}return ve}static isPosition(V){if(!V)return!1;if(V instanceof f)return!0;const{line:ve,character:Te}=V;return typeof ve=="number"&&typeof Te=="number"}static of(V){if(V instanceof f)return V;if(this.isPosition(V))return new f(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(V,ve){if(V<0)throw(0,T.$7)("line must be non-negative");if(ve<0)throw(0,T.$7)("character must be non-negative");this.c=V,this.e=ve}isBefore(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<V.e}isBeforeOrEqual(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<=V.e}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this.c===V.c&&this.e===V.e}compareTo(V){return this.c<V.c?-1:this.c>V.line?1:this.e<V.e?-1:this.e>V.e?1:0}translate(V,ve=0){if(V===null||ve===null)throw(0,T.$7)();let Te;return typeof V>"u"?Te=0:typeof V=="number"?Te=V:(Te=typeof V.lineDelta=="number"?V.lineDelta:0,ve=typeof V.characterDelta=="number"?V.characterDelta:0),Te===0&&ve===0?this:new f(this.line+Te,this.character+ve)}with(V,ve=this.character){if(V===null||ve===null)throw(0,T.$7)();let Te;return typeof V>"u"?Te=this.line:typeof V=="number"?Te=V:(Te=typeof V.line=="number"?V.line:this.line,ve=typeof V.character=="number"?V.character:this.character),Te===this.line&&ve===this.character?this:new f(Te,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$aL=F,e.$aL=F=f=Ge([E],F);let j=o=class{static isRange(V){return V instanceof o?!0:V?F.isPosition(V.start)&&F.isPosition(V.end):!1}static of(V){if(V instanceof o)return V;if(this.isRange(V))return new o(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(V,ve,Te,Ze){let tt,lt;if(typeof V=="number"&&typeof ve=="number"&&typeof Te=="number"&&typeof Ze=="number"?(tt=new F(V,ve),lt=new F(Te,Ze)):F.isPosition(V)&&F.isPosition(ve)&&(tt=F.of(V),lt=F.of(ve)),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this.c=tt,this.e=lt):(this.c=lt,this.e=tt)}contains(V){return o.isRange(V)?this.contains(V.start)&&this.contains(V.end):F.isPosition(V)?!(F.of(V).isBefore(this.c)||this.e.isBefore(V)):!1}isEqual(V){return this.c.isEqual(V.c)&&this.e.isEqual(V.e)}intersection(V){const ve=F.Max(V.start,this.c),Te=F.Min(V.end,this.e);if(!ve.isAfter(Te))return new o(ve,Te)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const ve=F.Min(V.start,this.c),Te=F.Max(V.end,this.end);return new o(ve,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(V,ve=this.end){if(V===null||ve===null)throw(0,T.$7)();let Te;return V?F.isPosition(V)?Te=V:(Te=V.start||this.start,ve=V.end||this.end):Te=this.start,Te.isEqual(this.c)&&ve.isEqual(this.end)?this:new o(Te,ve)}toJSON(){return[this.start,this.end]}};e.$bL=j,e.$bL=j=o=Ge([E],j);let M=i=class extends j{static isSelection(V){return V instanceof i?!0:V?j.isRange(V)&&F.isPosition(V.anchor)&&F.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(V,ve,Te,Ze){let tt,lt;if(typeof V=="number"&&typeof ve=="number"&&typeof Te=="number"&&typeof Ze=="number"?(tt=new F(V,ve),lt=new F(Te,Ze)):F.isPosition(V)&&F.isPosition(ve)&&(tt=F.of(V),lt=F.of(ve)),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt),this.f=tt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$cL=M,e.$cL=M=i=Ge([E],M);const O=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,T.$7)("connectionToken")};class U{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ve,Te){if(typeof V!="string"||V.length===0)throw(0,T.$7)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,T.$7)("port");typeof Te<"u"&&O(Te),this.host=V,this.port=Math.round(ve),this.connectionToken=Te}}e.$dL=U;class Q{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ve){this.makeConnection=V,this.connectionToken=ve,typeof ve<"u"&&O(ve)}}e.$eL=Q;class ue extends Error{static NotAvailable(V,ve){return new ue(V,p.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(V){return new ue(V,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,ve=p.RemoteAuthorityResolverErrorCode.Unknown,Te){super(V),this._message=V,this._code=ve,this._detail=Te,Object.setPrototypeOf(this,ue.prototype)}}e.$fL=ue;var Z;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var J;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let X=s=class{static isTextEdit(V){return V instanceof s?!0:V?j.isRange(V)&&typeof V.newText=="string":!1}static replace(V,ve){return new s(V,ve)}static insert(V,ve){return s.replace(new j(V,V),ve)}static delete(V){return s.replace(V,"")}static setEndOfLine(V){const ve=new s(new j(new F(0,0),new F(0,0)),"");return ve.newEol=V,ve}get range(){return this.c}set range(V){if(V&&!j.isRange(V))throw(0,T.$7)("range");this.c=V}get newText(){return this.e||""}set newText(V){if(V&&typeof V!="string")throw(0,T.$7)("newText");this.e=V}get newEol(){return this.f}set newEol(V){if(V&&typeof V!="number")throw(0,T.$7)("newEol");this.f=V}constructor(V,ve){this.c=V,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$gL=X,e.$gL=X=s=Ge([E],X);let le=n=class{static isNotebookCellEdit(V){return V instanceof n?!0:V?ti.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,ve){return new n(V,ve)}static insertCells(V,ve){return new n(new ti(V,V),ve)}static deleteCells(V){return new n(V,[])}static updateCellMetadata(V,ve){const Te=new n(new ti(V,V),[]);return Te.newCellMetadata=ve,Te}static updateNotebookMetadata(V){const ve=new n(new ti(0,0),[]);return ve.newNotebookMetadata=V,ve}constructor(V,ve){this.range=V,this.newCells=ve}};e.$hL=le,e.$hL=le=n=Ge([E],le);class x{static isSnippetTextEdit(V){return V instanceof x?!0:V?j.isRange(V.range)&&G.isSnippetString(V.snippet):!1}static replace(V,ve){return new x(V,ve)}static insert(V,ve){return x.replace(new j(V,V),ve)}constructor(V,ve){this.range=V,this.snippet=ve}}e.$iL=x;var be;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(be||(e.FileEditType=be={}));let ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(V,ve,Te,Ze){this.c.push({_type:1,from:V,to:ve,options:Te,metadata:Ze})}createFile(V,ve,Te){this.c.push({_type:1,from:void 0,to:V,options:ve,metadata:Te})}deleteFile(V,ve,Te){this.c.push({_type:1,from:V,to:void 0,options:ve,metadata:Te})}e(V,ve,Te){this.c.push({_type:3,metadata:Te,uri:V,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(V,ve,Te,Ze){const tt=ve.start,lt=ve.end;(tt!==lt||Te.length>0)&&this.c.push({_type:5,uri:V,index:tt,count:lt-tt,cells:Te,metadata:Ze})}g(V,ve,Te,Ze){this.c.push({_type:3,metadata:Ze,uri:V,edit:{editType:3,index:ve,metadata:Te}})}replace(V,ve,Te,Ze){this.c.push({_type:2,uri:V,edit:new X(ve,Te),metadata:Ze})}insert(V,ve,Te,Ze){this.replace(V,new j(ve,ve),Te,Ze)}delete(V,ve,Te){this.replace(V,ve,"",Te)}has(V){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===V.toString())}set(V,ve){if(ve)for(const Te of ve){if(!Te)continue;let Ze,tt;Array.isArray(Te)?(Ze=Te[0],tt=Te[1]):Ze=Te,le.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(V,Ze.range.start,Ze.newCellMetadata,tt):Ze.newNotebookMetadata?this.e(V,Ze.newNotebookMetadata,tt):this.f(V,Ze.range,Ze.newCells,tt):x.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:V,range:Ze.range,edit:Ze.snippet,metadata:tt}):this.c.push({_type:2,uri:V,edit:Ze,metadata:tt})}else{for(let Te=0;Te<this.c.length;Te++){const Ze=this.c[Te];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===V.toString()&&(this.c[Te]=void 0);break}}(0,D.$Ib)(this.c)}}get(V){const ve=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===V.toString()&&ve.push(Te.edit);return ve}entries(){const V=new I.$Ac;for(const ve of this.c)if(ve._type===2){let Te=V.get(ve.uri);Te||(Te=[ve.uri,[]],V.set(ve.uri,Te)),Te[1].push(ve.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$jL=ce,e.$jL=ce=Ge([E],ce);let G=c=class{static isSnippetString(V){return V instanceof c?!0:V?typeof V.value=="string":!1}static c(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this.e=1,this.value=V||""}appendText(V){return this.value+=c.c(V),this}appendTabstop(V=this.e++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,ve=this.e++){if(typeof V=="function"){const Te=new c;Te.e=this.e,V(Te),this.e=Te.e,V=Te.value}else V=c.c(V);return this.value+="${",this.value+=ve,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,ve=this.e++){const Te=V.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(V,ve){if(typeof ve=="function"){const Te=new c;Te.e=this.e,ve(Te),this.e=Te.e,ve=Te.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$kL=G,e.$kL=G=c=Ge([E],G);var W;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var ne;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let ye=t=class{static isLocation(V){return V instanceof t?!0:V?j.isRange(V.range)&&y.URI.isUri(V.uri):!1}constructor(V,ve){if(this.uri=V,ve)if(j.isRange(ve))this.range=j.of(ve);else if(F.isPosition(ve))this.range=new j(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$lL=ye,e.$lL=ye=t=Ge([E],ye);let de=class{static is(V){return V?typeof V.message=="string"&&V.location&&j.isRange(V.location.range)&&y.URI.isUri(V.location.uri):!1}constructor(V,ve){this.location=V,this.message=ve}static isEqual(V,ve){return V===ve?!0:!V||!ve?!1:V.message===ve.message&&V.location.range.isEqual(ve.location.range)&&V.location.uri.toString()===ve.location.uri.toString()}};e.$mL=de,e.$mL=de=Ge([E],de);let ge=class{constructor(V,ve,Te=ne.Error){if(!j.isRange(V))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=V,this.message=ve,this.severity=Te}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,ve){return V===ve?!0:!V||!ve?!1:V.message===ve.message&&V.severity===ve.severity&&V.code===ve.code&&V.severity===ve.severity&&V.source===ve.source&&V.range.isEqual(ve.range)&&(0,D.$ub)(V.tags,ve.tags)&&(0,D.$ub)(V.relatedInformation,ve.relatedInformation,de.isEqual)}};e.$nL=ge,e.$nL=ge=Ge([E],ge);let _=class{constructor(V,ve){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=ve}};e.$oL=_,e.$oL=_=Ge([E],_);var te;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let K=class{constructor(V,ve=te.Text){this.range=V,this.kind=ve}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.$pL=K,e.$pL=K=Ge([E],K);let ie=class{constructor(V,ve){this.uri=V,this.highlights=ve}toJSON(){return{uri:this.uri,highlights:this.highlights.map(V=>V.toJSON())}}};e.$qL=ie,e.$qL=ie=Ge([E],ie);var fe;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(fe||(e.SymbolKind=fe={}));var pe;(function(H){H[H.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let Pe=a=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,ve,Te,Ze,tt){this.name=V,this.kind=ve,this.containerName=tt,typeof Te=="string"&&(this.containerName=Te),Ze instanceof ye?this.location=Ze:Te instanceof j&&(this.location=new ye(Ze,Te)),a.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};e.$rL=Pe,e.$rL=Pe=a=Ge([E],Pe);let we=r=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(r.validate)}constructor(V,ve,Te,Ze,tt){this.name=V,this.detail=ve,this.kind=Te,this.range=Ze,this.selectionRange=tt,this.children=[],r.validate(this)}};e.$sL=we,e.$sL=we=r=Ge([E],we);var Ce;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let B=class{constructor(V,ve){this.title=V,this.kind=ve}};e.$tL=B,e.$tL=B=Ge([E],B);let Y=class{static{h=this}static{this.c="."}constructor(V){this.value=V}append(V){return new h(this.value?this.value+h.c+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+h.c)}};e.$uL=Y,e.$uL=Y=h=Ge([E],Y),Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorMove=Y.Refactor.append("move"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll"),Y.Notebook=Y.Empty.append("notebook");let ee=class{constructor(V,ve){if(this.range=V,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$vL=ee,e.$vL=ee=Ge([E],ee);class q{constructor(V,ve,Te,Ze,tt,lt){this.kind=V,this.name=ve,this.detail=Te,this.uri=Ze,this.range=tt,this.selectionRange=lt}}e.$wL=q;class oe{constructor(V,ve){this.fromRanges=ve,this.from=V}}e.$xL=oe;class he{constructor(V,ve){this.fromRanges=ve,this.to=V}}e.$yL=he;var Le;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Le||(e.LanguageStatusSeverity=Le={}));let je=class{constructor(V,ve){this.range=V,this.command=ve}get isResolved(){return!!this.command}};e.$zL=je,e.$zL=je=Ge([E],je);let He=u=class{#e;static isMarkdownString(V){return V instanceof u?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,ve=!1){this.#e=new g.$hk(V,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,ve){return this.#e.appendCodeblock(ve??"",V),this}};e.$AL=He,e.$AL=He=u=Ge([E],He);let Qe=class{constructor(V,ve){this.label=V,this.documentation=ve}};e.$BL=Qe,e.$BL=Qe=Ge([E],Qe);let _e=class{constructor(V,ve){this.label=V,this.documentation=ve,this.parameters=[]}};e.$CL=_e,e.$CL=_e=Ge([E],_e);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$DL=at,e.$DL=at=Ge([E],at);var st;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var rt;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let Ae=class{constructor(V){this.value=V}};e.$EL=Ae,e.$EL=Ae=Ge([E],Ae);let ze=class{constructor(V,ve,Te){this.position=V,this.label=ve,this.kind=Te}};e.$FL=ze,e.$FL=ze=Ge([E],ze);var Re;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Re||(e.CompletionTriggerKind=Re={}));var Ye;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Ye||(e.CompletionItemKind=Ye={}));var re;(function(H){H[H.Deprecated=1]="Deprecated"})(re||(e.CompletionItemTag=re={}));let se=class{constructor(V,ve){this.label=V,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&Ye[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$GL=se,e.$GL=se=Ge([E],se);let Ie=class{constructor(V=[],ve=!1){this.items=V,this.isIncomplete=ve}};e.$HL=Ie,e.$HL=Ie=Ge([E],Ie);let qe=class{constructor(V,ve,Te){this.insertText=V,this.range=ve,this.command=Te}};e.$IL=qe,e.$IL=qe=Ge([E],qe);let Xe=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.$JL=Xe,e.$JL=Xe=Ge([E],Xe);var it;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var nt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Oe(H,V){return`${C.$lm.toKey(H)}.${V}`}e.$KL=Oe;var yt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var Dt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Dt||(e.TextDocumentSaveReason=Dt={}));var Nt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Nt||(e.TextEditorRevealType=Nt={}));var Ft;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var Et;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Ht;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(H){function V(ve){switch(ve){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=V}(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var Ot;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(H){function V(ve){switch(ve){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=V}(Ot||(e.SyntaxTokenType=Ot={}));let Xt=class{constructor(V,ve){if(ve&&!y.URI.isUri(ve))throw(0,T.$7)("target");if(!j.isRange(V)||V.isEmpty)throw(0,T.$7)("range");this.range=V,this.target=ve}};e.$LL=Xt,e.$LL=Xt=Ge([E],Xt);let Vt=class{constructor(V,ve,Te,Ze){this.red=V,this.green=ve,this.blue=Te,this.alpha=Ze}};e.$ML=Vt,e.$ML=Vt=Ge([E],Vt);let Ut=class{constructor(V,ve){if(ve&&!(ve instanceof Vt))throw(0,T.$7)("color");if(!j.isRange(V)||V.isEmpty)throw(0,T.$7)("range");this.range=V,this.color=ve}};e.$NL=Ut,e.$NL=Ut=Ge([E],Ut);let et=class{constructor(V){if(!V||typeof V!="string")throw(0,T.$7)("label");this.label=V}};e.$OL=et,e.$OL=et=Ge([E],et);var Gt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var ht;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class $t{constructor(V,ve,Te){if(this.startIndex=V,this.length=ve,this.tooltip=Te,typeof V!="number"||V<0)throw(0,T.$7)("startIndex");if(typeof ve!="number"||ve<1)throw(0,T.$7)("length");if(Te!==void 0&&typeof Te!="string")throw(0,T.$7)("tooltip")}}e.$PL=$t;class Bt{constructor(V){this.uri=V}}e.$QL=Bt;class Qt{constructor(V){this.terminalCommand=V}}e.$RL=Qt;var kt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ft{constructor(V){if(this.options=V,typeof V!="object")throw(0,T.$7)("options")}}e.$SL=ft;var It;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var _t;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(_t||(e.TaskPanelKind=_t={}));let At=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(V){switch(V){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(V,ve){if(this.label=ve,typeof V!="string"||typeof ve!="string")throw(0,T.$7)("name");this.c=V}get id(){return this.c}};e.$TL=At,e.$TL=At=l=Ge([E],At);function Je(H){let V="";for(let ve=0;ve<H.length;ve++)V+=H[ve].replace(/,/g,",,")+",";return V}let Mt=class{constructor(V,ve,Te){if(typeof V!="string")throw(0,T.$7)("process");this.e=[],this.c=V,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Te):this.f=ve)}get process(){return this.c}set process(V){if(typeof V!="string")throw(0,T.$7)("process");this.c=V}get args(){return this.e}set args(V){Array.isArray(V)||(V=[]),this.e=V}get options(){return this.f}set options(V){this.f=V}computeId(){const V=[];if(V.push("process"),this.c!==void 0&&V.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)V.push(ve);return Je(V)}};e.$UL=Mt,e.$UL=Mt=Ge([E],Mt);let jt=class{constructor(V,ve,Te){if(this.f=[],Array.isArray(ve)){if(!V)throw(0,T.$7)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,T.$7)("command");this.e=V,this.f=ve,this.g=Te}else{if(typeof V!="string")throw(0,T.$7)("commandLine");this.c=V,this.g=ve}}get commandLine(){return this.c}set commandLine(V){if(typeof V!="string")throw(0,T.$7)("commandLine");this.c=V}get command(){return this.e?this.e:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,T.$7)("command");this.e=V}get args(){return this.f}set args(V){this.f=V||[]}get options(){return this.g}set options(V){this.g=V}computeId(){const V=[];if(V.push("shell"),this.c!==void 0&&V.push(this.c),this.e!==void 0&&V.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)V.push(typeof ve=="string"?ve:ve.value);return Je(V)}};e.$VL=jt,e.$VL=jt=Ge([E],jt);var Yt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Yt||(e.ShellQuoting=Yt={}));var gt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Tt{constructor(V){this.c=V}computeId(){return"customExecution"+(0,L.$qg)()}set callback(V){this.c=V}get callback(){return this.c}}e.$WL=Tt;let Rt=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(V,ve,Te,Ze,tt,lt){this.k=!1,this.l=this.definition=V;let mt;typeof ve=="string"?(this.n=this.name=ve,this.u=this.source=Te,this.execution=Ze,mt=tt,this.k=!0):ve===gt.Global||ve===gt.Workspace?(this.target=ve,this.n=this.name=Te,this.u=this.source=Ze,this.execution=tt,mt=lt):(this.target=ve,this.n=this.name=Te,this.u=this.source=Ze,this.execution=tt,mt=lt),typeof mt=="string"?(this.q=[mt],this.r=!0):Array.isArray(mt)?(this.q=mt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(V){this.j=V}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Mt?this.l={type:k.e,id:this.o.computeId()}:this.o instanceof jt?this.l={type:k.f,id:this.o.computeId()}:this.o instanceof Tt?this.l={type:k.c,id:this.o.computeId()}:this.l={type:k.g,id:(0,L.$qg)()}}get definition(){return this.l}set definition(V){if(V==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=V}get scope(){return this.m}set target(V){this.A(),this.m=V}get name(){return this.n}set name(V){if(typeof V!="string")throw(0,T.$7)("name");this.A(),this.n=V}get execution(){return this.o}set execution(V){V===null&&(V=void 0),this.A(),this.o=V;const ve=this.l.type;(k.g===ve||k.e===ve||k.f===ve||k.c===ve)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(V){if(Array.isArray(V))this.A(),this.q=V,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.A(),this.t=V}get source(){return this.u}set source(V){if(typeof V!="string"||V.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=V}get group(){return this.w}set group(V){V===null&&(V=void 0),this.A(),this.w=V}get detail(){return this.z}set detail(V){V===null&&(V=void 0),this.z=V}get presentationOptions(){return this.x}set presentationOptions(V){V==null&&(V=Object.create(null)),this.A(),this.x=V}get runOptions(){return this.y}set runOptions(V){V==null&&(V=Object.create(null)),this.A(),this.y=V}};e.$XL=Rt,e.$XL=Rt=k=Ge([E],Rt);var Wt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Wt||(e.ProgressLocation=Wt={}));var Me;(function(H){function V(ve){const Te=ve;return(0,$.$Mf)(Te.value)?Te.tooltip&&!(0,$.$If)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}H.isViewBadge=V})(Me||(e.ViewBadge=Me={}));let Fe=A=class{static isTreeItem(V,ve){const Te=V;if(Te.checkboxState!==void 0){const Ze=(0,$.$Mf)(Te.checkboxState)?Te.checkboxState:(0,$.$Kf)(Te.checkboxState)&&(0,$.$Mf)(Te.checkboxState.state)?Te.checkboxState.state:void 0,tt=!(0,$.$Mf)(Te.checkboxState)&&(0,$.$Kf)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==ae.Checked&&Ze!==ae.Unchecked||tt!==void 0&&!(0,$.$If)(tt))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(V instanceof A)return!0;if(Te.label!==void 0&&!(0,$.$If)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,$.$If)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,$.$If)(Te.iconPath)&&!y.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,$.$If)(Te.iconPath.id))){const Ze=Te.iconPath;if(!Ze||!(0,$.$If)(Ze.light)&&!y.URI.isUri(Ze.light)&&!(0,$.$If)(Ze.dark)&&!y.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,$.$If)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!y.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,$.$If)(Te.tooltip)&&!(Te.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<De.None&&Te.collapsibleState>De.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,$.$If)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(V,ve=De.None){this.collapsibleState=ve,y.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.$YL=Fe,e.$YL=Fe=A=Ge([E],Fe);var De;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(De||(e.TreeItemCollapsibleState=De={}));var ae;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(ae||(e.TreeItemCheckboxState=ae={}));let Ne=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.$ZL=Ne,e.$ZL=Ne=Ge([E],Ne);class Ue extends Ne{}e.$1L=Ue;class xe extends Ue{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.$2L=xe;class Ke{constructor(V,ve,Te,Ze){this.name=V,this.uri=ve,this._itemId=Te,this.c=Ze}data(){return this.c()}}e.$3L=Ke;let ct=class{#e=new Map;constructor(V){for(const[ve,Te]of V??[]){const Ze=this.#e.get(this.#t(ve));Ze?Ze.push(Te):this.#e.set(this.#t(ve),[Te])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,ve){this.#e.set(this.#t(V),[ve])}forEach(V,ve){for(const[Te,Ze]of this.#e)for(const tt of Ze)V.call(ve,tt,Te,this)}*[Symbol.iterator](){for(const[V,ve]of this.#e)for(const Te of ve)yield[V,Te]}#t(V){return V.toLowerCase()}};e.$4L=ct,e.$4L=ct=Ge([E],ct);let pt=class{constructor(V){this.insertText=V}};e.$5L=pt,e.$5L=pt=Ge([E],pt);let Kt=class{constructor(V,ve){this.label=ve,this.insertText=V}};e.$6L=Kt,e.$6L=Kt=Ge([E],Kt);let St=class{constructor(V,ve){this.id=V,this.color=ve}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.$7L=St,e.$7L=St=Ge([E],St),St.File=new St("file"),St.Folder=new St("folder");let Ct=class{constructor(V){this.id=V}};e.$8L=Ct,e.$8L=Ct=Ge([E],Ct);var wt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(wt||(e.ConfigurationTarget=wt={}));let Di=class{get base(){return this.c}set base(V){this.c=V,this.e=y.URI.file(V)}get baseUri(){return this.e}set baseUri(V){this.e=V,this.c=V.fsPath}constructor(V,ve){if(typeof V!="string"&&(!V||!y.URI.isUri(V)&&!y.URI.isUri(V.uri)))throw(0,T.$7)("base");if(typeof ve!="string")throw(0,T.$7)("pattern");typeof V=="string"?this.baseUri=y.URI.file(V):y.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$9L=Di,e.$9L=Di=Ge([E],Di);const Ki=new WeakMap;function Pt(H,V){Ki.set(H,V)}e.$0L=Pt;let si=class{constructor(V,ve,Te,Ze){this.enabled=typeof V=="boolean"?V:!0,typeof ve=="string"&&(this.condition=ve),typeof Te=="string"&&(this.hitCondition=Te),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=Ki.get(this)??(0,L.$qg)()),this.c}};e.$$L=si,e.$$L=si=Ge([E],si);let mi=class extends si{constructor(V,ve,Te,Ze,tt){if(super(ve,Te,Ze,tt),V===null)throw(0,T.$7)("location");this.location=V}};e.$_L=mi,e.$_L=mi=Ge([E],mi);let ui=class extends si{constructor(V,ve,Te,Ze,tt){super(ve,Te,Ze,tt),this.functionName=V}};e.$aM=ui,e.$aM=ui=Ge([E],ui);let Ci=class extends si{constructor(V,ve,Te,Ze,tt,lt,mt){if(super(Ze,tt,lt,mt),!ve)throw(0,T.$7)("dataId");this.label=V,this.dataId=ve,this.canPersist=Te}};e.$bM=Ci,e.$bM=Ci=Ge([E],Ci);let Ii=class{constructor(V,ve,Te){this.command=V,this.args=ve||[],this.options=Te}};e.$cM=Ii,e.$cM=Ii=Ge([E],Ii);let zt=class{constructor(V,ve){this.port=V,this.host=ve}};e.$dM=zt,e.$dM=zt=Ge([E],zt);let $i=class{constructor(V){this.path=V}};e.$eM=$i,e.$eM=$i=Ge([E],$i);let Pi=class{constructor(V){this.implementation=V}};e.$fM=Pi,e.$fM=Pi=Ge([E],Pi);let li=class{constructor(V,ve,Te){this.session=V,this.threadId=ve,this.frameId=Te}};e.$gM=li,e.$gM=li=Ge([E],li);let hi=class{constructor(V,ve){this.session=V,this.threadId=ve}};e.$hM=hi,e.$hM=hi=Ge([E],hi);let dt=class{constructor(V,ve){this.range=V,this.expression=ve}};e.$iM=dt,e.$iM=dt=Ge([E],dt);var Ji;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let ei=class{constructor(V,ve){this.range=V,this.text=ve}};e.$jM=ei,e.$jM=ei=Ge([E],ei);let oi=class{constructor(V,ve,Te=!0){this.range=V,this.variableName=ve,this.caseSensitiveLookup=Te}};e.$kM=oi,e.$kM=oi=Ge([E],oi);let bi=class{constructor(V,ve){this.range=V,this.expression=ve}};e.$lM=bi,e.$lM=bi=Ge([E],bi);let Ai=class{constructor(V,ve){this.frameId=V,this.stoppedLocation=ve}};e.$mM=Ai,e.$mM=Ai=Ge([E],Ai);var Qi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ri=v=class extends Error{static FileExists(V){return new v(V,m.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(V){return new v(V,m.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(V){return new v(V,m.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(V){return new v(V,m.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(V){return new v(V,m.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(V){return new v(V,m.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(V,ve=m.FileSystemProviderErrorCode.Unknown,Te){super(y.URI.isUri(V)?V.toString(!0):V),this.code=Te?.name??"Unknown",(0,m.$Fk)(this,ve),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};e.$nM=Ri,e.$nM=Ri=v=Ge([E],Ri);let wi=class{constructor(V,ve,Te){this.start=V,this.end=ve,this.kind=Te}};e.$oM=wi,e.$oM=wi=Ge([E],wi);var Yi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Li;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var di;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(di||(e.CommentMode=di={}));var Xi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var vi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));class Mi{constructor(V,ve=[]){this.tokenTypes=V,this.tokenModifiers=ve}}e.$pM=Mi;function un(H){return typeof H>"u"||(0,$.$Jf)(H)}class Ti{constructor(V){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,V){this.m=!0;for(let ve=0,Te=V.tokenTypes.length;ve<Te;ve++)this.k.set(V.tokenTypes[ve],ve);for(let ve=0,Te=V.tokenModifiers.length;ve<Te;ve++)this.l.set(V.tokenModifiers[ve],ve)}}push(V,ve,Te,Ze,tt){if(typeof V=="number"&&typeof ve=="number"&&typeof Te=="number"&&typeof Ze=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.o(V,ve,Te,Ze,tt);if(j.isRange(V)&&typeof ve=="string"&&un(Te))return this.n(V,ve,Te);throw(0,T.$7)()}n(V,ve,Te){if(!this.m)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ve))throw new Error("`tokenType` is not in the provided legend");const Ze=V.start.line,tt=V.start.character,lt=V.end.character-V.start.character,mt=this.k.get(ve);let qt=0;if(Te)for(const xt of Te){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const ni=this.l.get(xt);qt|=1<<ni>>>0}this.o(Ze,tt,lt,mt,qt)}o(V,ve,Te,Ze,tt){if(this.f&&(V<this.c||V===this.c&&ve<this.e)){this.f=!1;const qt=this.g.length/5|0;let xt=0,ni=0;for(let ri=0;ri<qt;ri++){let ci=this.g[5*ri],Hi=this.g[5*ri+1];ci===0?(ci=xt,Hi+=ni):ci+=xt,this.g[5*ri]=ci,this.g[5*ri+1]=Hi,xt=ci,ni=Hi}}let lt=V,mt=ve;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=Te,this.g[this.j++]=Ze,this.g[this.j++]=tt,this.c=V,this.e=ve}static q(V){const ve=[],Te=V.length/5|0;for(let mt=0;mt<Te;mt++)ve[mt]=mt;ve.sort((mt,qt)=>{const xt=V[5*mt],ni=V[5*qt];if(xt===ni){const ri=V[5*mt+1],ci=V[5*qt+1];return ri-ci}return xt-ni});const Ze=new Uint32Array(V.length);let tt=0,lt=0;for(let mt=0;mt<Te;mt++){const qt=5*ve[mt],xt=V[qt+0],ni=V[qt+1],ri=V[qt+2],ci=V[qt+3],Hi=V[qt+4],Cn=xt-tt,jn=Cn===0?ni-lt:ni,Gi=5*mt;Ze[Gi+0]=Cn,Ze[Gi+1]=jn,Ze[Gi+2]=ri,Ze[Gi+3]=ci,Ze[Gi+4]=Hi,tt=xt,lt=ni}return Ze}build(V){return this.f?new ai(new Uint32Array(this.g),V):new ai(Ti.q(this.g),V)}}e.$qM=Ti;class ai{constructor(V,ve){this.resultId=ve,this.data=V}}e.$rM=ai;class ln{constructor(V,ve,Te){this.start=V,this.deleteCount=ve,this.data=Te}}e.$sM=ln;class hn{constructor(V,ve){this.resultId=ve,this.edits=V}}e.$tM=hn;var Zi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let fi=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$uM=fi,e.$uM=fi=Ge([E],fi);var xi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var _i;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var pi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(pi||(e.ExtensionKind=pi={}));class en{static validate(V){if(typeof V.badge=="string"){let ve=(0,b.$jf)(V.badge,0);if(ve<V.badge.length&&(ve+=(0,b.$jf)(V.badge,ve)),V.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!St.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,ve,Te){this.badge=V,this.tooltip=ve,this.color=Te}}e.$vM=en;let Ni=class{constructor(V){this.kind=V}};e.$wM=Ni,e.$wM=Ni=Ge([E],Ni);var Fi;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Fi||(e.ColorThemeKind=Fi={}));class ti{static isNotebookRange(V){return V instanceof ti?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(V,ve){if(V<0)throw(0,T.$7)("start must be positive");if(ve<0)throw(0,T.$7)("end must be positive");V<=ve?(this.c=V,this.e=ve):(this.c=ve,this.e=V)}with(V){let ve=this.c,Te=this.e;return V.start!==void 0&&(ve=V.start),V.end!==void 0&&(Te=V.end),ve===this.c&&Te===this.e?this:new ti(ve,Te)}}e.$xM=ti;class yi{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(ve=>yi.isNotebookCellData(ve))}static isNotebookCellData(V){return!0}constructor(V,ve,Te,Ze,tt,lt,mt){this.kind=V,this.value=ve,this.languageId=Te,this.mime=Ze,this.outputs=tt??[],this.metadata=lt,this.executionSummary=mt,yi.validate(this)}}e.$yM=yi;class dn{constructor(V){this.cells=V}}e.$zM=dn;class Zt{static isNotebookCellOutputItem(V){return V instanceof Zt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const ve={name:V.name,message:V.message,stack:V.stack};return Zt.json(ve,"application/vnd.code.notebook.error")}static stdout(V){return Zt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Zt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,ve="application/octet-stream"){return new Zt(V,ve)}static#e=new TextEncoder;static text(V,ve=R.$fs.text){const Te=Zt.#e.encode(String(V));return new Zt(Te,ve)}static json(V,ve="text/x-json"){const Te=JSON.stringify(V,void 0,"	");return Zt.text(Te,ve)}constructor(V,ve){this.data=V,this.mime=ve;const Te=(0,R.$js)(ve,!0);if(!Te)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.$AM=Zt;class Ei{static isNotebookCellOutput(V){return V instanceof Ei?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,ve=!1){const Te=new Set,Ze=new Set;for(let tt=0;tt<V.length;tt++){const lt=V[tt],mt=(0,R.$js)(lt.mime);if(!Te.has(mt)||(0,S.$bJ)(mt)){Te.add(mt);continue}Ze.add(tt),ve&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ze.size===0?V:V.filter((tt,lt)=>!Ze.has(lt))}constructor(V,ve,Te){this.items=Ei.ensureUniqueMimeTypes(V,!0),typeof ve=="string"?(this.id=ve,this.metadata=Te):(this.id=(0,L.$qg)(),this.metadata=ve??Te)}}e.$BM=Ei;var ki;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(ki||(e.NotebookCellKind=ki={}));var Oi;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var We;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(We||(e.NotebookCellStatusBarAlignment=We={}));var ii;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ii||(e.NotebookEditorRevealType=ii={}));class tn{constructor(V,ve){this.text=V,this.alignment=ve}}e.$CM=tn;var ot;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(ot||(e.NotebookControllerAffinity=ot={}));var bt;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(bt||(e.NotebookControllerAffinity2=bt={}));class fn{constructor(V,ve=[]){this.uri=V,this.provides=(0,D.$3b)(ve)}}e.$DM=fn;class gn{constructor(V){this.label=V}}e.$EM=gn;var ji;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(ji||(e.NotebookVariablesRequestKind=ji={}));let zi=class{constructor(V,ve){this.label=V,this.timestamp=ve}};e.$FM=zi,e.$FM=zi=Ge([E],zi);var gi;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(gi||(e.ExtensionMode=gi={}));var nn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class mn{constructor(V,ve){this.ranges=V,this.wordPattern=ve}}e.$GM=mn;class sn{constructor(V){this.c=V}get autoForwardAction(){return this.c}}e.$HM=sn;var on;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ui=class{constructor(V=void 0,ve=void 0,Te=void 0,Ze=!1){this.include=V,this.exclude=ve,this.profile=Te,this.continuous=Ze}};e.$IM=Ui,e.$IM=Ui=Ge([E],Ui);let Bi=w=class{static diff(V,ve,Te){const Ze=new w(V);return Ze.expectedOutput=ve,Ze.actualOutput=Te,Ze}constructor(V){this.message=V}};e.$JM=Bi,e.$JM=Bi=w=Ge([E],Bi);let Wi=class{constructor(V){this.id=V}};e.$KM=Wi,e.$KM=Wi=Ge([E],Wi);class Si{constructor(V,ve){this.covered=V,this.total=ve}}e.$LM=Si;const Vi=H=>{if(H&&H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`)};class qi{static fromDetails(V,ve){const Te=new Si(0,0),Ze=new Si(0,0),tt=new Si(0,0);for(const mt of ve)if("branches"in mt){Te.total+=1,Te.covered+=mt.executionCount>0?1:0;for(const qt of mt.branches)Ze.total+=1,Ze.covered+=qt.executionCount>0?1:0}else tt.total+=1,tt.covered+=mt.executionCount>0?1:0;const lt=new qi(V,Te,Ze.total>0?Ze:void 0,tt.total>0?tt:void 0);return lt.detailedCoverage=ve,lt}constructor(V,ve,Te,Ze){this.uri=V,this.statementCoverage=ve,this.branchCoverage=Te,this.functionCoverage=Ze,Vi(ve),Vi(Te),Vi(Ze)}}e.$MM=qi;class $n{constructor(V,ve,Te=[]){this.executionCount=V,this.location=ve,this.branches=Te}}e.$NM=$n;class bn{constructor(V,ve,Te){this.executionCount=V,this.location=ve,this.label=Te}}e.$OM=bn;class $e{constructor(V,ve,Te){this.name=V,this.executionCount=ve,this.location=Te}}e.$PM=$e;var Ee;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Ee||(e.ExternalUriOpenerPriority=Ee={}));var Be;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Be||(e.WorkspaceTrustState=Be={}));var ut;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(ut||(e.PortAutoForwardAction=ut={}));class vt{constructor(V,ve,Te,Ze,tt,lt){this.kind=V,this.name=ve,this.detail=Te,this.uri=Ze,this.range=tt,this.selectionRange=lt}}e.$QM=vt;class Lt{constructor(V){this.uri=V}}e.$RM=Lt;class cn{constructor(V,ve){this.original=V,this.modified=ve}}e.$SM=cn;class In{constructor(V,ve,Te,Ze){this.base=V,this.input1=ve,this.input2=Te,this.result=Ze}}e.$TM=In;class Pn{constructor(V,ve){this.uri=V,this.viewType=ve}}e.$UM=Pn;class An{constructor(V){this.viewType=V}}e.$VM=An;class Rn{constructor(V,ve){this.uri=V,this.notebookType=ve}}e.$WM=Rn;class Ln{constructor(V,ve,Te){this.original=V,this.modified=ve,this.notebookType=Te}}e.$XM=Ln;class Mn{constructor(){}}e.$YM=Mn;class Tn{constructor(V,ve){this.uri=V,this.inputBoxUri=ve}}e.$ZM=Tn;class Nn{constructor(V){this.providerId=V}}e.$1M=Nn;var wn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var vn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(vn||(e.ChatAgentCopyKind=vn={}));var pn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(pn||(e.ChatVariableLevel=pn={}));class Fn{constructor(V,ve){this.label=V,this.values=ve}}e.$2M=Fn;var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class On{constructor(V,ve){this.role=V,this.content=ve}}e.$3M=On;var kn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(ke[310],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$0K.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(R);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(b,$)??[]}getRelatedInformation(R,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(R,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,b),new T.$_K(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$lgc=g}),define(ke[311],Se([1,0,4,6,7,26]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class R{constructor(y){this.b=new Map,this.c=new D.$Vd,this.onDidChangeSessions=this.c.event,this.d=new b,this.f=new b,this.a=y.getProxy(T.$0K.MainThreadAuthentication)}async getSession(y,L,C,m={}){const p=I.$lm.toKey(y.identifier),S=[...C].sort().join(" ");return await this.d.getOrCreate(`${p} ${L} ${S}`,async()=>{await this.a.$ensureProvider(L);const d=y.displayName||y.name;return this.a.$getSession(L,C,p,d,m)})}async getSessions(y,L,C){const m=I.$lm.toKey(y.identifier),p=[...C].sort().join(" ");return await this.f.getOrCreate(`${m} ${p}`,async()=>{await this.a.$ensureProvider(L);const S=y.displayName||y.name;return this.a.$getSessions(L,C,m,S)})}async removeSession(y,L){const C=this.b.get(y);return C?C.provider.removeSession(L):this.a.$removeSession(y,L)}registerAuthenticationProvider(y,L,C,m){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:L,provider:C,options:m??{supportsMultipleAccounts:!1}});const p=C.onDidChangeSessions(S=>this.a.$sendDidChangeSessions(y,S));return this.a.$registerAuthenticationProvider(y,L,m?.supportsMultipleAccounts??!1),new g.$_K(()=>{p.dispose(),this.b.delete(y),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,L,C){const m=this.b.get(y);if(m)return Promise.resolve(m.provider.createSession(L,C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,L){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,L){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,L){return this.c.fire({provider:{id:y,label:L}}),Promise.resolve()}}e.$wgc=R;class b{constructor(){this.a=new Map}getOrCreate(y,L){const C=this.a.get(y);if(C)return C;const m=L().finally(()=>this.a.delete(y));return this.a.set(y,m),m}}}),define(ke[147],Se([1,0,2,6,7,5,20,13,19,12,17,25]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=e.$vhc=void 0;let p=class{static{m=this}static{this.c=0}static{this.d=250}constructor(d,f){this.h=f,this.f=new Map,this.g=d.getProxy(T.$0K.MainThreadDecorations)}registerFileDecorationProvider(d,f){const o=m.c++;this.f.set(o,{provider:d,extensionDescription:f}),this.g.$registerDecorationProvider(o,f.identifier.value);const i=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(s=>{if(!s){this.g.$onDidChange(o,null);return}const n=(0,$.$3b)(s);if(n.length<=m.d){this.g.$onDidChange(o,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,n.length);const c=n.map(r=>({uri:r,rank:(0,y.$Pe)(r.path,"/")})),t=(0,$.$zb)(c,(r,h)=>r.rank-h.rank||(0,y.$5e)(r.uri.path,h.uri.path)),a=[];e:for(const r of t){let h;for(const u of r){const l=(0,L.$mc)(u.uri.path);if(h!==l&&(h=l,a.push(u.uri)>=m.d))break e}}this.g.$onDidChange(o,a)});return new g.$_K(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(d,f,o){if(!this.f.has(d))return Object.create(null);const i=Object.create(null),{provider:s,extensionDescription:n}=this.f.get(d);return await Promise.all(f.map(async c=>{try{const{uri:t,id:a}=c,r=await Promise.resolve(s.provideFileDecoration(D.URI.revive(t),o));if(!r)return;try{g.$vM.validate(r),r.badge&&typeof r.badge!="string"&&(0,C.$GF)(n,"codiconDecoration"),i[a]=[r.propagate,r.tooltip,r.badge,r.color]}catch(h){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${h}`)}}catch(t){this.h.error(t)}})),i}};e.$vhc=p,e.$vhc=p=m=Ge([Ve(0,R.$bN),Ve(1,b.$nj)],p),e.$whc=(0,I.$6h)("IExtHostDecorations")}),define(ke[312],Se([1,0,14,2,7,6,16,21,12]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;class y{static{this.a=0}constructor(C,m,p){this.d=m,this.e=p,this.b=new Map,this.c=C.getProxy(I.$0K.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const p=y.a++;this.b.set(p,m),this.c.$registerTextContentProvider(p,C);let S;if(typeof m.onDidChange=="function"){let d;S=m.onDidChange(async f=>{if(f.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;d&&await d;const o=this.$provideTextDocumentContent(p,f).then(async i=>{if(!i&&typeof i!="string")return;const s=this.d.getDocument(f);if(!s)return;const n=(0,$.$Ze)(i);if(!s.equalLines(n))return this.c.$onVirtualDocumentChange(f,i)}).catch(D.$1).finally(()=>{d===o&&(d=void 0)});d=o})}return new g.$_K(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,m){const p=this.b.get(C);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(m),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$yhc=y}),define(ke[148],Se([1,0,60,16,12,176,126,7,19]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=void 0;const y=new Map;function L(S,d){d?y.set(S,d):y.delete(S)}e.$dN=L;function C(S){return y.get(S)}class m extends I.$lv{constructor(d,f,o,i,s,n,c,t){super(f,o,i,s),this.c=d,this.m=n,this.q=c,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,$.$ub)(this.f,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.d},get fileName(){return d.d.fsPath},get isUntitled(){return d.d.scheme===T.Schemas.untitled},get languageId(){return d.m},get version(){return d.h},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(f){return f?d.s(f):d.getText()},get eol(){return d.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return d.f.length},lineAt(f){return d.t(f)},offsetAt(f){return d.u(f)},positionAt(f){return d.v(f)},validateRange(f){return d.w(f)},validatePosition(f){return d.x(f)},getWordRangeAtPosition(f,o){return d.y(f,o)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,D.ok)(!this.b),this.m=d}_acceptIsDirty(d){(0,D.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(d){const f=this.w(d);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const o=this.g,i=f.start.line,s=f.end.line,n=[];n.push(this.f[i].substring(f.start.character));for(let c=i+1;c<s;c++)n.push(this.f[c]);return n.push(this.f[s].substring(0,f.end.character)),n.join(o)}t(d){let f;if(d instanceof b.$aL?f=d.line:typeof d=="number"&&(f=d),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new p(f,this.f[f],f===this.f.length-1)}u(d){return d=this.x(d),this.l(),this.j.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.l();const f=this.j.getIndexOf(d),o=this.f[f.index].length;return new b.$aL(f.index,Math.min(f.remainder,o))}w(d){if(!(d instanceof b.$bL))throw new Error("Invalid argument");const f=this.x(d.start),o=this.x(d.end);return f===d.start&&o===d.end?d:new b.$bL(f.line,f.character,o.line,o.character)}x(d){if(!(d instanceof b.$aL))throw new Error("Invalid argument");if(this.f.length===0)return d.with(0,0);let{line:f,character:o}=d,i=!1;if(f<0)f=0,o=0,i=!0;else if(f>=this.f.length)f=this.f.length-1,o=this.f[f].length,i=!0;else{const s=this.f[f].length;o<0?(o=0,i=!0):o>s&&(o=s,i=!0)}return i?new b.$aL(f,o):d}y(d,f){const o=this.x(d);if(!f)f=C(this.m);else if((0,g.$Ye)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const i=(0,R.$xs)(o.character+1,(0,R.$vs)(f),this.f[o.line],0);if(i)return new b.$bL(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$eN=m;class p{constructor(d,f,o){this.a=d,this.b=f,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$bL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$bL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$fN=p}),define(ke[313],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$0K.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(R);if(!y)throw new Error("Embedding vector provider not found");const L=await y.provideEmbeddingVector(b,$);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(R,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(b,y),new T.$_K(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$Ahc=g}),define(ke[69],Se([1,0,6,32,7,22,5,20,58,3,11,23,16]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;let S=p=class{constructor(f,o){this.b=new Map,this.c=new L.$ch,this.a=f.getProxy(D.$0K.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(s){try{let n;const c=i.b.get(s.scheme);return c?(await i.a.$ensureActivation(s.scheme),n=await c.impl.stat(s)):n=await i.a.$stat(s),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===T.FilePermission.Readonly?1:void 0}}catch(n){p.e(n)}},async readDirectory(s){try{const n=i.b.get(s.scheme);return n?(await i.a.$ensureActivation(s.scheme),(await n.impl.readDirectory(s)).slice()):await i.a.$readdir(s)}catch(n){return p.e(n)}},async createDirectory(s){try{const n=i.b.get(s.scheme);return n&&!n.isReadonly?(await i.a.$ensureActivation(s.scheme),await i.d(n.impl,n.extUri,s)):await i.a.$mkdir(s)}catch(n){return p.e(n)}},async readFile(s){try{const n=i.b.get(s.scheme);return n?(await i.a.$ensureActivation(s.scheme),(await n.impl.readFile(s)).slice()):(await i.a.$readFile(s)).buffer}catch(n){return p.e(n)}},async writeFile(s,n){try{const c=i.b.get(s.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(s.scheme),await i.d(c.impl,c.extUri,c.extUri.dirname(s)),await i.c.queueFor(s,()=>Promise.resolve(c.impl.writeFile(s,n,{create:!0,overwrite:!0})))):await i.a.$writeFile(s,I.$je.wrap(n))}catch(c){return p.e(c)}},async delete(s,n){try{const c=i.b.get(s.scheme);return c&&!c.isReadonly&&!n?.useTrash?(await i.a.$ensureActivation(s.scheme),await c.impl.delete(s,{recursive:!1,...n})):await i.a.$delete(s,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(c){return p.e(c)}},async rename(s,n,c){try{return await i.a.$rename(s,n,{overwrite:!1,...c})}catch(t){return p.e(t)}},async copy(s,n,c){try{return await i.a.$copy(s,n,{overwrite:!1,...c})}catch(t){return p.e(t)}},isWritableFileSystem(s){const n=o.getCapabilities(s);if(typeof n=="number")return!(n&2048)}})}async d(f,o,i){const s=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await f.stat(i)).type&T.FileType.Directory))throw g.$nM.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(T.$Gk(n)!==T.FileSystemProviderErrorCode.FileNotFound)throw n;s.push(o.basename(i)),i=o.dirname(i)}for(let n=s.length-1;n>=0;n--){i=o.joinPath(i,s[n]);try{await f.createDirectory(i)}catch(c){if(T.$Gk(c)!==T.FileSystemProviderErrorCode.FileExists)throw c}}}static e(f){if(f instanceof g.$nM)throw f;if(f instanceof T.$Ck)switch(f.code){case T.FileSystemProviderErrorCode.FileExists:throw g.$nM.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$nM.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$nM.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$nM.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$nM.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$nM.Unavailable(f.message);default:throw new g.$nM(f.message,f.name)}if(!(f instanceof Error))throw new g.$nM(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw g.$nM.Unavailable(f.message);switch(f.name){case T.FileSystemProviderErrorCode.FileExists:throw g.$nM.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$nM.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$nM.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$nM.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$nM.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$nM.Unavailable(f.message);default:throw new g.$nM(f.message,f.name)}}addFileSystemProvider(f,o,i){return this.b.set(f,{impl:o,extUri:i?.isCaseSensitive?C.$xg:C.$zg,isReadonly:!!i?.isReadonly}),(0,y.$Rc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??C.$xg}};e.$Ngc=S,e.$Ngc=S=p=Ge([Ve(0,b.$bN),Ve(1,$.$ogc)],S),e.$Ogc=(0,R.$6h)("IExtHostConsumerFileSystem")}),define(ke[314],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;class g{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(D.$0K.MainThreadIssueReporter)}async $getIssueReporterUri(R,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(R);if(!$)throw new Error("Issue request handler not found");const y=await $.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(R,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueData(b);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(R,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueTemplate(b);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(R,b){const $=R.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new T.$_K(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(R,b){const $=R.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new T.$_K(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$Rhc=g}),define(ke[94],Se([1,0,5,27,13,69,2]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0,e.$Pgc=(0,D.$6h)("IExtensionStoragePaths");let b=class{constructor(y,L,C){this.d=L,this.f=C,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(y){return R.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,L=await this.g(y);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(R.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(y){if(this.c)return R.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return R.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Qgc=b,e.$Qgc=b=Ge([Ve(0,T.$rN),Ve(1,g.$nj),Ve(2,I.$Ogc)],b)}),define(ke[315],Se([1,0,7,20,4]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=void 0;let I=class{constructor(b){this.a=new D.$wM(D.ColorThemeKind.Dark),this.b=new g.$Vd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$wM($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$iic=I,e.$iic=I=Ge([Ve(0,T.$bN)],I)}),define(ke[70],Se([1,0,21,4,3,220,5,13,89,6,27,20,7]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wyb=e.$vyb=e.TunnelDtoConverter=void 0;class p extends $.$Jv{}var S;(function(f){function o(s){return{remoteAddress:s.remoteAddress,localAddress:s.localAddress,public:!!s.public,privacy:s.privacy??(s.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:s.protocol}}f.fromApiTunnel=o;function i(s){return{remoteAddress:{host:s.tunnelRemoteHost,port:s.tunnelRemotePort},localAddress:s.localAddress,public:s.privacy!==$.TunnelPrivacyId.ConstantPrivate&&s.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:s.privacy,protocol:s.protocol}}f.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$vyb=(0,R.$6h)("IExtHostTunnelService");let d=class extends g.$Tc{constructor(o,i,s){super(),this.s=s,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Vd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(y.$0K.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const s=await this.a.$openTunnel(i,o.displayName);if(s){const n=new p(s.remoteAddress,s.localAddress,()=>this.a.$closeTunnel(s.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const s=this.u();return this.r.set(s,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,s),new m.$_K(()=>{this.r.delete(s),this.a.$unregisterPortsAttributesProvider(s)})}async $providePortAttributes(o,i,s,n,c){const t=[];for(const r of o){const h=this.r.get(r);if(!h)return[];t.push(...await Promise.all(i.map(async u=>{let l;try{l=await h.provider.providePortAttributes({port:u,pid:s,commandLine:n},c)}catch{l=await h.provider.providePortAttributes(u,s,n,c)}return{providedAttributes:l,port:u}})))}const a=t.filter(r=>!!r.providedAttributes);return a.length>0?a.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,c)=>await o.provideTunnel(n,c,new D.$6d().token)??void 0;const s=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(s),Promise.resolve((0,g.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const s=o.tunnelFactory??(i?this.w(i):void 0);if(s){this.b=s;let n=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const c=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(c)}}else this.b=void 0;return(0,g.$Rc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const s=this.g.get(o.host);s.has(o.port)&&(i&&s.get(o.port).disposeListener.dispose(),await s.get(o.port).tunnel.dispose(),s.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const s=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),s!==void 0){const n=await s;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const c=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:n,disposeListener:c}),S.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(s){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),s instanceof Error)return s.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(n=>this.f(n.host,n.port,n.detail??""))),s=o.filter((n,c)=>i[c]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(n=>n.port).join(", ")} to ${s.map(n=>n.port).join(", ")}`),s}};e.$wyb=d,e.$wyb=d=Ge([Ve(0,C.$bN),Ve(1,L.$rN),Ve(2,b.$nj)],d)}),define(ke[15],Se([1,0,19,22,165,74,80,28,160,55,101,24,18,2,29,83,135,141,139,118,67,90,289,25,7]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c,t,a,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$aN=e.$_M=e.MarkdownString=e.$$M=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var h;(function(Me){function Fe(ae){const{selectionStartLineNumber:Ne,selectionStartColumn:Ue,positionLineNumber:xe,positionColumn:Ke}=ae,ct=new r.$aL(Ne-1,Ue-1),pt=new r.$aL(xe-1,Ke-1);return new r.$cL(ct,pt)}Me.to=Fe;function De(ae){const{anchor:Ne,active:Ue}=ae;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Me.from=De})(h||(e.Selection=h={}));var u;(function(Me){function Fe(ae){if(!ae)return;const{start:Ne,end:Ue}=ae;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Me.from=Fe;function De(ae){if(!ae)return;const{startLineNumber:Ne,startColumn:Ue,endLineNumber:xe,endColumn:Ke}=ae;return new r.$bL(Ne-1,Ue-1,xe-1,Ke-1)}Me.to=De})(u||(e.Range=u={}));var l;(function(Me){function Fe(De){return new r.$lL(p.URI.revive(De.uri),u.to(De.range))}Me.to=Fe})(l||(e.Location=l={}));var k;(function(Me){function Fe(De){switch(De){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Me.to=Fe})(k||(e.TokenType=k={}));var A;(function(Me){function Fe(ae){return new r.$aL(ae.lineNumber-1,ae.column-1)}Me.to=Fe;function De(ae){return{lineNumber:ae.line+1,column:ae.character+1}}Me.from=De})(A||(e.Position=A={}));var v;(function(Me){function Fe(Ne,Ue,xe){return(0,D.$Hb)((0,D.$3b)(Ne).map(Ke=>De(Ke,Ue,xe)))}Me.from=Fe;function De(Ne,Ue,xe){if(typeof Ne=="string")return{$serialized:!0,language:Ne,isBuiltin:xe?.isBuiltin};if(Ne)return{$serialized:!0,language:Ne.language,scheme:ae(Ne.scheme,Ue),pattern:se.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType,isBuiltin:xe?.isBuiltin}}function ae(Ne,Ue){return Ue&&typeof Ne=="string"?Ue.transformOutgoingScheme(Ne):Ne}})(v||(e.DocumentSelector=v={}));var w;(function(Me){function Fe(ae){switch(ae){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Me.from=Fe;function De(ae){switch(ae){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Me.to=De})(w||(e.DiagnosticTag=w={}));var E;(function(Me){function Fe(ae){let Ne;return ae.code&&((0,m.$If)(ae.code)||(0,m.$Mf)(ae.code)?Ne=String(ae.code):Ne={value:String(ae.code.value),target:ae.code.target}),{...u.from(ae.range),message:ae.message,source:ae.source,code:Ne,severity:N.from(ae.severity),relatedInformation:ae.relatedInformation&&ae.relatedInformation.map(P.from),tags:Array.isArray(ae.tags)?(0,D.$Hb)(ae.tags.map(w.from)):void 0}}Me.from=Fe;function De(ae){const Ne=new r.$nL(u.to(ae),ae.message,N.to(ae.severity));return Ne.source=ae.source,Ne.code=(0,m.$If)(ae.code)?ae.code:ae.code?.value,Ne.relatedInformation=ae.relatedInformation&&ae.relatedInformation.map(P.to),Ne.tags=ae.tags&&(0,D.$Hb)(ae.tags.map(w.to)),Ne}Me.to=De})(E||(e.Diagnostic=E={}));var P;(function(Me){function Fe(ae){return{...u.from(ae.location.range),message:ae.message,resource:ae.location.uri}}Me.from=Fe;function De(ae){return new r.$mL(new r.$lL(ae.resource,u.to(ae)),ae.message)}Me.to=De})(P||(e.DiagnosticRelatedInformation=P={}));var N;(function(Me){function Fe(ae){switch(ae){case r.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Me.from=Fe;function De(ae){switch(ae){case f.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Me.to=De})(N||(e.DiagnosticSeverity=N={}));var z;(function(Me){function Fe(ae){return typeof ae=="number"&&ae>=r.ViewColumn.One?ae-1:ae===r.ViewColumn.Beside?t.$cD:t.$bD}Me.from=Fe;function De(ae){if(typeof ae=="number"&&ae>=0)return ae+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=De})(z||(e.ViewColumn=z={}));function F(Me){return typeof Me.range<"u"}function j(Me){return Me.length===0?!0:!!F(Me[0])}e.$$M=j;var M;(function(Me){function Fe(Ke){return Ke.map(Me.from)}Me.fromMany=Fe;function De(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function ae(Ke){let ct;if(De(Ke)){const{language:Ct,value:wt}=Ke;ct={value:"```"+Ct+`
`+wt+"\n```\n"}}else r.$AL.isMarkdownString(Ke)?ct={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ct={value:Ke}:ct={value:""};const pt=Object.create(null);ct.uris=pt;const Kt=Ct=>{try{let wt=p.URI.parse(Ct,!0);wt=wt.with({query:Ne(wt.query,pt)}),pt[Ct]=wt}catch{}return""},St=new $.marked.Renderer;return St.link=Kt,St.image=Ct=>typeof Ct=="string"?Kt(R.$pk(Ct).href):"",(0,$.marked)(ct.value,{renderer:St}),ct}Me.from=ae;function Ne(Ke,ct){if(!Ke)return Ke;let pt;try{pt=(0,y.$Bh)(Ke)}catch{}if(!pt)return Ke;let Kt=!1;return pt=(0,C.$xn)(pt,St=>{if(p.URI.isUri(St)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Ct]=St,Kt=!0,Ct}else return}),Kt?JSON.stringify(pt):Ke}function Ue(Ke){const ct=new r.$AL(Ke.value,Ke.supportThemeIcons);return ct.isTrusted=Ke.isTrusted,ct.supportHtml=Ke.supportHtml,ct.baseUri=Ke.baseUri?p.URI.from(Ke.baseUri):void 0,ct}Me.to=Ue;function xe(Ke){if(Ke)return typeof Ke=="string"?Ke:Me.from(Ke)}Me.fromStrict=xe})(M||(e.MarkdownString=M={}));function O(Me){return j(Me)?Me.map(Fe=>({range:u.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?M.fromMany(Fe.hoverMessage):Fe.hoverMessage?M.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Me.map(Fe=>({range:u.from(Fe)}))}e.$_M=O;function U(Me){return typeof Me>"u"?Me:typeof Me=="string"?p.URI.file(Me):Me}e.$aN=U;var Q;(function(Me){function Fe(De){return typeof De>"u"?De:{contentText:De.contentText,contentIconPath:De.contentIconPath?U(De.contentIconPath):void 0,border:De.border,borderColor:De.borderColor,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,color:De.color,backgroundColor:De.backgroundColor,margin:De.margin,width:De.width,height:De.height}}Me.from=Fe})(Q||(e.ThemableDecorationAttachmentRenderOptions=Q={}));var ue;(function(Me){function Fe(De){return typeof De>"u"?De:{backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?U(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?Q.from(De.before):void 0,after:De.after?Q.from(De.after):void 0}}Me.from=Fe})(ue||(e.ThemableDecorationRenderOptions=ue={}));var Z;(function(Me){function Fe(De){if(typeof De>"u")return De;switch(De){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Fe})(Z||(e.DecorationRangeBehavior=Z={}));var J;(function(Me){function Fe(De){return{isWholeLine:De.isWholeLine,rangeBehavior:De.rangeBehavior?Z.from(De.rangeBehavior):void 0,overviewRulerLane:De.overviewRulerLane,light:De.light?ue.from(De.light):void 0,dark:De.dark?ue.from(De.dark):void 0,backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?U(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?Q.from(De.before):void 0,after:De.after?Q.from(De.after):void 0}}Me.from=Fe})(J||(e.DecorationRenderOptions=J={}));var X;(function(Me){function Fe(ae){return{text:ae.newText,eol:ae.newEol&&Ae.from(ae.newEol),range:u.from(ae.range)}}Me.from=Fe;function De(ae){const Ne=new r.$gL(u.to(ae.range),ae.text);return Ne.newEol=typeof ae.eol>"u"?void 0:Ae.to(ae.eol),Ne}Me.to=De})(X||(e.TextEdit=X={}));var le;(function(Me){function Fe(ae,Ne){const Ue={edits:[]};if(ae instanceof r.$jL){const xe=new b.$Bc;for(const Ke of ae._allEntries())Ke._type===1&&p.URI.isUri(Ke.to)&&Ke.from===void 0&&xe.add(Ke.to);for(const Ke of ae._allEntries())if(Ke._type===1){let ct;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ct={type:"base64",value:(0,T.$De)(T.$je.wrap(Ke.options.contents))}:ct={type:"dataTransferItem",id:Ke.options.contents._itemId}),Ue.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ct},metadata:Ke.metadata})}else Ke._type===2?Ue.edits.push({resource:Ke.uri,textEdit:X.from(Ke.edit),versionId:xe.has(Ke.uri)?void 0:Ne?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Ue.edits.push({resource:Ke.uri,textEdit:{range:u.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:xe.has(Ke.uri)?void 0:Ne?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Dt.from)}})}return Ue}Me.from=Fe;function De(ae){const Ne=new r.$jL,Ue=new b.$Ac;for(const xe of ae.edits)if(xe.textEdit){const Ke=xe,ct=p.URI.revive(Ke.resource),pt=u.to(Ke.textEdit.range),Kt=Ke.textEdit.text,St=Ke.textEdit.insertAsSnippet;let Ct;St?Ct=r.$iL.replace(pt,new r.$kL(Kt)):Ct=r.$gL.replace(pt,Kt);const wt=Ue.get(ct);wt?wt.push(Ct):Ue.set(ct,[Ct])}else Ne.renameFile(p.URI.revive(xe.oldResource),p.URI.revive(xe.newResource),xe.options);for(const[xe,Ke]of Ue)Ne.set(xe,Ke);return Ne}Me.to=De})(le||(e.WorkspaceEdit=le={}));var x;(function(Me){const Fe=Object.create(null);Fe[r.SymbolKind.File]=0,Fe[r.SymbolKind.Module]=1,Fe[r.SymbolKind.Namespace]=2,Fe[r.SymbolKind.Package]=3,Fe[r.SymbolKind.Class]=4,Fe[r.SymbolKind.Method]=5,Fe[r.SymbolKind.Property]=6,Fe[r.SymbolKind.Field]=7,Fe[r.SymbolKind.Constructor]=8,Fe[r.SymbolKind.Enum]=9,Fe[r.SymbolKind.Interface]=10,Fe[r.SymbolKind.Function]=11,Fe[r.SymbolKind.Variable]=12,Fe[r.SymbolKind.Constant]=13,Fe[r.SymbolKind.String]=14,Fe[r.SymbolKind.Number]=15,Fe[r.SymbolKind.Boolean]=16,Fe[r.SymbolKind.Array]=17,Fe[r.SymbolKind.Object]=18,Fe[r.SymbolKind.Key]=19,Fe[r.SymbolKind.Null]=20,Fe[r.SymbolKind.EnumMember]=21,Fe[r.SymbolKind.Struct]=22,Fe[r.SymbolKind.Event]=23,Fe[r.SymbolKind.Operator]=24,Fe[r.SymbolKind.TypeParameter]=25;function De(Ne){return typeof Fe[Ne]=="number"?Fe[Ne]:6}Me.from=De;function ae(Ne){for(const Ue in Fe)if(Fe[Ue]===Ne)return Number(Ue);return r.SymbolKind.Property}Me.to=ae})(x||(e.SymbolKind=x={}));var be;(function(Me){function Fe(ae){switch(ae){case r.SymbolTag.Deprecated:return 1}}Me.from=Fe;function De(ae){switch(ae){case 1:return r.SymbolTag.Deprecated}}Me.to=De})(be||(e.SymbolTag=be={}));var ce;(function(Me){function Fe(ae){return{name:ae.name,kind:x.from(ae.kind),tags:ae.tags&&ae.tags.map(be.from),containerName:ae.containerName,location:de.from(ae.location)}}Me.from=Fe;function De(ae){const Ne=new r.$rL(ae.name,x.to(ae.kind),ae.containerName,de.to(ae.location));return Ne.tags=ae.tags&&ae.tags.map(be.to),Ne}Me.to=De})(ce||(e.WorkspaceSymbol=ce={}));var G;(function(Me){function Fe(ae){const Ne={name:ae.name||"!!MISSING: name!!",detail:ae.detail,range:u.from(ae.range),selectionRange:u.from(ae.selectionRange),kind:x.from(ae.kind),tags:ae.tags?.map(be.from)??[]};return ae.children&&(Ne.children=ae.children.map(Fe)),Ne}Me.from=Fe;function De(ae){const Ne=new r.$sL(ae.name,ae.detail,x.to(ae.kind),u.to(ae.range),u.to(ae.selectionRange));return(0,D.$Lb)(ae.tags)&&(Ne.tags=ae.tags.map(be.to)),ae.children&&(Ne.children=ae.children.map(De)),Ne}Me.to=De})(G||(e.DocumentSymbol=G={}));var W;(function(Me){function Fe(ae){const Ne=new r.$wL(x.to(ae.kind),ae.name,ae.detail||"",p.URI.revive(ae.uri),u.to(ae.range),u.to(ae.selectionRange));return Ne._sessionId=ae._sessionId,Ne._itemId=ae._itemId,Ne}Me.to=Fe;function De(ae,Ne,Ue){if(Ne=Ne??ae._sessionId,Ue=Ue??ae._itemId,Ne===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Ue,name:ae.name,detail:ae.detail,kind:x.from(ae.kind),uri:ae.uri,range:u.from(ae.range),selectionRange:u.from(ae.selectionRange),tags:ae.tags?.map(be.from)}}Me.from=De})(W||(e.CallHierarchyItem=W={}));var ne;(function(Me){function Fe(De){return new r.$xL(W.to(De.from),De.fromRanges.map(ae=>u.to(ae)))}Me.to=Fe})(ne||(e.CallHierarchyIncomingCall=ne={}));var ye;(function(Me){function Fe(De){return new r.$yL(W.to(De.to),De.fromRanges.map(ae=>u.to(ae)))}Me.to=Fe})(ye||(e.CallHierarchyOutgoingCall=ye={}));var de;(function(Me){function Fe(ae){return{range:ae.range&&u.from(ae.range),uri:ae.uri}}Me.from=Fe;function De(ae){return new r.$lL(p.URI.revive(ae.uri),u.to(ae.range))}Me.to=De})(de||(e.location=de={}));var ge;(function(Me){function Fe(ae){const Ne=ae,Ue=ae;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Ue.uri,range:u.from(Ne.targetRange?Ne.targetRange:Ue.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Me.from=Fe;function De(ae){return{targetUri:p.URI.revive(ae.uri),targetRange:u.to(ae.range),targetSelectionRange:ae.targetSelectionRange?u.to(ae.targetSelectionRange):void 0,originSelectionRange:ae.originSelectionRange?u.to(ae.originSelectionRange):void 0}}Me.to=De})(ge||(e.DefinitionLink=ge={}));var _;(function(Me){function Fe(ae){return{range:u.from(ae.range),contents:M.fromMany(ae.contents)}}Me.from=Fe;function De(ae){return new r.$oL(ae.contents.map(M.to),u.to(ae.range))}Me.to=De})(_||(e.Hover=_={}));var te;(function(Me){function Fe(ae){return{range:u.from(ae.range),expression:ae.expression}}Me.from=Fe;function De(ae){return new r.$iM(u.to(ae.range),ae.expression)}Me.to=De})(te||(e.EvaluatableExpression=te={}));var K;(function(Me){function Fe(ae){if(ae instanceof r.$jM)return{type:"text",range:u.from(ae.range),text:ae.text};if(ae instanceof r.$kM)return{type:"variable",range:u.from(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};if(ae instanceof r.$lM)return{type:"expression",range:u.from(ae.range),expression:ae.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Fe;function De(ae){switch(ae.type){case"text":return{range:u.to(ae.range),text:ae.text};case"variable":return{range:u.to(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};case"expression":return{range:u.to(ae.range),expression:ae.expression}}}Me.to=De})(K||(e.InlineValue=K={}));var ie;(function(Me){function Fe(ae){return{frameId:ae.frameId,stoppedLocation:u.from(ae.stoppedLocation)}}Me.from=Fe;function De(ae){return new r.$mM(ae.frameId,u.to(ae.stoppedLocation))}Me.to=De})(ie||(e.InlineValueContext=ie={}));var fe;(function(Me){function Fe(ae){return{range:u.from(ae.range),kind:ae.kind}}Me.from=Fe;function De(ae){return new r.$pL(u.to(ae.range),ae.kind)}Me.to=De})(fe||(e.DocumentHighlight=fe={}));var pe;(function(Me){function Fe(ae){return{uri:ae.uri,highlights:ae.highlights.map(fe.from)}}Me.from=Fe;function De(ae){return new r.$qL(p.URI.revive(ae.uri),ae.highlights.map(fe.to))}Me.to=De})(pe||(e.MultiDocumentHighlight=pe={}));var Pe;(function(Me){function Fe(De){switch(De){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Me.to=Fe})(Pe||(e.CompletionTriggerKind=Pe={}));var we;(function(Me){function Fe(De){return{triggerKind:Pe.to(De.triggerKind),triggerCharacter:De.triggerCharacter}}Me.to=Fe})(we||(e.CompletionContext=we={}));var Ce;(function(Me){function Fe(ae){switch(ae){case r.CompletionItemTag.Deprecated:return 1}}Me.from=Fe;function De(ae){switch(ae){case 1:return r.CompletionItemTag.Deprecated}}Me.to=De})(Ce||(e.CompletionItemTag=Ce={}));var B;(function(Me){const Fe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function De(Ue){return Fe.get(Ue)??9}Me.from=De;const ae=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ne(Ue){return ae.get(Ue)??r.CompletionItemKind.Property}Me.to=Ne})(B||(e.CompletionItemKind=B={}));var Y;(function(Me){function Fe(De,ae){const Ne=new r.$GL(De.label);return Ne.insertText=De.insertText,Ne.kind=B.to(De.kind),Ne.tags=De.tags?.map(Ce.to),Ne.detail=De.detail,Ne.documentation=R.$jk(De.documentation)?M.to(De.documentation):De.documentation,Ne.sortText=De.sortText,Ne.filterText=De.filterText,Ne.preselect=De.preselect,Ne.commitCharacters=De.commitCharacters,S.$Us.isIRange(De.range)?Ne.range=u.to(De.range):typeof De.range=="object"&&(Ne.range={inserting:u.to(De.range.insert),replacing:u.to(De.range.replace)}),Ne.keepWhitespace=typeof De.insertTextRules>"u"?!1:!!(De.insertTextRules&1),typeof De.insertTextRules<"u"&&De.insertTextRules&4?Ne.insertText=new r.$kL(De.insertText):(Ne.insertText=De.insertText,Ne.textEdit=Ne.range instanceof r.$bL?new r.$gL(Ne.range,Ne.insertText):void 0),De.additionalTextEdits&&De.additionalTextEdits.length>0&&(Ne.additionalTextEdits=De.additionalTextEdits.map(Ue=>X.to(Ue))),Ne.command=ae&&De.command?ae.fromInternal(De.command):void 0,Ne}Me.to=Fe})(Y||(e.CompletionItem=Y={}));var ee;(function(Me){function Fe(ae){if(typeof ae.label!="string"&&!Array.isArray(ae.label))throw new TypeError("Invalid label");return{label:ae.label,documentation:M.fromStrict(ae.documentation)}}Me.from=Fe;function De(ae){return{label:ae.label,documentation:R.$jk(ae.documentation)?M.to(ae.documentation):ae.documentation}}Me.to=De})(ee||(e.ParameterInformation=ee={}));var q;(function(Me){function Fe(ae){return{label:ae.label,documentation:M.fromStrict(ae.documentation),parameters:Array.isArray(ae.parameters)?ae.parameters.map(ee.from):[],activeParameter:ae.activeParameter}}Me.from=Fe;function De(ae){return{label:ae.label,documentation:R.$jk(ae.documentation)?M.to(ae.documentation):ae.documentation,parameters:Array.isArray(ae.parameters)?ae.parameters.map(ee.to):[],activeParameter:ae.activeParameter}}Me.to=De})(q||(e.SignatureInformation=q={}));var oe;(function(Me){function Fe(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(q.from):[]}}Me.from=Fe;function De(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(q.to):[]}}Me.to=De})(oe||(e.SignatureHelp=oe={}));var he;(function(Me){function Fe(De,ae){const Ne=new r.$FL(A.to(ae.position),typeof ae.label=="string"?ae.label:ae.label.map(Le.to.bind(void 0,De)),ae.kind&&je.to(ae.kind));return Ne.textEdits=ae.textEdits&&ae.textEdits.map(X.to),Ne.tooltip=R.$jk(ae.tooltip)?M.to(ae.tooltip):ae.tooltip,Ne.paddingLeft=ae.paddingLeft,Ne.paddingRight=ae.paddingRight,Ne}Me.to=Fe})(he||(e.InlayHint=he={}));var Le;(function(Me){function Fe(De,ae){const Ne=new r.$EL(ae.label);return Ne.tooltip=R.$jk(ae.tooltip)?M.to(ae.tooltip):ae.tooltip,d.Command.is(ae.command)&&(Ne.command=De.fromInternal(ae.command)),ae.location&&(Ne.location=de.to(ae.location)),Ne}Me.to=Fe})(Le||(e.InlayHintLabelPart=Le={}));var je;(function(Me){function Fe(ae){return ae}Me.from=Fe;function De(ae){return ae}Me.to=De})(je||(e.InlayHintKind=je={}));var He;(function(Me){function Fe(ae){return{range:u.from(ae.range),url:ae.target,tooltip:ae.tooltip}}Me.from=Fe;function De(ae){let Ne;if(ae.url)try{Ne=typeof ae.url=="string"?p.URI.parse(ae.url,!0):p.URI.revive(ae.url)}catch{}return new r.$LL(u.to(ae.range),Ne)}Me.to=De})(He||(e.DocumentLink=He={}));var Qe;(function(Me){function Fe(ae){const Ne=new r.$OL(ae.label);return ae.textEdit&&(Ne.textEdit=X.to(ae.textEdit)),ae.additionalTextEdits&&(Ne.additionalTextEdits=ae.additionalTextEdits.map(Ue=>X.to(Ue))),Ne}Me.to=Fe;function De(ae){return{label:ae.label,textEdit:ae.textEdit?X.from(ae.textEdit):void 0,additionalTextEdits:ae.additionalTextEdits?ae.additionalTextEdits.map(Ne=>X.from(Ne)):void 0}}Me.from=De})(Qe||(e.ColorPresentation=Qe={}));var _e;(function(Me){function Fe(ae){return new r.$ML(ae[0],ae[1],ae[2],ae[3])}Me.to=Fe;function De(ae){return[ae.red,ae.green,ae.blue,ae.alpha]}Me.from=De})(_e||(e.Color=_e={}));var at;(function(Me){function Fe(ae){return{range:u.from(ae.range)}}Me.from=Fe;function De(ae){return new r.$vL(u.to(ae.range))}Me.to=De})(at||(e.SelectionRange=at={}));var st;(function(Me){function Fe(De){switch(De){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Me.to=Fe})(st||(e.TextDocumentSaveReason=st={}));var rt;(function(Me){function Fe(ae){switch(ae){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Fe;function De(ae){switch(ae){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Me.to=De})(rt||(e.TextEditorLineNumbersStyle=rt={}));var Ae;(function(Me){function Fe(ae){if(ae===r.EndOfLine.CRLF)return 1;if(ae===r.EndOfLine.LF)return 0}Me.from=Fe;function De(ae){if(ae===1)return r.EndOfLine.CRLF;if(ae===0)return r.EndOfLine.LF}Me.to=De})(Ae||(e.EndOfLine=Ae={}));var ze;(function(Me){function Fe(De){if(typeof De=="object")return De.viewId;switch(De){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Fe})(ze||(e.ProgressLocation=ze={}));var Re;(function(Me){function Fe(ae){const Ne={start:ae.start+1,end:ae.end+1};return ae.kind&&(Ne.kind=Ye.from(ae.kind)),Ne}Me.from=Fe;function De(ae){const Ne={start:ae.start-1,end:ae.end-1};return ae.kind&&(Ne.kind=Ye.to(ae.kind)),Ne}Me.to=De})(Re||(e.FoldingRange=Re={}));var Ye;(function(Me){function Fe(ae){if(ae)switch(ae){case r.FoldingRangeKind.Comment:return d.$Kt.Comment;case r.FoldingRangeKind.Imports:return d.$Kt.Imports;case r.FoldingRangeKind.Region:return d.$Kt.Region}}Me.from=Fe;function De(ae){if(ae)switch(ae.value){case d.$Kt.Comment.value:return r.FoldingRangeKind.Comment;case d.$Kt.Imports.value:return r.FoldingRangeKind.Imports;case d.$Kt.Region.value:return r.FoldingRangeKind.Region}}Me.to=De})(Ye||(e.FoldingRangeKind=Ye={}));var re;(function(Me){function Fe(De){if(De)return{pinned:typeof De.preview=="boolean"?!De.preview:void 0,inactive:De.background,preserveFocus:De.preserveFocus,selection:typeof De.selection=="object"?u.from(De.selection):void 0,override:typeof De.override=="boolean"?i.$EE.id:void 0}}Me.from=Fe})(re||(e.TextEditorOpenOptions=re={}));var se;(function(Me){function Fe(Ue){return Ue instanceof r.$9L?Ue.toJSON():typeof Ue=="string"?Ue:De(Ue)||ae(Ue)?new r.$9L(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Me.from=Fe;function De(Ue){const xe=Ue;return xe?p.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ae(Ue){const xe=Ue;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Ne(Ue){return typeof Ue=="string"?Ue:new r.$9L(p.URI.revive(Ue.baseUri),Ue.pattern)}Me.to=Ne})(se||(e.GlobPattern=se={}));var Ie;(function(Me){function Fe(De){if(De){if(Array.isArray(De))return De.map(Fe);if(typeof De=="string")return De;{const ae=De;return{language:ae.language,scheme:ae.scheme,pattern:se.from(ae.pattern),exclusive:ae.exclusive,notebookType:ae.notebookType}}}else return}Me.from=Fe})(Ie||(e.LanguageSelector=Ie={}));var qe;(function(Me){function Fe(ae){return!!ae&&typeof ae=="object"&&"documents"in ae&&Array.isArray(ae.documents)&&ae.documents.every(Ne=>Array.isArray(Ne)&&Ne.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&p.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(xe=>xe instanceof r.$bL)))}Me.is=Fe;function De(ae){return{documents:ae.documents.map(Ne=>Ne.map(Ue=>({uri:p.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(xe=>u.from(xe))})))}}Me.from=De})(qe||(e.MappedEditsContext=qe={}));var Xe;(function(Me){function Fe(ae){return{start:ae.start,end:ae.end}}Me.from=Fe;function De(ae){return new r.$xM(ae.start,ae.end)}Me.to=De})(Xe||(e.NotebookRange=Xe={}));var it;(function(Me){function Fe(ae){return{timing:typeof ae.runStartTime=="number"&&typeof ae.runEndTime=="number"?{startTime:ae.runStartTime,endTime:ae.runEndTime}:void 0,executionOrder:ae.executionOrder,success:ae.lastRunSuccess}}Me.to=Fe;function De(ae){return{lastRunSuccess:ae.success,runStartTime:ae.timing?.startTime,runEndTime:ae.timing?.endTime,executionOrder:ae.executionOrder}}Me.from=De})(it||(e.NotebookCellExecutionSummary=it={}));var nt;(function(Me){function Fe(De){if(De===s.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(De===s.NotebookCellExecutionState.Pending)return;if(De===s.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${De}`)}Me.to=Fe})(nt||(e.NotebookCellExecutionState=nt={}));var Oe;(function(Me){function Fe(ae){switch(ae){case r.NotebookCellKind.Markup:return s.CellKind.Markup;case r.NotebookCellKind.Code:default:return s.CellKind.Code}}Me.from=Fe;function De(ae){switch(ae){case s.CellKind.Markup:return r.NotebookCellKind.Markup;case s.CellKind.Code:default:return r.NotebookCellKind.Code}}Me.to=De})(Oe||(e.NotebookCellKind=Oe={}));var yt;(function(Me){function Fe(ae){const Ne={metadata:ae.metadata??Object.create(null),cells:[]};for(const Ue of ae.cells)r.$yM.validate(Ue),Ne.cells.push(Dt.from(Ue));return Ne}Me.from=Fe;function De(ae){const Ne=new r.$zM(ae.cells.map(Dt.to));return(0,m.$Vf)(ae.metadata)||(Ne.metadata=ae.metadata),Ne}Me.to=De})(yt||(e.NotebookData=yt={}));var Dt;(function(Me){function Fe(ae){return{cellKind:Oe.from(ae.kind),language:ae.languageId,mime:ae.mime,source:ae.value,metadata:ae.metadata,internalMetadata:it.from(ae.executionSummary??{}),outputs:ae.outputs?ae.outputs.map(Ft.from):[]}}Me.from=Fe;function De(ae){return new r.$yM(Oe.to(ae.cellKind),ae.source,ae.language,ae.mime,ae.outputs?ae.outputs.map(Ft.to):void 0,ae.metadata,ae.internalMetadata?it.to(ae.internalMetadata):void 0)}Me.to=De})(Dt||(e.NotebookCellData=Dt={}));var Nt;(function(Me){function Fe(ae){return{mime:ae.mime,valueBytes:T.$je.wrap(ae.data)}}Me.from=Fe;function De(ae){return new r.$AM(ae.valueBytes.buffer,ae.mime)}Me.to=De})(Nt||(e.NotebookCellOutputItem=Nt={}));var Ft;(function(Me){function Fe(ae){return{outputId:ae.id,items:ae.items.map(Nt.from),metadata:ae.metadata}}Me.from=Fe;function De(ae){const Ne=ae.items.map(Nt.to);return new r.$BM(Ne,ae.outputId,ae.metadata)}Me.to=De})(Ft||(e.NotebookCellOutput=Ft={}));var Et;(function(Me){function Fe(Ne){return ae(Ne)?{include:se.from(Ne.include)??void 0,exclude:se.from(Ne.exclude)??void 0}:se.from(Ne)??void 0}Me.from=Fe;function De(Ne){return ae(Ne)?{include:se.to(Ne.include),exclude:se.to(Ne.exclude)}:se.to(Ne)}Me.to=De;function ae(Ne){const Ue=Ne;return Ue?!(0,m.$Rf)(Ue.include)&&!(0,m.$Rf)(Ue.exclude):!1}})(Et||(e.NotebookExclusiveDocumentPattern=Et={}));var Ht;(function(Me){function Fe(De,ae,Ne){const Ue=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{alignment:De.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:ae.toInternal(Ue,Ne),text:De.text,tooltip:De.tooltip,accessibilityInformation:De.accessibilityInformation,priority:De.priority}}Me.from=Fe})(Ht||(e.NotebookStatusBarItem=Ht={}));var Ot;(function(Me){function Fe(De,ae,Ne){const Ue=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{command:ae.toInternal(Ue,Ne),label:De.label,description:De.description,detail:De.detail,documentation:De.documentation}}Me.from=Fe})(Ot||(e.NotebookKernelSourceAction=Ot={}));var Xt;(function(Me){function Fe(De){return{transientOutputs:De?.transientOutputs??!1,transientCellMetadata:De?.transientCellMetadata??{},transientDocumentMetadata:De?.transientDocumentMetadata??{},cellContentMetadata:De?.cellContentMetadata??{}}}Me.from=Fe})(Xt||(e.NotebookDocumentContentOptions=Xt={}));var Vt;(function(Me){function Fe(ae){return{uri:ae.uri,provides:ae.provides}}Me.from=Fe;function De(ae){return new r.$DM(p.URI.revive(ae.uri),ae.provides)}Me.to=De})(Vt||(e.NotebookRendererScript=Vt={}));var Ut;(function(Me){function Fe(ae){return{message:M.fromStrict(ae.message)||"",type:0,expected:ae.expectedOutput,actual:ae.actualOutput,contextValue:ae.contextValue,location:ae.location&&{range:u.from(ae.location.range),uri:ae.location.uri}}}Me.from=Fe;function De(ae){const Ne=new r.$JM(typeof ae.message=="string"?ae.message:M.to(ae.message));return Ne.actualOutput=ae.actual,Ne.expectedOutput=ae.expected,Ne.contextValue=ae.contextValue,Ne.location=ae.location?de.to(ae.location):void 0,Ne}Me.to=De})(Ut||(e.TestMessage=Ut={}));var et;(function(Me){Me.namespace=c.$6J,Me.denamespace=c.$7J})(et||(e.TestTag=et={}));var Gt;(function(Me){function Fe(ae){const Ne=(0,o.$0M)(ae).controllerId;return{extId:n.$2J.fromExtHostTestItem(ae,Ne).toString(),label:ae.label,uri:p.URI.revive(ae.uri),busy:ae.busy,tags:ae.tags.map(Ue=>et.namespace(Ne,Ue.id)),range:S.$Us.lift(u.from(ae.range)),description:ae.description||null,sortText:ae.sortText||null,error:ae.error&&M.fromStrict(ae.error)||null}}Me.from=Fe;function De(ae){return{parent:void 0,error:void 0,id:n.$2J.fromString(ae.extId).localId,label:ae.label,uri:p.URI.revive(ae.uri),tags:(ae.tags||[]).map(Ne=>{const{tagId:Ue}=et.denamespace(Ne);return new r.$KM(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(ae.range||void 0),canResolveChildren:!1,busy:ae.busy,description:ae.description||void 0,sortText:ae.sortText||void 0}}Me.toPlain=De})(Gt||(e.TestItem=Gt={})),function(Me){function Fe(ae){return{id:ae.id}}Me.from=Fe;function De(ae){return new r.$KM(ae.id)}Me.to=De}(et||(e.TestTag=et={}));var Jt;(function(Me){const Fe=(ae,Ne)=>{const Ue=[];for(const[Ke,ct]of Ne)n.$2J.compare(ct.item.extId,Ke)===2&&(Ne.delete(Ke),Ue.push(ct));const xe={...Gt.toPlain(ae.item),parent:void 0,taskStates:ae.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ct=>ct.type===0).map(Ut.to)})),children:Ue.map(Ke=>Fe(Ke,Ne))};for(const Ke of xe.children)Ke.parent=xe;return xe};function De(ae){const Ne=[],Ue=new Map;for(const xe of ae.items){Ue.set(xe.item.extId,xe);const Ke=n.$2J.root(xe.item.extId);ae.request.targets.some(ct=>ct.controllerId===Ke&&ct.testIds.includes(xe.item.extId))&&Ne.push(xe)}return{completedAt:ae.completedAt,results:Ne.map(xe=>Fe(xe,Ue))}}Me.to=De})(Jt||(e.TestResults=Jt={}));var ht;(function(Me){function Fe(Ue){return{covered:Ue.covered,total:Ue.total}}function De(Ue){return"line"in Ue?A.from(Ue):u.from(Ue)}function ae(Ue){return"branches"in Ue?{count:Ue.executionCount,location:De(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(xe=>({count:xe.executionCount,location:xe.location&&De(xe.location),label:xe.label})):void 0}:{type:0,name:Ue.name,count:Ue.executionCount,location:De(Ue.location)}}Me.fromDetailed=ae;function Ne(Ue){return{uri:Ue.uri,statement:Fe(Ue.statementCoverage),branch:Ue.branchCoverage&&Fe(Ue.branchCoverage),function:Ue.functionCoverage&&Fe(Ue.functionCoverage),details:Ue.detailedCoverage?.map(ae)}}Me.fromFile=Ne})(ht||(e.TestCoverage=ht={}));var $t;(function(Me){function Fe(De){switch(De){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Me.to=Fe})($t||(e.CodeActionTriggerKind=$t={}));var Bt;(function(Me){function Fe(ae){const Ne=new r.$QM(x.to(ae.kind),ae.name,ae.detail||"",p.URI.revive(ae.uri),u.to(ae.range),u.to(ae.selectionRange));return Ne._sessionId=ae._sessionId,Ne._itemId=ae._itemId,Ne}Me.to=Fe;function De(ae,Ne,Ue){if(Ne=Ne??ae._sessionId,Ue=Ue??ae._itemId,Ne===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Ue,kind:x.from(ae.kind),name:ae.name,detail:ae.detail??"",uri:ae.uri,range:u.from(ae.range),selectionRange:u.from(ae.selectionRange),tags:ae.tags?.map(be.from)}}Me.from=De})(Bt||(e.TypeHierarchyItem=Bt={}));var Qt;(function(Me){function Fe(De){if(De)return{value:De.value,tooltip:De.tooltip}}Me.from=Fe})(Qt||(e.ViewBadge=Qt={}));var kt;(function(Me){function Fe(Ue,xe,Ke){const ct=xe.fileData;return ct?new r.$2L(new r.$3L(ct.name,p.URI.revive(ct.uri),ct.id,(0,I.$db)(()=>Ke(ct.id)))):Ue===L.$fs.uriList&&xe.uriListData?new r.$1L(Ne(xe.uriListData)):new r.$1L(xe.asString)}Me.to=Fe;async function De(Ue,xe){const Ke=await xe.asString();if(Ue===L.$fs.uriList)return{asString:Ke,fileData:void 0,uriListData:ae(Ke)};const ct=xe.asFile();return{asString:Ke,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}Me.from=De;function ae(Ue){return g.$rt.split(Ue).map(xe=>{if(xe.startsWith("#"))return xe;try{return p.URI.parse(xe)}catch{}return xe})}function Ne(Ue){return g.$rt.create(Ue.map(xe=>typeof xe=="string"?xe:p.URI.revive(xe)))}})(kt||(e.DataTransferItem=kt={}));var ft;(function(Me){function Fe(ae,Ne){const Ue=ae.items.map(([xe,Ke])=>[xe,kt.to(xe,Ke,Ne)]);return new r.$4L(Ue)}Me.toDataTransfer=Fe;async function De(ae){const Ne={items:[]},Ue=[];for(const[xe,Ke]of ae)Ue.push((async()=>{Ne.items.push([xe,await kt.from(xe,Ke)])})());return await Promise.all(Ue),Ne}Me.from=De})(ft||(e.DataTransfer=ft={}));var It;(function(Me){function Fe(De){return{kind:"reply",message:De.message,title:De.title,tooltip:De.tooltip}}Me.from=Fe})(It||(e.ChatReplyFollowup=It={}));var _t;(function(Me){function Fe(De){return typeof De=="string"?{title:De,message:De,kind:"reply"}:"commandId"in De?{kind:"command",title:De.title??"",commandId:De.commandId??"",when:De.when??"",args:De.args}:It.from(De)}Me.from=Fe})(_t||(e.ChatFollowup=_t={}));var At;(function(Me){function Fe(ae){const Ne=new r.$3M(Je.to(ae.role),ae.content);return Ne.name=ae.name,Ne}Me.to=Fe;function De(ae){return{role:Je.from(ae.role),content:ae.content,name:ae.name}}Me.from=De})(At||(e.ChatMessage=At={}));var Je;(function(Me){function Fe(ae){switch(ae){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Me.to=Fe;function De(ae){switch(ae){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Me.from=De})(Je||(e.ChatMessageRole=Je={}));var Mt;(function(Me){function Fe(Ne){const Ue={};for(const xe of Object.keys(Ne))Ue[xe]=Ne[xe].map(Me.to);return Ue}Me.objectTo=Fe;function De(Ne){return{level:jt.to(Ne.level),kind:Ne.kind,value:(0,p.$vc)(Ne.value)?p.URI.revive(Ne.value):Ne.value,description:Ne.description}}Me.to=De;function ae(Ne){return{level:jt.from(Ne.level),kind:Ne.kind,value:Ne.value,description:Ne.description}}Me.from=ae})(Mt||(e.ChatVariable=Mt={}));var jt;(function(Me){function Fe(ae){switch(ae){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Me.to=Fe;function De(ae){switch(ae){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Me.from=De})(jt||(e.ChatVariableLevel=jt={}));var Yt;(function(Me){function Fe(De){switch(De){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=Fe})(Yt||(e.InteractiveEditorResponseFeedbackKind=Yt={}));var gt;(function(Me){function Fe(Ne,Ue){return"placeholder"in Ue&&"resolvedContent"in Ue?{content:Ue.placeholder,kind:"asyncContent"}:"markdownContent"in Ue?((0,a.$GF)(Ne,"chatAgents2Additions"),{content:M.from(Ue.markdownContent),kind:"markdownContent"}):"content"in Ue?"vulnerabilities"in Ue&&Ue.vulnerabilities?((0,a.$GF)(Ne,"chatAgents2Additions"),{content:Ue.content,vulnerabilities:Ue.vulnerabilities,kind:"vulnerability"}):typeof Ue.content=="string"?{content:Ue.content,kind:"content"}:((0,a.$GF)(Ne,"chatAgents2Additions"),{content:M.from(Ue.content),kind:"markdownContent"}):"documents"in Ue?{documents:Ue.documents.map(xe=>({uri:xe.uri,version:xe.version,ranges:xe.ranges.map(Ke=>u.from(Ke))})),kind:"usedContext"}:"reference"in Ue?{reference:"uri"in Ue.reference?{uri:Ue.reference.uri,range:u.from(Ue.reference.range)}:Ue.reference,kind:"reference"}:"inlineReference"in Ue?{inlineReference:"uri"in Ue.inlineReference?{uri:Ue.inlineReference.uri,range:u.from(Ue.inlineReference.range)}:Ue.inlineReference,name:Ue.title,kind:"inlineReference"}:"agentName"in Ue?((0,a.$GF)(Ne,"chatAgents2Additions"),{agentName:Ue.agentName,command:Ue.command,kind:"agentDetection"}):"treeData"in Ue?{treeData:Ue.treeData,kind:"treeData"}:"message"in Ue?{content:M.from(Ue.message),kind:"progressMessage"}:void 0}Me.from=Fe;function De(Ne){switch(Ne.kind){case"markdownContent":case"inlineReference":case"treeData":return Me.to(Ne);case"content":return{content:Ne.content};case"usedContext":return{documents:Ne.documents.map(Ue=>({uri:p.URI.revive(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(xe=>u.to(xe))}))};case"reference":return{reference:(0,p.$vc)(Ne.reference)?p.URI.revive(Ne.reference):l.to(Ne.reference)};case"agentDetection":return;case"progressMessage":return{message:Ne.content.value};case"vulnerability":return{content:Ne.content,vulnerabilities:Ne.vulnerabilities};default:return}}Me.to=De;function ae(Ne){switch(Ne.kind){case"markdownContent":return{content:Ne.content.value};case"inlineReference":return{inlineReference:(0,p.$vc)(Ne.inlineReference)?p.URI.revive(Ne.inlineReference):l.to(Ne.inlineReference),title:Ne.name};case"treeData":return{treeData:(0,y.$Ch)(Ne.treeData)};default:return}}Me.toProgressContent=ae})(gt||(e.ChatResponseProgress=gt={}));var Tt;(function(Me){function Fe(De,ae){return{prompt:De.message,variables:Mt.objectTo(De.variables),slashCommand:ae,subCommand:De.command,agentId:De.agentId}}Me.to=Fe})(Tt||(e.ChatAgentRequest=Tt={}));var Rt;(function(Me){function Fe(De){return{label:De.label,values:De.values.map(Mt.from),insertText:De.insertText,detail:De.detail,documentation:De.documentation}}Me.from=Fe})(Rt||(e.ChatAgentCompletionItem=Rt={}));var Wt;(function(Me){function Fe(De,ae,Ne){return"terminalCommand"in De?{terminalCommand:De.terminalCommand,shouldExecute:De.shouldExecute}:"uri"in De?{uri:De.uri}:ae.toInternal(De,Ne)}Me.from=Fe})(Wt||(e.TerminalQuickFix=Wt={}))}),define(ke[316],Se([1,0,6,20,15]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;let I=class{constructor(b,$){this.a=b.getProxy(D.$0K.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>$.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,y){const L=g.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,y?.isRefactoring??!1)}};e.$xgc=I,e.$xgc=I=Ge([Ve(0,T.$bN)],I)}),define(ke[317],Se([1,0,53,3,6,15]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;class R{static{this.a=0}constructor(y,L){this.extension=y,this.provider=L,this.handle=R.a++}}class b{static{this.a=0}constructor(y){this.b=new Map,this.c=new Map,this.d=y.getProxy(g.$0K.MainThreadChat)}registerChatProvider(y,L,C){const m=new R(y,C);return this.b.set(m.handle,m),this.d.$registerChatProvider(m.handle,L),(0,T.$Rc)(()=>{this.d.$unregisterChatProvider(m.handle),this.b.delete(m.handle)})}transferChatSession(y,L){const C=D.Iterable.find(this.c.keys(),m=>this.c.get(m)===y)??0;typeof C=="number"&&this.d.$transferChatSession(C,L)}sendInteractiveRequestToProvider(y,L){this.d.$sendRequestToProvider(y,L)}async $prepareChat(y,L){const C=this.b.get(y);if(!C)return;const m=await C.provider.prepareSession(L);if(!m)return;const p=b.a++;return this.c.set(p,m),{id:p,requesterUsername:m.requester?.name,requesterAvatarIconUri:m.requester?.icon,responderUsername:m.responder?.name,responderAvatarIconUri:m.responder?.icon,inputPlaceholder:m.inputPlaceholder}}async $provideWelcomeMessage(y,L){const C=this.b.get(y);if(!C||!C.provider.provideWelcomeMessage)return;const m=await C.provider.provideWelcomeMessage(L);if(m)return m.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(S=>I.ChatReplyFollowup.from(S)):I.MarkdownString.from(p))}async $provideSampleQuestions(y,L){const C=this.b.get(y);if(!C||!C.provider.provideSampleQuestions)return;const m=await C.provider.provideSampleQuestions(L);if(m)return m?.map(p=>I.ChatReplyFollowup.from(p))}$releaseSession(y){this.c.delete(y)}}e.$ygc=b}),define(ke[318],Se([1,0,19,11,21,44,4,38,18,2,210,86,6,15,7,279,25]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class o{static{this.a=0}constructor(n,c,t){this.j=c,this.k=t,this.b=new Map,this.g=new Map,this.i=new Map,this.d=n.getProxy(m.$0K.MainThreadChatAgents2)}createChatAgent(n,c,t){const a=o.a++,r=new i(n,c,this.d,a,t);return this.b.set(a,r),this.d.$registerAgent(a,c,{}),r.apiAgent}async $invokeAgent(n,c,t,a){this.g.delete(c.sessionId);const r=this.b.get(n);if(!r)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let h=!1;function u(){if(h)throw new Error("Only valid while executing the command")}const l=new T.$qh;a.onCancellationRequested(()=>l.complete()),this.j.allowListExtensionWhile(r.extension.identifier,l.p);const k=c.command?await r.validateSlashCommand(c.command):void 0,A=b.$Rd.create(!1);let v;try{const w=await this.l(r,c,t),E=r.invoke(p.ChatAgentRequest.to(c,k),{history:w},new C.$vv(P=>{u(),typeof v>"u"&&"content"in P&&(v=A.elapsed());const N=p.ChatResponseProgress.from(r.extension,P);if(!N){this.k.error("Unknown progress type: "+JSON.stringify(P));return}if("placeholder"in P&&"resolvedContent"in P){const z=Promise.all([this.d.$handleProgressChunk(c.requestId,N),P.resolvedContent]);(0,T.$Ug)(z,a).then(F=>{if(!F)return;const[j,M]=F,O=p.ChatResponseProgress.from(r.extension,M);if(!O){this.k.error("Unknown progress type: "+JSON.stringify(M));return}this.d.$handleProgressChunk(c.requestId,O,j??void 0)})}else this.d.$handleProgressChunk(c.requestId,N)}),a);return await(0,T.$Ug)(Promise.resolve(E).then(P=>{if(P){this.g.set(c.sessionId,P);let N=this.i.get(c.sessionId);N||(N=new Map,this.i.set(c.sessionId,N)),N.set(c.requestId,P);const z={firstProgress:v,totalElapsed:A.elapsed()};return{errorDetails:P.errorDetails,timings:z}}else this.g.delete(c.sessionId)}),a)}catch(w){return this.k.error(w,r.extension),{errorDetails:{message:(0,L.localize)(0,null,(0,I.$Qi)(w)),responseIsIncomplete:!0}}}finally{h=!0,l.complete()}}async l(n,c,t){return(0,D.$Hb)(await Promise.all(t.history.map(async a=>{const r=c.agentId===a.request.agentId&&this.i.get(c.sessionId)?.get(a.request.requestId)||a.result;return{request:p.ChatAgentRequest.to(a.request,void 0),response:(0,D.$Hb)(a.response.map(h=>p.ChatResponseProgress.toProgressContent(h))),result:r}})))}$releaseSession(n){this.g.delete(n),this.i.delete(n)}async $provideSlashCommands(n,c){const t=this.b.get(n);return t?t.provideSlashCommand(c):[]}$provideFollowups(n,c,t){const a=this.b.get(n);if(!a)return Promise.resolve([]);const r=this.g.get(c);return r?a.provideFollowups(r,t):Promise.resolve([])}$acceptFeedback(n,c,t,a,r){const h=this.b.get(n);if(!h)return;const u=this.i.get(c)?.get(t);if(!u)return;let l;switch(a){case d.InteractiveSessionVoteDirection.Down:l=S.ChatAgentResultFeedbackKind.Unhelpful;break;case d.InteractiveSessionVoteDirection.Up:l=S.ChatAgentResultFeedbackKind.Helpful;break}h.acceptFeedback(Object.freeze(r?{result:u,kind:l,reportIssue:r}:{result:u,kind:l}))}$acceptAction(n,c,t,a){const r=this.b.get(n);if(!r)return;const h=this.i.get(c)?.get(t);h&&a.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:a.action,result:h}))}async $invokeCompletionProvider(n,c,t){const a=this.b.get(n);return a?(await a.invokeCompletionProvider(c,t)).map(p.ChatAgentCompletionItem.from):[]}}e.$Agc=o;class i{constructor(n,c,t,a,r){this.extension=n,this.id=c,this.w=t,this.x=a,this.y=r,this.q=new R.$Vd,this.s=new R.$Vd}acceptFeedback(n){this.q.fire(n)}acceptAction(n){this.s.fire(n)}async invokeCompletionProvider(n,c){return this.u?await this.u.provider.provideCompletionItems(n,c)??[]:[]}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(g.CancellationToken.None),(0,$.$Sf)(this.b));const c=this.b.find(t=>t.name===n);if(!c)throw new Error(`Unknown slashCommand: ${n}`);return c}async provideSlashCommand(n){if(!this.a)return[];const c=await this.a.provideSlashCommands(n);return c?(this.b=c,c.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest}))):[]}async provideFollowups(n,c){if(!this.d)return[];const t=await this.d.provideFollowups(n,c);return t?t.map(a=>p.ChatFollowup.from(a)):[]}get apiAgent(){let n=!1,c=!1;const t=()=>{n||c||(c=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.g??"",fullName:this.i,icon:this.j?this.j instanceof y.URI?this.j:"light"in this.j?this.j.light:void 0:void 0,iconDark:this.j&&"dark"in this.j?this.j.dark:void 0,themeIcon:this.j instanceof S.$7L?this.j:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.k,isSecondary:this.o,helpTextPrefix:!this.l||typeof this.l=="string"?this.l:p.MarkdownString.from(this.l),helpTextPostfix:!this.m||typeof this.m=="string"?this.m:p.MarkdownString.from(this.m),sampleRequest:this.n,supportIssueReporting:this.t}),c=!1}))},a=this;return{get name(){return a.id},get description(){return a.g??""},set description(r){a.g=r,t()},get fullName(){return a.i??a.extension.displayName??a.extension.name},set fullName(r){a.i=r,t()},get iconPath(){return a.j},set iconPath(r){a.j=r,t()},get slashCommandProvider(){return a.a},set slashCommandProvider(r){a.a=r,t()},get followupProvider(){return a.d},set followupProvider(r){a.d=r,t()},get isDefault(){return(0,f.$GF)(a.extension,"defaultChatAgent"),a.k},set isDefault(r){(0,f.$GF)(a.extension,"defaultChatAgent"),a.k=r,t()},get helpTextPrefix(){return(0,f.$GF)(a.extension,"defaultChatAgent"),a.l},set helpTextPrefix(r){if((0,f.$GF)(a.extension,"defaultChatAgent"),!a.k)throw new Error("helpTextPrefix is only available on the default chat agent");a.l=r,t()},get helpTextPostfix(){return(0,f.$GF)(a.extension,"defaultChatAgent"),a.m},set helpTextPostfix(r){if((0,f.$GF)(a.extension,"defaultChatAgent"),!a.k)throw new Error("helpTextPostfix is only available on the default chat agent");a.m=r,t()},get isSecondary(){return(0,f.$GF)(a.extension,"defaultChatAgent"),a.o},set isSecondary(r){(0,f.$GF)(a.extension,"defaultChatAgent"),a.o=r,t()},get sampleRequest(){return a.n},set sampleRequest(r){a.n=r,t()},get supportIssueReporting(){return(0,f.$GF)(a.extension,"chatAgents2Additions"),a.t},set supportIssueReporting(r){(0,f.$GF)(a.extension,"chatAgents2Additions"),a.t=r,t()},get onDidReceiveFeedback(){return a.q.event},set agentVariableProvider(r){if(a.u=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");a.w.$registerAgentCompletionsProvider(a.x,r.triggerCharacters)}else a.w.$unregisterAgentCompletionsProvider(a.x)},get agentVariableProvider(){return a.u},onDidPerformAction:(0,f.$FF)(this.extension,"chatAgents2Additions")?this.s.event:void 0,dispose(){n=!0,a.a=void 0,a.d=void 0,a.q.dispose(),a.w.$unregisterAgent(a.x)}}}invoke(n,c,t,a){return this.y(n,c,t,a)}}}),define(ke[319],Se([1,0,21,3,6,15,86,26,11,4]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;class L{constructor(S,d){this.stream=new $.$wh,this.stream=d??new $.$wh;const f=this;this.apiObj={option:S,response:f.stream.asyncIterable}}}class C{constructor(S,d){this.a=new y.$Vd,this.b=new Map,this.c=new $.$wh,this.d=!1;const f=this;this.apiObject={result:S,response:f.c.asyncIterable,onDidStartResponseStream:f.a.event,cancel(){d.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let d=this.b.get(S.index);d||(this.b.size===0?d=new L(S.index,this.c):d=new L(S.index),this.b.set(S.index,d),this.a.fire(d.apiObj)),d.stream.emitOne(S.part)}}class m{static{this.a=1}constructor(S,d){this.d=d,this.c=new Map,this.e=new Map,this.f=new b.$nm,this.b=S.getProxy(g.$0K.MainThreadChatProvider)}registerProvider(S,d,f,o){const i=m.a++;return this.c.set(i,{extension:S,provider:f}),this.b.$registerProvider(i,d,{extension:S,model:o.name??""}),(0,T.$Rc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,d,f,o,i){const s=this.c.get(S);if(!s)return;const n=new R.$vv(async c=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${s.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(d,{index:c.index,part:c.part})});return s.provider.provideChatResponse(f.map(I.ChatMessage.to),o,n,i)}allowListExtensionWhile(S,d){this.f.set(S,d),d.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,d){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const f=await this.b.$prepareChatAccess(d);if(!f)throw new Error(`ChatAccess '${d}' NOT found`);const o=this;return{get model(){return f.model},get isRevoked(){return!o.f.has(S)},makeRequest(i,s,n){if(!o.f.has(S))throw new Error("Access to chat has been revoked");const c=new D.$6d(n),t=Math.random()*1e6|0,a=o.b.$fetchResponse(S,d,t,i.map(I.ChatMessage.from),s??{},c.token),r=new C(a,c);return o.e.set(t,{res:r}),a.finally(()=>{o.e.delete(t)}),r.apiObject}}}async $handleResponseFragment(S,d){const f=this.e.get(S);f&&f.res.handleFragment(d)}}e.$zgc=m}),define(ke[320],Se([1,0,3,6,14,15]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class R{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(T.$0K.MainThreadChatVariables)}async $resolveVariable($,y,L){const C=this.b.get($);if(C)try{const m=await C.resolver.resolve(C.data.name,{prompt:y},L);if(m)return m.map(I.ChatVariable.from)}catch(m){(0,g.$2)(m)}}registerVariableResolver($,y,L,C){const m=R.a++;return this.b.set(m,{extension:$.identifier,data:{name:y,description:L},resolver:C}),this.c.$registerVariable(m,{name:y,description:L}),(0,D.$Rc)(()=>{this.b.delete(m),this.c.$unregisterVariable(m)})}}e.$Bgc=R}),define(ke[321],Se([1,0,11,52,4,3,2,83,26,15,7,6,25]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;function p(S,d,f){const o=S.getProxy(C.$0K.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$nm,d.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const k=this.b.get(l.handle);return k?k.value:l}else if(l&&l.$mid===7){const k=this.b.get(l.commentControlHandle);if(!k)return l;const A=k.getCommentThread(l.commentThreadHandle);return A?A.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const k=this.b.get(l.thread.commentControlHandle);if(!k)return l;const A=k.getCommentThread(l.thread.commentThreadHandle);return A?l.$mid===8?A.value:{thread:A.value,text:l.text}:l}else if(l&&l.$mid===10){const k=this.b.get(l.thread.commentControlHandle);if(!k)return l;const A=k.getCommentThread(l.thread.commentThreadHandle);if(!A)return l;const v=l.commentUniqueId,w=A.getCommentByUniqueId(v);return w||l}else if(l&&l.$mid===11){const k=this.b.get(l.thread.commentControlHandle);if(!k)return l;const A=k.getCommentThread(l.thread.commentThreadHandle);if(!A)return l;const v=l.text,w=l.commentUniqueId,E=A.getCommentByUniqueId(w);return E?(typeof E.body=="string"?E.body=v:E.body=new L.$AL(v),E):l}return l}})}createCommentController(l,k,A){const v=i.a++,w=new n(l,v,k,A);this.b.set(w.handle,w);const E=this.c.get(l.identifier)||[];return E.push(w),this.c.set(l.identifier,E),w.value}async $createCommentThreadTemplate(l,k,A){const v=this.b.get(l);v&&v.$createCommentThreadTemplate(k,A)}async $updateCommentThreadTemplate(l,k,A){const v=this.b.get(l);v&&v.$updateCommentThreadTemplate(k,A)}$deleteCommentThread(l,k){this.b.get(l)?.$deleteCommentThread(k)}$provideCommentingRanges(l,k,A){const v=this.b.get(l);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const w=f.getDocument(R.URI.revive(k));return(0,D.$Yg)(async()=>{const E=await v.commentingRangeProvider.provideCommentingRanges(w,A);let P;return Array.isArray(E)?P={ranges:E,fileComments:!1}:E?P={ranges:E.ranges||[],fileComments:E.fileComments||!1}:P=E??void 0,P}).then(E=>{let P;return E&&(P={ranges:E.ranges.map(N=>y.Range.from(N)),fileComments:E.fileComments}),P})}$toggleReaction(l,k,A,v,w){const E=this.b.get(l);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,D.$Yg)(()=>{const P=E.getCommentThread(k);if(P){const N=P.getCommentByUniqueId(v.uniqueIdInThread);if(E!==void 0&&N&&E.reactionHandler)return E.reactionHandler(N,a(w))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,k,A,v,w,E,P,N){this.m=k,this.n=A,this.o=v,this.p=w,this.q=E,this.extensionDescription=P,this.r=N,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Vd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new I.$Uc,this.l.value=new I.$Sc,this.n===void 0&&(this.n=`${l}.${this.handle}`),o.$createCommentThread(k,this.handle,this.n,this.o,y.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{o.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(F){z.range=F},get comments(){return z.comments},set comments(F){z.comments=F},get collapsibleState(){return z.collapsibleState},set collapsibleState(F){z.collapsibleState=F},get canReply(){return z.canReply},set canReply(F){z.canReply=F},get contextValue(){return z.contextValue},set contextValue(F){z.contextValue=F},get label(){return z.label},set label(F){z.label=F},get state(){return z.state},set state(F){z.state=F},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new I.$Sc);const l=A=>Object.prototype.hasOwnProperty.call(this.b,A),k={};l("range")&&(k.range=y.Range.from(this.p)),l("label")&&(k.label=this.label),l("contextValue")&&(k.contextValue=this.contextValue??null),l("comments")&&(k.comments=this.q.map(A=>c(this,A,this.k,this.extensionDescription))),l("collapsibleState")&&(k.collapseState=r(this.g)),l("canReply")&&(k.canReply=this.canReply),l("state")&&(k.state=h(this.h)),l("isTemplate")&&(k.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(l){for(const k of this.k){const A=k[0],v=k[1];if(l===v)return A}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Ge([(0,T.$yh)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,k,A,v){this.f=l,this.g=k,this.h=A,this.i=v,this.a=new Map,o.$registerCommentController(this.handle,A,v,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(E){w.options=E},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(E){w.commentingRangeProvider=E},get reactionHandler(){return w.reactionHandler},set reactionHandler(E){w.reactionHandler=E},createCommentThread(E,P,N){return w.createCommentThread(E,P,N).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(l,k,A){k===void 0&&(0,m.$GF)(this.f,"fileComments");const v=new s(this.id,this.handle,void 0,l,k,A,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(l,k){const A=new s(this.id,this.handle,void 0,R.URI.revive(l),y.Range.to(k),[],this.f,!0);return A.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(A.handle,A),A}$updateCommentThreadTemplate(l,k){const A=this.a.get(l);A&&(A.range=y.Range.to(k))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function c(u,l,k,A){let v=k.get(l);return v||(v=++u.commentHandle,k.set(l,v)),l.state!==void 0&&(0,m.$GF)(A,"commentsDraftState"),l.reactions?.some(w=>w.reactors!==void 0)&&(0,m.$GF)(A,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:v,body:typeof l.body=="string"?l.body:y.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(w=>t(w)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(u){return{label:u.label,iconPath:u.iconPath?y.$aN(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted,reactors:u.reactors&&u.reactors.length>0&&typeof u.reactors[0]!="string"?u.reactors.map(l=>l.name):u.reactors}}function a(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?R.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1,reactors:u.reactors?.map(l=>({name:l}))}}function r(u){if(u!==void 0)switch(u){case L.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function h(u){if(u!==void 0)switch(u){case L.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$Fgc=p}),define(ke[322],Se([1,0,21,54,3,16,23,2,15,93,110,6,7]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class p{constructor(a,r){this.document=a,this.b=r,this.a=1,this.c=new L.$kgc("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,r){await this.f(a).undo(),r||this.disposeBackup()}async redo(a,r){await this.f(a).redo(),r||this.disposeBackup()}disposeEdits(a){for(const r of a)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=c(this.document.uri)+this.a++;return(0,R.$Hg)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const r=this.c.get(a,0);if(!r)throw new Error("No edit found");return r}}class S{constructor(){this.a=new Map}get(a,r){return this.a.get(this.b(a,r))}add(a,r,h){const u=this.b(a,r.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${a} resource:${r.uri}`);const l=new p(r,h);return this.a.set(u,l),l}delete(a,r){const h=this.b(a,r.uri);this.a.delete(h)}b(a,r){return`${a}@@@${r}`}}var d;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(d||(d={}));class f{constructor(){this.a=new Map}addTextProvider(a,r,h){return this.b(0,a,r,h)}addCustomProvider(a,r,h){return this.b(1,a,r,h)}get(a){return this.a.get(a)}b(a,r,h,u){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:a,extension:h,provider:u}),new m.$_K(()=>this.a.delete(r))}}class o{constructor(a,r,h,u,l){this.d=r,this.f=h,this.g=u,this.h=l,this.b=new f,this.c=new S,this.a=a.getProxy(C.$0K.MainThreadCustomEditors)}registerCustomEditorProvider(a,r,h,u){const l=new g.$Sc;return s(h)?(l.add(this.b.addTextProvider(r,a,h)),this.a.$registerTextEditorProvider((0,y.$Ugc)(a),r,u.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,y.$Sgc)(a))):(l.add(this.b.addCustomProvider(r,a,h)),i(h)&&l.add(h.onDidChangeCustomDocument(k=>{const A=this.i(r,k.document.uri);if(n(k)){const v=A.addEdit(k);this.a.$onDidEdit(k.document.uri,r,v,k.label)}else this.a.$onContentChange(k.document.uri,r)})),this.a.$registerCustomEditorProvider((0,y.$Ugc)(a),r,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,y.$Sgc)(a))),m.$_K.from(l,new m.$_K(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(a,r,h,u,l){const k=this.b.get(r);if(!k)throw new Error(`No provider found for '${r}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${r}'`);const A=b.URI.revive(a),v=await k.provider.openCustomDocument(A,{backupId:h,untitledDocumentData:u?.buffer},l);let w;return i(k.provider)&&this.f&&(w=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(r,v,w),{editable:i(k.provider)}}async $disposeCustomDocument(a,r){const h=this.b.get(r);if(!h)throw new Error(`No provider found for '${r}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${r}'`);const u=b.URI.revive(a),{document:l}=this.i(r,u);this.c.delete(r,l),l.dispose()}async $resolveCustomEditor(a,r,h,u,l,k){const A=this.b.get(h);if(!A)throw new Error(`No provider found for '${h}'`);const v=$.ViewColumn.to(l),w=this.g.createNewWebview(r,u.contentOptions,A.extension),E=this.h.createNewWebviewPanel(r,h,u.title,v,u.options,w,u.active),P=b.URI.revive(a);switch(A.type){case 1:{const{document:N}=this.i(h,P);return A.provider.resolveCustomEditor(N,E,k)}case 0:{const N=this.d.getDocument(P);return A.provider.resolveCustomTextEditor(N,E,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,r,h){this.i(r,a).disposeEdits(h)}async $onMoveCustomEditor(a,r,h){const u=this.b.get(h);if(!u)throw new Error(`No provider found for '${h}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const l=this.h.getWebviewPanel(a);if(!l)throw new Error("No webview found");const k=b.URI.revive(r),A=this.d.getDocument(k);await u.provider.moveCustomTextEditor(A,l,D.CancellationToken.None)}async $undo(a,r,h,u){return this.i(r,a).undo(h,u)}async $redo(a,r,h,u){return this.i(r,a).redo(h,u)}async $revert(a,r,h){const u=this.i(r,a);await this.j(r).revertCustomDocument(u.document,h),u.disposeBackup()}async $onSave(a,r,h){const u=this.i(r,a);await this.j(r).saveCustomDocument(u.document,h),u.disposeBackup()}async $onSaveAs(a,r,h,u){const l=this.i(r,a);return this.j(r).saveCustomDocumentAs(l.document,b.URI.revive(h),u)}async $backup(a,r,h){const u=this.i(r,a),k=await this.j(r).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},h);return u.updateBackup(k),k.id}i(a,r){const h=this.c.get(a,b.URI.revive(r));if(!h)throw new Error("No custom document found");return h}j(a){const h=this.b.get(a)?.provider;if(!h||!i(h))throw new Error("Custom document is not editable");return h}}e.$Xgc=o;function i(t){return!!t.onDidChangeCustomDocument}function s(t){return typeof t.resolveCustomTextEditor=="function"}function n(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function c(t){const a=t.scheme===I.Schemas.file||t.scheme===I.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Ti)(a)+""}}),define(ke[323],Se([1,0,211,135,2,6,7,15,4,13,28,58]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=e.$pgc=void 0;class p{#e;#t;#i;constructor(f,o,i,s,n,c,t,a){this.d=f,this.e=o,this.f=i,this.g=s,this.h=n,this.c=!1,this.f=Math.max(s,i),this.#i=new L.$Ac(r=>c.getComparisonKey(r)),this.#e=t,this.#t=a}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,o){if(!f){this.clear();return}this.j();let i=[];if(g.URI.isUri(f)){if(!o){this.delete(f);return}this.#i.set(f,o.slice()),i=[f]}else if(Array.isArray(f)){i=[];let c;f=[...f].sort(p.k);for(const t of f){const[a,r]=t;if((!c||a.toString()!==c.toString())&&(c&&this.#i.get(c).length===0&&this.#i.delete(c),c=a,i.push(a),this.#i.set(a,[])),r)this.#i.get(a)?.push(...r);else{const h=this.#i.get(a);h&&(h.length=0)}}}if(this.#t.fire(i),!this.#e)return;const s=[];let n=0;for(const c of i){let t=[];const a=this.#i.get(c);if(a)if(a.length>this.g){t=[];const r=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(const u of a)if(u.severity===r[h]&&t.push({...b.Diagnostic.from(u),modelVersionId:this.h(c)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,D.localize)(0,null,a.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=a.map(r=>({...b.Diagnostic.from(r),modelVersionId:this.h(c)}));if(s.push([c,t]),n+=t.length,n>this.f)break}this.#e.$changeMany(this.e,s)}delete(f){this.j(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(f,o){this.j();for(const[i,s]of this)f.call(o,i,s,this)}*[Symbol.iterator](){this.j();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this.j();const o=this.#i.get(f);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#i.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,o){return f[0].toString()<o[0].toString()?-1:f[0].toString()>o[0].toString()?1:0}}e.$pgc=p;let S=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(f){const o=new L.$Ac;for(const i of f)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(f,o,i,s){this.j=o,this.k=i,this.l=s,this.g=new Map,this.h=new $.$Zd({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=f.getProxy(I.$0K.MainThreadDiagnostics)}createDiagnosticCollection(f,o){const{g:i,f:s,h:n,j:c,k:t,l:a}=this,r=new class{$changeMany(l,k){s.$changeMany(l,k),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,l,k.length===0?"CLEARING":k)}$clear(l){s.$clear(l),c.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,l)}dispose(){s.dispose()}};let h;if(!o)o="_generated_diagnostic_collection_name_#"+m.c++,h=o;else if(!i.has(o))h=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do h=o+m.c++;while(i.has(h))}return new class extends p{constructor(){super(o,h,m.e,m.d,l=>a.getDocument(l)?.version,t.extUri,r,n),i.set(h,this)}dispose(){super.dispose(),i.delete(h)}}}getDiagnostics(f){if(f)return this.m(f);{const o=new Map,i=[];for(const s of this.g.values())s.forEach((n,c)=>{let t=o.get(n.toString());typeof t>"u"&&(t=i.length,o.set(n.toString(),t),i.push([n,[]])),i[t][1]=i[t][1].concat(...c)});return i}}m(f){let o=[];for(const i of this.g.values())i.has(f)&&(o=o.concat(i.get(f)));return o}$acceptMarkersChange(f){if(!this.n){const o="_generated_mirror",i=new p(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,s=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of f)this.n.set(g.URI.revive(o),i.map(b.Diagnostic.to))}};e.$qgc=S,e.$qgc=S=m=Ge([Ve(1,y.$nj),Ve(2,C.$ogc)],S)}),define(ke[324],Se([1,0,2,14,7,15,75]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class b{constructor(y,L,C,m={timeout:1500,errors:3}){this.c=y,this.d=L,this.f=C,this.g=m,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(L,C,m)=>{const S={dispose:this.a.push([L,C,y])};return Array.isArray(m)&&m.push(S),S}}async $participateInSave(y,L){const C=D.URI.revive(y);let m=!1;const p=setTimeout(()=>m=!0,this.g.timeout),S=[];try{for(const d of[...this.a]){if(m)break;const f=this.d.getDocument(C),o=await this.h(d,{document:f,reason:I.TextDocumentSaveReason.to(L)});S.push(o)}}finally{clearTimeout(p)}return S}h([y,L,C],m){const p=this.b.get(y);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(C,y,L,m).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const d=this.b.get(y);this.b.set(y,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,L,C,m){const p=[],S=Date.now(),{document:d,reason:f}=m,{version:o}=d,i=Object.freeze({document:d,reason:f,waitUntil(s){if(Object.isFrozen(p))throw(0,T.$8)("waitUntil can not be called async");p.push(Promise.resolve(s))}});try{L.apply(C,[i])}catch(s){return Promise.reject(s)}return Object.freeze(p),new Promise((s,n)=>{const c=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(p).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(c),s(t)}).catch(t=>{clearTimeout(c),n(t)})}).then(s=>{const n={edits:[]};for(const c of s)if(Array.isArray(c)&&c.every(t=>t instanceof g.$gL))for(const{newText:t,newEol:a,range:r}of c)n.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:r&&I.Range.from(r),text:t,eol:a&&I.EndOfLine.from(a)}});if(n.edits.length!==0)return o===d.version?this.f.$tryApplyWorkspaceEdit(n):Promise.reject(new Error("concurrent_edits"))})}}e.$zhc=b}),define(ke[325],Se([1,0,4,3,2,6,148,15,18,24,7]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class C{constructor(p,S){this.a=new D.$Vd,this.b=new D.$Vd,this.c=new D.$Vd,this.d=new D.$Vd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Sc,this.h=new Map,this.f=p.getProxy(I.$0K.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(d=>{for(const f of d)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const f of d)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const S=this.g.getDocument(p);if(S)return S}getDocument(p){const S=this.getDocumentData(p);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return S.document}ensureDocumentData(p){const S=this.g.getDocument(p);if(S)return Promise.resolve(S);let d=this.h.get(p.toString());return d||(d=this.f.$tryOpenDocument(p).then(f=>{this.h.delete(p.toString());const o=g.URI.revive(f);return(0,$.$Tf)(this.g.getDocument(o))},f=>(this.h.delete(p.toString()),Promise.reject(f))),this.h.set(p.toString(),d)),d}createDocumentData(p){return this.f.$tryCreateDocument(p).then(S=>g.URI.revive(S))}$acceptModelLanguageChanged(p,S){const d=g.URI.revive(p),f=this.g.getDocument(d);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(S),this.a.fire(f.document)}$acceptModelSaved(p){const S=g.URI.revive(p),d=this.g.getDocument(S);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(p,S){const d=g.URI.revive(p),f=this.g.getDocument(d);if(!f)throw new Error("unknown document");f._acceptIsDirty(S),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,S,d){const f=g.URI.revive(p),o=this.g.getDocument(f);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),o.onEvents(S);let i;S.isUndoing?i=L.TextDocumentChangeReason.Undo:S.isRedoing&&(i=L.TextDocumentChangeReason.Redo),this.c.fire((0,y.$wn)({document:o.document,contentChanges:S.changes.map(s=>({range:b.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:i}))}setWordDefinitionFor(p,S){(0,R.$dN)(p,S)}}e.$mgc=C}),define(ke[71],Se([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0,e.$Ygc=(0,R.$6h)("IExtHostEditorTabs");class C{constructor(f,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,o={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new L.$RM(I.URI.revive(this.b.input.uri));case 2:return new L.$SM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new L.$TM(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new L.$UM(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new L.$VM(this.b.input.viewType);case 4:return new L.$WM(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new L.$XM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new L.$YM;case 9:return new L.$ZM(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));case 10:return new L.$1M(this.b.input.providerId);default:return}}}class m{constructor(f,o){this.c=[],this.d="",this.b=f,this.e=o;for(const i of f.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,o={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return y.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(i=>i.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const i=new C(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,i),f.tabDto.isActive&&(this.d=i.tabId),i}else if(f.kind===1){const i=this.c.splice(f.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(f.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,i),i}const o=this.c.find(i=>i.tabId===f.tabDto.id);if(!o)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(f.tabDto),o}activeTabId(){return this.d}}let p=class{constructor(f){this.b=new T.$Vd,this.c=new T.$Vd,this.e=[],this.a=f.getProxy(b.$0K.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,o={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(i=>i.apiObject))},get activeTabGroup(){const i=f.d;return(0,g.$Tf)(f.e.find(n=>n.groupId===i)?.apiObject)},close:async(i,s)=>{const n=Array.isArray(i)?i:[i];return n.length?S(n[0])?this.j(n,s):this.i(n,s):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(f){const o=new Set(this.e.map(r=>r.groupId)),i=new Set(f.map(r=>r.groupId)),s=(0,D.$L)(o,i),n=this.e.filter(r=>s.removed.includes(r.groupId)).map(r=>r.apiObject),c=[],t=[];this.e=f.map(r=>{const h=new m(r,()=>this.d);return s.added.includes(h.groupId)?c.push(h.apiObject):t.push(h.apiObject),h});const a=(0,g.$Tf)(f.find(r=>r.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:c,closed:n,changed:t}))}$acceptTabGroupUpdate(f){const o=this.e.find(i=>i.groupId===f.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const o=this.e.find(s=>s.groupId===f.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(f){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===f)return i}h(f){return this.e.find(o=>o.apiObject===f)}async i(f,o){const i=[];for(const s of f){const n=this.g(s);if(!n)throw new Error("Tab close: Invalid tab not found!");i.push(n.tabId)}return this.a.$closeTab(i,o)}async j(f,o){const i=[];for(const s of f){const n=this.h(s);if(!n)throw new Error("Group close: Invalid group not found!");i.push(n.groupId)}return this.a.$closeGroup(i,o)}};e.$Zgc=p,e.$Zgc=p=Ge([Ve(0,$.$bN)],p);function S(d){return d.tabs!==void 0}}),define(ke[326],Se([1,0,2,6,3,7,15,173,12,22,25,80]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;class m{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const f=this.a.indexOf(d);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),f=[];let o,i,s=14,n=14;for(const c of d){let t=o?(0,$.$bf)(o,c):0;for(t===0?i=1:i=n;t<c.length;t++)t+1===c.length?(s=n,n=9):n+=1,f.push([i,c.toUpperCase().charCodeAt(t),n]),f.push([i,c.toLowerCase().charCodeAt(t),n]),i=n;o=c,n=s}f.push([9,58,10]),f.push([10,47,12]),this.b=new b.$yZ(f)}}provideDocumentLinks(d){this.c();const f=[],o=b.$zZ.computeLinks({getLineContent(i){return d.lineAt(i-1).text},getLineCount(){return d.lineCount}},this.b);for(const i of o){const s=R.DocumentLink.to(i);s.target&&f.push(s)}return f}}class p{constructor(d,f){this.i=f,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(T.$0K.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,f,o,i={}){if(p.j(o),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const s=this.h++;this.b.add(f),this.d.add(f),this.c.set(s,o);let n=2;i.isCaseSensitive&&(n+=1024),i.isReadonly&&(n+=2048),typeof o.copy=="function"&&(n+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,L.$GF)(d,"fsChunks"),n+=4);let c;i.isReadonly&&(0,C.$jk)(i.isReadonly)&&(c={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(s,f,n,c).catch(a=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${f}`),console.error(a)});const t=o.onDidChangeFile(a=>{const r=[];for(const h of a){const{uri:u,type:l}=h;if(u.scheme!==f)continue;let k;switch(l){case I.FileChangeType.Changed:k=0;break;case I.FileChangeType.Created:k=1;break;case I.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:u,type:k})}this.a.$onFileSystemChange(s,r)});return(0,g.$Rc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(s),this.a.$unregisterProvider(s)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:f,ctime:o,mtime:i,size:s,permissions:n}=d;return{type:f,ctime:o,mtime:i,size:s,permissions:n}}$stat(d,f){return Promise.resolve(this.l(d).stat(D.URI.revive(f))).then(o=>p.k(o))}$readdir(d,f){return Promise.resolve(this.l(d).readDirectory(D.URI.revive(f)))}$readFile(d,f){return Promise.resolve(this.l(d).readFile(D.URI.revive(f))).then(o=>y.$je.wrap(o))}$writeFile(d,f,o,i){return Promise.resolve(this.l(d).writeFile(D.URI.revive(f),o.buffer,i))}$delete(d,f,o){return Promise.resolve(this.l(d).delete(D.URI.revive(f),o))}$rename(d,f,o,i){return Promise.resolve(this.l(d).rename(D.URI.revive(f),D.URI.revive(o),i))}$copy(d,f,o,i){const s=this.l(d);if(!s.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(s.copy(D.URI.revive(f),D.URI.revive(o),i))}$mkdir(d,f){return Promise.resolve(this.l(d).createDirectory(D.URI.revive(f)))}$watch(d,f,o,i){const s=this.l(d).watch(D.URI.revive(o),i);this.f.set(f,s)}$unwatch(d,f){const o=this.f.get(f);o&&(o.dispose(),this.f.delete(f))}$open(d,f,o){const i=this.l(d);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(f),o))}$close(d,f){const o=this.l(d);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(f))}$read(d,f,o,i){const s=this.l(d);if(!s.read)throw new Error('FileSystemProvider does not implement "read"');const n=y.$je.alloc(i);return Promise.resolve(s.read(f,o,n.buffer,0,i)).then(c=>n.slice(0,c))}$write(d,f,o,i){const s=this.l(d);if(!s.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(s.write(f,o,i.buffer,0,i.byteLength))}l(d){const f=this.c.get(d);if(!f){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return f}}e.$Bhc=p}),define(ke[327],Se([1,0,4,34,2,6,15,7,43]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,S,d,f,o,i){this.a=Math.random(),this.b=new D.$Vd,this.c=new D.$Vd,this.d=new D.$Vd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const s=(0,T.$Mj)(o),n=typeof o=="string",c=i?.correlate,t=f(a=>{if(!(typeof a.session=="number"&&a.session!==this.a)&&!(c&&typeof a.session>"u")){if(!i?.ignoreCreateEvents)for(const r of a.created){const h=g.URI.revive(r);s(h.fsPath)&&(!n||S.getWorkspaceFolder(h))&&this.b.fire(h)}if(!i?.ignoreChangeEvents)for(const r of a.changed){const h=g.URI.revive(r);s(h.fsPath)&&(!n||S.getWorkspaceFolder(h))&&this.c.fire(h)}if(!i?.ignoreDeleteEvents)for(const r of a.deleted){const h=g.URI.revive(r);s(h.fsPath)&&(!n||S.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=b.$_K.from(this.i(p,d,o,i,i?.correlate),this.b,this.c,this.d,t)}i(p,S,d,f,o){const i=b.$_K.from();if(typeof d=="string")return i;const s=p.getProxy(I.$0K.MainThreadFileSystemEventService);let n=!1;return(d.pattern.includes(T.$Ij)||d.pattern.includes(T.$Jj))&&(n=!0),s.$watch(S.identifier.value,this.a,d.baseUri,{recursive:n,excludes:f?.excludes??[]},!!o),b.$_K.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class L{constructor(p){this.a=p,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(g.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(g.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(p,S,d){this.j=p,this.k=S,this.l=d,this.a=new D.$Vd,this.b=new D.$Vd,this.c=new D.$Vd,this.d=new D.$Vd,this.g=new D.$Xd,this.h=new D.$Xd,this.i=new D.$Xd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,S,d,f){return new y(this.j,p,S,this.a.event,R.GlobPattern.from(d),f)}$onFileEvent(p){this.a.fire(new L(p))}$onDidRunFileOperation(p,S){switch(p){case 2:this.b.fire(Object.freeze({files:S.map(d=>({oldUri:g.URI.revive(d.source),newUri:g.URI.revive(d.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(d=>g.URI.revive(d.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(d=>g.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,S){return(d,f,o)=>{const i=function(n){d.call(f,n)};return i.extension=p,S.event(i,void 0,o)}}async $onWillRunFileOperation(p,S,d,f){switch(p){case 2:return await this.n(this.g,{files:S.map(o=>({oldUri:g.URI.revive(o.source),newUri:g.URI.revive(o.target)}))},d,f);case 1:return await this.n(this.i,{files:S.map(o=>g.URI.revive(o.target))},d,f);case 0:case 3:return await this.n(this.h,{files:S.map(o=>g.URI.revive(o.target))},d,f)}}async n(p,S,d,f){const o=new Set,i=[];if(await p.fireAsync(S,f,async(n,c)=>{const t=Date.now(),a=await Promise.resolve(n);a instanceof b.$jL&&(i.push([c.extension,a]),o.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-t>d&&this.k.warn("SLOW file-participant",c.extension.identifier)}),f.isCancellationRequested||i.length===0)return;const s={edits:[]};for(const[,n]of i){const{edits:c}=R.WorkspaceEdit.from(n,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(c)}return{edit:s,extensionNames:Array.from(o)}}}e.$Chc=C}),define(ke[328],Se([1,0,2,24,15,7,83,6,12,29,19,18,169,21,26,3,131,121,110,38,14,11,25,213]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class r{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentSymbols(B,Y){const ee=this.d.getDocument(B),q=await this.e.provideDocumentSymbols(ee,Y);if(!(0,L.$Kb)(q))return q[0]instanceof I.$sL?q.map(g.DocumentSymbol.from):r.f(q)}static f(B){B=B.slice(0).sort((q,oe)=>{let he=q.location.range.start.compareTo(oe.location.range.start);return he===0&&(he=oe.location.range.end.compareTo(q.location.range.end)),he});const Y=[],ee=[];for(const q of B){const oe={name:q.name||"!!MISSING: name!!",kind:g.SymbolKind.from(q.kind),tags:q.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:g.Range.from(q.location.range),selectionRange:g.Range.from(q.location.range),children:[]};for(;;){if(ee.length===0){ee.push(oe),Y.push(oe);break}const he=ee[ee.length-1];if(y.$Us.containsRange(he.range,oe.range)&&!y.$Us.equalsRange(he.range,oe.range)){he.children?.push(oe),ee.push(oe);break}ee.pop()}}return Y}}class h{constructor(B,Y,ee,q,oe,he){this.f=B,this.g=Y,this.h=ee,this.j=q,this.k=oe,this.l=he,this.d=new i.$kgc("CodeLens"),this.e=new Map}async provideCodeLenses(B,Y){const ee=this.f.getDocument(B),q=await this.h.provideCodeLenses(ee,Y);if(!q||Y.isCancellationRequested)return;const oe=this.d.add(q),he=new d.$Sc;this.e.set(oe,he);const Le={cacheId:oe,lenses:[]};for(let je=0;je<q.length;je++)Le.lenses.push({cacheId:[oe,je],range:g.Range.from(q[je].range),command:this.g.toInternal(q[je].command,he)});return Le}async resolveCodeLens(B,Y){const ee=B.cacheId&&this.d.get(...B.cacheId);if(!ee)return;let q;if(typeof this.h.resolveCodeLens!="function"||ee.isResolved?q=ee:q=await this.h.resolveCodeLens(ee,Y),q||(q=ee),Y.isCancellationRequested)return;const oe=B.cacheId&&this.e.get(B.cacheId[0]);if(oe){if(!q.command){const he=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,he),this.l.error(he);return}return B.command=this.g.toInternal(q.command,oe),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function u(Ce){return Array.isArray(Ce)?Ce.map(g.DefinitionLink.from):Ce?[g.DefinitionLink.from(Ce)]:[]}class l{constructor(B,Y){this.d=B,this.e=Y}async provideDefinition(B,Y,ee){const q=this.d.getDocument(B),oe=g.Position.to(Y),he=await this.e.provideDefinition(q,oe,ee);return u(he)}}class k{constructor(B,Y){this.d=B,this.e=Y}async provideDeclaration(B,Y,ee){const q=this.d.getDocument(B),oe=g.Position.to(Y),he=await this.e.provideDeclaration(q,oe,ee);return u(he)}}class A{constructor(B,Y){this.d=B,this.e=Y}async provideImplementation(B,Y,ee){const q=this.d.getDocument(B),oe=g.Position.to(Y),he=await this.e.provideImplementation(q,oe,ee);return u(he)}}class v{constructor(B,Y){this.d=B,this.e=Y}async provideTypeDefinition(B,Y,ee){const q=this.d.getDocument(B),oe=g.Position.to(Y),he=await this.e.provideTypeDefinition(q,oe,ee);return u(he)}}class w{constructor(B,Y){this.d=B,this.e=Y}async provideHover(B,Y,ee){const q=this.d.getDocument(B),oe=g.Position.to(Y),he=await this.e.provideHover(q,oe,ee);if(!(!he||(0,L.$Kb)(he.contents)))return he.range||(he.range=q.getWordRangeAtPosition(oe)),he.range||(he.range=new I.$bL(oe,oe)),g.Hover.from(he)}}class E{constructor(B,Y){this.d=B,this.e=Y}async provideEvaluatableExpression(B,Y,ee){const q=this.d.getDocument(B),oe=g.Position.to(Y),he=await this.e.provideEvaluatableExpression(q,oe,ee);if(he)return g.EvaluatableExpression.from(he)}}class P{constructor(B,Y){this.d=B,this.e=Y}async provideInlineValues(B,Y,ee,q){const oe=this.d.getDocument(B),he=await this.e.provideInlineValues(oe,g.Range.to(Y),g.InlineValueContext.to(ee),q);if(Array.isArray(he))return he.map(Le=>g.InlineValue.from(Le))}}class N{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentHighlights(B,Y,ee){const q=this.d.getDocument(B),oe=g.Position.to(Y),he=await this.e.provideDocumentHighlights(q,oe,ee);if(Array.isArray(he))return he.map(g.DocumentHighlight.from)}}class z{constructor(B,Y){this.d=B,this.e=Y}async provideMultiDocumentHighlights(B,Y,ee,q){const oe=this.d.getDocument(B),he=ee.map(He=>this.d.getDocument(He)),Le=g.Position.to(Y),je=await this.e.provideMultiDocumentHighlights(oe,Le,he,q);if(Array.isArray(je))return je.map(g.MultiDocumentHighlight.from)}}class F{constructor(B,Y){this.d=B,this.e=Y}async provideLinkedEditingRanges(B,Y,ee){const q=this.d.getDocument(B),oe=g.Position.to(Y),he=await this.e.provideLinkedEditingRanges(q,oe,ee);if(he&&Array.isArray(he.ranges))return{ranges:(0,L.$Hb)(he.ranges.map(g.Range.from)),wordPattern:he.wordPattern}}}class j{constructor(B,Y){this.d=B,this.e=Y}async provideReferences(B,Y,ee,q){const oe=this.d.getDocument(B),he=g.Position.to(Y),Le=await this.e.provideReferences(oe,he,ee,q);if(Array.isArray(Le))return Le.map(g.location.from)}}class M{static{this.d=1e3}constructor(B,Y,ee,q,oe,he,Le){this.g=B,this.h=Y,this.j=ee,this.k=q,this.l=oe,this.m=he,this.n=Le,this.e=new i.$kgc("CodeAction"),this.f=new Map}async provideCodeActions(B,Y,ee,q){const oe=this.g.getDocument(B),he=m.$Ws.isISelection(Y)?g.Selection.to(Y):g.Range.to(Y),Le=[];for(const st of this.j.getDiagnostics(B))if(he.intersection(st.range)&&Le.push(st)>M.d)break;const je={diagnostics:Le,only:ee.only?new I.$uL(ee.only):void 0,triggerKind:g.CodeActionTriggerKind.to(ee.trigger)},He=await this.k.provideCodeActions(oe,he,je,q);if(!(0,L.$Lb)(He)||q.isCancellationRequested)return;const Qe=this.e.add(He),_e=new d.$Sc;this.f.set(Qe,_e);const at=[];for(let st=0;st<He.length;st++){const rt=He[st];rt&&(M.o(rt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)})):(je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),at.push({cacheId:[Qe,st],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(g.Diagnostic.from),edit:rt.edit&&g.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$FF)(this.m,"codeActionAI")?rt.isAI:!1,disabled:rt.disabled?.reason})))}return{cacheId:Qe,actions:at}}async resolveCodeAction(B,Y){const[ee,q]=B,oe=this.e.get(ee,q);if(!oe||M.o(oe))return{};if(!this.k.resolveCodeAction)return{};const he=await this.k.resolveCodeAction(oe,Y)??oe;let Le;he.edit&&(Le=g.WorkspaceEdit.from(he.edit,void 0));let je;if(he.command){const He=this.f.get(ee);He&&(je=this.h.toInternal(he.command,He))}return{edit:Le,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class O{static toInternalProviderId(B,Y){return B+"."+Y}constructor(B,Y,ee,q,oe){this.d=B,this.e=Y,this.f=ee,this.g=q,this.h=oe}async prepareDocumentPaste(B,Y,ee,q){if(!this.f.prepareDocumentPaste)return;const oe=this.e.getDocument(B),he=Y.map(He=>g.Range.to(He)),Le=g.DataTransfer.toDataTransfer(ee,()=>{throw new n.$$});if(await this.f.prepareDocumentPaste(oe,he,Le,q),q.isCancellationRequested)return;const je=Array.from(Le).filter(([,He])=>!(He instanceof I.$1L));return g.DataTransfer.from(je)}async providePasteEdits(B,Y,ee,q,oe){if(!this.f.provideDocumentPasteEdits)return;const he=this.e.getDocument(Y),Le=ee.map(Qe=>g.Range.to(Qe)),je=g.DataTransfer.toDataTransfer(q,async Qe=>(await this.d.$resolvePasteFileData(this.g,B,Qe)).buffer),He=await this.f.provideDocumentPasteEdits(he,Le,je,oe);if(He)return{label:He.label??(0,a.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class U{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentFormattingEdits(B,Y,ee){const q=this.d.getDocument(B),oe=await this.e.provideDocumentFormattingEdits(q,Y,ee);if(Array.isArray(oe))return oe.map(g.TextEdit.from)}}class Q{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentRangeFormattingEdits(B,Y,ee,q){const oe=this.d.getDocument(B),he=g.Range.to(Y),Le=await this.e.provideDocumentRangeFormattingEdits(oe,he,ee,q);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Y,ee,q){(0,C.$Sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const oe=this.d.getDocument(B),he=Y.map(g.Range.to),Le=await this.e.provideDocumentRangesFormattingEdits(oe,he,ee,q);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}}class ue{constructor(B,Y){this.d=B,this.e=Y,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Y,ee,q,oe){const he=this.d.getDocument(B),Le=g.Position.to(Y),je=await this.e.provideOnTypeFormattingEdits(he,Le,ee,q,oe);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class Z{constructor(B,Y){this.e=B,this.f=Y,this.d=new i.$kgc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Y){const ee=await this.e.provideWorkspaceSymbols(B,Y);if(!(0,L.$Lb)(ee))return{symbols:[]};const q=this.d.add(ee),oe={cacheId:q,symbols:[]};for(let he=0;he<ee.length;he++){const Le=ee[he];if(!Le||!Le.name){this.f.warn("INVALID SymbolInformation",Le);continue}oe.symbols.push({...g.WorkspaceSymbol.from(Le),cacheId:[q,he]})}return oe}async resolveWorkspaceSymbol(B,Y){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const ee=this.d.get(...B.cacheId);if(ee){const q=await this.e.resolveWorkspaceSymbol(ee,Y);return q&&(0,T.$yn)(B,g.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class J{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Y,ee){this.d=B,this.e=Y,this.f=ee}async provideRenameEdits(B,Y,ee,q){const oe=this.d.getDocument(B),he=g.Position.to(Y);try{const Le=await this.e.provideRenameEdits(oe,he,ee,q);return Le?g.WorkspaceEdit.from(Le):void 0}catch(Le){const je=J.g(Le);return je?{rejectReason:je,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(B,Y,ee){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(B),oe=g.Position.to(Y);try{const he=await this.e.prepareRename(q,oe,ee);let Le,je;if(I.$bL.isRange(he)?(Le=he,je=q.getText(he)):(0,C.$Kf)(he)&&(Le=he.range,je=he.placeholder),!Le||!je)return;if(Le.start.line>oe.line||Le.end.line<oe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Le),text:je}}catch(he){const Le=J.g(he);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(he)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class X{constructor(B,Y){this.resultId=B,this.tokens=Y}}class le{constructor(B,Y){this.f=B,this.g=Y,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Y,ee){const q=this.f.getDocument(B),oe=Y!==0?this.d.get(Y):null;let he=typeof oe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,oe.resultId,ee):await this.g.provideDocumentSemanticTokens(q,ee);return oe&&this.d.delete(Y),he?(he=le.h(he),this.o(le.n(oe,he),he)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return le.j(B)?le.k(B)?B:new I.$rM(new Uint32Array(B.data),B.resultId):le.l(B)?le.m(B)?B:new I.$tM(B.edits.map(Y=>new I.$sM(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Y of B.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static n(B,Y){if(!le.j(Y)||!B||!B.tokens)return Y;const ee=B.tokens,q=ee.length,oe=Y.data,he=oe.length;let Le=0;const je=Math.min(q,he);for(;Le<je&&ee[Le]===oe[Le];)Le++;if(Le===q&&Le===he)return new I.$tM([],Y.resultId);let He=0;const Qe=je-Le;for(;He<Qe&&ee[q-He-1]===oe[he-He-1];)He++;return new I.$tM([{start:Le,deleteCount:q-Le-He,data:oe.subarray(Le,he-He)}],Y.resultId)}o(B,Y){if(le.j(B)){const ee=this.e++;return this.d.set(ee,new X(B.resultId,B.data)),(0,f.$w$)({id:ee,type:"full",data:B.data})}if(le.l(B)){const ee=this.e++;return le.j(Y)?this.d.set(ee,new X(Y.resultId,Y.data)):this.d.set(ee,new X(B.resultId)),(0,f.$w$)({id:ee,type:"delta",deltas:(B.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class x{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentRangeSemanticTokens(B,Y,ee){const q=this.d.getDocument(B),oe=await this.e.provideDocumentRangeSemanticTokens(q,g.Range.to(Y),ee);return oe?this.f(oe):null}f(B){return(0,f.$w$)({id:0,type:"full",data:B.data})}}class be{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Y,ee,q,oe){this.f=B,this.g=Y,this.h=ee,this.j=q,this.k=oe,this.d=new i.$kgc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Y,ee,q){const oe=this.f.getDocument(B),he=g.Position.to(Y),Le=oe.getWordRangeAtPosition(he)||new I.$bL(he,he),je=Le.with({end:he}),He=new s.$Rd,Qe=await this.h.provideCompletionItems(oe,he,q,g.CompletionContext.to(ee));if(!Qe||q.isCancellationRequested)return;const _e=Array.isArray(Qe)?new I.$HL(Qe):Qe,at=be.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),st=new d.$Sc;this.e.set(at,st);const rt=[],Ae={x:at,b:rt,a:{replace:g.Range.from(Le),insert:g.Range.from(je)},c:_e.isIncomplete||void 0,d:He.elapsed()};for(let ze=0;ze<_e.items.length;ze++){const Re=_e.items[ze],Ye=this.l(Re,[at,ze],je,Le);rt.push(Ye)}return Ae}async resolveCompletionItem(B,Y){if(typeof this.h.resolveCompletionItem!="function")return;const ee=this.d.get(...B);if(!ee)return;const q=this.l(ee,B),oe=await this.h.resolveCompletionItem(ee,Y);if(!oe)return;const he=this.l(oe,B);return(q.h!==he.h||q.i!==he.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(q.n!==he.n||q.o!==he.o||!(0,T.$zn)(q.p,he.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...q,d:he.d,c:he.c,l:he.l,h:he.h,i:he.i,n:he.n,o:he.o,p:he.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Y,ee,q){const oe=this.e.get(Y[0]);if(!oe)throw Error("DisposableStore is missing...");const he=this.g.toInternal(B.command,oe),Le={x:Y,a:B.label,b:B.kind!==void 0?g.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(g.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:g.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(g.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=B.textEdit.newText):typeof B.insertText=="string"?Le.h=B.insertText:B.insertText instanceof I.$kL&&(Le.h=B.insertText.value,Le.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),I.$bL.isRange(je)?Le.j=g.Range.from(je):je&&(!ee?.isEqual(je.inserting)||!q?.isEqual(je.replacing))&&(Le.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),Le}}class ce{async provideInlineCompletions(B,Y,ee,q){}disposeCompletions(B){}handleDidShowCompletionItem(B,Y,ee){}handlePartialAccept(B,Y,ee){}}class G extends ce{constructor(B,Y,ee,q){super(),this.f=B,this.g=Y,this.h=ee,this.j=q,this.d=new W,this.e=(0,t.$FF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:I.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:I.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$FF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Y,ee,q){const oe=this.g.getDocument(B),he=g.Position.to(Y),Le=await this.h.provideInlineCompletionItems(oe,he,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:g.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ee.triggerKind]},q);if(!Le||q.isCancellationRequested)return;const je=Array.isArray(Le)?Le:Le.items,He=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],Qe=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:je}),items:je.map((st,rt)=>{let Ae;st.command&&(_e||(_e=new d.$Sc),Ae=this.j.toInternal(st.command,_e));const ze=st.insertText;return{insertText:typeof ze=="string"?ze:{snippet:ze.value},filterText:st.filterText,range:st.range?g.Range.from(st.range):void 0,command:Ae,idx:rt,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:He.map(st=>(_e||(_e=new d.$Sc),this.j.toInternal(st,_e))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Y,ee){const q=this.d.get(B)?.items[Y];q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(q,ee)}handlePartialAccept(B,Y,ee){const q=this.d.get(B)?.items[Y];q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(q,ee)}}class W{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Y=this.e++;return this.d.set(Y,B),Y}disposeReferenceId(B){const Y=this.d.get(B);return this.d.delete(B),Y}get(B){return this.d.get(B)}}class ne{constructor(B,Y){this.e=B,this.f=Y,this.d=new i.$kgc("SignatureHelp")}async provideSignatureHelp(B,Y,ee,q){const oe=this.e.getDocument(B),he=g.Position.to(Y),Le=this.g(ee),je=await this.f.provideSignatureHelp(oe,he,q,Le);if(je){const He=this.d.add([je]);return{...g.SignatureHelp.from(je),id:He}}}g(B){let Y;if(B.activeSignatureHelp){const ee=g.SignatureHelp.to(B.activeSignatureHelp),q=this.d.get(B.activeSignatureHelp.id,0);q?(Y=q,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return{...B,activeSignatureHelp:Y}}releaseSignatureHelp(B){this.d.delete(B)}}class ye{constructor(B,Y,ee,q,oe){this.f=B,this.g=Y,this.h=ee,this.j=q,this.k=oe,this.d=new i.$kgc("InlayHints"),this.e=new Map}async provideInlayHints(B,Y,ee){const q=this.f.getDocument(B),oe=g.Range.to(Y),he=await this.h.provideInlayHints(q,oe,ee);if(!Array.isArray(he)||he.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Y)}`);return}if(ee.isCancellationRequested)return;const Le=this.d.add(he);this.e.set(Le,new d.$Sc);const je={hints:[],cacheId:Le};for(let He=0;He<he.length;He++)this.l(he[He],oe)&&je.hints.push(this.m(he[He],[Le,He]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Y)}`),je}async resolveInlayHint(B,Y){if(typeof this.h.resolveInlayHint!="function")return;const ee=this.d.get(...B);if(!ee)return;const q=await this.h.resolveInlayHint(ee,Y);if(q&&this.l(q))return this.m(q,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Y){return B.label.length===0||Array.isArray(B.label)&&B.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Y&&!Y.contains(B.position))}m(B,Y){const ee=this.e.get(Y[0]);if(!ee)throw Error("DisposableStore is missing...");const q={label:"",cacheId:Y,tooltip:g.MarkdownString.fromStrict(B.tooltip),position:g.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(g.TextEdit.from),kind:B.kind&&g.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")q.label=B.label;else{const oe=[];q.label=oe;for(const he of B.label){if(!he.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Le={label:he.value,tooltip:g.MarkdownString.fromStrict(he.tooltip)};I.$lL.isLocation(he.location)&&(Le.location=g.location.from(he.location)),he.command&&(Le.command=this.g.toInternal(he.command,ee)),oe.push(Le)}}return q}}class de{constructor(B,Y){this.e=B,this.f=Y,this.d=new i.$kgc("DocumentLink")}async provideLinks(B,Y){const ee=this.e.getDocument(B),q=await this.f.provideDocumentLinks(ee,Y);if(!(!Array.isArray(q)||q.length===0)&&!Y.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(de.g).map(g.DocumentLink.from)};{const oe=this.d.add(q),he={links:[],cacheId:oe};for(let Le=0;Le<q.length;Le++){if(!de.g(q[Le]))continue;const je=g.DocumentLink.from(q[Le]);je.cacheId=[oe,Le],he.links.push(je)}return he}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Y){if(typeof this.f.resolveDocumentLink!="function")return;const ee=this.d.get(...B);if(!ee)return;const q=await this.f.resolveDocumentLink(ee,Y);if(!(!q||!de.g(q)))return g.DocumentLink.from(q)}releaseLinks(B){this.d.delete(B)}}class ge{constructor(B,Y){this.d=B,this.e=Y}async provideColors(B,Y){const ee=this.d.getDocument(B),q=await this.e.provideDocumentColors(ee,Y);return Array.isArray(q)?q.map(he=>({color:g.Color.from(he.color),range:g.Range.from(he.range)})):[]}async provideColorPresentations(B,Y,ee){const q=this.d.getDocument(B),oe=g.Range.to(Y.range),he=g.Color.to(Y.color),Le=await this.e.provideColorPresentations(he,{document:q,range:oe},ee);if(Array.isArray(Le))return Le.map(g.ColorPresentation.from)}}class _{constructor(B,Y){this.d=B,this.e=Y}async provideFoldingRanges(B,Y,ee){const q=this.d.getDocument(B),oe=await this.e.provideFoldingRanges(q,Y,ee);if(Array.isArray(oe))return oe.map(g.FoldingRange.from)}}class te{constructor(B,Y,ee){this.d=B,this.e=Y,this.f=ee}async provideSelectionRanges(B,Y,ee){const q=this.d.getDocument(B),oe=Y.map(g.Position.to),he=await this.e.provideSelectionRanges(q,oe,ee);if(!(0,L.$Lb)(he))return[];if(he.length!==oe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let je=0;je<oe.length;je++){const He=[];Le.push(He);let Qe=oe[je],_e=he[je];for(;;){if(!_e.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(He.push(g.SelectionRange.from(_e)),!_e.parent)break;Qe=_e.range,_e=_e.parent}}return Le}}class K{constructor(B,Y){this.f=B,this.g=Y,this.d=new o.$gN(""),this.e=new Map}async prepareSession(B,Y,ee){const q=this.f.getDocument(B),oe=g.Position.to(Y),he=await this.g.prepareCallHierarchy(q,oe,ee);if(!he)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(he)?he.map(je=>this.h(Le,je)):[this.h(Le,he)]}async provideCallsTo(B,Y,ee){const q=this.j(B,Y);if(!q)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyIncomingCalls(q,ee);if(oe)return oe.map(he=>({from:this.h(B,he.from),fromRanges:he.fromRanges.map(Le=>g.Range.from(Le))}))}async provideCallsFrom(B,Y,ee){const q=this.j(B,Y);if(!q)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyOutgoingCalls(q,ee);if(oe)return oe.map(he=>({to:this.h(B,he.to),fromRanges:he.fromRanges.map(Le=>g.Range.from(Le))}))}releaseSession(B){this.e.delete(B)}h(B,Y){const ee=this.e.get(B),q=g.CallHierarchyItem.from(Y,B,ee.size.toString(36));return ee.set(q._itemId,Y),q}j(B,Y){return this.e.get(B)?.get(Y)}}class ie{constructor(B,Y){this.f=B,this.g=Y,this.d=new o.$gN(""),this.e=new Map}async prepareSession(B,Y,ee){const q=this.f.getDocument(B),oe=g.Position.to(Y),he=await this.g.prepareTypeHierarchy(q,oe,ee);if(!he)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(he)?he.map(je=>this.h(Le,je)):[this.h(Le,he)]}async provideSupertypes(B,Y,ee){const q=this.j(B,Y);if(!q)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySupertypes(q,ee);if(oe)return oe.map(he=>this.h(B,he))}async provideSubtypes(B,Y,ee){const q=this.j(B,Y);if(!q)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySubtypes(q,ee);if(oe)return oe.map(he=>this.h(B,he))}releaseSession(B){this.e.delete(B)}h(B,Y){const ee=this.e.get(B),q=g.TypeHierarchyItem.from(Y,B,ee.size.toString(36));return ee.set(q._itemId,Y),q}j(B,Y){return this.e.get(B)?.get(Y)}}class fe{static toInternalProviderId(B,Y){return B+"."+Y}constructor(B,Y,ee,q,oe){this.d=B,this.e=Y,this.f=ee,this.g=q,this.h=oe}async provideDocumentOnDropEdits(B,Y,ee,q,oe){const he=this.e.getDocument(Y),Le=g.Position.to(ee),je=g.DataTransfer.toDataTransfer(q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,Qe)).buffer),He=await this.f.provideDocumentDropEdits(he,Le,je,oe);if(He)return{label:He.label??(0,a.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:fe.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class pe{constructor(B,Y){this.d=B,this.e=Y}async provideMappedEdits(B,Y,ee,q){const oe=D.URI.revive(B),he=this.d.getDocument(oe),Le=ee.documents.map(Qe=>Qe.map(_e=>({uri:D.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(at=>g.Range.to(at))}))),je={documents:Le,selections:Le[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(he,Y,je,q);return He?g.WorkspaceEdit.from(He):null}}class Pe{constructor(B,Y){this.adapter=B,this.extension=Y}}class we{static{this.d=0}constructor(B,Y,ee,q,oe,he,Le,je){this.g=Y,this.h=ee,this.j=q,this.k=oe,this.l=he,this.m=Le,this.n=je,this.f=new Map,this.e=B.getProxy(b.$0K.MainThreadLanguageFeatures)}o(B,Y){return g.DocumentSelector.from(B,this.g,Y)}p(B){return new I.$_K(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return we.d++}async s(B,Y,ee,q,oe,he=!1){const Le=this.f.get(B);if(!Le||!(Le.adapter instanceof Y))return q;const je=Date.now();he||this.l.trace(`[${Le.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const He=ee(Le.adapter,Le.extension);return Promise.resolve(He).catch(Qe=>{(0,n.$4)(Qe)||(this.l.error(`[${Le.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(Le.extension.identifier,Qe))}).finally(()=>{he||this.l.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),p.CancellationToken.isCancellationToken(oe)?(0,c.$Vg)(He,oe):He}t(B,Y){const ee=this.q();return this.f.set(ee,new Pe(B,Y)),ee}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Y,ee,q){const oe=this.t(new r(this.h,ee),B),he=q&&q.label||we.u(B);return this.e.$registerDocumentSymbolProvider(oe,this.o(Y,B),he),this.p(oe)}$provideDocumentSymbols(B,Y,ee){return this.s(B,r,q=>q.provideDocumentSymbols(D.URI.revive(Y),ee),void 0,ee)}registerCodeLensProvider(B,Y,ee){const q=this.q(),oe=typeof ee.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new Pe(new h(this.h,this.j.converter,ee,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(q,this.o(Y,B),oe);let he=this.p(q);if(oe!==void 0){const Le=ee.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(oe));he=I.$_K.from(he,Le)}return he}$provideCodeLenses(B,Y,ee){return this.s(B,h,q=>q.provideCodeLenses(D.URI.revive(Y),ee),void 0,ee)}$resolveCodeLens(B,Y,ee){return this.s(B,h,q=>q.resolveCodeLens(Y,ee),void 0,void 0)}$releaseCodeLenses(B,Y){this.s(B,h,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0,void 0)}registerDefinitionProvider(B,Y,ee){const q=this.t(new l(this.h,ee),B);return this.e.$registerDefinitionSupport(q,this.o(Y,B)),this.p(q)}$provideDefinition(B,Y,ee,q){return this.s(B,l,oe=>oe.provideDefinition(D.URI.revive(Y),ee,q),[],q)}registerDeclarationProvider(B,Y,ee){const q=this.t(new k(this.h,ee),B);return this.e.$registerDeclarationSupport(q,this.o(Y,B)),this.p(q)}$provideDeclaration(B,Y,ee,q){return this.s(B,k,oe=>oe.provideDeclaration(D.URI.revive(Y),ee,q),[],q)}registerImplementationProvider(B,Y,ee){const q=this.t(new A(this.h,ee),B);return this.e.$registerImplementationSupport(q,this.o(Y,B)),this.p(q)}$provideImplementation(B,Y,ee,q){return this.s(B,A,oe=>oe.provideImplementation(D.URI.revive(Y),ee,q),[],q)}registerTypeDefinitionProvider(B,Y,ee){const q=this.t(new v(this.h,ee),B);return this.e.$registerTypeDefinitionSupport(q,this.o(Y,B)),this.p(q)}$provideTypeDefinition(B,Y,ee,q){return this.s(B,v,oe=>oe.provideTypeDefinition(D.URI.revive(Y),ee,q),[],q)}registerHoverProvider(B,Y,ee,q){const oe=this.t(new w(this.h,ee),B);return this.e.$registerHoverProvider(oe,this.o(Y,B)),this.p(oe)}$provideHover(B,Y,ee,q){return this.s(B,w,oe=>oe.provideHover(D.URI.revive(Y),ee,q),void 0,q)}registerEvaluatableExpressionProvider(B,Y,ee,q){const oe=this.t(new E(this.h,ee),B);return this.e.$registerEvaluatableExpressionProvider(oe,this.o(Y,B)),this.p(oe)}$provideEvaluatableExpression(B,Y,ee,q){return this.s(B,E,oe=>oe.provideEvaluatableExpression(D.URI.revive(Y),ee,q),void 0,q)}registerInlineValuesProvider(B,Y,ee,q){const oe=typeof ee.onDidChangeInlineValues=="function"?this.q():void 0,he=this.t(new P(this.h,ee),B);this.e.$registerInlineValuesProvider(he,this.o(Y,B),oe);let Le=this.p(he);if(oe!==void 0){const je=ee.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(oe));Le=I.$_K.from(Le,je)}return Le}$provideInlineValues(B,Y,ee,q,oe){return this.s(B,P,he=>he.provideInlineValues(D.URI.revive(Y),ee,q,oe),void 0,oe)}registerDocumentHighlightProvider(B,Y,ee){const q=this.t(new N(this.h,ee),B);return this.e.$registerDocumentHighlightProvider(q,this.o(Y,B)),this.p(q)}registerMultiDocumentHighlightProvider(B,Y,ee){const q=this.t(new z(this.h,ee),B);return this.e.$registerMultiDocumentHighlightProvider(q,this.o(Y,B)),this.p(q)}$provideDocumentHighlights(B,Y,ee,q){return this.s(B,N,oe=>oe.provideDocumentHighlights(D.URI.revive(Y),ee,q),void 0,q)}$provideMultiDocumentHighlights(B,Y,ee,q,oe){return this.s(B,z,he=>he.provideMultiDocumentHighlights(D.URI.revive(Y),ee,q.map(Le=>D.URI.revive(Le)),oe),void 0,oe)}registerLinkedEditingRangeProvider(B,Y,ee){const q=this.t(new F(this.h,ee),B);return this.e.$registerLinkedEditingRangeProvider(q,this.o(Y,B)),this.p(q)}$provideLinkedEditingRanges(B,Y,ee,q){return this.s(B,F,async oe=>{const he=await oe.provideLinkedEditingRanges(D.URI.revive(Y),ee,q);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?we.w(he.wordPattern):void 0}},void 0,q)}registerReferenceProvider(B,Y,ee){const q=this.t(new j(this.h,ee),B);return this.e.$registerReferenceSupport(q,this.o(Y,B)),this.p(q)}$provideReferences(B,Y,ee,q,oe){return this.s(B,j,he=>he.provideReferences(D.URI.revive(Y),ee,q,oe),void 0,oe)}registerCodeActionProvider(B,Y,ee,q){const oe=new d.$Sc,he=this.t(new M(this.h,this.j.converter,this.k,ee,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(he,this.o(Y,B),{providedKinds:q?.providedCodeActionKinds?.map(Le=>Le.value),documentation:q?.documentation?.map(Le=>({kind:Le.kind.value,command:this.j.converter.toInternal(Le.command,oe)}))},we.u(B),!!ee.resolveCodeAction),oe.add(this.p(he)),oe}$provideCodeActions(B,Y,ee,q,oe){return this.s(B,M,he=>he.provideCodeActions(D.URI.revive(Y),ee,q,oe),void 0,oe)}$resolveCodeAction(B,Y,ee){return this.s(B,M,q=>q.resolveCodeAction(Y,ee),{},void 0)}$releaseCodeActions(B,Y){this.s(B,M,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Y,ee){const q=this.t(new U(this.h,ee),B);return this.e.$registerDocumentFormattingSupport(q,this.o(Y,B),B.identifier,B.displayName||B.name),this.p(q)}$provideDocumentFormattingEdits(B,Y,ee,q){return this.s(B,U,oe=>oe.provideDocumentFormattingEdits(D.URI.revive(Y),ee,q),void 0,q)}registerDocumentRangeFormattingEditProvider(B,Y,ee){const q=typeof ee.provideDocumentRangesFormattingEdits=="function",oe=this.t(new Q(this.h,ee),B);return this.e.$registerRangeFormattingSupport(oe,this.o(Y,B),B.identifier,B.displayName||B.name,q),this.p(oe)}$provideDocumentRangeFormattingEdits(B,Y,ee,q,oe){return this.s(B,Q,he=>he.provideDocumentRangeFormattingEdits(D.URI.revive(Y),ee,q,oe),void 0,oe)}$provideDocumentRangesFormattingEdits(B,Y,ee,q,oe){return this.s(B,Q,he=>he.provideDocumentRangesFormattingEdits(D.URI.revive(Y),ee,q,oe),void 0,oe)}registerOnTypeFormattingEditProvider(B,Y,ee,q){const oe=this.t(new ue(this.h,ee),B);return this.e.$registerOnTypeFormattingSupport(oe,this.o(Y,B),q,B.identifier),this.p(oe)}$provideOnTypeFormattingEdits(B,Y,ee,q,oe,he){return this.s(B,ue,Le=>Le.provideOnTypeFormattingEdits(D.URI.revive(Y),ee,q,oe,he),void 0,he)}registerWorkspaceSymbolProvider(B,Y){const ee=this.t(new Z(Y,this.l),B);return this.e.$registerNavigateTypeSupport(ee,typeof Y.resolveWorkspaceSymbol=="function"),this.p(ee)}$provideWorkspaceSymbols(B,Y,ee){return this.s(B,Z,q=>q.provideWorkspaceSymbols(Y,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(B,Y,ee){return this.s(B,Z,q=>q.resolveWorkspaceSymbol(Y,ee),void 0,void 0)}$releaseWorkspaceSymbols(B,Y){this.s(B,Z,ee=>ee.releaseWorkspaceSymbols(Y),void 0,void 0)}registerRenameProvider(B,Y,ee){const q=this.t(new J(this.h,ee,this.l),B);return this.e.$registerRenameSupport(q,this.o(Y,B),J.supportsResolving(ee)),this.p(q)}$provideRenameEdits(B,Y,ee,q,oe){return this.s(B,J,he=>he.provideRenameEdits(D.URI.revive(Y),ee,q,oe),void 0,oe)}$resolveRenameLocation(B,Y,ee,q){return this.s(B,J,oe=>oe.resolveRenameLocation(D.URI.revive(Y),ee,q),void 0,q)}registerDocumentSemanticTokensProvider(B,Y,ee,q){const oe=this.t(new le(this.h,ee),B),he=typeof ee.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(oe,this.o(Y,B),q,he);let Le=this.p(oe);if(he){const je=ee.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(he));Le=I.$_K.from(Le,je)}return Le}$provideDocumentSemanticTokens(B,Y,ee,q){return this.s(B,le,oe=>oe.provideDocumentSemanticTokens(D.URI.revive(Y),ee,q),null,q)}$releaseDocumentSemanticTokens(B,Y){this.s(B,le,ee=>ee.releaseDocumentSemanticColoring(Y),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Y,ee,q){const oe=this.t(new x(this.h,ee),B);return this.e.$registerDocumentRangeSemanticTokensProvider(oe,this.o(Y,B),q),this.p(oe)}$provideDocumentRangeSemanticTokens(B,Y,ee,q){return this.s(B,x,oe=>oe.provideDocumentRangeSemanticTokens(D.URI.revive(Y),ee,q),null,q)}registerCompletionItemProvider(B,Y,ee,q){const oe=this.t(new be(this.h,this.j.converter,ee,this.m,B),B);return this.e.$registerCompletionsProvider(oe,this.o(Y,B),q,be.supportsResolving(ee),B.identifier),this.p(oe)}$provideCompletionItems(B,Y,ee,q,oe){return this.s(B,be,he=>he.provideCompletionItems(D.URI.revive(Y),ee,q,oe),void 0,oe)}$resolveCompletionItem(B,Y,ee){return this.s(B,be,q=>q.resolveCompletionItem(Y,ee),void 0,ee)}$releaseCompletionItems(B,Y){this.s(B,be,ee=>ee.releaseCompletionItems(Y),void 0,void 0)}registerInlineCompletionsProvider(B,Y,ee,q){const oe=new G(B,this.h,ee,this.j.converter),he=this.t(oe,B);return this.e.$registerInlineCompletionsSupport(he,this.o(Y,B),oe.supportsHandleEvents,S.$lm.toKey(B.identifier.value),q?.yieldTo?.map(Le=>S.$lm.toKey(Le))||[]),this.p(he)}$provideInlineCompletions(B,Y,ee,q,oe){return this.s(B,ce,he=>he.provideInlineCompletions(D.URI.revive(Y),ee,q,oe),void 0,oe)}$handleInlineCompletionDidShow(B,Y,ee,q){this.s(B,ce,async oe=>{oe.handleDidShowCompletionItem(Y,ee,q)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Y,ee,q){this.s(B,ce,async oe=>{oe.handlePartialAccept(Y,ee,q)},void 0,void 0)}$freeInlineCompletionsList(B,Y){this.s(B,ce,async ee=>{ee.disposeCompletions(Y)},void 0,void 0)}registerSignatureHelpProvider(B,Y,ee,q){const oe=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,he=this.t(new ne(this.h,ee),B);return this.e.$registerSignatureHelpProvider(he,this.o(Y,B),oe),this.p(he)}$provideSignatureHelp(B,Y,ee,q,oe){return this.s(B,ne,he=>he.provideSignatureHelp(D.URI.revive(Y),ee,q,oe),void 0,oe)}$releaseSignatureHelp(B,Y){this.s(B,ne,ee=>ee.releaseSignatureHelp(Y),void 0,void 0)}registerInlayHintsProvider(B,Y,ee){const q=typeof ee.onDidChangeInlayHints=="function"?this.q():void 0,oe=this.t(new ye(this.h,this.j.converter,ee,this.l,B),B);this.e.$registerInlayHintsProvider(oe,this.o(Y,B),typeof ee.resolveInlayHint=="function",q,we.u(B));let he=this.p(oe);if(q!==void 0){const Le=ee.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(q));he=I.$_K.from(he,Le)}return he}$provideInlayHints(B,Y,ee,q){return this.s(B,ye,oe=>oe.provideInlayHints(D.URI.revive(Y),ee,q),void 0,q)}$resolveInlayHint(B,Y,ee){return this.s(B,ye,q=>q.resolveInlayHint(Y,ee),void 0,ee)}$releaseInlayHints(B,Y){this.s(B,ye,ee=>ee.releaseHints(Y),void 0,void 0)}registerDocumentLinkProvider(B,Y,ee){const q=this.t(new de(this.h,ee),B);return this.e.$registerDocumentLinkProvider(q,this.o(Y,B),typeof ee.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(B,Y,ee){return this.s(B,de,q=>q.provideLinks(D.URI.revive(Y),ee),void 0,ee,Y.scheme==="output")}$resolveDocumentLink(B,Y,ee){return this.s(B,de,q=>q.resolveLink(Y,ee),void 0,void 0,!0)}$releaseDocumentLinks(B,Y){this.s(B,de,ee=>ee.releaseLinks(Y),void 0,void 0,!0)}registerColorProvider(B,Y,ee){const q=this.t(new ge(this.h,ee),B);return this.e.$registerDocumentColorProvider(q,this.o(Y,B)),this.p(q)}$provideDocumentColors(B,Y,ee){return this.s(B,ge,q=>q.provideColors(D.URI.revive(Y),ee),[],ee)}$provideColorPresentations(B,Y,ee,q){return this.s(B,ge,oe=>oe.provideColorPresentations(D.URI.revive(Y),ee,q),void 0,q)}registerFoldingRangeProvider(B,Y,ee){const q=this.q(),oe=typeof ee.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new Pe(new _(this.h,ee),B)),this.e.$registerFoldingRangeProvider(q,this.o(Y,B),B.identifier,oe);let he=this.p(q);if(oe!==void 0){const Le=ee.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(oe));he=I.$_K.from(he,Le)}return he}$provideFoldingRanges(B,Y,ee,q){return this.s(B,_,oe=>oe.provideFoldingRanges(D.URI.revive(Y),ee,q),void 0,q)}registerSelectionRangeProvider(B,Y,ee){const q=this.t(new te(this.h,ee,this.l),B);return this.e.$registerSelectionRangeProvider(q,this.o(Y,B)),this.p(q)}$provideSelectionRanges(B,Y,ee,q){return this.s(B,te,oe=>oe.provideSelectionRanges(D.URI.revive(Y),ee,q),[],q)}registerCallHierarchyProvider(B,Y,ee){const q=this.t(new K(this.h,ee),B);return this.e.$registerCallHierarchyProvider(q,this.o(Y,B)),this.p(q)}$prepareCallHierarchy(B,Y,ee,q){return this.s(B,K,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Y),ee,q)),void 0,q)}$provideCallHierarchyIncomingCalls(B,Y,ee,q){return this.s(B,K,oe=>oe.provideCallsTo(Y,ee,q),void 0,q)}$provideCallHierarchyOutgoingCalls(B,Y,ee,q){return this.s(B,K,oe=>oe.provideCallsFrom(Y,ee,q),void 0,q)}$releaseCallHierarchy(B,Y){this.s(B,K,ee=>Promise.resolve(ee.releaseSession(Y)),void 0,void 0)}registerTypeHierarchyProvider(B,Y,ee){const q=this.t(new ie(this.h,ee),B);return this.e.$registerTypeHierarchyProvider(q,this.o(Y,B)),this.p(q)}$prepareTypeHierarchy(B,Y,ee,q){return this.s(B,ie,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Y),ee,q)),void 0,q)}$provideTypeHierarchySupertypes(B,Y,ee,q){return this.s(B,ie,oe=>oe.provideSupertypes(Y,ee,q),void 0,q)}$provideTypeHierarchySubtypes(B,Y,ee,q){return this.s(B,ie,oe=>oe.provideSubtypes(Y,ee,q),void 0,q)}$releaseTypeHierarchy(B,Y){this.s(B,ie,ee=>Promise.resolve(ee.releaseSession(Y)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Y,ee,q){const oe=this.q();this.f.set(oe,new Pe(new fe(this.e,this.h,ee,oe,B),B));const he=(0,t.$FF)(B,"dropMetadata")&&q?fe.toInternalProviderId(B.identifier.value,q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(oe,this.o(Y,B),he,(0,t.$FF)(B,"dropMetadata")?q:void 0),this.p(oe)}$provideDocumentOnDropEdits(B,Y,ee,q,oe,he){return this.s(B,fe,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(Y,D.URI.revive(ee),q,oe,he)),void 0,void 0)}registerMappedEditsProvider(B,Y,ee){const q=this.t(new pe(this.h,ee),B);return this.e.$registerMappedEditsProvider(q,this.o(Y,B)),this.p(q)}$provideMappedEdits(B,Y,ee,q,oe){return this.s(B,pe,he=>Promise.resolve(he.provideMappedEdits(Y,ee,q,oe)),null,oe)}registerDocumentPasteEditProvider(B,Y,ee,q){const oe=this.q();this.f.set(oe,new Pe(new O(this.e,this.h,ee,oe,B),B));const he=O.toInternalProviderId(B.identifier.value,q.id);return this.e.$registerPasteEditProvider(oe,this.o(Y,B),he,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:q.copyMimeTypes,pasteMimeTypes:q.pasteMimeTypes}),this.p(oe)}$prepareDocumentPaste(B,Y,ee,q,oe){return this.s(B,O,he=>he.prepareDocumentPaste(D.URI.revive(Y),ee,q,oe),void 0,oe)}$providePasteEdits(B,Y,ee,q,oe,he){return this.s(B,O,Le=>Le.providePasteEdits(Y,D.URI.revive(ee),q,oe,he),void 0,he)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:we.w(B.decreaseIndentPattern),increaseIndentPattern:we.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?we.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?we.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:we.w(B.beforeText),afterText:B.afterText?we.w(B.afterText):void 0,previousLineText:B.previousLineText?we.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(we.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Y=>I.SyntaxTokenType.toString(Y)):void 0}}static D(B){return B.map(we.C)}setLanguageConfiguration(B,Y,ee){const{wordPattern:q}=ee;if(q&&(0,$.$Ye)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor(Y,q):this.h.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ee.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const oe=this.q(),he={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?we.w(ee.wordPattern):void 0,indentationRules:ee.indentationRules?we.y(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?we.B(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs?we.D(ee.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(oe,Y,he),this.p(oe)}$setWordDefinitions(B){for(const Y of B)this.h.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.$ugc=we}),define(ke[329],Se([1,0,6,15,7,39,11,3,25]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;class y{constructor(C,m,p,S){this.c=m,this.d=p,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$0K.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const p=this.c.getDocumentData(C);if(!p)throw new Error(`document '${C.toString()}' NOT found`);return p.document}async tokenAtPosition(C,m){const p=C.version,S=T.Position.from(m),d=await this.a.$tokensAtPosition(C.uri,S),f={type:g.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new g.$bL(m.line,m.character,m.line,m.character)};if(!d)return f;const o={range:T.Range.to(d.range),type:T.TokenType.to(d.type)};return!o.range.contains(m)||p!==C.version?f:o}createLanguageStatusItem(C,m,p){const S=this.f++,d=this.a,f=this.g,o=`${C.identifier.value}/${m}`;if(f.has(o))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);f.add(o);const i={selector:p,id:m,name:C.displayName??C.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let s;const n=new b.$Sc,c=()=>{if(s?.dispose(),!f.has(o)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}s=(0,R.$8g)(()=>{n.clear(),this.a.$setLanguageStatus(S,{id:o,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:T.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===g.LanguageStatusSeverity.Error?I.default.Error:i.severity===g.LanguageStatusSeverity.Warning?I.default.Warning:I.default.Info,command:i.command&&this.d.toInternal(i.command,n),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){n.dispose(),s?.dispose(),d.$removeLanguageStatus(S),f.delete(o)},get id(){return i.id},get name(){return i.name},set name(a){i.name=a,c()},get selector(){return i.selector},set selector(a){i.selector=a,c()},get text(){return i.text},set text(a){i.text=a,c()},set text2(a){(0,$.$GF)(C,"languageStatusText"),i.text=a,c()},get text2(){return(0,$.$GF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(a){i.detail=a,c()},get severity(){return i.severity},set severity(a){i.severity=a,c()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(a){i.accessibilityInformation=a,c()},get command(){return i.command},set command(a){i.command=a,c()},get busy(){return i.busy},set busy(a){i.busy=a,c()}};return c(),t}}e.$Thc=y}),define(ke[330],Se([1,0,16,2,15,7,118]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0;class b{constructor(C,m,p,S){this.start=C,this.deletedCount=m,this.deletedItems=p,this.items=S}asApiEvent(){return{range:new I.$xM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,m,p){this.notebook=C,this.h=m,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(g.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(S){C.g=S},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(p)}return this.f}setOutputs(C){this.a=C.map(g.NotebookCellOutput.to)}setOutputItems(C,m,p){const S=p.map(g.NotebookCellOutputItem.to),d=this.a.find(f=>f.id===C);if(d&&(m||(d.items.length=0),d.items.push(...S),d.items.length>1&&d.items.every(f=>R.$bJ(f.mime)))){const f=new Map,o=[];d.items.forEach(i=>{let s;f.has(i.mime)?s=f.get(i.mime):(s=[],f.set(i.mime,s),o.push(i.mime)),s.push(i.data)}),d.items.length=0,o.forEach(i=>{const s=R.$cJ(f.get(i));d.items.push({mime:i,data:s.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$Ehc=$;class y{static{this.a=0}constructor(C,m,p,S,d){this.k=C,this.l=m,this.m=p,this.uri=S,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(p){return p=C.n(p),C.b[p].apiCell},getCells(p){return(p?C.p(p):C.b).map(d=>d.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,p){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:p});const S={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},d=[];for(const o of C.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,S.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,S.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),d.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),d.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),d.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),d.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),d.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const f=new Map;for(let o=0;o<d.length;o++){const i=d[o],s=f.get(i.cell);if(s===void 0){const n=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});f.set(i.cell,n-1)}else S.cellChanges[s]={...S.cellChanges[s],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,p=C.end|0;return m<0&&(m=0),p>this.b.length&&(p=this.b.length),C.with({start:m,end:p})}p(C){C=this.o(C);const m=[];for(let p=C.start;p<C.end;p++)m.push(this.b[p]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,p){if(this.j)return;const S=[],d=[],f=[];if(C.reverse().forEach(o=>{const s=o[2].map(t=>{const a=new $(this,this.l,t);return m||d.push($.asModelAddData(this.apiNotebook,t)),a}),n=new b(o[0],o[1],[],s),c=this.b.splice(o[0],o[1],...s);for(const t of c)f.push(t.uri),n.deletedItems.push(t.apiCell);S.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:f}),p)for(const o of S)p.push(o.asApiEvent())}s(C,m,p,S){const d=this.b.splice(C,m);this.b.splice(p,0,...d);const f=[new b(C,m,d.map(o=>o.apiCell),[]),new b(p,0,[],d)];for(const o of f)S.push(o.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,p,S){this.b[C].setOutputItems(m,p,S)}v(C,m){const p=this.b[C];p.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(p.uri,m)}w(C,m){const p=this.b[C];p.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$Fhc=y}),define(ke[331],Se([1,0,4,2,15,7]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class R{constructor($,y,L,C={timeout:1500,errors:3}){this.b=$,this.c=y,this.d=L,this.f=C,this.a=new D.$Xd}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(y,L,C)=>{const m=function(S){y.call(L,S)};return m.extension=$,this.a.event(m,void 0,C)}}async $participateInSave($,y,L){const C=T.URI.revive($),m=this.c.getNotebookDocument(C);if(!m)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:g.TextDocumentSaveReason.to(y)},L,async(d,f)=>{const o=Date.now(),i=await await Promise.resolve(d);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!L.isCancellationRequested&&i&&(i instanceof I.$jL?p.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(p.length===0)return!0;const S={edits:[]};for(const d of p){const{edits:f}=g.WorkspaceEdit.from(d);S.edits=S.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$Vhc=R}),define(ke[149],Se([1,0,14,15,7]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class I{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,y,L,C,m){this.id=b,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=L,this.c=m}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(g.$xM.isNotebookRange))throw(0,D.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,y){b.f.$tryRevealRange(b.id,T.NotebookRange.from($),y??g.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},I.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(T.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$Ghc=I}),define(ke[332],Se([1,0,4,13,15]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;let I=class{constructor(b,$){this.c=b,this.d=$,this.a=new D.$Vd,this.b=new D.$Vd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const y=this.d.getEditorById(b);$.visibleRanges&&y._acceptVisibleRanges($.visibleRanges.ranges.map(g.NotebookRange.to)),$.selections&&y._acceptSelections($.selections.selections.map(g.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(g.ViewColumn.to(b[$]))}};e.$Xhc=I,e.$Xhc=I=Ge([Ve(0,T.$nj)],I)}),define(ke[333],Se([1,0,4,6,149]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class I{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(T.$0K.MainThreadNotebookRenderers)}$postRendererMessage(b,$,y){const L=this.c.getEditorById(b);this.a.get($)?.fire({editor:L.apiEditor,message:y})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(L=>L.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(L,C,m)=>this.d($).event(L,C,m),postMessage:(L,C)=>{g.$Ghc.apiEditorsToExtHost.has(L)&&([L,C]=[C,L]);const m=C&&g.$Ghc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,L)}}}d(b){let $=this.a.get(b);return $||($=new D.$Vd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$1hc=I}),define(ke[334],Se([1,0,15,86,21,52,14]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class b{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,m,p){const S=this.b++,{title:d,location:f,cancellable:o}=m,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(S,{location:D.ProgressLocation.from(f),title:d,source:i,cancellable:o},C.isUnderDevelopment?void 0:C.identifier.value).catch(R.$2),this.d(S,p,!!o)}d(C,m,p){let S;p&&(S=new g.$6d,this.c.set(C,S));const d=o=>{this.a.$progressEnd(o),this.c.delete(o),S?.dispose()};let f;try{f=m(new y(this.a,C),p&&S?S.token:g.CancellationToken.None)}catch(o){throw d(C),o}return f.then(o=>d(C),o=>d(C)),f}$acceptProgressCanceled(C){const m=this.c.get(C);m&&(m.cancel(),this.c.delete(C))}}e.$5hc=b;function $(L,C){return L.message=C.message,typeof C.increment=="number"&&(typeof L.increment=="number"?L.increment+=C.increment:L.increment=C.increment),L}class y extends T.$vv{constructor(C,m){super(p=>this.throttledReport(p)),this.c=C,this.d=m}throttledReport(C){this.c.$progressReport(this.d,C)}}Ge([(0,I.$zh)(100,(L,C)=>$(L,C),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(ke[335],Se([1,0,2,6,11,15]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class R{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(T.$0K.MainThreadQuickDiff)}$provideOriginalResource($,y,L){const C=D.URI.revive(y),m=this.c.get($);return m?(0,g.$Yg)(()=>m.provideOriginalResource(C,L)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider($,y,L,C){const m=R.a++;return this.c.set(m,y),this.b.$registerQuickDiffProvider(m,I.DocumentSelector.from($,this.d),L,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$6hc=R}),define(ke[336],Se([1,0,21,4,3,6,2,7,14,19,39,61,25,15]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;function S(d,f,o){const i=d.getProxy(I.$0K.MainThreadQuickOpen);class s{constructor(k,A){this.e=new Map,this.f=0,this.a=k,this.b=A}showQuickPick(k,A,v,w=D.CancellationToken.None){this.c=void 0;const E=Promise.resolve(A),P=++this.f,N=i.$show(P,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},w),z={},F=N.then(()=>z);return Promise.race([F,E]).then(j=>{if(j===z)return;const M=(0,m.$FF)(k,"quickPickItemTooltip");return E.then(O=>{const U=[];for(let Q=0;Q<O.length;Q++){const ue=O[Q];if(typeof ue=="string")U.push({label:ue,handle:Q});else if(ue.kind===b.QuickPickItemKind.Separator)U.push({type:"separator",label:ue.label});else{ue.tooltip&&!M&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const Z=ue.iconPath?r(ue.iconPath):void 0;U.push({label:ue.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:M?p.MarkdownString.fromStrict(ue.tooltip):void 0,handle:Q})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=Q=>{v.onDidSelectItem(O[Q])}),i.$setItems(P,U),N.then(Q=>{if(typeof Q=="number")return O[Q];if(Array.isArray(Q))return Q.map(ue=>O[ue])})})}).then(void 0,j=>{if(!(0,$.$4)(j))return i.$setError(P,j),Promise.reject(j)})}$onItemSelected(k){this.c?.(k)}showInput(k,A=D.CancellationToken.None){return this.d=k?.validateInput,i.$input(k,typeof this.d=="function",A).then(void 0,v=>{if(!(0,$.$4)(v))return Promise.reject(v)})}async $validateInput(k){if(!this.d)return;const A=await this.d(k);if(!A||typeof A=="string")return A;let v;switch(A.severity){case b.InputBoxValidationSeverity.Info:v=L.default.Info;break;case b.InputBoxValidationSeverity.Warning:v=L.default.Warning;break;case b.InputBoxValidationSeverity.Error:v=L.default.Error;break;default:v=A.message?L.default.Error:L.default.Ignore;break}return{content:A.message,severity:v}}async showWorkspaceFolderPick(k,A=D.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!v)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(E=>E.uri.toString()===v.uri.toString())}createQuickPick(k){const A=new h(k,()=>this.e.delete(A._id));return this.e.set(A._id,A),A}createInputBox(k){const A=new u(k,()=>this.e.delete(A._id));return this.e.set(A._id,A),A}$onDidChangeValue(k,A){this.e.get(k)?._fireDidChangeValue(A)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,A){const v=this.e.get(k);v instanceof h&&v._fireDidChangeActive(A)}$onDidChangeSelection(k,A){const v=this.e.get(k);v instanceof h&&v._fireDidChangeSelection(A)}$onDidTriggerButton(k,A){this.e.get(k)?._fireDidTriggerButton(A)}$onDidTriggerItemButton(k,A,v){const w=this.e.get(k);w instanceof h&&w._fireDidTriggerItemButton(A,v)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class n{static{this.a=1}constructor(k,A){this.x=k,this.y=A,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Vd,this.q=new T.$Vd,this.r=new T.$Vd,this.s=new T.$Vd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((A,v)=>{const w=A===b.$uM.Back?-1:v;this.o.set(w,A)}),this.z({buttons:k.map((A,v)=>({...r(A.iconPath),tooltip:A.tooltip,handle:A===b.$uM.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const A=this.o.get(k);A&&this.r.fire(A)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(k){if(!this.v){for(const A of Object.keys(k)){const v=k[A];this.u[A]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function c(l){if(l instanceof b.$7L)return{id:l.id};const k=a(l),A=t(l);return{dark:typeof k=="string"?R.URI.file(k):k,light:typeof A=="string"?R.URI.file(A):A}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function a(l){return typeof l=="object"&&"dark"in l?l.dark:l}function r(l){const k=c(l);let A,v;return"id"in k?v=C.ThemeIcon.asClassName(k):A=k,{iconPath:A,iconClass:v}}class h extends n{constructor(k,A){super(k.identifier,A),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Vd,this.L=[],this.M=new T.$Vd,this.N=new T.$Vd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((w,E)=>{this.C.set(E,w),this.D.set(w,E)});const A=(0,m.$FF)(this.O,"quickPickItemTooltip"),v=[];for(let w=0;w<k.length;w++){const E=k[w];if(E.kind===b.QuickPickItemKind.Separator)v.push({type:"separator",label:E.label});else{E.tooltip&&!A&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=E.iconPath?r(E.iconPath):void 0;v.push({handle:w,label:E.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:A?p.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((N,z)=>({...r(N.iconPath),tooltip:N.tooltip,handle:z}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(A=>this.D.has(A)),this.z({activeItems:this.J.map(A=>this.D.get(A))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(A=>this.D.has(A)),this.z({selectedItems:this.L.map(A=>this.D.get(A))})}_fireDidChangeActive(k){const A=(0,y.$Hb)(k.map(v=>this.C.get(v)));this.J=A,this.K.fire(A)}_fireDidChangeSelection(k){const A=(0,y.$Hb)(k.map(v=>this.C.get(v)));this.L=A,this.M.fire(A)}_fireDidTriggerItemButton(k,A){const v=this.C.get(k);if(!v||!v.buttons||!v.buttons.length)return;const w=v.buttons[A];w&&this.N.fire({button:w,item:v})}}class u extends n{constructor(k,A){super(k.identifier,A),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:L.default.Error}):this.z({validationMessage:k.message,severity:k.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new s(f,o)}e.$7hc=S}),define(ke[337],Se([1,0,2,4,52,3,11,6,19,128,13,26,61,15,25,16,10]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=e.$8hc=void 0;function i(P){return P instanceof D.URI}function s(P,N){return P.scheme===d.Schemas.file&&N.scheme===d.Schemas.file&&f.$k?P.toString()===N.toString():P.toString().toLowerCase()===N.toString().toLowerCase()}function n(P){if(P)return typeof P.iconPath=="string"?D.URI.file(P.iconPath):D.URI.isUri(P.iconPath)||m.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function c(P){if(P.icon){if(D.URI.isUri(P.icon))return P.icon;if(m.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const N=P.icon;return{light:N.light,dark:N.dark}}}else return}function t(P,N){if(!P.iconPath&&!N.iconPath)return 0;if(P.iconPath){if(!N.iconPath)return 1}else return-1;const z=typeof P.iconPath=="string"?P.iconPath:D.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,F=typeof N.iconPath=="string"?N.iconPath:D.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,y.$Sq)(z,F)}function a(P,N){let z=0;if(P.strikeThrough!==N.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==N.faded)return P.faded?1:-1;if(P.tooltip!==N.tooltip)return(P.tooltip||"").localeCompare(N.tooltip||"");if(z=t(P,N),z!==0)return z;if(P.light&&N.light)z=t(P.light,N.light);else{if(P.light)return 1;if(N.light)return-1}if(z!==0)return z;if(P.dark&&N.dark)z=t(P.dark,N.dark);else{if(P.dark)return 1;if(N.dark)return-1}return z}function r(P,N){if(P.command!==N.command)return P.command<N.command?-1:1;if(P.title!==N.title)return P.title<N.title?-1:1;if(P.tooltip!==N.tooltip){if(P.tooltip!==void 0&&N.tooltip!==void 0)return P.tooltip<N.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(P.arguments===N.arguments)return 0;if(P.arguments)if(N.arguments){if(P.arguments.length!==N.arguments.length)return P.arguments.length-N.arguments.length}else return 1;else return-1;for(let z=0;z<P.arguments.length;z++){const F=P.arguments[z],j=N.arguments[z];if(F!==j&&!(i(F)&&i(j)&&s(F,j)))return F<j?-1:1}return 0}function h(P,N){let z=(0,y.$Sq)(P.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(z!==0)return z;if(P.command&&N.command)z=r(P.command,N.command);else{if(P.command)return 1;if(N.command)return-1}if(z!==0)return z;if(P.decorations&&N.decorations)z=a(P.decorations,N.decorations);else{if(P.decorations)return 1;if(N.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)z=(0,y.$Sq)(P.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)z=(0,y.$Sq)(P.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return z}function u(P,N){for(let z=0;z<P.length;z++)if(P[z]!==N[z])return!1;return!0}function l(P,N){return P.command===N.command&&P.title===N.title&&P.tooltip===N.tooltip&&(P.arguments&&N.arguments?u(P.arguments,N.arguments):P.arguments===N.arguments)}function k(P,N){return(0,$.$ub)(P,N,l)}class A{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,S.$GF)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,S.$GF)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.l,N))}get document(){return(0,S.$GF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(N,z,F,j,M){this.k=N,this.l=j,this.m=M,this.d="",this.e=new T.$Vd,this.f="",this.h=!0,this.j=!0,this.#t=z,this.#e=F}showValidationMessage(N,z){(0,S.$GF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,N,z)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$8hc=A;class v{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,z,F,j,M,O,U){this.q=N,this.s=z,this.t=F,this.u=j,this.v=M,this.multiDiffEditorEnableViewChanges=O,this.w=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Vd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Vd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=v.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,z){const F=this.h.get(N);return F?(0,R.$Yg)(()=>this.s.executeCommand(F.command,...F.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(h),F=(0,$.$Db)(this.o,N,h).map(O=>{const U=O.toInsert.map(Q=>{const ue=this.e++;this.g.set(ue,Q);const Z=Q.resourceUri;let J;if(Q.command)if(Q.command.command==="vscode.open"||Q.command.command==="vscode.diff"||Q.command.command==="vscode.changes"){const te=new I.$Sc;J=this.s.converter.toInternal(Q.command,te),this.j.set(ue,te)}else this.h.set(ue,Q.command);const X=(0,S.$FF)(this.w,"scmMultiDiffEditor"),le=X?Q.multiDiffEditorOriginalUri:void 0,x=X?Q.multiFileDiffEditorModifiedUri:void 0,be=n(Q.decorations),ce=Q.decorations&&n(Q.decorations.light)||be,G=Q.decorations&&n(Q.decorations.dark)||be,W=[ce,G],ne=Q.decorations&&Q.decorations.tooltip||"",ye=Q.decorations&&!!Q.decorations.strikeThrough,de=Q.decorations&&!!Q.decorations.faded,ge=Q.contextValue||"";return{rawResource:[ue,Z,W,ne,ye,de,ge,J,le,x],handle:ue}});return{start:O.start,deleteCount:O.deleteCount,toInsert:U}}),j=F.map(({start:O,deleteCount:U,toInsert:Q})=>[O,U,Q.map(ue=>ue.rawResource)]),M=F.reverse();for(const{start:O,deleteCount:U,toInsert:Q}of M){const ue=Q.map(J=>J.handle),Z=this.n.splice(O,U,...ue);for(const J of Z)this.g.delete(J),this.h.delete(J),this.j.get(J)?.dispose(),this.j.delete(J)}return this.o=N,j}dispose(){this.l=!0,this.m.fire()}}class w{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let z;(0,S.$FF)(this.x,"quickDiffProvider")&&(z=N?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:z})}get historyProvider(){return(0,S.$GF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,S.$GF)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new I.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,this.#e.$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new I.$Sc,this.o=N;const z=this.y.converter.toInternal(N,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:z})}get actionButton(){return(0,S.$GF)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,S.$GF)(this.x,"scmActionButton"),this.p.value=new I.$Sc,this.q=N;const z=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(F=>F.map(j=>this.y.converter.toInternal(j,this.p.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:z??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&k(this.t,N))return;this.s.value=new I.$Sc,this.t=N;const z=(N||[]).map(F=>this.y.converter.toInternal(F,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:z})}get selected(){return this.u}constructor(N,z,F,j,M,O,U){this.x=N,this.y=j,this.z=M,this.A=O,this.B=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new I.$Uc,this.m=void 0,this.n=new I.$Uc,this.o=void 0,this.p=new I.$Uc,this.s=new I.$Uc,this.t=void 0,this.u=!1,this.v=new T.$Vd,this.onDidChangeSelection=this.v.event,this.w=w.d++,this.C=new Map,this.D=new Set,this.#e=F;const Q=D.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new A(N,z,this.#e,this.w,Q),this.#e.$registerSourceControl(this.w,M,O,U,Q)}createResourceGroup(N,z,F){const j=(0,S.$FF)(this.x,"scmMultiDiffEditor")&&F?.multiDiffEditorEnableViewChanges===!0,M=new v(this.#e,this.y,this.w,N,z,j,this.x),O=T.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,O),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const N=[],z=[];for(const[F,j]of this.C){j.dispose();const M=F.onDidUpdateResourceStates(()=>{this.D.add(F),this.eventuallyUpdateResourceStates()});T.Event.once(F.onDidDispose)(()=>{this.D.delete(F),M.dispose(),this.e.delete(F.handle),this.#e.$unregisterGroup(this.w,F.handle)}),N.push([F.handle,F.id,F.label,F.features,F.multiDiffEditorEnableViewChanges]);const O=F._takeResourceStateSnapshot();O.length>0&&z.push([F.handle,O]),this.e.set(F.handle,F)}this.#e.$registerGroups(this.w,N,z),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(z=>{const F=z._takeResourceStateSnapshot();F.length!==0&&N.push([z.handle,F])}),N.length>0&&this.#e.$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,g.$yh)(100)],w.prototype,"eventuallyAddResourceGroups",null),Ge([(0,g.$yh)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let E=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,z,F,j){this.l=z,this.m=F,this.n=j,this.g=new Map,this.h=new C.$nm,this.j=new T.$Vd,this.e=N.getProxy(b.$0K.MainThreadSCM),this.f=N.getProxy(b.$0K.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const O=this.g.get(M.sourceControlHandle);if(!O)return M;const U=O.getResourceGroup(M.groupHandle);return U?U.getResourceState(M.handle):M}else if(M&&M.$mid===4){const O=this.g.get(M.sourceControlHandle);return O?O.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const O=this.g.get(M.handle);return O||M}return M}})}createSourceControl(N,z,F,j){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,z,F,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const M=o.d++,O=new w(N,this.m,this.e,this.l,z,F,j);this.g.set(M,O);const U=this.h.get(N.identifier)||[];return U.push(O),this.h.set(N.identifier,U),O}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const z=this.h.get(N.identifier),F=z&&z[z.length-1];return F&&F.inputBox}$provideOriginalResource(N,z,F){const j=D.URI.revive(z);this.n.trace("ExtHostSCM#$provideOriginalResource",N,j.toString());const M=this.g.get(N);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Yg)(()=>M.quickDiffProvider.provideOriginalResource(j,F)).then(O=>O||null)}$onInputBoxValueChange(N,z){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const F=this.g.get(N);return F&&F.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(N,z,F,j){this.n.trace("ExtHostSCM#$executeResourceCommand",N,z,F);const M=this.g.get(N);if(!M)return Promise.resolve(void 0);const O=M.getResourceGroup(z);return O?O.$executeResourceCommand(F,j):Promise.resolve(void 0)}$validateInput(N,z,F){this.n.trace("ExtHostSCM#$validateInput",N);const j=this.g.get(N);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Yg)(()=>j.inputBox.validateInput(z,F)).then(M=>{if(!M)return Promise.resolve(void 0);const O=p.MarkdownString.fromStrict(M.message);return O?Promise.resolve([O,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(N,z,F){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupBase(z,F)??void 0}async $resolveHistoryItemGroupCommonAncestor(N,z,F,j){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,F,j)??void 0}async $provideHistoryItems(N,z,F,j){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(z,F,j))?.map(U=>({...U,icon:c(U)}))??void 0}async $provideHistoryItemSummary(N,z,F,j){const M=this.g.get(N)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const O=await M.provideHistoryItemSummary(z,F,j);return O?{...O,icon:c(O)}:void 0}async $provideHistoryItemChanges(N,z,F,j){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(z,F,j)??void 0}};e.$9hc=E,e.$9hc=E=o=Ge([Ve(3,L.$nj)],E)}),define(ke[338],Se([1,0,6,15,2]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class I{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(D.$0K.MainThreadShare)}async $provideShare(b,$,y){return await this.c.get(b)?.provideShare({selection:T.Range.to($.selection),resourceUri:g.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(b,$){const y=I.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,T.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$0hc=I}),define(ke[339],Se([1,0,7,6,216,3,15,18]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=e.$_hc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$8L("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$8L("statusBarItem.warningForeground")]])}#e;#t;constructor(m,p,S,d,f,o=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new I.$Sc,this.#e=m,this.#t=p,f&&d){this.c=(0,D.$KL)(d.identifier,f);const s=S.get(this.c);s&&(o=s.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=s.priority,this.j=!0,this.name=s.name,this.text=s.text,this.tooltip=s.tooltip,this.command=s.command,this.accessibilityInformation=s.accessibilityInformation)}else this.c=String($.a++);this.e=d,this.f=f,this.g=o,this.h=this.u(i)}u(m){if((0,b.$Mf)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new I.$Sc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let p;this.m?p=this.m:p=(0,g.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=$.b.get(this.o.id));const d=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,p,this.k,d,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$_hc=$;class y{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const p={message:m};return this.b.unshift(p),this.c(),new D.$_K(()=>{const S=this.b.indexOf(p);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class L{constructor(m,p){this.e=new Map,this.a=m.getProxy(T.$0K.MainThreadStatusBar),this.b=p,this.c=new y(this)}$acceptStaticEntries(m){for(const p of m)this.e.set(p.entryId,p)}createStatusBarEntry(m,p,S,d){return new $(this.a,this.b,this.e,m,p,S,d)}setStatusBarMessage(m,p){const S=this.c.setMessage(m);let d;return typeof p=="number"?d=setTimeout(()=>S.dispose(),p):typeof p<"u"&&p.then(()=>S.dispose(),()=>S.dispose()),new D.$_K(()=>{S.dispose(),clearTimeout(d)})}}e.$aic=L}),define(ke[150],Se([1,0,29,141,67,111,90,15,2]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=e.$nN=void 0;const y=(s,n,c,t)=>{let a=n;return{enumerable:!0,configurable:!1,get(){return a},set(r){if(!c(a,r)){const h=a;a=r,s.listener?.(t(r,h))}}}},L=(s,n)=>s===n,C={range:(s,n)=>s===n?!0:!s||!n?!1:s.isEqual(n),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(s,n)=>!(s.length!==n.length||s.some(c=>!n.find(t=>c.id===t.id)))},m=s=>n=>({op:4,update:s(n)}),p=(s,n)=>({range:(()=>{let c;const t=m(a=>({range:D.$Us.lift(b.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return c},set(a){s.listener?.({op:6}),C.range(c,a)||(c=a,s.listener?.(t(a)))}}})(),label:y(s,n,C.label,m(c=>({label:c}))),description:y(s,void 0,C.description,m(c=>({description:c}))),sortText:y(s,void 0,C.sortText,m(c=>({sortText:c}))),canResolveChildren:y(s,!1,C.canResolveChildren,c=>({op:2,state:c})),busy:y(s,!1,C.busy,m(c=>({busy:c}))),error:y(s,void 0,C.error,m(c=>({error:b.MarkdownString.fromStrict(c)||null}))),tags:y(s,[],C.tags,(c,t)=>({op:1,new:c.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),S=s=>{const n=g.$2J.fromString(s.extId),c=new f(n.controllerId,n.localId,s.label,$.URI.revive(s.uri)||void 0);return c.range=b.Range.to(s.range||void 0),c.description=s.description||void 0,c.sortText=s.sortText||void 0,c.tags=s.tags.map(t=>b.TestTag.to({id:(0,R.$7J)(t).tagId})),c},d=s=>{let n;for(const c of s.tests){const t=S(c.item);(0,T.$0M)(t).parent=n,n=t}return n};e.$nN=d;class f{constructor(n,c,t,a){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const r=(0,T.$9M)(this,n);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof o?void 0:r.parent}},children:{value:(0,I.$8M)(r,T.$0M,f),enumerable:!0,writable:!1},...p(r,t)})}}e.$oN=f;class o extends f{constructor(n,c){super(n,n,c,void 0),this._isRoot=!0}}e.$pN=o;class i extends I.$4M{constructor(n,c,t){super({controllerId:n,getDocumentVersion:a=>a&&t.getDocument(a)?.version,getApiFor:T.$0M,getChildren:a=>a.children,root:new o(n,c),toITestItem:b.TestItem.from})}}e.$qN=i}),define(ke[35],Se([1,0,18,7,15,24,6,19,13,55,29,48,2,3,5,20,150,22,68,44,38,88,91,30]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=void 0;let r=class{#e;#t;#i;constructor(v,w,E){this.b=new Map,this.c=new Map,this.#e=v.getProxy(R.$0K.MainThreadCommands),this.d=w,this.#i=E,this.#t=v.getProxy(R.$0K.MainThreadTelemetry),this.converter=new h(this,P=>{const N=this.c.get(P);return N?.result===l.Void?N:void 0},w),this.f=[{processArgument(P){return(0,y.$Ch)(P)}},{processArgument(P){return(0,I.$xn)(P,function(N){if(L.$Us.isIRange(N))return g.Range.to(N);if(C.$Ts.isIPosition(N))return g.Position.to(N);if(L.$Us.isIRange(N.range)&&m.URI.isUri(N.uri))return g.location.to(N);if(N instanceof o.$je)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const w=this.registerCommand(!1,v.id,async(...E)=>{const P=v.args.map((z,F)=>{if(!z.validate(E[F]))throw new Error(`Invalid argument '${z.name}' when running '${v.id}', received: ${typeof E[F]=="object"?JSON.stringify(E[F],null,"	"):E[F]} `);return z.convert(E[F])}),N=await this.executeCommand(v.internalId,...P);return v.result.convert(N,E,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new T.$_K(()=>{w.dispose(),this.c.delete(v.id)})}registerCommand(v,w,E,P,N,z){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:E,thisArg:P,metadata:N,extension:z}),v&&this.#e.$registerCommand(w),new T.$_K(()=>{this.b.delete(w)&&v&&this.#e.$unregisterCommand(w)})}executeCommand(v,...w){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,w,!0)}async g(v,w,E){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,w,!1);{let P=!1;const N=(0,I.$xn)(w,function(z){if(z instanceof T.$aL)return g.Position.from(z);if(z instanceof T.$bL)return g.Range.from(z);if(z instanceof T.$lL)return g.location.from(z);if(T.$xM.isNotebookRange(z))return g.NotebookRange.from(z);if(z instanceof ArrayBuffer)return P=!0,o.$je.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return P=!0,o.$je.wrap(z);if(z instanceof o.$je)return P=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(v,P?new i.$Tv(N):N,E);return(0,y.$Ch)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(v,w,!1);throw z}}}async h(v,w,E){const P=this.b.get(v);if(!P)throw new Error("Unknown command");const{callback:N,thisArg:z,metadata:F}=P;if(F?.args)for(let M=0;M<F.args.length;M++)try{(0,D.$Zf)(w[M],F.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${F.args[M].name}' - ${F.args[M].description}`)}const j=n.$Rd.create();try{return await N.apply(z,w)}catch(M){if(v===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...w);O&&(v=O.command)}if(this.d.error(M,v,P.extension?.identifier),!E)throw M;if(P.extension?.identifier){const O=this.#i.onExtensionError(P.extension.identifier,M);this.d.trace("forwarded error to extension?",O,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,s.$Qi)(M)),this.id=v,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,v,j.elapsed())}}j(v,w,E){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new c.$Lo(w),duration:E})}$executeContributedCommand(v,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const E=this.b.get(v);return E?(w=w.map(P=>this.f.reduce((N,z)=>z.processArgument(N,E.extension?.identifier),P)),this.h(v,w,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(w=>(v&&(w=w.filter(E=>E[0]!=="_")),w))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[w,E]of this.b){const{metadata:P}=E;P&&(v[w]=P)}return Promise.resolve(v)}};e.$wN=r,e.$wN=r=Ge([Ve(0,d.$bN),Ve(1,$.$nj),Ve(2,t.$vN)],r),e.$xN=(0,S.$6h)("IExtHostCommands");class h{constructor(v,w,E){this.d=v,this.f=w,this.g=E,this.delegatingCommandId=`__vsc${(0,a.$qg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,w){if(!v)return;const E={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return E;const P=this.f(v.command);if(P)E.id=P.internalId,E.arguments=P.args.map((N,z)=>N.convert(v.arguments&&v.arguments[z]));else if((0,b.$Lb)(v.arguments)){const N=`${v.command} /${++this.c}`;this.b.set(N,v),w.add((0,p.$Rc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),E.$ident=N,E.id=this.delegatingCommandId,E.arguments=[N],this.g.trace("CommandsConverter#CREATE",v.command,N)}return E}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const w=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$yN=h;class u{static{this.Uri=new u("uri","Uri of a text document",v=>m.URI.isUri(v),v=>v)}static{this.Position=new u("position","A position in a text document",v=>T.$aL.isPosition(v),g.Position.from)}static{this.Range=new u("range","A range in a text document",v=>T.$bL.isRange(v),g.Range.from)}static{this.Selection=new u("selection","A selection in a text document",v=>T.$cL.isSelection(v),g.Selection.from)}static{this.Number=new u("number","",v=>typeof v=="number",v=>v)}static{this.String=new u("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=u.Arr(u.String)}static Arr(v){return new u(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,w=>Array.isArray(w)&&w.every(E=>v.validate(E)),w=>w.map(E=>v.convert(E)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",v=>v instanceof T.$wL,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",v=>v instanceof T.$QM,g.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",v=>v instanceof f.$oN,g.TestItem.from)}constructor(v,w,E,P){this.name=v,this.description=w,this.validate=E,this.convert=P}optional(){return new u(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,w){return new u(v??this.name,w??this.description,this.validate,this.convert)}}e.$zN=u;class l{static{this.Void=new l("no result",v=>v)}constructor(v,w){this.description=v,this.convert=w}}e.$AN=l;class k{constructor(v,w,E,P,N){this.id=v,this.internalId=w,this.description=E,this.args=P,this.result=N}}e.$BN=k}),define(ke[340],Se([1,0,19,16,2,83,131,45,35,15,7]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;const C=[new $.$BN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of DocumentHighlight-instances.",p(y.DocumentHighlight.to))),new $.$BN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$zN.Uri],new $.$AN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,f)=>{if((0,D.$Kb)(d))return;class o extends L.$rL{static to(s){const n=new o(s.name,y.SymbolKind.to(s.kind),s.containerName||"",new L.$lL(f[0],y.Range.to(s.range)));return n.detail=s.detail,n.range=n.location.range,n.selectionRange=y.Range.to(s.selectionRange),n.children=s.children?s.children.map(o.to):[],n}}return d.map(o.to)})),new $.$BN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$zN.Uri,new $.$zN("options","Formatting options",d=>!0,d=>d)],new $.$AN("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new $.$BN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$zN.Uri,$.$zN.Range,new $.$zN("options","Formatting options",d=>!0,d=>d)],new $.$AN("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new $.$BN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$zN.Uri,$.$zN.Position,new $.$zN("ch","Trigger character",d=>typeof d=="string",d=>d),new $.$zN("options","Formatting options",d=>!0,d=>d)],new $.$AN("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new $.$BN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$BN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$BN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$BN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$BN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Location-instances.",p(y.location.to))),new $.$BN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of Hover-instances.",p(y.Hover.to))),new $.$BN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$zN.Uri,new $.$zN("position","A position in a text document",d=>Array.isArray(d)&&d.every(f=>L.$aL.isPosition(f)),d=>d.map(y.Position.from))],new $.$AN("A promise that resolves to an array of ranges.",d=>d.map(f=>{let o;for(const i of f.reverse())o=new L.$vL(y.Range.to(i),o);return o}))),new $.$BN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$zN.String.with("query","Search string")],new $.$AN("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(y.WorkspaceSymbol.to))),new $.$BN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of CallHierarchyItem-instances",d=>d.map(y.CallHierarchyItem.to))),new $.$BN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$zN.CallHierarchyItem],new $.$AN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",d=>d.map(y.CallHierarchyIncomingCall.to))),new $.$BN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$zN.CallHierarchyItem],new $.$AN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",d=>d.map(y.CallHierarchyOutgoingCall.to))),new $.$BN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to a range and placeholder text.",d=>{if(d)return{range:y.Range.to(d.range),placeholder:d.text}})),new $.$BN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$zN.Uri,$.$zN.Position,$.$zN.String.with("newName","The new symbol name")],new $.$AN("A promise that resolves to a WorkspaceEdit.",d=>{if(d){if(d.rejectReason)throw new Error(d.rejectReason);return y.WorkspaceEdit.to(d)}})),new $.$BN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$zN.Uri,$.$zN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$AN("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(y.DocumentLink.to))),new $.$BN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$zN.Uri],new $.$AN("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new L.$pM(d.tokenTypes,d.tokenModifiers)})),new $.$BN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$zN.Uri],new $.$AN("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const f=(0,R.$x$)(d);if(f.type==="full")return new L.$rM(f.data,void 0)})),new $.$BN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$zN.Uri,$.$zN.Range.optional()],new $.$AN("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new L.$pM(d.tokenTypes,d.tokenModifiers)})),new $.$BN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$zN.Uri,$.$zN.Range],new $.$AN("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const f=(0,R.$x$)(d);if(f.type==="full")return new L.$rM(f.data,void 0)})),new $.$BN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$zN.Uri,$.$zN.Position,$.$zN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$zN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$AN("A promise that resolves to a CompletionList-instance.",(d,f,o)=>{if(!d)return new L.$HL([]);const i=d.suggestions.map(s=>y.CompletionItem.to(s,o));return new L.$HL(i,d.incomplete)})),new $.$BN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$zN.Uri,$.$zN.Position,$.$zN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$AN("A promise that resolves to SignatureHelp.",d=>{if(d)return y.SignatureHelp.to(d)})),new $.$BN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$zN.Uri,$.$zN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$AN("A promise that resolves to an array of CodeLens-instances.",(d,f,o)=>p(i=>new L.$zL(y.Range.to(i.range),i.command&&o.fromInternal(i.command)))(d))),new $.$BN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$zN.Uri,new $.$zN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>L.$bL.isRange(d),d=>L.$cL.isSelection(d)?y.Selection.from(d):y.Range.from(d)),$.$zN.String.with("kind","Code action kind to return code actions for").optional(),$.$zN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$AN("A promise that resolves to an array of Command-instances.",(d,f,o)=>p(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const s=new L.$tL(i.title,i.kind?new L.$uL(i.kind):void 0);return i.edit&&(s.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(s.command=o.fromInternal(i.command)),s.isPreferred=i.isPreferred,s}})(d))),new $.$BN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$zN.Uri],new $.$AN("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(f=>new L.$NL(y.Range.to(f.range),y.Color.to(f.color))):[])),new $.$BN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$zN("color","The color to show and insert",d=>d instanceof L.$ML,y.Color.from),new $.$zN("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:y.Range.from(d.range)}))],new $.$AN("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(y.ColorPresentation.to):[])),new $.$BN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$zN.Uri,$.$zN.Range],new $.$AN("A promise that resolves to an array of Inlay objects",(d,f,o)=>d.map(y.InlayHint.to.bind(void 0,o)))),new $.$BN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$zN.Uri],new $.$AN("A promise that resolves to an array of FoldingRange objects",(d,f)=>{if(d)return d.map(y.FoldingRange.to)})),new $.$BN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$AN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(f=>y.NotebookExclusiveDocumentPattern.to(f))})))),new $.$BN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$zN.Uri,$.$zN.Range,new $.$zN("context","An InlineValueContext",d=>d&&typeof d.frameId=="number"&&d.stoppedLocation instanceof L.$bL,d=>y.InlineValueContext.from(d))],new $.$AN("A promise that resolves to an array of InlineValue objects",d=>d.map(y.InlineValue.to))),new $.$BN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$zN("uriOrString","Uri-instance or string (only http/https)",d=>g.URI.isUri(d)||typeof d=="string"&&(0,T.$fg)(d,T.Schemas.http,T.Schemas.https),d=>d),new $.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[y.ViewColumn.from(d),void 0]:[y.ViewColumn.from(d.viewColumn),y.TextEditorOpenOptions.from(d)])).optional(),$.$zN.String.with("label","").optional()],$.$AN.Void),new $.$BN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$zN.Uri.with("resource","Resource to open"),$.$zN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[y.ViewColumn.from(d),void 0]:[y.ViewColumn.from(d.viewColumn),y.TextEditorOpenOptions.from(d)])).optional()],$.$AN.Void),new $.$BN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$zN.Uri.with("left","Left-hand side resource of the diff editor"),$.$zN.Uri.with("right","Right-hand side resource of the diff editor"),$.$zN.String.with("title","Human readable title for the diff editor").optional(),new $.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[y.ViewColumn.from(d.viewColumn),y.TextEditorOpenOptions.from(d)]).optional()],$.$AN.Void),new $.$BN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$zN.String.with("title","Human readable title for the changes editor"),new $.$zN("resourceList","List of resources to compare",d=>{for(const f of d){if(f.length!==3)return!1;const[o,i,s]=f;if(!g.URI.isUri(o)||!g.URI.isUri(i)&&i!==void 0&&i!==null||!g.URI.isUri(s)&&s!==void 0&&s!==null)return!1}return!0},d=>d)],$.$AN.Void),new $.$BN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$zN.Uri,$.$zN.Position],new $.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(y.TypeHierarchyItem.to))),new $.$BN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$zN.TypeHierarchyItem],new $.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(y.TypeHierarchyItem.to))),new $.$BN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$zN.TypeHierarchyItem],new $.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(y.TypeHierarchyItem.to))),new $.$BN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$zN.TestItem],$.$AN.Void),new $.$BN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$zN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$AN.Void),new $.$BN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$zN.String.with("name","The context key name"),new $.$zN("value","The context key value",()=>!0,d=>d)],$.$AN.Void),new $.$BN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$zN.Uri,$.$zN.StringArray,new $.$zN("MappedEditsContext","Mapped Edits Context",d=>y.MappedEditsContext.is(d),d=>y.MappedEditsContext.from(d))],new $.$AN("A promise that resolves to a workspace edit or null",d=>d?y.WorkspaceEdit.to(d):null))];class m{static register(f){C.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",b.$5i)}}e.$vgc=m;function p(d){return f=>{if(Array.isArray(f))return f.map(d)}}function S(d){if(!Array.isArray(d))return;const f=[];for(const o of d)I.$Gt(o)?f.push(y.DefinitionLink.to(o)):f.push(y.location.to(o));return f}}),define(ke[341],Se([1,0,3,2,6,15,7,35,11]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class y{static{this.a=0}constructor(p,S){this.extension=p,this.provider=S,this.handle=y.a++}}class L{constructor(p){this.session=p,this.responses=[]}}class C{static{this.a=0}constructor(p,S,d,f){this.f=d,this.g=f,this.b=new Map,this.d=new Map,this.e=p.getProxy(g.$0K.MainThreadInlineChat),S.registerApiCommand(new b.$BN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$zN("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?I.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?I.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?I.Position.from(o.position):void 0}})],b.$AN.Void))}registerProvider(p,S,d){const f=new y(p,S);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,d?.label??p.displayName??p.name,p.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",d?.supportReportIssue??!1),(0,D.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(p,S,d,f){const o=this.b.get(p);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(T.URI.revive(S)),s=I.Selection.to(d),n=await o.provider.prepareInteractiveEditorSession({document:i,selection:s},f);if(!n)return;if(n.wholeRange&&!n.wholeRange.contains(s))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const c=C.a++;return this.d.set(c,new L(n)),{id:c,placeholder:n.placeholder,input:n.input,slashCommands:n.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:I.Range.from(n.wholeRange),message:n.message}}async $provideResponse(p,S,d,f){const o=this.b.get(p);if(!o)return;const i=this.d.get(S.id);if(!i)return;const s={prompt:d.prompt,selection:I.Selection.to(d.selection),wholeRange:I.Range.to(d.wholeRange),attempt:d.attempt,live:d.live,withIntentDetection:d.withIntentDetection};let n=!1;const c={report:async A=>{if(!d.live&&A.edits?.length)throw new Error("Progress reporting is only supported for live sessions");n||f.isCancellationRequested||await this.e.$handleProgressChunk(d.requestId,{message:A.message,edits:A.edits?.map(I.TextEdit.from),editsShouldBeInstant:A.editsShouldBeInstant,slashCommand:A.slashCommand?.command,markdownFragment:R.$AL.isMarkdownString(A.content)?A.content.value:A.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,s,c,f));let a;try{a=await(0,$.$Ug)(t,f)}finally{n=!0}if(!a)return;const r=i.responses.push(a)-1,h={wholeRange:I.Range.from(a.wholeRange),placeholder:a.placeholder};if(!C.h(a))return{...h,id:r,type:"editorEdit",message:I.MarkdownString.from(a.contents),edits:[]};const{edits:u,contents:l}=a,k=l!==void 0?I.MarkdownString.from(l):void 0;return u instanceof R.$jL?{...h,id:r,type:"bulkEdit",edits:I.WorkspaceEdit.from(u),message:k}:{...h,id:r,type:"editorEdit",edits:u.map(I.TextEdit.from),message:k}}async $provideFollowups(p,S,d,f){const o=this.b.get(p),i=this.d.get(S),s=i?.responses[d];if(o&&s&&o.provider.provideFollowups){const n=Promise.resolve(o.provider.provideFollowups(i.session,s,f));return(await(0,$.$Ug)(n,f))?.map(I.ChatFollowup.from)}}$handleFeedback(p,S,d,f){const o=this.b.get(p),i=this.d.get(S),s=i?.responses[d];if(o&&s){const n=I.InteractiveEditorResponseFeedbackKind.to(f);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,s,n)}}$releaseSession(p,S){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$Dhc=C}),define(ke[342],Se([1,0,2,35]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class g{constructor(R,b,$,y,L){this.a=b,this.b=$,this.c=y;const C=new T.$BN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$zN("showOptions","Show Options",m=>!0,m=>m),new T.$zN("resource","Interactive resource Uri",m=>!0,m=>m),new T.$zN("controllerId","Notebook controller Id",m=>!0,m=>m),new T.$zN("title","Interactive editor title",m=>!0,m=>m)],new T.$AN("Notebook and input URI",m=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const p=this.a.getEditorById(m.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri),notebookEditor:p.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(R,b,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Qhc=g}),define(ke[343],Se([1,0,19,11,21,4,3,28,2,26,13,6,35,15,7,112,284,25,68]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=e.$Yhc=void 0;let s=class{constructor(l,k,A,v,w){this.m=k,this.n=A,this.o=v,this.q=w,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new I.$Vd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=l.getProxy(C.$0K.MainThreadNotebookKernels);const E=new m.$BN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$zN("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const N=this.n.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:N}}else if(P&&"notebookEditor"in P){const N=this.n.getIdByEditor(P.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return P})],m.$AN.Void);this.o.registerApiCommand(E)}createNotebookController(l,k,A,v,w,E){for(const x of this.j.values())if(x.controller.id===k&&y.$lm.equals(l.identifier,x.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const P=this.k++,N=this;this.q.trace(`NotebookController[${P}], CREATED by ${l.identifier.value}, ${k}`);const z=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${l.identifier}'`);let F=!1;const j=new I.$Vd,M=new I.$Vd,O={id:h(l.identifier,k),notebookType:A,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:v||l.identifier.value,preloads:E?E.map(p.NotebookRendererScript.from):[]};let U=w??z,Q,ue;this.a.$addKernel(P,O).catch(x=>{console.log(x),F=!0});let Z=0;const J=()=>{if(F)return;const x=++Z;Promise.resolve().then(()=>{x===Z&&this.a.$updateKernel(P,O)})},X=new b.$Ac,le={get id(){return k},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return O.label},set label(x){O.label=x??l.displayName??l.name,J()},get detail(){return O.detail??""},set detail(x){O.detail=x,J()},get description(){return O.description??""},set description(x){O.description=x,J()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(x){O.supportedLanguages=x,J()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(x){O.supportsExecutionOrder=x,J()},get rendererScripts(){return O.preloads?O.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(x){U=x??z},get interruptHandler(){return Q},set interruptHandler(x){Q=x,O.supportsInterrupt=!!x,J()},set variableProvider(x){(0,o.$GF)(l,"notebookVariableProvider"),ue=x,O.hasVariableProvider=!!x,x?.onDidChangeVariables(be=>N.a.$variablesUpdated(be.uri)),J()},get variableProvider(){return ue},createNotebookCellExecution(x){if(F)throw new Error("notebook controller is DISPOSED");if(!X.has(x.notebook.uri))throw N.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.notebook.uri.toString()}`);return N._createNotebookCellExecution(x,h(l.identifier,this.id))},createNotebookExecution(x){if((0,o.$GF)(l,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!X.has(x.uri))throw N.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.uri.toString()}`);return N._createNotebookExecution(x,h(l.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${P}], DISPOSED`),F=!0,this.j.delete(P),j.dispose(),M.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(x,be){be===S.NotebookControllerAffinity2.Hidden&&(0,o.$GF)(l,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(P,x.uri,be)},onDidReceiveMessage:M.event,postMessage(x,be){return(0,o.$GF)(l,"notebookMessaging"),N.a.$postMessage(P,be&&N.n.getIdByEditor(be),x)},asWebviewUri(x){return(0,o.$GF)(l,"notebookMessaging"),(0,d.$Dvb)(x,N.m.remote)}};return this.j.set(P,{extensionId:l.identifier,controller:le,onDidReceiveMessage:M,onDidChangeSelection:j,associatedNotebooks:X}),le}getIdByController(l){for(const[k,A]of this.j)if(A.controller===l)return h(A.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,k){const A=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${A}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(A,k);const w={dispose:()=>{this.f.delete(A),v.a.$removeKernelDetectionTask(A)}};return this.f.set(A,w),w}registerKernelSourceActionProvider(l,k,A){const v=this.i++,w=typeof A.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,E=this;this.h.set(v,A),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,k);let P;return w!==void 0&&(P=A.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(v),E.a.$removeKernelSourceActionProvider(v,v),P?.dispose()}}}async $provideKernelSourceActions(l,k){const A=this.h.get(l);if(A){const v=new R.$Sc;return(await A.provideNotebookKernelSourceActions(k)??[]).map(E=>p.NotebookKernelSourceAction.from(E,this.o.converter,v))}return[]}$acceptNotebookAssociation(l,k,A){const v=this.j.get(l);if(v){const w=this.n.getNotebookDocument($.URI.revive(k));A?v.associatedNotebooks.set(w.uri,!0):v.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,w.uri.toString(),A),v.onDidChangeSelection.fire({selected:A,notebook:w.apiNotebook})}}async $executeCells(l,k,A){const v=this.j.get(l);if(!v)return;const w=this.n.getNotebookDocument($.URI.revive(k)),E=[];for(const P of A){const N=w.getCell(P);N&&E.push(N.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,w.uri.toString(),E.length),await v.controller.executeHandler.call(v.controller,E,w.apiNotebook,v.controller)}catch(P){this.q.error(`NotebookController[${l}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(l,k,A){const v=this.j.get(l);if(!v)return;const w=this.n.getNotebookDocument($.URI.revive(k));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,w.apiNotebook);else for(const E of A){const P=w.getCell(E);P&&this.b.get(P.uri)?.cancel()}if(v.controller.interruptHandler){const E=this.c.get(w.uri);A.length&&Array.isArray(E)&&E.length&&E.forEach(P=>P.dispose())}}async $provideVariables(l,k,A,v,w,E,P){const N=this.j.get(l);if(!N)return;const z=this.n.getNotebookDocument($.URI.revive(A)),F=N.controller.variableProvider;if(!F)return;let j;if(v){if(j=this.s[v],!j)return}else this.s={};const M=w==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,O=F.provideVariables(z.apiNotebook,j,M,E,P);for await(const U of O){if(P.isCancellationRequested)return;const Q={id:this.r++,name:U.variable.name,value:U.variable.value,hasNamedChildren:U.hasNamedChildren,indexedChildrenCount:U.indexedChildrenCount};this.s[Q.id]=U.variable,this.a.$receiveVariable(k,Q)}}$acceptKernelMessageFromRenderer(l,k,A){const v=this.j.get(l);if(!v)return;const w=this.n.getEditorById(k);v.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:A}))}$cellExecutionChanged(l,k,A){const w=this.n.getNotebookDocument($.URI.revive(l)).getCell(k);if(w){const E=A?p.NotebookCellExecutionState.to(A):S.NotebookCellExecutionState.Idle;E!==void 0&&this.l.fire({cell:w.apiCell,state:E})}}_createNotebookCellExecution(l,k){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const w=new c(k,v,this.a);this.b.set(v.uri,w);const E=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),E.dispose(),this.b.delete(v.uri))});return w.asApiObject()}_createNotebookExecution(l,k){const A=this.n.getNotebookDocument(l.uri),v=l.getCells().find(P=>{const N=A.getCellFromApiCell(P);return N&&this.b.has(N.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(A.uri))throw new Error(`duplicate notebook execution for ${A.uri}`);const w=new a(k,A,this.a),E=w.onDidChangeState(()=>{w.state===t.Resolved&&(w.dispose(),E.dispose(),this.c.delete(A.uri))});return this.c.set(A.uri,[w,E]),w.asApiObject()}};e.$Yhc=s,e.$Yhc=s=Ge([Ve(4,L.$nj)],s);var n;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(n||(n={}));class c extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(l,k,A){super(),this.m=k,this.n=A,this.b=c.a++,this.c=new I.$Vd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new g.$6d),this.h=new r(10,v=>this.s(v)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const k=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new i.$Tv(k))}t(){if(this.f===n.Init)throw new Error("Must call start before modifying cell output");if(this.f===n.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let k=this.m;if(l&&(k=this.m.notebook.getCellFromApiCell(l)),!k)throw new Error("INVALID cell");return k.handle}y(l){return l.map(k=>{const A=S.$BM.ensureUniqueMimeTypes(k.items,!0);return A===k.items?p.NotebookCellOutput.from(k):p.NotebookCellOutput.from({items:A,id:k.id,metadata:k.metadata})})}async z(l,k,A){const v=this.w(k),w=this.y((0,D.$3b)(l));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:v,append:A,outputs:w})}async C(l,k,A){return l=S.$BM.ensureUniqueMimeTypes((0,D.$3b)(l),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:l.map(p.NotebookCellOutputItem.from),outputId:k.id,append:A})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(A){l.j=A,l.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(A){if(l.f===n.Resolved||l.f===n.Started)throw new Error("Cannot call start again");l.f=n.Started,l.c.fire(),l.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:A})},end(A,v){if(l.f===n.Resolved)throw new Error("Cannot call resolve twice");l.f=n.Resolved,l.c.fire(),l.h.flush(),l.n.$completeExecution(l.b,new i.$Tv({runEndTime:v,lastRunSuccess:A}))},clearOutput(A){return l.t(),l.z([],A,!1)},appendOutput(A,v){return l.t(),l.z(A,v,!0)},replaceOutput(A,v){return l.t(),l.z(A,v,!1)},appendOutputItems(A,v){return l.t(),l.C(A,v,!0)},replaceOutputItems(A,v){return l.t(),l.C(A,v,!1)}})}}var t;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(t||(t={}));class a extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(l,k,A){super(),this.h=k,this.j=A,this.b=a.a++,this.c=new I.$Vd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new g.$6d),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class r{constructor(l,k){this.f=l,this.g=k,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new T.$qh,this.b=Date.now(),(0,T.$7g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>l.complete())}}function h(u,l){return`${u.value}/${l}`}e.$Zhc=h}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,218,14,262,21,30,263,61,11,15,35]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=e.$ahc=e.$_gc=e.$$gc=void 0,e.$$gc=(0,g.$6h)("IExtHostTerminalService");class s{constructor(v,w,E,P){this.l=v,this._id=w,this.m=E,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(z,F=!0){N.q(),N.l.$sendText(N._id,z,F)},show(z){N.q(),N.l.$show(N._id,z)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(v,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??w?.cwd??void 0,env:v.env??void 0,icon:u(v.iconPath)??void 0,color:d.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(v.location,w?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,w,E,P,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:P,color:d.ThemeColor.isThemeColor(N)?N.id:void 0,location:w?.location||this.o(v,E),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,w){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in v?{viewColumn:o.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,w){this.h=Object.freeze({code:v,reason:w})}setDimensions(v,w){return v===this.d&&w===this.g||v===0||w===0?!1:(this.d=v,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(w=>{w!==v&&(this.b=Promise.resolve(v))})}}e.$_gc=s;class n{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new D.$Vd,this.onProcessData=this.a.event,this.b=new D.$Vd,this.d=new D.$Vd,this.onDidChangeProperty=this.d.event,this.f=new D.$Vd,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,w){this.g.setDimensions?.({columns:v,rows:w})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,t=class extends b.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,w,E){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Vd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Vd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Vd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Vd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Vd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Vd,this.onDidChangeShell=this.N.event,this.O=new D.$Vd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Vd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(T.$0K.MainThreadTerminalService),this.y=new S.$Prb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:P=>{const N=z=>{const F=z;return this.W(F.instanceId)?.value};switch(P?.$mid){case 15:return N(P);default:{if(Array.isArray(P))for(let z=0;z<P.length&&P[z].$mid===15;z++)P[z]=N(P[z]);return P}}}}),this.B({dispose:()=>{for(const[P,N]of this.g)N.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,w){const E=new s(this.a,(0,p.$qg)(),v,v.name),P=new n(v.pty);return E.createExtensionTerminal(v.location,w,this.R(v,w).resolvedExtHostIdentifier,u(v.iconPath),l(v.color)).then(N=>{const z=this.S(N,P);this.h[N]=z}),this.f.push(E),E.value}R(v,w){if(w=w||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const E=v.location.parentTerminal;if(E){const P=this.f.find(N=>N.value===E);P&&(w.resolvedExtHostIdentifier=P._id)}}else v.location&&typeof v.location!="object"?w.location=v.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(v,w){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const P=new n(w),N=this.S(v,P);this.h[v]=N}async $acceptActiveTerminalChanged(v){const w=this.b;if(v===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const E=this.W(v);E&&(this.b=E,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,w){const E=this.W(v);E&&this.O.fire({terminal:E.value,data:w})}async $acceptTerminalDimensions(v,w,E){const P=this.W(v);P&&P.setDimensions(w,E)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(v,w){const E=this.W(v);E&&this.P.fire({terminal:E.value,...w})}async $acceptTerminalMaximumDimensions(v,w,E){this.g.get(v)?.resize(w,E)}async $acceptTerminalTitleChange(v,w){const E=this.W(v);E&&(E.name=w)}async $acceptTerminalClosed(v,w,E){const P=this.Y(this.f,v);if(P!==null){const N=this.f.splice(P,1)[0];N.setExitStatus(w,E),this.H.fire(N.value)}}$acceptTerminalOpened(v,w,E,P){if(w){const F=this.Y(this.f,w);if(F!==null){this.f[F]._id=v,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const N={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:I.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},z=new s(this.a,v,N,E);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(v,w){this.W(v)?._setProcessId(w)}async $startExtensionTerminal(v,w){const E=this.W(v);if(!E)return{message:(0,y.localize)(0,null,v)};E.isOpen||await new Promise(N=>{const z=this.onDidOpenTerminal(async F=>{F===E.value&&(z.dispose(),N())})});const P=this.g.get(v);P?P.startSendingEvents(w):this.j[v]={initialDimensions:w}}S(v,w){const E=new b.$Sc;E.add(w.onProcessReady(N=>this.a.$sendProcessReady(v,N.pid,N.cwd,N.windowsPty))),E.add(w.onDidChangeProperty(N=>this.a.$sendProcessProperty(v,N))),this.y.startBuffering(v,w.onProcessData),E.add(w.onProcessExit(N=>this.U(v,N))),this.g.set(v,w);const P=this.j[v];return P&&w instanceof n&&(w.startSendingEvents(P.initialDimensions),delete this.j[v]),E}$acceptProcessAckDataEvent(v,w){this.g.get(v)?.acknowledgeDataEvent(w)}$acceptProcessInput(v,w){this.g.get(v)?.input(w)}$acceptTerminalInteraction(v){const w=this.W(v);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(v,w){this.W(v)?.setSelection(w)}$acceptProcessResize(v,w,E){try{this.g.get(v)?.resize(w,E)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(v,w){this.g.get(v)?.shutdown(w)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(w=>this.a.$sendProcessProperty(v,{type:"cwd",value:w}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new $.$_K(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,w,E){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,E),this.a.$registerProfileProvider(w,v.identifier.value),new $.$_K(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(v,w,E){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,E),this.a.$registerQuickFixProvider(v,w),new $.$_K(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,w){const E=new m.$6d().token;if(E.isCancellationRequested)return;const P=this.D.get(v);if(!P)return;const N=await P.provideTerminalQuickFixes(w,E);if(N===null||Array.isArray(N)&&N.length===0)return;const z=new b.$Sc;if(this.w.value=z,!Array.isArray(N))return N?o.TerminalQuickFix.from(N,this.Q.converter,z):void 0;const F=[];for(const j of N){const M=o.TerminalQuickFix.from(j,this.Q.converter,z);M&&F.push(M)}return F}async $createContributedProfileTerminal(v,w){const E=new m.$6d().token;let P=await this.C.get(v)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,w);return}this.createTerminalFromOptions(P.options,w)}}async $provideLinks(v,w){const E=this.W(v);if(!E)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const N=new m.$6d;this.G.set(v,N);const z=[],F={terminal:E.value,line:w},j=[];for(const U of this.z)j.push(f.Promises.withAsyncBody(async Q=>{N.token.onCancellationRequested(()=>Q({provider:U,links:[]}));const ue=await U.provideTerminalLinks(F,N.token)||[];N.token.isCancellationRequested||Q({provider:U,links:ue})}));const M=await Promise.all(j);if(N.token.isCancellationRequested)return[];const O=new Map;for(const U of M)U&&U.links.length>0&&z.push(...U.links.map(Q=>{const ue={id:c++,startIndex:Q.startIndex,length:Q.length,label:Q.tooltip};return O.set(ue.id,{provider:U.provider,link:Q}),ue}));return this.F.set(v,O),z}$activateLink(v,w){const E=this.F.get(v)?.get(w);E&&E.provider.handleTerminalLink(E.link)}U(v,w){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const E=this.h[v];E&&(E.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,w)}W(v){return this.X(this.f,v)}X(v,w){const E=this.Y(v,w);return E!==null?v[E]:null}Y(v,w){const E=v.findIndex(P=>P._id===w);return E===-1?null:E}getEnvironmentVariableCollection(v){let w=this.n.get(v.identifier.value);return w||(w=new a,this.$(v.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(v,w){const E=(0,C.$Mr)(w.map),P=(0,C.$Nr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(v,w.persistent,E.length===0?void 0:E,P)}$initEnvironmentVariableCollections(v){v.forEach(w=>{const E=w[0],P=new a(w[1]);this.$(E,P)})}$acceptDefaultProfile(v,w){const E=this.s;this.s=v,this.u=w,E?.path!==v.path&&this.N.fire(v.path)}$(v,w){this.n.set(v,w),w.onDidChangeCollection(()=>{this.Z(v,w)})}};e.$ahc=t,e.$ahc=t=Ge([Ve(1,i.$xN),Ve(2,R.$bN)],t);class a{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Vd,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const w=this.h(v);let E=this.a.get(w);return E||(E=new r(this,v),this.a.set(w,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(v,w,E,P){this.f(v,{value:w,type:$.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:P})}append(v,w,E,P){this.f(v,{value:w,type:$.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:P})}prepend(v,w,E,P){this.f(v,{value:w,type:$.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:P})}f(v,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(v,w.scope),P=this.map.get(E),N=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==w.value||P.type!==w.type||P.options?.applyAtProcessCreation!==N.applyAtProcessCreation||P.options?.applyAtShellIntegration!==N.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const z=this.g(v,w.scope),F={variable:v,...w,options:N};this.map.set(z,F),this.d.fire()}}get(v,w){const E=this.g(v,w),P=this.map.get(E);return P?k(P):void 0}g(v,w){const E=this.h(w);return E.length?`${v}:::${E}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const w=new Map;for(const[E,P]of this.map)this.h(P.scope)===this.h(v)&&w.set(P.variable,k(P));return w}delete(v,w){const E=this.g(v,w);this.map.delete(E),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[w,E]of this.map)E.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(w);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,w){const E=this.h(w),P=this.descriptionMap.get(E);if(!P||P.description!==v){let N;typeof v=="string"?N=v:N=v?.value.split(`

`)[0];const z={description:N,scope:w};this.descriptionMap.set(E,z),this.d.fire()}}getDescription(v){const w=this.h(v);return this.descriptionMap.get(w)?.description}k(v){const w=this.h(v);this.descriptionMap.delete(w)}}class r{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,w){this.b=v,this.d=w,this.a=new D.$Vd}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,w,E){this.b.replace(v,w,E,this.d)}append(v,w,E){this.b.append(v,w,E,this.d)}prepend(v,w,E){this.b.prepend(v,w,E,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,w){this.b.getVariableMap(this.d).forEach((E,P)=>v.call(w,P,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let h=class extends t{constructor(v,w){super(!1,v,w)}createTerminal(v,w,E){throw new L.$_}createTerminalFromOptions(v,w){throw new L.$_}};e.$bhc=h,e.$bhc=h=Ge([Ve(0,i.$xN),Ve(1,R.$bN)],h);function u(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function l(A){return d.ThemeColor.isThemeColor(A)?A:void 0}function k(A){const v={...A};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(ke[344],Se([1,0,11,22,21,4,74,54,3,24,18,30,13,6,20,150,15,7,67,111,90,25]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=e.$gic=e.$fic=e.$eic=void 0;let t=class extends $.$Tc{constructor(j,M,O,U){super(),this.w=U,this.f=this.B(new I.$Vd),this.g=new Map,this.s=this.B(new I.$Vd),this.onResultsChanged=this.f.event,this.results=[],this.h=j.getProxy(p.$0K.MainThreadTesting),this.m=new E(this.h),this.j=new u(this.h,M),O.registerArgumentProcessor({processArgument:Q=>{switch(Q?.$mid){case 16:{const ue=Q,Z=ue.tests[ue.tests.length-1].item.extId;return this.g.get(i.$2J.root(Z))?.collection.tree.get(Z)?.actual??(0,d.$nN)(Q)}case 18:{const{extId:ue,message:Z}=Q;return{test:this.g.get(i.$2J.root(ue))?.collection.tree.get(ue)?.actual,message:f.TestMessage.to(Z)}}default:return Q}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const Q=await O.executeCommand("_testing.getExplorerSelection"),ue=Z=>{const J=this.g.get(i.$2J.root(Z));if(J)return i.$2J.isRoot(Z)?J.controller:J.collection.tree.get(Z)?.actual};return{include:Q?.include.map(ue).filter(L.$Qf)||[],exclude:Q?.exclude.map(ue).filter(L.$Qf)||[]}})}createTestController(j,M,O,U){if(this.g.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const Q=new $.$Sc,ue=Q.add(new d.$qN(M,O,this.w));ue.root.label=O;const Z=new Map,J=new Set,X=this.h,le={items:ue.root.children,get label(){return O},set label(be){O=be,ue.root.label=be,X.$updateController(M,{label:O})},get refreshHandler(){return U},set refreshHandler(be){U=be,X.$updateController(M,{canRefresh:!!be})},get id(){return M},createRunProfile:(be,ce,G,W,ne,ye)=>{let de=(0,b.$Ti)(be);for(;Z.has(de);)de++;return new N(this.h,Z,j,J,this.s.event,M,de,be,ce,G,W,ne,ye)},createTestItem(be,ce,G){return new d.$oN(M,be,ce,G)},createTestRun:(be,ce,G=!0)=>this.j.createTestRun(j,M,ue,be,ce,G),invalidateTestResults:be=>{if(be===void 0)this.h.$markTestRetired(void 0);else{const ce=be instanceof Array?be:[be];this.h.$markTestRetired(ce.map(G=>i.$2J.fromExtHostTestItem(G,M).toString()))}},set resolveHandler(be){ue.resolveHandler=be},get resolveHandler(){return ue.resolveHandler},dispose:()=>{Q.dispose()}};X.$registerTestController(M,O,!!U),Q.add((0,$.$Rc)(()=>X.$unregisterTestController(M)));const x={controller:le,collection:ue,profiles:Z,extension:j,activeProfiles:J};return this.g.set(M,x),Q.add((0,$.$Rc)(()=>this.g.delete(M))),Q.add(ue.onDidGenerateDiff(be=>X.$publishDiff(M,be.map(n.TestsDiffOp.serialize)))),le}createTestObserver(){return this.m.checkout()}async runTests(j,M=g.CancellationToken.None){const O=l(j);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.g.get(O.controllerId);if(!U)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(Q=>i.$2J.fromExtHostTestItem(Q,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:z[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:j.exclude?.map(Q=>Q.id)},M)}$syncTests(){for(const{collection:j}of this.g.values())j.flushDiff();return Promise.resolve()}async $provideFileCoverage(j,M,O){return await this.j.getCoverageReport(j,M)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(j,M,O,U){return await this.j.getCoverageReport(j,M)?.resolveFileCoverage(O,U)??[]}$configureRunProfile(j,M){this.g.get(j)?.profiles.get(M)?.configureHandler?.()}$setDefaultRunProfiles(j){const M=new Map;for(const[O,U]of Object.entries(j)){const Q=this.g.get(O);if(!Q)continue;const ue=new Map,Z=U.filter(X=>!Q.activeProfiles.has(X)),J=[...Q.activeProfiles].filter(X=>!U.includes(X));for(const X of Z)ue.set(X,!0),Q.activeProfiles.add(X);for(const X of J)ue.set(X,!1),Q.activeProfiles.delete(X);ue.size&&M.set(O,ue)}this.s.fire(M)}async $refreshTests(j,M){await this.g.get(j)?.controller.refreshHandler?.(M)}$publishTestResults(j){this.results=Object.freeze(j.map(M=>(0,y.$wn)(f.TestResults.to(M))).concat(this.results).sort((M,O)=>O.completedAt-M.completedAt).slice(0,32)),this.f.fire()}async $expandTest(j,M){const O=this.g.get(i.$2J.fromString(j).controllerId)?.collection;O&&(await O.expand(j,M<0?1/0:M),O.flushDiff())}$acceptDiff(j){this.m.applyDiff(j.map(M=>n.TestsDiffOp.deserialize({asCanonicalUri:O=>O},M)))}async $runControllerTests(j,M){return Promise.all(j.map(O=>this.y(O,!1,M)))}async $startContinuousRun(j,M){const O=new g.$6d(M),U=await Promise.all(j.map(Q=>this.y(Q,!0,O.token)));return!M.isCancellationRequested&&!U.some(Q=>Q.error)&&await new Promise(Q=>M.onCancellationRequested(Q)),O.dispose(!0),U}async y(j,M,O){const U=this.g.get(j.controllerId);if(!U)return{};const{collection:Q,profiles:ue,extension:Z}=U,J=ue.get(j.profileId);if(!J)return{};const X=j.testIds.map(ce=>Q.tree.get(ce)).filter(L.$Qf),le=j.excludeExtIds.map(ce=>U.collection.tree.get(ce)).filter(L.$Qf).filter(ce=>X.some(G=>G.fullId.compare(ce.fullId)===2));if(!X.length)return{};const x=new o.$IM(X.some(ce=>ce.actual instanceof d.$pN)?void 0:X.map(ce=>ce.actual),le.map(ce=>ce.actual),J,M),be=(0,n.$4J)(j)&&this.j.prepareForMainThreadTestRun(x,k.fromInternal(j,U.collection),Z,O);try{return await J.runHandler(x,O),{}}catch(ce){return{error:String(ce)}}finally{be&&(be.hasRunningTasks&&!O.isCancellationRequested&&await I.Event.toPromise(be.onEnd),be.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.j.cancelAllRuns():this.j.cancelRunById(j)}};e.$eic=t,e.$eic=t=Ge([Ve(0,S.$bN),Ve(1,m.$nj)],t);const a=1e4;var r;(function(F){F[F.Running=0]="Running",F[F.Cancelling=1]="Cancelling",F[F.Ended=2]="Ended"})(r||(r={}));class h extends $.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(j,M,O,U,Q){super(),this.s=j,this.w=M,this.y=O,this.z=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.$Vd),this.m=this.B(new I.$Vd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new g.$6d(Q));const ue=this.B(new D.$fh(()=>this.C(),a));this.B(this.h.token.onCancellationRequested(()=>ue.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(j){const M=this.s.id,O=this.s.controllerId,U=(0,C.$qg)(),Q=this.y,ue=this.m;let Z;const J=be=>(ce,...G)=>{if(le){this.z.warn(`Setting the state of test "${ce.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ce)&&(this.F(ce),be(ce,...G))},X=(be,ce)=>{const G=ce instanceof Array?ce.map(f.TestMessage.from):[f.TestMessage.from(ce)];if(be.uri&&be.range){const W={range:f.Range.from(be.range),uri:be.uri};for(const ne of G)ne.location=ne.location||W}this.w.$appendTestMessagesInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),G)};let le=!1;const x={isPersisted:this.s.isPersisted,token:this.h.token,name:j,get coverageProvider(){return Z?.provider},set coverageProvider(be){(0,c.$GF)(Q,"testCoverage"),Z=be&&new A(be),ue.fire({taskId:U,runId:M,coverage:Z})},enqueued:J(be=>{this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),1)}),skipped:J(be=>{this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),5)}),started:J(be=>{this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),2)}),errored:J((be,ce,G)=>{X(be,ce),this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),6,G)}),failed:J((be,ce,G)=>{X(be,ce),this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,O).toString(),4,G)}),passed:J((be,ce)=>{this.w.$updateTestStateInRun(M,U,i.$2J.fromExtHostTestItem(be,this.s.controllerId).toString(),3,ce)}),appendOutput:(be,ce,G)=>{le||(G&&(this.s.isIncluded(G)?this.F(G):G=void 0),this.w.$appendOutputToRun(M,U,T.$je.fromString(be),ce&&f.location.from(ce),G&&i.$2J.fromExtHostTestItem(G,O).toString()))},end:()=>{le||(le=!0,this.w.$finishedTestRunTask(M,U),this.f.delete(U),this.f.size||this.D())}};return this.f.set(U,{run:x}),this.w.$startedTestRunTask(M,{id:U,name:j,running:!0}),x}C(){for(const{run:j}of this.f.values())j.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(j){if(!(j instanceof d.$oN))throw new s.$6M(j.id);if(this.g.has(i.$2J.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const M=[],O=this.s.colllection.root;for(;;){const U=f.TestItem.from(j);if(M.unshift(U),this.g.has(U.extId)||(this.g.add(U.extId),j===O))break;j=j.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,M)}dispose(){this.D(),super.dispose()}}class u{get trackers(){return this.c.values()}constructor(j,M){this.g=j,this.h=M,this.c=new Map,this.f=[]}getCoverageReport(j,M){return this.f.find(O=>O.runId===j)?.coverage.get(M)}prepareForMainThreadTestRun(j,M,O,U){return this.j(j,M,O,U)}cancelRunById(j){for(const M of this.c.values())if(M.id===j){M.cancel();return}}cancelAllRuns(){for(const j of this.c.values())j.cancel()}createTestRun(j,M,O,U,Q,ue){const Z=this.c.get(U);if(Z)return Z.createRun(Q);const J=k.fromPublic(M,O,U,ue),X=l(U);this.g.$startedExtensionTestRun({controllerId:M,continuous:!!U.continuous,profile:X&&{group:z[X.kind],id:X.profileId},exclude:U.exclude?.map(x=>i.$2J.fromExtHostTestItem(x,O.root.id).toString())??[],id:J.id,include:U.include?.map(x=>i.$2J.fromExtHostTestItem(x,O.root.id).toString())??[O.root.id],persist:ue});const le=this.j(U,J,j);return I.Event.once(le.onEnd)(()=>{this.g.$finishedExtensionTestRun(J.id),le.dispose()}),le.createRun(Q)}j(j,M,O,U){const Q=new h(M,this.g,O,this.h,U);this.c.set(j,Q);let ue;const Z=Q.onDidCoverage(({runId:J,taskId:X,coverage:le})=>{ue||(ue={runId:J,coverage:new Map},this.f.unshift(ue),this.f.length>n.$9J&&this.f.pop()),ue.coverage.set(X,le),this.g.$signalCoverageAvailable(J,X,!!le)});return I.Event.once(Q.onEnd)(()=>{this.c.delete(j),Z.dispose()}),Q}}e.$fic=u;const l=F=>{if(F.profile){if(!(F.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return F.profile}};class k{static fromPublic(j,M,O,U){return new k(j,(0,C.$qg)(),O.include?.map(Q=>i.$2J.fromExtHostTestItem(Q,j).toString())??[j],O.exclude?.map(Q=>i.$2J.fromExtHostTestItem(Q,j).toString())??[],U,M)}static fromInternal(j,M){return new k(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,M)}constructor(j,M,O,U,Q,ue){this.controllerId=j,this.id=M,this.isPersisted=Q,this.colllection=ue,this.c=O.map(Z=>Z+"\0"),this.f=U.map(Z=>Z+"\0")}isIncluded(j){const M=i.$2J.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const O of this.f)if(M===O||M.startsWith(O))return!1;for(const O of this.c)if(M===O||M.startsWith(O))return!0;return!1}}e.$gic=k;class A{constructor(j){this.provider=j}async provideFileCoverage(j){this.c||(this.c=(async()=>this.provider.provideFileCoverage(j))());try{return(await this.c)?.map(f.TestCoverage.fromFile)??[]}catch(M){throw this.c=void 0,M}}async resolveFileCoverage(j,M){const O=await this.c;let U=O?.[j];return!this.provider||!O||!U?[]:(U.detailedCoverage||(U=O[j]=await this.provider.resolveFileCoverage?.(U,M)??U),U.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(j){this.j=j,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(j){this.c.add(j)}update(j){Object.assign(j.revived,f.TestItem.toPlain(j.item)),this.c.has(j)||this.f.add(j)}remove(j){if(this.c.has(j)){this.c.delete(j);return}this.f.delete(j);const M=i.$2J.parentId(j.item.extId);if(M&&this.h.has(M.toString())){this.h.add(j.item.extId);return}this.g.add(j)}getChangeEvent(){const{c:j,f:M,g:O}=this;return{get added(){return[...j].map(U=>U.revived)},get updated(){return[...M].map(U=>U.revived)},get removed(){return[...O].map(U=>U.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends n.$0J{constructor(){super(...arguments),this.s=new I.$Vd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(j){return this.f.get(j)}getMirroredTestDataByReference(j){return this.f.get(j.id)}w(j,M){return{...j,revived:f.TestItem.toPlain(j.item),depth:M?M.depth+1:0,children:new Set}}v(){return new v(this.s)}}class E{constructor(j){this.f=j}checkout(){this.c||(this.c=this.g());const j=this.c;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(M=>M.revived)},dispose:(0,R.$db)(()=>{--j.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(j){return this.c?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.c?.tests.apply(j)}g(){const j=new w({asCanonicalUri:M=>M});return this.f.$subscribeToDiffs(),{observers:0,tests:j}}}const P=(F,j,M,O)=>{M?Object.assign(M,O):j.$updateTestRunConfig(F.controllerId,F.profileId,O)};class N{#e;#t;#i;#o;#n;#r;get label(){return this.f}set label(j){j!==this.f&&(this.f=j,P(this,this.#e,this.#n,{label:j}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(j){j!==this.g&&(this.g=j,P(this,this.#e,this.#n,{supportsContinuousRun:j}))}get isDefault(){return this.#i.has(this.profileId)}set isDefault(j){j!==this.isDefault&&(j?this.#i.add(this.profileId):this.#i.delete(this.profileId),P(this,this.#e,this.#n,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,P(this,this.#e,this.#n,{tag:j?f.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.c}set configureHandler(j){j!==this.c&&(this.c=j,P(this,this.#e,this.#n,{hasConfigurationHandler:!!j}))}get onDidChangeDefault(){return(0,c.$GF)(this.#t,"testingActiveProfile"),I.Event.chain(this.#o,j=>j.map(M=>M.get(this.controllerId)?.get(this.profileId)).filter(L.$Qf))}constructor(j,M,O,U,Q,ue,Z,J,X,le,x=!1,be=void 0,ce=!1){this.controllerId=ue,this.profileId=Z,this.f=J,this.kind=X,this.runHandler=le,this._tag=be,this.g=ce,this.#e=j,this.#r=M,this.#t=O,this.#i=U,this.#o=Q,M.set(Z,this);const G=z[X];if(typeof G!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);x&&U.add(Z),this.#n={profileId:Z,controllerId:ue,tag:be?f.TestTag.namespace(this.controllerId,be.id):null,label:J,group:G,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:ce},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$hic=N;const z={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(ke[151],Se([1,0,60,14,121,15,7]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.$iN=void 0;class b{static{this.c=new g.$gN("TextEditorDecorationType")}constructor(m,p,S){const d=b.c.nextId();m.$registerTextEditorDecorationType(p.identifier,d,I.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:d,dispose(){m.$removeTextEditorDecorationType(d)}})}}e.$iN=b;class ${constructor(m,p){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,p){this.k();let S=null;if(m instanceof R.$aL)S=new R.$bL(m,m);else if(m instanceof R.$bL)S=m;else throw new Error("Unrecognized location");this.l(S,p,!1)}insert(m,p){this.k(),this.l(new R.$bL(m,m),p,!0)}delete(m){this.k();let p=null;if(m instanceof R.$bL)p=m;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(m,p,S){const d=this.c.validateRange(m);this.g.push({range:d,text:p,forceMoveMarkers:S})}setEndOfLine(m){if(this.k(),m!==R.EndOfLine.LF&&m!==R.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=m}}class y{constructor(m,p,S,d){this.c=m,this.d=p,this._accept(S),this.e=d;const f=this;this.value={get tabSize(){return f.f},set tabSize(o){f.n(o)},get indentSize(){return f.g},set indentSize(o){f.p(o)},get insertSpaces(){return f.j},set insertSpaces(o){f.s(o)},get cursorStyle(){return f.k},set cursorStyle(o){f.t(o)},get lineNumbers(){return f.l},set lineNumbers(o){f.u(o)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=I.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const p=Math.floor(m);return p>0?p:null}if(typeof m=="string"){const p=parseInt(m,10);return isNaN(p)?null:p>0?p:null}return null}n(m){const p=this.m(m);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const p=Math.floor(m);return p>0?p:null}if(typeof m=="string"){const p=parseInt(m,10);return isNaN(p)?null:p>0?p:null}return null}p(m){const p=this.o(m);if(p!==null){if(typeof p=="number"){if(this.h===p)return;this.g=p,this.h=p}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const p=this.q(m);if(typeof p=="boolean"){if(this.j===p)return;this.j=p}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:I.TextEditorLineNumbersStyle.from(m)})))}assign(m){const p={};let S=!1;if(typeof m.tabSize<"u"){const d=this.m(m.tabSize);d==="auto"?(S=!0,p.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,S=!0,p.tabSize=d)}if(typeof m.indentSize<"u"){const d=this.o(m.indentSize);d==="tabSize"?(S=!0,p.indentSize=d):typeof d=="number"&&this.h!==d&&(this.g=d,this.h=d,S=!0,p.indentSize=d)}if(typeof m.insertSpaces<"u"){const d=this.q(m.insertSpaces);d==="auto"?(S=!0,p.insertSpaces=d):this.j!==d&&(this.j=d,S=!0,p.insertSpaces=d)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,S=!0,p.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,S=!0,p.lineNumbers=I.TextEditorLineNumbersStyle.from(m.lineNumbers)),S&&this.v("setOptions",this.c.$trySetOptions(this.d,p))}v(m,p){p.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(S)})}}e.$jN=y;class L{constructor(m,p,S,d,f,o,i,s){this.id=m,this.j=p,this.k=S,this.g=!1,this.h=new Set,this.c=f,this.d=new y(this.j,this.id,o,S),this.e=i,this.f=s;const n=this;this.value=Object.freeze({get document(){return d.value},set document(c){throw new T.$9("document")},get selection(){return n.c&&n.c[0]},set selection(c){if(!(c instanceof R.$cL))throw(0,T.$7)("selection");n.c=[c],n.l()},get selections(){return n.c},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof R.$cL)))throw(0,T.$7)("selections");n.c=c,n.l()},get visibleRanges(){return n.e},set visibleRanges(c){throw new T.$9("visibleRanges")},get options(){return n.d.value},set options(c){n.g||n.d.assign(c)},get viewColumn(){return n.f},set viewColumn(c){throw new T.$9("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new $(d.value,t);return c(a),n.m(a)},insertSnippet(c,t,a={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=n.c.map(h=>I.Range.from(h));else if(t instanceof R.$aL){const{lineNumber:h,column:u}=I.Position.from(t);r=[{startLineNumber:h,startColumn:u,endLineNumber:h,endColumn:u}]}else if(t instanceof R.$bL)r=[I.Range.from(t)];else{r=[];for(const h of t)if(h instanceof R.$bL)r.push(I.Range.from(h));else{const{lineNumber:u,column:l}=I.Position.from(h);r.push({startLineNumber:u,startColumn:l,endLineNumber:u,endColumn:l})}}return p.$tryInsertSnippet(m,d.value.version,c.value,r,a)},setDecorations(c,t){const a=t.length===0;a&&!n.h.has(c.key)||(a?n.h.delete(c.key):n.h.add(c.key),n.n(()=>{if(I.$$M(t))return p.$trySetDecorations(m,c.key,I.$_M(t));{const r=new Array(4*t.length);for(let h=0,u=t.length;h<u;h++){const l=t[h];r[4*h]=l.start.line+1,r[4*h+1]=l.start.character+1,r[4*h+2]=l.end.line+1,r[4*h+3]=l.end.character+1}return p.$trySetDecorationsFast(m,c.key,r)}}))},revealRange(c,t){n.n(()=>p.$tryRevealRange(m,I.Range.from(c),t||R.TextEditorRevealType.Default))},show(c){p.$tryShowEditor(m,I.ViewColumn.from(c))},hide(){p.$tryHideEditor(m)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,D.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,D.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,D.ok)(!this.g),this.f=m}_acceptSelections(m){(0,D.ok)(!this.g),this.c=m}async l(){const m=this.c.map(I.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const p=m.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const S=p.edits.map(f=>f.range);S.sort((f,o)=>f.end.line===o.end.line?f.end.character===o.end.character?f.start.line===o.start.line?f.start.character-o.start.character:f.start.line-o.start.line:f.end.character-o.end.character:f.end.line-o.end.line);for(let f=0,o=S.length-1;f<o;f++){const i=S[f].end;if(S[f+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=p.edits.map(f=>({range:I.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,d,{setEndOfLine:typeof p.setEndOfLine=="number"?I.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$kN=L}),define(ke[72],Se([1,0,60,4,3,2,5,6,148,20,151,15,13,28,16,53,43]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=void 0;class o{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(n,c){this.h=n,this.i=c,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new T.$Vd,this.e=new T.$Vd,this.f=new T.$Vd,this.g=new T.$Vd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const c=[],t=[],a=[];if(n.removedDocuments)for(const r of n.removedDocuments){const h=I.URI.revive(r),u=this.c.get(h);u?.unref()&&(this.c.delete(h),c.push(u.value))}if(n.addedDocuments)for(const r of n.addedDocuments){const h=I.URI.revive(r.uri);let u=this.c.get(h);if(u&&h.scheme!==S.Schemas.vscodeNotebookCell&&h.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);u||(u=new o(new $.$eN(this.h.getProxy(b.$0K.MainThreadDocuments),h,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(h,u),t.push(u.value)),u.ref()}if(n.removedEditors)for(const r of n.removedEditors){const h=this.b.get(r);this.b.delete(r),h&&a.push(h)}if(n.addedEditors)for(const r of n.addedEditors){const h=I.URI.revive(r.documentUri);D.ok(this.c.has(h),`document '${h}' does not exist`),D.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const u=this.c.get(h).value,l=new L.$kN(r.id,this.h.getProxy(b.$0K.MainThreadTextEditors),this.i,new f.$V(()=>u.document),r.selections.map(C.Selection.to),r.options,r.visibleRanges.map(k=>C.Range.to(k)),typeof r.editorPosition=="number"?C.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,l)}n.newActiveEditor!==void 0&&(D.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,g.$Oc)(c),(0,g.$Oc)(a),n.removedDocuments&&this.e.fire(c),n.addedDocuments&&this.d.fire(t),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return d.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const c=this.b.get(this.a);return n?c:c?.value}allEditors(){return[...this.b.values()]}};e.$lN=i,e.$lN=i=Ge([Ve(0,y.$bN),Ve(1,m.$nj)],i),e.$mN=(0,R.$6h)("IExtHostDocumentsAndEditors")}),define(ke[345],Se([1,0,19,4,6,151,15,7]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class ${constructor(L,C){this.i=C,this.a=new T.$Vd,this.b=new T.$Vd,this.c=new T.$Vd,this.d=new T.$Vd,this.f=new T.$Vd,this.g=new T.$Vd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(g.$0K.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const C=this.i.allEditors();return L?C:C.map(m=>m.value)}async showTextDocument(L,C,m){let p;typeof C=="number"?p={position:R.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?p={position:R.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?R.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:p={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(L.uri,p),d=S&&this.i.getEditor(S);if(d)return d.value;throw S?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,C){return new I.$iN(this.h,L,C).value}$acceptEditorPropertiesChanged(L,C){const m=this.i.getEditor(L);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const p=C.selections.selections.map(R.Selection.to);m._acceptSelections(p)}if(C.visibleRanges){const p=D.$Hb(C.visibleRanges.map(R.Range.to));m._acceptVisibleRanges(p)}if(C.options&&this.b.fire({textEditor:m.value,options:{...C.options,lineNumbers:R.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const p=b.TextEditorSelectionChangeKind.fromValue(C.selections.source),S=C.selections.selections.map(R.Selection.to);this.a.fire({textEditor:m.value,selections:S,kind:p})}if(C.visibleRanges){const p=D.$Hb(C.visibleRanges.map(R.Range.to));this.c.fire({textEditor:m.value,visibleRanges:p})}}$acceptEditorPositionData(L){for(const C in L){const m=this.i.getEditor(C);if(!m)throw new Error("Unknown text editor");const p=R.ViewColumn.to(L[C]);m.value.viewColumn!==p&&(m._acceptViewColumn(p),this.d.fire({textEditor:m.value,viewColumn:p}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.$Dgc=$}),define(ke[346],Se([1,0,2,5,6,3,7,15,26,18]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=e.$jic=void 0,e.$jic=(0,T.$6h)("IExtHostTimeline");class L{constructor(p,S){this.b=new Map,this.c=new Map,this.a=p.getProxy(g.$0K.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(d,f)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&$.$lm.equals(f,this.b.get(d.source)?.extension)){const o=d.uri===void 0?void 0:D.URI.revive(d.uri);return this.c.get(d.source)?.get(C(o))?.get(d.handle)}else return;return d}})}async $getTimeline(p,S,d,f){return this.b.get(p)?.provider.provideTimeline(D.URI.revive(S),d,f)}registerTimelineProvider(p,S,d,f){const o=new I.$Sc,i=this.d(S.id,f,o).bind(this);let s;S.onDidChange&&(s=S.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:S.id}),this));const n=this.c;return this.f({...S,scheme:p,onDidChange:void 0,async provideTimeline(c,t,a){t?.resetCache&&(o.clear(),n.get(S.id)?.clear());const r=await S.provideTimeline(c,t,a);if(r==null)return;const h=i(c,t);return{...r,source:S.id,items:r.items.map(h)}},dispose(){for(const c of n.values())c.get(S.id)?.clear();s?.dispose(),o.dispose()}},d)}d(p,S,d){return(f,o)=>{let i;if(o?.cacheResults){let s=this.c.get(p);s===void 0&&(s=new Map,this.c.set(p,s));const n=C(f);i=s.get(n),i===void 0&&(i=new Map,s.set(n,i))}return s=>{const{iconPath:n,...c}=s,t=`${p}|${s.id??s.timestamp}`;i?.set(t,s);let a,r,h;s.iconPath&&(n instanceof R.$7L?h={id:n.id,color:n.color}:D.URI.isUri(n)?(a=n,r=n):{light:a,dark:r}=n);let u;return R.$AL.isMarkdownString(c.tooltip)?u=b.MarkdownString.from(c.tooltip):(0,y.$If)(c.tooltip)?u=c.tooltip:R.$AL.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=b.MarkdownString.from(c.detail)):(0,y.$If)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=c.detail),{...c,id:c.id??void 0,handle:t,source:p,command:s.command?S.toInternal(s.command,d):void 0,icon:a,iconDark:r,themeIcon:h,tooltip:u,accessibilityInformation:s.accessibilityInformation}}}}f(p,S){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:S}),(0,I.$Rc)(()=>{for(const f of this.c.values())f.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$kic=L;function C(m){return m?.toString()}}),define(ke[347],Se([1,0,219,23,2,4,3,278,11,7,18,19,15,80,21,177,25]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;function o(n,c){if((0,L.$If)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let t;return Array.isArray(n.highlights)&&(t=n.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),t=t.length?t:void 0),{label:n.label,highlights:t}}}class i extends R.$Tc{constructor(c,t,a){super(),this.f=c,this.g=t,this.h=a,this.a=new Map,this.b=new d.$n8;function r(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:h=>r(h)?this.r(h):Array.isArray(h)&&h.length>0?h.map(u=>r(u)?this.r(u):u):h})}registerTreeDataProvider(c,t,a){const r=this.createTreeView(c,{treeDataProvider:t},a);return{dispose:()=>r.dispose()}}createTreeView(c,t,a){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],h=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,k=this.m(c,t,a),A={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:h,hasHandleDrag:u,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(c,A),w={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,f.$GF)(a,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,f.$GF)(a,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(E){(0,p.$jk)(E)&&(0,f.$GF)(a,"treeViewMarkdownMessage"),k.message=E},get title(){return k.title},set title(E){k.title=E},get description(){return k.description},set description(E){k.description=E},get badge(){return k.badge},set badge(E){E!==void 0&&y.ViewBadge.isViewBadge(E)?k.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(k.badge=void 0)},reveal:(E,P)=>k.reveal(E,P),dispose:async()=>{await v,this.a.delete(c),k.dispose()}};return this.B(w),w}$getChildren(c,t){const a=this.a.get(c);return a?a.getChildren(t):Promise.reject(new b.$aF(c))}async $handleDrop(c,t,a,r,h,u,l,k){const A=this.a.get(c);if(!A)return Promise.reject(new b.$aF(c));const v=m.DataTransfer.toDataTransfer(a,async w=>(await this.f.$resolveDropFileData(c,t,w)).buffer);return l===c&&k&&await this.j(v,A,k,h,u),A.onDrop(v,r,h)}async j(c,t,a,r,h){const u=this.b.removeDragOperationTransfer(h);if(u)(await u)?.forEach((l,k)=>{l&&c.set(k,l)});else if(h&&t.handleDrag){const l=t.handleDrag(a,c,r);this.b.addDragOperationTransfer(h,l),await l}return c}async $handleDrag(c,t,a,r){const h=this.a.get(c);if(!h)return Promise.reject(new b.$aF(c));const u=await this.j(new y.$4L,h,t,r,a);if(!(!u||r.isCancellationRequested))return m.DataTransfer.from(u)}async $hasResolve(c){const t=this.a.get(c);if(!t)throw new b.$aF(c);return t.hasResolve}$resolve(c,t,a){const r=this.a.get(c);if(!r)throw new b.$aF(c);return r.resolveTreeItem(t,a)}$setExpanded(c,t,a){const r=this.a.get(c);if(!r)throw new b.$aF(c);r.setExpanded(t,a)}$setSelectionAndFocus(c,t,a){const r=this.a.get(c);if(!r)throw new b.$aF(c);r.setSelectionAndFocus(t,a)}$setVisible(c,t){const a=this.a.get(c);if(!a){if(!t)return;throw new b.$aF(c)}a.setVisible(t)}$changeCheckboxState(c,t){const a=this.a.get(c);if(!a)throw new b.$aF(c);a.setCheckboxState(t)}m(c,t,a){const r=this.B(new s(c,t,this.f,this.g.converter,this.h,a));return this.a.set(c,r),r}r(c){const t=this.a.get(c.$treeViewId);return t&&"$treeItemHandle"in c?t.getExtensionElement(c.$treeItemHandle):t&&"$focusedTreeItem"in c&&c.$focusedTreeItem?t.focusedElement:null}}e.$lic=i;class s extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(c=>this.getExtensionElement(c)).filter(c=>!(0,L.$Rf)(c))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(c,t,a,r,h,u){if(super(),this.I=c,this.J=a,this.L=r,this.M=h,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new I.$Vd),this.onDidExpandElement=this.u.event,this.w=this.B(new I.$Vd),this.onDidCollapseElement=this.w.event,this.y=this.B(new I.$Vd),this.onDidChangeSelection=this.y.event,this.z=this.B(new I.$Vd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new I.$Vd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new I.$Vd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new I.$Vd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$6d,u.contributes&&u.contributes.views)for(const v in u.contributes.views)for(const w of u.contributes.views[v])w.id===c&&(this.P=w.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let l,k;const A=I.Event.debounce(this.F.event,(v,w)=>(v||(v={message:!1,elements:[]}),w.element!==!1&&(l||(l=new Promise(E=>k=E),this.G=this.G.then(()=>l)),Array.isArray(w.element)?v.elements.push(...w.element):v.elements.push(w.element)),w.message&&(v.message=!0),v),200,!0);this.B(A(({message:v,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const E=k;return l=null,this.$(w).then(()=>E())})),v&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(c){const t=c?this.getExtensionElement(c):void 0;if(c&&!t)return this.M.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let a=this.X(c);return a||(a=await this.Y(t)),a?a.map(r=>r.item):void 0}getExtensionElement(c){return this.j.get(c)}reveal(c,t){t=t||{select:!0,focus:!1};const a=(0,L.$Rf)(t.select)?!0:t.select,r=(0,L.$Rf)(t.focus)?!1:t.focus,h=(0,L.$Rf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.G.then(()=>this.S(c)).then(u=>this.W(c,u[u.length-1]).then(l=>this.J.$reveal(this.I,{item:l.item,parentChain:u.map(k=>k.item)},{select:a,focus:r,expand:h})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:a,focus:r,expand:h})}get message(){return this.O}set message(c){this.O=c,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(c){this.P=c,this.J.$setTitle(this.I,c,this.Q)}get description(){return this.Q}set description(c){this.Q=c,this.J.$setTitle(this.I,this.P,c)}get badge(){return this.R}set badge(c){this.R?.value===c?.value&&this.R?.tooltip===c?.tooltip||(this.R=m.ViewBadge.from(c),this.J.$setBadge(this.I,c))}setExpanded(c,t){const a=this.getExtensionElement(c);a&&(t?this.u.fire(Object.freeze({element:a})):this.w.fire(Object.freeze({element:a})))}setSelectionAndFocus(c,t){const a=!(0,C.$ub)(this.s,c);this.s=c;const r=this.t!==t;this.t=t,a&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(c){c!==this.r&&(this.r=c,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(c){const t=(await Promise.all(c.map(async a=>{const r=this.getExtensionElement(a.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:a.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);t.forEach(a=>{a.treeItem.checkboxState=a.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(a=>[a.extensionItem,a.newState])})}async handleDrag(c,t,a){const r=[];for(const h of c){const u=this.getExtensionElement(h);u&&r.push(u)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,a),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(c,t,a){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,$.$Yg)(()=>this.g?.handleDrop?this.g.handleDrop(r,c,a):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(c,t){if(!this.f.resolveTreeItem)return;const a=this.j.get(c);if(a){const r=this.m.get(a);if(r){const h=await this.f.resolveTreeItem(r.extensionItem,a,t)??r.extensionItem;return this.hb(h),r.item.tooltip=this.eb(h.tooltip),r.item.command=this.fb(r.disposableStore,h.command),r.item}}}S(c){return this.U(c).then(t=>t?this.S(t).then(a=>this.W(t,a[a.length-1]).then(r=>(a.push(r),a))):Promise.resolve([]))}U(c){const t=this.m.get(c);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Yg)(()=>this.f.getParent(c))}W(c,t){const a=this.m.get(c);return a?Promise.resolve(a):(0,$.$Yg)(()=>this.f.getTreeItem(c)).then(r=>this.kb(c,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const h=this.getExtensionElement(r);if(h){const u=this.m.get(h);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(c){if(c){let t;if(typeof c=="string"){const a=this.getExtensionElement(c);t=a?this.m.get(a):void 0}else t=c;return t&&t.children||void 0}return this.h}async Y(c){this.rb(c);const t=new S.$6d(this.Z.token);try{const a=c?this.m.get(c):void 0,r=await this.f.getChildren(c);if(t.token.isCancellationRequested)return;const h=(0,C.$Hb)(r||[]),u=await Promise.all((0,C.$Hb)(h).map(k=>this.f.getTreeItem(k)));if(t.token.isCancellationRequested)return;const l=u.map((k,A)=>k?this.db(h[A],k,a):null);return(0,C.$Hb)(l)}finally{t.dispose()}}$(c){if(c.some(a=>!a))return this.Z.dispose(!0),this.Z=new S.$6d,this.tb(),this.J.$refresh(this.I);{const a=this.ab(c);if(a.length)return this.bb(a)}return Promise.resolve(void 0)}ab(c){const t=new Set,a=c.map(h=>this.m.get(h));for(const h of a)if(h&&!t.has(h.item.handle)){let u=h;for(;u&&u.parent&&a.findIndex(l=>u&&u.parent&&l&&l.item.handle===u.parent.item.handle)===-1;){const l=this.j.get(u.parent.item.handle);u=l?this.m.get(l):void 0}u&&!u.parent&&t.add(h.item.handle)}const r=[];return t.forEach(h=>{const u=this.j.get(h);if(u){const l=this.m.get(u);l&&(!l.parent||!t.has(l.parent.item.handle))&&r.push(h)}}),r}bb(c){const t={};return Promise.all(c.map(a=>this.cb(a).then(r=>{r&&(t[a]=r.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(c){const t=this.getExtensionElement(c);if(t){const a=this.m.get(t);if(a)return this.rb(t),(0,$.$Yg)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const h=this.ib(t,r,a.parent);return this.pb(t,h,a,a.parent),a.dispose(),h}return null})}return Promise.resolve(null)}db(c,t,a){const r=this.ib(c,t,a);if(t.id&&this.j.has(r.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(c,r),this.qb(r,a),r}eb(c){return y.$AL.isMarkdownString(c)?m.MarkdownString.from(c):c}fb(c,t){return t?{...this.L.toInternal(t,c),originalId:t.command}:void 0}gb(c){if(c.checkboxState===void 0)return;let t,a,r;return typeof c.checkboxState=="number"?t=c.checkboxState:(t=c.checkboxState.state,a=c.checkboxState.tooltip,r=c.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:a,accessibilityInformation:r}}hb(c){if(!y.$YL.isTreeItem(c,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(c,t,a){this.hb(t);const r=this.B(new R.$Sc),h=this.kb(c,t,a),u=this.lb(t);return{item:{handle:h,parentHandle:a?a.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(r,t.command),contextValue:t.contextValue,icon:u,iconDark:this.mb(t)||u,themeIcon:this.jb(t),collapsibleState:(0,L.$Rf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:a,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(c){return c.iconPath instanceof y.$7L?c.iconPath:void 0}kb(c,{id:t,label:a,resourceUri:r},h,u){if(t)return`${s.b}/${t}`;const l=o(a,this.N),k=h?h.item.handle:s.a;let A=l?l.label:r?(0,T.$Eg)(r):"";A=A.indexOf("/")!==-1?A.replace("/","//"):A;const v=this.m.has(c)?this.m.get(c).item.handle:void 0,w=this.X(h)||[];let E,P=0;do{if(E=`${k}/${P}:${A}`,u||!this.j.has(E)||v===E)break;P++}while(P<=w.length);return E}lb(c){if(c.iconPath&&!(c.iconPath instanceof y.$7L))return typeof c.iconPath=="string"||g.URI.isUri(c.iconPath)?this.nb(c.iconPath):this.nb(c.iconPath.light)}mb(c){if(c.iconPath&&!(c.iconPath instanceof y.$7L)&&c.iconPath.dark)return this.nb(c.iconPath.dark)}nb(c){return g.URI.isUri(c)?c:g.URI.file(c)}ob(c,t){this.j.set(t.item.handle,c),this.m.set(c,t)}pb(c,t,a,r){this.j.delete(t.item.handle),this.m.delete(c),t.item.handle!==a.item.handle&&this.j.delete(a.item.handle),this.ob(c,t);const h=this.X(r)||[],u=h.filter(l=>l.item.handle===a.item.handle)[0];u&&h.splice(h.indexOf(u),1,t)}qb(c,t){t?(t.children||(t.children=[]),t.children.push(c)):(this.h||(this.h=[]),this.h.push(c))}rb(c){if(c){const t=this.m.get(c);if(t){if(t.children)for(const a of t.children){const r=this.j.get(a.item.handle);r&&this.sb(r)}t.children=void 0}}else this.tb()}sb(c){const t=this.m.get(c);if(t){if(t.children)for(const a of t.children){const r=this.j.get(a.item.handle);r&&this.sb(r)}this.m.delete(c),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(c=>c.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[348],Se([1,0,4,3,2,30,15,93,6,7]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class L extends T.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;#h;constructor(S,d,f,o){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Vd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Vd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=d,this.#o=f,this.#i=o.viewType,this.#n=o.panelOptions,this.#s=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(S){this.c(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,g.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#n}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,d){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:R.ViewColumn.from(S),preserveFocus:!!d})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends T.$Tc{static c(){return(0,I.$qg)()}constructor(S,d,f){super(),this.j=d,this.m=f,this.g=new Map,this.h=new Map,this.f=S.getProxy($.$0K.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,d,f,o,i={}){const s=typeof o=="object"?o.viewColumn:o,n={viewColumn:R.ViewColumn.from(s),preserveFocus:typeof o=="object"&&!!o.preserveFocus},c=(0,b.$Sgc)(S),t=C.c();this.f.$createWebviewPanel((0,b.$Ugc)(S),t,d,{title:f,panelOptions:m(i),webviewOptions:(0,b.$Vgc)(S,this.m,i),serializeBuffersForPostMessage:c},n);const a=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,d,f,s,i,a,!0)}$onDidChangeWebviewPanelViewStates(S){const d=Object.keys(S);d.sort((f,o)=>{const i=S[f],s=S[o];return i.active?1:s.active?-1:+i.visible-+s.visible});for(const f of d){const o=this.getWebviewPanel(f);if(!o)continue;const i=S[f];o._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,d,f){if(this.h.has(d))throw new Error(`Serializer for '${d}' already registered`);return this.h.set(d,{serializer:f,extension:S}),this.f.$registerSerializer(d,{serializeBuffersForPostMessage:(0,b.$Sgc)(S)}),new y.$_K(()=>{this.h.delete(d),this.f.$unregisterSerializer(d)})}async $deserializeWebviewPanel(S,d,f,o){const i=this.h.get(d);if(!i)throw new Error(`No serializer found for '${d}'`);const{serializer:s,extension:n}=i,c=this.j.createNewWebview(S,f.webviewOptions,n),t=this.createNewWebviewPanel(S,d,f.title,o,f.panelOptions,c,f.active);await s.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(S,d,f,o,i,s,n){const c=new L(S,this.f,s,{viewType:d,title:f,viewColumn:o,panelOptions:i,active:n});return this.g.set(S,c),c}getWebviewPanel(S){return this.g.get(S)}}e.$Wgc=C;function m(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(ke[349],Se([1,0,4,3,93,15,6,7]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;class $ extends T.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;constructor(C,m,p,S,d,f){super(),this.#n=!1,this.#u=this.B(new D.$Vd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Vd),this.onDidDispose=this.#l.event,this.#i=p,this.#a=S,this.#e=C,this.#t=m,this.#o=d,this.#r=f}dispose(){this.#n||(this.#n=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#s}set description(C){this.a(),this.#s!==C&&(this.#s=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#n||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=I.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#n)throw new Error("Webview is disposed")}}class y{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(R.$0K.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,p,S){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:p,extension:C}),this.a.$registerWebviewViewProvider((0,g.$Ugc)(C),m,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$Sgc)(C)}),new b.$_K(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,p,S,d){const f=this.b.get(m);if(!f)throw new Error(`No view provider found for '${m}'`);const{provider:o,extension:i}=f,s=this.d.createNewWebview(C,{},i),n=new $(C,this.a,m,p,s,!0);this.c.set(C,n),await o.resolveWebviewView(n,{state:S},d)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$oic=y}),define(ke[350],Se([1,0,69,16,13,249,32,10]),function(me,e,D,T,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(T.Schemas.file,new y(m),{isCaseSensitive:b.$k})}};e.$6ic=$,e.$6ic=$=Ge([Ve(0,D.$Ogc),Ve(1,g.$nj)],$);class y{constructor(C){this.b=C,this.a=new I.$Bq(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,p){return this.a.writeFile(C,m,{...p,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,p){return this.a.rename(C,m,p)}copy(C,m,p){return this.a.copy(C,m,p)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(ke[351],Se([1,0,17,63,30,35,3,6,2,20]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;let L=class extends R.$Tc{constructor(m,p){super();const S=m.getProxy(b.$0K.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async d=>{const f=$.URI.file((0,D.$jc)((0,T.tmpdir)(),(0,g.$qg)()));return await S.$download(d,f),f})}};e.$4ic=L,e.$4ic=L=Ge([Ve(0,y.$bN),Ve(1,I.$xN)],L)}),define(ke[352],Se([1,0,56,17,2,94,3,16,11,31]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;class L extends I.$Qgc{constructor(){super(...arguments),this.i=null}async g(t){const a=await super.g(t);if(a.scheme!==b.Schemas.file)return a;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${a.fsPath}.`),a;const r=a.fsPath;let h=0;do{let u;h===0?u=r:u=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${h}`:`${r}-${h}`,await C(u);const l=T.$jc(u,"vscode.lock"),k=await d(this.d,l,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),g.URI.file(u);h++}while(h<10);return a}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$djc=L;async function C(c){try{await y.Promises.stat(c);return}catch{}try{await y.Promises.mkdir(c,{recursive:!0})}catch{}}const m=1e3,p=10*60*1e3;class S extends R.$Tc{constructor(t,a){super(),this.b=t,this.c=a,this.a=this.B(new $.$eh),this.a.cancelAndSet(async()=>{const r=await f(t,a);(!r||r.pid!==process.pid)&&(t.info(`Lock '${a}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(a,new Date,new Date)}catch(h){t.error(h),t.info(`Lock '${a}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const a={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(a),{flag:"w"})}catch(a){this.b.error(a)}}}async function d(c,t,a){try{const h={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(h),{flag:"wx"})}catch(h){c.error(h)}const r=await f(c,t);return!r||r.pid!==process.pid?a?(c.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(c.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),s(c,t)):(c.info(`Lock '${t}': Lock acquired.`),new S(c,t))}async function f(c,t){let a;try{a=await y.Promises.readFile(t)}catch(r){return c.error(r),null}try{return JSON.parse(String(a))}catch(r){return c.error(r),null}}async function o(c,t){let a;try{a=await y.Promises.stat(t)}catch(r){return c.error(r),0}return a.mtime.getTime()}function i(c){try{return process.kill(c,0),!0}catch{return!1}}async function s(c,t){const a=await f(c,t);if(!a)return c.info(`Lock '${t}': Could not read pid of lock holder.`),n(c,t);if(a.willReleaseAt){let k=a.willReleaseAt-Date.now();if(k<5e3){for(k>0?c.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):c.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,$.$7g)(Math.min(100,k)),await o(c,t)===0)return n(c,t);k=a.willReleaseAt-Date.now()}return n(c,t)}}if(!i(a.pid))return c.info(`Lock '${t}': The pid ${a.pid} appears to be gone.`),n(c,t);const r=await o(c,t),h=Date.now()-r;if(h<=p)return c.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null;c.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$7g)(2e3);const u=await o(c,t),l=Date.now()-u;return l<=p?(c.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(c.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),n(c,t))}async function n(c,t){c.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return d(c,t,!0)}}),define(ke[353],Se([1,0,30,20,46,35]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;let R=class extends g.$ahc{constructor($,y){super(!0,$,y)}createTerminal($,y,L){return this.createTerminalFromOptions({name:$,shellPath:y,shellArgs:L})}createTerminalFromOptions($,y){const L=new g.$_gc(this.a,(0,D.$qg)(),$,$.name);return this.f.push(L),L.create($,this.R($,y)),L.value}};e.$yic=R,e.$yic=R=Ge([Ve(0,I.$xN),Ve(1,T.$bN)],R)}),define(ke[354],Se([1,0,4,37,45,5]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$sK=e.OutputChannelUpdateMode=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=void 0,e.$iK="text/x-code-output",e.$jK="output",e.$kK="Log",e.$lK="text/x-code-log-output",e.$mK="log",e.$nK="workbench.panel.output",e.$oK=new g.$kj("inOutput",!1),e.$pK=new g.$kj("activeLogOutput",!1),e.$qK=new g.$kj("outputView.scrollLock",!1),e.$rK=(0,I.$6h)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$sK={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new D.$Vd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Vd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(L=>y.push(L)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}T.$Hn.add(e.$sK.OutputChannels,new b),e.$tK=new g.$kj("activeOutputChannel","")}),define(ke[152],Se([1,0,6,5,20,26,13,354,69,27,58,182,22,18,32,4,3]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=void 0;class o extends R.$tj{get disposed(){return this.n}constructor(c,t,a,r,h){super(),this.id=c,this.name=t,this.r=a,this.s=r,this.extension=h,this.m=0,this.n=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(c){this.append(c+`
`)}append(c){this.info(c)}clear(){const c=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,c)}replace(c){const t=this.m;this.info(c),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(c,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof c=="boolean"?c:t))}hide(){this.s.$close(this.id)}g(c,t){this.m+=m.$je.fromString(t).byteLength,(0,R.log)(this.r,c,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(c){this.append(c)}}let s=class{constructor(c,t,a,r,h,u){this.i=t,this.j=a,this.k=r,this.l=h,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=c.getProxy(D.$0K.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.h=c;for(const[t,a]of this.g)a.visible=t===this.h}createOutputChannel(c,t,a){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,h=(0,p.$If)(t)?t:void 0;if((0,p.$If)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const l=this.i.environment.extensionLogLevel?.find(([A])=>I.$lm.equals(a.identifier,A))?.[1];l&&(u=(0,R.$Dj)(l));const k=r?this.o(c,u,a):this.n(c,h,a);return k.then(A=>{this.g.set(A.id,A),A.visible=A.id===this.h}),r?this.r(c,u??this.m.getLevel(),k):this.q(c,k)}async n(c,t,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,h=this.k.extUri.joinPath(r,`${this.f++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(c,h,t,a.identifier.value);return new o(l,c,u,this.a,a)}async o(c,t,a){const r=await this.p(a),h=c.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(r,`${h}.log`),l=`${a.identifier.value}.${h}`,k=this.l.createLogger(u,{id:l,name:c,logLevel:t,extensionId:a.identifier.value});return new i(l,c,k,this.a,a)}p(c){let t=this.d.get(c.identifier.value);if(!t){const a=this.k.extUri.joinPath(this.i.logsLocation,c.identifier.value);this.d.set(c.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(a)}catch(r){if((0,S.$Gk)(r)!==S.FileSystemProviderErrorCode.FileExists)throw r}return a})())}return t}q(c,t){let a=!1;const r=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return c},append(h){r(),t.then(u=>u.append(h))},appendLine(h){r(),t.then(u=>u.appendLine(h))},clear(){r(),t.then(h=>h.clear())},replace(h){r(),t.then(u=>u.replace(h))},show(h,u){r(),t.then(l=>l.show(h,u))},hide(){r(),t.then(h=>h.hide())},dispose(){a=!0,t.then(h=>h.dispose())}}}r(c,t,a){const r=new f.$Sc,h=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},u=r.add(new d.$Vd);function l(k){t=k,u.fire(k)}return a.then(k=>{r.add(k),k.logLevel!==t&&l(k.logLevel),r.add(k.onDidChangeLogLevel(A=>l(A)))}),{...this.q(c,a),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(k,...A){h(),a.then(v=>v.trace(k,...A))},debug(k,...A){h(),a.then(v=>v.debug(k,...A))},info(k,...A){h(),a.then(v=>v.info(k,...A))},warn(k,...A){h(),a.then(v=>v.warn(k,...A))},error(k,...A){h(),a.then(v=>v.error(k,...A))},dispose(){r.dispose()}}}};e.$2hc=s,e.$2hc=s=Ge([Ve(0,g.$bN),Ve(1,y.$rN),Ve(2,$.$Ogc),Ve(3,L.$ogc),Ve(4,R.$oj),Ve(5,R.$nj)],s),e.$3hc=(0,T.$6h)("IExtHostOutputService")}),define(ke[153],Se([1,0,5,11]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=void 0,e.$Lm=(0,D.$6h)("remoteAgentService"),e.$Mm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let I=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await g.getRoundTripTime();if($===void 0)return;I=Math.min(I,$/2),await(0,T.$7g)(this.sampleDelay)}this.average.push(I),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(I):R=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:I,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:(()=>typeof R>"u"?!1:I>this.highLatencyMaxThreshold||I>this.highLatencyMinThreshold&&I>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[355],Se([1,0,223,87,37,40,51,3,4,153,10,24]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=void 0,e.$RH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$SH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$TH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$UH=Object.freeze({id:"problems",title:(0,D.localize)(3,null),type:"object",order:101}),e.$VH={ConfigurationMigration:"base.contributions.configuration.migration"};class m{constructor(){this.migrations=[],this.a=new $.$Vd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const p=new m;g.$Hn.add(e.$VH.ConfigurationMigration,p);let S=class extends b.$Tc{constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async s=>{for(const n of s.added)await this.f(n,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(s=>this.c(s)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(s=>this.g(s,o?.uri))])}async g(o,i){const s=this.a.inspect(o.key,{resource:i}),n=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[c,t]of n){const a=[];for(const h of s.overrideIdentifiers??[]){const u=await this.h(o,{resource:i,overrideIdentifier:h},c);for(const l of u??[]){let k=a.find(([[A,v]])=>A===l[0]&&(0,C.$zn)(v.value,l[1].value));k||a.push(k=[l,[]]),k[1].push(h)}}const r=await this.h(o,{resource:i},c,s);for(const h of r??[])a.push([h,[]]);a.length&&await Promise.allSettled(a.map(async([[h,u],l])=>this.a.updateValue(h,u.value,{resource:i,overrideIdentifiers:l},t)))}}async h(o,i,s,n){const c=h=>t(this.a.inspect(h,i)),t=h=>{const u=h[s];return i.overrideIdentifier?u?.override:u?.value},a=n?t(n):c(o.key);if(a===void 0)return;const r=await o.migrateFn(a,c);return Array.isArray(r)?r:[[o.key,r]]}};e.$WH=S,e.$WH=S=Ge([Ve(0,R.$zi),Ve(1,I.$ci)],S);let d=class extends b.$Tc{constructor(o){super(),(async()=>{if(!L.$i&&(await o.getEnvironment())?.os!==1)return;g.$Hn.as(T.$Mn.Configuration).registerConfiguration({...e.$TH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(4,null)},default:[],markdownDescription:(0,D.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(6,null),scope:2}}})})()}};e.$XH=d,e.$XH=d=Ge([Ve(0,y.$Lm)],d)}),define(ke[356],Se([1,0,34,16,17,23,232,355,87,5,37]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdb=e.$idb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$hdb=e.$gdb=void 0,e.$gdb=(0,y.$6h)("editorResolverService"),e.$hdb="workbench.editorAssociations";const C=L.$Hn.as($.$Mn.Configuration),m={...b.$SH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var p;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(p||(e.RegisteredEditorPriority=p={}));var S;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function d(o){switch(o){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$idb=d;function f(o,i){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(i.scheme))return!1;const c=typeof o=="string"&&o.indexOf(g.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,I.$Eg)(i);return D.$Lj(typeof o=="string"?o.toLowerCase():o,c.toLowerCase())}e.$jdb=f}),define(ke[357],Se([1,0,33,16,17,10,23,2,5,267,40,143,153]),function(me,e,D,T,g,I,R,b,$,y,L,C,m){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.$LK=void 0,e.$LK=(0,$.$6h)("pathService");let S=p=class{constructor(f,o,i,s){this.d=f,this.e=o,this.f=i,this.g=s,this.a=(async()=>(await this.e.getEnvironment())?.os||I.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??f})()}hasValidBasename(f,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(s=>this.h(f,s,o)):this.h(f,o,i)}h(f,o,i){return f.scheme===T.Schemas.file||f.scheme===T.Schemas.vscodeRemote?(0,D.$6f)(i??(0,R.$Eg)(f),o===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,o){if(f.remoteAuthority)return T.Schemas.vscodeRemote;const i=(0,y.$IK)(o.getWorkspace());if(i)return i;const s=o.getWorkspace().folders[0];if(s)return s.uri.scheme;const n=o.getWorkspace().configuration;return n?n.scheme:T.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?g.$fc:g.$gc)}async fileURI(f){let o="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const s=f.indexOf("/",2);s===-1?(o=f.substring(2),f="/"):(o=f.substring(2,s),f=f.substring(s)||"/")}return b.URI.from({scheme:T.Schemas.file,authority:o,path:f,query:"",fragment:""})}};e.$MK=S,e.$MK=S=p=Ge([Ve(1,m.$Lm),Ve(2,C.$uK),Ve(3,L.$ci)],S)}),define(ke[358],Se([1,0,234,19,52,4,54,3,2,51,239,13,64,269,89,40,143,25,21,18,24,45]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$EK=e.$DK=e.OnPortForward=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.TunnelSource=e.TunnelCloseReason=e.$xK=e.$wK=e.$vK=void 0;const t=10*1e3,a="remote.tunnels.toRestore";e.$vK="onTunnel",e.$wK=new c.$kj("forwardedPortsViewEnabled",!1,D.localize(0,null));function r(N){const z=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}e.$xK=r;var h;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var u;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(u||(e.TunnelSource=u={})),e.$yK={source:u.User,description:D.localize(1,null)},e.$zK={source:u.Auto,description:D.localize(2,null)};function l(N,z,F){const j=N.get(A(z,F));if(j)return j;if((0,S.$Fv)(z))for(const M of S.$Ev){const O=A(M,F);if(N.has(O))return N.get(O)}else if((0,S.$Hv)(z))for(const M of S.$Gv){const O=A(M,F);if(N.has(O))return N.get(O)}}e.$AK=l;function k(N,z,F){const j=l(N,z,F);if(j)return j;const M=(0,S.$Hv)(z)?"localhost":(0,S.$Fv)(z)?"0.0.0.0":void 0;if(M)return l(N,M,F)}e.$BK=k;function A(N,z){return N+":"+z}e.$CK=A;var v;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(v||(e.OnPortForward=v={}));function w(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$DK=w;class E extends b.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new I.$Vd,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(F=>{(F.affectsConfiguration(E.c)||F.affectsConfiguration(E.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,F,j){let M=this.w(z,F,j,this.j,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const U=this.j[M];U.key===z?(O.onAutoForward=U.onAutoForward??O.onAutoForward,O.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:O.elevateIfNeeded,O.label=U.label??O.label,O.requireLocalPort=U.requireLocalPort,O.protocol=U.protocol):(O.onAutoForward=O.onAutoForward??U.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:U.elevateIfNeeded,O.label=O.label??U.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??U.protocol),M=this.w(z,F,j,this.j,M+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,s.$If)(z.host)&&(0,s.$Mf)(z.port)}w(z,F,j,M,O){if(O>=M.length)return-1;const U=!(0,S.$Fv)(F)&&!(0,S.$Hv)(F),ue=M.slice(O).findIndex(Z=>(0,s.$Mf)(Z.key)?U?!1:Z.key===z:this.t(Z.key)?U?!1:z>=Z.key.start&&z<=Z.key.end:this.u(Z.key)?z===Z.key.port&&F===Z.key.host:j?Z.key.test(j):!1);return ue>=0?ue+O:-1}y(){const z=this.r.getValue(E.c);if(!z||!(0,s.$Kf)(z))return[];const F=[];for(const M in z){if(M===void 0)continue;const O=z[M];let U;if(Number(M))U=Number(M);else if((0,s.$If)(M))if(E.g.test(M)){const Q=M.match(E.g);U={start:Number(Q[1]),end:Number(Q[2])}}else if(E.h.test(M)){const Q=M.match(E.h);U={host:Q[1],port:Number(Q[2])}}else{let Q;try{Q=RegExp(M)}catch{}Q&&(U=Q)}U&&F.push({key:U,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const j=this.r.getValue(E.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(F)}z(z){function F(j,M){return(0,s.$Mf)(j.key)?j.key:M.t(j.key)?j.key.start:M.u(j.key)?j.key.port:Number.MAX_VALUE}return z.sort((j,M)=>F(j,this)-F(M,this))}C(){return this.m}static providedActionToAction(z){switch(z){case S.ProvidedOnAutoForward.Notify:return v.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return v.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return v.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return v.OpenPreview;case S.ProvidedOnAutoForward.Silent:return v.Silent;case S.ProvidedOnAutoForward.Ignore:return v.Ignore;default:return}}async addAttributes(z,F,j){const O=this.r.inspect(E.c).userRemoteValue;let U;!O||!(0,s.$Kf)(O)?U={}:U=(0,n.$vn)(O),U[`${z}`]||(U[`${z}`]={});for(const Q in F)U[`${z}`][Q]=F[Q];return this.r.updateValue(E.c,U,j)}}e.$EK=E;let P=class extends b.$Tc{constructor(z,F,j,M,O,U,Q,ue,Z,J){super(),this.H=z,this.I=F,this.J=j,this.L=M,this.M=O,this.N=U,this.O=Q,this.P=ue,this.Q=Z,this.R=J,this.c=new Map,this.g=new I.$Vd,this.onForwardPort=this.g.event,this.h=new I.$Vd,this.onClosePort=this.h.event,this.j=new I.$Vd,this.onPortName=this.j.event,this.n=new I.$Vd,this.onCandidatesChanged=this.n.event,this.t=new I.$Vd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new I.$Vd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new E(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const le=await this.getAttributes(X.map(x=>({port:x.tunnelRemotePort,host:x.tunnelRemoteHost})));for(const x of X)if(x.localAddress){const be=A(x.tunnelRemoteHost,x.tunnelRemotePort),ce=k(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort);this.forwarded.set(be,{remotePort:x.tunnelRemotePort,remoteHost:x.tunnelRemoteHost,localAddress:x.localAddress,protocol:le?.get(x.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(x.localAddress,le?.get(x.tunnelRemotePort)),localPort:x.tunnelLocalPort,runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,privacy:x.privacy,source:e.$yK}),this.f.set(be,x)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const le=A(X.tunnelRemoteHost,X.tunnelRemotePort);if(!k(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!k(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!k(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const x=k(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),be=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set(le,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:be?.protocol??S.TunnelProtocol.Http,localUri:await this.X(X.localAddress,be),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,privacy:X.privacy,source:e.$yK})}await this.$(),this.f.set(le,X),this.g.fire(this.forwarded.get(le))})),this.B(this.H.onTunnelClosed(X=>this.W(X,h.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$vK))?(this.R.createKey(e.$wK.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,F){const j=A(z.host,z.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(z))}X(z,F){if(z.startsWith("http"))return $.URI.parse(z);const j=F?.protocol??"http";return $.URI.parse(`${j}://${z}`)}async Y(){const z=this.N.getWorkspace(),F=z.configuration?(0,R.$Ti)(z.configuration.path):z.folders.length>0?(0,R.$Ti)(z.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${a}.${this.L.remoteAuthority}.${F}`}async Z(){const z=this.I.get(a,1);if(z)return this.I.remove(a,1),await this.$(),z;const F=await this.Y();if(F)return this.I.get(F,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const F=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(j=>j.remotePort).join(", ")}`);for(const j of F){const M=k(this.detected,j.remoteHost,j.remotePort);j.source.source!==u.Extension&&!M||j.source.source===u.Extension&&M?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===u.Extension&&!M&&this.D.set(A(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Y();this.w=this.B(new b.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async F=>{F.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=JSON.stringify(Array.from(this.forwarded.values()));if(z!==this.y){this.y=z;const F=await this.Y();F&&this.I.store(F,this.y,0,0)}}}async bb(z,F,j){if(!z.tunnelLocalPort||!j?.requireLocalPort||z.tunnelLocalPort===F)return;const M=new Date;if(this.ab.getTime()+t>M.getTime())return;this.ab=M;const O=D.localize(3,null,F,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(O)}async forward(z,F){return!this.z&&this.L.remoteAuthority&&await I.Event.toPromise(this.C.event),this.cb(z,F)}async cb(z,F){await this.Q.activateByEvent(e.$vK);const j=k(this.forwarded,z.remote.host,z.remote.port);F=F??(F!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const M=z.local!==void 0?z.local:z.remote.port;let O;if(j)return this.eb(j,z,F);{const U=this.L.remoteAuthority,Q=U?{getAddress:async()=>(await this.M.resolveAuthority(U)).authority}:void 0,ue=A(z.remote.host,z.remote.port);this.c.set(ue,!0),z=this.db(ue,z);const Z=await this.H.openTunnel(Q,z.remote.host,z.remote.port,void 0,M,z.elevateIfNeeded?z.elevateIfNeeded:F?.elevateIfNeeded,z.privacy,F?.protocol);if(typeof Z=="string")O=Z;else if(Z&&Z.localAddress){const J=k(this.m??new Map,z.remote.host,z.remote.port),X=Z.protocol?Z.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:F?.protocol??S.TunnelProtocol.Http,le={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:F?.label??z.name,closeable:!0,localAddress:Z.localAddress,protocol:X,localUri:await this.X(Z.localAddress,F),runningProcess:J?.detail,hasRunningProcess:!!J,pid:J?.pid,source:z.source??e.$yK,privacy:Z.privacy};return this.forwarded.set(ue,le),this.f.set(ue,Z),this.c.delete(ue),await this.$(),await this.bb(Z,M,F),this.g.fire(le),Z}this.c.delete(ue)}return O}db(z,F){const j=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(j){const M=j.get(z);j.delete(z),M&&(F.name=M.name??F.name,F.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??F.local,F.privacy=M.privacy??F.privacy)}return F}async eb(z,F,j){const M=j?.label??F.name;let O;(function(Q){Q[Q.None=0]="None",Q[Q.Fire=1]="Fire",Q[Q.Reopen=2]="Reopen"})(O||(O={}));let U=O.None;switch(M!==z.name&&(z.name=M,U=O.Fire),(j?.protocol||z.protocol!==S.TunnelProtocol.Http)&&j?.protocol!==z.protocol&&(F.source=z.source,U=O.Reopen),F.privacy&&z.privacy!==F.privacy&&(U=O.Reopen),U){case O.Fire:{this.g.fire();break}case O.Reopen:await this.close(z.remoteHost,z.remotePort,h.User),await this.cb(F,j)}return k(this.f,F.remote.host,F.remote.port)}async name(z,F,j){const M=k(this.forwarded,z,F),O=A(z,F);if(M){M.name=j,await this.$(),this.j.fire({host:z,port:F});return}else this.detected.has(O)&&(this.detected.get(O).name=j,this.j.fire({host:z,port:F}))}async close(z,F,j){const M=A(z,F),O=this.forwarded.get(M);return j===h.AutoForwardEnd&&O&&O.source.source===u.Auto&&this.F.set(M,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.H.closeTunnel(z,F),this.W({host:z,port:F},j)}address(z,F){const j=A(z,F);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const F of z){const j=k(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),M=typeof F.localAddress=="string"?F.localAddress:A(F.localAddress.host,F.localAddress.port);this.detected.set(A(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:M,protocol:S.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:u.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,M,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let F=z;this.r&&(F=await this.r(z));const j=this.fb(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(M=>M.port).join(", ")}`),this.n.fire(j)}fb(z){const F=this.m??new Map,j=new Map;return this.m=j,z.forEach(M=>{const O=A(M.host,M.port);j.set(O,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),F.has(O)&&F.delete(O);const U=k(this.forwarded,M.host,M.port);U&&(U.runningProcess=M.detail,U.hasRunningProcess=!0,U.pid=M.pid)}),F.forEach((M,O)=>{const U=r(O);if(!U)return;const Q=k(this.forwarded,U.host,U.port);Q&&(Q.runningProcess=void 0,Q.hasRunningProcess=!1,Q.pid=void 0);const ue=k(this.detected,U.host,U.port);ue&&(ue.runningProcess=void 0,ue.hasRunningProcess=!1,ue.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const z=Array.from(this.forwarded.values()),F=await this.getAttributes(z.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(F)for(const j of z){const M=F.get(j.remotePort);(M?.protocol||j.protocol!==S.TunnelProtocol.Http)&&M?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},M),M&&M.label&&M.label!==j.name&&await this.name(j.remoteHost,j.remotePort,M.label)}}async getAttributes(z,F=!0){const j=new Map,M=new Map;z.forEach(Z=>{const J=k(this.m??new Map,S.$Ev[0],Z.port)??Z;if(J){j.set(Z.port,J);const X=w(J)?J.pid:void 0;M.has(X)||M.set(X,[]),M.get(X)?.push(Z.port)}});const O=new Map;if(z.forEach(Z=>{const J=this.configPortsAttributes.getAttributes(Z.port,Z.host,j.get(Z.port)?.detail);J&&O.set(Z.port,J)}),this.G.length===0||!F)return O.size>0?O:void 0;const U=await Promise.all((0,T.$Rb)(this.G.map(Z=>Array.from(M.entries()).map(J=>{const X=J[1],le=j.get(X[0]);return Z.providePortAttributes(X,le?.pid,le?.detail,new i.$6d().token)})))),Q=new Map;if(U.forEach(Z=>Z.forEach(J=>{J&&Q.set(J.port,J)})),!O&&!Q)return;const ue=new Map;return z.forEach(Z=>{const J=O.get(Z.port),X=Q.get(Z.port);ue.set(Z.port,{elevateIfNeeded:J?.elevateIfNeeded,label:J?.label,onAutoForward:J?.onAutoForward??E.providedActionToAction(X?.autoForwardAction),requireLocalPort:J?.requireLocalPort,protocol:J?.protocol})}),ue}addAttributesProvider(z){this.G.push(z)}};e.$FK=P,Ge([(0,g.$yh)(1e3)],P.prototype,"$",null),e.$FK=P=Ge([Ve(0,S.$Av),Ve(1,p.$up),Ve(2,y.$zi),Ve(3,f.$uK),Ve(4,m.$8k),Ve(5,d.$ci),Ve(6,C.$nj),Ve(7,L.$6v),Ve(8,o.$CF),Ve(9,c.$lj)],P)}),define(ke[95],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$oJ=e.$nJ=void 0;class D{constructor(R,b){this.line=R,this.character=b}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,b){return new D(0,0)}with(R){return new D(0,0)}}e.$nJ=D;class T{constructor(R,b,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(R,b),this.end=new D($,y)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$oJ=T;var g;(function(I){I[I.Information=1]="Information",I[I.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(ke[36],Se([1,0,19,34,24,33,12,5,17,14,95,11]),function(me,e,D,T,g,I,R,b,$,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.SearchErrorCode=e.$DJ=e.$CJ=e.SearchSortOrder=e.ViewMode=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.SearchCompletionExitCode=e.$xJ=e.$wJ=e.$vJ=e.QueryType=e.SearchProviderType=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$pJ="workbench.view.search",e.$qJ="workbench.panel.search",e.$rJ="workbench.view.search",e.$sJ="search-result",e.$tJ="search.exclude";const m="\u27EA ",p=" characters skipped \u27EB",S=(m.length+p.length+5)*2;e.$uJ=(0,b.$6h)("searchService");var d;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(d||(e.SearchProviderType=d={}));var f;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(f||(e.QueryType=f={}));function o(X){return!!X.preview}e.$vJ=o;function i(X){return!!X.resource}e.$wJ=i;function s(X){return!!X.message}e.$xJ=s;var n;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class c{constructor(le){this.resource=le,this.results=[]}}e.$yJ=c;class t{constructor(le,x,be,ce){this.ranges=x,this.webviewIndex=ce;const G=Array.isArray(x)?x:[x];if(be&&be.matchLines===1&&a(G)){le=(0,R.$Bf)(le,be.matchLines);let W="",ne=0,ye=0;const de=Math.floor(be.charsPerLine/5),ge=[];for(const _ of G){const te=Math.max(_.startColumn-de,0),K=_.startColumn+be.charsPerLine;if(te>ye+de+S){const ie=m+(te-ye)+p;W+=ie+le.slice(te,K),ne+=te-(ye+ie.length)}else W+=le.slice(ye,K);ge.push(new h(0,_.startColumn-ne,_.endColumn-ne)),ye=K}this.preview={text:W,matches:Array.isArray(this.ranges)?ge:ge[0]}}else{const W=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:le,matches:(0,D.$2b)(x,ne=>new r(ne.startLineNumber-W,ne.startColumn,ne.endLineNumber-W,ne.endColumn))}}}}e.$zJ=t;function a(X){const le=X[0].startLineNumber;for(const x of X)if(x.startLineNumber!==le||x.endLineNumber!==le)return!1;return!0}class r{constructor(le,x,be,ce){this.startLineNumber=le,this.startColumn=x,this.endLineNumber=be,this.endColumn=ce}}e.$AJ=r;class h extends r{constructor(le,x,be){super(le,x,le,be)}}e.$BJ=h;var u;(function(X){X.List="list",X.Tree="tree"})(u||(e.ViewMode=u={}));var l;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function k(X,le=!0){const x=X&&X.files&&X.files.exclude,be=le&&X&&X.search&&X.search.exclude;if(!x&&!be)return;if(!x||!be)return x||be;let ce=Object.create(null);return ce=g.$yn(ce,g.$vn(x)),ce=g.$yn(ce,g.$vn(be),!0),ce}e.$CJ=k;function A(X,le){return X.excludePattern&&T.$Lj(X.excludePattern,le)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&T.$Lj(X.includePattern,le)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(x=>{const be=x.folder.fsPath;if(I.$8f(le,be)){const ce=$.$lc(be,le);return!x.includePattern||!!T.$Lj(x.includePattern,ce)}else return!1}):!1:!0}e.$DJ=A;var v;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class w extends Error{constructor(le,x){super(le),this.code=x}}e.$EJ=w;function E(X){const le=X.message;if((0,y.$4)(X))return new w(le,v.canceled);try{const x=JSON.parse(le);return new w(x.message,x.code)}catch{return new w(le,v.other)}}e.$FJ=E;function P(X){const le={message:X.message,code:X.code};return new Error(JSON.stringify(le))}e.$GJ=P;function N(X){return X.type==="error"?!0:X.type==="success"}e.$HJ=N;function z(X){return X.type==="success"}e.$IJ=z;function F(X){return!!X.path}e.$JJ=F;function j(X,le){const x=X.searchPath?X.searchPath:X.relativePath;return(0,R.$yf)(x,le)}e.$KJ=j;class M{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$LJ=M;function O(X,le){const x={...X||{},...le||{}};return Object.keys(x).filter(be=>{const ce=x[be];return typeof ce=="boolean"&&ce})}e.$MJ=O;class U{constructor(le,x){this.c=null,this.a={...le.excludePattern||{},...x.excludePattern||{}},this.b=T.$Mj(this.a);let be=le.includePattern;x.includePattern&&(be?be={...be,...x.includePattern}:be=x.includePattern),be&&(this.c=T.$Mj(be))}matchesExcludesSync(le,x,be){return!!(this.b&&this.b(le,x,be))}includedInQuerySync(le,x,be){return!(this.b&&this.b(le,x,be)||this.c&&!this.c(le,x,be))}includedInQuery(le,x,be){const ce=this.b(le,x,be),G=()=>this.c?!!this.c(le,x,be):!0;return(0,C.$Sg)(ce)?ce.then(W=>W?!1:G()):G()}hasSiblingExcludeClauses(){return Q(this.a)}}e.$NJ=U;function Q(X){for(const le in X)if(typeof X[le]!="boolean")return!0;return!1}function ue(X){if(!X)return;let le;return x=>(le||(le=(X()||Promise.resolve([])).then(be=>be?J(be):{})),le.then(be=>!!be[x]))}e.$OJ=ue;function Z(X){if(!X)return;let le;return x=>{if(!le){const be=X();le=be?J(be):{}}return!!le[x]}}e.$PJ=Z;function J(X){const le={};for(const x of X)le[x]=!0;return le}}),define(ke[41],Se([1,0,19,11,21,4,3,77,16,122,23,12,2,221,5,13,252,40,58,27,20,15,7,66,36,6,55]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c,t,a,r,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=e.$Igc=void 0;function l(z,F,j){return new L.$wg(M=>w(M,j)).isEqual(z,F)}function k(z,F,j){return l(z.uri,F.uri,j)?0:(0,C.$5e)(z.uri.toString(),F.uri.toString())}function A(z,F,j){return z.index!==F.index?z.index<F.index?-1:1:l(z.uri,F.uri,j)?(0,C.$5e)(z.name,F.name):(0,C.$5e)(z.uri.toString(),F.uri.toString())}function v(z,F,j,M){const O=z.slice(0).sort((Q,ue)=>j(Q,ue,M)),U=F.slice(0).sort((Q,ue)=>j(Q,ue,M));return(0,D.$Eb)(O,U,(Q,ue)=>j(Q,ue,M))}function w(z,F){const j=F.getCapabilities(z.scheme);return!(j&&j&1024)}class E extends o.$mi{static toExtHostWorkspace(F,j,M,O){if(!F)return{workspace:null,added:[],removed:[]};const{id:U,name:Q,folders:ue,configuration:Z,transient:J,isUntitled:X}=F,le=[],x=j;j?ue.forEach((W,ne)=>{const ye=m.URI.revive(W.uri),de=E.o(M||j,ye,O);de?(de.name=W.name,de.index=W.index,le.push(de)):le.push({uri:ye,name:W.name,index:ne})}):le.push(...ue.map(({uri:W,name:ne,index:ye})=>({uri:m.URI.revive(W),name:ne,index:ye}))),le.sort((W,ne)=>W.index<ne.index?-1:1);const be=new E(U,Q,le,!!J,Z?m.URI.revive(Z):null,!!X,W=>w(W,O)),{added:ce,removed:G}=v(x?x.workspaceFolders:[],be.workspaceFolders,k,O);return{workspace:be,added:ce,removed:G}}static o(F,j,M){for(let O=0;O<F.folders.length;O++){const U=F.workspaceFolders[O];if(l(U.uri,j,M))return U}}constructor(F,j,M,O,U,Q,ue){super(F,M.map(Z=>new o.$ni(Z)),O,U,ue),this.t=j,this.u=Q,this.q=[],this.s=b.$_h.forUris(ue),M.forEach(Z=>{this.q.push(Z),this.s.set(Z.uri,Z)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,j){return j&&this.s.get(F)&&(F=(0,L.$Gg)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let P=class{constructor(F,j,M,O,U){this.c=new I.$Vd,this.onDidChangeWorkspace=this.c.event,this.g=new I.$Vd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new I.$Xd,this.B=new Map,this.h=O,this.s=M,this.t=U,this.j=new y.$9l,this.k=new T.$5g,this.o=F.getProxy(h.$0K.MainThreadWorkspace),this.q=F.getProxy(h.$0K.MainThreadMessageService);const Q=j.workspace;this.l=Q?new E(Q.id,Q.name,[],!!Q.transient,Q.configuration?m.URI.revive(Q.configuration):null,!!Q.isUntitled,ue=>w(ue,M)):void 0}$initializeWorkspace(F,j){this.v=j,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,L.$Eg)((0,L.$Gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,j,M,...O){const U=[];if(Array.isArray(O)&&O.forEach(X=>{m.URI.isUri(X.uri)&&!U.some(le=>l(le.uri,X.uri,this.s))&&U.push({uri:X.uri,name:X.name||(0,L.$Dg)(X.uri)})}),this.n||[j,M].some(X=>typeof X!="number"||X<0)||M===0&&U.length===0)return!1;const Q=this.x?this.x.workspaceFolders:[];if(j+M>Q.length)return!1;const ue=Q.slice(0);ue.splice(j,M,...U.map(X=>({uri:X.uri,name:X.name||(0,L.$Dg)(X.uri),index:void 0})));for(let X=0;X<ue.length;X++){const le=ue[X];if(ue.some((x,be)=>be!==X&&l(le.uri,x.uri,this.s)))return!1}ue.forEach((X,le)=>X.index=le);const{added:Z,removed:J}=v(Q,ue,A,this.s);if(Z.length===0&&J.length===0)return!1;if(this.o){const X=F.displayName||F.name;this.o.$updateWorkspaceFolders(X,j,M,U).then(void 0,le=>{this.n=void 0;const x={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(f.Severity.Error,(0,p.localize)(0,null,X,le.toString()),x,[])})}return this.y(ue),!0}getWorkspaceFolder(F,j){if(this.x)return this.x.getWorkspaceFolder(F,j)}async getWorkspaceFolder2(F,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,j)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,j){let M,O="";if(typeof F=="string"?(M=m.URI.file(F),O=F):typeof F<"u"&&(M=F,O=F.fsPath),!M)return O;const U=this.getWorkspaceFolder(M,!0);if(!U)return O;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let Q=(0,L.$Jg)(U.uri,M);return j&&U.name&&(Q=`${U.name}/${Q}`),Q}y(F){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:j,added:M,removed:O}=E.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:O}))}findFiles(F,j,M,O,U=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let Q;if(j===null?Q=!1:j&&(typeof j=="string"?Q=j:Q=j.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:Z}=N(c.GlobPattern.from(F));return this.o.$startFileSearch(ue??null,Z??null,Q??null,M??null,U).then(J=>Array.isArray(J)?J.map(X=>m.URI.revive(X)):[])}async findTextInFiles(F,j,M,O,U=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const Q=this.j.getNext(),ue=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Z,folder:J}=N(c.GlobPattern.from(j.include)),X=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,le={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:ue,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Z,excludePattern:X},x=!1;if(this.u[Q]=be=>{if(x)return;const ce=m.URI.revive(be.resource);be.results.forEach(G=>{const W=(0,u.$Ch)(G);(0,r.$vJ)(W)?M({uri:ce,preview:{text:W.preview.text,matches:(0,D.$2b)(W.preview.matches,ne=>new t.$bL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,D.$2b)(W.ranges,ne=>new t.$bL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):M({uri:ce,text:W.text,lineNumber:W.lineNumber})})},U.isCancellationRequested)return{};try{const be=await this.o.$startTextSearch(F,J??null,le,Q,U);return delete this.u[Q],be||{}}catch(be){throw delete this.u[Q],be}}$handleTextSearchResult(F,j){this.u[j]?.(F)}async save(F){const j=await this.o.$save(F,{saveAs:!1});return m.URI.revive(j)}async saveAs(F){const j=await this.o.$save(F,{saveAs:!0});return m.URI.revive(j)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,j){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,j);const M=this.t.transformOutgoingScheme(F),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,M),(0,R.$Rc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(F,j){this.h.info("Getting edit session identifier for workspaceFolder",F);const M=await this.resolveWorkspaceFolder(m.URI.revive(F));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const O=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!O),!O)return;const U=await O.provideEditSessionIdentity(M,j);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(F,j,M,O){this.h.info("Getting edit session identifier for workspaceFolder",F);const U=await this.resolveWorkspaceFolder(m.URI.revive(F));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const Q=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!Q),!Q)return;const ue=await Q.provideEditSessionIdentityMatch?.(j,M,O);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(F){return(j,M,O)=>{const U=function(ue){j.call(M,ue)};return U.extension=F,this.A.event(U,void 0,O)}}async $onWillCreateEditSessionIdentity(F,j,M){const O=await this.resolveWorkspaceFolder(m.URI.revive(F));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},j,async(U,Q)=>{const ue=Date.now();await Promise.resolve(U),Date.now()-ue>M&&this.h.warn("SLOW edit session create-participant",Q.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(F,j){if(this.B.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.B.set(F,j);const M=this.t.transformOutgoingScheme(F),O=this.z++;return this.o.$registerCanonicalUriProvider(O,M),(0,R.$Rc)(()=>{this.B.delete(F),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(F,j,M){const O=this.B.get(F.scheme);if(!O)return;const U=await O.provideCanonicalUri?.(m.URI.revive(F),j,M);if(U)return U}async $provideCanonicalUri(F,j,M){return this.provideCanonicalUri(m.URI.revive(F),{targetScheme:j},M)}};e.$Igc=P,e.$Igc=P=Ge([Ve(0,n.$bN),Ve(1,s.$rN),Ve(2,i.$ogc),Ve(3,d.$nj),Ve(4,a.$Ggc)],P),e.$Jgc=(0,S.$6h)("IExtHostWorkspace");function N(z){let F,j;return z&&(typeof z=="string"?F=z:(F=z.pattern,j=m.URI.revive(z.baseUri))),{includePattern:F,folder:j}}}),define(ke[42],Se([1,0,24,4,41,6,7,254,87,18,11,5,20,13,2]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=e.$Lgc=e.$Kgc=void 0;function d(a,r){if(r){const h=r.split(".");let u=a;for(let l=0;u&&l<h.length;l++)u=u[h[l]];return u}}function f(a){return a instanceof S.URI}function o(a){return a&&a.uri instanceof S.URI&&a.languageId&&typeof a.languageId=="string"}function i(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function s(a){return a&&a.uri instanceof S.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function n(a){if(f(a))return{resource:a};if(o(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(i(a))return{overrideIdentifier:a.languageId};if(s(a))return{resource:a.uri};if(a===null)return{resource:null}}let c=class{constructor(r,h,u){this.a=r.getProxy(I.$0K.MainThreadConfiguration),this.c=h,this.b=u,this.d=new L.$5g,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,h){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(r,h))}};e.$Kgc=c,e.$Kgc=c=Ge([Ve(0,m.$bN),Ve(1,g.$Jgc),Ve(2,p.$nj)],c);class t{constructor(r,h,u,l){this.a=new T.$Vd,this.b=r,this.f=l,this.c=h,this.e=b.$6n.parse(u),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,h){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$6n.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(h,u))}getConfiguration(r,h,u){const l=n(h)||{},k=this.g(r?d(this.e.getValue(void 0,l,this.c.workspace),r):this.e.getValue(void 0,l,this.c.workspace));r&&this.h(r,l,u?.identifier);function A(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(w){return typeof d(k,w)<"u"},get:(w,E)=>{this.h(r?`${r}.${w}`:w,l,u?.identifier);let P=d(k,w);if(typeof P>"u")P=E;else{let N;const z=(F,j)=>{if((0,y.$Kf)(F)){let M;const O=()=>{N=N||(0,D.$vn)(k),M=M||d(N,j)};return new Proxy(F,{get:(U,Q)=>{if(typeof Q=="string"&&Q.toLowerCase()==="tojson")return O(),()=>M;if(N)return M=M||d(N,j),M[Q];const ue=U[Q];return typeof Q=="string"?z(ue,`${j}.${Q}`):ue},set:(U,Q,ue)=>(O(),M&&(M[Q]=ue),!0),deleteProperty:(U,Q)=>(O(),M&&delete M[Q],!0),defineProperty:(U,Q,ue)=>(O(),M&&Object.defineProperty(M,Q,ue),!0)})}return Array.isArray(F)?(0,D.$vn)(F):F};P=z(P,w)}return P},update:(w,E,P,N)=>{w=r?`${r}.${w}`:w;const z=A(P);return E!==void 0?this.b.$updateConfigurationOption(z,w,E,l,N):this.b.$removeConfigurationOption(z,w,l,N)},inspect:w=>{w=r?`${r}.${w}`:w;const E=this.e.inspect(w,l,this.c.workspace);if(E)return{key:w,defaultValue:(0,D.$vn)(E.policy?.value??E.default?.value),globalValue:(0,D.$vn)(E.user?.value??E.application?.value),workspaceValue:(0,D.$vn)(E.workspace?.value),workspaceFolderValue:(0,D.$vn)(E.workspaceFolder?.value),defaultLanguageValue:(0,D.$vn)(E.default?.override),globalLanguageValue:(0,D.$vn)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,D.$vn)(E.workspace?.override),workspaceFolderLanguageValue:(0,D.$vn)(E.workspaceFolder?.override),languageIds:(0,D.$vn)(E.overrideIdentifiers)}}};return typeof k=="object"&&(0,D.$yn)(v,k,!1),Object.freeze(v)}g(r){const h=u=>(0,y.$Kf)(u)?new Proxy(u,{get:(l,k)=>h(l[k]),set:(l,k,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(l,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(l,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return h(r)}h(r,h,u){const l=$.$Wn.test(r)?4:this.d.get(r),k=u?`[${u.value}] `:"";if(l===4){typeof h?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){h?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,h){const u=new b.$8n(r,h,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,k)=>u.affectsConfiguration(l,n(k))})}k(r){return r.reduce((h,u)=>(h.set(u[0],u[1]),h),new Map)}}e.$Lgc=t,e.$Mgc=(0,C.$6h)("IExtHostConfiguration")}),define(ke[96],Se([1,0,2,11,4,6,7,41,72,42,21,46,20,27,5,16,10,13,92,295,14]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=e.$cic=e.$bic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var c;(function(z){function F(M){if(M!=null)return M}z.from=F;function j(M){if(M!=null)return M}z.to=j})(c||(c={}));var t;(function(z){function F(M){if(M!=null)return M}z.from=F;function j(M){if(M!=null)return M}z.to=j})(t||(t={}));var a;(function(z){function F(M){if(M!=null)return M}z.from=F;function j(M){if(M!=null)return M}z.to=j})(a||(a={}));var r;(function(z){function F(O){if(O){const U=O;return U&&!!U.process}else return!1}z.is=F;function j(O){if(O==null)return;const U={process:O.process,args:O.args};return O.options&&(U.options=a.from(O.options)),U}z.from=j;function M(O){if(O!=null)return new R.$UL(O.process,O.args,O.options)}z.to=M})(r||(r={}));var h;(function(z){function F(M){if(M!=null)return M}z.from=F;function j(M){if(M!=null)return M}z.to=j})(h||(h={}));var u;(function(z){function F(O){if(O){const U=O;return U&&(!!U.commandLine||!!U.command)}else return!1}z.is=F;function j(O){if(O==null)return;const U={};return O.commandLine!==void 0?U.commandLine=O.commandLine:(U.command=O.command,U.args=O.args),O.options&&(U.options=h.from(O.options)),U}z.from=j;function M(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$VL(O.commandLine,O.options):new R.$VL(O.command,O.args?O.args:[],O.options)}z.to=M})(u||(u={}));var l;(function(z){function F(O){if(O){const U=O;return U&&U.customExecution==="customExecution"}else return!1}z.is=F;function j(O){return{customExecution:"customExecution"}}z.from=j;function M(O,U){return U.get(O)}z.to=M})(l||(e.CustomExecutionDTO=l={}));var k;(function(z){function F(j,M){let O;return j.scope!==void 0&&typeof j.scope!="number"?O=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===R.TaskScope.Workspace&&M&&M.workspaceFile?O=M.workspaceFile:O=s.$yG),{id:j._id,workspaceFolder:O}}z.from=F})(k||(e.TaskHandleDTO=k={}));var A;(function(z){function F(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}z.from=F})(A||(A={}));var v;(function(z){function F(O,U){if(O==null)return[];const Q=[];for(const ue of O){const Z=j(ue,U);Z&&Q.push(Z)}return Q}z.fromMany=F;function j(O,U){if(O==null)return;let Q;O.execution instanceof R.$UL?Q=r.from(O.execution):O.execution instanceof R.$VL?Q=u.from(O.execution):O.execution&&O.execution instanceof R.$WL&&(Q=l.from(O.execution));const ue=c.from(O.definition);let Z;return O.scope?typeof O.scope=="number"?Z=O.scope:Z=O.scope.uri:Z=R.TaskScope.Workspace,!ue||!Z?void 0:{_id:O._id,definition:ue,name:O.name,source:{extensionId:U.identifier.value,label:O.source,scope:Z},execution:Q,isBackground:O.isBackground,group:A.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}z.from=j;async function M(O,U,Q){if(O==null)return;let ue;r.is(O.execution)?ue=r.to(O.execution):u.is(O.execution)?ue=u.to(O.execution):l.is(O.execution)&&(ue=l.to(O._id,Q));const Z=c.to(O.definition);let J;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?J=O.source.scope:J=await U.resolveWorkspaceFolder(D.URI.revive(O.source.scope)):J=R.TaskScope.Workspace),!Z||!J)return;const X=new R.$XL(Z,J,O.name,O.source.label,ue,O.problemMatchers);return O.isBackground!==void 0&&(X.isBackground=O.isBackground),O.group!==void 0&&(X.group=R.$TL.from(O.group._id),X.group&&O.group.isDefault&&(X.group=new R.$TL(X.group.id,X.group.label),O.group.isDefault===!0&&(X.group.isDefault=O.group.isDefault))),O.presentationOptions&&(X.presentationOptions=t.to(O.presentationOptions)),O._id&&(X._id=O._id),O.detail&&(X.detail=O.detail),X}z.to=M})(v||(e.TaskDTO=v={}));var w;(function(z){function F(M){return M}z.from=F;function j(M){if(M)return Object.assign(Object.create(null),M)}z.to=j})(w||(w={}));class E{#e;constructor(F,j,M){this._id=j,this.a=M,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let P=class{constructor(F,j,M,O,U,Q,ue,Z){this.q=new g.$Vd,this.r=new g.$Vd,this.s=new g.$Vd,this.u=new g.$Vd,this.a=F.getProxy(I.$0K.MainThreadTask),this.b=M,this.c=O,this.d=U,this.e=Q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=Z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,j,M){if(!M)return new R.$_K(()=>{});const O=this.x();return this.j.set(O,{type:j,provider:M,extension:F}),this.a.$registerTaskProvider(O,j),new R.$_K(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(F,j){this.a.$registerTaskSystem(F,j)}fetchTasks(F){return this.a.$fetchTasks(w.from(F)).then(async j=>{const M=[];for(const O of j){const U=await v.to(O,this.b,this.m);U&&M.push(U)}return M})}get taskExecutions(){const F=[];return this.k.forEach(j=>F.push(j)),F}terminateTask(F){if(!(F instanceof E))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,j,M){const O=this.m.get(F.id);O&&(this.o.set(F.id,O),this.e.attachPtyToTerminal(j,await O.callback(M))),this.p=F.id,this.q.fire({execution:await this.z(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){if(!this.l.has(F.id))return;const j=await this.z(F);this.l.delete(F.id),this.k.delete(F.id),this.B(F),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const j=await this.z(F.id);this.s.fire({execution:j,processId:F.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(F){const j=await this.z(F.id);this.u.fire({execution:j,exitCode:F.exitCode})}$provideTasks(F,j){const M=this.j.get(F);if(!M)return Promise.reject(new Error("no handler found"));const O=[],U=(0,T.$Yg)(()=>M.provider.provideTasks(L.CancellationToken.None)).then(Q=>this.v(j,O,M,Q));return new Promise(Q=>{U.then(ue=>{Promise.all(O).then(()=>{Q(ue)})})})}async $resolveTask(F,j){const M=this.j.get(F);if(!M)return Promise.reject(new Error("no handler found"));if(j.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${M.type}].`);const O=await v.to(j,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const U=await M.provider.resolveTask(O,L.CancellationToken.None);if(!U)return;this.A(U,M);const Q=v.from(U,M.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(Q.execution)&&await this.y(Q,U,!0),await this.w(Q)}x(){return this.h++}async y(F,j,M){const O=await this.a.$createTaskId(F);!M&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,j.execution)),this.m.set(O,j.execution)}async z(F,j){if(typeof F=="string"){const U=this.l.get(F);if(!U)throw new n.$bb("Unexpected: The specified task is missing an execution");return U}const M=this.l.get(F.id);if(M)return M;let O;return j?O=Promise.resolve(new E(this,F.id,j)):O=v.to(F.task,this.b,this.m).then(U=>{if(!U)throw new n.$bb("Unexpected: Task does not exist.");return new E(this,F.id,U)}),this.l.set(F.id,O),O.then(U=>(this.k.set(F.id,U),U))}A(F,j){F._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const M=this.n.values();let O=M.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=M.next()}};e.$bic=P,e.$bic=P=Ge([Ve(0,m.$bN),Ve(1,p.$rN),Ve(2,b.$Jgc),Ve(3,$.$mN),Ve(4,y.$Mgc),Ve(5,C.$$gc),Ve(6,o.$nj),Ve(7,i.$rgc)],P);let N=class extends P{constructor(F,j,M,O,U,Q,ue,Z){super(F,j,M,O,U,Q,ue,Z),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(F,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const M=v.from(j,F);if(M===void 0)throw new Error("Task is not valid");if(l.is(M.execution))await this.y(M,j,!1);else throw new n.$_;const O=await this.z(await this.a.$getTaskExecution(M),j);return this.a.$executeTask(M).catch(U=>{throw new Error(U)}),O}v(F,j,M,O){const U=[];if(O)for(const Q of O){if(this.A(Q,M),!Q.definition||!F[Q.definition.type]){const Z=Q.source?Q.source:"No task source";this.f.warn(`The task [${Z}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=v.from(Q,M.extension);ue&&l.is(ue.execution)?(U.push(ue),j.push(this.y(ue,Q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:M.extension}}async w(F){if(l.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,j,M){}};e.$cic=N,e.$cic=N=Ge([Ve(0,m.$bN),Ve(1,p.$rN),Ve(2,b.$Jgc),Ve(3,$.$mN),Ve(4,y.$Mgc),Ve(5,C.$$gc),Ve(6,o.$nj),Ve(7,i.$rgc)],N),e.$dic=(0,S.$6h)("IExtHostTask")}),define(ke[359],Se([1,0,36,29]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$WJ=e.$VJ=void 0;function g(R){return"cellResults"in R}e.$VJ=g,e.$WJ="rawCell#";function I(R,b){let $=-1;const y=[];let L=[];return R.forEach(m=>{m.range.startLineNumber!==$&&L.length>0&&(y.push([...L]),L=[]),L.push(m),$=m.range.endLineNumber}),L.length>0&&y.push([...L]),y.map(m=>{const p=[],S=m[0].range.startLineNumber,d=m[m.length-1].range.endLineNumber;for(let f=S;f<=d;f++)p.push(b.getLineContent(f));return new D.$zJ(p.join(`
`)+`
`,m.map(f=>new T.$Us(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}e.$XJ=I}),define(ke[360],Se([1,0,215,22,4,3,28,12,18,2,32,110,6,35,15,7,68,330,149,24,16,285,359,356]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(u=>u.apiEditor)}constructor(u,l,k,A,v,w){this.q=k,this.r=A,this.s=v,this.t=w,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new g.$Vd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Vd,this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Vd,this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Vd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$kgc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=u.getProxy(m.$0K.MainThreadNotebook),this.c=u.getProxy(m.$0K.MainThreadNotebookDocuments),this.d=u.getProxy(m.$0K.MainThreadNotebookEditors),this.i=l.converter,l.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const P=E.notebookEditor?.notebookUri,N=E.cell.handle,F=this.g.get(P)?.getCell(N);if(F)return F.apiCell}if(E&&E.$mid===14){const P=E.uri,N=this.g.get(P);if(N)return N.apiNotebook}return E}}),r.B(l)}getEditorById(u){const l=this.h.get(u);if(!l)throw new Error(`unknown text editor: ${u}. known editors: ${[...this.h.keys()]} `);return l}getIdByEditor(u){for(const[l,k]of this.h)if(k.apiEditor===u)return l}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(u,l){const k=this.g.get(u);if(!k&&!l)throw new Error(`NO notebook document for '${u}'`);return k}static u(u,l){if(!l)return;const k=l.filenamePattern.map(A=>S.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(l.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:l.displayName,filenamePattern:k,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,l,k){const A=r.a++,v=typeof k.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(A,k),this.b.$registerNotebookCellStatusBarItemProvider(A,v,l);let w;return v!==void 0&&(w=k.onDidChangeCellStatusBarItems(E=>this.b.$emitCellStatusBarEvent(v))),new d.$_K(()=>{this.f.delete(A),this.b.$unregisterNotebookCellStatusBarItemProvider(A,v),w?.dispose()})}async createNotebookDocument(u){const l=await this.c.$tryCreateNotebook({viewType:u.viewType,content:u.content&&S.NotebookData.from(u.content)});return y.URI.revive(l)}async openNotebookDocument(u){const l=this.g.get(u);if(l)return l.apiNotebook;const k=await this.c.$tryOpenNotebook(u),A=this.g.get(y.URI.revive(k));return(0,$.$Tf)(A?.apiNotebook)}async showNotebookDocument(u,l){y.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let k;typeof l=="object"?k={position:S.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(S.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:k={preserveFocus:!1};const A=await this.d.$tryShowNotebookDocument(u.uri,u.notebookType,k),v=A&&this.h.get(A)?.apiEditor;if(v)return v;throw A?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,l,k,A){const v=this.f.get(u),w=y.URI.revive(l),E=this.g.get(w);if(!E||!v)return;const P=E.getCellFromIndex(k);if(!P)return;const N=await v.provideCellStatusBarItems(P.apiCell,A);if(!N)return;const z=new I.$Sc,F=this.p.add([z]),M=(Array.isArray(N)?N:[N]).map(O=>S.NotebookStatusBarItem.from(O,this.i,z));return{cacheId:F,items:M}}$releaseNotebookCellStatusBarItems(u){this.p.delete(u)}registerNotebookSerializer(u,l,k,A,v){if((0,b.$Je)(l))throw new Error("viewType cannot be empty or just whitespace");const w=this.w++;return this.x.set(w,{viewType:l,serializer:k,options:A}),this.b.$registerNotebookSerializer(w,{id:u.identifier,location:u.extensionLocation},l,S.NotebookDocumentContentOptions.from(A),r.u(u,v)),(0,I.$Rc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(u,l,k){const A=this.x.get(u);if(!A)throw new Error("NO serializer found");const v=await A.serializer.deserializeNotebook(l.buffer,k);return new f.$Tv(S.NotebookData.from(v))}async $notebookToData(u,l,k){const A=this.x.get(u);if(!A)throw new Error("NO serializer found");const v=await A.serializer.serializeNotebook(S.NotebookData.to(l.value),k);return T.$je.wrap(v)}async $saveNotebook(u,l,k,A,v){const w=y.URI.revive(l),E=this.x.get(u);if(!E)throw new Error("NO serializer found");const P=this.g.get(w);if(!P)throw new Error("Document NOT found");if(P.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new L.$Lk((0,D.localize)(0,null,this.z(w)),6);await this.y(w,A);const N={metadata:(0,s.$Dn)(P.apiNotebook.metadata,O=>!(E.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of P.apiNotebook.getCells()){const U=new d.$yM(O.kind,O.document.getText(),O.document.languageId,O.mime,E.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);U.metadata=(0,s.$Dn)(O.metadata,Q=>!(E.options?.transientCellMetadata??{})[Q]),N.cells.push(U)}const z=await E.serializer.serializeNotebook(N,v);await this.s.value.writeFile(w,z);const F=this.s.getFileSystemProviderExtUri(w.scheme),j=await this.s.value.stat(w);return{name:F.basename(w),isFile:(j.type&L.FileType.File)!==0,isDirectory:(j.type&L.FileType.Directory)!==0,isSymbolicLink:(j.type&L.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&L.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((j.permissions??0)&L.FilePermission.Locked),etag:L.$Wk({mtime:j.mtime,size:j.size}),children:void 0}}async $searchInNotebooks(u,l,k,A,v){const w=this.x.get(u)?.serializer;if(!w)return{limitHit:!1,results:[]};const E=new R.$Bc;await(async(j,M,O)=>{await Promise.all(j.map(async U=>await Promise.all(U.filenamePatterns.map(Q=>{const ue={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:Q};return this.t.doInternalFileSearchWithCustomCallback(ue,M,Z=>{Z.forEach(J=>{E.has(J)||A.some(le=>U.isFromSettings&&!le.isFromSettings?!1:le.filenamePatterns.some(x=>(0,a.$jdb)(x,J)))||E.add(J)})})}))))})(k,v,l);const N=new R.$Ac;let z=!1;const F=Array.from(E).map(async j=>{const M=[];try{if(v.isCancellationRequested)return;if(l.maxResults&&[...N.values()].reduce((ue,Z)=>ue+Z.cellResults.length,0)>l.maxResults){z=!0;return}const O=[],U=this.g.get(j);if(U)U.apiNotebook.getCells().forEach(Z=>O.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(J=>J.items.map(X=>X.data.toString()))}));else{const ue=await this.s.value.readFile(j),Z=T.$je.fromString(ue.toString()),J=await w.deserializeNotebook(Z.buffer,v);if(v.isCancellationRequested)return;S.NotebookData.from(J).cells.forEach(le=>O.push({input:le.source,outputs:le.outputs.flatMap(x=>x.items.map(be=>be.valueBytes.toString()))}))}if(v.isCancellationRequested)return;O.forEach((ue,Z)=>{const J=l.contentPattern.pattern,X=new c.$WQb(ue.input,void 0,ue.outputs),le=X.findInInputs(J),x=X.findInOutputs(J),be=x.flatMap(ce=>(0,t.$XJ)(ce.matches,ce.textBuffer)).map((ce,G)=>(ce.webviewIndex=G,ce));if(le.length>0||x.length>0){const ce={index:Z,contentResults:(0,t.$XJ)(le,X.inputTextBuffer),webviewResults:be};M.push(ce)}});const Q={resource:j,cellResults:M};N.set(j,Q);return}catch{return}});return await Promise.all(F),{limitHit:z,results:[...N.values()]}}async y(u,l){const k=await this.s.value.stat(u);if(typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==L.$Vk&&typeof k.mtime=="number"&&typeof k.size=="number"&&l.mtime<k.mtime&&l.etag!==L.$Wk({mtime:l.mtime,size:k.size}))throw new L.$Lk((0,D.localize)(1,null),3,l)}z(u){return u.scheme===n.Schemas.file?u.fsPath:u.toString()}A(u,l,k){if(this.h.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const A=new i.$Ghc(l,this.d,u,k.visibleRanges.map(S.NotebookRange.to),k.selections.map(S.NotebookRange.to),typeof k.viewColumn=="number"?S.ViewColumn.to(k.viewColumn):void 0);this.h.set(l,A)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const k of u.value.removedDocuments){const A=y.URI.revive(k),v=this.g.get(A);v&&(v.dispose(),this.g.delete(A),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(v.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===A.toString()&&this.h.delete(w.id)}if(u.value.addedDocuments){const k=[];for(const A of u.value.addedDocuments){const v=y.URI.revive(A.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const w=new o.$Fhc(this.c,this.q,this.r,v,A);k.push(...A.cells.map(E=>o.$Ehc.asModelAddData(w.apiNotebook,E))),this.g.get(v)?.dispose(),this.g.set(v,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(w.apiNotebook)}}if(u.value.addedEditors)for(const k of u.value.addedEditors){if(this.h.has(k.id))return;const A=y.URI.revive(k.documentUri),v=this.g.get(A);v&&this.A(v,k.id,k)}const l=[];if(u.value.removedEditors)for(const k of u.value.removedEditors){const A=this.h.get(k);A&&(this.h.delete(k),this.k?.id===A.id&&(this.k=void 0),l.push(A))}if(u.value.visibleEditors){this.l=u.value.visibleEditors.map(A=>this.h.get(A)).filter(A=>!!A);const k=new Set;this.l.forEach(A=>k.add(A.id));for(const A of this.h.values()){const v=k.has(A.id);A._acceptVisibility(v)}this.l=[...this.h.values()].map(A=>A).filter(A=>A.visible),this.o.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this.k=void 0:u.value.newActiveEditor&&(this.h.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this.k=this.h.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(u){const l=p.$zN.String.with("notebookType","A notebook type"),k=new p.$BN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[l,new p.$zN("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>T.$je.wrap(v))],new p.$AN("Notebook Data",v=>S.NotebookData.to(v.value))),A=new p.$BN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[l,new p.$zN("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new f.$Tv(S.NotebookData.from(v)))],new p.$AN("Bytes",v=>v.buffer));u.registerApiCommand(k),u.registerApiCommand(A)}}e.$Phc=r}),define(ke[361],Se([1,0,17,21,44,34,23,38,36]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class y{constructor(m,p,S){this.k=m,this.l=p,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&I.$Mj(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&I.$Mj(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const p=this.k.folderQueries||[];return new Promise((S,d)=>{const f=o=>{this.f++,m(o)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),s=D.$nc(i);this.j&&this.j(i,s)||this.v(f,{base:o,basename:s})}),Promise.all(p.map(o=>this.p(o,f))).then(o=>{S({limitHit:this.e,stats:o[0]||void 0})},o=>{d(new Error((0,g.$Qi)(o)))})})}async p(m,p){const S=new T.$6d,d=this.q(m),f=this.r(),o=new $.$NJ(this.k,m),i=!o.hasSiblingExcludeClauses();let s;try{this.h.add(S),s=b.$Rd.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,S.token),c=s.elapsed(),t=b.$Rd.create();return this.g&&!this.e||(n&&n.forEach(a=>{const r=D.$gc.relative(m.folder.path,a.path);if(i){const h=D.$nc(a.path);this.v(p,{base:m.folder,relativePath:r,basename:h});return}this.s(f,m.folder,r,p)}),this.g&&!this.e)?null:(this.u(f,o,p),{providerTime:c,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(m){const p=(0,$.$MJ)(this.k.includePattern,m.includePattern),S=(0,$.$MJ)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:S,includes:p,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},p,S,d){if(S===this.a){const o=D.$nc(this.a);this.v(d,{base:p,relativePath:this.a,basename:o})}function f(o){const i=D.$nc(o),s=D.$mc(o);let n=m[s];n||(n=m[s]=[],f(s)),n.push({base:p,relativePath:o,basename:i})}f(S)}u({rootEntries:m,pathToEntries:p},S,d){const f=this,o=this.a;function i(s){const n=(0,$.$PJ)(()=>s.map(c=>c.basename));for(let c=0,t=s.length;c<t;c++){const a=s[c],{relativePath:r,basename:h}=a;if(S.matchesExcludesSync(r,h,o!==h?n:void 0))continue;const u=p[r];if(u)i(u);else{if(r===o)continue;f.v(d,a)}if(f.e)break}}i(m)}v(m,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(p))}}class L{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,p,S,d){const f=this.c(m.cacheKey),o=new y(m,p,f&&f.token);let i=0;const s=n=>{i+=n.length,S(n.map(c=>this.d(c)))};return this.e(o,L.a,s,d).then(n=>({limitHit:n.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:n.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new T.$6d),this.b.get(m)}d(m){return m.relativePath?{resource:R.$Hg(m.base,m.relativePath)}:{resource:m.base}}e(m,p,S,d){const f=d.onCancellationRequested(()=>{m.cancel()}),o=s=>{s&&(i.push(s),p>0&&i.length>=p&&(S(i),i=[]))};let i=[];return m.search(o).then(s=>(i.length&&S(i),f.dispose(),s),s=>(i.length&&S(i),f.dispose(),Promise.reject(s)))}}e.$Hhc=L}),define(ke[362],Se([1,0,19,73,34,103,28,16,17,23,12,18,2,100,235,51,13,40,142,357,36]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$NK=void 0;let c=class{constructor(w,E,P,N,z){this.a=w,this.b=E,this.c=P,this.d=N,this.e=z}text(w,E,P={}){w=this.f(w,P);const N=this.a.getValue(),z=E&&E.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(E?.map(o.$oi),P),type:2,contentPattern:w,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:N.search.usePCRE2||z||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(w,E){const P=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const N={...w,wordSeparators:P.editor.wordSeparators};return this.j(w,E)&&(N.isCaseSensitive=!0),this.k(w)&&(N.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),N}file(w,E={}){return{...this.h(w,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(w,E){return w?(w=Array.isArray(w)?w.map(u):u(w),E?this.parseSearchPaths(w):{pattern:a(...Array.isArray(w)?w:[w])}):{}}h(w=[],E={}){const P=this.g(E.includePattern,E.expandPatterns),N=this.g(E.excludePattern,E.expandPatterns),z=w.length>1,F=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(O=>this.q(O,E,N)):w.map(O=>this.r(O,E,N,z))).filter(O=>!!O),j={_reason:E._reason,folderQueries:F,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:N.pattern,includePattern:P.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const O=D.$Hb(D.$Rb(this.c.groups.map(ue=>ue.editors.map(Z=>Z.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const U=O.filter(ue=>(0,n.$DJ)(j,ue.fsPath)),Q=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Q)),{...j,...Q}}const M=E.extraFileResources&&E.extraFileResources.filter(O=>(0,n.$DJ)(j,O.fsPath));return j.extraFileResources=M&&M.length?M:void 0,j}i(w){const E=[],P=new R.$Ac,N={};let z=!1;return w.forEach(F=>{if(F.scheme===b.Schemas.walkThrough)return;if((0,y.$Lg)(F)){const M=this.b.getWorkspaceFolder(F)?.uri??F.with({path:$.$mc(F.fsPath)});let O=P.get(M);O||(z=!0,O={folder:M,includePattern:{}},E.push(O),P.set(M,O));const U=$.$lc(M.fsPath,F.fsPath);(0,C.$Tf)(O.includePattern)[U.replace(/\\/g,"/")]=!0}else F.fsPath&&(z=!0,N[F.fsPath]=!0)}),{folderQueries:E,includePattern:N,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(w,E){if(E.isSmartCase){if(w.isRegExp){if(L.$zf(w.pattern,!0))return!0}else if(L.$zf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,p.$4B)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const E=Q=>$.$ic(Q)||/^\.\.?([\/\\]|$)/.test(Q),N=(Array.isArray(w)?w:r(w)).map(Q=>{const ue=this.e.resolvedUserHome;return ue?(0,I.$Yv)(Q,ue.scheme===b.Schemas.file?ue.fsPath:ue.path):Q}),z=T.$K(N,Q=>E(Q)?"searchPaths":"exprSegments"),F=(z.exprSegments||[]).map(Q=>L.$Ue(Q,"/")).map(Q=>L.$Ue(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),h(Q))),j={},M=this.m(z.searchPaths||[]);M&&M.length&&(j.searchPaths=M);const O=D.$Rb(F),U=a(...O);return U&&(j.pattern=U),j}l(w,E){return E.disregardExcludeSettings?void 0:(0,n.$CJ)(w,!E.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const E=w.flatMap(N=>{let{pathPortion:z,globPortion:F}=t(N);return F&&(F=l(F)),this.n(z).flatMap(M=>this.o(M,F))}),P=new Map;return E.forEach(N=>{const z=N.searchPath.toString(),F=P.get(z);F?N.pattern&&(F.pattern=F.pattern||{},F.pattern[N.pattern]=!0):P.set(z,{searchPath:N.searchPath,pattern:N.pattern?a(N.pattern):void 0})}),Array.from(P.values())}n(w){if($.$ic(w)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==b.Schemas.file?[{searchPath:E[0].uri.with({path:w})}]:[{searchPath:m.URI.file($.$hc(w))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(w=u(w),w.startsWith("../")||w===".."){const N=$.$gc.resolve(E.path,w);return[{searchPath:E.with({path:N})}]}const P=l(w);return[{searchPath:E,pattern:P}]}else{if(w==="./"||w===".\\")return[];{const E=w.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(z=>{const F=E.match(new RegExp(`^${L.$Oe(z.name)}(?:/(.*)|$)`));return F?{match:F,folder:z}:null}).filter(C.$Qf);if(N.length)return N.map(z=>{const F=z.match[1];return{searchPath:z.folder.uri,pattern:F&&l(F)}});{const z=w.match(/\.[\/\\](.+)[\/\\]?/),F=z?z[1]:w,j=S.localize(0,null,F);throw new Error(j)}}}}o(w,E){const P=w.pattern&&E?`${w.pattern}/${E}`:w.pattern||E,N=[{searchPath:w.searchPath,pattern:P}];return P&&!P.endsWith("**")&&N.push({searchPath:w.searchPath,pattern:P+"/**"}),N}q(w,E,P){const N=this.r((0,o.$oi)(w.searchPath),E,P,!1);return N?{...N,includePattern:w.pattern}:null}r(w,E,P,N){let z;const F=m.URI.isUri(w)?w:w.uri;if(P.searchPaths){const Q=P.searchPaths.filter(ue=>(0,y.$Ag)(ue.searchPath,F))[0];if(Q&&!Q.pattern)return null;Q&&(z=Q.pattern)}const j=this.a.getValue({resource:F}),O={...this.l(j,E)||{},...z||{}},U=m.URI.isUri(w)?(0,y.$Eg)(w):w.name;return{folder:F,folderName:N?U:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!j.search.followSymlinks}}};e.$NK=c,e.$NK=c=Ge([Ve(0,d.$zi),Ve(1,o.$ci),Ve(2,i.$9C),Ve(3,f.$nj),Ve(4,s.$LK)],c);function t(v){const w=v.match(/[\*\{\}\(\)\[\]\?]/);if(w){const E=w.index,P=v.substr(0,E).match(/[/|\\][^/\\]*$/);if(P){let N=v.substr(0,P.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:v.substr((P.index||0)+1)}}}return{pathPortion:v}}function a(...v){return v.length?v.reduce((w,E)=>(w[E]=!0,w),Object.create(null)):void 0}function r(v){return g.$Kj(v,",").map(w=>w.trim()).filter(w=>!!w.length)}function h(v){return[`**/${v}/**`,`**/${v}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function u(v){return v.replace(/\\/g,"/")}function l(v){return u(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(v){return v.replace(/([?*[\]])/g,"[$1]")}function A(v,w){v=D.$Mb(v,N=>N.toString());const E=[],P=w.getWorkspace();return v&&v.forEach(N=>{let z;if(w.getWorkbenchState()===2)z=(0,y.$Jg)(P.folders[0].uri,N),z&&z!=="."&&(z="./"+z);else{const F=w.getWorkspaceFolder(N);if(F){const j=F.name;if(P.folders.filter(O=>O.name===j).length===1){const O=(0,y.$Jg)(F.uri,N);O===""?z=`./${F.name}`:z=`./${F.name}/${O}`}else z=N.fsPath}}z&&E.push(k(z))}),E}e.$OK=A}),define(ke[363],Se([1,0,23,2,21,14,5,362,36,40]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wsb=e.$vsb=void 0;const L=7e3;function C(d,f){const o=f.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],s=[];for(const h of o)if(/^workspaceContains:/.test(h)){const u=h.substr(18);u.indexOf("*")>=0||u.indexOf("?")>=0||d.forceUsingSearch?s.push(u):i.push(u)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);let n;const c=new Promise((h,u)=>{n=h}),t=h=>n({activationEvent:h}),a=Promise.all(i.map(h=>m(d,h,t))).then(()=>{}),r=p(d,f.identifier,s,t);return Promise.all([a,r]).then(()=>{n(void 0)}),c}e.$vsb=C;async function m(d,f,o){for(const i of d.folders)if(await d.exists(D.$Hg(T.URI.revive(i),f))){o(`workspaceContains:${f}`);return}}async function p(d,f,o,i){if(o.length===0)return Promise.resolve(void 0);const s=new g.$6d,n=d.checkExists(d.folders,o,s.token),c=setTimeout(async()=>{s.cancel(),d.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},L);let t=!1;try{t=await n}catch(a){I.$4(a)||I.$1(a)}s.dispose(),clearTimeout(c),t&&i(`workspaceContains:${o.join(",")}`)}function S(d,f,o,i){const s=d.get(R.$5h),n=d.get($.$uJ),t=s.createInstance(b.$NK).file(f.map(a=>(0,y.$oi)(T.URI.revive(a))),{_reason:"checkExists",includePattern:o,exists:!0});return n.fileSearch(t,i).then(a=>!!a.limitHit,a=>I.$4(a)?!1:Promise.reject(a))}e.$wsb=S}),define(ke[47],Se([1,0,212,17,57,23,11,3,77,2,13,6,42,291,117,41,25,144,14,26,22,271,7,64,5,27,94,20,107,70,46,4,363,116,273,16,114,38,10,115]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c,t,a,r,h,u,l,k,A,v,w,E,P,N,z,F,j,M,O){"use strict";var U;Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=e.$mhc=e.$lhc=e.$khc=e.$jhc=void 0,e.$jhc=(0,r.$6h)("IHostUtils");let Q=U=class extends b.$Tc{constructor(G,W,ne,ye,de,ge,_,te,K,ie,fe,pe){super(),this.X=pe,this.a=this.B(new w.$Vd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=ne,this.f=_,this.j=ye,this.m=de,this.s=ge,this.t=K,this.u=ie,this.w=fe,this.y=this.g.getProxy(C.$0K.MainThreadWorkspace),this.z=this.g.getProxy(C.$0K.MainThreadTelemetry),this.C=this.g.getProxy(C.$0K.MainThreadExtensionService),this.D=new R.$5g,this.F=new R.$5g,this.G=new R.$5g,this.H=new R.$5g,this.I=new be(this.f.extensions.activationEvents),this.L=new o.$t8b(this.I,this.f.extensions.allExtensions);const Pe=new s.$mm(this.f.extensions.myExtensions);this.J=new o.$t8b(this.I,le(this.L,Pe)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${J(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${J(this.J)}`)),this.M=new S.$7gc(this.g,this.s),this.N=new P.$chc(this.g),this.O=te,this.h=G.createChild(new k.$4h([S.$8gc,this.M],[P.$dhc,this.N])),this.P=this.B(new p.$6gc(this.J,this.L,{onExtensionActivationError:(we,Ce,B)=>{this.C.$onExtensionActivationError(we,i.$3(Ce),B)},actualActivateExtension:async(we,Ce)=>{if(o.$t8b.isHostExtension(we,this.J,this.L))return await this.C.$activateExtension(we,Ce),new p.$5gc;const B=this.J.getExtensionDescription(we);return this.db(B,Ce)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(G){i.$1(G)}}async Y(){this.O.onWillDeactivateAll();let G=[];try{G=this.J.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.cb(de))}catch{}await Promise.all(G)}terminate(G,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${G}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$7g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(G){return this.G.isOpen()?this.P.isActivated(G):!1}async getExtension(G){const W=await this.C.$getExtension(G);return W&&{...W,identifier:new s.$lm(W.identifier.value),extensionLocation:y.URI.revive(W.extensionLocation)}}Z(G,W){return this.P.activateByEvent(G,W)}$(G,W){return this.P.activateById(G,W)}activateByIdWithErrors(G,W){return this.$(G,W).then(()=>{const ne=this.P.getActivatedExtension(G);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(G=>this.J)}getExtensionExports(G){if(this.G.isOpen())return this.P.getActivatedExtension(G).exports;try{return this.P.getActivatedExtension(G).exports}catch{return null}}async ab(G){if(G.scheme===z.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(G.fsPath);return y.URI.file(W)}return G}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(G=>new x(G))),this.Q}async bb(G){const W=$.$_h.forUris(ne=>I.$yg.ignorePathCasing(ne));return await Promise.all(G.map(async ne=>{if(this.ub(ne)){const ye=await this.ab(ne.extensionLocation);W.set(ye,ne)}})),W}cb(G){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(G))return W;const ne=this.P.getActivatedExtension(G);if(!ne)return W;try{typeof ne.module.deactivate=="function"&&(W=Promise.resolve(ne.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${G.value}':`),this.s.error(ye)}try{(0,b.$Oc)(ne.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this.s.error(ye)}return W}async db(G,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(G.identifier):await this.C.$onWillActivateExtension(G.identifier),this.fb(G,W).then(ne=>{const ye=ne.activationTimes;return this.C.$onDidActivateExtension(G.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,W),this.eb(G,W,"success",ye),ne},ne=>{throw this.eb(G,W,"failure"),ne})}eb(G,W,ne,ye){const de=Z(G,W);this.z.$publicLog2("extensionActivationTimes",{...de,...ye||{},outcome:ne})}fb(G,W){const ne=Z(G,W);this.z.$publicLog2("activatePlugin",ne);const ye=this.ub(G);if(!ye)return Promise.resolve(new p.$4gc(p.$1gc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${G.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const de=new p.$2gc(W.startup);return Promise.all([this.vb(G,(0,I.$Hg)(G.extensionLocation,ye),de),this.gb(G)]).then(ge=>(g.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),U.hb(this.s,G.identifier,ge[0],ge[1],de))).then(ge=>(g.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),ge))}gb(G){const W=new c.$0gc(G,this.M),ne=new c.$9gc(G.identifier.value,!1,this.M),ye=new N.$ehc(G,this.N),de=G.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([W.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const _=this;let te,K;const ie=(0,f.$FF)(G,"ipc")?this.f.messagePorts?.get(s.$lm.toKey(G.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:ne,secrets:ye,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(fe){return T.$jc(G.extensionLocation.fsPath,fe)},get storagePath(){return _.O.workspaceValue(G)?.fsPath},get globalStoragePath(){return _.O.globalValue(G).fsPath},get logPath(){return T.$jc(_.f.logsLocation.fsPath,G.identifier.value)},get logUri(){return y.URI.joinPath(_.f.logsLocation,G.identifier.value)},get storageUri(){return _.O.workspaceValue(G)},get globalStorageUri(){return _.O.globalValue(G)},get extensionMode(){return de},get extension(){return te===void 0&&(te=new X(_,G.identifier,G,ge,!1)),te},get extensionRuntime(){return(0,f.$GF)(G,"extensionRuntime"),_.extensionRuntime},get environmentVariableCollection(){return _.u.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!K){if(!ie)return;const fe=w.Event.buffer(w.Event.fromDOMEventEmitter(ie,"message",pe=>pe.data));ie.start(),K={onDidReceiveMessage:fe,postMessage:ie.postMessage.bind(ie)}}return K}})})}static hb(G,W,ne,ye,de){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(G,W,ne,ye,de).then(ge=>new p.$3gc(!1,null,de.build(),ne,ge,ye.subscriptions))}static ib(G,W,ne,ye,de){if(typeof ne.activate=="function")try{de.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${W.value}`);const ge=typeof global=="object"?global:self,_=ne.activate.apply(ge,[ye]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(_).then(te=>(de.activateResolveStop(),te))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(ne)}jb(G,W){this.$(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:W}).then(void 0,ne=>{this.s.error(ne)})}kb(G,W=0){const ye=Date.now();(0,M.$B)(()=>{for(let de=W;de<G.length;de+=1){const ge=G[de];for(const _ of ge.activationEvents??[])if(_==="onStartupFinished")if(Date.now()-ye>50){this.kb(G,de);break}else this.jb(ge,_)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(G=>{const W=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(W)this.kb(ne);else for(const ye of ne)if(ye.activationEvents)for(const de of ye.activationEvents)de==="onStartupFinished"&&this.jb(ye,de)})}mb(){const G=this.Z("*",!0).then(void 0,ge=>{this.s.error(ge)});this.B(this.j.onDidChangeWorkspace(ge=>this.nb(ge.added)));const W=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(W),ye=this.pb(),de=Promise.all([ye,G,ne]).then(()=>{});return Promise.race([de,(0,R.$7g)(1e4)]).then(()=>{this.lb()}),de}nb(G){return G.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(G,W))).then(()=>{})}async ob(G,W){if(this.isActivated(W.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:G.map(ge=>ge.uri),forceUsingSearch:ne||!this.c.fsExists,exists:ge=>this.c.fsExists(ge.fsPath),checkExists:(ge,_,te)=>this.y.$checkExists(ge,_,te)},de=await(0,E.$vsb)(ye,W);if(de)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:de.activationEvent}).then(void 0,ge=>this.s.error(ge))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(G){throw console.error(G),G}}async qb(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:W}=this.f.environment;if(!G||!W)throw new Error(D.localize(0,null));const ne=await this.vb(null,W,new p.$2gc(!1));if(!ne||typeof ne.run!="function")throw new Error(D.localize(1,null,W.toString()));return new Promise((ye,de)=>{const ge=(K,ie)=>{K?(M.$t&&this.s.error("Test runner called back with error",K),de(K)):(M.$t&&(ie?this.s.info(`Test runner called back with ${ie} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof ie=="number"&&ie>0?1:0))},_=(0,I.$vg)(W),te=ne.run(_,ge);te&&te.then&&te.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(K=>{M.$t&&this.s.error("Test runner finished with error",K),de(K instanceof Error&&K.stack?K.stack:String(K))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$7g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,W){return this.R[G]=W,(0,b.$Rc)(()=>{delete this.R[G]})}async getRemoteExecServer(G){const{resolver:W}=await this.sb(G);return W?.resolveExecServer?.(G,{resolveAttempt:0})}async sb(G){const W=G.indexOf("+");if(W===-1)throw new t.$fL("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=G.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(G,W){const ne=j.$Rd.create(!1),ye=()=>`[resolveAuthority(${(0,a.$_k)(G)},${W})][${ne.elapsed()}ms] `,de=ee=>this.s.info(`${ye()}${ee}`),ge=ee=>this.s.warn(`${ye()}${ee}`),_=(ee,q=void 0)=>this.s.error(`${ye()}${ee}`,q),te=ee=>{if(ee instanceof t.$fL)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},K=async ee=>{de(`activating resolver for ${ee}...`);const{resolver:q,authorityPrefix:oe}=await this.sb(ee);if(!q)throw _(`no resolver for ${oe}`),new t.$fL(`No remote extension installed to resolve ${oe}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:oe,remoteAuthority:ee}},ie=G.split(/@|%40/g).reverse();de(`activating remote resolvers ${ie.join(" -> ")}`);let fe;try{fe=await Promise.all(ie.map(K)).catch(async ee=>{if(!(ee instanceof t.$fL)||ee._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return ge(`resolving nested authorities failed: ${ee.message}`),[await K(G)]})}catch(ee){return te(ee)}const pe=new R.$eh;pe.cancelAndSet(()=>de("waiting..."),1e3);let Pe,we;for(const[ee,{authorityPrefix:q,resolver:oe,remoteAuthority:he}]of fe.entries())try{if(ee===fe.length-1)de("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${q}`),Pe=await oe.resolve(he,{resolveAttempt:W,execServer:we}),g.mark(`code/extHost/didResolveAuthorityOK/${q}`),de("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(oe,t.$eL.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(de(`invoking resolveExecServer() for ${he}`),g.mark(`code/extHost/willResolveExecServer/${q}`),we=await oe.resolveExecServer?.(he,{resolveAttempt:W,execServer:we}),!we)throw new t.$fL(`Exec server was not available for ${he}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Le){return g.mark(`code/extHost/didResolveAuthorityError/${q}`),_("returned an error",Le),pe.dispose(),te(Le)}pe.dispose();const Ce={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},B={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${t.$eL.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let Y;if(t.$eL.isManagedResolvedAuthority(Pe)){const ee=W;this.X.setFactory(ee,Pe.makeConnection),Y={authority:G,connectTo:new a.$9k(ee),connectionToken:Pe.connectionToken}}else Y={authority:G,connectTo:new a.$0k(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:Y,options:B,tunnelInformation:Ce}}}async $getCanonicalURI(G,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,a.$_k)(G)})`);const{resolver:ne}=await this.sb(G);if(!ne)return null;const ye=y.URI.revive(W);if(typeof ne.getCanonicalURI>"u")return ye;const de=await(0,R.$Yg)(()=>ne.getCanonicalURI(ye));return de||ye}$startExtensionHost(G){G.toAdd.forEach(ye=>ye.extensionLocation=y.URI.revive(ye.extensionLocation));const{globalRegistry:W,myExtensions:ne}=ue(this.I,this.L,this.J,G);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(ne),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${J(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${J(this.J)}`)),this.rb()}$activateByEvent(G,W){return W===1?this.D.wait().then(ne=>this.Z(G,!1)):this.G.wait().then(ne=>this.Z(G,!1))}async $activate(G,W){return await this.G.wait(),this.J.getExtensionDescription(G)?(await this.$(G,W),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(ge=>ge.extensionLocation=y.URI.revive(ge.extensionLocation));const{globalRegistry:W,myExtensions:ne}=ue(this.I,this.L,this.J,G),ye=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ne),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${J(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${J(this.J)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const W=n.$je.alloc(G),ne=Math.random()%256;for(let ye=0;ye<G;ye++)W.writeUInt8(ne,ye);return W}async $updateRemoteConnectionData(G){this.W=G,this.a.fire()}};e.$khc=Q,e.$khc=Q=U=Ge([Ve(0,r.$5h),Ve(1,e.$jhc),Ve(2,l.$bN),Ve(3,d.$Jgc),Ve(4,m.$Mgc),Ve(5,L.$nj),Ve(6,h.$rN),Ve(7,u.$Pgc),Ve(8,A.$vyb),Ve(9,v.$$gc),Ve(10,F.$ghc),Ve(11,O.$hhc)],Q);function ue(ce,G,W,ne){ce.addActivationEvents(ne.addActivationEvents);const ye=new o.$t8b(ce,G.getAllExtensionDescriptions());ye.deltaExtensions(ne.toAdd,ne.toRemove);const de=new s.$mm(W.getAllExtensionDescriptions().map(_=>_.identifier));for(const _ of ne.myToRemove)de.delete(_);for(const _ of ne.myToAdd)de.add(_);const ge=le(ye,de);return{globalRegistry:ye,myExtensions:ge}}function Z(ce,G){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function J(ce){return ce.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.$lhc=(0,r.$6h)("IExtHostExtensionService");class X{#e;#t;#i;constructor(G,W,ne,ye,de){this.#e=G,this.#t=W,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$hc((0,I.$vg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=ye,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$mhc=X;function le(ce,G){return ce.getAllExtensionDescriptions().filter(W=>G.has(W.identifier))}class x{constructor(G){this.a=G}setSearchTree(G){this.a=G}findSubstr(G){return this.a.findSubstr(G)}forEach(G){return this.a.forEach(G)}}e.$nhc=x;class be{constructor(G){this.a=new s.$nm,this.addActivationEvents(G)}readActivationEvents(G){return this.a.get(G.identifier)??[]}addActivationEvents(G){for(const W of Object.keys(G))this.a.set(W,G[W])}}}),define(ke[364],Se([1,0,57,2,6,42,25,26,20,27,5,47,13,12]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;let d=class{constructor(n,c,t,a,r,h,u){this.c=n,this.d=c,this.e=t,this.f=a,this.g=r,this.h=h,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const c=await this.g.getExtensionPathIndex();this.register(new o(this.c,c,this.d,n,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,c,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const c of n.nodeModuleName)this.a.set(c,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(c=>n.alternativeModuleName(c))}};e.$vic=d,e.$vic=d=Ge([Ve(2,L.$5h),Ve(3,I.$Mgc),Ve(4,C.$lhc),Ve(5,y.$rN),Ve(6,m.$nj)],d);let f=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&S.a.size){const c=(0,p.$Oe)(this.c(n.environment.appRoot.fsPath)),t="[a-z0-9_.-]",a=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${c}/${r}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const c=this.b.exec(this.c(n));if(!c)return;const[,t,a,r]=c,h=S.a.get(a);if(h!==void 0)return console.warn(`${a} as been renamed to ${h}, please update your imports`),t+h+r}c(n){return n.replace(/\\/g,"/")}};f=S=Ge([Ve(0,y.$rN)],f);class o{constructor(n,c,t,a,r){this.c=n,this.d=c,this.e=t,this.f=a,this.g=r,this.nodeModuleName="vscode",this.a=new b.$nm}load(n,c){const t=this.d.findSubstr(c);if(t){let a=this.a.get(t.identifier);return a||(a=this.c(t,this.e,this.f),this.a.set(t.identifier,a)),a}if(!this.b){let a="";this.d.forEach((r,h)=>a+=`	${h} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${c}. These are the extension path mappings: 
${a}`),this.b=this.c(R.$AF,this.e,this.f)}return this.b}}let i=class{constructor(n,c,t){this.e=n,this.f=c,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$0K.MainThreadTelemetry);const a=t.getProxy(g.$0K.MainThreadWindow);this.c=(r,h)=>{const u=T.URI.parse(r);return h?this.g(r,h):u.scheme==="http"||u.scheme==="https"?a.$openUri(u,r,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?a.$openUri(u,r,{}):this.g(r,h)}}load(n,c,t){const a=this.e.findSubstr(c);return a&&(this.a=a.identifier.value,this.h()),this.b=t(n),this.c}g(n,c){return this.i(),this.b(n,c)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ge([Ve(2,$.$bN)],i)}),define(ke[59],Se([1,0,43,3,17,49,5,72,71,47,7,41,288,42]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=e.$ohc=void 0,e.$ohc=(0,R.$6h)("IExtHostVariableResolverProvider");class S extends m.$cO{constructor(o,i,s,n,c,t,a){function r(){if(s){const h=s.activeEditor();if(h)return h.document.uri;const u=n.tabGroups.all.find(l=>l.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof L.$SM||u.input instanceof L.$XM)return u.input.modified;if(u.input instanceof L.$RM||u.input instanceof L.$WM||u.input instanceof L.$UM)return u.input.uri}}}super({getFolderUri:h=>{const u=t.folders.filter(l=>l.name===h);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(h,u)=>c.getConfiguration(void 0,h).get(u),getAppRoot:()=>I.cwd(),getExecPath:()=>I.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=r();if(h)return g.$hc(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const h=r();if(h){const u=i.getWorkspaceFolder(h);if(u)return g.$hc(u.uri.fsPath)}}},getSelectedText:()=>{if(s){const h=s.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(s){const h=s.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>o.getExtension(h)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(I.env))}}let d=class extends T.$Tc{constructor(o,i,s,n,c){super(),this.b=o,this.c=i,this.g=s,this.h=n,this.j=c,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$phc=d,e.$phc=d=Ge([Ve(0,y.$lhc),Ve(1,C.$Jgc),Ve(2,b.$mN),Ve(3,p.$Mgc),Ve(4,$.$Ygc)],d)}),define(ke[97],Se([1,0,11,4,2,5,6,71,47,20,7,41,140,281,42,59]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=e.$thc=e.$shc=e.$rhc=e.$qhc=void 0,e.$qhc=(0,I.$6h)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,r,h,u,l,k){this.E=r,this.F=h,this.G=u,this.H=l,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Vd,this.n=new T.$Vd,this.o=new T.$Vd,this.u=new T.$Vd,this.k=a.getProxy(R.$0K.MainThreadDebugService),this.y=new T.$Vd,this.A=new T.$Vd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(A=>{A.onDidChange(v=>{this.J(A)}),this.J(A)})}asDebugSourceUri(a,r){const h=a;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let u=`debug:${encodeURIComponent(h.path||"")}`,l="?";return r&&(u+=`${l}session=${encodeURIComponent(r.id)}`,l="&"),u+=`${l}ref=${h.sourceReference}`,g.URI.parse(u)}else{if(h.path)return g.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(a){const r=[];for(const h of a.getAllExtensionDescriptions())if(h.contributes){const u=h.contributes.debuggers;if(u&&u.length>0)for(const l of u)(0,p.$bG)(l)&&r.push(l.type)}this.k.$registerDebugTypes(r)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const a=[];return this.w.forEach(r=>a.push(r)),a}addBreakpoints(a){const r=a.filter(l=>{const k=l.id;return this.w.has(k)?!1:(this.w.set(k,l),!0)});this.U(r,[],[]);const h=[],u=new Map;for(const l of r)if(l instanceof L.$_L){let k=u.get(l.location.uri.toString());k||(k={type:"sourceMulti",uri:l.location.uri,lines:[]},u.set(l.location.uri.toString(),k),h.push(k)),k.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof L.$aM&&h.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(h)}removeBreakpoints(a){const r=a.filter(k=>this.w.delete(k.id));this.U([],r,[]);const h=r.filter(k=>k instanceof L.$_L).map(k=>k.id),u=r.filter(k=>k instanceof L.$aM).map(k=>k.id),l=r.filter(k=>k instanceof L.$bM).map(k=>k.id);return this.k.$unregisterBreakpoints(h,u,l)}startDebugging(a,r,h){return this.k.$startDebugging(a?a.uri:void 0,r,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===L.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,suppressSaveBeforeStart:h.suppressSaveBeforeStart,suppressDebugStatusbar:h.suppressDebugStatusbar??h.debugUI?.simple,suppressDebugToolbar:h.suppressDebugToolbar??h.debugUI?.simple,suppressDebugView:h.suppressDebugView??h.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,r,h){if(!r)return new L.$_K(()=>{});const u=this.d++;return this.f.push({type:a,handle:u,provider:r}),this.k.$registerDebugConfigurationProvider(a,h,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,u),new L.$_K(()=>{this.f=this.f.filter(l=>l.provider!==r),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(a,r,h){if(!h)return new L.$_K(()=>{});if(!this.Q(a,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.N(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:r,handle:u,factory:h}),this.k.$registerDebugAdapterDescriptorFactory(r,u),new L.$_K(()=>{this.h=this.h.filter(l=>l.factory!==h),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(a,r){if(!r)return new L.$_K(()=>{});const h=this.i++;return this.j.push({type:a,handle:h,factory:r}),new L.$_K(()=>{this.j=this.j.filter(u=>u.factory!==r)})}async $runInTerminal(a,r){return Promise.resolve(void 0)}async $substituteVariables(a,r){let h;const u=await this.W(a);return u&&(h={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(h,r)}K(a,r){if(a.type==="implementation")return new n(a.implementation)}L(){}async $startDASession(a,r){const h=this,u=await this.V(r);return this.S(this.N(u.type),u).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const k=this.M(l),A=this.K(k,u);if(!A)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const v=A;return this.B.set(a,v),this.R(u).then(w=>(w&&this.C.set(a,w),v.onMessage(async E=>{if(E.type==="request"&&E.command==="handshake"){const P=E,N={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const z=await this.D.sign(P.arguments.value);N.body={signature:z},v.sendResponse(N)}else throw new Error("no signer")}catch(z){N.success=!1,N.message=z.message,v.sendResponse(N)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(E),E=(0,p.$gG)(E,!0),h.k.$acceptDAMessage(a,E)}),v.onError(E=>{w&&w.onError&&w.onError(E),this.k.$acceptDAError(a,E.name,E.message,E.stack)}),v.onExit(E=>{w&&w.onExit&&w.onExit(E??void 0,void 0),this.k.$acceptDAExit(a,E??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),v.startSession()))})}$sendDAMessage(a,r){r=(0,p.$fG)(r,!1);const h=this.C.get(a);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(r),this.B.get(a)?.sendMessage(r)}$stopDASession(a){const r=this.C.get(a);this.C.delete(a),r&&r.onWillStopSession&&r.onWillStopSession();const h=this.B.get(a);return this.B.delete(a),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const r=[],h=[],u=[];if(a.added)for(const l of a.added){const k=l.id;if(k&&!this.w.has(k)){let A;if(l.type==="function")A=new L.$aM(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")A=new L.$bM(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const v=g.URI.revive(l.uri);A=new L.$_L(new L.$lL(v,new L.$aL(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,L.$0L)(A,k),this.w.set(k,A),r.push(A)}}if(a.removed)for(const l of a.removed){const k=this.w.get(l);k&&(this.w.delete(l),h.push(k))}if(a.changed){for(const l of a.changed)if(l.id){const k=this.w.get(l.id);if(k){if(k instanceof L.$aM&&l.type==="function"){const A=k;A.enabled=l.enabled,A.condition=l.condition,A.hitCondition=l.hitCondition,A.logMessage=l.logMessage,A.functionName=l.functionName}else if(k instanceof L.$_L&&l.type==="source"){const A=k;A.enabled=l.enabled,A.condition=l.condition,A.hitCondition=l.hitCondition,A.logMessage=l.logMessage,A.location=new L.$lL(g.URI.revive(l.uri),new L.$aL(l.line,l.character))}u.push(k)}}}this.U(r,h,u)}async $acceptStackFrameFocus(a){let r;const h=a.sessionId?await this.V(a.sessionId):void 0;if(!h)throw new Error("no DebugSession found for debug focus context");a.kind==="thread"?r=new L.$hM(h,a.threadId):r=new L.$gM(h,a.threadId,a.frameId),this.z=r,this.A.fire(this.z)}$provideDebugConfigurations(a,r,h){return(0,D.$Yg)(async()=>{const u=this.P(a);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.W(r);return u.provideDebugConfigurations(l,h)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(a,r,h,u){return(0,D.$Yg)(async()=>{const l=this.P(a);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(r);return l.resolveDebugConfiguration(k,h,u)})}$resolveDebugConfigurationWithSubstitutedVariables(a,r,h,u){return(0,D.$Yg)(async()=>{const l=this.P(a);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(r);return l.resolveDebugConfigurationWithSubstitutedVariables(k,h,u)})}async $provideDebugAdapter(a,r){const h=this.O(a);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(r);return this.S(h,u).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.M(l)})}async $acceptDebugSessionStarted(a){const r=await this.V(a);this.m.fire(r)}async $acceptDebugSessionTerminated(a){const r=await this.V(a);r&&(this.n.fire(r),this.l.delete(r.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,r){(await this.V(a))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(a,r){const u={session:await this.V(a),event:r.event,body:r.body};this.u.fire(u)}M(a){if(a instanceof L.$cM)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof L.$dM)return{type:"server",port:a.port,host:a.host};if(a instanceof L.$eM)return{type:"pipeServer",path:a.path};if(a instanceof L.$fM)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}N(a){const r=this.h.filter(h=>h.type===a);if(r.length>0)return r[0].factory}O(a){const r=this.h.filter(h=>h.handle===a);if(r.length>0)return r[0].factory}P(a){const r=this.f.filter(h=>h.handle===a);if(r.length>0)return r[0].provider}Q(a,r){if(a.contributes){const h=a.contributes.debuggers;if(h&&h.length>0){for(const u of h)if(u.label&&u.type&&u.type===r)return!0}}return!1}R(a){const h=a.configuration.type,u=this.j.filter(l=>l.type===h||l.type==="*").map(l=>(0,D.$Yg)(()=>l.factory.createDebugAdapterTracker(a)).then(k=>k,k=>null));return Promise.race([Promise.all(u).then(l=>{const k=l.filter(A=>!!A);if(k.length>0)return new s(k)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async S(a,r){const h=r.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new L.$dM(h));if(a){const l=await this.F.getExtensionRegistry();return(0,D.$Yg)(()=>a.createDebugAdapterDescriptor(r,this.T(r,l))).then(k=>{if(k)return k})}const u=await this.F.getExtensionRegistry();return Promise.resolve(this.T(r,u))}T(a,r){}U(a,r,h){(a.length>0||r.length>0||h.length>0)&&this.y.fire(Object.freeze({added:a,removed:r,changed:h}))}async V(a){if(a)if(typeof a=="string"){const r=this.l.get(a);if(r)return r}else{let r=this.l.get(a.id);if(!r){const h=await this.W(a.folderUri),u=a.parent?this.l.get(a.parent):void 0;r=new o(this.k,a.id,a.type,a.name,h,a.configuration,u),this.l.set(r.id,r),this.k.$sessionCached(r.id)}return r}throw new Error("cannot find session")}W(a){if(a){const r=g.URI.revive(a);return this.E.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};e.$rhc=f,e.$rhc=f=Ge([Ve(0,y.$bN),Ve(1,C.$Jgc),Ve(2,$.$lhc),Ve(3,S.$Mgc),Ve(4,b.$Ygc),Ve(5,d.$ohc)],f);class o{constructor(a,r,h,u,l,k,A){this.d=a,this.f=r,this.g=h,this.h=u,this.i=l,this.j=k,this.k=A}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,r){return this.d.$customDebugAdapterRequest(this.f,a,r)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.$shc=o;class i{constructor(a){this.value=Object.freeze({append(r){a.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.$thc=i;class s{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(r=>r.onError?r.onError(a):void 0)}onExit(a,r){this.d.forEach(h=>h.onExit?h.onExit(a,r):void 0)}}class n extends m.$Nlb{constructor(a){super(),this.h=a,a.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends f{constructor(a,r,h,u,l,k){super(a,r,h,u,l,k)}};e.$uhc=c,e.$uhc=c=Ge([Ve(0,y.$bN),Ve(1,C.$Jgc),Ve(2,$.$lhc),Ve(3,S.$Mgc),Ve(4,b.$Ygc),Ve(5,d.$ohc)],c)}),define(ke[365],Se([1,0,14,57,2,6,308,13,84,107,27,247,20,66,47,91]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=e.$wic=void 0;class f{static async installEarlyHandler(s){Error.stackTraceLimit=100;const n=s.get(b.$nj),t=s.get(m.$bN).getProxy(I.$0K.MainThreadErrors);D.setUnexpectedErrorHandler(a=>{n.error(a);const r=D.$3(a);t.$onUnexpectedError(r)})}static async installFullHandler(s){const n=s.get(b.$nj),c=s.get(m.$bN),t=s.get(S.$lhc),a=s.get(d.$vN),r=c.getProxy(I.$0K.MainThreadExtensionService),h=c.getProxy(I.$0K.MainThreadErrors),u=await t.getExtensionPathIndex(),l=new WeakMap;function k(w,E){if(l.has(w))return l.get(w).stack;let P="",N,z;for(const j of E)P+=`
	at ${j.toString()}`,z=j.getFileName(),!N&&z&&(N=u.findSubstr(g.URI.file(z)));const F=`${w.name||"Error"}: ${w.message||""}${P}`;return l.set(w,{extensionIdentifier:N?.identifier,stack:F}),F}const A=Symbol("prepareStackTrace wrapped");let v=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(w){if(w===k||!w||w[A]){v=w||k;return}v=function(E,P){return k(E,P),w.call(Error,E,P)},Object.assign(v,{[A]:!0})}}),D.setUnexpectedErrorHandler(w=>{n.error(w);const E=D.$3(w),P=l.get(w);if(!P?.extensionIdentifier){h.$onUnexpectedError(E);return}r.$onExtensionRuntimeError(P.extensionIdentifier,E);const N=a.onExtensionError(P.extensionIdentifier,w);n.trace("forwarded error to extension?",N,P)})}}e.$wic=f;class o{constructor(s,n,c,t,a){this.a=c,this.b=new R.$B8b(s,null,t),n=o.e(n,this.b);const r=new y.$4h(...(0,$.$Zr)());r.set(L.$rN,{_serviceBrand:void 0,...n,messagePorts:a}),r.set(m.$bN,new m.$cN(this.b)),r.set(p.$Ggc,new p.$Hgc(t)),r.set(S.$jhc,c);const h=new C.$Eq(r,!0);h.invokeFunction(f.installEarlyHandler),this.d=h.invokeFunction(u=>u.get(b.$nj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=h.invokeFunction(u=>u.get(S.$lhc)),this.c.initialize(),h.invokeFunction(f.installFullHandler)}async asBrowserUri(s){const n=this.b.getProxy(I.$0K.MainThreadExtensionService);return g.URI.revive(await n.$asBrowserUri(s))}terminate(s){this.c.terminate(s)}static e(s,n){s.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(n.transformIncomingURIs(t.extensionLocation))}),s.environment.appRoot=g.URI.revive(n.transformIncomingURIs(s.environment.appRoot));const c=s.environment.extensionDevelopmentLocationURI;return c&&(s.environment.extensionDevelopmentLocationURI=c.map(t=>g.URI.revive(n.transformIncomingURIs(t)))),s.environment.extensionTestsLocationURI=g.URI.revive(n.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=g.URI.revive(n.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=g.URI.revive(n.transformIncomingURIs(s.environment.workspaceStorageHome)),s.environment.extensionTelemetryLogResource=g.URI.revive(n.transformIncomingURIs(s.environment.extensionTelemetryLogResource)),s.nlsBaseUrl=g.URI.revive(n.transformIncomingURIs(s.nlsBaseUrl)),s.logsLocation=g.URI.revive(n.transformIncomingURIs(s.logsLocation)),s.workspace=n.transformIncomingURIs(s.workspace),s}}e.$xic=o}),define(ke[366],Se([1,0,11,10,222,241,138,97,71,47,20,46,7,59,41,282,283,42]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;let i=class extends b.$rhc{constructor(a,r,h,u,l,k,A){super(a,r,h,u,k,A),this.Z=l,this.X=new c}K(a,r){switch(a.type){case"server":return new d.$Cic(a);case"pipeServer":return new d.$Dic(a);case"executable":return new d.$Eic(a,r.type)}return super.K(a,r)}T(a,r){const h=d.$Eic.platformAdapterExecutable(r.getAllExtensionDescriptions(),a.type);if(h)return new m.$cM(h.command,h.args,h.options)}L(){return new R.$o_b}async $runInTerminal(a,r){if(a.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const h=await this.G.getConfigProvider(),u=this.Z.getDefaultShell(!0),l=this.Z.getDefaultShellArgs(!0),k=a.title||g.localize(0,null),A=JSON.stringify({shell:u,shellArgs:l});let v=await this.X.checkout(A,k),w,E=!1;if(v)w=a.cwd;else{const F={shellPath:u,shellArgs:l,cwd:a.cwd,name:k,iconPath:new m.$7L("debug")};E=!0,v=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(v,A)}v.show(!0);const P=await v.processId;E?await new Promise(F=>setTimeout(F,1e3)):h.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?v.sendText("cls"):u.indexOf("bash")>=0?v.sendText("clear"):T.$i?v.sendText("cls"):v.sendText("clear"));const N=(0,f.$Gic)(u,a.args,!!a.argsCanBeInterpretedByShell,w,a.env);v.sendText(N);const z=this.onDidTerminateDebugSession(F=>{F.id===r&&(this.X.free(v),z.dispose())});return P}else if(a.kind==="external")return n(a,await this.G.getConfigProvider());return super.$runInTerminal(a,r)}};e.$Hic=i,e.$Hic=i=Ge([Ve(0,L.$bN),Ve(1,S.$Jgc),Ve(2,y.$lhc),Ve(3,o.$Mgc),Ve(4,C.$$gc),Ve(5,$.$Ygc),Ve(6,p.$ohc)],i);let s;function n(t,a){if(!s)if(T.$i)s=new I.$a$b;else if(T.$j)s=new I.$b$b;else if(T.$k)s=new I.$c$b;else throw new Error("external terminals not supported on this platform");const r=a.getConfiguration("terminal");return s.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class c{constructor(){this.b=new Map}static{this.a=1e3}async checkout(a,r){const u=[...this.b.entries()].map(([l,k])=>(0,D.$Tg)(async A=>{if(l.name!==r||k.lastUsedAt!==-1&&await(0,f.$Fic)(await l.processId))return null;const v=Date.now();return k.lastUsedAt+c.a>v||A.isCancellationRequested||k.config!==a?null:(k.lastUsedAt=v,l)}));return await(0,D.$$g)(u,l=>!!l)}insert(a,r){this.b.set(a,{lastUsedAt:Date.now(),config:r})}free(a){const r=this.b.get(a);r&&(r.lastUsedAt=-1)}onTerminalClosed(a){this.b.delete(a)}}}),define(ke[367],Se([1,0,17,2,105,41,72,42,40,46,20,27,96,16,13,92,23,63,59]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;let s=class extends m.$bic{constructor(c,t,a,r,h,u,l,k,A){super(c,t,a,r,h,u,l,k),this.C=a,this.D=A,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(c,t){const a=t;if(!t.execution&&a._id===void 0)throw new Error("Tasks to execute must include an execution");if(a._id!==void 0){const r=m.TaskHandleDTO.from(a,this.C),h=await this.a.$getTaskExecution(r);if(h.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.z(h,t);return this.a.$executeTask(r).catch(()=>{}),u}else{const r=m.TaskDTO.from(t,c);if(r===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(r.execution)&&await this.y(r,t,!1);const h=await this.z(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),h}}v(c,t,a,r){const h=[];if(r)for(const u of r){this.A(u,a),(!u.definition||!c[u.definition.type])&&this.f.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const l=m.TaskDTO.from(u,a.extension);l&&(h.push(l),m.CustomExecutionDTO.is(l.execution)&&t.push(this.y(l,u,!0)))}return{tasks:h,extension:a.extension}}async w(c){return c}async G(c){let t=c&&c.length>0?c[0]:void 0;if(!t){const a=T.URI.file((0,o.homedir)());t=new $.$ni({uri:a,name:f.$Eg(a),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(c,t){const a=T.URI.revive(c),r={process:void 0,variables:Object.create(null)},h=await this.b.resolveWorkspaceFolder(a),u=await this.b.getWorkspaceFolders2()??[],l=await this.D.getResolver(),k=h?{uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(u);for(const A of t.variables)r.variables[A]=await l.resolveAsync(k,A);if(t.process!==void 0){let A;if(t.process.path!==void 0){A=t.process.path.split(D.$tc);for(let v=0;v<A.length;v++)A[v]=await l.resolveAsync(k,A[v])}r.process=await g.win32.findExecutable(await l.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(k,t.process.cwd):void 0,A)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(c,t,a){return g.win32.findExecutable(c,t,a)}};e.$zic=s,e.$zic=s=Ge([Ve(0,L.$bN),Ve(1,C.$rN),Ve(2,I.$Jgc),Ve(3,R.$mN),Ve(4,b.$Mgc),Ve(5,y.$$gc),Ve(6,S.$nj),Ve(7,d.$rgc),Ve(8,i.$ohc)],s)}),define(ke[368],Se([1,0,63,59]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0;class g extends T.$phc{m(){return(0,D.homedir)()}}e.$fjc=g}),define(ke[154],Se([1,0,19,11,21,44,16,17,23,2,36]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=e.$Khc=e.$Jhc=e.$Ihc=void 0;class C{constructor(i,s,n,c){this.d=i,this.e=s,this.f=n,this.g=c,this.a=null,this.b=!1,this.c=0}search(i,s){const n=this.d.folderQueries||[],c=new g.$6d(s);return new Promise((t,a)=>{this.a=new p(i);let r=!1;const h=(u,l)=>{if(!r&&!this.b){const k=this.h(u);d(u)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,r=!0,c.cancel(),u=this.j(u,this.d.maxResults-this.c));const A=this.h(u);this.c+=A,(A>0||!d(u))&&this.a.add(u,l)}};Promise.all(n.map((u,l)=>this.k(u,k=>h(k,l),c.token))).then(u=>{c.dispose(),this.a.flush();const l=u.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||l,messages:(0,D.$Rb)(u.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},u=>{c.dispose();const l=(0,I.$Qi)(u);a(new Error(l))})})}h(i){return d(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,s){const n=Array.isArray(i.ranges)?i.ranges:[i.ranges],c=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:n.slice(0,s),preview:{matches:c.slice(0,s),text:i.preview.text},uri:i.uri}}async k(i,s,n){const c=new L.$NJ(this.d,i),t=[],a={report:u=>{if(!this.l(u))return;const l=i.folder.scheme===R.Schemas.file?(0,L.$OJ)(()=>this.f.readdir($.$Gg(u.uri))):void 0,k=$.$Jg(i.folder,u.uri);if(k){const A=c.includedInQuery(k,b.$nc(k),l);(0,T.$Sg)(A)?t.push(A.then(v=>{v&&s(u)})):A&&s(u)}}},r=this.n(i),h=await this.e.provideTextSearchResults(m(this.d.contentPattern),r,a,n);return t.length&&await Promise.all(t),h}l(i){if(d(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const s=(0,L.$MJ)(this.d.includePattern,i.includePattern),n=(0,L.$MJ)(this.d.excludePattern,i.excludePattern),c={folder:y.URI.from(i.folder),excludes:n,includes:s,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return c.usePCRE2=this.d.usePCRE2,c}}e.$Ihc=C;function m(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class p{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new f(512,s=>this.g(s))}add(i,s){this.d&&(this.b!==s||!$.$Ag(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=s,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Jhc=p;function S(o){return d(o)?{preview:{matches:(0,D.$2b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,D.$2b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function d(o){return!!o.preview}e.$Khc=d;class f{static{this.a=4e3}static{this.b=50}constructor(i,s){this.g=i,this.h=s,this.c=0,this.d=[],this.e=0}addItem(i,s){i&&this.j(i,s)}addItems(i,s){i&&this.k(i,s)}j(i,s){this.d.push(i),this.e+=s,this.l()}k(i,s){this.d=this.d.concat(i),this.e+=s,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Lhc=f}),define(ke[98],Se([1,0,3,6,5,361,20,66,13,2,154]),function(me,e,D,T,g,I,R,b,$,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=e.$Nhc=e.$Mhc=void 0,e.$Mhc=(0,g.$6h)("IExtHostSearch");let C=class{constructor(d,f,o){this.k=d,this.l=f,this.n=o,this.c=this.k.getProxy(T.$0K.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new I.$Hhc}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,f){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const o=this.d++;return this.e.set(o,f),this.c.$registerTextSearchProvider(o,this.o(d)),(0,D.$Rc)(()=>{this.g.delete(d),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(d,f){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const o=this.d++;return this.h.set(o,f),this.c.$registerFileSearchProvider(o,this.o(d)),(0,D.$Rc)(()=>{this.i.delete(d),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(d,f,o,i){const s=m(o),n=this.h.get(d);if(n)return this.j.fileSearch(s,n,c=>{this.c.$handleFileMatch(d,f,c.map(t=>t.resource))},i);throw new Error("unknown provider: "+d)}async doInternalFileSearchWithCustomCallback(d,f,o){return{messages:[]}}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,f,o,i){const s=this.e.get(d);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const n=m(o);return this.q(n,s).search(t=>this.c.$handleTextMatch(d,f,t),i)}$enableExtensionHostSearch(){}q(d,f){return new L.$Ihc(d,f,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$Nhc=C,e.$Nhc=C=Ge([Ve(0,R.$bN),Ve(1,b.$Ggc),Ve(2,$.$nj)],C);function m(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(p),extraFileResources:S.extraFileResources&&S.extraFileResources.map(d=>y.URI.revive(d))}}e.$Ohc=m;function p(S){return{...S,folder:y.URI.revive(S.folder)}}}),define(ke[369],Se([1,0,21,14,4,3,16,39,2,132,191,172,79,26,32,13,65,88,266,6,310,340,92,311,316,317,318,319,320,297,286,35,321,42,322,97,147,323,299,312,324,325,72,71,313,47,326,69,327,58,27,341,342,314,300,328,329,114,115,301,360,331,272,332,343,333,152,302,334,335,336,20,337,98,116,338,303,339,117,94,96,91,46,344,345,315,346,347,70,15,7,304,66,305,93,348,349,146,41,280,113,25,95]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c,t,a,r,h,u,l,k,A,v,w,E,P,N,z,F,j,M,O,U,Q,ue,Z,J,X,le,x,be,ce,G,W,ne,ye,de,ge,_,te,K,ie,fe,pe,Pe,we,Ce,B,Y,ee,q,oe,he,Le,je,He,Qe,_e,at,st,rt,Ae,ze,Re,Ye,re,se,Ie,qe,Xe,it,nt,Oe,yt,Dt,Nt,Ft,Et,Ht,Ot,Xt,Vt,Ut,et,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=void 0;function Jt(ht){const $t=ht.get(G.$rN),Bt=ht.get(ce.$ogc),Qt=ht.get(x.$Ogc),kt=ht.get(X.$lhc),ft=ht.get(Xt.$Jgc),It=ht.get(Re.$vN),_t=ht.get(P.$Mgc),At=ht.get(Dt.$Ggc),Je=ht.get(Le.$bN),Mt=ht.get(rt.$8gc),jt=ht.get(Ae.$Pgc),Yt=ht.get(d.$oj),gt=ht.get(d.$nj),Tt=ht.get(it.$vyb),Rt=ht.get(t.$rgc),Wt=ht.get(Ot.$qic),Me=ht.get(Qe.$dhc),Fe=ht.get(Z.$Ygc),De=ht.get(K.$hhc);Je.set(s.$$K.ExtHostFileSystemInfo,Bt),Je.set(s.$$K.ExtHostLogLevelServiceShape,Yt),Je.set(s.$$K.ExtHostWorkspace,ft),Je.set(s.$$K.ExtHostConfiguration,_t),Je.set(s.$$K.ExtHostExtensionService,kt),Je.set(s.$$K.ExtHostStorage,Mt),Je.set(s.$$K.ExtHostTunnelService,Tt),Je.set(s.$$K.ExtHostWindow,Wt),Je.set(s.$$K.ExtHostSecretState,Me),Je.set(s.$$K.ExtHostTelemetry,It),Je.set(s.$$K.ExtHostEditorTabs,Fe),Je.set(s.$$K.ExtHostManagedSockets,De);const ae=Je.set(s.$$K.ExtHostDecorations,ht.get(F.$whc)),Ne=Je.set(s.$$K.ExtHostDocumentsAndEditors,ht.get(ue.$mN)),Ue=Je.set(s.$$K.ExtHostCommands,ht.get(w.$xN)),xe=Je.set(s.$$K.ExtHostTerminalService,ht.get(Ye.$$gc)),Ke=Je.set(s.$$K.ExtHostDebugService,ht.get(z.$qhc)),ct=Je.set(s.$$K.ExtHostSearch,ht.get(He.$Mhc)),pt=Je.set(s.$$K.ExtHostTask,ht.get(ze.$dic)),Kt=Je.set(s.$$K.ExtHostOutputService,ht.get(Y.$3hc)),St=Je.set(s.$$K.ExtHostLocalization,ht.get(te.$ghc)),Ct=Je.set(s.$$K.ExtHostUrls,new Nt.$nic(Je)),wt=Je.set(s.$$K.ExtHostDocuments,new Q.$mgc(Je,Ne)),Di=Je.set(s.$$K.ExtHostDocumentContentProviders,new O.$yhc(Je,Ne,gt)),Ki=Je.set(s.$$K.ExtHostDocumentSaveParticipant,new U.$zhc(gt,wt,Je.getProxy(s.$0K.MainThreadBulkEdits))),Pt=Je.set(s.$$K.ExtHostNotebook,new fe.$Phc(Je,Ue,Ne,wt,Qt,ct)),si=Je.set(s.$$K.ExtHostNotebookDocuments,new Pe.$Whc(Pt)),mi=Je.set(s.$$K.ExtHostNotebookEditors,new we.$Xhc(gt,Pt)),ui=Je.set(s.$$K.ExtHostNotebookKernels,new Ce.$Yhc(Je,$t,Pt,Ue,gt)),Ci=Je.set(s.$$K.ExtHostNotebookRenderers,new B.$1hc(Je,Pt)),Ii=Je.set(s.$$K.ExtHostNotebookDocumentSaveParticipant,new pe.$Vhc(gt,Pt,Je.getProxy(s.$0K.MainThreadBulkEdits))),zt=Je.set(s.$$K.ExtHostEditors,new se.$Dgc(Je,Ne)),$i=Je.set(s.$$K.ExtHostTreeViews,new Xe.$lic(Je.getProxy(s.$0K.MainThreadTreeViews),Ue,gt)),Pi=Je.set(s.$$K.ExtHostEditorInsets,new v.$Egc(Je.getProxy(s.$0K.MainThreadEditorInsets),zt,$t.remote)),li=Je.set(s.$$K.ExtHostDiagnostics,new j.$qgc(Je,gt,Bt,Ne)),hi=Je.set(s.$$K.ExtHostLanguages,new _.$Thc(Je,wt,Ue.converter,At)),dt=Je.set(s.$$K.ExtHostLanguageFeatures,new ge.$ugc(Je,At,wt,Ue,li,gt,Rt,It)),Ji=Je.set(s.$$K.ExtHostFileSystem,new le.$Bhc(Je,dt)),ei=Je.set(s.$$K.ExtHostFileSystemEventService,new be.$Chc(Je,gt,Ne)),oi=Je.set(s.$$K.ExtHostQuickOpen,(0,he.$7hc)(Je,ft,Ue)),bi=Je.set(s.$$K.ExtHostSCM,new je.$9hc(Je,Ue,wt,gt)),Ai=Je.set(s.$$K.ExtHostQuickDiff,new oe.$6hc(Je,At)),Qi=Je.set(s.$$K.ExtHostShare,new _e.$0hc(Je,At)),Ri=Je.set(s.$$K.ExtHostComments,(0,E.$Fgc)(Je,Ue,wt)),wi=Je.set(s.$$K.ExtHostProgress,new q.$5hc(Je.getProxy(s.$0K.MainThreadProgress))),Yi=Je.set(s.$$K.ExtHostLabelService,new de.$Shc(Je)),Li=Je.set(s.$$K.ExtHostTheming,new Ie.$iic(Je)),di=Je.set(s.$$K.ExtHostAuthentication,new a.$wgc(Je)),Xi=Je.set(s.$$K.ExtHostTimeline,new qe.$kic(Je,Ue)),vi=Je.set(s.$$K.ExtHostWebviews,new Ft.$Tgc(Je,$t.remote,ft,gt,Rt)),Mi=Je.set(s.$$K.ExtHostWebviewPanels,new Et.$Wgc(Je,vi,ft)),un=Je.set(s.$$K.ExtHostCustomEditors,new N.$Xgc(Je,wt,jt,vi,Mi)),Ti=Je.set(s.$$K.ExtHostWebviewViews,new Ht.$oic(Je,vi)),ai=Je.set(s.$$K.ExtHostTesting,new re.$eic(Je,gt,Ue,Ne)),ln=Je.set(s.$$K.ExtHostUriOpeners,new yt.$mic(Je)),hn=Je.set(s.$$K.ExtHostProfileContentHandlers,new ee.$4hc(Je));Je.set(s.$$K.ExtHostInteractive,new ne.$Qhc(Je,Pt,Ne,Ue,gt));const Zi=Je.set(s.$$K.ExtHostInlineChat,new W.$Dhc(Je,Ue,wt,gt)),fi=Je.set(s.$$K.ExtHostChatProvider,new l.$zgc(Je,gt)),xi=Je.set(s.$$K.ExtHostChatAgents2,new u.$Agc(Je,fi,gt)),_i=Je.set(s.$$K.ExtHostChatVariables,new k.$Bgc(Je)),pi=Je.set(s.$$K.ExtHostChat,new h.$ygc(Je)),en=Je.set(s.$$K.ExtHostAiRelatedInformation,new n.$lgc(Je)),Ni=Je.set(s.$$K.ExtHostAiEmbeddingVector,new J.$Ahc(Je)),Fi=Je.set(s.$$K.ExtHostIssueReporter,new ye.$Rhc(Je)),ti=Je.set(s.$$K.ExtHostStatusBar,new st.$aic(Je,Ue.converter)),yi=Je.set(s.$$K.ExtHostSpeech,new at.$$hc(Je)),dn=Object.values(s.$$K);Je.assertRegistered(dn);const Zt=new r.$xgc(Je,Ne),Ei=new A.$Cgc(Je),ki=new ie.$Uhc(Je,gt),Oi=new M.$xhc(Je);return c.$vgc.register(Ue),function(We,ii,tn){function ot($e){return(Ee,Be,ut)=>{const vt=$e(Lt=>{try{Ee.call(Be,Lt)}catch(cn){T.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event`,{cause:cn})),It.onExtensionError(We.identifier,cn)}});return ut?.push(vt),vt}}const bt=function(){let $e=!We.isUnderDevelopment;function Ee(){$e||(gt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function Be(ut){if(Array.isArray(ut))ut.forEach(Be);else if(typeof ut=="string")Ee();else{const vt=ut;typeof vt.scheme>"u"&&Ee(),typeof vt.exclusive=="boolean"&&(0,et.$GF)(We,"documentFiltersExclusive")}return ut}}(),fn={getSession($e,Ee,Be){return di.getSession(We,$e,Ee,Be)},getSessions($e,Ee){return(0,et.$GF)(We,"authGetSessions"),di.getSessions(We,$e,Ee)},async hasSession($e,Ee){return(0,et.$GF)(We,"authSession"),!!await di.getSession(We,$e,Ee,{silent:!0})},get onDidChangeSessions(){return ot(di.onDidChangeSessions)},registerAuthenticationProvider($e,Ee,Be,ut){return di.registerAuthenticationProvider($e,Ee,Be,ut)}},gn={registerCommand($e,Ee,Be){return Ue.registerCommand(!0,$e,Ee,Be,void 0,We)},registerTextEditorCommand($e,Ee,Be){return Ue.registerCommand(!0,$e,(...ut)=>{const vt=zt.getActiveTextEditor();if(!vt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return vt.edit(Lt=>{Ee.apply(Be,[vt,Lt,...ut])}).then(Lt=>{Lt||gt.warn("Edits from command "+$e+" were not applied.")},Lt=>{gt.warn("An error occurred while running command "+$e,Lt)})},void 0,void 0,We)},registerDiffInformationCommand:($e,Ee,Be)=>((0,et.$GF)(We,"diffCommand"),Ue.registerCommand(!0,$e,async(...ut)=>{const vt=Ne.activeEditor(!0);if(!vt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Lt=await zt.getDiffInformation(vt.id);Ee.apply(Be,[Lt,...ut])},void 0,void 0,We)),executeCommand($e,...Ee){return Ue.executeCommand($e,...Ee)},getCommands($e=!1){return Ue.getCommands($e)}},ji={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return xe.getDefaultShell(!1)},get onDidChangeShell(){return ot(xe.onDidChangeShell)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(It.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$GF)(We,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$GF)(We,"telemetry"),ot(It.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Re.$uN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Ee){return Re.$tN.validateSender($e),It.instantiateLogger(We,$e,Ee)},openExternal($e,Ee){return Wt.openUri($e,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===$t.environment.appUriScheme)return Ct.createAppUri($e);try{return await Wt.asExternalUri($e,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,R.$eg)($e,R.Schemas.http)||(0,R.$eg)($e,R.Schemas.https))return $e;throw Ee}},get remoteName(){return(0,f.$bl)($t.remote.authority)},get remoteAuthority(){return(0,et.$GF)(We,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return ot(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler($e){return(0,et.$GF)(We,"handleIssueUri"),Fi.registerIssueUriRequestHandler(We,$e)},registerIssueDataProvider($e){return(0,et.$GF)(We,"handleIssueUri"),Fi.registerIssueDataProvider(We,$e)},get appQuality(){return(0,et.$GF)(We,"resolvers"),$t.quality},get appCommit(){return(0,et.$GF)(We,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(ji);const zi={createTestController($e,Ee,Be){return ai.createTestController(We,$e,Ee,Be)},createTestObserver(){return(0,et.$GF)(We,"testObserver"),ai.createTestObserver()},runTests($e){return(0,et.$GF)(We,"testObserver"),ai.runTests($e)},get onDidChangeTestResults(){return(0,et.$GF)(We,"testObserver"),ot(ai.onResultsChanged)},get testResults(){return(0,et.$GF)(We,"testObserver"),ai.results}},gi=$t.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,nn={getExtension($e,Ee){(0,et.$FF)(We,"extensionsAny")||(Ee=!1);const Be=ii.mine.getExtensionDescription($e);if(Be)return new X.$mhc(kt,We.identifier,Be,gi,!1);if(Ee){const ut=ii.all.getExtensionDescription($e);if(ut)return new X.$mhc(kt,We.identifier,ut,gi,!0)}},get all(){const $e=[];for(const Ee of ii.mine.getAllExtensionDescriptions())$e.push(new X.$mhc(kt,We.identifier,Ee,gi,!1));return $e},get allAcrossExtensionHosts(){(0,et.$GF)(We,"extensionsAny");const $e=new p.$mm(ii.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),Ee=[];for(const Be of ii.all.getAllExtensionDescriptions()){const ut=!$e.has(Be.identifier);Ee.push(new X.$mhc(kt,We.identifier,Be,gi,ut))}return Ee},get onDidChange(){return(0,et.$FF)(We,"extensionsAny")?ot(g.Event.any(ii.mine.onDidChange,ii.all.onDidChange)):ot(ii.mine.onDidChange)}},rn={createDiagnosticCollection($e){return li.createDiagnosticCollection(We.identifier,$e)},get onDidChangeDiagnostics(){return ot(li.onDidChangeDiagnostics)},getDiagnostics:$e=>li.getDiagnostics($e),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage($e,Ee){return hi.changeLanguage($e.uri,Ee)},match($e,Ee){const Be=wt.getDocumentData(Ee.uri)?.notebook;return(0,L.$Bt)(nt.LanguageSelector.from($e),Ee.uri,Ee.languageId,!0,Be?.uri,Be?.notebookType)},registerCodeActionsProvider($e,Ee,Be){return dt.registerCodeActionProvider(We,bt($e),Ee,Be)},registerDocumentPasteEditProvider($e,Ee,Be){return(0,et.$GF)(We,"documentPaste"),dt.registerDocumentPasteEditProvider(We,bt($e),Ee,Be)},registerCodeLensProvider($e,Ee){return dt.registerCodeLensProvider(We,bt($e),Ee)},registerDefinitionProvider($e,Ee){return dt.registerDefinitionProvider(We,bt($e),Ee)},registerDeclarationProvider($e,Ee){return dt.registerDeclarationProvider(We,bt($e),Ee)},registerImplementationProvider($e,Ee){return dt.registerImplementationProvider(We,bt($e),Ee)},registerTypeDefinitionProvider($e,Ee){return dt.registerTypeDefinitionProvider(We,bt($e),Ee)},registerHoverProvider($e,Ee){return dt.registerHoverProvider(We,bt($e),Ee,We.identifier)},registerEvaluatableExpressionProvider($e,Ee){return dt.registerEvaluatableExpressionProvider(We,bt($e),Ee,We.identifier)},registerInlineValuesProvider($e,Ee){return dt.registerInlineValuesProvider(We,bt($e),Ee,We.identifier)},registerDocumentHighlightProvider($e,Ee){return dt.registerDocumentHighlightProvider(We,bt($e),Ee)},registerMultiDocumentHighlightProvider($e,Ee){return dt.registerMultiDocumentHighlightProvider(We,bt($e),Ee)},registerLinkedEditingRangeProvider($e,Ee){return dt.registerLinkedEditingRangeProvider(We,bt($e),Ee)},registerReferenceProvider($e,Ee){return dt.registerReferenceProvider(We,bt($e),Ee)},registerRenameProvider($e,Ee){return dt.registerRenameProvider(We,bt($e),Ee)},registerDocumentSymbolProvider($e,Ee,Be){return dt.registerDocumentSymbolProvider(We,bt($e),Ee,Be)},registerWorkspaceSymbolProvider($e){return dt.registerWorkspaceSymbolProvider(We,$e)},registerDocumentFormattingEditProvider($e,Ee){return dt.registerDocumentFormattingEditProvider(We,bt($e),Ee)},registerDocumentRangeFormattingEditProvider($e,Ee){return dt.registerDocumentRangeFormattingEditProvider(We,bt($e),Ee)},registerOnTypeFormattingEditProvider($e,Ee,Be,...ut){return dt.registerOnTypeFormattingEditProvider(We,bt($e),Ee,[Be].concat(ut))},registerDocumentSemanticTokensProvider($e,Ee,Be){return dt.registerDocumentSemanticTokensProvider(We,bt($e),Ee,Be)},registerDocumentRangeSemanticTokensProvider($e,Ee,Be){return dt.registerDocumentRangeSemanticTokensProvider(We,bt($e),Ee,Be)},registerSignatureHelpProvider($e,Ee,Be,...ut){return typeof Be=="object"?dt.registerSignatureHelpProvider(We,bt($e),Ee,Be):dt.registerSignatureHelpProvider(We,bt($e),Ee,typeof Be>"u"?[]:[Be,...ut])},registerCompletionItemProvider($e,Ee,...Be){return dt.registerCompletionItemProvider(We,bt($e),Ee,Be)},registerInlineCompletionItemProvider($e,Ee,Be){return Ee.handleDidShowCompletionItem&&(0,et.$GF)(We,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$GF)(We,"inlineCompletionsAdditions"),Be&&(0,et.$GF)(We,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(We,bt($e),Ee,Be)},registerDocumentLinkProvider($e,Ee){return dt.registerDocumentLinkProvider(We,bt($e),Ee)},registerColorProvider($e,Ee){return dt.registerColorProvider(We,bt($e),Ee)},registerFoldingRangeProvider($e,Ee){return dt.registerFoldingRangeProvider(We,bt($e),Ee)},registerSelectionRangeProvider($e,Ee){return dt.registerSelectionRangeProvider(We,$e,Ee)},registerCallHierarchyProvider($e,Ee){return dt.registerCallHierarchyProvider(We,$e,Ee)},registerTypeHierarchyProvider($e,Ee){return dt.registerTypeHierarchyProvider(We,$e,Ee)},setLanguageConfiguration:($e,Ee)=>dt.setLanguageConfiguration(We,$e,Ee),getTokenInformationAtPosition($e,Ee){return(0,et.$GF)(We,"tokenInformation"),hi.tokenAtPosition($e,Ee)},registerInlayHintsProvider($e,Ee){return dt.registerInlayHintsProvider(We,$e,Ee)},createLanguageStatusItem($e,Ee){return hi.createLanguageStatusItem(We,$e,Ee)},registerDocumentDropEditProvider($e,Ee,Be){return dt.registerDocumentOnDropEditProvider(We,$e,Ee,(0,et.$FF)(We,"dropMetadata")?Be:void 0)}},mn={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return xe.activeTerminal},get terminals(){return xe.terminals},async showTextDocument($e,Ee,Be){const ut=await($.URI.isUri($e)?Promise.resolve(sn.openTextDocument($e)):Promise.resolve($e));return zt.showTextDocument(ut,Ee,Be)},createTextEditorDecorationType($e){return zt.createTextEditorDecorationType(We,$e)},onDidChangeActiveTextEditor($e,Ee,Be){return ot(zt.onDidChangeActiveTextEditor)($e,Ee,Be)},onDidChangeVisibleTextEditors($e,Ee,Be){return ot(zt.onDidChangeVisibleTextEditors)($e,Ee,Be)},onDidChangeTextEditorSelection($e,Ee,Be){return ot(zt.onDidChangeTextEditorSelection)($e,Ee,Be)},onDidChangeTextEditorOptions($e,Ee,Be){return ot(zt.onDidChangeTextEditorOptions)($e,Ee,Be)},onDidChangeTextEditorVisibleRanges($e,Ee,Be){return ot(zt.onDidChangeTextEditorVisibleRanges)($e,Ee,Be)},onDidChangeTextEditorViewColumn($e,Ee,Be){return ot(zt.onDidChangeTextEditorViewColumn)($e,Ee,Be)},onDidCloseTerminal($e,Ee,Be){return ot(xe.onDidCloseTerminal)($e,Ee,Be)},onDidOpenTerminal($e,Ee,Be){return ot(xe.onDidOpenTerminal)($e,Ee,Be)},onDidChangeActiveTerminal($e,Ee,Be){return ot(xe.onDidChangeActiveTerminal)($e,Ee,Be)},onDidChangeTerminalDimensions($e,Ee,Be){return(0,et.$GF)(We,"terminalDimensions"),ot(xe.onDidChangeTerminalDimensions)($e,Ee,Be)},onDidChangeTerminalState($e,Ee,Be){return ot(xe.onDidChangeTerminalState)($e,Ee,Be)},onDidWriteTerminalData($e,Ee,Be){return(0,et.$GF)(We,"terminalDataWriteEvent"),ot(xe.onDidWriteTerminalData)($e,Ee,Be)},onDidExecuteTerminalCommand($e,Ee,Be){return(0,et.$GF)(We,"terminalExecuteCommandEvent"),ot(xe.onDidExecuteTerminalCommand)($e,Ee,Be)},get state(){return Wt.getState(We)},onDidChangeWindowState($e,Ee,Be){return ot(Wt.onDidChangeWindowState)($e,Ee,Be)},showInformationMessage($e,...Ee){return ki.showMessage(We,b.default.Info,$e,Ee[0],Ee.slice(1))},showWarningMessage($e,...Ee){return ki.showMessage(We,b.default.Warning,$e,Ee[0],Ee.slice(1))},showErrorMessage($e,...Ee){return ki.showMessage(We,b.default.Error,$e,Ee[0],Ee.slice(1))},showQuickPick($e,Ee,Be){return oi.showQuickPick(We,$e,Ee,Be)},showWorkspaceFolderPick($e){return oi.showWorkspaceFolderPick($e)},showInputBox($e,Ee){return oi.showInput($e,Ee)},showOpenDialog($e){return Oi.showOpenDialog(We,$e)},showSaveDialog($e){return Oi.showSaveDialog($e)},createStatusBarItem($e,Ee,Be){let ut,vt,Lt;return typeof $e=="string"?(ut=$e,vt=Ee,Lt=Be):(vt=$e,Lt=Ee),ti.createStatusBarEntry(We,ut,vt,Lt)},setStatusBarMessage($e,Ee){return ti.setStatusBarMessage($e,Ee)},withScmProgress($e){return Rt.report("window.withScmProgress",We,"Use 'withProgress' instead."),wi.withProgress(We,{location:Oe.ProgressLocation.SourceControl},(Ee,Be)=>$e({report(ut){}}))},withProgress($e,Ee){return wi.withProgress(We,$e,Ee)},createOutputChannel($e,Ee){return Kt.createOutputChannel($e,Ee,We)},createWebviewPanel($e,Ee,Be,ut){return Mi.createWebviewPanel(We,$e,Ee,Be,ut)},createWebviewTextEditorInset($e,Ee,Be,ut){return(0,et.$GF)(We,"editorInsets"),Pi.createWebviewEditorInset($e,Ee,Be,ut,We)},createTerminal($e,Ee,Be){return typeof $e=="object"?"pty"in $e?xe.createExtensionTerminal($e):xe.createTerminalFromOptions($e):xe.createTerminal($e,Ee,Be)},registerTerminalLinkProvider($e){return xe.registerLinkProvider($e)},registerTerminalProfileProvider($e,Ee){return xe.registerProfileProvider(We,$e,Ee)},registerTerminalQuickFixProvider($e,Ee){return(0,et.$GF)(We,"terminalQuickFixProvider"),xe.registerTerminalQuickFixProvider($e,We.identifier.value,Ee)},registerTreeDataProvider($e,Ee){return $i.registerTreeDataProvider($e,Ee,We)},createTreeView($e,Ee){return $i.createTreeView($e,Ee,We)},registerWebviewPanelSerializer:($e,Ee)=>Mi.registerWebviewPanelSerializer(We,$e,Ee),registerCustomEditorProvider:($e,Ee,Be={})=>un.registerCustomEditorProvider(We,$e,Ee,Be),registerFileDecorationProvider($e){return ae.registerFileDecorationProvider($e,We)},registerUriHandler($e){return Ct.registerUriHandler(We,$e)},createQuickPick(){return oi.createQuickPick(We)},createInputBox(){return oi.createInputBox(We)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme($e,Ee,Be){return ot(Li.onDidChangeActiveColorTheme)($e,Ee,Be)},registerWebviewViewProvider($e,Ee,Be){return Ti.registerWebviewViewProvider(We,$e,Ee,Be?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Ee,Be){return ot(Pt.onDidChangeActiveNotebookEditor)($e,Ee,Be)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection($e,Ee,Be){return ot(mi.onDidChangeNotebookEditorSelection)($e,Ee,Be)},onDidChangeNotebookEditorVisibleRanges($e,Ee,Be){return ot(mi.onDidChangeNotebookEditorVisibleRanges)($e,Ee,Be)},showNotebookDocument($e,Ee){return Pt.showNotebookDocument($e,Ee)},registerExternalUriOpener($e,Ee,Be){return(0,et.$GF)(We,"externalUriOpener"),ln.registerExternalUriOpener(We.identifier,$e,Ee,Be)},registerProfileContentHandler($e,Ee){return(0,et.$GF)(We,"profileContentHandlers"),hn.registerProfileContentHandler(We,$e,Ee)},registerQuickDiffProvider($e,Ee,Be,ut){return(0,et.$GF)(We,"quickDiffProvider"),Ai.registerQuickDiffProvider(bt($e),Ee,Be,ut)},get tabGroups(){return Fe.tabGroups},registerShareProvider($e,Ee){return(0,et.$GF)(We,"shareProvider"),Qi.registerShareProvider(bt($e),Ee)}},sn={get rootPath(){return Rt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath($e){throw new T.$9("rootPath")},getWorkspaceFolder($e){return ft.getWorkspaceFolder($e)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name($e){throw new T.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile($e){throw new T.$9("workspaceFile")},updateWorkspaceFolders:($e,Ee,...Be)=>ft.updateWorkspaceFolders(We,$e,Ee||0,...Be),onDidChangeWorkspaceFolders:function($e,Ee,Be){return ot(ft.onDidChangeWorkspace)($e,Ee,Be)},asRelativePath:($e,Ee)=>ft.getRelativePath($e,Ee),findFiles:($e,Ee,Be,ut)=>ft.findFiles($e,Ee,Be,We.identifier,ut),findTextInFiles:($e,Ee,Be,ut)=>{(0,et.$GF)(We,"findTextInFiles");let vt,Lt;return typeof Ee=="object"?(vt=Ee,Lt=Be):(vt={},Lt=Ee,ut=Be),ft.findTextInFiles($e,vt||{},Lt,We.identifier,ut)},save:$e=>ft.save($e),saveAs:$e=>ft.saveAs($e),saveAll:$e=>ft.saveAll($e),applyEdit($e,Ee){return Zt.applyWorkspaceEdit($e,We,Ee)},createFileSystemWatcher:($e,Ee,Be,ut)=>{let vt;return typeof Ee=="boolean"?vt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ut,correlate:!1}:Ee&&((0,et.$GF)(We,"createFileSystemWatcher"),vt={...Ee,correlate:!0}),ei.createFileSystemWatcher(ft,We,$e,vt)},get textDocuments(){return wt.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new T.$9("textDocuments")},openTextDocument($e){let Ee;const Be=$e;if(typeof $e=="string")Ee=Promise.resolve($.URI.file($e));else if($.URI.isUri($e))Ee=Promise.resolve($e);else if(!Be||typeof Be=="object")Ee=wt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ut=>wt.ensureDocumentData(ut).then(vt=>vt.document))},onDidOpenTextDocument:($e,Ee,Be)=>ot(wt.onDidAddDocument)($e,Ee,Be),onDidCloseTextDocument:($e,Ee,Be)=>ot(wt.onDidRemoveDocument)($e,Ee,Be),onDidChangeTextDocument:($e,Ee,Be)=>ot(wt.onDidChangeDocument)($e,Ee,Be),onDidSaveTextDocument:($e,Ee,Be)=>ot(wt.onDidSaveDocument)($e,Ee,Be),onWillSaveTextDocument:($e,Ee,Be)=>ot(Ki.getOnWillSaveTextDocumentEvent(We))($e,Ee,Be),get notebookDocuments(){return Pt.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Ee){let Be;if($.URI.isUri($e))Be=$e,await Pt.openNotebookDocument($e);else if(typeof $e=="string")Be=$.URI.revive(await Pt.createNotebookDocument({viewType:$e,content:Ee}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument($e,Ee,Be){return ot(si.onDidSaveNotebookDocument)($e,Ee,Be)},onDidChangeNotebookDocument($e,Ee,Be){return ot(si.onDidChangeNotebookDocument)($e,Ee,Be)},onWillSaveNotebookDocument($e,Ee,Be){return ot(Ii.getOnWillSaveNotebookDocumentEvent(We))($e,Ee,Be)},get onDidOpenNotebookDocument(){return ot(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer($e,Ee,Be,ut){return Pt.registerNotebookSerializer(We,$e,Ee,Be,(0,et.$FF)(We,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:($e,Ee,Be)=>ot(tn.onDidChangeConfiguration)($e,Ee,Be),getConfiguration($e,Ee){return Ee=arguments.length===1?void 0:Ee,tn.getConfiguration($e,Ee,We)},registerTextDocumentContentProvider($e,Ee){return Di.registerTextDocumentContentProvider($e,Ee)},registerTaskProvider:($e,Ee)=>(Rt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(We,$e,Ee)),registerFileSystemProvider($e,Ee,Be){return(0,I.$Qc)(Ji.registerFileSystemProvider(We,$e,Ee,Be),Qt.addFileSystemProvider($e,Ee,Be))},get fs(){return Qt.value},registerFileSearchProvider:($e,Ee)=>((0,et.$GF)(We,"fileSearchProvider"),ct.registerFileSearchProvider($e,Ee)),registerTextSearchProvider:($e,Ee)=>((0,et.$GF)(We,"textSearchProvider"),ct.registerTextSearchProvider($e,Ee)),registerRemoteAuthorityResolver:($e,Ee)=>((0,et.$GF)(We,"resolvers"),kt.registerRemoteAuthorityResolver($e,Ee)),registerResourceLabelFormatter:$e=>((0,et.$GF)(We,"resolvers"),Yi.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,et.$GF)(We,"resolvers"),kt.getRemoteExecServer($e)),onDidCreateFiles:($e,Ee,Be)=>ot(ei.onDidCreateFile)($e,Ee,Be),onDidDeleteFiles:($e,Ee,Be)=>ot(ei.onDidDeleteFile)($e,Ee,Be),onDidRenameFiles:($e,Ee,Be)=>ot(ei.onDidRenameFile)($e,Ee,Be),onWillCreateFiles:($e,Ee,Be)=>ot(ei.getOnWillCreateFileEvent(We))($e,Ee,Be),onWillDeleteFiles:($e,Ee,Be)=>ot(ei.getOnWillDeleteFileEvent(We))($e,Ee,Be),onWillRenameFiles:($e,Ee,Be)=>ot(ei.getOnWillRenameFileEvent(We))($e,Ee,Be),openTunnel:$e=>((0,et.$GF)(We,"tunnels"),Tt.openTunnel(We,$e).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$GF)(We,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:($e,Ee,Be)=>((0,et.$GF)(We,"tunnels"),ot(Tt.onDidChangeTunnels)($e,Ee,Be)),registerPortAttributesProvider:($e,Ee)=>((0,et.$GF)(We,"portsAttributes"),Tt.registerPortsAttributesProvider($e,Ee)),registerTunnelProvider:($e,Ee)=>((0,et.$GF)(We,"tunnelFactory"),Tt.registerTunnelProvider($e,Ee)),registerTimelineProvider:($e,Ee)=>((0,et.$GF)(We,"timeline"),Xi.registerTimelineProvider($e,Ee,We.identifier,Ue.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:$e=>((0,et.$GF)(We,"workspaceTrust"),ft.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Ee,Be)=>ot(ft.onDidGrantWorkspaceTrust)($e,Ee,Be),registerEditSessionIdentityProvider:($e,Ee)=>((0,et.$GF)(We,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider($e,Ee)),onWillCreateEditSessionIdentity:($e,Ee,Be)=>((0,et.$GF)(We,"editSessionIdentityProvider"),ot(ft.getOnWillCreateEditSessionIdentityEvent(We))($e,Ee,Be)),registerCanonicalUriProvider:($e,Ee)=>((0,et.$GF)(We,"canonicalUriProvider"),ft.registerCanonicalUriProvider($e,Ee)),getCanonicalUri:($e,Ee,Be)=>((0,et.$GF)(We,"canonicalUriProvider"),ft.provideCanonicalUri($e,Ee,Be))},on={get inputBox(){return Rt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(We)},createSourceControl($e,Ee,Be){return bi.createSourceControl(We,$e,Ee,Be)}},an={createCommentController($e,Ee){return Ri.createCommentController(We,$e,Ee)}},Ui={get activeDebugSession(){return Ke.activeDebugSession},get activeDebugConsole(){return Ke.activeDebugConsole},get breakpoints(){return Ke.breakpoints},get stackFrameFocus(){return Ke.stackFrameFocus},onDidStartDebugSession($e,Ee,Be){return ot(Ke.onDidStartDebugSession)($e,Ee,Be)},onDidTerminateDebugSession($e,Ee,Be){return ot(Ke.onDidTerminateDebugSession)($e,Ee,Be)},onDidChangeActiveDebugSession($e,Ee,Be){return ot(Ke.onDidChangeActiveDebugSession)($e,Ee,Be)},onDidReceiveDebugSessionCustomEvent($e,Ee,Be){return ot(Ke.onDidReceiveDebugSessionCustomEvent)($e,Ee,Be)},onDidChangeBreakpoints($e,Ee,Be){return ot(Ke.onDidChangeBreakpoints)($e,Ee,Be)},onDidChangeStackFrameFocus($e,Ee,Be){return(0,et.$GF)(We,"debugFocus"),ot(Ke.onDidChangeStackFrameFocus)($e,Ee,Be)},registerDebugConfigurationProvider($e,Ee,Be){return Ke.registerDebugConfigurationProvider($e,Ee,Be||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Ee){return Ke.registerDebugAdapterDescriptorFactory(We,$e,Ee)},registerDebugAdapterTrackerFactory($e,Ee){return Ke.registerDebugAdapterTrackerFactory($e,Ee)},startDebugging($e,Ee,Be){return!Be||typeof Be=="object"&&"configuration"in Be?Ke.startDebugging($e,Ee,{parentSession:Be}):Ke.startDebugging($e,Ee,Be||{})},stopDebugging($e){return Ke.stopDebugging($e)},addBreakpoints($e){return Ke.addBreakpoints($e)},removeBreakpoints($e){return Ke.removeBreakpoints($e)},asDebugSourceUri($e,Ee){return Ke.asDebugSourceUri($e,Ee)}},Bi={registerTaskProvider:($e,Ee)=>pt.registerTaskProvider(We,$e,Ee),fetchTasks:$e=>pt.fetchTasks($e),executeTask:$e=>pt.executeTask(We,$e),get taskExecutions(){return pt.taskExecutions},onDidStartTask:($e,Ee,Be)=>ot(pt.onDidStartTask)($e,Ee,Be),onDidEndTask:($e,Ee,Be)=>ot(pt.onDidEndTask)($e,Ee,Be),onDidStartTaskProcess:($e,Ee,Be)=>ot(pt.onDidStartTaskProcess)($e,Ee,Be),onDidEndTaskProcess:($e,Ee,Be)=>ot(pt.onDidEndTaskProcess)($e,Ee,Be)},Wi={createNotebookController($e,Ee,Be,ut,vt){return ui.createNotebookController(We,$e,Ee,Be,ut,(0,et.$FF)(We,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Ee)=>Pt.registerNotebookCellStatusBarItemProvider(We,$e,Ee),createRendererMessaging($e){return Ci.createRendererMessaging(We,$e)},createNotebookControllerDetectionTask($e){return(0,et.$GF)(We,"notebookKernelSource"),ui.createNotebookControllerDetectionTask(We,$e)},registerKernelSourceActionProvider($e,Ee){return(0,et.$GF)(We,"notebookKernelSource"),ui.registerKernelSourceActionProvider(We,$e,Ee)},onDidChangeNotebookCellExecutionState($e,Ee,Be){return(0,et.$GF)(We,"notebookCellExecutionState"),ot(ui.onDidChangeNotebookCellExecutionState)($e,Ee,Be)}},Si={t(...$e){if(typeof $e[0]=="string"){const Ee=$e.shift(),Be=!$e||typeof $e[0]!="object"?$e:$e[0];return St.getMessage(We.identifier.value,{message:Ee,args:Be})}return St.getMessage(We.identifier.value,$e[0])},get bundle(){return St.getBundle(We.identifier.value)},get uri(){return St.getBundleUri(We.identifier.value)}},Vi={_version:1,registerInteractiveEditorSessionProvider($e,Ee){return(0,et.$GF)(We,"interactive"),Zi.registerProvider(We,$e,Ee)},registerInteractiveSessionProvider($e,Ee){return(0,et.$GF)(We,"interactive"),pi.registerChatProvider(We,$e,Ee)},sendInteractiveRequestToProvider($e,Ee){return(0,et.$GF)(We,"interactive"),pi.sendInteractiveRequestToProvider($e,Ee)},transferChatSession($e,Ee){return(0,et.$GF)(We,"interactive"),pi.transferChatSession($e,Ee)}},qi={getRelatedInformation($e,Ee){return(0,et.$GF)(We,"aiRelatedInformation"),en.getRelatedInformation(We,$e,Ee)},registerRelatedInformationProvider($e,Ee){return(0,et.$GF)(We,"aiRelatedInformation"),en.registerRelatedInformationProvider(We,$e,Ee)},registerEmbeddingVectorProvider($e,Ee){return(0,et.$GF)(We,"aiRelatedInformation"),Ni.registerEmbeddingVectorProvider(We,$e,Ee)}},$n={registerChatResponseProvider($e,Ee,Be){return(0,et.$GF)(We,"chatProvider"),fi.registerProvider(We.identifier,$e,Ee,Be)},requestChatAccess($e){return(0,et.$GF)(We,"chatRequestAccess"),fi.requestChatResponseProvider(We.identifier,$e)},registerVariable($e,Ee,Be){return(0,et.$GF)(We,"chatAgents2"),_i.registerVariableResolver(We,$e,Ee,Be)},registerMappedEditsProvider($e,Ee){return(0,et.$GF)(We,"mappedEditsProvider"),dt.registerMappedEditsProvider(We,$e,Ee)},createChatAgent($e,Ee){return(0,et.$GF)(We,"chatAgents2"),xi.createChatAgent(We,$e,Ee)}},bn={registerSpeechProvider($e,Ee){return(0,et.$GF)(We,"speech"),yi.registerProvider(We.identifier,$e,Ee)}};return{version:$t.version,ai:qi,authentication:fn,commands:gn,comments:an,chat:$n,debug:Ui,env:ji,extensions:nn,interactive:Vi,l10n:Si,languages:rn,notebooks:Wi,scm:on,speech:bn,tasks:Bi,tests:zi,window:mn,workspace:sn,Breakpoint:Oe.$$L,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$3M,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$2M,CallHierarchyIncomingCall:Oe.$xL,CallHierarchyItem:Oe.$wL,CallHierarchyOutgoingCall:Oe.$yL,CancellationError:T.$5,CancellationTokenSource:D.$6d,CandidatePortSource:s.CandidatePortSource,CodeAction:Oe.$tL,CodeActionKind:Oe.$uL,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$zL,Color:Oe.$ML,ColorInformation:Oe.$NL,ColorPresentation:Oe.$OL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$GL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$HL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$WL,DebugAdapterExecutable:Oe.$cM,DebugAdapterInlineImplementation:Oe.$fM,DebugAdapterNamedPipeServer:Oe.$eM,DebugAdapterServer:Oe.$dM,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$nL,DiagnosticRelatedInformation:Oe.$mL,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$_K,DocumentHighlight:Oe.$pL,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$qL,DocumentLink:Oe.$LL,DocumentSymbol:Oe.$sL,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$iM,InlineValueText:Oe.$jM,InlineValueVariableLookup:Oe.$kM,InlineValueEvaluatableExpression:Oe.$lM,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:g.$Vd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$vM,FileDecoration2:Oe.$vM,FileSystemError:Oe.$nM,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Oe.$oM,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$aM,InlineCompletionItem:Oe.$IL,InlineCompletionList:Oe.$JL,Hover:Oe.$oL,IndentAction:C.IndentAction,Location:Oe.$lL,MarkdownString:Oe.$AL,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Oe.$BL,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$aL,ProcessExecution:Oe.$UL,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$uM,Range:Oe.$bL,RelativePattern:Oe.$9L,Selection:Oe.$cL,SelectionRange:Oe.$vL,SemanticTokens:Oe.$rM,SemanticTokensBuilder:Oe.$qM,SemanticTokensEdit:Oe.$sM,SemanticTokensEdits:Oe.$tM,SemanticTokensLegend:Oe.$pM,ShellExecution:Oe.$VL,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$DL,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$CL,SnippetString:Oe.$kL,SourceBreakpoint:Oe.$_L,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$rL,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$XL,TaskGroup:Oe.$TL,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$PL,TerminalQuickFixTerminalCommand:Oe.$RL,TerminalQuickFixOpener:Oe.$QL,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$SL,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$gL,SnippetTextEdit:Oe.$iL,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$8L,ThemeIcon:Oe.$7L,TreeItem:Oe.$YL,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$QM,UIKind:Ut.UIKind,Uri:$.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$jL,DocumentDropEdit:Oe.$5L,DocumentPasteEdit:Oe.$6L,InlayHint:Oe.$FL,InlayHintLabelPart:Oe.$EL,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$fL,ResolvedAuthority:Oe.$dL,ManagedResolvedAuthority:Oe.$eL,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$FM,NotebookRange:Oe.$xM,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$yM,NotebookData:Oe.$zM,NotebookRendererScript:Oe.$DM,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$BM,NotebookCellOutputItem:Oe.$AM,NotebookCellStatusBarItem:Oe.$CM,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$hL,NotebookKernelSourceAction:Oe.$EM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$HM,LinkedEditingRanges:Oe.$GM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$IM,TestMessage:Oe.$JM,TestMessage2:Oe.$JM,TestTag:Oe.$KM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Oe.$4L,DataTransferItem:Oe.$ZL,CoveredCount:Oe.$LM,FileCoverage:Oe.$MM,StatementCoverage:Oe.$NM,BranchCoverage:Oe.$OM,FunctionCoverage:Oe.$PM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$RM,TabInputTextDiff:Oe.$SM,TabInputTextMerge:Oe.$TM,TabInputCustom:Oe.$UM,TabInputNotebook:Oe.$WM,TabInputNotebookDiff:Oe.$XM,TabInputWebview:Oe.$VM,TabInputTerminal:Oe.$YM,TabInputInteractiveWindow:Oe.$ZM,TabInputChat:Oe.$1M,TelemetryTrustedValue:o.$Lo,LogLevel:d.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Oe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$gM,ThreadFocus:Oe.$hM,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus}}}e.$ric=Jt}),define(ke[370],Se([1,0,84,152,41,147,42,35,72,46,96,97,98,117,70,92,146,69,58,116,91,71,145,13,59,114,115]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c,t,a,r,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Yr)(h.$ghc,h.$fhc,1),(0,D.$Yr)(a.$oj,t.$sic,1),(0,D.$Yr)(d.$rgc,d.$sgc,1),(0,D.$Yr)(b.$xN,b.$wN,0),(0,D.$Yr)(R.$Mgc,R.$Kgc,0),(0,D.$Yr)(o.$Ogc,o.$Ngc,0),(0,D.$Yr)(C.$qhc,C.$uhc,0),(0,D.$Yr)(I.$whc,I.$vhc,0),(0,D.$Yr)($.$mN,$.$lN,0),(0,D.$Yr)(u.$hhc,u.$ihc,0),(0,D.$Yr)(i.$ogc,i.$ngc,0),(0,D.$Yr)(T.$3hc,T.$2hc,1),(0,D.$Yr)(m.$Mhc,m.$Nhc,0),(0,D.$Yr)(p.$8gc,p.$7gc,0),(0,D.$Yr)(L.$dic,L.$cic,0),(0,D.$Yr)(y.$$gc,y.$bhc,0),(0,D.$Yr)(S.$vyb,S.$wyb,0),(0,D.$Yr)(f.$qic,f.$pic,0),(0,D.$Yr)(g.$Jgc,g.$Igc,0),(0,D.$Yr)(s.$dhc,s.$chc,0),(0,D.$Yr)(n.$vN,n.$sN,0),(0,D.$Yr)(c.$Ygc,c.$Zgc,0),(0,D.$Yr)(r.$ohc,r.$phc,0)}),define(ke[119],Se([1,0,19,13,36,95]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=e.$Jic=e.$Iic=void 0;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$Iic=R;function b(C,m,p,S){const d=(0,D.$2b)(p,$),f=new g.$zJ(m,d,S),o=f.preview.matches;return{ranges:(0,D.$2b)(d,y),uri:C,preview:{text:f.preview.text,matches:(0,D.$2b)(o,y)}}}e.$Jic=b;function $(C){return new g.$AJ(C.start.line,C.start.character,C.end.line,C.end.character)}function y(C){return new I.$oJ(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let L=class{constructor(m,p){this.a=m,this.b=p}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$Kic=L,e.$Kic=L=Ge([Ve(1,T.$nj)],L)}),define(ke[371],Se([1,0,50,17,76,33,10,12,119,372]),function(me,e,D,T,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=e.$Lic=void 0;const L=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(s,n,c,t){const a=m(s,n,c,t),r=n.folder.fsPath;return{cmd:D.spawn(L,a.args,{cwd:r}),rgDiskPath:L,siblingClauses:a.siblingClauses,rgArgs:a,cwd:r}}e.$Lic=C;function m(s,n,c,t){const a=["--files","--hidden","--case-sensitive","--no-require-git"];S([n],c,!1).forEach(h=>{const u=(0,$.$Iic)(h);if(a.push("-g",u),R.$j){const l=(0,g.$Hl)(u);l!==u&&a.push("-g",l)}});const r=p([n],t,void 0,!1);return r.globArgs.forEach(h=>{const u=`!${(0,$.$Iic)(h)}`;if(a.push("-g",u),R.$j){const l=(0,g.$Hl)(u);l!==u&&a.push("-g",l)}}),n.disregardIgnoreFiles!==!1?a.push("--no-ignore"):n.disregardParentIgnoreFiles!==!1&&a.push("--no-ignore-parent"),n.ignoreSymlinks||a.push("--follow"),s.exists&&a.push("--quiet"),a.push("--no-config"),n.disregardGlobalIgnoreFiles&&a.push("--no-ignore-global"),{args:a,siblingClauses:r.siblingClauses}}function p(s,n,c,t=!0){const a=[];let r={};return s.forEach(h=>{const u=Object.assign({},h.excludePattern||{},n||{}),l=d(u,t?h.folder.fsPath:void 0,c);a.push(...l.globArgs),l.siblingClauses&&(r=Object.assign(r,l.siblingClauses))}),{globArgs:a,siblingClauses:r}}function S(s,n,c=!0){const t=[];return s.forEach(a=>{const r=Object.assign({},n||{},a.includePattern||{}),h=d(r,c?a.folder.fsPath:void 0);t.push(...h.globArgs)}),t}function d(s,n,c){const t=[],a={};return Object.keys(s).forEach(r=>{if(c&&c.has(r)||!r)return;const h=s[r];r=o(n?f(n,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof h=="boolean"&&h?(r.startsWith("\\\\")&&(r+="**"),t.push(i(r))):h&&h.when&&(a[r]=h)}),{globArgs:t,siblingClauses:a}}function f(s,n){return T.$ic(n)?n:T.$jc(s,n)}e.$Mic=f;function o(s){return s=b.$Ue(s,"\\"),b.$Ue(s,"/")}function i(s){return I.$4f(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.$Nic=i}),define(ke[373],Se([1,0,50,56,17,374,19,44,34,76,33,10,38,12,18,31,36,371,129]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=e.$Oic=void 0;const s=new Set;process.on("exit",()=>{s.forEach(r=>r())});class n{constructor(h){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=h,this.b=h.filePattern||"",this.d=h.includePattern&&$.$Mj(h.includePattern),this.f=h.maxResults||null,this.g=!!h.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Zq)(this.b).normalizedLowercase),this.u=h.excludePattern&&$.$Mj(h.excludePattern),this.t=new Map,h.folderQueries.forEach(u=>{const l=Object.assign({},u.excludePattern||{},this.a.excludePattern||{}),k=u.folder.fsPath;h.folderQueries.map(A=>A.folder.fsPath).filter(A=>A!==k).forEach(A=>{(0,L.$8f)(A,k)&&(l[g.$lc(k,A)]=!0)}),this.t.set(k,new t(l,k))})}cancel(){this.l=!0,s.forEach(h=>h())}walk(h,u,l,k,A){if(this.m=m.$Rd.create(!1),this.l)return A(null,this.j);u.forEach(v=>{const w=g.$nc(v.fsPath);this.u&&this.u(v.fsPath,w)||this.J(l,{relativePath:v.fsPath,searchPath:void 0})}),this.r=m.$Rd.create(!1),this.w(h,(v,w)=>{this.x(this.y,this,v,l,k,E=>{if(E){const P=(0,b.$Qi)(E);console.error(P),this.q.push(P),w(E,void 0)}else w(null,void 0)})},(v,w)=>{this.m.stop();const E=v?R.$Hb(v)[0]:null;A(E,this.j)})}w(h,u,l){const k=new Array(h.length),A=new Array(h.length);let v=!1,w=0;if(h.length===0)return l(null,[]);h.forEach((E,P)=>{u(E,(N,z)=>{if(N?(v=!0,k[P]=null,A[P]=N):(k[P]=z,A[P]=null),++w===h.length)return l(v?A:null,k)})})}x(h,u,...l){try{h.apply(u,l)}catch(k){l[l.length-1](k)}}y(h,u,l,k){const A=h.folder.fsPath,v=C.$j,w=()=>F&&F.kill();s.add(w);let E=U=>{s.delete(w),E=()=>{},k(U)},P="";const N=this.D(),z=(0,o.$Lic)(this.a,h,this.a.includePattern,this.t.get(h.folder.fsPath).expression),F=z.cmd,j=!Object.keys(z.siblingClauses).length,M=z.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let O=`${z.rgDiskPath} ${M}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),l({message:O}),this.s=0,this.z(F,"utf8",l,(U,Q,ue)=>{if(U){E(U);return}if(this.j){E();return}const J=(P+(v?y.$Gl(Q||""):Q)).split(`
`);if(ue){const X=J.length;J[X-1]=J[X-1].trim(),J[X-1]||J.pop()}else P=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.s+=J.length,j){for(const X of J)if(this.J(u,{base:A,relativePath:X,searchPath:this.N(h,X)}),this.j){w();break}(ue||this.j)&&E();return}this.G(h,N,A,J,u),ue&&(this.H(N,A,u),E())})}spawnFindCmd(h){const u=this.t.get(h.folder.fsPath),l=u.getBasenameTerms(),k=u.getPathTerms(),A=["-L","."];if(l.length||k.length){A.push("-not","(","(");for(const v of l)A.push("-name",v),A.push("-o");for(const v of k)A.push("-path",v),A.push("-o");A.pop(),A.push(")","-prune",")")}return A.push("-type","f"),D.spawn("find",A,{cwd:h.folder.fsPath})}readStdout(h,u,l){let k="";this.z(h,u,()=>{},(A,v,w)=>{if(A){l(A);return}k+=v,w&&l(null,k)})}z(h,u,l,k){let A=(E,P,N)=>{(E||N)&&(A=()=>{},this.r?.stop()),k(E,P,N)},v=!1;h.stdout?(this.A(h.stdout,u,A),h.stdout.once("data",()=>v=!0)):l({message:"stdout is null"});let w;h.stderr?w=this.B(h.stderr):l({message:"stderr is null"}),h.on("error",E=>{A(E)}),h.on("close",E=>{let P;!v&&(P=this.C(w,u))&&a(P)?A(new Error(`command failed with error code ${E}: ${this.C(w,u)}`)):(this.g&&E===0&&(this.j=!0),A(null,"",!0))})}A(h,u,l){const k=new I.StringDecoder(u);return h.on("data",A=>{l(null,k.write(A))}),k}B(h){const u=[];return h.on("data",l=>{u.push(l)}),u}C(h,u){const l=new I.StringDecoder(u);return h.map(k=>l.write(k)).join("")}D(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}G(h,{pathToEntries:u},l,k,A){k.indexOf(this.b)!==-1&&this.J(A,{base:l,relativePath:this.b,searchPath:this.N(h,this.b)});const v=w=>{const E=g.$nc(w),P=g.$mc(w);let N=u[P];N||(N=u[P]=[],v(P)),N.push({base:l,relativePath:w,basename:E,searchPath:this.N(h,w)})};k.forEach(v)}H({rootEntries:h,pathToEntries:u},l,k){const A=this,v=this.t.get(l),w=this.b;function E(P){A.o++;const N=(0,f.$PJ)(()=>P.map(z=>z.basename));for(let z=0,F=P.length;z<F;z++){const j=P[z],{relativePath:M,basename:O}=j;if(v.test(M,O,w!==O?N:void 0))continue;const U=u[M];if(U)E(U);else{if(A.p++,M===w)continue;A.J(k,j)}if(A.j)break}}E(h)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(h,u,l,k,A){const v=h.folder,w=(0,f.$PJ)(()=>l);this.w(l,(E,P)=>{if(this.l||this.j)return P(null);const N=u?[u,E].join(g.sep):E;if(this.t.get(h.folder.fsPath).test(N,E,this.a.filePattern!==E?w:void 0))return P(null);const z=[v.fsPath,N].join(g.sep);T.lstat(z,(F,j)=>{if(F||this.l||this.j)return P(null);this.L(z,j,(M,O)=>M||this.l||this.j?P(null):O.isDirectory()?(this.o++,this.M(z,j,(U,Q)=>U||this.l||this.j||(Q=Q||"",this.v[Q])?P(null):(this.v[Q]=!0,d.Promises.readdir(z).then(ue=>{if(this.l||this.j)return P(null);this.I(h,N,ue,k,Z=>P(Z||null))},ue=>{P(null)})))):(this.p++,N===this.b||this.h&&S.$Mf(O.size)&&O.size>this.h||this.J(k,{base:v.fsPath,relativePath:N,searchPath:this.N(h,N)}),P(null,void 0)))})},E=>{const P=E&&R.$Hb(E);return A(P&&P.length>0?P[0]:void 0)})}J(h,u){this.K(u)&&(!this.d||this.d(u.relativePath,g.$nc(u.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||h(u))}K(h){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$KJ)(h,this.c)}return!0}L(h,u,l){return u.isSymbolicLink()?T.stat(h,l):l(null,u)}M(h,u,l){return u.isSymbolicLink()?T.realpath(h,(k,A)=>k?l(k):l(null,A)):l(null,h)}N(h,u){return h.folderName?g.$jc(h.folderName,u):u}}e.$Oic=n;class c{constructor(h){this.a=h.folderQueries,this.b=h.extraFileResources||[],this.c=new n(h)}search(h,u,l){this.c.walk(this.a,this.b,h,u,(k,A)=>{l(k,{limitHit:A,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Pic=c;class t{constructor(h,u){this.expression=h,this.c=u,this.d(h)}d(h){let u,l;Object.keys(h).filter(k=>h[k]).forEach(k=>{g.$ic(k)?(u=u||$.$Hj(),u[k]=h[k]):(l=l||$.$Hj(),l[k]=h[k])}),this.a=u&&$.$Mj(u,{trimForExclusions:!0}),this.b=l&&$.$Mj(l,{trimForExclusions:!0})}test(h,u,l){return this.b&&this.b(h,u,l)||this.a&&this.a(g.$jc(this.c,h),u,l)}getBasenameTerms(){const h=[];return this.a&&h.push(...$.$Oj(this.a)),this.b&&h.push(...$.$Oj(this.b)),h}getPathTerms(){const h=[];return this.a&&h.push(...$.$Pj(this.a)),this.b&&h.push(...$.$Pj(this.b)),h}}function a(r){const h=r.trim().split(`
`),u=h[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return p.$Af(h[h.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}}),define(ke[375],Se([1,0,99,22,186,21]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=e.DecodeStreamErrorKind=e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=e.$gD=void 0,e.$gD="utf8",e.$hD="utf8bom",e.$iD="utf16be",e.$jD="utf16le";function R(u){return[e.$gD,e.$hD,e.$iD,e.$jD].some(l=>l===u)}e.$kD=R,e.$lD=[254,255],e.$mD=[255,254],e.$nD=[239,187,191];const b=512,$=512,y=512*8,L=512*128;var C;(function(u){u[u.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(l,k){super(l),this.decodeStreamErrorKind=k}}e.$oD=m;class p{static async create(l){let k;if(l!==e.$gD)k=(await(0,g.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(l));else{const A=new TextDecoder;k={write(v){return A.decode(v,{stream:!0})},end(){return A.decode()}}}return new p(k)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function S(u,l){const k=l.minBytesRequiredForDetection??l.guessEncoding?y:$;return new Promise((A,v)=>{const w=(0,D.$0d)(j=>j.join("")),E=[];let P=0,N;const z=new I.$6d,F=async()=>{try{const j=await h({buffer:T.$je.concat(E),bytesRead:P},l.guessEncoding);if(j.seemsBinary&&l.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);j.encoding=await l.overwriteEncoding(j.encoding),N=await p.create(j.encoding);const M=N.write(T.$je.concat(E).buffer);w.write(M),E.length=0,P=0,A({stream:w,detected:j})}catch(j){z.cancel(),w.destroy(),v(j)}};(0,D.$be)(u,{onData:async j=>{N?w.write(N.write(j.buffer)):(E.push(j),P+=j.byteLength,P>=k&&(u.pause(),await F(),setTimeout(()=>u.resume())))},onError:j=>w.error(j),onEnd:async()=>{N||await F(),w.end(N?.end())}},z.token)})}e.$pD=S;async function d(u,l,k){const v=(await(0,g.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(l),k);let w=!1,E=!1;return{read(){if(E)return null;const P=u.read();if(typeof P!="string"){if(E=!0,!w&&k?.addBOM)switch(l){case e.$gD:case e.$hD:return T.$je.wrap(Uint8Array.from(e.$nD));case e.$iD:return T.$je.wrap(Uint8Array.from(e.$lD));case e.$jD:return T.$je.wrap(Uint8Array.from(e.$mD))}const N=v.end();return N&&N.length>0?(w=!0,T.$je.wrap(N)):null}return w=!0,T.$je.wrap(v.write(P))}}}e.$qD=d;async function f(u){return(await(0,g.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(u))}e.$rD=f;function o(u){return u===e.$hD||u===null?e.$gD:u}e.$sD=o;function i(u,l){if(!u||l<e.$lD.length)return null;const k=u.readUInt8(0),A=u.readUInt8(1);if(k===e.$lD[0]&&A===e.$lD[1])return e.$iD;if(k===e.$mD[0]&&A===e.$mD[1])return e.$jD;if(l<e.$nD.length)return null;const v=u.readUInt8(2);return k===e.$nD[0]&&A===e.$nD[1]&&v===e.$nD[2]?e.$hD:null}e.$tD=i;const s=["ascii","utf-16","utf-32"];async function n(u){const l=await(0,g.$fD)("jschardet","dist/jschardet.min.js"),k=u.slice(0,L),A=a(k.buffer),v=l.detect(A);if(!v||!v.encoding)return null;const w=v.encoding.toLowerCase();return 0<=s.indexOf(w)?null:t(v.encoding)}const c={ibm866:"cp866",big5:"cp950"};function t(u){const l=u.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return c[l]||l}function a(u){let l="";for(let k=0;k<u.length;k++)l+=String.fromCharCode(u[k]);return l}function r(u){switch(u){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=u.match(/windows(\d+)/);return l?"windows-"+l[1]:u}}}e.$uD=r;function h({buffer:u,bytesRead:l},k){let A=i(u,l),v=!1;if(A!==e.$iD&&A!==e.$jD&&u){let w=!0,E=!0,P=!1;for(let N=0;N<l&&N<b;N++){const z=N%2===1,F=u.readUInt8(N)===0;if(F&&(P=!0),w&&(z&&!F||!z&&F)&&(w=!1),E&&(z&&F||!z&&!F)&&(E=!1),F&&!w&&!E)break}P&&(w?A=e.$jD:E?A=e.$iD:v=!0)}return k&&!v&&!A&&u?n(u.slice(0,l)).then(w=>({seemsBinary:!1,encoding:w})):{seemsBinary:v,encoding:A}}e.$vD=h,e.$wD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[155],Se([1,0,375,31,154]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=void 0;class I extends g.$Ihc{constructor(b,$,y=T,L="searchProcess"){super(b,$,{readdir:C=>y.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$uD)(C)},L)}}e.$Xic=I}),define(ke[156],Se([1,0,50,391,374,19,73,34,12,2,36,95,392,372,119]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=e.$Vic=e.$Uic=e.$Tic=e.$Sic=e.$Ric=e.$Qic=void 0;const d=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(w){this.a=w}provideTextSearchResults(w,E,P,N){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((z,F)=>{N.onCancellationRequested(()=>J());const j=t(w,E),M=E.folder.fsPath,O=j.map(ce=>ce.match(/^-/)?ce:`'${ce}'`).join(" ");this.a.appendLine(`${d} ${O}
 - cwd: ${M}`);let U=D.spawn(d,j,{cwd:M});U.on("error",ce=>{console.error(ce),this.a.appendLine("Error: "+(ce&&ce.message)),F((0,L.$GJ)(new L.$EJ(ce&&ce.message,L.SearchErrorCode.rgProcessError)))});let Q=!1;const ue=new s(E.maxResults,E.folder,E.previewOptions);ue.on("result",ce=>{Q=!0,le="",P.report(ce)});let Z=!1;const J=()=>{Z=!0,U?.kill(),ue?.cancel()};let X=!1;ue.on("hitLimit",()=>{X=!0,J()});let le="";U.stdout.on("data",ce=>{ue.handleData(ce),Q||(le+=ce)});let x=!1;U.stdout.once("data",()=>x=!0);let be="";U.stderr.on("data",ce=>{const G=ce.toString();this.a.appendLine(G),be.length+G.length<1e6&&(be+=G)}),U.on("close",()=>{if(this.a.appendLine(x?"Got data from stdout":"No data from stdout"),this.a.appendLine(Q?"Got result from parser":"No result from parser"),le&&this.a.appendLine(`Got data without result: ${le}`),this.a.appendLine(""),Z)z({limitHit:X});else{ue.flush(),U=null;let ce;be&&!x&&(ce=o(be))?F((0,L.$GJ)(new L.$EJ(ce.message,ce.code))):z({limitHit:X})}})})}}e.$Qic=f;function o(v){const w=v.split(`
`),E=w[0].trim();if(w.some(N=>N.startsWith("regex parse error")))return new L.$EJ(i(w),L.SearchErrorCode.regexParseError);const P=E.match(/grep config error: unknown encoding: (.*)/);if(P)return new L.$EJ(`Unknown encoding: ${P[1]}`,L.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new L.$EJ(E.charAt(0).toUpperCase()+E.substr(1),L.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new L.$EJ(E.charAt(0).toUpperCase()+E.substr(1),L.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new L.$EJ(E,L.SearchErrorCode.regexParseError)}function i(v){const w=["Regex parse error"],E=v.filter(P=>P.startsWith("PCRE2:"));if(E.length>=1){const P=E[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const N=P.split(":")[1];w.push(":"+N)}}return w.join("")}class s extends T.EventEmitter{constructor(w,E,P){super(),this.g=w,this.h=E,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,E){return super.on(w,E),this}handleData(w){if(this.b)return;const E=typeof w=="string"?w:this.d.write(w);this.k(E)}k(w){let E=w.indexOf(`
`);const P=this.a+w;if(E>=0)E+=this.a.length;else{this.a=P;return}let N=0;for(;E>=0;)this.m(P.substring(N,E).trim()),N=E+1,E=P.indexOf(`
`,N);this.a=P.substring(N)}m(w){if(this.b||!w)return;let E;try{E=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(E.type==="match"){const P=n(E.data.path),N=y.URI.joinPath(this.h,P),z=this.n(E.data,N);this.p(z),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const P=n(E.data.path),N=y.URI.joinPath(this.h,P);this.o(E.data,N).forEach(F=>this.p(F))}}n(w,E){const P=w.line_number-1,N=n(w.lines),z=Buffer.from(N);let F=0,j=0,M=P;w.submatches.length===0&&w.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const O=(0,I.$Hb)(w.submatches.map((U,Q)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ue=n(U.match),Z=z.slice(F,U.start).toString(),J=c(Z),X=J.numLines>0?J.lastLineLength:J.lastLineLength+j,le=c(ue),x=J.numLines+M,be=le.numLines+x,ce=le.numLines>0?le.lastLineLength:le.lastLineLength+X;return F=U.end,j=ce,M=be,new C.$oJ(x,X,be,ce)}));return(0,S.$Jic)(E,N,O,this.j)}o(w,E){const P=n(w.lines),N=w.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((z,F)=>({text:z,uri:E,lineNumber:N+F}))}p(w){this.emit("result",w)}}e.$Ric=s;function n(v){return v.bytes?Buffer.from(v.bytes,"base64").toString():v.text}function c(v){const w=/\n/g;let E=0,P=-1,N;for(;N=w.exec(v);)E++,P=N.index;const z=P>=0?v.length-P-1:v.length;return{numLines:E,lastLineLength:z}}function t(v,w){const E=["--hidden","--no-require-git"];E.push(v.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:N}=(0,R.$K)(w.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const F=new Set;N.forEach(j=>{F.add(j)}),E.push("-g","!*"),F.forEach(j=>{a(j).map(S.$Iic).forEach(M=>{E.push("-g",M)})})}P&&P.length&&P.forEach(F=>{E.push("-g",F)}),w.excludes.map(S.$Iic).forEach(F=>E.push("-g",`!${F}`)),w.maxFileSize&&E.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),w.followSymlinks&&E.push("--follow"),w.encoding&&w.encoding!=="utf8"&&E.push("--encoding",w.encoding),v.pattern==="--"&&(v.isRegExp=!0,v.pattern="\\-\\-"),v.isMultiline&&!v.isRegExp&&(v.pattern=(0,$.$Oe)(v.pattern),v.isRegExp=!0),w.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),v.isRegExp&&(v.pattern=r(v.pattern),E.push("--engine","auto"));let z;if(v.isWordMatch){const j=(0,$.$Xe)(v.pattern,!!v.isRegExp,{wholeWord:v.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",j)}else if(v.isRegExp){let F=u(v.pattern);F=l(F),E.push("--regexp",F)}else z=v.pattern,E.push("--fixed-strings");return E.push("--no-config"),w.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),v.isMultiline&&E.push("--multiline"),w.beforeContext&&E.push("--before-context",w.beforeContext+""),w.afterContext&&E.push("--after-context",w.afterContext+""),E.push("--"),z&&E.push(z),E.push("."),E}e.$Sic=t;function a(v){return A(v).flatMap(E=>{const P=(0,b.$Kj)(E,"/");return P.map((N,z)=>P.slice(0,z+1).join("/"))})}function r(v){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;v.match(w);)v=v.replace(w,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;v.match(E);)v=v.replace(E,"$1\\x{$2}");return v}e.$Tic=r;const h=v=>v.type==="Assertion"&&v.kind==="lookbehind";function u(v){let w;try{w=new m.RegExpParser().parsePattern(v)}catch{return v}let E="",P=0;const N=(j,M,O)=>{E+=v.slice(P,j)+O,P=M},z=[];return new m.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const M=z[0];if(!M)N(j.start,j.end,"\\r?\\n");else if(!z.some(h))if(M.type==="CharacterClass")if(M.negate){const O=v.slice(M.start+2,j.start)+v.slice(j.end,M.end-1);M.parent?.type==="Quantifier"?N(M.start,M.end,O?`[^${O}]`:"."):N(M.start,M.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=v.slice(M.start+1,j.start)+v.slice(j.end,M.end-1);N(M.start,M.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else M.type==="Quantifier"&&N(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){z.unshift(j)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(j){z.unshift(j)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(j){z.unshift(j)},onCharacterClassLeave(){z.shift()},onAssertionEnter(j){h(j)&&z.push(j)},onAssertionLeave(j){z[0]===j&&z.shift()}}).visit(w),E+=v.slice(P),E}e.$Uic=u;function l(v){return v.replace(/\n/g,"\\r?\\n")}e.$Vic=l;function k(v){let w=!1,E=!1,P="",N="";for(let z=0;z<v.length;z++){const F=v[z];switch(F){case"\\":E?(w?N+="\\"+F:P+="\\"+F,E=!1):E=!0;break;case"{":if(E)w?N+=F:P+=F,E=!1;else{if(w)return{strInBraces:P+"{"+N+"{"+v.substring(z+1)};w=!0}break;case"}":if(E)w?N+=F:P+=F,E=!1;else{if(w)return{fixedStart:P,strInBraces:N,fixedEnd:v.substring(z+1)};P+=F}break;default:w?N+=(E?"\\":"")+F:P+=(E?"\\":"")+F,E=!1;break}}return{strInBraces:P+(w?"{"+N:"")}}function A(v){const{fixedStart:w,strInBraces:E,fixedEnd:P}=k(v);if(w===void 0||P===void 0)return[E];let N=(0,b.$Kj)(E,",");N.length||(N=[""]);const z=A(P);return N.flatMap(F=>{const j=w+F;return z.map(M=>j+M)})}e.$Wic=A}),define(ke[376],Se([1,0,21,156,86,16]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=void 0;class R{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,L,C,m){const p=new T.$Qic(this.b);if(L.folder.scheme===I.Schemas.vscodeUserData){const S={...L,folder:L.folder.with({scheme:I.Schemas.file})},d=new g.$vv(f=>C.report({...f,uri:f.uri.with({scheme:L.folder.scheme})}));return this.c(m,f=>p.provideTextSearchResults(y,S,d,f))}else return this.c(m,S=>p.provideTextSearchResults(y,L,C,S))}async c(y,L){const C=b(y);this.a.add(C);const m=await L(C.token);return this.a.delete(C),m}d(){this.a.forEach(y=>y.cancel())}}e.$1ic=R;function b($){const y=new D.$6d;return $.onCancellationRequested(()=>y.cancel()),y}}),define(ke[377],Se([1,0,31,156,155]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;class I{constructor($){this.a=$}search($,y,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(p){L({message:p})}},m=new g.$Xic(this.a,new T.$Qic(C),D);return new Promise((p,S)=>m.search(d=>{y(d.map(R))},$).then(d=>p({limitHit:d.limitHit,type:"success",stats:d.stats}),S))}}e.$Yic=I;function R(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,y)=>{if(y.ranges){const L=y;return $+(Array.isArray(L.ranges)?L.ranges.length:1)}else return $+1},0)}}}),define(ke[378],Se([1,0,19,11,14,4,129,17,38,2,32,36,373,377]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;class S{static{this.a=512}constructor(n="searchProcess"){this.d=n,this.b=Object.create(null)}fileSearch(n){let c;const t=o(n),a=new I.$Vd({onDidAddFirstListener:()=>{c=(0,T.$Tg)(r=>this.doFileSearchWithEngine(m.$Pic,t,h=>a.fire(h),r)),c.then(r=>a.fire(r),r=>a.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return a.event}textSearch(n){let c;const t=o(n),a=new I.$Vd({onDidAddFirstListener:()=>{c=(0,T.$Tg)(r=>this.f(t,h=>a.fire(h),r)),c.then(r=>a.fire(r),r=>a.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return a.event}f(n,c,t){return n.maxFileSize=this.g().maxFileSize,new p.$Yic(n).search(t,c,c)}g(){return{maxFileSize:16*L.$Yk.GB}}doFileSearch(n,c,t){return this.doFileSearchWithEngine(m.$Pic,n,c,t)}doFileSearchWithEngine(n,c,t,a,r=S.a){let h=0;const u=k=>{Array.isArray(k)?(h+=k.length,t(k.map(A=>this.h(A)))):k.relativePath?(h++,t(this.h(k))):t(k)};if(c.sortByScore){let k=this.l(c,u,a);if(!k){const A=c.maxResults?Object.assign({},c,{maxResults:null}):c,v=new n(A);k=this.j(v,c,t,u,a)}return new Promise((A,v)=>{k.then(([w,E])=>{const P=E.map(N=>this.h(N));this.o(P,t,r),A(w)},v)})}const l=new n(c);return this.r(l,u,r,a).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:h,sortingTime:void 0}}))}h(n){return{path:n.base?(0,b.$jc)(n.base,n.relativePath):n.relativePath}}j(n,c,t,a,r){const h=new I.$Vd;let u=(0,T.$Tg)(k=>{let A=[];const v=w=>{Array.isArray(w)?A=w:(a(w),h.fire(w))};return this.r(n,v,-1,k).then(w=>[w,A])}),l;if(c.cacheKey){l=this.k(c.cacheKey);const k={promise:u,event:h.event,resolved:!1};l.resultsToSearchCache[c.filePattern||""]=k,u.then(()=>{k.resolved=!0},A=>{delete l.resultsToSearchCache[c.filePattern||""]}),u=this.s(u)}return u.then(([k,A])=>{const v=l?l.scorerCache:Object.create(null),w=(typeof c.maxResults!="number"||c.maxResults>0)&&$.$Rd.create(!1);return this.n(c,A,v,r).then(E=>{const P=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:c.folderQueries.length,resultCount:E.length},messages:k.messages,limitHit:k.limitHit||typeof c.maxResults=="number"&&A.length>c.maxResults},E]})})}k(n){const c=this.b[n];return c||(this.b[n]=new d)}l(n,c,t){const a=n.cacheKey&&this.b[n.cacheKey];if(!a)return;const r=this.q(a,n.filePattern||"",c,t);if(r)return r.then(([h,u,l])=>{const k=$.$Rd.create(!1);return this.n(n,u,a.scorerCache,t).then(A=>{const v=k.elapsed(),w={fromCache:!0,detailStats:l,type:this.d,resultCount:u.length,sortingTime:v};return[{type:"success",limitHit:h.limitHit||typeof n.maxResults=="number"&&u.length>n.maxResults,stats:w},A]})})}n(n,c,t,a){const r=(0,R.$Zq)(n.filePattern||""),h=(l,k)=>(0,R.$Yq)(l,k,r,!0,f,t),u=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return D.$Gb(c,h,u,1e4,a)}o(n,c,t){if(t&&t>0)for(let a=0;a<n.length;a+=t)c(n.slice(a,a+t));else c(n)}q(n,c,t,a){const r=$.$Rd.create(!1),h=c.indexOf(b.sep)>=0;let u;for(const v in n.resultsToSearchCache)if(c.startsWith(v)){if(h&&v.indexOf(b.sep)<0&&v!=="")continue;const w=n.resultsToSearchCache[v];u={promise:this.s(w.promise),event:w.event,resolved:w.resolved};break}if(!u)return null;const l=r.elapsed(),k=$.$Rd.create(!1),A=u.event(t);return a&&a.onCancellationRequested(()=>{A.dispose()}),u.promise.then(([v,w])=>{if(a&&a.isCancellationRequested)throw(0,g.$6)();const E=[],P=(0,R.$Zq)(c).normalizedLowercase;for(const N of w)(0,C.$KJ)(N,P)&&E.push(N);return[v,E,{cacheWasResolved:u.resolved,cacheLookupTime:l,cacheFilterTime:k.elapsed(),cacheEntryCount:w.length}]})}r(n,c,t,a){return new Promise((r,h)=>{let u=[];a?.onCancellationRequested(()=>n.cancel()),n.search(l=>{l&&(t?(u.push(l),t>0&&u.length>=t&&(c(u),u=[])):c(l))},l=>{c(l)},(l,k)=>{u.length&&c(u),l?(c({message:"Search finished. Error: "+l.message}),h(l)):(c({message:"Search finished. Stats: "+JSON.stringify(k.stats)}),r(k))})})}clearCache(n){return delete this.b[n],Promise.resolve(void 0)}s(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(c,t){return n.then(c,t)}catch(c){return this.then(void 0,c)}finally(c){return n.finally(c)}}}}e.$Zic=S;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(s){return(0,b.$nc)(s.relativePath)}getItemDescription(s){return(0,b.$mc)(s.relativePath)}getItemPath(s){return s.relativePath}};function o(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(i),extraFileResources:s.extraFileResources&&s.extraFileResources.map(n=>y.URI.revive(n))}}function i(s){return{...s,folder:y.URI.revive(s.folder)}}}),define(ke[379],Se([1,0,3,16,2,31,13,27,20,98,66,36,378,376,119,155]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;let f=class extends y.$Nhc{constructor(i,s,n,c){super(i,n,c),this.s=I,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Sc;const t=new S.$Kic("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new p.$1ic(t))),s.remote.isRemote&&s.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$Kic("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new p.$1ic(i))),this.x.add(this.z(T.Schemas.file,new m.$Zic("fileSearchProvider")))}z(i,s){const n=this.d++;return this.v=s,this.t=n,this.c.$registerFileSearchProvider(n,this.o(i)),(0,D.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(n)})}$provideFileSearchResults(i,s,n,c){const t=(0,y.$Ohc)(n);if(i===this.t){const a=Date.now();return this.A(i,s,t,c).then(r=>{const h=Date.now()-a;return this.n.debug(`Ext host file search time: ${h}ms`),r})}return super.$provideFileSearchResults(i,s,n,c)}doInternalFileSearchWithCustomCallback(i,s,n){const c=t=>{if((0,C.$JJ)(t)&&(t=[t]),Array.isArray(t)){n(t.map(a=>g.URI.file(a.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,c,s)}async A(i,s,n,c){return this.doInternalFileSearchWithCustomCallback(n,c,t=>{this.c.$handleFileMatch(i,s,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,s){return new d.$Xic(i,s,void 0,"textSearchProvider")}};e.$2ic=f,e.$2ic=f=Ge([Ve(0,$.$bN),Ve(1,b.$rN),Ve(2,L.$Ggc),Ve(3,R.$nj)],f)}),define(ke[120],Se([1,0,393,62,63,394,22,14,4,3,17,10,30,81,82]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0;class d{traceSocketEvent(w,E){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,E)}constructor(w,E=""){this.f=!0,this.debugLabel=E,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(w){const E=P=>{this.traceSocketEvent("read",P),w(R.$je.wrap(P))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(w){const E=P=>{w({type:0,hadError:P,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(w){const E=()=>{w()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(w){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Uh=d;var f;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var o;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(o||(o={}));class i extends y.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(w,E){this.socket.traceSocketEvent(w,E)}constructor(w,E,P,N){super(),this.f=this.B(new $.$Vd),this.g=this.B(new $.$Vd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new s(this,E,P,N,this.f,(z,F)=>this.m(z,F))),this.B(this.a.onError(z=>{console.error(z),(0,b.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new S.$Ph,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this.f.event(w)}onClose(w){return this.g.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){let E=0;for(;E<w.byteLength;)this.a.writeMessage(w.slice(E,Math.min(E+262144,w.byteLength)),{compressed:!0,opcode:2}),E+=262144}m(w,{compressed:E,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let N=2;w.byteLength<126?N+=0:w.byteLength<2**16?N+=2:N+=8;const z=R.$je.alloc(N),F=E?64:0,j=P&15;if(z.writeUInt8(128|F|j,0),w.byteLength<126)z.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){z.writeUInt8(126,1);let M=1;z.writeUInt8(w.byteLength>>>8&255,++M),z.writeUInt8(w.byteLength>>>0&255,++M)}else{z.writeUInt8(127,1);let M=1;z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(w.byteLength>>>24&255,++M),z.writeUInt8(w.byteLength>>>16&255,++M),z.writeUInt8(w.byteLength>>>8&255,++M),z.writeUInt8(w.byteLength>>>0&255,++M)}this.socket.write(R.$je.concat([z,w]))}end(){this.h=!0,this.socket.end()}n(w){if(w.byteLength!==0){for(this.b.acceptChunk(w);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),P=E.readUInt8(0),N=(P&128)>>>7,z=(P&64)>>>6,F=P&15,j=E.readUInt8(1),M=(j&128)>>>7,O=j&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),P=E.readUInt8(1),N=(P&128)>>>7;let z=P&127,F=1;z===126?z=E.readUInt8(++F)*2**8+E.readUInt8(++F):z===127&&(z=E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F));let j=0;N&&(j=E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F)),this.j.state=3,this.j.readLen=z,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Vh=i;class s extends y.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$je.alloc(0)}constructor(w,E,P,N,z,F){super(),this.n=w,this.r=z,this.s=F,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Vd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Vd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new n(this.n,N,P,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(w,E){this.g.push({data:w,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:w,options:E}=this.g.shift();if(this.f&&E.compressed){const P=await this.w(this.f,w);this.s(P,E)}else this.s(w,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(w,E){return new Promise((P,N)=>{w.write(E),w.flush(z=>P(z))})}acceptFrame(w,E,P){this.h.push({data:w,isCompressed:E,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const w=this.h.shift();if(this.b&&w.isCompressed){const E=await this.C(this.b,w.data,w.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(w.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(w,E,P){return new Promise((N,z)=>{w.write(E),P&&w.write(R.$je.fromByteArray([0,0,255,255])),w.flush(F=>N(F))})}}class n extends y.$Tc{get recordedInflateBytes(){return this.j?R.$je.concat(this.f):R.$je.alloc(0)}constructor(w,E,P,N){super(),this.h=w,this.j=E,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(N),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(R.$je.wrap(z))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(w){this.j&&this.f.push(w.clone()),this.h.traceSocketEvent("zlibInflateWrite",w),this.b.write(w.buffer)}flush(w){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=R.$je.concat(this.g);this.g.length=0,w(E)})}}class c extends y.$Tc{constructor(w,E){super(),this.g=w,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(R.$je.wrap(P))})}write(w){this.g.traceSocketEvent("zlibDeflateWrite",w.buffer),this.b.write(w.buffer)}flush(w){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=R.$je.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),w(E)})}}function t(v,w){if(w===0)return;const E=v.byteLength>>>2;for(let M=0;M<E;M++){const O=v.readUInt32BE(M*4);v.writeUInt32BE(O^w,M*4)}const P=E*4,N=v.byteLength-P,z=w>>>24&255,F=w>>>16&255,j=w>>>8&255;N>=1&&v.writeUInt8(v.readUInt8(P)^z,P),N>=2&&v.writeUInt8(v.readUInt8(P+1)^F,P+1),N>=3&&v.writeUInt8(v.readUInt8(P+2)^j,P+2)}e.$Wh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function r(){const v=(0,m.$qg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const w=process.platform!=="darwin"&&e.$Wh?e.$Wh:(0,g.tmpdir)(),E=(0,L.$jc)(w,`vscode-ipc-${v}.sock`);return u(E),E}e.$Xh=r;function h(v,w,E){const N=(0,D.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${E}-${w}-sock`;const z=E.substr(0,4),F=w.substr(0,6);let j;return process.platform!=="darwin"&&e.$Wh&&!process.env.VSCODE_PORTABLE?j=(0,L.$jc)(e.$Wh,`vscode-${N}-${z}-${F}.sock`):j=(0,L.$jc)(v,`${z}-${F}.sock`),u(j),j}e.$Yh=h;function u(v){const w=a[C.$u];typeof w=="number"&&v.length>=w&&console.warn(`WARNING: IPC handle "${v}" is longer than ${w} chars, try a shorter --user-data-dir`)}class l extends p.$Jh{static b(w){const E=$.Event.fromNodeEventEmitter(w,"connection");return $.Event.map(E,P=>({protocol:new S.$Qh(new d(P,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(P,"close"))}))}constructor(w){super(l.b(w)),this.d=w}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Zh=l;function k(v){return new Promise((w,E)=>{const P=(0,T.createServer)();P.on("error",E),P.listen(v,()=>{P.removeListener("error",E),w(new l(P))})})}e.$1h=k;function A(v,w){return new Promise((E,P)=>{const N=(0,T.createConnection)(v,()=>{N.removeListener("error",P),E(S.$Rh.fromSocket(new d(N,`ipc-client${w}`),w))});N.once("error",P)})}e.$2h=A}),define(ke[380],Se([1,0,62,63,166,120,11,3,10,51,13,136,256,257,109,89,22]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=e.$l_b=e.$k_b=e.$j_b=void 0;async function o(t,a,r,h,u){let l;for(let k=3;k&&(l?.dispose(),l=await new i(t,a,r,h,u).waitForReady(),!(u&&g.$tg[u]||!g.$tg[l.tunnelLocalPort]));k--);return l}class i extends b.$Tc{constructor(a,r,h,u,l){super(),this.m=r,this.n=l,this.privacy=d.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=D.createServer(),this.c=new R.$5g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=u,this.tunnelRemoteHost=h}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,r=(0,d.$Hv)(this.m)?"0.0.0.0":"127.0.0.1";let h=await(0,g.$ug)(a,2,1e3,r),u=null;return this.b.listen(h,this.m),await this.c.wait(),u=this.b.address(),u||(h=0,this.b.listen(h,this.m),await this.c.wait(),u=this.b.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async r(a){a.pause();const r=(0,d.$Fv)(this.tunnelRemoteHost)||(0,d.$Hv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,h=await(0,m.$ll)(this.a,r,this.tunnelRemotePort),u=h.getSocket(),l=h.readEntireBuffer();h.dispose(),l.byteLength>0&&a.write(l.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),u.end()}),a.on("close",()=>u.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),u instanceof I.$Uh?u.socket.destroy():u.end()}),u instanceof I.$Uh?this.t(a,u):this.s(a,u),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),u.end()})}s(a,r){r.onClose(()=>a.destroy()),r.onEnd(()=>a.end()),r.onData(h=>a.write(h.buffer)),a.on("data",h=>r.write(f.$je.wrap(h))),a.resume()}t(a,r){const h=r.socket;h.on("end",()=>a.end()),h.on("close",()=>a.end()),h.on("error",()=>{a.destroy()}),h.pipe(a),a.pipe(h)}}e.$j_b=i;let s=class extends d.$Kv{constructor(a,r,h,u,l){super(r,l),this.v=a,this.w=h,this.y=u}isPortPrivileged(a){return(0,d.$Iv)(a,this.m,$.OS,T.release())}t(a,r,h,u,l,k,A,v){const w=this.s(r,h);if(w)return++w.refcount,w.value;if((0,d.$Cv)(a))return this.u(a,r,h,l,k,A,v);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${h} on local port ${l}.`);const E={commit:this.y.commit,quality:this.y.quality,addressProvider:a,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=o(E,u,r,h,l);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,h,P),P}}};e.$k_b=s,e.$k_b=s=Ge([Ve(0,p.$fl),Ve(1,L.$nj),Ve(2,S.$il),Ve(3,C.$Fj),Ve(4,y.$zi)],s);let n=class extends s{constructor(a,r,h,u,l){super(a,r,h,u,l)}};e.$l_b=n,e.$l_b=n=Ge([Ve(0,p.$fl),Ve(1,L.$nj),Ve(2,S.$il),Ve(3,C.$Fj),Ve(4,y.$zi)],n);let c=class extends b.$Tc{constructor(a,r,h,u,l){super(),this.b=a,this.c=r,this.f=h,this.g=u,this.h=l,this.a=new Map}async openTunnel(a,r,h,u,l,k,A,v,w){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${h}:${u} on local port ${k}.`),!this.a.has(a)){const E=new n(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(a,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(r,h,u,l,k,A,v,w)}};e.$m_b=c,e.$m_b=c=Ge([Ve(0,p.$fl),Ve(1,L.$nj),Ve(2,C.$Fj),Ve(3,S.$il),Ve(4,y.$zi)],c)}),define(ke[381],Se([1,0,120,276,56,35,2,13,40]),function(me,e,D,T,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.$CN=void 0;class y{constructor(m,p,S){this.b=m,this.c=p,this.f=S,this.a=T.createServer((d,f)=>this.h(d,f)),this.g().catch(d=>(p.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,p){const S=(f,o)=>{p.writeHead(f,{"content-type":"application/json"}),p.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},d=[];m.setEncoding("utf8"),m.on("data",f=>d.push(f)),m.on("end",async()=>{try{const f=JSON.parse(d.join(""));let o;switch(f.type){case"open":o=await this.i(f);break;case"openExternal":o=await this.j(f);break;case"status":o=await this.l(f);break;case"extensionManagement":o=await this.k(f);break;default:S(404,`Unknown message type: ${f.type}`);break}S(200,o)}catch(f){const o=f instanceof Error?f.message:JSON.stringify(f);S(500,o),this.c.error("Error while processing pipe request",f)}})}async i(m){const{fileURIs:p,folderURIs:S,forceNewWindow:d,diffMode:f,mergeMode:o,addMode:i,forceReuseWindow:s,gotoLineMode:n,waitMarkerFilePath:c,remoteAuthority:t}=m,a=[];if(Array.isArray(S))for(const l of S)try{a.push({folderUri:R.URI.parse(l)})}catch{}if(Array.isArray(p))for(const l of p)try{(0,$.$yi)(l)?a.push({workspaceUri:R.URI.parse(l)}):a.push({fileUri:R.URI.parse(l)})}catch{}const r=c?R.URI.file(c):void 0,u={forceNewWindow:d,diffMode:f,mergeMode:o,addMode:i,gotoLineMode:n,forceReuseWindow:s,preferNewWindow:!s&&!r&&!i,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",a,u)}async j(m){for(const p of m.uris){const S=R.URI.parse(p),d=S.scheme==="file"?S:p;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(m){const p=d=>d?.map(f=>/\.vsix$/i.test(f)?R.URI.parse(f):f),S={list:m.list,install:p(m.install),uninstall:p(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$CN=y;let L=class extends y{constructor(m,p){super(m,p,(0,D.$Xh)())}};e.$DN=L,e.$DN=L=Ge([Ve(0,I.$xN),Ve(1,b.$nj)],L)}),define(ke[382],Se([1,0,57,369,364,275,47,351,2,16,7,381,104,306,350]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=void 0;class d extends g.$vic{j(){const i=this,s=globalThis._VSCODE_NODE_MODULES.module,n=s._load;s._load=function(r,h,u){return r=t(r),i.a.has(r)?i.a.get(r).load(r,$.URI.file((0,m.$wq)(h.filename)),l=>n.apply(this,[l,h,u])):n.apply(this,arguments)};const c=s._resolveLookupPaths;s._resolveLookupPaths=(a,r)=>c.call(this,t(a),r);const t=a=>{for(const r of i.b){const h=r(a);if(h){a=h;break}}return a}}}class f extends R.$khc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async tb(){this.h.createInstance(p.$5ic);const i=this.h.invokeFunction(T.$ric);if(this.h.createInstance(b.$4ic),this.f.remote.isRemote&&this.f.remote.authority){const c=this.h.createInstance(C.$DN);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}this.h.createInstance(S.$6ic),await this.h.createInstance(d,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const n=await this.m.getConfigProvider();await(0,I.$3ic)(this.j,n,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,s,n){if(s.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${s}', must be of file-scheme`);let c=null;n.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${s.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),c=me.__$__nodeRequire(s.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),n.codeLoadingStop()}return c}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const s in i){const n=i[s];n===null?delete process.env[s]:process.env[s]=n}}}e.$7ic=f}),define(ke[383],Se([1,0,50,22,4,3,122,10,23,2,31,13,255,64,109,89,380,27,20,70,358]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=e.$bjc=e.$ajc=e.$_ic=e.$$ic=e.$0ic=e.$9ic=e.$8ic=void 0;function c(w){const E=w.trim().split(`
`),P=[];return E.forEach(z=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);F&&F.length>=3&&P.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),P.reduce((z,F)=>(z[F.socket]=F,z),{})}e.$8ic=c;function t(...w){const E=[].concat(...w.map(r));return[...new Map(E.filter(P=>P.st==="0A").map(P=>{const N=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:a(N[0]),port:parseInt(N[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$9ic=t;function a(w){let E="";if(w.length===8)for(let P=w.length-2;P>=0;P-=2)E+=parseInt(w.substr(P,2),16),P!==0&&(E+=".");else for(let P=0;P<w.length;P+=8){const N=w.substring(P,P+8);let z="";for(let F=8;F>=2;F-=2)z+=N.substring(F-2,F),(F===6||F===2)&&(z=parseInt(z,16).toString(16),E+=`${z}`,z="",P+F!==w.length-6&&(E+=":"))}return E}e.$0ic=a;function r(w){const E=w.trim().split(`
`),P=E.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return E.map(z=>z.trim().split(/\s+/).reduce((F,j,M)=>(F[P[M]||M]=j,F),{}))}e.$$ic=r;function h(w){return!!w.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||w.indexOf("out/server-main.js")!==-1||w.indexOf("_productName=VSCode")!==-1}function u(w){const E=w.trim().split(`
`),P=[];return E.forEach(N=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);z&&z.length>=4&&P.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),P}e.$_ic=u;async function l(w,E,P){const N=P.reduce((F,j)=>(F[j.pid]=j,F),{}),z=[];return w.forEach(({socket:F,ip:j,port:M})=>{const O=E[F]?E[F].pid:void 0,U=O?N[O]?.cmd:void 0;O&&U&&!h(U)&&z.push({host:j,port:M,detail:U,pid:O})}),z}e.$ajc=l;function k(w,E,P){const N=new Map,z=u(E);for(const F of w){const j=P.get(F.port);if(j){N.set(F.port,j);continue}const M=z.find(O=>O.cmd.includes(`${F.port}`));if(M){let O=M,U;do U=z.find(Q=>Q.ppid===O.pid),U&&(O=U);while(U);N.set(F.port,{host:F.ip,port:F.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else N.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return N}e.$bjc=k;let A=class extends s.$wyb{constructor(E,P,N,z){super(E,P,N),this.D=P,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(E){if(E&&this.C)return;this.C=E;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new R.$0l;let z=0;for(;this.C;){const F=new Date().getTime(),j=(await this.I()).filter(U=>(0,d.$Fv)(U.host)||(0,d.$Hv)(U.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(U=>U.port).join(", ")}`);const M=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),z++>3&&N.update(M),(!P||JSON.stringify(P)!==JSON.stringify(j))&&(P=j,await this.a.$onFoundNewCandidates(P));const O=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(U=>setTimeout(()=>U(),O))}}G(E){return Math.max(E*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(E=>E.port).join(", ")}`)}async I(){let E="",P="";try{E=await L.Promises.readFile("/proc/net/tcp","utf8"),P=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(E,P),z=await new Promise(Z=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,X,le)=>{Z(X)})}),F=c(z),j=await L.Promises.readdir("/proc"),M=[];for(const Z of j)try{const J=Number(Z),X=$.$Hg(y.URI.file("/proc"),Z);if((await L.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(J)){const x=await L.Promises.readlink($.$Hg(X,"cwd").fsPath),be=await L.Promises.readFile($.$Hg(X,"cmdline").fsPath,"utf8");M.push({pid:J,cwd:x,cmd:be})}}catch{}const O=[],U=N.filter(Z=>{const J=F[Z.socket];return J||O.push(Z),J}),Q=l(U,F,M);let ue;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const Z=await new Promise(J=>{(0,D.exec)("ps -F -A -l | grep root",(X,le,x)=>{J(le)})});this.z=k(O,Z,this.z),ue=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ue.map(J=>J.port).join(", ")}`)}return Q.then(Z=>ue?Z.concat(ue):Z)}w(E){return async P=>{const N=new f.$j_b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,j,M,O){const U=await E.makeConnection();return v.connect(U,j,M,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new p.$9k(0),connectionToken:E.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await N.waitForReady();const z=new g.$Vd;return{localAddress:(0,n.$xK)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{N.dispose(),z.fire(),z.dispose()}}}}};e.$cjc=A,e.$cjc=A=Ge([Ve(0,i.$bN),Ve(1,o.$rN),Ve(2,C.$nj),Ve(3,S.$il)],A);class v extends m.$yrb{static connect(E,P,N,z){const F=new I.$Sc,j={onClose:F.add(new g.$Vd),onData:F.add(new g.$Vd),onEnd:F.add(new g.$Vd)};F.add(E.onDidReceiveMessage(O=>j.onData.fire(T.$je.wrap(O)))),F.add(E.onDidEnd(()=>j.onEnd.fire())),F.add(E.onDidClose(O=>j.onClose.fire({type:0,error:O,hadError:!!O})));const M=new v(E,z,j);return M.B(F),(0,m.$xrb)(M,P,N,z,j)}constructor(E,P,N){super(P,N),this.n=E}write(E){this.n.send(E.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[384],Se([1,0,84,353,367,366,379,382,383,97,47,98,96,46,70,94,352,307,13,368,59,270,106,109,138]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o,i,s,n,c,t,a,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Yr)(L.$lhc,b.$7ic,0),(0,D.$Yr)(i.$oj,o.$ejc,1),(0,D.$Yr)(i.$nj,new t.$3h(c.$uic,[!1],!0)),(0,D.$Yr)(a.$il,r.$o_b,1),(0,D.$Yr)(d.$Pgc,f.$djc,0),(0,D.$Yr)(y.$qhc,I.$Hic,0),(0,D.$Yr)(C.$Mhc,R.$2ic,0),(0,D.$Yr)(m.$dic,g.$zic,0),(0,D.$Yr)(p.$$gc,T.$yic,0),(0,D.$Yr)(S.$vyb,$.$cjc,0),(0,D.$Yr)(n.$ohc,s.$fjc,0)}),define(ke[395],Se([1,0,62,396,57,14,82,120,253,113,365,22,31,104,11,132,277,290,370,384]),function(me,e,D,T,g,I,R,b,$,y,L,C,m,p,S,d,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let k=0;k<process.execArgv.length;k++)process.execArgv[k]==="--inspect-port=0"&&(process.execArgv.splice(k,1),k--)}();const i=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,k=l._load;l._load=function(A){if(A==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return k.apply(this,arguments)}})();const s=process.exit.bind(process),n=process.on.bind(process);function c(l){process.exit=function(k){if(l)s(k);else{const A=new Error("An extension called process.exit() and this was prevented.");console.warn(A.stack)}},process.crash=function(){const k=new Error("An extension called process.crash() and this was prevented.");console.warn(k.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(k,A){k==="uncaughtException"&&(A=function(){try{return A.call(void 0,arguments)}catch{}}),n(k,A)}}let t=function(l){s()};function a(){const l=(0,o.$Tm)(process.env);if(l.type===3)return new Promise((k,A)=>{const v=w=>{const E=w[0],P=new R.$Sh;E.on("message",N=>P.fire(C.$je.wrap(N.data))),E.on("close",()=>{t("renderer closed the MessagePort")}),E.start(),k({onMessage:P.event,send:N=>E.postMessage(N.buffer)})};process.parentPort.on("message",w=>v(w.ports))});if(l.type===2)return new Promise((k,A)=>{let v=null;const w=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,P=3e5,N=new S.$gh(()=>t("renderer disconnected for too long (1)"),E),z=new S.$gh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(j,M)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const O=C.$je.wrap(Buffer.from(j.initialDataChunk,"base64"));let U;if(j.skipWebSocketFrames)U=new b.$Uh(M,"extHost-socket");else{const Q=C.$je.wrap(Buffer.from(j.inflateBytes,"base64"));U=new b.$Vh(new b.$Uh(M,"extHost-socket"),j.permessageDeflate,Q,!1)}v?(N.cancel(),z.cancel(),v.beginAcceptReconnection(U,O),v.endAcceptReconnection(),v.sendResume()):(clearTimeout(w),v=new R.$Th({socket:U,initialChunk:O}),v.sendResume(),v.onDidDispose(()=>t("renderer disconnected")),k(v),v.onSocketClose(()=>{N.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;N.isScheduled()&&z.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const k=l.pipeName;return new Promise((A,v)=>{const w=D.createConnection(k,()=>{w.removeListener("error",v);const E=new R.$Th({socket:new b.$Uh(w,"extHost-renderer")});E.sendResume(),A(E)});w.once("error",v),w.on("close",()=>{t("renderer closed the socket")})})}}async function r(){const l=await a();return new class{constructor(){this.a=new R.$Sh,this.onMessage=this.a.event,this.b=!1,l.onMessage(k=>{(0,y.$um)(k,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(k)})}send(k){this.b||l.send(k)}async drain(){if(l.drain)return l.drain()}}}function h(l){return new Promise(k=>{const A=l.onMessage(v=>{A.dispose();const w=JSON.parse(v.toString()),E=w.commit,P=$.default.commit;if(E&&P&&E!==P&&s(55),w.parentPid){let N=0;setInterval(function(){try{process.kill(w.parentPid,0),N=0}catch(F){F&&F.code==="EPERM"?(N++,N>=3&&t(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):t(`parent process ${w.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(w.parentPid)}catch(F){(0,I.$1)(F)}}l.send((0,y.$tm)(0)),k({protocol:l,initData:w})});l.send((0,y.$tm)(1))})}async function u(){const l=[];process.on("unhandledRejection",(N,z)=>{l.push(z),setTimeout(()=>{const F=l.indexOf(z);F>=0&&z.catch(j=>{l.splice(F,1),(0,I.$4)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),N&&(0,I.$1)(N))})},1e3)}),process.on("rejectionHandled",N=>{const z=l.indexOf(N);z>=0&&l.splice(z,1)}),process.on("uncaughtException",function(N){(0,I.$Z)(N)||(0,I.$1)(N)}),g.mark("code/extHost/willConnectToRenderer");const k=await r();g.mark("code/extHost/didConnectToRenderer");const A=await h(k);g.mark("code/extHost/didWaitForInitData");const{initData:v}=A;c(!!v.environment.extensionTestsLocationURI),v.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,v.environment.skipWorkspaceStorageLock=(0,d.boolean)(i.skipWorkspaceStorageLock,!1);const w=new class{constructor(){this.pid=process.pid}exit(z){s(z)}fsExists(z){return m.Promises.exists(z)}fsRealpath(z){return(0,p.$vq)(z)}};let E=null;v.remote.authority&&i.transformURIs&&(E=(0,f.$3r)(v.remote.authority));const P=new L.$xic(A.protocol,v,w,E);t=N=>P.terminate(N)}u().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0b571a26e213bf1ec6266e37152ced80c006bd1e/core/vs/workbench/api/node/extensionHostProcess.js.map
