/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/strings","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],y=0,M=ge.length;y<M;y++)e[y]=Pe[ge[y]];return e};define(Pe[67],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function y(P){return(m,f,w)=>{let R=null,k=null;if(typeof w.value=="function"?(R="value",k=w.value):typeof w.get=="function"&&(R="get",k=w.get),!k)throw new Error("not supported");w[R]=P(k,f)}}function M(P,m,f){let w=null,R=null;if(typeof f.value=="function"?(w="value",R=f.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",R=f.get),!R)throw new Error("not supported");const k=`$memoize$${m}`;f[w]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,l)}),this[k]}}e.$xh=M;function C(P,m,f){return y((w,R)=>{const k=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...$){this[l]||(this[l]=f?f():void 0),clearTimeout(this[k]),m&&(this[l]=m(this[l],...$),$=[this[l]]),this[k]=setTimeout(()=>{w.apply(this,$),this[l]=f?f():void 0},P)}})}e.$yh=C;function A(P,m,f){return y((w,R)=>{const k=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,$=`$throttle$lastRun$${R}`,v=`$throttle$pending$${R}`;return function(...s){if(this[l]||(this[l]=f?f():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...s)),this[v])return;const a=this[$]+P;a<=Date.now()?(this[$]=Date.now(),w.apply(this,[this[l]]),this[l]=f?f():void 0):(this[v]=!0,this[k]=setTimeout(()=>{this[v]=!1,this[$]=Date.now(),w.apply(this,[this[l]]),this[l]=f?f():void 0},a-Date.now()))}})}e.$zh=A}),define(Pe[89],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0;class y{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$gN=y,e.$hN=new y("id#")}),define(Pe[119],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function P(i,u=!1){let t=0;const g=i.length;let p="",d=0,S=16,L=0;function b(U){let I=0,N=0;for(;I<U;){const W=i.charCodeAt(t);if(W>=48&&W<=57)N=N*16+W-48;else if(W>=65&&W<=70)N=N*16+W-65+10;else if(W>=97&&W<=102)N=N*16+W-97+10;else break;t++,I++}return I<U&&(N=-1),N}function E(U){t=U,p="",d=0,S=16,L=0}function D(){const U=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&w(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&w(i.charCodeAt(t)))for(t++;t<i.length&&w(i.charCodeAt(t));)t++;else return L=3,i.substring(U,t);let I=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&w(i.charCodeAt(t))){for(t++;t<i.length&&w(i.charCodeAt(t));)t++;I=t}else L=3;return i.substring(U,I)}function T(){let U="",I=t;for(;;){if(t>=g){U+=i.substring(I,t),L=2;break}const N=i.charCodeAt(t);if(N===34){U+=i.substring(I,t),t++;break}if(N===92){if(U+=i.substring(I,t),t++,t>=g){L=2;break}switch(i.charCodeAt(t++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const ae=b(4);ae>=0?U+=String.fromCharCode(ae):L=4;break}default:L=5}I=t;continue}if(N>=0&&N<=31)if(f(N)){U+=i.substring(I,t),L=2;break}else L=6;t++}return U}function O(){if(p="",L=0,d=t,t>=g)return d=g,S=17;let U=i.charCodeAt(t);if(m(U)){do t++,p+=String.fromCharCode(U),U=i.charCodeAt(t);while(m(U));return S=15}if(f(U))return t++,p+=String.fromCharCode(U),U===13&&i.charCodeAt(t)===10&&(t++,p+=`
`),S=14;switch(U){case 123:return t++,S=1;case 125:return t++,S=2;case 91:return t++,S=3;case 93:return t++,S=4;case 58:return t++,S=6;case 44:return t++,S=5;case 34:return t++,p=T(),S=10;case 47:{const I=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<g&&!f(i.charCodeAt(t));)t++;return p=i.substring(I,t),S=12}if(i.charCodeAt(t+1)===42){t+=2;const N=g-1;let W=!1;for(;t<N;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,W=!0;break}t++}return W||(t++,L=1),p=i.substring(I,t),S=13}return p+=String.fromCharCode(U),t++,S=16}case 45:if(p+=String.fromCharCode(U),t++,t===g||!w(i.charCodeAt(t)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=D(),S=11;default:for(;t<g&&G(U);)t++,U=i.charCodeAt(t);if(d!==t){switch(p=i.substring(d,t),p){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return p+=String.fromCharCode(U),t++,S=16}}function G(U){if(m(U)||f(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let U;do U=O();while(U>=12&&U<=15);return U}return{setPosition:E,getPosition:()=>t,scan:u?q:O,getToken:()=>S,getTokenValue:()=>p,getTokenOffset:()=>d,getTokenLength:()=>t-d,getTokenError:()=>L}}e.$an=P;function m(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function k(i,u){const t=[],g=new Object;let p;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function L(b,E,D,T){d.value=b,d.offset=E,d.length=D,d.type=T,d.colonOffset=void 0,p=d}try{o(i,{onObjectBegin:(b,E)=>{if(u<=b)throw g;p=void 0,S=u>b,t.push("")},onObjectProperty:(b,E,D)=>{if(u<E||(L(b,E,D,"property"),t[t.length-1]=b,u<=E+D))throw g},onObjectEnd:(b,E)=>{if(u<=b)throw g;p=void 0,t.pop()},onArrayBegin:(b,E)=>{if(u<=b)throw g;p=void 0,t.push(0)},onArrayEnd:(b,E)=>{if(u<=b)throw g;p=void 0,t.pop()},onLiteralValue:(b,E,D)=>{if(u<E||(L(b,E,D,h(b)),u<=E+D))throw g},onSeparator:(b,E,D)=>{if(u<=E)throw g;if(b===":"&&p&&p.type==="property")p.colonOffset=E,S=!1,p=void 0;else if(b===","){const T=t[t.length-1];typeof T=="number"?t[t.length-1]=T+1:(S=!0,t[t.length-1]=""),p=void 0}}})}catch(b){if(b!==g)throw b}return{path:t,previousNode:p,isAtPropertyKey:S,matches:b=>{let E=0;for(let D=0;E<b.length&&D<t.length;D++)if(b[E]===t[D]||b[E]==="*")E++;else if(b[E]!=="**")return!1;return E===b.length}}}e.$bn=k;function l(i,u=[],t=A.DEFAULT){let g=null,p=[];const d=[];function S(b){Array.isArray(p)?p.push(b):g!==null&&(p[g]=b)}return o(i,{onObjectBegin:()=>{const b={};S(b),d.push(p),p=b,g=null},onObjectProperty:b=>{g=b},onObjectEnd:()=>{p=d.pop()},onArrayBegin:()=>{const b=[];S(b),d.push(p),p=b,g=null},onArrayEnd:()=>{p=d.pop()},onLiteralValue:S,onError:(b,E,D)=>{u.push({error:b,offset:E,length:D})}},t),p[0]}e.$cn=l;function $(i,u=[],t=A.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(b){g.type==="property"&&(g.length=b-g.offset,g=g.parent)}function d(b){return g.children.push(b),b}o(i,{onObjectBegin:b=>{g=d({type:"object",offset:b,length:-1,parent:g,children:[]})},onObjectProperty:(b,E,D)=>{g=d({type:"property",offset:E,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:b,offset:E,length:D,parent:g})},onObjectEnd:(b,E)=>{g.length=b+E-g.offset,g=g.parent,p(b+E)},onArrayBegin:(b,E)=>{g=d({type:"array",offset:b,length:-1,parent:g,children:[]})},onArrayEnd:(b,E)=>{g.length=b+E-g.offset,g=g.parent,p(b+E)},onLiteralValue:(b,E,D)=>{d({type:h(b),offset:E,length:D,parent:g,value:b}),p(E+D)},onSeparator:(b,E,D)=>{g.type==="property"&&(b===":"?g.colonOffset=E:b===","&&p(E))},onError:(b,E,D)=>{u.push({error:b,offset:E,length:D})}},t);const L=g.children[0];return L&&delete L.parent,L}e.$dn=$;function v(i,u){if(!i)return;let t=i;for(const g of u)if(typeof g=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let p=!1;for(const d of t.children)if(Array.isArray(d.children)&&d.children[0].value===g){t=d.children[1],p=!0;break}if(!p)return}else{const p=g;if(t.type!=="array"||p<0||!Array.isArray(t.children)||p>=t.children.length)return;t=t.children[p]}return t}e.$en=v;function s(i){if(!i.parent||!i.parent.children)return[];const u=s(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;u.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&u.push(t)}return u}e.$fn=s;function a(i){switch(i.type){case"array":return i.children.map(a);case"object":{const u=Object.create(null);for(const t of i.children){const g=t.children[1];g&&(u[t.children[0].value]=a(g))}return u}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$gn=a;function r(i,u,t=!1){return u>=i.offset&&u<i.offset+i.length||t&&u===i.offset+i.length}e.$hn=r;function n(i,u,t=!1){if(r(i,u,t)){const g=i.children;if(Array.isArray(g))for(let p=0;p<g.length&&g[p].offset<=u;p++){const d=n(g[p],u,t);if(d)return d}return i}}e.$in=n;function o(i,u,t=A.DEFAULT){const g=P(i,!1);function p(ie){return ie?()=>ie(g.getTokenOffset(),g.getTokenLength()):()=>!0}function d(ie){return ie?be=>ie(be,g.getTokenOffset(),g.getTokenLength()):()=>!0}const S=p(u.onObjectBegin),L=d(u.onObjectProperty),b=p(u.onObjectEnd),E=p(u.onArrayBegin),D=p(u.onArrayEnd),T=d(u.onLiteralValue),O=d(u.onSeparator),G=p(u.onComment),q=d(u.onError),U=t&&t.disallowComments,I=t&&t.allowTrailingComma;function N(){for(;;){const ie=g.scan();switch(g.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:U||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ie){case 12:case 13:U?W(10):G();break;case 16:W(1);break;case 15:case 14:break;default:return ie}}}function W(ie,be=[],se=[]){if(q(ie),be.length+se.length>0){let Z=g.getToken();for(;Z!==17;){if(be.indexOf(Z)!==-1){N();break}else if(se.indexOf(Z)!==-1)break;Z=N()}}}function ae(ie){const be=g.getTokenValue();return ie?T(be):L(be),N(),!0}function de(){switch(g.getToken()){case 11:{let ie=0;try{ie=JSON.parse(g.getTokenValue()),typeof ie!="number"&&(W(2),ie=0)}catch{W(2)}T(ie);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return N(),!0}function we(){return g.getToken()!==10?(W(3,[],[2,5]),!1):(ae(!1),g.getToken()===6?(O(":"),N(),pe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function ke(){S(),N();let ie=!1;for(;g.getToken()!==2&&g.getToken()!==17;){if(g.getToken()===5){if(ie||W(4,[],[]),O(","),N(),g.getToken()===2&&I)break}else ie&&W(6,[],[]);we()||W(4,[],[2,5]),ie=!0}return b(),g.getToken()!==2?W(7,[2],[]):N(),!0}function ue(){E(),N();let ie=!1;for(;g.getToken()!==4&&g.getToken()!==17;){if(g.getToken()===5){if(ie||W(4,[],[]),O(","),N(),g.getToken()===4&&I)break}else ie&&W(6,[],[]);pe()||W(4,[],[4,5]),ie=!0}return D(),g.getToken()!==4?W(8,[4],[]):N(),!0}function pe(){switch(g.getToken()){case 3:return ue();case 1:return ke();case 10:return ae(!0);default:return de()}}return N(),g.getToken()===17?t.allowEmptyContent?!0:(W(4,[],[]),!1):pe()?(g.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$jn=o;function c(i,u){const t=P(i),g=[];let p,d=0,S;do switch(S=t.getPosition(),p=t.scan(),p){case 12:case 13:case 17:d!==S&&g.push(i.substring(d,S)),u!==void 0&&g.push(t.getTokenValue().replace(/[^\r\n]/g,u)),d=t.getPosition();break}while(p!==17);return g.join("")}e.$kn=c;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=h}),function(ge,e){typeof define=="function"&&define.amd?define(Pe[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ce,ce){for(var te=0;te<ce.length;te++){var J=ce[te];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(Ce,J.key,J)}}function y(Ce,ce,te){return ce&&e(Ce.prototype,ce),te&&e(Ce,te),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function M(Ce,ce){if(Ce){if(typeof Ce=="string")return C(Ce,ce);var te=Object.prototype.toString.call(Ce).slice(8,-1);if(te==="Object"&&Ce.constructor&&(te=Ce.constructor.name),te==="Map"||te==="Set")return Array.from(Ce);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return C(Ce,ce)}}function C(Ce,ce){(ce==null||ce>Ce.length)&&(ce=Ce.length);for(var te=0,J=new Array(ce);te<ce;te++)J[te]=Ce[te];return J}function A(Ce,ce){var te=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(te)return(te=te.call(Ce)).next.bind(te);if(Array.isArray(Ce)||(te=M(Ce))||ce&&Ce&&typeof Ce.length=="number"){te&&(Ce=te);var J=0;return function(){return J>=Ce.length?{done:!0}:{done:!1,value:Ce[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=P();function m(Ce){ge.defaults=Ce}var f=/[&<>"']/,w=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},$=function(ce){return l[ce]};function v(Ce,ce){if(ce){if(f.test(Ce))return Ce.replace(w,$)}else if(R.test(Ce))return Ce.replace(k,$);return Ce}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(Ce){return Ce.replace(s,function(ce,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var r=/(^|[^\[])\^/g;function n(Ce,ce){Ce=typeof Ce=="string"?Ce:Ce.source,ce=ce||"";var te={replace:function(ee,me){return me=me.source||me,me=me.replace(r,"$1"),Ce=Ce.replace(ee,me),te},getRegex:function(){return new RegExp(Ce,ce)}};return te}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,ce,te){if(Ce){var J;try{J=decodeURIComponent(a(te)).replace(o,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ce&&!c.test(te)&&(te=p(ce,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var i={},u=/^[^:]+:\/*[^/]*$/,t=/^([^:]+:)[\s\S]*$/,g=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(Ce,ce){i[" "+Ce]||(u.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=b(Ce,"/",!0)),Ce=i[" "+Ce];var te=Ce.indexOf(":")===-1;return ce.substring(0,2)==="//"?te?ce:Ce.replace(t,"$1")+ce:ce.charAt(0)==="/"?te?ce:Ce.replace(g,"$1")+ce:Ce+ce}var d={exec:function(){}};function S(Ce){for(var ce=1,te,J;ce<arguments.length;ce++){te=arguments[ce];for(J in te)Object.prototype.hasOwnProperty.call(te,J)&&(Ce[J]=te[J])}return Ce}function L(Ce,ce){var te=Ce.replace(/\|/g,function(me,ve,Me){for(var fe=!1,ye=ve;--ye>=0&&Me[ye]==="\\";)fe=!fe;return fe?"|":" |"}),J=te.split(/ \|/),ee=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ce)J.splice(ce);else for(;J.length<ce;)J.push("");for(;ee<J.length;ee++)J[ee]=J[ee].trim().replace(/\\\|/g,"|");return J}function b(Ce,ce,te){var J=Ce.length;if(J===0)return"";for(var ee=0;ee<J;){var me=Ce.charAt(J-ee-1);if(me===ce&&!te)ee++;else if(me!==ce&&te)ee++;else break}return Ce.slice(0,J-ee)}function E(Ce,ce){if(Ce.indexOf(ce[1])===-1)return-1;for(var te=Ce.length,J=0,ee=0;ee<te;ee++)if(Ce[ee]==="\\")ee++;else if(Ce[ee]===ce[0])J++;else if(Ce[ee]===ce[1]&&(J--,J<0))return ee;return-1}function D(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(Ce,ce){if(ce<1)return"";for(var te="";ce>1;)ce&1&&(te+=Ce),ce>>=1,Ce+=Ce;return te+Ce}function O(Ce,ce,te,J){var ee=ce.href,me=ce.title?v(ce.title):null,ve=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){J.state.inLink=!0;var Me={type:"link",raw:te,href:ee,title:me,text:ve,tokens:J.inlineTokens(ve)};return J.state.inLink=!1,Me}return{type:"image",raw:te,href:ee,title:me,text:v(ve)}}function G(Ce,ce){var te=Ce.match(/^(\s+)(?:```)/);if(te===null)return ce;var J=te[1];return ce.split(`
`).map(function(ee){var me=ee.match(/^\s+/);if(me===null)return ee;var ve=me[0];return ve.length>=J.length?ee.slice(J.length):ee}).join(`
`)}var q=function(){function Ce(te){this.options=te||ge.defaults}var ce=Ce.prototype;return ce.space=function(J){var ee=this.rules.block.newline.exec(J);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ce.code=function(J){var ee=this.rules.block.code.exec(J);if(ee){var me=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?me:b(me,`
`)}}},ce.fences=function(J){var ee=this.rules.block.fences.exec(J);if(ee){var me=ee[0],ve=G(me,ee[3]||"");return{type:"code",raw:me,lang:ee[2]?ee[2].trim():ee[2],text:ve}}},ce.heading=function(J){var ee=this.rules.block.heading.exec(J);if(ee){var me=ee[2].trim();if(/#$/.test(me)){var ve=b(me,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(me=ve.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:me,tokens:this.lexer.inline(me)}}},ce.hr=function(J){var ee=this.rules.block.hr.exec(J);if(ee)return{type:"hr",raw:ee[0]}},ce.blockquote=function(J){var ee=this.rules.block.blockquote.exec(J);if(ee){var me=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},ce.list=function(J){var ee=this.rules.block.list.exec(J);if(ee){var me,ve,Me,fe,ye,F,H,K,j,Y,_,Ee,Ne=ee[1].trim(),Ve=Ne.length>1,Ke={type:"list",raw:"",ordered:Ve,start:Ve?+Ne.slice(0,-1):"",loose:!1,items:[]};Ne=Ve?"\\d{1,9}\\"+Ne.slice(-1):"\\"+Ne,this.options.pedantic&&(Ne=Ve?Ne:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+Ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(Ee=!1,!(!(ee=Xe.exec(J))||this.rules.block.hr.test(J)));){if(me=ee[0],J=J.substring(me.length),K=ee[2].split(`
`,1)[0],j=J.split(`
`,1)[0],this.options.pedantic?(fe=2,_=K.trimLeft()):(fe=ee[2].search(/[^ ]/),fe=fe>4?1:fe,_=K.slice(fe),fe+=ee[1].length),F=!1,!K&&/^ *$/.test(j)&&(me+=j+`
`,J=J.substring(j.length+1),Ee=!0),!Ee)for(var nt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),at=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");J&&(Y=J.split(`
`,1)[0],K=Y,this.options.pedantic&&(K=K.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(K)||at.test(K)||nt.test(K)||it.test(J)));){if(K.search(/[^ ]/)>=fe||!K.trim())_+=`
`+K.slice(fe);else if(!F)_+=`
`+K;else break;!F&&!K.trim()&&(F=!0),me+=Y+`
`,J=J.substring(Y.length+1)}Ke.loose||(H?Ke.loose=!0:/\n *\n *$/.test(me)&&(H=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(_),ve&&(Me=ve[0]!=="[ ] ",_=_.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:me,task:!!ve,checked:Me,loose:!1,text:_}),Ke.raw+=me}Ke.items[Ke.items.length-1].raw=me.trimRight(),Ke.items[Ke.items.length-1].text=_.trimRight(),Ke.raw=Ke.raw.trimRight();var ct=Ke.items.length;for(ye=0;ye<ct;ye++){this.lexer.state.top=!1,Ke.items[ye].tokens=this.lexer.blockTokens(Ke.items[ye].text,[]);var je=Ke.items[ye].tokens.filter(function(X){return X.type==="space"}),mt=je.every(function(X){for(var x=X.raw.split(""),$e=0,Be=A(x),Qe;!(Qe=Be()).done;){var tt=Qe.value;if(tt===`
`&&($e+=1),$e>1)return!0}return!1});!Ke.loose&&je.length&&mt&&(Ke.loose=!0,Ke.items[ye].loose=!0)}return Ke}},ce.html=function(J){var ee=this.rules.block.html.exec(J);if(ee){var me={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(ee[0]):v(ee[0]);me.type="paragraph",me.text=ve,me.tokens=this.lexer.inline(ve)}return me}},ce.def=function(J){var ee=this.rules.block.def.exec(J);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var me=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ee[0],href:ee[2],title:ee[3]}}},ce.table=function(J){var ee=this.rules.block.table.exec(J);if(ee){var me={type:"table",header:L(ee[1]).map(function(H){return{text:H}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ee[0];var ve=me.align.length,Me,fe,ye,F;for(Me=0;Me<ve;Me++)/^ *-+: *$/.test(me.align[Me])?me.align[Me]="right":/^ *:-+: *$/.test(me.align[Me])?me.align[Me]="center":/^ *:-+ *$/.test(me.align[Me])?me.align[Me]="left":me.align[Me]=null;for(ve=me.rows.length,Me=0;Me<ve;Me++)me.rows[Me]=L(me.rows[Me],me.header.length).map(function(H){return{text:H}});for(ve=me.header.length,fe=0;fe<ve;fe++)me.header[fe].tokens=this.lexer.inline(me.header[fe].text);for(ve=me.rows.length,fe=0;fe<ve;fe++)for(F=me.rows[fe],ye=0;ye<F.length;ye++)F[ye].tokens=this.lexer.inline(F[ye].text);return me}}},ce.lheading=function(J){var ee=this.rules.block.lheading.exec(J);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ce.paragraph=function(J){var ee=this.rules.block.paragraph.exec(J);if(ee){var me=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:me,tokens:this.lexer.inline(me)}}},ce.text=function(J){var ee=this.rules.block.text.exec(J);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ce.escape=function(J){var ee=this.rules.inline.escape.exec(J);if(ee)return{type:"escape",raw:ee[0],text:v(ee[1])}},ce.tag=function(J){var ee=this.rules.inline.tag.exec(J);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):v(ee[0]):ee[0]}},ce.link=function(J){var ee=this.rules.inline.link.exec(J);if(ee){var me=ee[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var ve=b(me.slice(0,-1),"\\");if((me.length-ve.length)%2===0)return}else{var Me=E(ee[2],"()");if(Me>-1){var fe=ee[0].indexOf("!")===0?5:4,ye=fe+ee[1].length+Me;ee[2]=ee[2].substring(0,Me),ee[0]=ee[0].substring(0,ye).trim(),ee[3]=""}}var F=ee[2],H="";if(this.options.pedantic){var K=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(F);K&&(F=K[1],H=K[3])}else H=ee[3]?ee[3].slice(1,-1):"";return F=F.trim(),/^</.test(F)&&(this.options.pedantic&&!/>$/.test(me)?F=F.slice(1):F=F.slice(1,-1)),O(ee,{href:F&&F.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ce.reflink=function(J,ee){var me;if((me=this.rules.inline.reflink.exec(J))||(me=this.rules.inline.nolink.exec(J))){var ve=(me[2]||me[1]).replace(/\s+/g," ");if(ve=ee[ve.toLowerCase()],!ve||!ve.href){var Me=me[0].charAt(0);return{type:"text",raw:Me,text:Me}}return O(me,ve,me[0],this.lexer)}},ce.emStrong=function(J,ee,me){me===void 0&&(me="");var ve=this.rules.inline.emStrong.lDelim.exec(J);if(ve&&!(ve[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=ve[1]||ve[2]||"";if(!Me||Me&&(me===""||this.rules.inline.punctuation.exec(me))){var fe=ve[0].length-1,ye,F,H=fe,K=0,j=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,ee=ee.slice(-1*J.length+fe);(ve=j.exec(ee))!=null;)if(ye=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!ye){if(F=ye.length,ve[3]||ve[4]){H+=F;continue}else if((ve[5]||ve[6])&&fe%3&&!((fe+F)%3)){K+=F;continue}if(H-=F,!(H>0)){if(F=Math.min(F,F+H+K),Math.min(fe,F)%2){var Y=J.slice(1,fe+ve.index+F);return{type:"em",raw:J.slice(0,fe+ve.index+F+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}var _=J.slice(2,fe+ve.index+F-1);return{type:"strong",raw:J.slice(0,fe+ve.index+F+1),text:_,tokens:this.lexer.inlineTokens(_)}}}}}},ce.codespan=function(J){var ee=this.rules.inline.code.exec(J);if(ee){var me=ee[2].replace(/\n/g," "),ve=/[^ ]/.test(me),Me=/^ /.test(me)&&/ $/.test(me);return ve&&Me&&(me=me.substring(1,me.length-1)),me=v(me,!0),{type:"codespan",raw:ee[0],text:me}}},ce.br=function(J){var ee=this.rules.inline.br.exec(J);if(ee)return{type:"br",raw:ee[0]}},ce.del=function(J){var ee=this.rules.inline.del.exec(J);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ce.autolink=function(J,ee){var me=this.rules.inline.autolink.exec(J);if(me){var ve,Me;return me[2]==="@"?(ve=v(this.options.mangle?ee(me[1]):me[1]),Me="mailto:"+ve):(ve=v(me[1]),Me=ve),{type:"link",raw:me[0],text:ve,href:Me,tokens:[{type:"text",raw:ve,text:ve}]}}},ce.url=function(J,ee){var me;if(me=this.rules.inline.url.exec(J)){var ve,Me;if(me[2]==="@")ve=v(this.options.mangle?ee(me[0]):me[0]),Me="mailto:"+ve;else{var fe;do fe=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(fe!==me[0]);ve=v(me[0]),me[1]==="www."?Me="http://"+ve:Me=ve}return{type:"link",raw:me[0],text:ve,href:Me,tokens:[{type:"text",raw:ve,text:ve}]}}},ce.inlineText=function(J,ee){var me=this.rules.inline.text.exec(J);if(me){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):v(me[0]):me[0]:ve=v(this.options.smartypants?ee(me[0]):me[0]),{type:"text",raw:me[0],text:ve}}},Ce}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=n(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=n(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=n(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=n(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=n(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=S({},U),U.gfm=S({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=n(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=S({},U.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:n(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var I={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};I._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",I.punctuation=n(I.punctuation).replace(/punctuation/g,I._punctuation).getRegex(),I.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,I.escapedEmSt=/\\\*|\\_/g,I._comment=n(U._comment).replace("(?:-->|$)","-->").getRegex(),I.emStrong.lDelim=n(I.emStrong.lDelim).replace(/punct/g,I._punctuation).getRegex(),I.emStrong.rDelimAst=n(I.emStrong.rDelimAst,"g").replace(/punct/g,I._punctuation).getRegex(),I.emStrong.rDelimUnd=n(I.emStrong.rDelimUnd,"g").replace(/punct/g,I._punctuation).getRegex(),I._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,I._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,I._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,I.autolink=n(I.autolink).replace("scheme",I._scheme).replace("email",I._email).getRegex(),I._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,I.tag=n(I.tag).replace("comment",I._comment).replace("attribute",I._attribute).getRegex(),I._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,I._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,I._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,I.link=n(I.link).replace("label",I._label).replace("href",I._href).replace("title",I._title).getRegex(),I.reflink=n(I.reflink).replace("label",I._label).replace("ref",U._label).getRegex(),I.nolink=n(I.nolink).replace("ref",U._label).getRegex(),I.reflinkSearch=n(I.reflinkSearch,"g").replace("reflink",I.reflink).replace("nolink",I.nolink).getRegex(),I.normal=S({},I),I.pedantic=S({},I.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",I._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",I._label).getRegex()}),I.gfm=S({},I.normal,{escape:n(I.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),I.gfm.url=n(I.gfm.url,"i").replace("email",I.gfm._extended_email).getRegex(),I.breaks=S({},I.gfm,{br:n(I.br).replace("{2,}","*").getRegex(),text:n(I.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Ce){var ce="",te,J,ee=Ce.length;for(te=0;te<ee;te++)J=Ce.charCodeAt(te),Math.random()>.5&&(J="x"+J.toString(16)),ce+="&#"+J+";";return ce}var ae=function(){function Ce(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||ge.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:U.normal,inline:I.normal};this.options.pedantic?(J.block=U.pedantic,J.inline=I.pedantic):this.options.gfm&&(J.block=U.gfm,this.options.breaks?J.inline=I.breaks:J.inline=I.gfm),this.tokenizer.rules=J}Ce.lex=function(J,ee){var me=new Ce(ee);return me.lex(J)},Ce.lexInline=function(J,ee){var me=new Ce(ee);return me.inlineTokens(J)};var ce=Ce.prototype;return ce.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ce.blockTokens=function(J,ee){var me=this;ee===void 0&&(ee=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(H,K,j){return K+"    ".repeat(j.length)});for(var ve,Me,fe,ye;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(ve=H.call({lexer:me},J,ee))?(J=J.substring(ve.raw.length),ee.push(ve),!0):!1}))){if(ve=this.tokenizer.space(J)){J=J.substring(ve.raw.length),ve.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(ve);continue}if(ve=this.tokenizer.code(J)){J=J.substring(ve.raw.length),Me=ee[ee.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(ve);continue}if(ve=this.tokenizer.fences(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.heading(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.hr(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.blockquote(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.list(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.html(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.def(J)){J=J.substring(ve.raw.length),Me=ee[ee.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.lheading(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(fe=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,K=J.slice(1),j=void 0;me.options.extensions.startBlock.forEach(function(Y){j=Y.call({lexer:this},K),typeof j=="number"&&j>=0&&(H=Math.min(H,j))}),H<1/0&&H>=0&&(fe=J.substring(0,H+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(fe))){Me=ee[ee.length-1],ye&&Me.type==="paragraph"?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(ve),ye=fe.length!==J.length,J=J.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(J)){J=J.substring(ve.raw.length),Me=ee[ee.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+ve.raw,Me.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(ve);continue}if(J){var F="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(F);break}else throw new Error(F)}}return this.state.top=!0,ee},ce.inline=function(J,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:J,tokens:ee}),ee},ce.inlineTokens=function(J,ee){var me=this;ee===void 0&&(ee=[]);var ve,Me,fe,ye=J,F,H,K;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(F=this.tokenizer.rules.inline.reflinkSearch.exec(ye))!=null;)j.includes(F[0].slice(F[0].lastIndexOf("[")+1,-1))&&(ye=ye.slice(0,F.index)+"["+T("a",F[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(F=this.tokenizer.rules.inline.blockSkip.exec(ye))!=null;)ye=ye.slice(0,F.index)+"["+T("a",F[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(F=this.tokenizer.rules.inline.escapedEmSt.exec(ye))!=null;)ye=ye.slice(0,F.index)+"++"+ye.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(H||(K=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_){return(ve=_.call({lexer:me},J,ee))?(J=J.substring(ve.raw.length),ee.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.tag(J)){J=J.substring(ve.raw.length),Me=ee[ee.length-1],Me&&ve.type==="text"&&Me.type==="text"?(Me.raw+=ve.raw,Me.text+=ve.text):ee.push(ve);continue}if(ve=this.tokenizer.link(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(ve.raw.length),Me=ee[ee.length-1],Me&&ve.type==="text"&&Me.type==="text"?(Me.raw+=ve.raw,Me.text+=ve.text):ee.push(ve);continue}if(ve=this.tokenizer.emStrong(J,ye,K)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.codespan(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.br(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.del(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.autolink(J,W)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(J,W))){J=J.substring(ve.raw.length),ee.push(ve);continue}if(fe=J,this.options.extensions&&this.options.extensions.startInline&&function(){var _=1/0,Ee=J.slice(1),Ne=void 0;me.options.extensions.startInline.forEach(function(Ve){Ne=Ve.call({lexer:this},Ee),typeof Ne=="number"&&Ne>=0&&(_=Math.min(_,Ne))}),_<1/0&&_>=0&&(fe=J.substring(0,_+1))}(),ve=this.tokenizer.inlineText(fe,N)){J=J.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(K=ve.raw.slice(-1)),H=!0,Me=ee[ee.length-1],Me&&Me.type==="text"?(Me.raw+=ve.raw,Me.text+=ve.text):ee.push(ve);continue}if(J){var Y="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return ee},y(Ce,null,[{key:"rules",get:function(){return{block:U,inline:I}}}]),Ce}(),de=function(){function Ce(te){this.options=te||ge.defaults}var ce=Ce.prototype;return ce.code=function(J,ee,me){var ve=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(J,ve);Me!=null&&Me!==J&&(me=!0,J=Me)}return J=J.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+v(ve,!0)+'">'+(me?J:v(J,!0))+`</code></pre>
`:"<pre><code>"+(me?J:v(J,!0))+`</code></pre>
`},ce.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ce.html=function(J){return J},ce.heading=function(J,ee,me,ve){if(this.options.headerIds){var Me=this.options.headerPrefix+ve.slug(me);return"<h"+ee+' id="'+Me+'">'+J+"</h"+ee+`>
`}return"<h"+ee+">"+J+"</h"+ee+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(J,ee,me){var ve=ee?"ol":"ul",Me=ee&&me!==1?' start="'+me+'"':"";return"<"+ve+Me+`>
`+J+"</"+ve+`>
`},ce.listitem=function(J){return"<li>"+J+`</li>
`},ce.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(J){return"<p>"+J+`</p>
`},ce.table=function(J,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+ee+`</table>
`},ce.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ce.tablecell=function(J,ee){var me=ee.header?"th":"td",ve=ee.align?"<"+me+' align="'+ee.align+'">':"<"+me+">";return ve+J+("</"+me+`>
`)},ce.strong=function(J){return"<strong>"+J+"</strong>"},ce.em=function(J){return"<em>"+J+"</em>"},ce.codespan=function(J){return"<code>"+J+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(J){return"<del>"+J+"</del>"},ce.link=function(J,ee,me){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return me;var ve='<a href="'+v(J)+'"';return ee&&(ve+=' title="'+ee+'"'),ve+=">"+me+"</a>",ve},ce.image=function(J,ee,me){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return me;var ve='<img src="'+J+'" alt="'+me+'"';return ee&&(ve+=' title="'+ee+'"'),ve+=this.options.xhtml?"/>":">",ve},ce.text=function(J){return J},Ce}(),we=function(){function Ce(){}var ce=Ce.prototype;return ce.strong=function(J){return J},ce.em=function(J){return J},ce.codespan=function(J){return J},ce.del=function(J){return J},ce.html=function(J){return J},ce.text=function(J){return J},ce.link=function(J,ee,me){return""+me},ce.image=function(J,ee,me){return""+me},ce.br=function(){return""},Ce}(),ke=function(){function Ce(){this.seen={}}var ce=Ce.prototype;return ce.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(J,ee){var me=J,ve=0;if(this.seen.hasOwnProperty(me)){ve=this.seen[J];do ve++,me=J+"-"+ve;while(this.seen.hasOwnProperty(me))}return ee||(this.seen[J]=ve,this.seen[me]=0),me},ce.slug=function(J,ee){ee===void 0&&(ee={});var me=this.serialize(J);return this.getNextSafeSlug(me,ee.dryrun)},Ce}(),ue=function(){function Ce(te){this.options=te||ge.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new ke}Ce.parse=function(J,ee){var me=new Ce(ee);return me.parse(J)},Ce.parseInline=function(J,ee){var me=new Ce(ee);return me.parseInline(J)};var ce=Ce.prototype;return ce.parse=function(J,ee){ee===void 0&&(ee=!0);var me="",ve,Me,fe,ye,F,H,K,j,Y,_,Ee,Ne,Ve,Ke,Xe,nt,it,et,at,ct=J.length;for(ve=0;ve<ct;ve++){if(_=J[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(at=this.options.extensions.renderers[_.type].call({parser:this},_),at!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_.type))){me+=at||"";continue}switch(_.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(_.tokens),_.depth,a(this.parseInline(_.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(_.text,_.lang,_.escaped);continue}case"table":{for(j="",K="",ye=_.header.length,Me=0;Me<ye;Me++)K+=this.renderer.tablecell(this.parseInline(_.header[Me].tokens),{header:!0,align:_.align[Me]});for(j+=this.renderer.tablerow(K),Y="",ye=_.rows.length,Me=0;Me<ye;Me++){for(H=_.rows[Me],K="",F=H.length,fe=0;fe<F;fe++)K+=this.renderer.tablecell(this.parseInline(H[fe].tokens),{header:!1,align:_.align[fe]});Y+=this.renderer.tablerow(K)}me+=this.renderer.table(j,Y);continue}case"blockquote":{Y=this.parse(_.tokens),me+=this.renderer.blockquote(Y);continue}case"list":{for(Ee=_.ordered,Ne=_.start,Ve=_.loose,ye=_.items.length,Y="",Me=0;Me<ye;Me++)Xe=_.items[Me],nt=Xe.checked,it=Xe.task,Ke="",Xe.task&&(et=this.renderer.checkbox(nt),Ve?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=et+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=et+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:et}):Ke+=et),Ke+=this.parse(Xe.tokens,Ve),Y+=this.renderer.listitem(Ke,it,nt);me+=this.renderer.list(Y,Ee,Ne);continue}case"html":{me+=this.renderer.html(_.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(_.tokens));continue}case"text":{for(Y=_.tokens?this.parseInline(_.tokens):_.text;ve+1<ct&&J[ve+1].type==="text";)_=J[++ve],Y+=`
`+(_.tokens?this.parseInline(_.tokens):_.text);me+=ee?this.renderer.paragraph(Y):Y;continue}default:{var je='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return me},ce.parseInline=function(J,ee){ee=ee||this.renderer;var me="",ve,Me,fe,ye=J.length;for(ve=0;ve<ye;ve++){if(Me=J[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(fe=this.options.extensions.renderers[Me.type].call({parser:this},Me),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){me+=fe||"";continue}switch(Me.type){case"escape":{me+=ee.text(Me.text);break}case"html":{me+=ee.html(Me.text);break}case"link":{me+=ee.link(Me.href,Me.title,this.parseInline(Me.tokens,ee));break}case"image":{me+=ee.image(Me.href,Me.title,Me.text);break}case"strong":{me+=ee.strong(this.parseInline(Me.tokens,ee));break}case"em":{me+=ee.em(this.parseInline(Me.tokens,ee));break}case"codespan":{me+=ee.codespan(Me.text);break}case"br":{me+=ee.br();break}case"del":{me+=ee.del(this.parseInline(Me.tokens,ee));break}case"text":{me+=ee.text(Me.text);break}default:{var F='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(F);return}else throw new Error(F)}}}return me},Ce}();function pe(Ce,ce,te){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof ce=="function"&&(te=ce,ce=null),ce=S({},pe.defaults,ce||{}),D(ce),te){var J=ce.highlight,ee;try{ee=ae.lex(Ce,ce)}catch(ye){return te(ye)}var me=function(F){var H;if(!F)try{ce.walkTokens&&pe.walkTokens(ee,ce.walkTokens),H=ue.parse(ee,ce)}catch(K){F=K}return ce.highlight=J,F?te(F):te(null,H)};if(!J||J.length<3||(delete ce.highlight,!ee.length))return me();var ve=0;pe.walkTokens(ee,function(ye){ye.type==="code"&&(ve++,setTimeout(function(){J(ye.text,ye.lang,function(F,H){if(F)return me(F);H!=null&&H!==ye.text&&(ye.text=H,ye.escaped=!0),ve--,ve===0&&me()})},0))}),ve===0&&me();return}function Me(ye){if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(ye.message+"",!0)+"</pre>";throw ye}try{var fe=ae.lex(Ce,ce);if(ce.walkTokens){if(ce.async)return Promise.all(pe.walkTokens(fe,ce.walkTokens)).then(function(){return ue.parse(fe,ce)}).catch(Me);pe.walkTokens(fe,ce.walkTokens)}return ue.parse(fe,ce)}catch(ye){Me(ye)}}pe.options=pe.setOptions=function(Ce){return S(pe.defaults,Ce),m(pe.defaults),pe},pe.getDefaults=P,pe.defaults=ge.defaults,pe.use=function(){for(var Ce=arguments.length,ce=new Array(Ce),te=0;te<Ce;te++)ce[te]=arguments[te];var J=S.apply(void 0,[{}].concat(ce)),ee=pe.defaults.extensions||{renderers:{},childTokens:{}},me;ce.forEach(function(ve){if(ve.extensions&&(me=!0,ve.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var ye=ee.renderers?ee.renderers[fe.name]:null;ye?ee.renderers[fe.name]=function(){for(var F=arguments.length,H=new Array(F),K=0;K<F;K++)H[K]=arguments[K];var j=fe.renderer.apply(this,H);return j===!1&&(j=ye.apply(this,H)),j}:ee.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[fe.level]?ee[fe.level].unshift(fe.tokenizer):ee[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?ee.startBlock?ee.startBlock.push(fe.start):ee.startBlock=[fe.start]:fe.level==="inline"&&(ee.startInline?ee.startInline.push(fe.start):ee.startInline=[fe.start]))}fe.childTokens&&(ee.childTokens[fe.name]=fe.childTokens)})),ve.renderer&&function(){var fe=pe.defaults.renderer||new de,ye=function(K){var j=fe[K];fe[K]=function(){for(var Y=arguments.length,_=new Array(Y),Ee=0;Ee<Y;Ee++)_[Ee]=arguments[Ee];var Ne=ve.renderer[K].apply(fe,_);return Ne===!1&&(Ne=j.apply(fe,_)),Ne}};for(var F in ve.renderer)ye(F);J.renderer=fe}(),ve.tokenizer&&function(){var fe=pe.defaults.tokenizer||new q,ye=function(K){var j=fe[K];fe[K]=function(){for(var Y=arguments.length,_=new Array(Y),Ee=0;Ee<Y;Ee++)_[Ee]=arguments[Ee];var Ne=ve.tokenizer[K].apply(fe,_);return Ne===!1&&(Ne=j.apply(fe,_)),Ne}};for(var F in ve.tokenizer)ye(F);J.tokenizer=fe}(),ve.walkTokens){var Me=pe.defaults.walkTokens;J.walkTokens=function(fe){var ye=[];return ye.push(ve.walkTokens.call(this,fe)),Me&&(ye=ye.concat(Me.call(this,fe))),ye}}me&&(J.extensions=ee),pe.setOptions(J)})},pe.walkTokens=function(Ce,ce){for(var te=[],J=function(){var Me=me.value;switch(te=te.concat(ce.call(pe,Me)),Me.type){case"table":{for(var fe=A(Me.header),ye;!(ye=fe()).done;){var F=ye.value;te=te.concat(pe.walkTokens(F.tokens,ce))}for(var H=A(Me.rows),K;!(K=H()).done;)for(var j=K.value,Y=A(j),_;!(_=Y()).done;){var Ee=_.value;te=te.concat(pe.walkTokens(Ee.tokens,ce))}break}case"list":{te=te.concat(pe.walkTokens(Me.items,ce));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Me.type]?pe.defaults.extensions.childTokens[Me.type].forEach(function(Ne){te=te.concat(pe.walkTokens(Me[Ne],ce))}):Me.tokens&&(te=te.concat(pe.walkTokens(Me.tokens,ce)))}},ee=A(Ce),me;!(me=ee()).done;)J();return te},pe.parseInline=function(Ce,ce){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");ce=S({},pe.defaults,ce||{}),D(ce);try{var te=ae.lexInline(Ce,ce);return ce.walkTokens&&pe.walkTokens(te,ce.walkTokens),ue.parseInline(te,ce)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(J.message+"",!0)+"</pre>";throw J}},pe.Parser=ue,pe.parser=ue.parse,pe.Renderer=de,pe.TextRenderer=we,pe.Lexer=ae,pe.lexer=ae.lex,pe.Tokenizer=q,pe.Slugger=ke,pe.parse=pe;var ie=pe.options,be=pe.setOptions,se=pe.use,Z=pe.walkTokens,V=pe.parseInline,ne=pe,Ae=ue.parse,Le=ae.lex;ge.Lexer=ae,ge.Parser=ue,ge.Renderer=de,ge.Slugger=ke,ge.TextRenderer=we,ge.Tokenizer=q,ge.getDefaults=P,ge.lexer=Le,ge.marked=pe,ge.options=ie,ge.parse=ne,ge.parseInline=V,ge.parser=Ae,ge.setOptions=be,ge.use=se,ge.walkTokens=Z,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Pe[121],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=void 0;function y(s){const a=A(s);if(a&&a.length>0)return new Uint32Array(a)}e.$Rj=y;let M=0;const C=new Uint32Array(10);function A(s){if(M=0,P(s,k,4352),M>0||(P(s,l,4449),M>0)||(P(s,$,4520),M>0)||(P(s,v,12593),M))return C.subarray(0,M);if(s>=44032&&s<=55203){const a=s-44032,r=a%588,n=Math.floor(a/588),o=Math.floor(r/28),c=r%28-1;if(n<k.length?P(n,k,0):4352+n-12593<v.length&&P(4352+n,v,12593),o<l.length?P(o,l,0):4449+o-12593<v.length&&P(4449+o-12593,v,12593),c>=0&&(c<$.length?P(c,$,0):4520+c-12593<v.length&&P(4520+c-12593,v,12593)),M>0)return C.subarray(0,M)}}function P(s,a,r){s>=r&&s<r+a.length&&m(a[s-r])}function m(s){s!==0&&(C[M++]=s&255,s>>8&&(C[M++]=s>>8&255),s>>16&&(C[M++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var w;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(w||(w={}));var R;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(R||(R={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),$=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[122],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.rot=e.$7l=void 0;function y(m,f,w){return Math.min(Math.max(m,f),w)}e.$7l=y;function M(m,f){return(f+m%f)%f}e.rot=M;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$9l=C;class A{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$0l=A;class P{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const w=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$$l=P}),function(){function ge(C){const A=[];typeof C=="number"&&A.push("code/timeOrigin",C);function P(f){A.push(f,Date.now())}function m(){const f=[];for(let w=0;w<A.length;w+=2)f.push({name:A[w],startTime:A[w+1]});return f}return{mark:P,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const P of performance.getEntriesByType("mark"))A.push({name:P.name,startTime:Math.round(C+P.startTime)});return A}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=y(M))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var M in y)(typeof exports=="object"?exports:ge)[M]=y[M]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function y(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return ge[M].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=ge,y.c=e,y.d=function(M,C,A){y.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:A})},y.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},y.t=function(M,C){if(1&C&&(M=y(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var A=Object.create(null);if(y.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var P in M)y.d(A,P,function(m){return M[m]}.bind(null,P));return A},y.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return y.d(C,"a",C),C},y.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},y.p="",y(y.s=0)}([function(ge,e,y){(function(M){var C;e=ge.exports=se,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],f=e.src=[],w=0,R=w++;f[R]="0|[1-9]\\d*";var k=w++;f[k]="[0-9]+";var l=w++;f[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=w++;f[$]="("+f[R]+")\\.("+f[R]+")\\.("+f[R]+")";var v=w++;f[v]="("+f[k]+")\\.("+f[k]+")\\.("+f[k]+")";var s=w++;f[s]="(?:"+f[R]+"|"+f[l]+")";var a=w++;f[a]="(?:"+f[k]+"|"+f[l]+")";var r=w++;f[r]="(?:-("+f[s]+"(?:\\."+f[s]+")*))";var n=w++;f[n]="(?:-?("+f[a]+"(?:\\."+f[a]+")*))";var o=w++;f[o]="[0-9A-Za-z-]+";var c=w++;f[c]="(?:\\+("+f[o]+"(?:\\."+f[o]+")*))";var h=w++,i="v?"+f[$]+f[r]+"?"+f[c]+"?";f[h]="^"+i+"$";var u="[v=\\s]*"+f[v]+f[n]+"?"+f[c]+"?",t=w++;f[t]="^"+u+"$";var g=w++;f[g]="((?:<|>)?=?)";var p=w++;f[p]=f[k]+"|x|X|\\*";var d=w++;f[d]=f[R]+"|x|X|\\*";var S=w++;f[S]="[v=\\s]*("+f[d]+")(?:\\.("+f[d]+")(?:\\.("+f[d]+")(?:"+f[r]+")?"+f[c]+"?)?)?";var L=w++;f[L]="[v=\\s]*("+f[p]+")(?:\\.("+f[p]+")(?:\\.("+f[p]+")(?:"+f[n]+")?"+f[c]+"?)?)?";var b=w++;f[b]="^"+f[g]+"\\s*"+f[S]+"$";var E=w++;f[E]="^"+f[g]+"\\s*"+f[L]+"$";var D=w++;f[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=w++;f[T]="(?:~>?)";var O=w++;f[O]="(\\s*)"+f[T]+"\\s+",m[O]=new RegExp(f[O],"g");var G=w++;f[G]="^"+f[T]+f[S]+"$";var q=w++;f[q]="^"+f[T]+f[L]+"$";var U=w++;f[U]="(?:\\^)";var I=w++;f[I]="(\\s*)"+f[U]+"\\s+",m[I]=new RegExp(f[I],"g");var N=w++;f[N]="^"+f[U]+f[S]+"$";var W=w++;f[W]="^"+f[U]+f[L]+"$";var ae=w++;f[ae]="^"+f[g]+"\\s*("+u+")$|^$";var de=w++;f[de]="^"+f[g]+"\\s*("+i+")$|^$";var we=w++;f[we]="(\\s*)"+f[g]+"\\s*("+u+"|"+f[S]+")",m[we]=new RegExp(f[we],"g");var ke=w++;f[ke]="^\\s*("+f[S]+")\\s+-\\s+("+f[S]+")\\s*$";var ue=w++;f[ue]="^\\s*("+f[L]+")\\s+-\\s+("+f[L]+")\\s*$";var pe=w++;f[pe]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)C(ie,f[ie]),m[ie]||(m[ie]=new RegExp(f[ie]));function be(j,Y){if(j instanceof se)return j;if(typeof j!="string"||j.length>A||!(Y?m[t]:m[h]).test(j))return null;try{return new se(j,Y)}catch{return null}}function se(j,Y){if(j instanceof se){if(j.loose===Y)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof se))return new se(j,Y);C("SemVer",j,Y),this.loose=Y;var _=j.trim().match(Y?m[t]:m[h]);if(!_)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Ne=+Ee;if(Ne>=0&&Ne<P)return Ne}return Ee}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=be,e.valid=function(j,Y){var _=be(j,Y);return _?_.version:null},e.clean=function(j,Y){var _=be(j.trim().replace(/^[=v]+/,""),Y);return _?_.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(j){return C("SemVer.compare",this.version,this.loose,j),j instanceof se||(j=new se(j,this.loose)),this.compareMain(j)||this.comparePre(j)},se.prototype.compareMain=function(j){return j instanceof se||(j=new se(j,this.loose)),V(this.major,j.major)||V(this.minor,j.minor)||V(this.patch,j.patch)},se.prototype.comparePre=function(j){if(j instanceof se||(j=new se(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var Y=0;do{var _=this.prerelease[Y],Ee=j.prerelease[Y];if(C("prerelease compare",Y,_,Ee),_===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(_===void 0)return-1;if(_!==Ee)return V(_,Ee)}while(++Y)},se.prototype.inc=function(j,Y){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,Y,_,Ee){typeof _=="string"&&(Ee=_,_=void 0);try{return new se(j,_).inc(Y,Ee).version}catch{return null}},e.diff=function(j,Y){if(Ce(j,Y))return null;var _=be(j),Ee=be(Y);if(_.prerelease.length||Ee.prerelease.length){for(var Ne in _)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&_[Ne]!==Ee[Ne])return"pre"+Ne;return"prerelease"}for(var Ne in _)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&_[Ne]!==Ee[Ne])return Ne},e.compareIdentifiers=V;var Z=/^[0-9]+$/;function V(j,Y){var _=Z.test(j),Ee=Z.test(Y);return _&&Ee&&(j=+j,Y=+Y),_&&!Ee?-1:Ee&&!_?1:j<Y?-1:j>Y?1:0}function ne(j,Y,_){return new se(j,_).compare(new se(Y,_))}function Ae(j,Y,_){return ne(j,Y,_)>0}function Le(j,Y,_){return ne(j,Y,_)<0}function Ce(j,Y,_){return ne(j,Y,_)===0}function ce(j,Y,_){return ne(j,Y,_)!==0}function te(j,Y,_){return ne(j,Y,_)>=0}function J(j,Y,_){return ne(j,Y,_)<=0}function ee(j,Y,_,Ee){var Ne;switch(Y){case"===":typeof j=="object"&&(j=j.version),typeof _=="object"&&(_=_.version),Ne=j===_;break;case"!==":typeof j=="object"&&(j=j.version),typeof _=="object"&&(_=_.version),Ne=j!==_;break;case"":case"=":case"==":Ne=Ce(j,_,Ee);break;case"!=":Ne=ce(j,_,Ee);break;case">":Ne=Ae(j,_,Ee);break;case">=":Ne=te(j,_,Ee);break;case"<":Ne=Le(j,_,Ee);break;case"<=":Ne=J(j,_,Ee);break;default:throw new TypeError("Invalid operator: "+Y)}return Ne}function me(j,Y){if(j instanceof me){if(j.loose===Y)return j;j=j.value}if(!(this instanceof me))return new me(j,Y);C("comparator",j,Y),this.loose=Y,this.parse(j),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(j,Y){return V(Y,j)},e.major=function(j,Y){return new se(j,Y).major},e.minor=function(j,Y){return new se(j,Y).minor},e.patch=function(j,Y){return new se(j,Y).patch},e.compare=ne,e.compareLoose=function(j,Y){return ne(j,Y,!0)},e.rcompare=function(j,Y,_){return ne(Y,j,_)},e.sort=function(j,Y){return j.sort(function(_,Ee){return e.compare(_,Ee,Y)})},e.rsort=function(j,Y){return j.sort(function(_,Ee){return e.rcompare(_,Ee,Y)})},e.gt=Ae,e.lt=Le,e.eq=Ce,e.neq=ce,e.gte=te,e.lte=J,e.cmp=ee,e.Comparator=me;var ve={};function Me(j,Y){if(j instanceof Me)return j.loose===Y?j:new Me(j.raw,Y);if(j instanceof me)return new Me(j.value,Y);if(!(this instanceof Me))return new Me(j,Y);if(this.loose=Y,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function fe(j){return!j||j.toLowerCase()==="x"||j==="*"}function ye(j,Y,_,Ee,Ne,Ve,Ke,Xe,nt,it,et,at,ct){return((Y=fe(_)?"":fe(Ee)?">="+_+".0.0":fe(Ne)?">="+_+"."+Ee+".0":">="+Y)+" "+(Xe=fe(nt)?"":fe(it)?"<"+(+nt+1)+".0.0":fe(et)?"<"+nt+"."+(+it+1)+".0":at?"<="+nt+"."+it+"."+et+"-"+at:"<="+Xe)).trim()}function F(j,Y){for(var _=0;_<j.length;_++)if(!j[_].test(Y))return!1;if(Y.prerelease.length){for(_=0;_<j.length;_++)if(C(j[_].semver),j[_].semver!==ve&&j[_].semver.prerelease.length>0){var Ee=j[_].semver;if(Ee.major===Y.major&&Ee.minor===Y.minor&&Ee.patch===Y.patch)return!0}return!1}return!0}function H(j,Y,_){try{Y=new Me(Y,_)}catch{return!1}return Y.test(j)}function K(j,Y,_,Ee){var Ne,Ve,Ke,Xe,nt;switch(j=new se(j,Ee),Y=new Me(Y,Ee),_){case">":Ne=Ae,Ve=J,Ke=Le,Xe=">",nt=">=";break;case"<":Ne=Le,Ve=te,Ke=Ae,Xe="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(H(j,Y,Ee))return!1;for(var it=0;it<Y.set.length;++it){var et=Y.set[it],at=null,ct=null;if(et.forEach(function(je){je.semver===ve&&(je=new me(">=0.0.0")),at=at||je,ct=ct||je,Ne(je.semver,at.semver,Ee)?at=je:Ke(je.semver,ct.semver,Ee)&&(ct=je)}),at.operator===Xe||at.operator===nt||(!ct.operator||ct.operator===Xe)&&Ve(j,ct.semver)||ct.operator===nt&&Ke(j,ct.semver))return!1}return!0}me.prototype.parse=function(j){var Y=this.loose?m[ae]:m[de],_=j.match(Y);if(!_)throw new TypeError("Invalid comparator: "+j);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new se(_[2],this.loose):this.semver=ve},me.prototype.toString=function(){return this.value},me.prototype.test=function(j){return C("Comparator.test",j,this.loose),this.semver===ve||(typeof j=="string"&&(j=new se(j,this.loose)),ee(j,this.operator,this.semver,this.loose))},me.prototype.intersects=function(j,Y){if(!(j instanceof me))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new Me(j.value,Y),H(this.value,_,Y);if(j.operator==="")return _=new Me(this.value,Y),H(j.semver,_,Y);var Ee=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),Ne=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ve=this.semver.version===j.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Xe=ee(this.semver,"<",j.semver,Y)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),nt=ee(this.semver,">",j.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return Ee||Ne||Ve&&Ke||Xe||nt},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(j){var Y=this.loose;j=j.trim(),C("range",j,Y);var _=Y?m[ue]:m[ke];j=j.replace(_,ye),C("hyphen replace",j),j=j.replace(m[we],"$1$2$3"),C("comparator trim",j,m[we]),j=(j=(j=j.replace(m[O],"$1~")).replace(m[I],"$1^")).split(/\s+/).join(" ");var Ee=Y?m[ae]:m[de],Ne=j.split(" ").map(function(Ve){return function(Ke,Xe){return C("comp",Ke),Ke=function(nt,it){return nt.trim().split(/\s+/).map(function(et){return function(at,ct){C("caret",at,ct);var je=ct?m[W]:m[N];return at.replace(je,function(mt,X,x,$e,Be){var Qe;return C("caret",at,mt,X,x,$e,Be),fe(X)?Qe="":fe(x)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":fe($e)?Qe=X==="0"?">="+X+"."+x+".0 <"+X+"."+(+x+1)+".0":">="+X+"."+x+".0 <"+(+X+1)+".0.0":Be?(C("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=X==="0"?x==="0"?">="+X+"."+x+"."+$e+Be+" <"+X+"."+x+"."+(+$e+1):">="+X+"."+x+"."+$e+Be+" <"+X+"."+(+x+1)+".0":">="+X+"."+x+"."+$e+Be+" <"+(+X+1)+".0.0"):(C("no pr"),Qe=X==="0"?x==="0"?">="+X+"."+x+"."+$e+" <"+X+"."+x+"."+(+$e+1):">="+X+"."+x+"."+$e+" <"+X+"."+(+x+1)+".0":">="+X+"."+x+"."+$e+" <"+(+X+1)+".0.0"),C("caret return",Qe),Qe})}(et,it)}).join(" ")}(Ke,Xe),C("caret",Ke),Ke=function(nt,it){return nt.trim().split(/\s+/).map(function(et){return function(at,ct){var je=ct?m[q]:m[G];return at.replace(je,function(mt,X,x,$e,Be){var Qe;return C("tilde",at,mt,X,x,$e,Be),fe(X)?Qe="":fe(x)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":fe($e)?Qe=">="+X+"."+x+".0 <"+X+"."+(+x+1)+".0":Be?(C("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=">="+X+"."+x+"."+$e+Be+" <"+X+"."+(+x+1)+".0"):Qe=">="+X+"."+x+"."+$e+" <"+X+"."+(+x+1)+".0",C("tilde return",Qe),Qe})}(et,it)}).join(" ")}(Ke,Xe),C("tildes",Ke),Ke=function(nt,it){return C("replaceXRanges",nt,it),nt.split(/\s+/).map(function(et){return function(at,ct){at=at.trim();var je=ct?m[E]:m[b];return at.replace(je,function(mt,X,x,$e,Be,Qe){C("xRange",at,mt,X,x,$e,Be,Qe);var tt=fe(x),rt=tt||fe($e),Te=rt||fe(Be);return X==="="&&Te&&(X=""),tt?mt=X===">"||X==="<"?"<0.0.0":"*":X&&Te?(rt&&($e=0),Te&&(Be=0),X===">"?(X=">=",rt?(x=+x+1,$e=0,Be=0):Te&&($e=+$e+1,Be=0)):X==="<="&&(X="<",rt?x=+x+1:$e=+$e+1),mt=X+x+"."+$e+"."+Be):rt?mt=">="+x+".0.0 <"+(+x+1)+".0.0":Te&&(mt=">="+x+"."+$e+".0 <"+x+"."+(+$e+1)+".0"),C("xRange return",mt),mt})}(et,it)}).join(" ")}(Ke,Xe),C("xrange",Ke),Ke=function(nt,it){return C("replaceStars",nt,it),nt.trim().replace(m[pe],"")}(Ke,Xe),C("stars",Ke),Ke}(Ve,Y)}).join(" ").split(/\s+/);return this.loose&&(Ne=Ne.filter(function(Ve){return!!Ve.match(Ee)})),Ne=Ne.map(function(Ve){return new me(Ve,Y)})},Me.prototype.intersects=function(j,Y){if(!(j instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(Ee){return j.set.some(function(Ne){return Ne.every(function(Ve){return Ee.intersects(Ve,Y)})})})})},e.toComparators=function(j,Y){return new Me(j,Y).set.map(function(_){return _.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new se(j,this.loose));for(var Y=0;Y<this.set.length;Y++)if(F(this.set[Y],j))return!0;return!1},e.satisfies=H,e.maxSatisfying=function(j,Y,_){var Ee=null,Ne=null;try{var Ve=new Me(Y,_)}catch{return null}return j.forEach(function(Ke){Ve.test(Ke)&&(Ee&&Ne.compare(Ke)!==-1||(Ne=new se(Ee=Ke,_)))}),Ee},e.minSatisfying=function(j,Y,_){var Ee=null,Ne=null;try{var Ve=new Me(Y,_)}catch{return null}return j.forEach(function(Ke){Ve.test(Ke)&&(Ee&&Ne.compare(Ke)!==1||(Ne=new se(Ee=Ke,_)))}),Ee},e.validRange=function(j,Y){try{return new Me(j,Y).range||"*"}catch{return null}},e.ltr=function(j,Y,_){return K(j,Y,"<",_)},e.gtr=function(j,Y,_){return K(j,Y,">",_)},e.outside=K,e.prerelease=function(j,Y){var _=be(j,Y);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(j,Y,_){return j=new Me(j,_),Y=new Me(Y,_),j.intersects(Y)},e.coerce=function(j){if(j instanceof se)return j;if(typeof j!="string")return null;var Y=j.match(m[D]);return Y==null?null:be((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,y(1))},function(ge,e){var y,M,C=ge.exports={};function A(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function m(a){if(y===setTimeout)return setTimeout(a,0);if((y===A||!y)&&setTimeout)return y=setTimeout,setTimeout(a,0);try{return y(a,0)}catch{try{return y.call(null,a,0)}catch{return y.call(this,a,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:A}catch{y=A}try{M=typeof clearTimeout=="function"?clearTimeout:P}catch{M=P}})();var f,w=[],R=!1,k=-1;function l(){R&&f&&(R=!1,f.length?w=f.concat(w):k=-1,w.length&&$())}function $(){if(!R){var a=m(l);R=!0;for(var r=w.length;r;){for(f=w,w=[];++k<r;)f&&f[k].run();k=-1,r=w.length}f=null,R=!1,function(n){if(M===clearTimeout)return clearTimeout(n);if((M===P||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(n);try{M(n)}catch{try{return M.call(null,n)}catch{return M.call(this,n)}}}(a)}}function v(a,r){this.fun=a,this.array=r}function s(){}C.nextTick=function(a){var r=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)r[n-1]=arguments[n];w.push(new v(a,r)),w.length!==1||R||m($)},v.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=s,C.addListener=s,C.once=s,C.off=s,C.removeListener=s,C.removeAllListeners=s,C.emit=s,C.prependListener=s,C.prependOnceListener=s,C.listeners=function(a){return[]},C.binding=function(a){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(a){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[123],Re([1,0,15,6]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function C(c){const h=c;return h?typeof h.read=="function":!1}e.$7d=C;function A(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$8d=A;function P(c){const h=c;return h?A(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$9d=P;function m(c,h){return new f(c,h)}e.$0d=m;class f{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,y.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let u;switch(h){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const t=u.indexOf(i);t>=0&&u.splice(t,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,h){const i=[];let u;for(;(u=c.read())!==null;)i.push(u);return h(i)}e.$$d=w;function R(c,h,i){const u=[];let t;for(;(t=c.read())!==null&&u.length<i;)u.push(t);return t===null&&u.length>0?h(u):{read:()=>{if(u.length>0)return u.shift();if(typeof t<"u"){const g=t;return t=void 0,g}return c.read()}}}e.$_d=R;function k(c,h){return new Promise((i,u)=>{const t=[];l(c,{onData:g=>{h&&t.push(g)},onError:g=>{h?u(g):i(void 0)},onEnd:()=>{i(h?h(t):void 0)}})})}e.$ae=k;function l(c,h,i){c.on("error",u=>{i?.isCancellationRequested||h.onError(u)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",u=>{i?.isCancellationRequested||h.onData(u)})}e.$be=l;function $(c,h){return new Promise((i,u)=>{const t=new M.$Sc,g=[],p=L=>{if(g.push(L),g.length>h)return t.dispose(),c.pause(),i({stream:c,buffer:g,ended:!1})},d=L=>(t.dispose(),u(L)),S=()=>(t.dispose(),i({stream:c,buffer:g,ended:!0}));t.add((0,M.$Rc)(()=>c.removeListener("error",d))),c.on("error",d),t.add((0,M.$Rc)(()=>c.removeListener("end",S))),c.on("end",S),t.add((0,M.$Rc)(()=>c.removeListener("data",p))),c.on("data",p)})}e.$ce=$;function v(c,h){const i=m(h);return i.end(c),i}e.$de=v;function s(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}e.$ee=s;function a(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$fe=a;function r(c,h,i){const u=m(i);return l(c,{onData:t=>u.write(h.data(t)),onError:t=>u.error(h.error?h.error(t):t),onEnd:()=>u.end()}),u}e.$ge=r;function n(c,h,i){let u=!1;return{read:()=>{const t=h.read();return u?t:(u=!0,t!==null?i([c,t]):c)}}}e.$he=n;function o(c,h,i){let u=!1;const t=m(i);return l(h,{onData:g=>u?t.write(g):(u=!0,t.write(i([c,g]))),onError:g=>t.error(g),onEnd:()=>{u||(u=!0,t.write(c)),t.end()}}),t}e.$ie=o}),define(Pe[22],Re([1,0,39,123]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const C=typeof Buffer<"u",A=new y.$V(()=>new Uint8Array(256));let P,m;class f{static alloc(D){return C?new f(Buffer.allocUnsafe(D)):new f(new Uint8Array(D))}static wrap(D){return C&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new f(D)}static fromString(D,T){return!(T?.dontUseNodeBuffer||!1)&&C?new f(Buffer.from(D)):(P||(P=new TextEncoder),new f(P.encode(D)))}static fromByteArray(D){const T=f.alloc(D.length);for(let O=0,G=D.length;O<G;O++)T.buffer[O]=D[O];return T}static concat(D,T){if(typeof T>"u"){T=0;for(let q=0,U=D.length;q<U;q++)T+=D[q].byteLength}const O=f.alloc(T);let G=0;for(let q=0,U=D.length;q<U;q++){const I=D[q];O.set(I,G),G+=I.byteLength}return O}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=f.alloc(this.byteLength);return D.set(this),D}toString(){return C?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(D,T){return new f(this.buffer.subarray(D,T))}set(D,T){if(D instanceof f)this.buffer.set(D.buffer,T);else if(D instanceof Uint8Array)this.buffer.set(D,T);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),T);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return l(this.buffer,D)}writeUInt32BE(D,T){$(this.buffer,D,T)}readUInt32LE(D){return v(this.buffer,D)}writeUInt32LE(D,T){s(this.buffer,D,T)}readUInt8(D){return a(this.buffer,D)}writeUInt8(D,T){r(this.buffer,D,T)}indexOf(D,T=0){return w(this.buffer,D instanceof f?D.buffer:D,T)}}e.$je=f;function w(E,D,T=0){const O=D.byteLength,G=E.byteLength;if(O===0)return 0;if(O===1)return E.indexOf(D[0]);if(O>G-T)return-1;const q=A.value;q.fill(D.length);for(let W=0;W<D.length;W++)q[D[W]]=D.length-W-1;let U=T+D.length-1,I=U,N=-1;for(;U<G;)if(E[U]===D[I]){if(I===0){N=U;break}U--,I--}else U+=Math.max(D.length-I,q[E[U]]),I=D.length-1;return N}e.$ke=w;function R(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0}e.$le=R;function k(E,D,T){E[T+0]=D&255,D=D>>>8,E[T+1]=D&255}e.$me=k;function l(E,D){return E[D]*2**24+E[D+1]*2**16+E[D+2]*2**8+E[D+3]}e.$ne=l;function $(E,D,T){E[T+3]=D,D=D>>>8,E[T+2]=D,D=D>>>8,E[T+1]=D,D=D>>>8,E[T]=D}e.$oe=$;function v(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0|E[D+2]<<16>>>0|E[D+3]<<24>>>0}e.$pe=v;function s(E,D,T){E[T+0]=D&255,D=D>>>8,E[T+1]=D&255,D=D>>>8,E[T+2]=D&255,D=D>>>8,E[T+3]=D&255}e.$qe=s;function a(E,D){return E[D]}e.$re=a;function r(E,D,T){E[T]=D}e.$se=r;function n(E){return M.$$d(E,D=>f.concat(D))}e.$te=n;function o(E){return M.$fe(E)}e.$ue=o;function c(E){return M.$ae(E,D=>f.concat(D))}e.$ve=c;async function h(E){return E.ended?f.concat(E.buffer):f.concat([...E.buffer,await c(E.stream)])}e.$we=h;function i(E){return M.$de(E,D=>f.concat(D))}e.$xe=i;function u(E){return M.$ge(E,{data:D=>typeof D=="string"?f.fromString(D):f.wrap(D)},D=>f.concat(D))}e.$ye=u;function t(E){return M.$0d(D=>f.concat(D),E)}e.$ze=t;function g(E,D){return M.$he(E,D,T=>f.concat(T))}e.$Ae=g;function p(E,D){return M.$ie(E,D,T=>f.concat(T))}e.$Be=p;function d(E){let D=0,T=0,O=0;const G=new Uint8Array(Math.floor(E.length/4*3)),q=I=>{switch(T){case 3:G[O++]=D|I,T=0;break;case 2:G[O++]=D|I>>>2,D=I<<6,T=3;break;case 1:G[O++]=D|I>>>4,D=I<<4,T=2;break;default:D=I<<2,T=1}};for(let I=0;I<E.length;I++){const N=E.charCodeAt(I);if(N>=65&&N<=90)q(N-65);else if(N>=97&&N<=122)q(N-97+26);else if(N>=48&&N<=57)q(N-48+52);else if(N===43||N===45)q(62);else if(N===47||N===95)q(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${E[I]}`)}}const U=O;for(;T>0;)q(0);return f.wrap(G).slice(0,U)}e.$Ce=d;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:E},D=!0,T=!1){const O=T?L:S;let G="";const q=E.byteLength%3;let U=0;for(;U<E.byteLength-q;U+=3){const I=E[U+0],N=E[U+1],W=E[U+2];G+=O[I>>>2],G+=O[(I<<4|N>>>4)&63],G+=O[(N<<2|W>>>6)&63],G+=O[W&63]}if(q===1){const I=E[U+0];G+=O[I>>>2],G+=O[I<<4&63],D&&(G+="==")}else if(q===2){const I=E[U+0],N=E[U+1];G+=O[I>>>2],G+=O[(I<<4|N>>>4)&63],G+=O[N<<2&63],D&&(G+="=")}return G}e.$De=b}),define(Pe[124],Re([1,0,28,121,12]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=e.$6j=e.FuzzyScore=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.or=void 0;function A(...fe){return function(ye,F){for(let H=0,K=fe.length;H<K;H++){const j=fe[H](ye,F);if(j)return j}return null}}e.or=A,e.$Tj=P.bind(void 0,!1),e.$Uj=P.bind(void 0,!0);function P(fe,ye,F){if(!F||F.length<ye.length)return null;let H;return fe?H=C.$af(F,ye):H=F.indexOf(ye)===0,H?ye.length>0?[{start:0,end:ye.length}]:[]:null}function m(fe,ye){const F=ye.toLowerCase().indexOf(fe.toLowerCase());return F===-1?null:[{start:F,end:F+fe.length}]}e.$Vj=m;function f(fe,ye){return w(fe.toLowerCase(),ye.toLowerCase(),0,0)}e.$Wj=f;function w(fe,ye,F,H){if(F===fe.length)return[];if(H===ye.length)return null;if(fe[F]===ye[H]){let K=null;return(K=w(fe,ye,F+1,H+1))?c({start:H,end:H+1},K):null}return w(fe,ye,F,H+1)}function R(fe){return 97<=fe&&fe<=122}function k(fe){return 65<=fe&&fe<=90}e.$Xj=k;function l(fe){return 48<=fe&&fe<=57}function $(fe){return fe===32||fe===9||fe===10||fe===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>v.add(fe.charCodeAt(0)));function s(fe){return $(fe)||v.has(fe)}function a(fe,ye){return fe===ye||s(fe)&&s(ye)}const r=new Map;function n(fe){if(r.has(fe))return r.get(fe);let ye;const F=(0,M.$Rj)(fe);return F&&(ye=F),r.set(fe,ye),ye}function o(fe){return R(fe)||k(fe)||l(fe)}function c(fe,ye){return ye.length===0?ye=[fe]:fe.end===ye[0].start?ye[0].start=fe.start:ye.unshift(fe),ye}function h(fe,ye){for(let F=ye;F<fe.length;F++){const H=fe.charCodeAt(F);if(k(H)||l(H)||F>0&&!o(fe.charCodeAt(F-1)))return F}return fe.length}function i(fe,ye,F,H){if(F===fe.length)return[];if(H===ye.length)return null;if(fe[F]!==ye[H].toLowerCase())return null;{let K=null,j=H+1;for(K=i(fe,ye,F+1,H+1);!K&&(j=h(ye,j))<ye.length;)K=i(fe,ye,F+1,j),j++;return K===null?null:c({start:H,end:H+1},K)}}function u(fe){let ye=0,F=0,H=0,K=0,j=0;for(let Ve=0;Ve<fe.length;Ve++)j=fe.charCodeAt(Ve),k(j)&&ye++,R(j)&&F++,o(j)&&H++,l(j)&&K++;const Y=ye/fe.length,_=F/fe.length,Ee=H/fe.length,Ne=K/fe.length;return{upperPercent:Y,lowerPercent:_,alphaPercent:Ee,numericPercent:Ne}}function t(fe){const{upperPercent:ye,lowerPercent:F}=fe;return F===0&&ye>.6}function g(fe){const{upperPercent:ye,lowerPercent:F,alphaPercent:H,numericPercent:K}=fe;return F>.2&&ye<.8&&H>.6&&K<.2}function p(fe){let ye=0,F=0,H=0,K=0;for(let j=0;j<fe.length;j++)H=fe.charCodeAt(j),k(H)&&ye++,R(H)&&F++,$(H)&&K++;return(ye===0||F===0)&&K===0?fe.length<=30:ye<=5}function d(fe,ye){if(!ye||(ye=ye.trim(),ye.length===0)||!p(fe)||ye.length>60)return null;const F=u(ye);if(!g(F)){if(!t(F))return null;ye=ye.toLowerCase()}let H=null,K=0;for(fe=fe.toLowerCase();K<ye.length&&(H=i(fe,ye,0,K))===null;)K=h(ye,K+1);return H}e.$Yj=d;function S(fe,ye,F=!1){if(!ye||ye.length===0)return null;let H=null,K=0;for(fe=fe.toLowerCase(),ye=ye.toLowerCase();K<ye.length&&(H=L(fe,ye,0,K,F),H===null);)K=b(ye,K+1);return H}e.$Zj=S;function L(fe,ye,F,H,K){let j=0;if(F===fe.length)return[];if(H===ye.length)return null;if(!a(fe.charCodeAt(F),ye.charCodeAt(H))){const Ee=n(fe.charCodeAt(F));if(!Ee)return null;for(let Ne=0;Ne<Ee.length;Ne++)if(!a(Ee[Ne],ye.charCodeAt(H+Ne)))return null;j+=Ee.length-1}let Y=null,_=H+j+1;if(Y=L(fe,ye,F+1,_,K),!K)for(;!Y&&(_=b(ye,_))<ye.length;)Y=L(fe,ye,F+1,_,K),_++;if(!Y)return null;if(fe.charCodeAt(F)!==ye.charCodeAt(H)){const Ee=n(fe.charCodeAt(F));if(!Ee)return Y;for(let Ne=0;Ne<Ee.length;Ne++)if(Ee[Ne]!==ye.charCodeAt(H+Ne))return Y}return c({start:H,end:H+j+1},Y)}function b(fe,ye){for(let F=ye;F<fe.length;F++)if(s(fe.charCodeAt(F))||F>0&&s(fe.charCodeAt(F-1)))return F;return fe.length}const E=A(e.$Uj,d,m),D=A(e.$Uj,d,f),T=new y.$Dc(1e4);function O(fe,ye,F=!1){if(typeof fe!="string"||typeof ye!="string")return null;let H=T.get(fe);H||(H=new RegExp(C.$Ve(fe),"i"),T.set(fe,H));const K=H.exec(ye);return K?[{start:K.index,end:K.index+K[0].length}]:F?D(fe,ye):E(fe,ye)}e.$1j=O;function G(fe,ye){const F=ce(fe,fe.toLowerCase(),0,ye,ye.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?U(F):null}e.$2j=G;function q(fe,ye,F,H,K,j){const Y=Math.min(13,fe.length);for(;F<Y;F++){const _=ce(fe,ye,F,H,K,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(_)return _}return[0,j]}e.$3j=q;function U(fe){if(typeof fe>"u")return[];const ye=[],F=fe[1];for(let H=fe.length-1;H>1;H--){const K=fe[H]+F,j=ye[ye.length-1];j&&j.end===K?j.end=K+1:ye.push({start:K,end:K+1})}return ye}e.$4j=U;const I=128;function N(){const fe=[],ye=[];for(let F=0;F<=I;F++)ye[F]=0;for(let F=0;F<=I;F++)fe.push(ye.slice(0));return fe}function W(fe){const ye=[];for(let F=0;F<=fe;F++)ye[F]=0;return ye}const ae=W(2*I),de=W(2*I),we=N(),ke=N(),ue=N(),pe=!1;function ie(fe,ye,F,H,K){function j(_,Ee,Ne=" "){for(;_.length<Ee;)_=Ne+_;return _}let Y=` |   |${H.split("").map(_=>j(_,3)).join("|")}
`;for(let _=0;_<=F;_++)_===0?Y+=" |":Y+=`${ye[_-1]}|`,Y+=fe[_].slice(0,K+1).map(Ee=>j(Ee.toString(),3)).join("|")+`
`;return Y}function be(fe,ye,F,H){fe=fe.substr(ye),F=F.substr(H),console.log(ie(ke,fe,fe.length,F,F.length)),console.log(ie(ue,fe,fe.length,F,F.length)),console.log(ie(we,fe,fe.length,F,F.length))}function se(fe,ye){if(ye<0||ye>=fe.length)return!1;const F=fe.codePointAt(ye);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.$sf(F)}}function Z(fe,ye){if(ye<0||ye>=fe.length)return!1;switch(fe.charCodeAt(ye)){case 32:case 9:return!0;default:return!1}}function V(fe,ye,F){return ye[fe]!==F[fe]}function ne(fe,ye,F,H,K,j,Y=!1){for(;ye<F&&K<j;)fe[ye]===H[K]&&(Y&&(ae[ye]=K),ye+=1),K+=1;return ye===F}e.$5j=ne;var Ae;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var Le;(function(fe){fe.Default=[-100,0];function ye(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}fe.isDefault=ye})(Le||(e.FuzzyScore=Le={}));class Ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ye,F){this.firstMatchCanBeWeak=ye,this.boostFullMatch=F}}e.$6j=Ce;function ce(fe,ye,F,H,K,j,Y=Ce.default){const _=fe.length>I?I:fe.length,Ee=H.length>I?I:H.length;if(F>=_||j>=Ee||_-F>Ee-j||!ne(ye,F,_,K,j,Ee,!0))return;te(_,Ee,F,j,ye,K);let Ne=1,Ve=1,Ke=F,Xe=j;const nt=[!1];for(Ne=1,Ke=F;Ke<_;Ne++,Ke++){const je=ae[Ke],mt=de[Ke],X=Ke+1<_?de[Ke+1]:Ee;for(Ve=je-j+1,Xe=je;Xe<X;Ve++,Xe++){let x=Number.MIN_SAFE_INTEGER,$e=!1;Xe<=mt&&(x=J(fe,ye,Ke,F,H,K,Xe,Ee,j,we[Ne-1][Ve-1]===0,nt));let Be=0;x!==Number.MAX_SAFE_INTEGER&&($e=!0,Be=x+ke[Ne-1][Ve-1]);const Qe=Xe>je,tt=Qe?ke[Ne][Ve-1]+(we[Ne][Ve-1]>0?-5:0):0,rt=Xe>je+1&&we[Ne][Ve-1]>0,Te=rt?ke[Ne][Ve-2]+(we[Ne][Ve-2]>0?-5:0):0;if(rt&&(!Qe||Te>=tt)&&(!$e||Te>=Be))ke[Ne][Ve]=Te,ue[Ne][Ve]=3,we[Ne][Ve]=0;else if(Qe&&(!$e||tt>=Be))ke[Ne][Ve]=tt,ue[Ne][Ve]=2,we[Ne][Ve]=0;else if($e)ke[Ne][Ve]=Be,ue[Ne][Ve]=1,we[Ne][Ve]=we[Ne-1][Ve-1]+1;else throw new Error("not possible")}}if(pe&&be(fe,F,H,j),!nt[0]&&!Y.firstMatchCanBeWeak)return;Ne--,Ve--;const it=[ke[Ne][Ve],j];let et=0,at=0;for(;Ne>=1;){let je=Ve;do{const mt=ue[Ne][je];if(mt===3)je=je-2;else if(mt===2)je=je-1;else break}while(je>=1);et>1&&ye[F+Ne-1]===K[j+Ve-1]&&!V(je+j-1,H,K)&&et+1>we[Ne][je]&&(je=Ve),je===Ve?et++:et=1,at||(at=je),Ne--,Ve=je-1,it.push(Ve)}Ee===_&&Y.boostFullMatch&&(it[0]+=2);const ct=at-_;return it[0]-=ct,it}e.$7j=ce;function te(fe,ye,F,H,K,j){let Y=fe-1,_=ye-1;for(;Y>=F&&_>=H;)K[Y]===j[_]&&(de[Y]=_,Y--),_--}function J(fe,ye,F,H,K,j,Y,_,Ee,Ne,Ve){if(ye[F]!==j[Y])return Number.MIN_SAFE_INTEGER;let Ke=1,Xe=!1;return Y===F-H?Ke=fe[F]===K[Y]?7:5:V(Y,K,j)&&(Y===0||!V(Y-1,K,j))?(Ke=fe[F]===K[Y]?7:5,Xe=!0):se(j,Y)&&(Y===0||!se(j,Y-1))?Ke=5:(se(j,Y-1)||Z(j,Y-1))&&(Ke=5,Xe=!0),Ke>1&&F===H&&(Ve[0]=!0),Xe||(Xe=V(Y,K,j)||se(j,Y-1)||Z(j,Y-1)),F===H?Y>Ee&&(Ke-=Xe?3:5):Ne?Ke+=Xe?2:0:Ke+=Xe?0:1,Y+1===_&&(Ke-=Xe?3:5),Ke}function ee(fe,ye,F,H,K,j,Y){return ve(fe,ye,F,H,K,j,!0,Y)}e.$8j=ee;function me(fe,ye,F,H,K,j,Y){return ve(fe,ye,F,H,K,j,!1,Y)}e.$9j=me;function ve(fe,ye,F,H,K,j,Y,_){let Ee=ce(fe,ye,F,H,K,j,_);if(Ee&&!Y)return Ee;if(fe.length>=3){const Ne=Math.min(7,fe.length-1);for(let Ve=F+1;Ve<Ne;Ve++){const Ke=Me(fe,Ve);if(Ke){const Xe=ce(Ke,Ke.toLowerCase(),F,H,K,j,_);Xe&&(Xe[0]-=3,(!Ee||Xe[0]>Ee[0])&&(Ee=Xe))}}}return Ee}function Me(fe,ye){if(ye+1>=fe.length)return;const F=fe[ye],H=fe[ye+1];if(F!==H)return fe.slice(0,ye)+H+F+fe.slice(ye+2)}}),define(Pe[31],Re([1,0,12]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const A="error",P="warning",m="warn",f="info",w="ignore";function R(l){return l?y.$_e(A,l)?C.Error:y.$_e(P,l)||y.$_e(m,l)?C.Warning:y.$_e(f,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function k(l){switch(l){case C.Error:return A;case C.Warning:return P;case C.Info:return f;default:return w}}C.toString=k}(M||(M={})),e.default=M}),define(Pe[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(Pe[50],Re([1,0,18,12]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class C{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const v=$.charCodeAt(0),s=this.b.charCodeAt(this.c);return v-s}value(){return this.b[this.c]}}e.$8h=C;class A{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,M.$6e)($,this.b,0,$.length,this.c,this.d):(0,M.$8e)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$9h=A;class P{constructor($=!0,v=!0){this.f=$,this.g=v}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let v=$.length-1;v>=0;v--,this.c--){const s=this.b.charCodeAt(v);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,M.$6e)($,this.b,0,$.length,this.d,this.e):(0,M.$8e)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$0h=P;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class f{constructor($,v){this.f=$,this.g=v,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,M.$7e)($,this.c.scheme);if(this.d[this.e]===2)return(0,M.$7e)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,M.$5e)($,this.c.query);if(this.d[this.e]===5)return(0,M.$5e)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$$h=f;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(R||(R={}));class k{static forUris($=()=>!1,v=()=>!1){return new k(new f($,v))}static forPaths($=!1){return new k(new P(void 0,!$))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new A)}constructor($){this.b=$}clear(){this.c=void 0}fill($,v){if(v){const s=v.slice(0);(0,y.$Xb)(s);for(const a of s)this.set(a,$)}else{const s=$.slice(0);(0,y.$Xb)(s);for(const a of s)this.set(a[0],a[1])}}set($,v){const s=this.b.reset($);let a;this.c||(this.c=new w,this.c.segment=s.value());const r=[];for(a=this.c;;){const o=s.cmp(a.segment);if(o>0)a.left||(a.left=new w,a.left.segment=s.value()),r.push([-1,a]),a=a.left;else if(o<0)a.right||(a.right=new w,a.right.segment=s.value()),r.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new w,a.mid.segment=s.value()),r.push([0,a]),a=a.mid;else break}const n=a.value;a.value=v,a.key=$;for(let o=r.length-1;o>=0;o--){const c=r[o][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=r[o][0],u=r[o+1][0];if(i===1&&u===1)r[o][1]=c.rotateLeft();else if(i===-1&&u===-1)r[o][1]=c.rotateRight();else if(i===1&&u===-1)c.right=r[o+1][1]=r[o+1][1].rotateRight(),r[o][1]=c.rotateLeft();else if(i===-1&&u===1)c.left=r[o+1][1]=r[o+1][1].rotateLeft(),r[o][1]=c.rotateRight();else throw new Error;if(o>0)switch(r[o-1][0]){case-1:r[o-1][1].left=r[o][1];break;case 1:r[o-1][1].right=r[o][1];break;case 0:r[o-1][1].mid=r[o][1];break}else this.c=r[0][1]}}return n}get($){return this.d($)?.value}d($){const v=this.b.reset($);let s=this.c;for(;s;){const a=v.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(v.hasNext())v.next(),s=s.mid;else break}return s}has($){const v=this.d($);return!(v?.value===void 0&&v?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,v){const s=this.b.reset($),a=[];let r=this.c;for(;r;){const n=s.cmp(r.segment);if(n>0)a.push([-1,r]),r=r.left;else if(n<0)a.push([1,r]),r=r.right;else if(s.hasNext())s.next(),a.push([0,r]),r=r.mid;else break}if(r){if(v?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const n=this.f(r.right);if(n.key){const{key:o,value:c,segment:h}=n;this.e(n.key,!1),r.key=o,r.value=c,r.segment=h}}else{const n=r.left??r.right;if(a.length>0){const[o,c]=a[a.length-1];switch(o){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=a.length-1;n>=0;n--){const o=a[n][1];o.updateHeight();const c=o.balanceFactor();if(c>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),a[n][1]=o.rotateLeft()):c<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),a[n][1]=o.rotateRight()),n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const v=this.b.reset($);let s=this.c,a;for(;s;){const r=v.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(v.hasNext())v.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr($){return this.g($,!1)}g($,v){const s=this.b.reset($);let a=this.c;for(;a;){const r=s.cmp(a.segment);if(r>0)a=a.left;else if(r<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this.h(a.mid):v?a.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[v,s]of this)$(s,v)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const v=[];return this.j($,v),v[Symbol.iterator]()}j($,v){$&&($.left&&this.j($.left,v),$.value&&v.push([$.key,$.value]),$.mid&&this.j($.mid,v),$.right&&this.j($.right,v))}_isBalanced(){const $=v=>{if(!v)return!0;const s=v.balanceFactor();return s<-1||s>1?!1:$(v.left)&&$(v.right)};return $(this.c)}}e.$_h=k}),define(Pe[44],Re([1,0,90]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ak=e.ThemeColor=void 0;var M;(function(P){function m(f){return f&&typeof f=="object"&&typeof f.id=="string"}P.isThemeColor=m})(M||(e.ThemeColor=M={}));function C(P){return{id:P}}e.$ak=C;var A;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function f(n){const o=m.exec(n.id);if(!o)return f(y.$_j.error);const[,c,h]=o,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}P.asClassNameArray=f;function w(n){return f(n).join(" ")}P.asClassName=w;function R(n){return"."+f(n).join(".")}P.asCSSSelector=R;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||M.isThemeColor(n.color))}P.isThemeIcon=k;const l=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function $(n){const o=l.exec(n);if(!o)return;const[,c]=o;return{id:c}}P.fromString=$;function v(n){return{id:n}}P.fromId=v;function s(n,o){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),o&&(c=`${c}~${o}`),{id:c}}P.modify=s;function a(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}P.getModifier=a;function r(n,o){return n.id===o.id&&n.color?.id===o.color?.id}P.isEqual=r})(A||(e.ThemeIcon=A={}))}),define(Pe[126],Re([1,0,124,12,44]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=void 0;const A="$(",P=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${P.source}`,"g");function f(r){return r.replace(m,(n,o)=>o?n:`\\${n}`)}e.$bk=f;const w=new RegExp(`\\\\${P.source}`,"g");function R(r){return r.replace(w,n=>`\\${n}`)}e.$ck=R;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function l(r){return r.indexOf(A)===-1?r:r.replace(k,(n,o,c,h)=>c?n:o||h||"")}e.$dk=l;function $(r){return r?r.replace(/\$\((.*?)\)/g,(n,o)=>` ${o} `).trim():""}e.$ek=$;const v=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(r){v.lastIndex=0;let n="";const o=[];let c=0;for(;;){const h=v.lastIndex,i=v.exec(r),u=r.substring(h,i?.index);if(u.length>0){n+=u;for(let t=0;t<u.length;t++)o.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:o}}e.$fk=s;function a(r,n,o=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,y.$1j)(r,c,o);const i=(0,M.$Te)(c," "),u=c.length-i.length,t=(0,y.$1j)(r,i,o);if(t)for(const g of t){const p=h[g.start+u]+u;g.start+=p,g.end+=p}return t}e.$gk=a}),define(Pe[33],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return y.test(C)}e.$pg=M,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(m){for(let f=0;f<m.length;f++)m[f]=Math.floor(Math.random()*256);return m};const A=new Uint8Array(16),P=[];for(let m=0;m<256;m++)P.push(m.toString(16).padStart(2,"0"));return function(){C(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let f=0,w="";return w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w+="-",w+=P[A[f++]],w+=P[A[f++]],w+="-",w+=P[A[f++]],w+=P[A[f++]],w+="-",w+=P[A[f++]],w+=P[A[f++]],w+="-",w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w+=P[A[f++]],w}}()}),define(Pe[127],Re([1,0,18,68,33]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.$pt=e.$ot=e.$nt=void 0;function A(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$nt=A;function P(k,l,$){const v={id:(0,C.$qg)(),name:k,uri:l,data:$};return{asString:async()=>"",asFile:()=>v,value:void 0}}e.$ot=P;class m{constructor(){this.a=new Map}get size(){let l=0;for(const $ of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const $=[...this.a.keys()];return M.Iterable.some(this,([v,s])=>s.asFile())&&$.push("files"),R(f(l),$)}get(l){return this.a.get(this.b(l))?.[0]}append(l,$){const v=this.a.get(l);v?v.push($):this.a.set(this.b(l),[$])}replace(l,$){this.a.set(this.b(l),[$])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,$]of this.a)for(const v of $)yield[l,v]}b(l){return f(l)}}e.$pt=m;function f(k){return k.toLowerCase()}function w(k,l){return R(f(k),l.map(f))}e.$qt=w;function R(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const $=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!$)return!1;const[v,s,a]=$;return a==="*"?l.some(r=>r.startsWith(s+"/")):!1}e.$rt=Object.freeze({create:k=>(0,y.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$rt.split(k).filter(l=>!l.startsWith("#"))})}),define(Pe[128],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.StringEOL=void 0;var y;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(y||(e.StringEOL=y={}));function M(C){let A=0,P=0,m=0,f=0;for(let w=0,R=C.length;w<R;w++){const k=C.charCodeAt(w);k===13?(A===0&&(P=w),A++,w+1<R&&C.charCodeAt(w+1)===10?(f|=2,w++):f|=3,m=w+1):k===10&&(f|=1,A===0&&(P=w),A++,m=w+1)}return A===0&&(P=C.length),[A,P,C.length-m,f]}e.$ut=M}),define(Pe[129],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0,e.$ss={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=e.$Rt=e.IndentAction=void 0;var y;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class M{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let f=0,w=m.notIn.length;f<w;f++)switch(m.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,f){if(m.getTokenCount()===0)return!0;const w=m.findTokenIndexAtOffset(f-2),R=m.getStandardTokenType(w);return this.isOK(R)}g(m,f){for(let w=m;w<=f;w++){const R=String.fromCharCode(w);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Rt=M;class C{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of m)A(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),A(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),A(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),A(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&A(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$St=C;function A(P,m,f){P.has(m)?P.get(m).push(f):P.set(m,[f])}}),define(Pe[131],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.NodeColor=e.$SB=void 0;class y{constructor(a,r){this.piece=a,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$TB)return C(this.right);let a=this;for(;a.parent!==e.$TB&&a.parent.left!==a;)a=a.parent;return a.parent===e.$TB?e.$TB:a.parent}prev(){if(this.left!==e.$TB)return A(this.left);let a=this;for(;a.parent!==e.$TB&&a.parent.right!==a;)a=a.parent;return a.parent===e.$TB?e.$TB:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$SB=y;var M;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$TB=new y(null,0),e.$TB.parent=e.$TB,e.$TB.left=e.$TB,e.$TB.right=e.$TB,e.$TB.color=0;function C(s){for(;s.left!==e.$TB;)s=s.left;return s}e.$UB=C;function A(s){for(;s.right!==e.$TB;)s=s.right;return s}e.$VB=A;function P(s){return s===e.$TB?0:s.size_left+s.piece.length+P(s.right)}function m(s){return s===e.$TB?0:s.lf_left+s.piece.lineFeedCnt+m(s.right)}function f(){e.$TB.parent=e.$TB}function w(s,a){const r=a.right;r.size_left+=a.size_left+(a.piece?a.piece.length:0),r.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=r.left,r.left!==e.$TB&&(r.left.parent=a),r.parent=a.parent,a.parent===e.$TB?s.root=r:a.parent.left===a?a.parent.left=r:a.parent.right=r,r.left=a,a.parent=r}e.$WB=w;function R(s,a){const r=a.left;a.left=r.right,r.right!==e.$TB&&(r.right.parent=a),r.parent=a.parent,a.size_left-=r.size_left+(r.piece?r.piece.length:0),a.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),a.parent===e.$TB?s.root=r:a===a.parent.right?a.parent.right=r:a.parent.left=r,r.right=a,a.parent=r}e.$XB=R;function k(s,a){let r,n;if(a.left===e.$TB?(n=a,r=n.right):a.right===e.$TB?(n=a,r=n.left):(n=C(a.right),r=n.right),n===s.root){s.root=r,r.color=0,a.detach(),f(),s.root.parent=e.$TB;return}const o=n.color===1;if(n===n.parent.left?n.parent.left=r:n.parent.right=r,n===a?(r.parent=n.parent,v(s,r)):(n.parent===a?r.parent=n:r.parent=n.parent,v(s,r),n.left=a.left,n.right=a.right,n.parent=a.parent,n.color=a.color,a===s.root?s.root=n:a===a.parent.left?a.parent.left=n:a.parent.right=n,n.left!==e.$TB&&(n.left.parent=n),n.right!==e.$TB&&(n.right.parent=n),n.size_left=a.size_left,n.lf_left=a.lf_left,v(s,n)),a.detach(),r.parent.left===r){const h=P(r),i=m(r);if(h!==r.parent.size_left||i!==r.parent.lf_left){const u=h-r.parent.size_left,t=i-r.parent.lf_left;r.parent.size_left=h,r.parent.lf_left=i,$(s,r.parent,u,t)}}if(v(s,r.parent),o){f();return}let c;for(;r!==s.root&&r.color===0;)r===r.parent.left?(c=r.parent.right,c.color===1&&(c.color=0,r.parent.color=1,w(s,r.parent),c=r.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.right.color===0&&(c.left.color=0,c.color=1,R(s,c),c=r.parent.right),c.color=r.parent.color,r.parent.color=0,c.right.color=0,w(s,r.parent),r=s.root)):(c=r.parent.left,c.color===1&&(c.color=0,r.parent.color=1,R(s,r.parent),c=r.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.left.color===0&&(c.right.color=0,c.color=1,w(s,c),c=r.parent.left),c.color=r.parent.color,r.parent.color=0,c.left.color=0,R(s,r.parent),r=s.root));r.color=0,f()}e.$YB=k;function l(s,a){for(v(s,a);a!==s.root&&a.parent.color===1;)if(a.parent===a.parent.parent.left){const r=a.parent.parent.right;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,w(s,a)),a.parent.color=0,a.parent.parent.color=1,R(s,a.parent.parent))}else{const r=a.parent.parent.left;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,R(s,a)),a.parent.color=0,a.parent.parent.color=1,w(s,a.parent.parent))}s.root.color=0}e.$ZB=l;function $(s,a,r,n){for(;a!==s.root&&a!==e.$TB;)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=n),a=a.parent}e.$1B=$;function v(s,a){let r=0,n=0;if(a!==s.root){for(;a!==s.root&&a===a.parent.right;)a=a.parent;if(a!==s.root)for(a=a.parent,r=P(a.left)-a.size_left,n=m(a.left)-a.lf_left,a.size_left+=r,a.lf_left+=n;a!==s.root&&(r!==0||n!==0);)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=n),a=a.parent}}e.$2B=v}),define(Pe[91],Re([1,0,92,29,93,131,94]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=void 0;const m=65535;function f(r){let n;return r[r.length-1]<65536?n=new Uint16Array(r.length):n=new Uint32Array(r.length),n.set(r,0),n}class w{constructor(n,o,c,h,i){this.lineStarts=n,this.cr=o,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function R(r,n=!0){const o=[0];let c=1;for(let h=0,i=r.length;h<i;h++){const u=r.charCodeAt(h);u===13?h+1<i&&r.charCodeAt(h+1)===10?(o[c++]=h+2,h++):o[c++]=h+1:u===10&&(o[c++]=h+1)}return n?f(o):o}e.$9B=R;function k(r,n){r.length=0,r[0]=0;let o=1,c=0,h=0,i=0,u=!0;for(let g=0,p=n.length;g<p;g++){const d=n.charCodeAt(g);d===13?g+1<p&&n.charCodeAt(g+1)===10?(i++,r[o++]=g+2,g++):(c++,r[o++]=g+1):d===10?(h++,r[o++]=g+1):u&&d!==9&&(d<32||d>126)&&(u=!1)}const t=new w(f(r),c,h,i,u);return r.length=0,t}e.$0B=k;class l{constructor(n,o,c,h,i){this.bufferIndex=n,this.start=o,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$$B=l;class ${constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$_B=$;class v{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==A.$TB&&n.iterate(n.root,c=>(c!==A.$TB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=n){c[h]=null,o=!0;continue}}if(o){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class a{constructor(n,o,c){this.create(n,o,c)}create(n,o,c){this.a=[new $("",[0])],this.g={line:0,column:0},this.root=A.$TB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=c;let h=null;for(let i=0,u=n.length;i<u;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=R(n[i].buffer));const t=new l(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,t)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=m,c=o-Math.floor(o/3),h=c*2;let i="",u=0;const t=[];if(this.iterate(this.root,g=>{const p=this.R(g),d=p.length;if(u<=c||u+d<h)return i+=p,u+=d,!0;const S=i.replace(/\r\n|\r|\n/g,n);return t.push(new $(S,R(S))),i=p,u=d,!0}),u>0){const g=i.replace(/\r\n|\r|\n/g,n);t.push(new $(g,R(g)))}this.create(t,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,h=>{if(h===A.$TB)return!0;const i=this.R(h),u=i.length,t=n.G(o),g=n.G(o+u),p=n.getValueInRange2(t,g);return o+=u,i===p})}getOffsetAt(n,o){let c=0,h=this.root;for(;h!==A.$TB;)if(h.left!==A.$TB&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const i=this.B(h,n-h.lf_left-2);return c+=i+o-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,c=0;const h=n;for(;o!==A.$TB;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const i=this.A(o,n-o.size_left);if(c+=o.lf_left+i.index,i.index===0){const u=this.getOffsetAt(c+1,1),t=h-u;return new y.$Ts(c+1,t+1)}return new y.$Ts(c+1,i.remainder+1)}else if(n-=o.size_left+o.piece.length,c+=o.lf_left+o.piece.lineFeedCnt,o.right===A.$TB){const i=this.getOffsetAt(c+1,1),u=h-n-i;return new y.$Ts(c+1,u+1)}else o=o.right;return new y.$Ts(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,h);return o?o!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,o):i}getValueInRange2(n,o){if(n.node===o.node){const t=n.node,g=this.a[t.piece.bufferIndex].buffer,p=this.u(t.piece.bufferIndex,t.piece.start);return g.substring(p+n.remainder,p+o.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let u=h.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==A.$TB;){const t=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(c===o.node){u+=t.substring(g,g+o.remainder);break}else u+=t.substr(g,c.piece.length);c=c.next()}return u}getLinesContent(){const n=[];let o=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===A.$TB)return!0;const u=i.piece;let t=u.length;if(t===0)return!0;const g=this.a[u.bufferIndex].buffer,p=this.a[u.bufferIndex].lineStarts,d=u.start.line,S=u.end.line;let L=p[d]+u.start.column;if(h&&(g.charCodeAt(L)===10&&(L++,t--),n[o++]=c,c="",h=!1,t===0))return!0;if(d===S)return!this.f&&g.charCodeAt(L+t-1)===13?(h=!0,c+=g.substr(L,t-1)):c+=g.substr(L,t),!0;c+=this.f?g.substring(L,Math.max(L,p[d+1]-this.e)):g.substring(L,p[d+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;for(let b=d+1;b<S;b++)c=this.f?g.substring(p[b],p[b+1]-this.e):g.substring(p[b],p[b+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;return!this.f&&g.charCodeAt(p[S]+u.end.column-1)===13?(h=!0,u.end.column===0?o--:c=g.substr(p[S],u.end.column-1)):c=g.substr(p[S],u.end.column),!0}),h&&(n[o++]=c,c=""),n[o++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const c=this.a[o.piece.bufferIndex],h=this.u(o.piece.bufferIndex,o.piece.start);return c.buffer.charCodeAt(h)}else{const o=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(h)}}getLineCharCode(n,o){const c=this.H(n,o+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}findMatchesInNode(n,o,c,h,i,u,t,g,p,d,S){const L=this.a[n.piece.bufferIndex],b=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,i),D=this.u(n.piece.bufferIndex,u);let T;const O={line:0,column:0};let G,q;o._wordSeparators?(G=L.buffer.substring(E,D),q=U=>U+E,o.reset(0)):(G=L.buffer,q=U=>U,o.reset(E));do if(T=o.next(G),T){if(q(T.index)>=D)return d;this.s(n,q(T.index)-b,O);const U=this.t(n.piece.bufferIndex,i,O),I=O.line===i.line?O.column-i.column+h:O.column+1,N=I+T[0].length;if(S[d++]=(0,P.$5B)(new M.$Us(c+U,I,c+U,N),T,g),q(T.index)+T[0].length>=D||d>=p)return d}while(T);return d}findMatchesLineByLine(n,o,c,h){const i=[];let u=0;const t=new P.$8B(o.wordSeparators,o.regex);let g=this.H(n.startLineNumber,n.startColumn);if(g===null)return[];const p=this.H(n.endLineNumber,n.endColumn);if(p===null)return[];let d=this.s(g.node,g.remainder);const S=this.s(p.node,p.remainder);if(g.node===p.node)return this.findMatchesInNode(g.node,t,n.startLineNumber,n.startColumn,d,S,o,c,h,u,i),i;let L=n.startLineNumber,b=g.node;for(;b!==p.node;){const D=this.t(b.piece.bufferIndex,d,b.piece.end);if(D>=1){const O=this.a[b.piece.bufferIndex].lineStarts,G=this.u(b.piece.bufferIndex,b.piece.start),q=O[d.line+D],U=L===n.startLineNumber?n.startColumn:1;if(u=this.findMatchesInNode(b,t,L,U,d,this.s(b,q-G),o,c,h,u,i),u>=h)return i;L+=D}const T=L===n.startLineNumber?n.startColumn-1:0;if(L===n.endLineNumber){const O=this.getLineContent(L).substring(T,n.endColumn-1);return u=this.n(o,t,O,n.endLineNumber,T,u,i,c,h),i}if(u=this.n(o,t,this.getLineContent(L).substr(T),L,T,u,i,c,h),u>=h)return i;L++,g=this.H(L,1),b=g.node,d=this.s(g.node,g.remainder)}if(L===n.endLineNumber){const D=L===n.startLineNumber?n.startColumn-1:0,T=this.getLineContent(L).substring(D,n.endColumn-1);return u=this.n(o,t,T,n.endLineNumber,D,u,i,c,h),i}const E=L===n.startLineNumber?n.startColumn:1;return u=this.findMatchesInNode(p.node,t,L,E,d,S,o,c,h,u,i),i}n(n,o,c,h,i,u,t,g,p){const d=n.wordSeparators;if(!g&&n.simpleSearch){const L=n.simpleSearch,b=L.length,E=c.length;let D=-b;for(;(D=c.indexOf(L,D+b))!==-1;)if((!d||(0,P.$7B)(d,c,E,D,b))&&(t[u++]=new C.$av(new M.$Us(h,D+1+i,h,D+1+b+i),null),u>=p))return u;return u}let S;o.reset(0);do if(S=o.next(c),S&&(t[u++]=(0,P.$5B)(new M.$Us(h,S.index+1+i,h,S.index+1+S[0].length+i),S,g),u>=p))return u;while(S);return u}insert(n,o,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==A.$TB){const{node:h,remainder:i,nodeStartOffset:u}=this.G(n),t=h.piece,g=t.bufferIndex,p=this.s(h,i);if(h.piece.bufferIndex===0&&t.end.line===this.g.line&&t.end.column===this.g.column&&u+t.length===n&&o.length<m){this.F(h,o),this.y();return}if(u===n)this.o(o,h),this.h.validate(n);else if(u+h.piece.length>n){const d=[];let S=new l(t.bufferIndex,p,t.end,this.t(t.bufferIndex,p,t.end),this.u(g,t.end)-this.u(g,p));if(this.K()&&this.M(o)&&this.I(h,i)===10){const D={line:S.start.line+1,column:0};S=new l(S.bufferIndex,D,S.end,this.t(S.bufferIndex,D,S.end),S.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(h,i-1)===13){const D=this.s(h,i-1);this.C(h,D),o="\r"+o,h.piece.length===0&&d.push(h)}else this.C(h,p);else this.C(h,p);const L=this.w(o);S.length>0&&this.S(h,S);let b=h;for(let E=0;E<L.length;E++)b=this.S(b,L[E]);this.v(d)}else this.q(o,h)}else{const h=this.w(o);let i=this.T(null,h[0]);for(let u=1;u<h.length;u++)i=this.S(i,h[u])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===A.$TB)return;const c=this.G(n),h=this.G(n+o),i=c.node,u=h.node;if(i===u){const L=this.s(i,c.remainder),b=this.s(i,h.remainder);if(c.nodeStartOffset===n){if(o===i.piece.length){const E=i.next();(0,A.$YB)(this,i),this.N(E),this.y();return}this.D(i,b),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+o){this.C(i,L),this.O(i),this.y();return}this.E(i,L,b),this.y();return}const t=[],g=this.s(i,c.remainder);this.C(i,g),this.h.validate(n),i.piece.length===0&&t.push(i);const p=this.s(u,h.remainder);this.D(u,p),u.piece.length===0&&t.push(u);const d=i.next();for(let L=d;L!==A.$TB&&L!==u;L=L.next())t.push(L);const S=i.piece.length===0?i.prev():i;this.v(t),this.O(S),this.y()}o(n,o){const c=[];if(this.K()&&this.M(n)&&this.L(o)){const u=o.piece,t={line:u.start.line+1,column:0},g=new l(u.bufferIndex,t,u.end,this.t(u.bufferIndex,t,u.end),u.length-1);o.piece=g,n+=`
`,(0,A.$1B)(this,o,-1,-1),o.piece.length===0&&c.push(o)}const h=this.w(n);let i=this.T(o,h[h.length-1]);for(let u=h.length-2;u>=0;u--)i=this.T(i,h[u]);this.N(i),this.v(c)}q(n,o){this.Q(n,o)&&(n+=`
`);const c=this.w(n),h=this.S(o,c[0]);let i=h;for(let u=1;u<c.length;u++)i=this.S(i,c[u]);this.N(h)}s(n,o,c){const h=n.piece,i=n.piece.bufferIndex,u=this.a[i].lineStarts,g=u[h.start.line]+h.start.column+o;let p=h.start.line,d=h.end.line,S=0,L=0,b=0;for(;p<=d&&(S=p+(d-p)/2|0,b=u[S],S!==d);)if(L=u[S+1],g<b)d=S-1;else if(g>=L)p=S+1;else break;return c?(c.line=S,c.column=g-b,null):{line:S,column:g-b}}t(n,o,c){if(c.column===0)return c.line-o.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-o.line;const i=h[c.line+1],u=h[c.line]+c.column;if(i>u+1)return c.line-o.line;const t=u-1;return this.a[n].buffer.charCodeAt(t)===13?c.line-o.line+1:c.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,A.$YB)(this,n[o])}w(n){if(n.length>m){const d=[];for(;n.length>m;){const L=n.charCodeAt(m-1);let b;L===13||L>=55296&&L<=56319?(b=n.substring(0,m-1),n=n.substring(m-1)):(b=n.substring(0,m),n=n.substring(m));const E=R(b);d.push(new l(this.a.length,{line:0,column:0},{line:E.length-1,column:b.length-E[E.length-1]},E.length-1,b.length)),this.a.push(new $(b,E))}const S=R(n);return d.push(new l(this.a.length,{line:0,column:0},{line:S.length-1,column:n.length-S[S.length-1]},S.length-1,n.length)),this.a.push(new $(n,S)),d}let o=this.a[0].buffer.length;const c=R(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let d=0;d<c.length;d++)c[d]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let d=0;d<c.length;d++)c[d]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,u=this.a[0].lineStarts.length-1,t=i-this.a[0].lineStarts[u],g={line:u,column:t},p=new l(0,h,g,this.t(0,h,g),i-o);return this.g=g,[p]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let c=this.root,h="";const i=this.h.get2(n);if(i){c=i.node;const u=this.B(c,n-i.nodeStartLineNumber-1),t=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=t.substring(g+u,g+c.piece.length);else{const p=this.B(c,n-i.nodeStartLineNumber);return t.substring(g+u,g+p-o)}}else{let u=0;const t=n;for(;c!==A.$TB;)if(c.left!==A.$TB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const g=this.B(c,n-c.lf_left-2),p=this.B(c,n-c.lf_left-1),d=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);return u+=c.size_left,this.h.set({node:c,nodeStartOffset:u,nodeStartLineNumber:t-(n-1-c.lf_left)}),d.substring(S+g,S+p-o)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const g=this.B(c,n-c.lf_left-2),p=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);h=p.substring(d+g,d+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==A.$TB;){const u=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const t=this.B(c,0),g=this.u(c.piece.bufferIndex,c.piece.start);return h+=u.substring(g,g+t-o),h}else{const t=this.u(c.piece.bufferIndex,c.piece.start);h+=u.substr(t,c.piece.length)}c=c.next()}return h}y(){let n=this.root,o=1,c=0;for(;n!==A.$TB;)o+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=c,this.h.validate(this.c)}A(n,o){const c=n.piece,h=this.s(n,o),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===o){const u=this.t(n.piece.bufferIndex,c.start,h);if(u!==i)return{index:u,remainder:0}}return{index:i,remainder:h.column}}B(n,o){if(o<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+o+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(n,o){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),u=o,t=this.u(c.bufferIndex,u),g=this.t(c.bufferIndex,c.start,u),p=g-h,d=t-i,S=c.length+d;n.piece=new l(c.bufferIndex,c.start,u,g,S),(0,A.$1B)(this,n,d,p)}D(n,o){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),u=o,t=this.t(c.bufferIndex,u,c.end),g=this.u(c.bufferIndex,u),p=t-h,d=i-g,S=c.length+d;n.piece=new l(c.bufferIndex,u,c.end,t,S),(0,A.$1B)(this,n,d,p)}E(n,o,c){const h=n.piece,i=h.start,u=h.end,t=h.length,g=h.lineFeedCnt,p=o,d=this.t(h.bufferIndex,h.start,p),S=this.u(h.bufferIndex,o)-this.u(h.bufferIndex,i);n.piece=new l(h.bufferIndex,h.start,p,d,S),(0,A.$1B)(this,n,S-t,d-g);const L=new l(h.bufferIndex,c,u,this.t(h.bufferIndex,c,u),this.u(h.bufferIndex,u)-this.u(h.bufferIndex,c)),b=this.S(n,L);this.N(b)}F(n,o){this.Q(o,n)&&(o+=`
`);const c=this.K()&&this.L(o)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=o;const i=R(o,!1);for(let b=0;b<i.length;b++)i[b]+=h;if(c){const b=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-b}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const u=this.a[0].lineStarts.length-1,t=this.a[0].buffer.length-this.a[0].lineStarts[u],g={line:u,column:t},p=n.piece.length+o.length,d=n.piece.lineFeedCnt,S=this.t(0,n.piece.start,g),L=S-d;n.piece=new l(n.piece.bufferIndex,n.piece.start,g,S,p),this.g=g,(0,A.$1B)(this,n,o.length,L)}G(n){let o=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;o!==A.$TB;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){h+=o.size_left;const i={node:o,remainder:n-o.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=o.size_left+o.piece.length,h+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let c=this.root,h=0;for(;c!==A.$TB;)if(c.left!==A.$TB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),u=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+o-1,u),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+o-1<=c.piece.length)return{node:c,remainder:i+o-1,nodeStartOffset:h};o-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==A.$TB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),u=this.J(c);return{node:c,remainder:Math.min(o-1,i),nodeStartOffset:u}}else if(c.piece.length>=o-1){const i=this.J(c);return{node:c,remainder:o-1,nodeStartOffset:i}}else o-=c.piece.length;c=c.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+o;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===A.$TB||n.piece.lineFeedCnt===0)return!1;const o=n.piece,c=this.a[o.bufferIndex].lineStarts,h=o.start.line,i=c[h]+o.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===A.$TB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const u=n.piece.length-1,t=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,i,t,u),(0,A.$1B)(this,n,-1,-1),n.piece.length===0&&c.push(n);const g={line:o.piece.start.line+1,column:0},p=o.piece.length-1,d=this.t(o.piece.bufferIndex,g,o.piece.end);o.piece=new l(o.piece.bufferIndex,g,o.piece.end,d,p),(0,A.$1B)(this,o,-1,-1),o.piece.length===0&&c.push(o);const S=this.w(`\r
`);this.S(n,S[0]);for(let L=0;L<c.length;L++)(0,A.$YB)(this,c[L])}Q(n,o){if(this.K()&&this.M(n)){const c=o.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,A.$YB)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},u=h.length-1,t=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,t,u),(0,A.$1B)(this,c,-1,-1)}return!0}}return!1}iterate(n,o){if(n===A.$TB)return o(A.$TB);const c=this.iterate(n.left,o);return c&&o(n)&&this.iterate(n.right,o)}R(n){if(n===A.$TB)return"";const o=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return o.buffer.substring(h,i)}getPieceContent(n){const o=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return o.buffer.substring(c,h)}S(n,o){const c=new A.$SB(o,1);if(c.left=A.$TB,c.right=A.$TB,c.parent=A.$TB,c.size_left=0,c.lf_left=0,this.root===A.$TB)this.root=c,c.color=0;else if(n.right===A.$TB)n.right=c,c.parent=n;else{const i=(0,A.$UB)(n.right);i.left=c,c.parent=i}return(0,A.$ZB)(this,c),c}T(n,o){const c=new A.$SB(o,1);if(c.left=A.$TB,c.right=A.$TB,c.parent=A.$TB,c.size_left=0,c.lf_left=0,this.root===A.$TB)this.root=c,c.color=0;else if(n.left===A.$TB)n.left=c,c.parent=n;else{const h=(0,A.$VB)(n.left);h.right=c,c.parent=h}return(0,A.$ZB)(this,c),c}U(n){let o="";return this.iterate(n,c=>(o+=this.R(c),!0)),o}}e.$aC=a}),define(Pe[132],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8=e.$n8=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const P=this.a.get(A);return this.a.delete(A),P}}addDragOperationTransfer(A,P){this.a.set(A,P)}}e.$n8=y;class M{constructor(A){this.identifier=A}}e.$o8=M}),define(Pe[133],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Pe[134],Re([1,0,5,6,133]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class A extends M.$Tc{constructor(l,$="",v="",s=!0,a){super(),this.h=this.B(new y.$Vd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=$,this.u=v,this.w=s,this.C=a}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,$){this.C&&await this.C(l)}}e.$Ki=A;class P extends M.$Tc{constructor(){super(...arguments),this.f=this.B(new y.$Vd),this.onWillRun=this.f.event,this.m=this.B(new y.$Vd),this.onDidRun=this.m.event}async run(l,$){if(!l.enabled)return;this.f.fire({action:l});let v;try{await this.u(l,$)}catch(s){v=s}this.m.fire({action:l,error:v})}async u(l,$){await l.run($)}}e.$Li=P;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let $=[];for(const v of l)v.length&&($.length?$=[...$,new m,...v]:$=v);return $}static{this.ID="vs.actions.separator"}async run(){}}e.$Mi=m;class f{get actions(){return this.a}constructor(l,$,v,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=$,this.class=s,this.a=v}async run(){}}e.$Ni=f;class w extends A{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,C.localize(0,null),void 0,!1)}}e.$Oi=w;function R(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...l)=>k.run(...l),tooltip:k.label}}e.$Pi=R}),define(Pe[135],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Pe[136],Re([1,0,135]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const M=60,C=M*60,A=C*24,P=A*7,m=A*30,f=A*365;function w(k,l,$,v){typeof k!="number"&&(k=k.getTime());const s=Math.round((new Date().getTime()-k)/1e3);if(s<-30)return(0,y.localize)(0,null,w(new Date().getTime()+s*1e3,!1));if(!v&&s<30)return(0,y.localize)(1,null);let a;return s<M?(a=s,l?a===1?$?(0,y.localize)(2,null,a):(0,y.localize)(3,null,a):$?(0,y.localize)(4,null,a):(0,y.localize)(5,null,a):a===1?$?(0,y.localize)(6,null,a):(0,y.localize)(7,null,a):$?(0,y.localize)(8,null,a):(0,y.localize)(9,null,a)):s<C?(a=Math.floor(s/M),l?a===1?$?(0,y.localize)(10,null,a):(0,y.localize)(11,null,a):$?(0,y.localize)(12,null,a):(0,y.localize)(13,null,a):a===1?$?(0,y.localize)(14,null,a):(0,y.localize)(15,null,a):$?(0,y.localize)(16,null,a):(0,y.localize)(17,null,a)):s<A?(a=Math.floor(s/C),l?a===1?$?(0,y.localize)(18,null,a):(0,y.localize)(19,null,a):$?(0,y.localize)(20,null,a):(0,y.localize)(21,null,a):a===1?$?(0,y.localize)(22,null,a):(0,y.localize)(23,null,a):$?(0,y.localize)(24,null,a):(0,y.localize)(25,null,a)):s<P?(a=Math.floor(s/A),l?a===1?(0,y.localize)(26,null,a):(0,y.localize)(27,null,a):a===1?(0,y.localize)(28,null,a):(0,y.localize)(29,null,a)):s<m?(a=Math.floor(s/P),l?a===1?$?(0,y.localize)(30,null,a):(0,y.localize)(31,null,a):$?(0,y.localize)(32,null,a):(0,y.localize)(33,null,a):a===1?$?(0,y.localize)(34,null,a):(0,y.localize)(35,null,a):$?(0,y.localize)(36,null,a):(0,y.localize)(37,null,a)):s<f?(a=Math.floor(s/m),l?a===1?$?(0,y.localize)(38,null,a):(0,y.localize)(39,null,a):$?(0,y.localize)(40,null,a):(0,y.localize)(41,null,a):a===1?$?(0,y.localize)(42,null,a):(0,y.localize)(43,null,a):$?(0,y.localize)(44,null,a):(0,y.localize)(45,null,a)):(a=Math.floor(s/f),l?a===1?$?(0,y.localize)(46,null,a):(0,y.localize)(47,null,a):$?(0,y.localize)(48,null,a):(0,y.localize)(49,null,a):a===1?$?(0,y.localize)(50,null,a):(0,y.localize)(51,null,a):$?(0,y.localize)(52,null,a):(0,y.localize)(53,null,a))}e.$vm=w;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=R}),define(Pe[137],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Pe[40],Re([1,0,18,16,137]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function A(k,l){return l&&(k.stack||k.stacktrace)?C.localize(0,null,m(k),P(k.stack)||P(k.stacktrace)):m(k)}function P(k){return Array.isArray(k)?k.join(`
`):k}function m(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function f(k=null,l=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const $=y.$Hb(k),v=f($[0],l);return $.length>1?C.localize(4,null,v,$.length):v}if(M.$If(k))return k;if(k.detail){const $=k.detail;if($.error)return A($.error,l);if($.exception)return A($.exception,l)}return k.stack?A(k,l):k.message?k.message:C.localize(5,null)}e.$Qi=f;function w(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}e.$Ri=w;function R(k,l){let $;return typeof k=="string"?$=new Error(k):$=k,$.actions=l,$}e.$Si=R}),define(Pe[138],Re([1,0,39,19]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;const C=new y.$V(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),A=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(L,b,E=!1){const D=L||"",T=b||"",O=C.value.collator.compare(D,T);return C.value.collatorIsNumeric&&O===0&&D!==T?D<T?-1:1:O}e.$Iq=m;function f(L,b){const E=A.value.collator;return L=L||"",b=b||"",c(E,L,b)}e.$Jq=f;function w(L,b){const E=A.value.collator;return L=L||"",b=b||"",t(L,b)||c(E,L,b)}e.$Kq=w;function R(L,b){const E=A.value.collator;return L=L||"",b=b||"",u(L,b)||c(E,L,b)}e.$Lq=R;function k(L,b){return L=L||"",b=b||"",L===b?0:L<b?-1:1}e.$Mq=k;function l(L,b){const[E,D]=n(L),[T,O]=n(b);let G=C.value.collator.compare(D,O);if(G===0){if(C.value.collatorIsNumeric&&D!==O)return D<O?-1:1;if(G=C.value.collator.compare(E,T),C.value.collatorIsNumeric&&G===0&&E!==T)return E<T?-1:1}return G}e.$Nq=l;function $(L,b){L=L||"",b=b||"";const E=o(L),D=o(b),T=A.value.collator,O=P.value.collator;return c(O,E,D)||c(T,L,b)}e.$Oq=$;function v(L,b){L=L||"",b=b||"";const E=o(L),D=o(b),T=A.value.collator,O=P.value.collator;return c(O,E,D)||t(L,b)||c(T,L,b)}e.$Pq=v;function s(L,b){L=L||"",b=b||"";const E=o(L),D=o(b),T=A.value.collator,O=P.value.collator;return c(O,E,D)||u(L,b)||c(T,L,b)}e.$Qq=s;function a(L,b){L=L||"",b=b||"";const E=o(L).toLowerCase(),D=o(b).toLowerCase();return E!==D?E<D?-1:1:L!==b?L<b?-1:1:0}e.$Rq=a;const r=/^(.*?)(\.([^.]*))?$/;function n(L,b=!1){const E=L?r.exec(L):[];let D=[E&&E[1]||"",E&&E[3]||""];return b&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function o(L){const b=L?r.exec(L):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function c(L,b,E){const D=L.compare(b,E);return D!==0?D:b.length!==E.length?b.length<E.length?-1:1:0}function h(L){const b=L.charAt(0);return b.toLocaleUpperCase()!==b}function i(L){const b=L.charAt(0);return b.toLocaleLowerCase()!==b}function u(L,b){return h(L)&&i(b)?-1:i(L)&&h(b)?1:0}function t(L,b){return i(L)&&h(b)?-1:h(L)&&i(b)?1:0}function g(L,b,E=!1){return E||(L=L&&L.toLowerCase(),b=b&&b.toLowerCase()),L===b?0:L<b?-1:1}function p(L,b,E=!1){const D=L.split(M.sep),T=b.split(M.sep),O=D.length-1,G=T.length-1;let q,U;for(let I=0;;I++){if(q=O===I,U=G===I,q&&U)return m(D[I],T[I],E);if(q)return-1;if(U)return 1;const N=g(D[I],T[I],E);if(N!==0)return N}}e.$Sq=p;function d(L,b,E){const D=L.toLowerCase(),T=b.toLowerCase(),O=S(L,b,E);if(O)return O;const G=D.endsWith(E),q=T.endsWith(E);if(G!==q)return G?-1:1;const U=m(D,T);return U!==0?U:D.localeCompare(T)}e.$Tq=d;function S(L,b,E){const D=L.toLowerCase(),T=b.toLowerCase(),O=D.startsWith(E),G=T.startsWith(E);if(O!==G)return O?-1:1;if(O&&G){if(D.length<T.length)return-1;if(D.length>T.length)return 1}return 0}e.$Uq=S}),define(Pe[45],Re([1,0,19,21,12,16]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function P(d){return d===47||d===92}e.$1f=P;function m(d){return d.replace(/[\\/]/g,y.$gc.sep)}e.$2f=m;function f(d){return d.indexOf("/")===-1&&(d=m(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$3f=f;function w(d,S=y.$gc.sep){if(!d)return"";const L=d.length,b=d.charCodeAt(0);if(P(b)){if(P(d.charCodeAt(1))&&!P(d.charCodeAt(2))){let D=3;const T=D;for(;D<L&&!P(d.charCodeAt(D));D++);if(T!==D&&!P(d.charCodeAt(D+1))){for(D+=1;D<L;D++)if(P(d.charCodeAt(D)))return d.slice(0,D+1).replace(/[\\/]/g,S)}}return S}else if(r(b)&&d.charCodeAt(1)===58)return P(d.charCodeAt(2))?d.slice(0,2)+S:d.slice(0,2);let E=d.indexOf("://");if(E!==-1){for(E+=3;E<L;E++)if(P(d.charCodeAt(E)))return d.slice(0,E+1)}return""}e.$4f=w;function R(d){if(!M.$i||!d||d.length<5)return!1;let S=d.charCodeAt(0);if(S!==92||(S=d.charCodeAt(1),S!==92))return!1;let L=2;const b=L;for(;L<d.length&&(S=d.charCodeAt(L),S!==92);L++);return!(b===L||(S=d.charCodeAt(L+1),isNaN(S)||S===92))}e.$5f=R;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(d,S=M.$i){const L=S?k:l;return!(!d||d.length===0||/^\s+$/.test(d)||(L.lastIndex=0,L.test(d))||S&&$.test(d)||d==="."||d===".."||S&&d[d.length-1]==="."||S&&d.length!==d.trim().length||d.length>255)}e.$6f=v;function s(d,S,L){const b=d===S;return!L||b?b:!d||!S?!1:(0,C.$_e)(d,S)}e.$7f=s;function a(d,S,L,b=y.sep){if(d===S)return!0;if(!d||!S||S.length>d.length)return!1;if(L){if(!(0,C.$af)(d,S))return!1;if(S.length===d.length)return!0;let D=S.length;return S.charAt(S.length-1)===b&&D--,d.charAt(D)===b}return S.charAt(S.length-1)!==b&&(S+=b),d.indexOf(S)===0}e.$8f=a;function r(d){return d>=65&&d<=90||d>=97&&d<=122}e.$9f=r;function n(d,S){return M.$i&&d.endsWith(":")&&(d+=y.sep),(0,y.$ic)(d)||(d=(0,y.$jc)(S,d)),d=(0,y.$hc)(d),M.$i?(d=(0,C.$Ue)(d,y.sep),d.endsWith(":")&&(d+=y.sep)):(d=(0,C.$Ue)(d,y.sep),d||(d=y.sep)),d}e.$0f=n;function o(d){const S=(0,y.$hc)(d);return M.$i?d.length>3?!1:c(S)&&(d.length===2||S.charCodeAt(2)===92):S===y.$gc.sep}e.$$f=o;function c(d,S=M.$i){return S?r(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$_f=c;function h(d,S=M.$i){return c(d,S)?d[0]:void 0}e.$ag=h;function i(d,S,L){return S.length>d.length?-1:d===S?0:(L&&(d=d.toLowerCase(),S=S.toLowerCase()),d.indexOf(S))}e.$bg=i;function u(d){const S=d.split(":");let L,b,E;for(const D of S){const T=Number(D);(0,A.$Mf)(T)?b===void 0?b=T:E===void 0&&(E=T):L=L?[L,D].join(":"):D}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:b!==void 0?b:void 0,column:E!==void 0?E:b!==void 0?1:void 0}}e.$cg=u;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(d,S,L=8){let b="";for(let D=0;D<L;D++){let T;D===0&&M.$i&&!S&&(L===3||L===4)?T=g:T=t,b+=T.charAt(Math.floor(Math.random()*T.length))}let E;return S?E=`${S}-${b}`:E=b,d?(0,y.$jc)(d,E):E}e.$dg=p}),define(Pe[69],Re([1,0,19]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0,e.$fs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const k=(0,y.$oc)(R),l=M[k.toLowerCase()];return l!==void 0?l:P(R)}e.$gs=A;function P(R){const k=(0,y.$oc)(R);return C[k.toLowerCase()]}e.$hs=P;function m(R){for(const k in C)if(C[k]===R)return k}e.$is=m;const f=/^(.+)\/(.+?)(;.+)?$/;function w(R,k){const l=f.exec(R);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:R}e.$js=w}),define(Pe[51],Re([1,0,22,2]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function C(f){return JSON.stringify(f,P)}e.$Ah=C;function A(f){let w=JSON.parse(f);return w=m(w),w}e.$Bh=A;function P(f,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function m(f,w=0){if(!f||w>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return M.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof y.$je||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let R=0;R<f.length;++R)f[R]=m(f[R],w+1);else for(const R in f)Object.hasOwnProperty.call(f,R)&&(f[R]=m(f[R],w+1))}return f}e.$Ch=m}),define(Pe[11],Re([1,0,15,21,12,2]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var P;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(P||(e.Schemas=P={}));function m(l,$){return A.URI.isUri(l)?(0,C.$_e)(l.scheme,$):(0,C.$af)(l,$+":")}e.$eg=m;function f(l,...$){return $.some(v=>m(l,v))}e.$fg=f,e.$gg="vscode-tkn",e.$hg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${P.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${P.vscodeRemoteResource}`}set($,v,s){this.a[$]=v,this.b[$]=s}setConnectionToken($,v){this.c[$]=v}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(o){return y.$1(o),$}const v=$.authority;let s=this.a[v];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[v],r=this.c[v];let n=`path=${encodeURIComponent($.path)}`;return typeof r=="string"&&(n+=`&${e.$hg}=${encodeURIComponent(r)}`),A.URI.from({scheme:M.$o?this.d:P.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:n})}}e.$ig=new w,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class R{static{this.a=e.$ng}asBrowserUri($){const v=this.b($,ge);return this.uriToBrowserUri(v)}uriToBrowserUri($){return $.scheme===P.vscodeRemote?e.$ig.rewrite($):$.scheme===P.file&&(M.$m||M.$q===`${P.vscodeFileResource}://${R.a}`)?$.with({scheme:P.vscodeFileResource,authority:$.authority||R.a,query:null,fragment:null}):$}asFileUri($){const v=this.b($,ge);return this.uriToFileUri(v)}uriToFileUri($){return $.scheme===P.vscodeFileResource?$.with({scheme:P.file,authority:$.authority!==R.a?$.authority:null,query:null,fragment:null}):$}b($,v){return A.URI.isUri($)?$:A.URI.parse(v.toUrl($))}}e.$og=new R;var k;(function(l){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze($.get("3"));const v="vscode-coi";function s(r){let n;typeof r=="string"?n=new URL(r).searchParams:r instanceof URL?n=r.searchParams:A.URI.isUri(r)&&(n=new URL(r.toString(!0)).searchParams);const o=n?.get(v);if(o)return $.get(o)}l.getHeadersFromQuery=s;function a(r,n,o){if(!globalThis.crossOriginIsolated)return;const c=n&&o?"3":o?"2":"1";r instanceof URLSearchParams?r.set(v,c):r[v]=c}l.addSearchParam=a})(k||(e.COI=k={}))}),define(Pe[25],Re([1,0,45,11,19,21,12,2]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function f($){return(0,m.$wc)($,!0)}e.$vg=f;class w{constructor(v){this.a=v}compare(v,s,a=!1){return v===s?0:(0,P.$5e)(this.getComparisonKey(v,a),this.getComparisonKey(s,a))}isEqual(v,s,a=!1){return v===s?!0:!v||!s?!1:this.getComparisonKey(v,a)===this.getComparisonKey(s,a)}getComparisonKey(v,s=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,s,a=!1){if(v.scheme===s.scheme){if(v.scheme===M.Schemas.file)return y.$8f(f(v),f(s),this.a(v))&&v.query===s.query&&(a||v.fragment===s.fragment);if((0,e.$Mg)(v.authority,s.authority))return y.$8f(v.path,s.path,this.a(v),"/")&&v.query===s.query&&(a||v.fragment===s.fragment)}return!1}joinPath(v,...s){return m.URI.joinPath(v,...s)}basenameOrAuthority(v){return(0,e.$Eg)(v)||v.authority}basename(v){return C.$gc.basename(v.path)}extname(v){return C.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let s;return v.scheme===M.Schemas.file?s=m.URI.file(C.$mc(f(v))).path:(s=C.$gc.dirname(v.path),v.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),s="/")),v.with({path:s})}normalizePath(v){if(!v.path.length)return v;let s;return v.scheme===M.Schemas.file?s=m.URI.file(C.$hc(f(v))).path:s=C.$gc.normalize(v.path),v.with({path:s})}relativePath(v,s){if(v.scheme!==s.scheme||!(0,e.$Mg)(v.authority,s.authority))return;if(v.scheme===M.Schemas.file){const n=C.$lc(f(v),f(s));return A.$i?y.$2f(n):n}let a=v.path||"/";const r=s.path||"/";if(this.a(v)){let n=0;for(const o=Math.min(a.length,r.length);n<o&&!(a.charCodeAt(n)!==r.charCodeAt(n)&&a.charAt(n).toLowerCase()!==r.charAt(n).toLowerCase());n++);a=r.substr(0,n)+a.substr(n)}return C.$gc.relative(a,r)}resolvePath(v,s){if(v.scheme===M.Schemas.file){const a=m.URI.file(C.$kc(f(v),s));return v.with({authority:a.authority,path:a.path})}return s=y.$3f(s),v.with({path:C.$gc.resolve(v.path,s)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,s){return v===s||v!==void 0&&s!==void 0&&(0,P.$_e)(v,s)}hasTrailingPathSeparator(v,s=C.sep){if(v.scheme===M.Schemas.file){const a=f(v);return a.length>y.$4f(a).length&&a[a.length-1]===s}else{const a=v.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,s=C.sep){return(0,e.$Ng)(v,s)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,s=C.sep){let a=!1;if(v.scheme===M.Schemas.file){const r=f(v);a=r!==void 0&&r.length===y.$4f(r).length&&r[r.length-1]===s}else{s="/";const r=v.path;a=r.length===1&&r.charCodeAt(r.length-1)===47}return!a&&!(0,e.$Ng)(v,s)?v.with({path:v.path+"/"}):v}}e.$wg=w,e.$xg=new w(()=>!1),e.$yg=new w($=>$.scheme===M.Schemas.file?!A.$k:!0),e.$zg=new w($=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function R($,v){const s=[];for(let a=0;a<$.length;a++){const r=v($[a]);$.some((n,o)=>o===a?!1:(0,e.$Bg)(r,v(n)))||s.push($[a])}return s}e.$Qg=R;var k;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function v(s){const a=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,h]=o.split(":");c&&h&&a.set(c,h)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&a.set($.META_DATA_MIME,n),a}$.parseMetaData=v})(k||(e.DataUri=k={}));function l($,v,s){if(v){let a=$.path;return a&&a[0]!==C.$gc.sep&&(a=C.$gc.sep+a),$.with({scheme:s,authority:v,path:a})}return $.with({scheme:s})}e.$Rg=l}),define(Pe[13],Re([1,0,20,15,5,6,25,21,125,39]),function(ge,e,y,M,C,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function R(ce){return!!ce&&typeof ce.then=="function"}e.$Sg=R;function k(ce){const te=new y.$6d,J=ce(te.token),ee=new Promise((me,ve)=>{const Me=te.token.onCancellationRequested(()=>{Me.dispose(),ve(new M.$5)});Promise.resolve(J).then(fe=>{Me.dispose(),te.dispose(),me(fe)},fe=>{Me.dispose(),te.dispose(),ve(fe)})});return new class{cancel(){te.cancel(),te.dispose()}then(me,ve){return ee.then(me,ve)}catch(me){return this.then(void 0,me)}finally(me){return ee.finally(me)}}}e.$Tg=k;function l(ce,te,J){return new Promise((ee,me)=>{const ve=te.onCancellationRequested(()=>{ve.dispose(),ee(J)});ce.then(ee,me).finally(()=>ve.dispose())})}e.$Ug=l;function $(ce,te){return new Promise((J,ee)=>{const me=te.onCancellationRequested(()=>{me.dispose(),ee(new M.$5)});ce.then(J,ee).finally(()=>me.dispose())})}e.$Vg=$;async function v(ce){let te=-1;const J=ce.map((ee,me)=>ee.then(ve=>(te=me,ve)));try{return await Promise.race(J)}finally{ce.forEach((ee,me)=>{me!==te&&ee.cancel()})}}e.$Wg=v;function s(ce,te,J){let ee;const me=setTimeout(()=>{ee?.(void 0),J?.()},te);return Promise.race([ce.finally(()=>clearTimeout(me)),new Promise(ve=>ee=ve)])}e.$Xg=s;function a(ce){return new Promise((te,J)=>{const ee=ce();R(ee)?ee.then(te,J):te(ee)})}e.$Yg=a;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const J=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(J,J).then(ee)})}return new Promise((J,ee)=>{this.b.then(J,ee)})}return this.a=te(),new Promise((J,ee)=>{this.a.then(me=>{this.a=null,J(me)},me=>{this.a=null,ee(me)})})}dispose(){this.f=!0}}e.$Zg=r;class n{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$1g=n;class o{constructor(){this.a=new Map}queue(te,J){const me=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.a.get(te)===me&&this.a.delete(te)});return this.a.set(te,me),me}}e.$2g=o;const c=(ce,te)=>{let J=!0;const ee=setTimeout(()=>{J=!1,te()},ce);return{isTriggered:()=>J,dispose:()=>{clearTimeout(ee),J=!1}}},h=ce=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,ce())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class i{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,J=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise((me,ve)=>{this.d=me,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=J===f.$Sd?h(ee):c(J,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=i;class u{constructor(te){this.a=new i(te),this.b=new r}trigger(te,J){return this.a.trigger(()=>this.b.queue(te),J)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=u;class t{constructor(){this.a=!1,this.b=new Promise((te,J)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=t;class g extends t{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$6g=g;function p(ce,te){return te?new Promise((J,ee)=>{const me=setTimeout(()=>{ve.dispose(),J()},ce),ve=te.onCancellationRequested(()=>{clearTimeout(me),ve.dispose(),ee(new M.$5)})}):k(J=>p(ce,J))}e.$7g=p;function d(ce,te=0,J){const ee=setTimeout(()=>{ce(),J&&me.dispose()},te),me=(0,A.$Rc)(()=>{clearTimeout(ee),J?.deleteAndLeak(me)});return J?.add(me),me}e.$8g=d;function S(ce){const te=[];let J=0;const ee=ce.length;function me(){return J<ee?ce[J++]():null}function ve(Me){Me!=null&&te.push(Me);const fe=me();return fe?fe.then(ve):Promise.resolve(te)}return Promise.resolve(null).then(ve)}e.$9g=S;function L(ce,te=ee=>!!ee,J=null){let ee=0;const me=ce.length,ve=()=>{if(ee>=me)return Promise.resolve(J);const Me=ce[ee++];return Promise.resolve(Me()).then(ye=>te(ye)?Promise.resolve(ye):ve())};return ve()}e.$0g=L;function b(ce,te=ee=>!!ee,J=null){if(ce.length===0)return Promise.resolve(J);let ee=ce.length;const me=()=>{ee=-1;for(const ve of ce)ve.cancel?.()};return new Promise((ve,Me)=>{for(const fe of ce)fe.then(ye=>{--ee>=0&&te(ye)?(me(),ve(ye)):ee===0&&ve(J)}).catch(ye=>{--ee>=0&&(me(),Me(ye))})})}e.$$g=b;class E{constructor(te){this.a=0,this.b=!1,this.f=te,this.g=[],this.d=0,this.h=new C.$Vd}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(te){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((J,ee)=>{this.g.push({factory:te,c:J,e:ee}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const te=this.g.shift();this.d++;const J=te.factory();J.then(te.c,te.e),J.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=E;class D extends E{constructor(){super(1)}}e.$ah=D;class T{constructor(){this.a=new ke,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$bh=T;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new ie;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueSize(te,J=P.$xg){const ee=J.getComparisonKey(te);return this.a.get(ee)?.size??0}queueFor(te,J,ee=P.$xg){const me=ee.getComparisonKey(te);let ve=this.a.get(me);if(!ve){ve=new D;const Me=this.f++,fe=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(Me,fe),this.a.set(me,ve)}return ve.queue(J)}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=O;class G{constructor(te,J){this.a=-1,typeof te=="function"&&typeof J=="number"&&this.setIfNotSet(te,J)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,J){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},J)}setIfNotSet(te,J){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},J))}}e.$dh=G;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,J,ee=globalThis){this.cancel();const me=ee.setInterval(()=>{te()},J);this.d=(0,A.$Rc)(()=>{ee.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$eh=q;class U{constructor(te,J){this.b=-1,this.a=te,this.d=J,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=U;class I{constructor(te,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.a=te,this.b=J,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=I;class N extends U{constructor(te,J){super(te,J),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$hh=N;class W extends A.$Tc{constructor(te,J){super(),this.g=te,this.h=J,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const J of te)this.a.push(J);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(ce,te)=>{(0,m.$B)(()=>{if(J)return;const ee=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$kh=(ce,te,J)=>{const ee=ce.requestIdleCallback(te,typeof J=="number"?{timeout:J}:void 0);let me=!1;return{dispose(){me||(me=!0,ce.cancelIdleCallback(ee))}}},e.$jh=ce=>(0,e.$kh)(globalThis,ce)}();class ae{constructor(te,J){this.g=!1,this.d=()=>{try{this.j=J()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$kh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=ae;class de extends ae{constructor(te){super(globalThis,te)}}e.$mh=de;async function we(ce,te,J){let ee;for(let me=0;me<J;me++)try{return await ce()}catch(ve){ee=ve,await p(te)}throw ee}e.$nh=we;class ke{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,J,ee){return this.a={taskId:te,cancel:()=>ee?.(),promise:J},J.then(()=>this.d(te),()=>this.d(te)),J}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let J,ee;const me=new Promise((ve,Me)=>{J=ve,ee=Me});this.b={run:te,promise:me,promiseResolve:J,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=ke;class ue{constructor(te,J=()=>Date.now()){this.d=te,this.f=J,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$ph=ue;var pe;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(pe||(pe={}));class ie{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,J)=>{this.a=te,this.b=J})}complete(te){return new Promise(J=>{this.a(te),this.d={outcome:0,value:te},J()})}error(te){return new Promise(J=>{this.b(te),this.d={outcome:1,value:te},J()})}cancel(){return this.error(new M.$5)}}e.$qh=ie;var be;(function(ce){async function te(ee){let me;const ve=await Promise.all(ee.map(Me=>Me.then(fe=>fe,fe=>{me||(me=fe)})));if(typeof me<"u")throw me;return ve}ce.settled=te;function J(ee){return new Promise(async(me,ve)=>{try{await ee(me,ve)}catch(Me){ve(Me)}})}ce.withAsyncBody=J})(be||(e.Promises=be={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(J=>(this.a=J,this.d=!0,J),J=>{throw this.b=J,this.d=!0,J})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=se;class Z{constructor(te){this.b=te,this.a=new w.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=Z;var V;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(V||(V={}));class ne{static fromArray(te){return new ne(J=>{J.emitMany(te)})}static fromPromise(te){return new ne(async J=>{J.emitMany(await te)})}static fromPromises(te){return new ne(async J=>{await Promise.all(te.map(async ee=>J.emitOne(await ee)))})}static merge(te){return new ne(async J=>{await Promise.all(te.map(async ee=>{for await(const me of ee)J.emitOne(me)}))})}static{this.EMPTY=ne.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new C.$Vd,queueMicrotask(async()=>{const J={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(te(J)),this.j()}catch(ee){this.k(ee)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(te,J){return new ne(async ee=>{for await(const me of te)ee.emitOne(J(me))})}map(te){return ne.map(this,te)}static filter(te,J){return new ne(async ee=>{for await(const me of te)J(me)&&ee.emitOne(me)})}filter(te){return ne.filter(this,te)}static coalesce(te){return ne.filter(te,J=>!!J)}coalesce(){return ne.coalesce(this)}static async toPromise(te){const J=[];for await(const ee of te)J.push(ee);return J}toPromise(){return ne.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$th=ne;class Ae extends ne{constructor(te,J){super(J),this.l=te}cancel(){this.l.cancel()}}e.$uh=Ae;function Le(ce){const te=new y.$6d,J=ce(te.token);return new Ae(te,async ee=>{const me=te.token.onCancellationRequested(()=>{me.dispose(),te.dispose(),ee.reject(new M.$5)});try{for await(const ve of J){if(te.token.isCancellationRequested)return;ee.emitOne(ve)}me.dispose(),te.dispose()}catch(ve){me.dispose(),te.dispose(),ee.reject(ve)}})}e.$vh=Le;class Ce{constructor(){this.a=new ie,this.b=new ne(ee=>{if(te){ee.reject(te);return}return J&&ee.emitMany(J),this.d=me=>ee.reject(me),this.f=me=>ee.emitOne(me),this.a.p});let te,J;this.f=ee=>{J||(J=[]),J.push(ee)},this.d=ee=>{te||(te=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$wh=Ce}),define(Pe[34],Re([1,0,18,13,45,28,19,21,12]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=void 0;function w(){return Object.create(null)}e.$Hj=w,e.$Ij="**",e.$Jj="/";const R="[/\\\\]",k="[^/\\\\]",l=/\//g;function $(de,we){switch(de){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${we?`|${R}${k}+`:""})*?`}}function v(de,we){if(!de)return[];const ke=[];let ue=!1,pe=!1,ie="";for(const be of de){switch(be){case we:if(!ue&&!pe){ke.push(ie),ie="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}ie+=be}return ie&&ke.push(ie),ke}e.$Kj=v;function s(de){if(!de)return"";let we="";const ke=v(de,e.$Jj);if(ke.every(ue=>ue===e.$Ij))we=".*";else{let ue=!1;ke.forEach((pe,ie)=>{if(pe===e.$Ij){if(ue)return;we+=$(2,ie===ke.length-1)}else{let be=!1,se="",Z=!1,V="";for(const ne of pe){if(ne!=="}"&&be){se+=ne;continue}if(Z&&(ne!=="]"||!V)){let Ae;ne==="-"?Ae=ne:(ne==="^"||ne==="!")&&!V?Ae="^":ne===e.$Jj?Ae="":Ae=(0,f.$Oe)(ne),V+=Ae;continue}switch(ne){case"{":be=!0;continue;case"[":Z=!0;continue;case"}":{const Le=`(?:${v(se,",").map(Ce=>s(Ce)).join("|")})`;we+=Le,be=!1,se="";break}case"]":{we+="["+V+"]",Z=!1,V="";break}case"?":we+=k;continue;case"*":we+=$(1);continue;default:we+=(0,f.$Oe)(ne)}}ie<ke.length-1&&(ke[ie+1]!==e.$Ij||ie+2<ke.length)&&(we+=R)}ue=pe===e.$Ij})}return we}const a=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.$Dc(1e4),u=function(){return!1},t=function(){return null};function g(de,we){if(!de)return t;let ke;typeof de!="string"?ke=de.pattern:ke=de,ke=ke.trim();const ue=`${ke}_${!!we.trimForExclusions}`;let pe=i.get(ue);if(pe)return p(pe,de);let ie;return a.test(ke)?pe=S(ke.substr(4),ke):(ie=r.exec(d(ke,we)))?pe=L(ie[1],ke):(we.trimForExclusions?o:n).test(ke)?pe=b(ke,we):(ie=c.exec(d(ke,we)))?pe=E(ie[1].substr(1),ke,!0):(ie=h.exec(d(ke,we)))?pe=E(ie[1],ke,!1):pe=D(ke),i.set(ue,pe),p(pe,de)}function p(de,we){if(typeof we=="string")return de;const ke=function(ue,pe){return(0,C.$8f)(ue,we.base,!m.$k)?de((0,f.$Te)(ue.substr(we.base.length),P.sep),pe):null};return ke.allBasenames=de.allBasenames,ke.allPaths=de.allPaths,ke.basenames=de.basenames,ke.patterns=de.patterns,ke}function d(de,we){return we.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function S(de,we){return function(ke,ue){return typeof ke=="string"&&ke.endsWith(de)?we:null}}function L(de,we){const ke=`/${de}`,ue=`\\${de}`,pe=function(be,se){return typeof be!="string"?null:se?se===de?we:null:be===de||be.endsWith(ke)||be.endsWith(ue)?we:null},ie=[de];return pe.basenames=ie,pe.patterns=[we],pe.allBasenames=ie,pe}function b(de,we){const ke=W(de.slice(1,-1).split(",").map(se=>g(se,we)).filter(se=>se!==t),de),ue=ke.length;if(!ue)return t;if(ue===1)return ke[0];const pe=function(se,Z){for(let V=0,ne=ke.length;V<ne;V++)if(ke[V](se,Z))return de;return null},ie=ke.find(se=>!!se.allBasenames);ie&&(pe.allBasenames=ie.allBasenames);const be=ke.reduce((se,Z)=>Z.allPaths?se.concat(Z.allPaths):se,[]);return be.length&&(pe.allPaths=be),pe}function E(de,we,ke){const ue=P.sep===P.$gc.sep,pe=ue?de:de.replace(l,P.sep),ie=P.sep+pe,be=P.$gc.sep+de;let se;return ke?se=function(Z,V){return typeof Z=="string"&&(Z===pe||Z.endsWith(ie)||!ue&&(Z===de||Z.endsWith(be)))?we:null}:se=function(Z,V){return typeof Z=="string"&&(Z===pe||!ue&&Z===de)?we:null},se.allPaths=[(ke?"*/":"./")+de],se}function D(de){try{const we=new RegExp(`^${s(de)}$`);return function(ke){return we.lastIndex=0,typeof ke=="string"&&we.test(ke)?de:null}}catch{return t}}function T(de,we,ke){return!de||typeof we!="string"?!1:O(de)(we,void 0,ke)}e.$Lj=T;function O(de,we={}){if(!de)return u;if(typeof de=="string"||G(de)){const ke=g(de,we);if(ke===t)return u;const ue=function(pe,ie){return!!ke(pe,ie)};return ke.allBasenames&&(ue.allBasenames=ke.allBasenames),ke.allPaths&&(ue.allPaths=ke.allPaths),ue}return I(de,we)}e.$Mj=O;function G(de){const we=de;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}e.$Nj=G;function q(de){return de.allBasenames||[]}e.$Oj=q;function U(de){return de.allPaths||[]}e.$Pj=U;function I(de,we){const ke=W(Object.getOwnPropertyNames(de).map(se=>N(se,de[se],we)).filter(se=>se!==t)),ue=ke.length;if(!ue)return t;if(!ke.some(se=>!!se.requiresSiblings)){if(ue===1)return ke[0];const se=function(ne,Ae){let Le;for(let Ce=0,ce=ke.length;Ce<ce;Ce++){const te=ke[Ce](ne,Ae);if(typeof te=="string")return te;(0,M.$Sg)(te)&&(Le||(Le=[]),Le.push(te))}return Le?(async()=>{for(const Ce of Le){const ce=await Ce;if(typeof ce=="string")return ce}return null})():null},Z=ke.find(ne=>!!ne.allBasenames);Z&&(se.allBasenames=Z.allBasenames);const V=ke.reduce((ne,Ae)=>Ae.allPaths?ne.concat(Ae.allPaths):ne,[]);return V.length&&(se.allPaths=V),se}const pe=function(se,Z,V){let ne,Ae;for(let Le=0,Ce=ke.length;Le<Ce;Le++){const ce=ke[Le];ce.requiresSiblings&&V&&(Z||(Z=(0,P.$nc)(se)),ne||(ne=Z.substr(0,Z.length-(0,P.$oc)(se).length)));const te=ce(se,Z,ne,V);if(typeof te=="string")return te;(0,M.$Sg)(te)&&(Ae||(Ae=[]),Ae.push(te))}return Ae?(async()=>{for(const Le of Ae){const Ce=await Le;if(typeof Ce=="string")return Ce}return null})():null},ie=ke.find(se=>!!se.allBasenames);ie&&(pe.allBasenames=ie.allBasenames);const be=ke.reduce((se,Z)=>Z.allPaths?se.concat(Z.allPaths):se,[]);return be.length&&(pe.allPaths=be),pe}function N(de,we,ke){if(we===!1)return t;const ue=g(de,ke);if(ue===t)return t;if(typeof we=="boolean")return ue;if(we){const pe=we.when;if(typeof pe=="string"){const ie=(be,se,Z,V)=>{if(!V||!ue(be,se))return null;const ne=pe.replace("$(basename)",()=>Z),Ae=V(ne);return(0,M.$Sg)(Ae)?Ae.then(Le=>Le?de:null):Ae?de:null};return ie.requiresSiblings=!0,ie}}return ue}function W(de,we){const ke=de.filter(se=>!!se.basenames);if(ke.length<2)return de;const ue=ke.reduce((se,Z)=>{const V=Z.basenames;return V?se.concat(V):se},[]);let pe;if(we){pe=[];for(let se=0,Z=ue.length;se<Z;se++)pe.push(we)}else pe=ke.reduce((se,Z)=>{const V=Z.patterns;return V?se.concat(V):se},[]);const ie=function(se,Z){if(typeof se!="string")return null;if(!Z){let ne;for(ne=se.length;ne>0;ne--){const Ae=se.charCodeAt(ne-1);if(Ae===47||Ae===92)break}Z=se.substr(ne)}const V=ue.indexOf(Z);return V!==-1?pe[V]:null};ie.basenames=ue,ie.patterns=pe,ie.allBasenames=ue;const be=de.filter(se=>!se.basenames);return be.push(ie),be}function ae(de,we){return(0,y.$ub)(de,we,(ke,ue)=>typeof ke=="string"&&typeof ue=="string"?ke===ue:typeof ke!="string"&&typeof ue!="string"?ke.base===ue.base&&ke.pattern===ue.pattern:!1)}e.$Qj=ae}),define(Pe[52],Re([1,0,15,126,25,12,2]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class f{constructor(n="",o=!1){if(this.value=n,typeof this.value!="string")throw(0,y.$7)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(n,o=0){return this.value+=l(this.supportThemeIcons?(0,M.$bk)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,o){return this.value+=`
${$(o,n)}
`,this}appendLink(n,o,c){return this.value+="[",this.value+=this.c(o,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,o){const c=new RegExp((0,A.$Oe)(o),"g");return n.replace(c,(h,i)=>n.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$hk=f;function w(r){return R(r)?!r.value:Array.isArray(r)?r.every(w):!0}e.$ik=w;function R(r){return r instanceof f?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.$jk=R;function k(r,n){return r===n?!0:!r||!n?!1:r.value===n.value&&r.isTrusted===n.isTrusted&&r.supportThemeIcons===n.supportThemeIcons&&r.supportHtml===n.supportHtml&&(r.baseUri===n.baseUri||!!r.baseUri&&!!n.baseUri&&(0,C.$Ag)(P.URI.from(r.baseUri),P.URI.from(n.baseUri)))}e.$kk=k;function l(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$lk=l;function $(r,n){const o=r.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,c=o>=3?o+1:3;return[`${"`".repeat(c)}${n}`,r,`${"`".repeat(c)}`].join(`
`)}e.$mk=$;function v(r){return r.replace(/"/g,"&quot;")}e.$nk=v;function s(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ok=s;function a(r){const n=[],o=r.split("|").map(h=>h.trim());r=o[0];const c=o[1];if(c){const h=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),u=h?h[1]:"",t=i?i[1]:"",g=isFinite(parseInt(t)),p=isFinite(parseInt(u));g&&n.push(`width="${t}"`),p&&n.push(`height="${u}"`)}return{href:r,dimensions:n}}e.$pk=a}),define(Pe[95],Re([1,0,18,45,19,21,25,12]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=void 0;function f(g,p){const{os:d,tildify:S,relative:L}=p;if(L){const D=w(g,L,d);if(typeof D=="string")return D}let b=g.fsPath;if(d===1&&!A.$i?b=b.replace(/\//g,"\\"):d!==1&&A.$i&&(b=b.replace(/\\/g,"/")),d!==1&&S?.userHome){const D=S.userHome.fsPath;let T;g.scheme!==S.userHome.scheme&&g.path[0]===C.$gc.sep&&g.path[1]!==C.$gc.sep?T=S.userHome.with({path:g.path}).fsPath:T=b,b=l(T,D,d)}return(d===1?C.$fc:C.$gc).normalize(R(b,d===1))}e.$Vv=f;function w(g,p,d){const S=d===1?C.$fc:C.$gc,L=d===3?P.$xg:P.$zg,b=p.getWorkspace(),E=(0,y.$Ob)(b.folders);if(!E)return;g.scheme!==E.uri.scheme&&g.path[0]===C.$gc.sep&&g.path[1]!==C.$gc.sep&&(g=E.uri.with({path:g.path}));const D=p.getWorkspaceFolder(g);if(!D)return;let T;if(L.isEqual(D.uri,g)?T="":T=L.relativePath(D.uri,g)??"",T&&(T=S.normalize(T)),b.folders.length>1&&!p.noPrefix){const O=D.name?D.name:L.basenameOrAuthority(D.uri);T=T?`${O} \u2022 ${T}`:O}return T}function R(g,p=A.$i){return(0,M.$_f)(g,p)?g.charAt(0).toUpperCase()+g.slice(1):g}e.$Wv=R;let k=Object.create(null);function l(g,p,d=A.OS){if(d===1||!g||!p)return g;let S=k.original===p?k.normalized:void 0;S||(S=p,A.$i&&(S=(0,M.$2f)(S)),S=`${(0,m.$Ue)(S,C.$gc.sep)}${C.$gc.sep}`,k={original:p,normalized:S});let L=g;return A.$i&&(L=(0,M.$2f)(L)),(d===3?L.startsWith(S):(0,m.$af)(L,S))?`~/${L.substr(S.length)}`:g}e.$Xv=l;function $(g,p){return g.replace(/^~($|\/|\\)/,`${p}$1`)}e.$Yv=$;const v="\u2026",s="\\\\",a="~";function r(g,p=C.sep){const d=new Array(g.length);let S=!1;for(let L=0;L<g.length;L++){const b=g[L];if(b===""){d[L]=`.${p}`;continue}if(!b){d[L]=b;continue}S=!0;let E="",D=b;D.indexOf(s)===0?(E=D.substr(0,D.indexOf(s)+s.length),D=D.substr(D.indexOf(s)+s.length)):D.indexOf(p)===0?(E=D.substr(0,D.indexOf(p)+p.length),D=D.substr(D.indexOf(p)+p.length)):D.indexOf(a)===0&&(E=D.substr(0,D.indexOf(a)+a.length),D=D.substr(D.indexOf(a)+a.length));const T=D.split(p);for(let O=1;S&&O<=T.length;O++)for(let G=T.length-O;S&&G>=0;G--){S=!1;let q=T.slice(G,G+O).join(p);for(let U=0;!S&&U<g.length;U++)if(U!==L&&g[U]&&g[U].indexOf(q)>-1){const I=G+O===T.length,N=G>0&&g[U].indexOf(p)>-1?p+q:q,W=g[U].endsWith(N);S=!I||W}if(!S){let U="";(T[0].endsWith(":")||E!=="")&&(G===1&&(G=0,O++,q=T[0]+p+q),G>0&&(U=T[0]+p),U=E+U),G>0&&(U=U+v+p),U=U+q,G+O<T.length&&(U=U+p+v),d[L]=U}}S&&(d[L]=b)}return d}e.$Zv=r;var n;(function(g){g[g.TEXT=0]="TEXT",g[g.VARIABLE=1]="VARIABLE",g[g.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function o(g,p=Object.create(null)){const d=[];let S=!1,L="";for(const b of g)if(b==="$"||S&&b==="{")L&&d.push({value:L,type:n.TEXT}),L="",S=!0;else if(b==="}"&&S){const E=p[L];if(typeof E=="string")E.length&&d.push({value:E,type:n.VARIABLE});else if(E){const D=d[d.length-1];(!D||D.type!==n.SEPARATOR)&&d.push({value:E.label,type:n.SEPARATOR})}L="",S=!1}else L+=b;return L&&!S&&d.push({value:L,type:n.TEXT}),d.filter((b,E)=>{if(b.type===n.SEPARATOR){const D=d[E-1],T=d[E+1];return[D,T].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(b=>b.value).join("")}e.$1v=o;function c(g,p){return A.$j||p?g.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):g.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$2v=c;function h(g,p){return A.$j||p?g.replace(/\(&&\w\)|&&/g,""):A.$i?g.replace(/&&|&/g,d=>d==="&"?"&&":"&"):g.replace(/&&/g,"_")}e.$3v=h;function i(g){return g.replace(/&/g,"&&")}e.$4v=i;function u(g){if(g.endsWith("]")){const p=g.lastIndexOf(" [",g.length-2);if(p!==-1){const d=t(g.substring(0,p)),S=g.substring(p);return{name:d.name+S,parentPath:d.parentPath}}}return t(g)}e.$5v=u;function t(g){const p=g.indexOf("/")!==-1?C.$gc:C.$fc,d=p.basename(g),S=p.dirname(g);return d.length?{name:d,parentPath:S}:{name:S,parentPath:""}}}),define(Pe[139],Re([1,0,22,2]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function C(k){return k.toJSON()}class A{constructor(l){this.a=l}transformIncoming(l){const $=this.a.transformIncoming(l);return $===l?l:C(M.URI.from($))}transformOutgoing(l){const $=this.a.transformOutgoing(l);return $===l?l:C(M.URI.from($))}transformOutgoingURI(l){const $=this.a.transformOutgoing(l);return $===l?l:M.URI.from($)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$4m=A,e.$5m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function P(k,l,$){if(!k||$>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return l.transformOutgoing(k);for(const v in k)if(Object.hasOwnProperty.call(k,v)){const s=P(k[v],l,$+1);s!==null&&(k[v]=s)}}return null}function m(k,l){const $=P(k,l,0);return $===null?k:$}e.$6m=m;function f(k,l,$,v){if(!k||v>200)return null;if(typeof k=="object"){if(k.$mid===1)return $?M.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof y.$je)return null;for(const s in k)if(Object.hasOwnProperty.call(k,s)){const a=f(k[s],l,$,v+1);a!==null&&(k[s]=a)}}return null}function w(k,l){const $=f(k,l,!1,0);return $===null?k:$}e.$7m=w;function R(k,l){const $=f(k,l,!0,0);return $===null?k:$}e.$8m=R}),define(Pe[140],Re([1,0,12,21,22]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=void 0;let A;function P(){return A||(A=new TextDecoder("UTF-16LE")),A}let m;function f(){return m||(m=new TextDecoder("UTF-16BE")),m}let w;function R(){return w||(w=M.$D()?P():f()),w}e.$at=R;function k(v,s,a){const r=new Uint16Array(v.buffer,s,a);return a>0&&(r[0]===65279||r[0]===65534)?l(v,s,a):P().decode(r)}e.$bt=k;function l(v,s,a){const r=[];let n=0;for(let o=0;o<a;o++){const c=C.$le(v,s);s+=2,r[n++]=String.fromCharCode(c)}return r.join("")}class ${constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return R().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const a=this.a-this.d;a<=1&&(a===0||y.$df(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const a=s.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=s;return}for(let r=0;r<a;r++)this.b[this.d++]=s.charCodeAt(r)}}e.$ct=$}),define(Pe[141],Re([1,0,22,140]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=void 0;function C(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,R,k,l){this.oldPosition=w,this.oldText=R,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,R,k){const l=R.length;y.$oe(w,l,k),k+=4;for(let $=0;$<l;$++)y.$me(w,R.charCodeAt($),k),k+=2;return k}static d(w,R){const k=y.$ne(w,R);return R+=4,(0,M.$bt)(w,R,k)}writeSize(){return 4+4+A.a(this.oldText)+A.a(this.newText)}write(w,R){return y.$oe(w,this.oldPosition,R),R+=4,y.$oe(w,this.newPosition,R),R+=4,R=A.c(w,this.oldText,R),R=A.c(w,this.newText,R),R}static read(w,R,k){const l=y.$ne(w,R);R+=4;const $=y.$ne(w,R);R+=4;const v=A.d(w,R);R+=A.a(v);const s=A.d(w,R);return R+=A.a(s),k.push(new A(l,v,$,s)),R}}e.$dt=A;function P(f,w){return f===null||f.length===0?w:new m(f,w).compress()}e.$et=P;class m{constructor(w,R){this.a=w,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,R=0,k=this.n(w),l=this.l(R);for(;w<this.f||R<this.h;){if(k===null){this.k(l),l=this.l(++R);continue}if(l===null){this.m(k),k=this.n(++w);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++R);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++w);continue}if(l.oldPosition<k.newPosition){const[r,n]=m.r(l,k.newPosition-l.oldPosition);this.k(r),l=n;continue}if(k.newPosition<l.oldPosition){const[r,n]=m.q(k,l.oldPosition-k.newPosition);this.m(r),k=n;continue}let s,a;if(l.oldEnd===k.newEnd)s=k,a=l,k=this.n(++w),l=this.l(++R);else if(l.oldEnd<k.newEnd){const[r,n]=m.q(k,l.oldLength);s=r,a=l,k=n,l=this.l(++R)}else{const[r,n]=m.r(l,k.newLength);s=k,a=r,k=this.n(++w),l=n}this.d[this.e++]=new A(s.oldPosition,s.oldText,a.newPosition,a.newText),this.g+=s.newLength-s.oldLength,this.j+=a.newLength-a.oldLength}const $=m.s(this.d);return m.t($)}k(w){this.d[this.e++]=m.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=m.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,R){return new A(R.oldPosition-w,R.oldText,R.newPosition,R.newText)}static p(w,R){return new A(R.oldPosition,R.oldText,R.newPosition+w,R.newText)}static q(w,R){const k=w.newText.substr(0,R),l=w.newText.substr(R);return[new A(w.oldPosition,w.oldText,w.newPosition,k),new A(w.oldEnd,"",w.newPosition+R,l)]}static r(w,R){const k=w.oldText.substr(0,R),l=w.oldText.substr(R);return[new A(w.oldPosition,k,w.newPosition,w.newText),new A(w.oldPosition+R,l,w.newEnd,"")]}static s(w){if(w.length===0)return w;const R=[];let k=0,l=w[0];for(let $=1;$<w.length;$++){const v=w[$];l.oldEnd===v.oldPosition?l=new A(l.oldPosition,l.oldText+v.oldText,l.newPosition,l.newText+v.newText):(R[k++]=l,l=v)}return R[k++]=l,R}static t(w){if(w.length===0)return w;const R=[];let k=0;for(let l=0;l<w.length;l++){const $=w[l];$.oldText!==$.newText&&(R[k++]=$)}return R}}}),define(Pe[142],Re([1,0,34,19]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0;function C(A,P,m,f,w,R){if(Array.isArray(A)){let k=0;for(const l of A){const $=C(l,P,m,f,w,R);if($===10)return $;$>k&&(k=$)}return k}else{if(typeof A=="string")return f?A==="*"?5:A===m?10:0:0;if(A){const{language:k,pattern:l,scheme:$,hasAccessToAllModels:v,notebookType:s}=A;if(!f&&!v)return 0;s&&w&&(P=w);let a=0;if($)if($===P.scheme)a=10;else if($==="*")a=5;else return 0;if(k)if(k===m)a=10;else if(k==="*")a=Math.max(a,5);else return 0;if(s)if(s===R)a=10;else if(s==="*"&&R!==void 0)a=Math.max(a,5);else return 0;if(l){let r;if(typeof l=="string"?r=l:r={...l,base:(0,M.$hc)(l.base)},r===P.fsPath||(0,y.$Lj)(r,P.fsPath))a=10;else return 0}return a}else return 0}}e.$Bt=C}),define(Pe[143],Re([1,0,5,12,29,93,91,128,141,6]),function(ge,e,y,M,C,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=void 0;class R extends w.$Tc{constructor(l,$,v,s,a,r,n){super(),this.m=this.B(new y.$Vd),this.onDidChangeContent=this.m.event,this.f=$,this.j=!r,this.g=s,this.h=a,this.c=new P.$aC(l,v,n)}equals(l){return!(l instanceof R)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,$){return this.c.getOffsetAt(l,$)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,$){const v=l+$,s=this.getPositionAt(l),a=this.getPositionAt(v);return new C.$Us(s.lineNumber,s.column,a.lineNumber,a.column)}getValueInRange(l,$=0){if(l.isEmpty())return"";const v=this.n($);return this.c.getValueInRange(l,v)}getValueLengthInRange(l,$=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const v=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let a=0;const r=this.n($),n=this.getEOL();if(r.length!==n.length){const o=r.length-n.length,c=l.endLineNumber-l.startLineNumber;a=o*c}return s-v+a}getCharacterCountInRange(l,$=0){if(this.j){let v=0;const s=l.startLineNumber,a=l.endLineNumber;for(let r=s;r<=a;r++){const n=this.getLineContent(r),o=r===s?l.startColumn-1:0,c=r===a?l.endColumn-1:n.length;for(let h=o;h<c;h++)M.$df(n.charCodeAt(h))?(v=v+1,h=h+1):v=v+1}return v+=this.n($).length*(a-s),v}return this.getValueLengthInRange(l,$)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,$){return this.c.getLineCharCode(l,$)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const $=M.$1e(this.getLineContent(l));return $===-1?0:$+1}getLineLastNonWhitespaceColumn(l){const $=M.$3e(this.getLineContent(l));return $===-1?0:$+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,$,v){let s=this.g,a=this.h,r=this.j,n=!0,o=[];for(let p=0;p<l.length;p++){const d=l[p];n&&d._isTracked&&(n=!1);const S=d.range;if(d.text){let T=!0;r||(T=!M.$of(d.text),r=T),!s&&T&&(s=M.$nf(d.text)),!a&&T&&(a=M.$qf(d.text))}let L="",b=0,E=0,D=0;if(d.text){let T;[b,E,D,T]=(0,m.$ut)(d.text);const O=this.getEOL();T===0||T===(O===`\r
`?2:1)?L=d.text:L=d.text.replace(/\r\n|\r|\n/g,O)}o[p]={sortIndex:p,identifier:d.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:L,eolCount:b,firstLineLength:E,lastLineLength:D,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}o.sort(R.u);let c=!1;for(let p=0,d=o.length-1;p<d;p++){const S=o[p].range.getEndPosition(),L=o[p+1].range.getStartPosition();if(L.isBeforeOrEqual(S)){if(L.isBefore(S))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(o=this.s(o));const h=v||$?R._getInverseEditRanges(o):[],i=[];if($)for(let p=0;p<o.length;p++){const d=o[p],S=h[p];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let L=S.startLineNumber;L<=S.endLineNumber;L++){let b="";L===S.startLineNumber&&(b=this.getLineContent(d.range.startLineNumber),M.$1e(b)!==-1)||i.push({lineNumber:L,oldContent:b})}}let u=null;if(v){let p=0;u=[];for(let d=0;d<o.length;d++){const S=o[d],L=h[d],b=this.getValueInRange(S.range),E=S.rangeOffset+p;p+=S.text.length-b.length,u[d]={sortIndex:S.sortIndex,identifier:S.identifier,range:L,text:b,textChange:new f.$dt(S.rangeOffset,b,E,S.text)}}c||u.sort((d,S)=>d.sortIndex-S.sortIndex)}this.g=s,this.h=a,this.j=r;const t=this.t(o);let g=null;if($&&i.length>0){i.sort((p,d)=>d.lineNumber-p.lineNumber),g=[];for(let p=0,d=i.length;p<d;p++){const S=i[p].lineNumber;if(p>0&&i[p-1].lineNumber===S)continue;const L=i[p].oldContent,b=this.getLineContent(S);b.length===0||b===L||M.$1e(b)!==-1||g.push(S)}}return this.m.fire(),new A.$ev(u,t,g)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let $=!1;const v=l[0].range,s=l[l.length-1].range,a=new C.$Us(v.startLineNumber,v.startColumn,s.endLineNumber,s.endColumn);let r=v.startLineNumber,n=v.startColumn;const o=[];for(let t=0,g=l.length;t<g;t++){const p=l[t],d=p.range;$=$||p.forceMoveMarkers,o.push(this.getValueInRange(new C.$Us(r,n,d.startLineNumber,d.startColumn))),p.text.length>0&&o.push(p.text),r=d.endLineNumber,n=d.endColumn}const c=o.join(""),[h,i,u]=(0,m.$ut)(c);return{sortIndex:0,identifier:l[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:u,forceMoveMarkers:$,isAutoWhitespaceEdit:!1}}t(l){l.sort(R.w);const $=[];for(let v=0;v<l.length;v++){const s=l[v],a=s.range.startLineNumber,r=s.range.startColumn,n=s.range.endLineNumber,o=s.range.endColumn;if(a===n&&r===o&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new C.$Us(a,r,n,o);$.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return $}findMatchesLineByLine(l,$,v,s){return this.c.findMatchesLineByLine(l,$,v,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,$){const v=l.startLineNumber,s=l.startColumn,[a,r,n]=(0,m.$ut)($);let o;if($.length>0){const c=a+1;c===1?o=new C.$Us(v,s,v,s+r):o=new C.$Us(v,s,v+c-1,n+1)}else o=new C.$Us(v,s,v,s);return o}static _getInverseEditRanges(l){const $=[];let v=0,s=0,a=null;for(let r=0,n=l.length;r<n;r++){const o=l[r];let c,h;a?a.range.endLineNumber===o.range.startLineNumber?(c=v,h=s+(o.range.startColumn-a.range.endColumn)):(c=v+(o.range.startLineNumber-a.range.endLineNumber),h=o.range.startColumn):(c=o.range.startLineNumber,h=o.range.startColumn);let i;if(o.text.length>0){const u=o.eolCount+1;u===1?i=new C.$Us(c,h,c,h+o.firstLineLength):i=new C.$Us(c,h,c+u-1,o.lastLineLength+1)}else i=new C.$Us(c,h,c,h);v=i.endLineNumber,s=i.endColumn,$.push(i),a=o}return $}static u(l,$){const v=C.$Us.compareRangesUsingEnds(l.range,$.range);return v===0?l.sortIndex-$.sortIndex:v}static w(l,$){const v=C.$Us.compareRangesUsingEnds(l.range,$.range);return v===0?$.sortIndex-l.sortIndex:-v}}e.$bC=R}),define(Pe[144],Re([1,0,12,91,143]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class A{constructor(f,w,R,k,l,$,v,s,a){this.a=f,this.b=w,this.c=R,this.d=k,this.e=l,this.f=$,this.g=v,this.h=s,this.j=a}k(f){const w=this.c+this.d+this.e,R=this.c+this.e;return w===0?f===1?`
`:`\r
`:R>w/2?`\r
`:`
`}create(f){const w=this.k(f),R=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let l=0,$=R.length;l<$;l++){const v=R[l].buffer.replace(/\r\n|\r|\n/g,w),s=(0,M.$9B)(v);R[l]=new M.$_B(v,s)}const k=new C.$bC(R,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class P{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&y.$wf(f)&&(this.b=y.$vf,f=f.substr(1));const w=f.charCodeAt(f.length-1);w===13||w>=55296&&w<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=w):(this.m(f,!1),this.c=!1,this.d=w)}m(f,w){!w&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const w=(0,M.$0B)(this.e,f);this.a.push(new M.$_B(f,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=y.$nf(f)),this.k||(this.k=y.$qf(f)))}finish(f=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const w=(0,M.$9B)(f.buffer);f.lineStarts=w,this.d===13&&this.f++}}}e.$cC=P}),define(Pe[96],Re([1,0,22,21]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$=e.$w$=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function A(k){for(let l=0,$=k.length;l<$;l+=4){const v=k[l+0],s=k[l+1],a=k[l+2],r=k[l+3];k[l+0]=r,k[l+1]=a,k[l+2]=s,k[l+3]=v}}function P(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||A(l),y.$je.wrap(l)}function m(k){const l=k.buffer;if(M.$D()||A(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const $=new Uint8Array(l.byteLength);return $.set(l),new Uint32Array($.buffer,$.byteOffset,$.length/4)}}function f(k){const l=new Uint32Array(w(k));let $=0;if(l[$++]=k.id,k.type==="full")l[$++]=1,l[$++]=k.data.length,l.set(k.data,$),$+=k.data.length;else{l[$++]=2,l[$++]=k.deltas.length;for(const v of k.deltas)l[$++]=v.start,l[$++]=v.deleteCount,v.data?(l[$++]=v.data.length,l.set(v.data,$),$+=v.data.length):l[$++]=0}return P(l)}e.$w$=f;function w(k){let l=0;if(l+=1+1,k.type==="full")l+=1+k.data.length;else{l+=1,l+=(1+1+1)*k.deltas.length;for(const $ of k.deltas)$.data&&(l+=$.data.length)}return l}function R(k){const l=m(k);let $=0;const v=l[$++];if(l[$++]===1){const n=l[$++],o=l.subarray($,$+n);return $+=n,{id:v,type:"full",data:o}}const a=l[$++],r=[];for(let n=0;n<a;n++){const o=l[$++],c=l[$++],h=l[$++];let i;h>0&&(i=l.subarray($,$+h),$+=h),r[n]={start:o,deleteCount:c,data:i}}return{id:v,type:"delta",deltas:r}}e.$x$=R}),define(Pe[145],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Re([1,0,18,26,21,129,147,145]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=w;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(x,$e,Be,Qe){this.id=x,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(x,$e){return $(x,$e)}compute(x,$e,Be){return Be}}class l{constructor(x,$e){this.newValue=x,this.didChange=$e}}e.ApplyUpdateResult=l;function $(X,x){if(typeof X!="object"||typeof x!="object"||!X||!x)return new l(x,X!==x);if(Array.isArray(X)||Array.isArray(x)){const Be=Array.isArray(X)&&Array.isArray(x)&&y.$ub(X,x);return new l(x,!Be)}let $e=!1;for(const Be in x)if(x.hasOwnProperty(Be)){const Qe=$(X[Be],x[Be]);Qe.didChange&&(X[Be]=Qe.newValue,$e=!0)}return new l(X,$e)}class v{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,$e){return $(x,$e)}validate(x){return this.defaultValue}}class s{constructor(x,$e,Be,Qe){this.id=x,this.name=$e,this.defaultValue=Be,this.schema=Qe}applyUpdate(x,$e){return $(x,$e)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,$e,Be){return Be}}function a(X,x){return typeof X>"u"?x:X==="false"?!1:!!X}e.boolean=a;class r extends s{constructor(x,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Be),super(x,$e,Be,Qe)}validate(x){return a(x,this.defaultValue)}}function n(X,x,$e,Be){if(typeof X>"u")return x;let Qe=parseInt(X,10);return isNaN(Qe)?x:(Qe=Math.max($e,Qe),Qe=Math.min(Be,Qe),Qe|0)}e.clampedInt=n;class o extends s{static clampedInt(x,$e,Be,Qe){return n(x,$e,Be,Qe)}constructor(x,$e,Be,Qe,tt,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Be,rt.minimum=Qe,rt.maximum=tt),super(x,$e,Be,rt),this.minimum=Qe,this.maximum=tt}validate(x){return o.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function c(X,x,$e,Be){if(typeof X>"u")return x;const Qe=h.float(X,x);return h.clamp(Qe,$e,Be)}e.clampedFloat=c;class h extends s{static clamp(x,$e,Be){return x<$e?$e:x>Be?Be:x}static float(x,$e){if(typeof x=="number")return x;if(typeof x>"u")return $e;const Be=parseFloat(x);return isNaN(Be)?$e:Be}constructor(x,$e,Be,Qe,tt){typeof tt<"u"&&(tt.type="number",tt.default=Be),super(x,$e,Be,tt),this.validationFn=Qe}validate(x){return this.validationFn(h.float(x,this.defaultValue))}}class i extends s{static string(x,$e){return typeof x!="string"?$e:x}constructor(x,$e,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Be),super(x,$e,Be,Qe)}validate(x){return i.string(x,this.defaultValue)}}function u(X,x,$e,Be){return typeof X!="string"?x:Be&&X in Be?Be[X]:$e.indexOf(X)===-1?x:X}e.stringSet=u;class t extends s{constructor(x,$e,Be,Qe,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Qe,tt.default=Be),super(x,$e,Be,tt),this.c=Qe}validate(x){return u(x,this.defaultValue,this.c)}}class g extends k{constructor(x,$e,Be,Qe,tt,rt,Te=void 0){typeof Te<"u"&&(Te.type="string",Te.enum=tt,Te.default=Qe),super(x,$e,Be,Te),this.c=tt,this.d=rt}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function p(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(x){switch(x){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(x,$e,Be){return Be===0?x.accessibilitySupport:Be}}class S extends k{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:m.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{insertSpace:a($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function b(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function D(X){switch(X){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function T(X){switch(X){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class O extends v{constructor(){super(140)}compute(x,$e,Be){const Qe=["monaco-editor"];return $e.get(39)&&Qe.push($e.get(39)),x.extraEditorClassName&&Qe.push(x.extraEditorClassName),$e.get(73)==="default"?Qe.push("mouse-default"):$e.get(73)==="copy"&&Qe.push("mouse-copy"),$e.get(110)&&Qe.push("showUnused"),$e.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class G extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(x,$e,Be){return Be&&x.emptySelectionClipboard}}class q extends k{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:m.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:m.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{cursorMoveOnType:a($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":u($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":u($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a($e.loop,this.defaultValue.loop)}}}class U extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?U.OFF:x==="true"?U.ON:x:x?U.ON:U.OFF}}e.EditorFontLigatures=U;class I extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",I.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?I.OFF:x==="true"?I.TRANSLATE:x:x?I.TRANSLATE:I.OFF}compute(x,$e,Be){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=I;class N extends v{constructor(){super(50)}compute(x,$e,Be){return x.fontInfo}}class W extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(x){const $e=h.float(x,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp($e,6,100)}compute(x,$e,Be){return x.fontInfo.fontSize}}class ae extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ae.d,maximum:ae.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ae.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(o.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,ae.d,ae.e))}}class de extends k{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Be,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Be,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Be,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Be,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Be,description:m.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{multiple:u($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??u($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??u($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??u($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??u($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??u($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class we extends k{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:m.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:a($e.enabled,this.defaultValue.enabled),delay:o.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:a($e.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:a($e.above,this.defaultValue.above)}}}var ke;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class ue extends v{constructor(){super(143)}compute(x,$e,Be){return ue.computeLayout($e,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const $e=x.height/x.lineHeight,Be=Math.floor(x.paddingTop/x.lineHeight);let Qe=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(Qe=Math.max(Qe,$e-1));const tt=(Be+x.viewLineCount+Qe)/(x.pixelRatio*x.height),rt=Math.floor(x.viewLineCount/tt);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Qe,desiredRatio:tt,minimapLineCount:rt}}static c(x,$e){const Be=x.outerWidth,Qe=x.outerHeight,tt=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const rt=$e.stableMinimapLayoutInput,Te=rt&&x.outerHeight===rt.outerHeight&&x.lineHeight===rt.lineHeight&&x.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&x.pixelRatio===rt.pixelRatio&&x.scrollBeyondLastLine===rt.scrollBeyondLastLine&&x.paddingTop===rt.paddingTop&&x.paddingBottom===rt.paddingBottom&&x.minimap.enabled===rt.minimap.enabled&&x.minimap.side===rt.minimap.side&&x.minimap.size===rt.minimap.size&&x.minimap.showSlider===rt.minimap.showSlider&&x.minimap.renderCharacters===rt.minimap.renderCharacters&&x.minimap.maxColumn===rt.minimap.maxColumn&&x.minimap.scale===rt.minimap.scale&&x.verticalScrollbarWidth===rt.verticalScrollbarWidth&&x.isViewportWrapping===rt.isViewportWrapping,zt=x.lineHeight,At=x.typicalHalfwidthCharacterWidth,Gt=x.scrollBeyondLastLine,Ft=x.minimap.renderCharacters;let yt=tt>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const qt=x.minimap.maxColumn,Tt=x.minimap.size,Xt=x.minimap.side,Vt=x.verticalScrollbarWidth,Ut=x.viewLineCount,Ze=x.remainingWidth,Ht=x.isViewportWrapping,Jt=Ft?2:3;let lt=Math.floor(tt*Qe);const $t=lt/tt;let jt=!1,Qt=!1,Et=Jt*yt,dt=yt/tt,St=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Mt,extraLinesBeyondLastLine:Pt,desiredRatio:Bt,minimapLineCount:De}=ue.computeContainedMinimapLineCount({viewLineCount:Ut,scrollBeyondLastLine:Gt,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:Qe,lineHeight:zt,pixelRatio:tt});if(Ut/De>1)jt=!0,Qt=!0,yt=1,Et=1,dt=yt/tt;else{let he=!1,Q=yt+1;if(Tt==="fit"){const Ie=Math.ceil((Mt+Ut+Pt)*Et);Ht&&Te&&Ze<=$e.stableFitRemainingWidth?(he=!0,Q=$e.stableFitMaxMinimapScale):he=Ie>lt}if(Tt==="fill"||he){jt=!0;const Ie=yt;Et=Math.min(zt*tt,Math.max(1,Math.floor(1/Bt))),Ht&&Te&&Ze<=$e.stableFitRemainingWidth&&(Q=$e.stableFitMaxMinimapScale),yt=Math.min(Q,Math.max(1,Math.floor(Et/Jt))),yt>Ie&&(St=Math.min(2,yt/Ie)),dt=yt/tt/St,lt=Math.ceil(Math.max(ft,Mt+Ut+Pt)*Et),Ht?($e.stableMinimapLayoutInput=x,$e.stableFitRemainingWidth=Ze,$e.stableFitMaxMinimapScale=yt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const _t=Math.floor(qt*dt),Ct=Math.min(_t,Math.max(0,Math.floor((Ze-Vt-2)*dt/(At+dt)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(tt*Ct);const Lt=qe/tt;qe=Math.floor(qe*St);const Nt=Ft?1:2,Yt=Xt==="left"?0:Be-Ct-Vt;return{renderMinimap:Nt,minimapLeft:Yt,minimapWidth:Ct,minimapHeightIsEditorHeight:jt,minimapIsSampling:Qt,minimapScale:yt,minimapLineHeight:Et,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Lt,minimapCanvasOuterHeight:$t}}static computeLayout(x,$e){const Be=$e.outerWidth|0,Qe=$e.outerHeight|0,tt=$e.lineHeight|0,rt=$e.lineNumbersDigitCount|0,Te=$e.typicalHalfwidthCharacterWidth,zt=$e.maxDigitWidth,At=$e.pixelRatio,Gt=$e.viewLineCount,Ft=x.get(135),yt=Ft==="inherit"?x.get(134):Ft,qt=yt==="inherit"?x.get(130):yt,Tt=x.get(133),Xt=$e.isDominatedByLongLines,Vt=x.get(57),Ut=x.get(67).renderType!==0,Ze=x.get(68),Ht=x.get(104),Jt=x.get(83),lt=x.get(72),$t=x.get(102),jt=$t.verticalScrollbarSize,Qt=$t.verticalHasArrows,Et=$t.arrowSize,dt=$t.horizontalScrollbarSize,St=x.get(43),_t=x.get(109)!=="never";let Ct=x.get(65);St&&_t&&(Ct+=16);let qe=0;if(Ut){const Ye=Math.max(rt,Ze);qe=Math.round(Ye*zt)}let Lt=0;Vt&&(Lt=tt*$e.glyphMarginDecorationLaneCount);let Nt=0,Yt=Nt+Lt,ft=Yt+qe,Mt=ft+Ct;const Pt=Be-Lt-qe-Ct;let Bt=!1,De=!1,Fe=-1;yt==="inherit"&&Xt?(Bt=!0,De=!0):qt==="on"||qt==="bounded"?De=!0:qt==="wordWrapColumn"&&(Fe=Tt);const he=ue.c({outerWidth:Be,outerHeight:Qe,lineHeight:tt,typicalHalfwidthCharacterWidth:Te,pixelRatio:At,scrollBeyondLastLine:Ht,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:lt,verticalScrollbarWidth:jt,viewLineCount:Gt,remainingWidth:Pt,isViewportWrapping:De},$e.memory||new R);he.renderMinimap!==0&&he.minimapLeft===0&&(Nt+=he.minimapWidth,Yt+=he.minimapWidth,ft+=he.minimapWidth,Mt+=he.minimapWidth);const Q=Pt-he.minimapWidth,Ie=Math.max(1,Math.floor((Q-jt-2)/Te)),Oe=Qt?Et:0;return De&&(Fe=Math.max(1,Ie),qt==="bounded"&&(Fe=Math.min(Fe,Tt))),{width:Be,height:Qe,glyphMarginLeft:Nt,glyphMarginWidth:Lt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Yt,lineNumbersWidth:qe,decorationsLeft:ft,decorationsWidth:Ct,contentLeft:Mt,contentWidth:Q,minimap:he,viewportColumn:Ie,isWordWrapMinified:Bt,isViewportWrapping:De,wrappingColumn:Fe,verticalScrollbarWidth:jt,horizontalScrollbarHeight:dt,overviewRuler:{top:Oe,width:jt,height:Qe-2*Oe,right:0}}}}e.EditorLayoutInfoComputer=ue;class pe extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(x){return u(x,"simple",["simple","advanced"])}compute(x,$e,Be){return $e.get(2)===2?"advanced":Be}}var ie;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(ie||(e.ShowLightbulbIconMode=ie={}));class be extends k{constructor(){const x={enabled:ie.On};super(64,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",enum:[ie.Off,ie.OnCode,ie.On],default:x.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:u(x.enabled,this.defaultValue.enabled,[ie.Off,ie.OnCode,ie.On])}}}class se extends k{constructor(){const x={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:m.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:10,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:m.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:a($e.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:u($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:a($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Z extends k{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:m.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:u($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),padding:a($e.padding,this.defaultValue.padding)}}}class V extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):o.clampedInt(x,this.defaultValue,0,1e3)}compute(x,$e,Be){return Be<0?o.clampedInt(-Be*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class ne extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>h.clamp(x,0,150),{markdownDescription:m.localize(66,null)})}compute(x,$e,Be){return x.fontInfo.lineHeight}}class Ae extends k{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:x.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:m.localize(77,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:a($e.enabled,this.defaultValue.enabled),autohide:a($e.autohide,this.defaultValue.autohide),size:u($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:u($e.side,this.defaultValue.side,["right","left"]),showSlider:u($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a($e.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt($e.scale,1,1,3),maxColumn:o.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Le(X){return X==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class Ce extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{top:o.clampedInt($e.top,0,0,1e3),bottom:o.clampedInt($e.bottom,0,0,1e3)}}}class ce extends k{constructor(){const x={enabled:!0,cycle:!0};super(85,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:m.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:a($e.enabled,this.defaultValue.enabled),cycle:a($e.cycle,this.defaultValue.cycle)}}}class te extends v{constructor(){super(141)}compute(x,$e,Be){return x.pixelRatio}}class J extends k{constructor(){const x={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(88,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:x.strings,description:m.localize(85,null)},comments:{anyOf:$e,default:x.comments,description:m.localize(86,null)},other:{anyOf:$e,default:x.other,description:m.localize(87,null)}},default:x,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const At=x?"on":"off";return{comments:At,strings:At,other:At}}if(!x||typeof x!="object")return this.defaultValue;const{other:$e,comments:Be,strings:Qe}=x,tt=["on","inline","off"];let rt,Te,zt;return typeof $e=="boolean"?rt=$e?"on":"off":rt=u($e,this.defaultValue.other,tt),typeof Be=="boolean"?Te=Be?"on":"off":Te=u(Be,this.defaultValue.comments,tt),typeof Qe=="boolean"?zt=Qe?"on":"off":zt=u(Qe,this.defaultValue.strings,tt),{other:rt,comments:Te,strings:zt}}}var ee;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class me extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(x){let $e=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?($e=4,Be=x):x==="interval"?$e=3:x==="relative"?$e=2:x==="on"?$e=1:$e=0),{renderType:$e,renderFn:Be}}}function ve(X){const x=X.get(97);return x==="editable"?X.get(90):x!=="on"}e.filterValidationDecorations=ve;class Me extends k{constructor(){const x=[],$e={type:"number",description:m.localize(94,null)};super(101,"rulers",x,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:x,description:m.localize(96,null)})}validate(x){if(Array.isArray(x)){const $e=[];for(const Be of x)if(typeof Be=="number")$e.push({column:o.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Qe=Be;$e.push({column:o.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return $e.sort((Be,Qe)=>Be.column-Qe.column),$e}return this.defaultValue}}class fe extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function ye(X,x){if(typeof X!="string")return x;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends k{constructor(){const x={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x,Be=o.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=o.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ye($e.vertical,this.defaultValue.vertical),horizontal:ye($e.horizontal,this.defaultValue.horizontal),useShadows:a($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:a($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:o.clampedInt($e.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:o.clampedInt($e.verticalSliderSize,Qe,0,1e3),scrollByPage:a($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:a($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends k{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:m.localize(115,null)}})}applyUpdate(x,$e){let Be=!1;$e.allowedCharacters&&x&&(M.$zn(x.allowedCharacters,$e.allowedCharacters)||(x={...x,allowedCharacters:$e.allowedCharacters},Be=!0)),$e.allowedLocales&&x&&(M.$zn(x.allowedLocales,$e.allowedLocales)||(x={...x,allowedLocales:$e.allowedLocales},Be=!0));const Qe=super.applyUpdate(x,$e);return Be?new l(Qe.newValue,!0):Qe}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{nonBasicASCII:_($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,$e){if(typeof x!="object"||!x)return $e;const Be={};for(const[Qe,tt]of Object.entries(x))tt===!0&&(Be[Qe]=!0);return Be}}class K extends k{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:m.localize(121,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:a($e.enabled,this.defaultValue.enabled),mode:u($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:a($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:a($e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class j extends k{constructor(){const x={enabled:A.$ss.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$ss.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:m.localize(123,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:a($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends k{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(124,null),m.localize(125,null),m.localize(126,null)],default:x.bracketPairs,description:m.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(128,null),m.localize(129,null),m.localize(130,null)],default:x.bracketPairsHorizontal,description:m.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:m.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:m.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(134,null),m.localize(135,null),m.localize(136,null)],default:x.highlightActiveIndentation,description:m.localize(137,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{bracketPairs:_($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:_($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(X,x,$e){const Be=$e.indexOf(X);return Be===-1?x:$e[Be]}class Ee extends k{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(138,null),m.localize(139,null)],default:x.insertMode,description:m.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:m.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:m.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:m.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(144,null),m.localize(145,null),m.localize(146,null),m.localize(147,null)],default:x.selectionMode,markdownDescription:m.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:m.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:m.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:m.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:m.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:m.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{insertMode:u($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:a($e.showIcons,this.defaultValue.showIcons),showStatusBar:a($e.showStatusBar,this.defaultValue.showStatusBar),preview:a($e.preview,this.defaultValue.preview),previewMode:u($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a($e.showMethods,this.defaultValue.showMethods),showFunctions:a($e.showFunctions,this.defaultValue.showFunctions),showConstructors:a($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:a($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a($e.showFields,this.defaultValue.showFields),showVariables:a($e.showVariables,this.defaultValue.showVariables),showClasses:a($e.showClasses,this.defaultValue.showClasses),showStructs:a($e.showStructs,this.defaultValue.showStructs),showInterfaces:a($e.showInterfaces,this.defaultValue.showInterfaces),showModules:a($e.showModules,this.defaultValue.showModules),showProperties:a($e.showProperties,this.defaultValue.showProperties),showEvents:a($e.showEvents,this.defaultValue.showEvents),showOperators:a($e.showOperators,this.defaultValue.showOperators),showUnits:a($e.showUnits,this.defaultValue.showUnits),showValues:a($e.showValues,this.defaultValue.showValues),showConstants:a($e.showConstants,this.defaultValue.showConstants),showEnums:a($e.showEnums,this.defaultValue.showEnums),showEnumMembers:a($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a($e.showKeywords,this.defaultValue.showKeywords),showWords:a($e.showWords,this.defaultValue.showWords),showColors:a($e.showColors,this.defaultValue.showColors),showFiles:a($e.showFiles,this.defaultValue.showFiles),showReferences:a($e.showReferences,this.defaultValue.showReferences),showFolders:a($e.showFolders,this.defaultValue.showFolders),showTypeParameters:a($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a($e.showSnippets,this.defaultValue.showSnippets),showUsers:a($e.showUsers,this.defaultValue.showUsers),showIssues:a($e.showIssues,this.defaultValue.showIssues)}}}class Ne extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(187,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:a(x.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class Ke extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(188,null),m.localize(189,null),m.localize(190,null),m.localize(191,null)],description:m.localize(192,null),default:"same"}})}validate(x){switch(x){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(x,$e,Be){return $e.get(2)===2?0:Be}}class Xe extends v{constructor(){super(144)}compute(x,$e,Be){const Qe=$e.get(143);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class nt extends k{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(195,null),m.localize(196,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:a($e.enabled,this.defaultValue.enabled),showDropSelector:u($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends k{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(199,null),m.localize(200,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const $e=x;return{enabled:a($e.enabled,this.defaultValue.enabled),showPasteSelector:u($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?at:C.$k?ct:et,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(X){return e.editorOptionsRegistry[X.id]=X,X}var mt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.letterSpacing=63]="letterSpacing",X[X.lightbulb=64]="lightbulb",X[X.lineDecorationsWidth=65]="lineDecorationsWidth",X[X.lineHeight=66]="lineHeight",X[X.lineNumbers=67]="lineNumbers",X[X.lineNumbersMinChars=68]="lineNumbersMinChars",X[X.linkedEditing=69]="linkedEditing",X[X.links=70]="links",X[X.matchBrackets=71]="matchBrackets",X[X.minimap=72]="minimap",X[X.mouseStyle=73]="mouseStyle",X[X.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=75]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",X[X.multiCursorModifier=77]="multiCursorModifier",X[X.multiCursorPaste=78]="multiCursorPaste",X[X.multiCursorLimit=79]="multiCursorLimit",X[X.occurrencesHighlight=80]="occurrencesHighlight",X[X.overviewRulerBorder=81]="overviewRulerBorder",X[X.overviewRulerLanes=82]="overviewRulerLanes",X[X.padding=83]="padding",X[X.pasteAs=84]="pasteAs",X[X.parameterHints=85]="parameterHints",X[X.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",X[X.quickSuggestions=88]="quickSuggestions",X[X.quickSuggestionsDelay=89]="quickSuggestionsDelay",X[X.readOnly=90]="readOnly",X[X.readOnlyMessage=91]="readOnlyMessage",X[X.renameOnType=92]="renameOnType",X[X.renderControlCharacters=93]="renderControlCharacters",X[X.renderFinalNewline=94]="renderFinalNewline",X[X.renderLineHighlight=95]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=97]="renderValidationDecorations",X[X.renderWhitespace=98]="renderWhitespace",X[X.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",X[X.roundedSelection=100]="roundedSelection",X[X.rulers=101]="rulers",X[X.scrollbar=102]="scrollbar",X[X.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=104]="scrollBeyondLastLine",X[X.scrollPredominantAxis=105]="scrollPredominantAxis",X[X.selectionClipboard=106]="selectionClipboard",X[X.selectionHighlight=107]="selectionHighlight",X[X.selectOnLineNumbers=108]="selectOnLineNumbers",X[X.showFoldingControls=109]="showFoldingControls",X[X.showUnused=110]="showUnused",X[X.snippetSuggestions=111]="snippetSuggestions",X[X.smartSelect=112]="smartSelect",X[X.smoothScrolling=113]="smoothScrolling",X[X.stickyScroll=114]="stickyScroll",X[X.stickyTabStops=115]="stickyTabStops",X[X.stopRenderingLineAfter=116]="stopRenderingLineAfter",X[X.suggest=117]="suggest",X[X.suggestFontSize=118]="suggestFontSize",X[X.suggestLineHeight=119]="suggestLineHeight",X[X.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",X[X.suggestSelection=121]="suggestSelection",X[X.tabCompletion=122]="tabCompletion",X[X.tabIndex=123]="tabIndex",X[X.unicodeHighlighting=124]="unicodeHighlighting",X[X.unusualLineTerminators=125]="unusualLineTerminators",X[X.useShadowDOM=126]="useShadowDOM",X[X.useTabStops=127]="useTabStops",X[X.wordBreak=128]="wordBreak",X[X.wordSeparators=129]="wordSeparators",X[X.wordWrap=130]="wordWrap",X[X.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=133]="wordWrapColumn",X[X.wordWrapOverride1=134]="wordWrapOverride1",X[X.wordWrapOverride2=135]="wordWrapOverride2",X[X.wrappingIndent=136]="wrappingIndent",X[X.wrappingStrategy=137]="wrappingStrategy",X[X.showDeprecated=138]="showDeprecated",X[X.inlayHints=139]="inlayHints",X[X.editorClassName=140]="editorClassName",X[X.pixelRatio=141]="pixelRatio",X[X.tabFocusMode=142]="tabFocusMode",X[X.layoutInfo=143]="layoutInfo",X[X.wrappingInfo=144]="wrappingInfo",X[X.defaultColorDecorators=145]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(mt||(e.EditorOption=mt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(201,null)})),acceptSuggestionOnEnter:je(new t(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(202,null),""],markdownDescription:m.localize(203,null)})),accessibilitySupport:je(new d),accessibilityPageSize:je(new o(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(204,null),tags:["accessibility"]})),ariaLabel:je(new i(4,"ariaLabel",m.localize(205,null))),ariaRequired:je(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:je(new t(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(207,null),m.localize(208,null),""],description:m.localize(209,null)})),autoClosingComments:je(new t(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(210,null),m.localize(211,null),""],description:m.localize(212,null)})),autoClosingDelete:je(new t(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(213,null),""],description:m.localize(214,null)})),autoClosingOvertype:je(new t(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(215,null),""],description:m.localize(216,null)})),autoClosingQuotes:je(new t(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(217,null),m.localize(218,null),""],description:m.localize(219,null)})),autoIndent:je(new g(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[m.localize(220,null),m.localize(221,null),m.localize(222,null),m.localize(223,null),m.localize(224,null)],description:m.localize(225,null)})),automaticLayout:je(new r(13,"automaticLayout",!1)),autoSurround:je(new t(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(226,null),m.localize(227,null),m.localize(228,null),""],description:m.localize(229,null)})),bracketPairColorization:je(new j),bracketPairGuides:je(new Y),stickyTabStops:je(new r(115,"stickyTabStops",!1,{description:m.localize(230,null)})),codeLens:je(new r(17,"codeLens",!0,{description:m.localize(231,null)})),codeLensFontFamily:je(new i(18,"codeLensFontFamily","",{description:m.localize(232,null)})),codeLensFontSize:je(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(233,null)})),colorDecorators:je(new r(20,"colorDecorators",!0,{description:m.localize(234,null)})),colorDecoratorActivatedOn:je(new t(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(235,null),m.localize(236,null),m.localize(237,null)],description:m.localize(238,null)})),colorDecoratorsLimit:je(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(239,null)})),columnSelection:je(new r(22,"columnSelection",!1,{description:m.localize(240,null)})),comments:je(new S),contextmenu:je(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new r(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(241,null)})),cursorBlinking:je(new g(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:m.localize(242,null)})),cursorSmoothCaretAnimation:je(new t(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),cursorStyle:je(new g(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:m.localize(247,null)})),cursorSurroundingLines:je(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(248,null)})),cursorSurroundingLinesStyle:je(new t(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(249,null),m.localize(250,null)],markdownDescription:m.localize(251,null)})),cursorWidth:je(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(252,null)})),disableLayerHinting:je(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new r(34,"domReadOnly",!1)),dragAndDrop:je(new r(35,"dragAndDrop",!0,{description:m.localize(253,null)})),emptySelectionClipboard:je(new G),dropIntoEditor:je(new nt),stickyScroll:je(new se),experimentalWhitespaceRendering:je(new t(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(254,null),m.localize(255,null),m.localize(256,null)],description:m.localize(257,null)})),extraEditorClassName:je(new i(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:m.localize(258,null)})),find:je(new q),fixedOverflowWidgets:je(new r(42,"fixedOverflowWidgets",!1)),folding:je(new r(43,"folding",!0,{description:m.localize(259,null)})),foldingStrategy:je(new t(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(260,null),m.localize(261,null)],description:m.localize(262,null)})),foldingHighlight:je(new r(45,"foldingHighlight",!0,{description:m.localize(263,null)})),foldingImportsByDefault:je(new r(46,"foldingImportsByDefault",!1,{description:m.localize(264,null)})),foldingMaximumRegions:je(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(265,null)})),unfoldOnClickAfterEndOfLine:je(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(266,null)})),fontFamily:je(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(267,null)})),fontInfo:je(new N),fontLigatures2:je(new U),fontSize:je(new W),fontWeight:je(new ae),fontVariations:je(new I),formatOnPaste:je(new r(55,"formatOnPaste",!1,{description:m.localize(268,null)})),formatOnType:je(new r(56,"formatOnType",!1,{description:m.localize(269,null)})),glyphMargin:je(new r(57,"glyphMargin",!0,{description:m.localize(270,null)})),gotoLocation:je(new de),hideCursorInOverviewRuler:je(new r(59,"hideCursorInOverviewRuler",!1,{description:m.localize(271,null)})),hover:je(new we),inDiffEditor:je(new r(61,"inDiffEditor",!1)),letterSpacing:je(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:m.localize(272,null)})),lightbulb:je(new be),lineDecorationsWidth:je(new V),lineHeight:je(new ne),lineNumbers:je(new me),lineNumbersMinChars:je(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new r(69,"linkedEditing",!1,{description:m.localize(273,null)})),links:je(new r(70,"links",!0,{description:m.localize(274,null)})),matchBrackets:je(new t(71,"matchBrackets","always",["always","near","never"],{description:m.localize(275,null)})),minimap:je(new Ae),mouseStyle:je(new t(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(74,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:m.localize(276,null)})),mouseWheelZoom:je(new r(75,"mouseWheelZoom",!1,{markdownDescription:C.$j?m.localize(277,null):m.localize(278,null)})),multiCursorMergeOverlapping:je(new r(76,"multiCursorMergeOverlapping",!0,{description:m.localize(279,null)})),multiCursorModifier:je(new g(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Le,{markdownEnumDescriptions:[m.localize(280,null),m.localize(281,null)],markdownDescription:m.localize(282,null)})),multiCursorPaste:je(new t(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(283,null),m.localize(284,null)],markdownDescription:m.localize(285,null)})),multiCursorLimit:je(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(286,null)})),occurrencesHighlight:je(new t(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(287,null),m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),overviewRulerBorder:je(new r(81,"overviewRulerBorder",!0,{description:m.localize(291,null)})),overviewRulerLanes:je(new o(82,"overviewRulerLanes",3,0,3)),padding:je(new Ce),pasteAs:je(new it),parameterHints:je(new ce),peekWidgetDefaultFocus:je(new t(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(292,null),m.localize(293,null)],description:m.localize(294,null)})),definitionLinkOpensInPeek:je(new r(87,"definitionLinkOpensInPeek",!1,{description:m.localize(295,null)})),quickSuggestions:je(new J),quickSuggestionsDelay:je(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(296,null)})),readOnly:je(new r(90,"readOnly",!1)),readOnlyMessage:je(new fe),renameOnType:je(new r(92,"renameOnType",!1,{description:m.localize(297,null),markdownDeprecationMessage:m.localize(298,null)})),renderControlCharacters:je(new r(93,"renderControlCharacters",!0,{description:m.localize(299,null),restricted:!0})),renderFinalNewline:je(new t(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(300,null)})),renderLineHighlight:je(new t(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(301,null)],description:m.localize(302,null)})),renderLineHighlightOnlyWhenFocus:je(new r(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(303,null)})),renderValidationDecorations:je(new t(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new t(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(304,null),m.localize(305,null),m.localize(306,null),""],description:m.localize(307,null)})),revealHorizontalRightPadding:je(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new r(100,"roundedSelection",!0,{description:m.localize(308,null)})),rulers:je(new Me),scrollbar:je(new F),scrollBeyondLastColumn:je(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(309,null)})),scrollBeyondLastLine:je(new r(104,"scrollBeyondLastLine",!0,{description:m.localize(310,null)})),scrollPredominantAxis:je(new r(105,"scrollPredominantAxis",!0,{description:m.localize(311,null)})),selectionClipboard:je(new r(106,"selectionClipboard",!0,{description:m.localize(312,null),included:C.$k})),selectionHighlight:je(new r(107,"selectionHighlight",!0,{description:m.localize(313,null)})),selectOnLineNumbers:je(new r(108,"selectOnLineNumbers",!0)),showFoldingControls:je(new t(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(314,null),m.localize(315,null),m.localize(316,null)],description:m.localize(317,null)})),showUnused:je(new r(110,"showUnused",!0,{description:m.localize(318,null)})),showDeprecated:je(new r(138,"showDeprecated",!0,{description:m.localize(319,null)})),inlayHints:je(new Z),snippetSuggestions:je(new t(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(320,null),m.localize(321,null),m.localize(322,null),m.localize(323,null)],description:m.localize(324,null)})),smartSelect:je(new Ne),smoothScrolling:je(new r(113,"smoothScrolling",!1,{description:m.localize(325,null)})),stopRenderingLineAfter:je(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new Ee),inlineSuggest:je(new K),inlineCompletionsAccessibilityVerbose:je(new r(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(326,null)})),suggestFontSize:je(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new r(120,"suggestOnTriggerCharacters",!0,{description:m.localize(329,null)})),suggestSelection:je(new t(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(330,null),m.localize(331,null),m.localize(332,null)],description:m.localize(333,null)})),tabCompletion:je(new t(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),tabIndex:je(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new H),unusualLineTerminators:je(new t(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),useShadowDOM:je(new r(126,"useShadowDOM",!0)),useTabStops:je(new r(127,"useTabStops",!0,{description:m.localize(342,null)})),wordBreak:je(new t(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),wordSeparators:je(new i(129,"wordSeparators",P.$ts,{description:m.localize(346,null)})),wordWrap:je(new t(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(347,null),m.localize(348,null),m.localize(349,null),m.localize(350,null)],description:m.localize(351,null)})),wordWrapBreakAfterCharacters:je(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(352,null)})),wordWrapOverride1:je(new t(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new t(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new O),defaultColorDecorators:je(new r(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(353,null)})),pixelRatio:je(new te),tabFocusMode:je(new r(142,"tabFocusMode",!1,{markdownDescription:m.localize(354,null)})),layoutInfo:je(new ue),wrappingInfo:je(new Xe),wrappingIndent:je(new Ke),wrappingStrategy:je(new pe)}}),define(Pe[148],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Pe[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Pe[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Pe[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Pe[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[180],Re([1,0,15,150]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var C;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(C||(e.TokenType=C={}));function A(...w){switch(w.length){case 1:return(0,M.localize)(0,null,w[0]);case 2:return(0,M.localize)(1,null,w[0],w[1]);case 3:return(0,M.localize)(2,null,w[0],w[1],w[2]);default:return}}const P=(0,M.localize)(3,null),m=(0,M.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const k=this.d,l=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:R}),this.f.push($)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const k=this.c.substring(this.d,this.e),l=f.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,k=!1,l=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(m);return}const v=this.c.charCodeAt(R);if(k)k=!1;else if(v===47&&!l){R++;break}else v===91?l=!0:v===92?k=!0:v===93&&(l=!1);R++}for(;R<this.c.length&&f.a.has(this.c.charCodeAt(R));)R++;this.e=R;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=f}),define(Pe[181],Re([1,0,25,31,152,294]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function f(r){return r=r.trim(),r==="*"||P.test(r)}e.$ap=f;function w(r){if(!f(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=r.match(P);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$bp=w;function R(r){if(!r)return null;const n=r.majorBase,o=r.majorMustEqual,c=r.minorBase;let h=r.minorMustEqual;const i=r.patchBase;let u=r.patchMustEqual;r.hasCaret&&(n===0||(h=!1),u=!1);let t=0;if(r.preRelease){const g=m.exec(r.preRelease);if(g){const[,p,d,S]=g;t=Date.UTC(Number(p),Number(d)-1,Number(S))}}return{majorBase:n,majorMustEqual:o,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:u,isMinimum:r.hasGreaterEquals,notBefore:t}}e.$cp=R;function k(r,n,o){let c;typeof r=="string"?c=R(w(r)):c=r;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof o=="string"?i=R(w(o)):i=o,!c||!i)return!1;const u=c.majorBase,t=c.minorBase,g=c.patchBase;let p=i.majorBase,d=i.minorBase,S=i.patchBase;const L=i.notBefore;let b=i.majorMustEqual,E=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?u>p?!0:u<p?!1:t>d?!0:t<d||h&&h<L?!1:g>=S:(u===1&&p===0&&(!b||!E||!D)&&(p=1,d=0,S=0,b=!0,E=!1,D=!1),u<p?!1:u>p?!b:t<d?!1:t>d?!E:g<S?!1:g>S?!D:!(h&&h<L))}e.$dp=k;function l(r,n,o,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([M.default.Error,C.localize(0,null)]),i;if(typeof c.name!="string")return i.push([M.default.Error,C.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([M.default.Error,C.localize(2,null,"version")]),i;if(!c.engines)return i.push([M.default.Error,C.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([M.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!a(c.extensionDependencies))return i.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!a(c.activationEvents))return i.push([M.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([M.default.Error,C.localize(9,null,"main")]),i;{const g=(0,y.$Hg)(o,c.main);(0,y.$Bg)(g,o)||i.push([M.default.Warning,C.localize(10,null,g.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([M.default.Error,C.localize(11,null,"browser")]),i;{const g=(0,y.$Hg)(o,c.browser);(0,y.$Bg)(g,o)||i.push([M.default.Warning,C.localize(12,null,g.path,o.path)])}}if(!A.valid(c.version))return i.push([M.default.Error,C.localize(13,null)]),i;const u=[];if(!$(r,n,c,h,u))for(const g of u)i.push([M.default.Error,g]);return i}e.$ep=l;function $(r,n,o,c,h){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:s(r,n,o.engines.vscode,h)}e.$fp=$;function v(r,n,o){return r==="*"||s(n,o,r)}e.$gp=v;function s(r,n,o,c=[]){const h=R(w(o));if(!h)return c.push(C.localize(14,null,o)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(C.localize(15,null,o)),!1}else if(!h.majorMustEqual)return c.push(C.localize(16,null,o)),!1;return k(r,n,h)?!0:(c.push(C.localize(17,null,r,o)),!1)}function a(r){if(!Array.isArray(r))return!1;for(let n=0,o=r.length;n<o;n++)if(typeof r[n]!="string")return!1;return!0}}),define(Pe[70],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class y{constructor(C,A=[],P=!1){this.ctor=C,this.staticArguments=A,this.supportsDelayedInstantiation=P}}e.$3h=y}),define(Pe[53],Re([1,0,70]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const M=[];var C;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function A(m,f,w){f instanceof y.$3h||(f=new y.$3h(f,[],!!w)),M.push([m,f])}e.$Yr=A;function P(){return M}e.$Zr=P}),define(Pe[182],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class y{constructor(A,P){this.key=A,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=y;class M{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const P of this.a.values())P.outgoing.size===0&&A.push(P);return A}insertEdge(A,P){const m=this.lookupOrInsertNode(A),f=this.lookupOrInsertNode(P);m.outgoing.set(f.key,f),f.incoming.set(m.key,m)}removeNode(A){const P=this.b(A);this.a.delete(P);for(const m of this.a.values())m.outgoing.delete(P),m.incoming.delete(P)}lookupOrInsertNode(A){const P=this.b(A);let m=this.a.get(P);return m||(m=new y(P,A),this.a.set(P,m)),m}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[P,m]of this.a)A.push(`${P}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,P]of this.a){const m=new Set([A]),f=this.c(P,m);if(f)return f}}c(A,P){for(const[m,f]of A.outgoing){if(P.has(m))return[...P,m].join(" -> ");P.add(m);const w=this.c(f,P);if(w)return w;P.delete(m)}}}e.$Dq=M}),define(Pe[4],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e._util=void 0;var y;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function m(f){return f[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=m})(y||(e._util=y={})),e.$5h=C("instantiationService");function M(P,m,f){m[y.DI_TARGET]===m?m[y.DI_DEPENDENCIES].push({id:P,index:f}):(m[y.DI_DEPENDENCIES]=[{id:P,index:f}],m[y.DI_TARGET]=m)}function C(P){if(y.serviceIds.has(P))return y.serviceIds.get(P);const m=function(f,w,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(m,f,R)};return m.toString=()=>P,y.serviceIds.set(P,m),m}e.$6h=C;function A(P){return P}e.$7h=A}),define(Pe[46],Re([1,0,16,2,4]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,C.$6h)("configurationService");function A(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof M.URI)}e.$Ai=A;function P(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof M.URI)}e.$Bi=P;var m;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function f(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=f;function w(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.$Di=w;function R(r,n){const o=Object.create(null);for(const c in r)k(o,c,r[c],n);return o}e.$Ei=R;function k(r,n,o,c){const h=n.split("."),i=h.pop();let u=r;for(let t=0;t<h.length;t++){const g=h[t];let p=u[g];switch(typeof p){case"undefined":p=u[g]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,t+1).join(".")} is ${JSON.stringify(p)}`);return}u=p}if(typeof u=="object"&&u!==null)try{u[i]=o}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(u)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(u)}`)}e.$Fi=k;function l(r,n){const o=n.split(".");$(r,o)}e.$Gi=l;function $(r,n){const o=n.shift();if(n.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const c=r[o];typeof c=="object"&&!Array.isArray(c)&&($(c,n),Object.keys(c).length===0&&delete r[o])}}function v(r,n,o){function c(u,t){let g=u;for(const p of t){if(typeof g!="object"||g===null)return;g=g[p]}return g}const h=n.split("."),i=c(r,h);return typeof i>"u"?o:i}e.$Hi=v;function s(r,n,o){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in r?y.$Kf(r[c])&&y.$Kf(n[c])?s(r[c],n[c],o):o&&(r[c]=n[c]):r[c]=n[c])})}e.$Ii=s;function a(r){return r.replace(/[\[\]]/g,"")}e.$Ji=a}),define(Pe[35],Re([1,0,21,12,180,4,149,15]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",y.$j),f.set("isLinux",y.$k),f.set("isWindows",y.$i),f.set("isWeb",y.$o),f.set("isMacNative",y.$j&&!y.$o),f.set("isEdge",y.$H),f.set("isFirefox",y.$F),f.set("isChrome",y.$E),f.set("isSafari",y.$G);function w(Z,V){if(f.get(Z)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(Z,V)}e.$2i=w;const R=Object.prototype.hasOwnProperty;var k;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},$=(0,P.localize)(0,null),v=(0,P.localize)(1,null),s=(0,P.localize)(2,null),a=(0,P.localize)(3,null),r=(0,P.localize)(4,null),n=(0,P.localize)(5,null),o=(0,P.localize)(6,null),c=(0,P.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new C.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ae=this.D(),Le=Ae.type===17?n:void 0;throw this.h.push({message:r,offset:Ae.offset,lexeme:C.$1i.getLexeme(Ae),additionalInfo:Le}),h.c}return ne}catch(ne){if(ne!==h.c)throw ne;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ne=this.o();V.push(ne)}return V.length===1?V[0]:i.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ne=this.s();V.push(ne)}return V.length===1?V[0]:i.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),p.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,a),ne?.negate()}case 17:return this.z(),T.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ne=this.l();return this.A(1,a),ne}case 17:{const ne=V.lexeme;if(this.z(),this.y(9)){const Le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Le.type!==10)throw this.B("REGEX",Le);const Ce=Le.lexeme,ce=Ce.lastIndexOf("/"),te=ce===Ce.length-1?void 0:this.w(Ce.substring(ce+1));let J;try{J=new RegExp(Ce.substring(1,ce),te)}catch{throw this.B("REGEX",Le)}return N.create(ne,J)}switch(Le.type){case 10:case 19:{const Ce=[Le.lexeme];this.z();let ce=this.D(),te=0;for(let Me=0;Me<Le.lexeme.length;Me++)Le.lexeme.charCodeAt(Me)===40?te++:Le.lexeme.charCodeAt(Me)===41&&te--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Me=0;Me<ce.lexeme.length;Me++)ce.lexeme.charCodeAt(Me)===40?te++:Le.lexeme.charCodeAt(Me)===41&&te--}if(te<0)break;Ce.push(C.$1i.getLexeme(ce)),this.z(),ce=this.D()}const J=Ce.join(""),ee=J.lastIndexOf("/"),me=ee===J.length-1?void 0:this.w(J.substring(ee+1));let ve;try{ve=new RegExp(J.substring(1,ee),me)}catch{throw this.B("REGEX",Le)}return i.regex(ne,ve)}case 18:{const Ce=Le.lexeme;this.z();let ce=null;if(!(0,M.$Je)(Ce)){const te=Ce.indexOf("/"),J=Ce.lastIndexOf("/");if(te!==J&&te>=0){const ee=Ce.slice(te+1,J),me=Ce[J+1]==="i"?"i":"";try{ce=new RegExp(ee,me)}catch{throw this.B("REGEX",Le)}}}if(ce===null)throw this.B("REGEX",Le);return N.create(ne,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Le=this.u();return i.notIn(ne,Le)}switch(this.D().type){case 3:{this.z();const Le=this.u();if(this.x().type===18)return i.equals(ne,Le);switch(Le){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Le)}}case 4:{this.z();const Le=this.u();if(this.x().type===18)return i.notEquals(ne,Le);switch(Le){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Le)}}case 5:return this.z(),U.create(ne,this.u());case 6:return this.z(),I.create(ne,this.u());case 7:return this.z(),G.create(ne,this.u());case 8:return this.z(),q.create(ne,this.u());case 13:return this.z(),i.in(ne,this.u());default:return i.has(ne)}}case 20:throw this.h.push({message:o,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ne){if(this.C(V))return this.z();throw this.B(ne,this.D())}B(V,ne,Ae){const Le=(0,P.localize)(8,null,V,C.$1i.getLexeme(ne)),Ce=ne.offset,ce=C.$1i.getLexeme(ne);return this.h.push({message:Le,offset:Ce,lexeme:ce,additionalInfo:Ae}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=h;class i{static false(){return p.INSTANCE}static true(){return d.INSTANCE}static has(V){return S.create(V)}static equals(V,ne){return L.create(V,ne)}static notEquals(V,ne){return D.create(V,ne)}static regex(V,ne){return N.create(V,ne)}static in(V,ne){return b.create(V,ne)}static notIn(V,ne){return E.create(V,ne)}static not(V){return T.create(V)}static and(...V){return de.create(V,null,!0)}static or(...V){return we.create(V,null,!0)}static greater(V,ne){return G.create(V,ne)}static greaterEquals(V,ne){return q.create(V,ne)}static smaller(V,ne){return U.create(V,ne)}static smallerEquals(V,ne){return I.create(V,ne)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$4i=i;function u(Z){const V=new h({regexParsingWithErrorRecovery:!1});return Z.map(ne=>(V.parse(ne),V.lexingErrors.length>0?V.lexingErrors.map(Ae=>({errorMessage:Ae.additionalInfo?(0,P.localize)(9,null,Ae.additionalInfo):(0,P.localize)(10,null),offset:Ae.offset,length:Ae.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ae=>({errorMessage:Ae.additionalInfo?`${Ae.message}. ${Ae.additionalInfo}`:Ae.message,offset:Ae.offset,length:Ae.lexeme.length})):[]))}e.$5i=u;function t(Z,V){const ne=Z?Z.substituteConstants():void 0,Ae=V?V.substituteConstants():void 0;return!ne&&!Ae?!0:!ne||!Ae?!1:ne.equals(Ae)}e.$6i=t;function g(Z,V){return Z.cmp(V)}class p{static{this.INSTANCE=new p}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return d.INSTANCE}}e.$7i=p;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return p.INSTANCE}}e.$8i=d;class S{static create(V,ne=null){const Ae=f.get(V);return typeof Ae=="boolean"?Ae?d.INSTANCE:p.INSTANCE:new S(V,ne)}constructor(V,ne){this.key=V,this.c=ne,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=f.get(this.key);return typeof V=="boolean"?V?d.INSTANCE:p.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.$9i=S;class L{static create(V,ne,Ae=null){if(typeof ne=="boolean")return ne?S.create(V,Ae):T.create(V,Ae);const Le=f.get(V);return typeof Le=="boolean"?ne===(Le?"true":"false")?d.INSTANCE:p.INSTANCE:new L(V,ne,Ae)}constructor(V,ne,Ae){this.c=V,this.d=ne,this.f=Ae,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?d.INSTANCE:p.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$0i=L;class b{static create(V,ne){return new b(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.f),Ae=V.getValue(this.d);return Array.isArray(ne)?ne.includes(Ae):typeof Ae=="string"&&typeof ne=="object"&&ne!==null?R.call(ne,Ae):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$$i=b;class E{static create(V,ne){return new E(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=11,this.c=b.create(V,ne)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=E;class D{static create(V,ne,Ae=null){if(typeof ne=="boolean")return ne?T.create(V,Ae):S.create(V,Ae);const Le=f.get(V);return typeof Le=="boolean"?ne===(Le?"true":"false")?p.INSTANCE:d.INSTANCE:new D(V,ne,Ae)}constructor(V,ne,Ae){this.c=V,this.d=ne,this.f=Ae,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?p.INSTANCE:d.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$aj=D;class T{static create(V,ne=null){const Ae=f.get(V);return typeof Ae=="boolean"?Ae?p.INSTANCE:d.INSTANCE:new T(V,ne)}constructor(V,ne){this.c=V,this.d=ne,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=f.get(this.c);return typeof V=="boolean"?V?p.INSTANCE:d.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$bj=T;function O(Z,V){if(typeof Z=="string"){const ne=parseFloat(Z);isNaN(ne)||(Z=ne)}return typeof Z=="string"||typeof Z=="number"?V(Z):p.INSTANCE}class G{static create(V,ne,Ae=null){return O(ne,Le=>new G(V,Le,Ae))}constructor(V,ne,Ae){this.c=V,this.d=ne,this.f=Ae,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$cj=G;class q{static create(V,ne,Ae=null){return O(ne,Le=>new q(V,Le,Ae))}constructor(V,ne,Ae){this.c=V,this.d=ne,this.f=Ae,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$dj=q;class U{static create(V,ne,Ae=null){return O(ne,Le=>new U(V,Le,Ae))}constructor(V,ne,Ae){this.c=V,this.d=ne,this.f=Ae,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$ej=U;class I{static create(V,ne,Ae=null){return O(ne,Le=>new I(V,Le,Ae))}constructor(V,ne,Ae){this.c=V,this.d=ne,this.f=Ae,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$fj=I;class N{static create(V,ne){return new N(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ne=this.f?this.f.source:"",Ae=V.f?V.f.source:"";return ne<Ae?-1:ne>Ae?1:0}equals(V){if(V.type===this.type){const ne=this.f?this.f.source:"",Ae=V.f?V.f.source:"";return this.d===V.d&&ne===Ae}return!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$gj=N;class W{static create(V){return new W(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new W(this.c.map(V))}negate(){return this.c}}e.$hj=W;function ae(Z){let V=null;for(let ne=0,Ae=Z.length;ne<Ae;ne++){const Le=Z[ne].substituteConstants();if(Z[ne]!==Le&&V===null){V=[];for(let Ce=0;Ce<ne;Ce++)V[Ce]=Z[Ce]}V!==null&&(V[ne]=Le)}return V===null?Z:V}class de{static create(V,ne,Ae){return de.d(V,ne,Ae)}constructor(V,ne){this.expr=V,this.c=ne,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ae=this.expr.length;ne<Ae;ne++){const Le=g(this.expr[ne],V.expr[ne]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ae=this.expr.length;ne<Ae;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:de.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ae=this.expr.length;ne<Ae;ne++)if(!this.expr[ne].evaluate(V))return!1;return!0}static d(V,ne,Ae){const Le=[];let Ce=!1;for(const ce of V)if(ce){if(ce.type===1){Ce=!0;continue}if(ce.type===0)return p.INSTANCE;if(ce.type===6){Le.push(...ce.expr);continue}Le.push(ce)}if(Le.length===0&&Ce)return d.INSTANCE;if(Le.length!==0){if(Le.length===1)return Le[0];Le.sort(g);for(let ce=1;ce<Le.length;ce++)Le[ce-1].equals(Le[ce])&&(Le.splice(ce,1),ce--);if(Le.length===1)return Le[0];for(;Le.length>1;){const ce=Le[Le.length-1];if(ce.type!==9)break;Le.pop();const te=Le.pop(),J=Le.length===0,ee=we.create(ce.expr.map(me=>de.create([me,te],null,Ae)),null,J);ee&&(Le.push(ee),Le.sort(g))}if(Le.length===1)return Le[0];if(Ae){for(let ce=0;ce<Le.length;ce++)for(let te=ce+1;te<Le.length;te++)if(Le[ce].negate().equals(Le[te]))return p.INSTANCE;if(Le.length===1)return Le[0]}return new de(Le,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new de(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());this.c=we.create(V,this,!0)}return this.c}}e.$ij=de;class we{static create(V,ne,Ae){return we.d(V,ne,Ae)}constructor(V,ne){this.expr=V,this.c=ne,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ae=this.expr.length;ne<Ae;ne++){const Le=g(this.expr[ne],V.expr[ne]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ae=this.expr.length;ne<Ae;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:we.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ae=this.expr.length;ne<Ae;ne++)if(this.expr[ne].evaluate(V))return!0;return!1}static d(V,ne,Ae){let Le=[],Ce=!1;if(V){for(let ce=0,te=V.length;ce<te;ce++){const J=V[ce];if(J){if(J.type===0){Ce=!0;continue}if(J.type===1)return d.INSTANCE;if(J.type===9){Le=Le.concat(J.expr);continue}Le.push(J)}}if(Le.length===0&&Ce)return p.INSTANCE;Le.sort(g)}if(Le.length!==0){if(Le.length===1)return Le[0];for(let ce=1;ce<Le.length;ce++)Le[ce-1].equals(Le[ce])&&(Le.splice(ce,1),ce--);if(Le.length===1)return Le[0];if(Ae){for(let ce=0;ce<Le.length;ce++)for(let te=ce+1;te<Le.length;te++)if(Le[ce].negate().equals(Le[te]))return d.INSTANCE;if(Le.length===1)return Le[0]}return new we(Le,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new we(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());for(;V.length>1;){const ne=V.shift(),Ae=V.shift(),Le=[];for(const Ce of se(ne))for(const ce of se(Ae))Le.push(de.create([Ce,ce],null,!1));V.unshift(we.create(Le,null,!1))}this.c=we.create(V,this,!0)}return this.c}}e.$jj=we;class ke extends S{static{this.d=[]}static all(){return ke.d.values()}constructor(V,ne,Ae){super(V,null),this.f=ne,typeof Ae=="object"?ke.d.push({...Ae,key:V}):Ae!==!0&&ke.d.push({key:V,description:Ae,type:ne!=null?typeof ne:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return L.create(this.key,V)}notEqualsTo(V){return D.create(this.key,V)}}e.$kj=ke,e.$lj=(0,A.$6h)("contextKeyService");function ue(Z,V){return Z<V?-1:Z>V?1:0}function pe(Z,V,ne,Ae){return Z<ne?-1:Z>ne?1:V<Ae?-1:V>Ae?1:0}function ie(Z,V){if(Z.type===0||V.type===1)return!0;if(Z.type===9)return V.type===9?be(Z.expr,V.expr):!1;if(V.type===9){for(const ne of V.expr)if(ie(Z,ne))return!0;return!1}if(Z.type===6){if(V.type===6)return be(V.expr,Z.expr);for(const ne of Z.expr)if(ie(ne,V))return!0;return!1}return Z.equals(V)}e.$mj=ie;function be(Z,V){let ne=0,Ae=0;for(;ne<Z.length&&Ae<V.length;){const Le=Z[ne].cmp(V[Ae]);if(Le<0)return!1;Le===0&&ne++,Ae++}return ne===Z.length}function se(Z){return Z.type===9?Z.expr:[Z]}}),define(Pe[183],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,y.$6h)("environmentService"),e.$bi=(0,y.$7h)(e.$ai)}),define(Pe[97],Re([1,0,151,4]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ExtensionGalleryErrorCode=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function C(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=C;function A(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=A;function P(o,c){switch(o){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=P;function m(o,c){return c==="web"&&!o.includes("web")}e.$vo=m;function f(o,c,h){return m(c,h)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===h}e.$wo=f;function w(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$xo=w;var R;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var k;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(o){o.Install="install",o.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var $;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$yo=(0,M.$6h)("extensionGalleryService");var v;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Unknown="Unknown",o.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var s;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class a extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$zo=a;var r;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class n extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$Ao=n,e.$Bo=(0,M.$6h)("extensionManagementService"),e.$Co="extensionsIdentifiers/disabled",e.$Do="extensionsIdentifiers/enabled",e.$Eo=(0,M.$6h)("IGlobalExtensionEnablementService"),e.$Fo=(0,M.$6h)("IExtensionTipsService"),e.$Go=(0,y.localize)(0,null),e.$Ho={value:e.$Go,original:"Extensions"},e.$Io=(0,y.localize2)(1,"Preferences")}),define(Pe[41],Re([1,0,50,19,12,16,2,153,4,21,11,39]),function(ge,e,y,M,C,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.FileKind=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileOperationResult=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileChangeType=e.$Ik=e.FileOperation=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderErrorCode=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileSystemProviderCapabilities=e.$sk=e.FilePermission=e.FileType=e.$rk=e.$qk=void 0,e.$qk=(0,f.$6h)("fileService");function l(ie){return ie.create===!0}e.$rk=l;var $;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var v;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function s(ie){const be=ie;return!!be&&typeof be.onDidChange=="function"}e.$sk=s;var a;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function r(ie){return!!(ie.capabilities&2)}e.$tk=r;function n(ie){return!!(ie.capabilities&8)}e.$uk=n;function o(ie){return!!(ie.capabilities&131072)}e.$vk=o;function c(ie){return!!(ie.capabilities&4)}e.$wk=c;function h(ie){return!!(ie.capabilities&16)}e.$xk=h;function i(ie){return r(ie)?!!(ie.capabilities&16384):!1}e.$yk=i;function u(ie){return r(ie)?!!(ie.capabilities&32768):!1}e.$zk=u;function t(ie){return!!(ie.capabilities&65536)}e.$Ak=t;function g(ie){return!!(ie.capabilities&2048)}e.$Bk=g;var p;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class d extends Error{static create(be,se){const Z=new d(be.toString(),se);return b(Z,se),Z}constructor(be,se){super(be),this.code=se}}e.$Ck=d;function S(ie,be){return d.create(ie,be)}e.$Dk=S;function L(ie){return ie||S((0,m.localize)(0,null),p.Unknown)}e.$Ek=L;function b(ie,be){return ie.name=be?`${be} (FileSystemError)`:"FileSystemError",ie}e.$Fk=b;function E(ie){if(!ie)return p.Unknown;if(ie instanceof d)return ie.code;const be=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!be)return p.Unknown;switch(be[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.$Gk=E;function D(ie){if(ie instanceof I)return ie.fileOperationResult;switch(E(ie)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}e.$Hk=D;var T;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class O{constructor(be,se,Z){this.resource=be,this.operation=se,this.target=Z}isOperation(be){return this.operation===be}}e.$Ik=O;var G;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class q{static{this.a=null}constructor(be,se){this.c=se,this.b=void 0,this.d=new k.$V(()=>{const Z=y.$_h.forUris(()=>this.c);return Z.fill(this.rawAdded.map(V=>[V,!0])),Z}),this.f=new k.$V(()=>{const Z=y.$_h.forUris(()=>this.c);return Z.fill(this.rawUpdated.map(V=>[V,!0])),Z}),this.g=new k.$V(()=>{const Z=y.$_h.forUris(()=>this.c);return Z.fill(this.rawDeleted.map(V=>[V,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of be){switch(Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}this.b!==q.a&&(typeof Z.cId=="number"?this.b===void 0?this.b=Z.cId:this.b!==Z.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(be,...se){return this.h(be,{includeChildren:!1},...se)}affects(be,...se){return this.h(be,{includeChildren:!0},...se)}h(be,se,...Z){if(!be)return!1;const V=Z.length>0;return!!((!V||Z.includes(1))&&(this.d.value.get(be)||se.includeChildren&&this.d.value.findSuperstr(be))||(!V||Z.includes(0))&&(this.f.value.get(be)||se.includeChildren&&this.f.value.findSuperstr(be))||(!V||Z.includes(2))&&(this.g.value.findSubstr(be)||se.includeChildren&&this.g.value.findSuperstr(be)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(be){return this.b===be}hasCorrelation(){return typeof this.b=="number"}}e.$Jk=q;function U(ie,be,se){return!ie||!be||ie===be||be.length>ie.length?!1:(be.charAt(be.length-1)!==M.sep&&(be+=M.sep),se?(0,C.$af)(ie,be):ie.indexOf(be)===0)}e.$Kk=U;class I extends Error{constructor(be,se,Z){super(be),this.fileOperationResult=se,this.options=Z}}e.$Lk=I;class N extends I{constructor(be,se,Z,V){super(be,se,V),this.fileOperationResult=se,this.size=Z}}e.$Mk=N;class W extends I{constructor(be,se,Z){super(be,2,Z),this.stat=se}}e.$Nk=W;var ae;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Qk="files.associations",e.$Rk="files.exclude",e.$Sk="files.readonlyInclude",e.$Tk="files.readonlyExclude",e.$Uk="files.readonlyFromPermissions";var de;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(de||(e.FileKind=de={})),e.$Vk="";function we(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$Wk=we;async function ke(ie,be){if(!be.hasProvider(P.URI.from({scheme:ie.scheme})))return new Promise(se=>{const Z=be.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===ie.scheme&&V.added&&(Z.dispose(),se())})})}e.$Xk=ke;class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(be){return(0,A.$Mf)(be)||(be=0),be<ue.KB?(0,m.localize)(1,null,be.toFixed(0)):be<ue.MB?(0,m.localize)(2,null,(be/ue.KB).toFixed(2)):be<ue.GB?(0,m.localize)(3,null,(be/ue.MB).toFixed(2)):be<ue.TB?(0,m.localize)(4,null,(be/ue.GB).toFixed(2)):(0,m.localize)(5,null,(be/ue.TB).toFixed(2))}}e.$Yk=ue;function pe(ie){const be=typeof ie=="string"||ie?.scheme===R.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===R.Schemas.file?1024*ue.MB:be?10*ue.MB:w.$o?50*ue.MB:1024*ue.MB}e.$Zk=pe}),define(Pe[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class y{constructor(...C){this.a=new Map;for(const[A,P]of C)this.set(A,P)}set(C,A){const P=this.a.get(C);return this.a.set(C,A),P}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$4h=y}),define(Pe[184],Re([1,0,13,15,6,70,182,4,71,185]),function(ge,e,y,M,C,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const R=!1;class k extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class l{constructor(a=new f.$4h,r=!1,n,o=R){this.f=a,this.g=r,this.h=n,this.i=o,this.o=new Set,this.f.set(m.$5h,this),this._globalGraph=o?n?._globalGraph??new P.$Dq(c=>c):void 0}createChild(a){return new l(a,this.g,this,this.i)}invokeFunction(a,...r){const n=v.traceInvocation(this.i,a);let o=!1;try{return a({get:h=>{if(o)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...r)}finally{o=!0,n.stop()}}createInstance(a,...r){let n,o;return a instanceof A.$3h?(n=v.traceCreation(this.i,a.ctor),o=this.j(a.ctor,a.staticArguments.concat(r),n)):(n=v.traceCreation(this.i,a),o=this.j(a,r,n)),n.stop(),o}j(a,r=[],n){const o=m._util.getServiceDependencies(a).sort((i,u)=>i.index-u.index),c=[];for(const i of o){const u=this.m(i.id,n);u||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(u)}const h=o.length>0?o[0].index:r.length;if(r.length!==h){console.trace(`[createInstance] First service dependency of ${a.name} at position ${h+1} conflicts with ${r.length} static arguments`);const i=h-r.length;i>0?r=r.concat(new Array(i)):r=r.slice(0,h)}return Reflect.construct(a,r.concat(c))}k(a,r){if(this.f.get(a)instanceof A.$3h)this.f.set(a,r);else if(this.h)this.h.k(a,r);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const r=this.f.get(a);return!r&&this.h?this.h.l(a):r}m(a,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const n=this.l(a);return n instanceof A.$3h?this.q(a,n,r.branch(a,!0)):(r.branch(a,!1),n)}q(a,r,n){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,r,n)}finally{this.o.delete(a)}}r(a,r,n){const o=new P.$Dq(i=>i.id.toString());let c=0;const h=[{id:a,desc:r,_trace:n}];for(;h.length;){const i=h.pop();if(o.lookupOrInsertNode(i),c++>1e3)throw new k(o);for(const u of m._util.getServiceDependencies(i.desc.ctor)){const t=this.l(u.id);if(t||this.u(`[createInstance] ${a} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(u.id)),t instanceof A.$3h){const g={id:u.id,desc:t,_trace:i._trace.branch(u.id,!0)};o.insertEdge(i,g),h.push(g)}}}for(;;){const i=o.roots();if(i.length===0){if(!o.isEmpty())throw new k(o);break}for(const{data:u}of i){if(this.l(u.id)instanceof A.$3h){const g=this.s(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.k(u.id,g)}o.removeNode(u)}}return this.l(a)}s(a,r,n=[],o,c){if(this.f.get(a)instanceof A.$3h)return this.t(a,r,n,o,c);if(this.h)return this.h.s(a,r,n,o,c);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}t(a,r,n=[],o,c){if(o){const h=new l(void 0,this.g,this,this.i);h.c=String(a);const i=new Map,u=new y.$mh(()=>{const t=h.j(r,n,c);for(const[g,p]of i){const d=t[g];if(typeof d=="function")for(const S of p)S.disposable=d.apply(t,S.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,g){if(!u.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let S=i.get(g);return S||(S=new w.$4c,i.set(g,S)),(b,E,D)=>{if(u.isInitialized)return u.value[g](b,E,D);{const T={listener:[b,E,D],disposable:void 0},O=S.push(T);return(0,C.$Rc)(()=>{O(),T.disposable?.dispose()})}}}if(g in t)return t[g];const p=u.value;let d=p[g];return typeof d!="function"||(d=d.bind(p),t[g]=d),d},set(t,g,p){return u.value[g]=p,!0},getPrototypeOf(t){return r.prototype}})}else return this.j(r,n,c)}u(a,r){if(r&&console.warn(a),this.g)throw new Error(a)}}e.$Eq=l;var $;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})($||($={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(a,r){return a?new v(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(a,r){return a?new v(1,r.name):v.c}static{this.f=0}constructor(a,r){this.type=a,this.name=r,this.g=Date.now(),this.h=[]}branch(a,r){const n=new v(3,a.toString());return this.h.push([a,r,n]),n}stop(){const a=Date.now()-this.g;v.f+=a;let r=!1;function n(c,h){const i=[],u=new Array(c+1).join("	");for(const[t,g,p]of h.h)if(g&&p){r=!0,i.push(`${u}CREATES -> ${t}`);const d=n(c+1,p);d&&i.push(d)}else i.push(`${u}uses -> ${t}`);return i.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(a>2||r)&&v.all.add(o.join(`
`))}}e.$Fq=v}),define(Pe[14],Re([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,l.$6h)("logService"),e.$oj=(0,l.$6h)("loggerService");function $(){return new Date().toISOString()}function v(b){return(0,w.$Mf)(b)}e.$pj=v;var s;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$qj=s.Info;function a(b,E,D){switch(E){case s.Trace:b.trace(D);break;case s.Debug:b.debug(D);break;case s.Info:b.info(D);break;case s.Warning:b.warn(D);break;case s.Error:b.error(D);break;case s.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=a;function r(b,E=!1){let D="";for(let T=0;T<b.length;T++){let O=b[T];if(O instanceof Error&&(O=(0,y.$Qi)(O,E)),typeof O=="object")try{O=JSON.stringify(O)}catch{}D+=(T>0?" ":"")+O}return D}class n extends A.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new M.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==s.Off&&this.b<=E}}e.$sj=n;class o extends n{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...D){this.f(s.Trace)&&this.g(s.Trace,r([E,...D],!0))}debug(E,...D){this.f(s.Debug)&&this.g(s.Debug,r([E,...D]))}info(E,...D){this.f(s.Info)&&this.g(s.Info,r([E,...D]))}warn(E,...D){this.f(s.Warning)&&this.g(s.Warning,r([E,...D]))}error(E,...D){if(this.f(s.Error))if(E instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=E.stack,this.g(s.Error,r(T))}else this.g(s.Error,r([E,...D]))}flush(){}}e.$tj=o;class c extends n{constructor(E=e.$qj){super(),this.setLevel(E),this.g=!m.$i}trace(E,...D){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,E,...D):console.log(`[main ${$()}]`,E,...D))}debug(E,...D){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,E,...D):console.log(`[main ${$()}]`,E,...D))}info(E,...D){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,E,...D):console.log(`[main ${$()}]`,E,...D))}warn(E,...D){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,E,...D):console.warn(`[main ${$()}]`,E,...D))}error(E,...D){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,E,...D):console.error(`[main ${$()}]`,E,...D))}flush(){}}e.$uj=c;class h extends n{constructor(E=e.$qj,D=!0){super(),this.g=D,this.setLevel(E)}trace(E,...D){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...D):console.log(E,...D))}debug(E,...D){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...D):console.log(E,...D))}info(E,...D){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...D):console.log(E,...D))}warn(E,...D){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...D):console.log(E,...D))}error(E,...D){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...D):console.error(E,...D))}flush(){}}e.$vj=h;class i extends n{constructor(E,D=e.$qj){super(),this.g=E,this.setLevel(D)}trace(E,...D){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(E),...D])}debug(E,...D){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(E),...D])}info(E,...D){this.f(s.Info)&&this.g.log(s.Info,[this.h(E),...D])}warn(E,...D){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(E),...D])}error(E,...D){this.f(s.Error)&&this.g.log(s.Error,[this.h(E),...D])}h(E){return typeof E=="string"?E:(0,y.$Qi)(E,this.f(s.Trace))}flush(){}}e.$wj=i;class u extends n{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const D of this.g)D.setLevel(E);super.setLevel(E)}trace(E,...D){for(const T of this.g)T.trace(E,...D)}debug(E,...D){for(const T of this.g)T.debug(E,...D)}info(E,...D){for(const T of this.g)T.info(E,...D)}warn(E,...D){for(const T of this.g)T.warn(E,...D)}error(E,...D){for(const T of this.g)T.error(E,...D)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$xj=u;class t extends A.$Tc{constructor(E,D,T){if(super(),this.h=E,this.j=D,this.b=new P.$Ac,this.c=this.B(new M.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Vd),this.onDidChangeVisibility=this.g.event,T)for(const O of T)this.b.set(O.resource,{logger:void 0,info:O})}m(E){return(0,w.$If)(E)?[...this.b.values()].find(D=>D.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,D){const T=this.n(E),O=(0,w.$If)(E)?E:D?.id??(0,C.$Ti)(T.toString()).toString(16);let G=this.b.get(T)?.logger;const q=D?.logLevel==="always"?s.Trace:D?.logLevel;G||(G=this.s(T,q??this.getLogLevel(T)??this.h,{...D,id:O}));const U={logger:G,info:{resource:T,id:O,logLevel:q,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(U.info),this.b.set(T,U),G}n(E){return(0,w.$If)(E)?(0,f.$Hg)(this.j,`${E}.log`):E}setLogLevel(E,D){if(R.URI.isUri(E)){const T=E,O=D,G=this.b.get(T);G&&O!==G.info.logLevel&&(G.info.logLevel=O===this.h?void 0:O,G.logger?.setLevel(O),this.b.set(G.info.resource,G),this.f.fire([T,O]))}else{this.h=E;for(const[T,O]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,D){const T=this.m(E);T&&D!==!T.info.hidden&&(T.info.hidden=!D,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,D]))}getLogLevel(E){let D;return E&&(D=this.b.get(E)?.info.logLevel),D??this.h}registerLogger(E){const D=this.b.get(E.resource);D?D.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const D=this.b.get(E);D&&(D.logger&&D.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=t;class g{constructor(){this.onDidChangeLogLevel=new M.$Vd().event}setLevel(E){}getLevel(){return s.Info}trace(E,...D){}debug(E,...D){}info(E,...D){}warn(E,...D){}error(E,...D){}critical(E,...D){}dispose(){}flush(){}}e.$zj=g;class p extends g{}e.$Aj=p;function d(b){if(b.verbose)return s.Trace;if(typeof b.logLevel=="string"){const E=L(b.logLevel.toLowerCase());if(E!==void 0)return E}return e.$qj}e.$Bj=d;function S(b){switch(b){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}e.$Cj=S;function L(b){switch(b){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$Dj=L,e.$Ej=new k.$kj("logLevel",S(s.Info))}),define(Pe[186],Re([1,0,6,14]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=void 0;class C extends y.$Tc{constructor(P,m=[]){super(),this.a=new M.$xj([P,...m]),this.B(P.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...m){this.a.trace(P,...m)}debug(P,...m){this.a.debug(P,...m)}info(P,...m){this.a.info(P,...m)}warn(P,...m){this.a.warn(P,...m)}error(P,...m){this.a.error(P,...m)}flush(){this.a.flush()}}e.$yO=C}),define(Pe[99],Re([1,0,31,154,4]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var P;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(P||(e.MarkerSeverity=P={})),function(f){function w(v,s){return s-v}f.compare=w;const R=Object.create(null);R[f.Error]=(0,M.localize)(0,null),R[f.Warning]=(0,M.localize)(1,null),R[f.Info]=(0,M.localize)(2,null);function k(v){return R[v]||""}f.toString=k;function l(v){switch(v){case y.default.Error:return f.Error;case y.default.Warning:return f.Warning;case y.default.Info:return f.Info;case y.default.Ignore:return f.Hint}}f.fromSeverity=l;function $(v){switch(v){case f.Error:return y.default.Error;case f.Warning:return y.default.Warning;case f.Info:return y.default.Info;case f.Hint:return y.default.Ignore}}f.toSeverity=$}(P||(e.MarkerSeverity=P={}));var m;(function(f){const w="";function R(l){return k(l,!0)}f.makeKey=R;function k(l,$){const v=[w];return l.source?v.push(l.source.replace("\xA6","\\\xA6")):v.push(w),l.code?typeof l.code=="string"?v.push(l.code.replace("\xA6","\\\xA6")):v.push(l.code.value.replace("\xA6","\\\xA6")):v.push(w),l.severity!==void 0&&l.severity!==null?v.push(P.toString(l.severity)):v.push(w),l.message&&$?v.push(l.message.replace("\xA6","\\\xA6")):v.push(w),l.startLineNumber!==void 0&&l.startLineNumber!==null?v.push(l.startLineNumber.toString()):v.push(w),l.startColumn!==void 0&&l.startColumn!==null?v.push(l.startColumn.toString()):v.push(w),l.endLineNumber!==void 0&&l.endLineNumber!==null?v.push(l.endLineNumber.toString()):v.push(w),l.endColumn!==void 0&&l.endColumn!==null?v.push(l.endColumn.toString()):v.push(w),v.push(w),v.join("\xA6")}f.makeKeyOptionalMessage=k})(m||(e.IMarkerData=m={})),e.$At=(0,C.$6h)("markerService")}),define(Pe[187],Re([1,0,5,31,4]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.NotificationsFilter=e.$qv=e.NeverShowAgainScope=e.NotificationPriority=e.$pv=e.Severity=void 0,e.Severity=M.default,e.$pv=(0,C.$6h)("notificationService");var A;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var P;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(P||(e.NeverShowAgainScope=P={}));function m(k){if(k){const l=k;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$qv=m;var f;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class w{constructor(){this.progress=new R,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$rv=w;class R{infinite(){}done(){}total(l){}worked(l){}}e.$sv=R}),define(Pe[188],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,y.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,y,M){var C=arguments.length,A=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,y):M,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ge,e,y,M);else for(var m=ge.length-1;m>=0;m--)(P=ge[m])&&(A=(C<3?P(A):C>3?P(e,y,A):P(e,y))||A);return C>3&&A&&Object.defineProperty(e,y,A),A},He=this&&this.__param||function(ge,e){return function(y,M){e(y,M,ge)}};define(Pe[72],Re([1,0,13,20,6,4]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.ProgressLocation=e.$tv=void 0,e.$tv=(0,A.$6h)("progressService");var P;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(P||(e.ProgressLocation=P={})),e.$uv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$vv=m;class f{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const $=this.d;this.d=()=>{$?.(),l()}}):Promise.resolve()}}e.$wv=f;let w=class extends C.$Tc{constructor(l,$){super(),this.a=new y.$qh,$.withProgress(l,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,C.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$xv=w,e.$xv=w=Je([He(1,e.$tv)],w);class R extends C.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new C.$Sc)}start(l){this.stop();const $=++this.a,v=new M.$6d;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,C.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Rc)(()=>v.cancel())),this.b.add((0,C.$Rc)(()=>this.c?this.c.done():void 0)),{id:$,token:v.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$yv=R,e.$zv=(0,A.$6h)("editorProgressService")}),define(Pe[30],Re([1,0,54,16]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class C{constructor(){this.a=new Map}add(P,m){y.ok(M.$If(P)),y.ok(M.$Kf(m)),y.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,m)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$Hn=new C}),define(Pe[73],Re([1,0,5,30]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function C(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class A{constructor(){this.b=new y.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,w){this.a[C(f)]=w,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const P=new A;M.$Hn.add(e.$In.JSONContribution,P)}),define(Pe[55],Re([1,0,18,5,16,148,46,73,30]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$Mn={Configuration:"base.contributions.configuration"};var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const k=f.$Hn.as(m.$In.JSONContribution);class l{constructor(){this.h=new Set,this.i=new M.$Vd,this.onDidSchemaChange=this.i.event,this.j=new M.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(i,u=!0){this.registerConfigurations([i],u)}registerConfigurations(i,u=!0){const t=new Set;this.n(i,u,t),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const u=new Set;this.o(i,u),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:i,remove:u}){const t=new Set;this.o(u,t),this.n(i,!1,t),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const u=new Set;this.k(i,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(i,u){const t=[];for(const{overrides:g,source:p}of i)for(const d in g)if(u.add(d),e.$Wn.test(d)){const S=this.a.get(d),L=S?.valuesSources??new Map;if(p)for(const T of Object.keys(g[d]))L.set(T,p);const b={...S?.value||{},...g[d]};this.a.set(d,{source:p,value:b,valuesSources:L});const E=(0,P.$Ji)(d),D={type:"object",default:b,description:A.localize(1,null,E),$ref:e.$Tn,defaultDefaultValue:b,source:C.$If(p)?void 0:p,defaultValueSource:p};t.push(...s(d)),this.d[d]=D,this.b.properties[d]=D}else{this.a.set(d,{value:g[d],source:p});const S=this.d[d];S&&(this.w(d,S),this.r(d,S))}this.m(t)}deregisterDefaultConfigurations(i){const u=new Set;this.l(i,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(i,u){for(const{overrides:t,source:g}of i)for(const p in t){const d=this.a.get(p),S=C.$If(g)?g:g?.id,L=C.$If(d?.source)?d?.source:d?.source?.id;if(S===L)if(u.add(p),this.a.delete(p),e.$Wn.test(p))delete this.d[p],delete this.b.properties[p];else{const b=this.d[p];b&&(this.w(p,b),this.r(p,b))}}this.u()}deltaConfiguration(i){let u=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),u=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),u=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const u of i)this.h.add(u);this.u()}n(i,u,t){i.forEach(g=>{this.p(g,u,g.extensionInfo,g.restrictedProperties,void 0,t),this.c.push(g),this.q(g)})}o(i,u){const t=g=>{if(g.properties)for(const p in g.properties){u.add(p);const d=this.d[p];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[p],this.s(p,g.properties[p])}g.allOf?.forEach(p=>t(p))};for(const g of i){t(g);const p=this.c.indexOf(g);p!==-1&&this.c.splice(p,1)}}p(i,u=!0,t,g,p=3,d){p=C.$Rf(i.scope)?p:i.scope;const S=i.properties;if(S)for(const b in S){const E=S[b];if(u&&o(b,E)){delete S[b];continue}if(E.source=t,E.defaultDefaultValue=S[b].default,this.w(b,E),e.$Wn.test(b)?E.scope=void 0:(E.scope=C.$Rf(E.scope)?p:E.scope,E.restricted=C.$Rf(E.restricted)?!!g?.includes(b):E.restricted),S[b].hasOwnProperty("included")&&!S[b].included){this.f[b]=S[b],delete S[b];continue}else this.d[b]=S[b],S[b].policy?.name&&this.e.set(S[b].policy.name,b);!S[b].deprecationMessage&&S[b].markdownDeprecationMessage&&(S[b].deprecationMessage=S[b].markdownDeprecationMessage),d.add(b)}const L=i.allOf;if(L)for(const b of L)this.p(b,u,t,g,p,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const u=t=>{const g=t.properties;if(g)for(const d in g)this.r(d,g[d]);t.allOf?.forEach(u)};u(i)}r(i,u){switch(e.$Nn.properties[i]=u,u.scope){case 1:e.$On.properties[i]=u;break;case 2:e.$Pn.properties[i]=u;break;case 6:e.$Qn.properties[i]=u;break;case 3:e.$Rn.properties[i]=u;break;case 4:e.$Sn.properties[i]=u;break;case 5:e.$Sn.properties[i]=u,this.g.properties[i]=u;break}}s(i,u){switch(delete e.$Nn.properties[i],u.scope){case 1:delete e.$On.properties[i];break;case 2:delete e.$Pn.properties[i];break;case 6:delete e.$Qn.properties[i];break;case 3:delete e.$Rn.properties[i];break;case 4:case 5:delete e.$Sn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const u=`[${i}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$Tn};this.w(u,t),e.$Nn.properties[u]=t,e.$On.properties[u]=t,e.$Pn.properties[u]=t,e.$Qn.properties[u]=t,e.$Rn.properties[u]=t,e.$Sn.properties[u]=t}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=i,e.$On.patternProperties[e.$Vn]=i,e.$Pn.patternProperties[e.$Vn]=i,e.$Qn.patternProperties[e.$Vn]=i,e.$Rn.patternProperties[e.$Vn]=i,e.$Sn.patternProperties[e.$Vn]=i,this.i.fire()}w(i,u){const t=this.a.get(i);let g=t?.value,p=t?.source;C.$Pf(g)&&(g=u.defaultDefaultValue,p=void 0),C.$Pf(g)&&(g=r(u.type)),u.default=g,u.defaultValueSource=p}}const $="\\[([^\\]]+)\\]",v=new RegExp($,"g");e.$Vn=`^(${$})+$`,e.$Wn=new RegExp(e.$Vn);function s(h){const i=[];if(e.$Wn.test(h)){let u=v.exec(h);for(;u?.length;){const t=u[1].trim();t&&i.push(t),u=v.exec(h)}}return(0,y.$Mb)(i)}e.$Xn=s;function a(h){return h.reduce((i,u)=>`${i}[${u}]`,"")}e.$Yn=a;function r(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=r;const n=new l;f.$Hn.add(e.$Mn.Configuration,n);function o(h,i){return h.trim()?e.$Wn.test(h)?A.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?A.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}e.$1n=o;function c(){const h=[],i=n.getConfigurationProperties();for(const u of Object.keys(i))h.push([u,i[u].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$2n=c}),define(Pe[189],Re([1,0,18,5,119,6,28,26,16,2,46,55,30]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function $(u){return Object.isFrozen(u)?u:m.$wn(u)}class v{constructor(t={},g=[],p=[],d){this.b=t,this.c=g,this.d=p,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(g=>{if(g instanceof v)return g;const p=new s("");return p.parseRaw(g),p.configurationModel});this.f=t.reduce((g,p)=>p===g?p:g.merge(p),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,R.$Hi)(this.contents,t):this.contents}inspect(t,g){const p=this.rawConfiguration.getValue(t),d=g?this.rawConfiguration.getOverrideValue(t,g):void 0,S=g?this.rawConfiguration.override(g).getValue(t):p;return{value:p,override:d,merged:S}}getOverrideValue(t,g){const p=this.i(g);return p?t?(0,R.$Hi)(p,t):p:void 0}getKeysForOverrideIdentifier(t){const g=[];for(const p of this.overrides)p.identifiers.includes(t)&&g.push(...p.keys);return y.$Mb(g)}getAllOverrideIdentifiers(){const t=[];for(const g of this.overrides)t.push(...g.identifiers);return y.$Mb(t)}override(t){let g=this.a.get(t);return g||(g=this.g(t),this.a.set(t,g)),g}merge(...t){const g=m.$vn(this.contents),p=m.$vn(this.overrides),d=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const L of t)if(S.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(g,L.contents);for(const b of L.overrides){const[E]=p.filter(D=>y.$ub(D.identifiers,b.identifiers));E?(this.h(E.contents,b.contents),E.keys.push(...b.keys),E.keys=y.$Mb(E.keys)):p.push(m.$vn(b))}for(const b of L.keys)d.indexOf(b)===-1&&d.push(b)}return new v(g,d,p,S.every(L=>L instanceof v)?void 0:S)}g(t){const g=this.i(t);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const p={};for(const d of y.$Mb([...Object.keys(this.contents),...Object.keys(g)])){let S=this.contents[d];const L=g[d];L&&(typeof S=="object"&&typeof L=="object"?(S=m.$vn(S),this.h(S,L)):S=L),p[d]=S}return new v(p,this.keys,this.overrides)}h(t,g){for(const p of Object.keys(g)){if(p in t&&f.$Kf(t[p])&&f.$Kf(g[p])){this.h(t[p],g[p]);continue}t[p]=m.$vn(g[p])}}i(t){let g=null,p=null;const d=S=>{S&&(p?this.h(p,S):p=m.$vn(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===t?g=S.contents:S.identifiers.includes(t)&&d(S.contents);return d(g),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,g){this.j(t,g,!0)}setValue(t,g){this.j(t,g,!1)}removeValue(t){const g=this.keys.indexOf(t);g!==-1&&(this.keys.splice(g,1),(0,R.$Gi)(this.contents,t),k.$Wn.test(t)&&this.overrides.splice(this.overrides.findIndex(p=>y.$ub(p.identifiers,(0,k.$Xn)(t))),1))}j(t,g,p){(0,R.$Fi)(this.contents,t,g,d=>console.error(d)),p=p||this.keys.indexOf(t)===-1,p&&this.keys.push(t),k.$Wn.test(t)&&this.overrides.push({identifiers:(0,k.$Xn)(t),keys:Object.keys(this.contents[t]),contents:(0,R.$Ei)(this.contents[t],d=>console.error(d))})}}e.$3n=v;class s{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,g){if(!f.$Rf(t)){const p=this.g(t);this.parseRaw(p,g)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,g){this.a=t;const{contents:p,keys:d,overrides:S,restricted:L,hasExcludedProperties:b}=this.h(t,g);this.b=new v(p,d,S,b?[t]:void 0),this.c=L||[]}g(t){let g={},p=null,d=[];const S=[],L=[];function b(D){Array.isArray(d)?d.push(D):p!==null&&(d[p]=D)}const E={onObjectBegin:()=>{const D={};b(D),S.push(d),d=D,p=null},onObjectProperty:D=>{p=D},onObjectEnd:()=>{d=S.pop()},onArrayBegin:()=>{const D=[];b(D),S.push(d),d=D,p=null},onArrayEnd:()=>{d=S.pop()},onLiteralValue:b,onError:(D,T,O)=>{L.push({error:D,offset:T,length:O})}};if(t)try{C.$jn(t,E),g=d[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return g}h(t,g){const p=l.$Hn.as(k.$Mn.Configuration).getConfigurationProperties(),d=this.i(t,p,!0,g);t=d.raw;const S=(0,R.$Ei)(t,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),L=Object.keys(t),b=this.j(t,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:S,keys:L,overrides:b,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(t,g,p,d){let S=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:S};const L={},b=[];for(const E in t)if(k.$Wn.test(E)&&p){const D=this.i(t[E],g,!1,d);L[E]=D.raw,S=S||D.hasExcludedProperties,b.push(...D.restricted)}else{const D=g[E],T=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&b.push(E),!d.exclude?.includes(E)&&(d.include?.includes(E)||(T===void 0||d.scopes===void 0||d.scopes.includes(T))&&!(d.skipRestricted&&D?.restricted))?L[E]=t[E]:S=!0}return{raw:L,restricted:b,hasExcludedProperties:S}}j(t,g){const p=[];for(const d of Object.keys(t))if(k.$Wn.test(d)){const S={};for(const L in t[d])S[L]=t[d][L];p.push({identifiers:(0,k.$Xn)(d),keys:Object.keys(S),contents:(0,R.$Ei)(S,g)})}return p}}e.$4n=s;class a extends A.$Tc{constructor(t,g,p,d){super(),this.c=t,this.f=g,this.g=d,this.b=this.B(new M.$Vd),this.onDidChange=this.b.event,this.a=new s(this.c.toString()),this.B(this.g.watch(p.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&p.isEqual(S.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=a;class r{constructor(t,g,p,d,S,L,b,E,D,T,O,G,q){this.a=t,this.b=g,this.c=p,this.overrideIdentifiers=d,this.d=S,this.f=L,this.g=b,this.h=E,this.i=D,this.j=T,this.k=O,this.l=G,this.m=q}get value(){return $(this.c)}n(t,g,p){const d=t.inspect(g,p);return{get value(){return $(d.value)},get override(){return $(d.override)},get merged(){return $(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(t,g,p,d,S=new v,L=new v,b=new P.$Ac,E=new v,D=new P.$Ac){this.c=t,this.d=g,this.f=p,this.g=d,this.h=S,this.i=L,this.j=b,this.l=E,this.m=D,this.a=null,this.b=new P.$Ac,this.n=null}getValue(t,g,p){return this.p(t,g,p).getValue(t)}updateValue(t,g,p={}){let d;p.resource?(d=this.m.get(p.resource),d||(d=new v,this.m.set(p.resource,d))):d=this.l,g===void 0?d.removeValue(t):d.setValue(t,g),p.resource||(this.a=null)}inspect(t,g,p){const d=this.p(t,g,p),S=this.t(g.resource,p),L=g.resource?this.m.get(g.resource)||this.l:this.l,b=new Set;for(const E of d.overrides)for(const D of E.identifiers)d.getOverrideValue(t,D)!==void 0&&b.add(D);return new r(t,g,d.getValue(t),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,p?this.i:void 0,S||void 0,L)}keys(t){const g=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,g){this.j.set(t,g),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,g){const p=[];if(!g){const{added:d,updated:S,removed:L}=h(this.c,t);g=[...d,...S,...L]}for(const d of g)for(const S of(0,k.$Xn)(d)){const L=this.c.getKeysForOverrideIdentifier(S),b=t.getKeysForOverrideIdentifier(S),E=[...b.filter(D=>L.indexOf(D)===-1),...L.filter(D=>b.indexOf(D)===-1),...L.filter(D=>!m.$zn(this.c.override(S).getValue(D),t.override(S).getValue(D)))];p.push([S,E])}return this.updateDefaultConfiguration(t),{keys:g,overrides:p}}compareAndUpdatePolicyConfiguration(t){const{added:g,updated:p,removed:d}=h(this.d,t),S=[...g,...p,...d];return S.length&&this.updatePolicyConfiguration(t),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:g,updated:p,removed:d,overrides:S}=h(this.applicationConfiguration,t),L=[...g,...p,...d];return L.length&&this.updateApplicationConfiguration(t),{keys:L,overrides:S}}compareAndUpdateLocalUserConfiguration(t){const{added:g,updated:p,removed:d,overrides:S}=h(this.localUserConfiguration,t),L=[...g,...p,...d];return L.length&&this.updateLocalUserConfiguration(t),{keys:L,overrides:S}}compareAndUpdateRemoteUserConfiguration(t){const{added:g,updated:p,removed:d,overrides:S}=h(this.remoteUserConfiguration,t),L=[...g,...p,...d];return L.length&&this.updateRemoteUserConfiguration(t),{keys:L,overrides:S}}compareAndUpdateWorkspaceConfiguration(t){const{added:g,updated:p,removed:d,overrides:S}=h(this.workspaceConfiguration,t),L=[...g,...p,...d];return L.length&&this.updateWorkspaceConfiguration(t),{keys:L,overrides:S}}compareAndUpdateFolderConfiguration(t,g){const p=this.folderConfigurations.get(t),{added:d,updated:S,removed:L,overrides:b}=h(p,g),E=[...d,...S,...L];return(E.length||!p)&&this.updateFolderConfiguration(t,g),{keys:E,overrides:b}}compareAndDeleteFolderConfiguration(t){const g=this.folderConfigurations.get(t);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:p,updated:d,removed:S,overrides:L}=h(g,void 0);return{keys:[...p,...d,...S],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,g,p){let d=this.q(g,p);return g.overrideIdentifier&&(d=d.override(g.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(d=d.merge(this.d)),d}q({resource:t},g){let p=this.r();if(g&&t){const d=g.getFolder(t);d&&(p=this.s(d.uri)||p);const S=this.m.get(t);S&&(p=p.merge(S))}return p}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let g=this.b.get(t);if(!g){const p=this.r(),d=this.j.get(t);d?(g=p.merge(d),this.b.set(t,g)):g=p}return g}t(t,g){if(g&&t){const p=g.getFolder(t);if(p)return this.j.get(p.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,g)=>{const{contents:p,overrides:d,keys:S}=this.j.get(g);return t.push([g,{contents:p,overrides:d,keys:S}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(g=>t.add(g)),this.userConfiguration.keys.forEach(g=>t.add(g)),this.i.keys.forEach(g=>t.add(g)),this.j.forEach(g=>g.keys.forEach(p=>t.add(p))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(g=>t.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>t.add(g)),this.i.getAllOverrideIdentifiers().forEach(g=>t.add(g)),this.j.forEach(g=>g.getAllOverrideIdentifiers().forEach(p=>t.add(p))),[...t.values()]}v(t){const g=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(p=>g.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(p=>g.add(p)),this.i.getKeysForOverrideIdentifier(t).forEach(p=>g.add(p)),this.j.forEach(p=>p.getKeysForOverrideIdentifier(t).forEach(d=>g.add(d))),[...g.values()]}static parse(t){const g=this.w(t.defaults),p=this.w(t.policy),d=this.w(t.application),S=this.w(t.user),L=this.w(t.workspace),b=t.folders.reduce((E,D)=>(E.set(w.URI.revive(D[0]),this.w(D[1])),E),new P.$Ac);return new n(g,p,d,S,new v,L,b,new v,new P.$Ac)}static w(t){return new v(t.contents,t.keys,t.overrides)}}e.$6n=n;function o(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const t=new Set,g=new Map;for(const d of u)d.keys.forEach(S=>t.add(S)),d.overrides.forEach(([S,L])=>{const b=(0,P.$xc)(g,S,new Set);L.forEach(E=>b.add(E))});const p=[];return g.forEach((d,S)=>p.push([S,[...d.values()]])),{keys:[...t.values()],overrides:p}}e.$7n=o;class c{constructor(t,g,p,d){this.change=t,this.f=g,this.g=p,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of t.keys)this.affectedKeys.add(S);for(const[,S]of t.overrides)for(const L of S)this.affectedKeys.add(L);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(t,g){const p=this.a+t,d=this.d.indexOf(p);if(d<0)return!1;const S=d+p.length;if(S>=this.d.length)return!1;const L=this.d.charCodeAt(S);if(L!==this.b&&L!==this.c)return!1;if(g){const b=this.previousConfiguration?this.previousConfiguration.getValue(t,g,this.f?.workspace):void 0,E=this.g.getValue(t,g,this.h);return!m.$zn(b,E)}return!0}}e.$8n=c;function h(u,t){const{added:g,removed:p,updated:d}=i(t?.rawConfiguration,u?.rawConfiguration),S=[],L=u?.getAllOverrideIdentifiers()||[],b=t?.getAllOverrideIdentifiers()||[];if(t){const E=b.filter(D=>!L.includes(D));for(const D of E)S.push([D,t.getKeysForOverrideIdentifier(D)])}if(u){const E=L.filter(D=>!b.includes(D));for(const D of E)S.push([D,u.getKeysForOverrideIdentifier(D)])}if(t&&u){for(const E of L)if(b.includes(E)){const D=i({contents:u.getOverrideValue(void 0,E)||{},keys:u.getKeysForOverrideIdentifier(E)},{contents:t.getOverrideValue(void 0,E)||{},keys:t.getKeysForOverrideIdentifier(E)});S.push([E,[...D.added,...D.removed,...D.updated]])}}return{added:g,removed:p,updated:d,overrides:S}}function i(u,t){const g=u?t?u.keys.filter(S=>t.keys.indexOf(S)===-1):[...u.keys]:[],p=t?u?t.keys.filter(S=>u.keys.indexOf(S)===-1):[...t.keys]:[],d=[];if(u&&t){for(const S of t.keys)if(u.keys.indexOf(S)!==-1){const L=(0,R.$Hi)(t.contents,S),b=(0,R.$Hi)(u.contents,S);m.$zn(L,b)||d.push(S)}}return{added:g,removed:p,updated:d}}}),define(Pe[100],Re([1,0,15,4]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.RemoteAuthorityResolverErrorCode=e.$0k=e.$9k=e.RemoteConnectionType=e.$8k=void 0,e.$8k=(0,M.$6h)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class A{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$9k=A;class P{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$0k=P;var m;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class f extends y.$bb{static isNotAvailable(k){return k instanceof f&&k._code===m.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof f&&k._code===m.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof f&&k._code===m.NoResolverFound}static isInvalidAuthority(k){return k instanceof f&&k._code===m.InvalidAuthority}static isHandled(k){return k instanceof f&&k.isHandled}constructor(k,l=m.Unknown,$){super(k),this._message=k,this._code=l,this._detail=$,this.isHandled=l===m.NotAvailable&&$===!0,Object.setPrototypeOf(this,f.prototype)}}e.$$k=f;function w(R){const k=R.indexOf("+");return k===-1?R:R.substring(0,k)}e.$_k=w}),define(Pe[56],Re([1,0,11]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function M(w){return w.scheme===y.Schemas.vscodeRemote?w.authority:void 0}e.$al=M;function C(w){if(!w)return;const R=w.indexOf("+");return R<0?w:w.substr(0,R)}e.$bl=C;function A(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$cl=A;function P(w){const{host:R,port:k}=f(w);if(typeof k>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:k}}e.$dl=P;function m(w,R){let{host:k,port:l}=f(w);return typeof l>"u"&&(l=R),{host:k,port:l}}e.$el=m;function f(w){const R=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=w.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const l=w.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:w,port:void 0}}}),define(Pe[23],Re([1,0,12,4,56]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function A(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$jm=A,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(P||(e.ExtensionType=P={}));var m;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class f{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,r){if(typeof a>"u"||a===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof a=="string"||typeof r=="string"){const n=typeof a=="string"?a:a.value,o=typeof r=="string"?r:r.value;return y.$_e(n,o)}return a._lower===r._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$lm=f;class w{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const r of a)this.add(r)}add(a){this.c.add(f.toKey(a))}delete(a){return this.c.delete(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}}e.$mm=w;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(f.toKey(a))}get(a){return this.c.get(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}set(a,r){this.c.set(f.toKey(a),r)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=R;function k(s){return l(s)}e.$om=k;function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.$pm=l;function $(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.$qm=$;function v(s,a){if(a){const r=`onResolveRemoteAuthority:${(0,C.$bl)(a)}`;return!!s.activationEvents?.includes(r)}return!1}e.$rm=v,e.$sm=(0,M.$6h)("IBuiltinExtensionsScannerService")}),define(Pe[101],Re([1,0,15,23]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lF=e.$kF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(P,m){this.a.set(P,m)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const m=Object.create(null);for(const f of P){const w=this.readActivationEvents(f);w.length>0&&(m[M.$lm.toKey(f.identifier)]=w)}return m}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const m=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];for(let f=0;f<m.length;f++)m[f]==="onUri"&&(m[f]=`onUri:${M.$lm.toKey(P.identifier)}`);if(!P.contributes)return m;for(const f in P.contributes){const w=this.a.get(f);if(!w)continue;const R=P.contributes[f],k=Array.isArray(R)?R:[R];try{w(k,m)}catch(l){(0,y.$1)(l)}}return m}}e.$kF=C,e.$lF=new C}),define(Pe[190],Re([1,0,21,74,33]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=void 0;function A(f){if(y.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function P(f,w,R,k,l,$,v,s,a){const r=Object.create(null);r["common.machineId"]=$,r["common.sqmId"]=v,r.sessionID=(0,C.$qg)()+Date.now(),r.commitHash=k,r.version=l,r["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,y.$h)(y.$u),r["common.nodePlatform"]=M.$dc,r["common.nodeArch"]=R,r["common.product"]=a||"desktop",s&&(r["common.msftInternal"]=s);let n=0;const o=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),y.$l&&(r["common.snap"]="true");const c=A(w);return c&&(r["common.platformDetail"]=c),r}e.$Jo=P;function m(f){const w=M.env.USERDNSDOMAIN;if(!w)return!1;const R=w.toLowerCase();return f.some(k=>R===k)}e.$Ko=m}),define(Pe[191],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,y.$6h)("telemetryService"),e.$vl=(0,y.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var M;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Pe[57],Re([1,0,26,16,56,190,191]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;class m{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$Lo=m;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Mo=f,e.$No=new f;class w{async publicLog(u,t,g){}async publicLogError(u,t,g){}}e.$Oo=w,e.$Po="telemetry",e.$Qo="extensionTelemetryLog",e.$Ro={log:()=>null,flush:()=>Promise.resolve(null)};function R(i,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!i.enableTelemetry)}e.$So=R;function k(i,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$To=k;function l(i){const u=i.getValue(P.$Cl),t=i.getValue(P.$Dl);if(i.getValue(P.$El)===!1||t===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=l;function $(i){const u={},t={},g={};a(i,g);for(let p in g){p=p.length>150?p.substr(p.length-149):p;const d=g[p];typeof d=="number"?t[p]=d:typeof d=="boolean"?t[p]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${d.length}`),u[p]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(u[p]=d)}return{properties:u,measurements:t}}e.$Vo=$;const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const u=(0,C.$bl)(i);return v.has(u)?u:"other"}e.$Wo=s;function a(i,u,t=0,g){if(i)for(const p of Object.getOwnPropertyNames(i)){const d=i[p],S=g?g+p:p;Array.isArray(d)?u[S]=(0,y.$An)(d):d instanceof Date?u[S]=d.toISOString():(0,M.$Kf)(d)?t<2?a(d,u,t+1,S+"."):u[S]=(0,y.$An)(d):u[S]=d}}function r(i,u){const t=i.msftInternalDomains||[],g=u.getValue("telemetry.internalTesting");return(0,A.$Ko)(t)||g}e.$Xo=r;function n(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Yo=n;function o(i,u){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const g=[];for(const L of u)for(;;){const b=L.exec(i);if(!b)break;g.push([b.index,L.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(t="";;){const L=d.exec(i);if(!L)break;const b=g.some(([E,D])=>L.index<D&&E<d.lastIndex);!p.test(L[0])&&!b&&(t+=i.substring(S,L.index)+"<REDACTED: user-file-path>",S=d.lastIndex)}return S<i.length&&(t+=i.substr(S)),t}function c(i){if(!i)return i;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of u)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function h(i,u){return(0,y.$xn)(i,t=>{if(t instanceof m||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let g=t.replaceAll("%20"," ");g=o(g,u);for(const p of u)g=g.replace(p,"");return g=c(g),g}})}e.$Zo=h}),define(Pe[192],Re([1,0,12,97,23,21,2,15,74,57]),function(ge,e,y,M,C,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function R(t,g){return t.uuid&&g.uuid?t.uuid===g.uuid:t.id===g.id?!0:(0,y.$7e)(t.id,g.id)===0}e.$1o=R;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(g){const p=g.manifest?g.manifest.version:g.version,d=g.manifest?g.targetPlatform:g.properties.targetPlatform;return new l(g.identifier,p,d)}static parse(g){const p=k.exec(g);return p&&p[1]&&p[2]?new l({id:p[1]},p[2],p[4]||void 0):null}constructor(g,p,d="undefined"){this.version=p,this.targetPlatform=d,this.id=g.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(g){return g instanceof l?R(this,g)&&this.version===g.version&&this.targetPlatform===g.targetPlatform:!1}}e.$2o=l;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(t){const g=$.exec(t);return g&&g[1]?[a(g[1]),g[2]]:[a(t),void 0]}e.$3o=v;function s(t,g){return`${t}.${g}`}e.$4o=s;function a(t){return t.toLowerCase()}e.$5o=a;function r(t,g){return a(s(t??C.$hm,g))}e.$6o=r;function n(t,g){const p=[],d=S=>{for(const L of p)if(L.some(b=>R(g(b),g(S))))return L;return null};for(const S of t){const L=d(S);L?L.push(S):p.push([S])}return p}e.$7o=n;function o(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$8o=o;function c(t){return{id:new w.$Lo(t.identifier.id),name:new w.$Lo(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$9o=c,e.$0o=new C.$lm("pprice.better-merge");function h(t,g){const p=[],d=g.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const S=d.shift();if(S&&p.every(L=>!R(L.identifier,{id:S}))){const L=t.filter(b=>R(b.identifier,{id:S}));L.length===1&&(p.push(L[0]),d.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.$$o=h;async function i(t,g){if(!A.$k)return!1;let p;try{p=(await t.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{p=(await t.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){g.debug("Error while getting the os-release file.",(0,m.$0)(S))}}return!!p&&(p.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(t,g){const p=await i(t,g),d=(0,M.$uo)(p?"alpine":A.$u,f.$ec);return g.debug("ComputeTargetPlatform:",d),d}e.$_o=u}),define(Pe[193],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0;function y(f){return[...f.entries()]}e.$Mr=y;function M(f){return f?[...f.entries()]:[]}e.$Nr=M;function C(f){return new Map(f)}e.$Or=C;function A(f){return new Map(f??[])}e.$Pr=A;function P(f){return Array.from(f.entries()).map(w=>[w[0],y(w[1].map),M(w[1].descriptionMap)])}e.$Qr=P;function m(f){return new Map(f.map(w=>[w[0],{map:C(w[1]),descriptionMap:A(w[2])}]))}e.$Rr=m}),define(Pe[194],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,A,P=5){const m=A(f=>{const w=typeof f=="string"?f:f.data;let R=this.a.get(C);if(R){R.data.push(w);return}const k=setTimeout(()=>this.flushBuffer(C),P);R={data:[w],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),m.dispose()}},this.a.set(C,R)});return m}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const A=this.a.get(C);A&&(this.a.delete(C),this.b(C,A.data.join("")))}}e.$Prb=y}),define(Pe[195],Re([1,0,13,90,44,5,16,2,155,73,30]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.IconFontDefinition=e.IconContribution=e.$ww=void 0,e.$ww={IconContribution:"base.contributions.icons"};var k;(function(c){function h(i,u){let t=i.defaults;for(;C.ThemeIcon.isThemeIcon(t);){const g=v.getIcon(t.id);if(!g)return;t=g.defaults}return t}c.getDefinition=h})(k||(e.IconContribution=k={}));var l;(function(c){function h(u){return{weight:u.weight,style:u.style,src:u.src.map(t=>({format:t.format,location:t.location.toString()}))}}c.toJSONObject=h;function i(u){const t=g=>(0,P.$If)(g)?g:void 0;if(u&&Array.isArray(u.src)&&u.src.every(g=>(0,P.$If)(g.format)&&(0,P.$If)(g.location)))return{weight:t(u.weight),style:t(u.style),src:u.src.map(g=>({format:g.format,location:m.URI.parse(g.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class ${constructor(){this.a=new A.$Vd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,u,t){const g=this.b[h];if(g){if(u&&!g.description){g.description=u,this.d.properties[h].markdownDescription=`${u} $(${h})`;const S=this.e.enum.indexOf(h);S!==-1&&(this.e.enumDescriptions[S]=u),this.a.fire()}return g}const p={id:h,description:u,defaults:i,deprecationMessage:t};this.b[h]=p;const d={$ref:"#/definitions/icons"};return t&&(d.deprecationMessage=t),u&&(d.markdownDescription=`${u}: $(${h})`),this.d.properties[h]=d,this.e.enum.push(h),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const u=this.f[h];return u||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(g,p)=>g.id.localeCompare(p.id),i=g=>{for(;C.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const t=Object.keys(this.b).map(g=>this.b[g]);for(const g of t.filter(p=>!!p.description).sort(h))u.push(`|<i class="${i(g)}"></i>|${g.id}|${C.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const g of t.filter(p=>!C.ThemeIcon.isThemeIcon(p.defaults)).sort(h))u.push(`|<i class="${i(g)}"></i>|${g.id}|`);return u.join(`
`)}}const v=new $;R.$Hn.add(e.$ww.IconContribution,v);function s(c,h,i,u){return v.registerIcon(c,h,i,u)}e.$xw=s;function a(){return v}e.$yw=a;function r(){const c=(0,M.$0j)();for(const h in c){const i="\\"+c[h].toString(16);v.registerIcon(h,{fontCharacter:i})}}r(),e.$zw="vscode://schemas/icons";const n=R.$Hn.as(w.$In.JSONContribution);n.registerSchema(e.$zw,v.getIconSchema());const o=new y.$fh(()=>n.notifySchemaChanged(e.$zw),200);v.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Aw=s("widget-close",M.$_j.close,(0,f.localize)(2,null)),e.$Bw=s("goto-previous-location",M.$_j.arrowUp,(0,f.localize)(3,null)),e.$Cw=s("goto-next-location",M.$_j.arrowDown,(0,f.localize)(4,null)),e.$Dw=C.ThemeIcon.modify(M.$_j.sync,"spin"),e.$Ew=C.ThemeIcon.modify(M.$_j.loading,"spin")}),define(Pe[196],Re([1,0,5,46,4,14]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProvidedOnAutoForward=e.$Cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bv=e.$Av=void 0,e.$Av=(0,C.$6h)("tunnelService"),e.$Bv=(0,C.$6h)("sharedTunnelsService");var P;(function(a){a.Http="http",a.Https="https"})(P||(e.TunnelProtocol=P={}));var m;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(m||(e.TunnelPrivacyId=m={}));function f(a){return!!a.forwardPort}e.$Cv=f;var w;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function R(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(r)return{address:r[1],port:+r[2]}}e.$Dv=R,e.$Ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(a){return e.$Ev.indexOf(a)>=0}e.$Fv=k,e.$Gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(a){return e.$Gv.indexOf(a)>=0}e.$Hv=l;function $(a,r,n,o){if(n===1)return!1;if(n===2&&l(r)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(c?.length===4&&parseInt(c[1])>=18)return!1}return a<1024}e.$Iv=$;class v{constructor(r,n,o){this.remoteAddress=r,this.localAddress=n,this.b=o,this.a=new y.$Vd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jv=v;let s=class{constructor(r,n){this.k=r,this.l=n,this.a=new y.$Vd,this.onTunnelOpened=this.a.event,this.b=new y.$Vd,this.onTunnelClosed=this.b.event,this.c=new y.$Vd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const r=this.l.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.f=r,r?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.g=r.elevation,this.i=r.privacyOptions,this.h=r.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const r=[],n=Array.from(this.e.values());for(const o of n){const c=Array.from(o.values());for(const h of c){const i=await h.value;i&&typeof i!="string"&&r.push(i)}}return r}async dispose(){for(const r of this.e.values()){for(const{value:n}of r.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);r.clear()}this.e.clear()}setEnvironmentTunnel(r,n,o,c,h){this.q(r,n,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:n,localAddress:o,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,n){(l(r)||k(r))&&(r=e.$Ev[0]);const o=this.s(r,n);if(o)return++o.refcount,o.value}openTunnel(r,n,o,c,h,i=!1,u,t){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${h}.`);const g=this.f??r;if(!g)return;if(n||(n="localhost"),c||(c=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const p=this.t(g,n,o,c,h,i,u,t);return p?p.then(d=>{if(d){if(typeof d=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,o),d}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(d);return(d.tunnelRemoteHost!==n||d.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&d.privacy!==u&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}o(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const n=this.e.get(r.tunnelRemoteHost);if(n){const o=n.get(r.tunnelRemotePort);o&&(o.refcount--,await this.p(r.tunnelRemoteHost,r.tunnelRemotePort,o))}}}}async p(r,n,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${n}.`);const c=o.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(r)&&this.e.get(r).delete(n),c}}async closeTunnel(r,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${n} `);const o=this.e.get(r);if(o&&o.has(n)){const c=o.get(n);c.refcount=0,await this.p(r,n,c)}}q(r,n,o){this.e.has(r)||this.e.set(r,new Map),this.e.get(r).set(n,{refcount:1,value:o})}async r(r,n){const o=this.e.get(r);if(o){const c=o.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&o.delete(n),o.size===0&&this.e.delete(r)}}s(r,n){const o=[r];k(r)?(o.push(...e.$Ev),o.push(...e.$Gv)):l(r)&&o.push(...e.$Gv);const c=o.map(h=>this.e.get(h));for(const h of c){const i=h?.get(n);if(i)return i}}canTunnel(r){return!!R(r)}u(r,n,o,c,h,i,u){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${c}.`);const t=o;this.j.add(t);const g=c===void 0?o:c,p={elevationRequired:h?this.isPortPrivileged(g):!1},d={remoteAddress:{host:n,port:o},localAddressPort:c,privacy:i,public:i?i!==m.Private:void 0,protocol:u},S=r.forwardPort(d,p);return S?(this.q(n,o,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(t)})):this.j.delete(t),S}};e.$Kv=s,e.$Kv=s=Je([He(0,A.$nj),He(1,M.$zi)],s)}),define(Pe[197],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Lv=void 0,e.$Lv=(0,y.$6h)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Pe[198],Re([1,0,11]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=void 0;function M(f){return f.scheme!==y.Schemas.file&&f.scheme!==y.Schemas.vscodeRemote}e.$GK=M;function C(f){if(f.folders.length)return f.folders.every(w=>M(w.uri))?f.folders[0].uri:void 0;if(f.configuration&&M(f.configuration))return f.configuration}e.$HK=C;function A(f){return C(f)?.scheme}e.$IK=A;function P(f){return C(f)?.authority}e.$JK=P;function m(f){return C(f)!==void 0}e.$KK=m}),define(Pe[47],Re([1,0,156,19,50,25,2,4,11]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,m.$6h)("contextService");function w(g){const p=g;return typeof p?.id=="string"&&P.URI.isUri(p.uri)}e.$di=w;function R(g){return typeof g?.id=="string"&&!w(g)&&!l(g)}e.$ei=R,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function k(g,p){if(typeof g=="string"||typeof g>"u")return typeof g=="string"?{id:(0,M.$nc)(g)}:p?e.$fi:e.$gi;const d=g;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$hi=k;function l(g){const p=g;return typeof p?.id=="string"&&P.URI.isUri(p.configPath)}e.$ii=l;function $(g){const p=g;if(p?.uri)return{id:p.id,uri:P.URI.revive(p.uri)};const d=g;if(d?.configPath)return{id:d.id,configPath:P.URI.revive(d.configPath)};if(g?.id)return{id:g.id}}e.$ji=$;var v;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function s(g){const p=g;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.$ki=s;function a(g){const p=g;return!!(p&&typeof p=="object"&&P.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.$li=a;class r{constructor(p,d,S,L,b){this.h=p,this.j=S,this.k=L,this.l=b,this.c=C.$_h.forUris(this.l,()=>!0),this.folders=d}update(p){this.h=p.id,this.k=p.configuration,this.j=p.transient,this.l=p.l,this.folders=p.folders}get folders(){return this.g}set folders(p){this.g=p,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(p){this.k=p}getFolder(p){return p&&this.c.findSubstr(p)||null}n(){this.c=C.$_h.forUris(this.l,()=>!0);for(const p of this.folders)this.c.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=r;class n{constructor(p,d){this.raw=d,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,A.$Hg)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=n;function o(g){return new n({uri:g,index:0,name:(0,A.$Dg)(g)},{uri:g.toString()})}e.$oi=o,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,y.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function c(g,p){return A.$yg.isEqualOrParent(g,p.untitledWorkspacesHome)}e.$ti=c;function h(g){let p;return P.URI.isUri(g)?p=g:p=g.configuration,p?.scheme===f.Schemas.tmp}e.$ui=h,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(g){return g.id===e.$vi}e.$wi=i;function u(g,p){return!c(g,p)&&!h(g)}e.$xi=u;function t(g){return(typeof g=="string"?(0,M.$oc)(g):(0,A.$Fg)(g))===e.$qi}e.$yi=t}),define(Pe[75],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class y{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const A=this.c++;return this.b.set(A,C),this.e(),A}get(C,A){return this.b.has(C)?this.b.get(C)[A]:void 0}delete(C){this.b.delete(C),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$kgc=y}),define(Pe[42],Re([1,0,11,25,4]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=void 0;class A{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new M.$wg(m=>{const f=this.b.get(m.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(m,f){f===null?this.b.delete(m.scheme):this.b.set(m.scheme,f)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$ngc=A,e.$ogc=(0,C.$6h)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0,e.$rN=(0,y.$6h)("IExtHostInitDataService")}),define(Pe[199],Re([1,0,161,14,186,27]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0;let P=class extends C.$yO{constructor(f,w,R){const k=R.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",l=R.remote.isRemote?(0,y.localize)(0,null):f?(0,y.localize)(1,null):(0,y.localize)(2,null);super(w.createLogger(k,{name:l}))}};e.$uic=P,e.$uic=P=Je([He(1,M.$oj),He(2,A.$rN)],P)}),define(Pe[200],Re([1,0,13]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=void 0;class M{constructor(P,m,f){this.h=new Map,this.a=P,this.b=m,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new y.$fh(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of w.values())R.complete()}catch(R){for(const k of w.values())k.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,m){let f=this.f[P];return typeof f>"u"&&(f=m),f}update(P,m){this.f[P]=m;const f=this.h.get(P);if(f!==void 0)return f.p;const w=new y.$qh;return this.h.set(P,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$9gc=M;class C extends M{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,m){super(P.identifier.value,!0,m),this.j=P}}e.$0gc=C}),define(Pe[201],Re([1,0,5,2]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;class C{constructor(P){this.c=P,this.a=new y.$Vd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Vd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,m,f,w){const k=this.c.getNotebookDocument(M.URI.revive(P)).acceptModelChanged(m.value,f,w);this.b.fire(k)}$acceptDirtyStateChanged(P,m){this.c.getNotebookDocument(M.URI.revive(P)).acceptDirty(m)}$acceptModelSaved(P){const m=this.c.getNotebookDocument(M.URI.revive(P));this.a.fire(m.apiNotebook)}}e.$Whc=C}),define(Pe[17],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=void 0,e.$bN=(0,y.$6h)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$cN=M}),define(Pe[202],Re([1,0,23,5]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class C{#e;constructor(P,m){this.b=new M.$Vd,this.onDidChange=this.b.event,this.a=y.$lm.toKey(P.identifier),this.#e=m,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(P){return this.#e.get(this.a,P)}store(P,m){return this.#e.store(this.a,P,m)}delete(P){return this.#e.delete(this.a,P)}}e.$ehc=C}),define(Pe[58],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=e.$Ggc=void 0,e.$Ggc=(0,y.$6h)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.$Hgc=M}),define(Pe[203],Re([1,0,22]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilb=e.$hlb=void 0;class M{constructor(){this.buffers=[]}add(f){let w=this.buffers.indexOf(f);return w<0&&(w=this.buffers.length,this.buffers.push(f)),w}}function C(m,f){if(f.serializeBuffersForPostMessage){const w=new M,k=JSON.stringify(m,($,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(v)};if(ArrayBuffer.isView(v)){const s=A(v);if(s)return{$$vscode_array_buffer_reference$$:!0,index:w.add(v.buffer),view:{type:s,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),l=w.buffers.map($=>{const v=new Uint8Array($);return y.$je.wrap(v)});return{message:k,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$hlb=C;function A(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(m,f){const w=f.map(l=>{const $=new ArrayBuffer(l.byteLength);return new Uint8Array($).set(l.buffer),$}),R=f.length?(l,$)=>{if($&&typeof $=="object"&&$.$$vscode_array_buffer_reference$$){const v=$,{index:s}=v,a=w[s];if(v.view)switch(v.view.type){case 1:return new Int8Array(a,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return $}:void 0;return{message:JSON.parse(m,R),arrayBuffers:w}}e.$ilb=P}),define(Pe[102],Re([1,0,170,16,2,6,4,30,41,11,40,134,31]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=e.$4E=e.$3E=e.EditorsOrder=e.$2E=e.CloseDirection=e.$1E=e.$ZE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.EditorInputCapabilities=e.$QE=e.SaveReason=e.Verbosity=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=void 0,e.$DE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$EE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$FE="workbench.editor.sidebysideEditor",e.$GE="workbench.editors.textDiffEditor",e.$HE="workbench.editors.binaryResourceDiffEditor";var $;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})($||(e.EditorPaneSelectionChangeReason=$={}));var v;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function s(se){const Z=se;return!!Z&&typeof Z.getSelection=="function"&&!!Z.onDidChangeSelection}e.$IE=s;function a(se,Z,V){for(const ne of V.visibleEditorPanes)if(ne.group.id===Z&&se.matches(ne.input))return ne.getViewState()}e.$JE=a;function r(se){if(S(se))return!1;const Z=se;return C.URI.isUri(Z?.resource)}e.$KE=r;function n(se){if(S(se))return!1;const Z=se;return Z?.original!==void 0&&Z.modified!==void 0}e.$LE=n;function o(se){if(S(se))return!1;const Z=se;return!Z||Z.resources&&!Array.isArray(Z.resources)?!1:!!Z.resources||!!Z.multiDiffSource}e.$ME=o;function c(se){if(S(se)||n(se))return!1;const Z=se;return Z?.primary!==void 0&&Z.secondary!==void 0}e.$NE=c;function h(se){if(S(se))return!1;const Z=se;return Z?Z.resource===void 0||Z.resource.scheme===w.Schemas.untitled||Z.forceUntitled===!0:!1}e.$OE=h;function i(se){if(S(se))return!1;const Z=se;return C.URI.isUri(Z?.base?.resource)&&C.URI.isUri(Z?.input1?.resource)&&C.URI.isUri(Z?.input2?.resource)&&C.URI.isUri(Z?.result?.resource)}e.$PE=i;var u;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(u||(e.Verbosity=u={}));var t;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(t||(e.SaveReason=t={}));class g{constructor(){this.a=new Map}registerSource(Z,V){let ne=this.a.get(Z);return ne||(ne={source:Z,label:V},this.a.set(Z,ne)),ne.source}getSourceLabel(Z){return this.a.get(Z)?.label??Z}}e.$QE=new g;var p;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(p||(e.EditorInputCapabilities=p={}));class d extends A.$Tc{}e.$RE=d;function S(se){return se instanceof d}e.$SE=S;function L(se){const Z=se;return C.URI.isUri(Z?.preferredResource)}function b(se){const Z=se;return S(Z?.primary)&&S(Z?.secondary)}e.$TE=b;function E(se){const Z=se;return S(Z?.modified)&&S(Z?.original)}e.$UE=E;function D(se,Z,V,ne,Ae){return be(ne,[(0,k.$Pi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const Le={...V,limits:{size:Number.MAX_VALUE}};se.openEditor(Z,Le)}}),(0,k.$Pi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>Ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$VE=D;function T(se){return S(se?.editor)}e.$WE=T;function O(se){const Z=se;return T(se)&&Z?.group!==void 0}e.$XE=O;function G(se){const Z=se;return typeof Z?.groupId=="number"&&S(Z.editor)}e.$YE=G;var q;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var U;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var I;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(I||(e.SideBySideEditor=I={}));class N{getOriginalUri(Z,V){if(!Z)return;if(i(Z))return e.$1E.getOriginalUri(Z.result,V);if(V?.supportSideBySide){const{primary:Ae,secondary:Le}=this.a(Z);if(Ae&&Le){if(V?.supportSideBySide===I.BOTH)return{primary:this.getOriginalUri(Ae,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===I.ANY)return this.getOriginalUri(Ae,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Le,{filterByScheme:V.filterByScheme});Z=V.supportSideBySide===I.PRIMARY?Ae:Le}}if(n(Z)||o(Z)||c(Z)||i(Z))return;const ne=L(Z)?Z.preferredResource:Z.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}a(Z){return b(Z)||c(Z)?{primary:Z.primary,secondary:Z.secondary}:E(Z)||n(Z)?{primary:Z.modified,secondary:Z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Z,V){if(!Z)return;if(i(Z))return e.$1E.getCanonicalUri(Z.result,V);if(V?.supportSideBySide){const{primary:Ae,secondary:Le}=this.a(Z);if(Ae&&Le){if(V?.supportSideBySide===I.BOTH)return{primary:this.getCanonicalUri(Ae,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===I.ANY)return this.getCanonicalUri(Ae,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme});Z=V.supportSideBySide===I.PRIMARY?Ae:Le}}if(n(Z)||o(Z)||c(Z)||i(Z))return;const ne=Z.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}b(Z,V){if(Array.isArray(V)){if(V.some(ne=>Z.scheme===ne))return Z}else if(V===Z.scheme)return Z}}var W;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function ae(se,Z,V,ne){if(!se.isSticky(Z))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return V===W.MOUSE||V===W.KEYBOARD;case"mouse":return V===W.MOUSE;case"keyboard":return V===W.KEYBOARD}return!1}e.$ZE=ae,e.$1E=new N;var de;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(de||(e.CloseDirection=de={}));class we{constructor(){this.c=new Map,this.d=new Map}start(Z){const V=this.a=Z.get(P.$5h);for(const[ne,Ae]of this.c)this.e(ne,Ae,V);this.c.clear()}e(Z,V,ne){const Ae=ne.createInstance(V);this.d.set(Z,Ae)}registerFileEditorFactory(Z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Z}getFileEditorFactory(){return(0,M.$Tf)(this.b)}registerEditorSerializer(Z,V){if(this.c.has(Z)||this.d.has(Z))throw new Error(`A editor serializer with type ID '${Z}' was already registered.`);return this.a?this.e(Z,V,this.a):this.c.set(Z,V),(0,A.$Rc)(()=>{this.c.delete(Z),this.d.delete(Z)})}getEditorSerializer(Z){return this.d.get(typeof Z=="string"?Z:Z.typeId)}}m.$Hn.add(e.$DE.EditorFactory,new we);async function ke(se,Z,V){return!se||!se.length?[]:await Promise.all(se.map(async ne=>{const Ae=C.URI.revive(ne.fileUri);if(!Ae){V.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Z.canHandleResource(Ae)){V.info("Cannot resolve the path because it cannot be handled",ne);return}let Ce=ne.exists,ce=ne.type;if(typeof Ce!="boolean"||typeof ce!="number")try{ce=(await Z.stat(Ae)).isDirectory?f.FileType.Directory:f.FileType.Unknown,Ce=!0}catch(J){V.error(J),Ce=!1}if(!Ce&&ne.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ne);return}if(ce===f.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ne);return}const te={...ne.options,pinned:!0};return Ce?{resource:Ae,options:te}:{resource:Ae,options:te,forceUntitled:!0}}))}e.$2E=ke;var ue;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function pe(se){const Z=se;if(!Z)return!1;const V=Z;if(V.modified)return pe(V.modified);const ne=Z;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$3E=pe;function ie(se){return(0,R.$Ri)(se)}e.$4E=ie;function be(se,Z,V){const ne=(0,R.$Si)(se,Z);return ne.forceMessage=V?.forceMessage,ne.forceSeverity=V?.forceSeverity,ne.allowDialog=V?.allowDialog,ne}e.$5E=be}),define(Pe[204],Re([1,0,5,171,4,6,28,30,18,26,90,195]),function(ge,e,y,M,C,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$$E=e.ViewContentGroups=e.$0E=e.$9E=e.ViewContainerLocation=e.Extensions=e.$8E=e.$7E=e.$6E=void 0,e.$6E="views",e.$7E=(0,M.localize)(0,null),e.$8E=(0,k.$xw)("default-view-icon",R.$_j.window,(0,M.localize)(1,null));var l;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var $;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$9E=[0,1,2];function v(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$0E=v;class s extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new y.$Vd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Vd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(t,g,p){const d=this.get(t.id);if(d)return d;const S=t;return S.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,P.$xc)(this.g,g,[]).push(S),p?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:g}),S}deregisterViewContainer(t){for(const g of this.g.keys()){const p=this.g.get(g),d=p?.indexOf(t);if(d!==-1){p?.splice(d,1),p.length===0&&this.g.delete(g),this.f.fire({viewContainer:t,viewContainerLocation:g});return}}}get(t){return this.all.filter(g=>g.id===t)[0]}getViewContainers(t){return[...this.g.get(t)||[]]}getViewContainerLocation(t){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(p=>p?.id===t.id).length>0)[0]}getDefaultViewContainer(t){return this.h.find(g=>this.getViewContainerLocation(g)===t)}}m.$Hn.add(l.ViewContainersRegistry,new s);var a;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(a||(e.ViewContentGroups=a={}));function r(u,t){const g=u.group??a.More,p=t.group??a.More;return g!==p?g.localeCompare(p):(u.order??5)-(t.order??5)}class n extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new y.$Vd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Vd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Vd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Vd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new P.$Gc}registerViews(t,g){this.registerViews2([{views:t,viewContainer:g}])}registerViews2(t){t.forEach(({views:g,viewContainer:p})=>this.r(g,p)),this.c.fire(t)}deregisterViews(t,g){const p=this.s(t,g);p.length&&this.f.fire({views:p,viewContainer:g})}moveViews(t,g){for(const p of this.m.keys())if(p!==g){const d=this.s(t,p);d.length&&(this.r(d,g),this.g.fire({views:d,from:p,to:g}))}}getViews(t){return this.m.get(t)||[]}getView(t){for(const g of this.j){const p=(this.m.get(g)||[]).filter(d=>d.id===t)[0];if(p)return p}return null}getViewContainer(t){for(const g of this.j)if((this.m.get(g)||[]).filter(d=>d.id===t)[0])return g;return null}registerViewWelcomeContent(t,g){return this.n.add(t,g),this.h.fire(t),(0,A.$Rc)(()=>{this.n.delete(t,g),this.h.fire(t)})}registerViewWelcomeContent2(t,g){const p=new Map;for(const[d,S]of g)this.n.add(t,S),p.set(d,(0,A.$Rc)(()=>{this.n.delete(t,S),this.h.fire(t)}));return this.h.fire(t),p}getViewWelcomeContent(t){const g=[];return this.n.forEach(t,p=>g.push(p)),g.sort(r)}r(t,g){let p=this.m.get(g);p||(p=[],this.m.set(g,p),this.j.push(g));for(const d of t){if(this.getView(d.id)!==null)throw new Error((0,M.localize)(2,null,d.id));p.push(d)}}s(t,g){const p=this.m.get(g);if(!p)return[];const d=[],S=[];for(const L of p)t.includes(L)?d.push(L):S.push(L);return d.length&&(S.length?this.m.set(g,S):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),d}}m.$Hn.add(l.ViewsRegistry,new n),e.$$E=(0,C.$6h)("viewDescriptorService");var o;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var c;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(t,g){this.c=!1,this.d=!1,(0,w.$yn)(this,t),this.d=!!g,this.resolve=async p=>{if(g&&!this.c){const d=await g(p);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$_E=h;class i extends Error{constructor(t){super((0,M.localize)(3,null,t)),this.name="NoTreeViewError"}static is(t){return t.name==="NoTreeViewError"}}e.$aF=i}),define(Pe[205],Re([1,0,2,29,4]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$iF=e.$hF=void 0;function A(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof y.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(M.$Us.isIRange)}e.$hF=A;function P(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(A)}e.$iF=P;var m;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var f;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(f||(e.ChatAgentCopyKind=f={})),e.$jF=(0,C.$6h)("IChatService")}),define(Pe[206],Re([1,0,5,13,172]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlb=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new y.$Vd,this.n=new y.$Vd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,f,w,R){const k={command:m};if(f&&Object.keys(f).length>0&&(k.arguments=f),this.s("request",k),typeof R=="number"){const l=setTimeout(()=>{clearTimeout(l);const $=this.f.get(k.seq);if($){this.f.delete(k.seq);const v={type:"response",seq:0,request_seq:k.seq,success:!1,command:m,message:(0,C.localize)(0,null,R,m)};$(v)}},R)}return w&&this.f.set(k.seq,w),k.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,f){return m.type!=="event"||f.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,M.$7g)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const f=m,w=this.f.get(f.request_seq);w&&(this.f.delete(f.request_seq),w(f));break}}}}s(m,f){f.type=m,f.seq=this.d++,this.sendMessage(f)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((f,w)=>m.set(w,f)),await(0,M.$7g)(500),m.forEach((f,w)=>{f({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Nlb=A}),define(Pe[207],Re([1,0,173,35,4]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$NH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$MH=e.MemoryRangeType=e.$LH=e.State=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG="workbench.view.debug",e.$JG="workbench.debug.variablesView",e.$KG="workbench.debug.watchExpressionsView",e.$LG="workbench.debug.callStackView",e.$MG="workbench.debug.loadedScriptsView",e.$NG="workbench.debug.breakPointsView",e.$OG="workbench.debug.disassemblyView",e.$PG="workbench.panel.repl",e.$QG="workbench.panel.repl.view",e.$RG=new M.$kj("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$SG=new M.$kj("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$TG=new M.$kj("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$UG="debugUx",e.$VG=new M.$kj(e.$UG,"default",{type:"string",description:y.localize(3,null)}),e.$WG=new M.$kj("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$XG=new M.$kj("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$YG=new M.$kj("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$ZG=new M.$kj("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$1G=new M.$kj("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$2G=new M.$kj("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$3G=new M.$kj("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$4G=new M.$kj("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$5G=new M.$kj("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$6G=new M.$kj("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$7G=new M.$kj("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$8G=new M.$kj("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$9G=new M.$kj("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$0G=new M.$kj("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$$G=new M.$kj("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$_G=new M.$kj("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$aH=new M.$kj("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$bH=new M.$kj("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$cH=new M.$kj("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$dH=new M.$kj("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$eH=new M.$kj("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$fH=new M.$kj("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$gH=new M.$kj("focusedSessionIsNoDebug",!1,{type:"boolean",description:y.localize(26,null)}),e.$hH=new M.$kj("stepBackSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$iH=new M.$kj("restartFrameSupported",!1,{type:"boolean",description:y.localize(28,null)}),e.$jH=new M.$kj("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(29,null)}),e.$kH=new M.$kj("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$lH=new M.$kj("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(31,null)}),e.$mH=new M.$kj("breakpointsExist",!1,{type:"boolean",description:y.localize(32,null)}),e.$nH=new M.$kj("debuggersAvailable",!1,{type:"boolean",description:y.localize(33,null)}),e.$oH=new M.$kj("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(34,null)}),e.$pH=new M.$kj("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(35,null)}),e.$qH=new M.$kj("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$rH=new M.$kj("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$sH=new M.$kj("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$tH=new M.$kj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$uH=new M.$kj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$vH=new M.$kj("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$wH=new M.$kj("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(42,null)}),e.$xH=new M.$kj("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(43,null)}),e.$yH=new M.$kj("variableIsReadonly",!1,{type:"boolean",description:y.localize(44,null)}),e.$zH=new M.$kj("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(45,null)}),e.$AH=new M.$kj("multiSessionRepl",!1,{type:"boolean",description:y.localize(46,null)}),e.$BH=new M.$kj("multiSessionDebug",!1,{type:"boolean",description:y.localize(47,null)}),e.$CH=new M.$kj("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(48,null)}),e.$DH=new M.$kj("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(49,null)}),e.$EH=new M.$kj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(50,null)}),e.$FH=new M.$kj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(51,null)});const A=l=>y.localize(52,null,l);e.$GH=A,e.$HH="editor.contrib.debug",e.$IH="editor.contrib.breakpoint",e.$JH="debug",e.$KH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(53,null)};var P;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(P||(e.State=P={}));function m(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$LH=m;var f;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(f||(e.MemoryRangeType=f={})),e.$MH="vscode-debug-memory";var w;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var R;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$NH=(0,C.$6h)("debugService");var k;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE",l[l.TRIGGER_POINT=3]="TRIGGER_POINT"})(k||(e.BreakpointWidgetContext=k={}))}),define(Pe[208],Re([1,0,12,2,19,26,11,29,20,18]),function(ge,e,y,M,C,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=void 0;const R=/{([^}]+)}/g;function k(L,b,E){return L.replace(R,function(D,T){return b&&T.length>0&&T[0]!=="_"?D:E&&E.hasOwnProperty(T)?E[T]:D})}e.$0F=k;function l(L){const b={};for(const E of Object.keys(L))E.startsWith("!")||(b[E]=L[E]);return b}e.$$F=l;function $(L){return L.configuration.request==="attach"&&!v(L)&&(!L.parentSession||$(L.parentSession))}e.$_F=$;function v(L){let b=L.configuration.type;if(b)return b==="vslsShare"&&(b=L.configuration.adapterProxy.configuration.type),(0,y.$_e)(b,"extensionhost")||(0,y.$_e)(b,"pwa-extensionhost")?L:L.parentSession?v(L.parentSession):void 0}e.$aG=v;function s(L){return L.type&&(L.label||L.program||L.runtime)}e.$bG=s;function a(L,b,E){let D,T=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=O.exec(L);){const q=G.index+1,U=q+G[0].length;if(q<=b&&U>=E){D=G[0],T=q;break}}if(D){const q=/\w+/g;let U=null;for(;(U=q.exec(D))&&!(U.index+1+T+U[0].length>=E););U&&(D=D.substring(0,q.lastIndex))}return D?{start:T,end:T+D.length-1}:{start:0,end:0}}e.$cG=a;async function r(L,b,E,D){if(L.evaluatableExpressionProvider.has(b)){const T=L.evaluatableExpressionProvider.ordered(b),O=(0,w.$Hb)(await Promise.all(T.map(async G=>{try{return await G.provideEvaluatableExpression(b,E,D??f.CancellationToken.None)}catch{return}})));if(O.length>0){let G=O[0].expression;const q=O[0].range;return G||(G=b.getLineContent(E.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:G}}}else{const T=b.getLineContent(E.lineNumber),{start:O,end:G}=a(T,E.column,E.column),q=T.substring(O-1,G);return{matchingExpression:q,range:new m.$Us(E.lineNumber,O,E.lineNumber,O+q.length)}}return null}e.$dG=r;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(L){return!!(L&&L.match(n))}e.$eG=o;function c(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(o(L.path))return M.URI.parse(L.path);if((0,C.$ic)(L.path))return M.URI.file(L.path)}return L.path}function h(L){if(typeof L.path=="object"){const b=M.URI.revive(L.path);if(b)return b.scheme===P.Schemas.file?b.fsPath:b.toString()}return L.path}function i(L,b){const E=b?c:h,D=(0,A.$vn)(L);return t(D,(T,O)=>{T&&O&&(O.path=E(O))}),D}e.$fG=i;function u(L,b){const E=b?c:h,D=(0,A.$vn)(L);return t(D,(T,O)=>{!T&&O&&(O.path=E(O))}),D}e.$gG=u;function t(L,b){switch(L.type){case"event":{const E=L;switch(E.event){case"output":b(!1,E.body.source);break;case"loadedSource":b(!1,E.body.source);break;case"breakpoint":b(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=L;switch(E.command){case"setBreakpoints":b(!0,E.arguments.source);break;case"breakpointLocations":b(!0,E.arguments.source);break;case"source":b(!0,E.arguments.source);break;case"gotoTargets":b(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(D=>b(!1,D));break;default:break}break}case"response":{const E=L;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(D=>b(!1,D.source));break;case"loadedSources":E.body.sources.forEach(D=>b(!1,D));break;case"scopes":E.body.scopes.forEach(D=>b(!1,D.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(D=>b(!1,D.source));break;case"setBreakpoints":E.body.breakpoints.forEach(D=>b(!1,D.source));break;case"disassemble":E.body?.instructions.forEach(T=>b(!1,T.location));break;default:break}break}}}function g(L){return L.filter(b=>!b.presentation?.hidden).sort((b,E)=>b.presentation?E.presentation?b.presentation.group?E.presentation.group?b.presentation.group!==E.presentation.group?b.presentation.group.localeCompare(E.presentation.group):p(b.presentation.order,E.presentation.order):-1:E.presentation.group?1:p(b.presentation.order,E.presentation.order):-1:E.presentation?1:0)}e.$hG=g;function p(L,b){return typeof L!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:L-b}async function d(L,b){const E=L.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(E!=="none"&&(await b.saveAll(),E==="allEditorsInActiveGroup")){const D=b.activeEditorPane;D&&D.input.resource?.scheme===P.Schemas.untitled&&await b.save({editor:D.input,groupId:D.group.id})}await L.reloadConfiguration()}e.$iG=d;const S=(L,b)=>!L||!b?L===b:L.name===b.name&&L.path===b.path&&L.sourceReference===b.sourceReference;e.$jG=S}),define(Pe[209],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$fJ=(0,y.$6h)("INotebookExecutionService")}),define(Pe[210],Re([1,0,6,29,144,94]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WQb=void 0;class P extends y.$Tc{constructor(f,w,R){super(),this._source=f,this.b=w,this.c=R,this.a=void 0}f(f){const w=f.getLineCount();return new M.$Us(1,1,w,this.g(f,w))}g(f,w){if(w<1||w>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const f=new C.$cC;f.acceptChunk(this._source);const w=f.finish(!0),{textBuffer:R,disposable:k}=w.create(1);this.b=R,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const w=new C.$cC;w.acceptChunk(f);const R=w.finish(!0),{textBuffer:k,disposable:l}=R.create(1);return this.B(l),k})),this.a}findInInputs(f){const R=new A.$3B(f,!1,!1,null).parseSearchRequest();if(!R)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,R,!0,5e3)}findInOutputs(f){const R=new A.$3B(f,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),R,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$WQb=P}),define(Pe[48],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(A){A.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(P,m,f=P.parent){if(P._isRoot)return new C([m]);const w=[P.id];for(let R=f;R&&R.id!==m;R=R.parent)w.push(R.id);return w.push(m),new C(w.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const m=P.indexOf("\0");return m===-1?P:P.slice(0,m)}static fromString(P){return new C(P.split("\0"))}static join(P,m){return new C([...P.path,m])}static joinToString(P,m){return P.toString()+"\0"+m}static parentId(P){const m=P.lastIndexOf("\0");return m===-1?void 0:P.slice(0,m)}static localId(P){const m=P.lastIndexOf("\0");return m===-1?P:P.slice(m+1)}static isChild(P,m){return m.startsWith(P)&&m[P.length]==="\0"}static compare(P,m){return P===m?0:C.isChild(P,m)?2:C.isChild(m,P)?3:1}constructor(P,m=P.length){if(this.path=P,this.d=m,P.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new C(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new C(this.path,P)}compare(P){if(typeof P=="string")return C.compare(this.toString(),P);for(let m=0;m<P.d&&m<this.d;m++)if(P.path[m]!==this.path[m])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.$2J=C}),define(Pe[59],Re([1,0,2,92,29,48]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$9J=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$8J=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$7J=e.$6J=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$5J=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$4J=e.$3J=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var P;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(P||(e.TestResultState=P={}));var m;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var f;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$3J=[2,4,8,16,32,64];const w=I=>"runId"in I;e.$4J=w;var R;(function(I){I.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),I.deserialize=(N,W)=>({range:C.$Us.lift(W.range),uri:N.asCanonicalUri(y.URI.revive(W.uri))})})(R||(e.IRichLocation=R={}));var k;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(I){I.serialize=N=>({message:N.message,type:0,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&R.serialize(N.location)}),I.deserialize=(N,W)=>({message:W.message,type:0,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&R.deserialize(N,W.location)})})(l||(e.ITestErrorMessage=l={}));const $=(I,N)=>`${N?"s":"e"}${I}`;e.$5J=$;var v;(function(I){I.serialize=N=>({message:N.message,type:1,offset:N.offset,length:N.length,location:N.location&&R.serialize(N.location)}),I.deserialize=(N,W)=>({message:W.message,type:1,offset:W.offset,length:W.length,location:W.location&&R.deserialize(N,W.location)})})(v||(e.ITestOutputMessage=v={}));var s;(function(I){I.serialize=N=>N.type===0?l.serialize(N):v.serialize(N),I.deserialize=(N,W)=>W.type===0?l.deserialize(N,W):v.deserialize(N,W)})(s||(e.ITestMessage=s={}));var a;(function(I){I.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),I.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(s.serialize)}),I.deserialize=(N,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(ae=>s.deserialize(N,ae))})})(a||(e.ITestTaskState=a={}));const r="\0",n=(I,N)=>I+r+N;e.$6J=n;const o=I=>{const N=I.indexOf(r);return{ctrlId:I.slice(0,N),tagId:I.slice(N+1)}};e.$7J=o;var c;(function(I){I.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),I.deserialize=(N,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?N.asCanonicalUri(y.URI.revive(W.uri)):void 0,range:W.range?C.$Us.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(c||(e.ITestItem=c={}));var h;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(I){I.serialize=N=>({expand:N.expand,item:c.serialize(N.item)}),I.deserialize=(N,W)=>({controllerId:A.$2J.root(W.item.extId),expand:W.expand,item:c.deserialize(N,W.item)})})(i||(e.InternalTestItem=i={}));var u;(function(I){I.serialize=N=>{let W;return N.item&&(W={},N.item.label!==void 0&&(W.label=N.item.label),N.item.tags!==void 0&&(W.tags=N.item.tags),N.item.busy!==void 0&&(W.busy=N.item.busy),N.item.uri!==void 0&&(W.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(W.range=N.item.range?.toJSON()),N.item.description!==void 0&&(W.description=N.item.description),N.item.error!==void 0&&(W.error=N.item.error),N.item.sortText!==void 0&&(W.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:W}},I.deserialize=N=>{let W;return N.item&&(W={},N.item.label!==void 0&&(W.label=N.item.label),N.item.tags!==void 0&&(W.tags=N.item.tags),N.item.busy!==void 0&&(W.busy=N.item.busy),N.item.range!==void 0&&(W.range=N.item.range?C.$Us.lift(N.item.range):null),N.item.description!==void 0&&(W.description=N.item.description),N.item.error!==void 0&&(W.error=N.item.error),N.item.sortText!==void 0&&(W.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:W}}})(u||(e.ITestItemUpdate=u={}));const t=(I,N)=>{N.expand!==void 0&&(I.expand=N.expand),N.item!==void 0&&(I.item=I.item?Object.assign(I.item,N.item):N.item)};e.$8J=t;var g;(function(I){I.serializeWithoutMessages=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(a.serializeWithoutMessages)}),I.serialize=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(a.serialize)}),I.deserialize=(N,W)=>({...i.deserialize(N,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(ae=>a.deserialize(N,ae)),retired:!0})})(g||(e.TestResultItem=g={}));var p;(function(I){I.empty=()=>({covered:0,total:0}),I.sum=(N,W)=>{N.covered+=W.covered,N.total+=W.total}})(p||(e.ICoveredCount=p={}));var d;(function(I){I.serialize=N=>({statement:N.statement,branch:N.branch,function:N.function,details:N.details?.map(E.serialize),uri:N.uri.toJSON()}),I.deserialize=(N,W)=>({statement:W.statement,branch:W.branch,function:W.function,details:W.details?.map(E.deserialize),uri:N.asCanonicalUri(y.URI.revive(W.uri))})})(d||(e.IFileCoverage=d={}));function S(I){return{...I,location:I.location?.toJSON()}}function L(I){return I.location=I.location?M.$Ts.isIPosition(I.location)?M.$Ts.lift(I.location):C.$Us.lift(I.location):void 0,I}e.$9J=3;var b;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement",I[I.Branch=2]="Branch"})(b||(e.DetailType=b={}));var E;(function(I){I.serialize=N=>N.type===0?T.serialize(N):O.serialize(N),I.deserialize=N=>N.type===0?T.deserialize(N):O.deserialize(N)})(E||(e.CoverageDetails=E={}));var D;(function(I){I.serialize=S,I.deserialize=L})(D||(e.IBranchCoverage=D={}));var T;(function(I){I.serialize=S,I.deserialize=L})(T||(e.IFunctionCoverage=T={}));var O;(function(I){I.serialize=N=>({...S(N),branches:N.branches?.map(D.serialize)}),I.deserialize=N=>({...L(N),branches:N.branches?.map(D.deserialize)})})(O||(e.IStatementCoverage=O={}));var G;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var q;(function(I){I.deserialize=(N,W)=>W.op===0?{op:W.op,item:i.deserialize(N,W.item)}:W.op===1?{op:W.op,item:u.deserialize(W.item)}:W.op===2?{op:W.op,uri:N.asCanonicalUri(y.URI.revive(W.uri)),docv:W.docv}:W,I.serialize=N=>N.op===0?{op:N.op,item:i.serialize(N.item)}:N.op===1?{op:N.op,item:u.serialize(N.item)}:N})(q||(e.TestsDiffOp=q={}));class U{constructor(N){this.k=N,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(N){const W=this.v();for(const ae of N)switch(ae.op){case 0:this.l(i.deserialize(this.k,ae.item),W);break;case 1:this.o(u.deserialize(ae.item),W);break;case 3:this.p(ae.itemId,W);break;case 5:this.q(ae.itemId);break;case 4:this.updatePendingRoots(ae.amount);break;case 6:this.c.set(ae.tag.id,ae.tag);break;case 7:this.c.delete(ae.id);break}W.complete?.()}l(N,W){const ae=A.$2J.parentId(N.item.extId)?.toString();let de;if(!ae)de=this.w(N),this.g.add(de),this.f.set(N.item.extId,de);else if(this.f.has(ae)){const we=this.f.get(ae);we.children.add(N.item.extId),de=this.w(N,we),this.f.set(N.item.extId,de)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return W.add?.(de),N.expand===2&&this.h++,de}o(N,W){const ae=this.f.get(N.extId);if(ae)return N.expand!==void 0&&(ae.expand===2&&this.h--,N.expand===2&&this.h++),(0,e.$8J)(ae,N),W.update?.(ae),ae}p(N,W){const ae=this.f.get(N);if(!ae)return;const de=A.$2J.parentId(ae.item.extId)?.toString();de?this.f.get(de).children.delete(ae.item.extId):this.g.delete(ae);const we=[[N]];for(;we.length;)for(const ke of we.pop()){const ue=this.f.get(ke);ue&&(we.push(ue.children),this.f.delete(ke),W.remove?.(ue,ue!==ae),ue.expand===2&&this.h--)}}q(N){}updatePendingRoots(N){this.j+=N}v(){return{}}}e.$0J=U}),define(Pe[76],Re([1,0,13,5,6,54,59,48]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.TestItemEventOp=void 0;var f;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const w=(n,o)=>n===o,k=Object.entries({range:(n,o)=>n===o?!0:!n||!o?!1:n.equalsRange(o),busy:w,label:w,description:w,error:w,sortText:w,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.includes(c)))}),l=(n,o)=>{let c;for(const[h,i]of k)i(n[h],o[h])||(c?c[h]=o[h]:c={[h]:o[h]});return c};class $ extends C.$Tc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new y.$fh(()=>this.flushDiff(),200)),this.g=this.B(new M.$Vd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(o){this.h=o;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===o.uri){c.docv=o.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===o.item.extId){(0,P.$8J)(c.item,o.item);return}if(c.op===0&&c.item.item.extId===o.item.extId){(0,P.$8J)(c.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,c){const h=this.tree.get(o);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,c-1):i.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(o,c){switch(c.op){case 3:this.O(m.$2J.joinToString(o.fullId,c.id));break;case 0:this.z(c.item,o);break;case 5:for(const h of c.ops)this.w(o,h);break;case 1:this.C(c.new,c.old,o.fullId.toString());break;case 2:this.J(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:c.update}});break;case 6:this.y(o.actual.uri);break;default:(0,A.$6c)(c)}}y(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}z(o,c){const h=m.$2J.fromExtHostTestItem(o,this.root.id,c?.actual),i=this.s.getApiFor(o);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(o.id);let u=this.tree.get(h.toString());if(!u){u={fullId:h,actual:o,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},o.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(o,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(o)}}),this.I(o,u,c);return}if(u.actual===o){this.H(o,u,c);return}if(u.actual.uri?.toString()!==o.uri?.toString())return this.O(h.toString()),this.z(o,c);const t=this.s.getChildren(u.actual),g=u.actual,p=l(this.s.toITestItem(g),this.s.toITestItem(o));this.s.getApiFor(g).listener=void 0,u.actual=o,u.expand=0,p&&(p.hasOwnProperty("tags")&&(this.C(o.tags,g.tags,h.toString()),delete p.tags),this.w(u,{op:4,update:p})),this.I(o,u,c);for(const[d,S]of t)this.s.getChildren(o).get(S.id)||this.O(m.$2J.joinToString(h,S.id));this.y(u.actual.uri)}C(o,c,h){const i=new Set(c.map(u=>u.id));for(const u of o)i.delete(u.id)||this.D(u);this.pushDiff({op:1,item:{extId:h,item:{tags:o.map(u=>(0,P.$6J)(this.s.controllerId,u.id))}}}),i.forEach(this.F,this)}D(o){const c=this.j.get(o.id);c?c.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.$6J)(this.s.controllerId,o.id)}}))}F(o){const c=this.j.get(o);c&&!--c.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,P.$6J)(this.s.controllerId,o)}))}G(o,c){this.s.getApiFor(o).parent=c&&c.actual!==this.root?c.actual:void 0}H(o,c,h){this.G(o,h);const i=this.s.getApiFor(o);i.parent=h?.actual,i.listener=u=>this.w(c,u),this.J(c)}I(o,c,h){this.H(o,c,h);for(const[i,u]of this.s.getChildren(o))this.z(u,c)}J(o){let c;this.h?o.resolveBarrier?c=o.resolveBarrier.isOpen()?3:2:c=o.actual.canResolveChildren?1:0:c=0,c!==o.expand&&(o.expand=c,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:c}}),c===1&&o.expandLevels!==void 0&&this.M(o))}L(o,c){if(c<0)return;const h=[];for(const[i,u]of this.s.getChildren(o.actual)){const t=this.expand(m.$2J.joinToString(o.fullId,u.id),c);(0,y.$Sg)(t)&&h.push(t)}if(h.length)return Promise.all(h).then(()=>{})}M(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const u=new y.$5g;return u.open(),u}o.expand=2,this.N(o);const c=o.resolveBarrier=new y.$5g,h=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let i;try{i=this.h(o.actual===this.root?void 0:o.actual)}catch(u){h(u)}return(0,y.$Sg)(i)?i.catch(h).then(()=>{c.open(),this.J(o)}):(c.open(),this.J(o)),o.resolveBarrier}N(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}O(o){const c=this.tree.get(o);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const u of i.actual.tags)this.F(u.id);this.tree.delete(i.fullId.toString());for(const[u,t]of this.s.getChildren(i.actual))h.push(this.tree.get(m.$2J.joinToString(i.fullId,t.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$4M=$;class v extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$5M=v;class s extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$6M=s;class a extends Error{constructor(o,c,h){super(`TestItem with ID "${o}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$7M=a;const r=(n,o,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,u){for(const t of h.values())i.call(u,t,this)},[Symbol.iterator](){return h.entries()},replace(i){const u=new Map,t=new Set(h.keys()),g={op:5,ops:[]};for(const p of i){if(!(p instanceof c))throw new s(p.id);const d=o(p).controllerId;if(d!==n.controllerId)throw new a(p.id,d,n.controllerId);if(u.has(p.id))throw new v(p.id);u.set(p.id,p),t.delete(p.id),g.ops.push({op:0,item:p})}for(const p of t.keys())g.ops.push({op:3,id:p});n.listener?.(g),h=u},add(i){if(!(i instanceof c))throw new s(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$8M=r}),define(Pe[103],Re([1,0,76]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0;const M=new WeakMap,C=(P,m)=>{const f={controllerId:m};return M.set(P,f),f};e.$9M=C;const A=P=>{const m=M.get(P);if(!m)throw new y.$6M(P?.id||"<unknown>");return m};e.$0M=A}),define(Pe[77],Re([1,0,11,2]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Evb=e.$Dvb=e.$Cvb=e.$Bvb=e.$Avb=void 0,e.$Avb="vscode-cdn.net",e.$Bvb=`vscode-resource.${e.$Avb}`,e.$Cvb=`'self' https://*.${e.$Avb}`;function C(m,f){return m.scheme===y.Schemas.http||m.scheme===y.Schemas.https?m:(f&&f.authority&&f.isRemote&&m.scheme===y.Schemas.file&&(m=M.URI.from({scheme:y.Schemas.vscodeRemote,authority:f.authority,path:m.path})),M.URI.from({scheme:y.Schemas.https,authority:`${m.scheme}+${A(m.authority)}.${e.$Bvb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Dvb=C;function A(m){return m.replace(/./g,f=>{const w=f.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?f:"-"+w.toString(16).padStart(4,"0")})}function P(m){return m.replace(/-([0-9a-f]{4})/g,(f,w)=>String.fromCharCode(parseInt(w,16)))}e.$Evb=P}),define(Pe[211],Re([1,0,5,6,77]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class A{constructor(m,f,w){this.d=m,this.e=f,this.f=w,this.a=0,this.b=new M.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const R=f.getVisibleTextEditors();for(const k of this.c.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,f,w,R,k){let l;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===m){l=o;break}if(!l)throw new Error("not a visible editor");const $=this,v=this.a++,s=new y.$Vd,a=new y.$Vd,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,C.$Dvb)(o,$.f)}get cspSource(){return C.$Cvb}set options(o){this.b=o,$.d.$setOptions(v,o)}get options(){return this.b}set html(o){this.a=o,$.d.$setHtml(v,o)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(o){return $.d.$postMessage(v,o)}},n=new class{constructor(){this.editor=m,this.line=f,this.height=w,this.webview=r,this.onDidDispose=a.event}dispose(){$.c.has(v)&&($.c.delete(v),$.d.$disposeEditorInset(v),a.fire(),a.dispose(),s.dispose())}};return this.d.$createEditorInset(v,l.id,l.value.document.uri,f+1,w,R||{},k.identifier,k.extensionLocation),this.c.set(v,{editor:m,inset:n,onDidReceiveMessage:s}),n}$onDidDispose(m){const f=this.c.get(m);f&&f.inset.dispose()}$onDidReceiveMessage(m,f){this.c.get(m)?.onDidReceiveMessage.fire(f)}}e.$Egc=A}),define(Pe[212],Re([1,0,4]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=e.VariableKind=e.$ZN=void 0,e.$ZN=(0,y.$6h)("configurationResolverService");var M;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class C extends Error{constructor(P,m){super(m),this.variable=P}}e.$1N=C}),define(Pe[213],Re([1,0,19,74,16,26,21,95,176,212,12]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor($,v,s,a){this.h=new Map,this.a=$,this.b=v,this.g=s,a&&(this.c=a.then(r=>this.i(r)))}i($){if(P.$i){const v=Object.create(null);return Object.keys($).forEach(s=>{v[s.toLowerCase()]=$[s]}),v}return $}resolveWithEnvironment($,v,s){return this.l({env:this.i($),userHome:void 0},v?v.uri:void 0,s)}async resolveAsync($,v){const s={env:await this.c,userHome:await this.g};return this.l(s,$?$.uri:void 0,v)}async j($,v,s,a){const r=A.$vn(v);P.$i&&r.windows?Object.keys(r.windows).forEach(o=>r[o]=r.windows[o]):P.$j&&r.osx?Object.keys(r.osx).forEach(o=>r[o]=r.osx[o]):P.$k&&r.linux&&Object.keys(r.linux).forEach(o=>r[o]=r.linux[o]),delete r.windows,delete r.osx,delete r.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,$?$.uri:void 0,r,s,a)}async resolveAnyAsync($,v,s){return this.j($,v,s)}async resolveAnyMap($,v,s){const a=new Map;return{newConfig:await this.j($,v,s,a),resolvedVariables:a}}resolveWithInteractionReplace($,v,s,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction($,v,s,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable($,v){if(this.h.has($))throw new Error("Variable "+$+" is contributed twice.");this.h.set($,v)}async l($,v,s,a,r){if(C.$If(s))return this.m($,v,s,a,r);if(Array.isArray(s))return Promise.all(s.map(n=>this.l($,v,n,a,r)));if(C.$Kf(s)){const n=Object.create(null),o=await Promise.all(Object.keys(s).map(async c=>[await this.m($,v,c,a,r),await this.l($,v,s[c],a,r)]));for(const[c,h]of o)n[c]=h;return n}return s}m($,v,s,a,r){return(0,R.$4e)(s,k.VARIABLE_REGEXP,async(n,o)=>{if(o.includes(k.VARIABLE_LHS))return n;let c=await this.o($,n,o,v,a);return r?.set(o,c),c!==n&&C.$If(c)&&c.match(k.VARIABLE_REGEXP)&&(c=await this.m($,v,c,a,r)),c})}n($){return this.b?this.b.getUriLabel($,{noPrefix:!0}):$.fsPath}async o($,v,s,a,r){let n;const o=s.split(":");o.length>1&&(s=o[0],n=o[1]);const c=u=>{const t=this.a.getFilePath();if(t)return(0,m.$Wv)(t);throw new w.$1N(u,(0,f.localize)(0,null,v))},h=u=>{const t=c(u);if(this.a.getWorkspaceFolderPathForFile){const g=this.a.getWorkspaceFolderPathForFile();if(g)return(0,m.$Wv)(g)}throw new w.$1N(u,(0,f.localize)(1,null,v,y.$nc(t)))},i=u=>{if(n){const t=this.a.getFolderUri(n);if(t)return t;throw new w.$1N(u,(0,f.localize)(2,null,v,n))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new w.$1N(u,(0,f.localize)(3,null,v)):new w.$1N(u,(0,f.localize)(4,null,v))};switch(s){case"env":if(n){if($.env){const u=$.env[P.$i?n.toLowerCase():n];if(C.$If(u))return u}return""}throw new w.$1N(w.VariableKind.Env,(0,f.localize)(5,null,v));case"config":if(n){const u=this.a.getConfigurationValue(a,n);if(C.$Rf(u))throw new w.$1N(w.VariableKind.Config,(0,f.localize)(6,null,v,n));if(C.$Kf(u))throw new w.$1N(w.VariableKind.Config,(0,f.localize)(7,null,v,n));return u}throw new w.$1N(w.VariableKind.Config,(0,f.localize)(8,null,v));case"command":return this.p(w.VariableKind.Command,v,n,r,"command");case"input":return this.p(w.VariableKind.Input,v,n,r,"input");case"extensionInstallFolder":if(n){const u=await this.a.getExtension(n);if(!u)throw new w.$1N(w.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,v,n));return this.n(u.extensionLocation)}throw new w.$1N(w.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,v));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,m.$Wv)(this.n(i(w.VariableKind.WorkspaceFolder)));case"cwd":return a||n?(0,m.$Wv)(this.n(i(w.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Wv)(y.$nc(this.n(i(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if($.userHome)return $.userHome;throw new w.$1N(w.VariableKind.UserHome,(0,f.localize)(11,null,v))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new w.$1N(w.VariableKind.LineNumber,(0,f.localize)(12,null,v))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new w.$1N(w.VariableKind.SelectedText,(0,f.localize)(13,null,v))}case"file":return c(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$nc(h(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||n?y.$lc(this.n(i(w.VariableKind.RelativeFile)),c(w.VariableKind.RelativeFile)):c(w.VariableKind.RelativeFile);case"relativeFileDirname":{const u=y.$mc(c(w.VariableKind.RelativeFileDirname));if(a||n){const t=y.$lc(this.n(i(w.VariableKind.RelativeFileDirname)),u);return t.length===0?".":t}return u}case"fileDirname":return y.$mc(c(w.VariableKind.FileDirname));case"fileExtname":return y.$oc(c(w.VariableKind.FileExtname));case"fileBasename":return y.$nc(c(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=y.$nc(c(w.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-y.$oc(u).length)}case"fileDirnameBasename":return y.$nc(y.$mc(c(w.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||v}case"execInstallFolder":{const u=this.a.getAppRoot();return u||v}case"pathSeparator":case"/":return y.sep;default:try{const u=n?`${s}:${n}`:s;return this.p(w.VariableKind.Unknown,v,u,r,void 0)}catch{return v}}}}p($,v,s,a,r){if(s&&a){const n=r===void 0?a[s]:a[r+":"+s];if(typeof n=="string")return n;throw new w.$1N($,(0,f.localize)(14,null,v))}return v}}e.$cO=k}),define(Pe[104],Re([1,0,4,102]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.OpenEditorContext=e.GroupsOrder=e.$0C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9C=void 0,e.$9C=(0,y.$6h)("editorGroupsService");var C;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var P;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(P||(e.GroupLocation=P={}));var m;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var f;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function w(v){const s=v;return(0,M.$SE)(s?.editor)&&(0,M.$SE)(s?.replacement)}e.$0C=w;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var k;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l(v){const s=v;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.$$C=l;function $(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_C=$}),define(Pe[214],Re([1,0,4,104]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=void 0,e.$aD=(0,y.$6h)("editorService"),e.$bD=-1,e.$cD=-2,e.$dD=-3;function C(A){const P=A;return typeof A=="number"||(0,M.$$C)(P)}e.$eD=C}),define(Pe[215],Re([1,0,4,183]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=void 0,e.$uK=(0,y.$7h)(M.$ai)}),define(Pe[105],Re([1,0,23,5,19,6]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8b=e.$v8b=e.$u8b=e.$t8b=e.$s8b=void 0;class P{constructor(r,n){this.versionId=r,this.removedDueToLooping=n}}e.$s8b=P;class m{static isHostExtension(r,n,o){if(n.getExtensionDescription(r))return!1;const c=o.getExtensionDescription(r);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(r,n){this.j=r,this.c=new M.$Vd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(v),this.f=new y.$nm,this.g=[],this.h=new Map;for(const r of this.e){if(this.f.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.f.set(r.identifier,r),this.g.push(r);const n=this.j.readActivationEvents(r);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(r)}}set(r){return this.e=r,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(r,n){this.e=s(this.e,n),this.e=this.e.concat(r);const o=m.l(this.e);return this.e=s(this.e,o.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new P(this.d,o)}static l(r){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,t){this.addNode(u),this.addNode(t),this.c.has(u)?this.c.get(u).push(t):this.c.set(u,[t])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,t){const g=n.getArcs(u);for(let p=0;p<g.length;p++)if(!t.has(g[p]))return!1;return!0}getNodes(){return this.e}},o=new y.$nm;for(const u of r)if(o.set(u.identifier,u),u.extensionDependencies)for(const t of u.extensionDependencies)n.addArc(y.$lm.toKey(u.identifier),y.$lm.toKey(t));const c=new Set;n.getNodes().filter(u=>n.getArcs(u).length===0).forEach(u=>c.add(u));const h=n.getNodes().filter(u=>!c.has(u));let i;do{i=!1;for(let u=0;u<h.length;u++){const t=h[u];n.hasOnlyGoodArcs(t,c)&&(h.splice(u,1),u--,c.add(t),i=!0)}}while(i);return h.map(u=>o.get(u))}containsActivationEvent(r){return this.h.has(r)}containsExtension(r){return this.f.has(r)}getExtensionDescriptionsForActivationEvent(r){const n=this.h.get(r);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new f(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(r){const n=this.f.get(r);return n||void 0}getExtensionDescriptionByUUID(r){for(const n of this.g)if(n.uuid===r)return n}getExtensionDescriptionByIdOrUUID(r,n){return this.getExtensionDescription(r)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$t8b=m;class f{constructor(r,n){this.versionId=r,this.extensions=n}}e.$u8b=f;class w{constructor(r){this.d=new l,this.c=new m(r,[])}async acquireLock(r){const n=await this.d.acquire(r);return new R(this,n)}deltaExtensions(r,n,o){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,n){return this.c.getExtensionDescriptionByIdOrUUID(r,n)}}e.$v8b=w;class R extends A.$Tc{constructor(r,n){super(),this.f=r,this.c=!1,this.B(n)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$w8b=R;class k{constructor(r){this.name=r,this.promise=new Promise((n,o)=>{this.c=n})}resolve(r){this.c(r)}}class l{constructor(){this.c=[],this.d=!1}async acquire(r){const n=new k(r);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};r.resolve((0,A.$Rc)(c))}}var $;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})($||($={}));function v(a,r){const n=a.isBuiltin?0:a.isUnderDevelopment?2:1,o=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(n!==o)return n-o;const c=C.$gc.basename(a.extensionLocation.path),h=C.$gc.basename(r.extensionLocation.path);return c<h?-1:c>h?1:0}function s(a,r){const n=new y.$mm(r);return a.filter(o=>!n.has(o.identifier))}}),define(Pe[78],Re([1,0,22]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$um=e.$tm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var A;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function P(w){const R=y.$je.alloc(1);switch(w){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$tm=P;function m(w,R){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$um=m;var f;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Pe[60],Re([1,0,4,5,14,27,78,56,57,26,2,6,164]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.$tN=e.$sN=void 0;let $=class extends k.$Tc{constructor(r,n){super(),this.s=r,this.t=n,this.a=this.B(new M.$Vd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Vd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:f.$Qo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,C.$pj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,n,o){const c=this.getTelemetryDetails(),h=new v(n,o,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(r,n,o){this.f=r,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const n=Object.create(null);switch(n["common.extname"]=`${r.publisher}.${r.name}`,n["common.extversion"]=r.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case P.UIKind.Web:n["common.uikind"]="web";break;case P.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.$bl)((0,f.$Wo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const n=this.getTelemetryDetails();this.r.forEach((o,c)=>{const h=o.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(o=>{for(const c of o)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,n){const c=this.r.get(r.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(r.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$sN=$,e.$sN=$=Je([He(0,A.$rN),He(1,C.$oj)],$);class v{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,n,o,c,h,i,u){this.g=o,this.h=c,this.i=h,this.j=i,this.a=new M.$Vd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(r,n){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let n="properties"in r?r.properties??{}:r;return n=(0,f.$Zo)(n,[]),this.c&&(n=(0,w.$yn)(n,this.c)),this.b||(n=(0,w.$yn)(n,this.j)),"properties"in r?r.properties=n:r=n,r}k(r,n){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(r,n),this.h.trace(r,n))}logUsage(r,n){this.d.isUsageEnabled&&this.k(r,n)}logError(r,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,n);else{const o={name:r.name,message:r.message,stack:r.stack,cause:r.cause},c=(0,f.$Zo)(o,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const r=this,n={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$tN=v;function s(a){const r=Date.now()-new Date(a).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$uN=s,e.$vN=(0,y.$6h)("IExtHostTelemetry")}),define(Pe[24],Re([1,0,5,2,192,101,23,4]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LF=e.$KF=e.$JF=e.ActivationKind=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=e.ExtensionHostStartup=e.$DF=e.$CF=e.$BF=e.$AF=void 0,e.$AF=Object.freeze({identifier:new P.$lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$BF="extensions.webWorker",e.$CF=(0,m.$6h)("extensionService");class f{constructor(h){this.dependency=h}}e.$DF=f;var w;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,u){this.c=h,this.d=i.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$lF.createActivationEventsMap(this.d)}}set(h,i,u){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const t=[],g=[],p=[],d=[],S=k(this.d),L=k(i),b=(G,q)=>G.extensionLocation.toString()===q.extensionLocation.toString()||G.isBuiltin===q.isBuiltin||G.isUserBuiltin===q.isUserBuiltin||G.isUnderDevelopment===q.isUnderDevelopment;for(const G of this.d){const q=L.get(G.identifier);if(!q){t.push(G.identifier),S.delete(G.identifier);continue}if(!b(G,q)){t.push(G.identifier),S.delete(G.identifier);continue}}for(const G of i){const q=S.get(G.identifier);if(!q){g.push(G);continue}if(!b(q,G)){t.push(q.identifier),S.delete(q.identifier);continue}}const E=new P.$mm(this.e),D=new P.$mm(u);for(const G of this.e)D.has(G)||p.push(G);for(const G of u)E.has(G)||d.push(G);const T=A.$lF.createActivationEventsMap(g),O={versionId:h,toRemove:t,toAdd:g,addActivationEvents:T,myToRemove:p,myToAdd:d};return this.delta(O),O}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:u,myToRemove:t,myToAdd:g}=h,p=new P.$mm(i),d=new P.$mm(t);for(let S=0;S<this.d.length;S++)p.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)d.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of u)this.d.push(S);for(const S of g)this.e.push(S);return this.f=null,h}containsExtension(h){for(const i of this.e)if(P.$lm.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const u=A.$lF.readActivationEvents(i);for(const t of u)h.add(t)}return h}}e.$EF=R;function k(c){const h=new P.$nm;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$FF=l;function $(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$GF=$;class v{constructor(h,i,u,t){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=u,this.activationReason=t}}e.$HF=v;class s{constructor(h,i){this.description=h,this.value=i}}e.$IF=s;var a;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.$6o)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$JF=r;function n(c,h){return{identifier:new P.$lm((0,C.$4o)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$KF=n;class o{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$LF=o}),define(Pe[216],Re([1,0,15,105,23,24,14,13]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=e.$5gc=e.$4gc=e.$3gc=e.$2gc=e.$1gc=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(r,n,o,c){this.startup=r,this.codeLoadingTime=n,this.activateCallTime=o,this.activateResolvedTime=c}}e.$1gc=f;class w{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,n){return r===-1||n===-1?-1:n-r}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$2gc=w;class R{constructor(r,n,o,c,h,i){this.activationFailed=r,this.activationFailedError=n,this.activationTimes=o,this.module=c,this.exports=h,this.subscriptions=i}}e.$3gc=R;class k extends R{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$4gc=k;class l extends R{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$5gc=l;class $ extends R{constructor(r){super(!0,r,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(r,n,o,c){this.g=c,this.a=r,this.b=n,this.c=o,this.d=new C.$nm,this.f=Object.create(null)}dispose(){for(const[r,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const r=[];for(const[n,o]of this.d)r.push(o.wait());await Promise.all(r)}isActivated(r){const n=this.d.get(r);return!!(n&&n.value)}getActivatedExtension(r){const n=this.d.get(r);if(!n||!n.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return n.value}async activateByEvent(r,n){if(this.f[r])return;const o=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(o.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,n){const o=this.a.getExtensionDescription(r);if(!o)throw new Error(`Extension '${r}' is not known`);return this.h([{id:o.identifier,reason:n}])}async h(r){const n=r.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(n.map(o=>o.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const n=this.a.getExtensionDescription(r.id);if(!n){const h=new Error(`Cannot activate unknown extension '${r.id.value}'`),i=this.k(r,null,[],new $(h));return this.c.onExtensionActivationError(r.id,h,new A.$DF(r.id.value)),i}const o=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){o.push(i);continue}if(this.l(h)){o.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:r.reason}));continue}const u=this.a.getExtensionDescription(h);if(u){if(!u.main&&!u.browser)continue;o.push(this.j({id:u.identifier,reason:r.reason}));continue}const t=n.displayName||n.identifier.value,g=new Error(`Cannot activate the '${t}' extension because it depends on unknown extension '${h}'`),p=this.k(r,n.displayName,[],new $(g));return this.c.onExtensionActivationError(n.identifier,g,new A.$DF(h)),p}return this.k(r,n.displayName,o,null)}k(r,n,o,c){const h=new s(r.id,n,r.reason,o,c,this.c,this.g);return this.d.set(r.id,h),h}l(r){return M.$t8b.isHostExtension(r,this.a,this.b)}m(r){const n=this.b.getExtensionDescription(r);return n?!n.main&&!n.browser:!1}};e.$6gc=v,e.$6gc=v=Je([He(3,P.$nj)],v);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,n,o,c,h,i,u){this.c=r,this.d=n,this.f=o,this.g=c,this.h=h,this.j=i,this.k=u,this.a=new m.$5g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const n=this.g[r];if(n.value&&!n.value.activationFailed){this.g.splice(r,1),r--;continue}if(n.value&&n.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);o.detail=n.value.activationFailedError,this.h=new $(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const n=new Error;if(r&&r.name&&(n.name=r.name),r&&r.message?n.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(n.stack=r.stack),this.h=new $(n),this.b&&y.$4(r))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};s=Je([He(6,P.$nj)],s)}),define(Pe[217],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[218],Re([1,0,178,15,31,97,73,30,23,217,188,101]),function(ge,e,y,M,C,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=void 0;const l=m.$Hn.as(P.$In.JSONContribution);class ${constructor(h,i,u){this.a=h,this.b=i,this.c=u}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(C.default.Error,h)}warn(h){this.d(C.default.Warning,h)}info(h){this.d(C.default.Info,h)}}e.$uF=$;class v{static a(h){const i=new f.$mm;for(let u=0,t=h.length;u<t;u++)i.add(h[u].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new v(i,[]);if(!i||!i.length)return new v([],h);const u=this.a(h),t=this.a(i),g=i.filter(d=>!u.has(d.description.identifier)),p=h.filter(d=>!t.has(d.description.identifier));return new v(g,p)}constructor(h,i){this.added=h,this.removed=i}}e.$vF=v;class s{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=v.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,M.$1)(h)}}}e.$wF=s;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$xF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$km},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(42,null)},{label:"*",description:y.localize(43,null),body:"*"}]}},badges:{type:"array",description:y.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(45,null)},href:{type:"string",description:y.localize(46,null)},description:{type:"string",description:y.localize(47,null)}}}},markdown:{type:"string",description:y.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$mo}},extensionPack:{description:y.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$mo}},extensionKind:{description:y.localize(52,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(53,null)},{body:["workspace"],description:y.localize(54,null)},{body:["ui","workspace"],description:y.localize(55,null)},{body:["workspace","ui"],description:y.localize(56,null)},{body:[],description:y.localize(57,null)}]},capabilities:{description:y.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(61,null),y.localize(62,null),y.localize(63,null)]},description:{type:"string",markdownDescription:y.localize(64,null)}}},untrustedWorkspaces:{description:y.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(67,null),y.localize(68,null),y.localize(69,null)]},restrictedConfigurations:{description:y.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(71,null)}}}}},sponsor:{description:y.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(74,null),type:"string"},"vscode:uninstall":{description:y.localize(75,null),type:"string"}}},icon:{type:"string",description:y.localize(76,null)},l10n:{type:"string",description:y.localize(77,null)},pricing:{type:"string",markdownDescription:y.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new s(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&k.$lF.register(h.extensionPoint,h.activationEventsGenerator),e.$xF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(r,e.$xF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$yF=n;const o={ExtensionsRegistry:"ExtensionsRegistry"};m.$Hn.add(o.ExtensionsRegistry,new n),e.$zF=m.$Hn.as(o.ExtensionsRegistry),l.registerSchema(r,e.$xF),l.registerSchema(R.$Gj,{properties:{extensionEnabledApiProposals:{description:y.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Pe[219],Re([1,0,174,16,26,218,35,5]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var w;(function(l){function $(v,s,a){if(!v)return;const r=M.$If(v.type)?v.type:void 0;if(!r||r.length===0){a.error(y.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const o of v.required)M.$If(o)&&n.push(o);return{extensionId:s.value,taskType:r,required:n,properties:v.properties?C.$vn(v.properties):{},when:v.when?P.$4i.deserialize(v.when):void 0}}l.from=$})(w||(w={}));const R=A.$zF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,$)=>{for(const v of l)v.type&&$.push(`onTaskType:${v.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:f}});class k{constructor(){this.d=new m.$Vd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise(($,v)=>{R.setHandler((s,a)=>{this.c=void 0;try{for(const r of a.removed){const n=r.value;for(const o of n)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const r of a.added){const n=r.value;for(const o of n){const c=w.from(o,r.description.identifier,r.collector);c&&(this.a[c.taskType]=c)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}$(void 0)})})}onReady(){return this.b}get($){return this.a[$]}all(){return Object.keys(this.a).map($=>this.a[$])}getJsonSchema(){if(this.c===void 0){const $=[];for(const v of this.all()){const s={type:"object",additionalProperties:!1};v.required.length>0&&(s.required=v.required.slice(0)),v.properties!==void 0?s.properties=C.$vn(v.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[v.taskType]},$.push(s)}this.c={oneOf:$}}return this.c}}e.$xG=new k}),define(Pe[220],Re([1,0,175,16,25,26,35,219]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$HG=e.JsonSchemaVersion=e.ExecutionEngine=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$BG=e.ShellQuoting=e.$AG=e.$zG=e.$yG=void 0,e.$yG="settings",e.$zG=new P.$kj("taskRunning",!1,y.localize(0,null)),e.$AG={value:y.localize(1,null),original:"Tasks"};var f;(function(I){I[I.Escape=1]="Escape",I[I.Strong=2]="Strong",I[I.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$BG="$customized",function(I){function N(W){if(!W)return I.Strong;switch(W.toLowerCase()){case"escape":return I.Escape;case"strong":return I.Strong;case"weak":return I.Weak;default:return I.Strong}}I.from=N}(f||(e.ShellQuoting=f={}));var w;(function(I){I.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var R;(function(I){I[I.Always=1]="Always",I[I.Silent=2]="Silent",I[I.Never=3]="Never"})(R||(e.RevealKind=R={})),function(I){function N(W){switch(W.toLowerCase()){case"always":return I.Always;case"silent":return I.Silent;case"never":return I.Never;default:return I.Always}}I.fromString=N}(R||(e.RevealKind=R={}));var k;(function(I){I[I.Never=1]="Never",I[I.OnProblem=2]="OnProblem",I[I.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(I){function N(W){switch(W.toLowerCase()){case"always":return I.Always;case"never":return I.Never;case"onproblem":return I.OnProblem;default:return I.OnProblem}}I.fromString=N}(k||(e.RevealProblemKind=k={}));var l;(function(I){I[I.Shared=1]="Shared",I[I.Dedicated=2]="Dedicated",I[I.New=3]="New"})(l||(e.PanelKind=l={})),function(I){function N(W){switch(W.toLowerCase()){case"shared":return I.Shared;case"dedicated":return I.Dedicated;case"new":return I.New;default:return I.Shared}}I.fromString=N}(l||(e.PanelKind=l={}));var $;(function(I){I.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})($||(e.PresentationOptions=$={}));var v;(function(I){I[I.Shell=1]="Shell",I[I.Process=2]="Process",I[I.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(I){function N(ae){switch(ae.toLowerCase()){case"shell":return I.Shell;case"process":return I.Process;case"customExecution":return I.CustomExecution;default:return I.Process}}I.fromString=N;function W(ae){switch(ae){case I.Shell:return"shell";case I.Process:return"process";case I.CustomExecution:return"customExecution";default:return"process"}}I.toString=W}(v||(e.RuntimeType=v={}));var s;(function(I){function N(W){return M.$If(W)?W:W.value}I.value=N})(s||(e.CommandString=s={}));var a;(function(I){I.Clean={_id:"clean",isDefault:!1},I.Build={_id:"build",isDefault:!1},I.Rebuild={_id:"rebuild",isDefault:!1},I.Test={_id:"test",isDefault:!1};function N(ae){return ae===I.Clean._id||ae===I.Build._id||ae===I.Rebuild._id||ae===I.Test._id}I.is=N;function W(ae){if(ae!==void 0)return M.$If(ae)?N(ae)?{_id:ae,isDefault:!1}:void 0:ae}I.from=W})(a||(e.TaskGroup=a={}));var r;(function(I){I[I.Global=1]="Global",I[I.Workspace=2]="Workspace",I[I.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var n;(function(I){I.Workspace="workspace",I.Extension="extension",I.InMemory="inMemory",I.WorkspaceFile="workspaceFile",I.User="user";function N(W){switch(W){case I.User:return 2;case I.WorkspaceFile:return 5;default:return 6}}I.toConfigurationTarget=N})(n||(e.TaskSourceKind=n={}));var o;(function(I){I.parallel="parallel",I.sequence="sequence"})(o||(e.DependsOrder=o={}));var c;(function(I){I[I.default=1]="default",I[I.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(I){I.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(N,W,ae,de,we,ke){this._label="",this._id=N,W&&(this._label=W),ae&&(this.type=ae),this.runOptions=de,this.configurationProperties=we,this._source=ke}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,W=!1){if(N===void 0)return!1;if(M.$If(N))return N===this._label||N===this.configurationProperties.identifier||W&&N===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$CG=i;class u extends i{constructor(N,W,ae,de,we,ke,ue,pe){super(N,ae,void 0,ue,pe,W),this.command={},this._source=W,this.hasDefinedMatchers=ke,we&&(this.command=we)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case v.Shell:W="shell";break;case v.Process:W="process";break;case v.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(N){return N instanceof u}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(W+=this._source.kind);const ae={type:e.$BG,folder:N,id:W};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new u(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$DG=u;class t extends i{constructor(N,W,ae,de,we,ke,ue){super(N,ae,de,ke,ue,W),this._source=W,this.configures=we}static is(N){return N instanceof t}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$Eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(W+=this._source.kind);const ae={type:e.$BG,folder:N,id:W};return JSON.stringify(ae)}}e.$EG=t;class g extends i{constructor(N,W,ae,de,we,ke,ue,pe,ie){super(N,ae,de,pe,ie,W),this.defines=we,this.hasDefinedMatchers=ue,this.command=ke,this.icon=ie.icon,this.hide=ie.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof g}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new g(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$FG=g;class p extends i{constructor(N,W,ae,de,we,ke){super(N,ae,de,we,ke,W),this._source=W}clone(){return new p(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof p}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new p(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$GG=p;var d;(function(I){I[I.Process=1]="Process",I[I.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(I){I._default=I.Terminal}(d||(e.ExecutionEngine=d={}));var S;(function(I){I[I.V0_1_0=1]="V0_1_0",I[I.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class L{constructor(N){this.c=new Map;for(let W=0;W<N.length;W++)this.c.set(N[W].uri.toString(),W)}compare(N,W){const ae=N.getWorkspaceFolder(),de=W.getWorkspaceFolder();if(ae&&de){let we=this.c.get(ae.uri.toString());we=we===void 0?0:we+1;let ke=this.c.get(de.uri.toString());return ke=ke===void 0?0:ke+1,we===ke?N._label.localeCompare(W._label):we-ke}else return!ae&&de?-1:ae&&!de?1:0}}e.$HG=L;var b;(function(I){I.DependsOnStarted="dependsOnStarted",I.AcquiredInput="acquiredInput",I.Start="start",I.ProcessStarted="processStarted",I.Active="active",I.Inactive="inactive",I.Changed="changed",I.Terminated="terminated",I.ProcessEnded="processEnded",I.End="end"})(b||(e.TaskEventKind=b={}));var E;(function(I){I.SingleRun="singleRun",I.Background="background"})(E||(e.TaskRunType=E={}));var D;(function(I){I[I.System=0]="System",I[I.User=1]="User",I[I.FolderOpen=2]="FolderOpen",I[I.ConfigurationChange=3]="ConfigurationChange",I[I.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var T;(function(I){function N(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function W(pe,ie,be){return{...N(pe),kind:"start",terminalId:ie,resolvedVariables:be}}I.start=W;function ae(pe,ie,be){return{...N(pe),kind:"processStarted",terminalId:ie,processId:be}}I.processStarted=ae;function de(pe,ie,be){return{...N(pe),kind:"processEnded",terminalId:ie,exitCode:be}}I.processEnded=de;function we(pe,ie,be){return{...N(pe),kind:"terminated",exitReason:be,terminalId:ie}}I.terminated=we;function ke(pe,ie,be){return{...N(ie),kind:pe,terminalId:be}}I.general=ke;function ue(){return{kind:"changed"}}I.changed=ue})(T||(e.TaskEvent=T={}));var O;(function(I){function N(ae){const de=Object.keys(ae).sort();let we="";for(const ke of de){let ue=ae[ke];ue instanceof Object?ue=N(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),we+=ke+","+ue+","}return we}function W(ae){const we={_key:N(ae),type:ae.taskType};return Object.assign(we,ae),we}I.create=W})(O||(e.KeyedTaskIdentifier=O={}));var G;(function(I){I.AutoDetect="task.autoDetect",I.SaveBeforeRun="task.saveBeforeRun",I.ShowDecorations="task.showDecorations",I.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",I.SlowProviderWarning="task.slowProviderWarning",I.QuickOpenHistory="task.quickOpen.history",I.QuickOpenDetail="task.quickOpen.detail",I.QuickOpenSkip="task.quickOpen.skip",I.QuickOpenShowAll="task.quickOpen.showAll",I.AllowAutomaticTasks="task.allowAutomaticTasks",I.Reconnection="task.reconnection",I.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var q;(function(I){I.Tasks="tasks",I.SuppressTaskName="tasks.suppressTaskName",I.Windows="tasks.windows",I.Osx="tasks.osx",I.Linux="tasks.linux",I.ShowOutput="tasks.showOutput",I.IsShellCommand="tasks.isShellCommand",I.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var U;(function(I){function N(W,ae){const de=m.$xG.get(W.type);if(de===void 0){const pe=A.$vn(W);return delete pe._key,O.create(pe)}const we=Object.create(null);we.type=de.taskType;const ke=new Set;de.required.forEach(pe=>ke.add(pe));const ue=de.properties;for(const pe of Object.keys(ue)){const ie=W[pe];if(ie!=null)we[pe]=ie;else if(ke.has(pe)){const be=ue[pe];if(be.default!==void 0)we[pe]=A.$vn(be.default);else switch(be.type){case"boolean":we[pe]=!1;break;case"number":case"integer":we[pe]=0;break;case"string":we[pe]="";break;default:ae.error(y.localize(2,null,JSON.stringify(W,void 0,0),pe));return}}}return O.create(we)}I.createTaskIdentifier=N})(U||(e.TaskDefinition=U={}))}),define(Pe[221],Re([1,0,15]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y8b=e.$x8b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,m)=>{this.b=P,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,y.$1)(P))}then(P,m){return this.j().then(P,m)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.$x8b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new y.$5}}e.$y8b=C}),define(Pe[49],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=void 0;class y{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++y.count}}e.$Qv=y;const M=[];function C(m){const f=new y(m);return M[f.nid]=f,f}e.$Rv=C;function A(m){return M[m].sid}e.$Sv=A;class P{constructor(f){this.value=f}}e.$Tv=P}),define(Pe[3],Re([1,0,49]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$K=e.$0K=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$9K=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(C||(e.TabInputKind=C={}));var A;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var P;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(P||(e.WebviewEditorCapabilities=P={}));var m;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var f;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var w;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var R;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class k{static{this.a=0}static mixin(a){return a._id=k.a++,a}}e.$9K=k;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var $;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})($||(e.ISuggestResultDtoField=$={}));var v;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$0K={MainThreadAuthentication:(0,y.$Rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$Rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$Rv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,y.$Rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$Rv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$Rv)("MainThreadClipboard"),MainThreadCommands:(0,y.$Rv)("MainThreadCommands"),MainThreadComments:(0,y.$Rv)("MainThreadComments"),MainThreadConfiguration:(0,y.$Rv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$Rv)("MainThreadConsole"),MainThreadDebugService:(0,y.$Rv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$Rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$Rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$Rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$Rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$Rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$Rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$Rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$Rv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$Rv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$Rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$Rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$Rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$Rv)("MainThreadLanguages"),MainThreadLogger:(0,y.$Rv)("MainThreadLogger"),MainThreadMessageService:(0,y.$Rv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$Rv)("MainThreadOutputService"),MainThreadProgress:(0,y.$Rv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$Rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$Rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$Rv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$Rv)("MainThreadSecretState"),MainThreadStorage:(0,y.$Rv)("MainThreadStorage"),MainThreadSpeech:(0,y.$Rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$Rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$Rv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$Rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$Rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$Rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$Rv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$Rv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$Rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$Rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$Rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$Rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$Rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$Rv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$Rv)("MainThreadSCM"),MainThreadSearch:(0,y.$Rv)("MainThreadSearch"),MainThreadShare:(0,y.$Rv)("MainThreadShare"),MainThreadTask:(0,y.$Rv)("MainThreadTask"),MainThreadWindow:(0,y.$Rv)("MainThreadWindow"),MainThreadLabelService:(0,y.$Rv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$Rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$Rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$Rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$Rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$Rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$Rv)("MainThreadInteractive"),MainThreadChat:(0,y.$Rv)("MainThreadChat"),MainThreadInlineChat:(0,y.$Rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$Rv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$Rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$Rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$Rv)("MainThreadTimeline"),MainThreadTesting:(0,y.$Rv)("MainThreadTesting"),MainThreadLocalization:(0,y.$Rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$Rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$Rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$Rv)("MainThreadIssueReporter")},e.$$K={ExtHostCommands:(0,y.$Rv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$Rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$Rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$Rv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$Rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$Rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$Rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$Rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$Rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$Rv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$Rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$Rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$Rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$Rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$Rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$Rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$Rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$Rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$Rv)("ExtHostStatusBar"),ExtHostShare:(0,y.$Rv)("ExtHostShare"),ExtHostExtensionService:(0,y.$Rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$Rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$Rv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$Rv)("ExtHostSCM"),ExtHostSearch:(0,y.$Rv)("ExtHostSearch"),ExtHostTask:(0,y.$Rv)("ExtHostTask"),ExtHostWorkspace:(0,y.$Rv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$Rv)("ExtHostWindow"),ExtHostWebviews:(0,y.$Rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$Rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$Rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$Rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$Rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$Rv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$Rv)("ExtHostProgress"),ExtHostComments:(0,y.$Rv)("ExtHostComments"),ExtHostSecretState:(0,y.$Rv)("ExtHostSecretState"),ExtHostStorage:(0,y.$Rv)("ExtHostStorage"),ExtHostUrls:(0,y.$Rv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$Rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$Rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$Rv)("ExtHostOutputService"),ExtHostLabelService:(0,y.$Rv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$Rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$Rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$Rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$Rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$Rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$Rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$Rv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$Rv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$Rv)("ExtHostChat"),ExtHostChatAgents2:(0,y.$Rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$Rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$Rv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$Rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$Rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$Rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$Rv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$Rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$Rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$Rv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$Rv)("ExtHostTimeline"),ExtHostTesting:(0,y.$Rv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$Rv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$Rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$Rv)("ExtHostIssueReporter")}}),define(Pe[79],Re([1,0,4,14,3,17]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=e.$rgc=void 0,e.$rgc=(0,y.$6h)("IExtHostApiDeprecationService");let P=class{constructor(f,w){this.c=w,this.a=new Set,this.b=f.getProxy(C.$0K.MainThreadTelemetry)}report(f,w,R){const k=this.d(f,w);this.a.has(k)||(this.a.add(k),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:f}))}d(f,w){return`${f}-${w.identifier.value}`}};e.$sgc=P,e.$sgc=P=Je([He(0,A.$bN),He(1,M.$nj)],P),e.$tgc=Object.freeze(new class{report(m,f,w){}})}),define(Pe[222],Re([1,0,3]),function(ge,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;class M{constructor(A){const P=A.getProxy(y.$0K.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(m){return P.$writeText(m)}})}}e.$Cgc=M}),define(Pe[223],Re([1,0,26,3,27,17]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;let P=class{constructor(R,k){this.a=R.getProxy(M.$0K.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,k){const l=this,$=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){l.e(R,k,$,arguments)}})}e(R,k,l,$){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:f($,this.b)}),this.c&&this.f(R,l,$)}};e.$tic=P,e.$tic=P=Je([He(0,A.$bN),He(1,C.$rN)],P);const m=1e5;function f(w,R){const k=[];if(w.length)for(let l=0;l<w.length;l++){let $=w[l];if(typeof $>"u")$="undefined";else if($ instanceof Error){const v=$;v.stack?$=v.stack:$=v.toString()}k.push($)}if(R){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,y.$An)(k);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[224],Re([1,0,2,3,24]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class A{constructor(m){this.a=m.getProxy(M.$0K.MainThreadDialogs)}showOpenDialog(m,f){return f?.allowUIResources&&(0,C.$GF)(m,"showLocal"),this.a.$showOpenDialog(f).then(w=>w?w.map(R=>y.URI.revive(R)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(f=>f?y.URI.revive(f):void 0)}}e.$xhc=A}),define(Pe[225],Re([1,0,6,3]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;class C{constructor(P){this.b=0,this.a=P.getProxy(M.$0K.MainThreadLabelService)}$registerResourceLabelFormatter(P){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,P),(0,y.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Shc=C}),define(Pe[80],Re([1,0,21,12,2,4,14,3,27,17]),function(ge,e,y,M,C,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=e.$fhc=void 0;let R=class{constructor(l,$,v){this.f=v,this.d=new Map,this.a=$.getProxy(m.$0K.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===y.$g}getMessage(l,$){const{message:v,args:s,comment:a}=$;if(this.c)return(0,M.$Le)(v,s??{});let r=v;a&&a.length>0&&(r+=`/${Array.isArray(a)?a.join(""):a}`);const n=this.d.get(l)?.contents[r];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,M.$Le)(n??v,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let $;const v=await this.g(l);if(!v){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(v),a=JSON.parse(s);$=l.isBuiltin?a.contents?.bundle:a}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${v}: ${s.message}`);return}$&&this.d.set(l.identifier.value,{contents:$,uri:v})}async g(l){if(l.isBuiltin){const $=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return C.URI.revive($)}return l.l10n?C.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$fhc=R,e.$fhc=R=Je([He(0,f.$rN),He(1,w.$bN),He(2,P.$nj)],R),e.$ghc=(0,A.$6h)("IExtHostLocalizationService")}),define(Pe[226],Re([1,0,14,3,27,17,2,51]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=void 0;let f=class extends y.$yj{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map($=>(0,m.$Ch)($))),this.r=k.getProxy(M.$0K.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(P.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,$){return new w(this.r,k,l,$)}};e.$sic=f,e.$sic=f=Je([He(0,A.$bN),He(1,C.$rN)],f);class w extends y.$tj{constructor(k,l,$,v){super(v?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel($),this.r.$createLogger(l,v).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const $=[[k,l]];this.m?this.u($):this.n.push(...$)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Pe[81],Re([1,0,3,4,6,17,22]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=e.$hhc=void 0,e.$hhc=(0,M.$6h)("IExtHostManagedSockets");let m=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(y.$0K.MainThreadManagedSockets)}setFactory(k,l){for(const $ of this.d.values())$.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,$=await this.c.makeConnection(),v=new C.$Sc;return this.d.set(l,new w(l,$,v)),v.add((0,C.$Rc)(()=>this.d.delete(l))),v.add($.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),v.dispose()})),v.add($.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),v.dispose()})),v.add($.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,P.$je.wrap(s)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$ihc=m,e.$ihc=m=Je([He(0,A.$bN)],m);class f{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class w extends C.$Tc{constructor(k,l,$){super(),this.socketId=k,this.actual=l,this.B($)}}}),define(Pe[227],Re([1,0,3,14,24]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;function A(m){return m&&m.title}let P=class{constructor(f,w){this.b=w,this.a=f.getProxy(y.$0K.MainThreadMessageService)}showMessage(f,w,R,k,l){const $={source:{identifier:f.identifier,label:f.displayName||f.name}};let v;typeof k=="string"||A(k)?v=[k,...l]:($.modal=k?.modal,$.useCustom=k?.useCustom,$.detail=k?.detail,v=l),$.useCustom&&(0,C.$GF)(f,"resolvers");const s=[];let a=!1;for(let r=0;r<v.length;r++){const n=v[r];if(typeof n=="string")s.push({title:n,handle:r,isCloseAffordance:!1});else if(typeof n=="object"){const{title:o,isCloseAffordance:c}=n;s.push({title:o,isCloseAffordance:!!c,handle:r}),c&&(a?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,n):a=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,n)}return this.a.$showMessage(w,R,$,s).then(r=>{if(typeof r=="number")return v[r]})}};e.$Uhc=P,e.$Uhc=P=Je([He(1,M.$nj)],P)}),define(Pe[228],Re([1,0,6,16,2,24,3]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class m{constructor(w){this.b=new Map,this.a=w.getProxy(P.$0K.MainThreadProfileContentHandlers)}registerProfileContentHandler(w,R,k){if((0,A.$GF)(w,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,k),this.a.$registerProfileContentHandler(R,k.name,k.description,w.identifier.value),(0,y.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(w,R,k,l){const $=this.b.get(w);if(!$)throw new Error(`Unknown handler with id: ${w}`);return $.saveProfile(R,k,l)}async $readProfile(w,R,k){const l=this.b.get(w);if(!l)throw new Error(`Unknown handler with id: ${w}`);return l.readProfile((0,M.$If)(R)?R:C.URI.revive(R),k)}}e.$4hc=m}),define(Pe[82],Re([1,0,3,5,4]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=void 0;class A{constructor(m){this.b=new M.$Vd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(y.$0K.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,f){return this.a.$getPassword(m,f)}store(m,f,w){return this.a.$setPassword(m,f,w)}delete(m,f){return this.a.$deletePassword(m,f)}}e.$chc=A,e.$dhc=(0,C.$6h)("IExtHostSecretState")}),define(Pe[229],Re([1,0,20,6,3]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;class A{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(C.$0K.MainThreadSpeech)}async $createSpeechToTextSession(m,f){const w=this.c.get(m);if(!w)return;const R=new M.$Sc,k=new y.$6d;this.d.set(f,k);const l=R.add(w.provideSpeechToTextSession(k.token));R.add(l.onDidChange($=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,$)})),R.add(k.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,f,w){const R=A.a++;return this.c.set(R,w),this.b.$registerProvider(R,f,{extension:m,displayName:m.value}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$$hc=A}),define(Pe[83],Re([1,0,3,5,4]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=e.$7gc=void 0;class A{constructor(m,f){this.c=f,this.b=new M.$Vd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(y.$0K.MainThreadStorage)}registerExtensionStorageKeysToSync(m,f){this.a.$registerExtensionStorageKeysToSync(m,f)}async initializeExtensionStorage(m,f,w){const R=await this.a.$initializeExtensionStorage(m,f);let k;return R&&(k=this.d(m,f,R)),k||w}setValue(m,f,w){return this.a.$setValue(m,f,w)}$acceptValue(m,f,w){const R=this.d(m,f,w);R&&this.b.fire({shared:m,key:f,value:R})}d(m,f,w){try{return JSON.parse(w)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${m}): ${R}`)}}}e.$7gc=A,e.$8gc=(0,C.$6h)("IExtHostStorage")}),define(Pe[230],Re([1,0,6,11,2,3]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=void 0;class P{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(A.$0K.MainThreadUriOpeners)}registerExternalUriOpener(f,w,R,k){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const l=k.schemes.find($=>!P.a.has($));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(w,R),this.b.$registerUriOpener(w,k.schemes,f,k.label),(0,y.$Rc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(f,w,R){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener with id: ${f}`);const l=C.URI.revive(w);return k.canOpenExternalUri(l,R)}async $openUri(f,w,R){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener id: '${f}'`);return k.openExternalUri(C.URI.revive(w.resolvedUri),{sourceUri:C.URI.revive(w.sourceUri)},R)}}e.$mic=P}),define(Pe[231],Re([1,0,3,2,6,15,23]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;class m{static{this.a=0}constructor(w){this.c=new P.$mm,this.d=new Map,this.b=w.getProxy(y.$0K.MainThreadUrls)}registerUriHandler(w,R){const k=w.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=m.a++;return this.c.add(k),this.d.set(l,R),this.b.$registerUriHandler(l,k,w.displayName||w.name),(0,C.$Rc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(w,R){const k=this.d.get(w);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(R))}catch(l){(0,A.$1)(l)}return Promise.resolve(void 0)}async createAppUri(w){return M.URI.revive(await this.b.$createAppUri(w))}}e.$nic=m}),define(Pe[61],Re([1,0,5,6,11,26,2,181,203,77,3]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=void 0;class k{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;constructor(c,h,i,u,t,g,p){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new y.$Vd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$Vd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=i,this.#o=u,this.#n=t,this.#r=g,this.#l=l(g),this.#d=$(g),this.#i=p}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,w.$Dvb)(c,this.#o)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===C.Schemas.https||c.scheme===C.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$Cvb}return w.$Cvb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),A.$zn(this.#s,c)||this.#t.$setOptions(this.#e,a(this.#r,this.#n,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,f.$hlb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,t,g,p,d,S)=>{const L=P.URI.from({scheme:p||"file",path:decodeURIComponent(d)}),b=(0,w.$Dvb)(L,{isRemote:h,authority:i}).toString();return`${t}${b}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,t,g,p,d,S)=>{const L=P.URI.from({scheme:p||"file",path:decodeURIComponent(d)}),b=(0,w.$Dvb)(L,{isRemote:h,authority:i}).toString();return`${t}${b}${S}`})}}e.$Rgc=k;function l(o){try{const c=(0,m.$cp)((0,m.$bp)(o.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$Sgc=l;function $(o){try{const c=(0,m.$cp)((0,m.$bp)(o.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class v extends M.$Tc{constructor(c,h,i,u,t){super(),this.c=h,this.f=i,this.g=u,this.h=t,this.b=new Map,this.a=c.getProxy(R.$0K.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const u=this.j(c);if(u){const{message:t}=(0,f.$ilb)(h,i.value);u._onMessageEmitter.fire(t)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const u=new k(c,this.a,r(h),this.c,this.f,i,this.h);this.b.set(c,u);const t=u._onDidDispose(()=>{t.dispose(),this.deleteWebview(c)});return u}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Tgc=v;function s(o){return{id:o.identifier,location:o.extensionLocation}}e.$Ugc=s;function a(o,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(o,c)}}e.$Vgc=a;function r(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(c=>P.URI.from(c))}}function n(o,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(Pe[106],Re([1,0,5,3,2,11,12,4,17,24]),function(ge,e,y,M,C,A,P,m,f,w){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=e.$pic=void 0;let k=class{static{R=this}static{this.a={focused:!0,active:!0}}getState($){const v=this.d;return{get focused(){return v.focused},get active(){return(0,w.$GF)($,"windowActivity"),v.active}}}constructor($){this.c=new y.$Vd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=$.getProxy(M.$0K.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:s})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,v){v!==this.d[$]&&(this.d={...this.d,[$]:v},this.c.fire(this.d))}openUri($,v){let s;if(typeof $=="string"){s=$;try{$=C.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,P.$Je)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,s,v)}async asExternalUri($,v){if((0,P.$Je)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri($,v);return C.URI.from(s)}};e.$pic=k,e.$pic=k=R=Je([He(0,f.$bN)],k),e.$qic=(0,m.$6h)("IExtHostWindow")}),define(Pe[232],Re([1,0,223,27,17]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=void 0;let A=class extends y.$tic{constructor(m,f){super(m,f)}f(m,f,w){f.apply(console,w)}};e.$Ckc=A,e.$Ckc=A=Je([He(0,C.$bN),He(1,M.$rN)],A)}),define(Pe[233],Re([1,0,13,22,20,15,5,6,139,221,49]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$B8b=e.ResponsiveState=e.RequestInitiator=e.$A8b=e.$z8b=void 0;function l(D,T){try{return JSON.stringify(D,T)}catch{return"null"}}const $="$$ref$$",v={[$]:-1};class s{constructor(T,O){this.jsonString=T,this.referencedBuffers=O}}function a(D,T=null,O=!1){const G=[];return{jsonString:(O?l:JSON.stringify)(D,(U,I)=>{if(typeof I>"u")return v;if(typeof I=="object"){if(I instanceof M.$je){const N=G.push(I)-1;return{[$]:N}}if(T)return T(U,I)}return I}),referencedBuffers:G}}e.$z8b=a;function r(D,T,O){return JSON.parse(D,(G,q)=>{if(q){const U=q[$];if(typeof U=="number")return T[U];if(O&&q.$mid===1)return O.transformIncoming(q)}return q})}e.$A8b=r;function n(D,T){return JSON.stringify(D,T)}function o(D){return D?(T,O)=>O&&O.$mid===1?D.transformOutgoing(O):O:null}var c;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},u=Symbol.for("rpcProtocol"),t=Symbol.for("rpcProxy");class g extends m.$Tc{static{k=u}static{this.a=3*1e3}constructor(T,O=null,G=null){super(),this[k]=!0,this.b=this.B(new P.$Vd),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=O,this.g=G,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let q=0,U=R.$Qv.count;q<U;q++)this.m[q]=null,this.s[q]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$fh(()=>this.H(),1e3)),this.c.onMessage(q=>this.L(q))}dispose(){this.j=!0,Object.keys(this.w).forEach(T=>{const O=this.w[T];delete this.w[T],O.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(T){this.z===0&&(this.C=Date.now()+g.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(T){this.C=Date.now()+g.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(T){this.y!==T&&(this.y=T,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(T){return this.g?(0,f.$7m)(T,this.g):T}getProxy(T){const{nid:O,sid:G}=T;return this.s[O]||(this.s[O]=this.J(O,G)),this.s[O]}J(T,O){const G={get:(q,U)=>(typeof U=="string"&&!q[U]&&U.charCodeAt(0)===36&&(q[U]=(...I)=>this.U(T,U,I)),U===t?O:q[U])};return new Proxy(Object.create(null),G)}set(T,O){return this.m[T.nid]=O,O}assertRegistered(T){for(let O=0,G=T.length;O<G;O++){const q=T[O];if(!this.m[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}L(T){if(this.j)return;const O=T.byteLength,G=d.read(T,0),q=G.readUInt8(),U=G.readUInt32();switch(q){case 1:case 2:{let{rpcId:I,method:N,args:W}=L.deserializeRequestJSONArgs(G);this.g&&(W=(0,f.$7m)(W,this.g)),this.M(O,U,I,N,W,q===2);break}case 3:case 4:{let{rpcId:I,method:N,args:W}=L.deserializeRequestMixedArgs(G);this.g&&(W=(0,f.$7m)(W,this.g)),this.M(O,U,I,N,W,q===4);break}case 5:{this.f?.logIncoming(O,U,0,"ack"),this.G(U);break}case 6:{this.N(O,U);break}case 7:{this.O(O,U,void 0);break}case 9:{let I=L.deserializeReplyOKJSON(G);this.g&&(I=(0,f.$7m)(I,this.g)),this.O(O,U,I);break}case 10:{const I=L.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(O,U,I);break}case 8:{const I=L.deserializeReplyOKVSBuffer(G);this.O(O,U,I);break}case 11:{let I=L.deserializeReplyErrError(G);this.g&&(I=(0,f.$7m)(I,this.g)),this.P(O,U,I);break}case 12:{this.P(O,U,void 0);break}default:console.error("received unexpected message"),console.error(T)}}M(T,O,G,q,U,I){this.f?.logIncoming(T,O,1,`receiveRequest ${(0,R.$Sv)(G)}.${q}(`,U);const N=String(O);let W,ae;if(I){const we=new C.$6d;U.push(we.token),W=this.Q(G,q,U),ae=()=>we.cancel()}else W=this.Q(G,q,U),ae=i;this.u[N]=ae;const de=L.serializeAcknowledged(O);this.f?.logOutgoing(de.byteLength,O,1,"ack"),this.c.send(de),W.then(we=>{delete this.u[N];const ke=L.serializeReplyOK(O,we,this.h);this.f?.logOutgoing(ke.byteLength,O,1,"reply:",we),this.c.send(ke)},we=>{delete this.u[N];const ke=L.serializeReplyErr(O,we);this.f?.logOutgoing(ke.byteLength,O,1,"replyErr:",we),this.c.send(ke)})}N(T,O){this.f?.logIncoming(T,O,1,"receiveCancel");const G=String(O);this.u[G]?.()}O(T,O,G){this.f?.logIncoming(T,O,0,"receiveReply:",G);const q=String(O);if(!this.w.hasOwnProperty(q))return;const U=this.w[q];delete this.w[q],U.resolveOk(G)}P(T,O,G){this.f?.logIncoming(T,O,0,"receiveReplyErr:",G);const q=String(O);if(!this.w.hasOwnProperty(q))return;const U=this.w[q];delete this.w[q];let I;G&&(G.$isError?(I=new Error,I.name=G.name,I.message=G.message,I.stack=G.stack):I=G),U.resolveErr(I)}Q(T,O,G){try{return Promise.resolve(this.S(T,O,G))}catch(q){return Promise.reject(q)}}S(T,O,G){const q=this.m[T];if(!q)throw new Error("Unknown actor "+(0,R.$Sv)(T));const U=q[O];if(typeof U!="function")throw new Error("Unknown method "+O+" on actor "+(0,R.$Sv)(T));return U.apply(q,G)}U(T,O,G){if(this.j)return new w.$y8b;let q=null;if(G.length>0&&C.CancellationToken.isCancellationToken(G[G.length-1])&&(q=G.pop()),q&&q.isCancellationRequested)return Promise.reject(A.$6());const U=L.serializeRequestArguments(G,this.h),I=++this.t,N=String(I),W=new w.$x8b,ae=new m.$Sc;q&&ae.add(q.onCancellationRequested(()=>{const we=L.serializeCancel(I);this.f?.logOutgoing(we.byteLength,I,0,"cancel"),this.c.send(L.serializeCancel(I))})),this.w[N]=new p(W,ae),this.F(I);const de=L.serializeRequest(I,T,O,U,!!q);return this.f?.logOutgoing(de.byteLength,I,0,`request: ${(0,R.$Sv)(T)}.${O}(`,G),this.c.send(de),W}}e.$B8b=g;class p{constructor(T,O){this.a=T,this.b=O}resolveOk(T){this.a.resolveOk(T),this.b.dispose()}resolveErr(T){this.a.resolveErr(T),this.b.dispose()}}class d{static alloc(T,O,G){const q=new d(M.$je.alloc(G+1+4),0);return q.writeUInt8(T),q.writeUInt32(O),q}static read(T,O){return new d(T,O)}get buffer(){return this.a}constructor(T,O){this.a=T,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+T);return this.b+=T,O}static sizeMixedArray(T){let O=0;O+=1;for(let G=0,q=T.length;G<q;G++){const U=T[G];switch(O+=1,U.type){case 1:O+=this.sizeLongString(U.value);break;case 2:O+=this.sizeVSBuffer(U.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(U.value);for(let I=0;I<U.buffers.length;++I)O+=this.sizeVSBuffer(U.buffers[I]);break;case 4:break}}return O}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let O=0,G=T.length;O<G;O++){const q=T[O];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let U=0;U<q.buffers.length;++U)this.writeBuffer(q.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const O=new Array(T);for(let G=0;G<T;G++)switch(this.readUInt8()){case 1:O[G]=this.readLongString();break;case 2:O[G]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),I=this.readLongString(),N=[];for(let W=0;W<U;++W)N.push(this.readVSBuffer());O[G]=new R.$Tv(r(I,N,null));break}case 4:O[G]=void 0;break}return O}}var S;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(S||(S={}));class L{static a(T){for(let O=0,G=T.length;O<G;O++)if(T[O]instanceof M.$je||T[O]instanceof R.$Tv||typeof T[O]>"u")return!0;return!1}static serializeRequestArguments(T,O){if(this.a(T)){const G=[];for(let q=0,U=T.length;q<U;q++){const I=T[q];if(I instanceof M.$je)G[q]={type:2,value:I};else if(typeof I>"u")G[q]={type:4};else if(I instanceof R.$Tv){const{jsonString:N,referencedBuffers:W}=a(I.value,O);G[q]={type:3,value:M.$je.fromString(N),buffers:W}}else G[q]={type:1,value:M.$je.fromString(n(I,O))}}return{type:1,args:G}}return{type:0,args:n(T,O)}}static serializeRequest(T,O,G,q,U){switch(q.type){case 0:return this.b(T,O,G,q.args,U);case 1:return this.c(T,O,G,q.args,U)}}static b(T,O,G,q,U){const I=M.$je.fromString(G),N=M.$je.fromString(q);let W=0;W+=d.sizeUInt8(),W+=d.sizeShortString(I),W+=d.sizeLongString(N);const ae=d.alloc(U?2:1,T,W);return ae.writeUInt8(O),ae.writeShortString(I),ae.writeLongString(N),ae.buffer}static deserializeRequestJSONArgs(T){const O=T.readUInt8(),G=T.readShortString(),q=T.readLongString();return{rpcId:O,method:G,args:JSON.parse(q)}}static c(T,O,G,q,U){const I=M.$je.fromString(G);let N=0;N+=d.sizeUInt8(),N+=d.sizeShortString(I),N+=d.sizeMixedArray(q);const W=d.alloc(U?4:3,T,N);return W.writeUInt8(O),W.writeShortString(I),W.writeMixedArray(q),W.buffer}static deserializeRequestMixedArgs(T){const O=T.readUInt8(),G=T.readShortString(),q=T.readMixedArray(),U=new Array(q.length);for(let I=0,N=q.length;I<N;I++){const W=q[I];typeof W=="string"?U[I]=JSON.parse(W):U[I]=W}return{rpcId:O,method:G,args:U}}static serializeAcknowledged(T){return d.alloc(5,T,0).buffer}static serializeCancel(T){return d.alloc(6,T,0).buffer}static serializeReplyOK(T,O,G){if(typeof O>"u")return this.d(T);if(O instanceof M.$je)return this.e(T,O);if(O instanceof R.$Tv){const{jsonString:q,referencedBuffers:U}=a(O.value,G,!0);return this.g(T,q,U)}else return this.f(T,l(O,G))}static d(T){return d.alloc(7,T,0).buffer}static e(T,O){let G=0;G+=d.sizeVSBuffer(O);const q=d.alloc(8,T,G);return q.writeVSBuffer(O),q.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,O){const G=M.$je.fromString(O);let q=0;q+=d.sizeLongString(G);const U=d.alloc(9,T,q);return U.writeLongString(G),U.buffer}static g(T,O,G){const q=M.$je.fromString(O);let U=0;U+=d.sizeUInt32,U+=d.sizeLongString(q);for(const N of G)U+=d.sizeVSBuffer(N);const I=d.alloc(10,T,U);I.writeUInt32(G.length),I.writeLongString(q);for(const N of G)I.writeBuffer(N);return I.buffer}static deserializeReplyOKJSON(T){const O=T.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(T,O){const G=T.readUInt32(),q=T.readLongString(),U=[];for(let I=0;I<G;++I)U.push(T.readVSBuffer());return new R.$Tv(r(q,U,O))}static serializeReplyErr(T,O){const G=O?l(A.$3(O),null):void 0;if(typeof G!="string")return this.h(T);const q=M.$je.fromString(G);let U=0;U+=d.sizeLongString(q);const I=d.alloc(11,T,U);return I.writeLongString(q),I.buffer}static deserializeReplyErrError(T){const O=T.readLongString();return JSON.parse(O)}static h(T){return d.alloc(12,T,0).buffer}}var b;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var E;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(E||(E={}))}),define(Pe[234],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0;const y=function(A){const P=m=>{globalThis.removeEventListener("message",P);const f=m.data;Object.defineProperties(globalThis,{postMessage:{value(w,R){f.postMessage(w,R)}},onmessage:{get(){return f.onmessage},set(w){f.onmessage=w}}}),f.addEventListener("message",w=>{globalThis.dispatchEvent(new MessageEvent("message",{data:w.data,ports:w.ports?[...w.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};globalThis.addEventListener("message",P)}.toString();class M extends EventTarget{constructor(A,P,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${y})('${P}'))`,w=new Blob([f],{type:"application/javascript"}),R=URL.createObjectURL(w),k=new MessageChannel,l=R,$={type:"_newWorker",id:l,port:k.port2,url:R,options:m};A($,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{A({type:"_terminateWorker",id:l}),URL.revokeObjectURL(R),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(v){k.port1.onmessage=v}},onmessageerror:{get(){return k.port1.onmessageerror},set(v){k.port1.onmessageerror=v}}}),k.port1.addEventListener("messageerror",v=>{const s=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(s)}),k.port1.addEventListener("message",v=>{const s=new MessageEvent("message",{data:v.data});this.dispatchEvent(s)}),k.port1.start()}}e.$Ekc=M}),define(Pe[235],Re([1,0,22,28,11,53,4]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XI=e.$WI=e.$VI=e.$UI=void 0,e.$UI=(0,P.$6h)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${m.join("")}]+`),w=7;function R($){if($.scheme!==C.Schemas.vscodeNotebookCell)return;const v=$.fragment.indexOf("s");if(v<0)return;const s=parseInt($.fragment.substring(0,v).replace(f,""),w),a=(0,y.$Ce)($.fragment.substring(v+1)).toString();if(!isNaN(s))return{handle:s,notebook:$.with({scheme:a,fragment:null})}}e.$VI=R;function k($,v){const s=v.toString(w),r=`${s.length<m.length?m[s.length-1]:"z"}${s}s${(0,y.$De)(y.$je.fromString($.scheme),!0,!0)}`;return $.with({scheme:C.Schemas.vscodeNotebookCell,fragment:r})}e.$WI=k;class l{constructor(){this.a=new M.$Ac}getNotebook(v){if(v.scheme===C.Schemas.vscodeNotebookCell){const s=R(v);if(s){const a=this.a.get(s.notebook);if(a)return a}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$XI=l,(0,A.$Yr)(e.$UI,l,1)}),define(Pe[84],Re([1,0,22,34,68,69,11,19,21,35,235]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.CellStatusbarAlignment=e.$_I=e.$$I=e.$0I=e.NotebookEditorPriority=e.$9I=e.$8I=e.$7I=e.$6I=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$5I=e.$4I=e.$3I=e.$2I=e.CellKind=e.$1I=e.$ZI=e.$YI=void 0,e.$YI="workbench.editor.notebook",e.$ZI="workbench.editor.notebookTextDiffEditor",e.$1I="workbench.editor.interactive";var k;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(k||(e.CellKind=k={})),e.$2I=["application/json","application/javascript","text/html","image/svg+xml",A.$fs.latex,A.$fs.markdown,"image/png","image/jpeg",A.$fs.text],e.$3I=[A.$fs.latex,A.$fs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$fs.text],e.$4I=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$5I="_notAvailable";var l;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var $;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var v;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var s;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var a;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var r;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var n;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var o;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(o||(e.CellEditType=o={}));var c;(function(W){W.scheme=P.Schemas.vscodeNotebookCell;function ae(ie,be){return(0,R.$WI)(ie,be)}W.generate=ae;function de(ie){return(0,R.$VI)(ie)}W.parse=de;function we(ie,be){return ie.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${be??""},${ie.scheme!==P.Schemas.file?ie.scheme:""}`})}W.generateCellOutputUri=we;function ke(ie){if(ie.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const be=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ie.fragment);if(!be)return;const se=be[1]&&be[1]!==""?be[1]:void 0,Z=be[2];return{outputId:se,notebook:ie.with({scheme:Z||P.Schemas.file,fragment:null})}}W.parseCellOutputUri=ke;function ue(ie,be,se){return W.generate(ie,be).with({scheme:se})}W.generateCellPropertyUri=ue;function pe(ie,be){if(ie.scheme===be)return W.parse(ie.with({scheme:W.scheme}))}W.parseCellPropertyUri=pe})(c||(e.CellUri=c={}));const h=W=>f.$i?W.replace(/\//g,"\\"):W;class i{constructor(ae=[],de=e.$2I){this.e=de,this.d=[...new Set(ae)].map(we=>({pattern:we,matches:M.$Mj(h(we))}))}sort(ae){const de=new Map(C.Iterable.map(ae,ke=>[ke,h(ke)]));let we=[];for(const{matches:ke}of this.d)for(const[ue,pe]of de)if(ke(pe)){we.push(ue),de.delete(ue);break}return de.size&&(we=we.concat([...de.keys()].sort((ke,ue)=>this.e.indexOf(ke)-this.e.indexOf(ue)))),we}prioritize(ae,de){const we=this.f(ae);if(we===-1){this.d.unshift({pattern:ae,matches:M.$Mj(h(ae))});return}const ke=new Set(de.map(pe=>this.f(pe,we)));ke.delete(-1);const ue=Array.from(ke).sort();this.d.splice(we+1,0,...ue.map(pe=>this.d[pe]));for(let pe=ue.length-1;pe>=0;pe--)this.d.splice(ue[pe],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,de=this.d.length){const we=h(ae);for(let ke=0;ke<de;ke++)if(this.d[ke].matches(we))return ke;return-1}}e.$6I=i;function u(W,ae,de,we=(ke,ue)=>ke===ue){const ke=[];function ue(be,se,Z){if(se===0&&Z.length===0)return;const V=ke[ke.length-1];V&&V.start+V.deleteCount===be?(V.deleteCount+=se,V.toInsert.push(...Z)):ke.push({start:be,deleteCount:se,toInsert:Z})}let pe=0,ie=0;for(;;){if(pe===W.length){ue(pe,0,ae.slice(ie));break}if(ie===ae.length){ue(pe,W.length-pe,[]);break}const be=W[pe],se=ae[ie];if(we(be,se)){pe+=1,ie+=1;continue}de(se)?(ue(pe,1,[]),pe+=1):(ue(pe,0,[se]),ie+=1)}return ke}e.$7I=u,e.$8I=new w.$kj("notebookEditorCursorAtBoundary","none"),e.$9I=new w.$kj("notebookEditorCursorAtLineBoundary","none");var t;(function(W){W.default="default",W.option="option"})(t||(e.NotebookEditorPriority=t={}));function g(W){const ae=W;return!!((typeof ae.include=="string"||M.$Nj(ae.include))&&(typeof ae.exclude=="string"||M.$Nj(ae.exclude)))}e.$0I=g;function p(W,ae,de){if(Array.isArray(W.viewType)&&W.viewType.indexOf(ae)>=0||W.viewType===ae)return!0;if(W.filenamePattern){const we=g(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,ke=g(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(M.$Lj(we,(0,m.$nc)(de.fsPath).toLowerCase()))return!(ke&&M.$Lj(ke,(0,m.$nc)(de.fsPath).toLowerCase()))}return!1}e.$$I=p,e.$_I={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var d;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class S{static{this.d="notebook/"}static create(ae){return`${S.d}${ae}`}static parse(ae){if(ae.startsWith(S.d))return ae.substring(S.d.length)}}e.$aJ=S;function L(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}e.$bJ=L;const b=new TextDecoder;function E(W){const ae=[];let de=!1;for(const pe of W)(ae.length===0||de)&&(ae.push(pe),de=!0);let we=O(ae);const ke=y.$je.concat(ae.map(pe=>y.$je.wrap(pe))),ue=N(ke);return we=we||ue.byteLength!==ke.byteLength,{data:ue,didCompression:we}}e.$cJ=E,e.$dJ=`${String.fromCharCode(27)}[A`;const D=e.$dJ.split("").map(W=>W.charCodeAt(0)),T=10;function O(W){let ae=!1;return W.forEach((de,we)=>{if(we===0||de.length<e.$dJ.length)return;const ke=W[we-1],ue=de.subarray(0,e.$dJ.length);if(ue[0]===D[0]&&ue[1]===D[1]&&ue[2]===D[2]){const pe=ke.lastIndexOf(T);if(pe===-1)return;ae=!0,W[we-1]=ke.subarray(0,pe),W[we]=de.subarray(e.$dJ.length)}}),ae}function G(W){let ae=W;do W=ae,ae=W.replace(/[^\n]\x08/gm,"");while(ae.length<W.length);return W}function q(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const ae=W.match(/^(.*)\r+/m)[1];let de=W.match(/\r+(.*)$/m)[1];de=de+ae.slice(de.length,ae.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,de)}return W}const U="\b".charCodeAt(0),I="\r".charCodeAt(0);function N(W){return!W.buffer.includes(U)&&!W.buffer.includes(I)?W:y.$je.fromString(q(G(b.decode(W.buffer))))}}),define(Pe[7],Re([1,0,18,15,52,28,69,12,16,2,33,23,41,100,84]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v){"use strict";var s,a,r,n,o,c,h,i,u,t,g,p,d,S,L,b,E;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$3M=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$2M=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.TestRunProfileKind=e.TestResultState=e.$HM=e.$GM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$FM=e.NotebookVariablesRequestKind=e.$EM=e.$DM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$CM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.ColorThemeKind=e.$wM=e.$vM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$uM=e.DebugConsoleMode=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$oM=e.$nM=e.FileChangeType=e.$mM=e.$lM=e.$kM=e.$jM=e.InlineCompletionTriggerKind=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.ConfigurationTarget=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$YL=e.ViewBadge=e.ProgressLocation=e.$XL=e.$WL=e.TaskScope=e.ShellQuoting=e.$VL=e.$UL=e.$TL=e.TaskPanelKind=e.TaskRevealKind=e.$SL=e.TerminalLocation=e.$RL=e.$QL=e.$PL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$OL=e.$NL=e.$ML=e.$LL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$KL=e.StatusBarAlignment=e.ViewColumn=e.$JL=e.$IL=e.$HL=e.$GL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$FL=e.$EL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.LanguageStatusSeverity=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.CodeActionTriggerKind=e.$sL=e.$rL=e.SymbolTag=e.SymbolKind=e.$qL=e.$pL=e.DocumentHighlightKind=e.$oL=e.$nL=e.$mL=e.$lL=e.DiagnosticSeverity=e.DiagnosticTag=e.$kL=e.$jL=e.FileEditType=e.$iL=e.$hL=e.$gL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(B){return Object.assign(B,{apply:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const Se=oe.length===1?[]:oe[1];return Reflect.construct(B,Se,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const[Se,...Ge]=oe;return Reflect.construct(B,Ge,Se.constructor)}}})}var T;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(T||(e.TerminalOutputAnchor=T={}));var O;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let G=s=class{static from(...z){let oe=z;return new s(function(){if(oe){for(const Se of oe)Se&&typeof Se.dispose=="function"&&Se.dispose();oe=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$_K=G,e.$_K=G=s=Je([D],G);let q=a=class{static Min(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let Se=1;Se<z.length;Se++){const Ge=z[Se];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let Se=1;Se<z.length;Se++){const Ge=z[Se];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(z){if(!z)return!1;if(z instanceof a)return!0;const{line:oe,character:Se}=z;return typeof oe=="number"&&typeof Se=="number"}static of(z){if(z instanceof a)return z;if(this.isPosition(z))return new a(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,oe){if(z<0)throw(0,M.$7)("line must be non-negative");if(oe<0)throw(0,M.$7)("character must be non-negative");this.c=z,this.e=oe}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,oe=0){if(z===null||oe===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,oe=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&oe===0?this:new a(this.line+Se,this.character+oe)}with(z,oe=this.character){if(z===null||oe===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,oe=typeof z.character=="number"?z.character:this.character),Se===this.line&&oe===this.character?this:new a(Se,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$aL=q,e.$aL=q=a=Je([D],q);let U=r=class{static isRange(z){return z instanceof r?!0:z?q.isPosition(z.start)&&q.isPosition(z.end):!1}static of(z){if(z instanceof r)return z;if(this.isRange(z))return new r(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,oe,Se,Ge){let xe,ut;if(typeof z=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new q(z,oe),ut=new q(Se,Ge)):q.isPosition(z)&&q.isPosition(oe)&&(xe=q.of(z),ut=q.of(oe)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(z){return r.isRange(z)?this.contains(z.start)&&this.contains(z.end):q.isPosition(z)?!(q.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const oe=q.Max(z.start,this.c),Se=q.Min(z.end,this.e);if(!oe.isAfter(Se))return new r(oe,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const oe=q.Min(z.start,this.c),Se=q.Max(z.end,this.end);return new r(oe,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,oe=this.end){if(z===null||oe===null)throw(0,M.$7)();let Se;return z?q.isPosition(z)?Se=z:(Se=z.start||this.start,oe=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&oe.isEqual(this.end)?this:new r(Se,oe)}toJSON(){return[this.start,this.end]}};e.$bL=U,e.$bL=U=r=Je([D],U);let I=n=class extends U{static isSelection(z){return z instanceof n?!0:z?U.isRange(z)&&q.isPosition(z.anchor)&&q.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,oe,Se,Ge){let xe,ut;if(typeof z=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new q(z,oe),ut=new q(Se,Ge)):q.isPosition(z)&&q.isPosition(oe)&&(xe=q.of(z),ut=q.of(oe)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$cL=I,e.$cL=I=n=Je([D],I);const N=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,M.$7)("connectionToken")};class W{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,oe,Se){if(typeof z!="string"||z.length===0)throw(0,M.$7)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,M.$7)("port");typeof Se<"u"&&N(Se),this.host=z,this.port=Math.round(oe),this.connectionToken=Se}}e.$dL=W;class ae{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,oe){this.makeConnection=z,this.connectionToken=oe,typeof oe<"u"&&N(oe)}}e.$eL=ae;class de extends Error{static NotAvailable(z,oe){return new de(z,$.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(z){return new de(z,$.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,oe=$.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=oe,this._detail=Se,Object.setPrototypeOf(this,de.prototype)}}e.$fL=de;var we;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(we||(e.EndOfLine=we={}));var ke;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let ue=o=class{static isTextEdit(z){return z instanceof o?!0:z?U.isRange(z)&&typeof z.newText=="string":!1}static replace(z,oe){return new o(z,oe)}static insert(z,oe){return o.replace(new U(z,z),oe)}static delete(z){return o.replace(z,"")}static setEndOfLine(z){const oe=new o(new U(new q(0,0),new q(0,0)),"");return oe.newEol=z,oe}get range(){return this.c}set range(z){if(z&&!U.isRange(z))throw(0,M.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,M.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,M.$7)("newEol");this.f=z}constructor(z,oe){this.c=z,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$gL=ue,e.$gL=ue=o=Je([D],ue);let pe=c=class{static isNotebookCellEdit(z){return z instanceof c?!0:z?ti.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,oe){return new c(z,oe)}static insertCells(z,oe){return new c(new ti(z,z),oe)}static deleteCells(z){return new c(z,[])}static updateCellMetadata(z,oe){const Se=new c(new ti(z,z),[]);return Se.newCellMetadata=oe,Se}static updateNotebookMetadata(z){const oe=new c(new ti(0,0),[]);return oe.newNotebookMetadata=z,oe}constructor(z,oe){this.range=z,this.newCells=oe}};e.$hL=pe,e.$hL=pe=c=Je([D],pe);class ie{static isSnippetTextEdit(z){return z instanceof ie?!0:z?U.isRange(z.range)&&Z.isSnippetString(z.snippet):!1}static replace(z,oe){return new ie(z,oe)}static insert(z,oe){return ie.replace(new U(z,z),oe)}constructor(z,oe){this.range=z,this.snippet=oe}}e.$iL=ie;var be;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(be||(e.FileEditType=be={}));let se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,oe,Se,Ge){this.c.push({_type:1,from:z,to:oe,options:Se,metadata:Ge})}createFile(z,oe,Se){this.c.push({_type:1,from:void 0,to:z,options:oe,metadata:Se})}deleteFile(z,oe,Se){this.c.push({_type:1,from:z,to:void 0,options:oe,metadata:Se})}e(z,oe,Se){this.c.push({_type:3,metadata:Se,uri:z,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(z,oe,Se,Ge){const xe=oe.start,ut=oe.end;(xe!==ut||Se.length>0)&&this.c.push({_type:5,uri:z,index:xe,count:ut-xe,cells:Se,metadata:Ge})}g(z,oe,Se,Ge){this.c.push({_type:3,metadata:Ge,uri:z,edit:{editType:3,index:oe,metadata:Se}})}replace(z,oe,Se,Ge){this.c.push({_type:2,uri:z,edit:new ue(oe,Se),metadata:Ge})}insert(z,oe,Se,Ge){this.replace(z,new U(oe,oe),Se,Ge)}delete(z,oe,Se){this.replace(z,oe,"",Se)}has(z){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===z.toString())}set(z,oe){if(oe)for(const Se of oe){if(!Se)continue;let Ge,xe;Array.isArray(Se)?(Ge=Se[0],xe=Se[1]):Ge=Se,pe.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(z,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(z,Ge.newNotebookMetadata,xe):this.f(z,Ge.range,Ge.newCells,xe):ie.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:z,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:z,edit:Ge,metadata:xe})}else{for(let Se=0;Se<this.c.length;Se++){const Ge=this.c[Se];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,y.$Ib)(this.c)}}get(z){const oe=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===z.toString()&&oe.push(Se.edit);return oe}entries(){const z=new A.$Ac;for(const oe of this.c)if(oe._type===2){let Se=z.get(oe.uri);Se||(Se=[oe.uri,[]],z.set(oe.uri,Se)),Se[1].push(oe.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$jL=se,e.$jL=se=Je([D],se);let Z=h=class{static isSnippetString(z){return z instanceof h?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=h.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,oe=this.e++){if(typeof z=="function"){const Se=new h;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=h.c(z);return this.value+="${",this.value+=oe,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,oe=this.e++){const Se=z.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,oe){if(typeof oe=="function"){const Se=new h;Se.e=this.e,oe(Se),this.e=Se.e,oe=Se.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$kL=Z,e.$kL=Z=h=Je([D],Z);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ne;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ae=i=class{static isLocation(z){return z instanceof i?!0:z?U.isRange(z.range)&&w.URI.isUri(z.uri):!1}constructor(z,oe){if(this.uri=z,oe)if(U.isRange(oe))this.range=U.of(oe);else if(q.isPosition(oe))this.range=new U(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$lL=Ae,e.$lL=Ae=i=Je([D],Ae);let Le=class{static is(z){return z?typeof z.message=="string"&&z.location&&U.isRange(z.location.range)&&w.URI.isUri(z.location.uri):!1}constructor(z,oe){this.location=z,this.message=oe}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.location.range.isEqual(oe.location.range)&&z.location.uri.toString()===oe.location.uri.toString()}};e.$mL=Le,e.$mL=Le=Je([D],Le);let Ce=class{constructor(z,oe,Se=ne.Error){if(!U.isRange(z))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=z,this.message=oe,this.severity=Se}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.severity===oe.severity&&z.code===oe.code&&z.severity===oe.severity&&z.source===oe.source&&z.range.isEqual(oe.range)&&(0,y.$ub)(z.tags,oe.tags)&&(0,y.$ub)(z.relatedInformation,oe.relatedInformation,Le.isEqual)}};e.$nL=Ce,e.$nL=Ce=Je([D],Ce);let ce=class{constructor(z,oe){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=oe}};e.$oL=ce,e.$oL=ce=Je([D],ce);var te;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let J=class{constructor(z,oe=te.Text){this.range=z,this.kind=oe}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.$pL=J,e.$pL=J=Je([D],J);let ee=class{constructor(z,oe){this.uri=z,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$qL=ee,e.$qL=ee=Je([D],ee);var me;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var ve;(function(B){B[B.Deprecated=1]="Deprecated"})(ve||(e.SymbolTag=ve={}));let Me=u=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,oe,Se,Ge,xe){this.name=z,this.kind=oe,this.containerName=xe,typeof Se=="string"&&(this.containerName=Se),Ge instanceof Ae?this.location=Ge:Se instanceof U&&(this.location=new Ae(Ge,Se)),u.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$rL=Me,e.$rL=Me=u=Je([D],Me);let fe=t=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(t.validate)}constructor(z,oe,Se,Ge,xe){this.name=z,this.detail=oe,this.kind=Se,this.range=Ge,this.selectionRange=xe,this.children=[],t.validate(this)}};e.$sL=fe,e.$sL=fe=t=Je([D],fe);var ye;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(ye||(e.CodeActionTriggerKind=ye={}));let F=class{constructor(z,oe){this.title=z,this.kind=oe}};e.$tL=F,e.$tL=F=Je([D],F);let H=class{static{g=this}static{this.c="."}constructor(z){this.value=z}append(z){return new g(this.value?this.value+g.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+g.c)}};e.$uL=H,e.$uL=H=g=Je([D],H),H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let K=class{constructor(z,oe){if(this.range=z,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$vL=K,e.$vL=K=Je([D],K);class j{constructor(z,oe,Se,Ge,xe,ut){this.kind=z,this.name=oe,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$wL=j;class Y{constructor(z,oe){this.fromRanges=oe,this.from=z}}e.$xL=Y;class _{constructor(z,oe){this.fromRanges=oe,this.to=z}}e.$yL=_;var Ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ee||(e.LanguageStatusSeverity=Ee={}));let Ne=class{constructor(z,oe){this.range=z,this.command=oe}get isResolved(){return!!this.command}};e.$zL=Ne,e.$zL=Ne=Je([D],Ne);let Ve=p=class{#e;static isMarkdownString(z){return z instanceof p?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,oe=!1){this.#e=new C.$hk(z,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,oe){return this.#e.appendCodeblock(oe??"",z),this}};e.$AL=Ve,e.$AL=Ve=p=Je([D],Ve);let Ke=class{constructor(z,oe){this.label=z,this.documentation=oe}};e.$BL=Ke,e.$BL=Ke=Je([D],Ke);let Xe=class{constructor(z,oe){this.label=z,this.documentation=oe,this.parameters=[]}};e.$CL=Xe,e.$CL=Xe=Je([D],Xe);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$DL=nt,e.$DL=nt=Je([D],nt);var it;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var et;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let at=class{constructor(z){this.value=z}};e.$EL=at,e.$EL=at=Je([D],at);let ct=class{constructor(z,oe,Se){this.position=z,this.label=oe,this.kind=Se}};e.$FL=ct,e.$FL=ct=Je([D],ct);var je;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var mt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(mt||(e.CompletionItemKind=mt={}));var X;(function(B){B[B.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let x=class{constructor(z,oe){this.label=z,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&mt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$GL=x,e.$GL=x=Je([D],x);let $e=class{constructor(z=[],oe=!1){this.items=z,this.isIncomplete=oe}};e.$HL=$e,e.$HL=$e=Je([D],$e);let Be=class{constructor(z,oe,Se){this.insertText=z,this.range=oe,this.command=Se}};e.$IL=Be,e.$IL=Be=Je([D],Be);let Qe=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$JL=Qe,e.$JL=Qe=Je([D],Qe);var tt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var rt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function Te(B,z){return`${k.$lm.toKey(B)}.${z}`}e.$KL=Te;var zt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(zt||(e.TextEditorLineNumbersStyle=zt={}));var At;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(At||(e.TextDocumentSaveReason=At={}));var Gt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var Ft;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var yt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(yt||(e.TextDocumentChangeReason=yt={}));var qt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(qt||(e.DecorationRangeBehavior=qt={})),function(B){function z(oe){switch(oe){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var Tt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Tt||(e.SyntaxTokenType=Tt={})),function(B){function z(oe){switch(oe){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(Tt||(e.SyntaxTokenType=Tt={}));let Xt=class{constructor(z,oe){if(oe&&!w.URI.isUri(oe))throw(0,M.$7)("target");if(!U.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.target=oe}};e.$LL=Xt,e.$LL=Xt=Je([D],Xt);let Vt=class{constructor(z,oe,Se,Ge){this.red=z,this.green=oe,this.blue=Se,this.alpha=Ge}};e.$ML=Vt,e.$ML=Vt=Je([D],Vt);let Ut=class{constructor(z,oe){if(oe&&!(oe instanceof Vt))throw(0,M.$7)("color");if(!U.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.color=oe}};e.$NL=Ut,e.$NL=Ut=Je([D],Ut);let Ze=class{constructor(z){if(!z||typeof z!="string")throw(0,M.$7)("label");this.label=z}};e.$OL=Ze,e.$OL=Ze=Je([D],Ze);var Ht;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var Jt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var lt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class $t{constructor(z,oe,Se){if(this.startIndex=z,this.length=oe,this.tooltip=Se,typeof z!="number"||z<0)throw(0,M.$7)("startIndex");if(typeof oe!="number"||oe<1)throw(0,M.$7)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$7)("tooltip")}}e.$PL=$t;class jt{constructor(z){this.uri=z}}e.$QL=jt;class Qt{constructor(z){this.terminalCommand=z}}e.$RL=Qt;var Et;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Et||(e.TerminalLocation=Et={}));class dt{constructor(z){if(this.options=z,typeof z!="object")throw(0,M.$7)("options")}}e.$SL=dt;var St;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(St||(e.TaskRevealKind=St={}));var _t;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(_t||(e.TaskPanelKind=_t={}));let Ct=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(z){switch(z){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(z,oe){if(this.label=oe,typeof z!="string"||typeof oe!="string")throw(0,M.$7)("name");this.c=z}get id(){return this.c}};e.$TL=Ct,e.$TL=Ct=d=Je([D],Ct);function qe(B){let z="";for(let oe=0;oe<B.length;oe++)z+=B[oe].replace(/,/g,",,")+",";return z}let Lt=class{constructor(z,oe,Se){if(typeof z!="string")throw(0,M.$7)("process");this.e=[],this.c=z,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=Se):this.f=oe)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,M.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)z.push(oe);return qe(z)}};e.$UL=Lt,e.$UL=Lt=Je([D],Lt);let Nt=class{constructor(z,oe,Se){if(this.f=[],Array.isArray(oe)){if(!z)throw(0,M.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z,this.f=oe,this.g=Se}else{if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z,this.g=oe}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)z.push(typeof oe=="string"?oe:oe.value);return qe(z)}};e.$VL=Nt,e.$VL=Nt=Je([D],Nt);var Yt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Yt||(e.ShellQuoting=Yt={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Mt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,R.$qg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$WL=Mt;let Pt=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,oe,Se,Ge,xe,ut){this.k=!1,this.l=this.definition=z;let gt;typeof oe=="string"?(this.n=this.name=oe,this.u=this.source=Se,this.execution=Ge,gt=xe,this.k=!0):oe===ft.Global||oe===ft.Workspace?(this.target=oe,this.n=this.name=Se,this.u=this.source=Ge,this.execution=xe,gt=ut):(this.target=oe,this.n=this.name=Se,this.u=this.source=Ge,this.execution=xe,gt=ut),typeof gt=="string"?(this.q=[gt],this.r=!0):Array.isArray(gt)?(this.q=gt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Lt?this.l={type:S.e,id:this.o.computeId()}:this.o instanceof Nt?this.l={type:S.f,id:this.o.computeId()}:this.o instanceof Mt?this.l={type:S.c,id:this.o.computeId()}:this.l={type:S.g,id:(0,R.$qg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,M.$7)("Kind can't be undefined or null");this.A(),this.l=z}get scope(){return this.m}set target(z){this.A(),this.m=z}get name(){return this.n}set name(z){if(typeof z!="string")throw(0,M.$7)("name");this.A(),this.n=z}get execution(){return this.o}set execution(z){z===null&&(z=void 0),this.A(),this.o=z;const oe=this.l.type;(S.g===oe||S.e===oe||S.f===oe||S.c===oe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(z){if(Array.isArray(z))this.A(),this.q=z,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.A(),this.t=z}get source(){return this.u}set source(z){if(typeof z!="string"||z.length===0)throw(0,M.$7)("source must be a string of length > 0");this.A(),this.u=z}get group(){return this.w}set group(z){z===null&&(z=void 0),this.A(),this.w=z}get detail(){return this.z}set detail(z){z===null&&(z=void 0),this.z=z}get presentationOptions(){return this.x}set presentationOptions(z){z==null&&(z=Object.create(null)),this.A(),this.x=z}get runOptions(){return this.y}set runOptions(z){z==null&&(z=Object.create(null)),this.A(),this.y=z}};e.$XL=Pt,e.$XL=Pt=S=Je([D],Pt);var Bt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Bt||(e.ProgressLocation=Bt={}));var De;(function(B){function z(oe){const Se=oe;return(0,f.$Mf)(Se.value)?Se.tooltip&&!(0,f.$If)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}B.isViewBadge=z})(De||(e.ViewBadge=De={}));let Fe=L=class{static isTreeItem(z,oe){const Se=z;if(Se.checkboxState!==void 0){const Ge=(0,f.$Mf)(Se.checkboxState)?Se.checkboxState:(0,f.$Kf)(Se.checkboxState)&&(0,f.$Mf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,xe=!(0,f.$Mf)(Se.checkboxState)&&(0,f.$Kf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Q.Checked&&Ge!==Q.Unchecked||xe!==void 0&&!(0,f.$If)(xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof L)return!0;if(Se.label!==void 0&&!(0,f.$If)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,f.$If)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,f.$If)(Se.iconPath)&&!w.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,f.$If)(Se.iconPath.id))){const Ge=Se.iconPath;if(!Ge||!(0,f.$If)(Ge.light)&&!w.URI.isUri(Ge.light)&&!(0,f.$If)(Ge.dark)&&!w.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,f.$If)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!w.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,f.$If)(Se.tooltip)&&!(Se.tooltip instanceof Ve)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<he.None&&Se.collapsibleState>he.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,f.$If)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,oe=he.None){this.collapsibleState=oe,w.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$YL=Fe,e.$YL=Fe=L=Je([D],Fe);var he;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(he||(e.TreeItemCollapsibleState=he={}));var Q;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Q||(e.TreeItemCheckboxState=Q={}));let Ie=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$ZL=Ie,e.$ZL=Ie=Je([D],Ie);class Oe extends Ie{}e.$1L=Oe;class Ye extends Oe{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$2L=Ye;class We{constructor(z,oe,Se,Ge){this.name=z,this.uri=oe,this._itemId=Se,this.c=Ge}data(){return this.c()}}e.$3L=We;let st=class{#e=new Map;constructor(z){for(const[oe,Se]of z??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(Se):this.#e.set(this.#t(oe),[Se])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,oe){this.#e.set(this.#t(z),[oe])}forEach(z,oe){for(const[Se,Ge]of this.#e)for(const xe of Ge)z.call(oe,xe,Se,this)}*[Symbol.iterator](){for(const[z,oe]of this.#e)for(const Se of oe)yield[z,Se]}#t(z){return z.toLowerCase()}};e.$4L=st,e.$4L=st=Je([D],st);let wt=class{constructor(z){this.insertText=z}};e.$5L=wt,e.$5L=wt=Je([D],wt);let Kt=class{constructor(z,oe){this.label=oe,this.insertText=z}};e.$6L=Kt,e.$6L=Kt=Je([D],Kt);let kt=class{constructor(z,oe){this.id=z,this.color=oe}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$7L=kt,e.$7L=kt=Je([D],kt),kt.File=new kt("file"),kt.Folder=new kt("folder");let Dt=class{constructor(z){this.id=z}};e.$8L=Dt,e.$8L=Dt=Je([D],Dt);var vt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(vt||(e.ConfigurationTarget=vt={}));let Si=class{get base(){return this.c}set base(z){this.c=z,this.e=w.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,oe){if(typeof z!="string"&&(!z||!w.URI.isUri(z)&&!w.URI.isUri(z.uri)))throw(0,M.$7)("base");if(typeof oe!="string")throw(0,M.$7)("pattern");typeof z=="string"?this.baseUri=w.URI.file(z):w.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$9L=Si,e.$9L=Si=Je([D],Si);const Gi=new WeakMap;function It(B,z){Gi.set(B,z)}e.$0L=It;let si=class{constructor(z,oe,Se,Ge){this.enabled=typeof z=="boolean"?z:!0,typeof oe=="string"&&(this.condition=oe),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Gi.get(this)??(0,R.$qg)()),this.c}};e.$$L=si,e.$$L=si=Je([D],si);let mi=class extends si{constructor(z,oe,Se,Ge,xe){if(super(oe,Se,Ge,xe),z===null)throw(0,M.$7)("location");this.location=z}};e.$_L=mi,e.$_L=mi=Je([D],mi);let ui=class extends si{constructor(z,oe,Se,Ge,xe){super(oe,Se,Ge,xe),this.functionName=z}};e.$aM=ui,e.$aM=ui=Je([D],ui);let Ii=class extends si{constructor(z,oe,Se,Ge,xe,ut,gt){if(super(Ge,xe,ut,gt),!oe)throw(0,M.$7)("dataId");this.label=z,this.dataId=oe,this.canPersist=Se}};e.$bM=Ii,e.$bM=Ii=Je([D],Ii);let Ci=class{constructor(z,oe,Se){this.command=z,this.args=oe||[],this.options=Se}};e.$cM=Ci,e.$cM=Ci=Je([D],Ci);let Ot=class{constructor(z,oe){this.port=z,this.host=oe}};e.$dM=Ot,e.$dM=Ot=Je([D],Ot);let $i=class{constructor(z){this.path=z}};e.$eM=$i,e.$eM=$i=Je([D],$i);let Pi=class{constructor(z){this.implementation=z}};e.$fM=Pi,e.$fM=Pi=Je([D],Pi);let li=class{constructor(z,oe,Se){this.session=z,this.threadId=oe,this.frameId=Se}};e.$gM=li,e.$gM=li=Je([D],li);let hi=class{constructor(z,oe){this.session=z,this.threadId=oe}};e.$hM=hi,e.$hM=hi=Je([D],hi);let ht=class{constructor(z,oe){this.range=z,this.expression=oe}};e.$iM=ht,e.$iM=ht=Je([D],ht);var Ji;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let ei=class{constructor(z,oe){this.range=z,this.text=oe}};e.$jM=ei,e.$jM=ei=Je([D],ei);let oi=class{constructor(z,oe,Se=!0){this.range=z,this.variableName=oe,this.caseSensitiveLookup=Se}};e.$kM=oi,e.$kM=oi=Je([D],oi);let pi=class{constructor(z,oe){this.range=z,this.expression=oe}};e.$lM=pi,e.$lM=pi=Je([D],pi);let Ri=class{constructor(z,oe){this.frameId=z,this.stoppedLocation=oe}};e.$mM=Ri,e.$mM=Ri=Je([D],Ri);var Qi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ai=b=class extends Error{static FileExists(z){return new b(z,l.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(z){return new b(z,l.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(z){return new b(z,l.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(z){return new b(z,l.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(z){return new b(z,l.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(z){return new b(z,l.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(z,oe=l.FileSystemProviderErrorCode.Unknown,Se){super(w.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,l.$Fk)(this,oe),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$nM=Ai,e.$nM=Ai=b=Je([D],Ai);let vi=class{constructor(z,oe,Se){this.start=z,this.end=oe,this.kind=Se}};e.$oM=vi,e.$oM=vi=Je([D],vi);var Yi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Li;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var di;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(di||(e.CommentMode=di={}));var Xi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var bi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Mi{constructor(z,oe=[]){this.tokenTypes=z,this.tokenModifiers=oe}}e.$pM=Mi;function un(B){return typeof B>"u"||(0,f.$Jf)(B)}class Fi{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let oe=0,Se=z.tokenTypes.length;oe<Se;oe++)this.k.set(z.tokenTypes[oe],oe);for(let oe=0,Se=z.tokenModifiers.length;oe<Se;oe++)this.l.set(z.tokenModifiers[oe],oe)}}push(z,oe,Se,Ge,xe){if(typeof z=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.o(z,oe,Se,Ge,xe);if(U.isRange(z)&&typeof oe=="string"&&un(Se))return this.n(z,oe,Se);throw(0,M.$7)()}n(z,oe,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,xe=z.start.character,ut=z.end.character-z.start.character,gt=this.k.get(oe);let Wt=0;if(Se)for(const xt of Se){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const ni=this.l.get(xt);Wt|=1<<ni>>>0}this.o(Ge,xe,ut,gt,Wt)}o(z,oe,Se,Ge,xe){if(this.f&&(z<this.c||z===this.c&&oe<this.e)){this.f=!1;const Wt=this.g.length/5|0;let xt=0,ni=0;for(let ri=0;ri<Wt;ri++){let ci=this.g[5*ri],Hi=this.g[5*ri+1];ci===0?(ci=xt,Hi+=ni):ci+=xt,this.g[5*ri]=ci,this.g[5*ri+1]=Hi,xt=ci,ni=Hi}}let ut=z,gt=oe;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=Se,this.g[this.j++]=Ge,this.g[this.j++]=xe,this.c=z,this.e=oe}static q(z){const oe=[],Se=z.length/5|0;for(let gt=0;gt<Se;gt++)oe[gt]=gt;oe.sort((gt,Wt)=>{const xt=z[5*gt],ni=z[5*Wt];if(xt===ni){const ri=z[5*gt+1],ci=z[5*Wt+1];return ri-ci}return xt-ni});const Ge=new Uint32Array(z.length);let xe=0,ut=0;for(let gt=0;gt<Se;gt++){const Wt=5*oe[gt],xt=z[Wt+0],ni=z[Wt+1],ri=z[Wt+2],ci=z[Wt+3],Hi=z[Wt+4],In=xt-xe,zn=In===0?ni-ut:ni,Ki=5*gt;Ge[Ki+0]=In,Ge[Ki+1]=zn,Ge[Ki+2]=ri,Ge[Ki+3]=ci,Ge[Ki+4]=Hi,xe=xt,ut=ni}return Ge}build(z){return this.f?new ai(new Uint32Array(this.g),z):new ai(Fi.q(this.g),z)}}e.$qM=Fi;class ai{constructor(z,oe){this.resultId=oe,this.data=z}}e.$rM=ai;class ln{constructor(z,oe,Se){this.start=z,this.deleteCount=oe,this.data=Se}}e.$sM=ln;class hn{constructor(z,oe){this.resultId=oe,this.edits=z}}e.$tM=hn;var Zi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let fi=class{static{this.Back={iconPath:new kt("arrow-left")}}constructor(){}};e.$uM=fi,e.$uM=fi=Je([D],fi);var xi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var _i;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var wi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(wi||(e.ExtensionKind=wi={}));class en{static validate(z){if(typeof z.badge=="string"){let oe=(0,m.$jf)(z.badge,0);if(oe<z.badge.length&&(oe+=(0,m.$jf)(z.badge,oe)),z.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!kt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,oe,Se){this.badge=z,this.tooltip=oe,this.color=Se}}e.$vM=en;let Ti=class{constructor(z){this.kind=z}};e.$wM=Ti,e.$wM=Ti=Je([D],Ti);var Ni;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class ti{static isNotebookRange(z){return z instanceof ti?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,oe){if(z<0)throw(0,M.$7)("start must be positive");if(oe<0)throw(0,M.$7)("end must be positive");z<=oe?(this.c=z,this.e=oe):(this.c=oe,this.e=z)}with(z){let oe=this.c,Se=this.e;return z.start!==void 0&&(oe=z.start),z.end!==void 0&&(Se=z.end),oe===this.c&&Se===this.e?this:new ti(oe,Se)}}e.$xM=ti;class yi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(oe=>yi.isNotebookCellData(oe))}static isNotebookCellData(z){return!0}constructor(z,oe,Se,Ge,xe,ut,gt){this.kind=z,this.value=oe,this.languageId=Se,this.mime=Ge,this.outputs=xe??[],this.metadata=ut,this.executionSummary=gt,yi.validate(this)}}e.$yM=yi;class dn{constructor(z){this.cells=z}}e.$zM=dn;class Zt{static isNotebookCellOutputItem(z){return z instanceof Zt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const oe={name:z.name,message:z.message,stack:z.stack};return Zt.json(oe,"application/vnd.code.notebook.error")}static stdout(z){return Zt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Zt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,oe="application/octet-stream"){return new Zt(z,oe)}static#e=new TextEncoder;static text(z,oe=P.$fs.text){const Se=Zt.#e.encode(String(z));return new Zt(Se,oe)}static json(z,oe="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return Zt.text(Se,oe)}constructor(z,oe){this.data=z,this.mime=oe;const Se=(0,P.$js)(oe,!0);if(!Se)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$AM=Zt;class Ei{static isNotebookCellOutput(z){return z instanceof Ei?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,oe=!1){const Se=new Set,Ge=new Set;for(let xe=0;xe<z.length;xe++){const ut=z[xe],gt=(0,P.$js)(ut.mime);if(!Se.has(gt)||(0,v.$bJ)(gt)){Se.add(gt);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?z:z.filter((xe,ut)=>!Ge.has(ut))}constructor(z,oe,Se){this.items=Ei.ensureUniqueMimeTypes(z,!0),typeof oe=="string"?(this.id=oe,this.metadata=Se):(this.id=(0,R.$qg)(),this.metadata=oe??Se)}}e.$BM=Ei;var ki;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(ki||(e.NotebookCellKind=ki={}));var Oi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Ue;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ue||(e.NotebookCellStatusBarAlignment=Ue={}));var ii;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ii||(e.NotebookEditorRevealType=ii={}));class tn{constructor(z,oe){this.text=z,this.alignment=oe}}e.$CM=tn;var _e;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(_e||(e.NotebookControllerAffinity=_e={}));var pt;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(pt||(e.NotebookControllerAffinity2=pt={}));class fn{constructor(z,oe=[]){this.uri=z,this.provides=(0,y.$3b)(oe)}}e.$DM=fn;class gn{constructor(z){this.label=z}}e.$EM=gn;var zi;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(zi||(e.NotebookVariablesRequestKind=zi={}));let Ui=class{constructor(z,oe){this.label=z,this.timestamp=oe}};e.$FM=Ui,e.$FM=Ui=Je([D],Ui);var gi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(gi||(e.ExtensionMode=gi={}));var nn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class mn{constructor(z,oe){this.ranges=z,this.wordPattern=oe}}e.$GM=mn;class sn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$HM=sn;var on;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let ji=class{constructor(z=void 0,oe=void 0,Se=void 0,Ge=!1){this.include=z,this.exclude=oe,this.profile=Se,this.continuous=Ge}};e.$IM=ji,e.$IM=ji=Je([D],ji);let Bi=E=class{static diff(z,oe,Se){const Ge=new E(z);return Ge.expectedOutput=oe,Ge.actualOutput=Se,Ge}constructor(z){this.message=z}};e.$JM=Bi,e.$JM=Bi=E=Je([D],Bi);let Vi=class{constructor(z){this.id=z}};e.$KM=Vi,e.$KM=Vi=Je([D],Vi);class Di{constructor(z,oe){this.covered=z,this.total=oe}}e.$LM=Di;const Wi=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class qi{static fromDetails(z,oe){const Se=new Di(0,0),Ge=new Di(0,0),xe=new Di(0,0);for(const gt of oe)if("branches"in gt){Se.total+=1,Se.covered+=gt.executionCount>0?1:0;for(const Wt of gt.branches)Ge.total+=1,Ge.covered+=Wt.executionCount>0?1:0}else xe.total+=1,xe.covered+=gt.executionCount>0?1:0;const ut=new qi(z,Se,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=oe,ut}constructor(z,oe,Se,Ge){this.uri=z,this.statementCoverage=oe,this.branchCoverage=Se,this.functionCoverage=Ge,Wi(oe),Wi(Se),Wi(Ge)}}e.$MM=qi;class $n{constructor(z,oe,Se=[]){this.executionCount=z,this.location=oe,this.branches=Se}}e.$NM=$n;class pn{constructor(z,oe,Se){this.executionCount=z,this.location=oe,this.label=Se}}e.$OM=pn;class re{constructor(z,oe,Se){this.name=z,this.executionCount=oe,this.location=Se}}e.$PM=re;var le;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(le||(e.ExternalUriOpenerPriority=le={}));var ze;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(ze||(e.WorkspaceTrustState=ze={}));var ot;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(ot||(e.PortAutoForwardAction=ot={}));class bt{constructor(z,oe,Se,Ge,xe,ut){this.kind=z,this.name=oe,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$QM=bt;class Rt{constructor(z){this.uri=z}}e.$RM=Rt;class cn{constructor(z,oe){this.original=z,this.modified=oe}}e.$SM=cn;class Cn{constructor(z,oe,Se,Ge){this.base=z,this.input1=oe,this.input2=Se,this.result=Ge}}e.$TM=Cn;class Pn{constructor(z,oe){this.uri=z,this.viewType=oe}}e.$UM=Pn;class Rn{constructor(z){this.viewType=z}}e.$VM=Rn;class An{constructor(z,oe){this.uri=z,this.notebookType=oe}}e.$WM=An;class Ln{constructor(z,oe,Se){this.original=z,this.modified=oe,this.notebookType=Se}}e.$XM=Ln;class Mn{constructor(){}}e.$YM=Mn;class Fn{constructor(z,oe){this.uri=z,this.inputBoxUri=oe}}e.$ZM=Fn;class Tn{constructor(z){this.providerId=z}}e.$1M=Tn;var vn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var bn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(bn||(e.ChatAgentCopyKind=bn={}));var wn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Nn{constructor(z,oe){this.label=z,this.values=oe}}e.$2M=Nn;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class On{constructor(z,oe){this.role=z,this.content=oe}}e.$3M=On;var kn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Dn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Pe[236],Re([1,0,3,7]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class C{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(y.$0K.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(P,m,f){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(P);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(m,f)??[]}getRelatedInformation(P,m,f){return this.c.$getAiRelatedInformation(m,f)}registerRelatedInformationProvider(P,m,f){const w=this.b;return this.b++,this.a.set(w,f),this.c.$registerAiRelatedInformationProvider(w,m),new M.$_K(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$lgc=C}),define(Pe[237],Re([1,0,5,3,7,23]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class P{constructor(w){this.b=new Map,this.c=new y.$Vd,this.onDidChangeSessions=this.c.event,this.d=new m,this.f=new m,this.a=w.getProxy(M.$0K.MainThreadAuthentication)}async getSession(w,R,k,l={}){const $=A.$lm.toKey(w.identifier),v=[...k].sort().join(" ");return await this.d.getOrCreate(`${$} ${R} ${v}`,async()=>{await this.a.$ensureProvider(R);const s=w.displayName||w.name;return this.a.$getSession(R,k,$,s,l)})}async getSessions(w,R,k){const l=A.$lm.toKey(w.identifier),$=[...k].sort().join(" ");return await this.f.getOrCreate(`${l} ${$}`,async()=>{await this.a.$ensureProvider(R);const v=w.displayName||w.name;return this.a.$getSessions(R,k,l,v)})}async removeSession(w,R){const k=this.b.get(w);return k?k.provider.removeSession(R):this.a.$removeSession(w,R)}registerAuthenticationProvider(w,R,k,l){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:R,provider:k,options:l??{supportsMultipleAccounts:!1}});const $=k.onDidChangeSessions(v=>this.a.$sendDidChangeSessions(w,v));return this.a.$registerAuthenticationProvider(w,R,l?.supportsMultipleAccounts??!1),new C.$_K(()=>{$.dispose(),this.b.delete(w),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,R,k){const l=this.b.get(w);if(l)return Promise.resolve(l.provider.createSession(R,k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,R){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,R){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,R){return this.c.fire({provider:{id:w,label:R}}),Promise.resolve()}}e.$wgc=P;class m{constructor(){this.a=new Map}getOrCreate(w,R){const k=this.a.get(w);if(k)return k;const l=R().finally(()=>this.a.delete(w));return this.a.set(w,l),l}}}),define(Pe[107],Re([1,0,2,3,7,4,17,14,18,12,19,24]),function(ge,e,y,M,C,A,P,m,f,w,R,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=e.$vhc=void 0;let $=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,a){this.h=a,this.f=new Map,this.g=s.getProxy(M.$0K.MainThreadDecorations)}registerFileDecorationProvider(s,a){const r=l.c++;this.f.set(r,{provider:s,extensionDescription:a}),this.g.$registerDecorationProvider(r,a.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(r,null);return}const c=(0,f.$3b)(o);if(c.length<=l.d){this.g.$onDidChange(r,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,c.length);const h=c.map(t=>({uri:t,rank:(0,w.$Pe)(t.path,"/")})),i=(0,f.$zb)(h,(t,g)=>t.rank-g.rank||(0,w.$5e)(t.uri.path,g.uri.path)),u=[];e:for(const t of i){let g;for(const p of t){const d=(0,R.$mc)(p.uri.path);if(g!==d&&(g=d,u.push(p.uri)>=l.d))break e}}this.g.$onDidChange(r,u)});return new C.$_K(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(s,a,r){if(!this.f.has(s))return Object.create(null);const n=Object.create(null),{provider:o,extensionDescription:c}=this.f.get(s);return await Promise.all(a.map(async h=>{try{const{uri:i,id:u}=h,t=await Promise.resolve(o.provideFileDecoration(y.URI.revive(i),r));if(!t)return;try{C.$vM.validate(t),t.badge&&typeof t.badge!="string"&&(0,k.$GF)(c,"codiconDecoration"),n[u]=[t.propagate,t.tooltip,t.badge,t.color]}catch(g){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${g}`)}}catch(i){this.h.error(i)}})),n}};e.$vhc=$,e.$vhc=$=l=Je([He(0,P.$bN),He(1,m.$nj)],$),e.$whc=(0,A.$6h)("IExtHostDecorations")}),define(Pe[238],Re([1,0,15,2,7,3,11,20,12]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;class w{static{this.a=0}constructor(k,l,$){this.d=l,this.e=$,this.b=new Map,this.c=k.getProxy(A.$0K.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(P.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const $=w.a++;this.b.set($,l),this.c.$registerTextContentProvider($,k);let v;if(typeof l.onDidChange=="function"){let s;v=l.onDidChange(async a=>{if(a.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;s&&await s;const r=this.$provideTextDocumentContent($,a).then(async n=>{if(!n&&typeof n!="string")return;const o=this.d.getDocument(a);if(!o)return;const c=(0,f.$Ze)(n);if(!o.equalLines(c))return this.c.$onVirtualDocumentChange(a,n)}).catch(y.$1).finally(()=>{s===r&&(s=void 0)});s=r})}return new C.$_K(()=>{this.b.delete($)&&this.c.$unregisterTextContentProvider($),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(k,l){const $=this.b.get(k);return $?Promise.resolve($.provideTextDocumentContent(M.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$yhc=w}),define(Pe[108],Re([1,0,54,11,12,295,147,7,18]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=void 0;const w=new Map;function R(v,s){s?w.set(v,s):w.delete(v)}e.$dN=R;function k(v){return w.get(v)}class l extends A.$lv{constructor(s,a,r,n,o,c,h,i){super(a,r,n,o),this.c=s,this.m=c,this.q=h,this.notebook=i,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,f.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===M.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(a){return a?s.s(a):s.getText()},get eol(){return s.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(a){return s.t(a)},offsetAt(a){return s.u(a)},positionAt(a){return s.v(a)},validateRange(a){return s.w(a)},validatePosition(a){return s.x(a)},getWordRangeAtPosition(a,r){return s.y(a,r)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,y.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,y.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const a=this.w(s);if(a.isEmpty)return"";if(a.isSingleLine)return this.f[a.start.line].substring(a.start.character,a.end.character);const r=this.g,n=a.start.line,o=a.end.line,c=[];c.push(this.f[n].substring(a.start.character));for(let h=n+1;h<o;h++)c.push(this.f[h]);return c.push(this.f[o].substring(0,a.end.character)),c.join(r)}t(s){let a;if(s instanceof m.$aL?a=s.line:typeof s=="number"&&(a=s),typeof a!="number"||a<0||a>=this.f.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new $(a,this.f[a],a===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const a=this.j.getIndexOf(s),r=this.f[a.index].length;return new m.$aL(a.index,Math.min(a.remainder,r))}w(s){if(!(s instanceof m.$bL))throw new Error("Invalid argument");const a=this.x(s.start),r=this.x(s.end);return a===s.start&&r===s.end?s:new m.$bL(a.line,a.character,r.line,r.character)}x(s){if(!(s instanceof m.$aL))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:a,character:r}=s,n=!1;if(a<0)a=0,r=0,n=!0;else if(a>=this.f.length)a=this.f.length-1,r=this.f[a].length,n=!0;else{const o=this.f[a].length;r<0?(r=0,n=!0):r>o&&(r=o,n=!0)}return n?new m.$aL(a,r):s}y(s,a){const r=this.x(s);if(!a)a=k(this.m);else if((0,C.$Ye)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const n=(0,P.$xs)(r.character+1,(0,P.$vs)(a),this.f[r.line],0);if(n)return new m.$bL(r.line,n.startColumn-1,r.line,n.endColumn-1)}}e.$eN=l;class ${constructor(s,a,r){this.a=s,this.b=a,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$bL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$bL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$fN=$}),define(Pe[239],Re([1,0,3,7]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class C{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(y.$0K.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(P,m,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(P);if(!w)throw new Error("Embedding vector provider not found");const R=await w.provideEmbeddingVector(m,f);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(P,m,f){const w=this.b;return this.b++,this.a.set(w,f),this.c.$registerAiEmbeddingVectorProvider(m,w),new M.$_K(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$Ahc=C}),define(Pe[62],Re([1,0,3,41,7,22,4,17,42,6,13,25,11]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;let v=$=class{constructor(a,r){this.b=new Map,this.c=new R.$ch,this.a=a.getProxy(y.$0K.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(o){try{let c;const h=n.b.get(o.scheme);return h?(await n.a.$ensureActivation(o.scheme),c=await h.impl.stat(o)):c=await n.a.$stat(o),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===M.FilePermission.Readonly?1:void 0}}catch(c){$.e(c)}},async readDirectory(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readDirectory(o)).slice()):await n.a.$readdir(o)}catch(c){return $.e(c)}},async createDirectory(o){try{const c=n.b.get(o.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(c.impl,c.extUri,o)):await n.a.$mkdir(o)}catch(c){return $.e(c)}},async readFile(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readFile(o)).slice()):(await n.a.$readFile(o)).buffer}catch(c){return $.e(c)}},async writeFile(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(o)),await n.c.queueFor(o,()=>Promise.resolve(h.impl.writeFile(o,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(o,A.$je.wrap(c))}catch(h){return $.e(h)}},async delete(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(o.scheme),await h.impl.delete(o,{recursive:!1,...c})):await n.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return $.e(h)}},async rename(o,c,h){try{return await n.a.$rename(o,c,{overwrite:!1,...h})}catch(i){return $.e(i)}},async copy(o,c,h){try{return await n.a.$copy(o,c,{overwrite:!1,...h})}catch(i){return $.e(i)}},isWritableFileSystem(o){const c=r.getCapabilities(o);if(typeof c=="number")return!(c&2048)}})}async d(a,r,n){const o=[];for(;!r.isEqual(n,r.dirname(n));)try{if(!((await a.stat(n)).type&M.FileType.Directory))throw C.$nM.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(M.$Gk(c)!==M.FileSystemProviderErrorCode.FileNotFound)throw c;o.push(r.basename(n)),n=r.dirname(n)}for(let c=o.length-1;c>=0;c--){n=r.joinPath(n,o[c]);try{await a.createDirectory(n)}catch(h){if(M.$Gk(h)!==M.FileSystemProviderErrorCode.FileExists)throw h}}}static e(a){if(a instanceof C.$nM)throw a;if(a instanceof M.$Ck)switch(a.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$nM.FileExists(a.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$nM.FileNotFound(a.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$nM.FileNotADirectory(a.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$nM.FileIsADirectory(a.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$nM.NoPermissions(a.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$nM.Unavailable(a.message);default:throw new C.$nM(a.message,a.name)}if(!(a instanceof Error))throw new C.$nM(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw C.$nM.Unavailable(a.message);switch(a.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$nM.FileExists(a.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$nM.FileNotFound(a.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$nM.FileNotADirectory(a.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$nM.FileIsADirectory(a.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$nM.NoPermissions(a.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$nM.Unavailable(a.message);default:throw new C.$nM(a.message,a.name)}}addFileSystemProvider(a,r,n){return this.b.set(a,{impl:r,extUri:n?.isCaseSensitive?k.$xg:k.$zg,isReadonly:!!n?.isReadonly}),(0,w.$Rc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??k.$xg}};e.$Ngc=v,e.$Ngc=v=$=Je([He(0,m.$bN),He(1,f.$ogc)],v),e.$Ogc=(0,P.$6h)("IExtHostConsumerFileSystem")}),define(Pe[240],Re([1,0,3,7]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;class C{constructor(P){this.a=new Map,this.b=new Map,this.c=P.getProxy(y.$0K.MainThreadIssueReporter)}async $getIssueReporterUri(P,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(P);if(!f)throw new Error("Issue request handler not found");const w=await f.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(P,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(P);if(!f)throw new Error("Issue data provider not found");const w=await f.provideIssueData(m);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(P,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(P);if(!f)throw new Error("Issue data provider not found");const w=await f.provideIssueTemplate(m);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(P,m){const f=P.identifier.value;return this.a.set(f,m),this.c.$registerIssueUriRequestHandler(f),new M.$_K(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(P,m){const f=P.identifier.value;return this.b.set(f,m),this.c.$registerIssueDataProvider(f),new M.$_K(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$Rhc=C}),define(Pe[85],Re([1,0,4,27,14,62,2]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0,e.$Pgc=(0,y.$6h)("IExtensionStoragePaths");let m=class{constructor(w,R,k){this.d=R,this.f=k,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(w){return P.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,R=await this.g(w);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(P.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(w){if(this.c)return P.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return P.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Qgc=m,e.$Qgc=m=Je([He(0,M.$rN),He(1,C.$nj),He(2,A.$Ogc)],m)}),define(Pe[241],Re([1,0,7,17,5]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=void 0;let A=class{constructor(m){this.a=new y.$wM(y.ColorThemeKind.Dark),this.b=new C.$Vd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let f;switch(m){case"light":f=y.ColorThemeKind.Light;break;case"hcDark":f=y.ColorThemeKind.HighContrast;break;case"hcLight":f=y.ColorThemeKind.HighContrastLight;break;default:f=y.ColorThemeKind.Dark}this.a=new y.$wM(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$iic=A,e.$iic=A=Je([He(0,M.$bN)],A)}),define(Pe[86],Re([1,0,20,5,6,167,4,14,196,3,27,17,7]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wyb=e.$vyb=e.TunnelDtoConverter=void 0;class $ extends f.$Jv{}var v;(function(a){function r(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:o.protocol}}a.fromApiTunnel=r;function n(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==f.TunnelPrivacyId.ConstantPrivate&&o.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}a.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$vyb=(0,P.$6h)("IExtHostTunnelService");let s=class extends C.$Tc{constructor(r,n,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Vd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(w.$0K.MainThreadTunnelService)}async openTunnel(r,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const o=await this.a.$openTunnel(n,r.displayName);if(o){const c=new $(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,n){const o=this.u();return this.r.set(o,{selector:r,provider:n}),this.a.$registerPortsAttributesProvider(r,o),new l.$_K(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(r,n,o,c,h){const i=[];for(const t of r){const g=this.r.get(t);if(!g)return[];i.push(...await Promise.all(n.map(async p=>{let d;try{d=await g.provider.providePortAttributes({port:p,pid:o,commandLine:c},h)}catch{d=await g.provider.providePortAttributes(p,o,c,h)}return{providedAttributes:d,port:p}})))}const u=i.filter(t=>!!t.providedAttributes);return u.length>0?u.map(t=>({autoForwardAction:t.providedAttributes.autoForwardAction,port:t.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await r.provideTunnel(c,h,new y.$6d().token)??void 0;const o=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,C.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,n){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const o=r.tunnelFactory??(n?this.w(n):void 0);if(o){this.b=o;let c=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const h=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,C.$Rc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,n){if(this.g.has(r.host)){const o=this.g.get(r.host);o.has(r.port)&&(n&&o.get(r.port).disposeListener.dispose(),await o.get(r.port).tunnel.dispose(),o.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(r,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const c=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:c,disposeListener:h}),v.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(r){const n=await Promise.all(r.map(c=>this.f(c.host,c.port,c.detail??""))),o=r.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(c=>c.port).join(", ")} to ${o.map(c=>c.port).join(", ")}`),o}};e.$wyb=s,e.$wyb=s=Je([He(0,k.$bN),He(1,R.$rN),He(2,m.$nj)],s)}),define(Pe[8],Re([1,0,18,22,127,242,52,28,120,51,69,26,16,2,29,87,99,103,102,84,48,59,214,24,7]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n,o,c,h,i,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$aN=e.$_M=e.MarkdownString=e.$$M=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var g;(function(De){function Fe(Q){const{selectionStartLineNumber:Ie,selectionStartColumn:Oe,positionLineNumber:Ye,positionColumn:We}=Q,st=new t.$aL(Ie-1,Oe-1),wt=new t.$aL(Ye-1,We-1);return new t.$cL(st,wt)}De.to=Fe;function he(Q){const{anchor:Ie,active:Oe}=Q;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}De.from=he})(g||(e.Selection=g={}));var p;(function(De){function Fe(Q){if(!Q)return;const{start:Ie,end:Oe}=Q;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}De.from=Fe;function he(Q){if(!Q)return;const{startLineNumber:Ie,startColumn:Oe,endLineNumber:Ye,endColumn:We}=Q;return new t.$bL(Ie-1,Oe-1,Ye-1,We-1)}De.to=he})(p||(e.Range=p={}));var d;(function(De){function Fe(he){return new t.$lL($.URI.revive(he.uri),p.to(he.range))}De.to=Fe})(d||(e.Location=d={}));var S;(function(De){function Fe(he){switch(he){case 1:return t.StandardTokenType.Comment;case 0:return t.StandardTokenType.Other;case 3:return t.StandardTokenType.RegEx;case 2:return t.StandardTokenType.String}}De.to=Fe})(S||(e.TokenType=S={}));var L;(function(De){function Fe(Q){return new t.$aL(Q.lineNumber-1,Q.column-1)}De.to=Fe;function he(Q){return{lineNumber:Q.line+1,column:Q.character+1}}De.from=he})(L||(e.Position=L={}));var b;(function(De){function Fe(Ie,Oe,Ye){return(0,y.$Hb)((0,y.$3b)(Ie).map(We=>he(We,Oe,Ye)))}De.from=Fe;function he(Ie,Oe,Ye){if(typeof Ie=="string")return{$serialized:!0,language:Ie,isBuiltin:Ye?.isBuiltin};if(Ie)return{$serialized:!0,language:Ie.language,scheme:Q(Ie.scheme,Oe),pattern:x.from(Ie.pattern)??void 0,exclusive:Ie.exclusive,notebookType:Ie.notebookType,isBuiltin:Ye?.isBuiltin}}function Q(Ie,Oe){return Oe&&typeof Ie=="string"?Oe.transformOutgoingScheme(Ie):Ie}})(b||(e.DocumentSelector=b={}));var E;(function(De){function Fe(Q){switch(Q){case t.DiagnosticTag.Unnecessary:return 1;case t.DiagnosticTag.Deprecated:return 2}}De.from=Fe;function he(Q){switch(Q){case 1:return t.DiagnosticTag.Unnecessary;case 2:return t.DiagnosticTag.Deprecated;default:return}}De.to=he})(E||(e.DiagnosticTag=E={}));var D;(function(De){function Fe(Q){let Ie;return Q.code&&((0,l.$If)(Q.code)||(0,l.$Mf)(Q.code)?Ie=String(Q.code):Ie={value:String(Q.code.value),target:Q.code.target}),{...p.from(Q.range),message:Q.message,source:Q.source,code:Ie,severity:O.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(T.from),tags:Array.isArray(Q.tags)?(0,y.$Hb)(Q.tags.map(E.from)):void 0}}De.from=Fe;function he(Q){const Ie=new t.$nL(p.to(Q),Q.message,O.to(Q.severity));return Ie.source=Q.source,Ie.code=(0,l.$If)(Q.code)?Q.code:Q.code?.value,Ie.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(T.to),Ie.tags=Q.tags&&(0,y.$Hb)(Q.tags.map(E.to)),Ie}De.to=he})(D||(e.Diagnostic=D={}));var T;(function(De){function Fe(Q){return{...p.from(Q.location.range),message:Q.message,resource:Q.location.uri}}De.from=Fe;function he(Q){return new t.$mL(new t.$lL(Q.resource,p.to(Q)),Q.message)}De.to=he})(T||(e.DiagnosticRelatedInformation=T={}));var O;(function(De){function Fe(Q){switch(Q){case t.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case t.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case t.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case t.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error}De.from=Fe;function he(Q){switch(Q){case a.MarkerSeverity.Info:return t.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:return t.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return t.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return t.DiagnosticSeverity.Hint;default:return t.DiagnosticSeverity.Error}}De.to=he})(O||(e.DiagnosticSeverity=O={}));var G;(function(De){function Fe(Q){return typeof Q=="number"&&Q>=t.ViewColumn.One?Q-1:Q===t.ViewColumn.Beside?i.$cD:i.$bD}De.from=Fe;function he(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=he})(G||(e.ViewColumn=G={}));function q(De){return typeof De.range<"u"}function U(De){return De.length===0?!0:!!q(De[0])}e.$$M=U;var I;(function(De){function Fe(We){return We.map(De.from)}De.fromMany=Fe;function he(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function Q(We){let st;if(he(We)){const{language:Dt,value:vt}=We;st={value:"```"+Dt+`
`+vt+"\n```\n"}}else t.$AL.isMarkdownString(We)?st={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?st={value:We}:st={value:""};const wt=Object.create(null);st.uris=wt;const Kt=Dt=>{try{let vt=$.URI.parse(Dt,!0);vt=vt.with({query:Ie(vt.query,wt)}),wt[Dt]=vt}catch{}return""},kt=new f.marked.Renderer;return kt.link=Kt,kt.image=Dt=>typeof Dt=="string"?Kt(P.$pk(Dt).href):"",(0,f.marked)(st.value,{renderer:kt}),st}De.from=Q;function Ie(We,st){if(!We)return We;let wt;try{wt=(0,w.$Bh)(We)}catch{}if(!wt)return We;let Kt=!1;return wt=(0,k.$xn)(wt,kt=>{if($.URI.isUri(kt)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[Dt]=kt,Kt=!0,Dt}else return}),Kt?JSON.stringify(wt):We}function Oe(We){const st=new t.$AL(We.value,We.supportThemeIcons);return st.isTrusted=We.isTrusted,st.supportHtml=We.supportHtml,st.baseUri=We.baseUri?$.URI.from(We.baseUri):void 0,st}De.to=Oe;function Ye(We){if(We)return typeof We=="string"?We:De.from(We)}De.fromStrict=Ye})(I||(e.MarkdownString=I={}));function N(De){return U(De)?De.map(Fe=>({range:p.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?I.fromMany(Fe.hoverMessage):Fe.hoverMessage?I.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):De.map(Fe=>({range:p.from(Fe)}))}e.$_M=N;function W(De){return typeof De>"u"?De:typeof De=="string"?$.URI.file(De):De}e.$aN=W;var ae;(function(De){function Fe(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?W(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}De.from=Fe})(ae||(e.ThemableDecorationAttachmentRenderOptions=ae={}));var de;(function(De){function Fe(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?W(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?ae.from(he.before):void 0,after:he.after?ae.from(he.after):void 0}}De.from=Fe})(de||(e.ThemableDecorationRenderOptions=de={}));var we;(function(De){function Fe(he){if(typeof he>"u")return he;switch(he){case t.DecorationRangeBehavior.OpenOpen:return 0;case t.DecorationRangeBehavior.ClosedClosed:return 1;case t.DecorationRangeBehavior.OpenClosed:return 2;case t.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Fe})(we||(e.DecorationRangeBehavior=we={}));var ke;(function(De){function Fe(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?we.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?de.from(he.light):void 0,dark:he.dark?de.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?W(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?ae.from(he.before):void 0,after:he.after?ae.from(he.after):void 0}}De.from=Fe})(ke||(e.DecorationRenderOptions=ke={}));var ue;(function(De){function Fe(Q){return{text:Q.newText,eol:Q.newEol&&at.from(Q.newEol),range:p.from(Q.range)}}De.from=Fe;function he(Q){const Ie=new t.$gL(p.to(Q.range),Q.text);return Ie.newEol=typeof Q.eol>"u"?void 0:at.to(Q.eol),Ie}De.to=he})(ue||(e.TextEdit=ue={}));var pe;(function(De){function Fe(Q,Ie){const Oe={edits:[]};if(Q instanceof t.$jL){const Ye=new m.$Bc;for(const We of Q._allEntries())We._type===1&&$.URI.isUri(We.to)&&We.from===void 0&&Ye.add(We.to);for(const We of Q._allEntries())if(We._type===1){let st;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?st={type:"base64",value:(0,M.$De)(M.$je.wrap(We.options.contents))}:st={type:"dataTransferItem",id:We.options.contents._itemId}),Oe.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:st},metadata:We.metadata})}else We._type===2?Oe.edits.push({resource:We.uri,textEdit:ue.from(We.edit),versionId:Ye.has(We.uri)?void 0:Ie?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Oe.edits.push({resource:We.uri,textEdit:{range:p.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ye.has(We.uri)?void 0:Ie?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Oe.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Ie?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Oe.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Ie?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(At.from)}})}return Oe}De.from=Fe;function he(Q){const Ie=new t.$jL,Oe=new m.$Ac;for(const Ye of Q.edits)if(Ye.textEdit){const We=Ye,st=$.URI.revive(We.resource),wt=p.to(We.textEdit.range),Kt=We.textEdit.text,kt=We.textEdit.insertAsSnippet;let Dt;kt?Dt=t.$iL.replace(wt,new t.$kL(Kt)):Dt=t.$gL.replace(wt,Kt);const vt=Oe.get(st);vt?vt.push(Dt):Oe.set(st,[Dt])}else Ie.renameFile($.URI.revive(Ye.oldResource),$.URI.revive(Ye.newResource),Ye.options);for(const[Ye,We]of Oe)Ie.set(Ye,We);return Ie}De.to=he})(pe||(e.WorkspaceEdit=pe={}));var ie;(function(De){const Fe=Object.create(null);Fe[t.SymbolKind.File]=0,Fe[t.SymbolKind.Module]=1,Fe[t.SymbolKind.Namespace]=2,Fe[t.SymbolKind.Package]=3,Fe[t.SymbolKind.Class]=4,Fe[t.SymbolKind.Method]=5,Fe[t.SymbolKind.Property]=6,Fe[t.SymbolKind.Field]=7,Fe[t.SymbolKind.Constructor]=8,Fe[t.SymbolKind.Enum]=9,Fe[t.SymbolKind.Interface]=10,Fe[t.SymbolKind.Function]=11,Fe[t.SymbolKind.Variable]=12,Fe[t.SymbolKind.Constant]=13,Fe[t.SymbolKind.String]=14,Fe[t.SymbolKind.Number]=15,Fe[t.SymbolKind.Boolean]=16,Fe[t.SymbolKind.Array]=17,Fe[t.SymbolKind.Object]=18,Fe[t.SymbolKind.Key]=19,Fe[t.SymbolKind.Null]=20,Fe[t.SymbolKind.EnumMember]=21,Fe[t.SymbolKind.Struct]=22,Fe[t.SymbolKind.Event]=23,Fe[t.SymbolKind.Operator]=24,Fe[t.SymbolKind.TypeParameter]=25;function he(Ie){return typeof Fe[Ie]=="number"?Fe[Ie]:6}De.from=he;function Q(Ie){for(const Oe in Fe)if(Fe[Oe]===Ie)return Number(Oe);return t.SymbolKind.Property}De.to=Q})(ie||(e.SymbolKind=ie={}));var be;(function(De){function Fe(Q){switch(Q){case t.SymbolTag.Deprecated:return 1}}De.from=Fe;function he(Q){switch(Q){case 1:return t.SymbolTag.Deprecated}}De.to=he})(be||(e.SymbolTag=be={}));var se;(function(De){function Fe(Q){return{name:Q.name,kind:ie.from(Q.kind),tags:Q.tags&&Q.tags.map(be.from),containerName:Q.containerName,location:Le.from(Q.location)}}De.from=Fe;function he(Q){const Ie=new t.$rL(Q.name,ie.to(Q.kind),Q.containerName,Le.to(Q.location));return Ie.tags=Q.tags&&Q.tags.map(be.to),Ie}De.to=he})(se||(e.WorkspaceSymbol=se={}));var Z;(function(De){function Fe(Q){const Ie={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:p.from(Q.range),selectionRange:p.from(Q.selectionRange),kind:ie.from(Q.kind),tags:Q.tags?.map(be.from)??[]};return Q.children&&(Ie.children=Q.children.map(Fe)),Ie}De.from=Fe;function he(Q){const Ie=new t.$sL(Q.name,Q.detail,ie.to(Q.kind),p.to(Q.range),p.to(Q.selectionRange));return(0,y.$Lb)(Q.tags)&&(Ie.tags=Q.tags.map(be.to)),Q.children&&(Ie.children=Q.children.map(he)),Ie}De.to=he})(Z||(e.DocumentSymbol=Z={}));var V;(function(De){function Fe(Q){const Ie=new t.$wL(ie.to(Q.kind),Q.name,Q.detail||"",$.URI.revive(Q.uri),p.to(Q.range),p.to(Q.selectionRange));return Ie._sessionId=Q._sessionId,Ie._itemId=Q._itemId,Ie}De.to=Fe;function he(Q,Ie,Oe){if(Ie=Ie??Q._sessionId,Oe=Oe??Q._itemId,Ie===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Oe,name:Q.name,detail:Q.detail,kind:ie.from(Q.kind),uri:Q.uri,range:p.from(Q.range),selectionRange:p.from(Q.selectionRange),tags:Q.tags?.map(be.from)}}De.from=he})(V||(e.CallHierarchyItem=V={}));var ne;(function(De){function Fe(he){return new t.$xL(V.to(he.from),he.fromRanges.map(Q=>p.to(Q)))}De.to=Fe})(ne||(e.CallHierarchyIncomingCall=ne={}));var Ae;(function(De){function Fe(he){return new t.$yL(V.to(he.to),he.fromRanges.map(Q=>p.to(Q)))}De.to=Fe})(Ae||(e.CallHierarchyOutgoingCall=Ae={}));var Le;(function(De){function Fe(Q){return{range:Q.range&&p.from(Q.range),uri:Q.uri}}De.from=Fe;function he(Q){return new t.$lL($.URI.revive(Q.uri),p.to(Q.range))}De.to=he})(Le||(e.location=Le={}));var Ce;(function(De){function Fe(Q){const Ie=Q,Oe=Q;return{originSelectionRange:Ie.originSelectionRange?p.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Oe.uri,range:p.from(Ie.targetRange?Ie.targetRange:Oe.range),targetSelectionRange:Ie.targetSelectionRange?p.from(Ie.targetSelectionRange):void 0}}De.from=Fe;function he(Q){return{targetUri:$.URI.revive(Q.uri),targetRange:p.to(Q.range),targetSelectionRange:Q.targetSelectionRange?p.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?p.to(Q.originSelectionRange):void 0}}De.to=he})(Ce||(e.DefinitionLink=Ce={}));var ce;(function(De){function Fe(Q){return{range:p.from(Q.range),contents:I.fromMany(Q.contents)}}De.from=Fe;function he(Q){return new t.$oL(Q.contents.map(I.to),p.to(Q.range))}De.to=he})(ce||(e.Hover=ce={}));var te;(function(De){function Fe(Q){return{range:p.from(Q.range),expression:Q.expression}}De.from=Fe;function he(Q){return new t.$iM(p.to(Q.range),Q.expression)}De.to=he})(te||(e.EvaluatableExpression=te={}));var J;(function(De){function Fe(Q){if(Q instanceof t.$jM)return{type:"text",range:p.from(Q.range),text:Q.text};if(Q instanceof t.$kM)return{type:"variable",range:p.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof t.$lM)return{type:"expression",range:p.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Fe;function he(Q){switch(Q.type){case"text":return{range:p.to(Q.range),text:Q.text};case"variable":return{range:p.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:p.to(Q.range),expression:Q.expression}}}De.to=he})(J||(e.InlineValue=J={}));var ee;(function(De){function Fe(Q){return{frameId:Q.frameId,stoppedLocation:p.from(Q.stoppedLocation)}}De.from=Fe;function he(Q){return new t.$mM(Q.frameId,p.to(Q.stoppedLocation))}De.to=he})(ee||(e.InlineValueContext=ee={}));var me;(function(De){function Fe(Q){return{range:p.from(Q.range),kind:Q.kind}}De.from=Fe;function he(Q){return new t.$pL(p.to(Q.range),Q.kind)}De.to=he})(me||(e.DocumentHighlight=me={}));var ve;(function(De){function Fe(Q){return{uri:Q.uri,highlights:Q.highlights.map(me.from)}}De.from=Fe;function he(Q){return new t.$qL($.URI.revive(Q.uri),Q.highlights.map(me.to))}De.to=he})(ve||(e.MultiDocumentHighlight=ve={}));var Me;(function(De){function Fe(he){switch(he){case 1:return t.CompletionTriggerKind.TriggerCharacter;case 2:return t.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return t.CompletionTriggerKind.Invoke}}De.to=Fe})(Me||(e.CompletionTriggerKind=Me={}));var fe;(function(De){function Fe(he){return{triggerKind:Me.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}De.to=Fe})(fe||(e.CompletionContext=fe={}));var ye;(function(De){function Fe(Q){switch(Q){case t.CompletionItemTag.Deprecated:return 1}}De.from=Fe;function he(Q){switch(Q){case 1:return t.CompletionItemTag.Deprecated}}De.to=he})(ye||(e.CompletionItemTag=ye={}));var F;(function(De){const Fe=new Map([[t.CompletionItemKind.Method,0],[t.CompletionItemKind.Function,1],[t.CompletionItemKind.Constructor,2],[t.CompletionItemKind.Field,3],[t.CompletionItemKind.Variable,4],[t.CompletionItemKind.Class,5],[t.CompletionItemKind.Interface,7],[t.CompletionItemKind.Struct,6],[t.CompletionItemKind.Module,8],[t.CompletionItemKind.Property,9],[t.CompletionItemKind.Unit,12],[t.CompletionItemKind.Value,13],[t.CompletionItemKind.Constant,14],[t.CompletionItemKind.Enum,15],[t.CompletionItemKind.EnumMember,16],[t.CompletionItemKind.Keyword,17],[t.CompletionItemKind.Snippet,27],[t.CompletionItemKind.Text,18],[t.CompletionItemKind.Color,19],[t.CompletionItemKind.File,20],[t.CompletionItemKind.Reference,21],[t.CompletionItemKind.Folder,23],[t.CompletionItemKind.Event,10],[t.CompletionItemKind.Operator,11],[t.CompletionItemKind.TypeParameter,24],[t.CompletionItemKind.Issue,26],[t.CompletionItemKind.User,25]]);function he(Oe){return Fe.get(Oe)??9}De.from=he;const Q=new Map([[0,t.CompletionItemKind.Method],[1,t.CompletionItemKind.Function],[2,t.CompletionItemKind.Constructor],[3,t.CompletionItemKind.Field],[4,t.CompletionItemKind.Variable],[5,t.CompletionItemKind.Class],[7,t.CompletionItemKind.Interface],[6,t.CompletionItemKind.Struct],[8,t.CompletionItemKind.Module],[9,t.CompletionItemKind.Property],[12,t.CompletionItemKind.Unit],[13,t.CompletionItemKind.Value],[14,t.CompletionItemKind.Constant],[15,t.CompletionItemKind.Enum],[16,t.CompletionItemKind.EnumMember],[17,t.CompletionItemKind.Keyword],[27,t.CompletionItemKind.Snippet],[18,t.CompletionItemKind.Text],[19,t.CompletionItemKind.Color],[20,t.CompletionItemKind.File],[21,t.CompletionItemKind.Reference],[23,t.CompletionItemKind.Folder],[10,t.CompletionItemKind.Event],[11,t.CompletionItemKind.Operator],[24,t.CompletionItemKind.TypeParameter],[25,t.CompletionItemKind.User],[26,t.CompletionItemKind.Issue]]);function Ie(Oe){return Q.get(Oe)??t.CompletionItemKind.Property}De.to=Ie})(F||(e.CompletionItemKind=F={}));var H;(function(De){function Fe(he,Q){const Ie=new t.$GL(he.label);return Ie.insertText=he.insertText,Ie.kind=F.to(he.kind),Ie.tags=he.tags?.map(ye.to),Ie.detail=he.detail,Ie.documentation=P.$jk(he.documentation)?I.to(he.documentation):he.documentation,Ie.sortText=he.sortText,Ie.filterText=he.filterText,Ie.preselect=he.preselect,Ie.commitCharacters=he.commitCharacters,v.$Us.isIRange(he.range)?Ie.range=p.to(he.range):typeof he.range=="object"&&(Ie.range={inserting:p.to(he.range.insert),replacing:p.to(he.range.replace)}),Ie.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?Ie.insertText=new t.$kL(he.insertText):(Ie.insertText=he.insertText,Ie.textEdit=Ie.range instanceof t.$bL?new t.$gL(Ie.range,Ie.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Ie.additionalTextEdits=he.additionalTextEdits.map(Oe=>ue.to(Oe))),Ie.command=Q&&he.command?Q.fromInternal(he.command):void 0,Ie}De.to=Fe})(H||(e.CompletionItem=H={}));var K;(function(De){function Fe(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:I.fromStrict(Q.documentation)}}De.from=Fe;function he(Q){return{label:Q.label,documentation:P.$jk(Q.documentation)?I.to(Q.documentation):Q.documentation}}De.to=he})(K||(e.ParameterInformation=K={}));var j;(function(De){function Fe(Q){return{label:Q.label,documentation:I.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(K.from):[],activeParameter:Q.activeParameter}}De.from=Fe;function he(Q){return{label:Q.label,documentation:P.$jk(Q.documentation)?I.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(K.to):[],activeParameter:Q.activeParameter}}De.to=he})(j||(e.SignatureInformation=j={}));var Y;(function(De){function Fe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(j.from):[]}}De.from=Fe;function he(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(j.to):[]}}De.to=he})(Y||(e.SignatureHelp=Y={}));var _;(function(De){function Fe(he,Q){const Ie=new t.$FL(L.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(Ee.to.bind(void 0,he)),Q.kind&&Ne.to(Q.kind));return Ie.textEdits=Q.textEdits&&Q.textEdits.map(ue.to),Ie.tooltip=P.$jk(Q.tooltip)?I.to(Q.tooltip):Q.tooltip,Ie.paddingLeft=Q.paddingLeft,Ie.paddingRight=Q.paddingRight,Ie}De.to=Fe})(_||(e.InlayHint=_={}));var Ee;(function(De){function Fe(he,Q){const Ie=new t.$EL(Q.label);return Ie.tooltip=P.$jk(Q.tooltip)?I.to(Q.tooltip):Q.tooltip,s.Command.is(Q.command)&&(Ie.command=he.fromInternal(Q.command)),Q.location&&(Ie.location=Le.to(Q.location)),Ie}De.to=Fe})(Ee||(e.InlayHintLabelPart=Ee={}));var Ne;(function(De){function Fe(Q){return Q}De.from=Fe;function he(Q){return Q}De.to=he})(Ne||(e.InlayHintKind=Ne={}));var Ve;(function(De){function Fe(Q){return{range:p.from(Q.range),url:Q.target,tooltip:Q.tooltip}}De.from=Fe;function he(Q){let Ie;if(Q.url)try{Ie=typeof Q.url=="string"?$.URI.parse(Q.url,!0):$.URI.revive(Q.url)}catch{}return new t.$LL(p.to(Q.range),Ie)}De.to=he})(Ve||(e.DocumentLink=Ve={}));var Ke;(function(De){function Fe(Q){const Ie=new t.$OL(Q.label);return Q.textEdit&&(Ie.textEdit=ue.to(Q.textEdit)),Q.additionalTextEdits&&(Ie.additionalTextEdits=Q.additionalTextEdits.map(Oe=>ue.to(Oe))),Ie}De.to=Fe;function he(Q){return{label:Q.label,textEdit:Q.textEdit?ue.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Ie=>ue.from(Ie)):void 0}}De.from=he})(Ke||(e.ColorPresentation=Ke={}));var Xe;(function(De){function Fe(Q){return new t.$ML(Q[0],Q[1],Q[2],Q[3])}De.to=Fe;function he(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}De.from=he})(Xe||(e.Color=Xe={}));var nt;(function(De){function Fe(Q){return{range:p.from(Q.range)}}De.from=Fe;function he(Q){return new t.$vL(p.to(Q.range))}De.to=he})(nt||(e.SelectionRange=nt={}));var it;(function(De){function Fe(he){switch(he){case 2:return t.TextDocumentSaveReason.AfterDelay;case 1:return t.TextDocumentSaveReason.Manual;case 3:case 4:return t.TextDocumentSaveReason.FocusOut}}De.to=Fe})(it||(e.TextDocumentSaveReason=it={}));var et;(function(De){function Fe(Q){switch(Q){case t.TextEditorLineNumbersStyle.Off:return 0;case t.TextEditorLineNumbersStyle.Relative:return 2;case t.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Fe;function he(Q){switch(Q){case 0:return t.TextEditorLineNumbersStyle.Off;case 2:return t.TextEditorLineNumbersStyle.Relative;case 1:default:return t.TextEditorLineNumbersStyle.On}}De.to=he})(et||(e.TextEditorLineNumbersStyle=et={}));var at;(function(De){function Fe(Q){if(Q===t.EndOfLine.CRLF)return 1;if(Q===t.EndOfLine.LF)return 0}De.from=Fe;function he(Q){if(Q===1)return t.EndOfLine.CRLF;if(Q===0)return t.EndOfLine.LF}De.to=he})(at||(e.EndOfLine=at={}));var ct;(function(De){function Fe(he){if(typeof he=="object")return he.viewId;switch(he){case t.ProgressLocation.SourceControl:return 3;case t.ProgressLocation.Window:return 10;case t.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Fe})(ct||(e.ProgressLocation=ct={}));var je;(function(De){function Fe(Q){const Ie={start:Q.start+1,end:Q.end+1};return Q.kind&&(Ie.kind=mt.from(Q.kind)),Ie}De.from=Fe;function he(Q){const Ie={start:Q.start-1,end:Q.end-1};return Q.kind&&(Ie.kind=mt.to(Q.kind)),Ie}De.to=he})(je||(e.FoldingRange=je={}));var mt;(function(De){function Fe(Q){if(Q)switch(Q){case t.FoldingRangeKind.Comment:return s.$Kt.Comment;case t.FoldingRangeKind.Imports:return s.$Kt.Imports;case t.FoldingRangeKind.Region:return s.$Kt.Region}}De.from=Fe;function he(Q){if(Q)switch(Q.value){case s.$Kt.Comment.value:return t.FoldingRangeKind.Comment;case s.$Kt.Imports.value:return t.FoldingRangeKind.Imports;case s.$Kt.Region.value:return t.FoldingRangeKind.Region}}De.to=he})(mt||(e.FoldingRangeKind=mt={}));var X;(function(De){function Fe(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?p.from(he.selection):void 0,override:typeof he.override=="boolean"?n.$EE.id:void 0}}De.from=Fe})(X||(e.TextEditorOpenOptions=X={}));var x;(function(De){function Fe(Oe){return Oe instanceof t.$9L?Oe.toJSON():typeof Oe=="string"?Oe:he(Oe)||Q(Oe)?new t.$9L(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}De.from=Fe;function he(Oe){const Ye=Oe;return Ye?$.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function Q(Oe){const Ye=Oe;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Ie(Oe){return typeof Oe=="string"?Oe:new t.$9L($.URI.revive(Oe.baseUri),Oe.pattern)}De.to=Ie})(x||(e.GlobPattern=x={}));var $e;(function(De){function Fe(he){if(he){if(Array.isArray(he))return he.map(Fe);if(typeof he=="string")return he;{const Q=he;return{language:Q.language,scheme:Q.scheme,pattern:x.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}De.from=Fe})($e||(e.LanguageSelector=$e={}));var Be;(function(De){function Fe(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Ie=>Array.isArray(Ie)&&Ie.every(Oe=>Oe&&typeof Oe=="object"&&"uri"in Oe&&$.URI.isUri(Oe.uri)&&"version"in Oe&&typeof Oe.version=="number"&&"ranges"in Oe&&Array.isArray(Oe.ranges)&&Oe.ranges.every(Ye=>Ye instanceof t.$bL)))}De.is=Fe;function he(Q){return{documents:Q.documents.map(Ie=>Ie.map(Oe=>({uri:$.URI.from(Oe.uri),version:Oe.version,ranges:Oe.ranges.map(Ye=>p.from(Ye))})))}}De.from=he})(Be||(e.MappedEditsContext=Be={}));var Qe;(function(De){function Fe(Q){return{start:Q.start,end:Q.end}}De.from=Fe;function he(Q){return new t.$xM(Q.start,Q.end)}De.to=he})(Qe||(e.NotebookRange=Qe={}));var tt;(function(De){function Fe(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}De.to=Fe;function he(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}De.from=he})(tt||(e.NotebookCellExecutionSummary=tt={}));var rt;(function(De){function Fe(he){if(he===o.NotebookCellExecutionState.Unconfirmed)return t.NotebookCellExecutionState.Pending;if(he===o.NotebookCellExecutionState.Pending)return;if(he===o.NotebookCellExecutionState.Executing)return t.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}De.to=Fe})(rt||(e.NotebookCellExecutionState=rt={}));var Te;(function(De){function Fe(Q){switch(Q){case t.NotebookCellKind.Markup:return o.CellKind.Markup;case t.NotebookCellKind.Code:default:return o.CellKind.Code}}De.from=Fe;function he(Q){switch(Q){case o.CellKind.Markup:return t.NotebookCellKind.Markup;case o.CellKind.Code:default:return t.NotebookCellKind.Code}}De.to=he})(Te||(e.NotebookCellKind=Te={}));var zt;(function(De){function Fe(Q){const Ie={metadata:Q.metadata??Object.create(null),cells:[]};for(const Oe of Q.cells)t.$yM.validate(Oe),Ie.cells.push(At.from(Oe));return Ie}De.from=Fe;function he(Q){const Ie=new t.$zM(Q.cells.map(At.to));return(0,l.$Vf)(Q.metadata)||(Ie.metadata=Q.metadata),Ie}De.to=he})(zt||(e.NotebookData=zt={}));var At;(function(De){function Fe(Q){return{cellKind:Te.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:tt.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Ft.from):[]}}De.from=Fe;function he(Q){return new t.$yM(Te.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Ft.to):void 0,Q.metadata,Q.internalMetadata?tt.to(Q.internalMetadata):void 0)}De.to=he})(At||(e.NotebookCellData=At={}));var Gt;(function(De){function Fe(Q){return{mime:Q.mime,valueBytes:M.$je.wrap(Q.data)}}De.from=Fe;function he(Q){return new t.$AM(Q.valueBytes.buffer,Q.mime)}De.to=he})(Gt||(e.NotebookCellOutputItem=Gt={}));var Ft;(function(De){function Fe(Q){return{outputId:Q.id,items:Q.items.map(Gt.from),metadata:Q.metadata}}De.from=Fe;function he(Q){const Ie=Q.items.map(Gt.to);return new t.$BM(Ie,Q.outputId,Q.metadata)}De.to=he})(Ft||(e.NotebookCellOutput=Ft={}));var yt;(function(De){function Fe(Ie){return Q(Ie)?{include:x.from(Ie.include)??void 0,exclude:x.from(Ie.exclude)??void 0}:x.from(Ie)??void 0}De.from=Fe;function he(Ie){return Q(Ie)?{include:x.to(Ie.include),exclude:x.to(Ie.exclude)}:x.to(Ie)}De.to=he;function Q(Ie){const Oe=Ie;return Oe?!(0,l.$Rf)(Oe.include)&&!(0,l.$Rf)(Oe.exclude):!1}})(yt||(e.NotebookExclusiveDocumentPattern=yt={}));var qt;(function(De){function Fe(he,Q,Ie){const Oe=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===t.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Oe,Ie),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}De.from=Fe})(qt||(e.NotebookStatusBarItem=qt={}));var Tt;(function(De){function Fe(he,Q,Ie){const Oe=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:Q.toInternal(Oe,Ie),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}De.from=Fe})(Tt||(e.NotebookKernelSourceAction=Tt={}));var Xt;(function(De){function Fe(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}De.from=Fe})(Xt||(e.NotebookDocumentContentOptions=Xt={}));var Vt;(function(De){function Fe(Q){return{uri:Q.uri,provides:Q.provides}}De.from=Fe;function he(Q){return new t.$DM($.URI.revive(Q.uri),Q.provides)}De.to=he})(Vt||(e.NotebookRendererScript=Vt={}));var Ut;(function(De){function Fe(Q){return{message:I.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:p.from(Q.location.range),uri:Q.location.uri}}}De.from=Fe;function he(Q){const Ie=new t.$JM(typeof Q.message=="string"?Q.message:I.to(Q.message));return Ie.actualOutput=Q.actual,Ie.expectedOutput=Q.expected,Ie.contextValue=Q.contextValue,Ie.location=Q.location?Le.to(Q.location):void 0,Ie}De.to=he})(Ut||(e.TestMessage=Ut={}));var Ze;(function(De){De.namespace=h.$6J,De.denamespace=h.$7J})(Ze||(e.TestTag=Ze={}));var Ht;(function(De){function Fe(Q){const Ie=(0,r.$0M)(Q).controllerId;return{extId:c.$2J.fromExtHostTestItem(Q,Ie).toString(),label:Q.label,uri:$.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Oe=>Ze.namespace(Ie,Oe.id)),range:v.$Us.lift(p.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&I.fromStrict(Q.error)||null}}De.from=Fe;function he(Q){return{parent:void 0,error:void 0,id:c.$2J.fromString(Q.extId).localId,label:Q.label,uri:$.URI.revive(Q.uri),tags:(Q.tags||[]).map(Ie=>{const{tagId:Oe}=Ze.denamespace(Ie);return new t.$KM(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:p.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}De.toPlain=he})(Ht||(e.TestItem=Ht={})),function(De){function Fe(Q){return{id:Q.id}}De.from=Fe;function he(Q){return new t.$KM(Q.id)}De.to=he}(Ze||(e.TestTag=Ze={}));var Jt;(function(De){const Fe=(Q,Ie)=>{const Oe=[];for(const[We,st]of Ie)c.$2J.compare(st.item.extId,We)===2&&(Ie.delete(We),Oe.push(st));const Ye={...Ht.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(st=>st.type===0).map(Ut.to)})),children:Oe.map(We=>Fe(We,Ie))};for(const We of Ye.children)We.parent=Ye;return Ye};function he(Q){const Ie=[],Oe=new Map;for(const Ye of Q.items){Oe.set(Ye.item.extId,Ye);const We=c.$2J.root(Ye.item.extId);Q.request.targets.some(st=>st.controllerId===We&&st.testIds.includes(Ye.item.extId))&&Ie.push(Ye)}return{completedAt:Q.completedAt,results:Ie.map(Ye=>Fe(Ye,Oe))}}De.to=he})(Jt||(e.TestResults=Jt={}));var lt;(function(De){function Fe(Oe){return{covered:Oe.covered,total:Oe.total}}function he(Oe){return"line"in Oe?L.from(Oe):p.from(Oe)}function Q(Oe){return"branches"in Oe?{count:Oe.executionCount,location:he(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&he(Ye.location),label:Ye.label})):void 0}:{type:0,name:Oe.name,count:Oe.executionCount,location:he(Oe.location)}}De.fromDetailed=Q;function Ie(Oe){return{uri:Oe.uri,statement:Fe(Oe.statementCoverage),branch:Oe.branchCoverage&&Fe(Oe.branchCoverage),function:Oe.functionCoverage&&Fe(Oe.functionCoverage),details:Oe.detailedCoverage?.map(Q)}}De.fromFile=Ie})(lt||(e.TestCoverage=lt={}));var $t;(function(De){function Fe(he){switch(he){case 1:return t.CodeActionTriggerKind.Invoke;case 2:return t.CodeActionTriggerKind.Automatic}}De.to=Fe})($t||(e.CodeActionTriggerKind=$t={}));var jt;(function(De){function Fe(Q){const Ie=new t.$QM(ie.to(Q.kind),Q.name,Q.detail||"",$.URI.revive(Q.uri),p.to(Q.range),p.to(Q.selectionRange));return Ie._sessionId=Q._sessionId,Ie._itemId=Q._itemId,Ie}De.to=Fe;function he(Q,Ie,Oe){if(Ie=Ie??Q._sessionId,Oe=Oe??Q._itemId,Ie===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Oe,kind:ie.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:p.from(Q.range),selectionRange:p.from(Q.selectionRange),tags:Q.tags?.map(be.from)}}De.from=he})(jt||(e.TypeHierarchyItem=jt={}));var Qt;(function(De){function Fe(he){if(he)return{value:he.value,tooltip:he.tooltip}}De.from=Fe})(Qt||(e.ViewBadge=Qt={}));var Et;(function(De){function Fe(Oe,Ye,We){const st=Ye.fileData;return st?new t.$2L(new t.$3L(st.name,$.URI.revive(st.uri),st.id,(0,A.$db)(()=>We(st.id)))):Oe===R.$fs.uriList&&Ye.uriListData?new t.$1L(Ie(Ye.uriListData)):new t.$1L(Ye.asString)}De.to=Fe;async function he(Oe,Ye){const We=await Ye.asString();if(Oe===R.$fs.uriList)return{asString:We,fileData:void 0,uriListData:Q(We)};const st=Ye.asFile();return{asString:We,fileData:st?{name:st.name,uri:st.uri,id:st._itemId??st.id}:void 0}}De.from=he;function Q(Oe){return C.$rt.split(Oe).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return $.URI.parse(Ye)}catch{}return Ye})}function Ie(Oe){return C.$rt.create(Oe.map(Ye=>typeof Ye=="string"?Ye:$.URI.revive(Ye)))}})(Et||(e.DataTransferItem=Et={}));var dt;(function(De){function Fe(Q,Ie){const Oe=Q.items.map(([Ye,We])=>[Ye,Et.to(Ye,We,Ie)]);return new t.$4L(Oe)}De.toDataTransfer=Fe;async function he(Q){const Ie={items:[]},Oe=[];for(const[Ye,We]of Q)Oe.push((async()=>{Ie.items.push([Ye,await Et.from(Ye,We)])})());return await Promise.all(Oe),Ie}De.from=he})(dt||(e.DataTransfer=dt={}));var St;(function(De){function Fe(he){return{kind:"reply",message:he.message,title:he.title,tooltip:he.tooltip}}De.from=Fe})(St||(e.ChatReplyFollowup=St={}));var _t;(function(De){function Fe(he){return typeof he=="string"?{title:he,message:he,kind:"reply"}:"commandId"in he?{kind:"command",title:he.title??"",commandId:he.commandId??"",when:he.when??"",args:he.args}:St.from(he)}De.from=Fe})(_t||(e.ChatFollowup=_t={}));var Ct;(function(De){function Fe(Q){const Ie=new t.$3M(qe.to(Q.role),Q.content);return Ie.name=Q.name,Ie}De.to=Fe;function he(Q){return{role:qe.from(Q.role),content:Q.content,name:Q.name}}De.from=he})(Ct||(e.ChatMessage=Ct={}));var qe;(function(De){function Fe(Q){switch(Q){case 0:return t.ChatMessageRole.System;case 1:return t.ChatMessageRole.User;case 2:return t.ChatMessageRole.Assistant;case 3:return t.ChatMessageRole.Function}}De.to=Fe;function he(Q){switch(Q){case t.ChatMessageRole.System:return 0;case t.ChatMessageRole.Assistant:return 2;case t.ChatMessageRole.Function:return 3;case t.ChatMessageRole.User:default:return 1}}De.from=he})(qe||(e.ChatMessageRole=qe={}));var Lt;(function(De){function Fe(Ie){const Oe={};for(const Ye of Object.keys(Ie))Oe[Ye]=Ie[Ye].map(De.to);return Oe}De.objectTo=Fe;function he(Ie){return{level:Nt.to(Ie.level),kind:Ie.kind,value:(0,$.$vc)(Ie.value)?$.URI.revive(Ie.value):Ie.value,description:Ie.description}}De.to=he;function Q(Ie){return{level:Nt.from(Ie.level),kind:Ie.kind,value:Ie.value,description:Ie.description}}De.from=Q})(Lt||(e.ChatVariable=Lt={}));var Nt;(function(De){function Fe(Q){switch(Q){case"short":return t.ChatVariableLevel.Short;case"medium":return t.ChatVariableLevel.Medium;case"full":default:return t.ChatVariableLevel.Full}}De.to=Fe;function he(Q){switch(Q){case t.ChatVariableLevel.Short:return"short";case t.ChatVariableLevel.Medium:return"medium";case t.ChatVariableLevel.Full:default:return"full"}}De.from=he})(Nt||(e.ChatVariableLevel=Nt={}));var Yt;(function(De){function Fe(he){switch(he){case 1:return t.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return t.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return t.InteractiveEditorResponseFeedbackKind.Undone;case 3:return t.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return t.InteractiveEditorResponseFeedbackKind.Bug}}De.to=Fe})(Yt||(e.InteractiveEditorResponseFeedbackKind=Yt={}));var ft;(function(De){function Fe(Ie,Oe){return"placeholder"in Oe&&"resolvedContent"in Oe?{content:Oe.placeholder,kind:"asyncContent"}:"markdownContent"in Oe?((0,u.$GF)(Ie,"chatAgents2Additions"),{content:I.from(Oe.markdownContent),kind:"markdownContent"}):"content"in Oe?"vulnerabilities"in Oe&&Oe.vulnerabilities?((0,u.$GF)(Ie,"chatAgents2Additions"),{content:Oe.content,vulnerabilities:Oe.vulnerabilities,kind:"vulnerability"}):typeof Oe.content=="string"?{content:Oe.content,kind:"content"}:((0,u.$GF)(Ie,"chatAgents2Additions"),{content:I.from(Oe.content),kind:"markdownContent"}):"documents"in Oe?{documents:Oe.documents.map(Ye=>({uri:Ye.uri,version:Ye.version,ranges:Ye.ranges.map(We=>p.from(We))})),kind:"usedContext"}:"reference"in Oe?{reference:"uri"in Oe.reference?{uri:Oe.reference.uri,range:p.from(Oe.reference.range)}:Oe.reference,kind:"reference"}:"inlineReference"in Oe?{inlineReference:"uri"in Oe.inlineReference?{uri:Oe.inlineReference.uri,range:p.from(Oe.inlineReference.range)}:Oe.inlineReference,name:Oe.title,kind:"inlineReference"}:"agentName"in Oe?((0,u.$GF)(Ie,"chatAgents2Additions"),{agentName:Oe.agentName,command:Oe.command,kind:"agentDetection"}):"treeData"in Oe?{treeData:Oe.treeData,kind:"treeData"}:"message"in Oe?{content:I.from(Oe.message),kind:"progressMessage"}:void 0}De.from=Fe;function he(Ie){switch(Ie.kind){case"markdownContent":case"inlineReference":case"treeData":return De.to(Ie);case"content":return{content:Ie.content};case"usedContext":return{documents:Ie.documents.map(Oe=>({uri:$.URI.revive(Oe.uri),version:Oe.version,ranges:Oe.ranges.map(Ye=>p.to(Ye))}))};case"reference":return{reference:(0,$.$vc)(Ie.reference)?$.URI.revive(Ie.reference):d.to(Ie.reference)};case"agentDetection":return;case"progressMessage":return{message:Ie.content.value};case"vulnerability":return{content:Ie.content,vulnerabilities:Ie.vulnerabilities};default:return}}De.to=he;function Q(Ie){switch(Ie.kind){case"markdownContent":return{content:Ie.content.value};case"inlineReference":return{inlineReference:(0,$.$vc)(Ie.inlineReference)?$.URI.revive(Ie.inlineReference):d.to(Ie.inlineReference),title:Ie.name};case"treeData":return{treeData:(0,w.$Ch)(Ie.treeData)};default:return}}De.toProgressContent=Q})(ft||(e.ChatResponseProgress=ft={}));var Mt;(function(De){function Fe(he,Q){return{prompt:he.message,variables:Lt.objectTo(he.variables),slashCommand:Q,subCommand:he.command,agentId:he.agentId}}De.to=Fe})(Mt||(e.ChatAgentRequest=Mt={}));var Pt;(function(De){function Fe(he){return{label:he.label,values:he.values.map(Lt.from),insertText:he.insertText,detail:he.detail,documentation:he.documentation}}De.from=Fe})(Pt||(e.ChatAgentCompletionItem=Pt={}));var Bt;(function(De){function Fe(he,Q,Ie){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:Q.toInternal(he,Ie)}De.from=Fe})(Bt||(e.TerminalQuickFix=Bt={}))}),define(Pe[243],Re([1,0,3,17,8]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;let A=class{constructor(m,f){this.a=m.getProxy(y.$0K.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>f.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,f,w){const R=C.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,w?.isRefactoring??!1)}};e.$xgc=A,e.$xgc=A=Je([He(0,M.$bN)],A)}),define(Pe[244],Re([1,0,68,6,3,8]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;class P{static{this.a=0}constructor(w,R){this.extension=w,this.provider=R,this.handle=P.a++}}class m{static{this.a=0}constructor(w){this.b=new Map,this.c=new Map,this.d=w.getProxy(C.$0K.MainThreadChat)}registerChatProvider(w,R,k){const l=new P(w,k);return this.b.set(l.handle,l),this.d.$registerChatProvider(l.handle,R),(0,M.$Rc)(()=>{this.d.$unregisterChatProvider(l.handle),this.b.delete(l.handle)})}transferChatSession(w,R){const k=y.Iterable.find(this.c.keys(),l=>this.c.get(l)===w)??0;typeof k=="number"&&this.d.$transferChatSession(k,R)}sendInteractiveRequestToProvider(w,R){this.d.$sendRequestToProvider(w,R)}async $prepareChat(w,R){const k=this.b.get(w);if(!k)return;const l=await k.provider.prepareSession(R);if(!l)return;const $=m.a++;return this.c.set($,l),{id:$,requesterUsername:l.requester?.name,requesterAvatarIconUri:l.requester?.icon,responderUsername:l.responder?.name,responderAvatarIconUri:l.responder?.icon,inputPlaceholder:l.inputPlaceholder}}async $provideWelcomeMessage(w,R){const k=this.b.get(w);if(!k||!k.provider.provideWelcomeMessage)return;const l=await k.provider.provideWelcomeMessage(R);if(l)return l.map($=>typeof $=="string"?$:Array.isArray($)?$.map(v=>A.ChatReplyFollowup.from(v)):A.MarkdownString.from($))}async $provideSampleQuestions(w,R){const k=this.b.get(w);if(!k||!k.provider.provideSampleQuestions)return;const l=await k.provider.provideSampleQuestions(R);if(l)return l?.map($=>A.ChatReplyFollowup.from($))}$releaseSession(w){this.c.delete(w)}}e.$ygc=m}),define(Pe[245],Re([1,0,18,13,20,40,5,63,16,2,157,72,3,8,7,205,24]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class r{static{this.a=0}constructor(c,h,i){this.j=h,this.k=i,this.b=new Map,this.g=new Map,this.i=new Map,this.d=c.getProxy(l.$0K.MainThreadChatAgents2)}createChatAgent(c,h,i){const u=r.a++,t=new n(c,h,this.d,u,i);return this.b.set(u,t),this.d.$registerAgent(u,h,{}),t.apiAgent}async $invokeAgent(c,h,i,u){this.g.delete(h.sessionId);const t=this.b.get(c);if(!t)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let g=!1;function p(){if(g)throw new Error("Only valid while executing the command")}const d=new M.$qh;u.onCancellationRequested(()=>d.complete()),this.j.allowListExtensionWhile(t.extension.identifier,d.p);const S=h.command?await t.validateSlashCommand(h.command):void 0,L=m.$Rd.create(!1);let b;try{const E=await this.l(t,h,i),D=t.invoke($.ChatAgentRequest.to(h,S),{history:E},new k.$vv(T=>{p(),typeof b>"u"&&"content"in T&&(b=L.elapsed());const O=$.ChatResponseProgress.from(t.extension,T);if(!O){this.k.error("Unknown progress type: "+JSON.stringify(T));return}if("placeholder"in T&&"resolvedContent"in T){const G=Promise.all([this.d.$handleProgressChunk(h.requestId,O),T.resolvedContent]);(0,M.$Ug)(G,u).then(q=>{if(!q)return;const[U,I]=q,N=$.ChatResponseProgress.from(t.extension,I);if(!N){this.k.error("Unknown progress type: "+JSON.stringify(I));return}this.d.$handleProgressChunk(h.requestId,N,U??void 0)})}else this.d.$handleProgressChunk(h.requestId,O)}),u);return await(0,M.$Ug)(Promise.resolve(D).then(T=>{if(T){this.g.set(h.sessionId,T);let O=this.i.get(h.sessionId);O||(O=new Map,this.i.set(h.sessionId,O)),O.set(h.requestId,T);const G={firstProgress:b,totalElapsed:L.elapsed()};return{errorDetails:T.errorDetails,timings:G}}else this.g.delete(h.sessionId)}),u)}catch(E){return this.k.error(E,t.extension),{errorDetails:{message:(0,R.localize)(0,null,(0,A.$Qi)(E)),responseIsIncomplete:!0}}}finally{g=!0,d.complete()}}async l(c,h,i){return(0,y.$Hb)(await Promise.all(i.history.map(async u=>{const t=h.agentId===u.request.agentId&&this.i.get(h.sessionId)?.get(u.request.requestId)||u.result;return{request:$.ChatAgentRequest.to(u.request,void 0),response:(0,y.$Hb)(u.response.map(g=>$.ChatResponseProgress.toProgressContent(g))),result:t}})))}$releaseSession(c){this.g.delete(c),this.i.delete(c)}async $provideSlashCommands(c,h){const i=this.b.get(c);return i?i.provideSlashCommand(h):[]}$provideFollowups(c,h,i){const u=this.b.get(c);if(!u)return Promise.resolve([]);const t=this.g.get(h);return t?u.provideFollowups(t,i):Promise.resolve([])}$acceptFeedback(c,h,i,u,t){const g=this.b.get(c);if(!g)return;const p=this.i.get(h)?.get(i);if(!p)return;let d;switch(u){case s.InteractiveSessionVoteDirection.Down:d=v.ChatAgentResultFeedbackKind.Unhelpful;break;case s.InteractiveSessionVoteDirection.Up:d=v.ChatAgentResultFeedbackKind.Helpful;break}g.acceptFeedback(Object.freeze(t?{result:p,kind:d,reportIssue:t}:{result:p,kind:d}))}$acceptAction(c,h,i,u){const t=this.b.get(c);if(!t)return;const g=this.i.get(h)?.get(i);g&&u.action.kind!=="vote"&&t.acceptAction(Object.freeze({action:u.action,result:g}))}async $invokeCompletionProvider(c,h,i){const u=this.b.get(c);return u?(await u.invokeCompletionProvider(h,i)).map($.ChatAgentCompletionItem.from):[]}}e.$Agc=r;class n{constructor(c,h,i,u,t){this.extension=c,this.id=h,this.w=i,this.x=u,this.y=t,this.q=new P.$Vd,this.s=new P.$Vd}acceptFeedback(c){this.q.fire(c)}acceptAction(c){this.s.fire(c)}async invokeCompletionProvider(c,h){return this.u?await this.u.provider.provideCompletionItems(c,h)??[]:[]}async validateSlashCommand(c){this.b||(await this.provideSlashCommand(C.CancellationToken.None),(0,f.$Sf)(this.b));const h=this.b.find(i=>i.name===c);if(!h)throw new Error(`Unknown slashCommand: ${c}`);return h}async provideSlashCommand(c){if(!this.a)return[];const h=await this.a.provideSlashCommands(c);return h?(this.b=h,h.map(i=>({name:i.name,description:i.description,followupPlaceholder:i.followupPlaceholder,shouldRepopulate:i.shouldRepopulate,sampleRequest:i.sampleRequest}))):[]}async provideFollowups(c,h){if(!this.d)return[];const i=await this.d.provideFollowups(c,h);return i?i.map(u=>$.ChatFollowup.from(u)):[]}get apiAgent(){let c=!1,h=!1;const i=()=>{c||h||(h=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.g??"",fullName:this.i,icon:this.j?this.j instanceof w.URI?this.j:"light"in this.j?this.j.light:void 0:void 0,iconDark:this.j&&"dark"in this.j?this.j.dark:void 0,themeIcon:this.j instanceof v.$7L?this.j:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.k,isSecondary:this.o,helpTextPrefix:!this.l||typeof this.l=="string"?this.l:$.MarkdownString.from(this.l),helpTextPostfix:!this.m||typeof this.m=="string"?this.m:$.MarkdownString.from(this.m),sampleRequest:this.n,supportIssueReporting:this.t}),h=!1}))},u=this;return{get name(){return u.id},get description(){return u.g??""},set description(t){u.g=t,i()},get fullName(){return u.i??u.extension.displayName??u.extension.name},set fullName(t){u.i=t,i()},get iconPath(){return u.j},set iconPath(t){u.j=t,i()},get slashCommandProvider(){return u.a},set slashCommandProvider(t){u.a=t,i()},get followupProvider(){return u.d},set followupProvider(t){u.d=t,i()},get isDefault(){return(0,a.$GF)(u.extension,"defaultChatAgent"),u.k},set isDefault(t){(0,a.$GF)(u.extension,"defaultChatAgent"),u.k=t,i()},get helpTextPrefix(){return(0,a.$GF)(u.extension,"defaultChatAgent"),u.l},set helpTextPrefix(t){if((0,a.$GF)(u.extension,"defaultChatAgent"),!u.k)throw new Error("helpTextPrefix is only available on the default chat agent");u.l=t,i()},get helpTextPostfix(){return(0,a.$GF)(u.extension,"defaultChatAgent"),u.m},set helpTextPostfix(t){if((0,a.$GF)(u.extension,"defaultChatAgent"),!u.k)throw new Error("helpTextPostfix is only available on the default chat agent");u.m=t,i()},get isSecondary(){return(0,a.$GF)(u.extension,"defaultChatAgent"),u.o},set isSecondary(t){(0,a.$GF)(u.extension,"defaultChatAgent"),u.o=t,i()},get sampleRequest(){return u.n},set sampleRequest(t){u.n=t,i()},get supportIssueReporting(){return(0,a.$GF)(u.extension,"chatAgents2Additions"),u.t},set supportIssueReporting(t){(0,a.$GF)(u.extension,"chatAgents2Additions"),u.t=t,i()},get onDidReceiveFeedback(){return u.q.event},set agentVariableProvider(t){if(u.u=t,t){if(!t.triggerCharacters.length)throw new Error("triggerCharacters are required");u.w.$registerAgentCompletionsProvider(u.x,t.triggerCharacters)}else u.w.$unregisterAgentCompletionsProvider(u.x)},get agentVariableProvider(){return u.u},onDidPerformAction:(0,a.$FF)(this.extension,"chatAgents2Additions")?this.s.event:void 0,dispose(){c=!0,u.a=void 0,u.d=void 0,u.q.dispose(),u.w.$unregisterAgent(u.x)}}}invoke(c,h,i,u){return this.y(c,h,i,u)}}}),define(Pe[246],Re([1,0,20,6,3,8,72,23,13,5]),function(ge,e,y,M,C,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;class R{constructor(v,s){this.stream=new f.$wh,this.stream=s??new f.$wh;const a=this;this.apiObj={option:v,response:a.stream.asyncIterable}}}class k{constructor(v,s){this.a=new w.$Vd,this.b=new Map,this.c=new f.$wh,this.d=!1;const a=this;this.apiObject={result:v,response:a.c.asyncIterable,onDidStartResponseStream:a.a.event,cancel(){s.cancel()}},v.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,r]of this.b)r.stream.resolve();else this.c.resolve()})}handleFragment(v){if(this.d)return;let s=this.b.get(v.index);s||(this.b.size===0?s=new R(v.index,this.c):s=new R(v.index),this.b.set(v.index,s),this.a.fire(s.apiObj)),s.stream.emitOne(v.part)}}class l{static{this.a=1}constructor(v,s){this.d=s,this.c=new Map,this.e=new Map,this.f=new m.$nm,this.b=v.getProxy(C.$0K.MainThreadChatProvider)}registerProvider(v,s,a,r){const n=l.a++;return this.c.set(n,{extension:v,provider:a}),this.b.$registerProvider(n,s,{extension:v,model:r.name??""}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(v,s,a,r,n){const o=this.c.get(v);if(!o)return;const c=new P.$vv(async h=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(s,{index:h.index,part:h.part})});return o.provider.provideChatResponse(a.map(A.ChatMessage.to),r,c,n)}allowListExtensionWhile(v,s){this.f.set(v,s),s.finally(()=>this.f.delete(v))}async requestChatResponseProvider(v,s){if(!this.f.has(v))throw new Error("Extension is NOT allowed to make chat requests");const a=await this.b.$prepareChatAccess(s);if(!a)throw new Error(`ChatAccess '${s}' NOT found`);const r=this;return{get model(){return a.model},get isRevoked(){return!r.f.has(v)},makeRequest(n,o,c){if(!r.f.has(v))throw new Error("Access to chat has been revoked");const h=new y.$6d(c),i=Math.random()*1e6|0,u=r.b.$fetchResponse(v,s,i,n.map(A.ChatMessage.from),o??{},h.token),t=new k(u,h);return r.e.set(i,{res:t}),u.finally(()=>{r.e.delete(i)}),t.apiObject}}}async $handleResponseFragment(v,s){const a=this.e.get(v);a&&a.res.handleFragment(s)}}e.$zgc=l}),define(Pe[247],Re([1,0,6,3,15,8]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class P{static{this.a=0}constructor(f){this.b=new Map,this.c=f.getProxy(M.$0K.MainThreadChatVariables)}async $resolveVariable(f,w,R){const k=this.b.get(f);if(k)try{const l=await k.resolver.resolve(k.data.name,{prompt:w},R);if(l)return l.map(A.ChatVariable.from)}catch(l){(0,C.$2)(l)}}registerVariableResolver(f,w,R,k){const l=P.a++;return this.b.set(l,{extension:f.identifier,data:{name:w,description:R},resolver:k}),this.c.$registerVariable(l,{name:w,description:R}),(0,y.$Rc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$Bgc=P}),define(Pe[248],Re([1,0,13,67,5,6,2,87,23,8,7,3,24]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;function $(v,s,a){const r=v.getProxy(k.$0K.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$nm,s.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const S=this.b.get(d.handle);return S?S.value:d}else if(d&&d.$mid===7){const S=this.b.get(d.commentControlHandle);if(!S)return d;const L=S.getCommentThread(d.commentThreadHandle);return L?L.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const S=this.b.get(d.thread.commentControlHandle);if(!S)return d;const L=S.getCommentThread(d.thread.commentThreadHandle);return L?d.$mid===8?L.value:{thread:L.value,text:d.text}:d}else if(d&&d.$mid===10){const S=this.b.get(d.thread.commentControlHandle);if(!S)return d;const L=S.getCommentThread(d.thread.commentThreadHandle);if(!L)return d;const b=d.commentUniqueId,E=L.getCommentByUniqueId(b);return E||d}else if(d&&d.$mid===11){const S=this.b.get(d.thread.commentControlHandle);if(!S)return d;const L=S.getCommentThread(d.thread.commentThreadHandle);if(!L)return d;const b=d.text,E=d.commentUniqueId,D=L.getCommentByUniqueId(E);return D?(typeof D.body=="string"?D.body=b:D.body=new R.$AL(b),D):d}return d}})}createCommentController(d,S,L){const b=n.a++,E=new c(d,b,S,L);this.b.set(E.handle,E);const D=this.c.get(d.identifier)||[];return D.push(E),this.c.set(d.identifier,D),E.value}async $createCommentThreadTemplate(d,S,L){const b=this.b.get(d);b&&b.$createCommentThreadTemplate(S,L)}async $updateCommentThreadTemplate(d,S,L){const b=this.b.get(d);b&&b.$updateCommentThreadTemplate(S,L)}$deleteCommentThread(d,S){this.b.get(d)?.$deleteCommentThread(S)}$provideCommentingRanges(d,S,L){const b=this.b.get(d);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const E=a.getDocument(P.URI.revive(S));return(0,y.$Yg)(async()=>{const D=await b.commentingRangeProvider.provideCommentingRanges(E,L);let T;return Array.isArray(D)?T={ranges:D,fileComments:!1}:D?T={ranges:D.ranges||[],fileComments:D.fileComments||!1}:T=D??void 0,T}).then(D=>{let T;return D&&(T={ranges:D.ranges.map(O=>w.Range.from(O)),fileComments:D.fileComments}),T})}$toggleReaction(d,S,L,b,E){const D=this.b.get(d);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,y.$Yg)(()=>{const T=D.getCommentThread(S);if(T){const O=T.getCommentByUniqueId(b.uniqueIdInThread);if(D!==void 0&&O&&D.reactionHandler)return D.reactionHandler(O,u(E))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,S,L,b,E,D,T,O){this.m=S,this.n=L,this.o=b,this.p=E,this.q=D,this.extensionDescription=T,this.r=O,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Vd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Uc,this.l.value=new A.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),r.$createCommentThread(S,this.handle,this.n,this.o,w.Range.from(this.p),T.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{r.$deleteCommentThread(S,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(q){G.range=q},get comments(){return G.comments},set comments(q){G.comments=q},get collapsibleState(){return G.collapsibleState},set collapsibleState(q){G.collapsibleState=q},get canReply(){return G.canReply},set canReply(q){G.canReply=q},get contextValue(){return G.contextValue},set contextValue(q){G.contextValue=q},get label(){return G.label},set label(q){G.label=q},get state(){return G.state},set state(q){G.state=q},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Sc);const d=L=>Object.prototype.hasOwnProperty.call(this.b,L),S={};d("range")&&(S.range=w.Range.from(this.p)),d("label")&&(S.label=this.label),d("contextValue")&&(S.contextValue=this.contextValue??null),d("comments")&&(S.comments=this.q.map(L=>h(this,L,this.k,this.extensionDescription))),d("collapsibleState")&&(S.collapseState=t(this.g)),d("canReply")&&(S.canReply=this.canReply),d("state")&&(S.state=g(this.h)),d("isTemplate")&&(S.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(d){for(const S of this.k){const L=S[0],b=S[1];if(d===b)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Je([(0,M.$yh)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,S,L,b){this.f=d,this.g=S,this.h=L,this.i=b,this.a=new Map,r.$registerCommentController(this.handle,L,b,this.f.identifier.value);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(D){E.options=D},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(D){E.commentingRangeProvider=D},get reactionHandler(){return E.reactionHandler},set reactionHandler(D){E.reactionHandler=D},createCommentThread(D,T,O){return E.createCommentThread(D,T,O).value},dispose:()=>{E.dispose()}}),this.e=[],this.e.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(d,S,L){S===void 0&&(0,l.$GF)(this.f,"fileComments");const b=new o(this.id,this.handle,void 0,d,S,L,this.f,!1);return this.a.set(b.handle,b),b}$createCommentThreadTemplate(d,S){const L=new o(this.id,this.handle,void 0,P.URI.revive(d),w.Range.to(S),[],this.f,!0);return L.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(d,S){const L=this.a.get(d);L&&(L.range=w.Range.to(S))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function h(p,d,S,L){let b=S.get(d);return b||(b=++p.commentHandle,S.set(d,b)),d.state!==void 0&&(0,l.$GF)(L,"commentsDraftState"),d.reactions?.some(E=>E.reactors!==void 0)&&(0,l.$GF)(L,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:b,body:typeof d.body=="string"?d.body:w.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(E=>i(E)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function i(p){return{label:p.label,iconPath:p.iconPath?w.$aN(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(d=>d.name):p.reactors}}function u(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?P.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(d=>({name:d}))}}function t(p){if(p!==void 0)switch(p){case R.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function g(p){if(p!==void 0)switch(p){case R.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new n}e.$Fgc=$}),define(Pe[249],Re([1,0,20,98,6,11,25,2,8,61,75,3,7]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class ${constructor(u,t){this.document=u,this.b=t,this.a=1,this.c=new R.$kgc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,t){await this.f(u).undo(),t||this.disposeBackup()}async redo(u,t){await this.f(u).redo(),t||this.disposeBackup()}disposeEdits(u){for(const t of u)this.c.delete(t)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=h(this.document.uri)+this.a++;return(0,P.$Hg)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const t=this.c.get(u,0);if(!t)throw new Error("No edit found");return t}}class v{constructor(){this.a=new Map}get(u,t){return this.a.get(this.b(u,t))}add(u,t,g){const p=this.b(u,t.uri);if(this.a.has(p))throw new Error(`Document already exists for viewType:${u} resource:${t.uri}`);const d=new $(t,g);return this.a.set(p,d),d}delete(u,t){const g=this.b(u,t.uri);this.a.delete(g)}b(u,t){return`${u}@@@${t}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class a{constructor(){this.a=new Map}addTextProvider(u,t,g){return this.b(0,u,t,g)}addCustomProvider(u,t,g){return this.b(1,u,t,g)}get(u){return this.a.get(u)}b(u,t,g,p){if(this.a.has(t))throw new Error(`Provider for viewType:${t} already registered`);return this.a.set(t,{type:u,extension:g,provider:p}),new l.$_K(()=>this.a.delete(t))}}class r{constructor(u,t,g,p,d){this.d=t,this.f=g,this.g=p,this.h=d,this.b=new a,this.c=new v,this.a=u.getProxy(k.$0K.MainThreadCustomEditors)}registerCustomEditorProvider(u,t,g,p){const d=new C.$Sc;return o(g)?(d.add(this.b.addTextProvider(t,u,g)),this.a.$registerTextEditorProvider((0,w.$Ugc)(u),t,p.webviewOptions||{},{supportsMove:!!g.moveCustomTextEditor},(0,w.$Sgc)(u))):(d.add(this.b.addCustomProvider(t,u,g)),n(g)&&d.add(g.onDidChangeCustomDocument(S=>{const L=this.i(t,S.document.uri);if(c(S)){const b=L.addEdit(S);this.a.$onDidEdit(S.document.uri,t,b,S.label)}else this.a.$onContentChange(S.document.uri,t)})),this.a.$registerCustomEditorProvider((0,w.$Ugc)(u),t,p.webviewOptions||{},!!p.supportsMultipleEditorsPerDocument,(0,w.$Sgc)(u))),l.$_K.from(d,new l.$_K(()=>{this.a.$unregisterEditorProvider(t)}))}async $createCustomDocument(u,t,g,p,d){const S=this.b.get(t);if(!S)throw new Error(`No provider found for '${t}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${t}'`);const L=m.URI.revive(u),b=await S.provider.openCustomDocument(L,{backupId:g,untitledDocumentData:p?.buffer},d);let E;return n(S.provider)&&this.f&&(E=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(t,b,E),{editable:n(S.provider)}}async $disposeCustomDocument(u,t){const g=this.b.get(t);if(!g)throw new Error(`No provider found for '${t}'`);if(g.type!==1)throw new Error(`Invalid provider type for '${t}'`);const p=m.URI.revive(u),{document:d}=this.i(t,p);this.c.delete(t,d),d.dispose()}async $resolveCustomEditor(u,t,g,p,d,S){const L=this.b.get(g);if(!L)throw new Error(`No provider found for '${g}'`);const b=f.ViewColumn.to(d),E=this.g.createNewWebview(t,p.contentOptions,L.extension),D=this.h.createNewWebviewPanel(t,g,p.title,b,p.options,E,p.active),T=m.URI.revive(u);switch(L.type){case 1:{const{document:O}=this.i(g,T);return L.provider.resolveCustomEditor(O,D,S)}case 0:{const O=this.d.getDocument(T);return L.provider.resolveCustomTextEditor(O,D,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,t,g){this.i(t,u).disposeEdits(g)}async $onMoveCustomEditor(u,t,g){const p=this.b.get(g);if(!p)throw new Error(`No provider found for '${g}'`);if(!p.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${g}'`);const d=this.h.getWebviewPanel(u);if(!d)throw new Error("No webview found");const S=m.URI.revive(t),L=this.d.getDocument(S);await p.provider.moveCustomTextEditor(L,d,y.CancellationToken.None)}async $undo(u,t,g,p){return this.i(t,u).undo(g,p)}async $redo(u,t,g,p){return this.i(t,u).redo(g,p)}async $revert(u,t,g){const p=this.i(t,u);await this.j(t).revertCustomDocument(p.document,g),p.disposeBackup()}async $onSave(u,t,g){const p=this.i(t,u);await this.j(t).saveCustomDocument(p.document,g),p.disposeBackup()}async $onSaveAs(u,t,g,p){const d=this.i(t,u);return this.j(t).saveCustomDocumentAs(d.document,m.URI.revive(g),p)}async $backup(u,t,g){const p=this.i(t,u),S=await this.j(t).backupCustomDocument(p.document,{destination:p.getNewBackupUri()},g);return p.updateBackup(S),S.id}i(u,t){const g=this.c.get(u,m.URI.revive(t));if(!g)throw new Error("No custom document found");return g}j(u){const g=this.b.get(u)?.provider;if(!g||!n(g))throw new Error("Custom document is not editable");return g}}e.$Xgc=r;function n(i){return!!i.onDidChangeCustomDocument}function o(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const u=i.scheme===A.Schemas.file||i.scheme===A.Schemas.untitled?i.fsPath:i.toString();return(0,M.$Ti)(u)+""}}),define(Pe[250],Re([1,0,158,99,2,3,7,8,5,14,28,42]),function(ge,e,y,M,C,A,P,m,f,w,R,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=e.$pgc=void 0;class ${#e;#t;#i;constructor(a,r,n,o,c,h,i,u){this.d=a,this.e=r,this.f=n,this.g=o,this.h=c,this.c=!1,this.f=Math.max(o,n),this.#i=new R.$Ac(t=>h.getComparisonKey(t)),this.#e=i,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,r){if(!a){this.clear();return}this.j();let n=[];if(C.URI.isUri(a)){if(!r){this.delete(a);return}this.#i.set(a,r.slice()),n=[a]}else if(Array.isArray(a)){n=[];let h;a=[...a].sort($.k);for(const i of a){const[u,t]=i;if((!h||u.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=u,n.push(u),this.#i.set(u,[])),t)this.#i.get(u)?.push(...t);else{const g=this.#i.get(u);g&&(g.length=0)}}}if(this.#t.fire(n),!this.#e)return;const o=[];let c=0;for(const h of n){let i=[];const u=this.#i.get(h);if(u)if(u.length>this.g){i=[];const t=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const p of u)if(p.severity===t[g]&&i.push({...m.Diagnostic.from(p),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:M.MarkerSeverity.Info,message:(0,y.localize)(0,null,u.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=u.map(t=>({...m.Diagnostic.from(t),modelVersionId:this.h(h)}));if(o.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,o)}delete(a){this.j(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(a,r){this.j();for(const[n,o]of this)a.call(r,n,o,this)}*[Symbol.iterator](){this.j();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this.j();const r=this.#i.get(a);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(a){return this.j(),Array.isArray(this.#i.get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,r){return a[0].toString()<r[0].toString()?-1:a[0].toString()>r[0].toString()?1:0}}e.$pgc=$;let v=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(a){const r=new R.$Ac;for(const n of a)r.set(n,n);return{uris:Object.freeze(Array.from(r.values()))}}constructor(a,r,n,o){this.j=r,this.k=n,this.l=o,this.g=new Map,this.h=new f.$Zd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,l._mapper),this.f=a.getProxy(A.$0K.MainThreadDiagnostics)}createDiagnosticCollection(a,r){const{g:n,f:o,h:c,j:h,k:i,l:u}=this,t=new class{$changeMany(d,S){o.$changeMany(d,S),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,d,S.length===0?"CLEARING":S)}$clear(d){o.$clear(d),h.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,d)}dispose(){o.dispose()}};let g;if(!r)r="_generated_diagnostic_collection_name_#"+l.c++,g=r;else if(!n.has(r))g=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do g=r+l.c++;while(n.has(g))}return new class extends ${constructor(){super(r,g,l.e,l.d,d=>u.getDocument(d)?.version,i.extUri,t,c),n.set(g,this)}dispose(){super.dispose(),n.delete(g)}}}getDiagnostics(a){if(a)return this.m(a);{const r=new Map,n=[];for(const o of this.g.values())o.forEach((c,h)=>{let i=r.get(c.toString());typeof i>"u"&&(i=n.length,r.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(a){let r=[];for(const n of this.g.values())n.has(a)&&(r=r.concat(n.get(a)));return r}$acceptMarkersChange(a){if(!this.n){const r="_generated_mirror",n=new $(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(r,n),this.n=n}for(const[r,n]of a)this.n.set(C.URI.revive(r),n.map(m.Diagnostic.to))}};e.$qgc=v,e.$qgc=v=l=Je([He(1,w.$nj),He(2,k.$ogc)],v)}),define(Pe[251],Re([1,0,2,15,7,8,185]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class m{constructor(w,R,k,l={timeout:1500,errors:3}){this.c=w,this.d=R,this.f=k,this.g=l,this.a=new P.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(R,k,l)=>{const v={dispose:this.a.push([R,k,w])};return Array.isArray(l)&&l.push(v),v}}async $participateInSave(w,R){const k=y.URI.revive(w);let l=!1;const $=setTimeout(()=>l=!0,this.g.timeout),v=[];try{for(const s of[...this.a]){if(l)break;const a=this.d.getDocument(k),r=await this.h(s,{document:a,reason:A.TextDocumentSaveReason.to(R)});v.push(r)}}finally{clearTimeout($)}return v}h([w,R,k],l){const $=this.b.get(w);return typeof $=="number"&&$>this.g.errors?Promise.resolve(!1):this.i(k,w,R,l).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const s=this.b.get(w);this.b.set(w,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,R,k,l){const $=[],v=Date.now(),{document:s,reason:a}=l,{version:r}=s,n=Object.freeze({document:s,reason:a,waitUntil(o){if(Object.isFrozen($))throw(0,M.$8)("waitUntil can not be called async");$.push(Promise.resolve(o))}});try{R.apply(k,[n])}catch(o){return Promise.reject(o)}return Object.freeze($),new Promise((o,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all($).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(h),o(i)}).catch(i=>{clearTimeout(h),c(i)})}).then(o=>{const c={edits:[]};for(const h of o)if(Array.isArray(h)&&h.every(i=>i instanceof C.$gL))for(const{newText:i,newEol:u,range:t}of h)c.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:t&&A.Range.from(t),text:i,eol:u&&A.EndOfLine.from(u)}});if(c.edits.length!==0)return r===s.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$zhc=m}),define(Pe[252],Re([1,0,5,6,2,3,108,8,16,26,7]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class k{constructor($,v){this.a=new y.$Vd,this.b=new y.$Vd,this.c=new y.$Vd,this.d=new y.$Vd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Sc,this.h=new Map,this.f=$.getProxy(A.$0K.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(s=>{for(const a of s)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const a of s)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const v=this.g.getDocument($);if(v)return v}getDocument($){const v=this.getDocumentData($);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return v.document}ensureDocumentData($){const v=this.g.getDocument($);if(v)return Promise.resolve(v);let s=this.h.get($.toString());return s||(s=this.f.$tryOpenDocument($).then(a=>{this.h.delete($.toString());const r=C.URI.revive(a);return(0,f.$Tf)(this.g.getDocument(r))},a=>(this.h.delete($.toString()),Promise.reject(a))),this.h.set($.toString(),s)),s}createDocumentData($){return this.f.$tryCreateDocument($).then(v=>C.URI.revive(v))}$acceptModelLanguageChanged($,v){const s=C.URI.revive($),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(v),this.a.fire(a.document)}$acceptModelSaved($){const v=C.URI.revive($),s=this.g.getDocument(v);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(s.document)}$acceptDirtyStateChanged($,v){const s=C.URI.revive($),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");a._acceptIsDirty(v),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,v,s){const a=C.URI.revive($),r=this.g.getDocument(a);if(!r)throw new Error("unknown document");r._acceptIsDirty(s),r.onEvents(v);let n;v.isUndoing?n=R.TextDocumentChangeReason.Undo:v.isRedoing&&(n=R.TextDocumentChangeReason.Redo),this.c.fire((0,w.$wn)({document:r.document,contentChanges:v.changes.map(o=>({range:m.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor($,v){(0,P.$dN)($,v)}}e.$mgc=k}),define(Pe[64],Re([1,0,253,5,16,2,4,3,17,8,7]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0,e.$Ygc=(0,P.$6h)("IExtHostEditorTabs");class k{constructor(a,r,n){this.e=n,this.d=r,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,r={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$RM(A.URI.revive(this.b.input.uri));case 2:return new R.$SM(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new R.$TM(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new R.$UM(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$VM(this.b.input.viewType);case 4:return new R.$WM(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$XM(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$YM;case 9:return new R.$ZM(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$1M(this.b.input.providerId);default:return}}}class l{constructor(a,r){this.c=[],this.d="",this.b=a,this.e=r;for(const n of a.tabs)n.isActive&&(this.d=n.id),this.c.push(new k(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,r={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return w.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(n=>n.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(n=>n.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===0){const n=new k(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,n),a.tabDto.isActive&&(this.d=n.tabId),n}else if(a.kind===1){const n=this.c.splice(a.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(a.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,n),n}const r=this.c.find(n=>n.tabId===a.tabDto.id);if(!r)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(a.tabDto),r}activeTabId(){return this.d}}let $=class{constructor(a){this.b=new M.$Vd,this.c=new M.$Vd,this.e=[],this.a=a.getProxy(m.$0K.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,r={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(n=>n.apiObject))},get activeTabGroup(){const n=a.d;return(0,C.$Tf)(a.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,o)=>{const c=Array.isArray(n)?n:[n];return c.length?v(c[0])?this.j(c,o):this.i(c,o):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(a){const r=new Set(this.e.map(t=>t.groupId)),n=new Set(a.map(t=>t.groupId)),o=(0,y.$L)(r,n),c=this.e.filter(t=>o.removed.includes(t.groupId)).map(t=>t.apiObject),h=[],i=[];this.e=a.map(t=>{const g=new l(t,()=>this.d);return o.added.includes(g.groupId)?h.push(g.apiObject):i.push(g.apiObject),g});const u=(0,C.$Tf)(a.find(t=>t.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(a){const r=this.e.find(n=>n.groupId===a.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const r=this.e.find(o=>o.groupId===a.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const n=r.acceptTabOperation(a);switch(a.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(a){for(const r of this.e)for(const n of r.tabs)if(n.apiObject===a)return n}h(a){return this.e.find(r=>r.apiObject===a)}async i(a,r){const n=[];for(const o of a){const c=this.g(o);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,r)}async j(a,r){const n=[];for(const o of a){const c=this.h(o);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,r)}};e.$Zgc=$,e.$Zgc=$=Je([He(0,f.$bN)],$);function v(s){return s.tabs!==void 0}}),define(Pe[254],Re([1,0,2,3,6,7,8,296,12,22,24,52]),function(ge,e,y,M,C,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const a=this.a.indexOf(s);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),a=[];let r,n,o=14,c=14;for(const h of s){let i=r?(0,f.$bf)(r,h):0;for(i===0?n=1:n=c;i<h.length;i++)i+1===h.length?(o=c,c=9):c+=1,a.push([n,h.toUpperCase().charCodeAt(i),c]),a.push([n,h.toLowerCase().charCodeAt(i),c]),n=c;r=h,c=o}a.push([9,58,10]),a.push([10,47,12]),this.b=new m.$yZ(a)}}provideDocumentLinks(s){this.c();const a=[],r=m.$zZ.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this.b);for(const n of r){const o=P.DocumentLink.to(n);o.target&&a.push(o)}return a}}class ${constructor(s,a){this.i=a,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(M.$0K.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,a,r,n={}){if($.j(r),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const o=this.h++;this.b.add(a),this.d.add(a),this.c.set(o,r);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof r.copy=="function"&&(c+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,R.$GF)(s,"fsChunks"),c+=4);let h;n.isReadonly&&(0,k.$jk)(n.isReadonly)&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(o,a,c,h).catch(u=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${a}`),console.error(u)});const i=r.onDidChangeFile(u=>{const t=[];for(const g of u){const{uri:p,type:d}=g;if(p.scheme!==a)continue;let S;switch(d){case A.FileChangeType.Changed:S=0;break;case A.FileChangeType.Created:S=1;break;case A.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:p,type:S})}this.a.$onFileSystemChange(o,t)});return(0,C.$Rc)(()=>{i.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:a,ctime:r,mtime:n,size:o,permissions:c}=s;return{type:a,ctime:r,mtime:n,size:o,permissions:c}}$stat(s,a){return Promise.resolve(this.l(s).stat(y.URI.revive(a))).then(r=>$.k(r))}$readdir(s,a){return Promise.resolve(this.l(s).readDirectory(y.URI.revive(a)))}$readFile(s,a){return Promise.resolve(this.l(s).readFile(y.URI.revive(a))).then(r=>w.$je.wrap(r))}$writeFile(s,a,r,n){return Promise.resolve(this.l(s).writeFile(y.URI.revive(a),r.buffer,n))}$delete(s,a,r){return Promise.resolve(this.l(s).delete(y.URI.revive(a),r))}$rename(s,a,r,n){return Promise.resolve(this.l(s).rename(y.URI.revive(a),y.URI.revive(r),n))}$copy(s,a,r,n){const o=this.l(s);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(y.URI.revive(a),y.URI.revive(r),n))}$mkdir(s,a){return Promise.resolve(this.l(s).createDirectory(y.URI.revive(a)))}$watch(s,a,r,n){const o=this.l(s).watch(y.URI.revive(r),n);this.f.set(a,o)}$unwatch(s,a){const r=this.f.get(a);r&&(r.dispose(),this.f.delete(a))}$open(s,a,r){const n=this.l(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(y.URI.revive(a),r))}$close(s,a){const r=this.l(s);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(a))}$read(s,a,r,n){const o=this.l(s);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const c=w.$je.alloc(n);return Promise.resolve(o.read(a,r,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(s,a,r,n){const o=this.l(s);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(a,r,n.buffer,0,n.byteLength))}l(s){const a=this.c.get(s);if(!a){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return a}}e.$Bhc=$}),define(Pe[255],Re([1,0,5,34,2,3,8,7,39]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor($,v,s,a,r,n){this.a=Math.random(),this.b=new y.$Vd,this.c=new y.$Vd,this.d=new y.$Vd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,M.$Mj)(r),c=typeof r=="string",h=n?.correlate,i=a(u=>{if(!(typeof u.session=="number"&&u.session!==this.a)&&!(h&&typeof u.session>"u")){if(!n?.ignoreCreateEvents)for(const t of u.created){const g=C.URI.revive(t);o(g.fsPath)&&(!c||v.getWorkspaceFolder(g))&&this.b.fire(g)}if(!n?.ignoreChangeEvents)for(const t of u.changed){const g=C.URI.revive(t);o(g.fsPath)&&(!c||v.getWorkspaceFolder(g))&&this.c.fire(g)}if(!n?.ignoreDeleteEvents)for(const t of u.deleted){const g=C.URI.revive(t);o(g.fsPath)&&(!c||v.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=m.$_K.from(this.i($,s,r,n,n?.correlate),this.b,this.c,this.d,i)}i($,v,s,a,r){const n=m.$_K.from();if(typeof s=="string")return n;const o=$.getProxy(A.$0K.MainThreadFileSystemEventService);let c=!1;return(s.pattern.includes(M.$Ij)||s.pattern.includes(M.$Jj))&&(c=!0),o.$watch(v.identifier.value,this.a,s.baseUri,{recursive:c,excludes:a?.excludes??[]},!!r),m.$_K.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor($){this.a=$,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(C.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor($,v,s){this.j=$,this.k=v,this.l=s,this.a=new y.$Vd,this.b=new y.$Vd,this.c=new y.$Vd,this.d=new y.$Vd,this.g=new y.$Xd,this.h=new y.$Xd,this.i=new y.$Xd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher($,v,s,a){return new w(this.j,$,v,this.a.event,P.GlobPattern.from(s),a)}$onFileEvent($){this.a.fire(new R($))}$onDidRunFileOperation($,v){switch($){case 2:this.b.fire(Object.freeze({files:v.map(s=>({oldUri:C.URI.revive(s.source),newUri:C.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(s=>C.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(s=>C.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent($){return this.m($,this.g)}getOnWillCreateFileEvent($){return this.m($,this.h)}getOnWillDeleteFileEvent($){return this.m($,this.i)}m($,v){return(s,a,r)=>{const n=function(c){s.call(a,c)};return n.extension=$,v.event(n,void 0,r)}}async $onWillRunFileOperation($,v,s,a){switch($){case 2:return await this.n(this.g,{files:v.map(r=>({oldUri:C.URI.revive(r.source),newUri:C.URI.revive(r.target)}))},s,a);case 1:return await this.n(this.i,{files:v.map(r=>C.URI.revive(r.target))},s,a);case 0:case 3:return await this.n(this.h,{files:v.map(r=>C.URI.revive(r.target))},s,a)}}async n($,v,s,a){const r=new Set,n=[];if(await $.fireAsync(v,a,async(c,h)=>{const i=Date.now(),u=await Promise.resolve(c);u instanceof m.$jL&&(n.push([h.extension,u]),r.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>s&&this.k.warn("SLOW file-participant",h.extension.identifier)}),a.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,c]of n){const{edits:h}=P.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(h)}return{edit:o,extensionNames:Array.from(r)}}}e.$Chc=k}),define(Pe[256],Re([1,0,2,26,8,7,87,3,12,29,18,16,297,20,23,6,96,89,75,63,15,13,24,160]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n,o,c,h,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class t{constructor(F,H){this.d=F,this.e=H}async provideDocumentSymbols(F,H){const K=this.d.getDocument(F),j=await this.e.provideDocumentSymbols(K,H);if(!(0,R.$Kb)(j))return j[0]instanceof A.$sL?j.map(C.DocumentSymbol.from):t.f(j)}static f(F){F=F.slice(0).sort((j,Y)=>{let _=j.location.range.start.compareTo(Y.location.range.start);return _===0&&(_=Y.location.range.end.compareTo(j.location.range.end)),_});const H=[],K=[];for(const j of F){const Y={name:j.name||"!!MISSING: name!!",kind:C.SymbolKind.from(j.kind),tags:j.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:C.Range.from(j.location.range),selectionRange:C.Range.from(j.location.range),children:[]};for(;;){if(K.length===0){K.push(Y),H.push(Y);break}const _=K[K.length-1];if(w.$Us.containsRange(_.range,Y.range)&&!w.$Us.equalsRange(_.range,Y.range)){_.children?.push(Y),K.push(Y);break}K.pop()}}return H}}class g{constructor(F,H,K,j,Y,_){this.f=F,this.g=H,this.h=K,this.j=j,this.k=Y,this.l=_,this.d=new n.$kgc("CodeLens"),this.e=new Map}async provideCodeLenses(F,H){const K=this.f.getDocument(F),j=await this.h.provideCodeLenses(K,H);if(!j||H.isCancellationRequested)return;const Y=this.d.add(j),_=new s.$Sc;this.e.set(Y,_);const Ee={cacheId:Y,lenses:[]};for(let Ne=0;Ne<j.length;Ne++)Ee.lenses.push({cacheId:[Y,Ne],range:C.Range.from(j[Ne].range),command:this.g.toInternal(j[Ne].command,_)});return Ee}async resolveCodeLens(F,H){const K=F.cacheId&&this.d.get(...F.cacheId);if(!K)return;let j;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?j=K:j=await this.h.resolveCodeLens(K,H),j||(j=K),H.isCancellationRequested)return;const Y=F.cacheId&&this.e.get(F.cacheId[0]);if(Y){if(!j.command){const _=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,_),this.l.error(_);return}return F.command=this.g.toInternal(j.command,Y),F}}releaseCodeLenses(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}}function p(ye){return Array.isArray(ye)?ye.map(C.DefinitionLink.from):ye?[C.DefinitionLink.from(ye)]:[]}class d{constructor(F,H){this.d=F,this.e=H}async provideDefinition(F,H,K){const j=this.d.getDocument(F),Y=C.Position.to(H),_=await this.e.provideDefinition(j,Y,K);return p(_)}}class S{constructor(F,H){this.d=F,this.e=H}async provideDeclaration(F,H,K){const j=this.d.getDocument(F),Y=C.Position.to(H),_=await this.e.provideDeclaration(j,Y,K);return p(_)}}class L{constructor(F,H){this.d=F,this.e=H}async provideImplementation(F,H,K){const j=this.d.getDocument(F),Y=C.Position.to(H),_=await this.e.provideImplementation(j,Y,K);return p(_)}}class b{constructor(F,H){this.d=F,this.e=H}async provideTypeDefinition(F,H,K){const j=this.d.getDocument(F),Y=C.Position.to(H),_=await this.e.provideTypeDefinition(j,Y,K);return p(_)}}class E{constructor(F,H){this.d=F,this.e=H}async provideHover(F,H,K){const j=this.d.getDocument(F),Y=C.Position.to(H),_=await this.e.provideHover(j,Y,K);if(!(!_||(0,R.$Kb)(_.contents)))return _.range||(_.range=j.getWordRangeAtPosition(Y)),_.range||(_.range=new A.$bL(Y,Y)),C.Hover.from(_)}}class D{constructor(F,H){this.d=F,this.e=H}async provideEvaluatableExpression(F,H,K){const j=this.d.getDocument(F),Y=C.Position.to(H),_=await this.e.provideEvaluatableExpression(j,Y,K);if(_)return C.EvaluatableExpression.from(_)}}class T{constructor(F,H){this.d=F,this.e=H}async provideInlineValues(F,H,K,j){const Y=this.d.getDocument(F),_=await this.e.provideInlineValues(Y,C.Range.to(H),C.InlineValueContext.to(K),j);if(Array.isArray(_))return _.map(Ee=>C.InlineValue.from(Ee))}}class O{constructor(F,H){this.d=F,this.e=H}async provideDocumentHighlights(F,H,K){const j=this.d.getDocument(F),Y=C.Position.to(H),_=await this.e.provideDocumentHighlights(j,Y,K);if(Array.isArray(_))return _.map(C.DocumentHighlight.from)}}class G{constructor(F,H){this.d=F,this.e=H}async provideMultiDocumentHighlights(F,H,K,j){const Y=this.d.getDocument(F),_=K.map(Ve=>this.d.getDocument(Ve)),Ee=C.Position.to(H),Ne=await this.e.provideMultiDocumentHighlights(Y,Ee,_,j);if(Array.isArray(Ne))return Ne.map(C.MultiDocumentHighlight.from)}}class q{constructor(F,H){this.d=F,this.e=H}async provideLinkedEditingRanges(F,H,K){const j=this.d.getDocument(F),Y=C.Position.to(H),_=await this.e.provideLinkedEditingRanges(j,Y,K);if(_&&Array.isArray(_.ranges))return{ranges:(0,R.$Hb)(_.ranges.map(C.Range.from)),wordPattern:_.wordPattern}}}class U{constructor(F,H){this.d=F,this.e=H}async provideReferences(F,H,K,j){const Y=this.d.getDocument(F),_=C.Position.to(H),Ee=await this.e.provideReferences(Y,_,K,j);if(Array.isArray(Ee))return Ee.map(C.location.from)}}class I{static{this.d=1e3}constructor(F,H,K,j,Y,_,Ee){this.g=F,this.h=H,this.j=K,this.k=j,this.l=Y,this.m=_,this.n=Ee,this.e=new n.$kgc("CodeAction"),this.f=new Map}async provideCodeActions(F,H,K,j){const Y=this.g.getDocument(F),_=l.$Ws.isISelection(H)?C.Selection.to(H):C.Range.to(H),Ee=[];for(const it of this.j.getDiagnostics(F))if(_.intersection(it.range)&&Ee.push(it)>I.d)break;const Ne={diagnostics:Ee,only:K.only?new A.$uL(K.only):void 0,triggerKind:C.CodeActionTriggerKind.to(K.trigger)},Ve=await this.k.provideCodeActions(Y,_,Ne,j);if(!(0,R.$Lb)(Ve)||j.isCancellationRequested)return;const Ke=this.e.add(Ve),Xe=new s.$Sc;this.f.set(Ke,Xe);const nt=[];for(let it=0;it<Ve.length;it++){const et=Ve[it];et&&(I.o(et)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Xe)})):(Ne.only&&(et.kind?Ne.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),nt.push({cacheId:[Ke,it],title:et.title,command:et.command&&this.h.toInternal(et.command,Xe),diagnostics:et.diagnostics&&et.diagnostics.map(C.Diagnostic.from),edit:et.edit&&C.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,i.$FF)(this.m,"codeActionAI")?et.isAI:!1,disabled:et.disabled?.reason})))}return{cacheId:Ke,actions:nt}}async resolveCodeAction(F,H){const[K,j]=F,Y=this.e.get(K,j);if(!Y||I.o(Y))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(Y,H)??Y;let Ee;_.edit&&(Ee=C.WorkspaceEdit.from(_.edit,void 0));let Ne;if(_.command){const Ve=this.f.get(K);Ve&&(Ne=this.h.toInternal(_.command,Ve))}return{edit:Ee,command:Ne}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class N{static toInternalProviderId(F,H){return F+"."+H}constructor(F,H,K,j,Y){this.d=F,this.e=H,this.f=K,this.g=j,this.h=Y}async prepareDocumentPaste(F,H,K,j){if(!this.f.prepareDocumentPaste)return;const Y=this.e.getDocument(F),_=H.map(Ve=>C.Range.to(Ve)),Ee=C.DataTransfer.toDataTransfer(K,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(Y,_,Ee,j),j.isCancellationRequested)return;const Ne=Array.from(Ee).filter(([,Ve])=>!(Ve instanceof A.$1L));return C.DataTransfer.from(Ne)}async providePasteEdits(F,H,K,j,Y){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(H),Ee=K.map(Ke=>C.Range.to(Ke)),Ne=C.DataTransfer.toDataTransfer(j,async Ke=>(await this.d.$resolvePasteFileData(this.g,F,Ke)).buffer),Ve=await this.f.provideDocumentPasteEdits(_,Ee,Ne,Y);if(Ve)return{label:Ve.label??(0,u.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ve.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:N.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?C.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class W{constructor(F,H){this.d=F,this.e=H}async provideDocumentFormattingEdits(F,H,K){const j=this.d.getDocument(F),Y=await this.e.provideDocumentFormattingEdits(j,H,K);if(Array.isArray(Y))return Y.map(C.TextEdit.from)}}class ae{constructor(F,H){this.d=F,this.e=H}async provideDocumentRangeFormattingEdits(F,H,K,j){const Y=this.d.getDocument(F),_=C.Range.to(H),Ee=await this.e.provideDocumentRangeFormattingEdits(Y,_,K,j);if(Array.isArray(Ee))return Ee.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,H,K,j){(0,k.$Sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Y=this.d.getDocument(F),_=H.map(C.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Y,_,K,j);if(Array.isArray(Ee))return Ee.map(C.TextEdit.from)}}class de{constructor(F,H){this.d=F,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,H,K,j,Y){const _=this.d.getDocument(F),Ee=C.Position.to(H),Ne=await this.e.provideOnTypeFormattingEdits(_,Ee,K,j,Y);if(Array.isArray(Ne))return Ne.map(C.TextEdit.from)}}class we{constructor(F,H){this.e=F,this.f=H,this.d=new n.$kgc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,H){const K=await this.e.provideWorkspaceSymbols(F,H);if(!(0,R.$Lb)(K))return{symbols:[]};const j=this.d.add(K),Y={cacheId:j,symbols:[]};for(let _=0;_<K.length;_++){const Ee=K[_];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Y.symbols.push({...C.WorkspaceSymbol.from(Ee),cacheId:[j,_]})}return Y}async resolveWorkspaceSymbol(F,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const K=this.d.get(...F.cacheId);if(K){const j=await this.e.resolveWorkspaceSymbol(K,H);return j&&(0,M.$yn)(F,C.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class ke{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,H,K){this.d=F,this.e=H,this.f=K}async provideRenameEdits(F,H,K,j){const Y=this.d.getDocument(F),_=C.Position.to(H);try{const Ee=await this.e.provideRenameEdits(Y,_,K,j);return Ee?C.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Ne=ke.g(Ee);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(F,H,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const j=this.d.getDocument(F),Y=C.Position.to(H);try{const _=await this.e.prepareRename(j,Y,K);let Ee,Ne;if(A.$bL.isRange(_)?(Ee=_,Ne=j.getText(_)):(0,k.$Kf)(_)&&(Ee=_.range,Ne=_.placeholder),!Ee||!Ne)return;if(Ee.start.line>Y.line||Ee.end.line<Y.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(Ee),text:Ne}}catch(_){const Ee=ke.g(_);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(_)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class ue{constructor(F,H){this.resultId=F,this.tokens=H}}class pe{constructor(F,H){this.f=F,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,H,K){const j=this.f.getDocument(F),Y=H!==0?this.d.get(H):null;let _=typeof Y?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(j,Y.resultId,K):await this.g.provideDocumentSemanticTokens(j,K);return Y&&this.d.delete(H),_?(_=pe.h(_),this.o(pe.n(Y,_),_)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return pe.j(F)?pe.k(F)?F:new A.$rM(new Uint32Array(F.data),F.resultId):pe.l(F)?pe.m(F)?F:new A.$tM(F.edits.map(H=>new A.$sM(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const H of F.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(F,H){if(!pe.j(H)||!F||!F.tokens)return H;const K=F.tokens,j=K.length,Y=H.data,_=Y.length;let Ee=0;const Ne=Math.min(j,_);for(;Ee<Ne&&K[Ee]===Y[Ee];)Ee++;if(Ee===j&&Ee===_)return new A.$tM([],H.resultId);let Ve=0;const Ke=Ne-Ee;for(;Ve<Ke&&K[j-Ve-1]===Y[_-Ve-1];)Ve++;return new A.$tM([{start:Ee,deleteCount:j-Ee-Ve,data:Y.subarray(Ee,_-Ve)}],H.resultId)}o(F,H){if(pe.j(F)){const K=this.e++;return this.d.set(K,new ue(F.resultId,F.data)),(0,a.$w$)({id:K,type:"full",data:F.data})}if(pe.l(F)){const K=this.e++;return pe.j(H)?this.d.set(K,new ue(H.resultId,H.data)):this.d.set(K,new ue(F.resultId)),(0,a.$w$)({id:K,type:"delta",deltas:(F.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}class ie{constructor(F,H){this.d=F,this.e=H}async provideDocumentRangeSemanticTokens(F,H,K){const j=this.d.getDocument(F),Y=await this.e.provideDocumentRangeSemanticTokens(j,C.Range.to(H),K);return Y?this.f(Y):null}f(F){return(0,a.$w$)({id:0,type:"full",data:F.data})}}class be{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,H,K,j,Y){this.f=F,this.g=H,this.h=K,this.j=j,this.k=Y,this.d=new n.$kgc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,H,K,j){const Y=this.f.getDocument(F),_=C.Position.to(H),Ee=Y.getWordRangeAtPosition(_)||new A.$bL(_,_),Ne=Ee.with({end:_}),Ve=new o.$Rd,Ke=await this.h.provideCompletionItems(Y,_,j,C.CompletionContext.to(K));if(!Ke||j.isCancellationRequested)return;const Xe=Array.isArray(Ke)?new A.$HL(Ke):Ke,nt=be.supportsResolving(this.h)?this.d.add(Xe.items):this.d.add([]),it=new s.$Sc;this.e.set(nt,it);const et=[],at={x:nt,b:et,a:{replace:C.Range.from(Ee),insert:C.Range.from(Ne)},c:Xe.isIncomplete||void 0,d:Ve.elapsed()};for(let ct=0;ct<Xe.items.length;ct++){const je=Xe.items[ct],mt=this.l(je,[nt,ct],Ne,Ee);et.push(mt)}return at}async resolveCompletionItem(F,H){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...F);if(!K)return;const j=this.l(K,F),Y=await this.h.resolveCompletionItem(K,H);if(!Y)return;const _=this.l(Y,F);return(j.h!==_.h||j.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(j.n!==_.n||j.o!==_.o||!(0,M.$zn)(j.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...j,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,H,K,j){const Y=this.e.get(H[0]);if(!Y)throw Error("DisposableStore is missing...");const _=this.g.toInternal(F.command,Y),Ee={x:H,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=F.textEdit.newText):typeof F.insertText=="string"?Ee.h=F.insertText:F.insertText instanceof A.$kL&&(Ee.h=F.insertText.value,Ee.i|=4);let Ne;return F.textEdit?Ne=F.textEdit.range:F.range&&(Ne=F.range),A.$bL.isRange(Ne)?Ee.j=C.Range.from(Ne):Ne&&(!K?.isEqual(Ne.inserting)||!j?.isEqual(Ne.replacing))&&(Ee.j={insert:C.Range.from(Ne.inserting),replace:C.Range.from(Ne.replacing)}),Ee}}class se{async provideInlineCompletions(F,H,K,j){}disposeCompletions(F){}handleDidShowCompletionItem(F,H,K){}handlePartialAccept(F,H,K){}}class Z extends se{constructor(F,H,K,j){super(),this.f=F,this.g=H,this.h=K,this.j=j,this.d=new V,this.e=(0,i.$FF)(this.f,"inlineCompletionsAdditions"),this.k={[P.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[P.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$FF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,H,K,j){const Y=this.g.getDocument(F),_=C.Position.to(H),Ee=await this.h.provideInlineCompletionItems(Y,_,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:C.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},j);if(!Ee||j.isCancellationRequested)return;const Ne=Array.isArray(Ee)?Ee:Ee.items,Ve=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],Ke=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Xe;return{pid:this.d.createReferenceId({dispose(){Xe?.dispose()},items:Ne}),items:Ne.map((it,et)=>{let at;it.command&&(Xe||(Xe=new s.$Sc),at=this.j.toInternal(it.command,Xe));const ct=it.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:it.filterText,range:it.range?C.Range.from(it.range):void 0,command:at,idx:et,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Ve.map(it=>(Xe||(Xe=new s.$Sc),this.j.toInternal(it,Xe))),suppressSuggestions:!1,enableForwardStability:Ke}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,H,K){const j=this.d.get(F)?.items[H];j&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(j,K)}handlePartialAccept(F,H,K){const j=this.d.get(F)?.items[H];j&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(j,K)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const H=this.e++;return this.d.set(H,F),H}disposeReferenceId(F){const H=this.d.get(F);return this.d.delete(F),H}get(F){return this.d.get(F)}}class ne{constructor(F,H){this.e=F,this.f=H,this.d=new n.$kgc("SignatureHelp")}async provideSignatureHelp(F,H,K,j){const Y=this.e.getDocument(F),_=C.Position.to(H),Ee=this.g(K),Ne=await this.f.provideSignatureHelp(Y,_,j,Ee);if(Ne){const Ve=this.d.add([Ne]);return{...C.SignatureHelp.from(Ne),id:Ve}}}g(F){let H;if(F.activeSignatureHelp){const K=C.SignatureHelp.to(F.activeSignatureHelp),j=this.d.get(F.activeSignatureHelp.id,0);j?(H=j,H.activeSignature=K.activeSignature,H.activeParameter=K.activeParameter):H=K}return{...F,activeSignatureHelp:H}}releaseSignatureHelp(F){this.d.delete(F)}}class Ae{constructor(F,H,K,j,Y){this.f=F,this.g=H,this.h=K,this.j=j,this.k=Y,this.d=new n.$kgc("InlayHints"),this.e=new Map}async provideInlayHints(F,H,K){const j=this.f.getDocument(F),Y=C.Range.to(H),_=await this.h.provideInlayHints(j,Y,K);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`);return}if(K.isCancellationRequested)return;const Ee=this.d.add(_);this.e.set(Ee,new s.$Sc);const Ne={hints:[],cacheId:Ee};for(let Ve=0;Ve<_.length;Ve++)this.l(_[Ve],Y)&&Ne.hints.push(this.m(_[Ve],[Ee,Ve]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`),Ne}async resolveInlayHint(F,H){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...F);if(!K)return;const j=await this.h.resolveInlayHint(K,H);if(j&&this.l(j))return this.m(j,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,H){return F.label.length===0||Array.isArray(F.label)&&F.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(H&&!H.contains(F.position))}m(F,H){const K=this.e.get(H[0]);if(!K)throw Error("DisposableStore is missing...");const j={label:"",cacheId:H,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};if(typeof F.label=="string")j.label=F.label;else{const Y=[];j.label=Y;for(const _ of F.label){if(!_.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:_.value,tooltip:C.MarkdownString.fromStrict(_.tooltip)};A.$lL.isLocation(_.location)&&(Ee.location=C.location.from(_.location)),_.command&&(Ee.command=this.g.toInternal(_.command,K)),Y.push(Ee)}}return j}}class Le{constructor(F,H){this.e=F,this.f=H,this.d=new n.$kgc("DocumentLink")}async provideLinks(F,H){const K=this.e.getDocument(F),j=await this.f.provideDocumentLinks(K,H);if(!(!Array.isArray(j)||j.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:j.filter(Le.g).map(C.DocumentLink.from)};{const Y=this.d.add(j),_={links:[],cacheId:Y};for(let Ee=0;Ee<j.length;Ee++){if(!Le.g(j[Ee]))continue;const Ne=C.DocumentLink.from(j[Ee]);Ne.cacheId=[Y,Ee],_.links.push(Ne)}return _}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,H){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...F);if(!K)return;const j=await this.f.resolveDocumentLink(K,H);if(!(!j||!Le.g(j)))return C.DocumentLink.from(j)}releaseLinks(F){this.d.delete(F)}}class Ce{constructor(F,H){this.d=F,this.e=H}async provideColors(F,H){const K=this.d.getDocument(F),j=await this.e.provideDocumentColors(K,H);return Array.isArray(j)?j.map(_=>({color:C.Color.from(_.color),range:C.Range.from(_.range)})):[]}async provideColorPresentations(F,H,K){const j=this.d.getDocument(F),Y=C.Range.to(H.range),_=C.Color.to(H.color),Ee=await this.e.provideColorPresentations(_,{document:j,range:Y},K);if(Array.isArray(Ee))return Ee.map(C.ColorPresentation.from)}}class ce{constructor(F,H){this.d=F,this.e=H}async provideFoldingRanges(F,H,K){const j=this.d.getDocument(F),Y=await this.e.provideFoldingRanges(j,H,K);if(Array.isArray(Y))return Y.map(C.FoldingRange.from)}}class te{constructor(F,H,K){this.d=F,this.e=H,this.f=K}async provideSelectionRanges(F,H,K){const j=this.d.getDocument(F),Y=H.map(C.Position.to),_=await this.e.provideSelectionRanges(j,Y,K);if(!(0,R.$Lb)(_))return[];if(_.length!==Y.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Ne=0;Ne<Y.length;Ne++){const Ve=[];Ee.push(Ve);let Ke=Y[Ne],Xe=_[Ne];for(;;){if(!Xe.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(C.SelectionRange.from(Xe)),!Xe.parent)break;Ke=Xe.range,Xe=Xe.parent}}return Ee}}class J{constructor(F,H){this.f=F,this.g=H,this.d=new r.$gN(""),this.e=new Map}async prepareSession(F,H,K){const j=this.f.getDocument(F),Y=C.Position.to(H),_=await this.g.prepareCallHierarchy(j,Y,K);if(!_)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(_)?_.map(Ne=>this.h(Ee,Ne)):[this.h(Ee,_)]}async provideCallsTo(F,H,K){const j=this.j(F,H);if(!j)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyIncomingCalls(j,K);if(Y)return Y.map(_=>({from:this.h(F,_.from),fromRanges:_.fromRanges.map(Ee=>C.Range.from(Ee))}))}async provideCallsFrom(F,H,K){const j=this.j(F,H);if(!j)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyOutgoingCalls(j,K);if(Y)return Y.map(_=>({to:this.h(F,_.to),fromRanges:_.fromRanges.map(Ee=>C.Range.from(Ee))}))}releaseSession(F){this.e.delete(F)}h(F,H){const K=this.e.get(F),j=C.CallHierarchyItem.from(H,F,K.size.toString(36));return K.set(j._itemId,H),j}j(F,H){return this.e.get(F)?.get(H)}}class ee{constructor(F,H){this.f=F,this.g=H,this.d=new r.$gN(""),this.e=new Map}async prepareSession(F,H,K){const j=this.f.getDocument(F),Y=C.Position.to(H),_=await this.g.prepareTypeHierarchy(j,Y,K);if(!_)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(_)?_.map(Ne=>this.h(Ee,Ne)):[this.h(Ee,_)]}async provideSupertypes(F,H,K){const j=this.j(F,H);if(!j)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySupertypes(j,K);if(Y)return Y.map(_=>this.h(F,_))}async provideSubtypes(F,H,K){const j=this.j(F,H);if(!j)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySubtypes(j,K);if(Y)return Y.map(_=>this.h(F,_))}releaseSession(F){this.e.delete(F)}h(F,H){const K=this.e.get(F),j=C.TypeHierarchyItem.from(H,F,K.size.toString(36));return K.set(j._itemId,H),j}j(F,H){return this.e.get(F)?.get(H)}}class me{static toInternalProviderId(F,H){return F+"."+H}constructor(F,H,K,j,Y){this.d=F,this.e=H,this.f=K,this.g=j,this.h=Y}async provideDocumentOnDropEdits(F,H,K,j,Y){const _=this.e.getDocument(H),Ee=C.Position.to(K),Ne=C.DataTransfer.toDataTransfer(j,async Ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Ke)).buffer),Ve=await this.f.provideDocumentDropEdits(_,Ee,Ne,Y);if(Ve)return{label:Ve.label??(0,u.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ve.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:me.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?C.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class ve{constructor(F,H){this.d=F,this.e=H}async provideMappedEdits(F,H,K,j){const Y=y.URI.revive(F),_=this.d.getDocument(Y),Ee=K.documents.map(Ke=>Ke.map(Xe=>({uri:y.URI.revive(Xe.uri),version:Xe.version,ranges:Xe.ranges.map(nt=>C.Range.to(nt))}))),Ne={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},Ve=await this.e.provideMappedEdits(_,H,Ne,j);return Ve?C.WorkspaceEdit.from(Ve):null}}class Me{constructor(F,H){this.adapter=F,this.extension=H}}class fe{static{this.d=0}constructor(F,H,K,j,Y,_,Ee,Ne){this.g=H,this.h=K,this.j=j,this.k=Y,this.l=_,this.m=Ee,this.n=Ne,this.f=new Map,this.e=F.getProxy(m.$0K.MainThreadLanguageFeatures)}o(F,H){return C.DocumentSelector.from(F,this.g,H)}p(F){return new A.$_K(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return fe.d++}async s(F,H,K,j,Y,_=!1){const Ee=this.f.get(F);if(!Ee||!(Ee.adapter instanceof H))return j;const Ne=Date.now();_||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ve=K(Ee.adapter,Ee.extension);return Promise.resolve(Ve).catch(Ke=>{(0,c.$4)(Ke)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(Ke),this.n.onExtensionError(Ee.extension.identifier,Ke))}).finally(()=>{_||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),$.CancellationToken.isCancellationToken(Y)?(0,h.$Vg)(Ve,Y):Ve}t(F,H){const K=this.q();return this.f.set(K,new Me(F,H)),K}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,H,K,j){const Y=this.t(new t(this.h,K),F),_=j&&j.label||fe.u(F);return this.e.$registerDocumentSymbolProvider(Y,this.o(H,F),_),this.p(Y)}$provideDocumentSymbols(F,H,K){return this.s(F,t,j=>j.provideDocumentSymbols(y.URI.revive(H),K),void 0,K)}registerCodeLensProvider(F,H,K){const j=this.q(),Y=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(j,new Me(new g(this.h,this.j.converter,K,F,this.n,this.l),F)),this.e.$registerCodeLensSupport(j,this.o(H,F),Y);let _=this.p(j);if(Y!==void 0){const Ee=K.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(Y));_=A.$_K.from(_,Ee)}return _}$provideCodeLenses(F,H,K){return this.s(F,g,j=>j.provideCodeLenses(y.URI.revive(H),K),void 0,K)}$resolveCodeLens(F,H,K){return this.s(F,g,j=>j.resolveCodeLens(H,K),void 0,void 0)}$releaseCodeLenses(F,H){this.s(F,g,K=>Promise.resolve(K.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(F,H,K){const j=this.t(new d(this.h,K),F);return this.e.$registerDefinitionSupport(j,this.o(H,F)),this.p(j)}$provideDefinition(F,H,K,j){return this.s(F,d,Y=>Y.provideDefinition(y.URI.revive(H),K,j),[],j)}registerDeclarationProvider(F,H,K){const j=this.t(new S(this.h,K),F);return this.e.$registerDeclarationSupport(j,this.o(H,F)),this.p(j)}$provideDeclaration(F,H,K,j){return this.s(F,S,Y=>Y.provideDeclaration(y.URI.revive(H),K,j),[],j)}registerImplementationProvider(F,H,K){const j=this.t(new L(this.h,K),F);return this.e.$registerImplementationSupport(j,this.o(H,F)),this.p(j)}$provideImplementation(F,H,K,j){return this.s(F,L,Y=>Y.provideImplementation(y.URI.revive(H),K,j),[],j)}registerTypeDefinitionProvider(F,H,K){const j=this.t(new b(this.h,K),F);return this.e.$registerTypeDefinitionSupport(j,this.o(H,F)),this.p(j)}$provideTypeDefinition(F,H,K,j){return this.s(F,b,Y=>Y.provideTypeDefinition(y.URI.revive(H),K,j),[],j)}registerHoverProvider(F,H,K,j){const Y=this.t(new E(this.h,K),F);return this.e.$registerHoverProvider(Y,this.o(H,F)),this.p(Y)}$provideHover(F,H,K,j){return this.s(F,E,Y=>Y.provideHover(y.URI.revive(H),K,j),void 0,j)}registerEvaluatableExpressionProvider(F,H,K,j){const Y=this.t(new D(this.h,K),F);return this.e.$registerEvaluatableExpressionProvider(Y,this.o(H,F)),this.p(Y)}$provideEvaluatableExpression(F,H,K,j){return this.s(F,D,Y=>Y.provideEvaluatableExpression(y.URI.revive(H),K,j),void 0,j)}registerInlineValuesProvider(F,H,K,j){const Y=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new T(this.h,K),F);this.e.$registerInlineValuesProvider(_,this.o(H,F),Y);let Ee=this.p(_);if(Y!==void 0){const Ne=K.onDidChangeInlineValues(Ve=>this.e.$emitInlineValuesEvent(Y));Ee=A.$_K.from(Ee,Ne)}return Ee}$provideInlineValues(F,H,K,j,Y){return this.s(F,T,_=>_.provideInlineValues(y.URI.revive(H),K,j,Y),void 0,Y)}registerDocumentHighlightProvider(F,H,K){const j=this.t(new O(this.h,K),F);return this.e.$registerDocumentHighlightProvider(j,this.o(H,F)),this.p(j)}registerMultiDocumentHighlightProvider(F,H,K){const j=this.t(new G(this.h,K),F);return this.e.$registerMultiDocumentHighlightProvider(j,this.o(H,F)),this.p(j)}$provideDocumentHighlights(F,H,K,j){return this.s(F,O,Y=>Y.provideDocumentHighlights(y.URI.revive(H),K,j),void 0,j)}$provideMultiDocumentHighlights(F,H,K,j,Y){return this.s(F,G,_=>_.provideMultiDocumentHighlights(y.URI.revive(H),K,j.map(Ee=>y.URI.revive(Ee)),Y),void 0,Y)}registerLinkedEditingRangeProvider(F,H,K){const j=this.t(new q(this.h,K),F);return this.e.$registerLinkedEditingRangeProvider(j,this.o(H,F)),this.p(j)}$provideLinkedEditingRanges(F,H,K,j){return this.s(F,q,async Y=>{const _=await Y.provideLinkedEditingRanges(y.URI.revive(H),K,j);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?fe.w(_.wordPattern):void 0}},void 0,j)}registerReferenceProvider(F,H,K){const j=this.t(new U(this.h,K),F);return this.e.$registerReferenceSupport(j,this.o(H,F)),this.p(j)}$provideReferences(F,H,K,j,Y){return this.s(F,U,_=>_.provideReferences(y.URI.revive(H),K,j,Y),void 0,Y)}registerCodeActionProvider(F,H,K,j){const Y=new s.$Sc,_=this.t(new I(this.h,this.j.converter,this.k,K,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(_,this.o(H,F),{providedKinds:j?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:j?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Y)}))},fe.u(F),!!K.resolveCodeAction),Y.add(this.p(_)),Y}$provideCodeActions(F,H,K,j,Y){return this.s(F,I,_=>_.provideCodeActions(y.URI.revive(H),K,j,Y),void 0,Y)}$resolveCodeAction(F,H,K){return this.s(F,I,j=>j.resolveCodeAction(H,K),{},void 0)}$releaseCodeActions(F,H){this.s(F,I,K=>Promise.resolve(K.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(F,H,K){const j=this.t(new W(this.h,K),F);return this.e.$registerDocumentFormattingSupport(j,this.o(H,F),F.identifier,F.displayName||F.name),this.p(j)}$provideDocumentFormattingEdits(F,H,K,j){return this.s(F,W,Y=>Y.provideDocumentFormattingEdits(y.URI.revive(H),K,j),void 0,j)}registerDocumentRangeFormattingEditProvider(F,H,K){const j=typeof K.provideDocumentRangesFormattingEdits=="function",Y=this.t(new ae(this.h,K),F);return this.e.$registerRangeFormattingSupport(Y,this.o(H,F),F.identifier,F.displayName||F.name,j),this.p(Y)}$provideDocumentRangeFormattingEdits(F,H,K,j,Y){return this.s(F,ae,_=>_.provideDocumentRangeFormattingEdits(y.URI.revive(H),K,j,Y),void 0,Y)}$provideDocumentRangesFormattingEdits(F,H,K,j,Y){return this.s(F,ae,_=>_.provideDocumentRangesFormattingEdits(y.URI.revive(H),K,j,Y),void 0,Y)}registerOnTypeFormattingEditProvider(F,H,K,j){const Y=this.t(new de(this.h,K),F);return this.e.$registerOnTypeFormattingSupport(Y,this.o(H,F),j,F.identifier),this.p(Y)}$provideOnTypeFormattingEdits(F,H,K,j,Y,_){return this.s(F,de,Ee=>Ee.provideOnTypeFormattingEdits(y.URI.revive(H),K,j,Y,_),void 0,_)}registerWorkspaceSymbolProvider(F,H){const K=this.t(new we(H,this.l),F);return this.e.$registerNavigateTypeSupport(K,typeof H.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(F,H,K){return this.s(F,we,j=>j.provideWorkspaceSymbols(H,K),{symbols:[]},K)}$resolveWorkspaceSymbol(F,H,K){return this.s(F,we,j=>j.resolveWorkspaceSymbol(H,K),void 0,void 0)}$releaseWorkspaceSymbols(F,H){this.s(F,we,K=>K.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(F,H,K){const j=this.t(new ke(this.h,K,this.l),F);return this.e.$registerRenameSupport(j,this.o(H,F),ke.supportsResolving(K)),this.p(j)}$provideRenameEdits(F,H,K,j,Y){return this.s(F,ke,_=>_.provideRenameEdits(y.URI.revive(H),K,j,Y),void 0,Y)}$resolveRenameLocation(F,H,K,j){return this.s(F,ke,Y=>Y.resolveRenameLocation(y.URI.revive(H),K,j),void 0,j)}registerDocumentSemanticTokensProvider(F,H,K,j){const Y=this.t(new pe(this.h,K),F),_=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Y,this.o(H,F),j,_);let Ee=this.p(Y);if(_){const Ne=K.onDidChangeSemanticTokens(Ve=>this.e.$emitDocumentSemanticTokensEvent(_));Ee=A.$_K.from(Ee,Ne)}return Ee}$provideDocumentSemanticTokens(F,H,K,j){return this.s(F,pe,Y=>Y.provideDocumentSemanticTokens(y.URI.revive(H),K,j),null,j)}$releaseDocumentSemanticTokens(F,H){this.s(F,pe,K=>K.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,H,K,j){const Y=this.t(new ie(this.h,K),F);return this.e.$registerDocumentRangeSemanticTokensProvider(Y,this.o(H,F),j),this.p(Y)}$provideDocumentRangeSemanticTokens(F,H,K,j){return this.s(F,ie,Y=>Y.provideDocumentRangeSemanticTokens(y.URI.revive(H),K,j),null,j)}registerCompletionItemProvider(F,H,K,j){const Y=this.t(new be(this.h,this.j.converter,K,this.m,F),F);return this.e.$registerCompletionsProvider(Y,this.o(H,F),j,be.supportsResolving(K),F.identifier),this.p(Y)}$provideCompletionItems(F,H,K,j,Y){return this.s(F,be,_=>_.provideCompletionItems(y.URI.revive(H),K,j,Y),void 0,Y)}$resolveCompletionItem(F,H,K){return this.s(F,be,j=>j.resolveCompletionItem(H,K),void 0,K)}$releaseCompletionItems(F,H){this.s(F,be,K=>K.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(F,H,K,j){const Y=new Z(F,this.h,K,this.j.converter),_=this.t(Y,F);return this.e.$registerInlineCompletionsSupport(_,this.o(H,F),Y.supportsHandleEvents,v.$lm.toKey(F.identifier.value),j?.yieldTo?.map(Ee=>v.$lm.toKey(Ee))||[]),this.p(_)}$provideInlineCompletions(F,H,K,j,Y){return this.s(F,se,_=>_.provideInlineCompletions(y.URI.revive(H),K,j,Y),void 0,Y)}$handleInlineCompletionDidShow(F,H,K,j){this.s(F,se,async Y=>{Y.handleDidShowCompletionItem(H,K,j)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,H,K,j){this.s(F,se,async Y=>{Y.handlePartialAccept(H,K,j)},void 0,void 0)}$freeInlineCompletionsList(F,H){this.s(F,se,async K=>{K.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(F,H,K,j){const Y=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,_=this.t(new ne(this.h,K),F);return this.e.$registerSignatureHelpProvider(_,this.o(H,F),Y),this.p(_)}$provideSignatureHelp(F,H,K,j,Y){return this.s(F,ne,_=>_.provideSignatureHelp(y.URI.revive(H),K,j,Y),void 0,Y)}$releaseSignatureHelp(F,H){this.s(F,ne,K=>K.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(F,H,K){const j=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,Y=this.t(new Ae(this.h,this.j.converter,K,this.l,F),F);this.e.$registerInlayHintsProvider(Y,this.o(H,F),typeof K.resolveInlayHint=="function",j,fe.u(F));let _=this.p(Y);if(j!==void 0){const Ee=K.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(j));_=A.$_K.from(_,Ee)}return _}$provideInlayHints(F,H,K,j){return this.s(F,Ae,Y=>Y.provideInlayHints(y.URI.revive(H),K,j),void 0,j)}$resolveInlayHint(F,H,K){return this.s(F,Ae,j=>j.resolveInlayHint(H,K),void 0,K)}$releaseInlayHints(F,H){this.s(F,Ae,K=>K.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(F,H,K){const j=this.t(new Le(this.h,K),F);return this.e.$registerDocumentLinkProvider(j,this.o(H,F),typeof K.resolveDocumentLink=="function"),this.p(j)}$provideDocumentLinks(F,H,K){return this.s(F,Le,j=>j.provideLinks(y.URI.revive(H),K),void 0,K,H.scheme==="output")}$resolveDocumentLink(F,H,K){return this.s(F,Le,j=>j.resolveLink(H,K),void 0,void 0,!0)}$releaseDocumentLinks(F,H){this.s(F,Le,K=>K.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(F,H,K){const j=this.t(new Ce(this.h,K),F);return this.e.$registerDocumentColorProvider(j,this.o(H,F)),this.p(j)}$provideDocumentColors(F,H,K){return this.s(F,Ce,j=>j.provideColors(y.URI.revive(H),K),[],K)}$provideColorPresentations(F,H,K,j){return this.s(F,Ce,Y=>Y.provideColorPresentations(y.URI.revive(H),K,j),void 0,j)}registerFoldingRangeProvider(F,H,K){const j=this.q(),Y=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(j,new Me(new ce(this.h,K),F)),this.e.$registerFoldingRangeProvider(j,this.o(H,F),F.identifier,Y);let _=this.p(j);if(Y!==void 0){const Ee=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Y));_=A.$_K.from(_,Ee)}return _}$provideFoldingRanges(F,H,K,j){return this.s(F,ce,Y=>Y.provideFoldingRanges(y.URI.revive(H),K,j),void 0,j)}registerSelectionRangeProvider(F,H,K){const j=this.t(new te(this.h,K,this.l),F);return this.e.$registerSelectionRangeProvider(j,this.o(H,F)),this.p(j)}$provideSelectionRanges(F,H,K,j){return this.s(F,te,Y=>Y.provideSelectionRanges(y.URI.revive(H),K,j),[],j)}registerCallHierarchyProvider(F,H,K){const j=this.t(new J(this.h,K),F);return this.e.$registerCallHierarchyProvider(j,this.o(H,F)),this.p(j)}$prepareCallHierarchy(F,H,K,j){return this.s(F,J,Y=>Promise.resolve(Y.prepareSession(y.URI.revive(H),K,j)),void 0,j)}$provideCallHierarchyIncomingCalls(F,H,K,j){return this.s(F,J,Y=>Y.provideCallsTo(H,K,j),void 0,j)}$provideCallHierarchyOutgoingCalls(F,H,K,j){return this.s(F,J,Y=>Y.provideCallsFrom(H,K,j),void 0,j)}$releaseCallHierarchy(F,H){this.s(F,J,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(F,H,K){const j=this.t(new ee(this.h,K),F);return this.e.$registerTypeHierarchyProvider(j,this.o(H,F)),this.p(j)}$prepareTypeHierarchy(F,H,K,j){return this.s(F,ee,Y=>Promise.resolve(Y.prepareSession(y.URI.revive(H),K,j)),void 0,j)}$provideTypeHierarchySupertypes(F,H,K,j){return this.s(F,ee,Y=>Y.provideSupertypes(H,K,j),void 0,j)}$provideTypeHierarchySubtypes(F,H,K,j){return this.s(F,ee,Y=>Y.provideSubtypes(H,K,j),void 0,j)}$releaseTypeHierarchy(F,H){this.s(F,ee,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(F,H,K,j){const Y=this.q();this.f.set(Y,new Me(new me(this.e,this.h,K,Y,F),F));const _=(0,i.$FF)(F,"dropMetadata")&&j?me.toInternalProviderId(F.identifier.value,j.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Y,this.o(H,F),_,(0,i.$FF)(F,"dropMetadata")?j:void 0),this.p(Y)}$provideDocumentOnDropEdits(F,H,K,j,Y,_){return this.s(F,me,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(H,y.URI.revive(K),j,Y,_)),void 0,void 0)}registerMappedEditsProvider(F,H,K){const j=this.t(new ve(this.h,K),F);return this.e.$registerMappedEditsProvider(j,this.o(H,F)),this.p(j)}$provideMappedEdits(F,H,K,j,Y){return this.s(F,ve,_=>Promise.resolve(_.provideMappedEdits(H,K,j,Y)),null,Y)}registerDocumentPasteEditProvider(F,H,K,j){const Y=this.q();this.f.set(Y,new Me(new N(this.e,this.h,K,Y,F),F));const _=N.toInternalProviderId(F.identifier.value,j.id);return this.e.$registerPasteEditProvider(Y,this.o(H,F),_,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:j.copyMimeTypes,pasteMimeTypes:j.pasteMimeTypes}),this.p(Y)}$prepareDocumentPaste(F,H,K,j,Y){return this.s(F,N,_=>_.prepareDocumentPaste(y.URI.revive(H),K,j,Y),void 0,Y)}$providePasteEdits(F,H,K,j,Y,_){return this.s(F,N,Ee=>Ee.providePasteEdits(H,y.URI.revive(K),j,Y,_),void 0,_)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:fe.w(F.decreaseIndentPattern),increaseIndentPattern:fe.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?fe.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?fe.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:fe.w(F.beforeText),afterText:F.afterText?fe.w(F.afterText):void 0,previousLineText:F.previousLineText?fe.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(fe.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(H=>A.SyntaxTokenType.toString(H)):void 0}}static D(F){return F.map(fe.C)}setLanguageConfiguration(F,H,K){const{wordPattern:j}=K;if(j&&(0,f.$Ye)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this.h.setWordDefinitionFor(H,j):this.h.setWordDefinitionFor(H,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const Y=this.q(),_={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?fe.w(K.wordPattern):void 0,indentationRules:K.indentationRules?fe.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?fe.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?fe.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Y,H,_),this.p(Y)}$setWordDefinitions(F){for(const H of F)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.$ugc=fe}),define(Pe[257],Re([1,0,3,8,7,31,13,6,24]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;class w{constructor(k,l,$,v){this.c=l,this.d=$,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(y.$0K.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const $=this.c.getDocumentData(k);if(!$)throw new Error(`document '${k.toString()}' NOT found`);return $.document}async tokenAtPosition(k,l){const $=k.version,v=M.Position.from(l),s=await this.a.$tokensAtPosition(k.uri,v),a={type:C.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new C.$bL(l.line,l.character,l.line,l.character)};if(!s)return a;const r={range:M.Range.to(s.range),type:M.TokenType.to(s.type)};return!r.range.contains(l)||$!==k.version?a:r}createLanguageStatusItem(k,l,$){const v=this.f++,s=this.a,a=this.g,r=`${k.identifier.value}/${l}`;if(a.has(r))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);a.add(r);const n={selector:$,id:l,name:k.displayName??k.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const c=new m.$Sc,h=()=>{if(o?.dispose(),!a.has(r)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,P.$8g)(()=>{c.clear(),this.a.$setLanguageStatus(v,{id:r,name:n.name??k.displayName??k.name,source:k.displayName??k.name,selector:M.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?A.default.Error:n.severity===C.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),o?.dispose(),s.$removeLanguageStatus(v),a.delete(r)},get id(){return n.id},get name(){return n.name},set name(u){n.name=u,h()},get selector(){return n.selector},set selector(u){n.selector=u,h()},get text(){return n.text},set text(u){n.text=u,h()},set text2(u){(0,f.$GF)(k,"languageStatusText"),n.text=u,h()},get text2(){return(0,f.$GF)(k,"languageStatusText"),n.text},get detail(){return n.detail},set detail(u){n.detail=u,h()},get severity(){return n.severity},set severity(u){n.severity=u,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(u){n.accessibilityInformation=u,h()},get command(){return n.command},set command(u){n.command=u,h()},get busy(){return n.busy},set busy(u){n.busy=u,h()}};return h(),i}}e.$Thc=w}),define(Pe[258],Re([1,0,11,2,8,7,84]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0;class m{constructor(k,l,$,v){this.start=k,this.deletedCount=l,this.deletedItems=$,this.items=v}asApiEvent(){return{range:new A.$xM(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(k,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,l,$){this.notebook=k,this.h=l,this.j=$,this.handle=$.handle,this.uri=M.URI.revive($.uri),this.cellKind=$.cellKind,this.a=$.outputs.map(C.NotebookCellOutput.to),this.e=$.internalMetadata??{},this.b=Object.freeze($.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to($.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const $={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime(v){k.g=v},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze($)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,l,$){const v=$.map(C.NotebookCellOutputItem.to),s=this.a.find(a=>a.id===k);if(s&&(l||(s.items.length=0),s.items.push(...v),s.items.length>1&&s.items.every(a=>P.$bJ(a.mime)))){const a=new Map,r=[];s.items.forEach(n=>{let o;a.has(n.mime)?o=a.get(n.mime):(o=[],a.set(n.mime,o),r.push(n.mime)),o.push(n.data)}),s.items.length=0,r.forEach(n=>{const o=P.$cJ(a.get(n));s.items.push({mime:n,data:o.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$Ehc=f;class w{static{this.a=0}constructor(k,l,$,v,s){this.k=k,this.l=l,this.m=$,this.uri=v,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===y.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt($){return $=k.n($),k.b[$].apiCell},getCells($){return($?k.p($):k.b).map(s=>s.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,$){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:$});const v={notebook:this.apiNotebook,metadata:$,cellChanges:[],contentChanges:[]},s=[];for(const r of k.rawEvents)r.kind===P.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,v.contentChanges):r.kind===P.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,v.contentChanges):r.kind===P.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===P.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===P.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),s.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),s.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const a=new Map;for(let r=0;r<s.length;r++){const n=s[r],o=a.get(n.cell);if(o===void 0){const c=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});a.set(n.cell,c-1)}else v.cellChanges[o]={...v.cellChanges[o],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,$=k.end|0;return l<0&&(l=0),$>this.b.length&&($=this.b.length),k.with({start:l,end:$})}p(k){k=this.o(k);const l=[];for(let $=k.start;$<k.end;$++)l.push(this.b[$]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,$){if(this.j)return;const v=[],s=[],a=[];if(k.reverse().forEach(r=>{const o=r[2].map(i=>{const u=new f(this,this.l,i);return l||s.push(f.asModelAddData(this.apiNotebook,i)),u}),c=new m(r[0],r[1],[],o),h=this.b.splice(r[0],r[1],...o);for(const i of h)a.push(i.uri),c.deletedItems.push(i.apiCell);v.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:a}),$)for(const r of v)$.push(r.asApiEvent())}s(k,l,$,v){const s=this.b.splice(k,l);this.b.splice($,0,...s);const a=[new m(k,l,s.map(r=>r.apiCell),[]),new m($,0,[],s)];for(const r of a)v.push(r.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,$,v){this.b[k].setOutputItems(l,$,v)}v(k,l){const $=this.b[k];$.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged($.uri,l)}w(k,l){const $=this.b[k];$.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$Fhc=w}),define(Pe[259],Re([1,0,5,2,8,7]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class P{constructor(f,w,R,k={timeout:1500,errors:3}){this.b=f,this.c=w,this.d=R,this.f=k,this.a=new y.$Xd}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(w,R,k)=>{const l=function(v){w.call(R,v)};return l.extension=f,this.a.event(l,void 0,k)}}async $participateInSave(f,w,R){const k=M.URI.revive(f),l=this.c.getNotebookDocument(k);if(!l)throw new Error("Unable to resolve notebook document");const $=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:C.TextDocumentSaveReason.to(w)},R,async(s,a)=>{const r=Date.now(),n=await await Promise.resolve(s);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!R.isCancellationRequested&&n&&(n instanceof A.$jL?$.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if($.length===0)return!0;const v={edits:[]};for(const s of $){const{edits:a}=C.WorkspaceEdit.from(s);v.edits=v.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$Vhc=P}),define(Pe[109],Re([1,0,15,8,7]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,f,w,R,k,l){this.id=m,this.f=f,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=R,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(f){this.selections=[f]},get selections(){return m.a},set selections(f){if(!Array.isArray(f)||!f.every(C.$xM.isNotebookRange))throw(0,y.$7)("selections");m.a=f,m.g(f)},get visibleRanges(){return m.b},revealRange(f,w){m.f.$tryRevealRange(m.id,M.NotebookRange.from(f),w??C.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(M.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$Ghc=A}),define(Pe[260],Re([1,0,5,14,8]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;let A=class{constructor(m,f){this.c=m,this.d=f,this.a=new y.$Vd,this.b=new y.$Vd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,f);const w=this.d.getEditorById(m);f.visibleRanges&&w._acceptVisibleRanges(f.visibleRanges.ranges.map(C.NotebookRange.to)),f.selections&&w._acceptSelections(f.selections.selections.map(C.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const f in m)this.d.getEditorById(f)._acceptViewColumn(C.ViewColumn.to(m[f]))}};e.$Xhc=A,e.$Xhc=A=Je([He(0,M.$nj)],A)}),define(Pe[261],Re([1,0,5,3,109]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class A{constructor(m,f){this.c=f,this.a=new Map,this.b=m.getProxy(M.$0K.MainThreadNotebookRenderers)}$postRendererMessage(m,f,w){const R=this.c.getEditorById(m);this.a.get(f)?.fire({editor:R.apiEditor,message:w})}createRendererMessaging(m,f){if(!m.contributes?.notebookRenderer?.some(R=>R.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(R,k,l)=>this.d(f).event(R,k,l),postMessage:(R,k)=>{C.$Ghc.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const l=k&&C.$Ghc.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,f,R)}}}d(m){let f=this.a.get(m);return f||(f=new y.$Vd({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(m)}}),this.a.set(m,f),f)}}e.$1hc=A}),define(Pe[262],Re([1,0,8,72,20,67,15]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class m{constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,l,$){const v=this.b++,{title:s,location:a,cancellable:r}=l,n={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(v,{location:y.ProgressLocation.from(a),title:s,source:n,cancellable:r},k.isUnderDevelopment?void 0:k.identifier.value).catch(P.$2),this.d(v,$,!!r)}d(k,l,$){let v;$&&(v=new C.$6d,this.c.set(k,v));const s=r=>{this.a.$progressEnd(r),this.c.delete(r),v?.dispose()};let a;try{a=l(new w(this.a,k),$&&v?v.token:C.CancellationToken.None)}catch(r){throw s(k),r}return a.then(r=>s(k),r=>s(k)),a}$acceptProgressCanceled(k){const l=this.c.get(k);l&&(l.cancel(),this.c.delete(k))}}e.$5hc=m;function f(R,k){return R.message=k.message,typeof k.increment=="number"&&(typeof R.increment=="number"?R.increment+=k.increment:R.increment=k.increment),R}class w extends M.$vv{constructor(k,l){super($=>this.throttledReport($)),this.c=k,this.d=l}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,A.$zh)(100,(R,k)=>f(R,k),()=>Object.create(null))],w.prototype,"throttledReport",null)}),define(Pe[263],Re([1,0,2,3,13,8]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class P{static{this.a=0}constructor(f,w){this.d=w,this.c=new Map,this.b=f.getProxy(M.$0K.MainThreadQuickDiff)}$provideOriginalResource(f,w,R){const k=y.URI.revive(w),l=this.c.get(f);return l?(0,C.$Yg)(()=>l.provideOriginalResource(k,R)).then($=>$||null):Promise.resolve(null)}registerQuickDiffProvider(f,w,R,k){const l=P.a++;return this.c.set(l,w),this.b.$registerQuickDiffProvider(l,A.DocumentSelector.from(f,this.d),R,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$6hc=P}),define(Pe[264],Re([1,0,20,5,6,3,2,7,15,18,31,44,24,8]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;function v(s,a,r){const n=s.getProxy(A.$0K.MainThreadQuickOpen);class o{constructor(S,L){this.e=new Map,this.f=0,this.a=S,this.b=L}showQuickPick(S,L,b,E=y.CancellationToken.None){this.c=void 0;const D=Promise.resolve(L),T=++this.f,O=n.$show(T,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},E),G={},q=O.then(()=>G);return Promise.race([q,D]).then(U=>{if(U===G)return;const I=(0,l.$FF)(S,"quickPickItemTooltip");return D.then(N=>{const W=[];for(let ae=0;ae<N.length;ae++){const de=N[ae];if(typeof de=="string")W.push({label:de,handle:ae});else if(de.kind===m.QuickPickItemKind.Separator)W.push({type:"separator",label:de.label});else{de.tooltip&&!I&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const we=de.iconPath?t(de.iconPath):void 0;W.push({label:de.label,iconPath:we?.iconPath,iconClass:we?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:I?$.MarkdownString.fromStrict(de.tooltip):void 0,handle:ae})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=ae=>{b.onDidSelectItem(N[ae])}),n.$setItems(T,W),O.then(ae=>{if(typeof ae=="number")return N[ae];if(Array.isArray(ae))return ae.map(de=>N[de])})})}).then(void 0,U=>{if(!(0,f.$4)(U))return n.$setError(T,U),Promise.reject(U)})}$onItemSelected(S){this.c?.(S)}showInput(S,L=y.CancellationToken.None){return this.d=S?.validateInput,n.$input(S,typeof this.d=="function",L).then(void 0,b=>{if(!(0,f.$4)(b))return Promise.reject(b)})}async $validateInput(S){if(!this.d)return;const L=await this.d(S);if(!L||typeof L=="string")return L;let b;switch(L.severity){case m.InputBoxValidationSeverity.Info:b=R.default.Info;break;case m.InputBoxValidationSeverity.Warning:b=R.default.Warning;break;case m.InputBoxValidationSeverity.Error:b=R.default.Error;break;default:b=L.message?R.default.Error:R.default.Ignore;break}return{content:L.message,severity:b}}async showWorkspaceFolderPick(S,L=y.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!b)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(D=>D.uri.toString()===b.uri.toString())}createQuickPick(S){const L=new g(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(S){const L=new p(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(S,L){this.e.get(S)?._fireDidChangeValue(L)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,L){const b=this.e.get(S);b instanceof g&&b._fireDidChangeActive(L)}$onDidChangeSelection(S,L){const b=this.e.get(S);b instanceof g&&b._fireDidChangeSelection(L)}$onDidTriggerButton(S,L){this.e.get(S)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(S,L,b){const E=this.e.get(S);E instanceof g&&E._fireDidTriggerItemButton(L,b)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class c{static{this.a=1}constructor(S,L){this.x=S,this.y=L,this._id=g.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Vd,this.q=new M.$Vd,this.r=new M.$Vd,this.s=new M.$Vd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((L,b)=>{const E=L===m.$uM.Back?-1:b;this.o.set(E,L)}),this.z({buttons:S.map((L,b)=>({...t(L.iconPath),tooltip:L.tooltip,handle:L===m.$uM.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const L=this.o.get(S);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(S){if(!this.v){for(const L of Object.keys(S)){const b=S[L];this.u[L]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(d){if(d instanceof m.$7L)return{id:d.id};const S=u(d),L=i(d);return{dark:typeof S=="string"?P.URI.file(S):S,light:typeof L=="string"?P.URI.file(L):L}}function i(d){return typeof d=="object"&&"light"in d?d.light:d}function u(d){return typeof d=="object"&&"dark"in d?d.dark:d}function t(d){const S=h(d);let L,b;return"id"in S?b=k.ThemeIcon.asClassName(S):L=S,{iconPath:L,iconClass:b}}class g extends c{constructor(S,L){super(S.identifier,L),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Vd,this.L=[],this.M=new M.$Vd,this.N=new M.$Vd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((E,D)=>{this.C.set(D,E),this.D.set(E,D)});const L=(0,l.$FF)(this.O,"quickPickItemTooltip"),b=[];for(let E=0;E<S.length;E++){const D=S[E];if(D.kind===m.QuickPickItemKind.Separator)b.push({type:"separator",label:D.label});else{D.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const T=D.iconPath?t(D.iconPath):void 0;b.push({handle:E,label:D.label,iconPath:T?.iconPath,iconClass:T?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:L?$.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((O,G)=>({...t(O.iconPath),tooltip:O.tooltip,handle:G}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(S){const L=(0,w.$Hb)(S.map(b=>this.C.get(b)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(S){const L=(0,w.$Hb)(S.map(b=>this.C.get(b)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(S,L){const b=this.C.get(S);if(!b||!b.buttons||!b.buttons.length)return;const E=b.buttons[L];E&&this.N.fire({button:E,item:b})}}class p extends c{constructor(S,L){super(S.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:R.default.Error}):this.z({validationMessage:S.message,severity:S.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new o(a,r)}e.$7hc=v}),define(Pe[265],Re([1,0,2,5,67,6,13,3,18,138,14,23,44,8,24,11,21]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=e.$8hc=void 0;function n(T){return T instanceof y.URI}function o(T,O){return T.scheme===s.Schemas.file&&O.scheme===s.Schemas.file&&a.$k?T.toString()===O.toString():T.toString().toLowerCase()===O.toString().toLowerCase()}function c(T){if(T)return typeof T.iconPath=="string"?y.URI.file(T.iconPath):y.URI.isUri(T.iconPath)||l.ThemeIcon.isThemeIcon(T.iconPath)?T.iconPath:void 0}function h(T){if(T.icon){if(y.URI.isUri(T.icon))return T.icon;if(l.ThemeIcon.isThemeIcon(T.icon))return T.icon;{const O=T.icon;return{light:O.light,dark:O.dark}}}else return}function i(T,O){if(!T.iconPath&&!O.iconPath)return 0;if(T.iconPath){if(!O.iconPath)return 1}else return-1;const G=typeof T.iconPath=="string"?T.iconPath:y.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id,q=typeof O.iconPath=="string"?O.iconPath:y.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,w.$Sq)(G,q)}function u(T,O){let G=0;if(T.strikeThrough!==O.strikeThrough)return T.strikeThrough?1:-1;if(T.faded!==O.faded)return T.faded?1:-1;if(T.tooltip!==O.tooltip)return(T.tooltip||"").localeCompare(O.tooltip||"");if(G=i(T,O),G!==0)return G;if(T.light&&O.light)G=i(T.light,O.light);else{if(T.light)return 1;if(O.light)return-1}if(G!==0)return G;if(T.dark&&O.dark)G=i(T.dark,O.dark);else{if(T.dark)return 1;if(O.dark)return-1}return G}function t(T,O){if(T.command!==O.command)return T.command<O.command?-1:1;if(T.title!==O.title)return T.title<O.title?-1:1;if(T.tooltip!==O.tooltip){if(T.tooltip!==void 0&&O.tooltip!==void 0)return T.tooltip<O.tooltip?-1:1;if(T.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(T.arguments===O.arguments)return 0;if(T.arguments)if(O.arguments){if(T.arguments.length!==O.arguments.length)return T.arguments.length-O.arguments.length}else return 1;else return-1;for(let G=0;G<T.arguments.length;G++){const q=T.arguments[G],U=O.arguments[G];if(q!==U&&!(n(q)&&n(U)&&o(q,U)))return q<U?-1:1}return 0}function g(T,O){let G=(0,w.$Sq)(T.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(G!==0)return G;if(T.command&&O.command)G=t(T.command,O.command);else{if(T.command)return 1;if(O.command)return-1}if(G!==0)return G;if(T.decorations&&O.decorations)G=u(T.decorations,O.decorations);else{if(T.decorations)return 1;if(O.decorations)return-1}if(T.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)G=(0,w.$Sq)(T.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(T.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(T.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)G=(0,w.$Sq)(T.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(T.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return G}function p(T,O){for(let G=0;G<T.length;G++)if(T[G]!==O[G])return!1;return!0}function d(T,O){return T.command===O.command&&T.title===O.title&&T.tooltip===O.tooltip&&(T.arguments&&O.arguments?p(T.arguments,O.arguments):T.arguments===O.arguments)}function S(T,O){return(0,f.$ub)(T,O,d)}class L{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,v.$GF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,v.$GF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,v.$GF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,G,q,U,I){this.k=O,this.l=U,this.m=I,this.d="",this.e=new M.$Vd,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=q}showValidationMessage(O,G){(0,v.$GF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,G)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$8hc=L;class b{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,G,q,U,I,N,W){this.q=O,this.s=G,this.t=q,this.u=U,this.v=I,this.multiDiffEditorEnableViewChanges=N,this.w=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Vd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Vd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=b.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,G){const q=this.h.get(O);return q?(0,P.$Yg)(()=>this.s.executeCommand(q.command,...q.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(g),q=(0,f.$Db)(this.o,O,g).map(N=>{const W=N.toInsert.map(ae=>{const de=this.e++;this.g.set(de,ae);const we=ae.resourceUri;let ke;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const te=new A.$Sc;ke=this.s.converter.toInternal(ae.command,te),this.j.set(de,te)}else this.h.set(de,ae.command);const ue=(0,v.$FF)(this.w,"scmMultiDiffEditor"),pe=ue?ae.multiDiffEditorOriginalUri:void 0,ie=ue?ae.multiFileDiffEditorModifiedUri:void 0,be=c(ae.decorations),se=ae.decorations&&c(ae.decorations.light)||be,Z=ae.decorations&&c(ae.decorations.dark)||be,V=[se,Z],ne=ae.decorations&&ae.decorations.tooltip||"",Ae=ae.decorations&&!!ae.decorations.strikeThrough,Le=ae.decorations&&!!ae.decorations.faded,Ce=ae.contextValue||"";return{rawResource:[de,we,V,ne,Ae,Le,Ce,ke,pe,ie],handle:de}});return{start:N.start,deleteCount:N.deleteCount,toInsert:W}}),U=q.map(({start:N,deleteCount:W,toInsert:ae})=>[N,W,ae.map(de=>de.rawResource)]),I=q.reverse();for(const{start:N,deleteCount:W,toInsert:ae}of I){const de=ae.map(ke=>ke.handle),we=this.n.splice(N,W,...de);for(const ke of we)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=O,U}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let G;(0,v.$FF)(this.x,"quickDiffProvider")&&(G=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:G})}get historyProvider(){return(0,v.$GF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,v.$GF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new A.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new A.$Sc,this.o=O;const G=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,v.$GF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,v.$GF)(this.x,"scmActionButton"),this.p.value=new A.$Sc,this.q=O;const G=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(q=>q.map(U=>this.y.converter.toInternal(U,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&S(this.t,O))return;this.s.value=new A.$Sc,this.t=O;const G=(O||[]).map(q=>this.y.converter.toInternal(q,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(O,G,q,U,I,N,W){this.x=O,this.y=U,this.z=I,this.A=N,this.B=W,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Uc,this.m=void 0,this.n=new A.$Uc,this.o=void 0,this.p=new A.$Uc,this.s=new A.$Uc,this.t=void 0,this.u=!1,this.v=new M.$Vd,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=q;const ae=y.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${I}/scm${this.w}/input`,query:W?`rootUri=${encodeURIComponent(W.toString())}`:void 0});this.f=new L(O,G,this.#e,this.w,ae),this.#e.$registerSourceControl(this.w,I,N,W,ae)}createResourceGroup(O,G,q){const U=(0,v.$FF)(this.x,"scmMultiDiffEditor")&&q?.multiDiffEditorEnableViewChanges===!0,I=new b(this.#e,this.y,this.w,O,G,U,this.x),N=M.Event.once(I.onDidDispose)(()=>this.C.delete(I));return this.C.set(I,N),this.eventuallyAddResourceGroups(),I}eventuallyAddResourceGroups(){const O=[],G=[];for(const[q,U]of this.C){U.dispose();const I=q.onDidUpdateResourceStates(()=>{this.D.add(q),this.eventuallyUpdateResourceStates()});M.Event.once(q.onDidDispose)(()=>{this.D.delete(q),I.dispose(),this.e.delete(q.handle),this.#e.$unregisterGroup(this.w,q.handle)}),O.push([q.handle,q.id,q.label,q.features,q.multiDiffEditorEnableViewChanges]);const N=q._takeResourceStateSnapshot();N.length>0&&G.push([q.handle,N]),this.e.set(q.handle,q)}this.#e.$registerGroups(this.w,O,G),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(G=>{const q=G._takeResourceStateSnapshot();q.length!==0&&O.push([G.handle,q])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,C.$yh)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,C.$yh)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,G,q,U){this.l=G,this.m=q,this.n=U,this.g=new Map,this.h=new k.$nm,this.j=new M.$Vd,this.e=O.getProxy(m.$0K.MainThreadSCM),this.f=O.getProxy(m.$0K.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===3){const N=this.g.get(I.sourceControlHandle);if(!N)return I;const W=N.getResourceGroup(I.groupHandle);return W?W.getResourceState(I.handle):I}else if(I&&I.$mid===4){const N=this.g.get(I.sourceControlHandle);return N?N.getResourceGroup(I.groupHandle):I}else if(I&&I.$mid===5){const N=this.g.get(I.handle);return N||I}return I}})}createSourceControl(O,G,q,U){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,G,q,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const I=r.d++,N=new E(O,this.m,this.e,this.l,G,q,U);this.g.set(I,N);const W=this.h.get(O.identifier)||[];return W.push(N),this.h.set(O.identifier,W),N}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const G=this.h.get(O.identifier),q=G&&G[G.length-1];return q&&q.inputBox}$provideOriginalResource(O,G,q){const U=y.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",O,U.toString());const I=this.g.get(O);return!I||!I.quickDiffProvider||!I.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.$Yg)(()=>I.quickDiffProvider.provideOriginalResource(U,q)).then(N=>N||null)}$onInputBoxValueChange(O,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const q=this.g.get(O);return q&&q.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(O,G,q,U){this.n.trace("ExtHostSCM#$executeResourceCommand",O,G,q);const I=this.g.get(O);if(!I)return Promise.resolve(void 0);const N=I.getResourceGroup(G);return N?N.$executeResourceCommand(q,U):Promise.resolve(void 0)}$validateInput(O,G,q){this.n.trace("ExtHostSCM#$validateInput",O);const U=this.g.get(O);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,P.$Yg)(()=>U.inputBox.validateInput(G,q)).then(I=>{if(!I)return Promise.resolve(void 0);const N=$.MarkdownString.fromStrict(I.message);return N?Promise.resolve([N,I.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(O,G,q){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupBase(G,q)??void 0}async $resolveHistoryItemGroupCommonAncestor(O,G,q,U){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,q,U)??void 0}async $provideHistoryItems(O,G,q,U){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(G,q,U))?.map(W=>({...W,icon:h(W)}))??void 0}async $provideHistoryItemSummary(O,G,q,U){const I=this.g.get(O)?.historyProvider;if(typeof I?.provideHistoryItemSummary!="function")return;const N=await I.provideHistoryItemSummary(G,q,U);return N?{...N,icon:h(N)}:void 0}async $provideHistoryItemChanges(O,G,q,U){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(G,q,U)??void 0}};e.$9hc=D,e.$9hc=D=r=Je([He(3,R.$nj)],D)}),define(Pe[266],Re([1,0,3,8,2]),function(ge,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class A{static{this.a=0}constructor(m,f){this.d=f,this.c=new Map,this.b=m.getProxy(y.$0K.MainThreadShare)}async $provideShare(m,f,w){return await this.c.get(m)?.provideShare({selection:M.Range.to(f.selection),resourceUri:C.URI.revive(f.resourceUri)},w)??void 0}registerShareProvider(m,f){const w=A.a++;return this.c.set(w,f),this.b.$registerShareProvider(w,M.DocumentSelector.from(m,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$0hc=A}),define(Pe[267],Re([1,0,7,3,163,6,8,16]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=e.$_hc=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$8L("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$8L("statusBarItem.warningForeground")]])}#e;#t;constructor(l,$,v,s,a,r=y.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new A.$Sc,this.#e=l,this.#t=$,a&&s){this.c=(0,y.$KL)(s.identifier,a);const o=v.get(this.c);o&&(r=o.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,n=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(f.a++);this.e=s,this.f=a,this.g=r,this.h=this.u(n)}u(l){if((0,m.$Mf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!f.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new A.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let $;this.m?$=this.m:$=(0,C.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=f.b.get(this.o.id));const s=P.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,$,this.k,s,this.r?.internal,v,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$_hc=f;class w{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const $={message:l};return this.b.unshift($),this.c(),new y.$_K(()=>{const v=this.b.indexOf($);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(l,$){this.e=new Map,this.a=l.getProxy(M.$0K.MainThreadStatusBar),this.b=$,this.c=new w(this)}$acceptStaticEntries(l){for(const $ of l)this.e.set($.entryId,$)}createStatusBarEntry(l,$,v,s){return new f(this.a,this.b,this.e,l,$,v,s)}setStatusBarMessage(l,$){const v=this.c.setMessage(l);let s;return typeof $=="number"?s=setTimeout(()=>v.dispose(),$):typeof $<"u"&&$.then(()=>v.dispose(),()=>v.dispose()),new y.$_K(()=>{v.dispose(),clearTimeout(s)})}}e.$aic=R}),define(Pe[110],Re([1,0,29,103,48,76,59,8,2]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=e.$nN=void 0;const w=(o,c,h,i)=>{let u=c;return{enumerable:!0,configurable:!1,get(){return u},set(t){if(!h(u,t)){const g=u;u=t,o.listener?.(i(t,g))}}}},R=(o,c)=>o===c,k={range:(o,c)=>o===c?!0:!o||!c?!1:o.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(o,c)=>!(o.length!==c.length||o.some(h=>!c.find(i=>h.id===i.id)))},l=o=>c=>({op:4,update:o(c)}),$=(o,c)=>({range:(()=>{let h;const i=l(u=>({range:y.$Us.lift(m.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return h},set(u){o.listener?.({op:6}),k.range(h,u)||(h=u,o.listener?.(i(u)))}}})(),label:w(o,c,k.label,l(h=>({label:h}))),description:w(o,void 0,k.description,l(h=>({description:h}))),sortText:w(o,void 0,k.sortText,l(h=>({sortText:h}))),canResolveChildren:w(o,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:w(o,!1,k.busy,l(h=>({busy:h}))),error:w(o,void 0,k.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:w(o,[],k.tags,(h,i)=>({op:1,new:h.map(m.TestTag.from),old:i.map(m.TestTag.from)}))}),v=o=>{const c=C.$2J.fromString(o.extId),h=new a(c.controllerId,c.localId,o.label,f.URI.revive(o.uri)||void 0);return h.range=m.Range.to(o.range||void 0),h.description=o.description||void 0,h.sortText=o.sortText||void 0,h.tags=o.tags.map(i=>m.TestTag.to({id:(0,P.$7J)(i).tagId})),h},s=o=>{let c;for(const h of o.tests){const i=v(h.item);(0,M.$0M)(i).parent=c,c=i}return c};e.$nN=s;class a{constructor(c,h,i,u){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const t=(0,M.$9M)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return t.parent instanceof r?void 0:t.parent}},children:{value:(0,A.$8M)(t,M.$0M,a),enumerable:!0,writable:!1},...$(t,i)})}}e.$oN=a;class r extends a{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$pN=r;class n extends A.$4M{constructor(c,h,i){super({controllerId:c,getDocumentVersion:u=>u&&i.getDocument(u)?.version,getApiFor:M.$0M,getChildren:u=>u.children,root:new r(c,h),toITestItem:m.TestItem.from})}}e.$qN=n}),define(Pe[32],Re([1,0,16,7,8,26,3,18,14,51,29,92,2,6,4,17,110,22,49,40,63,57,60,33]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n,o,c,h,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=void 0;let t=class{#e;#t;#i;constructor(b,E,D){this.b=new Map,this.c=new Map,this.#e=b.getProxy(P.$0K.MainThreadCommands),this.d=E,this.#i=D,this.#t=b.getProxy(P.$0K.MainThreadTelemetry),this.converter=new g(this,T=>{const O=this.c.get(T);return O?.result===d.Void?O:void 0},E),this.f=[{processArgument(T){return(0,w.$Ch)(T)}},{processArgument(T){return(0,A.$xn)(T,function(O){if(R.$Us.isIRange(O))return C.Range.to(O);if(k.$Ts.isIPosition(O))return C.Position.to(O);if(R.$Us.isIRange(O.range)&&l.URI.isUri(O.uri))return C.location.to(O);if(O instanceof r.$je)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const E=this.registerCommand(!1,b.id,async(...D)=>{const T=b.args.map((G,q)=>{if(!G.validate(D[q]))throw new Error(`Invalid argument '${G.name}' when running '${b.id}', received: ${typeof D[q]=="object"?JSON.stringify(D[q],null,"	"):D[q]} `);return G.convert(D[q])}),O=await this.executeCommand(b.internalId,...T);return b.result.convert(O,D,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new M.$_K(()=>{E.dispose(),this.c.delete(b.id)})}registerCommand(b,E,D,T,O,G){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:D,thisArg:T,metadata:O,extension:G}),b&&this.#e.$registerCommand(E),new M.$_K(()=>{this.b.delete(E)&&b&&this.#e.$unregisterCommand(E)})}executeCommand(b,...E){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,E,!0)}async g(b,E,D){if(this.b.has(b))return this.#e.$fireCommandActivationEvent(b),this.h(b,E,!1);{let T=!1;const O=(0,A.$xn)(E,function(G){if(G instanceof M.$aL)return C.Position.from(G);if(G instanceof M.$bL)return C.Range.from(G);if(G instanceof M.$lL)return C.location.from(G);if(M.$xM.isNotebookRange(G))return C.NotebookRange.from(G);if(G instanceof ArrayBuffer)return T=!0,r.$je.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return T=!0,r.$je.wrap(G);if(G instanceof r.$je)return T=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(b,T?new n.$Tv(O):O,D);return(0,w.$Ch)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(b,E,!1);throw G}}}async h(b,E,D){const T=this.b.get(b);if(!T)throw new Error("Unknown command");const{callback:O,thisArg:G,metadata:q}=T;if(q?.args)for(let I=0;I<q.args.length;I++)try{(0,y.$Zf)(E[I],q.args[I].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${q.args[I].name}' - ${q.args[I].description}`)}const U=c.$Rd.create();try{return await O.apply(G,E)}catch(I){if(b===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...E);N&&(b=N.command)}if(this.d.error(I,b,T.extension?.identifier),!D)throw I;if(T.extension?.identifier){const N=this.#i.onExtensionError(T.extension.identifier,I);this.d.trace("forwarded error to extension?",N,T.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Qi)(I)),this.id=b,this.source=T.extension?.displayName??T.extension?.name}}}finally{this.j(T,b,U.elapsed())}}j(b,E,D){b.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new h.$Lo(E),duration:D})}$executeContributedCommand(b,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const D=this.b.get(b);return D?(E=E.map(T=>this.f.reduce((O,G)=>G.processArgument(O,D.extension?.identifier),T)),this.h(b,E,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),this.#e.$getCommands().then(E=>(b&&(E=E.filter(D=>D[0]!=="_")),E))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[E,D]of this.b){const{metadata:T}=D;T&&(b[E]=T)}return Promise.resolve(b)}};e.$wN=t,e.$wN=t=Je([He(0,s.$bN),He(1,f.$nj),He(2,i.$vN)],t),e.$xN=(0,v.$6h)("IExtHostCommands");class g{constructor(b,E,D){this.d=b,this.f=E,this.g=D,this.delegatingCommandId=`__vsc${(0,u.$qg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,E){if(!b)return;const D={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return D;const T=this.f(b.command);if(T)D.id=T.internalId,D.arguments=T.args.map((O,G)=>O.convert(b.arguments&&b.arguments[G]));else if((0,m.$Lb)(b.arguments)){const O=`${b.command} /${++this.c}`;this.b.set(O,b),E.add((0,$.$Rc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),D.$ident=O,D.id=this.delegatingCommandId,D.arguments=[O],this.g.trace("CommandsConverter#CREATE",b.command,O)}return D}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const E=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$yN=g;class p{static{this.Uri=new p("uri","Uri of a text document",b=>l.URI.isUri(b),b=>b)}static{this.Position=new p("position","A position in a text document",b=>M.$aL.isPosition(b),C.Position.from)}static{this.Range=new p("range","A range in a text document",b=>M.$bL.isRange(b),C.Range.from)}static{this.Selection=new p("selection","A selection in a text document",b=>M.$cL.isSelection(b),C.Selection.from)}static{this.Number=new p("number","",b=>typeof b=="number",b=>b)}static{this.String=new p("string","",b=>typeof b=="string",b=>b)}static{this.StringArray=p.Arr(p.String)}static Arr(b){return new p(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,E=>Array.isArray(E)&&E.every(D=>b.validate(D)),E=>E.map(D=>b.convert(D)))}static{this.CallHierarchyItem=new p("item","A call hierarchy item",b=>b instanceof M.$wL,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new p("item","A type hierarchy item",b=>b instanceof M.$QM,C.TypeHierarchyItem.from)}static{this.TestItem=new p("testItem","A VS Code TestItem",b=>b instanceof a.$oN,C.TestItem.from)}constructor(b,E,D,T){this.name=b,this.description=E,this.validate=D,this.convert=T}optional(){return new p(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,E){return new p(b??this.name,E??this.description,this.validate,this.convert)}}e.$zN=p;class d{static{this.Void=new d("no result",b=>b)}constructor(b,E){this.description=b,this.convert=E}}e.$AN=d;class S{constructor(b,E,D,T,O){this.id=b,this.internalId=E,this.description=D,this.args=T,this.result=O}}e.$BN=S}),define(Pe[268],Re([1,0,18,11,2,87,96,35,32,8,7]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;const k=[new f.$BN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of DocumentHighlight-instances.",$(w.DocumentHighlight.to))),new f.$BN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$zN.Uri],new f.$AN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,a)=>{if((0,y.$Kb)(s))return;class r extends R.$rL{static to(o){const c=new r(o.name,w.SymbolKind.to(o.kind),o.containerName||"",new R.$lL(a[0],w.Range.to(o.range)));return c.detail=o.detail,c.range=c.location.range,c.selectionRange=w.Range.to(o.selectionRange),c.children=o.children?o.children.map(r.to):[],c}}return s.map(r.to)})),new f.$BN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$zN.Uri,new f.$zN("options","Formatting options",s=>!0,s=>s)],new f.$AN("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new f.$BN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$zN.Uri,f.$zN.Range,new f.$zN("options","Formatting options",s=>!0,s=>s)],new f.$AN("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new f.$BN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$zN.Uri,f.$zN.Position,new f.$zN("ch","Trigger character",s=>typeof s=="string",s=>s),new f.$zN("options","Formatting options",s=>!0,s=>s)],new f.$AN("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new f.$BN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Location or LocationLink instances.",v)),new f.$BN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Location or LocationLink instances.",v)),new f.$BN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Location or LocationLink instances.",v)),new f.$BN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Location or LocationLink instances.",v)),new f.$BN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Location-instances.",$(w.location.to))),new f.$BN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of Hover-instances.",$(w.Hover.to))),new f.$BN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$zN.Uri,new f.$zN("position","A position in a text document",s=>Array.isArray(s)&&s.every(a=>R.$aL.isPosition(a)),s=>s.map(w.Position.from))],new f.$AN("A promise that resolves to an array of ranges.",s=>s.map(a=>{let r;for(const n of a.reverse())r=new R.$vL(w.Range.to(n),r);return r}))),new f.$BN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$zN.String.with("query","Search string")],new f.$AN("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(w.WorkspaceSymbol.to))),new f.$BN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(w.CallHierarchyItem.to))),new f.$BN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$zN.CallHierarchyItem],new f.$AN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(w.CallHierarchyIncomingCall.to))),new f.$BN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$zN.CallHierarchyItem],new f.$AN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(w.CallHierarchyOutgoingCall.to))),new f.$BN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:w.Range.to(s.range),placeholder:s.text}})),new f.$BN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$zN.Uri,f.$zN.Position,f.$zN.String.with("newName","The new symbol name")],new f.$AN("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return w.WorkspaceEdit.to(s)}})),new f.$BN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$zN.Uri,f.$zN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$AN("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(w.DocumentLink.to))),new f.$BN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$zN.Uri],new f.$AN("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new R.$pM(s.tokenTypes,s.tokenModifiers)})),new f.$BN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$zN.Uri],new f.$AN("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,P.$x$)(s);if(a.type==="full")return new R.$rM(a.data,void 0)})),new f.$BN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$zN.Uri,f.$zN.Range.optional()],new f.$AN("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new R.$pM(s.tokenTypes,s.tokenModifiers)})),new f.$BN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$zN.Uri,f.$zN.Range],new f.$AN("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,P.$x$)(s);if(a.type==="full")return new R.$rM(a.data,void 0)})),new f.$BN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$zN.Uri,f.$zN.Position,f.$zN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$zN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$AN("A promise that resolves to a CompletionList-instance.",(s,a,r)=>{if(!s)return new R.$HL([]);const n=s.suggestions.map(o=>w.CompletionItem.to(o,r));return new R.$HL(n,s.incomplete)})),new f.$BN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$zN.Uri,f.$zN.Position,f.$zN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$AN("A promise that resolves to SignatureHelp.",s=>{if(s)return w.SignatureHelp.to(s)})),new f.$BN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$zN.Uri,f.$zN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$AN("A promise that resolves to an array of CodeLens-instances.",(s,a,r)=>$(n=>new R.$zL(w.Range.to(n.range),n.command&&r.fromInternal(n.command)))(s))),new f.$BN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$zN.Uri,new f.$zN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>R.$bL.isRange(s),s=>R.$cL.isSelection(s)?w.Selection.from(s):w.Range.from(s)),f.$zN.String.with("kind","Code action kind to return code actions for").optional(),f.$zN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$AN("A promise that resolves to an array of Command-instances.",(s,a,r)=>$(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(n.command)}else{const o=new R.$tL(n.title,n.kind?new R.$uL(n.kind):void 0);return n.edit&&(o.edit=w.WorkspaceEdit.to(n.edit)),n.command&&(o.command=r.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(s))),new f.$BN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$zN.Uri],new f.$AN("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(a=>new R.$NL(w.Range.to(a.range),w.Color.to(a.color))):[])),new f.$BN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$zN("color","The color to show and insert",s=>s instanceof R.$ML,w.Color.from),new f.$zN("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:w.Range.from(s.range)}))],new f.$AN("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(w.ColorPresentation.to):[])),new f.$BN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$zN.Uri,f.$zN.Range],new f.$AN("A promise that resolves to an array of Inlay objects",(s,a,r)=>s.map(w.InlayHint.to.bind(void 0,r)))),new f.$BN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$zN.Uri],new f.$AN("A promise that resolves to an array of FoldingRange objects",(s,a)=>{if(s)return s.map(w.FoldingRange.to)})),new f.$BN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$AN("A promise that resolves to an array of NotebookContentProvider static info objects.",$(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(a=>w.NotebookExclusiveDocumentPattern.to(a))})))),new f.$BN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$zN.Uri,f.$zN.Range,new f.$zN("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof R.$bL,s=>w.InlineValueContext.from(s))],new f.$AN("A promise that resolves to an array of InlineValue objects",s=>s.map(w.InlineValue.to))),new f.$BN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$zN("uriOrString","Uri-instance or string (only http/https)",s=>C.URI.isUri(s)||typeof s=="string"&&(0,M.$fg)(s,M.Schemas.http,M.Schemas.https),s=>s),new f.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[w.ViewColumn.from(s),void 0]:[w.ViewColumn.from(s.viewColumn),w.TextEditorOpenOptions.from(s)])).optional(),f.$zN.String.with("label","").optional()],f.$AN.Void),new f.$BN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$zN.Uri.with("resource","Resource to open"),f.$zN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[w.ViewColumn.from(s),void 0]:[w.ViewColumn.from(s.viewColumn),w.TextEditorOpenOptions.from(s)])).optional()],f.$AN.Void),new f.$BN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$zN.Uri.with("left","Left-hand side resource of the diff editor"),f.$zN.Uri.with("right","Right-hand side resource of the diff editor"),f.$zN.String.with("title","Human readable title for the diff editor").optional(),new f.$zN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[w.ViewColumn.from(s.viewColumn),w.TextEditorOpenOptions.from(s)]).optional()],f.$AN.Void),new f.$BN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$zN.String.with("title","Human readable title for the changes editor"),new f.$zN("resourceList","List of resources to compare",s=>{for(const a of s){if(a.length!==3)return!1;const[r,n,o]=a;if(!C.URI.isUri(r)||!C.URI.isUri(n)&&n!==void 0&&n!==null||!C.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},s=>s)],f.$AN.Void),new f.$BN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$zN.Uri,f.$zN.Position],new f.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(w.TypeHierarchyItem.to))),new f.$BN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$zN.TypeHierarchyItem],new f.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(w.TypeHierarchyItem.to))),new f.$BN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$zN.TypeHierarchyItem],new f.$AN("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(w.TypeHierarchyItem.to))),new f.$BN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$zN.TestItem],f.$AN.Void),new f.$BN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$zN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$AN.Void),new f.$BN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$zN.String.with("name","The context key name"),new f.$zN("value","The context key value",()=>!0,s=>s)],f.$AN.Void),new f.$BN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$zN.Uri,f.$zN.StringArray,new f.$zN("MappedEditsContext","Mapped Edits Context",s=>w.MappedEditsContext.is(s),s=>w.MappedEditsContext.from(s))],new f.$AN("A promise that resolves to a workspace edit or null",s=>s?w.WorkspaceEdit.to(s):null))];class l{static register(a){k.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",m.$5i)}}e.$vgc=l;function $(s){return a=>{if(Array.isArray(a))return a.map(s)}}function v(s){if(!Array.isArray(s))return;const a=[];for(const r of s)A.$Gt(r)?a.push(w.DefinitionLink.to(r)):a.push(w.location.to(r));return a}}),define(Pe[269],Re([1,0,6,2,3,8,7,32,13]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class w{static{this.a=0}constructor($,v){this.extension=$,this.provider=v,this.handle=w.a++}}class R{constructor($){this.session=$,this.responses=[]}}class k{static{this.a=0}constructor($,v,s,a){this.f=s,this.g=a,this.b=new Map,this.d=new Map,this.e=$.getProxy(C.$0K.MainThreadInlineChat),v.registerApiCommand(new m.$BN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$zN("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?A.Range.from(r.initialRange):void 0,initialSelection:r.initialSelection?A.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?A.Position.from(r.position):void 0}})],m.$AN.Void))}registerProvider($,v,s){const a=new w($,v);return this.b.set(a.handle,a),this.e.$registerInteractiveEditorProvider(a.handle,s?.label??$.displayName??$.name,$.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",s?.supportReportIssue??!1),(0,y.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(a.handle),this.b.delete(a.handle)})}async $prepareSession($,v,s,a){const r=this.b.get($);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(M.URI.revive(v)),o=A.Selection.to(s),c=await r.provider.prepareInteractiveEditorSession({document:n,selection:o},a);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=k.a++;return this.d.set(h,new R(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:A.Range.from(c.wholeRange),message:c.message}}async $provideResponse($,v,s,a){const r=this.b.get($);if(!r)return;const n=this.d.get(v.id);if(!n)return;const o={prompt:s.prompt,selection:A.Selection.to(s.selection),wholeRange:A.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,withIntentDetection:s.withIntentDetection};let c=!1;const h={report:async L=>{if(!s.live&&L.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||a.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:L.message,edits:L.edits?.map(A.TextEdit.from),editsShouldBeInstant:L.editsShouldBeInstant,slashCommand:L.slashCommand?.command,markdownFragment:P.$AL.isMarkdownString(L.content)?L.content.value:L.content})}},i=Promise.resolve(r.provider.provideInteractiveEditorResponse(n.session,o,h,a));let u;try{u=await(0,f.$Ug)(i,a)}finally{c=!0}if(!u)return;const t=n.responses.push(u)-1,g={wholeRange:A.Range.from(u.wholeRange),placeholder:u.placeholder};if(!k.h(u))return{...g,id:t,type:"editorEdit",message:A.MarkdownString.from(u.contents),edits:[]};const{edits:p,contents:d}=u,S=d!==void 0?A.MarkdownString.from(d):void 0;return p instanceof P.$jL?{...g,id:t,type:"bulkEdit",edits:A.WorkspaceEdit.from(p),message:S}:{...g,id:t,type:"editorEdit",edits:p.map(A.TextEdit.from),message:S}}async $provideFollowups($,v,s,a){const r=this.b.get($),n=this.d.get(v),o=n?.responses[s];if(r&&o&&r.provider.provideFollowups){const c=Promise.resolve(r.provider.provideFollowups(n.session,o,a));return(await(0,f.$Ug)(c,a))?.map(A.ChatFollowup.from)}}$handleFeedback($,v,s,a){const r=this.b.get($),n=this.d.get(v),o=n?.responses[s];if(r&&o){const c=A.InteractiveEditorResponseFeedbackKind.to(a);r.provider.handleInteractiveEditorResponseFeedback?.(n.session,o,c)}}$releaseSession($,v){}static h($){return typeof $=="object"&&typeof $.edits=="object"}}e.$Dhc=k}),define(Pe[270],Re([1,0,2,32]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class C{constructor(P,m,f,w,R){this.a=m,this.b=f,this.c=w;const k=new M.$BN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$zN("showOptions","Show Options",l=>!0,l=>l),new M.$zN("resource","Interactive resource Uri",l=>!0,l=>l),new M.$zN("controllerId","Notebook controller Id",l=>!0,l=>l),new M.$zN("title","Interactive editor title",l=>!0,l=>l)],new M.$AN("Notebook and input URI",l=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const $=this.a.getEditorById(l.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",$.id),{notebookUri:y.URI.revive(l.notebookUri),inputUri:y.URI.revive(l.inputUri),notebookEditor:$.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:y.URI.revive(l.notebookUri),inputUri:y.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(P,m,f,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:f,uri:P,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.$Qhc=C}),define(Pe[271],Re([1,0,18,13,20,5,6,28,2,23,14,3,32,8,7,77,209,24,49]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=e.$Yhc=void 0;let o=class{constructor(d,S,L,b,E){this.m=S,this.n=L,this.o=b,this.q=E,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$Vd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(k.$0K.MainThreadNotebookKernels);const D=new l.$BN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$zN("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const O=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:O}}else if(T&&"notebookEditor"in T){const O=this.n.getIdByEditor(T.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return T})],l.$AN.Void);this.o.registerApiCommand(D)}createNotebookController(d,S,L,b,E,D){for(const ie of this.j.values())if(ie.controller.id===S&&w.$lm.equals(d.identifier,ie.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const T=this.k++,O=this;this.q.trace(`NotebookController[${T}], CREATED by ${d.identifier.value}, ${S}`);const G=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${d.identifier}'`);let q=!1;const U=new A.$Vd,I=new A.$Vd,N={id:g(d.identifier,S),notebookType:L,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:b||d.identifier.value,preloads:D?D.map($.NotebookRendererScript.from):[]};let W=E??G,ae,de;this.a.$addKernel(T,N).catch(ie=>{console.log(ie),q=!0});let we=0;const ke=()=>{if(q)return;const ie=++we;Promise.resolve().then(()=>{ie===we&&this.a.$updateKernel(T,N)})},ue=new m.$Ac,pe={get id(){return S},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return N.label},set label(ie){N.label=ie??d.displayName??d.name,ke()},get detail(){return N.detail??""},set detail(ie){N.detail=ie,ke()},get description(){return N.description??""},set description(ie){N.description=ie,ke()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(ie){N.supportedLanguages=ie,ke()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){N.supportsExecutionOrder=ie,ke()},get rendererScripts(){return N.preloads?N.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(ie){W=ie??G},get interruptHandler(){return ae},set interruptHandler(ie){ae=ie,N.supportsInterrupt=!!ie,ke()},set variableProvider(ie){(0,r.$GF)(d,"notebookVariableProvider"),de=ie,N.hasVariableProvider=!!ie,ie?.onDidChangeVariables(be=>O.a.$variablesUpdated(be.uri)),ke()},get variableProvider(){return de},createNotebookCellExecution(ie){if(q)throw new Error("notebook controller is DISPOSED");if(!ue.has(ie.notebook.uri))throw O.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return O._createNotebookCellExecution(ie,g(d.identifier,this.id))},createNotebookExecution(ie){if((0,r.$GF)(d,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!ue.has(ie.uri))throw O.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.uri.toString()}`);return O._createNotebookExecution(ie,g(d.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${T}], DISPOSED`),q=!0,this.j.delete(T),U.dispose(),I.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity(ie,be){be===v.NotebookControllerAffinity2.Hidden&&(0,r.$GF)(d,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(T,ie.uri,be)},onDidReceiveMessage:I.event,postMessage(ie,be){return(0,r.$GF)(d,"notebookMessaging"),O.a.$postMessage(T,be&&O.n.getIdByEditor(be),ie)},asWebviewUri(ie){return(0,r.$GF)(d,"notebookMessaging"),(0,s.$Dvb)(ie,O.m.remote)}};return this.j.set(T,{extensionId:d.identifier,controller:pe,onDidReceiveMessage:I,onDidChangeSelection:U,associatedNotebooks:ue}),pe}getIdByController(d){for(const[S,L]of this.j)if(L.controller===d)return g(L.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,S){const L=this.g++,b=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(L,S);const E={dispose:()=>{this.f.delete(L),b.a.$removeKernelDetectionTask(L)}};return this.f.set(L,E),E}registerKernelSourceActionProvider(d,S,L){const b=this.i++,E=typeof L.onDidChangeNotebookKernelSourceActions=="function"?b:void 0,D=this;this.h.set(b,L),this.q.trace(`NotebookKernelSourceActionProvider[${b}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(b,b,S);let T;return E!==void 0&&(T=L.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(E))),{dispose:()=>{this.h.delete(b),D.a.$removeKernelSourceActionProvider(b,b),T?.dispose()}}}async $provideKernelSourceActions(d,S){const L=this.h.get(d);if(L){const b=new P.$Sc;return(await L.provideNotebookKernelSourceActions(S)??[]).map(D=>$.NotebookKernelSourceAction.from(D,this.o.converter,b))}return[]}$acceptNotebookAssociation(d,S,L){const b=this.j.get(d);if(b){const E=this.n.getNotebookDocument(f.URI.revive(S));L?b.associatedNotebooks.set(E.uri,!0):b.associatedNotebooks.delete(E.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,E.uri.toString(),L),b.onDidChangeSelection.fire({selected:L,notebook:E.apiNotebook})}}async $executeCells(d,S,L){const b=this.j.get(d);if(!b)return;const E=this.n.getNotebookDocument(f.URI.revive(S)),D=[];for(const T of L){const O=E.getCell(T);O&&D.push(O.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,E.uri.toString(),D.length),await b.controller.executeHandler.call(b.controller,D,E.apiNotebook,b.controller)}catch(T){this.q.error(`NotebookController[${d}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(d,S,L){const b=this.j.get(d);if(!b)return;const E=this.n.getNotebookDocument(f.URI.revive(S));if(b.controller.interruptHandler)await b.controller.interruptHandler.call(b.controller,E.apiNotebook);else for(const D of L){const T=E.getCell(D);T&&this.b.get(T.uri)?.cancel()}if(b.controller.interruptHandler){const D=this.c.get(E.uri);L.length&&Array.isArray(D)&&D.length&&D.forEach(T=>T.dispose())}}async $provideVariables(d,S,L,b,E,D,T){const O=this.j.get(d);if(!O)return;const G=this.n.getNotebookDocument(f.URI.revive(L)),q=O.controller.variableProvider;if(!q)return;let U;if(b){if(U=this.s[b],!U)return}else this.s={};const I=E==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,N=q.provideVariables(G.apiNotebook,U,I,D,T);for await(const W of N){if(T.isCancellationRequested)return;const ae={id:this.r++,name:W.variable.name,value:W.variable.value,hasNamedChildren:W.hasNamedChildren,indexedChildrenCount:W.indexedChildrenCount};this.s[ae.id]=W.variable,this.a.$receiveVariable(S,ae)}}$acceptKernelMessageFromRenderer(d,S,L){const b=this.j.get(d);if(!b)return;const E=this.n.getEditorById(S);b.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:L}))}$cellExecutionChanged(d,S,L){const E=this.n.getNotebookDocument(f.URI.revive(d)).getCell(S);if(E){const D=L?$.NotebookCellExecutionState.to(L):v.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:E.apiCell,state:D})}}_createNotebookCellExecution(d,S){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const b=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!b)throw new Error("invalid cell");if(this.b.has(b.uri))throw new Error(`duplicate execution for ${b.uri}`);const E=new h(S,b,this.a);this.b.set(b.uri,E);const D=E.onDidChangeState(()=>{E.state===c.Resolved&&(E.dispose(),D.dispose(),this.b.delete(b.uri))});return E.asApiObject()}_createNotebookExecution(d,S){const L=this.n.getNotebookDocument(d.uri),b=d.getCells().find(T=>{const O=L.getCellFromApiCell(T);return O&&this.b.has(O.uri)});if(b)throw new Error(`duplicate cell execution for ${b.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const E=new u(S,L,this.a),D=E.onDidChangeState(()=>{E.state===i.Resolved&&(E.dispose(),D.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[E,D]),E.asApiObject()}};e.$Yhc=o,e.$Yhc=o=Je([He(4,R.$nj)],o);var c;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(c||(c={}));class h extends P.$Tc{static{this.a=0}get state(){return this.f}constructor(d,S,L){super(),this.m=S,this.n=L,this.b=h.a++,this.c=new A.$Vd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new C.$6d),this.h=new t(10,b=>this.s(b)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const S=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new n.$Tv(S))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let S=this.m;if(d&&(S=this.m.notebook.getCellFromApiCell(d)),!S)throw new Error("INVALID cell");return S.handle}y(d){return d.map(S=>{const L=v.$BM.ensureUniqueMimeTypes(S.items,!0);return L===S.items?$.NotebookCellOutput.from(S):$.NotebookCellOutput.from({items:L,id:S.id,metadata:S.metadata})})}async z(d,S,L){const b=this.w(S),E=this.y((0,y.$3b)(d));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:b,append:L,outputs:E})}async C(d,S,L){return d=v.$BM.ensureUniqueMimeTypes((0,y.$3b)(d),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:d.map($.NotebookCellOutputItem.from),outputId:S.id,append:L})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(L){d.j=L,d.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(L){if(d.f===c.Resolved||d.f===c.Started)throw new Error("Cannot call start again");d.f=c.Started,d.c.fire(),d.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,b){if(d.f===c.Resolved)throw new Error("Cannot call resolve twice");d.f=c.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new n.$Tv({runEndTime:b,lastRunSuccess:L}))},clearOutput(L){return d.t(),d.z([],L,!1)},appendOutput(L,b){return d.t(),d.z(L,b,!0)},replaceOutput(L,b){return d.t(),d.z(L,b,!1)},appendOutputItems(L,b){return d.t(),d.C(L,b,!0)},replaceOutputItems(L,b){return d.t(),d.C(L,b,!1)}})}}var i;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(i||(i={}));class u extends P.$Tc{static{this.a=0}get state(){return this.f}constructor(d,S,L){super(),this.h=S,this.j=L,this.b=u.a++,this.c=new A.$Vd,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new C.$6d),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class t{constructor(d,S){this.f=d,this.g=S,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new M.$qh,this.b=Date.now(),(0,M.$7g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>d.complete())}}function g(p,d){return`${p.value}/${d}`}e.$Zhc=g}),define(Pe[65],Re([1,0,5,3,4,2,17,6,7,165,15,193,20,33,194,44,13,8,32]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=e.$ahc=e.$_gc=e.$$gc=void 0,e.$$gc=(0,C.$6h)("IExtHostTerminalService");class o{constructor(b,E,D,T){this.l=b,this._id=E,this.m=D,this.n=T,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(G,q=!0){O.q(),O.l.$sendText(O._id,G,q)},show(G){O.q(),O.l.$show(O._id,G)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(b,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??E?.cwd??void 0,env:b.env??void 0,icon:p(b.iconPath)??void 0,color:s.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.o(b.location,E?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,E,D,T,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:T,color:s.ThemeColor.isThemeColor(O)?O.id:void 0,location:E?.location||this.o(b,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(b,E){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in b?{viewColumn:r.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.n=b}setExitStatus(b,E){this.h=Object.freeze({code:b,reason:E})}setDimensions(b,E){return b===this.d&&E===this.g||b===0||E===0?!1:(this.d=b,this.g=E,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(b){this.k=b}_setProcessId(b){this.f?(this.f(b),this.f=void 0):this.b.then(E=>{E!==b&&(this.b=Promise.resolve(b))})}}e.$_gc=o;class c{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new y.$Vd,this.onProcessData=this.a.event,this.b=new y.$Vd,this.d=new y.$Vd,this.onDidChangeProperty=this.d.event,this.f=new y.$Vd,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,E){this.g.setDimensions?.({columns:b,rows:E})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends m.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,E,D){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Vd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Vd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Vd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Vd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Vd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Vd,this.onDidChangeShell=this.N.event,this.O=new y.$Vd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Vd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(M.$0K.MainThreadTerminalService),this.y=new v.$Prb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:T=>{const O=G=>{const q=G;return this.W(q.instanceId)?.value};switch(T?.$mid){case 15:return O(T);default:{if(Array.isArray(T))for(let G=0;G<T.length&&T[G].$mid===15;G++)T[G]=O(T[G]);return T}}}}),this.B({dispose:()=>{for(const[T,O]of this.g)O.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,E){const D=new o(this.a,(0,$.$qg)(),b,b.name),T=new c(b.pty);return D.createExtensionTerminal(b.location,E,this.R(b,E).resolvedExtHostIdentifier,p(b.iconPath),d(b.color)).then(O=>{const G=this.S(O,T);this.h[O]=G}),this.f.push(D),D.value}R(b,E){if(E=E||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const D=b.location.parentTerminal;if(D){const T=this.f.find(O=>O.value===D);T&&(E.resolvedExtHostIdentifier=T._id)}}else b.location&&typeof b.location!="object"?E.location=b.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(b,E){if(!this.W(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const T=new c(E),O=this.S(b,T);this.h[b]=O}async $acceptActiveTerminalChanged(b){const E=this.b;if(b===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const D=this.W(b);D&&(this.b=D,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,E){const D=this.W(b);D&&this.O.fire({terminal:D.value,data:E})}async $acceptTerminalDimensions(b,E,D){const T=this.W(b);T&&T.setDimensions(E,D)&&this.L.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(b,E){const D=this.W(b);D&&this.P.fire({terminal:D.value,...E})}async $acceptTerminalMaximumDimensions(b,E,D){this.g.get(b)?.resize(E,D)}async $acceptTerminalTitleChange(b,E){const D=this.W(b);D&&(D.name=E)}async $acceptTerminalClosed(b,E,D){const T=this.Y(this.f,b);if(T!==null){const O=this.f.splice(T,1)[0];O.setExitStatus(E,D),this.H.fire(O.value)}}$acceptTerminalOpened(b,E,D,T){if(E){const q=this.Y(this.f,E);if(q!==null){this.f[q]._id=b,this.I.fire(this.terminals[q]),this.f[q].isOpen=!0;return}}const O={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:A.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},G=new o(this.a,b,O,D);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(b,E){this.W(b)?._setProcessId(E)}async $startExtensionTerminal(b,E){const D=this.W(b);if(!D)return{message:(0,w.localize)(0,null,b)};D.isOpen||await new Promise(O=>{const G=this.onDidOpenTerminal(async q=>{q===D.value&&(G.dispose(),O())})});const T=this.g.get(b);T?T.startSendingEvents(E):this.j[b]={initialDimensions:E}}S(b,E){const D=new m.$Sc;D.add(E.onProcessReady(O=>this.a.$sendProcessReady(b,O.pid,O.cwd,O.windowsPty))),D.add(E.onDidChangeProperty(O=>this.a.$sendProcessProperty(b,O))),this.y.startBuffering(b,E.onProcessData),D.add(E.onProcessExit(O=>this.U(b,O))),this.g.set(b,E);const T=this.j[b];return T&&E instanceof c&&(E.startSendingEvents(T.initialDimensions),delete this.j[b]),D}$acceptProcessAckDataEvent(b,E){this.g.get(b)?.acknowledgeDataEvent(E)}$acceptProcessInput(b,E){this.g.get(b)?.input(E)}$acceptTerminalInteraction(b){const E=this.W(b);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(b,E){this.W(b)?.setSelection(E)}$acceptProcessResize(b,E,D){try{this.g.get(b)?.resize(E,D)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(b,E){this.g.get(b)?.shutdown(E)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(E=>this.a.$sendProcessProperty(b,{type:"cwd",value:E}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new f.$_K(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,E,D){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,D),this.a.$registerProfileProvider(E,b.identifier.value),new f.$_K(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(b,E,D){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,D),this.a.$registerQuickFixProvider(b,E),new f.$_K(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,E){const D=new l.$6d().token;if(D.isCancellationRequested)return;const T=this.D.get(b);if(!T)return;const O=await T.provideTerminalQuickFixes(E,D);if(O===null||Array.isArray(O)&&O.length===0)return;const G=new m.$Sc;if(this.w.value=G,!Array.isArray(O))return O?r.TerminalQuickFix.from(O,this.Q.converter,G):void 0;const q=[];for(const U of O){const I=r.TerminalQuickFix.from(U,this.Q.converter,G);I&&q.push(I)}return q}async $createContributedProfileTerminal(b,E){const D=new l.$6d().token;let T=await this.C.get(b)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,E);return}this.createTerminalFromOptions(T.options,E)}}async $provideLinks(b,E){const D=this.W(b);if(!D)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const O=new l.$6d;this.G.set(b,O);const G=[],q={terminal:D.value,line:E},U=[];for(const W of this.z)U.push(a.Promises.withAsyncBody(async ae=>{O.token.onCancellationRequested(()=>ae({provider:W,links:[]}));const de=await W.provideTerminalLinks(q,O.token)||[];O.token.isCancellationRequested||ae({provider:W,links:de})}));const I=await Promise.all(U);if(O.token.isCancellationRequested)return[];const N=new Map;for(const W of I)W&&W.links.length>0&&G.push(...W.links.map(ae=>{const de={id:h++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return N.set(de.id,{provider:W.provider,link:ae}),de}));return this.F.set(b,N),G}$activateLink(b,E){const D=this.F.get(b)?.get(E);D&&D.provider.handleTerminalLink(D.link)}U(b,E){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const D=this.h[b];D&&(D.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,E)}W(b){return this.X(this.f,b)}X(b,E){const D=this.Y(b,E);return D!==null?b[D]:null}Y(b,E){const D=b.findIndex(T=>T._id===E);return D===-1?null:D}getEnvironmentVariableCollection(b){let E=this.n.get(b.identifier.value);return E||(E=new u,this.$(b.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Z(b,E){const D=(0,k.$Mr)(E.map),T=(0,k.$Nr)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(b,E.persistent,D.length===0?void 0:D,T)}$initEnvironmentVariableCollections(b){b.forEach(E=>{const D=E[0],T=new u(E[1]);this.$(D,T)})}$acceptDefaultProfile(b,E){const D=this.s;this.s=b,this.u=E,D?.path!==b.path&&this.N.fire(b.path)}$(b,E){this.n.set(b,E),E.onDidChangeCollection(()=>{this.Z(b,E)})}};e.$ahc=i,e.$ahc=i=Je([He(1,n.$xN),He(2,P.$bN)],i);class u{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Vd,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const E=this.h(b);let D=this.a.get(E);return D||(D=new t(this,b),this.a.set(E,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(b,E,D,T){this.f(b,{value:E,type:f.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:T})}append(b,E,D,T){this.f(b,{value:E,type:f.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:T})}prepend(b,E,D,T){this.f(b,{value:E,type:f.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:T})}f(b,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(b,E.scope),T=this.map.get(D),O=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==E.value||T.type!==E.type||T.options?.applyAtProcessCreation!==O.applyAtProcessCreation||T.options?.applyAtShellIntegration!==O.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const G=this.g(b,E.scope),q={variable:b,...E,options:O};this.map.set(G,q),this.d.fire()}}get(b,E){const D=this.g(b,E),T=this.map.get(D);return T?S(T):void 0}g(b,E){const D=this.h(E);return D.length?`${b}:::${D}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const E=new Map;for(const[D,T]of this.map)this.h(T.scope)===this.h(b)&&E.set(T.variable,S(T));return E}delete(b,E){const D=this.g(b,E);this.map.delete(D),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[E,D]of this.map)D.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(E);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,E){const D=this.h(E),T=this.descriptionMap.get(D);if(!T||T.description!==b){let O;typeof b=="string"?O=b:O=b?.value.split(`

`)[0];const G={description:O,scope:E};this.descriptionMap.set(D,G),this.d.fire()}}getDescription(b){const E=this.h(b);return this.descriptionMap.get(E)?.description}k(b){const E=this.h(b);this.descriptionMap.delete(E)}}class t{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,E){this.b=b,this.d=E,this.a=new y.$Vd}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,E,D){this.b.replace(b,E,D,this.d)}append(b,E,D){this.b.append(b,E,D,this.d)}prepend(b,E,D){this.b.prepend(b,E,D,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,E){this.b.getVariableMap(this.d).forEach((D,T)=>b.call(E,T,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let g=class extends i{constructor(b,E){super(!1,b,E)}createTerminal(b,E,D){throw new R.$_}createTerminalFromOptions(b,E){throw new R.$_}};e.$bhc=g,e.$bhc=g=Je([He(0,n.$xN),He(1,P.$bN)],g);function p(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function d(L){return s.ThemeColor.isThemeColor(L)?L:void 0}function S(L){const b={...L};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(Pe[272],Re([1,0,13,22,20,5,242,98,6,26,16,33,14,3,17,110,8,7,48,76,59,24]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n,o,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=e.$gic=e.$fic=e.$eic=void 0;let i=class extends f.$Tc{constructor(U,I,N,W){super(),this.w=W,this.f=this.B(new A.$Vd),this.g=new Map,this.s=this.B(new A.$Vd),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy($.$0K.MainThreadTesting),this.m=new D(this.h),this.j=new p(this.h,I),N.registerArgumentProcessor({processArgument:ae=>{switch(ae?.$mid){case 16:{const de=ae,we=de.tests[de.tests.length-1].item.extId;return this.g.get(n.$2J.root(we))?.collection.tree.get(we)?.actual??(0,s.$nN)(ae)}case 18:{const{extId:de,message:we}=ae;return{test:this.g.get(n.$2J.root(de))?.collection.tree.get(de)?.actual,message:a.TestMessage.to(we)}}default:return ae}}}),N.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ae=await N.executeCommand("_testing.getExplorerSelection"),de=we=>{const ke=this.g.get(n.$2J.root(we));if(ke)return n.$2J.isRoot(we)?ke.controller:ke.collection.tree.get(we)?.actual};return{include:ae?.include.map(de).filter(R.$Qf)||[],exclude:ae?.exclude.map(de).filter(R.$Qf)||[]}})}createTestController(U,I,N,W){if(this.g.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const ae=new f.$Sc,de=ae.add(new s.$qN(I,N,this.w));de.root.label=N;const we=new Map,ke=new Set,ue=this.h,pe={items:de.root.children,get label(){return N},set label(be){N=be,de.root.label=be,ue.$updateController(I,{label:N})},get refreshHandler(){return W},set refreshHandler(be){W=be,ue.$updateController(I,{canRefresh:!!be})},get id(){return I},createRunProfile:(be,se,Z,V,ne,Ae)=>{let Le=(0,m.$Ti)(be);for(;we.has(Le);)Le++;return new O(this.h,we,U,ke,this.s.event,I,Le,be,se,Z,V,ne,Ae)},createTestItem(be,se,Z){return new s.$oN(I,be,se,Z)},createTestRun:(be,se,Z=!0)=>this.j.createTestRun(U,I,de,be,se,Z),invalidateTestResults:be=>{if(be===void 0)this.h.$markTestRetired(void 0);else{const se=be instanceof Array?be:[be];this.h.$markTestRetired(se.map(Z=>n.$2J.fromExtHostTestItem(Z,I).toString()))}},set resolveHandler(be){de.resolveHandler=be},get resolveHandler(){return de.resolveHandler},dispose:()=>{ae.dispose()}};ue.$registerTestController(I,N,!!W),ae.add((0,f.$Rc)(()=>ue.$unregisterTestController(I)));const ie={controller:pe,collection:de,profiles:we,extension:U,activeProfiles:ke};return this.g.set(I,ie),ae.add((0,f.$Rc)(()=>this.g.delete(I))),ae.add(de.onDidGenerateDiff(be=>ue.$publishDiff(I,be.map(c.TestsDiffOp.serialize)))),pe}createTestObserver(){return this.m.checkout()}async runTests(U,I=C.CancellationToken.None){const N=d(U);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.g.get(N.controllerId);if(!W)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ae=>n.$2J.fromExtHostTestItem(ae,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:G[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:U.exclude?.map(ae=>ae.id)},I)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,I,N){return await this.j.getCoverageReport(U,I)?.provideFileCoverage(N)??[]}async $resolveFileCoverage(U,I,N,W){return await this.j.getCoverageReport(U,I)?.resolveFileCoverage(N,W)??[]}$configureRunProfile(U,I){this.g.get(U)?.profiles.get(I)?.configureHandler?.()}$setDefaultRunProfiles(U){const I=new Map;for(const[N,W]of Object.entries(U)){const ae=this.g.get(N);if(!ae)continue;const de=new Map,we=W.filter(ue=>!ae.activeProfiles.has(ue)),ke=[...ae.activeProfiles].filter(ue=>!W.includes(ue));for(const ue of we)de.set(ue,!0),ae.activeProfiles.add(ue);for(const ue of ke)de.set(ue,!1),ae.activeProfiles.delete(ue);de.size&&I.set(N,de)}this.s.fire(I)}async $refreshTests(U,I){await this.g.get(U)?.controller.refreshHandler?.(I)}$publishTestResults(U){this.results=Object.freeze(U.map(I=>(0,w.$wn)(a.TestResults.to(I))).concat(this.results).sort((I,N)=>N.completedAt-I.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,I){const N=this.g.get(n.$2J.fromString(U).controllerId)?.collection;N&&(await N.expand(U,I<0?1/0:I),N.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(I=>c.TestsDiffOp.deserialize({asCanonicalUri:N=>N},I)))}async $runControllerTests(U,I){return Promise.all(U.map(N=>this.y(N,!1,I)))}async $startContinuousRun(U,I){const N=new C.$6d(I),W=await Promise.all(U.map(ae=>this.y(ae,!0,N.token)));return!I.isCancellationRequested&&!W.some(ae=>ae.error)&&await new Promise(ae=>I.onCancellationRequested(ae)),N.dispose(!0),W}async y(U,I,N){const W=this.g.get(U.controllerId);if(!W)return{};const{collection:ae,profiles:de,extension:we}=W,ke=de.get(U.profileId);if(!ke)return{};const ue=U.testIds.map(se=>ae.tree.get(se)).filter(R.$Qf),pe=U.excludeExtIds.map(se=>W.collection.tree.get(se)).filter(R.$Qf).filter(se=>ue.some(Z=>Z.fullId.compare(se.fullId)===2));if(!ue.length)return{};const ie=new r.$IM(ue.some(se=>se.actual instanceof s.$pN)?void 0:ue.map(se=>se.actual),pe.map(se=>se.actual),ke,I),be=(0,c.$4J)(U)&&this.j.prepareForMainThreadTestRun(ie,S.fromInternal(U,W.collection),we,N);try{return await ke.runHandler(ie,N),{}}catch(se){return{error:String(se)}}finally{be&&(be.hasRunningTasks&&!N.isCancellationRequested&&await A.Event.toPromise(be.onEnd),be.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$eic=i,e.$eic=i=Je([He(0,v.$bN),He(1,l.$nj)],i);const u=1e4;var t;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(t||(t={}));class g extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,I,N,W,ae){super(),this.s=U,this.w=I,this.y=N,this.z=W,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Vd),this.m=this.B(new A.$Vd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new C.$6d(ae));const de=this.B(new y.$fh(()=>this.C(),u));this.B(this.h.token.onCancellationRequested(()=>de.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const I=this.s.id,N=this.s.controllerId,W=(0,k.$qg)(),ae=this.y,de=this.m;let we;const ke=be=>(se,...Z)=>{if(pe){this.z.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}this.s.isIncluded(se)&&(this.F(se),be(se,...Z))},ue=(be,se)=>{const Z=se instanceof Array?se.map(a.TestMessage.from):[a.TestMessage.from(se)];if(be.uri&&be.range){const V={range:a.Range.from(be.range),uri:be.uri};for(const ne of Z)ne.location=ne.location||V}this.w.$appendTestMessagesInRun(I,W,n.$2J.fromExtHostTestItem(be,N).toString(),Z)};let pe=!1;const ie={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return we?.provider},set coverageProvider(be){(0,h.$GF)(ae,"testCoverage"),we=be&&new L(be),de.fire({taskId:W,runId:I,coverage:we})},enqueued:ke(be=>{this.w.$updateTestStateInRun(I,W,n.$2J.fromExtHostTestItem(be,N).toString(),1)}),skipped:ke(be=>{this.w.$updateTestStateInRun(I,W,n.$2J.fromExtHostTestItem(be,N).toString(),5)}),started:ke(be=>{this.w.$updateTestStateInRun(I,W,n.$2J.fromExtHostTestItem(be,N).toString(),2)}),errored:ke((be,se,Z)=>{ue(be,se),this.w.$updateTestStateInRun(I,W,n.$2J.fromExtHostTestItem(be,N).toString(),6,Z)}),failed:ke((be,se,Z)=>{ue(be,se),this.w.$updateTestStateInRun(I,W,n.$2J.fromExtHostTestItem(be,N).toString(),4,Z)}),passed:ke((be,se)=>{this.w.$updateTestStateInRun(I,W,n.$2J.fromExtHostTestItem(be,this.s.controllerId).toString(),3,se)}),appendOutput:(be,se,Z)=>{pe||(Z&&(this.s.isIncluded(Z)?this.F(Z):Z=void 0),this.w.$appendOutputToRun(I,W,M.$je.fromString(be),se&&a.location.from(se),Z&&n.$2J.fromExtHostTestItem(Z,N).toString()))},end:()=>{pe||(pe=!0,this.w.$finishedTestRunTask(I,W),this.f.delete(W),this.f.size||this.D())}};return this.f.set(W,{run:ie}),this.w.$startedTestRunTask(I,{id:W,name:U,running:!0}),ie}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof s.$oN))throw new o.$6M(U.id);if(this.g.has(n.$2J.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const I=[],N=this.s.colllection.root;for(;;){const W=a.TestItem.from(U);if(I.unshift(W),this.g.has(W.extId)||(this.g.add(W.extId),U===N))break;U=U.parent||N}this.w.$addTestsToRun(this.s.controllerId,this.s.id,I)}dispose(){this.D(),super.dispose()}}class p{get trackers(){return this.c.values()}constructor(U,I){this.g=U,this.h=I,this.c=new Map,this.f=[]}getCoverageReport(U,I){return this.f.find(N=>N.runId===U)?.coverage.get(I)}prepareForMainThreadTestRun(U,I,N,W){return this.j(U,I,N,W)}cancelRunById(U){for(const I of this.c.values())if(I.id===U){I.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,I,N,W,ae,de){const we=this.c.get(W);if(we)return we.createRun(ae);const ke=S.fromPublic(I,N,W,de),ue=d(W);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!W.continuous,profile:ue&&{group:G[ue.kind],id:ue.profileId},exclude:W.exclude?.map(ie=>n.$2J.fromExtHostTestItem(ie,N.root.id).toString())??[],id:ke.id,include:W.include?.map(ie=>n.$2J.fromExtHostTestItem(ie,N.root.id).toString())??[N.root.id],persist:de});const pe=this.j(W,ke,U);return A.Event.once(pe.onEnd)(()=>{this.g.$finishedExtensionTestRun(ke.id),pe.dispose()}),pe.createRun(ae)}j(U,I,N,W){const ae=new g(I,this.g,N,this.h,W);this.c.set(U,ae);let de;const we=ae.onDidCoverage(({runId:ke,taskId:ue,coverage:pe})=>{de||(de={runId:ke,coverage:new Map},this.f.unshift(de),this.f.length>c.$9J&&this.f.pop()),de.coverage.set(ue,pe),this.g.$signalCoverageAvailable(ke,ue,!!pe)});return A.Event.once(ae.onEnd)(()=>{this.c.delete(U),we.dispose()}),ae}}e.$fic=p;const d=q=>{if(q.profile){if(!(q.profile instanceof O))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class S{static fromPublic(U,I,N,W){return new S(U,(0,k.$qg)(),N.include?.map(ae=>n.$2J.fromExtHostTestItem(ae,U).toString())??[U],N.exclude?.map(ae=>n.$2J.fromExtHostTestItem(ae,U).toString())??[],W,I)}static fromInternal(U,I){return new S(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,I)}constructor(U,I,N,W,ae,de){this.controllerId=U,this.id=I,this.isPersisted=ae,this.colllection=de,this.c=N.map(we=>we+"\0"),this.f=W.map(we=>we+"\0")}isIncluded(U){const I=n.$2J.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const N of this.f)if(I===N||I.startsWith(N))return!1;for(const N of this.c)if(I===N||I.startsWith(N))return!0;return!1}}e.$gic=S;class L{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(a.TestCoverage.fromFile)??[]}catch(I){throw this.c=void 0,I}}async resolveFileCoverage(U,I){const N=await this.c;let W=N?.[U];return!this.provider||!N||!W?[]:(W.detailedCoverage||(W=N[U]=await this.provider.resolveFileCoverage?.(W,I)??W),W.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,a.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const I=n.$2J.parentId(U.item.extId);if(I&&this.h.has(I.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:I,g:N}=this;return{get added(){return[...U].map(W=>W.revived)},get updated(){return[...I].map(W=>W.revived)},get removed(){return[...N].map(W=>W.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class E extends c.$0J{constructor(){super(...arguments),this.s=new A.$Vd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,I){return{...U,revived:a.TestItem.toPlain(U.item),depth:I?I.depth+1:0,children:new Set}}v(){return new b(this.s)}}class D{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(I=>I.revived)},dispose:(0,P.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new E({asCanonicalUri:I=>I});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const T=(q,U,I,N)=>{I?Object.assign(I,N):U.$updateTestRunConfig(q.controllerId,q.profileId,N)};class O{#e;#t;#i;#o;#n;#r;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,T(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,T(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#i.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#i.add(this.profileId):this.#i.delete(this.profileId),T(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,T(this,this.#e,this.#n,{tag:U?a.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,T(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return(0,h.$GF)(this.#t,"testingActiveProfile"),A.Event.chain(this.#o,U=>U.map(I=>I.get(this.controllerId)?.get(this.profileId)).filter(R.$Qf))}constructor(U,I,N,W,ae,de,we,ke,ue,pe,ie=!1,be=void 0,se=!1){this.controllerId=de,this.profileId=we,this.f=ke,this.kind=ue,this.runHandler=pe,this._tag=be,this.g=se,this.#e=U,this.#r=I,this.#t=N,this.#i=W,this.#o=ae,I.set(we,this);const Z=G[ue];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${ue}`);ie&&W.add(we),this.#n={profileId:we,controllerId:de,tag:be?a.TestTag.namespace(this.controllerId,be.id):null,label:ke,group:Z,isDefault:ie,hasConfigurationHandler:!1,supportsContinuousRun:se},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$hic=O;const G={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Pe[111],Re([1,0,54,15,89,8,7]),function(ge,e,y,M,C,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.$iN=void 0;class m{static{this.c=new C.$gN("TextEditorDecorationType")}constructor(l,$,v){const s=m.c.nextId();l.$registerTextEditorDecorationType($.identifier,s,A.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$iN=m;class f{constructor(l,$){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=$.undoStopBefore,this.f=$.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,$){this.k();let v=null;if(l instanceof P.$aL)v=new P.$bL(l,l);else if(l instanceof P.$bL)v=l;else throw new Error("Unrecognized location");this.l(v,$,!1)}insert(l,$){this.k(),this.l(new P.$bL(l,l),$,!0)}delete(l){this.k();let $=null;if(l instanceof P.$bL)$=l;else throw new Error("Unrecognized location");this.l($,null,!0)}l(l,$,v){const s=this.c.validateRange(l);this.g.push({range:s,text:$,forceMoveMarkers:v})}setEndOfLine(l){if(this.k(),l!==P.EndOfLine.LF&&l!==P.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=l}}class w{constructor(l,$,v,s){this.c=l,this.d=$,this._accept(v),this.e=s;const a=this;this.value={get tabSize(){return a.f},set tabSize(r){a.n(r)},get indentSize(){return a.g},set indentSize(r){a.p(r)},get insertSpaces(){return a.j},set insertSpaces(r){a.s(r)},get cursorStyle(){return a.k},set cursorStyle(r){a.t(r)},get lineNumbers(){return a.l},set lineNumbers(r){a.u(r)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}n(l){const $=this.m(l);if($!==null){if(typeof $=="number"){if(this.f===$)return;this.f=$}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:$}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}p(l){const $=this.o(l);if($!==null){if(typeof $=="number"){if(this.h===$)return;this.g=$,this.h=$}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:$}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const $=this.q(l);if(typeof $=="boolean"){if(this.j===$)return;this.j=$}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:$}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(l)})))}assign(l){const $={};let v=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(v=!0,$.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,v=!0,$.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(v=!0,$.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,v=!0,$.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(v=!0,$.insertSpaces=s):this.j!==s&&(this.j=s,v=!0,$.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,v=!0,$.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,v=!0,$.lineNumbers=A.TextEditorLineNumbersStyle.from(l.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,$))}v(l,$){$.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(v)})}}e.$jN=w;class R{constructor(l,$,v,s,a,r,n,o){this.id=l,this.j=$,this.k=v,this.g=!1,this.h=new Set,this.c=a,this.d=new w(this.j,this.id,r,v),this.e=n,this.f=o;const c=this;this.value=Object.freeze({get document(){return s.value},set document(h){throw new M.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof P.$cL))throw(0,M.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof P.$cL)))throw(0,M.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new M.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new M.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new f(s.value,i);return h(u),c.m(u)},insertSnippet(h,i,u={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let t;if(!i||Array.isArray(i)&&i.length===0)t=c.c.map(g=>A.Range.from(g));else if(i instanceof P.$aL){const{lineNumber:g,column:p}=A.Position.from(i);t=[{startLineNumber:g,startColumn:p,endLineNumber:g,endColumn:p}]}else if(i instanceof P.$bL)t=[A.Range.from(i)];else{t=[];for(const g of i)if(g instanceof P.$bL)t.push(A.Range.from(g));else{const{lineNumber:p,column:d}=A.Position.from(g);t.push({startLineNumber:p,startColumn:d,endLineNumber:p,endColumn:d})}}return $.$tryInsertSnippet(l,s.value.version,h.value,t,u)},setDecorations(h,i){const u=i.length===0;u&&!c.h.has(h.key)||(u?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(A.$$M(i))return $.$trySetDecorations(l,h.key,A.$_M(i));{const t=new Array(4*i.length);for(let g=0,p=i.length;g<p;g++){const d=i[g];t[4*g]=d.start.line+1,t[4*g+1]=d.start.character+1,t[4*g+2]=d.end.line+1,t[4*g+3]=d.end.character+1}return $.$trySetDecorationsFast(l,h.key,t)}}))},revealRange(h,i){c.n(()=>$.$tryRevealRange(l,A.Range.from(h),i||P.TextEditorRevealType.Default))},show(h){$.$tryShowEditor(l,A.ViewColumn.from(h))},hide(){$.$tryHideEditor(l)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,y.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,y.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,y.ok)(!this.g),this.f=l}_acceptSelections(l){(0,y.ok)(!this.g),this.c=l}async l(){const l=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const $=l.finalize();if($.edits.length===0&&!$.setEndOfLine)return Promise.resolve(!0);const v=$.edits.map(a=>a.range);v.sort((a,r)=>a.end.line===r.end.line?a.end.character===r.end.character?a.start.line===r.start.line?a.start.character-r.start.character:a.start.line-r.start.line:a.end.character-r.end.character:a.end.line-r.end.line);for(let a=0,r=v.length-1;a<r;a++){const n=v[a].end;if(v[a+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=$.edits.map(a=>({range:A.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,$.documentVersionId,s,{setEndOfLine:typeof $.setEndOfLine=="number"?A.EndOfLine.from($.setEndOfLine):void 0,undoStopBefore:$.undoStopBefore,undoStopAfter:$.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,$=>($ instanceof Error&&$.name==="DISPOSED"||this.k.warn($),null))}}e.$kN=R}),define(Pe[66],Re([1,0,54,5,6,2,4,3,108,17,111,8,14,28,11,68,39]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=void 0;class r{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new $.$Ac,this.d=new M.$Vd,this.e=new M.$Vd,this.f=new M.$Vd,this.g=new M.$Vd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],u=[];if(c.removedDocuments)for(const t of c.removedDocuments){const g=A.URI.revive(t),p=this.c.get(g);p?.unref()&&(this.c.delete(g),h.push(p.value))}if(c.addedDocuments)for(const t of c.addedDocuments){const g=A.URI.revive(t.uri);let p=this.c.get(g);if(p&&g.scheme!==v.Schemas.vscodeNotebookCell&&g.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${g} already exists!'`);p||(p=new r(new f.$eN(this.h.getProxy(m.$0K.MainThreadDocuments),g,t.lines,t.EOL,t.versionId,t.languageId,t.isDirty,t.notebook)),this.c.set(g,p),i.push(p.value)),p.ref()}if(c.removedEditors)for(const t of c.removedEditors){const g=this.b.get(t);this.b.delete(t),g&&u.push(g)}if(c.addedEditors)for(const t of c.addedEditors){const g=A.URI.revive(t.documentUri);y.ok(this.c.has(g),`document '${g}' does not exist`),y.ok(!this.b.has(t.id),`editor '${t.id}' already exists!`);const p=this.c.get(g).value,d=new R.$kN(t.id,this.h.getProxy(m.$0K.MainThreadTextEditors),this.i,new a.$V(()=>p.document),t.selections.map(k.Selection.to),t.options,t.visibleRanges.map(S=>k.Range.to(S)),typeof t.editorPosition=="number"?k.ViewColumn.to(t.editorPosition):void 0);this.b.set(t.id,d)}c.newActiveEditor!==void 0&&(y.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,C.$Oc)(h),(0,C.$Oc)(u),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(t=>t.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$lN=n,e.$lN=n=Je([He(0,w.$bN),He(1,l.$nj)],n),e.$mN=(0,P.$6h)("IExtHostDocumentsAndEditors")}),define(Pe[273],Re([1,0,18,5,3,111,8,7]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class f{constructor(R,k){this.i=k,this.a=new M.$Vd,this.b=new M.$Vd,this.c=new M.$Vd,this.d=new M.$Vd,this.f=new M.$Vd,this.g=new M.$Vd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(C.$0K.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const k=this.i.allEditors();return R?k:k.map(l=>l.value)}async showTextDocument(R,k,l){let $;typeof k=="number"?$={position:P.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?$={position:P.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?P.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:$={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(R.uri,$),s=v&&this.i.getEditor(v);if(s)return s.value;throw v?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,k){return new A.$iN(this.h,R,k).value}$acceptEditorPropertiesChanged(R,k){const l=this.i.getEditor(R);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const $=k.selections.selections.map(P.Selection.to);l._acceptSelections($)}if(k.visibleRanges){const $=y.$Hb(k.visibleRanges.map(P.Range.to));l._acceptVisibleRanges($)}if(k.options&&this.b.fire({textEditor:l.value,options:{...k.options,lineNumbers:P.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const $=m.TextEditorSelectionChangeKind.fromValue(k.selections.source),v=k.selections.selections.map(P.Selection.to);this.a.fire({textEditor:l.value,selections:v,kind:$})}if(k.visibleRanges){const $=y.$Hb(k.visibleRanges.map(P.Range.to));this.c.fire({textEditor:l.value,visibleRanges:$})}}$acceptEditorPositionData(R){for(const k in R){const l=this.i.getEditor(k);if(!l)throw new Error("Unknown text editor");const $=P.ViewColumn.to(R[k]);l.value.viewColumn!==$&&(l._acceptViewColumn($),this.d.fire({textEditor:l.value,viewColumn:$}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$Dgc=f}),define(Pe[274],Re([1,0,2,4,3,6,7,8,23,16]),function(ge,e,y,M,C,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=e.$jic=void 0,e.$jic=(0,M.$6h)("IExtHostTimeline");class R{constructor($,v){this.b=new Map,this.c=new Map,this.a=$.getProxy(C.$0K.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(s,a)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&f.$lm.equals(a,this.b.get(s.source)?.extension)){const r=s.uri===void 0?void 0:y.URI.revive(s.uri);return this.c.get(s.source)?.get(k(r))?.get(s.handle)}else return;return s}})}async $getTimeline($,v,s,a){return this.b.get($)?.provider.provideTimeline(y.URI.revive(v),s,a)}registerTimelineProvider($,v,s,a){const r=new A.$Sc,n=this.d(v.id,a,r).bind(this);let o;v.onDidChange&&(o=v.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:v.id}),this));const c=this.c;return this.f({...v,scheme:$,onDidChange:void 0,async provideTimeline(h,i,u){i?.resetCache&&(r.clear(),c.get(v.id)?.clear());const t=await v.provideTimeline(h,i,u);if(t==null)return;const g=n(h,i);return{...t,source:v.id,items:t.items.map(g)}},dispose(){for(const h of c.values())h.get(v.id)?.clear();o?.dispose(),r.dispose()}},s)}d($,v,s){return(a,r)=>{let n;if(r?.cacheResults){let o=this.c.get($);o===void 0&&(o=new Map,this.c.set($,o));const c=k(a);n=o.get(c),n===void 0&&(n=new Map,o.set(c,n))}return o=>{const{iconPath:c,...h}=o,i=`${$}|${o.id??o.timestamp}`;n?.set(i,o);let u,t,g;o.iconPath&&(c instanceof P.$7L?g={id:c.id,color:c.color}:y.URI.isUri(c)?(u=c,t=c):{light:u,dark:t}=c);let p;return P.$AL.isMarkdownString(h.tooltip)?p=m.MarkdownString.from(h.tooltip):(0,w.$If)(h.tooltip)?p=h.tooltip:P.$AL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=m.MarkdownString.from(h.detail)):(0,w.$If)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=h.detail),{...h,id:h.id??void 0,handle:i,source:$,command:o.command?v.toInternal(o.command,s):void 0,icon:u,iconDark:t,themeIcon:g,tooltip:p,accessibilityInformation:o.accessibilityInformation}}}}f($,v){if(this.b.get($.id))throw new Error(`Timeline Provider ${$.id} already exists.`);return this.a.$registerTimelineProvider({id:$.id,label:$.label,scheme:$.scheme}),this.b.set($.id,{provider:$,extension:v}),(0,A.$Rc)(()=>{for(const a of this.c.values())a.get($.id)?.clear();this.b.delete($.id),this.a.$unregisterTimelineProvider($.id),$.dispose()})}}e.$kic=R;function k(l){return l?.toString()}}),define(Pe[275],Re([1,0,166,25,2,5,6,204,13,7,16,18,8,52,20,132,24]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;function r(c,h){if((0,R.$If)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends P.$Tc{constructor(h,i,u){super(),this.f=h,this.g=i,this.h=u,this.a=new Map,this.b=new s.$n8;function t(g){return g&&g.$treeViewId&&(g.$treeItemHandle||g.$selectedTreeItems||g.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:g=>t(g)?this.r(g):Array.isArray(g)&&g.length>0?g.map(p=>t(p)?this.r(p):p):g})}registerTreeDataProvider(h,i,u){const t=this.createTreeView(h,{treeDataProvider:i},u);return{dispose:()=>t.dispose()}}createTreeView(h,i,u){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=i.dragAndDropController?.dropMimeTypes??[],g=i.dragAndDropController?.dragMimeTypes??[],p=!!i.dragAndDropController?.handleDrag,d=!!i.dragAndDropController?.handleDrop,S=this.m(h,i,u),L={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:t,dragMimeTypes:g,hasHandleDrag:p,hasHandleDrop:d,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(h,L),E={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,a.$GF)(u,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,a.$GF)(u,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(D){(0,$.$jk)(D)&&(0,a.$GF)(u,"treeViewMarkdownMessage"),S.message=D},get title(){return S.title},set title(D){S.title=D},get description(){return S.description},set description(D){S.description=D},get badge(){return S.badge},set badge(D){D!==void 0&&w.ViewBadge.isViewBadge(D)?S.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(S.badge=void 0)},reveal:(D,T)=>S.reveal(D,T),dispose:async()=>{await b,this.a.delete(h),S.dispose()}};return this.B(E),E}$getChildren(h,i){const u=this.a.get(h);return u?u.getChildren(i):Promise.reject(new m.$aF(h))}async $handleDrop(h,i,u,t,g,p,d,S){const L=this.a.get(h);if(!L)return Promise.reject(new m.$aF(h));const b=l.DataTransfer.toDataTransfer(u,async E=>(await this.f.$resolveDropFileData(h,i,E)).buffer);return d===h&&S&&await this.j(b,L,S,g,p),L.onDrop(b,t,g)}async j(h,i,u,t,g){const p=this.b.removeDragOperationTransfer(g);if(p)(await p)?.forEach((d,S)=>{d&&h.set(S,d)});else if(g&&i.handleDrag){const d=i.handleDrag(u,h,t);this.b.addDragOperationTransfer(g,d),await d}return h}async $handleDrag(h,i,u,t){const g=this.a.get(h);if(!g)return Promise.reject(new m.$aF(h));const p=await this.j(new w.$4L,g,i,t,u);if(!(!p||t.isCancellationRequested))return l.DataTransfer.from(p)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new m.$aF(h);return i.hasResolve}$resolve(h,i,u){const t=this.a.get(h);if(!t)throw new m.$aF(h);return t.resolveTreeItem(i,u)}$setExpanded(h,i,u){const t=this.a.get(h);if(!t)throw new m.$aF(h);t.setExpanded(i,u)}$setSelectionAndFocus(h,i,u){const t=this.a.get(h);if(!t)throw new m.$aF(h);t.setSelectionAndFocus(i,u)}$setVisible(h,i){const u=this.a.get(h);if(!u){if(!i)return;throw new m.$aF(h)}u.setVisible(i)}$changeCheckboxState(h,i){const u=this.a.get(h);if(!u)throw new m.$aF(h);u.setCheckboxState(i)}m(h,i,u){const t=this.B(new o(h,i,this.f,this.g.converter,this.h,u));return this.a.set(h,t),t}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$lic=n;class o extends P.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.$Rf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,u,t,g,p){if(super(),this.I=h,this.J=u,this.L=t,this.M=g,this.N=p,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$Vd),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$Vd),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$Vd),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$Vd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$Vd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$Vd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$Vd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$6d,p.contributes&&p.contributes.views)for(const b in p.contributes.views)for(const E of p.contributes.views[b])E.id===h&&(this.P=E.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let d,S;const L=A.Event.debounce(this.F.event,(b,E)=>(b||(b={message:!1,elements:[]}),E.element!==!1&&(d||(d=new Promise(D=>S=D),this.G=this.G.then(()=>d)),Array.isArray(E.element)?b.elements.push(...E.element):b.elements.push(E.element)),E.message&&(b.message=!0),b),200,!0);this.B(L(({message:b,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const D=S;return d=null,this.$(E).then(()=>D())})),b&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let u=this.X(h);return u||(u=await this.Y(i)),u?u.map(t=>t.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const u=(0,R.$Rf)(i.select)?!0:i.select,t=(0,R.$Rf)(i.focus)?!1:i.focus,g=(0,R.$Rf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(p=>this.W(h,p[p.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:p.map(S=>S.item)},{select:u,focus:t,expand:g})),p=>this.M.error(p)):this.J.$reveal(this.I,void 0,{select:u,focus:t,expand:g})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const u=this.getExtensionElement(h);u&&(i?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(h,i){const u=!(0,k.$ub)(this.s,h);this.s=h;const t=this.t!==i;this.t=i,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),t&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async u=>{const t=this.getExtensionElement(u.treeItemHandle);return t?{extensionItem:t,treeItem:await this.f.getTreeItem(t),newState:u.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);i.forEach(u=>{u.treeItem.checkboxState=u.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(u=>[u.extensionItem,u.newState])})}async handleDrag(h,i,u){const t=[];for(const g of h){const p=this.getExtensionElement(g);p&&t.push(p)}if(!(!this.g?.handleDrag||t.length===0))return await this.g.handleDrag(t,i,u),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,u){const t=i?this.getExtensionElement(i):void 0;if(!(!t&&i||!this.g?.handleDrop))return(0,f.$Yg)(()=>this.g?.handleDrop?this.g.handleDrop(t,h,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const u=this.j.get(h);if(u){const t=this.m.get(u);if(t){const g=await this.f.resolveTreeItem(t.extensionItem,u,i)??t.extensionItem;return this.hb(g),t.item.tooltip=this.eb(g.tooltip),t.item.command=this.fb(t.disposableStore,g.command),t.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(u=>this.W(i,u[u.length-1]).then(t=>(u.push(t),u))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,f.$Yg)(()=>this.f.getParent(h))}W(h,i){const u=this.m.get(h);return u?Promise.resolve(u):(0,f.$Yg)(()=>this.f.getTreeItem(h)).then(t=>this.kb(h,t,i,!0)).then(t=>this.getChildren(i?i.item.handle:void 0).then(()=>{const g=this.getExtensionElement(t);if(g){const p=this.m.get(g);if(p)return Promise.resolve(p)}throw new Error(`Cannot resolve tree item for element ${t} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const u=this.getExtensionElement(h);i=u?this.m.get(u):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new v.$6d(this.Z.token);try{const u=h?this.m.get(h):void 0,t=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const g=(0,k.$Hb)(t||[]),p=await Promise.all((0,k.$Hb)(g).map(S=>this.f.getTreeItem(S)));if(i.token.isCancellationRequested)return;const d=p.map((S,L)=>S?this.db(g[L],S,u):null);return(0,k.$Hb)(d)}finally{i.dispose()}}$(h){if(h.some(u=>!u))return this.Z.dispose(!0),this.Z=new v.$6d,this.tb(),this.J.$refresh(this.I);{const u=this.ab(h);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(h){const i=new Set,u=h.map(g=>this.m.get(g));for(const g of u)if(g&&!i.has(g.item.handle)){let p=g;for(;p&&p.parent&&u.findIndex(d=>p&&p.parent&&d&&d.item.handle===p.parent.item.handle)===-1;){const d=this.j.get(p.parent.item.handle);p=d?this.m.get(d):void 0}p&&!p.parent&&i.add(g.item.handle)}const t=[];return i.forEach(g=>{const p=this.j.get(g);if(p){const d=this.m.get(p);d&&(!d.parent||!i.has(d.parent.item.handle))&&t.push(g)}}),t}bb(h){const i={};return Promise.all(h.map(u=>this.cb(u).then(t=>{t&&(i[u]=t.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const u=this.m.get(i);if(u)return this.rb(i),(0,f.$Yg)(()=>this.f.getTreeItem(i)).then(t=>{if(t){const g=this.ib(i,t,u.parent);return this.pb(i,g,u,u.parent),u.dispose(),g}return null})}return Promise.resolve(null)}db(h,i,u){const t=this.ib(h,i,u);if(i.id&&this.j.has(t.item.handle))throw new Error((0,y.localize)(0,null,i.id));return this.ob(h,t),this.qb(t,u),t}eb(h){return w.$AL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,u,t;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,u=h.checkboxState.tooltip,t=h.checkboxState.accessibilityInformation),{isChecked:i===w.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:t}}hb(h){if(!w.$YL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,u){this.hb(i);const t=this.B(new P.$Sc),g=this.kb(h,i,u),p=this.lb(i);return{item:{handle:g,parentHandle:u?u.item.handle:void 0,label:r(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(t,i.command),contextValue:i.contextValue,icon:p,iconDark:this.mb(i)||p,themeIcon:this.jb(i),collapsibleState:(0,R.$Rf)(i.collapsibleState)?w.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:u,children:void 0,disposableStore:t,dispose(){t.dispose()}}}jb(h){return h.iconPath instanceof w.$7L?h.iconPath:void 0}kb(h,{id:i,label:u,resourceUri:t},g,p){if(i)return`${o.b}/${i}`;const d=r(u,this.N),S=g?g.item.handle:o.a;let L=d?d.label:t?(0,M.$Eg)(t):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const b=this.m.has(h)?this.m.get(h).item.handle:void 0,E=this.X(g)||[];let D,T=0;do{if(D=`${S}/${T}:${L}`,p||!this.j.has(D)||b===D)break;T++}while(T<=E.length);return D}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$7L))return typeof h.iconPath=="string"||C.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$7L)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return C.URI.isUri(h)?h:C.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,u,t){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(h,i);const g=this.X(t)||[],p=g.filter(d=>d.item.handle===u.item.handle)[0];p&&g.splice(g.indexOf(p),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const u of i.children){const t=this.j.get(u.item.handle);t&&this.sb(t)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const u of i.children){const t=this.j.get(u.item.handle);t&&this.sb(t)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[276],Re([1,0,5,6,2,33,8,61,3,7]),function(ge,e,y,M,C,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class R extends M.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;#h;constructor(v,s,a,r){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new y.$Vd),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$Vd),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=s,this.#o=a,this.#i=r.viewType,this.#n=r.panelOptions,this.#s=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,C.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#n}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#s=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:P.ViewColumn.from(v),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends M.$Tc{static c(){return(0,A.$qg)()}constructor(v,s,a){super(),this.j=s,this.m=a,this.g=new Map,this.h=new Map,this.f=v.getProxy(f.$0K.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,s,a,r,n={}){const o=typeof r=="object"?r.viewColumn:r,c={viewColumn:P.ViewColumn.from(o),preserveFocus:typeof r=="object"&&!!r.preserveFocus},h=(0,m.$Sgc)(v),i=k.c();this.f.$createWebviewPanel((0,m.$Ugc)(v),i,s,{title:a,panelOptions:l(n),webviewOptions:(0,m.$Vgc)(v,this.m,n),serializeBuffersForPostMessage:h},c);const u=this.j.createNewWebview(i,n,v);return this.createNewWebviewPanel(i,s,a,o,n,u,!0)}$onDidChangeWebviewPanelViewStates(v){const s=Object.keys(v);s.sort((a,r)=>{const n=v[a],o=v[r];return n.active?1:o.active?-1:+n.visible-+o.visible});for(const a of s){const r=this.getWebviewPanel(a);if(!r)continue;const n=v[a];r._updateViewState({active:n.active,visible:n.visible,viewColumn:P.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,s,a){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:a,extension:v}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,m.$Sgc)(v)}),new w.$_K(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(v,s,a,r){const n=this.h.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:o,extension:c}=n,h=this.j.createNewWebview(v,a.webviewOptions,c),i=this.createNewWebviewPanel(v,s,a.title,r,a.panelOptions,h,a.active);await o.deserializeWebviewPanel(i,a.state)}createNewWebviewPanel(v,s,a,r,n,o,c){const h=new R(v,this.f,o,{viewType:s,title:a,viewColumn:r,panelOptions:n,active:c});return this.g.set(v,h),h}getWebviewPanel(v){return this.g.get(v)}}e.$Wgc=k;function l($){return{enableFindWidget:$.enableFindWidget,retainContextWhenHidden:$.retainContextWhenHidden}}}),define(Pe[277],Re([1,0,5,6,61,8,3,7]),function(ge,e,y,M,C,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;class f extends M.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;constructor(k,l,$,v,s,a){super(),this.#n=!1,this.#u=this.B(new y.$Vd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new y.$Vd),this.onDidDispose=this.#l.event,this.#i=$,this.#a=v,this.#e=k,this.#t=l,this.#o=s,this.#r=a}dispose(){this.#n||(this.#n=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#s}set description(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#n||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#n)throw new Error("Webview is disposed")}}class w{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(P.$0K.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,$,v){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:$,extension:k}),this.a.$registerWebviewViewProvider((0,C.$Ugc)(k),l,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Sgc)(k)}),new m.$_K(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,$,v,s){const a=this.b.get(l);if(!a)throw new Error(`No view provider found for '${l}'`);const{provider:r,extension:n}=a,o=this.d.createNewWebview(k,{},n),c=new f(k,this.a,l,$,o,!0);this.c.set(k,c),await r.resolveWebviewView(c,{state:v},s)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$oic=w}),define(Pe[278],Re([1,0,5,30,35,4]),function(ge,e,y,M,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$sK=e.OutputChannelUpdateMode=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=void 0,e.$iK="text/x-code-output",e.$jK="output",e.$kK="Log",e.$lK="text/x-code-log-output",e.$mK="log",e.$nK="workbench.panel.output",e.$oK=new C.$kj("inOutput",!1),e.$pK=new C.$kj("activeLogOutput",!1),e.$qK=new C.$kj("outputView.scrollLock",!1),e.$rK=(0,A.$6h)("outputService");var P;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(P||(e.OutputChannelUpdateMode=P={})),e.$sK={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new y.$Vd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Vd,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(R=>w.push(R)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}M.$Hn.add(e.$sK.OutputChannels,new m),e.$tK=new C.$kj("activeOutputChannel","")}),define(Pe[112],Re([1,0,3,4,17,23,14,278,62,27,42,136,22,16,41,5,6]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=void 0;class r extends P.$tj{get disposed(){return this.n}constructor(h,i,u,t,g){super(),this.id=h,this.name=i,this.r=u,this.s=t,this.extension=g,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(p=>this.setLevel(p)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$je.fromString(i).byteLength,(0,P.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends r{appendLine(h){this.append(h)}}let o=class{constructor(h,i,u,t,g,p){this.i=i,this.j=u,this.k=t,this.l=g,this.m=p,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(y.$0K.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,k.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,u]of this.g)u.visible=i===this.h}createOutputChannel(h,i,u){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const t=typeof i=="object"&&i.log,g=(0,$.$If)(i)?i:void 0;if((0,$.$If)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");let p;const d=this.i.environment.extensionLogLevel?.find(([L])=>A.$lm.equals(u.identifier,L))?.[1];d&&(p=(0,P.$Dj)(d));const S=t?this.o(h,p,u):this.n(h,g,u);return S.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),t?this.r(h,p??this.m.getLevel(),S):this.q(h,S)}async n(h,i,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const t=await this.c,g=this.k.extUri.joinPath(t,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.l.createLogger(g,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(h,g,i,u.identifier.value);return new r(d,h,p,this.a,u)}async o(h,i,u){const t=await this.p(u),g=h.replace(/[\\/:\*\?"<>\|]/g,""),p=this.k.extUri.joinPath(t,`${g}.log`),d=`${u.identifier.value}.${g}`,S=this.l.createLogger(p,{id:d,name:h,logLevel:i,extensionId:u.identifier.value});return new n(d,h,S,this.a,u)}p(h){let i=this.d.get(h.identifier.value);if(!i){const u=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(u)}catch(t){if((0,v.$Gk)(t)!==v.FileSystemProviderErrorCode.FileExists)throw t}return u})())}return i}q(h,i){let u=!1;const t=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return h},append(g){t(),i.then(p=>p.append(g))},appendLine(g){t(),i.then(p=>p.appendLine(g))},clear(){t(),i.then(g=>g.clear())},replace(g){t(),i.then(p=>p.replace(g))},show(g,p){t(),i.then(d=>d.show(g,p))},hide(){t(),i.then(g=>g.hide())},dispose(){u=!0,i.then(g=>g.dispose())}}}r(h,i,u){const t=new a.$Sc,g=()=>{if(t.isDisposed)throw new Error("Channel has been closed")},p=t.add(new s.$Vd);function d(S){i=S,p.fire(S)}return u.then(S=>{t.add(S),S.logLevel!==i&&d(S.logLevel),t.add(S.onDidChangeLogLevel(L=>d(L)))}),{...this.q(h,u),get logLevel(){return i},onDidChangeLogLevel:p.event,trace(S,...L){g(),u.then(b=>b.trace(S,...L))},debug(S,...L){g(),u.then(b=>b.debug(S,...L))},info(S,...L){g(),u.then(b=>b.info(S,...L))},warn(S,...L){g(),u.then(b=>b.warn(S,...L))},error(S,...L){g(),u.then(b=>b.error(S,...L))},dispose(){t.dispose()}}}};e.$2hc=o,e.$2hc=o=Je([He(0,C.$bN),He(1,w.$rN),He(2,f.$Ogc),He(3,R.$ogc),He(4,P.$oj),He(5,P.$nj)],o),e.$3hc=(0,M.$6h)("IExtHostOutputService")}),define(Pe[113],Re([1,0,4,13]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=void 0,e.$Lm=(0,y.$6h)("remoteAgentService"),e.$Mm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let A=1/0;for(let m=0;m<this.maxSampleCount;m++){const f=await C.getRoundTripTime();if(f===void 0)return;A=Math.min(A,f/2),await(0,M.$7g)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let P;return this.initial.length<this.maxInitialCount?this.initial.push(A):P=this.initial.reduce((m,f)=>m+f,0)/this.initial.length,this.lastMeasurement={initial:P,current:A,average:this.average.reduce((m,f)=>m+f,0)/this.average.length,high:(()=>typeof P>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>P*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[279],Re([1,0,169,55,30,47,46,6,5,113,21,26]),function(ge,e,y,M,C,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=void 0,e.$RH=Object.freeze({id:"application",order:100,title:(0,y.localize)(0,null),type:"object"}),e.$SH=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(1,null),type:"object"}),e.$TH=Object.freeze({id:"security",scope:1,title:(0,y.localize)(2,null),type:"object",order:7}),e.$UH=Object.freeze({id:"problems",title:(0,y.localize)(3,null),type:"object",order:101}),e.$VH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new f.$Vd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const $=new l;C.$Hn.add(e.$VH.ConfigurationMigration,$);let v=class extends m.$Tc{constructor(r,n){super(),this.a=r,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.f(c,$.migrations)})),this.c($.migrations),this.B($.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(r){await this.f(void 0,r);for(const n of this.b.getWorkspace().folders)await this.f(n,r)}async f(r,n){await Promise.all([n.map(o=>this.g(o,r?.uri))])}async g(r,n){const o=this.a.inspect(r.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[h,i]of c){const u=[];for(const g of o.overrideIdentifiers??[]){const p=await this.h(r,{resource:n,overrideIdentifier:g},h);for(const d of p??[]){let S=u.find(([[L,b]])=>L===d[0]&&(0,k.$zn)(b.value,d[1].value));S||u.push(S=[d,[]]),S[1].push(g)}}const t=await this.h(r,{resource:n},h,o);for(const g of t??[])u.push([g,[]]);u.length&&await Promise.allSettled(u.map(async([[g,p],d])=>this.a.updateValue(g,p.value,{resource:n,overrideIdentifiers:d},i)))}}async h(r,n,o,c){const h=g=>i(this.a.inspect(g,n)),i=g=>{const p=g[o];return n.overrideIdentifier?p?.override:p?.value},u=c?i(c):h(r.key);if(u===void 0)return;const t=await r.migrateFn(u,h);return Array.isArray(t)?t:[[r.key,t]]}};e.$WH=v,e.$WH=v=Je([He(0,P.$zi),He(1,A.$ci)],v);let s=class extends m.$Tc{constructor(r){super(),(async()=>{if(!R.$i&&(await r.getEnvironment())?.os!==1)return;C.$Hn.as(M.$Mn.Configuration).registerConfiguration({...e.$TH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(4,null)},default:[],markdownDescription:(0,y.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(6,null),scope:2}}})})()}};e.$XH=s,e.$XH=s=Je([He(0,w.$Lm)],s)}),define(Pe[280],Re([1,0,34,11,19,25,177,279,55,4,30]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdb=e.$idb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$hdb=e.$gdb=void 0,e.$gdb=(0,w.$6h)("editorResolverService"),e.$hdb="workbench.editorAssociations";const k=R.$Hn.as(f.$Mn.Configuration),l={...m.$SH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,P.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var $;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})($||(e.RegisteredEditorPriority=$={}));var v;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function s(r){switch(r){case $.exclusive:return 5;case $.default:return 4;case $.builtin:return 3;case $.option:default:return 1}}e.$idb=s;function a(r,n){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof r=="string"&&r.indexOf(C.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,A.$Eg)(n);return y.$Lj(typeof r=="string"?r.toLowerCase():r,h.toLowerCase())}e.$jdb=a}),define(Pe[281],Re([1,0,45,11,19,21,25,2,4,198,47,215,113]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.$LK=void 0,e.$LK=(0,f.$6h)("pathService");let v=$=class{constructor(a,r,n,o){this.d=a,this.e=r,this.f=n,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??a})()}hasValidBasename(a,r,n){return typeof r=="string"||typeof r>"u"?this.a.then(o=>this.h(a,o,r)):this.h(a,r,n)}h(a,r,n){return a.scheme===M.Schemas.file||a.scheme===M.Schemas.vscodeRemote?(0,y.$6f)(n??(0,P.$Eg)(a),r===1):!0}get defaultUriScheme(){return $.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,r){if(a.remoteAuthority)return M.Schemas.vscodeRemote;const n=(0,w.$IK)(r.getWorkspace());if(n)return n;const o=r.getWorkspace().folders[0];if(o)return o.uri.scheme;const c=r.getWorkspace().configuration;return c?c.scheme:M.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?C.$fc:C.$gc)}async fileURI(a){let r="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const o=a.indexOf("/",2);o===-1?(r=a.substring(2),a="/"):(r=a.substring(2,o),a=a.substring(o)||"/")}return m.URI.from({scheme:M.Schemas.file,authority:r,path:a,query:"",fragment:""})}};e.$MK=v,e.$MK=v=$=Je([He(1,l.$Lm),He(2,k.$uK),He(3,R.$ci)],v)}),define(Pe[114],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$oJ=e.$nJ=void 0;class y{constructor(P,m){this.line=P,this.character=m}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,m){return new y(0,0)}with(P){return new y(0,0)}}e.$nJ=y;class M{constructor(P,m,f,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(P,m),this.end=new y(f,w)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new M(0,0,0,0)}with(P){return new M(0,0,0,0)}}e.$oJ=M;var C;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Pe[43],Re([1,0,18,34,26,45,12,4,19,15,114,13]),function(ge,e,y,M,C,A,P,m,f,w,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.SearchErrorCode=e.$DJ=e.$CJ=e.SearchSortOrder=e.ViewMode=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.SearchCompletionExitCode=e.$xJ=e.$wJ=e.$vJ=e.QueryType=e.SearchProviderType=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$pJ="workbench.view.search",e.$qJ="workbench.panel.search",e.$rJ="workbench.view.search",e.$sJ="search-result",e.$tJ="search.exclude";const l="\u27EA ",$=" characters skipped \u27EB",v=(l.length+$.length+5)*2;e.$uJ=(0,m.$6h)("searchService");var s;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(s||(e.SearchProviderType=s={}));var a;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(a||(e.QueryType=a={}));function r(ue){return!!ue.preview}e.$vJ=r;function n(ue){return!!ue.resource}e.$wJ=n;function o(ue){return!!ue.message}e.$xJ=o;var c;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(pe){this.resource=pe,this.results=[]}}e.$yJ=h;class i{constructor(pe,ie,be,se){this.ranges=ie,this.webviewIndex=se;const Z=Array.isArray(ie)?ie:[ie];if(be&&be.matchLines===1&&u(Z)){pe=(0,P.$Bf)(pe,be.matchLines);let V="",ne=0,Ae=0;const Le=Math.floor(be.charsPerLine/5),Ce=[];for(const ce of Z){const te=Math.max(ce.startColumn-Le,0),J=ce.startColumn+be.charsPerLine;if(te>Ae+Le+v){const ee=l+(te-Ae)+$;V+=ee+pe.slice(te,J),ne+=te-(Ae+ee.length)}else V+=pe.slice(Ae,J);Ce.push(new g(0,ce.startColumn-ne,ce.endColumn-ne)),Ae=J}this.preview={text:V,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const V=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:pe,matches:(0,y.$2b)(ie,ne=>new t(ne.startLineNumber-V,ne.startColumn,ne.endLineNumber-V,ne.endColumn))}}}}e.$zJ=i;function u(ue){const pe=ue[0].startLineNumber;for(const ie of ue)if(ie.startLineNumber!==pe||ie.endLineNumber!==pe)return!1;return!0}class t{constructor(pe,ie,be,se){this.startLineNumber=pe,this.startColumn=ie,this.endLineNumber=be,this.endColumn=se}}e.$AJ=t;class g extends t{constructor(pe,ie,be){super(pe,ie,pe,be)}}e.$BJ=g;var p;(function(ue){ue.List="list",ue.Tree="tree"})(p||(e.ViewMode=p={}));var d;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function S(ue,pe=!0){const ie=ue&&ue.files&&ue.files.exclude,be=pe&&ue&&ue.search&&ue.search.exclude;if(!ie&&!be)return;if(!ie||!be)return ie||be;let se=Object.create(null);return se=C.$yn(se,C.$vn(ie)),se=C.$yn(se,C.$vn(be),!0),se}e.$CJ=S;function L(ue,pe){return ue.excludePattern&&M.$Lj(ue.excludePattern,pe)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&M.$Lj(ue.includePattern,pe)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(ie=>{const be=ie.folder.fsPath;if(A.$8f(pe,be)){const se=f.$lc(be,pe);return!ie.includePattern||!!M.$Lj(ie.includePattern,se)}else return!1}):!1:!0}e.$DJ=L;var b;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class E extends Error{constructor(pe,ie){super(pe),this.code=ie}}e.$EJ=E;function D(ue){const pe=ue.message;if((0,w.$4)(ue))return new E(pe,b.canceled);try{const ie=JSON.parse(pe);return new E(ie.message,ie.code)}catch{return new E(pe,b.other)}}e.$FJ=D;function T(ue){const pe={message:ue.message,code:ue.code};return new Error(JSON.stringify(pe))}e.$GJ=T;function O(ue){return ue.type==="error"?!0:ue.type==="success"}e.$HJ=O;function G(ue){return ue.type==="success"}e.$IJ=G;function q(ue){return!!ue.path}e.$JJ=q;function U(ue,pe){const ie=ue.searchPath?ue.searchPath:ue.relativePath;return(0,P.$yf)(ie,pe)}e.$KJ=U;class I{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$LJ=I;function N(ue,pe){const ie={...ue||{},...pe||{}};return Object.keys(ie).filter(be=>{const se=ie[be];return typeof se=="boolean"&&se})}e.$MJ=N;class W{constructor(pe,ie){this.c=null,this.a={...pe.excludePattern||{},...ie.excludePattern||{}},this.b=M.$Mj(this.a);let be=pe.includePattern;ie.includePattern&&(be?be={...be,...ie.includePattern}:be=ie.includePattern),be&&(this.c=M.$Mj(be))}matchesExcludesSync(pe,ie,be){return!!(this.b&&this.b(pe,ie,be))}includedInQuerySync(pe,ie,be){return!(this.b&&this.b(pe,ie,be)||this.c&&!this.c(pe,ie,be))}includedInQuery(pe,ie,be){const se=this.b(pe,ie,be),Z=()=>this.c?!!this.c(pe,ie,be):!0;return(0,k.$Sg)(se)?se.then(V=>V?!1:Z()):Z()}hasSiblingExcludeClauses(){return ae(this.a)}}e.$NJ=W;function ae(ue){for(const pe in ue)if(typeof ue[pe]!="boolean")return!0;return!1}function de(ue){if(!ue)return;let pe;return ie=>(pe||(pe=(ue()||Promise.resolve([])).then(be=>be?ke(be):{})),pe.then(be=>!!be[ie]))}e.$OJ=de;function we(ue){if(!ue)return;let pe;return ie=>{if(!pe){const be=ue();pe=be?ke(be):{}}return!!pe[ie]}}e.$PJ=we;function ke(ue){const pe={};for(const ie of ue)pe[ie]=!0;return pe}}),define(Pe[36],Re([1,0,18,13,20,5,6,50,11,122,25,12,2,168,4,14,187,47,42,27,17,8,7,58,43,3,51]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n,o,c,h,i,u,t,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=e.$Igc=void 0;function d(G,q,U){return new R.$wg(I=>E(I,U)).isEqual(G,q)}function S(G,q,U){return d(G.uri,q.uri,U)?0:(0,k.$5e)(G.uri.toString(),q.uri.toString())}function L(G,q,U){return G.index!==q.index?G.index<q.index?-1:1:d(G.uri,q.uri,U)?(0,k.$5e)(G.name,q.name):(0,k.$5e)(G.uri.toString(),q.uri.toString())}function b(G,q,U,I){const N=G.slice(0).sort((ae,de)=>U(ae,de,I)),W=q.slice(0).sort((ae,de)=>U(ae,de,I));return(0,y.$Eb)(N,W,(ae,de)=>U(ae,de,I))}function E(G,q){const U=q.getCapabilities(G.scheme);return!(U&&U&1024)}class D extends r.$mi{static toExtHostWorkspace(q,U,I,N){if(!q)return{workspace:null,added:[],removed:[]};const{id:W,name:ae,folders:de,configuration:we,transient:ke,isUntitled:ue}=q,pe=[],ie=U;U?de.forEach((V,ne)=>{const Ae=l.URI.revive(V.uri),Le=D.o(I||U,Ae,N);Le?(Le.name=V.name,Le.index=V.index,pe.push(Le)):pe.push({uri:Ae,name:V.name,index:ne})}):pe.push(...de.map(({uri:V,name:ne,index:Ae})=>({uri:l.URI.revive(V),name:ne,index:Ae}))),pe.sort((V,ne)=>V.index<ne.index?-1:1);const be=new D(W,ae,pe,!!ke,we?l.URI.revive(we):null,!!ue,V=>E(V,N)),{added:se,removed:Z}=b(ie?ie.workspaceFolders:[],be.workspaceFolders,S,N);return{workspace:be,added:se,removed:Z}}static o(q,U,I){for(let N=0;N<q.folders.length;N++){const W=q.workspaceFolders[N];if(d(W.uri,U,I))return W}}constructor(q,U,I,N,W,ae,de){super(q,I.map(we=>new r.$ni(we)),N,W,de),this.t=U,this.u=ae,this.q=[],this.s=m.$_h.forUris(de),I.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,U){return U&&this.s.get(q)&&(q=(0,R.$Gg)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let T=class{constructor(q,U,I,N,W){this.c=new A.$Vd,this.onDidChangeWorkspace=this.c.event,this.g=new A.$Vd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new A.$Xd,this.B=new Map,this.h=N,this.s=I,this.t=W,this.j=new w.$9l,this.k=new M.$5g,this.o=q.getProxy(g.$0K.MainThreadWorkspace),this.q=q.getProxy(g.$0K.MainThreadMessageService);const ae=U.workspace;this.l=ae?new D(ae.id,ae.name,[],!!ae.transient,ae.configuration?l.URI.revive(ae.configuration):null,!!ae.isUntitled,de=>E(de,I)):void 0}$initializeWorkspace(q,U){this.v=U,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:f.Schemas.untitled,path:(0,R.$Eg)((0,R.$Gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,U,I,...N){const W=[];if(Array.isArray(N)&&N.forEach(ue=>{l.URI.isUri(ue.uri)&&!W.some(pe=>d(pe.uri,ue.uri,this.s))&&W.push({uri:ue.uri,name:ue.name||(0,R.$Dg)(ue.uri)})}),this.n||[U,I].some(ue=>typeof ue!="number"||ue<0)||I===0&&W.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(U+I>ae.length)return!1;const de=ae.slice(0);de.splice(U,I,...W.map(ue=>({uri:ue.uri,name:ue.name||(0,R.$Dg)(ue.uri),index:void 0})));for(let ue=0;ue<de.length;ue++){const pe=de[ue];if(de.some((ie,be)=>be!==ue&&d(pe.uri,ie.uri,this.s)))return!1}de.forEach((ue,pe)=>ue.index=pe);const{added:we,removed:ke}=b(ae,de,L,this.s);if(we.length===0&&ke.length===0)return!1;if(this.o){const ue=q.displayName||q.name;this.o.$updateWorkspaceFolders(ue,U,I,W).then(void 0,pe=>{this.n=void 0;const ie={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(a.Severity.Error,(0,$.localize)(0,null,ue,pe.toString()),ie,[])})}return this.y(de),!0}getWorkspaceFolder(q,U){if(this.x)return this.x.getWorkspaceFolder(q,U)}async getWorkspaceFolder2(q,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,U)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,U){let I,N="";if(typeof q=="string"?(I=l.URI.file(q),N=q):typeof q<"u"&&(I=q,N=q.fsPath),!I)return N;const W=this.getWorkspaceFolder(I,!0);if(!W)return N;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ae=(0,R.$Jg)(W.uri,I);return U&&W.name&&(ae=`${W.name}/${ae}`),ae}y(q){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:U,added:I,removed:N}=D.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:I,removed:N}))}findFiles(q,U,I,N,W=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let ae;if(U===null?ae=!1:U&&(typeof U=="string"?ae=U:ae=U.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:we}=O(h.GlobPattern.from(q));return this.o.$startFileSearch(de??null,we??null,ae??null,I??null,W).then(ke=>Array.isArray(ke)?ke.map(ue=>l.URI.revive(ue)):[])}async findTextInFiles(q,U,I,N,W=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),de=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:we,folder:ke}=O(h.GlobPattern.from(U.include)),ue=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,pe={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:de,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:we,excludePattern:ue},ie=!1;if(this.u[ae]=be=>{if(ie)return;const se=l.URI.revive(be.resource);be.results.forEach(Z=>{const V=(0,p.$Ch)(Z);(0,t.$vJ)(V)?I({uri:se,preview:{text:V.preview.text,matches:(0,y.$2b)(V.preview.matches,ne=>new i.$bL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,y.$2b)(V.ranges,ne=>new i.$bL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):I({uri:se,text:V.text,lineNumber:V.lineNumber})})},W.isCancellationRequested)return{};try{const be=await this.o.$startTextSearch(q,ke??null,pe,ae,W);return delete this.u[ae],be||{}}catch(be){throw delete this.u[ae],be}}$handleTextSearchResult(q,U){this.u[U]?.(q)}async save(q){const U=await this.o.$save(q,{saveAs:!1});return l.URI.revive(U)}async saveAs(q){const U=await this.o.$save(q,{saveAs:!0});return l.URI.revive(U)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,U){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,U);const I=this.t.transformOutgoingScheme(q),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,I),(0,P.$Rc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(q,U){this.h.info("Getting edit session identifier for workspaceFolder",q);const I=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!I){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",I);const N=this.w.get(I.uri.scheme);if(this.h.info(`Provider for scheme ${I.uri.scheme} is defined: `,!!N),!N)return;const W=await N.provideEditSessionIdentity(I,U);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(q,U,I,N){this.h.info("Getting edit session identifier for workspaceFolder",q);const W=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const ae=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!ae),!ae)return;const de=await ae.provideEditSessionIdentityMatch?.(U,I,N);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(q){return(U,I,N)=>{const W=function(de){U.call(I,de)};return W.extension=q,this.A.event(W,void 0,N)}}async $onWillCreateEditSessionIdentity(q,U,I){const N=await this.resolveWorkspaceFolder(l.URI.revive(q));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},U,async(W,ae)=>{const de=Date.now();await Promise.resolve(W),Date.now()-de>I&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(q,U){if(this.B.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.B.set(q,U);const I=this.t.transformOutgoingScheme(q),N=this.z++;return this.o.$registerCanonicalUriProvider(N,I),(0,P.$Rc)(()=>{this.B.delete(q),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(q,U,I){const N=this.B.get(q.scheme);if(!N)return;const W=await N.provideCanonicalUri?.(l.URI.revive(q),U,I);if(W)return W}async $provideCanonicalUri(q,U,I){return this.provideCanonicalUri(l.URI.revive(q),{targetScheme:U},I)}};e.$Igc=T,e.$Igc=T=Je([He(0,c.$bN),He(1,o.$rN),He(2,n.$ogc),He(3,s.$nj),He(4,u.$Ggc)],T),e.$Jgc=(0,v.$6h)("IExtHostWorkspace");function O(G){let q,U;return G&&(typeof G=="string"?q=G:(q=G.pattern,U=l.URI.revive(G.baseUri))),{includePattern:q,folder:U}}}),define(Pe[37],Re([1,0,26,5,36,3,7,189,55,16,13,4,17,14,2]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=e.$Lgc=e.$Kgc=void 0;function s(u,t){if(t){const g=t.split(".");let p=u;for(let d=0;p&&d<g.length;d++)p=p[g[d]];return p}}function a(u){return u instanceof v.URI}function r(u){return u&&u.uri instanceof v.URI&&u.languageId&&typeof u.languageId=="string"}function n(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function o(u){return u&&u.uri instanceof v.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function c(u){if(a(u))return{resource:u};if(r(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(n(u))return{overrideIdentifier:u.languageId};if(o(u))return{resource:u.uri};if(u===null)return{resource:null}}let h=class{constructor(t,g,p){this.a=t.getProxy(A.$0K.MainThreadConfiguration),this.c=g,this.b=p,this.d=new R.$5g,this.e=null}getConfigProvider(){return this.d.wait().then(t=>this.e)}$initializeConfiguration(t){this.e=new i(this.a,this.c,t,this.b),this.d.open()}$acceptConfigurationChanged(t,g){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(t,g))}};e.$Kgc=h,e.$Kgc=h=Je([He(0,l.$bN),He(1,C.$Jgc),He(2,$.$nj)],h);class i{constructor(t,g,p,d){this.a=new M.$Vd,this.b=t,this.f=d,this.c=g,this.e=m.$6n.parse(p),this.d=this.k(p.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(t,g){const p={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$6n.parse(t),this.d=this.k(t.configurationScopes),this.a.fire(this.j(g,p))}getConfiguration(t,g,p){const d=c(g)||{},S=this.g(t?s(this.e.getValue(void 0,d,this.c.workspace),t):this.e.getValue(void 0,d,this.c.workspace));t&&this.h(t,d,p?.identifier);function L(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(E){return typeof s(S,E)<"u"},get:(E,D)=>{this.h(t?`${t}.${E}`:E,d,p?.identifier);let T=s(S,E);if(typeof T>"u")T=D;else{let O;const G=(q,U)=>{if((0,w.$Kf)(q)){let I;const N=()=>{O=O||(0,y.$vn)(S),I=I||s(O,U)};return new Proxy(q,{get:(W,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return N(),()=>I;if(O)return I=I||s(O,U),I[ae];const de=W[ae];return typeof ae=="string"?G(de,`${U}.${ae}`):de},set:(W,ae,de)=>(N(),I&&(I[ae]=de),!0),deleteProperty:(W,ae)=>(N(),I&&delete I[ae],!0),defineProperty:(W,ae,de)=>(N(),I&&Object.defineProperty(I,ae,de),!0)})}return Array.isArray(q)?(0,y.$vn)(q):q};T=G(T,E)}return T},update:(E,D,T,O)=>{E=t?`${t}.${E}`:E;const G=L(T);return D!==void 0?this.b.$updateConfigurationOption(G,E,D,d,O):this.b.$removeConfigurationOption(G,E,d,O)},inspect:E=>{E=t?`${t}.${E}`:E;const D=this.e.inspect(E,d,this.c.workspace);if(D)return{key:E,defaultValue:(0,y.$vn)(D.policy?.value??D.default?.value),globalValue:(0,y.$vn)(D.user?.value??D.application?.value),workspaceValue:(0,y.$vn)(D.workspace?.value),workspaceFolderValue:(0,y.$vn)(D.workspaceFolder?.value),defaultLanguageValue:(0,y.$vn)(D.default?.override),globalLanguageValue:(0,y.$vn)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,y.$vn)(D.workspace?.override),workspaceFolderLanguageValue:(0,y.$vn)(D.workspaceFolder?.override),languageIds:(0,y.$vn)(D.overrideIdentifiers)}}};return typeof S=="object"&&(0,y.$yn)(b,S,!1),Object.freeze(b)}g(t){const g=p=>(0,w.$Kf)(p)?new Proxy(p,{get:(d,S)=>g(d[S]),set:(d,S,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(d,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(d,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return g(t)}h(t,g,p){const d=f.$Wn.test(t)?4:this.d.get(t),S=p?`[${p.value}] `:"";if(d===4){typeof g?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${t}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){g?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${t}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(t,g){const p=new m.$8n(t,g,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,S)=>p.affectsConfiguration(d,c(S))})}k(t){return t.reduce((g,p)=>(g.set(p[0],p[1]),g),new Map)}}e.$Lgc=i,e.$Mgc=(0,k.$6h)("IExtHostConfiguration")}),define(Pe[115],Re([1,0,2,13,5,3,7,36,66,37,20,65,17,27,4,11,21,14,79,220,15]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=e.$cic=e.$bic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(G){function q(I){if(I!=null)return I}G.from=q;function U(I){if(I!=null)return I}G.to=U})(h||(h={}));var i;(function(G){function q(I){if(I!=null)return I}G.from=q;function U(I){if(I!=null)return I}G.to=U})(i||(i={}));var u;(function(G){function q(I){if(I!=null)return I}G.from=q;function U(I){if(I!=null)return I}G.to=U})(u||(u={}));var t;(function(G){function q(N){if(N){const W=N;return W&&!!W.process}else return!1}G.is=q;function U(N){if(N==null)return;const W={process:N.process,args:N.args};return N.options&&(W.options=u.from(N.options)),W}G.from=U;function I(N){if(N!=null)return new P.$UL(N.process,N.args,N.options)}G.to=I})(t||(t={}));var g;(function(G){function q(I){if(I!=null)return I}G.from=q;function U(I){if(I!=null)return I}G.to=U})(g||(g={}));var p;(function(G){function q(N){if(N){const W=N;return W&&(!!W.commandLine||!!W.command)}else return!1}G.is=q;function U(N){if(N==null)return;const W={};return N.commandLine!==void 0?W.commandLine=N.commandLine:(W.command=N.command,W.args=N.args),N.options&&(W.options=g.from(N.options)),W}G.from=U;function I(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new P.$VL(N.commandLine,N.options):new P.$VL(N.command,N.args?N.args:[],N.options)}G.to=I})(p||(p={}));var d;(function(G){function q(N){if(N){const W=N;return W&&W.customExecution==="customExecution"}else return!1}G.is=q;function U(N){return{customExecution:"customExecution"}}G.from=U;function I(N,W){return W.get(N)}G.to=I})(d||(e.CustomExecutionDTO=d={}));var S;(function(G){function q(U,I){let N;return U.scope!==void 0&&typeof U.scope!="number"?N=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===P.TaskScope.Workspace&&I&&I.workspaceFile?N=I.workspaceFile:N=o.$yG),{id:U._id,workspaceFolder:N}}G.from=q})(S||(e.TaskHandleDTO=S={}));var L;(function(G){function q(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}G.from=q})(L||(L={}));var b;(function(G){function q(N,W){if(N==null)return[];const ae=[];for(const de of N){const we=U(de,W);we&&ae.push(we)}return ae}G.fromMany=q;function U(N,W){if(N==null)return;let ae;N.execution instanceof P.$UL?ae=t.from(N.execution):N.execution instanceof P.$VL?ae=p.from(N.execution):N.execution&&N.execution instanceof P.$WL&&(ae=d.from(N.execution));const de=h.from(N.definition);let we;return N.scope?typeof N.scope=="number"?we=N.scope:we=N.scope.uri:we=P.TaskScope.Workspace,!de||!we?void 0:{_id:N._id,definition:de,name:N.name,source:{extensionId:W.identifier.value,label:N.source,scope:we},execution:ae,isBackground:N.isBackground,group:L.from(N.group),presentationOptions:i.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}G.from=U;async function I(N,W,ae){if(N==null)return;let de;t.is(N.execution)?de=t.to(N.execution):p.is(N.execution)?de=p.to(N.execution):d.is(N.execution)&&(de=d.to(N._id,ae));const we=h.to(N.definition);let ke;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?ke=N.source.scope:ke=await W.resolveWorkspaceFolder(y.URI.revive(N.source.scope)):ke=P.TaskScope.Workspace),!we||!ke)return;const ue=new P.$XL(we,ke,N.name,N.source.label,de,N.problemMatchers);return N.isBackground!==void 0&&(ue.isBackground=N.isBackground),N.group!==void 0&&(ue.group=P.$TL.from(N.group._id),ue.group&&N.group.isDefault&&(ue.group=new P.$TL(ue.group.id,ue.group.label),N.group.isDefault===!0&&(ue.group.isDefault=N.group.isDefault))),N.presentationOptions&&(ue.presentationOptions=i.to(N.presentationOptions)),N._id&&(ue._id=N._id),N.detail&&(ue.detail=N.detail),ue}G.to=I})(b||(e.TaskDTO=b={}));var E;(function(G){function q(I){return I}G.from=q;function U(I){if(I)return Object.assign(Object.create(null),I)}G.to=U})(E||(E={}));class D{#e;constructor(q,U,I){this._id=U,this.a=I,this.#e=q}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}let T=class{constructor(q,U,I,N,W,ae,de,we){this.q=new C.$Vd,this.r=new C.$Vd,this.s=new C.$Vd,this.u=new C.$Vd,this.a=q.getProxy(A.$0K.MainThreadTask),this.b=I,this.c=N,this.d=W,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,U,I){if(!I)return new P.$_K(()=>{});const N=this.x();return this.j.set(N,{type:U,provider:I,extension:q}),this.a.$registerTaskProvider(N,U),new P.$_K(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(q,U){this.a.$registerTaskSystem(q,U)}fetchTasks(q){return this.a.$fetchTasks(E.from(q)).then(async U=>{const I=[];for(const N of U){const W=await b.to(N,this.b,this.m);W&&I.push(W)}return I})}get taskExecutions(){const q=[];return this.k.forEach(U=>q.push(U)),q}terminateTask(q){if(!(q instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,U,I){const N=this.m.get(q.id);N&&(this.o.set(q.id,N),this.e.attachPtyToTerminal(U,await N.callback(I))),this.p=q.id,this.q.fire({execution:await this.z(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){if(!this.l.has(q.id))return;const U=await this.z(q);this.l.delete(q.id),this.k.delete(q.id),this.B(q),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const U=await this.z(q.id);this.s.fire({execution:U,processId:q.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(q){const U=await this.z(q.id);this.u.fire({execution:U,exitCode:q.exitCode})}$provideTasks(q,U){const I=this.j.get(q);if(!I)return Promise.reject(new Error("no handler found"));const N=[],W=(0,M.$Yg)(()=>I.provider.provideTasks(R.CancellationToken.None)).then(ae=>this.v(U,N,I,ae));return new Promise(ae=>{W.then(de=>{Promise.all(N).then(()=>{ae(de)})})})}async $resolveTask(q,U){const I=this.j.get(q);if(!I)return Promise.reject(new Error("no handler found"));if(U.definition.type!==I.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${I.type}].`);const N=await b.to(U,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const W=await I.provider.resolveTask(N,R.CancellationToken.None);if(!W)return;this.A(W,I);const ae=b.from(W,I.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(ae.execution)&&await this.y(ae,W,!0),await this.w(ae)}x(){return this.h++}async y(q,U,I){const N=await this.a.$createTaskId(q);!I&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,U.execution)),this.m.set(N,U.execution)}async z(q,U){if(typeof q=="string"){const W=this.l.get(q);if(!W)throw new c.$bb("Unexpected: The specified task is missing an execution");return W}const I=this.l.get(q.id);if(I)return I;let N;return U?N=Promise.resolve(new D(this,q.id,U)):N=b.to(q.task,this.b,this.m).then(W=>{if(!W)throw new c.$bb("Unexpected: Task does not exist.");return new D(this,q.id,W)}),this.l.set(q.id,N),N.then(W=>(this.k.set(q.id,W),W))}A(q,U){q._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const I=this.n.values();let N=I.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=I.next()}};e.$bic=T,e.$bic=T=Je([He(0,l.$bN),He(1,$.$rN),He(2,m.$Jgc),He(3,f.$mN),He(4,w.$Mgc),He(5,k.$$gc),He(6,r.$nj),He(7,n.$rgc)],T);let O=class extends T{constructor(q,U,I,N,W,ae,de,we){super(q,U,I,N,W,ae,de,we),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:a.$h(0)})}async executeTask(q,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const I=b.from(U,q);if(I===void 0)throw new Error("Task is not valid");if(d.is(I.execution))await this.y(I,U,!1);else throw new c.$_;const N=await this.z(await this.a.$getTaskExecution(I),U);return this.a.$executeTask(I).catch(W=>{throw new Error(W)}),N}v(q,U,I,N){const W=[];if(N)for(const ae of N){if(this.A(ae,I),!ae.definition||!q[ae.definition.type]){const we=ae.source?ae.source:"No task source";this.f.warn(`The task [${we}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const de=b.from(ae,I.extension);de&&d.is(de.execution)?(W.push(de),U.push(this.y(de,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:I.extension}}async w(q){if(d.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,U,I){}};e.$cic=O,e.$cic=O=Je([He(0,l.$bN),He(1,$.$rN),He(2,m.$Jgc),He(3,f.$mN),He(4,w.$Mgc),He(5,k.$$gc),He(6,r.$nj),He(7,n.$rgc)],O),e.$dic=(0,v.$6h)("IExtHostTask")}),define(Pe[282],Re([1,0,43,29]),function(ge,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$WJ=e.$VJ=void 0;function C(P){return"cellResults"in P}e.$VJ=C,e.$WJ="rawCell#";function A(P,m){let f=-1;const w=[];let R=[];return P.forEach(l=>{l.range.startLineNumber!==f&&R.length>0&&(w.push([...R]),R=[]),R.push(l),f=l.range.endLineNumber}),R.length>0&&w.push([...R]),w.map(l=>{const $=[],v=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let a=v;a<=s;a++)$.push(m.getLineContent(a));return new y.$zJ($.join(`
`)+`
`,l.map(a=>new M.$Us(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}e.$XJ=A}),define(Pe[283],Re([1,0,162,22,5,6,28,12,16,2,41,75,3,32,8,7,49,258,109,26,11,210,282,280]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n,o,c,h,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(p=>p.apiEditor)}constructor(p,d,S,L,b,E){this.q=S,this.r=L,this.s=b,this.t=E,this.f=new Map,this.g=new P.$Ac,this.h=new Map,this.j=new C.$Vd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Vd,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Vd,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Vd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$kgc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=p.getProxy(l.$0K.MainThreadNotebook),this.c=p.getProxy(l.$0K.MainThreadNotebookDocuments),this.d=p.getProxy(l.$0K.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const T=D.notebookEditor?.notebookUri,O=D.cell.handle,q=this.g.get(T)?.getCell(O);if(q)return q.apiCell}if(D&&D.$mid===14){const T=D.uri,O=this.g.get(T);if(O)return O.apiNotebook}return D}}),t.B(d)}getEditorById(p){const d=this.h.get(p);if(!d)throw new Error(`unknown text editor: ${p}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor(p){for(const[d,S]of this.h)if(S.apiEditor===p)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(p,d){const S=this.g.get(p);if(!S&&!d)throw new Error(`NO notebook document for '${p}'`);return S}static u(p,d){if(!d)return;const S=d.filenamePattern.map(L=>v.NotebookExclusiveDocumentPattern.from(L)).filter(L=>L!==void 0);if(d.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:p.identifier,providerDisplayName:p.displayName||p.name,displayName:d.displayName,filenamePattern:S,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(p,d,S){const L=t.a++,b=typeof S.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(L,S),this.b.$registerNotebookCellStatusBarItemProvider(L,b,d);let E;return b!==void 0&&(E=S.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(b))),new s.$_K(()=>{this.f.delete(L),this.b.$unregisterNotebookCellStatusBarItemProvider(L,b),E?.dispose()})}async createNotebookDocument(p){const d=await this.c.$tryCreateNotebook({viewType:p.viewType,content:p.content&&v.NotebookData.from(p.content)});return w.URI.revive(d)}async openNotebookDocument(p){const d=this.g.get(p);if(d)return d.apiNotebook;const S=await this.c.$tryOpenNotebook(p),L=this.g.get(w.URI.revive(S));return(0,f.$Tf)(L?.apiNotebook)}async showNotebookDocument(p,d){w.URI.isUri(p)&&(p=await this.openNotebookDocument(p));let S;typeof d=="object"?S={position:v.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(v.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:S={preserveFocus:!1};const L=await this.d.$tryShowNotebookDocument(p.uri,p.notebookType,S),b=L&&this.h.get(L)?.apiEditor;if(b)return b;throw L?new Error(`Could NOT open editor for "${p.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${p.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(p,d,S,L){const b=this.f.get(p),E=w.URI.revive(d),D=this.g.get(E);if(!D||!b)return;const T=D.getCellFromIndex(S);if(!T)return;const O=await b.provideCellStatusBarItems(T.apiCell,L);if(!O)return;const G=new A.$Sc,q=this.p.add([G]),I=(Array.isArray(O)?O:[O]).map(N=>v.NotebookStatusBarItem.from(N,this.i,G));return{cacheId:q,items:I}}$releaseNotebookCellStatusBarItems(p){this.p.delete(p)}registerNotebookSerializer(p,d,S,L,b){if((0,m.$Je)(d))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:d,serializer:S,options:L}),this.b.$registerNotebookSerializer(E,{id:p.identifier,location:p.extensionLocation},d,v.NotebookDocumentContentOptions.from(L),t.u(p,b)),(0,A.$Rc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(p,d,S){const L=this.x.get(p);if(!L)throw new Error("NO serializer found");const b=await L.serializer.deserializeNotebook(d.buffer,S);return new a.$Tv(v.NotebookData.from(b))}async $notebookToData(p,d,S){const L=this.x.get(p);if(!L)throw new Error("NO serializer found");const b=await L.serializer.serializeNotebook(v.NotebookData.to(d.value),S);return M.$je.wrap(b)}async $saveNotebook(p,d,S,L,b){const E=w.URI.revive(d),D=this.x.get(p);if(!D)throw new Error("NO serializer found");const T=this.g.get(E);if(!T)throw new Error("Document NOT found");if(T.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new R.$Lk((0,y.localize)(0,null,this.z(E)),6);await this.y(E,L);const O={metadata:(0,o.$Dn)(T.apiNotebook.metadata,N=>!(D.options?.transientDocumentMetadata??{})[N]),cells:[]};for(const N of T.apiNotebook.getCells()){const W=new s.$yM(N.kind,N.document.getText(),N.document.languageId,N.mime,D.options?.transientOutputs?[]:[...N.outputs],N.metadata,N.executionSummary);W.metadata=(0,o.$Dn)(N.metadata,ae=>!(D.options?.transientCellMetadata??{})[ae]),O.cells.push(W)}const G=await D.serializer.serializeNotebook(O,b);await this.s.value.writeFile(E,G);const q=this.s.getFileSystemProviderExtUri(E.scheme),U=await this.s.value.stat(E);return{name:q.basename(E),isFile:(U.type&R.FileType.File)!==0,isDirectory:(U.type&R.FileType.Directory)!==0,isSymbolicLink:(U.type&R.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((U.permissions??0)&R.FilePermission.Locked),etag:R.$Wk({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(p,d,S,L,b){const E=this.x.get(p)?.serializer;if(!E)return{limitHit:!1,results:[]};const D=new P.$Bc;await(async(U,I,N)=>{await Promise.all(U.map(async W=>await Promise.all(W.filenamePatterns.map(ae=>{const de={_reason:N._reason,folderQueries:N.folderQueries,includePattern:N.includePattern,excludePattern:N.excludePattern,maxResults:N.maxResults,type:1,filePattern:ae};return this.t.doInternalFileSearchWithCustomCallback(de,I,we=>{we.forEach(ke=>{D.has(ke)||L.some(pe=>W.isFromSettings&&!pe.isFromSettings?!1:pe.filenamePatterns.some(ie=>(0,u.$jdb)(ie,ke)))||D.add(ke)})})}))))})(S,b,d);const O=new P.$Ac;let G=!1;const q=Array.from(D).map(async U=>{const I=[];try{if(b.isCancellationRequested)return;if(d.maxResults&&[...O.values()].reduce((de,we)=>de+we.cellResults.length,0)>d.maxResults){G=!0;return}const N=[],W=this.g.get(U);if(W)W.apiNotebook.getCells().forEach(we=>N.push({input:we.document.getText(),outputs:we.outputs.flatMap(ke=>ke.items.map(ue=>ue.data.toString()))}));else{const de=await this.s.value.readFile(U),we=M.$je.fromString(de.toString()),ke=await E.deserializeNotebook(we.buffer,b);if(b.isCancellationRequested)return;v.NotebookData.from(ke).cells.forEach(pe=>N.push({input:pe.source,outputs:pe.outputs.flatMap(ie=>ie.items.map(be=>be.valueBytes.toString()))}))}if(b.isCancellationRequested)return;N.forEach((de,we)=>{const ke=d.contentPattern.pattern,ue=new h.$WQb(de.input,void 0,de.outputs),pe=ue.findInInputs(ke),ie=ue.findInOutputs(ke),be=ie.flatMap(se=>(0,i.$XJ)(se.matches,se.textBuffer)).map((se,Z)=>(se.webviewIndex=Z,se));if(pe.length>0||ie.length>0){const se={index:we,contentResults:(0,i.$XJ)(pe,ue.inputTextBuffer),webviewResults:be};I.push(se)}});const ae={resource:U,cellResults:I};O.set(U,ae);return}catch{return}});return await Promise.all(q),{limitHit:G,results:[...O.values()]}}async y(p,d){const S=await this.s.value.stat(p);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==R.$Vk&&typeof S.mtime=="number"&&typeof S.size=="number"&&d.mtime<S.mtime&&d.etag!==R.$Wk({mtime:d.mtime,size:S.size}))throw new R.$Lk((0,y.localize)(1,null),3,d)}z(p){return p.scheme===c.Schemas.file?p.fsPath:p.toString()}A(p,d,S){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const L=new n.$Ghc(d,this.d,p,S.visibleRanges.map(v.NotebookRange.to),S.selections.map(v.NotebookRange.to),typeof S.viewColumn=="number"?v.ViewColumn.to(S.viewColumn):void 0);this.h.set(d,L)}$acceptDocumentAndEditorsDelta(p){if(p.value.removedDocuments)for(const S of p.value.removedDocuments){const L=w.URI.revive(S),b=this.g.get(L);b&&(b.dispose(),this.g.delete(L),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(b.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===L.toString()&&this.h.delete(E.id)}if(p.value.addedDocuments){const S=[];for(const L of p.value.addedDocuments){const b=w.URI.revive(L.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const E=new r.$Fhc(this.c,this.q,this.r,b,L);S.push(...L.cells.map(D=>r.$Ehc.asModelAddData(E.apiNotebook,D))),this.g.get(b)?.dispose(),this.g.set(b,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(E.apiNotebook)}}if(p.value.addedEditors)for(const S of p.value.addedEditors){if(this.h.has(S.id))return;const L=w.URI.revive(S.documentUri),b=this.g.get(L);b&&this.A(b,S.id,S)}const d=[];if(p.value.removedEditors)for(const S of p.value.removedEditors){const L=this.h.get(S);L&&(this.h.delete(S),this.k?.id===L.id&&(this.k=void 0),d.push(L))}if(p.value.visibleEditors){this.l=p.value.visibleEditors.map(L=>this.h.get(L)).filter(L=>!!L);const S=new Set;this.l.forEach(L=>S.add(L.id));for(const L of this.h.values()){const b=S.has(L.id);L._acceptVisibility(b)}this.l=[...this.h.values()].map(L=>L).filter(L=>L.visible),this.o.fire(this.visibleNotebookEditors)}p.value.newActiveEditor===null?this.k=void 0:p.value.newActiveEditor&&(this.h.get(p.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${p.value.newActiveEditor}`),this.k=this.h.get(p.value.newActiveEditor)),p.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(p){const d=$.$zN.String.with("notebookType","A notebook type"),S=new $.$BN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new $.$zN("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>M.$je.wrap(b))],new $.$AN("Notebook Data",b=>v.NotebookData.to(b.value))),L=new $.$BN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new $.$zN("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new a.$Tv(v.NotebookData.from(b)))],new $.$AN("Bytes",b=>b.buffer));p.registerApiCommand(S),p.registerApiCommand(L)}}e.$Phc=t}),define(Pe[284],Re([1,0,19,20,40,34,25,63,43]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class w{constructor(l,$,v){this.k=l,this.l=$,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&A.$Mj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&A.$Mj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const $=this.k.folderQueries||[];return new Promise((v,s)=>{const a=r=>{this.f++,l(r)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const n=r.toString(),o=y.$nc(n);this.j&&this.j(n,o)||this.v(a,{base:r,basename:o})}),Promise.all($.map(r=>this.p(r,a))).then(r=>{v({limitHit:this.e,stats:r[0]||void 0})},r=>{s(new Error((0,C.$Qi)(r)))})})}async p(l,$){const v=new M.$6d,s=this.q(l),a=this.r(),r=new f.$NJ(this.k,l),n=!r.hasSiblingExcludeClauses();let o;try{this.h.add(v),o=m.$Rd.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,v.token),h=o.elapsed(),i=m.$Rd.create();return this.g&&!this.e||(c&&c.forEach(u=>{const t=y.$gc.relative(l.folder.path,u.path);if(n){const g=y.$nc(u.path);this.v($,{base:l.folder,relativePath:t,basename:g});return}this.s(a,l.folder,t,$)}),this.g&&!this.e)?null:(this.u(a,r,$),{providerTime:h,postProcessTime:i.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(l){const $=(0,f.$MJ)(this.k.includePattern,l.includePattern),v=(0,f.$MJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:v,includes:$,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},$,v,s){if(v===this.a){const r=y.$nc(this.a);this.v(s,{base:$,relativePath:this.a,basename:r})}function a(r){const n=y.$nc(r),o=y.$mc(r);let c=l[o];c||(c=l[o]=[],a(o)),c.push({base:$,relativePath:r,basename:n})}a(v)}u({rootEntries:l,pathToEntries:$},v,s){const a=this,r=this.a;function n(o){const c=(0,f.$PJ)(()=>o.map(h=>h.basename));for(let h=0,i=o.length;h<i;h++){const u=o[h],{relativePath:t,basename:g}=u;if(v.matchesExcludesSync(t,g,r!==g?c:void 0))continue;const p=$[t];if(p)n(p);else{if(t===r)continue;a.v(s,u)}if(a.e)break}}n(l)}v(l,$){(!this.b||$.relativePath&&this.b($.relativePath,$.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l($))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,$,v,s){const a=this.c(l.cacheKey),r=new w(l,$,a&&a.token);let n=0;const o=c=>{n+=c.length,v(c.map(h=>this.d(h)))};return this.e(r,R.a,o,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new M.$6d),this.b.get(l)}d(l){return l.relativePath?{resource:P.$Hg(l.base,l.relativePath)}:{resource:l.base}}e(l,$,v,s){const a=s.onCancellationRequested(()=>{l.cancel()}),r=o=>{o&&(n.push(o),$>0&&n.length>=$&&(v(n),n=[]))};let n=[];return l.search(r).then(o=>(n.length&&v(n),a.dispose(),o),o=>(n.length&&v(n),a.dispose(),Promise.reject(o)))}}e.$Hhc=R}),define(Pe[285],Re([1,0,18,253,34,95,28,11,19,25,12,16,2,94,179,46,14,47,104,281,43]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$NK=void 0;let h=class{constructor(E,D,T,O,G){this.a=E,this.b=D,this.c=T,this.d=O,this.e=G}text(E,D,T={}){E=this.f(E,T);const O=this.a.getValue(),G=D&&D.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(D?.map(r.$oi),T),type:2,contentPattern:E,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:O.search.usePCRE2||G||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}f(E,D){const T=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const O={...E,wordSeparators:T.editor.wordSeparators};return this.j(E,D)&&(O.isCaseSensitive=!0),this.k(E)&&(O.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),O}file(E,D={}){return{...this.h(E,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}g(E,D){return E?(E=Array.isArray(E)?E.map(p):p(E),D?this.parseSearchPaths(E):{pattern:u(...Array.isArray(E)?E:[E])}):{}}h(E=[],D={}){const T=this.g(D.includePattern,D.expandPatterns),O=this.g(D.excludePattern,D.expandPatterns),G=E.length>1,q=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(N=>this.q(N,D,O)):E.map(N=>this.r(N,D,O,G))).filter(N=>!!N),U={_reason:D._reason,folderQueries:q,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:O.pattern,includePattern:T.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const N=y.$Hb(y.$Rb(this.c.groups.map(de=>de.editors.map(we=>we.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const W=N.filter(de=>(0,c.$DJ)(U,de.fsPath)),ae=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...U,...ae}}const I=D.extraFileResources&&D.extraFileResources.filter(N=>(0,c.$DJ)(U,N.fsPath));return U.extraFileResources=I&&I.length?I:void 0,U}i(E){const D=[],T=new P.$Ac,O={};let G=!1;return E.forEach(q=>{if(q.scheme===m.Schemas.walkThrough)return;if((0,w.$Lg)(q)){const I=this.b.getWorkspaceFolder(q)?.uri??q.with({path:f.$mc(q.fsPath)});let N=T.get(I);N||(G=!0,N={folder:I,includePattern:{}},D.push(N),T.set(I,N));const W=f.$lc(I.fsPath,q.fsPath);(0,k.$Tf)(N.includePattern)[W.replace(/\\/g,"/")]=!0}else q.fsPath&&(G=!0,O[q.fsPath]=!0)}),{folderQueries:D,includePattern:O,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(E,D){if(D.isSmartCase){if(E.isRegExp){if(R.$zf(E.pattern,!0))return!0}else if(R.$zf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,$.$4B)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const D=ae=>f.$ic(ae)||/^\.\.?([\/\\]|$)/.test(ae),O=(Array.isArray(E)?E:t(E)).map(ae=>{const de=this.e.resolvedUserHome;return de?(0,A.$Yv)(ae,de.scheme===m.Schemas.file?de.fsPath:de.path):ae}),G=M.$K(O,ae=>D(ae)?"searchPaths":"exprSegments"),q=(G.exprSegments||[]).map(ae=>R.$Ue(ae,"/")).map(ae=>R.$Ue(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),g(ae))),U={},I=this.m(G.searchPaths||[]);I&&I.length&&(U.searchPaths=I);const N=y.$Rb(q),W=u(...N);return W&&(U.pattern=W),U}l(E,D){return D.disregardExcludeSettings?void 0:(0,c.$CJ)(E,!D.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const D=E.flatMap(O=>{let{pathPortion:G,globPortion:q}=i(O);return q&&(q=d(q)),this.n(G).flatMap(I=>this.o(I,q))}),T=new Map;return D.forEach(O=>{const G=O.searchPath.toString(),q=T.get(G);q?O.pattern&&(q.pattern=q.pattern||{},q.pattern[O.pattern]=!0):T.set(G,{searchPath:O.searchPath,pattern:O.pattern?u(O.pattern):void 0})}),Array.from(T.values())}n(E){if(f.$ic(E)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==m.Schemas.file?[{searchPath:D[0].uri.with({path:E})}]:[{searchPath:l.URI.file(f.$hc(E))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(E=p(E),E.startsWith("../")||E===".."){const O=f.$gc.resolve(D.path,E);return[{searchPath:D.with({path:O})}]}const T=d(E);return[{searchPath:D,pattern:T}]}else{if(E==="./"||E===".\\")return[];{const D=E.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(G=>{const q=D.match(new RegExp(`^${R.$Oe(G.name)}(?:/(.*)|$)`));return q?{match:q,folder:G}:null}).filter(k.$Qf);if(O.length)return O.map(G=>{const q=G.match[1];return{searchPath:G.folder.uri,pattern:q&&d(q)}});{const G=E.match(/\.[\/\\](.+)[\/\\]?/),q=G?G[1]:E,U=v.localize(0,null,q);throw new Error(U)}}}}o(E,D){const T=E.pattern&&D?`${E.pattern}/${D}`:E.pattern||D,O=[{searchPath:E.searchPath,pattern:T}];return T&&!T.endsWith("**")&&O.push({searchPath:E.searchPath,pattern:T+"/**"}),O}q(E,D,T){const O=this.r((0,r.$oi)(E.searchPath),D,T,!1);return O?{...O,includePattern:E.pattern}:null}r(E,D,T,O){let G;const q=l.URI.isUri(E)?E:E.uri;if(T.searchPaths){const ae=T.searchPaths.filter(de=>(0,w.$Ag)(de.searchPath,q))[0];if(ae&&!ae.pattern)return null;ae&&(G=ae.pattern)}const U=this.a.getValue({resource:q}),N={...this.l(U,D)||{},...G||{}},W=l.URI.isUri(E)?(0,w.$Eg)(E):E.name;return{folder:q,folderName:O?W:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!U.search.followSymlinks}}};e.$NK=h,e.$NK=h=Je([He(0,s.$zi),He(1,r.$ci),He(2,n.$9C),He(3,a.$nj),He(4,o.$LK)],h);function i(b){const E=b.match(/[\*\{\}\(\)\[\]\?]/);if(E){const D=E.index,T=b.substr(0,D).match(/[/|\\][^/\\]*$/);if(T){let O=b.substr(0,T.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:b.substr((T.index||0)+1)}}}return{pathPortion:b}}function u(...b){return b.length?b.reduce((E,D)=>(E[D]=!0,E),Object.create(null)):void 0}function t(b){return C.$Kj(b,",").map(E=>E.trim()).filter(E=>!!E.length)}function g(b){return[`**/${b}/**`,`**/${b}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function p(b){return b.replace(/\\/g,"/")}function d(b){return p(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(b){return b.replace(/([?*[\]])/g,"[$1]")}function L(b,E){b=y.$Mb(b,O=>O.toString());const D=[],T=E.getWorkspace();return b&&b.forEach(O=>{let G;if(E.getWorkbenchState()===2)G=(0,w.$Jg)(T.folders[0].uri,O),G&&G!=="."&&(G="./"+G);else{const q=E.getWorkspaceFolder(O);if(q){const U=q.name;if(T.folders.filter(N=>N.name===U).length===1){const N=(0,w.$Jg)(q.uri,O);N===""?G=`./${q.name}`:G=`./${q.name}/${N}`}else G=O.fsPath}}G&&D.push(S(G))}),D}e.$OK=L}),define(Pe[286],Re([1,0,25,2,20,15,4,285,43,47]),function(ge,e,y,M,C,A,P,m,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wsb=e.$vsb=void 0;const R=7e3;function k(s,a){const r=a.activationEvents;if(!r)return Promise.resolve(void 0);const n=[],o=[];for(const g of r)if(/^workspaceContains:/.test(g)){const p=g.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||s.forceUsingSearch?o.push(p):n.push(p)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);let c;const h=new Promise((g,p)=>{c=g}),i=g=>c({activationEvent:g}),u=Promise.all(n.map(g=>l(s,g,i))).then(()=>{}),t=$(s,a.identifier,o,i);return Promise.all([u,t]).then(()=>{c(void 0)}),h}e.$vsb=k;async function l(s,a,r){for(const n of s.folders)if(await s.exists(y.$Hg(M.URI.revive(n),a))){r(`workspaceContains:${a}`);return}}async function $(s,a,r,n){if(r.length===0)return Promise.resolve(void 0);const o=new C.$6d,c=s.checkExists(s.folders,r,o.token),h=setTimeout(async()=>{o.cancel(),s.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},R);let i=!1;try{i=await c}catch(u){A.$4(u)||A.$1(u)}o.dispose(),clearTimeout(h),i&&n(`workspaceContains:${r.join(",")}`)}function v(s,a,r,n){const o=s.get(P.$5h),c=s.get(f.$uJ),i=o.createInstance(m.$NK).file(a.map(u=>(0,w.$oi)(M.URI.revive(u))),{_reason:"checkExists",includePattern:r,exists:!0});return c.fileSearch(i,n).then(u=>!!u.limitHit,u=>A.$4(u)?!1:Promise.reject(u))}e.$wsb=v}),define(Pe[38],Re([1,0,159,19,88,25,13,6,50,2,14,3,37,216,83,36,24,105,15,23,22,200,7,100,4,27,85,17,71,86,65,5,286,82,202,11,80,63,21,81]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n,o,c,h,i,u,t,g,p,d,S,L,b,E,D,T,O,G,q,U,I,N){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=e.$mhc=e.$lhc=e.$khc=e.$jhc=void 0,e.$jhc=(0,t.$6h)("IHostUtils");let ae=W=class extends m.$Tc{constructor(Z,V,ne,Ae,Le,Ce,ce,te,J,ee,me,ve){super(),this.X=ve,this.a=this.B(new E.$Vd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ne,this.f=ce,this.j=Ae,this.m=Le,this.s=Ce,this.t=J,this.u=ee,this.w=me,this.y=this.g.getProxy(k.$0K.MainThreadWorkspace),this.z=this.g.getProxy(k.$0K.MainThreadTelemetry),this.C=this.g.getProxy(k.$0K.MainThreadExtensionService),this.D=new P.$5g,this.F=new P.$5g,this.G=new P.$5g,this.H=new P.$5g,this.I=new be(this.f.extensions.activationEvents),this.L=new r.$t8b(this.I,this.f.extensions.allExtensions);const Me=new o.$mm(this.f.extensions.myExtensions);this.J=new r.$t8b(this.I,pe(this.L,Me)),I.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new v.$7gc(this.g,this.s),this.N=new T.$chc(this.g),this.O=te,this.h=Z.createChild(new S.$4h([v.$8gc,this.M],[T.$dhc,this.N])),this.P=this.B(new $.$6gc(this.J,this.L,{onExtensionActivationError:(fe,ye,F)=>{this.C.$onExtensionActivationError(fe,n.$3(ye),F)},actualActivateExtension:async(fe,ye)=>{if(r.$t8b.isHostExtension(fe,this.J,this.L))return await this.C.$activateExtension(fe,ye),new $.$5gc;const F=this.J.getExtensionDescription(fe);return this.db(F,ye)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Z){n.$1(Z)}}async Y(){this.O.onWillDeactivateAll();let Z=[];try{Z=this.J.getAllExtensionDescriptions().map(Le=>Le.identifier).filter(Le=>this.isActivated(Le)).map(Le=>this.cb(Le))}catch{}await Promise.all(Z)}terminate(Z,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ae=>{this.s.error(Ae)}),this.g.dispose();const ne=this.Y();Promise.race([(0,P.$7g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(Z){return this.G.isOpen()?this.P.isActivated(Z):!1}async getExtension(Z){const V=await this.C.$getExtension(Z);return V&&{...V,identifier:new o.$lm(V.identifier.value),extensionLocation:w.URI.revive(V.extensionLocation)}}Z(Z,V){return this.P.activateByEvent(Z,V)}$(Z,V){return this.P.activateById(Z,V)}activateByIdWithErrors(Z,V){return this.$(Z,V).then(()=>{const ne=this.P.getActivatedExtension(Z);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Z=>this.J)}getExtensionExports(Z){if(this.G.isOpen())return this.P.getActivatedExtension(Z).exports;try{return this.P.getActivatedExtension(Z).exports}catch{return null}}async ab(Z){if(Z.scheme===G.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(Z.fsPath);return w.URI.file(V)}return Z}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Z=>new ie(Z))),this.Q}async bb(Z){const V=f.$_h.forUris(ne=>A.$yg.ignorePathCasing(ne));return await Promise.all(Z.map(async ne=>{if(this.ub(ne)){const Ae=await this.ab(ne.extensionLocation);V.set(Ae,ne)}})),V}cb(Z){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Z))return V;const ne=this.P.getActivatedExtension(Z);if(!ne)return V;try{typeof ne.module.deactivate=="function"&&(V=Promise.resolve(ne.module.deactivate()).then(void 0,Ae=>(this.s.error(Ae),Promise.resolve(void 0))))}catch(Ae){this.s.error(`An error occurred when deactivating the extension '${Z.value}':`),this.s.error(Ae)}try{(0,m.$Oc)(ne.subscriptions)}catch(Ae){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Z.value}':`),this.s.error(Ae)}return V}async db(Z,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Z.identifier):await this.C.$onWillActivateExtension(Z.identifier),this.fb(Z,V).then(ne=>{const Ae=ne.activationTimes;return this.C.$onDidActivateExtension(Z.identifier,Ae.codeLoadingTime,Ae.activateCallTime,Ae.activateResolvedTime,V),this.eb(Z,V,"success",Ae),ne},ne=>{throw this.eb(Z,V,"failure"),ne})}eb(Z,V,ne,Ae){const Le=we(Z,V);this.z.$publicLog2("extensionActivationTimes",{...Le,...Ae||{},outcome:ne})}fb(Z,V){const ne=we(Z,V);this.z.$publicLog2("activatePlugin",ne);const Ae=this.ub(Z);if(!Ae)return Promise.resolve(new $.$4gc($.$1gc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Z.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${Z.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Le=new $.$2gc(V.startup);return Promise.all([this.vb(Z,(0,A.$Hg)(Z.extensionLocation,Ae),Le),this.gb(Z)]).then(Ce=>(C.mark(`code/extHost/willActivateExtension/${Z.identifier.value}`),W.hb(this.s,Z.identifier,Ce[0],Ce[1],Le))).then(Ce=>(C.mark(`code/extHost/didActivateExtension/${Z.identifier.value}`),Ce))}gb(Z){const V=new h.$0gc(Z,this.M),ne=new h.$9gc(Z.identifier.value,!1,this.M),Ae=new O.$ehc(Z,this.N),Le=Z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Z.identifier.value}`),Promise.all([V.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ce=this;let te,J;const ee=(0,a.$FF)(Z,"ipc")?this.f.messagePorts?.get(o.$lm.toKey(Z.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ne,secrets:Ae,subscriptions:[],get extensionUri(){return Z.extensionLocation},get extensionPath(){return Z.extensionLocation.fsPath},asAbsolutePath(me){return M.$jc(Z.extensionLocation.fsPath,me)},get storagePath(){return ce.O.workspaceValue(Z)?.fsPath},get globalStoragePath(){return ce.O.globalValue(Z).fsPath},get logPath(){return M.$jc(ce.f.logsLocation.fsPath,Z.identifier.value)},get logUri(){return w.URI.joinPath(ce.f.logsLocation,Z.identifier.value)},get storageUri(){return ce.O.workspaceValue(Z)},get globalStorageUri(){return ce.O.globalValue(Z)},get extensionMode(){return Le},get extension(){return te===void 0&&(te=new ue(ce,Z.identifier,Z,Ce,!1)),te},get extensionRuntime(){return(0,a.$GF)(Z,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(Z)},get messagePassingProtocol(){if(!J){if(!ee)return;const me=E.Event.buffer(E.Event.fromDOMEventEmitter(ee,"message",ve=>ve.data));ee.start(),J={onDidReceiveMessage:me,postMessage:ee.postMessage.bind(ee)}}return J}})})}static hb(Z,V,ne,Ae,Le){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(Z,V,ne,Ae,Le).then(Ce=>new $.$3gc(!1,null,Le.build(),ne,Ce,Ae.subscriptions))}static ib(Z,V,ne,Ae,Le){if(typeof ne.activate=="function")try{Le.activateCallStart(),Z.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Ce=typeof global=="object"?global:self,ce=ne.activate.apply(Ce,[Ae]);return Le.activateCallStop(),Le.activateResolveStart(),Promise.resolve(ce).then(te=>(Le.activateResolveStop(),te))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(ne)}jb(Z,V){this.$(Z.identifier,{startup:!1,extensionId:Z.identifier,activationEvent:V}).then(void 0,ne=>{this.s.error(ne)})}kb(Z,V=0){const Ae=Date.now();(0,I.$B)(()=>{for(let Le=V;Le<Z.length;Le+=1){const Ce=Z[Le];for(const ce of Ce.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-Ae>50){this.kb(Z,Le);break}else this.jb(Ce,ce)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(Z=>{const V=Z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(V)this.kb(ne);else for(const Ae of ne)if(Ae.activationEvents)for(const Le of Ae.activationEvents)Le==="onStartupFinished"&&this.jb(Ae,Le)})}mb(){const Z=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const V=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(V),Ae=this.pb(),Le=Promise.all([Ae,Z,ne]).then(()=>{});return Promise.race([Le,(0,P.$7g)(1e4)]).then(()=>{this.lb()}),Le}nb(Z){return Z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(Z,V))).then(()=>{})}async ob(Z,V){if(this.isActivated(V.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ae={logService:this.s,folders:Z.map(Ce=>Ce.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,ce,te)=>this.y.$checkExists(Ce,ce,te)},Le=await(0,D.$vsb)(Ae,V);if(Le)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Le.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Z){throw console.error(Z),Z}}async qb(){const{extensionDevelopmentLocationURI:Z,extensionTestsLocationURI:V}=this.f.environment;if(!Z||!V)throw new Error(y.localize(0,null));const ne=await this.vb(null,V,new $.$2gc(!1));if(!ne||typeof ne.run!="function")throw new Error(y.localize(1,null,V.toString()));return new Promise((Ae,Le)=>{const Ce=(J,ee)=>{J?(I.$t&&this.s.error("Test runner called back with error",J),Le(J)):(I.$t&&(ee?this.s.info(`Test runner called back with ${ee} failures.`):this.s.info("Test runner called back with successful outcome.")),Ae(typeof ee=="number"&&ee>0?1:0))},ce=(0,A.$vg)(V),te=ne.run(ce,Ce);te&&te.then&&te.then(()=>{I.$t&&this.s.info("Test runner finished successfully."),Ae(0)}).catch(J=>{I.$t&&this.s.error("Test runner finished with error",J),Le(J instanceof Error&&J.stack?J.stack:String(J))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,P.$7g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Z,V){return this.R[Z]=V,(0,m.$Rc)(()=>{delete this.R[Z]})}async getRemoteExecServer(Z){const{resolver:V}=await this.sb(Z);return V?.resolveExecServer?.(Z,{resolveAttempt:0})}async sb(Z){const V=Z.indexOf("+");if(V===-1)throw new i.$fL("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Z.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(Z,V){const ne=U.$Rd.create(!1),Ae=()=>`[resolveAuthority(${(0,u.$_k)(Z)},${V})][${ne.elapsed()}ms] `,Le=K=>this.s.info(`${Ae()}${K}`),Ce=K=>this.s.warn(`${Ae()}${K}`),ce=(K,j=void 0)=>this.s.error(`${Ae()}${K}`,j),te=K=>{if(K instanceof i.$fL)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K},J=async K=>{Le(`activating resolver for ${K}...`);const{resolver:j,authorityPrefix:Y}=await this.sb(K);if(!j)throw ce(`no resolver for ${Y}`),new i.$fL(`No remote extension installed to resolve ${Y}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:j,authorityPrefix:Y,remoteAuthority:K}},ee=Z.split(/@|%40/g).reverse();Le(`activating remote resolvers ${ee.join(" -> ")}`);let me;try{me=await Promise.all(ee.map(J)).catch(async K=>{if(!(K instanceof i.$fL)||K._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw K;return Ce(`resolving nested authorities failed: ${K.message}`),[await J(Z)]})}catch(K){return te(K)}const ve=new P.$eh;ve.cancelAndSet(()=>Le("waiting..."),1e3);let Me,fe;for(const[K,{authorityPrefix:j,resolver:Y,remoteAuthority:_}]of me.entries())try{if(K===me.length-1)Le("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${j}`),Me=await Y.resolve(_,{resolveAttempt:V,execServer:fe}),C.mark(`code/extHost/didResolveAuthorityOK/${j}`),Le("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Y,i.$eL.isManagedResolvedAuthority(Me)?Me:void 0));else{if(Le(`invoking resolveExecServer() for ${_}`),C.mark(`code/extHost/willResolveExecServer/${j}`),fe=await Y.resolveExecServer?.(_,{resolveAttempt:V,execServer:fe}),!fe)throw new i.$fL(`Exec server was not available for ${_}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${j}`)}}catch(Ee){return C.mark(`code/extHost/didResolveAuthorityError/${j}`),ce("returned an error",Ee),ve.dispose(),te(Ee)}ve.dispose();const ye={environmentTunnels:Me.environmentTunnels,features:Me.tunnelFeatures?{elevation:Me.tunnelFeatures.elevation,privacyOptions:Me.tunnelFeatures.privacyOptions,protocol:Me.tunnelFeatures.protocol===void 0?!0:Me.tunnelFeatures.protocol}:void 0},F={extensionHostEnv:Me.extensionHostEnv,isTrusted:Me.isTrusted,authenticationSession:Me.authenticationSessionForInitializingExtensions?{id:Me.authenticationSessionForInitializingExtensions.id,providerId:Me.authenticationSessionForInitializingExtensions.providerId}:void 0};Le(`returned ${i.$eL.isManagedResolvedAuthority(Me)?"managed authority":`${Me.host}:${Me.port}`}`);let H;if(i.$eL.isManagedResolvedAuthority(Me)){const K=V;this.X.setFactory(K,Me.makeConnection),H={authority:Z,connectTo:new u.$9k(K),connectionToken:Me.connectionToken}}else H={authority:Z,connectTo:new u.$0k(Me.host,Me.port),connectionToken:Me.connectionToken};return{type:"ok",value:{authority:H,options:F,tunnelInformation:ye}}}async $getCanonicalURI(Z,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$_k)(Z)})`);const{resolver:ne}=await this.sb(Z);if(!ne)return null;const Ae=w.URI.revive(V);if(typeof ne.getCanonicalURI>"u")return Ae;const Le=await(0,P.$Yg)(()=>ne.getCanonicalURI(Ae));return Le||Ae}$startExtensionHost(Z){Z.toAdd.forEach(Ae=>Ae.extensionLocation=w.URI.revive(Ae.extensionLocation));const{globalRegistry:V,myExtensions:ne}=de(this.I,this.L,this.J,Z);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),I.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(Z,V){return V===1?this.D.wait().then(ne=>this.Z(Z,!1)):this.G.wait().then(ne=>this.Z(Z,!1))}async $activate(Z,V){return await this.G.wait(),this.J.getExtensionDescription(Z)?(await this.$(Z,V),!0):!1}async $deltaExtensions(Z){Z.toAdd.forEach(Ce=>Ce.extensionLocation=w.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:ne}=de(this.I,this.L,this.J,Z),Ae=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ae),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),I.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Z){return Z}async $test_up(Z){return Z.byteLength}async $test_down(Z){const V=c.$je.alloc(Z),ne=Math.random()%256;for(let Ae=0;Ae<Z;Ae++)V.writeUInt8(ne,Ae);return V}async $updateRemoteConnectionData(Z){this.W=Z,this.a.fire()}};e.$khc=ae,e.$khc=ae=W=Je([He(0,t.$5h),He(1,e.$jhc),He(2,d.$bN),He(3,s.$Jgc),He(4,l.$Mgc),He(5,R.$nj),He(6,g.$rN),He(7,p.$Pgc),He(8,L.$vyb),He(9,b.$$gc),He(10,q.$ghc),He(11,N.$hhc)],ae);function de(se,Z,V,ne){se.addActivationEvents(ne.addActivationEvents);const Ae=new r.$t8b(se,Z.getAllExtensionDescriptions());Ae.deltaExtensions(ne.toAdd,ne.toRemove);const Le=new o.$mm(V.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)Le.delete(ce);for(const ce of ne.myToAdd)Le.add(ce);const Ce=pe(Ae,Le);return{globalRegistry:Ae,myExtensions:Ce}}function we(se,Z){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:Z.activationEvent,reasonId:Z.extensionId.value}}function ke(se){return se.getAllExtensionDescriptions().map(Z=>Z.identifier.value).join(",")}e.$lhc=(0,t.$6h)("IExtHostExtensionService");class ue{#e;#t;#i;constructor(Z,V,ne,Ae,Le){this.#e=Z,this.#t=V,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=M.$hc((0,A.$vg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ae,this.isFromDifferentExtensionHost=Le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$mhc=ue;function pe(se,Z){return se.getAllExtensionDescriptions().filter(V=>Z.has(V.identifier))}class ie{constructor(Z){this.a=Z}setSearchTree(Z){this.a=Z}findSubstr(Z){return this.a.findSubstr(Z)}forEach(Z){return this.a.forEach(Z)}}e.$nhc=ie;class be{constructor(Z){this.a=new o.$nm,this.addActivationEvents(Z)}readActivationEvents(Z){return this.a.get(Z.identifier)??[]}addActivationEvents(Z){for(const V of Object.keys(Z))this.a.set(V,Z[V])}}}),define(Pe[287],Re([1,0,88,2,3,37,24,23,17,27,4,38,14,12]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;let s=class{constructor(c,h,i,u,t,g,p){this.c=c,this.d=h,this.e=i,this.f=u,this.g=t,this.h=g,this.i=p,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new r(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(a)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$vic=s,e.$vic=s=Je([He(2,R.$5h),He(3,A.$Mgc),He(4,k.$lhc),He(5,w.$rN),He(6,l.$nj)],s);let a=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&v.a.size){const h=(0,$.$Oe)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",u=`@${i}+\\/${i}+|${i}+`,t="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${t}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,u,t]=h,g=v.a.get(u);if(g!==void 0)return console.warn(`${u} as been renamed to ${g}, please update your imports`),i+g+t}c(c){return c.replace(/\\/g,"/")}};a=v=Je([He(0,w.$rN)],a);class r{constructor(c,h,i,u,t){this.c=c,this.d=h,this.e=i,this.f=u,this.g=t,this.nodeModuleName="vscode",this.a=new m.$nm}load(c,h){const i=this.d.findSubstr(h);if(i){let u=this.a.get(i.identifier);return u||(u=this.c(i,this.e,this.f),this.a.set(i.identifier,u)),u}if(!this.b){let u="";this.d.forEach((t,g)=>u+=`	${g} -> ${t.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${u}`),this.b=this.c(P.$AF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(C.$0K.MainThreadTelemetry);const u=i.getProxy(C.$0K.MainThreadWindow);this.c=(t,g)=>{const p=M.URI.parse(t);return g?this.g(t,g):p.scheme==="http"||p.scheme==="https"?u.$openUri(p,t,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this.f?u.$openUri(p,t,{}):this.g(t,g)}}load(c,h,i){const u=this.e.findSubstr(h);return u&&(this.a=u.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([He(2,f.$bN)],n)}),define(Pe[116],Re([1,0,39,6,19,74,4,66,64,38,7,36,213,37]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=e.$ohc=void 0,e.$ohc=(0,P.$6h)("IExtHostVariableResolverProvider");class v extends l.$cO{constructor(r,n,o,c,h,i,u){function t(){if(o){const g=o.activeEditor();if(g)return g.document.uri;const p=c.tabGroups.all.find(d=>d.isActive)?.activeTab;if(p!==void 0){if(p.input instanceof R.$SM||p.input instanceof R.$XM)return p.input.modified;if(p.input instanceof R.$RM||p.input instanceof R.$WM||p.input instanceof R.$UM)return p.input.uri}}}super({getFolderUri:g=>{const p=i.folders.filter(d=>d.name===g);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(g,p)=>h.getConfiguration(void 0,g).get(p),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const g=t();if(g)return C.$hc(g.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const g=t();if(g){const p=n.getWorkspaceFolder(g);if(p)return C.$hc(p.uri.fsPath)}}},getSelectedText:()=>{if(o){const g=o.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(o){const g=o.activeEditor();if(g)return String(g.selection.end.line+1)}},getExtension:g=>r.getExtension(g)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(A.env))}}let s=class extends M.$Tc{constructor(r,n,o,c,h){super(),this.b=r,this.c=n,this.g=o,this.h=c,this.j=h,this.a=new y.$V(async()=>{const i=await this.h.getConfigProvider(),t={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async g=>{t.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,i,t,this.m())})}getResolver(){return this.a.value}m(){}};e.$phc=s,e.$phc=s=Je([He(0,w.$lhc),He(1,k.$Jgc),He(2,m.$mN),He(3,$.$Mgc),He(4,f.$Ygc)],s)}),define(Pe[117],Re([1,0,13,5,2,4,3,64,38,17,7,36,206,208,37,116]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=e.$thc=e.$shc=e.$rhc=e.$qhc=void 0,e.$qhc=(0,A.$6h)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(u,t,g,p,d,S){this.E=t,this.F=g,this.G=p,this.H=d,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Vd,this.n=new M.$Vd,this.o=new M.$Vd,this.u=new M.$Vd,this.k=u.getProxy(P.$0K.MainThreadDebugService),this.y=new M.$Vd,this.A=new M.$Vd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(b=>{this.J(L)}),this.J(L)})}asDebugSourceUri(u,t){const g=u;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let p=`debug:${encodeURIComponent(g.path||"")}`,d="?";return t&&(p+=`${d}session=${encodeURIComponent(t.id)}`,d="&"),p+=`${d}ref=${g.sourceReference}`,C.URI.parse(p)}else{if(g.path)return C.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(u){const t=[];for(const g of u.getAllExtensionDescriptions())if(g.contributes){const p=g.contributes.debuggers;if(p&&p.length>0)for(const d of p)(0,$.$bG)(d)&&t.push(d.type)}this.k.$registerDebugTypes(t)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const u=[];return this.w.forEach(t=>u.push(t)),u}addBreakpoints(u){const t=u.filter(d=>{const S=d.id;return this.w.has(S)?!1:(this.w.set(S,d),!0)});this.U(t,[],[]);const g=[],p=new Map;for(const d of t)if(d instanceof R.$_L){let S=p.get(d.location.uri.toString());S||(S={type:"sourceMulti",uri:d.location.uri,lines:[]},p.set(d.location.uri.toString(),S),g.push(S)),S.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof R.$aM&&g.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(g)}removeBreakpoints(u){const t=u.filter(S=>this.w.delete(S.id));this.U([],t,[]);const g=t.filter(S=>S instanceof R.$_L).map(S=>S.id),p=t.filter(S=>S instanceof R.$aM).map(S=>S.id),d=t.filter(S=>S instanceof R.$bM).map(S=>S.id);return this.k.$unregisterBreakpoints(g,p,d)}startDebugging(u,t,g){return this.k.$startDebugging(u?u.uri:void 0,t,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(u){return this.k.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,t,g){if(!t)return new R.$_K(()=>{});const p=this.d++;return this.f.push({type:u,handle:p,provider:t}),this.k.$registerDebugConfigurationProvider(u,g,!!t.provideDebugConfigurations,!!t.resolveDebugConfiguration,!!t.resolveDebugConfigurationWithSubstitutedVariables,p),new R.$_K(()=>{this.f=this.f.filter(d=>d.provider!==t),this.k.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(u,t,g){if(!g)return new R.$_K(()=>{});if(!this.Q(u,t))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${t}' debugger.`);if(this.N(t))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this.g++;return this.h.push({type:t,handle:p,factory:g}),this.k.$registerDebugAdapterDescriptorFactory(t,p),new R.$_K(()=>{this.h=this.h.filter(d=>d.factory!==g),this.k.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(u,t){if(!t)return new R.$_K(()=>{});const g=this.i++;return this.j.push({type:u,handle:g,factory:t}),new R.$_K(()=>{this.j=this.j.filter(p=>p.factory!==t)})}async $runInTerminal(u,t){return Promise.resolve(void 0)}async $substituteVariables(u,t){let g;const p=await this.W(u);return p&&(g={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(g,t)}K(u,t){if(u.type==="implementation")return new c(u.implementation)}L(){}async $startDASession(u,t){const g=this,p=await this.V(t);return this.S(this.N(p.type),p).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const S=this.M(d),L=this.K(S,p);if(!L)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const b=L;return this.B.set(u,b),this.R(p).then(E=>(E&&this.C.set(u,E),b.onMessage(async D=>{if(D.type==="request"&&D.command==="handshake"){const T=D,O={type:"response",seq:0,command:T.command,request_seq:T.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const G=await this.D.sign(T.arguments.value);O.body={signature:G},b.sendResponse(O)}else throw new Error("no signer")}catch(G){O.success=!1,O.message=G.message,b.sendResponse(O)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(D),D=(0,$.$gG)(D,!0),g.k.$acceptDAMessage(u,D)}),b.onError(D=>{E&&E.onError&&E.onError(D),this.k.$acceptDAError(u,D.name,D.message,D.stack)}),b.onExit(D=>{E&&E.onExit&&E.onExit(D??void 0,void 0),this.k.$acceptDAExit(u,D??void 0,void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),b.startSession()))})}$sendDAMessage(u,t){t=(0,$.$fG)(t,!1);const g=this.C.get(u);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(t),this.B.get(u)?.sendMessage(t)}$stopDASession(u){const t=this.C.get(u);this.C.delete(u),t&&t.onWillStopSession&&t.onWillStopSession();const g=this.B.get(u);return this.B.delete(u),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const t=[],g=[],p=[];if(u.added)for(const d of u.added){const S=d.id;if(S&&!this.w.has(S)){let L;if(d.type==="function")L=new R.$aM(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")L=new R.$bM(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const b=C.URI.revive(d.uri);L=new R.$_L(new R.$lL(b,new R.$aL(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,R.$0L)(L,S),this.w.set(S,L),t.push(L)}}if(u.removed)for(const d of u.removed){const S=this.w.get(d);S&&(this.w.delete(d),g.push(S))}if(u.changed){for(const d of u.changed)if(d.id){const S=this.w.get(d.id);if(S){if(S instanceof R.$aM&&d.type==="function"){const L=S;L.enabled=d.enabled,L.condition=d.condition,L.hitCondition=d.hitCondition,L.logMessage=d.logMessage,L.functionName=d.functionName}else if(S instanceof R.$_L&&d.type==="source"){const L=S;L.enabled=d.enabled,L.condition=d.condition,L.hitCondition=d.hitCondition,L.logMessage=d.logMessage,L.location=new R.$lL(C.URI.revive(d.uri),new R.$aL(d.line,d.character))}p.push(S)}}}this.U(t,g,p)}async $acceptStackFrameFocus(u){let t;const g=u.sessionId?await this.V(u.sessionId):void 0;if(!g)throw new Error("no DebugSession found for debug focus context");u.kind==="thread"?t=new R.$hM(g,u.threadId):t=new R.$gM(g,u.threadId,u.frameId),this.z=t,this.A.fire(this.z)}$provideDebugConfigurations(u,t,g){return(0,y.$Yg)(async()=>{const p=this.P(u);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(t);return p.provideDebugConfigurations(d,g)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(u,t,g,p){return(0,y.$Yg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(t);return d.resolveDebugConfiguration(S,g,p)})}$resolveDebugConfigurationWithSubstitutedVariables(u,t,g,p){return(0,y.$Yg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(t);return d.resolveDebugConfigurationWithSubstitutedVariables(S,g,p)})}async $provideDebugAdapter(u,t){const g=this.O(u);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.V(t);return this.S(g,p).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(u){const t=await this.V(u);this.m.fire(t)}async $acceptDebugSessionTerminated(u){const t=await this.V(u);t&&(this.n.fire(t),this.l.delete(t.id))}async $acceptDebugSessionActiveChanged(u){this.q=u?await this.V(u):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(u,t){(await this.V(u))?._acceptNameChanged(t)}async $acceptDebugSessionCustomEvent(u,t){const p={session:await this.V(u),event:t.event,body:t.body};this.u.fire(p)}M(u){if(u instanceof R.$cM)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof R.$dM)return{type:"server",port:u.port,host:u.host};if(u instanceof R.$eM)return{type:"pipeServer",path:u.path};if(u instanceof R.$fM)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}N(u){const t=this.h.filter(g=>g.type===u);if(t.length>0)return t[0].factory}O(u){const t=this.h.filter(g=>g.handle===u);if(t.length>0)return t[0].factory}P(u){const t=this.f.filter(g=>g.handle===u);if(t.length>0)return t[0].provider}Q(u,t){if(u.contributes){const g=u.contributes.debuggers;if(g&&g.length>0){for(const p of g)if(p.label&&p.type&&p.type===t)return!0}}return!1}R(u){const g=u.configuration.type,p=this.j.filter(d=>d.type===g||d.type==="*").map(d=>(0,y.$Yg)(()=>d.factory.createDebugAdapterTracker(u)).then(S=>S,S=>null));return Promise.race([Promise.all(p).then(d=>{const S=d.filter(L=>!!L);if(S.length>0)return new o(S)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(u,t){const g=t.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new R.$dM(g));if(u){const d=await this.F.getExtensionRegistry();return(0,y.$Yg)(()=>u.createDebugAdapterDescriptor(t,this.T(t,d))).then(S=>{if(S)return S})}const p=await this.F.getExtensionRegistry();return Promise.resolve(this.T(t,p))}T(u,t){}U(u,t,g){(u.length>0||t.length>0||g.length>0)&&this.y.fire(Object.freeze({added:u,removed:t,changed:g}))}async V(u){if(u)if(typeof u=="string"){const t=this.l.get(u);if(t)return t}else{let t=this.l.get(u.id);if(!t){const g=await this.W(u.folderUri),p=u.parent?this.l.get(u.parent):void 0;t=new r(this.k,u.id,u.type,u.name,g,u.configuration,p),this.l.set(t.id,t),this.k.$sessionCached(t.id)}return t}throw new Error("cannot find session")}W(u){if(u){const t=C.URI.revive(u);return this.E.resolveWorkspaceFolder(t)}return Promise.resolve(void 0)}};e.$rhc=a,e.$rhc=a=Je([He(0,w.$bN),He(1,k.$Jgc),He(2,f.$lhc),He(3,v.$Mgc),He(4,m.$Ygc),He(5,s.$ohc)],a);class r{constructor(u,t,g,p,d,S,L){this.d=u,this.f=t,this.g=g,this.h=p,this.i=d,this.j=S,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(u){this.h=u,this.d.$setDebugSessionName(this.f,u)}get parentSession(){return this.k}_acceptNameChanged(u){this.h=u}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(u,t){return this.d.$customDebugAdapterRequest(this.f,u,t)}getDebugProtocolBreakpoint(u){return this.d.$getDebugProtocolBreakpoint(this.f,u.id)}}e.$shc=r;class n{constructor(u){this.value=Object.freeze({append(t){u.$appendDebugConsole(t)},appendLine(t){this.append(t+`
`)}})}}e.$thc=n;class o{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(t=>t.onWillReceiveMessage?t.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(t=>t.onDidSendMessage?t.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(t=>t.onError?t.onError(u):void 0)}onExit(u,t){this.d.forEach(g=>g.onExit?g.onExit(u,t):void 0)}}class c extends l.$Nlb{constructor(u){super(),this.h=u,u.onDidSendMessage(t=>{this.acceptMessage(t)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends a{constructor(u,t,g,p,d,S){super(u,t,g,p,d,S)}};e.$uhc=h,e.$uhc=h=Je([He(0,w.$bN),He(1,k.$Jgc),He(2,f.$lhc),He(3,v.$Mgc),He(4,m.$Ygc),He(5,s.$ohc)],h)}),define(Pe[288],Re([1,0,15,88,2,3,233,14,53,71,27,184,17,58,38,60]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=e.$wic=void 0;class a{static async installEarlyHandler(o){Error.stackTraceLimit=100;const c=o.get(m.$nj),i=o.get(l.$bN).getProxy(A.$0K.MainThreadErrors);y.setUnexpectedErrorHandler(u=>{c.error(u);const t=y.$3(u);i.$onUnexpectedError(t)})}static async installFullHandler(o){const c=o.get(m.$nj),h=o.get(l.$bN),i=o.get(v.$lhc),u=o.get(s.$vN),t=h.getProxy(A.$0K.MainThreadExtensionService),g=h.getProxy(A.$0K.MainThreadErrors),p=await i.getExtensionPathIndex(),d=new WeakMap;function S(E,D){if(d.has(E))return d.get(E).stack;let T="",O,G;for(const U of D)T+=`
	at ${U.toString()}`,G=U.getFileName(),!O&&G&&(O=p.findSubstr(C.URI.file(G)));const q=`${E.name||"Error"}: ${E.message||""}${T}`;return d.set(E,{extensionIdentifier:O?.identifier,stack:q}),q}const L=Symbol("prepareStackTrace wrapped");let b=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(E){if(E===S||!E||E[L]){b=E||S;return}b=function(D,T){return S(D,T),E.call(Error,D,T)},Object.assign(b,{[L]:!0})}}),y.setUnexpectedErrorHandler(E=>{c.error(E);const D=y.$3(E),T=d.get(E);if(!T?.extensionIdentifier){g.$onUnexpectedError(D);return}t.$onExtensionRuntimeError(T.extensionIdentifier,D);const O=u.onExtensionError(T.extensionIdentifier,E);c.trace("forwarded error to extension?",O,T)})}}e.$wic=a;class r{constructor(o,c,h,i,u){this.a=h,this.b=new P.$B8b(o,null,i),c=r.e(c,this.b);const t=new w.$4h(...(0,f.$Zr)());t.set(R.$rN,{_serviceBrand:void 0,...c,messagePorts:u}),t.set(l.$bN,new l.$cN(this.b)),t.set($.$Ggc,new $.$Hgc(i)),t.set(v.$jhc,h);const g=new k.$Eq(t,!0);g.invokeFunction(a.installEarlyHandler),this.d=g.invokeFunction(p=>p.get(m.$nj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=g.invokeFunction(p=>p.get(v.$lhc)),this.c.initialize(),g.invokeFunction(a.installFullHandler)}async asBrowserUri(o){const c=this.b.getProxy(A.$0K.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,c){o.extensions.allExtensions.forEach(i=>{i.extensionLocation=C.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),o.environment.appRoot=C.URI.revive(c.transformIncomingURIs(o.environment.appRoot));const h=o.environment.extensionDevelopmentLocationURI;return h&&(o.environment.extensionDevelopmentLocationURI=h.map(i=>C.URI.revive(c.transformIncomingURIs(i)))),o.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=C.URI.revive(c.transformIncomingURIs(o.logsLocation)),o.workspace=c.transformIncomingURIs(o.workspace),o}}e.$xic=r}),define(Pe[289],Re([1,0,18,13,20,40,11,19,25,2,43]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=e.$Khc=e.$Jhc=e.$Ihc=void 0;class k{constructor(n,o,c,h){this.d=n,this.e=o,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,o){const c=this.d.folderQueries||[],h=new C.$6d(o);return new Promise((i,u)=>{this.a=new $(n);let t=!1;const g=(p,d)=>{if(!t&&!this.b){const S=this.h(p);s(p)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,t=!0,h.cancel(),p=this.j(p,this.d.maxResults-this.c));const L=this.h(p);this.c+=L,(L>0||!s(p))&&this.a.add(p,d)}};Promise.all(c.map((p,d)=>this.k(p,S=>g(S,d),h.token))).then(p=>{h.dispose(),this.a.flush();const d=p.some(S=>!!S&&!!S.limitHit);i({limitHit:this.b||d,messages:(0,y.$Rb)(p.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},p=>{h.dispose();const d=(0,A.$Qi)(p);u(new Error(d))})})}h(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,o){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,o),preview:{matches:h.slice(0,o),text:n.preview.text},uri:n.uri}}async k(n,o,c){const h=new R.$NJ(this.d,n),i=[],u={report:p=>{if(!this.l(p))return;const d=n.folder.scheme===P.Schemas.file?(0,R.$OJ)(()=>this.f.readdir(f.$Gg(p.uri))):void 0,S=f.$Jg(n.folder,p.uri);if(S){const L=h.includedInQuery(S,m.$nc(S),d);(0,M.$Sg)(L)?i.push(L.then(b=>{b&&o(p)})):L&&o(p)}}},t=this.n(n),g=await this.e.provideTextSearchResults(l(this.d.contentPattern),t,u,c);return i.length&&await Promise.all(i),g}l(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const o=(0,R.$MJ)(this.d.includePattern,n.includePattern),c=(0,R.$MJ)(this.d.excludePattern,n.excludePattern),h={folder:w.URI.from(n.folder),excludes:c,includes:o,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$Ihc=k;function l(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class ${constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new a(512,o=>this.g(o))}add(n,o){this.d&&(this.b!==o||!f.$Ag(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Jhc=$;function v(r){return s(r)?{preview:{matches:(0,y.$2b)(r.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:r.preview.text},ranges:(0,y.$2b)(r.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function s(r){return!!r.preview}e.$Khc=s;class a{static{this.a=4e3}static{this.b=50}constructor(n,o){this.g=n,this.h=o,this.c=0,this.d=[],this.e=0}addItem(n,o){n&&this.j(n,o)}addItems(n,o){n&&this.k(n,o)}j(n,o){this.d.push(n),this.e+=o,this.l()}k(n,o){this.d=this.d.concat(n),this.e+=o,this.l()}l(){this.c<a.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},a.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Lhc=a}),define(Pe[118],Re([1,0,6,3,4,284,17,58,14,2,289]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=e.$Nhc=e.$Mhc=void 0,e.$Mhc=(0,C.$6h)("IExtHostSearch");let k=class{constructor(s,a,r){this.k=s,this.l=a,this.n=r,this.c=this.k.getProxy(M.$0K.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.$Hhc}o(s){return this.l.transformOutgoingScheme(s)}registerTextSearchProvider(s,a){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const r=this.d++;return this.e.set(r,a),this.c.$registerTextSearchProvider(r,this.o(s)),(0,y.$Rc)(()=>{this.g.delete(s),this.e.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(s,a){if(this.i.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.i.add(s);const r=this.d++;return this.h.set(r,a),this.c.$registerFileSearchProvider(r,this.o(s)),(0,y.$Rc)(()=>{this.i.delete(s),this.h.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(s,a,r,n){const o=l(r),c=this.h.get(s);if(c)return this.j.fileSearch(o,c,h=>{this.c.$handleFileMatch(s,a,h.map(i=>i.resource))},n);throw new Error("unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,a,r){return{messages:[]}}$clearCache(s){return this.j.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,a,r,n){const o=this.e.get(s);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const c=l(r);return this.q(c,o).search(i=>this.c.$handleTextMatch(s,a,i),n)}$enableExtensionHostSearch(){}q(s,a){return new R.$Ihc(s,a,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.$Nhc=k,e.$Nhc=k=Je([He(0,P.$bN),He(1,m.$Ggc),He(2,f.$nj)],k);function l(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map($),extraFileResources:v.extraFileResources&&v.extraFileResources.map(s=>w.URI.revive(s))}}e.$Ohc=l;function $(v){return{...v,folder:w.URI.revive(v.folder)}}}),define(Pe[290],Re([1,0,20,15,5,6,11,31,2,146,142,130,93,23,41,14,56,57,197,3,236,268,79,237,243,244,245,246,247,222,211,32,248,37,249,117,107,250,224,238,251,252,66,64,239,38,254,62,255,42,27,269,270,240,225,256,257,80,81,227,283,259,201,260,271,261,112,228,262,263,264,17,265,118,82,266,229,267,83,85,115,60,65,272,273,241,274,275,86,8,7,230,58,231,61,276,277,106,36,207,78,24,114]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n,o,c,h,i,u,t,g,p,d,S,L,b,E,D,T,O,G,q,U,I,N,W,ae,de,we,ke,ue,pe,ie,be,se,Z,V,ne,Ae,Le,Ce,ce,te,J,ee,me,ve,Me,fe,ye,F,H,K,j,Y,_,Ee,Ne,Ve,Ke,Xe,nt,it,et,at,ct,je,mt,X,x,$e,Be,Qe,tt,rt,Te,zt,At,Gt,Ft,yt,qt,Tt,Xt,Vt,Ut,Ze,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=void 0;function Jt(lt){const $t=lt.get(Z.$rN),jt=lt.get(se.$ogc),Qt=lt.get(ie.$Ogc),Et=lt.get(ue.$lhc),dt=lt.get(Xt.$Jgc),St=lt.get(je.$vN),_t=lt.get(T.$Mgc),Ct=lt.get(At.$Ggc),qe=lt.get(Ee.$bN),Lt=lt.get(et.$8gc),Nt=lt.get(at.$Pgc),Yt=lt.get(s.$oj),ft=lt.get(s.$nj),Mt=lt.get(tt.$vyb),Pt=lt.get(i.$rgc),Bt=lt.get(Tt.$qic),De=lt.get(Ke.$dhc),Fe=lt.get(we.$Ygc),he=lt.get(J.$hhc);qe.set(o.$$K.ExtHostFileSystemInfo,jt),qe.set(o.$$K.ExtHostLogLevelServiceShape,Yt),qe.set(o.$$K.ExtHostWorkspace,dt),qe.set(o.$$K.ExtHostConfiguration,_t),qe.set(o.$$K.ExtHostExtensionService,Et),qe.set(o.$$K.ExtHostStorage,Lt),qe.set(o.$$K.ExtHostTunnelService,Mt),qe.set(o.$$K.ExtHostWindow,Bt),qe.set(o.$$K.ExtHostSecretState,De),qe.set(o.$$K.ExtHostTelemetry,St),qe.set(o.$$K.ExtHostEditorTabs,Fe),qe.set(o.$$K.ExtHostManagedSockets,he);const Q=qe.set(o.$$K.ExtHostDecorations,lt.get(q.$whc)),Ie=qe.set(o.$$K.ExtHostDocumentsAndEditors,lt.get(de.$mN)),Oe=qe.set(o.$$K.ExtHostCommands,lt.get(E.$xN)),Ye=qe.set(o.$$K.ExtHostTerminalService,lt.get(mt.$$gc)),We=qe.set(o.$$K.ExtHostDebugService,lt.get(G.$qhc)),st=qe.set(o.$$K.ExtHostSearch,lt.get(Ve.$Mhc)),wt=qe.set(o.$$K.ExtHostTask,lt.get(ct.$dic)),Kt=qe.set(o.$$K.ExtHostOutputService,lt.get(H.$3hc)),kt=qe.set(o.$$K.ExtHostLocalization,lt.get(te.$ghc)),Dt=qe.set(o.$$K.ExtHostUrls,new Gt.$nic(qe)),vt=qe.set(o.$$K.ExtHostDocuments,new ae.$mgc(qe,Ie)),Si=qe.set(o.$$K.ExtHostDocumentContentProviders,new N.$yhc(qe,Ie,ft)),Gi=qe.set(o.$$K.ExtHostDocumentSaveParticipant,new W.$zhc(ft,vt,qe.getProxy(o.$0K.MainThreadBulkEdits))),It=qe.set(o.$$K.ExtHostNotebook,new me.$Phc(qe,Oe,Ie,vt,Qt,st)),si=qe.set(o.$$K.ExtHostNotebookDocuments,new Me.$Whc(It)),mi=qe.set(o.$$K.ExtHostNotebookEditors,new fe.$Xhc(ft,It)),ui=qe.set(o.$$K.ExtHostNotebookKernels,new ye.$Yhc(qe,$t,It,Oe,ft)),Ii=qe.set(o.$$K.ExtHostNotebookRenderers,new F.$1hc(qe,It)),Ci=qe.set(o.$$K.ExtHostNotebookDocumentSaveParticipant,new ve.$Vhc(ft,It,qe.getProxy(o.$0K.MainThreadBulkEdits))),Ot=qe.set(o.$$K.ExtHostEditors,new x.$Dgc(qe,Ie)),$i=qe.set(o.$$K.ExtHostTreeViews,new Qe.$lic(qe.getProxy(o.$0K.MainThreadTreeViews),Oe,ft)),Pi=qe.set(o.$$K.ExtHostEditorInsets,new b.$Egc(qe.getProxy(o.$0K.MainThreadEditorInsets),Ot,$t.remote)),li=qe.set(o.$$K.ExtHostDiagnostics,new U.$qgc(qe,ft,jt,Ie)),hi=qe.set(o.$$K.ExtHostLanguages,new ce.$Thc(qe,vt,Oe.converter,Ct)),ht=qe.set(o.$$K.ExtHostLanguageFeatures,new Ce.$ugc(qe,Ct,vt,Oe,li,ft,Pt,St)),Ji=qe.set(o.$$K.ExtHostFileSystem,new pe.$Bhc(qe,ht)),ei=qe.set(o.$$K.ExtHostFileSystemEventService,new be.$Chc(qe,ft,Ie)),oi=qe.set(o.$$K.ExtHostQuickOpen,(0,_.$7hc)(qe,dt,Oe)),pi=qe.set(o.$$K.ExtHostSCM,new Ne.$9hc(qe,Oe,vt,ft)),Ri=qe.set(o.$$K.ExtHostQuickDiff,new Y.$6hc(qe,Ct)),Qi=qe.set(o.$$K.ExtHostShare,new Xe.$0hc(qe,Ct)),Ai=qe.set(o.$$K.ExtHostComments,(0,D.$Fgc)(qe,Oe,vt)),vi=qe.set(o.$$K.ExtHostProgress,new j.$5hc(qe.getProxy(o.$0K.MainThreadProgress))),Yi=qe.set(o.$$K.ExtHostLabelService,new Le.$Shc(qe)),Li=qe.set(o.$$K.ExtHostTheming,new $e.$iic(qe)),di=qe.set(o.$$K.ExtHostAuthentication,new u.$wgc(qe)),Xi=qe.set(o.$$K.ExtHostTimeline,new Be.$kic(qe,Oe)),bi=qe.set(o.$$K.ExtHostWebviews,new Ft.$Tgc(qe,$t.remote,dt,ft,Pt)),Mi=qe.set(o.$$K.ExtHostWebviewPanels,new yt.$Wgc(qe,bi,dt)),un=qe.set(o.$$K.ExtHostCustomEditors,new O.$Xgc(qe,vt,Nt,bi,Mi)),Fi=qe.set(o.$$K.ExtHostWebviewViews,new qt.$oic(qe,bi)),ai=qe.set(o.$$K.ExtHostTesting,new X.$eic(qe,ft,Oe,Ie)),ln=qe.set(o.$$K.ExtHostUriOpeners,new zt.$mic(qe)),hn=qe.set(o.$$K.ExtHostProfileContentHandlers,new K.$4hc(qe));qe.set(o.$$K.ExtHostInteractive,new ne.$Qhc(qe,It,Ie,Oe,ft));const Zi=qe.set(o.$$K.ExtHostInlineChat,new V.$Dhc(qe,Oe,vt,ft)),fi=qe.set(o.$$K.ExtHostChatProvider,new d.$zgc(qe,ft)),xi=qe.set(o.$$K.ExtHostChatAgents2,new p.$Agc(qe,fi,ft)),_i=qe.set(o.$$K.ExtHostChatVariables,new S.$Bgc(qe)),wi=qe.set(o.$$K.ExtHostChat,new g.$ygc(qe)),en=qe.set(o.$$K.ExtHostAiRelatedInformation,new c.$lgc(qe)),Ti=qe.set(o.$$K.ExtHostAiEmbeddingVector,new ke.$Ahc(qe)),Ni=qe.set(o.$$K.ExtHostIssueReporter,new Ae.$Rhc(qe)),ti=qe.set(o.$$K.ExtHostStatusBar,new it.$aic(qe,Oe.converter)),yi=qe.set(o.$$K.ExtHostSpeech,new nt.$$hc(qe)),dn=Object.values(o.$$K);qe.assertRegistered(dn);const Zt=new t.$xgc(qe,Ie),Ei=new L.$Cgc(qe),ki=new ee.$Uhc(qe,ft),Oi=new I.$xhc(qe);return h.$vgc.register(Oe),function(Ue,ii,tn){function _e(re){return(le,ze,ot)=>{const bt=re(Rt=>{try{le.call(ze,Rt)}catch(cn){M.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event`,{cause:cn})),St.onExtensionError(Ue.identifier,cn)}});return ot?.push(bt),bt}}const pt=function(){let re=!Ue.isUnderDevelopment;function le(){re||(ft.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function ze(ot){if(Array.isArray(ot))ot.forEach(ze);else if(typeof ot=="string")le();else{const bt=ot;typeof bt.scheme>"u"&&le(),typeof bt.exclusive=="boolean"&&(0,Ze.$GF)(Ue,"documentFiltersExclusive")}return ot}}(),fn={getSession(re,le,ze){return di.getSession(Ue,re,le,ze)},getSessions(re,le){return(0,Ze.$GF)(Ue,"authGetSessions"),di.getSessions(Ue,re,le)},async hasSession(re,le){return(0,Ze.$GF)(Ue,"authSession"),!!await di.getSession(Ue,re,le,{silent:!0})},get onDidChangeSessions(){return _e(di.onDidChangeSessions)},registerAuthenticationProvider(re,le,ze,ot){return di.registerAuthenticationProvider(re,le,ze,ot)}},gn={registerCommand(re,le,ze){return Oe.registerCommand(!0,re,le,ze,void 0,Ue)},registerTextEditorCommand(re,le,ze){return Oe.registerCommand(!0,re,(...ot)=>{const bt=Ot.getActiveTextEditor();if(!bt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return bt.edit(Rt=>{le.apply(ze,[bt,Rt,...ot])}).then(Rt=>{Rt||ft.warn("Edits from command "+re+" were not applied.")},Rt=>{ft.warn("An error occurred while running command "+re,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(re,le,ze)=>((0,Ze.$GF)(Ue,"diffCommand"),Oe.registerCommand(!0,re,async(...ot)=>{const bt=Ie.activeEditor(!0);if(!bt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Rt=await Ot.getDiffInformation(bt.id);le.apply(ze,[Rt,...ot])},void 0,void 0,Ue)),executeCommand(re,...le){return Oe.executeCommand(re,...le)},getCommands(re=!1){return Oe.getCommands(re)}},zi={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return Ye.getDefaultShell(!1)},get onDidChangeShell(){return _e(Ye.onDidChangeShell)},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return _e(St.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$GF)(Ue,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$GF)(Ue,"telemetry"),_e(St.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,je.$uN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,le){return je.$tN.validateSender(re),St.instantiateLogger(Ue,re,le)},openExternal(re,le){return Bt.openUri(re,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===$t.environment.appUriScheme)return Dt.createAppUri(re);try{return await Bt.asExternalUri(re,{allowTunneling:!!$t.remote.authority})}catch(le){if((0,P.$eg)(re,P.Schemas.http)||(0,P.$eg)(re,P.Schemas.https))return re;throw le}},get remoteName(){return(0,a.$bl)($t.remote.authority)},get remoteAuthority(){return(0,Ze.$GF)(Ue,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return _e(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(re){return(0,Ze.$GF)(Ue,"handleIssueUri"),Ni.registerIssueUriRequestHandler(Ue,re)},registerIssueDataProvider(re){return(0,Ze.$GF)(Ue,"handleIssueUri"),Ni.registerIssueDataProvider(Ue,re)},get appQuality(){return(0,Ze.$GF)(Ue,"resolvers"),$t.quality},get appCommit(){return(0,Ze.$GF)(Ue,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(zi);const Ui={createTestController(re,le,ze){return ai.createTestController(Ue,re,le,ze)},createTestObserver(){return(0,Ze.$GF)(Ue,"testObserver"),ai.createTestObserver()},runTests(re){return(0,Ze.$GF)(Ue,"testObserver"),ai.runTests(re)},get onDidChangeTestResults(){return(0,Ze.$GF)(Ue,"testObserver"),_e(ai.onResultsChanged)},get testResults(){return(0,Ze.$GF)(Ue,"testObserver"),ai.results}},gi=$t.remote.isRemote?Te.ExtensionKind.Workspace:Te.ExtensionKind.UI,nn={getExtension(re,le){(0,Ze.$FF)(Ue,"extensionsAny")||(le=!1);const ze=ii.mine.getExtensionDescription(re);if(ze)return new ue.$mhc(Et,Ue.identifier,ze,gi,!1);if(le){const ot=ii.all.getExtensionDescription(re);if(ot)return new ue.$mhc(Et,Ue.identifier,ot,gi,!0)}},get all(){const re=[];for(const le of ii.mine.getAllExtensionDescriptions())re.push(new ue.$mhc(Et,Ue.identifier,le,gi,!1));return re},get allAcrossExtensionHosts(){(0,Ze.$GF)(Ue,"extensionsAny");const re=new $.$mm(ii.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),le=[];for(const ze of ii.all.getAllExtensionDescriptions()){const ot=!re.has(ze.identifier);le.push(new ue.$mhc(Et,Ue.identifier,ze,gi,ot))}return le},get onDidChange(){return(0,Ze.$FF)(Ue,"extensionsAny")?_e(C.Event.any(ii.mine.onDidChange,ii.all.onDidChange)):_e(ii.mine.onDidChange)}},rn={createDiagnosticCollection(re){return li.createDiagnosticCollection(Ue.identifier,re)},get onDidChangeDiagnostics(){return _e(li.onDidChangeDiagnostics)},getDiagnostics:re=>li.getDiagnostics(re),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(re,le){return hi.changeLanguage(re.uri,le)},match(re,le){const ze=vt.getDocumentData(le.uri)?.notebook;return(0,R.$Bt)(rt.LanguageSelector.from(re),le.uri,le.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(re,le,ze){return ht.registerCodeActionProvider(Ue,pt(re),le,ze)},registerDocumentPasteEditProvider(re,le,ze){return(0,Ze.$GF)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,pt(re),le,ze)},registerCodeLensProvider(re,le){return ht.registerCodeLensProvider(Ue,pt(re),le)},registerDefinitionProvider(re,le){return ht.registerDefinitionProvider(Ue,pt(re),le)},registerDeclarationProvider(re,le){return ht.registerDeclarationProvider(Ue,pt(re),le)},registerImplementationProvider(re,le){return ht.registerImplementationProvider(Ue,pt(re),le)},registerTypeDefinitionProvider(re,le){return ht.registerTypeDefinitionProvider(Ue,pt(re),le)},registerHoverProvider(re,le){return ht.registerHoverProvider(Ue,pt(re),le,Ue.identifier)},registerEvaluatableExpressionProvider(re,le){return ht.registerEvaluatableExpressionProvider(Ue,pt(re),le,Ue.identifier)},registerInlineValuesProvider(re,le){return ht.registerInlineValuesProvider(Ue,pt(re),le,Ue.identifier)},registerDocumentHighlightProvider(re,le){return ht.registerDocumentHighlightProvider(Ue,pt(re),le)},registerMultiDocumentHighlightProvider(re,le){return ht.registerMultiDocumentHighlightProvider(Ue,pt(re),le)},registerLinkedEditingRangeProvider(re,le){return ht.registerLinkedEditingRangeProvider(Ue,pt(re),le)},registerReferenceProvider(re,le){return ht.registerReferenceProvider(Ue,pt(re),le)},registerRenameProvider(re,le){return ht.registerRenameProvider(Ue,pt(re),le)},registerDocumentSymbolProvider(re,le,ze){return ht.registerDocumentSymbolProvider(Ue,pt(re),le,ze)},registerWorkspaceSymbolProvider(re){return ht.registerWorkspaceSymbolProvider(Ue,re)},registerDocumentFormattingEditProvider(re,le){return ht.registerDocumentFormattingEditProvider(Ue,pt(re),le)},registerDocumentRangeFormattingEditProvider(re,le){return ht.registerDocumentRangeFormattingEditProvider(Ue,pt(re),le)},registerOnTypeFormattingEditProvider(re,le,ze,...ot){return ht.registerOnTypeFormattingEditProvider(Ue,pt(re),le,[ze].concat(ot))},registerDocumentSemanticTokensProvider(re,le,ze){return ht.registerDocumentSemanticTokensProvider(Ue,pt(re),le,ze)},registerDocumentRangeSemanticTokensProvider(re,le,ze){return ht.registerDocumentRangeSemanticTokensProvider(Ue,pt(re),le,ze)},registerSignatureHelpProvider(re,le,ze,...ot){return typeof ze=="object"?ht.registerSignatureHelpProvider(Ue,pt(re),le,ze):ht.registerSignatureHelpProvider(Ue,pt(re),le,typeof ze>"u"?[]:[ze,...ot])},registerCompletionItemProvider(re,le,...ze){return ht.registerCompletionItemProvider(Ue,pt(re),le,ze)},registerInlineCompletionItemProvider(re,le,ze){return le.handleDidShowCompletionItem&&(0,Ze.$GF)(Ue,"inlineCompletionsAdditions"),le.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$GF)(Ue,"inlineCompletionsAdditions"),ze&&(0,Ze.$GF)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,pt(re),le,ze)},registerDocumentLinkProvider(re,le){return ht.registerDocumentLinkProvider(Ue,pt(re),le)},registerColorProvider(re,le){return ht.registerColorProvider(Ue,pt(re),le)},registerFoldingRangeProvider(re,le){return ht.registerFoldingRangeProvider(Ue,pt(re),le)},registerSelectionRangeProvider(re,le){return ht.registerSelectionRangeProvider(Ue,re,le)},registerCallHierarchyProvider(re,le){return ht.registerCallHierarchyProvider(Ue,re,le)},registerTypeHierarchyProvider(re,le){return ht.registerTypeHierarchyProvider(Ue,re,le)},setLanguageConfiguration:(re,le)=>ht.setLanguageConfiguration(Ue,re,le),getTokenInformationAtPosition(re,le){return(0,Ze.$GF)(Ue,"tokenInformation"),hi.tokenAtPosition(re,le)},registerInlayHintsProvider(re,le){return ht.registerInlayHintsProvider(Ue,re,le)},createLanguageStatusItem(re,le){return hi.createLanguageStatusItem(Ue,re,le)},registerDocumentDropEditProvider(re,le,ze){return ht.registerDocumentOnDropEditProvider(Ue,re,le,(0,Ze.$FF)(Ue,"dropMetadata")?ze:void 0)}},mn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return Ye.activeTerminal},get terminals(){return Ye.terminals},async showTextDocument(re,le,ze){const ot=await(f.URI.isUri(re)?Promise.resolve(sn.openTextDocument(re)):Promise.resolve(re));return Ot.showTextDocument(ot,le,ze)},createTextEditorDecorationType(re){return Ot.createTextEditorDecorationType(Ue,re)},onDidChangeActiveTextEditor(re,le,ze){return _e(Ot.onDidChangeActiveTextEditor)(re,le,ze)},onDidChangeVisibleTextEditors(re,le,ze){return _e(Ot.onDidChangeVisibleTextEditors)(re,le,ze)},onDidChangeTextEditorSelection(re,le,ze){return _e(Ot.onDidChangeTextEditorSelection)(re,le,ze)},onDidChangeTextEditorOptions(re,le,ze){return _e(Ot.onDidChangeTextEditorOptions)(re,le,ze)},onDidChangeTextEditorVisibleRanges(re,le,ze){return _e(Ot.onDidChangeTextEditorVisibleRanges)(re,le,ze)},onDidChangeTextEditorViewColumn(re,le,ze){return _e(Ot.onDidChangeTextEditorViewColumn)(re,le,ze)},onDidCloseTerminal(re,le,ze){return _e(Ye.onDidCloseTerminal)(re,le,ze)},onDidOpenTerminal(re,le,ze){return _e(Ye.onDidOpenTerminal)(re,le,ze)},onDidChangeActiveTerminal(re,le,ze){return _e(Ye.onDidChangeActiveTerminal)(re,le,ze)},onDidChangeTerminalDimensions(re,le,ze){return(0,Ze.$GF)(Ue,"terminalDimensions"),_e(Ye.onDidChangeTerminalDimensions)(re,le,ze)},onDidChangeTerminalState(re,le,ze){return _e(Ye.onDidChangeTerminalState)(re,le,ze)},onDidWriteTerminalData(re,le,ze){return(0,Ze.$GF)(Ue,"terminalDataWriteEvent"),_e(Ye.onDidWriteTerminalData)(re,le,ze)},onDidExecuteTerminalCommand(re,le,ze){return(0,Ze.$GF)(Ue,"terminalExecuteCommandEvent"),_e(Ye.onDidExecuteTerminalCommand)(re,le,ze)},get state(){return Bt.getState(Ue)},onDidChangeWindowState(re,le,ze){return _e(Bt.onDidChangeWindowState)(re,le,ze)},showInformationMessage(re,...le){return ki.showMessage(Ue,m.default.Info,re,le[0],le.slice(1))},showWarningMessage(re,...le){return ki.showMessage(Ue,m.default.Warning,re,le[0],le.slice(1))},showErrorMessage(re,...le){return ki.showMessage(Ue,m.default.Error,re,le[0],le.slice(1))},showQuickPick(re,le,ze){return oi.showQuickPick(Ue,re,le,ze)},showWorkspaceFolderPick(re){return oi.showWorkspaceFolderPick(re)},showInputBox(re,le){return oi.showInput(re,le)},showOpenDialog(re){return Oi.showOpenDialog(Ue,re)},showSaveDialog(re){return Oi.showSaveDialog(re)},createStatusBarItem(re,le,ze){let ot,bt,Rt;return typeof re=="string"?(ot=re,bt=le,Rt=ze):(bt=re,Rt=le),ti.createStatusBarEntry(Ue,ot,bt,Rt)},setStatusBarMessage(re,le){return ti.setStatusBarMessage(re,le)},withScmProgress(re){return Pt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),vi.withProgress(Ue,{location:Te.ProgressLocation.SourceControl},(le,ze)=>re({report(ot){}}))},withProgress(re,le){return vi.withProgress(Ue,re,le)},createOutputChannel(re,le){return Kt.createOutputChannel(re,le,Ue)},createWebviewPanel(re,le,ze,ot){return Mi.createWebviewPanel(Ue,re,le,ze,ot)},createWebviewTextEditorInset(re,le,ze,ot){return(0,Ze.$GF)(Ue,"editorInsets"),Pi.createWebviewEditorInset(re,le,ze,ot,Ue)},createTerminal(re,le,ze){return typeof re=="object"?"pty"in re?Ye.createExtensionTerminal(re):Ye.createTerminalFromOptions(re):Ye.createTerminal(re,le,ze)},registerTerminalLinkProvider(re){return Ye.registerLinkProvider(re)},registerTerminalProfileProvider(re,le){return Ye.registerProfileProvider(Ue,re,le)},registerTerminalQuickFixProvider(re,le){return(0,Ze.$GF)(Ue,"terminalQuickFixProvider"),Ye.registerTerminalQuickFixProvider(re,Ue.identifier.value,le)},registerTreeDataProvider(re,le){return $i.registerTreeDataProvider(re,le,Ue)},createTreeView(re,le){return $i.createTreeView(re,le,Ue)},registerWebviewPanelSerializer:(re,le)=>Mi.registerWebviewPanelSerializer(Ue,re,le),registerCustomEditorProvider:(re,le,ze={})=>un.registerCustomEditorProvider(Ue,re,le,ze),registerFileDecorationProvider(re){return Q.registerFileDecorationProvider(re,Ue)},registerUriHandler(re){return Dt.registerUriHandler(Ue,re)},createQuickPick(){return oi.createQuickPick(Ue)},createInputBox(){return oi.createInputBox(Ue)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(re,le,ze){return _e(Li.onDidChangeActiveColorTheme)(re,le,ze)},registerWebviewViewProvider(re,le,ze){return Fi.registerWebviewViewProvider(Ue,re,le,ze?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,le,ze){return _e(It.onDidChangeActiveNotebookEditor)(re,le,ze)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return _e(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(re,le,ze){return _e(mi.onDidChangeNotebookEditorSelection)(re,le,ze)},onDidChangeNotebookEditorVisibleRanges(re,le,ze){return _e(mi.onDidChangeNotebookEditorVisibleRanges)(re,le,ze)},showNotebookDocument(re,le){return It.showNotebookDocument(re,le)},registerExternalUriOpener(re,le,ze){return(0,Ze.$GF)(Ue,"externalUriOpener"),ln.registerExternalUriOpener(Ue.identifier,re,le,ze)},registerProfileContentHandler(re,le){return(0,Ze.$GF)(Ue,"profileContentHandlers"),hn.registerProfileContentHandler(Ue,re,le)},registerQuickDiffProvider(re,le,ze,ot){return(0,Ze.$GF)(Ue,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(re),le,ze,ot)},get tabGroups(){return Fe.tabGroups},registerShareProvider(re,le){return(0,Ze.$GF)(Ue,"shareProvider"),Qi.registerShareProvider(pt(re),le)}},sn={get rootPath(){return Pt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(re){throw new M.$9("rootPath")},getWorkspaceFolder(re){return dt.getWorkspaceFolder(re)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(re){throw new M.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(re){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(re,le,...ze)=>dt.updateWorkspaceFolders(Ue,re,le||0,...ze),onDidChangeWorkspaceFolders:function(re,le,ze){return _e(dt.onDidChangeWorkspace)(re,le,ze)},asRelativePath:(re,le)=>dt.getRelativePath(re,le),findFiles:(re,le,ze,ot)=>dt.findFiles(re,le,ze,Ue.identifier,ot),findTextInFiles:(re,le,ze,ot)=>{(0,Ze.$GF)(Ue,"findTextInFiles");let bt,Rt;return typeof le=="object"?(bt=le,Rt=ze):(bt={},Rt=le,ot=ze),dt.findTextInFiles(re,bt||{},Rt,Ue.identifier,ot)},save:re=>dt.save(re),saveAs:re=>dt.saveAs(re),saveAll:re=>dt.saveAll(re),applyEdit(re,le){return Zt.applyWorkspaceEdit(re,Ue,le)},createFileSystemWatcher:(re,le,ze,ot)=>{let bt;return typeof le=="boolean"?bt={ignoreCreateEvents:!!le,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!ot,correlate:!1}:le&&((0,Ze.$GF)(Ue,"createFileSystemWatcher"),bt={...le,correlate:!0}),ei.createFileSystemWatcher(dt,Ue,re,bt)},get textDocuments(){return vt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new M.$9("textDocuments")},openTextDocument(re){let le;const ze=re;if(typeof re=="string")le=Promise.resolve(f.URI.file(re));else if(f.URI.isUri(re))le=Promise.resolve(re);else if(!ze||typeof ze=="object")le=vt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ot=>vt.ensureDocumentData(ot).then(bt=>bt.document))},onDidOpenTextDocument:(re,le,ze)=>_e(vt.onDidAddDocument)(re,le,ze),onDidCloseTextDocument:(re,le,ze)=>_e(vt.onDidRemoveDocument)(re,le,ze),onDidChangeTextDocument:(re,le,ze)=>_e(vt.onDidChangeDocument)(re,le,ze),onDidSaveTextDocument:(re,le,ze)=>_e(vt.onDidSaveDocument)(re,le,ze),onWillSaveTextDocument:(re,le,ze)=>_e(Gi.getOnWillSaveTextDocumentEvent(Ue))(re,le,ze),get notebookDocuments(){return It.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,le){let ze;if(f.URI.isUri(re))ze=re,await It.openNotebookDocument(re);else if(typeof re=="string")ze=f.URI.revive(await It.createNotebookDocument({viewType:re,content:le}));else throw new Error("Invalid arguments");return It.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(re,le,ze){return _e(si.onDidSaveNotebookDocument)(re,le,ze)},onDidChangeNotebookDocument(re,le,ze){return _e(si.onDidChangeNotebookDocument)(re,le,ze)},onWillSaveNotebookDocument(re,le,ze){return _e(Ci.getOnWillSaveNotebookDocumentEvent(Ue))(re,le,ze)},get onDidOpenNotebookDocument(){return _e(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return _e(It.onDidCloseNotebookDocument)},registerNotebookSerializer(re,le,ze,ot){return It.registerNotebookSerializer(Ue,re,le,ze,(0,Ze.$FF)(Ue,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(re,le,ze)=>_e(tn.onDidChangeConfiguration)(re,le,ze),getConfiguration(re,le){return le=arguments.length===1?void 0:le,tn.getConfiguration(re,le,Ue)},registerTextDocumentContentProvider(re,le){return Si.registerTextDocumentContentProvider(re,le)},registerTaskProvider:(re,le)=>(Pt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(Ue,re,le)),registerFileSystemProvider(re,le,ze){return(0,A.$Qc)(Ji.registerFileSystemProvider(Ue,re,le,ze),Qt.addFileSystemProvider(re,le,ze))},get fs(){return Qt.value},registerFileSearchProvider:(re,le)=>((0,Ze.$GF)(Ue,"fileSearchProvider"),st.registerFileSearchProvider(re,le)),registerTextSearchProvider:(re,le)=>((0,Ze.$GF)(Ue,"textSearchProvider"),st.registerTextSearchProvider(re,le)),registerRemoteAuthorityResolver:(re,le)=>((0,Ze.$GF)(Ue,"resolvers"),Et.registerRemoteAuthorityResolver(re,le)),registerResourceLabelFormatter:re=>((0,Ze.$GF)(Ue,"resolvers"),Yi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Ze.$GF)(Ue,"resolvers"),Et.getRemoteExecServer(re)),onDidCreateFiles:(re,le,ze)=>_e(ei.onDidCreateFile)(re,le,ze),onDidDeleteFiles:(re,le,ze)=>_e(ei.onDidDeleteFile)(re,le,ze),onDidRenameFiles:(re,le,ze)=>_e(ei.onDidRenameFile)(re,le,ze),onWillCreateFiles:(re,le,ze)=>_e(ei.getOnWillCreateFileEvent(Ue))(re,le,ze),onWillDeleteFiles:(re,le,ze)=>_e(ei.getOnWillDeleteFileEvent(Ue))(re,le,ze),onWillRenameFiles:(re,le,ze)=>_e(ei.getOnWillRenameFileEvent(Ue))(re,le,ze),openTunnel:re=>((0,Ze.$GF)(Ue,"tunnels"),Mt.openTunnel(Ue,re).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,Ze.$GF)(Ue,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(re,le,ze)=>((0,Ze.$GF)(Ue,"tunnels"),_e(Mt.onDidChangeTunnels)(re,le,ze)),registerPortAttributesProvider:(re,le)=>((0,Ze.$GF)(Ue,"portsAttributes"),Mt.registerPortsAttributesProvider(re,le)),registerTunnelProvider:(re,le)=>((0,Ze.$GF)(Ue,"tunnelFactory"),Mt.registerTunnelProvider(re,le)),registerTimelineProvider:(re,le)=>((0,Ze.$GF)(Ue,"timeline"),Xi.registerTimelineProvider(re,le,Ue.identifier,Oe.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:re=>((0,Ze.$GF)(Ue,"workspaceTrust"),dt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,le,ze)=>_e(dt.onDidGrantWorkspaceTrust)(re,le,ze),registerEditSessionIdentityProvider:(re,le)=>((0,Ze.$GF)(Ue,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(re,le)),onWillCreateEditSessionIdentity:(re,le,ze)=>((0,Ze.$GF)(Ue,"editSessionIdentityProvider"),_e(dt.getOnWillCreateEditSessionIdentityEvent(Ue))(re,le,ze)),registerCanonicalUriProvider:(re,le)=>((0,Ze.$GF)(Ue,"canonicalUriProvider"),dt.registerCanonicalUriProvider(re,le)),getCanonicalUri:(re,le,ze)=>((0,Ze.$GF)(Ue,"canonicalUriProvider"),dt.provideCanonicalUri(re,le,ze))},on={get inputBox(){return Pt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(Ue)},createSourceControl(re,le,ze){return pi.createSourceControl(Ue,re,le,ze)}},an={createCommentController(re,le){return Ai.createCommentController(Ue,re,le)}},ji={get activeDebugSession(){return We.activeDebugSession},get activeDebugConsole(){return We.activeDebugConsole},get breakpoints(){return We.breakpoints},get stackFrameFocus(){return We.stackFrameFocus},onDidStartDebugSession(re,le,ze){return _e(We.onDidStartDebugSession)(re,le,ze)},onDidTerminateDebugSession(re,le,ze){return _e(We.onDidTerminateDebugSession)(re,le,ze)},onDidChangeActiveDebugSession(re,le,ze){return _e(We.onDidChangeActiveDebugSession)(re,le,ze)},onDidReceiveDebugSessionCustomEvent(re,le,ze){return _e(We.onDidReceiveDebugSessionCustomEvent)(re,le,ze)},onDidChangeBreakpoints(re,le,ze){return _e(We.onDidChangeBreakpoints)(re,le,ze)},onDidChangeStackFrameFocus(re,le,ze){return(0,Ze.$GF)(Ue,"debugFocus"),_e(We.onDidChangeStackFrameFocus)(re,le,ze)},registerDebugConfigurationProvider(re,le,ze){return We.registerDebugConfigurationProvider(re,le,ze||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,le){return We.registerDebugAdapterDescriptorFactory(Ue,re,le)},registerDebugAdapterTrackerFactory(re,le){return We.registerDebugAdapterTrackerFactory(re,le)},startDebugging(re,le,ze){return!ze||typeof ze=="object"&&"configuration"in ze?We.startDebugging(re,le,{parentSession:ze}):We.startDebugging(re,le,ze||{})},stopDebugging(re){return We.stopDebugging(re)},addBreakpoints(re){return We.addBreakpoints(re)},removeBreakpoints(re){return We.removeBreakpoints(re)},asDebugSourceUri(re,le){return We.asDebugSourceUri(re,le)}},Bi={registerTaskProvider:(re,le)=>wt.registerTaskProvider(Ue,re,le),fetchTasks:re=>wt.fetchTasks(re),executeTask:re=>wt.executeTask(Ue,re),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(re,le,ze)=>_e(wt.onDidStartTask)(re,le,ze),onDidEndTask:(re,le,ze)=>_e(wt.onDidEndTask)(re,le,ze),onDidStartTaskProcess:(re,le,ze)=>_e(wt.onDidStartTaskProcess)(re,le,ze),onDidEndTaskProcess:(re,le,ze)=>_e(wt.onDidEndTaskProcess)(re,le,ze)},Vi={createNotebookController(re,le,ze,ot,bt){return ui.createNotebookController(Ue,re,le,ze,ot,(0,Ze.$FF)(Ue,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(re,le)=>It.registerNotebookCellStatusBarItemProvider(Ue,re,le),createRendererMessaging(re){return Ii.createRendererMessaging(Ue,re)},createNotebookControllerDetectionTask(re){return(0,Ze.$GF)(Ue,"notebookKernelSource"),ui.createNotebookControllerDetectionTask(Ue,re)},registerKernelSourceActionProvider(re,le){return(0,Ze.$GF)(Ue,"notebookKernelSource"),ui.registerKernelSourceActionProvider(Ue,re,le)},onDidChangeNotebookCellExecutionState(re,le,ze){return(0,Ze.$GF)(Ue,"notebookCellExecutionState"),_e(ui.onDidChangeNotebookCellExecutionState)(re,le,ze)}},Di={t(...re){if(typeof re[0]=="string"){const le=re.shift(),ze=!re||typeof re[0]!="object"?re:re[0];return kt.getMessage(Ue.identifier.value,{message:le,args:ze})}return kt.getMessage(Ue.identifier.value,re[0])},get bundle(){return kt.getBundle(Ue.identifier.value)},get uri(){return kt.getBundleUri(Ue.identifier.value)}},Wi={_version:1,registerInteractiveEditorSessionProvider(re,le){return(0,Ze.$GF)(Ue,"interactive"),Zi.registerProvider(Ue,re,le)},registerInteractiveSessionProvider(re,le){return(0,Ze.$GF)(Ue,"interactive"),wi.registerChatProvider(Ue,re,le)},sendInteractiveRequestToProvider(re,le){return(0,Ze.$GF)(Ue,"interactive"),wi.sendInteractiveRequestToProvider(re,le)},transferChatSession(re,le){return(0,Ze.$GF)(Ue,"interactive"),wi.transferChatSession(re,le)}},qi={getRelatedInformation(re,le){return(0,Ze.$GF)(Ue,"aiRelatedInformation"),en.getRelatedInformation(Ue,re,le)},registerRelatedInformationProvider(re,le){return(0,Ze.$GF)(Ue,"aiRelatedInformation"),en.registerRelatedInformationProvider(Ue,re,le)},registerEmbeddingVectorProvider(re,le){return(0,Ze.$GF)(Ue,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(Ue,re,le)}},$n={registerChatResponseProvider(re,le,ze){return(0,Ze.$GF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,re,le,ze)},requestChatAccess(re){return(0,Ze.$GF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,re)},registerVariable(re,le,ze){return(0,Ze.$GF)(Ue,"chatAgents2"),_i.registerVariableResolver(Ue,re,le,ze)},registerMappedEditsProvider(re,le){return(0,Ze.$GF)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,re,le)},createChatAgent(re,le){return(0,Ze.$GF)(Ue,"chatAgents2"),xi.createChatAgent(Ue,re,le)}},pn={registerSpeechProvider(re,le){return(0,Ze.$GF)(Ue,"speech"),yi.registerProvider(Ue.identifier,re,le)}};return{version:$t.version,ai:qi,authentication:fn,commands:gn,comments:an,chat:$n,debug:ji,env:zi,extensions:nn,interactive:Wi,l10n:Di,languages:rn,notebooks:Vi,scm:on,speech:pn,tasks:Bi,tests:Ui,window:mn,workspace:sn,Breakpoint:Te.$$L,TerminalOutputAnchor:Te.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Te.ChatAgentResultFeedbackKind,ChatMessage:Te.$3M,ChatMessageRole:Te.ChatMessageRole,ChatVariableLevel:Te.ChatVariableLevel,ChatAgentCompletionItem:Te.$2M,CallHierarchyIncomingCall:Te.$xL,CallHierarchyItem:Te.$wL,CallHierarchyOutgoingCall:Te.$yL,CancellationError:M.$5,CancellationTokenSource:y.$6d,CandidatePortSource:o.CandidatePortSource,CodeAction:Te.$tL,CodeActionKind:Te.$uL,CodeActionTriggerKind:Te.CodeActionTriggerKind,CodeLens:Te.$zL,Color:Te.$ML,ColorInformation:Te.$NL,ColorPresentation:Te.$OL,ColorThemeKind:Te.ColorThemeKind,CommentMode:Te.CommentMode,CommentState:Te.CommentState,CommentThreadCollapsibleState:Te.CommentThreadCollapsibleState,CommentThreadState:Te.CommentThreadState,CompletionItem:Te.$GL,CompletionItemKind:Te.CompletionItemKind,CompletionItemTag:Te.CompletionItemTag,CompletionList:Te.$HL,CompletionTriggerKind:Te.CompletionTriggerKind,ConfigurationTarget:Te.ConfigurationTarget,CustomExecution:Te.$WL,DebugAdapterExecutable:Te.$cM,DebugAdapterInlineImplementation:Te.$fM,DebugAdapterNamedPipeServer:Te.$eM,DebugAdapterServer:Te.$dM,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Te.DebugConsoleMode,DecorationRangeBehavior:Te.DecorationRangeBehavior,Diagnostic:Te.$nL,DiagnosticRelatedInformation:Te.$mL,DiagnosticSeverity:Te.DiagnosticSeverity,DiagnosticTag:Te.DiagnosticTag,Disposable:Te.$_K,DocumentHighlight:Te.$pL,DocumentHighlightKind:Te.DocumentHighlightKind,MultiDocumentHighlight:Te.$qL,DocumentLink:Te.$LL,DocumentSymbol:Te.$sL,EndOfLine:Te.EndOfLine,EnvironmentVariableMutatorType:Te.EnvironmentVariableMutatorType,EvaluatableExpression:Te.$iM,InlineValueText:Te.$jM,InlineValueVariableLookup:Te.$kM,InlineValueEvaluatableExpression:Te.$lM,InlineCompletionTriggerKind:Te.InlineCompletionTriggerKind,EventEmitter:C.$Vd,ExtensionKind:Te.ExtensionKind,ExtensionMode:Te.ExtensionMode,ExternalUriOpenerPriority:Te.ExternalUriOpenerPriority,FileChangeType:Te.FileChangeType,FileDecoration:Te.$vM,FileDecoration2:Te.$vM,FileSystemError:Te.$nM,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Te.$oM,FoldingRangeKind:Te.FoldingRangeKind,FunctionBreakpoint:Te.$aM,InlineCompletionItem:Te.$IL,InlineCompletionList:Te.$JL,Hover:Te.$oL,IndentAction:k.IndentAction,Location:Te.$lL,MarkdownString:Te.$AL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Te.$BL,PortAutoForwardAction:Te.PortAutoForwardAction,Position:Te.$aL,ProcessExecution:Te.$UL,ProgressLocation:Te.ProgressLocation,QuickInputButtons:Te.$uM,Range:Te.$bL,RelativePattern:Te.$9L,Selection:Te.$cL,SelectionRange:Te.$vL,SemanticTokens:Te.$rM,SemanticTokensBuilder:Te.$qM,SemanticTokensEdit:Te.$sM,SemanticTokensEdits:Te.$tM,SemanticTokensLegend:Te.$pM,ShellExecution:Te.$VL,ShellQuoting:Te.ShellQuoting,SignatureHelp:Te.$DL,SignatureHelpTriggerKind:Te.SignatureHelpTriggerKind,SignatureInformation:Te.$CL,SnippetString:Te.$kL,SourceBreakpoint:Te.$_L,StandardTokenType:Te.StandardTokenType,StatusBarAlignment:Te.StatusBarAlignment,SymbolInformation:Te.$rL,SymbolKind:Te.SymbolKind,SymbolTag:Te.SymbolTag,Task:Te.$XL,TaskGroup:Te.$TL,TaskPanelKind:Te.TaskPanelKind,TaskRevealKind:Te.TaskRevealKind,TaskScope:Te.TaskScope,TerminalLink:Te.$PL,TerminalQuickFixTerminalCommand:Te.$RL,TerminalQuickFixOpener:Te.$QL,TerminalLocation:Te.TerminalLocation,TerminalProfile:Te.$SL,TerminalExitReason:Te.TerminalExitReason,TextDocumentSaveReason:Te.TextDocumentSaveReason,TextEdit:Te.$gL,SnippetTextEdit:Te.$iL,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Te.TextEditorLineNumbersStyle,TextEditorRevealType:Te.TextEditorRevealType,TextEditorSelectionChangeKind:Te.TextEditorSelectionChangeKind,SyntaxTokenType:Te.SyntaxTokenType,TextDocumentChangeReason:Te.TextDocumentChangeReason,ThemeColor:Te.$8L,ThemeIcon:Te.$7L,TreeItem:Te.$YL,TreeItemCheckboxState:Te.TreeItemCheckboxState,TreeItemCollapsibleState:Te.TreeItemCollapsibleState,TypeHierarchyItem:Te.$QM,UIKind:Ut.UIKind,Uri:f.URI,ViewColumn:Te.ViewColumn,WorkspaceEdit:Te.$jL,DocumentDropEdit:Te.$5L,DocumentPasteEdit:Te.$6L,InlayHint:Te.$FL,InlayHintLabelPart:Te.$EL,InlayHintKind:Te.InlayHintKind,RemoteAuthorityResolverError:Te.$fL,ResolvedAuthority:Te.$dL,ManagedResolvedAuthority:Te.$eL,SourceControlInputBoxValidationType:Te.SourceControlInputBoxValidationType,ExtensionRuntime:Te.ExtensionRuntime,TimelineItem:Te.$FM,NotebookRange:Te.$xM,NotebookCellKind:Te.NotebookCellKind,NotebookCellExecutionState:Te.NotebookCellExecutionState,NotebookCellData:Te.$yM,NotebookData:Te.$zM,NotebookRendererScript:Te.$DM,NotebookCellStatusBarAlignment:Te.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Te.NotebookEditorRevealType,NotebookCellOutput:Te.$BM,NotebookCellOutputItem:Te.$AM,NotebookCellStatusBarItem:Te.$CM,NotebookControllerAffinity:Te.NotebookControllerAffinity,NotebookControllerAffinity2:Te.NotebookControllerAffinity2,NotebookEdit:Te.$hL,NotebookKernelSourceAction:Te.$EM,NotebookVariablesRequestKind:Te.NotebookVariablesRequestKind,PortAttributes:Te.$HM,LinkedEditingRanges:Te.$GM,TestResultState:Te.TestResultState,TestRunRequest:Te.$IM,TestMessage:Te.$JM,TestMessage2:Te.$JM,TestTag:Te.$KM,TestRunProfileKind:Te.TestRunProfileKind,TextSearchCompleteMessageType:Ht.TextSearchCompleteMessageType,DataTransfer:Te.$4L,DataTransferItem:Te.$ZL,CoveredCount:Te.$LM,FileCoverage:Te.$MM,StatementCoverage:Te.$NM,BranchCoverage:Te.$OM,FunctionCoverage:Te.$PM,WorkspaceTrustState:Te.WorkspaceTrustState,LanguageStatusSeverity:Te.LanguageStatusSeverity,QuickPickItemKind:Te.QuickPickItemKind,InputBoxValidationSeverity:Te.InputBoxValidationSeverity,TabInputText:Te.$RM,TabInputTextDiff:Te.$SM,TabInputTextMerge:Te.$TM,TabInputCustom:Te.$UM,TabInputNotebook:Te.$WM,TabInputNotebookDiff:Te.$XM,TabInputWebview:Te.$VM,TabInputTerminal:Te.$YM,TabInputInteractiveWindow:Te.$ZM,TabInputChat:Te.$1M,TelemetryTrustedValue:r.$Lo,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Te.InteractiveSessionVoteDirection,ChatAgentCopyKind:Te.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Te.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Te.$gM,ThreadFocus:Te.$hM,RelatedInformationType:Te.RelatedInformationType,SpeechToTextStatus:Te.SpeechToTextStatus}}}e.$ric=Jt}),define(Pe[291],Re([1,0,53,112,36,107,37,32,66,65,115,117,118,83,86,79,106,62,42,82,60,64,226,14,116,80,81]),function(ge,e,y,M,C,A,P,m,f,w,R,k,l,$,v,s,a,r,n,o,c,h,i,u,t,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Yr)(g.$ghc,g.$fhc,1),(0,y.$Yr)(u.$oj,i.$sic,1),(0,y.$Yr)(s.$rgc,s.$sgc,1),(0,y.$Yr)(m.$xN,m.$wN,0),(0,y.$Yr)(P.$Mgc,P.$Kgc,0),(0,y.$Yr)(r.$Ogc,r.$Ngc,0),(0,y.$Yr)(k.$qhc,k.$uhc,0),(0,y.$Yr)(A.$whc,A.$vhc,0),(0,y.$Yr)(f.$mN,f.$lN,0),(0,y.$Yr)(p.$hhc,p.$ihc,0),(0,y.$Yr)(n.$ogc,n.$ngc,0),(0,y.$Yr)(M.$3hc,M.$2hc,1),(0,y.$Yr)(l.$Mhc,l.$Nhc,0),(0,y.$Yr)($.$8gc,$.$7gc,0),(0,y.$Yr)(R.$dic,R.$cic,0),(0,y.$Yr)(w.$$gc,w.$bhc,0),(0,y.$Yr)(v.$vyb,v.$wyb,0),(0,y.$Yr)(a.$qic,a.$pic,0),(0,y.$Yr)(C.$Jgc,C.$Igc,0),(0,y.$Yr)(o.$dhc,o.$chc,0),(0,y.$Yr)(c.$vN,c.$sN,0),(0,y.$Yr)(h.$Ygc,h.$Zgc,0),(0,y.$Yr)(t.$ohc,t.$phc,0)}),define(Pe[292],Re([1,0,290,38,2,287,7,13,232]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=void 0;class w extends A.$vic{j(){}getModule($,v){for(const s of this.b){const a=s($);if(a){$=a;break}}if(this.a.has($))return this.a.get($).load($,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends M.$khc{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(f.$Ckc);const $=this.h.invokeFunction(y.$ric);this.r=this.h.createInstance(w,$,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub($){return $.browser}async vb($,v,s){v=v.with({path:k(v.path,".js")});const a=$?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const r=C.URI.revive(await this.C.$asBrowserUri(v)),n=await fetch(r.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),n.status!==200)throw new Error(n.statusText);const o=await n.text(),c=`${v.toString(!0)}#vscode-extension`,h=`${o}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(p){throw console.error(a?`Loading code for extension ${a} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${v.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}$&&await this.w.initializeLocalizedMessages($);const u={},t={exports:u},g=p=>{const d=this.r.getModule(p,v);if(d===void 0)throw new Error(`Cannot load module '${p}'`);return d};try{return s.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),i(t,u,g),t.exports!==u?t.exports:u}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),s.codeLoadingStop()}}async $setRemoteEnvironment($){}async zb($=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+$;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,m.$7g)(10)}}e.$Dkc=R;function k(l,$){return l.endsWith($)?l:l+$}}),define(Pe[293],Re([1,0,70,53,14,38,199,85,292]),function(ge,e,y,M,C,A,P,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$Yr)(C.$nj,new y.$3h(P.$uic,[!0],!0)),(0,M.$Yr)(A.$lhc,f.$Dkc,0),(0,M.$Yr)(m.$Pgc,m.$Qgc,0)}),define(Pe[298],Re([1,0,22,5,78,288,234,19,88,11,2,291,293]),function(ge,e,y,M,C,A,P,m,f,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function $(i){return/^(file|vscode-remote):/i.test(i)}const v=fetch.bind(self);function s(i){self.fetch=async function(u,t){return u instanceof Request||$(String(u))&&(u=(await i(R.URI.parse(String(u)))).toString(!0)),v(u,t)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,t,g,p,d){(async()=>($(t.toString())&&(t=(await i(R.URI.parse(t.toString()))).toString(!0)),super.open(u,t,g??!0,p,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(u,t){if(/^file:/i.test(u.toString()))u=w.$og.uriToBrowserUri(R.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const p=`(${function(b){function E(O){return typeof O=="string"||O instanceof URL?String(O).replace(/^file:\/\//i,"vscode-file://vscode-app"):O}const D=fetch.bind(self);self.fetch=function(O,G){return O instanceof Request?D(O,G):D(E(O),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(O,G,q,U,I){return super.open(O,E(G),q??!0,U,I)}};const T=importScripts.bind(self);self.importScripts=(...O)=>{T(...O.map(E))},T(b)}.toString()}('${u}'))`;t=t||{},t.name=t.name||m.$nc(u.toString());const d=new Blob([p],{type:"application/javascript"}),S=URL.createObjectURL(d);return new i(S,t)}}else self.Worker=class extends P.$Ekc{constructor(i,u){super(l,i,{name:m.$nc(i.toString()),...u})}};const a=new class{constructor(){this.pid=void 0}exit(i){k()}};class r{constructor(){const u=new MessageChannel,t=new M.$Vd;let g=!1;l(u.port2,[u.port2]),u.port1.onmessage=p=>{const{data:d}=p;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const S=y.$je.wrap(new Uint8Array(d,0,d.byteLength));if((0,C.$um)(S,2)){g=!0,o("received terminate message from renderer");return}t.fire(S)},this.protocol={onMessage:t.event,send:p=>{if(!g){const d=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);u.port1.postMessage(d,[d])}}}}}function n(i){return new Promise(u=>{const t=i.onMessage(g=>{t.dispose();const p=JSON.parse(g.toString());i.send((0,C.$tm)(0)),u({protocol:i,initData:p})});i.send((0,C.$tm)(1))})}let o=i=>k();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){f.mark("code/extHost/willConnectToRenderer");const i=new r;return{onmessage(u){c(u)&&n(i.protocol).then(t=>{f.mark("code/extHost/didWaitForInitData");const g=new A.$xic(t.protocol,t.initData,a,null,u.data);s(p=>g.asBrowserUri(p)),o=p=>g.terminate(p)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0b571a26e213bf1ec6266e37152ced80c006bd1e/core/vs/workbench/api/worker/extensionHostWorker.js.map
